/* Z Kit - inspection/compiler/completion.h
 _____  _______________
/_   /_/  -_/_   _/  _ |
 /____/\___/ /__//___/_| Kit
Copyright (C) 2006-2018 Manuel Sainz de Baranda y Goñi.
Copyright (C) 2018 Ortega Sosa, Sofía.
Released under the terms of the GNU Lesser General Public License v3. */

/* MARK: - CPU endianness */

#ifdef Z_COMPILER_CPU_INTEGER_ENDIANNESS

#	define Z_COMPILER_CPU_INTEGER_ENDIANNESS_8BIT   Z_COMPILER_CPU_INTEGER_ENDIANNESS
#	define Z_COMPILER_CPU_INTEGER_ENDIANNESS_16BIT  Z_COMPILER_CPU_INTEGER_ENDIANNESS
#	define Z_COMPILER_CPU_INTEGER_ENDIANNESS_32BIT  Z_COMPILER_CPU_INTEGER_ENDIANNESS
#	define Z_COMPILER_CPU_INTEGER_ENDIANNESS_64BIT  Z_COMPILER_CPU_INTEGER_ENDIANNESS
#	define Z_COMPILER_CPU_INTEGER_ENDIANNESS_128BIT Z_COMPILER_CPU_INTEGER_ENDIANNESS

#endif

/* MARK: - Bit field order */

#ifdef Z_COMPILER_BIT_FIELD_ORDER

#	define Z_COMPILER_BIT_FIELD_ORDER_8BIT   Z_COMPILER_BIT_FIELD_ORDER
#	define Z_COMPILER_BIT_FIELD_ORDER_16BIT  Z_COMPILER_BIT_FIELD_ORDER
#	define Z_COMPILER_BIT_FIELD_ORDER_32BIT  Z_COMPILER_BIT_FIELD_ORDER
#	define Z_COMPILER_BIT_FIELD_ORDER_64BIT  Z_COMPILER_BIT_FIELD_ORDER
#	define Z_COMPILER_BIT_FIELD_ORDER_128BIT Z_COMPILER_BIT_FIELD_ORDER

#endif

/* MARK: - K&R C support */

#ifndef Z_COMPILER_C_HAS_OPERATOR_SIZE_OF
#	define Z_COMPILER_C_HAS_OPERATOR_SIZE_OF FALSE
#endif

#ifndef Z_COMPILER_C_HAS_STORAGE_CLASS_AUTO
#	define Z_COMPILER_C_HAS_STORAGE_CLASS_AUTO FALSE
#endif

#ifndef Z_COMPILER_C_HAS_STORAGE_CLASS_EXTERN
#	define Z_COMPILER_C_HAS_STORAGE_CLASS_EXTERN FALSE
#endif

#ifndef Z_COMPILER_C_HAS_STORAGE_CLASS_REGISTER
#	define Z_COMPILER_C_HAS_STORAGE_CLASS_REGISTER FALSE
#endif

#ifndef Z_COMPILER_C_HAS_STORAGE_CLASS_STATIC
#	define Z_COMPILER_C_HAS_STORAGE_CLASS_STATIC FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_FLOAT
#	define Z_COMPILER_C_HAS_TYPE_FLOAT FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_DOUBLE
#	define Z_COMPILER_C_HAS_TYPE_DOUBLE FALSE
#endif

/* MARK: - C89 support */

#ifndef Z_COMPILER_C_HAS_ENUMERATION
#	define Z_COMPILER_C_HAS_ENUMERATION FALSE
#endif

#ifndef Z_COMPILER_C_HAS_VOID_POINTER
#	define Z_COMPILER_C_HAS_VOID_POINTER FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_LDOUBLE
#	define Z_COMPILER_C_HAS_TYPE_LDOUBLE FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_QUALIFIER_CONSTANT
#	define Z_COMPILER_C_HAS_TYPE_QUALIFIER_CONSTANT FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_QUALIFIER_VOLATILE
#	define Z_COMPILER_C_HAS_TYPE_QUALIFIER_VOLATILE FALSE
#endif

/* MARK: - C90 support */

/* MARK: - C94 support */

#ifndef Z_COMPILER_C_HAS_DIGRAPHS
#	define Z_COMPILER_C_HAS_DIGRAPHS FALSE
#endif

/* MARK: - C99 support */

#ifndef Z_COMPILER_C_HAS_COMPOUND_LITERAL
#	define Z_COMPILER_C_HAS_COMPOUND_LITERAL FALSE
#endif

#ifndef Z_COMPILER_C_HAS_CPP_STYLE_COMMENT
#	define Z_COMPILER_C_HAS_CPP_STYLE_COMMENT FALSE
#endif

#ifndef Z_COMPILER_C_HAS_DESIGNATED_INITIALIZER
#	define Z_COMPILER_C_HAS_DESIGNATED_INITIALIZER FALSE
#endif

#ifndef Z_COMPILER_C_HAS_FLEXIBLE_ARRAY_MEMBER
#	define Z_COMPILER_C_HAS_FLEXIBLE_ARRAY_MEMBER FALSE
#endif

#ifndef Z_COMPILER_C_HAS_INLINE_FUNCION
#	define Z_COMPILER_C_HAS_INLINE_FUNCION FALSE
#endif

#ifndef Z_COMPILER_C_HAS_MIXED_DECLARATIONS_AND_CODE
#	define Z_COMPILER_C_HAS_MIXED_DECLARATIONS_AND_CODE FALSE
#endif

#ifndef Z_COMPILER_C_HAS_NON_CONSTANT_AGGREGATE_INITIALIZER
#	define Z_COMPILER_C_HAS_NON_CONSTANT_AGGREGATE_INITIALIZER FALSE
#endif

#ifndef Z_COMPILER_C_HAS_PREPROCESSOR_ARITHMETIC_DONE_IN_MAXIMUM_INTEGRAL
#	define Z_COMPILER_C_HAS_PREPROCESSOR_ARITHMETIC_DONE_IN_MAXIMUM_INTEGRAL FALSE
#endif

#ifndef Z_COMPILER_C_HAS_VARIADIC_MACRO
#	define Z_COMPILER_C_HAS_VARIADIC_MACRO FALSE
#endif

#ifndef Z_COMPILER_C_HAS_VLA
#	define Z_COMPILER_C_HAS_VLA FALSE
#endif

#ifndef Z_COMPILER_C_HAS_MAGIC_CONSTANT_FUNCTION_NAME
#	define Z_COMPILER_C_HAS_MAGIC_CONSTANT_FUNCTION_NAME FALSE
#endif

#ifndef Z_COMPILER_C_HAS_SPECIFIER_INLINE
#	define Z_COMPILER_C_HAS_SPECIFIER_INLINE FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_BOOLEAN
#	define Z_COMPILER_C_HAS_TYPE_BOOLEAN FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_LLONG
#	define Z_COMPILER_C_HAS_TYPE_LLONG FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_QUALIFIER_RESTRICT
#	define Z_COMPILER_C_HAS_TYPE_QUALIFIER_RESTRICT FALSE
#endif

/* MARK: - C11 support */

#ifndef Z_COMPILER_C_HAS_ANONYMOUS_STRUCTURE
#	define Z_COMPILER_C_HAS_ANONYMOUS_STRUCTURE FALSE
#endif

#ifndef Z_COMPILER_C_HAS_ANONYMOUS_UNION
#	define Z_COMPILER_C_HAS_ANONYMOUS_UNION FALSE
#endif

#ifndef Z_COMPILER_C_HAS_ATOMIC_OPERATIONS
#	define Z_COMPILER_C_HAS_ATOMIC_OPERATIONS FALSE
#endif

#ifndef Z_COMPILER_C_HAS_GENERIC_SELECTION
#	define Z_COMPILER_C_HAS_GENERIC_SELECTION FALSE
#endif

#ifndef Z_COMPILER_C_HAS_STATIC_ASSERTION
#	define Z_COMPILER_C_HAS_STATIC_ASSERTION FALSE
#endif

#ifndef Z_COMPILER_C_HAS_OPERATOR_ALIGN_OF
#	define Z_COMPILER_C_HAS_OPERATOR_ALIGN_OF FALSE
#endif

#ifndef Z_COMPILER_C_HAS_SPECIFIER_ALIGN_AS
#	define Z_COMPILER_C_HAS_SPECIFIER_ALIGN_AS FALSE
#endif

#ifndef Z_COMPILER_C_HAS_SPECIFIER_ATOMIC
#	define Z_COMPILER_C_HAS_SPECIFIER_ATOMIC FALSE
#endif

#ifndef Z_COMPILER_C_HAS_SPECIFIER_NO_RETURN
#	define Z_COMPILER_C_HAS_SPECIFIER_NO_RETURN FALSE
#endif

#ifndef Z_COMPILER_C_HAS_STORATE_CLASS_THREAD_LOCAL
#	define Z_COMPILER_C_HAS_STORATE_CLASS_THREAD_LOCAL FALSE
#endif

#ifndef Z_COMPILER_C_HAS_TYPE_QUALIFIER_ATOMIC
#	define Z_COMPILER_C_HAS_TYPE_QUALIFIER_ATOMIC FALSE
#endif

/* MARK: - C18 support */

/* MARK: - Apple C extensions support */

#ifndef Z_COMPILER_C_HAS_CLOSURE
#	define Z_COMPILER_C_HAS_CLOSURE FALSE
#endif

#ifdef __cplusplus

	/* MARK: - C++98 support */

#	ifndef Z_COMPILER_CPP_HAS_SFINAE
#		define Z_COMPILER_CPP_HAS_SFINAE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TYPE_BOOLEAN
#		define Z_COMPILER_CPP_HAS_TYPE_BOOLEAN FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TYPE_WCHAR
#		define Z_COMPILER_CPP_HAS_TYPE_WCHAR FALSE
#	endif

	/* MARK: - C++03 support */

#	ifndef Z_COMPILER_CPP_HAS_VALUE_INITIALIZATION
#		define Z_COMPILER_CPP_HAS_VALUE_INITIALIZATION FALSE
#	endif

	/* MARK: - C++11 support */

#	ifndef Z_COMPILER_CPP_HAS_C99_PREPROCESSOR
#		define Z_COMPILER_CPP_HAS_C99_PREPROCESSOR FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CONCURRENT_STATIC_LOCAL_VARIABLE
#		define Z_COMPILER_CPP_HAS_CONCURRENT_STATIC_LOCAL_VARIABLE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CONDITIONALLY_SUPPORTED_BEHAVIOR
#		define Z_COMPILER_CPP_HAS_CONDITIONALLY_SUPPORTED_BEHAVIOR FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_COPY_LIST_INITIALIZATION
#		define Z_COMPILER_CPP_HAS_COPY_LIST_INITIALIZATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CPP11_RULES_ON_UNIVERSAL_CHARACTER_NAME
#		define Z_COMPILER_CPP_HAS_CPP11_RULES_ON_UNIVERSAL_CHARACTER_NAME FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DEFAULT_MEMBER_INITIALIZER
#		define Z_COMPILER_CPP_HAS_DEFAULT_MEMBER_INITIALIZER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DEFAULT_TEMPLATE_ARGUMENTS_FOR_FUNCTION_TEMPLATE
#		define Z_COMPILER_CPP_HAS_DEFAULT_TEMPLATE_ARGUMENTS_FOR_FUNCTION_TEMPLATE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DEFAULTED_FUNCTION
#		define Z_COMPILER_CPP_HAS_DEFAULTED_FUNCTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DELEGATING_CONSTRUCTORS
#		define Z_COMPILER_CPP_HAS_DELEGATING_CONSTRUCTORS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DELETED_FUNCTION
#		define Z_COMPILER_CPP_HAS_DELETED_FUNCTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DIRECT_LIST_INITIALIZATION
#		define Z_COMPILER_CPP_HAS_DIRECT_LIST_INITIALIZATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_EXPLICIT_CONVERSION_FUNCTION
#		define Z_COMPILER_CPP_HAS_EXPLICIT_CONVERSION_FUNCTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_EXPRESSION_SFINAE
#		define Z_COMPILER_CPP_HAS_EXPRESSION_SFINAE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_EXTENDED_FRIEND_DECLARATION
#		define Z_COMPILER_CPP_HAS_EXTENDED_FRIEND_DECLARATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_EXTERN_TEMPLATE
#		define Z_COMPILER_CPP_HAS_EXTERN_TEMPLATE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_FORWARD_DECLARATION_OF_ENUMERATION
#		define Z_COMPILER_CPP_HAS_FORWARD_DECLARATION_OF_ENUMERATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_INHERITING_CONSTRUCTORS
#		define Z_COMPILER_CPP_HAS_INHERITING_CONSTRUCTORS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_INITIALIZATION_OF_CLASS_OBJECT_BY_RVALUE
#		define Z_COMPILER_CPP_HAS_INITIALIZATION_OF_CLASS_OBJECT_BY_RVALUE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_INITIALIZER_LIST
#		define Z_COMPILER_CPP_HAS_INITIALIZER_LIST FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_INLINE_NAMESPACE
#		define Z_COMPILER_CPP_HAS_INLINE_NAMESPACE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LAMBDA
#		define Z_COMPILER_CPP_HAS_LAMBDA FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LOCAL_TYPE_AS_TEMPLATE_ARGUMENT
#		define Z_COMPILER_CPP_HAS_LOCAL_TYPE_AS_TEMPLATE_ARGUMENT FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_MOVE_SPECIAL_MEMBER_FUNCTIONS
#		define Z_COMPILER_CPP_HAS_MOVE_SPECIAL_MEMBER_FUNCTIONS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_MULTI_DECLARATOR_AUTO
#		define Z_COMPILER_CPP_HAS_MULTI_DECLARATOR_AUTO FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_RANGE_BASED_FOR
#		define Z_COMPILER_CPP_HAS_RANGE_BASED_FOR FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_REFERENCE_QUALIFIED_NON_STATIC_MEMBER_FUNCTION
#		define Z_COMPILER_CPP_HAS_REFERENCE_QUALIFIED_NON_STATIC_MEMBER_FUNCTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_REMOVAL_OF_AUTO_AS_STORAGE_CLASS
#		define Z_COMPILER_CPP_HAS_REMOVAL_OF_AUTO_AS_STORAGE_CLASS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_RIGHT_ANGLE_BRACKETS
#		define Z_COMPILER_CPP_HAS_RIGHT_ANGLE_BRACKETS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_RVALUE_REFERENCE
#		define Z_COMPILER_CPP_HAS_RVALUE_REFERENCE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_STANDARD_LAYOUT
#		define Z_COMPILER_CPP_HAS_STANDARD_LAYOUT FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_STANDARDIZED_ATTRIBUTE_SYNTAX
#		define Z_COMPILER_CPP_HAS_STANDARDIZED_ATTRIBUTE_SYNTAX FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_STATIC_ASSERTION
#		define Z_COMPILER_CPP_HAS_STATIC_ASSERTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_STRONGLY_TYPED_ENUMERATION
#		define Z_COMPILER_CPP_HAS_STRONGLY_TYPED_ENUMERATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TEMPLATE_ALIAS
#		define Z_COMPILER_CPP_HAS_TEMPLATE_ALIAS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TRAILING_RETURN_TYPE
#		define Z_COMPILER_CPP_HAS_TRAILING_RETURN_TYPE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_UNNAMED_TYPE_AS_TEMPLATE_ARGUMENT
#		define Z_COMPILER_CPP_HAS_UNNAMED_TYPE_AS_TEMPLATE_ARGUMENT FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_UNRESTRICTED_UNION
#		define Z_COMPILER_CPP_HAS_UNRESTRICTED_UNION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_VARIADIC_TEMPLATE
#		define Z_COMPILER_CPP_HAS_VARIADIC_TEMPLATE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_VARIADIC_TEMPLATE_EXTENDED_PARAMETERS
#		define Z_COMPILER_CPP_HAS_VARIADIC_TEMPLATE_EXTENDED_PARAMETERS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTE_CARRIES_DEPENDENCY
#		define Z_COMPILER_CPP_HAS_ATTRIBUTE_CARRIES_DEPENDENCY FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTE_NO_RETURN
#		define Z_COMPILER_CPP_HAS_ATTRIBUTE_NO_RETURN FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_CHAR16_CHARACTER
#		define Z_COMPILER_CPP_HAS_LITERAL_CHAR16_CHARACTER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_CHAR16_STRING
#		define Z_COMPILER_CPP_HAS_LITERAL_CHAR16_STRING FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_CHAR32_CHARACTER
#		define Z_COMPILER_CPP_HAS_LITERAL_CHAR32_CHARACTER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_CHAR32_STRING
#		define Z_COMPILER_CPP_HAS_LITERAL_CHAR32_STRING FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_NULL_POINTER
#		define Z_COMPILER_CPP_HAS_LITERAL_NULL_POINTER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_RAW_STRING
#		define Z_COMPILER_CPP_HAS_LITERAL_RAW_STRING FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_UNICODE_STRING
#		define Z_COMPILER_CPP_HAS_LITERAL_UNICODE_STRING FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_USER_DEFINED
#		define Z_COMPILER_CPP_HAS_LITERAL_USER_DEFINED FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_MAGIC_CONSTANT_FUNCTION_NAME
#		define Z_COMPILER_CPP_HAS_MAGIC_CONSTANT_FUNCTION_NAME FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_OPERATOR_ALIGN_OF
#		define Z_COMPILER_CPP_HAS_OPERATOR_ALIGN_OF FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_OPERATOR_NO_EXCEPTION
#		define Z_COMPILER_CPP_HAS_OPERATOR_NO_EXCEPTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_OPERATOR_SIZE_OF_NON_STATIC_DATA_MEMBER
#		define Z_COMPILER_CPP_HAS_OPERATOR_SIZE_OF_NON_STATIC_DATA_MEMBER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_OPERATOR_SIZE_OF_PARAMETER_PACK
#		define Z_COMPILER_CPP_HAS_OPERATOR_SIZE_OF_PARAMETER_PACK FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_ALIGN_AS
#		define Z_COMPILER_CPP_HAS_SPECIFIER_ALIGN_AS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_AUTO
#		define Z_COMPILER_CPP_HAS_SPECIFIER_AUTO FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_CONSTANT_EXPRESSION
#		define Z_COMPILER_CPP_HAS_SPECIFIER_CONSTANT_EXPRESSION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_DECLARED_TYPE
#		define Z_COMPILER_CPP_HAS_SPECIFIER_DECLARED_TYPE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_DECLARED_TYPE_OF_INCOMPLETE_RETURN
#		define Z_COMPILER_CPP_HAS_SPECIFIER_DECLARED_TYPE_OF_INCOMPLETE_RETURN FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_FINAL
#		define Z_COMPILER_CPP_HAS_SPECIFIER_FINAL FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_NO_EXCEPTION
#		define Z_COMPILER_CPP_HAS_SPECIFIER_NO_EXCEPTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_OVERRIDE
#		define Z_COMPILER_CPP_HAS_SPECIFIER_OVERRIDE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_STORATE_CLASS_THREAD_LOCAL
#		define Z_COMPILER_CPP_HAS_STORATE_CLASS_THREAD_LOCAL FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TYPE_CHAR16
#		define Z_COMPILER_CPP_HAS_TYPE_CHAR16 FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TYPE_CHAR32
#		define Z_COMPILER_CPP_HAS_TYPE_CHAR32 FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TYPE_LLONG
#		define Z_COMPILER_CPP_HAS_TYPE_LLONG FALSE
#	endif

	/* MARK: - C++14 support */

#	ifndef Z_COMPILER_CPP_HAS_APOSTROPHE_AS_DIGIT_SEPARATOR
#		define Z_COMPILER_CPP_HAS_APOSTROPHE_AS_DIGIT_SEPARATOR FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CPP14_RULES_ON_CONSTANT_EXPRESSION_FUNCTION
#		define Z_COMPILER_CPP_HAS_CPP14_RULES_ON_CONSTANT_EXPRESSION_FUNCTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CPP14_RULES_ON_CONTEXTUAL_CONVERSION
#		define Z_COMPILER_CPP_HAS_CPP14_RULES_ON_CONTEXTUAL_CONVERSION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DEFAULT_MEMBER_INITIALIZER_FOR_AGGREGATE
#		define Z_COMPILER_CPP_HAS_DEFAULT_MEMBER_INITIALIZER_FOR_AGGREGATE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_GENERIC_LAMBDA
#		define Z_COMPILER_CPP_HAS_GENERIC_LAMBDA FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_INITIALIZED_LAMBDA_CAPTURE
#		define Z_COMPILER_CPP_HAS_INITIALIZED_LAMBDA_CAPTURE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_RETURN_TYPE_DEDUCTION_FOR_NORMAL_FUNCTION
#		define Z_COMPILER_CPP_HAS_RETURN_TYPE_DEDUCTION_FOR_NORMAL_FUNCTION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SIZED_DEALLOCATION
#		define Z_COMPILER_CPP_HAS_SIZED_DEALLOCATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_VARIABLE_TEMPLATE
#		define Z_COMPILER_CPP_HAS_VARIABLE_TEMPLATE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTE_DEPRECATED
#		define Z_COMPILER_CPP_HAS_ATTRIBUTE_DEPRECATED FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_BINARY
#		define Z_COMPILER_CPP_HAS_LITERAL_BINARY FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SPECIFIER_DECLARED_TYPE_OF_AUTO
#		define Z_COMPILER_CPP_HAS_SPECIFIER_DECLARED_TYPE_OF_AUTO FALSE
#	endif

	/* MARK: - C++17 support */

#	ifndef Z_COMPILER_CPP_HAS_AGGREGATE_WITH_BASE_CLASSES
#		define Z_COMPILER_CPP_HAS_AGGREGATE_WITH_BASE_CLASSES FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTES_FOR_ENUMERATION
#		define Z_COMPILER_CPP_HAS_ATTRIBUTES_FOR_ENUMERATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTES_FOR_NAMESPACE
#		define Z_COMPILER_CPP_HAS_ATTRIBUTES_FOR_NAMESPACE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTE_USING_PREFIX
#		define Z_COMPILER_CPP_HAS_ATTRIBUTE_USING_PREFIX FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CONSTANT_EXPRESSION_IF
#		define Z_COMPILER_CPP_HAS_CONSTANT_EXPRESSION_IF FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CONSTANT_EXPRESSION_LAMBDA
#		define Z_COMPILER_CPP_HAS_CONSTANT_EXPRESSION_LAMBDA FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CPP17_RULES_ON_BRACED_INITIALIZATION
#		define Z_COMPILER_CPP_HAS_CPP17_RULES_ON_BRACED_INITIALIZATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CPP17_RULES_ON_EXPRESSION_EVALUATION_ORDER
#		define Z_COMPILER_CPP_HAS_CPP17_RULES_ON_EXPRESSION_EVALUATION_ORDER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CPP17_RULES_ON_INHERITING_CONSTRUCTORS
#		define Z_COMPILER_CPP_HAS_CPP17_RULES_ON_INHERITING_CONSTRUCTORS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CPP17_RULES_ON_NON_TYPE_TEMPLATE_ARGUMENTS
#		define Z_COMPILER_CPP_HAS_CPP17_RULES_ON_NON_TYPE_TEMPLATE_ARGUMENTS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_CPP17_RULES_ON_TEMPLATE_TEMPLATE_ARGUMENT_MATCHING
#		define Z_COMPILER_CPP_HAS_CPP17_RULES_ON_TEMPLATE_TEMPLATE_ARGUMENT_MATCHING FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DIFFERING_BEGIN_AND_END_TYPES_IN_RANGE_BASED_FOR
#		define Z_COMPILER_CPP_HAS_DIFFERING_BEGIN_AND_END_TYPES_IN_RANGE_BASED_FOR FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_DIRECT_LIST_INITIALIZATION_OF_ENUMERATION
#		define Z_COMPILER_CPP_HAS_DIRECT_LIST_INITIALIZATION_OF_ENUMERATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_EXCEPTION_SPECIFICATION_AS_PART_OF_THE_TYPE
#		define Z_COMPILER_CPP_HAS_EXCEPTION_SPECIFICATION_AS_PART_OF_THE_TYPE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_FOLD_EXPRESSION
#		define Z_COMPILER_CPP_HAS_FOLD_EXPRESSION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_FOLD_EXPRESSION_SAFETY_WITH_EMPTY_PARAMETER_PACK
#		define Z_COMPILER_CPP_HAS_FOLD_EXPRESSION_SAFETY_WITH_EMPTY_PARAMETER_PACK FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_GUARANTEED_COPY_ELISION
#		define Z_COMPILER_CPP_HAS_GUARANTEED_COPY_ELISION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_IF_WITH_INITIALIZER
#		define Z_COMPILER_CPP_HAS_IF_WITH_INITIALIZER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_IGNORATION_OF_UNKNOWN_ATTRIBUTES
#		define Z_COMPILER_CPP_HAS_IGNORATION_OF_UNKNOWN_ATTRIBUTES FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_INLINE_VARIABLE
#		define Z_COMPILER_CPP_HAS_INLINE_VARIABLE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LAMBDA_CAPTURE_OF_THIS_OBJECT_BY_VALUE
#		define Z_COMPILER_CPP_HAS_LAMBDA_CAPTURE_OF_THIS_OBJECT_BY_VALUE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LAUNDER
#		define Z_COMPILER_CPP_HAS_LAUNDER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_NESTED_NAMESPACE_DEFINITION
#		define Z_COMPILER_CPP_HAS_NESTED_NAMESPACE_DEFINITION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_NON_TYPE_TEMPLATE_PARAMETER_WITH_AUTO_TYPE
#		define Z_COMPILER_CPP_HAS_NON_TYPE_TEMPLATE_PARAMETER_WITH_AUTO_TYPE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_OVER_ALIGNED_DYNAMIC_ALLOCATION
#		define Z_COMPILER_CPP_HAS_OVER_ALIGNED_DYNAMIC_ALLOCATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_REMOVAL_OF_DYNAMIC_EXCEPTION_SPECIFICATION
#		define Z_COMPILER_CPP_HAS_REMOVAL_OF_DYNAMIC_EXCEPTION_SPECIFICATION FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_REMOVAL_OF_INCREMENT_BOOLEAN_OPERATOR
#		define Z_COMPILER_CPP_HAS_REMOVAL_OF_INCREMENT_BOOLEAN_OPERATOR FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_REMOVAL_OF_REGISTER_AS_STORAGE_CLASS
#		define Z_COMPILER_CPP_HAS_REMOVAL_OF_REGISTER_AS_STORAGE_CLASS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_REMOVAL_OF_TRIGRAPHS
#		define Z_COMPILER_CPP_HAS_REMOVAL_OF_TRIGRAPHS FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_STATIC_ASSERTION_WITH_NO_MESSAGE
#		define Z_COMPILER_CPP_HAS_STATIC_ASSERTION_WITH_NO_MESSAGE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_STRUCTURED_BINDING
#		define Z_COMPILER_CPP_HAS_STRUCTURED_BINDING FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_SWITCH_WITH_INITIALIZER
#		define Z_COMPILER_CPP_HAS_SWITCH_WITH_INITIALIZER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TEMPLATE_ARGUMENTS_DEDUCTION_FOR_CLASS_TEMPLATE
#		define Z_COMPILER_CPP_HAS_TEMPLATE_ARGUMENTS_DEDUCTION_FOR_CLASS_TEMPLATE FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_TYPENAME_IN_TEMPLATE_TEMPLATE_PARAMETER
#		define Z_COMPILER_CPP_HAS_TYPENAME_IN_TEMPLATE_TEMPLATE_PARAMETER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_VARIADIC_USING
#		define Z_COMPILER_CPP_HAS_VARIADIC_USING FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTE_FALL_THROUGH
#		define Z_COMPILER_CPP_HAS_ATTRIBUTE_FALL_THROUGH FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTE_MAYBE_UNUSED
#		define Z_COMPILER_CPP_HAS_ATTRIBUTE_MAYBE_UNUSED FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_ATTRIBUTE_NO_DISCARD
#		define Z_COMPILER_CPP_HAS_ATTRIBUTE_NO_DISCARD FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_HEXADECIMAL_FLOATING_POINT
#		define Z_COMPILER_CPP_HAS_LITERAL_HEXADECIMAL_FLOATING_POINT FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_LITERAL_UTF8_CHARACTER
#		define Z_COMPILER_CPP_HAS_LITERAL_UTF8_CHARACTER FALSE
#	endif

#	ifndef Z_COMPILER_CPP_HAS_PREPROCESSOR_OPERATOR_HAS_INCLUDE
#		define Z_COMPILER_CPP_HAS_PREPROCESSOR_OPERATOR_HAS_INCLUDE FALSE
#	endif

#endif

/* MARK: - Attributes */

#ifdef Z_COMPILER_ATTRIBUTE_ALIAS
#	define Z_COMPILER_HAS_ATTRIBUTE_ALIAS TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_ALIAS FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_API
#	define Z_COMPILER_HAS_ATTRIBUTE_API TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_API FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_API_ALIAS
#	define Z_COMPILER_HAS_ATTRIBUTE_API_ALIAS TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_API_ALIAS FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_API_EXPORT
#	define Z_COMPILER_HAS_ATTRIBUTE_API_EXPORT TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_API_EXPORT FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_API_EXPORT_ALIAS
#	define Z_COMPILER_HAS_ATTRIBUTE_API_EXPORT_ALIAS TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_API_EXPORT_ALIAS FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_API_WEAK_EXPORT
#	define Z_COMPILER_HAS_ATTRIBUTE_API_WEAK_EXPORT TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_API_WEAK_EXPORT FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_EBCO
#	define Z_COMPILER_HAS_ATTRIBUTE_EBCO TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_EBCO FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_INLINE
#	define Z_COMPILER_HAS_ATTRIBUTE_INLINE TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_INLINE FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_NO_RETURN
#	define Z_COMPILER_HAS_ATTRIBUTE_NO_RETURN TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_NO_RETURN FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_NULL_TERMINATED
#	define Z_COMPILER_HAS_ATTRIBUTE_NULL_TERMINATED TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_NULL_TERMINATED FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_PRIVATE
#	define Z_COMPILER_HAS_ATTRIBUTE_PRIVATE TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_PRIVATE FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_PUBLIC
#	define Z_COMPILER_HAS_ATTRIBUTE_PUBLIC TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_PUBLIC FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_STRICT_SIZE_BEGIN
#	define Z_COMPILER_HAS_ATTRIBUTE_STRICT_SIZE_BEGIN TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_STRICT_SIZE_BEGIN FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_STRICT_SIZE_END
#	define Z_COMPILER_HAS_ATTRIBUTE_STRICT_SIZE_END TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_STRICT_SIZE_END FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_THREAD_LOCAL
#	define Z_COMPILER_HAS_ATTRIBUTE_THREAD_LOCAL TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_THREAD_LOCAL FALSE
#endif

#ifdef Z_COMPILER_ATTRIBUTE_WEAK
#	define Z_COMPILER_HAS_ATTRIBUTE_WEAK TRUE
#else
#	define Z_COMPILER_HAS_ATTRIBUTE_WEAK FALSE
#endif

/* MARK: - Built-in constants */

#ifdef Z_COMPILER_CONSTANT_FLOAT16_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_FLOAT16_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT16_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT16_NAN
#	define Z_COMPILER_HAS_CONSTANT_FLOAT16_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT16_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT32_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_FLOAT32_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT32_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT32_NAN
#	define Z_COMPILER_HAS_CONSTANT_FLOAT32_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT32_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT64_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_FLOAT64_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT64_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT64_NAN
#	define Z_COMPILER_HAS_CONSTANT_FLOAT64_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT64_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT128_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_FLOAT128_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT128_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT128_NAN
#	define Z_COMPILER_HAS_CONSTANT_FLOAT128_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT128_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT80_X87_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_FLOAT80_X87_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT80_X87_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT80_X87_NAN
#	define Z_COMPILER_HAS_CONSTANT_FLOAT80_X87_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT80_X87_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT96_X87_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_FLOAT96_X87_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT96_X87_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT96_X87_NAN
#	define Z_COMPILER_HAS_CONSTANT_FLOAT96_X87_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT96_X87_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT128_X87_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_FLOAT128_X87_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT128_X87_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT128_X87_NAN
#	define Z_COMPILER_HAS_CONSTANT_FLOAT128_X87_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT128_X87_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_UCHAR_BITS
#	define Z_COMPILER_HAS_CONSTANT_UCHAR_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_UCHAR_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_UCHAR_SIZE
#	define Z_COMPILER_HAS_CONSTANT_UCHAR_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_UCHAR_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_UCHAR_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_UCHAR_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_UCHAR_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_USHORT_BITS
#	define Z_COMPILER_HAS_CONSTANT_USHORT_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_USHORT_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_USHORT_SIZE
#	define Z_COMPILER_HAS_CONSTANT_USHORT_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_USHORT_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_USHORT_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_USHORT_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_USHORT_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_UINT_BITS
#	define Z_COMPILER_HAS_CONSTANT_UINT_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_UINT_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_UINT_SIZE
#	define Z_COMPILER_HAS_CONSTANT_UINT_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_UINT_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_UINT_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_UINT_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_UINT_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_ULONG_BITS
#	define Z_COMPILER_HAS_CONSTANT_ULONG_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_ULONG_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_ULONG_SIZE
#	define Z_COMPILER_HAS_CONSTANT_ULONG_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_ULONG_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_ULONG_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_ULONG_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_ULONG_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_ULLONG_BITS
#	define Z_COMPILER_HAS_CONSTANT_ULLONG_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_ULLONG_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_ULLONG_SIZE
#	define Z_COMPILER_HAS_CONSTANT_ULLONG_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_ULLONG_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_ULLONG_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_ULLONG_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_ULLONG_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SCHAR_BITS
#	define Z_COMPILER_HAS_CONSTANT_SCHAR_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SCHAR_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SCHAR_SIZE
#	define Z_COMPILER_HAS_CONSTANT_SCHAR_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SCHAR_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SCHAR_MINIMUM
#	define Z_COMPILER_HAS_CONSTANT_SCHAR_MINIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SCHAR_MINIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SCHAR_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_SCHAR_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SCHAR_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SSHORT_BITS
#	define Z_COMPILER_HAS_CONSTANT_SSHORT_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SSHORT_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SSHORT_SIZE
#	define Z_COMPILER_HAS_CONSTANT_SSHORT_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SSHORT_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SSHORT_MINIMUM
#	define Z_COMPILER_HAS_CONSTANT_SSHORT_MINIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SSHORT_MINIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SSHORT_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_SSHORT_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SSHORT_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SINT_BITS
#	define Z_COMPILER_HAS_CONSTANT_SINT_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SINT_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SINT_SIZE
#	define Z_COMPILER_HAS_CONSTANT_SINT_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SINT_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SINT_MINIMUM
#	define Z_COMPILER_HAS_CONSTANT_SINT_MINIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SINT_MINIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SINT_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_SINT_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SINT_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SLONG_BITS
#	define Z_COMPILER_HAS_CONSTANT_SLONG_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SLONG_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SLONG_SIZE
#	define Z_COMPILER_HAS_CONSTANT_SLONG_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SLONG_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SLONG_MINIMUM
#	define Z_COMPILER_HAS_CONSTANT_SLONG_MINIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SLONG_MINIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SLONG_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_SLONG_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SLONG_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SLLONG_BITS
#	define Z_COMPILER_HAS_CONSTANT_SLLONG_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SLLONG_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SLLONG_SIZE
#	define Z_COMPILER_HAS_CONSTANT_SLLONG_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SLLONG_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SLLONG_MINIMUM
#	define Z_COMPILER_HAS_CONSTANT_SLLONG_MINIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SLLONG_MINIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SLLONG_MAXIMUM
#	define Z_COMPILER_HAS_CONSTANT_SLLONG_MAXIMUM TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SLLONG_MAXIMUM FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT_BITS
#	define Z_COMPILER_HAS_CONSTANT_FLOAT_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT_SIZE
#	define Z_COMPILER_HAS_CONSTANT_FLOAT_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_FLOAT_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_FLOAT_NAN
#	define Z_COMPILER_HAS_CONSTANT_FLOAT_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_FLOAT_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_DOUBLE_BITS
#	define Z_COMPILER_HAS_CONSTANT_DOUBLE_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_DOUBLE_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_DOUBLE_SIZE
#	define Z_COMPILER_HAS_CONSTANT_DOUBLE_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_DOUBLE_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_DOUBLE_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_DOUBLE_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_DOUBLE_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_DOUBLE_NAN
#	define Z_COMPILER_HAS_CONSTANT_DOUBLE_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_DOUBLE_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_LDOUBLE_BITS
#	define Z_COMPILER_HAS_CONSTANT_LDOUBLE_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_LDOUBLE_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_LDOUBLE_SIZE
#	define Z_COMPILER_HAS_CONSTANT_LDOUBLE_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_LDOUBLE_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_LDOUBLE_INFINITY
#	define Z_COMPILER_HAS_CONSTANT_LDOUBLE_INFINITY TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_LDOUBLE_INFINITY FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_LDOUBLE_NAN
#	define Z_COMPILER_HAS_CONSTANT_LDOUBLE_NAN TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_LDOUBLE_NAN FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SIZE_BITS
#	define Z_COMPILER_HAS_CONSTANT_SIZE_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SIZE_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SIZE_SIZE
#	define Z_COMPILER_HAS_CONSTANT_SIZE_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SIZE_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SSIZE_BITS
#	define Z_COMPILER_HAS_CONSTANT_SSIZE_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SSIZE_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_SSIZE_SIZE
#	define Z_COMPILER_HAS_CONSTANT_SSIZE_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_SSIZE_SIZE FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_POINTER_BITS
#	define Z_COMPILER_HAS_CONSTANT_POINTER_BITS TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_POINTER_BITS FALSE
#endif

#ifdef Z_COMPILER_CONSTANT_POINTER_SIZE
#	define Z_COMPILER_HAS_CONSTANT_POINTER_SIZE TRUE
#else
#	define Z_COMPILER_HAS_CONSTANT_POINTER_SIZE FALSE
#endif

/* MARK: - Built-in magic constants */

#ifdef Z_COMPILER_MAGIC_CONSTANT_MANGLED_FUNCTION_NAME
#	define Z_COMPILER_HAS_MAGIC_CONSTANT_MANGLED_FUNCTION_NAME TRUE
#else
#	define Z_COMPILER_HAS_MAGIC_CONSTANT_MANGLED_FUNCTION_NAME FALSE
#endif

/* MARK: - Built-in macros: Struture */

#ifdef Z_COMPILER_MACRO_OFFSET_OF
#	define Z_COMPILER_HAS_MACRO_OFFSET_OF TRUE
#else
#	define Z_COMPILER_HAS_MACRO_OFFSET_OF FALSE
#endif

/* MARK: - Built-in macros: VAL */

#ifdef Z_COMPILER_MACRO_VAL_INITIALIZE
#	define Z_COMPILER_HAS_MACRO_VAL_INITIALIZE TRUE
#else
#	define Z_COMPILER_HAS_MACRO_VAL_INITIALIZE FALSE
#endif

#ifdef Z_COMPILER_MACRO_VAL_FINALIZE
#	define Z_COMPILER_HAS_MACRO_VAL_FINALIZE TRUE
#else
#	define Z_COMPILER_HAS_MACRO_VAL_FINALIZE FALSE
#endif

#ifdef Z_COMPILER_MACRO_VAL_READ
#	define Z_COMPILER_HAS_MACRO_VAL_READ TRUE
#else
#	define Z_COMPILER_HAS_MACRO_VAL_READ FALSE
#endif

#ifdef Z_COMPILER_MACRO_VAL_COPY
#	define Z_COMPILER_HAS_MACRO_VAL_COPY TRUE
#else
#	define Z_COMPILER_HAS_MACRO_VAL_COPY FALSE
#endif

/* MARK: - Built-in types */

#ifdef Z_COMPILER_TYPE_UINT8
#	define Z_COMPILER_HAS_TYPE_UINT8 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_UINT8 FALSE
#endif

#ifdef Z_COMPILER_TYPE_UINT16
#	define Z_COMPILER_HAS_TYPE_UINT16 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_UINT16 FALSE
#endif

#ifdef Z_COMPILER_TYPE_UINT32
#	define Z_COMPILER_HAS_TYPE_UINT32 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_UINT32 FALSE
#endif

#ifdef Z_COMPILER_TYPE_UINT64
#	define Z_COMPILER_HAS_TYPE_UINT64 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_UINT64 FALSE
#endif

#ifdef Z_COMPILER_TYPE_UINT128
#	define Z_COMPILER_HAS_TYPE_UINT128 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_UINT128 FALSE
#endif

#ifdef Z_COMPILER_TYPE_SINT8
#	define Z_COMPILER_HAS_TYPE_SINT8 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_SINT8 FALSE
#endif

#ifdef Z_COMPILER_TYPE_SINT16
#	define Z_COMPILER_HAS_TYPE_SINT16 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_SINT16 FALSE
#endif

#ifdef Z_COMPILER_TYPE_SINT32
#	define Z_COMPILER_HAS_TYPE_SINT32 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_SINT32 FALSE
#endif

#ifdef Z_COMPILER_TYPE_SINT64
#	define Z_COMPILER_HAS_TYPE_SINT64 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_SINT64 FALSE
#endif

#ifdef Z_COMPILER_TYPE_SINT128
#	define Z_COMPILER_HAS_TYPE_SINT128 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_SINT128 FALSE
#endif

#ifdef Z_COMPILER_TYPE_FLOAT16
#	define Z_COMPILER_HAS_TYPE_FLOAT16 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_FLOAT16 FALSE
#endif

#ifdef Z_COMPILER_TYPE_FLOAT32
#	define Z_COMPILER_HAS_TYPE_FLOAT32 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_FLOAT32 FALSE
#endif

#ifdef Z_COMPILER_TYPE_FLOAT64
#	define Z_COMPILER_HAS_TYPE_FLOAT64 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_FLOAT64 FALSE
#endif

#ifdef Z_COMPILER_TYPE_FLOAT128
#	define Z_COMPILER_HAS_TYPE_FLOAT128 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_FLOAT128 FALSE
#endif

#ifdef Z_COMPILER_TYPE_FLOAT80_X87
#	define Z_COMPILER_HAS_TYPE_FLOAT80_X87 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_FLOAT80_X87 FALSE
#endif

#ifdef Z_COMPILER_TYPE_FLOAT96_X87
#	define Z_COMPILER_HAS_TYPE_FLOAT96_X87 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_FLOAT96_X87 FALSE
#endif

#ifdef Z_COMPILER_TYPE_FLOAT128_X87
#	define Z_COMPILER_HAS_TYPE_FLOAT128_X87 TRUE
#else
#	define Z_COMPILER_HAS_TYPE_FLOAT128_X87 FALSE
#endif

#ifdef Z_COMPILER_TYPE_VAL
#	define Z_COMPILER_HAS_TYPE_VAL TRUE
#else
#	define Z_COMPILER_HAS_TYPE_VAL FALSE
#endif

/* MARK: - Suffix macros for built-in types */

#ifdef Z_COMPILER_LITERAL_UINT8
#	define Z_COMPILER_HAS_LITERAL_UINT8 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_UINT8 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_UINT16
#	define Z_COMPILER_HAS_LITERAL_UINT16 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_UINT16 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_UINT32
#	define Z_COMPILER_HAS_LITERAL_UINT32 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_UINT32 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_UINT64
#	define Z_COMPILER_HAS_LITERAL_UINT64 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_UINT64 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_UINT128
#	define Z_COMPILER_HAS_LITERAL_UINT128 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_UINT128 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_SINT8
#	define Z_COMPILER_HAS_LITERAL_SINT8 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_SINT8 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_SINT16
#	define Z_COMPILER_HAS_LITERAL_SINT16 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_SINT16 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_SINT32
#	define Z_COMPILER_HAS_LITERAL_SINT32 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_SINT32 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_SINT64
#	define Z_COMPILER_HAS_LITERAL_SINT64 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_SINT64 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_SINT128
#	define Z_COMPILER_HAS_LITERAL_SINT128 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_SINT128 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_FLOAT16
#	define Z_COMPILER_HAS_LITERAL_FLOAT16 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_FLOAT16 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_FLOAT32
#	define Z_COMPILER_HAS_LITERAL_FLOAT32 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_FLOAT32 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_FLOAT64
#	define Z_COMPILER_HAS_LITERAL_FLOAT64 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_FLOAT64 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_FLOAT128
#	define Z_COMPILER_HAS_LITERAL_FLOAT128 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_FLOAT128 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_FLOAT80_X87
#	define Z_COMPILER_HAS_LITERAL_FLOAT80_X87 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_FLOAT80_X87 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_FLOAT96_X87
#	define Z_COMPILER_HAS_LITERAL_FLOAT96_X87 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_FLOAT96_X87 FALSE
#endif

#ifdef Z_COMPILER_LITERAL_FLOAT128_X87
#	define Z_COMPILER_HAS_LITERAL_FLOAT128_X87 TRUE
#else
#	define Z_COMPILER_HAS_LITERAL_FLOAT128_X87 FALSE
#endif

/* MARK: - Built-in functions: Atomic operations */

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT8_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT8_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT16_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT16_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT32_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT32_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT64_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT64_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_UINT128_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_UINT128_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT8_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT8_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT16_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT16_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT32_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT32_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT64_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT64_ATOMIC_NOT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_SET_IF_EQUAL
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_SET_IF_EQUAL TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_SET_IF_EQUAL FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_SET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_SET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_SET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_INCREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_INCREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_INCREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_ADD
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_ADD TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_ADD FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_DECREMENT
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_DECREMENT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_DECREMENT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_SUBTRACT
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_SUBTRACT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_SUBTRACT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_AND
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_AND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_AND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_OR
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_OR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_OR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_XOR
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_XOR TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_XOR FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_NAND
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_NAND TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_NAND FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_GET_THEN_NOT
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_NOT TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_GET_THEN_NOT FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_INCREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_INCREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_INCREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_ADD_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_ADD_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_ADD_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_DECREMENT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_DECREMENT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_DECREMENT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_SUBTRACT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_SUBTRACT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_SUBTRACT_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_AND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_AND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_AND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_OR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_OR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_OR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_XOR_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_XOR_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_XOR_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_NAND_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_NAND_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_NAND_THEN_GET FALSE
#endif

#ifdef Z_COMPILER_FUNCTION_SINT128_ATOMIC_NOT_THEN_GET
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_NOT_THEN_GET TRUE
#else
#	define Z_COMPILER_HAS_FUNCTION_SINT128_ATOMIC_NOT_THEN_GET FALSE
#endif

/* MARK: - Built-in traits */

#ifdef Z_COMPILER_TRAIT_TYPE_HAS_VIRTUAL_DESTRUCTOR
#	define Z_COMPILER_HAS_TRAIT_TYPE_HAS_VIRTUAL_DESTRUCTOR TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_HAS_VIRTUAL_DESTRUCTOR FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_ABSTRACT
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_ABSTRACT TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_ABSTRACT FALSE
#endif

#ifdef  Z_COMPILER_TRAIT_TYPE_IS_AGGREGATE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_AGGREGATE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_AGGREGATE FALSE
#endif

#ifdef  Z_COMPILER_TRAIT_TYPE_IS_ASSIGNABLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_ASSIGNABLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_ASSIGNABLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_BASE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_BASE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_BASE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_CLASS
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_CLASS TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_CLASS FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_CONSTRUCTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_CONSTRUCTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_CONSTRUCTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_CONVERTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_CONVERTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_CONVERTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_EMPTY
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_EMPTY TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_EMPTY FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_ENUMERATION
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_ENUMERATION TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_ENUMERATION FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_FINAL
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_FINAL TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_FINAL FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_INTERFACE_CLASS
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_INTERFACE_CLASS TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_INTERFACE_CLASS FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_LITERAL
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_LITERAL TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_LITERAL FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_ASSIGNABLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_ASSIGNABLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_ASSIGNABLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_CONSTRUCTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_CONSTRUCTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_CONSTRUCTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_COPY_ASSIGNABLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_COPY_ASSIGNABLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_COPY_ASSIGNABLE TRUE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_COPY_CONSTRUCTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_COPY_CONSTRUCTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_COPY_CONSTRUCTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_NOTHROW_DEFAULT_CONSTRUCTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_DEFAULT_CONSTRUCTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_NOTHROW_DEFAULT_CONSTRUCTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_POD
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_POD TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_POD FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_POLYMORPHIC
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_POLYMORPHIC TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_POLYMORPHIC FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_STANDARD_LAYOUT
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_STANDARD_LAYOUT TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_STANDARD_LAYOUT FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_TRIVIAL
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIAL TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIAL FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_ASSIGNABLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_ASSIGNABLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_ASSIGNABLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_CONSTRUCTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_CONSTRUCTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_CONSTRUCTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_COPY_ASSIGNABLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_COPY_ASSIGNABLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_COPY_ASSIGNABLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_COPY_CONSTRUCTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_COPY_CONSTRUCTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_COPY_CONSTRUCTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_COPYABLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_COPYABLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_COPYABLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_DEFAULT_CONSTRUCTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_DEFAULT_CONSTRUCTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_DEFAULT_CONSTRUCTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_TRIVIALLY_DESTRUCTIBLE
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_DESTRUCTIBLE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_TRIVIALLY_DESTRUCTIBLE FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_IS_UNION
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_UNION TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_IS_UNION FALSE
#endif

#ifdef Z_COMPILER_TRAIT_TYPE_UNDERLYING_TYPE
#	define Z_COMPILER_HAS_TRAIT_TYPE_UNDERLYING_TYPE TRUE
#else
#	define Z_COMPILER_HAS_TRAIT_TYPE_UNDERLYING_TYPE FALSE
#endif

/* MARK: - Value formats */

#if Z_COMPILER_C_HAS_TYPE_FLOAT && !defined(Z_COMPILER_VALUE_FORMAT_FLOAT)
#	define Z_COMPILER_VALUE_FORMAT_FLOAT Z_VALUE_FORMAT_IEEE_754_BINARY32
#endif

#if Z_COMPILER_C_HAS_TYPE_DOUBLE && !defined(Z_COMPILER_VALUE_FORMAT_DOUBLE)
#	define Z_COMPILER_VALUE_FORMAT_DOUBLE Z_VALUE_FORMAT_IEEE_754_BINARY64
#endif

/* MARK: - Complete implementations */

#if	Z_COMPILER_HAS_TYPE_VAL		    && \
	Z_COMPILER_HAS_MACRO_VAL_INITIALIZE && \
	Z_COMPILER_HAS_MACRO_VAL_FINALIZE   && \
	Z_COMPILER_HAS_MACRO_VAL_READ

#	define Z_COMPILER_HAS_VAL TRUE
#else
#	define Z_COMPILER_HAS_VAL FALSE
#endif

/* inspection/C++/completion.h EOF */
