/* Z Kit - keys/science/chemistry.h
 _____  _______________
/_   /_/  -_/_   _/  _ |
 /____/\___/ /__//___/_| Kit
Copyright (C) 2006-2018 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef _Z_keys_science_chemistry_H_
#define _Z_keys_science_chemistry_H_

#define Z_CHEMICAL_ELEMENT_HYDROGEN	   1
#define Z_CHEMICAL_ELEMENT_HELIUM	   2
#define Z_CHEMICAL_ELEMENT_LITHIUM	   3
#define Z_CHEMICAL_ELEMENT_BERYLLIUM	   4
#define Z_CHEMICAL_ELEMENT_BORON	   5
#define Z_CHEMICAL_ELEMENT_CARBON	   6
#define Z_CHEMICAL_ELEMENT_NITROGEN	   7
#define Z_CHEMICAL_ELEMENT_OXYGEN	   8
#define Z_CHEMICAL_ELEMENT_FLUORINE	   9
#define Z_CHEMICAL_ELEMENT_NEON		  10
#define Z_CHEMICAL_ELEMENT_SODIUM	  11
#define Z_CHEMICAL_ELEMENT_MAGNESIUM	  12
#define Z_CHEMICAL_ELEMENT_ALUMINIUM	  13
#define Z_CHEMICAL_ELEMENT_SILICON	  14
#define Z_CHEMICAL_ELEMENT_PHOSPHORUS	  15
#define Z_CHEMICAL_ELEMENT_SULFUR	  16
#define Z_CHEMICAL_ELEMENT_CHLORINE	  17
#define Z_CHEMICAL_ELEMENT_ARGON	  18
#define Z_CHEMICAL_ELEMENT_POTASSIUM	  19
#define Z_CHEMICAL_ELEMENT_CALCIUM	  20
#define Z_CHEMICAL_ELEMENT_SCANDIUM	  21
#define Z_CHEMICAL_ELEMENT_TITANIUM	  22
#define Z_CHEMICAL_ELEMENT_VANADIUM	  23
#define Z_CHEMICAL_ELEMENT_CHROMIUM	  24
#define Z_CHEMICAL_ELEMENT_MANGANESE	  25
#define Z_CHEMICAL_ELEMENT_IRON		  26
#define Z_CHEMICAL_ELEMENT_COBALT	  27
#define Z_CHEMICAL_ELEMENT_NICKEL	  28
#define Z_CHEMICAL_ELEMENT_COPPER	  29
#define Z_CHEMICAL_ELEMENT_ZINC		  30
#define Z_CHEMICAL_ELEMENT_GALLIUM	  31
#define Z_CHEMICAL_ELEMENT_GERMANIUM	  32
#define Z_CHEMICAL_ELEMENT_ARSENIC	  33
#define Z_CHEMICAL_ELEMENT_SELENIUM	  34
#define Z_CHEMICAL_ELEMENT_BROMINE	  35
#define Z_CHEMICAL_ELEMENT_KRYPTON	  36
#define Z_CHEMICAL_ELEMENT_RUBIDIUM	  37
#define Z_CHEMICAL_ELEMENT_STRONTIUM	  38
#define Z_CHEMICAL_ELEMENT_YTTRIUM	  39
#define Z_CHEMICAL_ELEMENT_ZIRCONIUM	  40
#define Z_CHEMICAL_ELEMENT_NIOBIUM	  41
#define Z_CHEMICAL_ELEMENT_MOLYBDENUM	  42
#define Z_CHEMICAL_ELEMENT_TECHNETIUM	  43
#define Z_CHEMICAL_ELEMENT_RUTHENIUM	  44
#define Z_CHEMICAL_ELEMENT_RHODIUM	  45
#define Z_CHEMICAL_ELEMENT_PALLADIUM	  46
#define Z_CHEMICAL_ELEMENT_SILVER	  47
#define Z_CHEMICAL_ELEMENT_CADMIUM	  48
#define Z_CHEMICAL_ELEMENT_INDIUM	  49
#define Z_CHEMICAL_ELEMENT_TIN		  50
#define Z_CHEMICAL_ELEMENT_ANTIMONY	  51
#define Z_CHEMICAL_ELEMENT_TELLURIUM	  52
#define Z_CHEMICAL_ELEMENT_IODINE	  53
#define Z_CHEMICAL_ELEMENT_XENON	  54
#define Z_CHEMICAL_ELEMENT_CAESIUM	  55
#define Z_CHEMICAL_ELEMENT_BARIUM	  56
#define Z_CHEMICAL_ELEMENT_LANTHANUM	  57
#define Z_CHEMICAL_ELEMENT_CERIUM	  58
#define Z_CHEMICAL_ELEMENT_PRASEODYMIUM	  59
#define Z_CHEMICAL_ELEMENT_NEODYMIUM	  60
#define Z_CHEMICAL_ELEMENT_PROMETHIUM	  61
#define Z_CHEMICAL_ELEMENT_SAMARIUM	  62
#define Z_CHEMICAL_ELEMENT_EUROPIUM	  63
#define Z_CHEMICAL_ELEMENT_GADOLINIUM	  64
#define Z_CHEMICAL_ELEMENT_TERBIUM	  65
#define Z_CHEMICAL_ELEMENT_DYSPROSIUM	  66
#define Z_CHEMICAL_ELEMENT_HOLMIUM	  67
#define Z_CHEMICAL_ELEMENT_ERBIUM	  68
#define Z_CHEMICAL_ELEMENT_THULIUM	  69
#define Z_CHEMICAL_ELEMENT_YTTERBIUM	  70
#define Z_CHEMICAL_ELEMENT_LUTETIUM	  71
#define Z_CHEMICAL_ELEMENT_HAFNIUM	  72
#define Z_CHEMICAL_ELEMENT_TANTALUM	  73
#define Z_CHEMICAL_ELEMENT_WOLFRAM	  74
#define Z_CHEMICAL_ELEMENT_TUNGSTEN	  Z_CHEMICAL_ELEMENT_WOLFRAM
#define Z_CHEMICAL_ELEMENT_RHENIUM	  75
#define Z_CHEMICAL_ELEMENT_OSMIUM	  76
#define Z_CHEMICAL_ELEMENT_IRIDIUM	  77
#define Z_CHEMICAL_ELEMENT_PLATINUM	  78
#define Z_CHEMICAL_ELEMENT_GOLD		  79
#define Z_CHEMICAL_ELEMENT_MERCURY	  80
#define Z_CHEMICAL_ELEMENT_THALLIUM	  81
#define Z_CHEMICAL_ELEMENT_LEAD		  82
#define Z_CHEMICAL_ELEMENT_BISMUTH	  83
#define Z_CHEMICAL_ELEMENT_POLONIUM	  84
#define Z_CHEMICAL_ELEMENT_ASTATINE	  85
#define Z_CHEMICAL_ELEMENT_RADON	  86
#define Z_CHEMICAL_ELEMENT_FRANCIUM	  87
#define Z_CHEMICAL_ELEMENT_RADIUM	  88
#define Z_CHEMICAL_ELEMENT_ACTINIUM	  89
#define Z_CHEMICAL_ELEMENT_THORIUM	  90
#define Z_CHEMICAL_ELEMENT_PROTACTINIUM	  91
#define Z_CHEMICAL_ELEMENT_URANIUM	  92
#define Z_CHEMICAL_ELEMENT_NEPTUNIUM	  93
#define Z_CHEMICAL_ELEMENT_PLUTONIUM	  94
#define Z_CHEMICAL_ELEMENT_AMERICIUM	  95
#define Z_CHEMICAL_ELEMENT_CURIUM	  96
#define Z_CHEMICAL_ELEMENT_BERKELIUM	  97
#define Z_CHEMICAL_ELEMENT_CALIFORNIUM	  98
#define Z_CHEMICAL_ELEMENT_EINSTEINIUM	  99
#define Z_CHEMICAL_ELEMENT_FERMIUM	 100
#define Z_CHEMICAL_ELEMENT_MENDELEVIUM	 101
#define Z_CHEMICAL_ELEMENT_NOBELIUM	 102
#define Z_CHEMICAL_ELEMENT_LAWRENCIUM	 103
#define Z_CHEMICAL_ELEMENT_RUTHERFORDIUM 104
#define Z_CHEMICAL_ELEMENT_DUBNIUM	 105
#define Z_CHEMICAL_ELEMENT_SEABORGIUM	 106
#define Z_CHEMICAL_ELEMENT_BOHRIUM	 107
#define Z_CHEMICAL_ELEMENT_HASSIUM	 108
#define Z_CHEMICAL_ELEMENT_MEITNERIUM	 109
#define Z_CHEMICAL_ELEMENT_DARMSTADTIUM	 110
#define Z_CHEMICAL_ELEMENT_ROENTGENIUM	 111
#define Z_CHEMICAL_ELEMENT_COPERNICIUM	 112
#define Z_CHEMICAL_ELEMENT_NIHONIUM	 113
#define Z_CHEMICAL_ELEMENT_FLEROVIUM	 114
#define Z_CHEMICAL_ELEMENT_MOSCOVIUM	 115
#define Z_CHEMICAL_ELEMENT_LIVERMORIUM	 116
#define Z_CHEMICAL_ELEMENT_TENNESSINE	 117
#define Z_CHEMICAL_ELEMENT_OGANESSON	 118

#define Z_KEY_BITS_CHEMICAL_ELEMENT 8
#define Z_KEY_LAST_CHEMICAL_ELEMENT Z_CHEMICAL_ELEMENT_OGANESSON

#define Z_CHEMICAL_ELEMENT_BLOCK_S 0
#define Z_CHEMICAL_ELEMENT_BLOCK_P 1
#define Z_CHEMICAL_ELEMENT_BLOCK_D 2
#define Z_CHEMICAL_ELEMENT_BLOCK_F 3

#define Z_KEY_BITS_CHEMICAL_ELEMENT_BLOCK 8
#define Z_KEY_LAST_CHEMICAL_ELEMENT_BLOCK Z_CHEMICAL_ELEMENT_BLOCK_F

#ifdef Z_ORDER_CHEMICAL_ELEMENT_CLASS_KEYS_HORIZONTALLY

#	define Z_CHEMICAL_ELEMENT_CLASS_ALKALI_METAL	     0
#	define Z_CHEMICAL_ELEMENT_CLASS_ALKALINE_EARTH_METAL 1
#	define Z_CHEMICAL_ELEMENT_CLASS_TRANSITION_METAL     2
#	define Z_CHEMICAL_ELEMENT_CLASS_POOR_METAL	     3
#	define Z_CHEMICAL_ELEMENT_CLASS_METALLOID	     4
#	define Z_CHEMICAL_ELEMENT_CLASS_NON_METAL	     5
#	define Z_CHEMICAL_ELEMENT_CLASS_HALOGEN		     6
#	define Z_CHEMICAL_ELEMENT_CLASS_NOBLE_GAS	     7
#	define Z_CHEMICAL_ELEMENT_CLASS_LANTHANIDE	     8
#	define Z_CHEMICAL_ELEMENT_CLASS_ACTINIDE	     9

#else

#	define Z_CHEMICAL_ELEMENT_CLASS_NON_METAL	     0
#	define Z_CHEMICAL_ELEMENT_CLASS_NOBLE_GAS	     1
#	define Z_CHEMICAL_ELEMENT_CLASS_ALKALI_METAL	     2
#	define Z_CHEMICAL_ELEMENT_CLASS_ALKALINE_EARTH_METAL 3
#	define Z_CHEMICAL_ELEMENT_CLASS_METALLOID	     4
#	define Z_CHEMICAL_ELEMENT_CLASS_HALOGEN		     5
#	define Z_CHEMICAL_ELEMENT_CLASS_POOR_METAL	     6
#	define Z_CHEMICAL_ELEMENT_CLASS_TRANSITION_METAL     7
#	define Z_CHEMICAL_ELEMENT_CLASS_LANTHANIDE	     8
#	define Z_CHEMICAL_ELEMENT_CLASS_ACTINIDE	     9

#endif

#define Z_KEY_BITS_CHEMICAL_ELEMENT_CLASS 8
#define Z_KEY_LAST_CHEMICAL_ELEMENT_CLASS Z_CHEMICAL_ELEMENT_CLASS_ACTINIDE

#define Z_CHEMICAL_ELEMENT_METAL_STATE_METAL	 0
#define Z_CHEMICAL_ELEMENT_METAL_STATE_METALLOID 1
#define Z_CHEMICAL_ELEMENT_METAL_STATE_NON_METAL 2

#define Z_KEY_BITS_CHEMICAL_ELEMENT_METAL_STATE 8
#define Z_KEY_LAST_CHEMICAL_ELEMENT_METAL_STATE Z_CHEMICAL_ELEMENT_METAL_STATE_NON_METAL

#define Z_CHEMICAL_ELEMENT_GAS_PHASE_MONOATOMIC	0
#define Z_CHEMICAL_ELEMENT_GAS_PHASE_DIATOMIC	1

#define Z_KEY_BITS_CHEMICAL_ELEMENT_GAS_PHASE 8
#define Z_KEY_LAST_CHEMICAL_ELEMENT_GAS_PHASE Z_CHEMICAL_ELEMENT_GAS_PHASE_DIATOMIC

#define Z_CHEMICAL_ELEMENT_DECAY_MODE_BETA_DECAY       0
#define Z_CHEMICAL_ELEMENT_DECAY_MODE_ELECTRON_CAPTURE 1
#define Z_CHEMICAL_ELEMENT_DECAY_MODE_ALPHA_EMISSION   2
#define Z_CHEMICAL_ELEMENT_DECAY_MODE_BETA_PLUS_DECAY  3

#define Z_KEY_BITS_CHEMICAL_ELEMENT_DECAY_MODE 8
#define Z_KEY_LAST_CHEMICAL_ELEMENT_DECAY_MODE Z_CHEMICAL_ELEMENT_DECAY_MODE_BETA_PLUS_DECAY

#define Z_CHEMICAL_ELEMENT_ADIABATIC_INDEX_5_3 0
#define Z_CHEMICAL_ELEMENT_ADIABATIC_INDEX_7_5 1

#define Z_KEY_BITS_CHEMICAL_ELEMENT_ADIABATIC_INDEX 8
#define Z_KEY_LAST_CHEMICAL_ELEMENT_ADIABATIC_INDEX Z_CHEMICAL_ELEMENT_ADIABATIC_INDEX_7_5

#endif /* _Z_keys_science_chemistry_H_ */
