/* Z Kit - formats/character set/Unicode.h
 _____  _______________
/_   /_/  -_/_   _/  _ |
 /____/\___/ /__//___/_| Kit
Copyright (C) 2006-2018 Manuel Sainz de Baranda y Goñi.
Released under the terms of the GNU Lesser General Public License v3. */

#ifndef _Z_formats_character_set_Unicode_H_
#define _Z_formats_character_set_Unicode_H_

/* MARK: - 0000h-007Fh - Basic Latin */

#define Z_UNICODE_NULL			      0x0000
#define Z_UNICODE_START_OF_HEADING	      0x0001
#define Z_UNICODE_START_OF_TEXT		      0x0002
#define Z_UNICODE_END_OF_TEXT		      0x0003
#define Z_UNICODE_END_OF_TRANSMISSION	      0x0004
#define Z_UNICODE_ENQUIRY		      0x0005
#define Z_UNICODE_ACKNOWLEDGE		      0x0006
#define Z_UNICODE_BELL			      0x0007
#define Z_UNICODE_BACKSPACE		      0x0008
#define Z_UNICODE_CHARACTER_TABULATION	      0x0009
#define Z_UNICODE_LINE_FEED		      0x000A
#define Z_UNICODE_LINE_TABULATION	      0x000B
#define Z_UNICODE_FORM_FEED		      0x000C
#define Z_UNICODE_CARRIAGE_RETURN	      0x000D
#define Z_UNICODE_SHIFT_OUT		      0x000E
#define Z_UNICODE_SHIFT_IN		      0x000F
#define Z_UNICODE_DATA_LINK_ESCAPE	      0x0010
#define Z_UNICODE_DEVICE_CONTROL_ONE	      0x0011
#define Z_UNICODE_DEVICE_CONTROL_TWO	      0x0012
#define Z_UNICODE_DEVICE_CONTROL_THREE	      0x0013
#define Z_UNICODE_DEVICE_CONTROL_FOUR	      0x0014
#define Z_UNICODE_NEGATIVE_ACKNOWLEDGE	      0x0015
#define Z_UNICODE_SYNCHRONOUS_IDLE	      0x0016
#define Z_UNICODE_END_OF_TRANSMISSION_BLOCK   0x0017
#define Z_UNICODE_CANCEL		      0x0018
#define Z_UNICODE_END_OF_MEDIUM		      0x0019
#define Z_UNICODE_SUBSTITUTE		      0x001A
#define Z_UNICODE_ESCAPE		      0x001B
#define Z_UNICODE_INFORMATION_SEPARATOR_FOUR  0x001C
#define Z_UNICODE_INFORMATION_SEPARATOR_THREE 0x001D
#define Z_UNICODE_INFORMATION_SEPARATOR_TWO   0x001E
#define Z_UNICODE_INFORMATION_SEPARATOR_ONE   0x001F
#define Z_UNICODE_SPACE			      0x0020
#define Z_UNICODE_EXCLAMATION_MARK	      0x0021
#define Z_UNICODE_QUOTATION_MARK	      0x0022
#define Z_UNICODE_NUMBER_SIGN		      0x0023
#define Z_UNICODE_DOLLAR_SIGN		      0x0024
#define Z_UNICODE_PERCENT_SIGN		      0x0025
#define Z_UNICODE_AMPERSAND		      0x0026
#define Z_UNICODE_APOSTROPHE		      0x0027
#define Z_UNICODE_LEFT_PARENTHESIS	      0x0028
#define Z_UNICODE_RIGHT_PARENTHESIS	      0x0029
#define Z_UNICODE_ASTERISK		      0x002A
#define Z_UNICODE_PLUS_SIGN		      0x002B
#define Z_UNICODE_COMMA			      0x002C
#define Z_UNICODE_HYPHEN_MINUS		      0x002D
#define Z_UNICODE_FULL_STOP		      0x002E
#define Z_UNICODE_SOLIDUS		      0x002F
#define Z_UNICODE_DIGIT_ZERO		      0x0030
#define Z_UNICODE_DIGIT_ONE		      0x0031
#define Z_UNICODE_DIGIT_TWO		      0x0032
#define Z_UNICODE_DIGIT_THREE		      0x0033
#define Z_UNICODE_DIGIT_FOUR		      0x0034
#define Z_UNICODE_DIGIT_FIVE		      0x0035
#define Z_UNICODE_DIGIT_SIX		      0x0036
#define Z_UNICODE_DIGIT_SEVEN		      0x0037
#define Z_UNICODE_DIGIT_EIGHT		      0x0038
#define Z_UNICODE_DIGIT_NINE		      0x0039
#define Z_UNICODE_COLON			      0x003A
#define Z_UNICODE_SEMICOLON		      0x003B
#define Z_UNICODE_LESS_THAN_SIGN	      0x003C
#define Z_UNICODE_EQUALS_SIGN		      0x003D
#define Z_UNICODE_GREATER_THAN_SIGN	      0x003E
#define Z_UNICODE_QUESTION_MARK		      0x003F
#define Z_UNICODE_COMMERCIAL_AT		      0x0040
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A      0x0041
#define Z_UNICODE_LATIN_CAPITAL_LETTER_B      0x0042
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C      0x0043
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D      0x0044
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E      0x0045
#define Z_UNICODE_LATIN_CAPITAL_LETTER_F      0x0046
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G      0x0047
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H      0x0048
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I      0x0049
#define Z_UNICODE_LATIN_CAPITAL_LETTER_J      0x004A
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K      0x004B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L      0x004C
#define Z_UNICODE_LATIN_CAPITAL_LETTER_M      0x004D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N      0x004E
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O      0x004F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_P      0x0050
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Q      0x0051
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R      0x0052
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S      0x0053
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T      0x0054
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U      0x0055
#define Z_UNICODE_LATIN_CAPITAL_LETTER_V      0x0056
#define Z_UNICODE_LATIN_CAPITAL_LETTER_W      0x0057
#define Z_UNICODE_LATIN_CAPITAL_LETTER_X      0x0058
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y      0x0059
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z      0x005A
#define Z_UNICODE_LEFT_SQUARE_BRACKET	      0x005B
#define Z_UNICODE_REVERSE_SOLIDUS	      0x005C
#define Z_UNICODE_RIGHT_SQUARE_BRACKET	      0x005D
#define Z_UNICODE_CIRCUMFLEX_ACCENT	      0x005E
#define Z_UNICODE_LOW_LINE		      0x005F
#define Z_UNICODE_GRAVE_ACCENT		      0x0060
#define Z_UNICODE_LATIN_SMALL_LETTER_A	      0x0061
#define Z_UNICODE_LATIN_SMALL_LETTER_B	      0x0062
#define Z_UNICODE_LATIN_SMALL_LETTER_C	      0x0063
#define Z_UNICODE_LATIN_SMALL_LETTER_D	      0x0064
#define Z_UNICODE_LATIN_SMALL_LETTER_E	      0x0065
#define Z_UNICODE_LATIN_SMALL_LETTER_F	      0x0066
#define Z_UNICODE_LATIN_SMALL_LETTER_G	      0x0067
#define Z_UNICODE_LATIN_SMALL_LETTER_H	      0x0068
#define Z_UNICODE_LATIN_SMALL_LETTER_I	      0x0069
#define Z_UNICODE_LATIN_SMALL_LETTER_J	      0x006A
#define Z_UNICODE_LATIN_SMALL_LETTER_K	      0x006B
#define Z_UNICODE_LATIN_SMALL_LETTER_L	      0x006C
#define Z_UNICODE_LATIN_SMALL_LETTER_M	      0x006D
#define Z_UNICODE_LATIN_SMALL_LETTER_N	      0x006E
#define Z_UNICODE_LATIN_SMALL_LETTER_O	      0x006F
#define Z_UNICODE_LATIN_SMALL_LETTER_P	      0x0070
#define Z_UNICODE_LATIN_SMALL_LETTER_Q	      0x0071
#define Z_UNICODE_LATIN_SMALL_LETTER_R	      0x0072
#define Z_UNICODE_LATIN_SMALL_LETTER_S	      0x0073
#define Z_UNICODE_LATIN_SMALL_LETTER_T	      0x0074
#define Z_UNICODE_LATIN_SMALL_LETTER_U	      0x0075
#define Z_UNICODE_LATIN_SMALL_LETTER_V	      0x0076
#define Z_UNICODE_LATIN_SMALL_LETTER_W	      0x0077
#define Z_UNICODE_LATIN_SMALL_LETTER_X	      0x0078
#define Z_UNICODE_LATIN_SMALL_LETTER_Y	      0x0079
#define Z_UNICODE_LATIN_SMALL_LETTER_Z	      0x007A
#define Z_UNICODE_LEFT_CURLY_BRACKET	      0x007B
#define Z_UNICODE_VERTICAL_LINE		      0x007C
#define Z_UNICODE_RIGHT_CURLY_BRACKET	      0x007D
#define Z_UNICODE_TILDE			      0x007E
#define Z_UNICODE_DELETE		      0x007F

/* MARK: - 0080h-00FFh - C1 Controls and Latin-1 Supplement */

/* 0080h <control> */
/* 0081h <control> */
/* 0084h <control> */
/* 0099h <control> */
#define Z_UNICODE_BREAK_PERMITTED_HERE			     0x0082
#define Z_UNICODE_NO_BREAK_HERE				     0x0083
#define Z_UNICODE_NEXT_LINE				     0x0085
#define Z_UNICODE_START_OF_SELECTED_AREA		     0x0086
#define Z_UNICODE_END_OF_SELECTED_AREA			     0x0087
#define Z_UNICODE_CHARACTER_TABULATION_SET		     0x0088
#define Z_UNICODE_CHARACTER_TABULATION_WITH_JUSTIFICATION    0x0089
#define Z_UNICODE_LINE_TABULATION_SET			     0x008A
#define Z_UNICODE_PARTIAL_LINE_FORWARD			     0x008B
#define Z_UNICODE_PARTIAL_LINE_BACKWARD			     0x008C
#define Z_UNICODE_REVERSE_LINE_FEED			     0x008D
#define Z_UNICODE_SINGLE_SHIFT_TWO			     0x008E
#define Z_UNICODE_SINGLE_SHIFT_THREE			     0x008F
#define Z_UNICODE_DEVICE_CONTROL_STRING			     0x0090
#define Z_UNICODE_PRIVATE_USE_ONE			     0x0091
#define Z_UNICODE_PRIVATE_USE_TWO			     0x0092
#define Z_UNICODE_SET_TRANSMIT_STATE			     0x0093
#define Z_UNICODE_CANCEL_CHARACTER			     0x0094
#define Z_UNICODE_MESSAGE_WAITING			     0x0095
#define Z_UNICODE_START_OF_GUARDED_AREA			     0x0096
#define Z_UNICODE_END_OF_GUARDED_AREA			     0x0097
#define Z_UNICODE_START_OF_STRING			     0x0098
#define Z_UNICODE_SINGLE_CHARACTER_INTRODUCER		     0x009A
#define Z_UNICODE_CONTROL_SEQUENCE_INTRODUCER		     0x009B
#define Z_UNICODE_STRING_TERMINATOR			     0x009C
#define Z_UNICODE_OPERATING_SYSTEM_COMMAND		     0x009D
#define Z_UNICODE_PRIVACY_MESSAGE			     0x009E
#define Z_UNICODE_APPLICATION_PROGRAM_COMMAND		     0x009F
#define Z_UNICODE_NO_BREAK_SPACE			     0x00A0
#define Z_UNICODE_INVERTED_EXCLAMATION_MARK		     0x00A1
#define Z_UNICODE_CENT_SIGN				     0x00A2
#define Z_UNICODE_POUND_SIGN				     0x00A3
#define Z_UNICODE_CURRENCY_SIGN				     0x00A4
#define Z_UNICODE_YEN_SIGN				     0x00A5
#define Z_UNICODE_BROKEN_BAR				     0x00A6
#define Z_UNICODE_SECTION_SIGN				     0x00A7
#define Z_UNICODE_DIAERESIS				     0x00A8
#define Z_UNICODE_COPYRIGHT_SIGN			     0x00A9
#define Z_UNICODE_FEMININE_ORDINAL_INDICATOR		     0x00AA
#define Z_UNICODE_LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK  0x00AB
#define Z_UNICODE_NOT_SIGN				     0x00AC
#define Z_UNICODE_SOFT_HYPHEN				     0x00AD
#define Z_UNICODE_REGISTERED_SIGN			     0x00AE
#define Z_UNICODE_MACRON				     0x00AF
#define Z_UNICODE_DEGREE_SIGN				     0x00B0
#define Z_UNICODE_PLUS_MINUS_SIGN			     0x00B1
#define Z_UNICODE_SUPERSCRIPT_TWO			     0x00B2
#define Z_UNICODE_SUPERSCRIPT_THREE			     0x00B3
#define Z_UNICODE_ACUTE_ACCENT				     0x00B4
#define Z_UNICODE_MICRO_SIGN				     0x00B5
#define Z_UNICODE_PILCROW_SIGN				     0x00B6
#define Z_UNICODE_MIDDLE_DOT				     0x00B7
#define Z_UNICODE_CEDILLA				     0x00B8
#define Z_UNICODE_SUPERSCRIPT_ONE			     0x00B9
#define Z_UNICODE_MASCULINE_ORDINAL_INDICATOR		     0x00BA
#define Z_UNICODE_RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK 0x00BB
#define Z_UNICODE_VULGAR_FRACTION_ONE_QUARTER		     0x00BC
#define Z_UNICODE_VULGAR_FRACTION_ONE_HALF		     0x00BD
#define Z_UNICODE_VULGAR_FRACTION_THREE_QUARTERS	     0x00BE
#define Z_UNICODE_INVERTED_QUESTION_MARK		     0x00BF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_GRAVE	     0x00C0
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_ACUTE	     0x00C1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX     0x00C2
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_TILDE	     0x00C3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS	     0x00C4
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE     0x00C5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AE		     0x00C6
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_CEDILLA	     0x00C7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_GRAVE	     0x00C8
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_ACUTE	     0x00C9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX     0x00CA
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_DIAERESIS	     0x00CB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_GRAVE	     0x00CC
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_ACUTE	     0x00CD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_CIRCUMFLEX     0x00CE
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_DIAERESIS	     0x00CF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_ETH		     0x00D0
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_TILDE	     0x00D1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_GRAVE	     0x00D2
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_ACUTE	     0x00D3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX     0x00D4
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_TILDE	     0x00D5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS	     0x00D6
#define Z_UNICODE_MULTIPLICATION_SIGN			     0x00D7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_STROKE	     0x00D8
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_GRAVE	     0x00D9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_ACUTE	     0x00DA
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_CIRCUMFLEX     0x00DB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS	     0x00DC
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_ACUTE	     0x00DD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_THORN		     0x00DE
#define Z_UNICODE_LATIN_SMALL_LETTER_SHARP_S		     0x00DF
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_GRAVE	     0x00E0
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_ACUTE	     0x00E1
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX	     0x00E2
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_TILDE	     0x00E3
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_DIAERESIS	     0x00E4
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_RING_ABOVE	     0x00E5
#define Z_UNICODE_LATIN_SMALL_LETTER_AE			     0x00E6
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_CEDILLA	     0x00E7
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_GRAVE	     0x00E8
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_ACUTE	     0x00E9
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX	     0x00EA
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_DIAERESIS	     0x00EB
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_GRAVE	     0x00EC
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_ACUTE	     0x00ED
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_CIRCUMFLEX	     0x00EE
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_DIAERESIS	     0x00EF
#define Z_UNICODE_LATIN_SMALL_LETTER_ETH		     0x00F0
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_TILDE	     0x00F1
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_GRAVE	     0x00F2
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_ACUTE	     0x00F3
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX	     0x00F4
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_TILDE	     0x00F5
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_DIAERESIS	     0x00F6
#define Z_UNICODE_DIVISION_SIGN				     0x00F7
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_STROKE	     0x00F8
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_GRAVE	     0x00F9
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_ACUTE	     0x00FA
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_CIRCUMFLEX	     0x00FB
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DIAERESIS	     0x00FC
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_ACUTE	     0x00FD
#define Z_UNICODE_LATIN_SMALL_LETTER_THORN		     0x00FE
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_DIAERESIS	     0x00FF

/* MARK: - 0100h-017Fh - Latin Extended-A */

#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_MACRON	      0x0100
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_MACRON	      0x0101
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_BREVE	      0x0102
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_BREVE	      0x0103
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_OGONEK	      0x0104
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_OGONEK	      0x0105
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_ACUTE	      0x0106
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_ACUTE	      0x0107
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_CIRCUMFLEX      0x0108
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_CIRCUMFLEX	      0x0109
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_DOT_ABOVE	      0x010A
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_DOT_ABOVE	      0x010B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_CARON	      0x010C
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_CARON	      0x010D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_CARON	      0x010E
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_CARON	      0x010F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_STROKE	      0x0110
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_STROKE	      0x0111
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_MACRON	      0x0112
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_MACRON	      0x0113
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_BREVE	      0x0114
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_BREVE	      0x0115
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_DOT_ABOVE	      0x0116
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_DOT_ABOVE	      0x0117
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_OGONEK	      0x0118
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_OGONEK	      0x0119
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CARON	      0x011A
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CARON	      0x011B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_CIRCUMFLEX      0x011C
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_CIRCUMFLEX	      0x011D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_BREVE	      0x011E
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_BREVE	      0x011F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_DOT_ABOVE	      0x0120
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_DOT_ABOVE	      0x0121
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_CEDILLA	      0x0122
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_CEDILLA	      0x0123
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_CIRCUMFLEX      0x0124
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_CIRCUMFLEX	      0x0125
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_STROKE	      0x0126
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_STROKE	      0x0127
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_TILDE	      0x0128
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_TILDE	      0x0129
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_MACRON	      0x012A
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_MACRON	      0x012B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_BREVE	      0x012C
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_BREVE	      0x012D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_OGONEK	      0x012E
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_OGONEK	      0x012F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_DOT_ABOVE	      0x0130
#define Z_UNICODE_LATIN_SMALL_LETTER_DOTLESS_I		      0x0131
#define Z_UNICODE_LATIN_CAPITAL_LIGATURE_IJ		      0x0132
#define Z_UNICODE_LATIN_SMALL_LIGATURE_IJ		      0x0133
#define Z_UNICODE_LATIN_CAPITAL_LETTER_J_WITH_CIRCUMFLEX      0x0134
#define Z_UNICODE_LATIN_SMALL_LETTER_J_WITH_CIRCUMFLEX	      0x0135
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_CEDILLA	      0x0136
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_CEDILLA	      0x0137
#define Z_UNICODE_LATIN_SMALL_LETTER_KRA		      0x0138
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_ACUTE	      0x0139
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_ACUTE	      0x013A
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_CEDILLA	      0x013B
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_CEDILLA	      0x013C
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_CARON	      0x013D
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_CARON	      0x013E
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_MIDDLE_DOT      0x013F
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_MIDDLE_DOT	      0x0140
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_STROKE	      0x0141
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_STROKE	      0x0142
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_ACUTE	      0x0143
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_ACUTE	      0x0144
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_CEDILLA	      0x0145
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_CEDILLA	      0x0146
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_CARON	      0x0147
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_CARON	      0x0148
#define Z_UNICODE_LATIN_SMALL_LETTER_N_PRECEDED_BY_APOSTROPHE 0x0149
#define Z_UNICODE_LATIN_CAPITAL_LETTER_ENG		      0x014A
#define Z_UNICODE_LATIN_SMALL_LETTER_ENG		      0x014B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_MACRON	      0x014C
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_MACRON	      0x014D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_BREVE	      0x014E
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_BREVE	      0x014F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_DOUBLE_ACUTE    0x0150
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_DOUBLE_ACUTE      0x0151
#define Z_UNICODE_LATIN_CAPITAL_LIGATURE_OE		      0x0152
#define Z_UNICODE_LATIN_SMALL_LIGATURE_OE		      0x0153
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_ACUTE	      0x0154
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_ACUTE	      0x0155
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_CEDILLA	      0x0156
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_CEDILLA	      0x0157
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_CARON	      0x0158
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_CARON	      0x0159
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_ACUTE	      0x015A
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_ACUTE	      0x015B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_CIRCUMFLEX      0x015C
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_CIRCUMFLEX	      0x015D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_CEDILLA	      0x015E
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_CEDILLA	      0x015F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_CARON	      0x0160
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_CARON	      0x0161
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_CEDILLA	      0x0162
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_CEDILLA	      0x0163
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_CARON	      0x0164
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_CARON	      0x0165
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_STROKE	      0x0166
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_STROKE	      0x0167
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_TILDE	      0x0168
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_TILDE	      0x0169
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_MACRON	      0x016A
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_MACRON	      0x016B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_BREVE	      0x016C
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_BREVE	      0x016D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_RING_ABOVE      0x016E
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_RING_ABOVE	      0x016F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DOUBLE_ACUTE    0x0170
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DOUBLE_ACUTE      0x0171
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_OGONEK	      0x0172
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_OGONEK	      0x0173
#define Z_UNICODE_LATIN_CAPITAL_LETTER_W_WITH_CIRCUMFLEX      0x0174
#define Z_UNICODE_LATIN_SMALL_LETTER_W_WITH_CIRCUMFLEX	      0x0175
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_CIRCUMFLEX      0x0176
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_CIRCUMFLEX	      0x0177
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_DIAERESIS	      0x0178
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_ACUTE	      0x0179
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_ACUTE	      0x017A
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_DOT_ABOVE	      0x017B
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_DOT_ABOVE	      0x017C
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_CARON	      0x017D
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_CARON	      0x017E
#define Z_UNICODE_LATIN_SMALL_LETTER_LONG_S		      0x017F

/* MARK: - 0180h-024Fh - Latin Extended-B */

#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_STROKE			0x0180
#define Z_UNICODE_LATIN_CAPITAL_LETTER_B_WITH_HOOK			0x0181
#define Z_UNICODE_LATIN_CAPITAL_LETTER_B_WITH_TOPBAR			0x0182
#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_TOPBAR			0x0183
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TONE_SIX				0x0184
#define Z_UNICODE_LATIN_SMALL_LETTER_TONE_SIX				0x0185
#define Z_UNICODE_LATIN_CAPITAL_LETTER_OPEN_O				0x0186
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_HOOK			0x0187
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_HOOK			0x0188
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AFRICAN_D			0x0189
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_HOOK			0x018A
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_TOPBAR			0x018B
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_TOPBAR			0x018C
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_DELTA			0x018D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_REVERSED_E			0x018E
#define Z_UNICODE_LATIN_CAPITAL_LETTER_SCHWA				0x018F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_OPEN_E				0x0190
#define Z_UNICODE_LATIN_CAPITAL_LETTER_F_WITH_HOOK			0x0191
#define Z_UNICODE_LATIN_SMALL_LETTER_F_WITH_HOOK			0x0192
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_HOOK			0x0193
#define Z_UNICODE_LATIN_CAPITAL_LETTER_GAMMA				0x0194
#define Z_UNICODE_LATIN_SMALL_LETTER_HV					0x0195
#define Z_UNICODE_LATIN_CAPITAL_LETTER_IOTA				0x0196
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_STROKE			0x0197
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_HOOK			0x0198
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_HOOK			0x0199
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_BAR				0x019A
#define Z_UNICODE_LATIN_SMALL_LETTER_LAMBDA_WITH_STROKE			0x019B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_M				0x019C
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_LEFT_HOOK			0x019D
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_LONG_RIGHT_LEG		0x019E
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_MIDDLE_TILDE		0x019F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_HORN			0x01A0
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_HORN			0x01A1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_OI				0x01A2
#define Z_UNICODE_LATIN_SMALL_LETTER_OI					0x01A3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_P_WITH_HOOK			0x01A4
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_HOOK			0x01A5
#define Z_UNICODE_LATIN_LETTER_YR					0x01A6
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TONE_TWO				0x01A7
#define Z_UNICODE_LATIN_SMALL_LETTER_TONE_TWO				0x01A8
#define Z_UNICODE_LATIN_CAPITAL_LETTER_ESH				0x01A9
#define Z_UNICODE_LATIN_LETTER_REVERSED_ESH_LOOP			0x01AA
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_PALATAL_HOOK		0x01AB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_HOOK			0x01AC
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_HOOK			0x01AD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_RETROFLEX_HOOK		0x01AE
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_HORN			0x01AF
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_HORN			0x01B0
#define Z_UNICODE_LATIN_CAPITAL_LETTER_UPSILON				0x01B1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_V_WITH_HOOK			0x01B2
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_HOOK			0x01B3
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_HOOK			0x01B4
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_STROKE			0x01B5
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_STROKE			0x01B6
#define Z_UNICODE_LATIN_CAPITAL_LETTER_EZH				0x01B7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_EZH_REVERSED			0x01B8
#define Z_UNICODE_LATIN_SMALL_LETTER_EZH_REVERSED			0x01B9
#define Z_UNICODE_LATIN_SMALL_LETTER_EZH_WITH_TAIL			0x01BA
#define Z_UNICODE_LATIN_LETTER_TWO_WITH_STROKE				0x01BB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TONE_FIVE			0x01BC
#define Z_UNICODE_LATIN_SMALL_LETTER_TONE_FIVE				0x01BD
#define Z_UNICODE_LATIN_LETTER_INVERTED_GLOTTAL_STOP_WITH_STROKE	0x01BE
#define Z_UNICODE_LATIN_LETTER_WYNN					0x01BF
#define Z_UNICODE_LATIN_LETTER_DENTAL_CLICK				0x01C0
#define Z_UNICODE_LATIN_LETTER_LATERAL_CLICK				0x01C1
#define Z_UNICODE_LATIN_LETTER_ALVEOLAR_CLICK				0x01C2
#define Z_UNICODE_LATIN_LETTER_RETROFLEX_CLICK				0x01C3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_DZ_WITH_CARON			0x01C4
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_SMALL_LETTER_Z_WITH_CARON	0x01C5
#define Z_UNICODE_LATIN_SMALL_LETTER_DZ_WITH_CARON			0x01C6
#define Z_UNICODE_LATIN_CAPITAL_LETTER_LJ				0x01C7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_SMALL_LETTER_J		0x01C8
#define Z_UNICODE_LATIN_SMALL_LETTER_LJ					0x01C9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_NJ				0x01CA
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_SMALL_LETTER_J		0x01CB
#define Z_UNICODE_LATIN_SMALL_LETTER_NJ					0x01CC
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_CARON			0x01CD
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_CARON			0x01CE
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_CARON			0x01CF
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_CARON			0x01D0
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_CARON			0x01D1
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_CARON			0x01D2
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_CARON			0x01D3
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_CARON			0x01D4
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_MACRON	0x01D5
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_MACRON	0x01D6
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_ACUTE	0x01D7
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_ACUTE		0x01D8
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_CARON	0x01D9
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_CARON		0x01DA
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_AND_GRAVE	0x01DB
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_AND_GRAVE		0x01DC
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_E				0x01DD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS_AND_MACRON	0x01DE
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_DIAERESIS_AND_MACRON	0x01DF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_DOT_ABOVE_AND_MACRON	0x01E0
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_DOT_ABOVE_AND_MACRON	0x01E1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AE_WITH_MACRON			0x01E2
#define Z_UNICODE_LATIN_SMALL_LETTER_AE_WITH_MACRON			0x01E3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_STROKE			0x01E4
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_STROKE			0x01E5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_CARON			0x01E6
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_CARON			0x01E7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_CARON			0x01E8
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_CARON			0x01E9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_OGONEK			0x01EA
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_OGONEK			0x01EB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_OGONEK_AND_MACRON		0x01EC
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_OGONEK_AND_MACRON		0x01ED
#define Z_UNICODE_LATIN_CAPITAL_LETTER_EZH_WITH_CARON			0x01EE
#define Z_UNICODE_LATIN_SMALL_LETTER_EZH_WITH_CARON			0x01EF
#define Z_UNICODE_LATIN_SMALL_LETTER_J_WITH_CARON			0x01F0
#define Z_UNICODE_LATIN_CAPITAL_LETTER_DZ				0x01F1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_SMALL_LETTER_Z		0x01F2
#define Z_UNICODE_LATIN_SMALL_LETTER_DZ					0x01F3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_ACUTE			0x01F4
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_ACUTE			0x01F5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_HWAIR				0x01F6
#define Z_UNICODE_LATIN_CAPITAL_LETTER_WYNN				0x01F7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_GRAVE			0x01F8
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_GRAVE			0x01F9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE_AND_ACUTE	0x01FA
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_RING_ABOVE_AND_ACUTE	0x01FB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AE_WITH_ACUTE			0x01FC
#define Z_UNICODE_LATIN_SMALL_LETTER_AE_WITH_ACUTE			0x01FD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_STROKE_AND_ACUTE		0x01FE
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_STROKE_AND_ACUTE		0x01FF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_DOUBLE_GRAVE		0x0200
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_DOUBLE_GRAVE		0x0201
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_INVERTED_BREVE		0x0202
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_INVERTED_BREVE		0x0203
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_DOUBLE_GRAVE		0x0204
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_DOUBLE_GRAVE		0x0205
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_INVERTED_BREVE		0x0206
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_INVERTED_BREVE		0x0207
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_DOUBLE_GRAVE		0x0208
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_DOUBLE_GRAVE		0x0209
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_INVERTED_BREVE		0x020A
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_INVERTED_BREVE		0x020B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_DOUBLE_GRAVE		0x020C
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_DOUBLE_GRAVE		0x020D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_INVERTED_BREVE		0x020E
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_INVERTED_BREVE		0x020F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_DOUBLE_GRAVE		0x0210
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_DOUBLE_GRAVE		0x0211
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_INVERTED_BREVE		0x0212
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_INVERTED_BREVE		0x0213
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DOUBLE_GRAVE		0x0214
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DOUBLE_GRAVE		0x0215
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_INVERTED_BREVE		0x0216
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_INVERTED_BREVE		0x0217
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_COMMA_BELOW		0x0218
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_COMMA_BELOW			0x0219
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_COMMA_BELOW		0x021A
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_COMMA_BELOW			0x021B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_YOGH				0x021C
#define Z_UNICODE_LATIN_SMALL_LETTER_YOGH				0x021D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_CARON			0x021E
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_CARON			0x021F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_LONG_RIGHT_LEG		0x0220
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_CURL			0x0221
#define Z_UNICODE_LATIN_CAPITAL_LETTER_OU				0x0222
#define Z_UNICODE_LATIN_SMALL_LETTER_OU					0x0223
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_HOOK			0x0224
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_HOOK			0x0225
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_DOT_ABOVE			0x0226
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_DOT_ABOVE			0x0227
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CEDILLA			0x0228
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CEDILLA			0x0229
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS_AND_MACRON	0x022A
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_DIAERESIS_AND_MACRON	0x022B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_MACRON		0x022C
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_TILDE_AND_MACRON		0x022D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_DOT_ABOVE			0x022E
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_DOT_ABOVE			0x022F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_DOT_ABOVE_AND_MACRON	0x0230
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_DOT_ABOVE_AND_MACRON	0x0231
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_MACRON			0x0232
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_MACRON			0x0233
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_CURL			0x0234
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_CURL			0x0235
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_CURL			0x0236
#define Z_UNICODE_LATIN_SMALL_LETTER_DOTLESS_J				0x0237
#define Z_UNICODE_LATIN_SMALL_LETTER_DB_DIGRAPH				0x0238
#define Z_UNICODE_LATIN_SMALL_LETTER_QP_DIGRAPH				0x0239
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_STROKE			0x023A
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_STROKE			0x023B
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_STROKE			0x023C
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_BAR			0x023D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_DIAGONAL_STROKE		0x023E
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_SWASH_TAIL			0x023F
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_SWASH_TAIL			0x0240
#define Z_UNICODE_LATIN_CAPITAL_LETTER_GLOTTAL_STOP			0x0241
#define Z_UNICODE_LATIN_SMALL_LETTER_GLOTTAL_STOP			0x0242
#define Z_UNICODE_LATIN_CAPITAL_LETTER_B_WITH_STROKE			0x0243
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_BAR				0x0244
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_V				0x0245
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_STROKE			0x0246
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_STROKE			0x0247
#define Z_UNICODE_LATIN_CAPITAL_LETTER_J_WITH_STROKE			0x0248
#define Z_UNICODE_LATIN_SMALL_LETTER_J_WITH_STROKE			0x0249
#define Z_UNICODE_LATIN_CAPITAL_LETTER_SMALL_Q_WITH_HOOK_TAIL		0x024A
#define Z_UNICODE_LATIN_SMALL_LETTER_Q_WITH_HOOK_TAIL			0x024B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_STROKE			0x024C
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_STROKE			0x024D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_STROKE			0x024E
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_STROKE			0x024F

/* MARK: - 0250h-02AFh - IPA Extensions */

#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_A			     0x0250
#define Z_UNICODE_LATIN_SMALL_LETTER_ALPHA			     0x0251
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_ALPHA		     0x0252
#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_HOOK		     0x0253
#define Z_UNICODE_LATIN_SMALL_LETTER_OPEN_O			     0x0254
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_CURL		     0x0255
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_TAIL		     0x0256
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_HOOK		     0x0257
#define Z_UNICODE_LATIN_SMALL_LETTER_REVERSED_E			     0x0258
#define Z_UNICODE_LATIN_SMALL_LETTER_SCHWA			     0x0259
#define Z_UNICODE_LATIN_SMALL_LETTER_SCHWA_WITH_HOOK		     0x025A
#define Z_UNICODE_LATIN_SMALL_LETTER_OPEN_E			     0x025B
#define Z_UNICODE_LATIN_SMALL_LETTER_REVERSED_OPEN_E		     0x025C
#define Z_UNICODE_LATIN_SMALL_LETTER_REVERSED_OPEN_E_WITH_HOOK	     0x025D
#define Z_UNICODE_LATIN_SMALL_LETTER_CLOSED_REVERSED_OPEN_E	     0x025E
#define Z_UNICODE_LATIN_SMALL_LETTER_DOTLESS_J_WITH_STROKE	     0x025F
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_HOOK		     0x0260
#define Z_UNICODE_LATIN_SMALL_LETTER_SCRIPT_G			     0x0261
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_G			     0x0262
#define Z_UNICODE_LATIN_SMALL_LETTER_GAMMA			     0x0263
#define Z_UNICODE_LATIN_SMALL_LETTER_RAMS_HORN			     0x0264
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_H			     0x0265
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_HOOK		     0x0266
#define Z_UNICODE_LATIN_SMALL_LETTER_HENG_WITH_HOOK		     0x0267
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_STROKE		     0x0268
#define Z_UNICODE_LATIN_SMALL_LETTER_IOTA			     0x0269
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_I			     0x026A
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_MIDDLE_TILDE	     0x026B
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_BELT		     0x026C
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_RETROFLEX_HOOK	     0x026D
#define Z_UNICODE_LATIN_SMALL_LETTER_LEZH			     0x026E
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_M			     0x026F
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_M_WITH_LONG_LEG	     0x0270
#define Z_UNICODE_LATIN_SMALL_LETTER_M_WITH_HOOK		     0x0271
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_LEFT_HOOK		     0x0272
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_RETROFLEX_HOOK	     0x0273
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_N			     0x0274
#define Z_UNICODE_LATIN_SMALL_LETTER_BARRED_O			     0x0275
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_OE			     0x0276
#define Z_UNICODE_LATIN_SMALL_LETTER_CLOSED_OMEGA		     0x0277
#define Z_UNICODE_LATIN_SMALL_LETTER_PHI			     0x0278
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_R			     0x0279
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_R_WITH_LONG_LEG	     0x027A
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_R_WITH_HOOK		     0x027B
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_LONG_LEG		     0x027C
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_TAIL		     0x027D
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_FISHHOOK		     0x027E
#define Z_UNICODE_LATIN_SMALL_LETTER_REVERSED_R_WITH_FISHHOOK	     0x027F
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_R			     0x0280
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_INVERTED_R		     0x0281
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_HOOK		     0x0282
#define Z_UNICODE_LATIN_SMALL_LETTER_ESH			     0x0283
#define Z_UNICODE_LATIN_SMALL_LETTER_DOTLESS_J_WITH_STROKE_AND_HOOK  0x0284
#define Z_UNICODE_LATIN_SMALL_LETTER_SQUAT_REVERSED_ESH		     0x0285
#define Z_UNICODE_LATIN_SMALL_LETTER_ESH_WITH_CURL		     0x0286
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_T			     0x0287
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_RETROFLEX_HOOK	     0x0288
#define Z_UNICODE_LATIN_SMALL_LETTER_U_BAR			     0x0289
#define Z_UNICODE_LATIN_SMALL_LETTER_UPSILON			     0x028A
#define Z_UNICODE_LATIN_SMALL_LETTER_V_WITH_HOOK		     0x028B
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_V			     0x028C
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_W			     0x028D
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_Y			     0x028E
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_Y			     0x028F
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_RETROFLEX_HOOK	     0x0290
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_CURL		     0x0291
#define Z_UNICODE_LATIN_SMALL_LETTER_EZH			     0x0292
#define Z_UNICODE_LATIN_SMALL_LETTER_EZH_WITH_CURL		     0x0293
#define Z_UNICODE_LATIN_LETTER_GLOTTAL_STOP			     0x0294
#define Z_UNICODE_LATIN_LETTER_PHARYNGEAL_VOICED_FRICATIVE	     0x0295
#define Z_UNICODE_LATIN_LETTER_INVERTED_GLOTTAL_STOP		     0x0296
#define Z_UNICODE_LATIN_LETTER_STRETCHED_C			     0x0297
#define Z_UNICODE_LATIN_LETTER_BILABIAL_CLICK			     0x0298
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_B			     0x0299
#define Z_UNICODE_LATIN_SMALL_LETTER_CLOSED_OPEN_E		     0x029A
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_G_WITH_HOOK	     0x029B
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_H			     0x029C
#define Z_UNICODE_LATIN_SMALL_LETTER_J_WITH_CROSSED_TAIL	     0x029D
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_K			     0x029E
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_L			     0x029F
#define Z_UNICODE_LATIN_SMALL_LETTER_Q_WITH_HOOK		     0x02A0
#define Z_UNICODE_LATIN_LETTER_GLOTTAL_STOP_WITH_STROKE		     0x02A1
#define Z_UNICODE_LATIN_LETTER_REVERSED_GLOTTAL_STOP_WITH_STROKE     0x02A2
#define Z_UNICODE_LATIN_SMALL_LETTER_DZ_DIGRAPH			     0x02A3
#define Z_UNICODE_LATIN_SMALL_LETTER_DEZH_DIGRAPH		     0x02A4
#define Z_UNICODE_LATIN_SMALL_LETTER_DZ_DIGRAPH_WITH_CURL	     0x02A5
#define Z_UNICODE_LATIN_SMALL_LETTER_TS_DIGRAPH			     0x02A6
#define Z_UNICODE_LATIN_SMALL_LETTER_TESH_DIGRAPH		     0x02A7
#define Z_UNICODE_LATIN_SMALL_LETTER_TC_DIGRAPH_WITH_CURL	     0x02A8
#define Z_UNICODE_LATIN_SMALL_LETTER_FENG_DIGRAPH		     0x02A9
#define Z_UNICODE_LATIN_SMALL_LETTER_LS_DIGRAPH			     0x02AA
#define Z_UNICODE_LATIN_SMALL_LETTER_LZ_DIGRAPH			     0x02AB
#define Z_UNICODE_LATIN_LETTER_BILABIAL_PERCUSSIVE		     0x02AC
#define Z_UNICODE_LATIN_LETTER_BIDENTAL_PERCUSSIVE		     0x02AD
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_H_WITH_FISHHOOK	     0x02AE
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_H_WITH_FISHHOOK_AND_TAIL 0x02AF

/* MARK: - 02B0h-02FFh - Spacing Modifier Letters */

#define Z_UNICODE_MODIFIER_LETTER_SMALL_H		      0x02B0
#define Z_UNICODE_MODIFIER_LETTER_SMALL_H_WITH_HOOK	      0x02B1
#define Z_UNICODE_MODIFIER_LETTER_SMALL_J		      0x02B2
#define Z_UNICODE_MODIFIER_LETTER_SMALL_R		      0x02B3
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_R	      0x02B4
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_R_WITH_HOOK    0x02B5
#define Z_UNICODE_MODIFIER_LETTER_SMALL_CAPITAL_INVERTED_R    0x02B6
#define Z_UNICODE_MODIFIER_LETTER_SMALL_W		      0x02B7
#define Z_UNICODE_MODIFIER_LETTER_SMALL_Y		      0x02B8
#define Z_UNICODE_MODIFIER_LETTER_PRIME			      0x02B9
#define Z_UNICODE_MODIFIER_LETTER_DOUBLE_PRIME		      0x02BA
#define Z_UNICODE_MODIFIER_LETTER_TURNED_COMMA		      0x02BB
#define Z_UNICODE_MODIFIER_LETTER_APOSTROPHE		      0x02BC
#define Z_UNICODE_MODIFIER_LETTER_REVERSED_COMMA	      0x02BD
#define Z_UNICODE_MODIFIER_LETTER_RIGHT_HALF_RING	      0x02BE
#define Z_UNICODE_MODIFIER_LETTER_LEFT_HALF_RING	      0x02BF
#define Z_UNICODE_MODIFIER_LETTER_GLOTTAL_STOP		      0x02C0
#define Z_UNICODE_MODIFIER_LETTER_REVERSED_GLOTTAL_STOP	      0x02C1
#define Z_UNICODE_MODIFIER_LETTER_LEFT_ARROWHEAD	      0x02C2
#define Z_UNICODE_MODIFIER_LETTER_RIGHT_ARROWHEAD	      0x02C3
#define Z_UNICODE_MODIFIER_LETTER_UP_ARROWHEAD		      0x02C4
#define Z_UNICODE_MODIFIER_LETTER_DOWN_ARROWHEAD	      0x02C5
#define Z_UNICODE_MODIFIER_LETTER_CIRCUMFLEX_ACCENT	      0x02C6
#define Z_UNICODE_CARON					      0x02C7
#define Z_UNICODE_MODIFIER_LETTER_VERTICAL_LINE		      0x02C8
#define Z_UNICODE_MODIFIER_LETTER_MACRON		      0x02C9
#define Z_UNICODE_MODIFIER_LETTER_ACUTE_ACCENT		      0x02CA
#define Z_UNICODE_MODIFIER_LETTER_GRAVE_ACCENT		      0x02CB
#define Z_UNICODE_MODIFIER_LETTER_LOW_VERTICAL_LINE	      0x02CC
#define Z_UNICODE_MODIFIER_LETTER_LOW_MACRON		      0x02CD
#define Z_UNICODE_MODIFIER_LETTER_LOW_GRAVE_ACCENT	      0x02CE
#define Z_UNICODE_MODIFIER_LETTER_LOW_ACUTE_ACCENT	      0x02CF
#define Z_UNICODE_MODIFIER_LETTER_TRIANGULAR_COLON	      0x02D0
#define Z_UNICODE_MODIFIER_LETTER_HALF_TRIANGULAR_COLON	      0x02D1
#define Z_UNICODE_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING     0x02D2
#define Z_UNICODE_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING      0x02D3
#define Z_UNICODE_MODIFIER_LETTER_UP_TACK		      0x02D4
#define Z_UNICODE_MODIFIER_LETTER_DOWN_TACK		      0x02D5
#define Z_UNICODE_MODIFIER_LETTER_PLUS_SIGN		      0x02D6
#define Z_UNICODE_MODIFIER_LETTER_MINUS_SIGN		      0x02D7
#define Z_UNICODE_BREVE					      0x02D8
#define Z_UNICODE_DOT_ABOVE				      0x02D9
#define Z_UNICODE_RING_ABOVE				      0x02DA
#define Z_UNICODE_OGONEK				      0x02DB
#define Z_UNICODE_SMALL_TILDE				      0x02DC
#define Z_UNICODE_DOUBLE_ACUTE_ACCENT			      0x02DD
#define Z_UNICODE_MODIFIER_LETTER_RHOTIC_HOOK		      0x02DE
#define Z_UNICODE_MODIFIER_LETTER_CROSS_ACCENT		      0x02DF
#define Z_UNICODE_MODIFIER_LETTER_SMALL_GAMMA		      0x02E0
#define Z_UNICODE_MODIFIER_LETTER_SMALL_L		      0x02E1
#define Z_UNICODE_MODIFIER_LETTER_SMALL_S		      0x02E2
#define Z_UNICODE_MODIFIER_LETTER_SMALL_X		      0x02E3
#define Z_UNICODE_MODIFIER_LETTER_SMALL_REVERSED_GLOTTAL_STOP 0x02E4
#define Z_UNICODE_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR	      0x02E5
#define Z_UNICODE_MODIFIER_LETTER_HIGH_TONE_BAR		      0x02E6
#define Z_UNICODE_MODIFIER_LETTER_MID_TONE_BAR		      0x02E7
#define Z_UNICODE_MODIFIER_LETTER_LOW_TONE_BAR		      0x02E8
#define Z_UNICODE_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR	      0x02E9
#define Z_UNICODE_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK     0x02EA
#define Z_UNICODE_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK    0x02EB
#define Z_UNICODE_MODIFIER_LETTER_VOICING		      0x02EC
#define Z_UNICODE_MODIFIER_LETTER_UNASPIRATED		      0x02ED
#define Z_UNICODE_MODIFIER_LETTER_DOUBLE_APOSTROPHE	      0x02EE
#define Z_UNICODE_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD	      0x02EF
#define Z_UNICODE_MODIFIER_LETTER_LOW_UP_ARROWHEAD	      0x02F0
#define Z_UNICODE_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD	      0x02F1
#define Z_UNICODE_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD	      0x02F2
#define Z_UNICODE_MODIFIER_LETTER_LOW_RING		      0x02F3
#define Z_UNICODE_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT	      0x02F4
#define Z_UNICODE_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT  0x02F5
#define Z_UNICODE_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT  0x02F6
#define Z_UNICODE_MODIFIER_LETTER_LOW_TILDE		      0x02F7
#define Z_UNICODE_MODIFIER_LETTER_RAISED_COLON		      0x02F8
#define Z_UNICODE_MODIFIER_LETTER_BEGIN_HIGH_TONE	      0x02F9
#define Z_UNICODE_MODIFIER_LETTER_END_HIGH_TONE		      0x02FA
#define Z_UNICODE_MODIFIER_LETTER_BEGIN_LOW_TONE	      0x02FB
#define Z_UNICODE_MODIFIER_LETTER_END_LOW_TONE		      0x02FC
#define Z_UNICODE_MODIFIER_LETTER_SHELF			      0x02FD
#define Z_UNICODE_MODIFIER_LETTER_OPEN_SHELF		      0x02FE
#define Z_UNICODE_MODIFIER_LETTER_LOW_LEFT_ARROW	      0x02FF

/* MARK: - 0300h-036Fh - Combining Diacritical Marks */

#define Z_UNICODE_COMBINING_GRAVE_ACCENT			   0x0300
#define Z_UNICODE_COMBINING_ACUTE_ACCENT			   0x0301
#define Z_UNICODE_COMBINING_CIRCUMFLEX_ACCENT			   0x0302
#define Z_UNICODE_COMBINING_TILDE				   0x0303
#define Z_UNICODE_COMBINING_MACRON				   0x0304
#define Z_UNICODE_COMBINING_OVERLINE				   0x0305
#define Z_UNICODE_COMBINING_BREVE				   0x0306
#define Z_UNICODE_COMBINING_DOT_ABOVE				   0x0307
#define Z_UNICODE_COMBINING_DIAERESIS				   0x0308
#define Z_UNICODE_COMBINING_HOOK_ABOVE				   0x0309
#define Z_UNICODE_COMBINING_RING_ABOVE				   0x030A
#define Z_UNICODE_COMBINING_DOUBLE_ACUTE_ACCENT			   0x030B
#define Z_UNICODE_COMBINING_CARON				   0x030C
#define Z_UNICODE_COMBINING_VERTICAL_LINE_ABOVE			   0x030D
#define Z_UNICODE_COMBINING_DOUBLE_VERTICAL_LINE_ABOVE		   0x030E
#define Z_UNICODE_COMBINING_DOUBLE_GRAVE_ACCENT			   0x030F
#define Z_UNICODE_COMBINING_CANDRABINDU				   0x0310
#define Z_UNICODE_COMBINING_INVERTED_BREVE			   0x0311
#define Z_UNICODE_COMBINING_TURNED_COMMA_ABOVE			   0x0312
#define Z_UNICODE_COMBINING_COMMA_ABOVE				   0x0313
#define Z_UNICODE_COMBINING_REVERSED_COMMA_ABOVE		   0x0314
#define Z_UNICODE_COMBINING_COMMA_ABOVE_RIGHT			   0x0315
#define Z_UNICODE_COMBINING_GRAVE_ACCENT_BELOW			   0x0316
#define Z_UNICODE_COMBINING_ACUTE_ACCENT_BELOW			   0x0317
#define Z_UNICODE_COMBINING_LEFT_TACK_BELOW			   0x0318
#define Z_UNICODE_COMBINING_RIGHT_TACK_BELOW			   0x0319
#define Z_UNICODE_COMBINING_LEFT_ANGLE_ABOVE			   0x031A
#define Z_UNICODE_COMBINING_HORN				   0x031B
#define Z_UNICODE_COMBINING_LEFT_HALF_RING_BELOW		   0x031C
#define Z_UNICODE_COMBINING_UP_TACK_BELOW			   0x031D
#define Z_UNICODE_COMBINING_DOWN_TACK_BELOW			   0x031E
#define Z_UNICODE_COMBINING_PLUS_SIGN_BELOW			   0x031F
#define Z_UNICODE_COMBINING_MINUS_SIGN_BELOW			   0x0320
#define Z_UNICODE_COMBINING_PALATALIZED_HOOK_BELOW		   0x0321
#define Z_UNICODE_COMBINING_RETROFLEX_HOOK_BELOW		   0x0322
#define Z_UNICODE_COMBINING_DOT_BELOW				   0x0323
#define Z_UNICODE_COMBINING_DIAERESIS_BELOW			   0x0324
#define Z_UNICODE_COMBINING_RING_BELOW				   0x0325
#define Z_UNICODE_COMBINING_COMMA_BELOW				   0x0326
#define Z_UNICODE_COMBINING_CEDILLA				   0x0327
#define Z_UNICODE_COMBINING_OGONEK				   0x0328
#define Z_UNICODE_COMBINING_VERTICAL_LINE_BELOW			   0x0329
#define Z_UNICODE_COMBINING_BRIDGE_BELOW			   0x032A
#define Z_UNICODE_COMBINING_INVERTED_DOUBLE_ARCH_BELOW		   0x032B
#define Z_UNICODE_COMBINING_CARON_BELOW				   0x032C
#define Z_UNICODE_COMBINING_CIRCUMFLEX_ACCENT_BELOW		   0x032D
#define Z_UNICODE_COMBINING_BREVE_BELOW				   0x032E
#define Z_UNICODE_COMBINING_INVERTED_BREVE_BELOW		   0x032F
#define Z_UNICODE_COMBINING_TILDE_BELOW				   0x0330
#define Z_UNICODE_COMBINING_MACRON_BELOW			   0x0331
#define Z_UNICODE_COMBINING_LOW_LINE				   0x0332
#define Z_UNICODE_COMBINING_DOUBLE_LOW_LINE			   0x0333
#define Z_UNICODE_COMBINING_TILDE_OVERLAY			   0x0334
#define Z_UNICODE_COMBINING_SHORT_STROKE_OVERLAY		   0x0335
#define Z_UNICODE_COMBINING_LONG_STROKE_OVERLAY			   0x0336
#define Z_UNICODE_COMBINING_SHORT_SOLIDUS_OVERLAY		   0x0337
#define Z_UNICODE_COMBINING_LONG_SOLIDUS_OVERLAY		   0x0338
#define Z_UNICODE_COMBINING_RIGHT_HALF_RING_BELOW		   0x0339
#define Z_UNICODE_COMBINING_INVERTED_BRIDGE_BELOW		   0x033A
#define Z_UNICODE_COMBINING_SQUARE_BELOW			   0x033B
#define Z_UNICODE_COMBINING_SEAGULL_BELOW			   0x033C
#define Z_UNICODE_COMBINING_X_ABOVE				   0x033D
#define Z_UNICODE_COMBINING_VERTICAL_TILDE			   0x033E
#define Z_UNICODE_COMBINING_DOUBLE_OVERLINE			   0x033F
#define Z_UNICODE_COMBINING_GRAVE_TONE_MARK			   0x0340
#define Z_UNICODE_COMBINING_ACUTE_TONE_MARK			   0x0341
#define Z_UNICODE_COMBINING_GREEK_PERISPOMENI			   0x0342
#define Z_UNICODE_COMBINING_GREEK_KORONIS			   0x0343
#define Z_UNICODE_COMBINING_GREEK_DIALYTIKA_TONOS		   0x0344
#define Z_UNICODE_COMBINING_GREEK_YPOGEGRAMMENI			   0x0345
#define Z_UNICODE_COMBINING_BRIDGE_ABOVE			   0x0346
#define Z_UNICODE_COMBINING_EQUALS_SIGN_BELOW			   0x0347
#define Z_UNICODE_COMBINING_DOUBLE_VERTICAL_LINE_BELOW		   0x0348
#define Z_UNICODE_COMBINING_LEFT_ANGLE_BELOW			   0x0349
#define Z_UNICODE_COMBINING_NOT_TILDE_ABOVE			   0x034A
#define Z_UNICODE_COMBINING_HOMOTHETIC_ABOVE			   0x034B
#define Z_UNICODE_COMBINING_ALMOST_EQUAL_TO_ABOVE		   0x034C
#define Z_UNICODE_COMBINING_LEFT_RIGHT_ARROW_BELOW		   0x034D
#define Z_UNICODE_COMBINING_UPWARDS_ARROW_BELOW			   0x034E
#define Z_UNICODE_COMBINING_GRAPHEME_JOINER			   0x034F
#define Z_UNICODE_COMBINING_RIGHT_ARROWHEAD_ABOVE		   0x0350
#define Z_UNICODE_COMBINING_LEFT_HALF_RING_ABOVE		   0x0351
#define Z_UNICODE_COMBINING_FERMATA				   0x0352
#define Z_UNICODE_COMBINING_X_BELOW				   0x0353
#define Z_UNICODE_COMBINING_LEFT_ARROWHEAD_BELOW		   0x0354
#define Z_UNICODE_COMBINING_RIGHT_ARROWHEAD_BELOW		   0x0355
#define Z_UNICODE_COMBINING_RIGHT_ARROWHEAD_AND_UP_ARROWHEAD_BELOW 0x0356
#define Z_UNICODE_COMBINING_RIGHT_HALF_RING_ABOVE		   0x0357
#define Z_UNICODE_COMBINING_DOT_ABOVE_RIGHT			   0x0358
#define Z_UNICODE_COMBINING_ASTERISK_BELOW			   0x0359
#define Z_UNICODE_COMBINING_DOUBLE_RING_BELOW			   0x035A
#define Z_UNICODE_COMBINING_ZIGZAG_ABOVE			   0x035B
#define Z_UNICODE_COMBINING_DOUBLE_BREVE_BELOW			   0x035C
#define Z_UNICODE_COMBINING_DOUBLE_BREVE			   0x035D
#define Z_UNICODE_COMBINING_DOUBLE_MACRON			   0x035E
#define Z_UNICODE_COMBINING_DOUBLE_MACRON_BELOW			   0x035F
#define Z_UNICODE_COMBINING_DOUBLE_TILDE			   0x0360
#define Z_UNICODE_COMBINING_DOUBLE_INVERTED_BREVE		   0x0361
#define Z_UNICODE_COMBINING_DOUBLE_RIGHTWARDS_ARROW_BELOW	   0x0362
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_A		   0x0363
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_E		   0x0364
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_I		   0x0365
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_O		   0x0366
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_U		   0x0367
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_C		   0x0368
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_D		   0x0369
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_H		   0x036A
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_M		   0x036B
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_R		   0x036C
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_T		   0x036D
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_V		   0x036E
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_X		   0x036F

/* MARK: - 0370h-03FFh - Greek and Coptic */

#define Z_UNICODE_GREEK_CAPITAL_LETTER_HETA			      0x0370
#define Z_UNICODE_GREEK_SMALL_LETTER_HETA			      0x0371
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ARCHAIC_SAMPI		      0x0372
#define Z_UNICODE_GREEK_SMALL_LETTER_ARCHAIC_SAMPI		      0x0373
#define Z_UNICODE_GREEK_NUMERAL_SIGN				      0x0374
#define Z_UNICODE_GREEK_LOWER_NUMERAL_SIGN			      0x0375
#define Z_UNICODE_GREEK_CAPITAL_LETTER_PAMPHYLIAN_DIGAMMA	      0x0376
#define Z_UNICODE_GREEK_SMALL_LETTER_PAMPHYLIAN_DIGAMMA		      0x0377
#define Z_UNICODE_GREEK_YPOGEGRAMMENI				      0x037A
#define Z_UNICODE_GREEK_SMALL_REVERSED_LUNATE_SIGMA_SYMBOL	      0x037B
#define Z_UNICODE_GREEK_SMALL_DOTTED_LUNATE_SIGMA_SYMBOL	      0x037C
#define Z_UNICODE_GREEK_SMALL_REVERSED_DOTTED_LUNATE_SIGMA_SYMBOL     0x037D
#define Z_UNICODE_GREEK_QUESTION_MARK				      0x037E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_YOT			      0x037F
#define Z_UNICODE_GREEK_TONOS					      0x0384
#define Z_UNICODE_GREEK_DIALYTIKA_TONOS				      0x0385
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_TONOS		      0x0386
#define Z_UNICODE_GREEK_ANO_TELEIA				      0x0387
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_TONOS	      0x0388
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_TONOS		      0x0389
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_TONOS		      0x038A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_TONOS	      0x038C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_TONOS	      0x038E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_TONOS		      0x038F
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_TONOS    0x0390
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA			      0x0391
#define Z_UNICODE_GREEK_CAPITAL_LETTER_BETA			      0x0392
#define Z_UNICODE_GREEK_CAPITAL_LETTER_GAMMA			      0x0393
#define Z_UNICODE_GREEK_CAPITAL_LETTER_DELTA			      0x0394
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON			      0x0395
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ZETA			      0x0396
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA			      0x0397
#define Z_UNICODE_GREEK_CAPITAL_LETTER_THETA			      0x0398
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA			      0x0399
#define Z_UNICODE_GREEK_CAPITAL_LETTER_KAPPA			      0x039A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_LAMDA			      0x039B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_MU			      0x039C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_NU			      0x039D
#define Z_UNICODE_GREEK_CAPITAL_LETTER_XI			      0x039E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON			      0x039F
#define Z_UNICODE_GREEK_CAPITAL_LETTER_PI			      0x03A0
#define Z_UNICODE_GREEK_CAPITAL_LETTER_RHO			      0x03A1
#define Z_UNICODE_GREEK_CAPITAL_LETTER_SIGMA			      0x03A3
#define Z_UNICODE_GREEK_CAPITAL_LETTER_TAU			      0x03A4
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON			      0x03A5
#define Z_UNICODE_GREEK_CAPITAL_LETTER_PHI			      0x03A6
#define Z_UNICODE_GREEK_CAPITAL_LETTER_CHI			      0x03A7
#define Z_UNICODE_GREEK_CAPITAL_LETTER_PSI			      0x03A8
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA			      0x03A9
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_DIALYTIKA	      0x03AA
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_DIALYTIKA	      0x03AB
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_TONOS		      0x03AC
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_TONOS		      0x03AD
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_TONOS		      0x03AE
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_TONOS		      0x03AF
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_TONOS 0x03B0
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA			      0x03B1
#define Z_UNICODE_GREEK_SMALL_LETTER_BETA			      0x03B2
#define Z_UNICODE_GREEK_SMALL_LETTER_GAMMA			      0x03B3
#define Z_UNICODE_GREEK_SMALL_LETTER_DELTA			      0x03B4
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON			      0x03B5
#define Z_UNICODE_GREEK_SMALL_LETTER_ZETA			      0x03B6
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA			      0x03B7
#define Z_UNICODE_GREEK_SMALL_LETTER_THETA			      0x03B8
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA			      0x03B9
#define Z_UNICODE_GREEK_SMALL_LETTER_KAPPA			      0x03BA
#define Z_UNICODE_GREEK_SMALL_LETTER_LAMDA			      0x03BB
#define Z_UNICODE_GREEK_SMALL_LETTER_MU				      0x03BC
#define Z_UNICODE_GREEK_SMALL_LETTER_NU				      0x03BD
#define Z_UNICODE_GREEK_SMALL_LETTER_XI				      0x03BE
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON			      0x03BF
#define Z_UNICODE_GREEK_SMALL_LETTER_PI				      0x03C0
#define Z_UNICODE_GREEK_SMALL_LETTER_RHO			      0x03C1
#define Z_UNICODE_GREEK_SMALL_LETTER_FINAL_SIGMA		      0x03C2
#define Z_UNICODE_GREEK_SMALL_LETTER_SIGMA			      0x03C3
#define Z_UNICODE_GREEK_SMALL_LETTER_TAU			      0x03C4
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON			      0x03C5
#define Z_UNICODE_GREEK_SMALL_LETTER_PHI			      0x03C6
#define Z_UNICODE_GREEK_SMALL_LETTER_CHI			      0x03C7
#define Z_UNICODE_GREEK_SMALL_LETTER_PSI			      0x03C8
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA			      0x03C9
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA	      0x03CA
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA	      0x03CB
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_TONOS		      0x03CC
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_TONOS		      0x03CD
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_TONOS		      0x03CE
#define Z_UNICODE_GREEK_CAPITAL_KAI_SYMBOL			      0x03CF
#define Z_UNICODE_GREEK_BETA_SYMBOL				      0x03D0
#define Z_UNICODE_GREEK_THETA_SYMBOL				      0x03D1
#define Z_UNICODE_GREEK_UPSILON_WITH_HOOK_SYMBOL		      0x03D2
#define Z_UNICODE_GREEK_UPSILON_WITH_ACUTE_AND_HOOK_SYMBOL	      0x03D3
#define Z_UNICODE_GREEK_UPSILON_WITH_DIAERESIS_AND_HOOK_SYMBOL	      0x03D4
#define Z_UNICODE_GREEK_PHI_SYMBOL				      0x03D5
#define Z_UNICODE_GREEK_PI_SYMBOL				      0x03D6
#define Z_UNICODE_GREEK_KAI_SYMBOL				      0x03D7
#define Z_UNICODE_GREEK_LETTER_ARCHAIC_KOPPA			      0x03D8
#define Z_UNICODE_GREEK_SMALL_LETTER_ARCHAIC_KOPPA		      0x03D9
#define Z_UNICODE_GREEK_LETTER_STIGMA				      0x03DA
#define Z_UNICODE_GREEK_SMALL_LETTER_STIGMA			      0x03DB
#define Z_UNICODE_GREEK_LETTER_DIGAMMA				      0x03DC
#define Z_UNICODE_GREEK_SMALL_LETTER_DIGAMMA			      0x03DD
#define Z_UNICODE_GREEK_LETTER_KOPPA				      0x03DE
#define Z_UNICODE_GREEK_SMALL_LETTER_KOPPA			      0x03DF
#define Z_UNICODE_GREEK_LETTER_SAMPI				      0x03E0
#define Z_UNICODE_GREEK_SMALL_LETTER_SAMPI			      0x03E1
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_SHEI			      0x03E2
#define Z_UNICODE_COPTIC_SMALL_LETTER_SHEI			      0x03E3
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_FEI			      0x03E4
#define Z_UNICODE_COPTIC_SMALL_LETTER_FEI			      0x03E5
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_KHEI			      0x03E6
#define Z_UNICODE_COPTIC_SMALL_LETTER_KHEI			      0x03E7
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_HORI			      0x03E8
#define Z_UNICODE_COPTIC_SMALL_LETTER_HORI			      0x03E9
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_GANGIA			      0x03EA
#define Z_UNICODE_COPTIC_SMALL_LETTER_GANGIA			      0x03EB
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_SHIMA			      0x03EC
#define Z_UNICODE_COPTIC_SMALL_LETTER_SHIMA			      0x03ED
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_DEI			      0x03EE
#define Z_UNICODE_COPTIC_SMALL_LETTER_DEI			      0x03EF
#define Z_UNICODE_GREEK_KAPPA_SYMBOL				      0x03F0
#define Z_UNICODE_GREEK_RHO_SYMBOL				      0x03F1
#define Z_UNICODE_GREEK_LUNATE_SIGMA_SYMBOL			      0x03F2
#define Z_UNICODE_GREEK_LETTER_YOT				      0x03F3
#define Z_UNICODE_GREEK_CAPITAL_THETA_SYMBOL			      0x03F4
#define Z_UNICODE_GREEK_LUNATE_EPSILON_SYMBOL			      0x03F5
#define Z_UNICODE_GREEK_REVERSED_LUNATE_EPSILON_SYMBOL		      0x03F6
#define Z_UNICODE_GREEK_CAPITAL_LETTER_SHO			      0x03F7
#define Z_UNICODE_GREEK_SMALL_LETTER_SHO			      0x03F8
#define Z_UNICODE_GREEK_CAPITAL_LUNATE_SIGMA_SYMBOL		      0x03F9
#define Z_UNICODE_GREEK_CAPITAL_LETTER_SAN			      0x03FA
#define Z_UNICODE_GREEK_SMALL_LETTER_SAN			      0x03FB
#define Z_UNICODE_GREEK_RHO_WITH_STROKE_SYMBOL			      0x03FC
#define Z_UNICODE_GREEK_CAPITAL_REVERSED_LUNATE_SIGMA_SYMBOL	      0x03FD
#define Z_UNICODE_GREEK_CAPITAL_DOTTED_LUNATE_SIGMA_SYMBOL	      0x03FE
#define Z_UNICODE_GREEK_CAPITAL_REVERSED_DOTTED_LUNATE_SIGMA_SYMBOL   0x03FF

/* MARK: - 0400h-04FFh - Cyrillic */

#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IE_WITH_GRAVE			   0x0400
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IO				   0x0401
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DJE				   0x0402
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_GJE				   0x0403
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_UKRAINIAN_IE			   0x0404
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DZE				   0x0405
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BYELORUSSIAN_UKRAINIAN_I	   0x0406
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YI				   0x0407
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_JE				   0x0408
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_LJE				   0x0409
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_NJE				   0x040A
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TSHE				   0x040B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KJE				   0x040C
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_I_WITH_GRAVE			   0x040D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SHORT_U			   0x040E
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DZHE				   0x040F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_A				   0x0410
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BE				   0x0411
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_VE				   0x0412
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_GHE				   0x0413
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DE				   0x0414
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IE				   0x0415
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZHE				   0x0416
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZE				   0x0417
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_I				   0x0418
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SHORT_I			   0x0419
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KA				   0x041A
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EL				   0x041B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EM				   0x041C
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EN				   0x041D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_O				   0x041E
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_PE				   0x041F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ER				   0x0420
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ES				   0x0421
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TE				   0x0422
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_U				   0x0423
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EF				   0x0424
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_HA				   0x0425
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TSE				   0x0426
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_CHE				   0x0427
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SHA				   0x0428
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SHCHA				   0x0429
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_HARD_SIGN			   0x042A
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YERU				   0x042B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SOFT_SIGN			   0x042C
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_E				   0x042D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YU				   0x042E
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YA				   0x042F
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_A				   0x0430
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BE				   0x0431
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_VE				   0x0432
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_GHE				   0x0433
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DE				   0x0434
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IE				   0x0435
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZHE				   0x0436
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZE				   0x0437
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_I				   0x0438
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SHORT_I				   0x0439
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KA				   0x043A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EL				   0x043B
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EM				   0x043C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EN				   0x043D
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_O				   0x043E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_PE				   0x043F
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ER				   0x0440
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ES				   0x0441
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TE				   0x0442
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_U				   0x0443
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EF				   0x0444
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_HA				   0x0445
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TSE				   0x0446
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_CHE				   0x0447
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SHA				   0x0448
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SHCHA				   0x0449
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_HARD_SIGN			   0x044A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YERU				   0x044B
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SOFT_SIGN			   0x044C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_E				   0x044D
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YU				   0x044E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YA				   0x044F
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IE_WITH_GRAVE			   0x0450
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IO				   0x0451
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DJE				   0x0452
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_GJE				   0x0453
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_UKRAINIAN_IE			   0x0454
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DZE				   0x0455
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BYELORUSSIAN_UKRAINIAN_I	   0x0456
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YI				   0x0457
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_JE				   0x0458
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_LJE				   0x0459
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_NJE				   0x045A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TSHE				   0x045B
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KJE				   0x045C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_I_WITH_GRAVE			   0x045D
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SHORT_U				   0x045E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DZHE				   0x045F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_OMEGA				   0x0460
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_OMEGA				   0x0461
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YAT				   0x0462
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YAT				   0x0463
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IOTIFIED_E			   0x0464
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IOTIFIED_E			   0x0465
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_LITTLE_YUS			   0x0466
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_LITTLE_YUS			   0x0467
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IOTIFIED_LITTLE_YUS		   0x0468
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IOTIFIED_LITTLE_YUS		   0x0469
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BIG_YUS			   0x046A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BIG_YUS				   0x046B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IOTIFIED_BIG_YUS		   0x046C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IOTIFIED_BIG_YUS		   0x046D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KSI				   0x046E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KSI				   0x046F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_PSI				   0x0470
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_PSI				   0x0471
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_FITA				   0x0472
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_FITA				   0x0473
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IZHITSA			   0x0474
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IZHITSA				   0x0475
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IZHITSA_WITH_DOUBLE_GRAVE_ACCENT 0x0476
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IZHITSA_WITH_DOUBLE_GRAVE_ACCENT   0x0477
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_UK				   0x0478
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_UK				   0x0479
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ROUND_OMEGA			   0x047A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ROUND_OMEGA			   0x047B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_OMEGA_WITH_TITLO		   0x047C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_OMEGA_WITH_TITLO		   0x047D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_OT				   0x047E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_OT				   0x047F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOPPA				   0x0480
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOPPA				   0x0481
#define Z_UNICODE_CYRILLIC_THOUSANDS_SIGN				   0x0482
#define Z_UNICODE_COMBINING_CYRILLIC_TITLO				   0x0483
#define Z_UNICODE_COMBINING_CYRILLIC_PALATALIZATION			   0x0484
#define Z_UNICODE_COMBINING_CYRILLIC_DASIA_PNEUMATA			   0x0485
#define Z_UNICODE_COMBINING_CYRILLIC_PSILI_PNEUMATA			   0x0486
#define Z_UNICODE_COMBINING_CYRILLIC_POKRYTIE				   0x0487
#define Z_UNICODE_COMBINING_CYRILLIC_HUNDRED_THOUSANDS_SIGN		   0x0488
#define Z_UNICODE_COMBINING_CYRILLIC_MILLIONS_SIGN			   0x0489
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SHORT_I_WITH_TAIL		   0x048A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SHORT_I_WITH_TAIL		   0x048B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SEMISOFT_SIGN			   0x048C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SEMISOFT_SIGN			   0x048D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ER_WITH_TICK			   0x048E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ER_WITH_TICK			   0x048F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_GHE_WITH_UPTURN		   0x0490
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_GHE_WITH_UPTURN			   0x0491
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_GHE_WITH_STROKE		   0x0492
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_GHE_WITH_STROKE			   0x0493
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_GHE_WITH_MIDDLE_HOOK		   0x0494
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_GHE_WITH_MIDDLE_HOOK		   0x0495
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZHE_WITH_DESCENDER		   0x0496
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZHE_WITH_DESCENDER		   0x0497
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZE_WITH_DESCENDER		   0x0498
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZE_WITH_DESCENDER		   0x0499
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KA_WITH_DESCENDER		   0x049A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KA_WITH_DESCENDER		   0x049B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KA_WITH_VERTICAL_STROKE	   0x049C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KA_WITH_VERTICAL_STROKE		   0x049D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KA_WITH_STROKE		   0x049E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KA_WITH_STROKE			   0x049F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BASHKIR_KA			   0x04A0
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BASHKIR_KA			   0x04A1
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EN_WITH_DESCENDER		   0x04A2
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EN_WITH_DESCENDER		   0x04A3
#define Z_UNICODE_CYRILLIC_CAPITAL_LIGATURE_EN_GHE			   0x04A4
#define Z_UNICODE_CYRILLIC_SMALL_LIGATURE_EN_GHE			   0x04A5
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_PE_WITH_MIDDLE_HOOK		   0x04A6
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_PE_WITH_MIDDLE_HOOK		   0x04A7
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ABKHASIAN_HA			   0x04A8
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ABKHASIAN_HA			   0x04A9
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ES_WITH_DESCENDER		   0x04AA
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ES_WITH_DESCENDER		   0x04AB
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TE_WITH_DESCENDER		   0x04AC
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TE_WITH_DESCENDER		   0x04AD
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_STRAIGHT_U			   0x04AE
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_STRAIGHT_U			   0x04AF
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_STRAIGHT_U_WITH_STROKE	   0x04B0
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_STRAIGHT_U_WITH_STROKE		   0x04B1
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_HA_WITH_DESCENDER		   0x04B2
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_HA_WITH_DESCENDER		   0x04B3
#define Z_UNICODE_CYRILLIC_CAPITAL_LIGATURE_TE_TSE			   0x04B4
#define Z_UNICODE_CYRILLIC_SMALL_LIGATURE_TE_TSE			   0x04B5
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_CHE_WITH_DESCENDER		   0x04B6
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_CHE_WITH_DESCENDER		   0x04B7
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_CHE_WITH_VERTICAL_STROKE	   0x04B8
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_CHE_WITH_VERTICAL_STROKE	   0x04B9
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SHHA				   0x04BA
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SHHA				   0x04BB
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ABKHASIAN_CHE			   0x04BC
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ABKHASIAN_CHE			   0x04BD
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ABKHASIAN_CHE_WITH_DESCENDER	   0x04BE
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ABKHASIAN_CHE_WITH_DESCENDER	   0x04BF
#define Z_UNICODE_CYRILLIC_LETTER_PALOCHKA				   0x04C0
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZHE_WITH_BREVE		   0x04C1
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZHE_WITH_BREVE			   0x04C2
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KA_WITH_HOOK			   0x04C3
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KA_WITH_HOOK			   0x04C4
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EL_WITH_TAIL			   0x04C5
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EL_WITH_TAIL			   0x04C6
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EN_WITH_HOOK			   0x04C7
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EN_WITH_HOOK			   0x04C8
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EN_WITH_TAIL			   0x04C9
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EN_WITH_TAIL			   0x04CA
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KHAKASSIAN_CHE		   0x04CB
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KHAKASSIAN_CHE			   0x04CC
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EM_WITH_TAIL			   0x04CD
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EM_WITH_TAIL			   0x04CE
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_PALOCHKA			   0x04CF
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_A_WITH_BREVE			   0x04D0
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_A_WITH_BREVE			   0x04D1
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_A_WITH_DIAERESIS		   0x04D2
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_A_WITH_DIAERESIS		   0x04D3
#define Z_UNICODE_CYRILLIC_CAPITAL_LIGATURE_A_IE			   0x04D4
#define Z_UNICODE_CYRILLIC_SMALL_LIGATURE_A_IE				   0x04D5
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IE_WITH_BREVE			   0x04D6
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IE_WITH_BREVE			   0x04D7
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SCHWA				   0x04D8
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SCHWA				   0x04D9
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SCHWA_WITH_DIAERESIS		   0x04DA
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SCHWA_WITH_DIAERESIS		   0x04DB
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZHE_WITH_DIAERESIS		   0x04DC
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZHE_WITH_DIAERESIS		   0x04DD
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZE_WITH_DIAERESIS		   0x04DE
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZE_WITH_DIAERESIS		   0x04DF
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ABKHASIAN_DZE			   0x04E0
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ABKHASIAN_DZE			   0x04E1
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_I_WITH_MACRON			   0x04E2
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_I_WITH_MACRON			   0x04E3
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_I_WITH_DIAERESIS		   0x04E4
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_I_WITH_DIAERESIS		   0x04E5
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_O_WITH_DIAERESIS		   0x04E6
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_O_WITH_DIAERESIS		   0x04E7
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BARRED_O			   0x04E8
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BARRED_O			   0x04E9
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BARRED_O_WITH_DIAERESIS	   0x04EA
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BARRED_O_WITH_DIAERESIS		   0x04EB
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_E_WITH_DIAERESIS		   0x04EC
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_E_WITH_DIAERESIS		   0x04ED
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_U_WITH_MACRON			   0x04EE
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_U_WITH_MACRON			   0x04EF
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_U_WITH_DIAERESIS		   0x04F0
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_U_WITH_DIAERESIS		   0x04F1
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_U_WITH_DOUBLE_ACUTE		   0x04F2
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_U_WITH_DOUBLE_ACUTE		   0x04F3
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_CHE_WITH_DIAERESIS		   0x04F4
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_CHE_WITH_DIAERESIS		   0x04F5
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_GHE_WITH_DESCENDER		   0x04F6
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_GHE_WITH_DESCENDER		   0x04F7
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YERU_WITH_DIAERESIS		   0x04F8
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YERU_WITH_DIAERESIS		   0x04F9
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_GHE_WITH_STROKE_AND_HOOK	   0x04FA
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_GHE_WITH_STROKE_AND_HOOK	   0x04FB
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_HA_WITH_HOOK			   0x04FC
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_HA_WITH_HOOK			   0x04FD
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_HA_WITH_STROKE		   0x04FE
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_HA_WITH_STROKE			   0x04FF

/* MARK: - 0500h-052Fh - Cyrillic Supplement */

#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOMI_DE	      0x0500
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOMI_DE		      0x0501
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOMI_DJE	      0x0502
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOMI_DJE	      0x0503
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOMI_ZJE	      0x0504
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOMI_ZJE	      0x0505
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOMI_DZJE	      0x0506
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOMI_DZJE	      0x0507
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOMI_LJE	      0x0508
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOMI_LJE	      0x0509
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOMI_NJE	      0x050A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOMI_NJE	      0x050B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOMI_SJE	      0x050C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOMI_SJE	      0x050D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_KOMI_TJE	      0x050E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_KOMI_TJE	      0x050F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_REVERSED_ZE	      0x0510
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_REVERSED_ZE	      0x0511
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EL_WITH_HOOK	      0x0512
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EL_WITH_HOOK	      0x0513
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_LHA		      0x0514
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_LHA		      0x0515
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_RHA		      0x0516
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_RHA		      0x0517
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YAE		      0x0518
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YAE		      0x0519
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_QA		      0x051A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_QA		      0x051B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_WE		      0x051C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_WE		      0x051D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ALEUT_KA	      0x051E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ALEUT_KA	      0x051F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EL_WITH_MIDDLE_HOOK 0x0520
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EL_WITH_MIDDLE_HOOK   0x0521
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EN_WITH_MIDDLE_HOOK 0x0522
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EN_WITH_MIDDLE_HOOK   0x0523
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_PE_WITH_DESCENDER   0x0524
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_PE_WITH_DESCENDER     0x0525
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SHHA_WITH_DESCENDER 0x0526
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SHHA_WITH_DESCENDER   0x0527
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EN_WITH_LEFT_HOOK   0x0528
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EN_WITH_LEFT_HOOK     0x0529
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DZZHE		      0x052A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DZZHE		      0x052B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DCHE		      0x052C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DCHE		      0x052D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_EL_WITH_DESCENDER   0x052E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_EL_WITH_DESCENDER     0x052F

/* MARK: - 0530h-058Fh - Armenian */

#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_AYB		  0x0531
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_BEN		  0x0532
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_GIM		  0x0533
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_DA		  0x0534
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_ECH		  0x0535
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_ZA		  0x0536
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_EH		  0x0537
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_ET		  0x0538
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_TO		  0x0539
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_ZHE		  0x053A
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_INI		  0x053B
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_LIWN		  0x053C
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_XEH		  0x053D
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_CA		  0x053E
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_KEN		  0x053F
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_HO		  0x0540
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_JA		  0x0541
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_GHAD		  0x0542
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_CHEH		  0x0543
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_MEN		  0x0544
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_YI		  0x0545
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_NOW		  0x0546
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_SHA		  0x0547
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_VO		  0x0548
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_CHA		  0x0549
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_PEH		  0x054A
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_JHEH		  0x054B
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_RA		  0x054C
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_SEH		  0x054D
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_VEW		  0x054E
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_TIWN		  0x054F
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_REH		  0x0550
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_CO		  0x0551
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_YIWN		  0x0552
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_PIWR		  0x0553
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_KEH		  0x0554
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_OH		  0x0555
#define Z_UNICODE_ARMENIAN_CAPITAL_LETTER_FEH		  0x0556
#define Z_UNICODE_ARMENIAN_MODIFIER_LETTER_LEFT_HALF_RING 0x0559
#define Z_UNICODE_ARMENIAN_APOSTROPHE			  0x055A
#define Z_UNICODE_ARMENIAN_EMPHASIS_MARK		  0x055B
#define Z_UNICODE_ARMENIAN_EXCLAMATION_MARK		  0x055C
#define Z_UNICODE_ARMENIAN_COMMA			  0x055D
#define Z_UNICODE_ARMENIAN_QUESTION_MARK		  0x055E
#define Z_UNICODE_ARMENIAN_ABBREVIATION_MARK		  0x055F
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_AYB		  0x0561
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_BEN		  0x0562
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_GIM		  0x0563
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_DA		  0x0564
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_ECH		  0x0565
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_ZA		  0x0566
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_EH		  0x0567
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_ET		  0x0568
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_TO		  0x0569
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_ZHE		  0x056A
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_INI		  0x056B
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_LIWN		  0x056C
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_XEH		  0x056D
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_CA		  0x056E
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_KEN		  0x056F
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_HO		  0x0570
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_JA		  0x0571
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_GHAD		  0x0572
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_CHEH		  0x0573
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_MEN		  0x0574
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_YI		  0x0575
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_NOW		  0x0576
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_SHA		  0x0577
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_VO		  0x0578
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_CHA		  0x0579
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_PEH		  0x057A
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_JHEH		  0x057B
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_RA		  0x057C
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_SEH		  0x057D
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_VEW		  0x057E
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_TIWN		  0x057F
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_REH		  0x0580
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_CO		  0x0581
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_YIWN		  0x0582
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_PIWR		  0x0583
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_KEH		  0x0584
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_OH		  0x0585
#define Z_UNICODE_ARMENIAN_SMALL_LETTER_FEH		  0x0586
#define Z_UNICODE_ARMENIAN_SMALL_LIGATURE_ECH_YIWN	  0x0587
#define Z_UNICODE_ARMENIAN_FULL_STOP			  0x0589
#define Z_UNICODE_ARMENIAN_HYPHEN			  0x058A
#define Z_UNICODE_RIGHT_FACING_ARMENIAN_ETERNITY_SIGN	  0x058D
#define Z_UNICODE_LEFT_FACING_ARMENIAN_ETERNITY_SIGN	  0x058E
#define Z_UNICODE_ARMENIAN_DRAM_SIGN			  0x058F

/* MARK: - 0590h-05FFh - Hebrew */

#define Z_UNICODE_HEBREW_ACCENT_ETNAHTA		     0x0591
#define Z_UNICODE_HEBREW_ACCENT_SEGOL		     0x0592
#define Z_UNICODE_HEBREW_ACCENT_SHALSHELET	     0x0593
#define Z_UNICODE_HEBREW_ACCENT_ZAQEF_QATAN	     0x0594
#define Z_UNICODE_HEBREW_ACCENT_ZAQEF_GADOL	     0x0595
#define Z_UNICODE_HEBREW_ACCENT_TIPEHA		     0x0596
#define Z_UNICODE_HEBREW_ACCENT_REVIA		     0x0597
#define Z_UNICODE_HEBREW_ACCENT_ZARQA		     0x0598
#define Z_UNICODE_HEBREW_ACCENT_PASHTA		     0x0599
#define Z_UNICODE_HEBREW_ACCENT_YETIV		     0x059A
#define Z_UNICODE_HEBREW_ACCENT_TEVIR		     0x059B
#define Z_UNICODE_HEBREW_ACCENT_GERESH		     0x059C
#define Z_UNICODE_HEBREW_ACCENT_GERESH_MUQDAM	     0x059D
#define Z_UNICODE_HEBREW_ACCENT_GERSHAYIM	     0x059E
#define Z_UNICODE_HEBREW_ACCENT_QARNEY_PARA	     0x059F
#define Z_UNICODE_HEBREW_ACCENT_TELISHA_GEDOLA	     0x05A0
#define Z_UNICODE_HEBREW_ACCENT_PAZER		     0x05A1
#define Z_UNICODE_HEBREW_ACCENT_ATNAH_HAFUKH	     0x05A2
#define Z_UNICODE_HEBREW_ACCENT_MUNAH		     0x05A3
#define Z_UNICODE_HEBREW_ACCENT_MAHAPAKH	     0x05A4
#define Z_UNICODE_HEBREW_ACCENT_MERKHA		     0x05A5
#define Z_UNICODE_HEBREW_ACCENT_MERKHA_KEFULA	     0x05A6
#define Z_UNICODE_HEBREW_ACCENT_DARGA		     0x05A7
#define Z_UNICODE_HEBREW_ACCENT_QADMA		     0x05A8
#define Z_UNICODE_HEBREW_ACCENT_TELISHA_QETANA	     0x05A9
#define Z_UNICODE_HEBREW_ACCENT_YERAH_BEN_YOMO	     0x05AA
#define Z_UNICODE_HEBREW_ACCENT_OLE		     0x05AB
#define Z_UNICODE_HEBREW_ACCENT_ILUY		     0x05AC
#define Z_UNICODE_HEBREW_ACCENT_DEHI		     0x05AD
#define Z_UNICODE_HEBREW_ACCENT_ZINOR		     0x05AE
#define Z_UNICODE_HEBREW_MARK_MASORA_CIRCLE	     0x05AF
#define Z_UNICODE_HEBREW_POINT_SHEVA		     0x05B0
#define Z_UNICODE_HEBREW_POINT_HATAF_SEGOL	     0x05B1
#define Z_UNICODE_HEBREW_POINT_HATAF_PATAH	     0x05B2
#define Z_UNICODE_HEBREW_POINT_HATAF_QAMATS	     0x05B3
#define Z_UNICODE_HEBREW_POINT_HIRIQ		     0x05B4
#define Z_UNICODE_HEBREW_POINT_TSERE		     0x05B5
#define Z_UNICODE_HEBREW_POINT_SEGOL		     0x05B6
#define Z_UNICODE_HEBREW_POINT_PATAH		     0x05B7
#define Z_UNICODE_HEBREW_POINT_QAMATS		     0x05B8
#define Z_UNICODE_HEBREW_POINT_HOLAM		     0x05B9
#define Z_UNICODE_HEBREW_POINT_HOLAM_HASER_FOR_VAV   0x05BA
#define Z_UNICODE_HEBREW_POINT_QUBUTS		     0x05BB
#define Z_UNICODE_HEBREW_POINT_DAGESH_OR_MAPIQ	     0x05BC
#define Z_UNICODE_HEBREW_POINT_METEG		     0x05BD
#define Z_UNICODE_HEBREW_PUNCTUATION_MAQAF	     0x05BE
#define Z_UNICODE_HEBREW_POINT_RAFE		     0x05BF
#define Z_UNICODE_HEBREW_PUNCTUATION_PASEQ	     0x05C0
#define Z_UNICODE_HEBREW_POINT_SHIN_DOT		     0x05C1
#define Z_UNICODE_HEBREW_POINT_SIN_DOT		     0x05C2
#define Z_UNICODE_HEBREW_PUNCTUATION_SOF_PASUQ	     0x05C3
#define Z_UNICODE_HEBREW_MARK_UPPER_DOT		     0x05C4
#define Z_UNICODE_HEBREW_MARK_LOWER_DOT		     0x05C5
#define Z_UNICODE_HEBREW_PUNCTUATION_NUN_HAFUKHA     0x05C6
#define Z_UNICODE_HEBREW_POINT_QAMATS_QATAN	     0x05C7
#define Z_UNICODE_HEBREW_LETTER_ALEF		     0x05D0
#define Z_UNICODE_HEBREW_LETTER_BET		     0x05D1
#define Z_UNICODE_HEBREW_LETTER_GIMEL		     0x05D2
#define Z_UNICODE_HEBREW_LETTER_DALET		     0x05D3
#define Z_UNICODE_HEBREW_LETTER_HE		     0x05D4
#define Z_UNICODE_HEBREW_LETTER_VAV		     0x05D5
#define Z_UNICODE_HEBREW_LETTER_ZAYIN		     0x05D6
#define Z_UNICODE_HEBREW_LETTER_HET		     0x05D7
#define Z_UNICODE_HEBREW_LETTER_TET		     0x05D8
#define Z_UNICODE_HEBREW_LETTER_YOD		     0x05D9
#define Z_UNICODE_HEBREW_LETTER_FINAL_KAF	     0x05DA
#define Z_UNICODE_HEBREW_LETTER_KAF		     0x05DB
#define Z_UNICODE_HEBREW_LETTER_LAMED		     0x05DC
#define Z_UNICODE_HEBREW_LETTER_FINAL_MEM	     0x05DD
#define Z_UNICODE_HEBREW_LETTER_MEM		     0x05DE
#define Z_UNICODE_HEBREW_LETTER_FINAL_NUN	     0x05DF
#define Z_UNICODE_HEBREW_LETTER_NUN		     0x05E0
#define Z_UNICODE_HEBREW_LETTER_SAMEKH		     0x05E1
#define Z_UNICODE_HEBREW_LETTER_AYIN		     0x05E2
#define Z_UNICODE_HEBREW_LETTER_FINAL_PE	     0x05E3
#define Z_UNICODE_HEBREW_LETTER_PE		     0x05E4
#define Z_UNICODE_HEBREW_LETTER_FINAL_TSADI	     0x05E5
#define Z_UNICODE_HEBREW_LETTER_TSADI		     0x05E6
#define Z_UNICODE_HEBREW_LETTER_QOF		     0x05E7
#define Z_UNICODE_HEBREW_LETTER_RESH		     0x05E8
#define Z_UNICODE_HEBREW_LETTER_SHIN		     0x05E9
#define Z_UNICODE_HEBREW_LETTER_TAV		     0x05EA
#define Z_UNICODE_HEBREW_LIGATURE_YIDDISH_DOUBLE_VAV 0x05F0
#define Z_UNICODE_HEBREW_LIGATURE_YIDDISH_VAV_YOD    0x05F1
#define Z_UNICODE_HEBREW_LIGATURE_YIDDISH_DOUBLE_YOD 0x05F2
#define Z_UNICODE_HEBREW_PUNCTUATION_GERESH	     0x05F3
#define Z_UNICODE_HEBREW_PUNCTUATION_GERSHAYIM	     0x05F4

/* MARK: - 0600h-06FFh - Arabic */

#define Z_UNICODE_ARABIC_NUMBER_SIGN						0x0600
#define Z_UNICODE_ARABIC_SIGN_SANAH						0x0601
#define Z_UNICODE_ARABIC_FOOTNOTE_MARKER					0x0602
#define Z_UNICODE_ARABIC_SIGN_SAFHA						0x0603
#define Z_UNICODE_ARABIC_SIGN_SAMVAT						0x0604
#define Z_UNICODE_ARABIC_NUMBER_MARK_ABOVE					0x0605
#define Z_UNICODE_ARABIC_INDIC_CUBE_ROOT					0x0606
#define Z_UNICODE_ARABIC_INDIC_FOURTH_ROOT					0x0607
#define Z_UNICODE_ARABIC_RAY							0x0608
#define Z_UNICODE_ARABIC_INDIC_PER_MILLE_SIGN					0x0609
#define Z_UNICODE_ARABIC_INDIC_PER_TEN_THOUSAND_SIGN				0x060A
#define Z_UNICODE_AFGHANI_SIGN							0x060B
#define Z_UNICODE_ARABIC_COMMA							0x060C
#define Z_UNICODE_ARABIC_DATE_SEPARATOR						0x060D
#define Z_UNICODE_ARABIC_POETIC_VERSE_SIGN					0x060E
#define Z_UNICODE_ARABIC_SIGN_MISRA						0x060F
#define Z_UNICODE_ARABIC_SIGN_SALLALLAHOU_ALAYHE_WASSALLAM			0x0610
#define Z_UNICODE_ARABIC_SIGN_ALAYHE_ASSALLAM					0x0611
#define Z_UNICODE_ARABIC_SIGN_RAHMATULLAH_ALAYHE				0x0612
#define Z_UNICODE_ARABIC_SIGN_RADI_ALLAHOU_ANHU					0x0613
#define Z_UNICODE_ARABIC_SIGN_TAKHALLUS						0x0614
#define Z_UNICODE_ARABIC_SMALL_HIGH_TAH						0x0615
#define Z_UNICODE_ARABIC_SMALL_HIGH_LIGATURE_ALEF_WITH_LAM_WITH_YEH		0x0616
#define Z_UNICODE_ARABIC_SMALL_HIGH_ZAIN					0x0617
#define Z_UNICODE_ARABIC_SMALL_FATHA						0x0618
#define Z_UNICODE_ARABIC_SMALL_DAMMA						0x0619
#define Z_UNICODE_ARABIC_SMALL_KASRA						0x061A
#define Z_UNICODE_ARABIC_SEMICOLON						0x061B
#define Z_UNICODE_ARABIC_LETTER_MARK						0x061C
#define Z_UNICODE_ARABIC_TRIPLE_DOT_PUNCTUATION_MARK				0x061E
#define Z_UNICODE_ARABIC_QUESTION_MARK						0x061F
#define Z_UNICODE_ARABIC_LETTER_KASHMIRI_YEH					0x0620
#define Z_UNICODE_ARABIC_LETTER_HAMZA						0x0621
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE				0x0622
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE				0x0623
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE				0x0624
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW				0x0625
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE				0x0626
#define Z_UNICODE_ARABIC_LETTER_ALEF						0x0627
#define Z_UNICODE_ARABIC_LETTER_BEH						0x0628
#define Z_UNICODE_ARABIC_LETTER_TEH_MARBUTA					0x0629
#define Z_UNICODE_ARABIC_LETTER_TEH						0x062A
#define Z_UNICODE_ARABIC_LETTER_THEH						0x062B
#define Z_UNICODE_ARABIC_LETTER_JEEM						0x062C
#define Z_UNICODE_ARABIC_LETTER_HAH						0x062D
#define Z_UNICODE_ARABIC_LETTER_KHAH						0x062E
#define Z_UNICODE_ARABIC_LETTER_DAL						0x062F
#define Z_UNICODE_ARABIC_LETTER_THAL						0x0630
#define Z_UNICODE_ARABIC_LETTER_REH						0x0631
#define Z_UNICODE_ARABIC_LETTER_ZAIN						0x0632
#define Z_UNICODE_ARABIC_LETTER_SEEN						0x0633
#define Z_UNICODE_ARABIC_LETTER_SHEEN						0x0634
#define Z_UNICODE_ARABIC_LETTER_SAD						0x0635
#define Z_UNICODE_ARABIC_LETTER_DAD						0x0636
#define Z_UNICODE_ARABIC_LETTER_TAH						0x0637
#define Z_UNICODE_ARABIC_LETTER_ZAH						0x0638
#define Z_UNICODE_ARABIC_LETTER_AIN						0x0639
#define Z_UNICODE_ARABIC_LETTER_GHAIN						0x063A
#define Z_UNICODE_ARABIC_LETTER_KEHEH_WITH_TWO_DOTS_ABOVE			0x063B
#define Z_UNICODE_ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_BELOW			0x063C
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_WITH_INVERTED_V			0x063D
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_WITH_TWO_DOTS_ABOVE			0x063E
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_WITH_THREE_DOTS_ABOVE			0x063F
#define Z_UNICODE_ARABIC_TATWEEL						0x0640
#define Z_UNICODE_ARABIC_LETTER_FEH						0x0641
#define Z_UNICODE_ARABIC_LETTER_QAF						0x0642
#define Z_UNICODE_ARABIC_LETTER_KAF						0x0643
#define Z_UNICODE_ARABIC_LETTER_LAM						0x0644
#define Z_UNICODE_ARABIC_LETTER_MEEM						0x0645
#define Z_UNICODE_ARABIC_LETTER_NOON						0x0646
#define Z_UNICODE_ARABIC_LETTER_HEH						0x0647
#define Z_UNICODE_ARABIC_LETTER_WAW						0x0648
#define Z_UNICODE_ARABIC_LETTER_ALEF_MAKSURA					0x0649
#define Z_UNICODE_ARABIC_LETTER_YEH						0x064A
#define Z_UNICODE_ARABIC_FATHATAN						0x064B
#define Z_UNICODE_ARABIC_DAMMATAN						0x064C
#define Z_UNICODE_ARABIC_KASRATAN						0x064D
#define Z_UNICODE_ARABIC_FATHA							0x064E
#define Z_UNICODE_ARABIC_DAMMA							0x064F
#define Z_UNICODE_ARABIC_KASRA							0x0650
#define Z_UNICODE_ARABIC_SHADDA							0x0651
#define Z_UNICODE_ARABIC_SUKUN							0x0652
#define Z_UNICODE_ARABIC_MADDAH_ABOVE						0x0653
#define Z_UNICODE_ARABIC_HAMZA_ABOVE						0x0654
#define Z_UNICODE_ARABIC_HAMZA_BELOW						0x0655
#define Z_UNICODE_ARABIC_SUBSCRIPT_ALEF						0x0656
#define Z_UNICODE_ARABIC_INVERTED_DAMMA						0x0657
#define Z_UNICODE_ARABIC_MARK_NOON_GHUNNA					0x0658
#define Z_UNICODE_ARABIC_ZWARAKAY						0x0659
#define Z_UNICODE_ARABIC_VOWEL_SIGN_SMALL_V_ABOVE				0x065A
#define Z_UNICODE_ARABIC_VOWEL_SIGN_INVERTED_SMALL_V_ABOVE			0x065B
#define Z_UNICODE_ARABIC_VOWEL_SIGN_DOT_BELOW					0x065C
#define Z_UNICODE_ARABIC_REVERSED_DAMMA						0x065D
#define Z_UNICODE_ARABIC_FATHA_WITH_TWO_DOTS					0x065E
#define Z_UNICODE_ARABIC_WAVY_HAMZA_BELOW					0x065F
#define Z_UNICODE_ARABIC_INDIC_DIGIT_ZERO					0x0660
#define Z_UNICODE_ARABIC_INDIC_DIGIT_ONE					0x0661
#define Z_UNICODE_ARABIC_INDIC_DIGIT_TWO					0x0662
#define Z_UNICODE_ARABIC_INDIC_DIGIT_THREE					0x0663
#define Z_UNICODE_ARABIC_INDIC_DIGIT_FOUR					0x0664
#define Z_UNICODE_ARABIC_INDIC_DIGIT_FIVE					0x0665
#define Z_UNICODE_ARABIC_INDIC_DIGIT_SIX					0x0666
#define Z_UNICODE_ARABIC_INDIC_DIGIT_SEVEN					0x0667
#define Z_UNICODE_ARABIC_INDIC_DIGIT_EIGHT					0x0668
#define Z_UNICODE_ARABIC_INDIC_DIGIT_NINE					0x0669
#define Z_UNICODE_ARABIC_PERCENT_SIGN						0x066A
#define Z_UNICODE_ARABIC_DECIMAL_SEPARATOR					0x066B
#define Z_UNICODE_ARABIC_THOUSANDS_SEPARATOR					0x066C
#define Z_UNICODE_ARABIC_FIVE_POINTED_STAR					0x066D
#define Z_UNICODE_ARABIC_LETTER_DOTLESS_BEH					0x066E
#define Z_UNICODE_ARABIC_LETTER_DOTLESS_QAF					0x066F
#define Z_UNICODE_ARABIC_LETTER_SUPERSCRIPT_ALEF				0x0670
#define Z_UNICODE_ARABIC_LETTER_ALEF_WASLA					0x0671
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_WAVY_HAMZA_ABOVE			0x0672
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_WAVY_HAMZA_BELOW			0x0673
#define Z_UNICODE_ARABIC_LETTER_HIGH_HAMZA					0x0674
#define Z_UNICODE_ARABIC_LETTER_HIGH_HAMZA_ALEF					0x0675
#define Z_UNICODE_ARABIC_LETTER_HIGH_HAMZA_WAW					0x0676
#define Z_UNICODE_ARABIC_LETTER_U_WITH_HAMZA_ABOVE				0x0677
#define Z_UNICODE_ARABIC_LETTER_HIGH_HAMZA_YEH					0x0678
#define Z_UNICODE_ARABIC_LETTER_TTEH						0x0679
#define Z_UNICODE_ARABIC_LETTER_TTEHEH						0x067A
#define Z_UNICODE_ARABIC_LETTER_BEEH						0x067B
#define Z_UNICODE_ARABIC_LETTER_TEH_WITH_RING					0x067C
#define Z_UNICODE_ARABIC_LETTER_TEH_WITH_THREE_DOTS_ABOVE_DOWNWARDS		0x067D
#define Z_UNICODE_ARABIC_LETTER_PEH						0x067E
#define Z_UNICODE_ARABIC_LETTER_TEHEH						0x067F
#define Z_UNICODE_ARABIC_LETTER_BEHEH						0x0680
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_HAMZA_ABOVE				0x0681
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_TWO_DOTS_VERTICAL_ABOVE		0x0682
#define Z_UNICODE_ARABIC_LETTER_NYEH						0x0683
#define Z_UNICODE_ARABIC_LETTER_DYEH						0x0684
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_THREE_DOTS_ABOVE			0x0685
#define Z_UNICODE_ARABIC_LETTER_TCHEH						0x0686
#define Z_UNICODE_ARABIC_LETTER_TCHEHEH						0x0687
#define Z_UNICODE_ARABIC_LETTER_DDAL						0x0688
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_RING					0x0689
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_DOT_BELOW				0x068A
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_DOT_BELOW_AND_SMALL_TAH		0x068B
#define Z_UNICODE_ARABIC_LETTER_DAHAL						0x068C
#define Z_UNICODE_ARABIC_LETTER_DDAHAL						0x068D
#define Z_UNICODE_ARABIC_LETTER_DUL						0x068E
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_THREE_DOTS_ABOVE_DOWNWARDS		0x068F
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_FOUR_DOTS_ABOVE			0x0690
#define Z_UNICODE_ARABIC_LETTER_RREH						0x0691
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_SMALL_V				0x0692
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_RING					0x0693
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_DOT_BELOW				0x0694
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_SMALL_V_BELOW				0x0695
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_DOT_BELOW_AND_DOT_ABOVE		0x0696
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_TWO_DOTS_ABOVE				0x0697
#define Z_UNICODE_ARABIC_LETTER_JEH						0x0698
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_FOUR_DOTS_ABOVE			0x0699
#define Z_UNICODE_ARABIC_LETTER_SEEN_WITH_DOT_BELOW_AND_DOT_ABOVE		0x069A
#define Z_UNICODE_ARABIC_LETTER_SEEN_WITH_THREE_DOTS_BELOW			0x069B
#define Z_UNICODE_ARABIC_LETTER_SEEN_WITH_THREE_DOTS_BELOW_AND_THREE_DOTS_ABOVE	0x069C
#define Z_UNICODE_ARABIC_LETTER_SAD_WITH_TWO_DOTS_BELOW				0x069D
#define Z_UNICODE_ARABIC_LETTER_SAD_WITH_THREE_DOTS_ABOVE			0x069E
#define Z_UNICODE_ARABIC_LETTER_TAH_WITH_THREE_DOTS_ABOVE			0x069F
#define Z_UNICODE_ARABIC_LETTER_AIN_WITH_THREE_DOTS_ABOVE			0x06A0
#define Z_UNICODE_ARABIC_LETTER_DOTLESS_FEH					0x06A1
#define Z_UNICODE_ARABIC_LETTER_FEH_WITH_DOT_MOVED_BELOW			0x06A2
#define Z_UNICODE_ARABIC_LETTER_FEH_WITH_DOT_BELOW				0x06A3
#define Z_UNICODE_ARABIC_LETTER_VEH						0x06A4
#define Z_UNICODE_ARABIC_LETTER_FEH_WITH_THREE_DOTS_BELOW			0x06A5
#define Z_UNICODE_ARABIC_LETTER_PEHEH						0x06A6
#define Z_UNICODE_ARABIC_LETTER_QAF_WITH_DOT_ABOVE				0x06A7
#define Z_UNICODE_ARABIC_LETTER_QAF_WITH_THREE_DOTS_ABOVE			0x06A8
#define Z_UNICODE_ARABIC_LETTER_KEHEH						0x06A9
#define Z_UNICODE_ARABIC_LETTER_SWASH_KAF					0x06AA
#define Z_UNICODE_ARABIC_LETTER_KAF_WITH_RING					0x06AB
#define Z_UNICODE_ARABIC_LETTER_KAF_WITH_DOT_ABOVE				0x06AC
#define Z_UNICODE_ARABIC_LETTER_NG						0x06AD
#define Z_UNICODE_ARABIC_LETTER_KAF_WITH_THREE_DOTS_BELOW			0x06AE
#define Z_UNICODE_ARABIC_LETTER_GAF						0x06AF
#define Z_UNICODE_ARABIC_LETTER_GAF_WITH_RING					0x06B0
#define Z_UNICODE_ARABIC_LETTER_NGOEH						0x06B1
#define Z_UNICODE_ARABIC_LETTER_GAF_WITH_TWO_DOTS_BELOW				0x06B2
#define Z_UNICODE_ARABIC_LETTER_GUEH						0x06B3
#define Z_UNICODE_ARABIC_LETTER_GAF_WITH_THREE_DOTS_ABOVE			0x06B4
#define Z_UNICODE_ARABIC_LETTER_LAM_WITH_SMALL_V				0x06B5
#define Z_UNICODE_ARABIC_LETTER_LAM_WITH_DOT_ABOVE				0x06B6
#define Z_UNICODE_ARABIC_LETTER_LAM_WITH_THREE_DOTS_ABOVE			0x06B7
#define Z_UNICODE_ARABIC_LETTER_LAM_WITH_THREE_DOTS_BELOW			0x06B8
#define Z_UNICODE_ARABIC_LETTER_NOON_WITH_DOT_BELOW				0x06B9
#define Z_UNICODE_ARABIC_LETTER_NOON_GHUNNA					0x06BA
#define Z_UNICODE_ARABIC_LETTER_RNOON						0x06BB
#define Z_UNICODE_ARABIC_LETTER_NOON_WITH_RING					0x06BC
#define Z_UNICODE_ARABIC_LETTER_NOON_WITH_THREE_DOTS_ABOVE			0x06BD
#define Z_UNICODE_ARABIC_LETTER_HEH_DOACHASHMEE					0x06BE
#define Z_UNICODE_ARABIC_LETTER_TCHEH_WITH_DOT_ABOVE				0x06BF
#define Z_UNICODE_ARABIC_LETTER_HEH_WITH_YEH_ABOVE				0x06C0
#define Z_UNICODE_ARABIC_LETTER_HEH_GOAL					0x06C1
#define Z_UNICODE_ARABIC_LETTER_HEH_GOAL_WITH_HAMZA_ABOVE			0x06C2
#define Z_UNICODE_ARABIC_LETTER_TEH_MARBUTA_GOAL				0x06C3
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_RING					0x06C4
#define Z_UNICODE_ARABIC_LETTER_KIRGHIZ_OE					0x06C5
#define Z_UNICODE_ARABIC_LETTER_OE						0x06C6
#define Z_UNICODE_ARABIC_LETTER_U						0x06C7
#define Z_UNICODE_ARABIC_LETTER_YU						0x06C8
#define Z_UNICODE_ARABIC_LETTER_KIRGHIZ_YU					0x06C9
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_TWO_DOTS_ABOVE				0x06CA
#define Z_UNICODE_ARABIC_LETTER_VE						0x06CB
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH					0x06CC
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_TAIL					0x06CD
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_SMALL_V				0x06CE
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_DOT_ABOVE				0x06CF
#define Z_UNICODE_ARABIC_LETTER_E						0x06D0
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_THREE_DOTS_BELOW			0x06D1
#define Z_UNICODE_ARABIC_LETTER_YEH_BARREE					0x06D2
#define Z_UNICODE_ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE			0x06D3
#define Z_UNICODE_ARABIC_FULL_STOP						0x06D4
#define Z_UNICODE_ARABIC_LETTER_AE						0x06D5
#define Z_UNICODE_ARABIC_SMALL_HIGH_LIGATURE_SAD_WITH_LAM_WITH_ALEF_MAKSURA	0x06D6
#define Z_UNICODE_ARABIC_SMALL_HIGH_LIGATURE_QAF_WITH_LAM_WITH_ALEF_MAKSURA	0x06D7
#define Z_UNICODE_ARABIC_SMALL_HIGH_MEEM_INITIAL_FORM				0x06D8
#define Z_UNICODE_ARABIC_SMALL_HIGH_LAM_ALEF					0x06D9
#define Z_UNICODE_ARABIC_SMALL_HIGH_JEEM					0x06DA
#define Z_UNICODE_ARABIC_SMALL_HIGH_THREE_DOTS					0x06DB
#define Z_UNICODE_ARABIC_SMALL_HIGH_SEEN					0x06DC
#define Z_UNICODE_ARABIC_END_OF_AYAH						0x06DD
#define Z_UNICODE_ARABIC_START_OF_RUB_EL_HIZB					0x06DE
#define Z_UNICODE_ARABIC_SMALL_HIGH_ROUNDED_ZERO				0x06DF
#define Z_UNICODE_ARABIC_SMALL_HIGH_UPRIGHT_RECTANGULAR_ZERO			0x06E0
#define Z_UNICODE_ARABIC_SMALL_HIGH_DOTLESS_HEAD_OF_KHAH			0x06E1
#define Z_UNICODE_ARABIC_SMALL_HIGH_MEEM_ISOLATED_FORM				0x06E2
#define Z_UNICODE_ARABIC_SMALL_LOW_SEEN						0x06E3
#define Z_UNICODE_ARABIC_SMALL_HIGH_MADDA					0x06E4
#define Z_UNICODE_ARABIC_SMALL_WAW						0x06E5
#define Z_UNICODE_ARABIC_SMALL_YEH						0x06E6
#define Z_UNICODE_ARABIC_SMALL_HIGH_YEH						0x06E7
#define Z_UNICODE_ARABIC_SMALL_HIGH_NOON					0x06E8
#define Z_UNICODE_ARABIC_PLACE_OF_SAJDAH					0x06E9
#define Z_UNICODE_ARABIC_EMPTY_CENTRE_LOW_STOP					0x06EA
#define Z_UNICODE_ARABIC_EMPTY_CENTRE_HIGH_STOP					0x06EB
#define Z_UNICODE_ARABIC_ROUNDED_HIGH_STOP_WITH_FILLED_CENTRE			0x06EC
#define Z_UNICODE_ARABIC_SMALL_LOW_MEEM						0x06ED
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_INVERTED_V				0x06EE
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_INVERTED_V				0x06EF
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_ZERO				0x06F0
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_ONE				0x06F1
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_TWO				0x06F2
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_THREE				0x06F3
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_FOUR				0x06F4
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_FIVE				0x06F5
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_SIX				0x06F6
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_SEVEN				0x06F7
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_EIGHT				0x06F8
#define Z_UNICODE_EXTENDED_ARABIC_INDIC_DIGIT_NINE				0x06F9
#define Z_UNICODE_ARABIC_LETTER_SHEEN_WITH_DOT_BELOW				0x06FA
#define Z_UNICODE_ARABIC_LETTER_DAD_WITH_DOT_BELOW				0x06FB
#define Z_UNICODE_ARABIC_LETTER_GHAIN_WITH_DOT_BELOW				0x06FC
#define Z_UNICODE_ARABIC_SIGN_SINDHI_AMPERSAND					0x06FD
#define Z_UNICODE_ARABIC_SIGN_SINDHI_POSTPOSITION_MEN				0x06FE
#define Z_UNICODE_ARABIC_LETTER_HEH_WITH_INVERTED_V				0x06FF

/* MARK: - 0700h-074Fh - Syriac */

#define Z_UNICODE_SYRIAC_END_OF_PARAGRAPH	       0x0700
#define Z_UNICODE_SYRIAC_SUPRALINEAR_FULL_STOP	       0x0701
#define Z_UNICODE_SYRIAC_SUBLINEAR_FULL_STOP	       0x0702
#define Z_UNICODE_SYRIAC_SUPRALINEAR_COLON	       0x0703
#define Z_UNICODE_SYRIAC_SUBLINEAR_COLON	       0x0704
#define Z_UNICODE_SYRIAC_HORIZONTAL_COLON	       0x0705
#define Z_UNICODE_SYRIAC_COLON_SKEWED_LEFT	       0x0706
#define Z_UNICODE_SYRIAC_COLON_SKEWED_RIGHT	       0x0707
#define Z_UNICODE_SYRIAC_SUPRALINEAR_COLON_SKEWED_LEFT 0x0708
#define Z_UNICODE_SYRIAC_SUBLINEAR_COLON_SKEWED_RIGHT  0x0709
#define Z_UNICODE_SYRIAC_CONTRACTION		       0x070A
#define Z_UNICODE_SYRIAC_HARKLEAN_OBELUS	       0x070B
#define Z_UNICODE_SYRIAC_HARKLEAN_METOBELUS	       0x070C
#define Z_UNICODE_SYRIAC_HARKLEAN_ASTERISCUS	       0x070D
#define Z_UNICODE_SYRIAC_ABBREVIATION_MARK	       0x070F
#define Z_UNICODE_SYRIAC_LETTER_ALAPH		       0x0710
#define Z_UNICODE_SYRIAC_LETTER_SUPERSCRIPT_ALAPH      0x0711
#define Z_UNICODE_SYRIAC_LETTER_BETH		       0x0712
#define Z_UNICODE_SYRIAC_LETTER_GAMAL		       0x0713
#define Z_UNICODE_SYRIAC_LETTER_GAMAL_GARSHUNI	       0x0714
#define Z_UNICODE_SYRIAC_LETTER_DALATH		       0x0715
#define Z_UNICODE_SYRIAC_LETTER_DOTLESS_DALATH_RISH    0x0716
#define Z_UNICODE_SYRIAC_LETTER_HE		       0x0717
#define Z_UNICODE_SYRIAC_LETTER_WAW		       0x0718
#define Z_UNICODE_SYRIAC_LETTER_ZAIN		       0x0719
#define Z_UNICODE_SYRIAC_LETTER_HETH		       0x071A
#define Z_UNICODE_SYRIAC_LETTER_TETH		       0x071B
#define Z_UNICODE_SYRIAC_LETTER_TETH_GARSHUNI	       0x071C
#define Z_UNICODE_SYRIAC_LETTER_YUDH		       0x071D
#define Z_UNICODE_SYRIAC_LETTER_YUDH_HE		       0x071E
#define Z_UNICODE_SYRIAC_LETTER_KAPH		       0x071F
#define Z_UNICODE_SYRIAC_LETTER_LAMADH		       0x0720
#define Z_UNICODE_SYRIAC_LETTER_MIM		       0x0721
#define Z_UNICODE_SYRIAC_LETTER_NUN		       0x0722
#define Z_UNICODE_SYRIAC_LETTER_SEMKATH		       0x0723
#define Z_UNICODE_SYRIAC_LETTER_FINAL_SEMKATH	       0x0724
#define Z_UNICODE_SYRIAC_LETTER_E		       0x0725
#define Z_UNICODE_SYRIAC_LETTER_PE		       0x0726
#define Z_UNICODE_SYRIAC_LETTER_REVERSED_PE	       0x0727
#define Z_UNICODE_SYRIAC_LETTER_SADHE		       0x0728
#define Z_UNICODE_SYRIAC_LETTER_QAPH		       0x0729
#define Z_UNICODE_SYRIAC_LETTER_RISH		       0x072A
#define Z_UNICODE_SYRIAC_LETTER_SHIN		       0x072B
#define Z_UNICODE_SYRIAC_LETTER_TAW		       0x072C
#define Z_UNICODE_SYRIAC_LETTER_PERSIAN_BHETH	       0x072D
#define Z_UNICODE_SYRIAC_LETTER_PERSIAN_GHAMAL	       0x072E
#define Z_UNICODE_SYRIAC_LETTER_PERSIAN_DHALATH	       0x072F
#define Z_UNICODE_SYRIAC_PTHAHA_ABOVE		       0x0730
#define Z_UNICODE_SYRIAC_PTHAHA_BELOW		       0x0731
#define Z_UNICODE_SYRIAC_PTHAHA_DOTTED		       0x0732
#define Z_UNICODE_SYRIAC_ZQAPHA_ABOVE		       0x0733
#define Z_UNICODE_SYRIAC_ZQAPHA_BELOW		       0x0734
#define Z_UNICODE_SYRIAC_ZQAPHA_DOTTED		       0x0735
#define Z_UNICODE_SYRIAC_RBASA_ABOVE		       0x0736
#define Z_UNICODE_SYRIAC_RBASA_BELOW		       0x0737
#define Z_UNICODE_SYRIAC_DOTTED_ZLAMA_HORIZONTAL       0x0738
#define Z_UNICODE_SYRIAC_DOTTED_ZLAMA_ANGULAR	       0x0739
#define Z_UNICODE_SYRIAC_HBASA_ABOVE		       0x073A
#define Z_UNICODE_SYRIAC_HBASA_BELOW		       0x073B
#define Z_UNICODE_SYRIAC_HBASA_ESASA_DOTTED	       0x073C
#define Z_UNICODE_SYRIAC_ESASA_ABOVE		       0x073D
#define Z_UNICODE_SYRIAC_ESASA_BELOW		       0x073E
#define Z_UNICODE_SYRIAC_RWAHA			       0x073F
#define Z_UNICODE_SYRIAC_FEMININE_DOT		       0x0740
#define Z_UNICODE_SYRIAC_QUSHSHAYA		       0x0741
#define Z_UNICODE_SYRIAC_RUKKAKHA		       0x0742
#define Z_UNICODE_SYRIAC_TWO_VERTICAL_DOTS_ABOVE       0x0743
#define Z_UNICODE_SYRIAC_TWO_VERTICAL_DOTS_BELOW       0x0744
#define Z_UNICODE_SYRIAC_THREE_DOTS_ABOVE	       0x0745
#define Z_UNICODE_SYRIAC_THREE_DOTS_BELOW	       0x0746
#define Z_UNICODE_SYRIAC_OBLIQUE_LINE_ABOVE	       0x0747
#define Z_UNICODE_SYRIAC_OBLIQUE_LINE_BELOW	       0x0748
#define Z_UNICODE_SYRIAC_MUSIC			       0x0749
#define Z_UNICODE_SYRIAC_BARREKH		       0x074A
#define Z_UNICODE_SYRIAC_LETTER_SOGDIAN_ZHAIN	       0x074D
#define Z_UNICODE_SYRIAC_LETTER_SOGDIAN_KHAPH	       0x074E
#define Z_UNICODE_SYRIAC_LETTER_SOGDIAN_FE	       0x074F

/* MARK: - 0750h-077Fh - Arabic Supplement */

#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_THREE_DOTS_HORIZONTALLY_BELOW			      0x0750
#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_DOT_BELOW_AND_THREE_DOTS_ABOVE			      0x0751
#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW		      0x0752
#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW_AND_TWO_DOTS_ABOVE 0x0753
#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_TWO_DOTS_BELOW_AND_DOT_ABOVE			      0x0754
#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_INVERTED_SMALL_V_BELOW				      0x0755
#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_SMALL_V					      0x0756
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_TWO_DOTS_ABOVE					      0x0757
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW		      0x0758
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_TWO_DOTS_VERTICALLY_BELOW_AND_SMALL_TAH	      0x0759
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_INVERTED_SMALL_V_BELOW				      0x075A
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_STROKE						      0x075B
#define Z_UNICODE_ARABIC_LETTER_SEEN_WITH_FOUR_DOTS_ABOVE				      0x075C
#define Z_UNICODE_ARABIC_LETTER_AIN_WITH_TWO_DOTS_ABOVE					      0x075D
#define Z_UNICODE_ARABIC_LETTER_AIN_WITH_THREE_DOTS_POINTING_DOWNWARDS_ABOVE		      0x075E
#define Z_UNICODE_ARABIC_LETTER_AIN_WITH_TWO_DOTS_VERTICALLY_ABOVE			      0x075F
#define Z_UNICODE_ARABIC_LETTER_FEH_WITH_TWO_DOTS_BELOW					      0x0760
#define Z_UNICODE_ARABIC_LETTER_FEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW		      0x0761
#define Z_UNICODE_ARABIC_LETTER_KEHEH_WITH_DOT_ABOVE					      0x0762
#define Z_UNICODE_ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_ABOVE				      0x0763
#define Z_UNICODE_ARABIC_LETTER_KEHEH_WITH_THREE_DOTS_POINTING_UPWARDS_BELOW		      0x0764
#define Z_UNICODE_ARABIC_LETTER_MEEM_WITH_DOT_ABOVE					      0x0765
#define Z_UNICODE_ARABIC_LETTER_MEEM_WITH_DOT_BELOW					      0x0766
#define Z_UNICODE_ARABIC_LETTER_NOON_WITH_TWO_DOTS_BELOW				      0x0767
#define Z_UNICODE_ARABIC_LETTER_NOON_WITH_SMALL_TAH					      0x0768
#define Z_UNICODE_ARABIC_LETTER_NOON_WITH_SMALL_V					      0x0769
#define Z_UNICODE_ARABIC_LETTER_LAM_WITH_BAR						      0x076A
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_TWO_DOTS_VERTICALLY_ABOVE			      0x076B
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_HAMZA_ABOVE					      0x076C
#define Z_UNICODE_ARABIC_LETTER_SEEN_WITH_TWO_DOTS_VERTICALLY_ABOVE			      0x076D
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_BELOW			      0x076E
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS		      0x076F
#define Z_UNICODE_ARABIC_LETTER_SEEN_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS		      0x0770
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_SMALL_ARABIC_LETTER_TAH_AND_TWO_DOTS		      0x0771
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_SMALL_ARABIC_LETTER_TAH_ABOVE			      0x0772
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE		      0x0773
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE	      0x0774
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE	      0x0775
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE	      0x0776
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_BELOW	      0x0777
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE		      0x0778
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE	      0x0779
#define Z_UNICODE_ARABIC_LETTER_YEH_BARREE_WITH_EXTENDED_ARABIC_INDIC_DIGIT_TWO_ABOVE	      0x077A
#define Z_UNICODE_ARABIC_LETTER_YEH_BARREE_WITH_EXTENDED_ARABIC_INDIC_DIGIT_THREE_ABOVE	      0x077B
#define Z_UNICODE_ARABIC_LETTER_HAH_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_BELOW		      0x077C
#define Z_UNICODE_ARABIC_LETTER_SEEN_WITH_EXTENDED_ARABIC_INDIC_DIGIT_FOUR_ABOVE	      0x077D
#define Z_UNICODE_ARABIC_LETTER_SEEN_WITH_INVERTED_V					      0x077E
#define Z_UNICODE_ARABIC_LETTER_KAF_WITH_TWO_DOTS_ABOVE					      0x077F

/* MARK: - 0780h-07BFh - Thaana */

#define Z_UNICODE_THAANA_LETTER_HAA	  0x0780
#define Z_UNICODE_THAANA_LETTER_SHAVIYANI 0x0781
#define Z_UNICODE_THAANA_LETTER_NOONU	  0x0782
#define Z_UNICODE_THAANA_LETTER_RAA	  0x0783
#define Z_UNICODE_THAANA_LETTER_BAA	  0x0784
#define Z_UNICODE_THAANA_LETTER_LHAVIYANI 0x0785
#define Z_UNICODE_THAANA_LETTER_KAAFU	  0x0786
#define Z_UNICODE_THAANA_LETTER_ALIFU	  0x0787
#define Z_UNICODE_THAANA_LETTER_VAAVU	  0x0788
#define Z_UNICODE_THAANA_LETTER_MEEMU	  0x0789
#define Z_UNICODE_THAANA_LETTER_FAAFU	  0x078A
#define Z_UNICODE_THAANA_LETTER_DHAALU	  0x078B
#define Z_UNICODE_THAANA_LETTER_THAA	  0x078C
#define Z_UNICODE_THAANA_LETTER_LAAMU	  0x078D
#define Z_UNICODE_THAANA_LETTER_GAAFU	  0x078E
#define Z_UNICODE_THAANA_LETTER_GNAVIYANI 0x078F
#define Z_UNICODE_THAANA_LETTER_SEENU	  0x0790
#define Z_UNICODE_THAANA_LETTER_DAVIYANI  0x0791
#define Z_UNICODE_THAANA_LETTER_ZAVIYANI  0x0792
#define Z_UNICODE_THAANA_LETTER_TAVIYANI  0x0793
#define Z_UNICODE_THAANA_LETTER_YAA	  0x0794
#define Z_UNICODE_THAANA_LETTER_PAVIYANI  0x0795
#define Z_UNICODE_THAANA_LETTER_JAVIYANI  0x0796
#define Z_UNICODE_THAANA_LETTER_CHAVIYANI 0x0797
#define Z_UNICODE_THAANA_LETTER_TTAA	  0x0798
#define Z_UNICODE_THAANA_LETTER_HHAA	  0x0799
#define Z_UNICODE_THAANA_LETTER_KHAA	  0x079A
#define Z_UNICODE_THAANA_LETTER_THAALU	  0x079B
#define Z_UNICODE_THAANA_LETTER_ZAA	  0x079C
#define Z_UNICODE_THAANA_LETTER_SHEENU	  0x079D
#define Z_UNICODE_THAANA_LETTER_SAADHU	  0x079E
#define Z_UNICODE_THAANA_LETTER_DAADHU	  0x079F
#define Z_UNICODE_THAANA_LETTER_TO	  0x07A0
#define Z_UNICODE_THAANA_LETTER_ZO	  0x07A1
#define Z_UNICODE_THAANA_LETTER_AINU	  0x07A2
#define Z_UNICODE_THAANA_LETTER_GHAINU	  0x07A3
#define Z_UNICODE_THAANA_LETTER_QAAFU	  0x07A4
#define Z_UNICODE_THAANA_LETTER_WAAVU	  0x07A5
#define Z_UNICODE_THAANA_ABAFILI	  0x07A6
#define Z_UNICODE_THAANA_AABAAFILI	  0x07A7
#define Z_UNICODE_THAANA_IBIFILI	  0x07A8
#define Z_UNICODE_THAANA_EEBEEFILI	  0x07A9
#define Z_UNICODE_THAANA_UBUFILI	  0x07AA
#define Z_UNICODE_THAANA_OOBOOFILI	  0x07AB
#define Z_UNICODE_THAANA_EBEFILI	  0x07AC
#define Z_UNICODE_THAANA_EYBEYFILI	  0x07AD
#define Z_UNICODE_THAANA_OBOFILI	  0x07AE
#define Z_UNICODE_THAANA_OABOAFILI	  0x07AF
#define Z_UNICODE_THAANA_SUKUN		  0x07B0
#define Z_UNICODE_THAANA_LETTER_NAA	  0x07B1

/* MARK: - 07C0h-07FFh - NKo */

#define Z_UNICODE_NKO_DIGIT_ZERO		     0x07C0
#define Z_UNICODE_NKO_DIGIT_ONE			     0x07C1
#define Z_UNICODE_NKO_DIGIT_TWO			     0x07C2
#define Z_UNICODE_NKO_DIGIT_THREE		     0x07C3
#define Z_UNICODE_NKO_DIGIT_FOUR		     0x07C4
#define Z_UNICODE_NKO_DIGIT_FIVE		     0x07C5
#define Z_UNICODE_NKO_DIGIT_SIX			     0x07C6
#define Z_UNICODE_NKO_DIGIT_SEVEN		     0x07C7
#define Z_UNICODE_NKO_DIGIT_EIGHT		     0x07C8
#define Z_UNICODE_NKO_DIGIT_NINE		     0x07C9
#define Z_UNICODE_NKO_LETTER_A			     0x07CA
#define Z_UNICODE_NKO_LETTER_EE			     0x07CB
#define Z_UNICODE_NKO_LETTER_I			     0x07CC
#define Z_UNICODE_NKO_LETTER_E			     0x07CD
#define Z_UNICODE_NKO_LETTER_U			     0x07CE
#define Z_UNICODE_NKO_LETTER_OO			     0x07CF
#define Z_UNICODE_NKO_LETTER_O			     0x07D0
#define Z_UNICODE_NKO_LETTER_DAGBASINNA		     0x07D1
#define Z_UNICODE_NKO_LETTER_N			     0x07D2
#define Z_UNICODE_NKO_LETTER_BA			     0x07D3
#define Z_UNICODE_NKO_LETTER_PA			     0x07D4
#define Z_UNICODE_NKO_LETTER_TA			     0x07D5
#define Z_UNICODE_NKO_LETTER_JA			     0x07D6
#define Z_UNICODE_NKO_LETTER_CHA		     0x07D7
#define Z_UNICODE_NKO_LETTER_DA			     0x07D8
#define Z_UNICODE_NKO_LETTER_RA			     0x07D9
#define Z_UNICODE_NKO_LETTER_RRA		     0x07DA
#define Z_UNICODE_NKO_LETTER_SA			     0x07DB
#define Z_UNICODE_NKO_LETTER_GBA		     0x07DC
#define Z_UNICODE_NKO_LETTER_FA			     0x07DD
#define Z_UNICODE_NKO_LETTER_KA			     0x07DE
#define Z_UNICODE_NKO_LETTER_LA			     0x07DF
#define Z_UNICODE_NKO_LETTER_NA_WOLOSO		     0x07E0
#define Z_UNICODE_NKO_LETTER_MA			     0x07E1
#define Z_UNICODE_NKO_LETTER_NYA		     0x07E2
#define Z_UNICODE_NKO_LETTER_NA			     0x07E3
#define Z_UNICODE_NKO_LETTER_HA			     0x07E4
#define Z_UNICODE_NKO_LETTER_WA			     0x07E5
#define Z_UNICODE_NKO_LETTER_YA			     0x07E6
#define Z_UNICODE_NKO_LETTER_NYA_WOLOSO		     0x07E7
#define Z_UNICODE_NKO_LETTER_JONA_JA		     0x07E8
#define Z_UNICODE_NKO_LETTER_JONA_CHA		     0x07E9
#define Z_UNICODE_NKO_LETTER_JONA_RA		     0x07EA
#define Z_UNICODE_NKO_COMBINING_SHORT_HIGH_TONE	     0x07EB
#define Z_UNICODE_NKO_COMBINING_SHORT_LOW_TONE	     0x07EC
#define Z_UNICODE_NKO_COMBINING_SHORT_RISING_TONE    0x07ED
#define Z_UNICODE_NKO_COMBINING_LONG_DESCENDING_TONE 0x07EE
#define Z_UNICODE_NKO_COMBINING_LONG_HIGH_TONE	     0x07EF
#define Z_UNICODE_NKO_COMBINING_LONG_LOW_TONE	     0x07F0
#define Z_UNICODE_NKO_COMBINING_LONG_RISING_TONE     0x07F1
#define Z_UNICODE_NKO_COMBINING_NASALIZATION_MARK    0x07F2
#define Z_UNICODE_NKO_COMBINING_DOUBLE_DOT_ABOVE     0x07F3
#define Z_UNICODE_NKO_HIGH_TONE_APOSTROPHE	     0x07F4
#define Z_UNICODE_NKO_LOW_TONE_APOSTROPHE	     0x07F5
#define Z_UNICODE_NKO_SYMBOL_OO_DENNEN		     0x07F6
#define Z_UNICODE_NKO_SYMBOL_GBAKURUNEN		     0x07F7
#define Z_UNICODE_NKO_COMMA			     0x07F8
#define Z_UNICODE_NKO_EXCLAMATION_MARK		     0x07F9
#define Z_UNICODE_NKO_LAJANYALAN		     0x07FA

/* MARK: - 0800h-083Fh - Samaritan */

#define Z_UNICODE_SAMARITAN_LETTER_ALAF			   0x0800
#define Z_UNICODE_SAMARITAN_LETTER_BIT			   0x0801
#define Z_UNICODE_SAMARITAN_LETTER_GAMAN		   0x0802
#define Z_UNICODE_SAMARITAN_LETTER_DALAT		   0x0803
#define Z_UNICODE_SAMARITAN_LETTER_IY			   0x0804
#define Z_UNICODE_SAMARITAN_LETTER_BAA			   0x0805
#define Z_UNICODE_SAMARITAN_LETTER_ZEN			   0x0806
#define Z_UNICODE_SAMARITAN_LETTER_IT			   0x0807
#define Z_UNICODE_SAMARITAN_LETTER_TIT			   0x0808
#define Z_UNICODE_SAMARITAN_LETTER_YUT			   0x0809
#define Z_UNICODE_SAMARITAN_LETTER_KAAF			   0x080A
#define Z_UNICODE_SAMARITAN_LETTER_LABAT		   0x080B
#define Z_UNICODE_SAMARITAN_LETTER_MIM			   0x080C
#define Z_UNICODE_SAMARITAN_LETTER_NUN			   0x080D
#define Z_UNICODE_SAMARITAN_LETTER_SINGAAT		   0x080E
#define Z_UNICODE_SAMARITAN_LETTER_IN			   0x080F
#define Z_UNICODE_SAMARITAN_LETTER_FI			   0x0810
#define Z_UNICODE_SAMARITAN_LETTER_TSAADIY		   0x0811
#define Z_UNICODE_SAMARITAN_LETTER_QUF			   0x0812
#define Z_UNICODE_SAMARITAN_LETTER_RISH			   0x0813
#define Z_UNICODE_SAMARITAN_LETTER_SHAN			   0x0814
#define Z_UNICODE_SAMARITAN_LETTER_TAAF			   0x0815
#define Z_UNICODE_SAMARITAN_MARK_IN			   0x0816
#define Z_UNICODE_SAMARITAN_MARK_IN_ALAF		   0x0817
#define Z_UNICODE_SAMARITAN_MARK_OCCLUSION		   0x0818
#define Z_UNICODE_SAMARITAN_MARK_DAGESH			   0x0819
#define Z_UNICODE_SAMARITAN_MODIFIER_LETTER_EPENTHETIC_YUT 0x081A
#define Z_UNICODE_SAMARITAN_MARK_EPENTHETIC_YUT		   0x081B
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_LONG_E		   0x081C
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_E		   0x081D
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_OVERLONG_AA	   0x081E
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_LONG_AA		   0x081F
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_AA		   0x0820
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_OVERLONG_A	   0x0821
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_LONG_A		   0x0822
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_A		   0x0823
#define Z_UNICODE_SAMARITAN_MODIFIER_LETTER_SHORT_A	   0x0824
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_SHORT_A		   0x0825
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_LONG_U		   0x0826
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_U		   0x0827
#define Z_UNICODE_SAMARITAN_MODIFIER_LETTER_I		   0x0828
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_LONG_I		   0x0829
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_I		   0x082A
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_O		   0x082B
#define Z_UNICODE_SAMARITAN_VOWEL_SIGN_SUKUN		   0x082C
#define Z_UNICODE_SAMARITAN_MARK_NEQUDAA		   0x082D
#define Z_UNICODE_SAMARITAN_PUNCTUATION_NEQUDAA		   0x0830
#define Z_UNICODE_SAMARITAN_PUNCTUATION_AFSAAQ		   0x0831
#define Z_UNICODE_SAMARITAN_PUNCTUATION_ANGED		   0x0832
#define Z_UNICODE_SAMARITAN_PUNCTUATION_BAU		   0x0833
#define Z_UNICODE_SAMARITAN_PUNCTUATION_ATMAAU		   0x0834
#define Z_UNICODE_SAMARITAN_PUNCTUATION_SHIYYAALAA	   0x0835
#define Z_UNICODE_SAMARITAN_ABBREVIATION_MARK		   0x0836
#define Z_UNICODE_SAMARITAN_PUNCTUATION_MELODIC_QITSA	   0x0837
#define Z_UNICODE_SAMARITAN_PUNCTUATION_ZIQAA		   0x0838
#define Z_UNICODE_SAMARITAN_PUNCTUATION_QITSA		   0x0839
#define Z_UNICODE_SAMARITAN_PUNCTUATION_ZAEF		   0x083A
#define Z_UNICODE_SAMARITAN_PUNCTUATION_TURU		   0x083B
#define Z_UNICODE_SAMARITAN_PUNCTUATION_ARKAANU		   0x083C
#define Z_UNICODE_SAMARITAN_PUNCTUATION_SOF_MASHFAAT	   0x083D
#define Z_UNICODE_SAMARITAN_PUNCTUATION_ANNAAU		   0x083E

/* MARK: - 0840h-085Fh - Mandaic */

#define Z_UNICODE_MANDAIC_LETTER_HALQA	    0x0840
#define Z_UNICODE_MANDAIC_LETTER_AB	    0x0841
#define Z_UNICODE_MANDAIC_LETTER_AG	    0x0842
#define Z_UNICODE_MANDAIC_LETTER_AD	    0x0843
#define Z_UNICODE_MANDAIC_LETTER_AH	    0x0844
#define Z_UNICODE_MANDAIC_LETTER_USHENNA    0x0845
#define Z_UNICODE_MANDAIC_LETTER_AZ	    0x0846
#define Z_UNICODE_MANDAIC_LETTER_IT	    0x0847
#define Z_UNICODE_MANDAIC_LETTER_ATT	    0x0848
#define Z_UNICODE_MANDAIC_LETTER_AKSA	    0x0849
#define Z_UNICODE_MANDAIC_LETTER_AK	    0x084A
#define Z_UNICODE_MANDAIC_LETTER_AL	    0x084B
#define Z_UNICODE_MANDAIC_LETTER_AM	    0x084C
#define Z_UNICODE_MANDAIC_LETTER_AN	    0x084D
#define Z_UNICODE_MANDAIC_LETTER_AS	    0x084E
#define Z_UNICODE_MANDAIC_LETTER_IN	    0x084F
#define Z_UNICODE_MANDAIC_LETTER_AP	    0x0850
#define Z_UNICODE_MANDAIC_LETTER_ASZ	    0x0851
#define Z_UNICODE_MANDAIC_LETTER_AQ	    0x0852
#define Z_UNICODE_MANDAIC_LETTER_AR	    0x0853
#define Z_UNICODE_MANDAIC_LETTER_ASH	    0x0854
#define Z_UNICODE_MANDAIC_LETTER_AT	    0x0855
#define Z_UNICODE_MANDAIC_LETTER_DUSHENNA   0x0856
#define Z_UNICODE_MANDAIC_LETTER_KAD	    0x0857
#define Z_UNICODE_MANDAIC_LETTER_AIN	    0x0858
#define Z_UNICODE_MANDAIC_AFFRICATION_MARK  0x0859
#define Z_UNICODE_MANDAIC_VOCALIZATION_MARK 0x085A
#define Z_UNICODE_MANDAIC_GEMINATION_MARK   0x085B
#define Z_UNICODE_MANDAIC_PUNCTUATION	    0x085E

/* MARK: - 08A0h-08FFh - Arabic Extended-A */

#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_SMALL_V_BELOW			0x08A0
#define Z_UNICODE_ARABIC_LETTER_BEH_WITH_HAMZA_ABOVE			0x08A1
#define Z_UNICODE_ARABIC_LETTER_JEEM_WITH_TWO_DOTS_ABOVE		0x08A2
#define Z_UNICODE_ARABIC_LETTER_TAH_WITH_TWO_DOTS_ABOVE			0x08A3
#define Z_UNICODE_ARABIC_LETTER_FEH_WITH_DOT_BELOW_AND_THREE_DOTS_ABOVE	0x08A4
#define Z_UNICODE_ARABIC_LETTER_QAF_WITH_DOT_BELOW			0x08A5
#define Z_UNICODE_ARABIC_LETTER_LAM_WITH_DOUBLE_BAR			0x08A6
#define Z_UNICODE_ARABIC_LETTER_MEEM_WITH_THREE_DOTS_ABOVE		0x08A7
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_TWO_DOTS_BELOW_AND_HAMZA_ABOVE	0x08A8
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_TWO_DOTS_BELOW_AND_DOT_ABOVE	0x08A9
#define Z_UNICODE_ARABIC_LETTER_REH_WITH_LOOP				0x08AA
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_DOT_WITHIN			0x08AB
#define Z_UNICODE_ARABIC_LETTER_ROHINGYA_YEH				0x08AC
#define Z_UNICODE_ARABIC_LETTER_LOW_ALEF				0x08AD
#define Z_UNICODE_ARABIC_LETTER_DAL_WITH_THREE_DOTS_BELOW		0x08AE
#define Z_UNICODE_ARABIC_LETTER_SAD_WITH_THREE_DOTS_BELOW		0x08AF
#define Z_UNICODE_ARABIC_LETTER_GAF_WITH_INVERTED_STROKE		0x08B0
#define Z_UNICODE_ARABIC_LETTER_STRAIGHT_WAW				0x08B1
#define Z_UNICODE_ARABIC_LETTER_ZAIN_WITH_INVERTED_V_ABOVE		0x08B2
#define Z_UNICODE_ARABIC_LETTER_AIN_WITH_THREE_DOTS_BELOW		0x08B3
#define Z_UNICODE_ARABIC_LETTER_KAF_WITH_DOT_BELOW			0x08B4
#define Z_UNICODE_ARABIC_TURNED_DAMMA_BELOW				0x08E3
#define Z_UNICODE_ARABIC_CURLY_FATHA					0x08E4
#define Z_UNICODE_ARABIC_CURLY_DAMMA					0x08E5
#define Z_UNICODE_ARABIC_CURLY_KASRA					0x08E6
#define Z_UNICODE_ARABIC_CURLY_FATHATAN					0x08E7
#define Z_UNICODE_ARABIC_CURLY_DAMMATAN					0x08E8
#define Z_UNICODE_ARABIC_CURLY_KASRATAN					0x08E9
#define Z_UNICODE_ARABIC_TONE_ONE_DOT_ABOVE				0x08EA
#define Z_UNICODE_ARABIC_TONE_TWO_DOTS_ABOVE				0x08EB
#define Z_UNICODE_ARABIC_TONE_LOOP_ABOVE				0x08EC
#define Z_UNICODE_ARABIC_TONE_ONE_DOT_BELOW				0x08ED
#define Z_UNICODE_ARABIC_TONE_TWO_DOTS_BELOW				0x08EE
#define Z_UNICODE_ARABIC_TONE_LOOP_BELOW				0x08EF
#define Z_UNICODE_ARABIC_OPEN_FATHATAN					0x08F0
#define Z_UNICODE_ARABIC_OPEN_DAMMATAN					0x08F1
#define Z_UNICODE_ARABIC_OPEN_KASRATAN					0x08F2
#define Z_UNICODE_ARABIC_SMALL_HIGH_WAW					0x08F3
#define Z_UNICODE_ARABIC_FATHA_WITH_RING				0x08F4
#define Z_UNICODE_ARABIC_FATHA_WITH_DOT_ABOVE				0x08F5
#define Z_UNICODE_ARABIC_KASRA_WITH_DOT_BELOW				0x08F6
#define Z_UNICODE_ARABIC_LEFT_ARROWHEAD_ABOVE				0x08F7
#define Z_UNICODE_ARABIC_RIGHT_ARROWHEAD_ABOVE				0x08F8
#define Z_UNICODE_ARABIC_LEFT_ARROWHEAD_BELOW				0x08F9
#define Z_UNICODE_ARABIC_RIGHT_ARROWHEAD_BELOW				0x08FA
#define Z_UNICODE_ARABIC_DOUBLE_RIGHT_ARROWHEAD_ABOVE			0x08FB
#define Z_UNICODE_ARABIC_DOUBLE_RIGHT_ARROWHEAD_ABOVE_WITH_DOT		0x08FC
#define Z_UNICODE_ARABIC_RIGHT_ARROWHEAD_ABOVE_WITH_DOT			0x08FD
#define Z_UNICODE_ARABIC_DAMMA_WITH_DOT					0x08FE
#define Z_UNICODE_ARABIC_MARK_SIDEWAYS_NOON_GHUNNA			0x08FF

/* MARK: - 0900h-097Fh - Devanagari */

#define Z_UNICODE_DEVANAGARI_SIGN_INVERTED_CANDRABINDU	0x0900
#define Z_UNICODE_DEVANAGARI_SIGN_CANDRABINDU		0x0901
#define Z_UNICODE_DEVANAGARI_SIGN_ANUSVARA		0x0902
#define Z_UNICODE_DEVANAGARI_SIGN_VISARGA		0x0903
#define Z_UNICODE_DEVANAGARI_LETTER_SHORT_A		0x0904
#define Z_UNICODE_DEVANAGARI_LETTER_A			0x0905
#define Z_UNICODE_DEVANAGARI_LETTER_AA			0x0906
#define Z_UNICODE_DEVANAGARI_LETTER_I			0x0907
#define Z_UNICODE_DEVANAGARI_LETTER_II			0x0908
#define Z_UNICODE_DEVANAGARI_LETTER_U			0x0909
#define Z_UNICODE_DEVANAGARI_LETTER_UU			0x090A
#define Z_UNICODE_DEVANAGARI_LETTER_VOCALIC_R		0x090B
#define Z_UNICODE_DEVANAGARI_LETTER_VOCALIC_L		0x090C
#define Z_UNICODE_DEVANAGARI_LETTER_CANDRA_E		0x090D
#define Z_UNICODE_DEVANAGARI_LETTER_SHORT_E		0x090E
#define Z_UNICODE_DEVANAGARI_LETTER_E			0x090F
#define Z_UNICODE_DEVANAGARI_LETTER_AI			0x0910
#define Z_UNICODE_DEVANAGARI_LETTER_CANDRA_O		0x0911
#define Z_UNICODE_DEVANAGARI_LETTER_SHORT_O		0x0912
#define Z_UNICODE_DEVANAGARI_LETTER_O			0x0913
#define Z_UNICODE_DEVANAGARI_LETTER_AU			0x0914
#define Z_UNICODE_DEVANAGARI_LETTER_KA			0x0915
#define Z_UNICODE_DEVANAGARI_LETTER_KHA			0x0916
#define Z_UNICODE_DEVANAGARI_LETTER_GA			0x0917
#define Z_UNICODE_DEVANAGARI_LETTER_GHA			0x0918
#define Z_UNICODE_DEVANAGARI_LETTER_NGA			0x0919
#define Z_UNICODE_DEVANAGARI_LETTER_CA			0x091A
#define Z_UNICODE_DEVANAGARI_LETTER_CHA			0x091B
#define Z_UNICODE_DEVANAGARI_LETTER_JA			0x091C
#define Z_UNICODE_DEVANAGARI_LETTER_JHA			0x091D
#define Z_UNICODE_DEVANAGARI_LETTER_NYA			0x091E
#define Z_UNICODE_DEVANAGARI_LETTER_TTA			0x091F
#define Z_UNICODE_DEVANAGARI_LETTER_TTHA		0x0920
#define Z_UNICODE_DEVANAGARI_LETTER_DDA			0x0921
#define Z_UNICODE_DEVANAGARI_LETTER_DDHA		0x0922
#define Z_UNICODE_DEVANAGARI_LETTER_NNA			0x0923
#define Z_UNICODE_DEVANAGARI_LETTER_TA			0x0924
#define Z_UNICODE_DEVANAGARI_LETTER_THA			0x0925
#define Z_UNICODE_DEVANAGARI_LETTER_DA			0x0926
#define Z_UNICODE_DEVANAGARI_LETTER_DHA			0x0927
#define Z_UNICODE_DEVANAGARI_LETTER_NA			0x0928
#define Z_UNICODE_DEVANAGARI_LETTER_NNNA		0x0929
#define Z_UNICODE_DEVANAGARI_LETTER_PA			0x092A
#define Z_UNICODE_DEVANAGARI_LETTER_PHA			0x092B
#define Z_UNICODE_DEVANAGARI_LETTER_BA			0x092C
#define Z_UNICODE_DEVANAGARI_LETTER_BHA			0x092D
#define Z_UNICODE_DEVANAGARI_LETTER_MA			0x092E
#define Z_UNICODE_DEVANAGARI_LETTER_YA			0x092F
#define Z_UNICODE_DEVANAGARI_LETTER_RA			0x0930
#define Z_UNICODE_DEVANAGARI_LETTER_RRA			0x0931
#define Z_UNICODE_DEVANAGARI_LETTER_LA			0x0932
#define Z_UNICODE_DEVANAGARI_LETTER_LLA			0x0933
#define Z_UNICODE_DEVANAGARI_LETTER_LLLA		0x0934
#define Z_UNICODE_DEVANAGARI_LETTER_VA			0x0935
#define Z_UNICODE_DEVANAGARI_LETTER_SHA			0x0936
#define Z_UNICODE_DEVANAGARI_LETTER_SSA			0x0937
#define Z_UNICODE_DEVANAGARI_LETTER_SA			0x0938
#define Z_UNICODE_DEVANAGARI_LETTER_HA			0x0939
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_OE		0x093A
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_OOE		0x093B
#define Z_UNICODE_DEVANAGARI_SIGN_NUKTA			0x093C
#define Z_UNICODE_DEVANAGARI_SIGN_AVAGRAHA		0x093D
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_AA		0x093E
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_I		0x093F
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_II		0x0940
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_U		0x0941
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_UU		0x0942
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_VOCALIC_R	0x0943
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_VOCALIC_RR	0x0944
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_CANDRA_E	0x0945
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_SHORT_E		0x0946
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_E		0x0947
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_AI		0x0948
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_CANDRA_O	0x0949
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_SHORT_O		0x094A
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_O		0x094B
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_AU		0x094C
#define Z_UNICODE_DEVANAGARI_SIGN_VIRAMA		0x094D
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_PRISHTHAMATRA_E	0x094E
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_AW		0x094F
#define Z_UNICODE_DEVANAGARI_OM				0x0950
#define Z_UNICODE_DEVANAGARI_STRESS_SIGN_UDATTA		0x0951
#define Z_UNICODE_DEVANAGARI_STRESS_SIGN_ANUDATTA	0x0952
#define Z_UNICODE_DEVANAGARI_GRAVE_ACCENT		0x0953
#define Z_UNICODE_DEVANAGARI_ACUTE_ACCENT		0x0954
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_CANDRA_LONG_E	0x0955
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_UE		0x0956
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_UUE		0x0957
#define Z_UNICODE_DEVANAGARI_LETTER_QA			0x0958
#define Z_UNICODE_DEVANAGARI_LETTER_KHHA		0x0959
#define Z_UNICODE_DEVANAGARI_LETTER_GHHA		0x095A
#define Z_UNICODE_DEVANAGARI_LETTER_ZA			0x095B
#define Z_UNICODE_DEVANAGARI_LETTER_DDDHA		0x095C
#define Z_UNICODE_DEVANAGARI_LETTER_RHA			0x095D
#define Z_UNICODE_DEVANAGARI_LETTER_FA			0x095E
#define Z_UNICODE_DEVANAGARI_LETTER_YYA			0x095F
#define Z_UNICODE_DEVANAGARI_LETTER_VOCALIC_RR		0x0960
#define Z_UNICODE_DEVANAGARI_LETTER_VOCALIC_LL		0x0961
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_VOCALIC_L	0x0962
#define Z_UNICODE_DEVANAGARI_VOWEL_SIGN_VOCALIC_LL	0x0963
#define Z_UNICODE_DEVANAGARI_DANDA			0x0964
#define Z_UNICODE_DEVANAGARI_DOUBLE_DANDA		0x0965
#define Z_UNICODE_DEVANAGARI_DIGIT_ZERO			0x0966
#define Z_UNICODE_DEVANAGARI_DIGIT_ONE			0x0967
#define Z_UNICODE_DEVANAGARI_DIGIT_TWO			0x0968
#define Z_UNICODE_DEVANAGARI_DIGIT_THREE		0x0969
#define Z_UNICODE_DEVANAGARI_DIGIT_FOUR			0x096A
#define Z_UNICODE_DEVANAGARI_DIGIT_FIVE			0x096B
#define Z_UNICODE_DEVANAGARI_DIGIT_SIX			0x096C
#define Z_UNICODE_DEVANAGARI_DIGIT_SEVEN		0x096D
#define Z_UNICODE_DEVANAGARI_DIGIT_EIGHT		0x096E
#define Z_UNICODE_DEVANAGARI_DIGIT_NINE			0x096F
#define Z_UNICODE_DEVANAGARI_ABBREVIATION_SIGN		0x0970
#define Z_UNICODE_DEVANAGARI_SIGN_HIGH_SPACING_DOT	0x0971
#define Z_UNICODE_DEVANAGARI_LETTER_CANDRA_A		0x0972
#define Z_UNICODE_DEVANAGARI_LETTER_OE			0x0973
#define Z_UNICODE_DEVANAGARI_LETTER_OOE			0x0974
#define Z_UNICODE_DEVANAGARI_LETTER_AW			0x0975
#define Z_UNICODE_DEVANAGARI_LETTER_UE			0x0976
#define Z_UNICODE_DEVANAGARI_LETTER_UUE			0x0977
#define Z_UNICODE_DEVANAGARI_LETTER_MARWARI_DDA		0x0978
#define Z_UNICODE_DEVANAGARI_LETTER_ZHA			0x0979
#define Z_UNICODE_DEVANAGARI_LETTER_HEAVY_YA		0x097A
#define Z_UNICODE_DEVANAGARI_LETTER_GGA			0x097B
#define Z_UNICODE_DEVANAGARI_LETTER_JJA			0x097C
#define Z_UNICODE_DEVANAGARI_LETTER_GLOTTAL_STOP	0x097D
#define Z_UNICODE_DEVANAGARI_LETTER_DDDA		0x097E
#define Z_UNICODE_DEVANAGARI_LETTER_BBA			0x097F

/* MARK: - 0980h-09FFh - Bengali */

/* 09E4h <reserved> */
/* 09E5h <reserved> */
#define Z_UNICODE_BENGALI_ANJI						   0x0980
#define Z_UNICODE_BENGALI_SIGN_CANDRABINDU				   0x0981
#define Z_UNICODE_BENGALI_SIGN_ANUSVARA					   0x0982
#define Z_UNICODE_BENGALI_SIGN_VISARGA					   0x0983
#define Z_UNICODE_BENGALI_LETTER_A					   0x0985
#define Z_UNICODE_BENGALI_LETTER_AA					   0x0986
#define Z_UNICODE_BENGALI_LETTER_I					   0x0987
#define Z_UNICODE_BENGALI_LETTER_II					   0x0988
#define Z_UNICODE_BENGALI_LETTER_U					   0x0989
#define Z_UNICODE_BENGALI_LETTER_UU					   0x098A
#define Z_UNICODE_BENGALI_LETTER_VOCALIC_R				   0x098B
#define Z_UNICODE_BENGALI_LETTER_VOCALIC_L				   0x098C
#define Z_UNICODE_BENGALI_LETTER_E					   0x098F
#define Z_UNICODE_BENGALI_LETTER_AI					   0x0990
#define Z_UNICODE_BENGALI_LETTER_O					   0x0993
#define Z_UNICODE_BENGALI_LETTER_AU					   0x0994
#define Z_UNICODE_BENGALI_LETTER_KA					   0x0995
#define Z_UNICODE_BENGALI_LETTER_KHA					   0x0996
#define Z_UNICODE_BENGALI_LETTER_GA					   0x0997
#define Z_UNICODE_BENGALI_LETTER_GHA					   0x0998
#define Z_UNICODE_BENGALI_LETTER_NGA					   0x0999
#define Z_UNICODE_BENGALI_LETTER_CA					   0x099A
#define Z_UNICODE_BENGALI_LETTER_CHA					   0x099B
#define Z_UNICODE_BENGALI_LETTER_JA					   0x099C
#define Z_UNICODE_BENGALI_LETTER_JHA					   0x099D
#define Z_UNICODE_BENGALI_LETTER_NYA					   0x099E
#define Z_UNICODE_BENGALI_LETTER_TTA					   0x099F
#define Z_UNICODE_BENGALI_LETTER_TTHA					   0x09A0
#define Z_UNICODE_BENGALI_LETTER_DDA					   0x09A1
#define Z_UNICODE_BENGALI_LETTER_DDHA					   0x09A2
#define Z_UNICODE_BENGALI_LETTER_NNA					   0x09A3
#define Z_UNICODE_BENGALI_LETTER_TA					   0x09A4
#define Z_UNICODE_BENGALI_LETTER_THA					   0x09A5
#define Z_UNICODE_BENGALI_LETTER_DA					   0x09A6
#define Z_UNICODE_BENGALI_LETTER_DHA					   0x09A7
#define Z_UNICODE_BENGALI_LETTER_NA					   0x09A8
#define Z_UNICODE_BENGALI_LETTER_PA					   0x09AA
#define Z_UNICODE_BENGALI_LETTER_PHA					   0x09AB
#define Z_UNICODE_BENGALI_LETTER_BA					   0x09AC
#define Z_UNICODE_BENGALI_LETTER_BHA					   0x09AD
#define Z_UNICODE_BENGALI_LETTER_MA					   0x09AE
#define Z_UNICODE_BENGALI_LETTER_YA					   0x09AF
#define Z_UNICODE_BENGALI_LETTER_RA					   0x09B0
#define Z_UNICODE_BENGALI_LETTER_LA					   0x09B2
#define Z_UNICODE_BENGALI_LETTER_SHA					   0x09B6
#define Z_UNICODE_BENGALI_LETTER_SSA					   0x09B7
#define Z_UNICODE_BENGALI_LETTER_SA					   0x09B8
#define Z_UNICODE_BENGALI_LETTER_HA					   0x09B9
#define Z_UNICODE_BENGALI_SIGN_NUKTA					   0x09BC
#define Z_UNICODE_BENGALI_SIGN_AVAGRAHA					   0x09BD
#define Z_UNICODE_BENGALI_VOWEL_SIGN_AA					   0x09BE
#define Z_UNICODE_BENGALI_VOWEL_SIGN_I					   0x09BF
#define Z_UNICODE_BENGALI_VOWEL_SIGN_II					   0x09C0
#define Z_UNICODE_BENGALI_VOWEL_SIGN_U					   0x09C1
#define Z_UNICODE_BENGALI_VOWEL_SIGN_UU					   0x09C2
#define Z_UNICODE_BENGALI_VOWEL_SIGN_VOCALIC_R				   0x09C3
#define Z_UNICODE_BENGALI_VOWEL_SIGN_VOCALIC_RR				   0x09C4
#define Z_UNICODE_BENGALI_VOWEL_SIGN_E					   0x09C7
#define Z_UNICODE_BENGALI_VOWEL_SIGN_AI					   0x09C8
#define Z_UNICODE_BENGALI_VOWEL_SIGN_O					   0x09CB
#define Z_UNICODE_BENGALI_VOWEL_SIGN_AU					   0x09CC
#define Z_UNICODE_BENGALI_SIGN_VIRAMA					   0x09CD
#define Z_UNICODE_BENGALI_LETTER_KHANDA_TA				   0x09CE
#define Z_UNICODE_BENGALI_AU_LENGTH_MARK				   0x09D7
#define Z_UNICODE_BENGALI_LETTER_RRA					   0x09DC
#define Z_UNICODE_BENGALI_LETTER_RHA					   0x09DD
#define Z_UNICODE_BENGALI_LETTER_YYA					   0x09DF
#define Z_UNICODE_BENGALI_LETTER_VOCALIC_RR				   0x09E0
#define Z_UNICODE_BENGALI_LETTER_VOCALIC_LL				   0x09E1
#define Z_UNICODE_BENGALI_VOWEL_SIGN_VOCALIC_L				   0x09E2
#define Z_UNICODE_BENGALI_VOWEL_SIGN_VOCALIC_LL				   0x09E3
#define Z_UNICODE_BENGALI_DIGIT_ZERO					   0x09E6
#define Z_UNICODE_BENGALI_DIGIT_ONE					   0x09E7
#define Z_UNICODE_BENGALI_DIGIT_TWO					   0x09E8
#define Z_UNICODE_BENGALI_DIGIT_THREE					   0x09E9
#define Z_UNICODE_BENGALI_DIGIT_FOUR					   0x09EA
#define Z_UNICODE_BENGALI_DIGIT_FIVE					   0x09EB
#define Z_UNICODE_BENGALI_DIGIT_SIX					   0x09EC
#define Z_UNICODE_BENGALI_DIGIT_SEVEN					   0x09ED
#define Z_UNICODE_BENGALI_DIGIT_EIGHT					   0x09EE
#define Z_UNICODE_BENGALI_DIGIT_NINE					   0x09EF
#define Z_UNICODE_BENGALI_LETTER_RA_WITH_MIDDLE_DIAGONAL		   0x09F0
#define Z_UNICODE_BENGALI_LETTER_RA_WITH_LOWER_DIAGONAL			   0x09F1
#define Z_UNICODE_BENGALI_RUPEE_MARK					   0x09F2
#define Z_UNICODE_BENGALI_RUPEE_SIGN					   0x09F3
#define Z_UNICODE_BENGALI_CURRENCY_NUMERATOR_ONE			   0x09F4
#define Z_UNICODE_BENGALI_CURRENCY_NUMERATOR_TWO			   0x09F5
#define Z_UNICODE_BENGALI_CURRENCY_NUMERATOR_THREE			   0x09F6
#define Z_UNICODE_BENGALI_CURRENCY_NUMERATOR_FOUR			   0x09F7
#define Z_UNICODE_BENGALI_CURRENCY_NUMERATOR_ONE_LESS_THAN_THE_DENOMINATOR 0x09F8
#define Z_UNICODE_BENGALI_CURRENCY_DENOMINATOR_SIXTEEN			   0x09F9
#define Z_UNICODE_BENGALI_ISSHAR					   0x09FA
#define Z_UNICODE_BENGALI_GANDA_MARK					   0x09FB

/* MARK: - 0A00h-0A7Fh - Gurmukhi */

/* 0A64h <reserved> */
/* 0A65h <reserved> */
#define Z_UNICODE_GURMUKHI_SIGN_ADAK_BINDI 0x0A01
#define Z_UNICODE_GURMUKHI_SIGN_BINDI	   0x0A02
#define Z_UNICODE_GURMUKHI_SIGN_VISARGA	   0x0A03
#define Z_UNICODE_GURMUKHI_LETTER_A	   0x0A05
#define Z_UNICODE_GURMUKHI_LETTER_AA	   0x0A06
#define Z_UNICODE_GURMUKHI_LETTER_I	   0x0A07
#define Z_UNICODE_GURMUKHI_LETTER_II	   0x0A08
#define Z_UNICODE_GURMUKHI_LETTER_U	   0x0A09
#define Z_UNICODE_GURMUKHI_LETTER_UU	   0x0A0A
#define Z_UNICODE_GURMUKHI_LETTER_EE	   0x0A0F
#define Z_UNICODE_GURMUKHI_LETTER_AI	   0x0A10
#define Z_UNICODE_GURMUKHI_LETTER_OO	   0x0A13
#define Z_UNICODE_GURMUKHI_LETTER_AU	   0x0A14
#define Z_UNICODE_GURMUKHI_LETTER_KA	   0x0A15
#define Z_UNICODE_GURMUKHI_LETTER_KHA	   0x0A16
#define Z_UNICODE_GURMUKHI_LETTER_GA	   0x0A17
#define Z_UNICODE_GURMUKHI_LETTER_GHA	   0x0A18
#define Z_UNICODE_GURMUKHI_LETTER_NGA	   0x0A19
#define Z_UNICODE_GURMUKHI_LETTER_CA	   0x0A1A
#define Z_UNICODE_GURMUKHI_LETTER_CHA	   0x0A1B
#define Z_UNICODE_GURMUKHI_LETTER_JA	   0x0A1C
#define Z_UNICODE_GURMUKHI_LETTER_JHA	   0x0A1D
#define Z_UNICODE_GURMUKHI_LETTER_NYA	   0x0A1E
#define Z_UNICODE_GURMUKHI_LETTER_TTA	   0x0A1F
#define Z_UNICODE_GURMUKHI_LETTER_TTHA	   0x0A20
#define Z_UNICODE_GURMUKHI_LETTER_DDA	   0x0A21
#define Z_UNICODE_GURMUKHI_LETTER_DDHA	   0x0A22
#define Z_UNICODE_GURMUKHI_LETTER_NNA	   0x0A23
#define Z_UNICODE_GURMUKHI_LETTER_TA	   0x0A24
#define Z_UNICODE_GURMUKHI_LETTER_THA	   0x0A25
#define Z_UNICODE_GURMUKHI_LETTER_DA	   0x0A26
#define Z_UNICODE_GURMUKHI_LETTER_DHA	   0x0A27
#define Z_UNICODE_GURMUKHI_LETTER_NA	   0x0A28
#define Z_UNICODE_GURMUKHI_LETTER_PA	   0x0A2A
#define Z_UNICODE_GURMUKHI_LETTER_PHA	   0x0A2B
#define Z_UNICODE_GURMUKHI_LETTER_BA	   0x0A2C
#define Z_UNICODE_GURMUKHI_LETTER_BHA	   0x0A2D
#define Z_UNICODE_GURMUKHI_LETTER_MA	   0x0A2E
#define Z_UNICODE_GURMUKHI_LETTER_YA	   0x0A2F
#define Z_UNICODE_GURMUKHI_LETTER_RA	   0x0A30
#define Z_UNICODE_GURMUKHI_LETTER_LA	   0x0A32
#define Z_UNICODE_GURMUKHI_LETTER_LLA	   0x0A33
#define Z_UNICODE_GURMUKHI_LETTER_VA	   0x0A35
#define Z_UNICODE_GURMUKHI_LETTER_SHA	   0x0A36
#define Z_UNICODE_GURMUKHI_LETTER_SA	   0x0A38
#define Z_UNICODE_GURMUKHI_LETTER_HA	   0x0A39
#define Z_UNICODE_GURMUKHI_SIGN_NUKTA	   0x0A3C
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_AA   0x0A3E
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_I	   0x0A3F
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_II   0x0A40
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_U	   0x0A41
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_UU   0x0A42
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_EE   0x0A47
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_AI   0x0A48
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_OO   0x0A4B
#define Z_UNICODE_GURMUKHI_VOWEL_SIGN_AU   0x0A4C
#define Z_UNICODE_GURMUKHI_SIGN_VIRAMA	   0x0A4D
#define Z_UNICODE_GURMUKHI_SIGN_UDAAT	   0x0A51
#define Z_UNICODE_GURMUKHI_LETTER_KHHA	   0x0A59
#define Z_UNICODE_GURMUKHI_LETTER_GHHA	   0x0A5A
#define Z_UNICODE_GURMUKHI_LETTER_ZA	   0x0A5B
#define Z_UNICODE_GURMUKHI_LETTER_RRA	   0x0A5C
#define Z_UNICODE_GURMUKHI_LETTER_FA	   0x0A5E
#define Z_UNICODE_GURMUKHI_DIGIT_ZERO	   0x0A66
#define Z_UNICODE_GURMUKHI_DIGIT_ONE	   0x0A67
#define Z_UNICODE_GURMUKHI_DIGIT_TWO	   0x0A68
#define Z_UNICODE_GURMUKHI_DIGIT_THREE	   0x0A69
#define Z_UNICODE_GURMUKHI_DIGIT_FOUR	   0x0A6A
#define Z_UNICODE_GURMUKHI_DIGIT_FIVE	   0x0A6B
#define Z_UNICODE_GURMUKHI_DIGIT_SIX	   0x0A6C
#define Z_UNICODE_GURMUKHI_DIGIT_SEVEN	   0x0A6D
#define Z_UNICODE_GURMUKHI_DIGIT_EIGHT	   0x0A6E
#define Z_UNICODE_GURMUKHI_DIGIT_NINE	   0x0A6F
#define Z_UNICODE_GURMUKHI_TIPPI	   0x0A70
#define Z_UNICODE_GURMUKHI_ADDAK	   0x0A71
#define Z_UNICODE_GURMUKHI_IRI		   0x0A72
#define Z_UNICODE_GURMUKHI_URA		   0x0A73
#define Z_UNICODE_GURMUKHI_EK_ONKAR	   0x0A74
#define Z_UNICODE_GURMUKHI_SIGN_YAKASH	   0x0A75

/* MARK: - 0A80h-0AFFh - Gujarati */

/* 0AE4h <reserved> */
/* 0AE5h <reserved> */
#define Z_UNICODE_GUJARATI_SIGN_CANDRABINDU	 0x0A81
#define Z_UNICODE_GUJARATI_SIGN_ANUSVARA	 0x0A82
#define Z_UNICODE_GUJARATI_SIGN_VISARGA		 0x0A83
#define Z_UNICODE_GUJARATI_LETTER_A		 0x0A85
#define Z_UNICODE_GUJARATI_LETTER_AA		 0x0A86
#define Z_UNICODE_GUJARATI_LETTER_I		 0x0A87
#define Z_UNICODE_GUJARATI_LETTER_II		 0x0A88
#define Z_UNICODE_GUJARATI_LETTER_U		 0x0A89
#define Z_UNICODE_GUJARATI_LETTER_UU		 0x0A8A
#define Z_UNICODE_GUJARATI_LETTER_VOCALIC_R	 0x0A8B
#define Z_UNICODE_GUJARATI_LETTER_VOCALIC_L	 0x0A8C
#define Z_UNICODE_GUJARATI_VOWEL_CANDRA_E	 0x0A8D
#define Z_UNICODE_GUJARATI_LETTER_E		 0x0A8F
#define Z_UNICODE_GUJARATI_LETTER_AI		 0x0A90
#define Z_UNICODE_GUJARATI_VOWEL_CANDRA_O	 0x0A91
#define Z_UNICODE_GUJARATI_LETTER_O		 0x0A93
#define Z_UNICODE_GUJARATI_LETTER_AU		 0x0A94
#define Z_UNICODE_GUJARATI_LETTER_KA		 0x0A95
#define Z_UNICODE_GUJARATI_LETTER_KHA		 0x0A96
#define Z_UNICODE_GUJARATI_LETTER_GA		 0x0A97
#define Z_UNICODE_GUJARATI_LETTER_GHA		 0x0A98
#define Z_UNICODE_GUJARATI_LETTER_NGA		 0x0A99
#define Z_UNICODE_GUJARATI_LETTER_CA		 0x0A9A
#define Z_UNICODE_GUJARATI_LETTER_CHA		 0x0A9B
#define Z_UNICODE_GUJARATI_LETTER_JA		 0x0A9C
#define Z_UNICODE_GUJARATI_LETTER_JHA		 0x0A9D
#define Z_UNICODE_GUJARATI_LETTER_NYA		 0x0A9E
#define Z_UNICODE_GUJARATI_LETTER_TTA		 0x0A9F
#define Z_UNICODE_GUJARATI_LETTER_TTHA		 0x0AA0
#define Z_UNICODE_GUJARATI_LETTER_DDA		 0x0AA1
#define Z_UNICODE_GUJARATI_LETTER_DDHA		 0x0AA2
#define Z_UNICODE_GUJARATI_LETTER_NNA		 0x0AA3
#define Z_UNICODE_GUJARATI_LETTER_TA		 0x0AA4
#define Z_UNICODE_GUJARATI_LETTER_THA		 0x0AA5
#define Z_UNICODE_GUJARATI_LETTER_DA		 0x0AA6
#define Z_UNICODE_GUJARATI_LETTER_DHA		 0x0AA7
#define Z_UNICODE_GUJARATI_LETTER_NA		 0x0AA8
#define Z_UNICODE_GUJARATI_LETTER_PA		 0x0AAA
#define Z_UNICODE_GUJARATI_LETTER_PHA		 0x0AAB
#define Z_UNICODE_GUJARATI_LETTER_BA		 0x0AAC
#define Z_UNICODE_GUJARATI_LETTER_BHA		 0x0AAD
#define Z_UNICODE_GUJARATI_LETTER_MA		 0x0AAE
#define Z_UNICODE_GUJARATI_LETTER_YA		 0x0AAF
#define Z_UNICODE_GUJARATI_LETTER_RA		 0x0AB0
#define Z_UNICODE_GUJARATI_LETTER_LA		 0x0AB2
#define Z_UNICODE_GUJARATI_LETTER_LLA		 0x0AB3
#define Z_UNICODE_GUJARATI_LETTER_VA		 0x0AB5
#define Z_UNICODE_GUJARATI_LETTER_SHA		 0x0AB6
#define Z_UNICODE_GUJARATI_LETTER_SSA		 0x0AB7
#define Z_UNICODE_GUJARATI_LETTER_SA		 0x0AB8
#define Z_UNICODE_GUJARATI_LETTER_HA		 0x0AB9
#define Z_UNICODE_GUJARATI_SIGN_NUKTA		 0x0ABC
#define Z_UNICODE_GUJARATI_SIGN_AVAGRAHA	 0x0ABD
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_AA	 0x0ABE
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_I		 0x0ABF
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_II	 0x0AC0
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_U		 0x0AC1
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_UU	 0x0AC2
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_VOCALIC_R	 0x0AC3
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_VOCALIC_RR 0x0AC4
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_CANDRA_E	 0x0AC5
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_E		 0x0AC7
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_AI	 0x0AC8
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_CANDRA_O	 0x0AC9
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_O		 0x0ACB
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_AU	 0x0ACC
#define Z_UNICODE_GUJARATI_SIGN_VIRAMA		 0x0ACD
#define Z_UNICODE_GUJARATI_OM			 0x0AD0
#define Z_UNICODE_GUJARATI_LETTER_VOCALIC_RR	 0x0AE0
#define Z_UNICODE_GUJARATI_LETTER_VOCALIC_LL	 0x0AE1
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_VOCALIC_L	 0x0AE2
#define Z_UNICODE_GUJARATI_VOWEL_SIGN_VOCALIC_LL 0x0AE3
#define Z_UNICODE_GUJARATI_DIGIT_ZERO		 0x0AE6
#define Z_UNICODE_GUJARATI_DIGIT_ONE		 0x0AE7
#define Z_UNICODE_GUJARATI_DIGIT_TWO		 0x0AE8
#define Z_UNICODE_GUJARATI_DIGIT_THREE		 0x0AE9
#define Z_UNICODE_GUJARATI_DIGIT_FOUR		 0x0AEA
#define Z_UNICODE_GUJARATI_DIGIT_FIVE		 0x0AEB
#define Z_UNICODE_GUJARATI_DIGIT_SIX		 0x0AEC
#define Z_UNICODE_GUJARATI_DIGIT_SEVEN		 0x0AED
#define Z_UNICODE_GUJARATI_DIGIT_EIGHT		 0x0AEE
#define Z_UNICODE_GUJARATI_DIGIT_NINE		 0x0AEF
#define Z_UNICODE_GUJARATI_ABBREVIATION_SIGN	 0x0AF0
#define Z_UNICODE_GUJARATI_RUPEE_SIGN		 0x0AF1
#define Z_UNICODE_GUJARATI_LETTER_ZHA		 0x0AF9

/* MARK: - 0B00h-0B7Fh - Oriya */

/* 0B64h <reserved> */
/* 0B65h <reserved> */
#define Z_UNICODE_ORIYA_SIGN_CANDRABINDU	  0x0B01
#define Z_UNICODE_ORIYA_SIGN_ANUSVARA		  0x0B02
#define Z_UNICODE_ORIYA_SIGN_VISARGA		  0x0B03
#define Z_UNICODE_ORIYA_LETTER_A		  0x0B05
#define Z_UNICODE_ORIYA_LETTER_AA		  0x0B06
#define Z_UNICODE_ORIYA_LETTER_I		  0x0B07
#define Z_UNICODE_ORIYA_LETTER_II		  0x0B08
#define Z_UNICODE_ORIYA_LETTER_U		  0x0B09
#define Z_UNICODE_ORIYA_LETTER_UU		  0x0B0A
#define Z_UNICODE_ORIYA_LETTER_VOCALIC_R	  0x0B0B
#define Z_UNICODE_ORIYA_LETTER_VOCALIC_L	  0x0B0C
#define Z_UNICODE_ORIYA_LETTER_E		  0x0B0F
#define Z_UNICODE_ORIYA_LETTER_AI		  0x0B10
#define Z_UNICODE_ORIYA_LETTER_O		  0x0B13
#define Z_UNICODE_ORIYA_LETTER_AU		  0x0B14
#define Z_UNICODE_ORIYA_LETTER_KA		  0x0B15
#define Z_UNICODE_ORIYA_LETTER_KHA		  0x0B16
#define Z_UNICODE_ORIYA_LETTER_GA		  0x0B17
#define Z_UNICODE_ORIYA_LETTER_GHA		  0x0B18
#define Z_UNICODE_ORIYA_LETTER_NGA		  0x0B19
#define Z_UNICODE_ORIYA_LETTER_CA		  0x0B1A
#define Z_UNICODE_ORIYA_LETTER_CHA		  0x0B1B
#define Z_UNICODE_ORIYA_LETTER_JA		  0x0B1C
#define Z_UNICODE_ORIYA_LETTER_JHA		  0x0B1D
#define Z_UNICODE_ORIYA_LETTER_NYA		  0x0B1E
#define Z_UNICODE_ORIYA_LETTER_TTA		  0x0B1F
#define Z_UNICODE_ORIYA_LETTER_TTHA		  0x0B20
#define Z_UNICODE_ORIYA_LETTER_DDA		  0x0B21
#define Z_UNICODE_ORIYA_LETTER_DDHA		  0x0B22
#define Z_UNICODE_ORIYA_LETTER_NNA		  0x0B23
#define Z_UNICODE_ORIYA_LETTER_TA		  0x0B24
#define Z_UNICODE_ORIYA_LETTER_THA		  0x0B25
#define Z_UNICODE_ORIYA_LETTER_DA		  0x0B26
#define Z_UNICODE_ORIYA_LETTER_DHA		  0x0B27
#define Z_UNICODE_ORIYA_LETTER_NA		  0x0B28
#define Z_UNICODE_ORIYA_LETTER_PA		  0x0B2A
#define Z_UNICODE_ORIYA_LETTER_PHA		  0x0B2B
#define Z_UNICODE_ORIYA_LETTER_BA		  0x0B2C
#define Z_UNICODE_ORIYA_LETTER_BHA		  0x0B2D
#define Z_UNICODE_ORIYA_LETTER_MA		  0x0B2E
#define Z_UNICODE_ORIYA_LETTER_YA		  0x0B2F
#define Z_UNICODE_ORIYA_LETTER_RA		  0x0B30
#define Z_UNICODE_ORIYA_LETTER_LA		  0x0B32
#define Z_UNICODE_ORIYA_LETTER_LLA		  0x0B33
#define Z_UNICODE_ORIYA_LETTER_VA		  0x0B35
#define Z_UNICODE_ORIYA_LETTER_SHA		  0x0B36
#define Z_UNICODE_ORIYA_LETTER_SSA		  0x0B37
#define Z_UNICODE_ORIYA_LETTER_SA		  0x0B38
#define Z_UNICODE_ORIYA_LETTER_HA		  0x0B39
#define Z_UNICODE_ORIYA_SIGN_NUKTA		  0x0B3C
#define Z_UNICODE_ORIYA_SIGN_AVAGRAHA		  0x0B3D
#define Z_UNICODE_ORIYA_VOWEL_SIGN_AA		  0x0B3E
#define Z_UNICODE_ORIYA_VOWEL_SIGN_I		  0x0B3F
#define Z_UNICODE_ORIYA_VOWEL_SIGN_II		  0x0B40
#define Z_UNICODE_ORIYA_VOWEL_SIGN_U		  0x0B41
#define Z_UNICODE_ORIYA_VOWEL_SIGN_UU		  0x0B42
#define Z_UNICODE_ORIYA_VOWEL_SIGN_VOCALIC_R	  0x0B43
#define Z_UNICODE_ORIYA_VOWEL_SIGN_VOCALIC_RR	  0x0B44
#define Z_UNICODE_ORIYA_VOWEL_SIGN_E		  0x0B47
#define Z_UNICODE_ORIYA_VOWEL_SIGN_AI		  0x0B48
#define Z_UNICODE_ORIYA_VOWEL_SIGN_O		  0x0B4B
#define Z_UNICODE_ORIYA_VOWEL_SIGN_AU		  0x0B4C
#define Z_UNICODE_ORIYA_SIGN_VIRAMA		  0x0B4D
#define Z_UNICODE_ORIYA_AI_LENGTH_MARK		  0x0B56
#define Z_UNICODE_ORIYA_AU_LENGTH_MARK		  0x0B57
#define Z_UNICODE_ORIYA_LETTER_RRA		  0x0B5C
#define Z_UNICODE_ORIYA_LETTER_RHA		  0x0B5D
#define Z_UNICODE_ORIYA_LETTER_YYA		  0x0B5F
#define Z_UNICODE_ORIYA_LETTER_VOCALIC_RR	  0x0B60
#define Z_UNICODE_ORIYA_LETTER_VOCALIC_LL	  0x0B61
#define Z_UNICODE_ORIYA_VOWEL_SIGN_VOCALIC_L	  0x0B62
#define Z_UNICODE_ORIYA_VOWEL_SIGN_VOCALIC_LL	  0x0B63
#define Z_UNICODE_ORIYA_DIGIT_ZERO		  0x0B66
#define Z_UNICODE_ORIYA_DIGIT_ONE		  0x0B67
#define Z_UNICODE_ORIYA_DIGIT_TWO		  0x0B68
#define Z_UNICODE_ORIYA_DIGIT_THREE		  0x0B69
#define Z_UNICODE_ORIYA_DIGIT_FOUR		  0x0B6A
#define Z_UNICODE_ORIYA_DIGIT_FIVE		  0x0B6B
#define Z_UNICODE_ORIYA_DIGIT_SIX		  0x0B6C
#define Z_UNICODE_ORIYA_DIGIT_SEVEN		  0x0B6D
#define Z_UNICODE_ORIYA_DIGIT_EIGHT		  0x0B6E
#define Z_UNICODE_ORIYA_DIGIT_NINE		  0x0B6F
#define Z_UNICODE_ORIYA_ISSHAR			  0x0B70
#define Z_UNICODE_ORIYA_LETTER_WA		  0x0B71
#define Z_UNICODE_ORIYA_FRACTION_ONE_QUARTER	  0x0B72
#define Z_UNICODE_ORIYA_FRACTION_ONE_HALF	  0x0B73
#define Z_UNICODE_ORIYA_FRACTION_THREE_QUARTERS	  0x0B74
#define Z_UNICODE_ORIYA_FRACTION_ONE_SIXTEENTH	  0x0B75
#define Z_UNICODE_ORIYA_FRACTION_ONE_EIGHTH	  0x0B76
#define Z_UNICODE_ORIYA_FRACTION_THREE_SIXTEENTHS 0x0B77

/* MARK: - 0B80h-0BFFh - Tamil */

/* 0BE4h <reserved> */
/* 0BE5h <reserved> */
#define Z_UNICODE_TAMIL_SIGN_ANUSVARA	    0x0B82
#define Z_UNICODE_TAMIL_SIGN_VISARGA	    0x0B83
#define Z_UNICODE_TAMIL_LETTER_A	    0x0B85
#define Z_UNICODE_TAMIL_LETTER_AA	    0x0B86
#define Z_UNICODE_TAMIL_LETTER_I	    0x0B87
#define Z_UNICODE_TAMIL_LETTER_II	    0x0B88
#define Z_UNICODE_TAMIL_LETTER_U	    0x0B89
#define Z_UNICODE_TAMIL_LETTER_UU	    0x0B8A
#define Z_UNICODE_TAMIL_LETTER_E	    0x0B8E
#define Z_UNICODE_TAMIL_LETTER_EE	    0x0B8F
#define Z_UNICODE_TAMIL_LETTER_AI	    0x0B90
#define Z_UNICODE_TAMIL_LETTER_O	    0x0B92
#define Z_UNICODE_TAMIL_LETTER_OO	    0x0B93
#define Z_UNICODE_TAMIL_LETTER_AU	    0x0B94
#define Z_UNICODE_TAMIL_LETTER_KA	    0x0B95
#define Z_UNICODE_TAMIL_LETTER_NGA	    0x0B99
#define Z_UNICODE_TAMIL_LETTER_CA	    0x0B9A
#define Z_UNICODE_TAMIL_LETTER_JA	    0x0B9C
#define Z_UNICODE_TAMIL_LETTER_NYA	    0x0B9E
#define Z_UNICODE_TAMIL_LETTER_TTA	    0x0B9F
#define Z_UNICODE_TAMIL_LETTER_NNA	    0x0BA3
#define Z_UNICODE_TAMIL_LETTER_TA	    0x0BA4
#define Z_UNICODE_TAMIL_LETTER_NA	    0x0BA8
#define Z_UNICODE_TAMIL_LETTER_NNNA	    0x0BA9
#define Z_UNICODE_TAMIL_LETTER_PA	    0x0BAA
#define Z_UNICODE_TAMIL_LETTER_MA	    0x0BAE
#define Z_UNICODE_TAMIL_LETTER_YA	    0x0BAF
#define Z_UNICODE_TAMIL_LETTER_RA	    0x0BB0
#define Z_UNICODE_TAMIL_LETTER_RRA	    0x0BB1
#define Z_UNICODE_TAMIL_LETTER_LA	    0x0BB2
#define Z_UNICODE_TAMIL_LETTER_LLA	    0x0BB3
#define Z_UNICODE_TAMIL_LETTER_LLLA	    0x0BB4
#define Z_UNICODE_TAMIL_LETTER_VA	    0x0BB5
#define Z_UNICODE_TAMIL_LETTER_SHA	    0x0BB6
#define Z_UNICODE_TAMIL_LETTER_SSA	    0x0BB7
#define Z_UNICODE_TAMIL_LETTER_SA	    0x0BB8
#define Z_UNICODE_TAMIL_LETTER_HA	    0x0BB9
#define Z_UNICODE_TAMIL_VOWEL_SIGN_AA	    0x0BBE
#define Z_UNICODE_TAMIL_VOWEL_SIGN_I	    0x0BBF
#define Z_UNICODE_TAMIL_VOWEL_SIGN_II	    0x0BC0
#define Z_UNICODE_TAMIL_VOWEL_SIGN_U	    0x0BC1
#define Z_UNICODE_TAMIL_VOWEL_SIGN_UU	    0x0BC2
#define Z_UNICODE_TAMIL_VOWEL_SIGN_E	    0x0BC6
#define Z_UNICODE_TAMIL_VOWEL_SIGN_EE	    0x0BC7
#define Z_UNICODE_TAMIL_VOWEL_SIGN_AI	    0x0BC8
#define Z_UNICODE_TAMIL_VOWEL_SIGN_O	    0x0BCA
#define Z_UNICODE_TAMIL_VOWEL_SIGN_OO	    0x0BCB
#define Z_UNICODE_TAMIL_VOWEL_SIGN_AU	    0x0BCC
#define Z_UNICODE_TAMIL_SIGN_VIRAMA	    0x0BCD
#define Z_UNICODE_TAMIL_OM		    0x0BD0
#define Z_UNICODE_TAMIL_AU_LENGTH_MARK	    0x0BD7
#define Z_UNICODE_TAMIL_DIGIT_ZERO	    0x0BE6
#define Z_UNICODE_TAMIL_DIGIT_ONE	    0x0BE7
#define Z_UNICODE_TAMIL_DIGIT_TWO	    0x0BE8
#define Z_UNICODE_TAMIL_DIGIT_THREE	    0x0BE9
#define Z_UNICODE_TAMIL_DIGIT_FOUR	    0x0BEA
#define Z_UNICODE_TAMIL_DIGIT_FIVE	    0x0BEB
#define Z_UNICODE_TAMIL_DIGIT_SIX	    0x0BEC
#define Z_UNICODE_TAMIL_DIGIT_SEVEN	    0x0BED
#define Z_UNICODE_TAMIL_DIGIT_EIGHT	    0x0BEE
#define Z_UNICODE_TAMIL_DIGIT_NINE	    0x0BEF
#define Z_UNICODE_TAMIL_NUMBER_TEN	    0x0BF0
#define Z_UNICODE_TAMIL_NUMBER_ONE_HUNDRED  0x0BF1
#define Z_UNICODE_TAMIL_NUMBER_ONE_THOUSAND 0x0BF2
#define Z_UNICODE_TAMIL_DAY_SIGN	    0x0BF3
#define Z_UNICODE_TAMIL_MONTH_SIGN	    0x0BF4
#define Z_UNICODE_TAMIL_YEAR_SIGN	    0x0BF5
#define Z_UNICODE_TAMIL_DEBIT_SIGN	    0x0BF6
#define Z_UNICODE_TAMIL_CREDIT_SIGN	    0x0BF7
#define Z_UNICODE_TAMIL_AS_ABOVE_SIGN	    0x0BF8
#define Z_UNICODE_TAMIL_RUPEE_SIGN	    0x0BF9
#define Z_UNICODE_TAMIL_NUMBER_SIGN	    0x0BFA

/* MARK: - 0C00h-0C7Fh - Telugu */

/* 0C64h <reserved> */
/* 0C65h <reserved> */
#define Z_UNICODE_TELUGU_SIGN_COMBINING_CANDRABINDU_ABOVE	      0x0C00
#define Z_UNICODE_TELUGU_SIGN_CANDRABINDU			      0x0C01
#define Z_UNICODE_TELUGU_SIGN_ANUSVARA				      0x0C02
#define Z_UNICODE_TELUGU_SIGN_VISARGA				      0x0C03
#define Z_UNICODE_TELUGU_LETTER_A				      0x0C05
#define Z_UNICODE_TELUGU_LETTER_AA				      0x0C06
#define Z_UNICODE_TELUGU_LETTER_I				      0x0C07
#define Z_UNICODE_TELUGU_LETTER_II				      0x0C08
#define Z_UNICODE_TELUGU_LETTER_U				      0x0C09
#define Z_UNICODE_TELUGU_LETTER_UU				      0x0C0A
#define Z_UNICODE_TELUGU_LETTER_VOCALIC_R			      0x0C0B
#define Z_UNICODE_TELUGU_LETTER_VOCALIC_L			      0x0C0C
#define Z_UNICODE_TELUGU_LETTER_E				      0x0C0E
#define Z_UNICODE_TELUGU_LETTER_EE				      0x0C0F
#define Z_UNICODE_TELUGU_LETTER_AI				      0x0C10
#define Z_UNICODE_TELUGU_LETTER_O				      0x0C12
#define Z_UNICODE_TELUGU_LETTER_OO				      0x0C13
#define Z_UNICODE_TELUGU_LETTER_AU				      0x0C14
#define Z_UNICODE_TELUGU_LETTER_KA				      0x0C15
#define Z_UNICODE_TELUGU_LETTER_KHA				      0x0C16
#define Z_UNICODE_TELUGU_LETTER_GA				      0x0C17
#define Z_UNICODE_TELUGU_LETTER_GHA				      0x0C18
#define Z_UNICODE_TELUGU_LETTER_NGA				      0x0C19
#define Z_UNICODE_TELUGU_LETTER_CA				      0x0C1A
#define Z_UNICODE_TELUGU_LETTER_CHA				      0x0C1B
#define Z_UNICODE_TELUGU_LETTER_JA				      0x0C1C
#define Z_UNICODE_TELUGU_LETTER_JHA				      0x0C1D
#define Z_UNICODE_TELUGU_LETTER_NYA				      0x0C1E
#define Z_UNICODE_TELUGU_LETTER_TTA				      0x0C1F
#define Z_UNICODE_TELUGU_LETTER_TTHA				      0x0C20
#define Z_UNICODE_TELUGU_LETTER_DDA				      0x0C21
#define Z_UNICODE_TELUGU_LETTER_DDHA				      0x0C22
#define Z_UNICODE_TELUGU_LETTER_NNA				      0x0C23
#define Z_UNICODE_TELUGU_LETTER_TA				      0x0C24
#define Z_UNICODE_TELUGU_LETTER_THA				      0x0C25
#define Z_UNICODE_TELUGU_LETTER_DA				      0x0C26
#define Z_UNICODE_TELUGU_LETTER_DHA				      0x0C27
#define Z_UNICODE_TELUGU_LETTER_NA				      0x0C28
#define Z_UNICODE_TELUGU_LETTER_PA				      0x0C2A
#define Z_UNICODE_TELUGU_LETTER_PHA				      0x0C2B
#define Z_UNICODE_TELUGU_LETTER_BA				      0x0C2C
#define Z_UNICODE_TELUGU_LETTER_BHA				      0x0C2D
#define Z_UNICODE_TELUGU_LETTER_MA				      0x0C2E
#define Z_UNICODE_TELUGU_LETTER_YA				      0x0C2F
#define Z_UNICODE_TELUGU_LETTER_RA				      0x0C30
#define Z_UNICODE_TELUGU_LETTER_RRA				      0x0C31
#define Z_UNICODE_TELUGU_LETTER_LA				      0x0C32
#define Z_UNICODE_TELUGU_LETTER_LLA				      0x0C33
#define Z_UNICODE_TELUGU_LETTER_LLLA				      0x0C34
#define Z_UNICODE_TELUGU_LETTER_VA				      0x0C35
#define Z_UNICODE_TELUGU_LETTER_SHA				      0x0C36
#define Z_UNICODE_TELUGU_LETTER_SSA				      0x0C37
#define Z_UNICODE_TELUGU_LETTER_SA				      0x0C38
#define Z_UNICODE_TELUGU_LETTER_HA				      0x0C39
#define Z_UNICODE_TELUGU_SIGN_AVAGRAHA				      0x0C3D
#define Z_UNICODE_TELUGU_VOWEL_SIGN_AA				      0x0C3E
#define Z_UNICODE_TELUGU_VOWEL_SIGN_I				      0x0C3F
#define Z_UNICODE_TELUGU_VOWEL_SIGN_II				      0x0C40
#define Z_UNICODE_TELUGU_VOWEL_SIGN_U				      0x0C41
#define Z_UNICODE_TELUGU_VOWEL_SIGN_UU				      0x0C42
#define Z_UNICODE_TELUGU_VOWEL_SIGN_VOCALIC_R			      0x0C43
#define Z_UNICODE_TELUGU_VOWEL_SIGN_VOCALIC_RR			      0x0C44
#define Z_UNICODE_TELUGU_VOWEL_SIGN_E				      0x0C46
#define Z_UNICODE_TELUGU_VOWEL_SIGN_EE				      0x0C47
#define Z_UNICODE_TELUGU_VOWEL_SIGN_AI				      0x0C48
#define Z_UNICODE_TELUGU_VOWEL_SIGN_O				      0x0C4A
#define Z_UNICODE_TELUGU_VOWEL_SIGN_OO				      0x0C4B
#define Z_UNICODE_TELUGU_VOWEL_SIGN_AU				      0x0C4C
#define Z_UNICODE_TELUGU_SIGN_VIRAMA				      0x0C4D
#define Z_UNICODE_TELUGU_LENGTH_MARK				      0x0C55
#define Z_UNICODE_TELUGU_AI_LENGTH_MARK				      0x0C56
#define Z_UNICODE_TELUGU_LETTER_TSA				      0x0C58
#define Z_UNICODE_TELUGU_LETTER_DZA				      0x0C59
#define Z_UNICODE_TELUGU_LETTER_RRRA				      0x0C5A
#define Z_UNICODE_TELUGU_LETTER_VOCALIC_RR			      0x0C60
#define Z_UNICODE_TELUGU_LETTER_VOCALIC_LL			      0x0C61
#define Z_UNICODE_TELUGU_VOWEL_SIGN_VOCALIC_L			      0x0C62
#define Z_UNICODE_TELUGU_VOWEL_SIGN_VOCALIC_LL			      0x0C63
#define Z_UNICODE_TELUGU_DIGIT_ZERO				      0x0C66
#define Z_UNICODE_TELUGU_DIGIT_ONE				      0x0C67
#define Z_UNICODE_TELUGU_DIGIT_TWO				      0x0C68
#define Z_UNICODE_TELUGU_DIGIT_THREE				      0x0C69
#define Z_UNICODE_TELUGU_DIGIT_FOUR				      0x0C6A
#define Z_UNICODE_TELUGU_DIGIT_FIVE				      0x0C6B
#define Z_UNICODE_TELUGU_DIGIT_SIX				      0x0C6C
#define Z_UNICODE_TELUGU_DIGIT_SEVEN				      0x0C6D
#define Z_UNICODE_TELUGU_DIGIT_EIGHT				      0x0C6E
#define Z_UNICODE_TELUGU_DIGIT_NINE				      0x0C6F
#define Z_UNICODE_TELUGU_FRACTION_DIGIT_ZERO_FOR_ODD_POWERS_OF_FOUR   0x0C78
#define Z_UNICODE_TELUGU_FRACTION_DIGIT_ONE_FOR_ODD_POWERS_OF_FOUR    0x0C79
#define Z_UNICODE_TELUGU_FRACTION_DIGIT_TWO_FOR_ODD_POWERS_OF_FOUR    0x0C7A
#define Z_UNICODE_TELUGU_FRACTION_DIGIT_THREE_FOR_ODD_POWERS_OF_FOUR  0x0C7B
#define Z_UNICODE_TELUGU_FRACTION_DIGIT_ONE_FOR_EVEN_POWERS_OF_FOUR   0x0C7C
#define Z_UNICODE_TELUGU_FRACTION_DIGIT_TWO_FOR_EVEN_POWERS_OF_FOUR   0x0C7D
#define Z_UNICODE_TELUGU_FRACTION_DIGIT_THREE_FOR_EVEN_POWERS_OF_FOUR 0x0C7E
#define Z_UNICODE_TELUGU_SIGN_TUUMU				      0x0C7F

/* MARK: - 0C80h-0CFFh - Kannada */

/* 0CE4h <reserved> */
/* 0CE5h <reserved> */
#define Z_UNICODE_KANNADA_SIGN_CANDRABINDU	0x0C81
#define Z_UNICODE_KANNADA_SIGN_ANUSVARA		0x0C82
#define Z_UNICODE_KANNADA_SIGN_VISARGA		0x0C83
#define Z_UNICODE_KANNADA_LETTER_A		0x0C85
#define Z_UNICODE_KANNADA_LETTER_AA		0x0C86
#define Z_UNICODE_KANNADA_LETTER_I		0x0C87
#define Z_UNICODE_KANNADA_LETTER_II		0x0C88
#define Z_UNICODE_KANNADA_LETTER_U		0x0C89
#define Z_UNICODE_KANNADA_LETTER_UU		0x0C8A
#define Z_UNICODE_KANNADA_LETTER_VOCALIC_R	0x0C8B
#define Z_UNICODE_KANNADA_LETTER_VOCALIC_L	0x0C8C
#define Z_UNICODE_KANNADA_LETTER_E		0x0C8E
#define Z_UNICODE_KANNADA_LETTER_EE		0x0C8F
#define Z_UNICODE_KANNADA_LETTER_AI		0x0C90
#define Z_UNICODE_KANNADA_LETTER_O		0x0C92
#define Z_UNICODE_KANNADA_LETTER_OO		0x0C93
#define Z_UNICODE_KANNADA_LETTER_AU		0x0C94
#define Z_UNICODE_KANNADA_LETTER_KA		0x0C95
#define Z_UNICODE_KANNADA_LETTER_KHA		0x0C96
#define Z_UNICODE_KANNADA_LETTER_GA		0x0C97
#define Z_UNICODE_KANNADA_LETTER_GHA		0x0C98
#define Z_UNICODE_KANNADA_LETTER_NGA		0x0C99
#define Z_UNICODE_KANNADA_LETTER_CA		0x0C9A
#define Z_UNICODE_KANNADA_LETTER_CHA		0x0C9B
#define Z_UNICODE_KANNADA_LETTER_JA		0x0C9C
#define Z_UNICODE_KANNADA_LETTER_JHA		0x0C9D
#define Z_UNICODE_KANNADA_LETTER_NYA		0x0C9E
#define Z_UNICODE_KANNADA_LETTER_TTA		0x0C9F
#define Z_UNICODE_KANNADA_LETTER_TTHA		0x0CA0
#define Z_UNICODE_KANNADA_LETTER_DDA		0x0CA1
#define Z_UNICODE_KANNADA_LETTER_DDHA		0x0CA2
#define Z_UNICODE_KANNADA_LETTER_NNA		0x0CA3
#define Z_UNICODE_KANNADA_LETTER_TA		0x0CA4
#define Z_UNICODE_KANNADA_LETTER_THA		0x0CA5
#define Z_UNICODE_KANNADA_LETTER_DA		0x0CA6
#define Z_UNICODE_KANNADA_LETTER_DHA		0x0CA7
#define Z_UNICODE_KANNADA_LETTER_NA		0x0CA8
#define Z_UNICODE_KANNADA_LETTER_PA		0x0CAA
#define Z_UNICODE_KANNADA_LETTER_PHA		0x0CAB
#define Z_UNICODE_KANNADA_LETTER_BA		0x0CAC
#define Z_UNICODE_KANNADA_LETTER_BHA		0x0CAD
#define Z_UNICODE_KANNADA_LETTER_MA		0x0CAE
#define Z_UNICODE_KANNADA_LETTER_YA		0x0CAF
#define Z_UNICODE_KANNADA_LETTER_RA		0x0CB0
#define Z_UNICODE_KANNADA_LETTER_RRA		0x0CB1
#define Z_UNICODE_KANNADA_LETTER_LA		0x0CB2
#define Z_UNICODE_KANNADA_LETTER_LLA		0x0CB3
#define Z_UNICODE_KANNADA_LETTER_VA		0x0CB5
#define Z_UNICODE_KANNADA_LETTER_SHA		0x0CB6
#define Z_UNICODE_KANNADA_LETTER_SSA		0x0CB7
#define Z_UNICODE_KANNADA_LETTER_SA		0x0CB8
#define Z_UNICODE_KANNADA_LETTER_HA		0x0CB9
#define Z_UNICODE_KANNADA_SIGN_NUKTA		0x0CBC
#define Z_UNICODE_KANNADA_SIGN_AVAGRAHA		0x0CBD
#define Z_UNICODE_KANNADA_VOWEL_SIGN_AA		0x0CBE
#define Z_UNICODE_KANNADA_VOWEL_SIGN_I		0x0CBF
#define Z_UNICODE_KANNADA_VOWEL_SIGN_II		0x0CC0
#define Z_UNICODE_KANNADA_VOWEL_SIGN_U		0x0CC1
#define Z_UNICODE_KANNADA_VOWEL_SIGN_UU		0x0CC2
#define Z_UNICODE_KANNADA_VOWEL_SIGN_VOCALIC_R	0x0CC3
#define Z_UNICODE_KANNADA_VOWEL_SIGN_VOCALIC_RR	0x0CC4
#define Z_UNICODE_KANNADA_VOWEL_SIGN_E		0x0CC6
#define Z_UNICODE_KANNADA_VOWEL_SIGN_EE		0x0CC7
#define Z_UNICODE_KANNADA_VOWEL_SIGN_AI		0x0CC8
#define Z_UNICODE_KANNADA_VOWEL_SIGN_O		0x0CCA
#define Z_UNICODE_KANNADA_VOWEL_SIGN_OO		0x0CCB
#define Z_UNICODE_KANNADA_VOWEL_SIGN_AU		0x0CCC
#define Z_UNICODE_KANNADA_SIGN_VIRAMA		0x0CCD
#define Z_UNICODE_KANNADA_LENGTH_MARK		0x0CD5
#define Z_UNICODE_KANNADA_AI_LENGTH_MARK	0x0CD6
#define Z_UNICODE_KANNADA_LETTER_FA		0x0CDE
#define Z_UNICODE_KANNADA_LETTER_VOCALIC_RR	0x0CE0
#define Z_UNICODE_KANNADA_LETTER_VOCALIC_LL	0x0CE1
#define Z_UNICODE_KANNADA_VOWEL_SIGN_VOCALIC_L	0x0CE2
#define Z_UNICODE_KANNADA_VOWEL_SIGN_VOCALIC_LL	0x0CE3
#define Z_UNICODE_KANNADA_DIGIT_ZERO		0x0CE6
#define Z_UNICODE_KANNADA_DIGIT_ONE		0x0CE7
#define Z_UNICODE_KANNADA_DIGIT_TWO		0x0CE8
#define Z_UNICODE_KANNADA_DIGIT_THREE		0x0CE9
#define Z_UNICODE_KANNADA_DIGIT_FOUR		0x0CEA
#define Z_UNICODE_KANNADA_DIGIT_FIVE		0x0CEB
#define Z_UNICODE_KANNADA_DIGIT_SIX		0x0CEC
#define Z_UNICODE_KANNADA_DIGIT_SEVEN		0x0CED
#define Z_UNICODE_KANNADA_DIGIT_EIGHT		0x0CEE
#define Z_UNICODE_KANNADA_DIGIT_NINE		0x0CEF
#define Z_UNICODE_KANNADA_SIGN_JIHVAMULIYA	0x0CF1
#define Z_UNICODE_KANNADA_SIGN_UPADHMANIYA	0x0CF2

/* MARK: - 0D00h-0D7Fh - Malayalam */

/* 0D64h <reserved> */
/* 0D65h <reserved> */
#define Z_UNICODE_MALAYALAM_SIGN_CANDRABINDU	    0x0D01
#define Z_UNICODE_MALAYALAM_SIGN_ANUSVARA	    0x0D02
#define Z_UNICODE_MALAYALAM_SIGN_VISARGA	    0x0D03
#define Z_UNICODE_MALAYALAM_LETTER_A		    0x0D05
#define Z_UNICODE_MALAYALAM_LETTER_AA		    0x0D06
#define Z_UNICODE_MALAYALAM_LETTER_I		    0x0D07
#define Z_UNICODE_MALAYALAM_LETTER_II		    0x0D08
#define Z_UNICODE_MALAYALAM_LETTER_U		    0x0D09
#define Z_UNICODE_MALAYALAM_LETTER_UU		    0x0D0A
#define Z_UNICODE_MALAYALAM_LETTER_VOCALIC_R	    0x0D0B
#define Z_UNICODE_MALAYALAM_LETTER_VOCALIC_L	    0x0D0C
#define Z_UNICODE_MALAYALAM_LETTER_E		    0x0D0E
#define Z_UNICODE_MALAYALAM_LETTER_EE		    0x0D0F
#define Z_UNICODE_MALAYALAM_LETTER_AI		    0x0D10
#define Z_UNICODE_MALAYALAM_LETTER_O		    0x0D12
#define Z_UNICODE_MALAYALAM_LETTER_OO		    0x0D13
#define Z_UNICODE_MALAYALAM_LETTER_AU		    0x0D14
#define Z_UNICODE_MALAYALAM_LETTER_KA		    0x0D15
#define Z_UNICODE_MALAYALAM_LETTER_KHA		    0x0D16
#define Z_UNICODE_MALAYALAM_LETTER_GA		    0x0D17
#define Z_UNICODE_MALAYALAM_LETTER_GHA		    0x0D18
#define Z_UNICODE_MALAYALAM_LETTER_NGA		    0x0D19
#define Z_UNICODE_MALAYALAM_LETTER_CA		    0x0D1A
#define Z_UNICODE_MALAYALAM_LETTER_CHA		    0x0D1B
#define Z_UNICODE_MALAYALAM_LETTER_JA		    0x0D1C
#define Z_UNICODE_MALAYALAM_LETTER_JHA		    0x0D1D
#define Z_UNICODE_MALAYALAM_LETTER_NYA		    0x0D1E
#define Z_UNICODE_MALAYALAM_LETTER_TTA		    0x0D1F
#define Z_UNICODE_MALAYALAM_LETTER_TTHA		    0x0D20
#define Z_UNICODE_MALAYALAM_LETTER_DDA		    0x0D21
#define Z_UNICODE_MALAYALAM_LETTER_DDHA		    0x0D22
#define Z_UNICODE_MALAYALAM_LETTER_NNA		    0x0D23
#define Z_UNICODE_MALAYALAM_LETTER_TA		    0x0D24
#define Z_UNICODE_MALAYALAM_LETTER_THA		    0x0D25
#define Z_UNICODE_MALAYALAM_LETTER_DA		    0x0D26
#define Z_UNICODE_MALAYALAM_LETTER_DHA		    0x0D27
#define Z_UNICODE_MALAYALAM_LETTER_NA		    0x0D28
#define Z_UNICODE_MALAYALAM_LETTER_NNNA		    0x0D29
#define Z_UNICODE_MALAYALAM_LETTER_PA		    0x0D2A
#define Z_UNICODE_MALAYALAM_LETTER_PHA		    0x0D2B
#define Z_UNICODE_MALAYALAM_LETTER_BA		    0x0D2C
#define Z_UNICODE_MALAYALAM_LETTER_BHA		    0x0D2D
#define Z_UNICODE_MALAYALAM_LETTER_MA		    0x0D2E
#define Z_UNICODE_MALAYALAM_LETTER_YA		    0x0D2F
#define Z_UNICODE_MALAYALAM_LETTER_RA		    0x0D30
#define Z_UNICODE_MALAYALAM_LETTER_RRA		    0x0D31
#define Z_UNICODE_MALAYALAM_LETTER_LA		    0x0D32
#define Z_UNICODE_MALAYALAM_LETTER_LLA		    0x0D33
#define Z_UNICODE_MALAYALAM_LETTER_LLLA		    0x0D34
#define Z_UNICODE_MALAYALAM_LETTER_VA		    0x0D35
#define Z_UNICODE_MALAYALAM_LETTER_SHA		    0x0D36
#define Z_UNICODE_MALAYALAM_LETTER_SSA		    0x0D37
#define Z_UNICODE_MALAYALAM_LETTER_SA		    0x0D38
#define Z_UNICODE_MALAYALAM_LETTER_HA		    0x0D39
#define Z_UNICODE_MALAYALAM_LETTER_TTTA		    0x0D3A
#define Z_UNICODE_MALAYALAM_SIGN_AVAGRAHA	    0x0D3D
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_AA	    0x0D3E
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_I	    0x0D3F
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_II	    0x0D40
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_U	    0x0D41
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_UU	    0x0D42
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_VOCALIC_R    0x0D43
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_VOCALIC_RR   0x0D44
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_E	    0x0D46
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_EE	    0x0D47
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_AI	    0x0D48
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_O	    0x0D4A
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_OO	    0x0D4B
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_AU	    0x0D4C
#define Z_UNICODE_MALAYALAM_SIGN_VIRAMA		    0x0D4D
#define Z_UNICODE_MALAYALAM_LETTER_DOT_REPH	    0x0D4E
#define Z_UNICODE_MALAYALAM_AU_LENGTH_MARK	    0x0D57
#define Z_UNICODE_MALAYALAM_LETTER_ARCHAIC_II	    0x0D5F
#define Z_UNICODE_MALAYALAM_LETTER_VOCALIC_RR	    0x0D60
#define Z_UNICODE_MALAYALAM_LETTER_VOCALIC_LL	    0x0D61
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_VOCALIC_L    0x0D62
#define Z_UNICODE_MALAYALAM_VOWEL_SIGN_VOCALIC_LL   0x0D63
#define Z_UNICODE_MALAYALAM_DIGIT_ZERO		    0x0D66
#define Z_UNICODE_MALAYALAM_DIGIT_ONE		    0x0D67
#define Z_UNICODE_MALAYALAM_DIGIT_TWO		    0x0D68
#define Z_UNICODE_MALAYALAM_DIGIT_THREE		    0x0D69
#define Z_UNICODE_MALAYALAM_DIGIT_FOUR		    0x0D6A
#define Z_UNICODE_MALAYALAM_DIGIT_FIVE		    0x0D6B
#define Z_UNICODE_MALAYALAM_DIGIT_SIX		    0x0D6C
#define Z_UNICODE_MALAYALAM_DIGIT_SEVEN		    0x0D6D
#define Z_UNICODE_MALAYALAM_DIGIT_EIGHT		    0x0D6E
#define Z_UNICODE_MALAYALAM_DIGIT_NINE		    0x0D6F
#define Z_UNICODE_MALAYALAM_NUMBER_TEN		    0x0D70
#define Z_UNICODE_MALAYALAM_NUMBER_ONE_HUNDRED	    0x0D71
#define Z_UNICODE_MALAYALAM_NUMBER_ONE_THOUSAND	    0x0D72
#define Z_UNICODE_MALAYALAM_FRACTION_ONE_QUARTER    0x0D73
#define Z_UNICODE_MALAYALAM_FRACTION_ONE_HALF	    0x0D74
#define Z_UNICODE_MALAYALAM_FRACTION_THREE_QUARTERS 0x0D75
#define Z_UNICODE_MALAYALAM_DATE_MARK		    0x0D79
#define Z_UNICODE_MALAYALAM_LETTER_CHILLU_NN	    0x0D7A
#define Z_UNICODE_MALAYALAM_LETTER_CHILLU_N	    0x0D7B
#define Z_UNICODE_MALAYALAM_LETTER_CHILLU_RR	    0x0D7C
#define Z_UNICODE_MALAYALAM_LETTER_CHILLU_L	    0x0D7D
#define Z_UNICODE_MALAYALAM_LETTER_CHILLU_LL	    0x0D7E
#define Z_UNICODE_MALAYALAM_LETTER_CHILLU_K	    0x0D7F

/* MARK: - 0D80h-0DFFh - Sinhala */

#define Z_UNICODE_SINHALA_SIGN_ANUSVARAYA			 0x0D82
#define Z_UNICODE_SINHALA_SIGN_VISARGAYA			 0x0D83
#define Z_UNICODE_SINHALA_LETTER_AYANNA				 0x0D85
#define Z_UNICODE_SINHALA_LETTER_AAYANNA			 0x0D86
#define Z_UNICODE_SINHALA_LETTER_AEYANNA			 0x0D87
#define Z_UNICODE_SINHALA_LETTER_AEEYANNA			 0x0D88
#define Z_UNICODE_SINHALA_LETTER_IYANNA				 0x0D89
#define Z_UNICODE_SINHALA_LETTER_IIYANNA			 0x0D8A
#define Z_UNICODE_SINHALA_LETTER_UYANNA				 0x0D8B
#define Z_UNICODE_SINHALA_LETTER_UUYANNA			 0x0D8C
#define Z_UNICODE_SINHALA_LETTER_IRUYANNA			 0x0D8D
#define Z_UNICODE_SINHALA_LETTER_IRUUYANNA			 0x0D8E
#define Z_UNICODE_SINHALA_LETTER_ILUYANNA			 0x0D8F
#define Z_UNICODE_SINHALA_LETTER_ILUUYANNA			 0x0D90
#define Z_UNICODE_SINHALA_LETTER_EYANNA				 0x0D91
#define Z_UNICODE_SINHALA_LETTER_EEYANNA			 0x0D92
#define Z_UNICODE_SINHALA_LETTER_AIYANNA			 0x0D93
#define Z_UNICODE_SINHALA_LETTER_OYANNA				 0x0D94
#define Z_UNICODE_SINHALA_LETTER_OOYANNA			 0x0D95
#define Z_UNICODE_SINHALA_LETTER_AUYANNA			 0x0D96
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_KAYANNA		 0x0D9A
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_KAYANNA		 0x0D9B
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_GAYANNA		 0x0D9C
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_GAYANNA		 0x0D9D
#define Z_UNICODE_SINHALA_LETTER_KANTAJA_NAASIKYAYA		 0x0D9E
#define Z_UNICODE_SINHALA_LETTER_SANYAKA_GAYANNA		 0x0D9F
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_CAYANNA		 0x0DA0
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_CAYANNA		 0x0DA1
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_JAYANNA		 0x0DA2
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_JAYANNA		 0x0DA3
#define Z_UNICODE_SINHALA_LETTER_TAALUJA_NAASIKYAYA		 0x0DA4
#define Z_UNICODE_SINHALA_LETTER_TAALUJA_SANYOOGA_NAAKSIKYAYA	 0x0DA5
#define Z_UNICODE_SINHALA_LETTER_SANYAKA_JAYANNA		 0x0DA6
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_TTAYANNA		 0x0DA7
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_TTAYANNA		 0x0DA8
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_DDAYANNA		 0x0DA9
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_DDAYANNA		 0x0DAA
#define Z_UNICODE_SINHALA_LETTER_MUURDHAJA_NAYANNA		 0x0DAB
#define Z_UNICODE_SINHALA_LETTER_SANYAKA_DDAYANNA		 0x0DAC
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_TAYANNA		 0x0DAD
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_TAYANNA		 0x0DAE
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_DAYANNA		 0x0DAF
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_DAYANNA		 0x0DB0
#define Z_UNICODE_SINHALA_LETTER_DANTAJA_NAYANNA		 0x0DB1
#define Z_UNICODE_SINHALA_LETTER_SANYAKA_DAYANNA		 0x0DB3
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_PAYANNA		 0x0DB4
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_PAYANNA		 0x0DB5
#define Z_UNICODE_SINHALA_LETTER_ALPAPRAANA_BAYANNA		 0x0DB6
#define Z_UNICODE_SINHALA_LETTER_MAHAAPRAANA_BAYANNA		 0x0DB7
#define Z_UNICODE_SINHALA_LETTER_MAYANNA			 0x0DB8
#define Z_UNICODE_SINHALA_LETTER_AMBA_BAYANNA			 0x0DB9
#define Z_UNICODE_SINHALA_LETTER_YAYANNA			 0x0DBA
#define Z_UNICODE_SINHALA_LETTER_RAYANNA			 0x0DBB
#define Z_UNICODE_SINHALA_LETTER_DANTAJA_LAYANNA		 0x0DBD
#define Z_UNICODE_SINHALA_LETTER_VAYANNA			 0x0DC0
#define Z_UNICODE_SINHALA_LETTER_TAALUJA_SAYANNA		 0x0DC1
#define Z_UNICODE_SINHALA_LETTER_MUURDHAJA_SAYANNA		 0x0DC2
#define Z_UNICODE_SINHALA_LETTER_DANTAJA_SAYANNA		 0x0DC3
#define Z_UNICODE_SINHALA_LETTER_HAYANNA			 0x0DC4
#define Z_UNICODE_SINHALA_LETTER_MUURDHAJA_LAYANNA		 0x0DC5
#define Z_UNICODE_SINHALA_LETTER_FAYANNA			 0x0DC6
#define Z_UNICODE_SINHALA_SIGN_AL_LAKUNA			 0x0DCA
#define Z_UNICODE_SINHALA_VOWEL_SIGN_AELA_PILLA			 0x0DCF
#define Z_UNICODE_SINHALA_VOWEL_SIGN_KETTI_AEDA_PILLA		 0x0DD0
#define Z_UNICODE_SINHALA_VOWEL_SIGN_DIGA_AEDA_PILLA		 0x0DD1
#define Z_UNICODE_SINHALA_VOWEL_SIGN_KETTI_IS_PILLA		 0x0DD2
#define Z_UNICODE_SINHALA_VOWEL_SIGN_DIGA_IS_PILLA		 0x0DD3
#define Z_UNICODE_SINHALA_VOWEL_SIGN_KETTI_PAA_PILLA		 0x0DD4
#define Z_UNICODE_SINHALA_VOWEL_SIGN_DIGA_PAA_PILLA		 0x0DD6
#define Z_UNICODE_SINHALA_VOWEL_SIGN_GAETTA_PILLA		 0x0DD8
#define Z_UNICODE_SINHALA_VOWEL_SIGN_KOMBUVA			 0x0DD9
#define Z_UNICODE_SINHALA_VOWEL_SIGN_DIGA_KOMBUVA		 0x0DDA
#define Z_UNICODE_SINHALA_VOWEL_SIGN_KOMBU_DEKA			 0x0DDB
#define Z_UNICODE_SINHALA_VOWEL_SIGN_KOMBUVA_HAA_AELA_PILLA	 0x0DDC
#define Z_UNICODE_SINHALA_VOWEL_SIGN_KOMBUVA_HAA_DIGA_AELA_PILLA 0x0DDD
#define Z_UNICODE_SINHALA_VOWEL_SIGN_KOMBUVA_HAA_GAYANUKITTA	 0x0DDE
#define Z_UNICODE_SINHALA_VOWEL_SIGN_GAYANUKITTA		 0x0DDF
#define Z_UNICODE_SINHALA_LITH_DIGIT_ZERO			 0x0DE6
#define Z_UNICODE_SINHALA_LITH_DIGIT_ONE			 0x0DE7
#define Z_UNICODE_SINHALA_LITH_DIGIT_TWO			 0x0DE8
#define Z_UNICODE_SINHALA_LITH_DIGIT_THREE			 0x0DE9
#define Z_UNICODE_SINHALA_LITH_DIGIT_FOUR			 0x0DEA
#define Z_UNICODE_SINHALA_LITH_DIGIT_FIVE			 0x0DEB
#define Z_UNICODE_SINHALA_LITH_DIGIT_SIX			 0x0DEC
#define Z_UNICODE_SINHALA_LITH_DIGIT_SEVEN			 0x0DED
#define Z_UNICODE_SINHALA_LITH_DIGIT_EIGHT			 0x0DEE
#define Z_UNICODE_SINHALA_LITH_DIGIT_NINE			 0x0DEF
#define Z_UNICODE_SINHALA_VOWEL_SIGN_DIGA_GAETTA_PILLA		 0x0DF2
#define Z_UNICODE_SINHALA_VOWEL_SIGN_DIGA_GAYANUKITTA		 0x0DF3
#define Z_UNICODE_SINHALA_PUNCTUATION_KUNDDALIYA		 0x0DF4

/* MARK: - 0E00h-0E7Fh - Thai */

#define Z_UNICODE_THAI_CHARACTER_KO_KAI		  0x0E01
#define Z_UNICODE_THAI_CHARACTER_KHO_KHAI	  0x0E02
#define Z_UNICODE_THAI_CHARACTER_KHO_KHUAT	  0x0E03
#define Z_UNICODE_THAI_CHARACTER_KHO_KHWAI	  0x0E04
#define Z_UNICODE_THAI_CHARACTER_KHO_KHON	  0x0E05
#define Z_UNICODE_THAI_CHARACTER_KHO_RAKHANG	  0x0E06
#define Z_UNICODE_THAI_CHARACTER_NGO_NGU	  0x0E07
#define Z_UNICODE_THAI_CHARACTER_CHO_CHAN	  0x0E08
#define Z_UNICODE_THAI_CHARACTER_CHO_CHING	  0x0E09
#define Z_UNICODE_THAI_CHARACTER_CHO_CHANG	  0x0E0A
#define Z_UNICODE_THAI_CHARACTER_SO_SO		  0x0E0B
#define Z_UNICODE_THAI_CHARACTER_CHO_CHOE	  0x0E0C
#define Z_UNICODE_THAI_CHARACTER_YO_YING	  0x0E0D
#define Z_UNICODE_THAI_CHARACTER_DO_CHADA	  0x0E0E
#define Z_UNICODE_THAI_CHARACTER_TO_PATAK	  0x0E0F
#define Z_UNICODE_THAI_CHARACTER_THO_THAN	  0x0E10
#define Z_UNICODE_THAI_CHARACTER_THO_NANGMONTHO	  0x0E11
#define Z_UNICODE_THAI_CHARACTER_THO_PHUTHAO	  0x0E12
#define Z_UNICODE_THAI_CHARACTER_NO_NEN		  0x0E13
#define Z_UNICODE_THAI_CHARACTER_DO_DEK		  0x0E14
#define Z_UNICODE_THAI_CHARACTER_TO_TAO		  0x0E15
#define Z_UNICODE_THAI_CHARACTER_THO_THUNG	  0x0E16
#define Z_UNICODE_THAI_CHARACTER_THO_THAHAN	  0x0E17
#define Z_UNICODE_THAI_CHARACTER_THO_THONG	  0x0E18
#define Z_UNICODE_THAI_CHARACTER_NO_NU		  0x0E19
#define Z_UNICODE_THAI_CHARACTER_BO_BAIMAI	  0x0E1A
#define Z_UNICODE_THAI_CHARACTER_PO_PLA		  0x0E1B
#define Z_UNICODE_THAI_CHARACTER_PHO_PHUNG	  0x0E1C
#define Z_UNICODE_THAI_CHARACTER_FO_FA		  0x0E1D
#define Z_UNICODE_THAI_CHARACTER_PHO_PHAN	  0x0E1E
#define Z_UNICODE_THAI_CHARACTER_FO_FAN		  0x0E1F
#define Z_UNICODE_THAI_CHARACTER_PHO_SAMPHAO	  0x0E20
#define Z_UNICODE_THAI_CHARACTER_MO_MA		  0x0E21
#define Z_UNICODE_THAI_CHARACTER_YO_YAK		  0x0E22
#define Z_UNICODE_THAI_CHARACTER_RO_RUA		  0x0E23
#define Z_UNICODE_THAI_CHARACTER_RU		  0x0E24
#define Z_UNICODE_THAI_CHARACTER_LO_LING	  0x0E25
#define Z_UNICODE_THAI_CHARACTER_LU		  0x0E26
#define Z_UNICODE_THAI_CHARACTER_WO_WAEN	  0x0E27
#define Z_UNICODE_THAI_CHARACTER_SO_SALA	  0x0E28
#define Z_UNICODE_THAI_CHARACTER_SO_RUSI	  0x0E29
#define Z_UNICODE_THAI_CHARACTER_SO_SUA		  0x0E2A
#define Z_UNICODE_THAI_CHARACTER_HO_HIP		  0x0E2B
#define Z_UNICODE_THAI_CHARACTER_LO_CHULA	  0x0E2C
#define Z_UNICODE_THAI_CHARACTER_O_ANG		  0x0E2D
#define Z_UNICODE_THAI_CHARACTER_HO_NOKHUK	  0x0E2E
#define Z_UNICODE_THAI_CHARACTER_PAIYANNOI	  0x0E2F
#define Z_UNICODE_THAI_CHARACTER_SARA_A		  0x0E30
#define Z_UNICODE_THAI_CHARACTER_MAI_HAN_AKAT	  0x0E31
#define Z_UNICODE_THAI_CHARACTER_SARA_AA	  0x0E32
#define Z_UNICODE_THAI_CHARACTER_SARA_AM	  0x0E33
#define Z_UNICODE_THAI_CHARACTER_SARA_I		  0x0E34
#define Z_UNICODE_THAI_CHARACTER_SARA_II	  0x0E35
#define Z_UNICODE_THAI_CHARACTER_SARA_UE	  0x0E36
#define Z_UNICODE_THAI_CHARACTER_SARA_UEE	  0x0E37
#define Z_UNICODE_THAI_CHARACTER_SARA_U		  0x0E38
#define Z_UNICODE_THAI_CHARACTER_SARA_UU	  0x0E39
#define Z_UNICODE_THAI_CHARACTER_PHINTHU	  0x0E3A
#define Z_UNICODE_THAI_CURRENCY_SYMBOL_BAHT	  0x0E3F
#define Z_UNICODE_THAI_CHARACTER_SARA_E		  0x0E40
#define Z_UNICODE_THAI_CHARACTER_SARA_AE	  0x0E41
#define Z_UNICODE_THAI_CHARACTER_SARA_O		  0x0E42
#define Z_UNICODE_THAI_CHARACTER_SARA_AI_MAIMUAN  0x0E43
#define Z_UNICODE_THAI_CHARACTER_SARA_AI_MAIMALAI 0x0E44
#define Z_UNICODE_THAI_CHARACTER_LAKKHANGYAO	  0x0E45
#define Z_UNICODE_THAI_CHARACTER_MAIYAMOK	  0x0E46
#define Z_UNICODE_THAI_CHARACTER_MAITAIKHU	  0x0E47
#define Z_UNICODE_THAI_CHARACTER_MAI_EK		  0x0E48
#define Z_UNICODE_THAI_CHARACTER_MAI_THO	  0x0E49
#define Z_UNICODE_THAI_CHARACTER_MAI_TRI	  0x0E4A
#define Z_UNICODE_THAI_CHARACTER_MAI_CHATTAWA	  0x0E4B
#define Z_UNICODE_THAI_CHARACTER_THANTHAKHAT	  0x0E4C
#define Z_UNICODE_THAI_CHARACTER_NIKHAHIT	  0x0E4D
#define Z_UNICODE_THAI_CHARACTER_YAMAKKAN	  0x0E4E
#define Z_UNICODE_THAI_CHARACTER_FONGMAN	  0x0E4F
#define Z_UNICODE_THAI_DIGIT_ZERO		  0x0E50
#define Z_UNICODE_THAI_DIGIT_ONE		  0x0E51
#define Z_UNICODE_THAI_DIGIT_TWO		  0x0E52
#define Z_UNICODE_THAI_DIGIT_THREE		  0x0E53
#define Z_UNICODE_THAI_DIGIT_FOUR		  0x0E54
#define Z_UNICODE_THAI_DIGIT_FIVE		  0x0E55
#define Z_UNICODE_THAI_DIGIT_SIX		  0x0E56
#define Z_UNICODE_THAI_DIGIT_SEVEN		  0x0E57
#define Z_UNICODE_THAI_DIGIT_EIGHT		  0x0E58
#define Z_UNICODE_THAI_DIGIT_NINE		  0x0E59
#define Z_UNICODE_THAI_CHARACTER_ANGKHANKHU	  0x0E5A
#define Z_UNICODE_THAI_CHARACTER_KHOMUT		  0x0E5B

/* MARK: - 0E80h-0EFFh - Lao */

#define Z_UNICODE_LAO_LETTER_KO		 0x0E81
#define Z_UNICODE_LAO_LETTER_KHO_SUNG	 0x0E82
#define Z_UNICODE_LAO_LETTER_KHO_TAM	 0x0E84
#define Z_UNICODE_LAO_LETTER_NGO	 0x0E87
#define Z_UNICODE_LAO_LETTER_CO		 0x0E88
#define Z_UNICODE_LAO_LETTER_SO_TAM	 0x0E8A
#define Z_UNICODE_LAO_LETTER_NYO	 0x0E8D
#define Z_UNICODE_LAO_LETTER_DO		 0x0E94
#define Z_UNICODE_LAO_LETTER_TO		 0x0E95
#define Z_UNICODE_LAO_LETTER_THO_SUNG	 0x0E96
#define Z_UNICODE_LAO_LETTER_THO_TAM	 0x0E97
#define Z_UNICODE_LAO_LETTER_NO		 0x0E99
#define Z_UNICODE_LAO_LETTER_BO		 0x0E9A
#define Z_UNICODE_LAO_LETTER_PO		 0x0E9B
#define Z_UNICODE_LAO_LETTER_PHO_SUNG	 0x0E9C
#define Z_UNICODE_LAO_LETTER_FO_TAM	 0x0E9D
#define Z_UNICODE_LAO_LETTER_PHO_TAM	 0x0E9E
#define Z_UNICODE_LAO_LETTER_FO_SUNG	 0x0E9F
#define Z_UNICODE_LAO_LETTER_MO		 0x0EA1
#define Z_UNICODE_LAO_LETTER_YO		 0x0EA2
#define Z_UNICODE_LAO_LETTER_LO_LING	 0x0EA3
#define Z_UNICODE_LAO_LETTER_LO_LOOT	 0x0EA5
#define Z_UNICODE_LAO_LETTER_WO		 0x0EA7
#define Z_UNICODE_LAO_LETTER_SO_SUNG	 0x0EAA
#define Z_UNICODE_LAO_LETTER_HO_SUNG	 0x0EAB
#define Z_UNICODE_LAO_LETTER_O		 0x0EAD
#define Z_UNICODE_LAO_LETTER_HO_TAM	 0x0EAE
#define Z_UNICODE_LAO_ELLIPSIS		 0x0EAF
#define Z_UNICODE_LAO_VOWEL_SIGN_A	 0x0EB0
#define Z_UNICODE_LAO_VOWEL_SIGN_MAI_KAN 0x0EB1
#define Z_UNICODE_LAO_VOWEL_SIGN_AA	 0x0EB2
#define Z_UNICODE_LAO_VOWEL_SIGN_AM	 0x0EB3
#define Z_UNICODE_LAO_VOWEL_SIGN_I	 0x0EB4
#define Z_UNICODE_LAO_VOWEL_SIGN_II	 0x0EB5
#define Z_UNICODE_LAO_VOWEL_SIGN_Y	 0x0EB6
#define Z_UNICODE_LAO_VOWEL_SIGN_YY	 0x0EB7
#define Z_UNICODE_LAO_VOWEL_SIGN_U	 0x0EB8
#define Z_UNICODE_LAO_VOWEL_SIGN_UU	 0x0EB9
#define Z_UNICODE_LAO_VOWEL_SIGN_MAI_KON 0x0EBB
#define Z_UNICODE_LAO_SEMIVOWEL_SIGN_LO	 0x0EBC
#define Z_UNICODE_LAO_SEMIVOWEL_SIGN_NYO 0x0EBD
#define Z_UNICODE_LAO_VOWEL_SIGN_E	 0x0EC0
#define Z_UNICODE_LAO_VOWEL_SIGN_EI	 0x0EC1
#define Z_UNICODE_LAO_VOWEL_SIGN_O	 0x0EC2
#define Z_UNICODE_LAO_VOWEL_SIGN_AY	 0x0EC3
#define Z_UNICODE_LAO_VOWEL_SIGN_AI	 0x0EC4
#define Z_UNICODE_LAO_KO_LA		 0x0EC6
#define Z_UNICODE_LAO_TONE_MAI_EK	 0x0EC8
#define Z_UNICODE_LAO_TONE_MAI_THO	 0x0EC9
#define Z_UNICODE_LAO_TONE_MAI_TI	 0x0ECA
#define Z_UNICODE_LAO_TONE_MAI_CATAWA	 0x0ECB
#define Z_UNICODE_LAO_CANCELLATION_MARK	 0x0ECC
#define Z_UNICODE_LAO_NIGGAHITA		 0x0ECD
#define Z_UNICODE_LAO_DIGIT_ZERO	 0x0ED0
#define Z_UNICODE_LAO_DIGIT_ONE		 0x0ED1
#define Z_UNICODE_LAO_DIGIT_TWO		 0x0ED2
#define Z_UNICODE_LAO_DIGIT_THREE	 0x0ED3
#define Z_UNICODE_LAO_DIGIT_FOUR	 0x0ED4
#define Z_UNICODE_LAO_DIGIT_FIVE	 0x0ED5
#define Z_UNICODE_LAO_DIGIT_SIX		 0x0ED6
#define Z_UNICODE_LAO_DIGIT_SEVEN	 0x0ED7
#define Z_UNICODE_LAO_DIGIT_EIGHT	 0x0ED8
#define Z_UNICODE_LAO_DIGIT_NINE	 0x0ED9
#define Z_UNICODE_LAO_HO_NO		 0x0EDC
#define Z_UNICODE_LAO_HO_MO		 0x0EDD
#define Z_UNICODE_LAO_LETTER_KHMU_GO	 0x0EDE
#define Z_UNICODE_LAO_LETTER_KHMU_NYO	 0x0EDF

/* MARK: - 0F00h-0FFFh - Tibetan */

#define Z_UNICODE_TIBETAN_SYLLABLE_OM				   0x0F00
#define Z_UNICODE_TIBETAN_MARK_GTER_YIG_MGO_TRUNCATED_A		   0x0F01
#define Z_UNICODE_TIBETAN_MARK_GTER_YIG_MGO__UM_RNAM_BCAD_MA	   0x0F02
#define Z_UNICODE_TIBETAN_MARK_GTER_YIG_MGO__UM_GTER_TSHEG_MA	   0x0F03
#define Z_UNICODE_TIBETAN_MARK_INITIAL_YIG_MGO_MDUN_MA		   0x0F04
#define Z_UNICODE_TIBETAN_MARK_CLOSING_YIG_MGO_SGAB_MA		   0x0F05
#define Z_UNICODE_TIBETAN_MARK_CARET_YIG_MGO_PHUR_SHAD_MA	   0x0F06
#define Z_UNICODE_TIBETAN_MARK_YIG_MGO_TSHEG_SHAD_MA		   0x0F07
#define Z_UNICODE_TIBETAN_MARK_SBRUL_SHAD			   0x0F08
#define Z_UNICODE_TIBETAN_MARK_BSKUR_YIG_MGO			   0x0F09
#define Z_UNICODE_TIBETAN_MARK_BKA__SHOG_YIG_MGO		   0x0F0A
#define Z_UNICODE_TIBETAN_MARK_INTERSYLLABIC_TSHEG		   0x0F0B
#define Z_UNICODE_TIBETAN_MARK_DELIMITER_TSHEG_BSTAR		   0x0F0C
#define Z_UNICODE_TIBETAN_MARK_SHAD				   0x0F0D
#define Z_UNICODE_TIBETAN_MARK_NYIS_SHAD			   0x0F0E
#define Z_UNICODE_TIBETAN_MARK_TSHEG_SHAD			   0x0F0F
#define Z_UNICODE_TIBETAN_MARK_NYIS_TSHEG_SHAD			   0x0F10
#define Z_UNICODE_TIBETAN_MARK_RIN_CHEN_SPUNGS_SHAD		   0x0F11
#define Z_UNICODE_TIBETAN_MARK_RGYA_GRAM_SHAD			   0x0F12
#define Z_UNICODE_TIBETAN_MARK_CARET__DZUD_RTAGS_ME_LONG_CAN	   0x0F13
#define Z_UNICODE_TIBETAN_MARK_GTER_TSHEG			   0x0F14
#define Z_UNICODE_TIBETAN_LOGOTYPE_SIGN_CHAD_RTAGS		   0x0F15
#define Z_UNICODE_TIBETAN_LOGOTYPE_SIGN_LHAG_RTAGS		   0x0F16
#define Z_UNICODE_TIBETAN_ASTROLOGICAL_SIGN_SGRA_GCAN__CHAR_RTAGS  0x0F17
#define Z_UNICODE_TIBETAN_ASTROLOGICAL_SIGN__KHYUD_PA		   0x0F18
#define Z_UNICODE_TIBETAN_ASTROLOGICAL_SIGN_SDONG_TSHUGS	   0x0F19
#define Z_UNICODE_TIBETAN_SIGN_RDEL_DKAR_GCIG			   0x0F1A
#define Z_UNICODE_TIBETAN_SIGN_RDEL_DKAR_GNYIS			   0x0F1B
#define Z_UNICODE_TIBETAN_SIGN_RDEL_DKAR_GSUM			   0x0F1C
#define Z_UNICODE_TIBETAN_SIGN_RDEL_NAG_GCIG			   0x0F1D
#define Z_UNICODE_TIBETAN_SIGN_RDEL_NAG_GNYIS			   0x0F1E
#define Z_UNICODE_TIBETAN_SIGN_RDEL_DKAR_RDEL_NAG		   0x0F1F
#define Z_UNICODE_TIBETAN_DIGIT_ZERO				   0x0F20
#define Z_UNICODE_TIBETAN_DIGIT_ONE				   0x0F21
#define Z_UNICODE_TIBETAN_DIGIT_TWO				   0x0F22
#define Z_UNICODE_TIBETAN_DIGIT_THREE				   0x0F23
#define Z_UNICODE_TIBETAN_DIGIT_FOUR				   0x0F24
#define Z_UNICODE_TIBETAN_DIGIT_FIVE				   0x0F25
#define Z_UNICODE_TIBETAN_DIGIT_SIX				   0x0F26
#define Z_UNICODE_TIBETAN_DIGIT_SEVEN				   0x0F27
#define Z_UNICODE_TIBETAN_DIGIT_EIGHT				   0x0F28
#define Z_UNICODE_TIBETAN_DIGIT_NINE				   0x0F29
#define Z_UNICODE_TIBETAN_DIGIT_HALF_ONE			   0x0F2A
#define Z_UNICODE_TIBETAN_DIGIT_HALF_TWO			   0x0F2B
#define Z_UNICODE_TIBETAN_DIGIT_HALF_THREE			   0x0F2C
#define Z_UNICODE_TIBETAN_DIGIT_HALF_FOUR			   0x0F2D
#define Z_UNICODE_TIBETAN_DIGIT_HALF_FIVE			   0x0F2E
#define Z_UNICODE_TIBETAN_DIGIT_HALF_SIX			   0x0F2F
#define Z_UNICODE_TIBETAN_DIGIT_HALF_SEVEN			   0x0F30
#define Z_UNICODE_TIBETAN_DIGIT_HALF_EIGHT			   0x0F31
#define Z_UNICODE_TIBETAN_DIGIT_HALF_NINE			   0x0F32
#define Z_UNICODE_TIBETAN_DIGIT_HALF_ZERO			   0x0F33
#define Z_UNICODE_TIBETAN_MARK_BSDUS_RTAGS			   0x0F34
#define Z_UNICODE_TIBETAN_MARK_NGAS_BZUNG_NYI_ZLA		   0x0F35
#define Z_UNICODE_TIBETAN_MARK_CARET__DZUD_RTAGS_BZHI_MIG_CAN	   0x0F36
#define Z_UNICODE_TIBETAN_MARK_NGAS_BZUNG_SGOR_RTAGS		   0x0F37
#define Z_UNICODE_TIBETAN_MARK_CHE_MGO				   0x0F38
#define Z_UNICODE_TIBETAN_MARK_TSA__PHRU			   0x0F39
#define Z_UNICODE_TIBETAN_MARK_GUG_RTAGS_GYON			   0x0F3A
#define Z_UNICODE_TIBETAN_MARK_GUG_RTAGS_GYAS			   0x0F3B
#define Z_UNICODE_TIBETAN_MARK_ANG_KHANG_GYON			   0x0F3C
#define Z_UNICODE_TIBETAN_MARK_ANG_KHANG_GYAS			   0x0F3D
#define Z_UNICODE_TIBETAN_SIGN_YAR_TSHES			   0x0F3E
#define Z_UNICODE_TIBETAN_SIGN_MAR_TSHES			   0x0F3F
#define Z_UNICODE_TIBETAN_LETTER_KA				   0x0F40
#define Z_UNICODE_TIBETAN_LETTER_KHA				   0x0F41
#define Z_UNICODE_TIBETAN_LETTER_GA				   0x0F42
#define Z_UNICODE_TIBETAN_LETTER_GHA				   0x0F43
#define Z_UNICODE_TIBETAN_LETTER_NGA				   0x0F44
#define Z_UNICODE_TIBETAN_LETTER_CA				   0x0F45
#define Z_UNICODE_TIBETAN_LETTER_CHA				   0x0F46
#define Z_UNICODE_TIBETAN_LETTER_JA				   0x0F47
#define Z_UNICODE_TIBETAN_LETTER_NYA				   0x0F49
#define Z_UNICODE_TIBETAN_LETTER_TTA				   0x0F4A
#define Z_UNICODE_TIBETAN_LETTER_TTHA				   0x0F4B
#define Z_UNICODE_TIBETAN_LETTER_DDA				   0x0F4C
#define Z_UNICODE_TIBETAN_LETTER_DDHA				   0x0F4D
#define Z_UNICODE_TIBETAN_LETTER_NNA				   0x0F4E
#define Z_UNICODE_TIBETAN_LETTER_TA				   0x0F4F
#define Z_UNICODE_TIBETAN_LETTER_THA				   0x0F50
#define Z_UNICODE_TIBETAN_LETTER_DA				   0x0F51
#define Z_UNICODE_TIBETAN_LETTER_DHA				   0x0F52
#define Z_UNICODE_TIBETAN_LETTER_NA				   0x0F53
#define Z_UNICODE_TIBETAN_LETTER_PA				   0x0F54
#define Z_UNICODE_TIBETAN_LETTER_PHA				   0x0F55
#define Z_UNICODE_TIBETAN_LETTER_BA				   0x0F56
#define Z_UNICODE_TIBETAN_LETTER_BHA				   0x0F57
#define Z_UNICODE_TIBETAN_LETTER_MA				   0x0F58
#define Z_UNICODE_TIBETAN_LETTER_TSA				   0x0F59
#define Z_UNICODE_TIBETAN_LETTER_TSHA				   0x0F5A
#define Z_UNICODE_TIBETAN_LETTER_DZA				   0x0F5B
#define Z_UNICODE_TIBETAN_LETTER_DZHA				   0x0F5C
#define Z_UNICODE_TIBETAN_LETTER_WA				   0x0F5D
#define Z_UNICODE_TIBETAN_LETTER_ZHA				   0x0F5E
#define Z_UNICODE_TIBETAN_LETTER_ZA				   0x0F5F
#define Z_UNICODE_TIBETAN_LETTER__A				   0x0F60
#define Z_UNICODE_TIBETAN_LETTER_YA				   0x0F61
#define Z_UNICODE_TIBETAN_LETTER_RA				   0x0F62
#define Z_UNICODE_TIBETAN_LETTER_LA				   0x0F63
#define Z_UNICODE_TIBETAN_LETTER_SHA				   0x0F64
#define Z_UNICODE_TIBETAN_LETTER_SSA				   0x0F65
#define Z_UNICODE_TIBETAN_LETTER_SA				   0x0F66
#define Z_UNICODE_TIBETAN_LETTER_HA				   0x0F67
#define Z_UNICODE_TIBETAN_LETTER_A				   0x0F68
#define Z_UNICODE_TIBETAN_LETTER_KSSA				   0x0F69
#define Z_UNICODE_TIBETAN_LETTER_FIXED_FORM_RA			   0x0F6A
#define Z_UNICODE_TIBETAN_LETTER_KKA				   0x0F6B
#define Z_UNICODE_TIBETAN_LETTER_RRA				   0x0F6C
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_AA				   0x0F71
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_I				   0x0F72
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_II				   0x0F73
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_U				   0x0F74
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_UU				   0x0F75
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_VOCALIC_R			   0x0F76
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_VOCALIC_RR			   0x0F77
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_VOCALIC_L			   0x0F78
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_VOCALIC_LL			   0x0F79
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_E				   0x0F7A
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_EE				   0x0F7B
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_O				   0x0F7C
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_OO				   0x0F7D
#define Z_UNICODE_TIBETAN_SIGN_RJES_SU_NGA_RO			   0x0F7E
#define Z_UNICODE_TIBETAN_SIGN_RNAM_BCAD			   0x0F7F
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_REVERSED_I			   0x0F80
#define Z_UNICODE_TIBETAN_VOWEL_SIGN_REVERSED_II		   0x0F81
#define Z_UNICODE_TIBETAN_SIGN_NYI_ZLA_NAA_DA			   0x0F82
#define Z_UNICODE_TIBETAN_SIGN_SNA_LDAN				   0x0F83
#define Z_UNICODE_TIBETAN_MARK_HALANTA				   0x0F84
#define Z_UNICODE_TIBETAN_MARK_PALUTA				   0x0F85
#define Z_UNICODE_TIBETAN_SIGN_LCI_RTAGS			   0x0F86
#define Z_UNICODE_TIBETAN_SIGN_YANG_RTAGS			   0x0F87
#define Z_UNICODE_TIBETAN_SIGN_LCE_TSA_CAN			   0x0F88
#define Z_UNICODE_TIBETAN_SIGN_MCHU_CAN				   0x0F89
#define Z_UNICODE_TIBETAN_SIGN_GRU_CAN_RGYINGS			   0x0F8A
#define Z_UNICODE_TIBETAN_SIGN_GRU_MED_RGYINGS			   0x0F8B
#define Z_UNICODE_TIBETAN_SIGN_INVERTED_MCHU_CAN		   0x0F8C
#define Z_UNICODE_TIBETAN_SUBJOINED_SIGN_LCE_TSA_CAN		   0x0F8D
#define Z_UNICODE_TIBETAN_SUBJOINED_SIGN_MCHU_CAN		   0x0F8E
#define Z_UNICODE_TIBETAN_SUBJOINED_SIGN_INVERTED_MCHU_CAN	   0x0F8F
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_KA			   0x0F90
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_KHA			   0x0F91
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_GA			   0x0F92
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_GHA			   0x0F93
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_NGA			   0x0F94
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_CA			   0x0F95
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_CHA			   0x0F96
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_JA			   0x0F97
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_NYA			   0x0F99
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_TTA			   0x0F9A
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_TTHA			   0x0F9B
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_DDA			   0x0F9C
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_DDHA			   0x0F9D
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_NNA			   0x0F9E
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_TA			   0x0F9F
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_THA			   0x0FA0
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_DA			   0x0FA1
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_DHA			   0x0FA2
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_NA			   0x0FA3
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_PA			   0x0FA4
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_PHA			   0x0FA5
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_BA			   0x0FA6
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_BHA			   0x0FA7
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_MA			   0x0FA8
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_TSA			   0x0FA9
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_TSHA			   0x0FAA
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_DZA			   0x0FAB
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_DZHA			   0x0FAC
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_WA			   0x0FAD
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_ZHA			   0x0FAE
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_ZA			   0x0FAF
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER__A			   0x0FB0
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_YA			   0x0FB1
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_RA			   0x0FB2
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_LA			   0x0FB3
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_SHA			   0x0FB4
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_SSA			   0x0FB5
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_SA			   0x0FB6
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_HA			   0x0FB7
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_A			   0x0FB8
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_KSSA			   0x0FB9
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_FIXED_FORM_WA	   0x0FBA
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_FIXED_FORM_YA	   0x0FBB
#define Z_UNICODE_TIBETAN_SUBJOINED_LETTER_FIXED_FORM_RA	   0x0FBC
#define Z_UNICODE_TIBETAN_KU_RU_KHA				   0x0FBE
#define Z_UNICODE_TIBETAN_KU_RU_KHA_BZHI_MIG_CAN		   0x0FBF
#define Z_UNICODE_TIBETAN_CANTILLATION_SIGN_HEAVY_BEAT		   0x0FC0
#define Z_UNICODE_TIBETAN_CANTILLATION_SIGN_LIGHT_BEAT		   0x0FC1
#define Z_UNICODE_TIBETAN_CANTILLATION_SIGN_CANG_TE_U		   0x0FC2
#define Z_UNICODE_TIBETAN_CANTILLATION_SIGN_SBUB__CHAL		   0x0FC3
#define Z_UNICODE_TIBETAN_SYMBOL_DRIL_BU			   0x0FC4
#define Z_UNICODE_TIBETAN_SYMBOL_RDO_RJE			   0x0FC5
#define Z_UNICODE_TIBETAN_SYMBOL_PADMA_GDAN			   0x0FC6
#define Z_UNICODE_TIBETAN_SYMBOL_RDO_RJE_RGYA_GRAM		   0x0FC7
#define Z_UNICODE_TIBETAN_SYMBOL_PHUR_PA			   0x0FC8
#define Z_UNICODE_TIBETAN_SYMBOL_NOR_BU				   0x0FC9
#define Z_UNICODE_TIBETAN_SYMBOL_NOR_BU_NYIS__KHYIL		   0x0FCA
#define Z_UNICODE_TIBETAN_SYMBOL_NOR_BU_GSUM__KHYIL		   0x0FCB
#define Z_UNICODE_TIBETAN_SYMBOL_NOR_BU_BZHI__KHYIL		   0x0FCC
#define Z_UNICODE_TIBETAN_SIGN_RDEL_NAG_RDEL_DKAR		   0x0FCE
#define Z_UNICODE_TIBETAN_SIGN_RDEL_NAG_GSUM			   0x0FCF
#define Z_UNICODE_TIBETAN_MARK_BSKA__SHOG_GI_MGO_RGYAN		   0x0FD0
#define Z_UNICODE_TIBETAN_MARK_MNYAM_YIG_GI_MGO_RGYAN		   0x0FD1
#define Z_UNICODE_TIBETAN_MARK_NYIS_TSHEG			   0x0FD2
#define Z_UNICODE_TIBETAN_MARK_INITIAL_BRDA_RNYING_YIG_MGO_MDUN_MA 0x0FD3
#define Z_UNICODE_TIBETAN_MARK_CLOSING_BRDA_RNYING_YIG_MGO_SGAB_MA 0x0FD4
#define Z_UNICODE_RIGHT_FACING_SVASTI_SIGN			   0x0FD5
#define Z_UNICODE_LEFT_FACING_SVASTI_SIGN			   0x0FD6
#define Z_UNICODE_RIGHT_FACING_SVASTI_SIGN_WITH_DOTS		   0x0FD7
#define Z_UNICODE_LEFT_FACING_SVASTI_SIGN_WITH_DOTS		   0x0FD8
#define Z_UNICODE_TIBETAN_MARK_LEADING_MCHAN_RTAGS		   0x0FD9
#define Z_UNICODE_TIBETAN_MARK_TRAILING_MCHAN_RTAGS		   0x0FDA

/* MARK: - 1000h-109Fh - Myanmar */

#define Z_UNICODE_MYANMAR_LETTER_KA			  0x1000
#define Z_UNICODE_MYANMAR_LETTER_KHA			  0x1001
#define Z_UNICODE_MYANMAR_LETTER_GA			  0x1002
#define Z_UNICODE_MYANMAR_LETTER_GHA			  0x1003
#define Z_UNICODE_MYANMAR_LETTER_NGA			  0x1004
#define Z_UNICODE_MYANMAR_LETTER_CA			  0x1005
#define Z_UNICODE_MYANMAR_LETTER_CHA			  0x1006
#define Z_UNICODE_MYANMAR_LETTER_JA			  0x1007
#define Z_UNICODE_MYANMAR_LETTER_JHA			  0x1008
#define Z_UNICODE_MYANMAR_LETTER_NYA			  0x1009
#define Z_UNICODE_MYANMAR_LETTER_NNYA			  0x100A
#define Z_UNICODE_MYANMAR_LETTER_TTA			  0x100B
#define Z_UNICODE_MYANMAR_LETTER_TTHA			  0x100C
#define Z_UNICODE_MYANMAR_LETTER_DDA			  0x100D
#define Z_UNICODE_MYANMAR_LETTER_DDHA			  0x100E
#define Z_UNICODE_MYANMAR_LETTER_NNA			  0x100F
#define Z_UNICODE_MYANMAR_LETTER_TA			  0x1010
#define Z_UNICODE_MYANMAR_LETTER_THA			  0x1011
#define Z_UNICODE_MYANMAR_LETTER_DA			  0x1012
#define Z_UNICODE_MYANMAR_LETTER_DHA			  0x1013
#define Z_UNICODE_MYANMAR_LETTER_NA			  0x1014
#define Z_UNICODE_MYANMAR_LETTER_PA			  0x1015
#define Z_UNICODE_MYANMAR_LETTER_PHA			  0x1016
#define Z_UNICODE_MYANMAR_LETTER_BA			  0x1017
#define Z_UNICODE_MYANMAR_LETTER_BHA			  0x1018
#define Z_UNICODE_MYANMAR_LETTER_MA			  0x1019
#define Z_UNICODE_MYANMAR_LETTER_YA			  0x101A
#define Z_UNICODE_MYANMAR_LETTER_RA			  0x101B
#define Z_UNICODE_MYANMAR_LETTER_LA			  0x101C
#define Z_UNICODE_MYANMAR_LETTER_WA			  0x101D
#define Z_UNICODE_MYANMAR_LETTER_SA			  0x101E
#define Z_UNICODE_MYANMAR_LETTER_HA			  0x101F
#define Z_UNICODE_MYANMAR_LETTER_LLA			  0x1020
#define Z_UNICODE_MYANMAR_LETTER_A			  0x1021
#define Z_UNICODE_MYANMAR_LETTER_SHAN_A			  0x1022
#define Z_UNICODE_MYANMAR_LETTER_I			  0x1023
#define Z_UNICODE_MYANMAR_LETTER_II			  0x1024
#define Z_UNICODE_MYANMAR_LETTER_U			  0x1025
#define Z_UNICODE_MYANMAR_LETTER_UU			  0x1026
#define Z_UNICODE_MYANMAR_LETTER_E			  0x1027
#define Z_UNICODE_MYANMAR_LETTER_MON_E			  0x1028
#define Z_UNICODE_MYANMAR_LETTER_O			  0x1029
#define Z_UNICODE_MYANMAR_LETTER_AU			  0x102A
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_TALL_AA		  0x102B
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_AA			  0x102C
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_I			  0x102D
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_II			  0x102E
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_U			  0x102F
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_UU			  0x1030
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_E			  0x1031
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_AI			  0x1032
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_MON_II		  0x1033
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_MON_O		  0x1034
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_E_ABOVE		  0x1035
#define Z_UNICODE_MYANMAR_SIGN_ANUSVARA			  0x1036
#define Z_UNICODE_MYANMAR_SIGN_DOT_BELOW		  0x1037
#define Z_UNICODE_MYANMAR_SIGN_VISARGA			  0x1038
#define Z_UNICODE_MYANMAR_SIGN_VIRAMA			  0x1039
#define Z_UNICODE_MYANMAR_SIGN_ASAT			  0x103A
#define Z_UNICODE_MYANMAR_CONSONANT_SIGN_MEDIAL_YA	  0x103B
#define Z_UNICODE_MYANMAR_CONSONANT_SIGN_MEDIAL_RA	  0x103C
#define Z_UNICODE_MYANMAR_CONSONANT_SIGN_MEDIAL_WA	  0x103D
#define Z_UNICODE_MYANMAR_CONSONANT_SIGN_MEDIAL_HA	  0x103E
#define Z_UNICODE_MYANMAR_LETTER_GREAT_SA		  0x103F
#define Z_UNICODE_MYANMAR_DIGIT_ZERO			  0x1040
#define Z_UNICODE_MYANMAR_DIGIT_ONE			  0x1041
#define Z_UNICODE_MYANMAR_DIGIT_TWO			  0x1042
#define Z_UNICODE_MYANMAR_DIGIT_THREE			  0x1043
#define Z_UNICODE_MYANMAR_DIGIT_FOUR			  0x1044
#define Z_UNICODE_MYANMAR_DIGIT_FIVE			  0x1045
#define Z_UNICODE_MYANMAR_DIGIT_SIX			  0x1046
#define Z_UNICODE_MYANMAR_DIGIT_SEVEN			  0x1047
#define Z_UNICODE_MYANMAR_DIGIT_EIGHT			  0x1048
#define Z_UNICODE_MYANMAR_DIGIT_NINE			  0x1049
#define Z_UNICODE_MYANMAR_SIGN_LITTLE_SECTION		  0x104A
#define Z_UNICODE_MYANMAR_SIGN_SECTION			  0x104B
#define Z_UNICODE_MYANMAR_SYMBOL_LOCATIVE		  0x104C
#define Z_UNICODE_MYANMAR_SYMBOL_COMPLETED		  0x104D
#define Z_UNICODE_MYANMAR_SYMBOL_AFOREMENTIONED		  0x104E
#define Z_UNICODE_MYANMAR_SYMBOL_GENITIVE		  0x104F
#define Z_UNICODE_MYANMAR_LETTER_SHA			  0x1050
#define Z_UNICODE_MYANMAR_LETTER_SSA			  0x1051
#define Z_UNICODE_MYANMAR_LETTER_VOCALIC_R		  0x1052
#define Z_UNICODE_MYANMAR_LETTER_VOCALIC_RR		  0x1053
#define Z_UNICODE_MYANMAR_LETTER_VOCALIC_L		  0x1054
#define Z_UNICODE_MYANMAR_LETTER_VOCALIC_LL		  0x1055
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_VOCALIC_R		  0x1056
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_VOCALIC_RR		  0x1057
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_VOCALIC_L		  0x1058
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_VOCALIC_LL		  0x1059
#define Z_UNICODE_MYANMAR_LETTER_MON_NGA		  0x105A
#define Z_UNICODE_MYANMAR_LETTER_MON_JHA		  0x105B
#define Z_UNICODE_MYANMAR_LETTER_MON_BBA		  0x105C
#define Z_UNICODE_MYANMAR_LETTER_MON_BBE		  0x105D
#define Z_UNICODE_MYANMAR_CONSONANT_SIGN_MON_MEDIAL_NA	  0x105E
#define Z_UNICODE_MYANMAR_CONSONANT_SIGN_MON_MEDIAL_MA	  0x105F
#define Z_UNICODE_MYANMAR_CONSONANT_SIGN_MON_MEDIAL_LA	  0x1060
#define Z_UNICODE_MYANMAR_LETTER_SGAW_KAREN_SHA		  0x1061
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_SGAW_KAREN_EU	  0x1062
#define Z_UNICODE_MYANMAR_TONE_MARK_SGAW_KAREN_HATHI	  0x1063
#define Z_UNICODE_MYANMAR_TONE_MARK_SGAW_KAREN_KE_PHO	  0x1064
#define Z_UNICODE_MYANMAR_LETTER_WESTERN_PWO_KAREN_THA	  0x1065
#define Z_UNICODE_MYANMAR_LETTER_WESTERN_PWO_KAREN_PWA	  0x1066
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_WESTERN_PWO_KAREN_EU 0x1067
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_WESTERN_PWO_KAREN_UE 0x1068
#define Z_UNICODE_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_1	  0x1069
#define Z_UNICODE_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_2	  0x106A
#define Z_UNICODE_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_3	  0x106B
#define Z_UNICODE_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_4	  0x106C
#define Z_UNICODE_MYANMAR_SIGN_WESTERN_PWO_KAREN_TONE_5	  0x106D
#define Z_UNICODE_MYANMAR_LETTER_EASTERN_PWO_KAREN_NNA	  0x106E
#define Z_UNICODE_MYANMAR_LETTER_EASTERN_PWO_KAREN_YWA	  0x106F
#define Z_UNICODE_MYANMAR_LETTER_EASTERN_PWO_KAREN_GHWA	  0x1070
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_GEBA_KAREN_I	  0x1071
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_KAYAH_OE		  0x1072
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_KAYAH_U		  0x1073
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_KAYAH_EE		  0x1074
#define Z_UNICODE_MYANMAR_LETTER_SHAN_KA		  0x1075
#define Z_UNICODE_MYANMAR_LETTER_SHAN_KHA		  0x1076
#define Z_UNICODE_MYANMAR_LETTER_SHAN_GA		  0x1077
#define Z_UNICODE_MYANMAR_LETTER_SHAN_CA		  0x1078
#define Z_UNICODE_MYANMAR_LETTER_SHAN_ZA		  0x1079
#define Z_UNICODE_MYANMAR_LETTER_SHAN_NYA		  0x107A
#define Z_UNICODE_MYANMAR_LETTER_SHAN_DA		  0x107B
#define Z_UNICODE_MYANMAR_LETTER_SHAN_NA		  0x107C
#define Z_UNICODE_MYANMAR_LETTER_SHAN_PHA		  0x107D
#define Z_UNICODE_MYANMAR_LETTER_SHAN_FA		  0x107E
#define Z_UNICODE_MYANMAR_LETTER_SHAN_BA		  0x107F
#define Z_UNICODE_MYANMAR_LETTER_SHAN_THA		  0x1080
#define Z_UNICODE_MYANMAR_LETTER_SHAN_HA		  0x1081
#define Z_UNICODE_MYANMAR_CONSONANT_SIGN_SHAN_MEDIAL_WA	  0x1082
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_SHAN_AA		  0x1083
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_SHAN_E		  0x1084
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_SHAN_E_ABOVE	  0x1085
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_SHAN_FINAL_Y	  0x1086
#define Z_UNICODE_MYANMAR_SIGN_SHAN_TONE_2		  0x1087
#define Z_UNICODE_MYANMAR_SIGN_SHAN_TONE_3		  0x1088
#define Z_UNICODE_MYANMAR_SIGN_SHAN_TONE_5		  0x1089
#define Z_UNICODE_MYANMAR_SIGN_SHAN_TONE_6		  0x108A
#define Z_UNICODE_MYANMAR_SIGN_SHAN_COUNCIL_TONE_2	  0x108B
#define Z_UNICODE_MYANMAR_SIGN_SHAN_COUNCIL_TONE_3	  0x108C
#define Z_UNICODE_MYANMAR_SIGN_SHAN_COUNCIL_EMPHATIC_TONE 0x108D
#define Z_UNICODE_MYANMAR_LETTER_RUMAI_PALAUNG_FA	  0x108E
#define Z_UNICODE_MYANMAR_SIGN_RUMAI_PALAUNG_TONE_5	  0x108F
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_ZERO		  0x1090
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_ONE		  0x1091
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_TWO		  0x1092
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_THREE		  0x1093
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_FOUR		  0x1094
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_FIVE		  0x1095
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_SIX		  0x1096
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_SEVEN		  0x1097
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_EIGHT		  0x1098
#define Z_UNICODE_MYANMAR_SHAN_DIGIT_NINE		  0x1099
#define Z_UNICODE_MYANMAR_SIGN_KHAMTI_TONE_1		  0x109A
#define Z_UNICODE_MYANMAR_SIGN_KHAMTI_TONE_3		  0x109B
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_AITON_A		  0x109C
#define Z_UNICODE_MYANMAR_VOWEL_SIGN_AITON_AI		  0x109D
#define Z_UNICODE_MYANMAR_SYMBOL_SHAN_ONE		  0x109E
#define Z_UNICODE_MYANMAR_SYMBOL_SHAN_EXCLAMATION	  0x109F

/* MARK: - 10A0h-10FFh - Georgian */

#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_AN   0x10A0
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_BAN  0x10A1
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_GAN  0x10A2
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_DON  0x10A3
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_EN   0x10A4
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_VIN  0x10A5
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_ZEN  0x10A6
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_TAN  0x10A7
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_IN   0x10A8
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_KAN  0x10A9
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_LAS  0x10AA
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_MAN  0x10AB
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_NAR  0x10AC
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_ON   0x10AD
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_PAR  0x10AE
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_ZHAR 0x10AF
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_RAE  0x10B0
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_SAN  0x10B1
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_TAR  0x10B2
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_UN   0x10B3
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_PHAR 0x10B4
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_KHAR 0x10B5
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_GHAN 0x10B6
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_QAR  0x10B7
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_SHIN 0x10B8
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_CHIN 0x10B9
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_CAN  0x10BA
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_JIL  0x10BB
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_CIL  0x10BC
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_CHAR 0x10BD
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_XAN  0x10BE
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_JHAN 0x10BF
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_HAE  0x10C0
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_HE   0x10C1
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_HIE  0x10C2
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_WE   0x10C3
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_HAR  0x10C4
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_HOE  0x10C5
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_YN   0x10C7
#define Z_UNICODE_GEORGIAN_CAPITAL_LETTER_AEN  0x10CD
#define Z_UNICODE_GEORGIAN_LETTER_AN	       0x10D0
#define Z_UNICODE_GEORGIAN_LETTER_BAN	       0x10D1
#define Z_UNICODE_GEORGIAN_LETTER_GAN	       0x10D2
#define Z_UNICODE_GEORGIAN_LETTER_DON	       0x10D3
#define Z_UNICODE_GEORGIAN_LETTER_EN	       0x10D4
#define Z_UNICODE_GEORGIAN_LETTER_VIN	       0x10D5
#define Z_UNICODE_GEORGIAN_LETTER_ZEN	       0x10D6
#define Z_UNICODE_GEORGIAN_LETTER_TAN	       0x10D7
#define Z_UNICODE_GEORGIAN_LETTER_IN	       0x10D8
#define Z_UNICODE_GEORGIAN_LETTER_KAN	       0x10D9
#define Z_UNICODE_GEORGIAN_LETTER_LAS	       0x10DA
#define Z_UNICODE_GEORGIAN_LETTER_MAN	       0x10DB
#define Z_UNICODE_GEORGIAN_LETTER_NAR	       0x10DC
#define Z_UNICODE_GEORGIAN_LETTER_ON	       0x10DD
#define Z_UNICODE_GEORGIAN_LETTER_PAR	       0x10DE
#define Z_UNICODE_GEORGIAN_LETTER_ZHAR	       0x10DF
#define Z_UNICODE_GEORGIAN_LETTER_RAE	       0x10E0
#define Z_UNICODE_GEORGIAN_LETTER_SAN	       0x10E1
#define Z_UNICODE_GEORGIAN_LETTER_TAR	       0x10E2
#define Z_UNICODE_GEORGIAN_LETTER_UN	       0x10E3
#define Z_UNICODE_GEORGIAN_LETTER_PHAR	       0x10E4
#define Z_UNICODE_GEORGIAN_LETTER_KHAR	       0x10E5
#define Z_UNICODE_GEORGIAN_LETTER_GHAN	       0x10E6
#define Z_UNICODE_GEORGIAN_LETTER_QAR	       0x10E7
#define Z_UNICODE_GEORGIAN_LETTER_SHIN	       0x10E8
#define Z_UNICODE_GEORGIAN_LETTER_CHIN	       0x10E9
#define Z_UNICODE_GEORGIAN_LETTER_CAN	       0x10EA
#define Z_UNICODE_GEORGIAN_LETTER_JIL	       0x10EB
#define Z_UNICODE_GEORGIAN_LETTER_CIL	       0x10EC
#define Z_UNICODE_GEORGIAN_LETTER_CHAR	       0x10ED
#define Z_UNICODE_GEORGIAN_LETTER_XAN	       0x10EE
#define Z_UNICODE_GEORGIAN_LETTER_JHAN	       0x10EF
#define Z_UNICODE_GEORGIAN_LETTER_HAE	       0x10F0
#define Z_UNICODE_GEORGIAN_LETTER_HE	       0x10F1
#define Z_UNICODE_GEORGIAN_LETTER_HIE	       0x10F2
#define Z_UNICODE_GEORGIAN_LETTER_WE	       0x10F3
#define Z_UNICODE_GEORGIAN_LETTER_HAR	       0x10F4
#define Z_UNICODE_GEORGIAN_LETTER_HOE	       0x10F5
#define Z_UNICODE_GEORGIAN_LETTER_FI	       0x10F6
#define Z_UNICODE_GEORGIAN_LETTER_YN	       0x10F7
#define Z_UNICODE_GEORGIAN_LETTER_ELIFI	       0x10F8
#define Z_UNICODE_GEORGIAN_LETTER_TURNED_GAN   0x10F9
#define Z_UNICODE_GEORGIAN_LETTER_AIN	       0x10FA
#define Z_UNICODE_GEORGIAN_PARAGRAPH_SEPARATOR 0x10FB
#define Z_UNICODE_MODIFIER_LETTER_GEORGIAN_NAR 0x10FC
#define Z_UNICODE_GEORGIAN_LETTER_AEN	       0x10FD
#define Z_UNICODE_GEORGIAN_LETTER_HARD_SIGN    0x10FE
#define Z_UNICODE_GEORGIAN_LETTER_LABIAL_SIGN  0x10FF

/* MARK: - 1100h-11FFh - Hangul Jamo */

#define Z_UNICODE_HANGUL_CHOSEONG_KIYEOK		0x1100
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGKIYEOK		0x1101
#define Z_UNICODE_HANGUL_CHOSEONG_NIEUN			0x1102
#define Z_UNICODE_HANGUL_CHOSEONG_TIKEUT		0x1103
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGTIKEUT		0x1104
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL			0x1105
#define Z_UNICODE_HANGUL_CHOSEONG_MIEUM			0x1106
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP			0x1107
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGPIEUP		0x1108
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS			0x1109
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGSIOS		0x110A
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG			0x110B
#define Z_UNICODE_HANGUL_CHOSEONG_CIEUC			0x110C
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGCIEUC		0x110D
#define Z_UNICODE_HANGUL_CHOSEONG_CHIEUCH		0x110E
#define Z_UNICODE_HANGUL_CHOSEONG_KHIEUKH		0x110F
#define Z_UNICODE_HANGUL_CHOSEONG_THIEUTH		0x1110
#define Z_UNICODE_HANGUL_CHOSEONG_PHIEUPH		0x1111
#define Z_UNICODE_HANGUL_CHOSEONG_HIEUH			0x1112
#define Z_UNICODE_HANGUL_CHOSEONG_NIEUN_KIYEOK		0x1113
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGNIEUN		0x1114
#define Z_UNICODE_HANGUL_CHOSEONG_NIEUN_TIKEUT		0x1115
#define Z_UNICODE_HANGUL_CHOSEONG_NIEUN_PIEUP		0x1116
#define Z_UNICODE_HANGUL_CHOSEONG_TIKEUT_KIYEOK		0x1117
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_NIEUN		0x1118
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGRIEUL		0x1119
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_HIEUH		0x111A
#define Z_UNICODE_HANGUL_CHOSEONG_KAPYEOUNRIEUL		0x111B
#define Z_UNICODE_HANGUL_CHOSEONG_MIEUM_PIEUP		0x111C
#define Z_UNICODE_HANGUL_CHOSEONG_KAPYEOUNMIEUM		0x111D
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_KIYEOK		0x111E
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_NIEUN		0x111F
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_TIKEUT		0x1120
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_SIOS		0x1121
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_SIOS_KIYEOK	0x1122
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_SIOS_TIKEUT	0x1123
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_SIOS_PIEUP	0x1124
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_SSANGSIOS	0x1125
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_SIOS_CIEUC	0x1126
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_CIEUC		0x1127
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_CHIEUCH		0x1128
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_THIEUTH		0x1129
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_PHIEUPH		0x112A
#define Z_UNICODE_HANGUL_CHOSEONG_KAPYEOUNPIEUP		0x112B
#define Z_UNICODE_HANGUL_CHOSEONG_KAPYEOUNSSANGPIEUP	0x112C
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_KIYEOK		0x112D
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_NIEUN		0x112E
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_TIKEUT		0x112F
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_RIEUL		0x1130
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_MIEUM		0x1131
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_PIEUP		0x1132
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_PIEUP_KIYEOK	0x1133
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_SSANGSIOS	0x1134
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_IEUNG		0x1135
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_CIEUC		0x1136
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_CHIEUCH		0x1137
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_KHIEUKH		0x1138
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_THIEUTH		0x1139
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_PHIEUPH		0x113A
#define Z_UNICODE_HANGUL_CHOSEONG_SIOS_HIEUH		0x113B
#define Z_UNICODE_HANGUL_CHOSEONG_CHITUEUMSIOS		0x113C
#define Z_UNICODE_HANGUL_CHOSEONG_CHITUEUMSSANGSIOS	0x113D
#define Z_UNICODE_HANGUL_CHOSEONG_CEONGCHIEUMSIOS	0x113E
#define Z_UNICODE_HANGUL_CHOSEONG_CEONGCHIEUMSSANGSIOS	0x113F
#define Z_UNICODE_HANGUL_CHOSEONG_PANSIOS		0x1140
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_KIYEOK		0x1141
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_TIKEUT		0x1142
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_MIEUM		0x1143
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_PIEUP		0x1144
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_SIOS		0x1145
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_PANSIOS		0x1146
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGIEUNG		0x1147
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_CIEUC		0x1148
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_CHIEUCH		0x1149
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_THIEUTH		0x114A
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_PHIEUPH		0x114B
#define Z_UNICODE_HANGUL_CHOSEONG_YESIEUNG		0x114C
#define Z_UNICODE_HANGUL_CHOSEONG_CIEUC_IEUNG		0x114D
#define Z_UNICODE_HANGUL_CHOSEONG_CHITUEUMCIEUC		0x114E
#define Z_UNICODE_HANGUL_CHOSEONG_CHITUEUMSSANGCIEUC	0x114F
#define Z_UNICODE_HANGUL_CHOSEONG_CEONGCHIEUMCIEUC	0x1150
#define Z_UNICODE_HANGUL_CHOSEONG_CEONGCHIEUMSSANGCIEUC	0x1151
#define Z_UNICODE_HANGUL_CHOSEONG_CHIEUCH_KHIEUKH	0x1152
#define Z_UNICODE_HANGUL_CHOSEONG_CHIEUCH_HIEUH		0x1153
#define Z_UNICODE_HANGUL_CHOSEONG_CHITUEUMCHIEUCH	0x1154
#define Z_UNICODE_HANGUL_CHOSEONG_CEONGCHIEUMCHIEUCH	0x1155
#define Z_UNICODE_HANGUL_CHOSEONG_PHIEUPH_PIEUP		0x1156
#define Z_UNICODE_HANGUL_CHOSEONG_KAPYEOUNPHIEUPH	0x1157
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGHIEUH		0x1158
#define Z_UNICODE_HANGUL_CHOSEONG_YEORINHIEUH		0x1159
#define Z_UNICODE_HANGUL_CHOSEONG_KIYEOK_TIKEUT		0x115A
#define Z_UNICODE_HANGUL_CHOSEONG_NIEUN_SIOS		0x115B
#define Z_UNICODE_HANGUL_CHOSEONG_NIEUN_CIEUC		0x115C
#define Z_UNICODE_HANGUL_CHOSEONG_NIEUN_HIEUH		0x115D
#define Z_UNICODE_HANGUL_CHOSEONG_TIKEUT_RIEUL		0x115E
#define Z_UNICODE_HANGUL_CHOSEONG_FILLER		0x115F
#define Z_UNICODE_HANGUL_JUNGSEONG_FILLER		0x1160
#define Z_UNICODE_HANGUL_JUNGSEONG_A			0x1161
#define Z_UNICODE_HANGUL_JUNGSEONG_AE			0x1162
#define Z_UNICODE_HANGUL_JUNGSEONG_YA			0x1163
#define Z_UNICODE_HANGUL_JUNGSEONG_YAE			0x1164
#define Z_UNICODE_HANGUL_JUNGSEONG_EO			0x1165
#define Z_UNICODE_HANGUL_JUNGSEONG_E			0x1166
#define Z_UNICODE_HANGUL_JUNGSEONG_YEO			0x1167
#define Z_UNICODE_HANGUL_JUNGSEONG_YE			0x1168
#define Z_UNICODE_HANGUL_JUNGSEONG_O			0x1169
#define Z_UNICODE_HANGUL_JUNGSEONG_WA			0x116A
#define Z_UNICODE_HANGUL_JUNGSEONG_WAE			0x116B
#define Z_UNICODE_HANGUL_JUNGSEONG_OE			0x116C
#define Z_UNICODE_HANGUL_JUNGSEONG_YO			0x116D
#define Z_UNICODE_HANGUL_JUNGSEONG_U			0x116E
#define Z_UNICODE_HANGUL_JUNGSEONG_WEO			0x116F
#define Z_UNICODE_HANGUL_JUNGSEONG_WE			0x1170
#define Z_UNICODE_HANGUL_JUNGSEONG_WI			0x1171
#define Z_UNICODE_HANGUL_JUNGSEONG_YU			0x1172
#define Z_UNICODE_HANGUL_JUNGSEONG_EU			0x1173
#define Z_UNICODE_HANGUL_JUNGSEONG_YI			0x1174
#define Z_UNICODE_HANGUL_JUNGSEONG_I			0x1175
#define Z_UNICODE_HANGUL_JUNGSEONG_A_O			0x1176
#define Z_UNICODE_HANGUL_JUNGSEONG_A_U			0x1177
#define Z_UNICODE_HANGUL_JUNGSEONG_YA_O			0x1178
#define Z_UNICODE_HANGUL_JUNGSEONG_YA_YO		0x1179
#define Z_UNICODE_HANGUL_JUNGSEONG_EO_O			0x117A
#define Z_UNICODE_HANGUL_JUNGSEONG_EO_U			0x117B
#define Z_UNICODE_HANGUL_JUNGSEONG_EO_EU		0x117C
#define Z_UNICODE_HANGUL_JUNGSEONG_YEO_O		0x117D
#define Z_UNICODE_HANGUL_JUNGSEONG_YEO_U		0x117E
#define Z_UNICODE_HANGUL_JUNGSEONG_O_EO			0x117F
#define Z_UNICODE_HANGUL_JUNGSEONG_O_E			0x1180
#define Z_UNICODE_HANGUL_JUNGSEONG_O_YE			0x1181
#define Z_UNICODE_HANGUL_JUNGSEONG_O_O			0x1182
#define Z_UNICODE_HANGUL_JUNGSEONG_O_U			0x1183
#define Z_UNICODE_HANGUL_JUNGSEONG_YO_YA		0x1184
#define Z_UNICODE_HANGUL_JUNGSEONG_YO_YAE		0x1185
#define Z_UNICODE_HANGUL_JUNGSEONG_YO_YEO		0x1186
#define Z_UNICODE_HANGUL_JUNGSEONG_YO_O			0x1187
#define Z_UNICODE_HANGUL_JUNGSEONG_YO_I			0x1188
#define Z_UNICODE_HANGUL_JUNGSEONG_U_A			0x1189
#define Z_UNICODE_HANGUL_JUNGSEONG_U_AE			0x118A
#define Z_UNICODE_HANGUL_JUNGSEONG_U_EO_EU		0x118B
#define Z_UNICODE_HANGUL_JUNGSEONG_U_YE			0x118C
#define Z_UNICODE_HANGUL_JUNGSEONG_U_U			0x118D
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_A			0x118E
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_EO		0x118F
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_E			0x1190
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_YEO		0x1191
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_YE		0x1192
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_U			0x1193
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_I			0x1194
#define Z_UNICODE_HANGUL_JUNGSEONG_EU_U			0x1195
#define Z_UNICODE_HANGUL_JUNGSEONG_EU_EU		0x1196
#define Z_UNICODE_HANGUL_JUNGSEONG_YI_U			0x1197
#define Z_UNICODE_HANGUL_JUNGSEONG_I_A			0x1198
#define Z_UNICODE_HANGUL_JUNGSEONG_I_YA			0x1199
#define Z_UNICODE_HANGUL_JUNGSEONG_I_O			0x119A
#define Z_UNICODE_HANGUL_JUNGSEONG_I_U			0x119B
#define Z_UNICODE_HANGUL_JUNGSEONG_I_EU			0x119C
#define Z_UNICODE_HANGUL_JUNGSEONG_I_ARAEA		0x119D
#define Z_UNICODE_HANGUL_JUNGSEONG_ARAEA		0x119E
#define Z_UNICODE_HANGUL_JUNGSEONG_ARAEA_EO		0x119F
#define Z_UNICODE_HANGUL_JUNGSEONG_ARAEA_U		0x11A0
#define Z_UNICODE_HANGUL_JUNGSEONG_ARAEA_I		0x11A1
#define Z_UNICODE_HANGUL_JUNGSEONG_SSANGARAEA		0x11A2
#define Z_UNICODE_HANGUL_JUNGSEONG_A_EU			0x11A3
#define Z_UNICODE_HANGUL_JUNGSEONG_YA_U			0x11A4
#define Z_UNICODE_HANGUL_JUNGSEONG_YEO_YA		0x11A5
#define Z_UNICODE_HANGUL_JUNGSEONG_O_YA			0x11A6
#define Z_UNICODE_HANGUL_JUNGSEONG_O_YAE		0x11A7
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK		0x11A8
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGKIYEOK		0x11A9
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK_SIOS		0x11AA
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN		0x11AB
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_CIEUC		0x11AC
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_HIEUH		0x11AD
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT		0x11AE
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL		0x11AF
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_KIYEOK		0x11B0
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_MIEUM		0x11B1
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_PIEUP		0x11B2
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_SIOS		0x11B3
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_THIEUTH	0x11B4
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_PHIEUPH	0x11B5
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_HIEUH		0x11B6
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM		0x11B7
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP		0x11B8
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_SIOS		0x11B9
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS			0x11BA
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGSIOS		0x11BB
#define Z_UNICODE_HANGUL_JONGSEONG_IEUNG		0x11BC
#define Z_UNICODE_HANGUL_JONGSEONG_CIEUC		0x11BD
#define Z_UNICODE_HANGUL_JONGSEONG_CHIEUCH		0x11BE
#define Z_UNICODE_HANGUL_JONGSEONG_KHIEUKH		0x11BF
#define Z_UNICODE_HANGUL_JONGSEONG_THIEUTH		0x11C0
#define Z_UNICODE_HANGUL_JONGSEONG_PHIEUPH		0x11C1
#define Z_UNICODE_HANGUL_JONGSEONG_HIEUH		0x11C2
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK_RIEUL		0x11C3
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK_SIOS_KIYEOK	0x11C4
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_KIYEOK		0x11C5
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_TIKEUT		0x11C6
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_SIOS		0x11C7
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_PANSIOS	0x11C8
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_THIEUTH	0x11C9
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT_KIYEOK	0x11CA
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT_RIEUL		0x11CB
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_KIYEOK_SIOS	0x11CC
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_NIEUN		0x11CD
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_TIKEUT		0x11CE
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_TIKEUT_HIEUH	0x11CF
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGRIEUL		0x11D0
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_MIEUM_KIYEOK	0x11D1
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_MIEUM_SIOS	0x11D2
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_PIEUP_SIOS	0x11D3
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_PIEUP_HIEUH	0x11D4
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_KAPYEOUNPIEUP	0x11D5
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_SSANGSIOS	0x11D6
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_PANSIOS	0x11D7
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_KHIEUKH	0x11D8
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_YEORINHIEUH	0x11D9
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_KIYEOK		0x11DA
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_RIEUL		0x11DB
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_PIEUP		0x11DC
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_SIOS		0x11DD
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_SSANGSIOS	0x11DE
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_PANSIOS	0x11DF
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_CHIEUCH	0x11E0
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_HIEUH		0x11E1
#define Z_UNICODE_HANGUL_JONGSEONG_KAPYEOUNMIEUM	0x11E2
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_RIEUL		0x11E3
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_PHIEUPH	0x11E4
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_HIEUH		0x11E5
#define Z_UNICODE_HANGUL_JONGSEONG_KAPYEOUNPIEUP	0x11E6
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_KIYEOK		0x11E7
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_TIKEUT		0x11E8
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_RIEUL		0x11E9
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_PIEUP		0x11EA
#define Z_UNICODE_HANGUL_JONGSEONG_PANSIOS		0x11EB
#define Z_UNICODE_HANGUL_JONGSEONG_IEUNG_KIYEOK		0x11EC
#define Z_UNICODE_HANGUL_JONGSEONG_IEUNG_SSANGKIYEOK	0x11ED
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGIEUNG		0x11EE
#define Z_UNICODE_HANGUL_JONGSEONG_IEUNG_KHIEUKH	0x11EF
#define Z_UNICODE_HANGUL_JONGSEONG_YESIEUNG		0x11F0
#define Z_UNICODE_HANGUL_JONGSEONG_YESIEUNG_SIOS	0x11F1
#define Z_UNICODE_HANGUL_JONGSEONG_YESIEUNG_PANSIOS	0x11F2
#define Z_UNICODE_HANGUL_JONGSEONG_PHIEUPH_PIEUP	0x11F3
#define Z_UNICODE_HANGUL_JONGSEONG_KAPYEOUNPHIEUPH	0x11F4
#define Z_UNICODE_HANGUL_JONGSEONG_HIEUH_NIEUN		0x11F5
#define Z_UNICODE_HANGUL_JONGSEONG_HIEUH_RIEUL		0x11F6
#define Z_UNICODE_HANGUL_JONGSEONG_HIEUH_MIEUM		0x11F7
#define Z_UNICODE_HANGUL_JONGSEONG_HIEUH_PIEUP		0x11F8
#define Z_UNICODE_HANGUL_JONGSEONG_YEORINHIEUH		0x11F9
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK_NIEUN		0x11FA
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK_PIEUP		0x11FB
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK_CHIEUCH	0x11FC
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK_KHIEUKH	0x11FD
#define Z_UNICODE_HANGUL_JONGSEONG_KIYEOK_HIEUH		0x11FE
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGNIEUN		0x11FF

/* MARK: - 1200h-137Fh - Ethiopic */

#define Z_UNICODE_ETHIOPIC_SYLLABLE_HA				      0x1200
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HU				      0x1201
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HI				      0x1202
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HAA				      0x1203
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HEE				      0x1204
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HE				      0x1205
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HO				      0x1206
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HOA				      0x1207
#define Z_UNICODE_ETHIOPIC_SYLLABLE_LA				      0x1208
#define Z_UNICODE_ETHIOPIC_SYLLABLE_LU				      0x1209
#define Z_UNICODE_ETHIOPIC_SYLLABLE_LI				      0x120A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_LAA				      0x120B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_LEE				      0x120C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_LE				      0x120D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_LO				      0x120E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_LWA				      0x120F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HHA				      0x1210
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HHU				      0x1211
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HHI				      0x1212
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HHAA			      0x1213
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HHEE			      0x1214
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HHE				      0x1215
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HHO				      0x1216
#define Z_UNICODE_ETHIOPIC_SYLLABLE_HHWA			      0x1217
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MA				      0x1218
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MU				      0x1219
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MI				      0x121A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MAA				      0x121B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MEE				      0x121C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ME				      0x121D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MO				      0x121E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MWA				      0x121F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SZA				      0x1220
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SZU				      0x1221
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SZI				      0x1222
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SZAA			      0x1223
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SZEE			      0x1224
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SZE				      0x1225
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SZO				      0x1226
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SZWA			      0x1227
#define Z_UNICODE_ETHIOPIC_SYLLABLE_RA				      0x1228
#define Z_UNICODE_ETHIOPIC_SYLLABLE_RU				      0x1229
#define Z_UNICODE_ETHIOPIC_SYLLABLE_RI				      0x122A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_RAA				      0x122B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_REE				      0x122C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_RE				      0x122D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_RO				      0x122E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_RWA				      0x122F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SA				      0x1230
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SU				      0x1231
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SI				      0x1232
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SAA				      0x1233
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SEE				      0x1234
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SE				      0x1235
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SO				      0x1236
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SWA				      0x1237
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHA				      0x1238
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHU				      0x1239
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHI				      0x123A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHAA			      0x123B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHEE			      0x123C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHE				      0x123D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHO				      0x123E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHWA			      0x123F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QA				      0x1240
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QU				      0x1241
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QI				      0x1242
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QAA				      0x1243
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QEE				      0x1244
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QE				      0x1245
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QO				      0x1246
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QOA				      0x1247
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QWA				      0x1248
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QWI				      0x124A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QWAA			      0x124B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QWEE			      0x124C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QWE				      0x124D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHA				      0x1250
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHU				      0x1251
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHI				      0x1252
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHAA			      0x1253
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHEE			      0x1254
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHE				      0x1255
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHO				      0x1256
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHWA			      0x1258
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHWI			      0x125A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHWAA			      0x125B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHWEE			      0x125C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QHWE			      0x125D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BA				      0x1260
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BU				      0x1261
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BI				      0x1262
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BAA				      0x1263
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BEE				      0x1264
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BE				      0x1265
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BO				      0x1266
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BWA				      0x1267
#define Z_UNICODE_ETHIOPIC_SYLLABLE_VA				      0x1268
#define Z_UNICODE_ETHIOPIC_SYLLABLE_VU				      0x1269
#define Z_UNICODE_ETHIOPIC_SYLLABLE_VI				      0x126A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_VAA				      0x126B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_VEE				      0x126C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_VE				      0x126D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_VO				      0x126E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_VWA				      0x126F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TA				      0x1270
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TU				      0x1271
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TI				      0x1272
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TAA				      0x1273
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TEE				      0x1274
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TE				      0x1275
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TO				      0x1276
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TWA				      0x1277
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CA				      0x1278
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CU				      0x1279
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CI				      0x127A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CAA				      0x127B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CEE				      0x127C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CE				      0x127D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CO				      0x127E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CWA				      0x127F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XA				      0x1280
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XU				      0x1281
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XI				      0x1282
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XAA				      0x1283
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XEE				      0x1284
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XE				      0x1285
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XO				      0x1286
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XOA				      0x1287
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XWA				      0x1288
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XWI				      0x128A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XWAA			      0x128B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XWEE			      0x128C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XWE				      0x128D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NA				      0x1290
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NU				      0x1291
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NI				      0x1292
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NAA				      0x1293
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NEE				      0x1294
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NE				      0x1295
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NO				      0x1296
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NWA				      0x1297
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYA				      0x1298
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYU				      0x1299
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYI				      0x129A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYAA			      0x129B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYEE			      0x129C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYE				      0x129D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYO				      0x129E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYWA			      0x129F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_A			      0x12A0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_U			      0x12A1
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_I			      0x12A2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_AA			      0x12A3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_EE			      0x12A4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_E			      0x12A5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_O			      0x12A6
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_WA			      0x12A7
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KA				      0x12A8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KU				      0x12A9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KI				      0x12AA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KAA				      0x12AB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KEE				      0x12AC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KE				      0x12AD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KO				      0x12AE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KOA				      0x12AF
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KWA				      0x12B0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KWI				      0x12B2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KWAA			      0x12B3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KWEE			      0x12B4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KWE				      0x12B5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXA				      0x12B8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXU				      0x12B9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXI				      0x12BA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXAA			      0x12BB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXEE			      0x12BC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXE				      0x12BD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXO				      0x12BE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXWA			      0x12C0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXWI			      0x12C2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXWAA			      0x12C3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXWEE			      0x12C4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KXWE			      0x12C5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_WA				      0x12C8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_WU				      0x12C9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_WI				      0x12CA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_WAA				      0x12CB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_WEE				      0x12CC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_WE				      0x12CD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_WO				      0x12CE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_WOA				      0x12CF
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHARYNGEAL_A		      0x12D0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHARYNGEAL_U		      0x12D1
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHARYNGEAL_I		      0x12D2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHARYNGEAL_AA		      0x12D3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHARYNGEAL_EE		      0x12D4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHARYNGEAL_E		      0x12D5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHARYNGEAL_O		      0x12D6
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZA				      0x12D8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZU				      0x12D9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZI				      0x12DA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZAA				      0x12DB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZEE				      0x12DC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZE				      0x12DD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZO				      0x12DE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZWA				      0x12DF
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZHA				      0x12E0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZHU				      0x12E1
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZHI				      0x12E2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZHAA			      0x12E3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZHEE			      0x12E4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZHE				      0x12E5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZHO				      0x12E6
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZHWA			      0x12E7
#define Z_UNICODE_ETHIOPIC_SYLLABLE_YA				      0x12E8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_YU				      0x12E9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_YI				      0x12EA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_YAA				      0x12EB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_YEE				      0x12EC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_YE				      0x12ED
#define Z_UNICODE_ETHIOPIC_SYLLABLE_YO				      0x12EE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_YOA				      0x12EF
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DA				      0x12F0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DU				      0x12F1
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DI				      0x12F2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DAA				      0x12F3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DEE				      0x12F4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DE				      0x12F5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DO				      0x12F6
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DWA				      0x12F7
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDA				      0x12F8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDU				      0x12F9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDI				      0x12FA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDAA			      0x12FB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDEE			      0x12FC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDE				      0x12FD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDO				      0x12FE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDWA			      0x12FF
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JA				      0x1300
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JU				      0x1301
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JI				      0x1302
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JAA				      0x1303
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JEE				      0x1304
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JE				      0x1305
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JO				      0x1306
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JWA				      0x1307
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GA				      0x1308
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GU				      0x1309
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GI				      0x130A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GAA				      0x130B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GEE				      0x130C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GE				      0x130D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GO				      0x130E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GOA				      0x130F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GWA				      0x1310
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GWI				      0x1312
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GWAA			      0x1313
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GWEE			      0x1314
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GWE				      0x1315
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGA				      0x1318
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGU				      0x1319
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGI				      0x131A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGAA			      0x131B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGEE			      0x131C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGE				      0x131D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGO				      0x131E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGWAA			      0x131F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THA				      0x1320
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THU				      0x1321
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THI				      0x1322
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THAA			      0x1323
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THEE			      0x1324
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THE				      0x1325
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THO				      0x1326
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THWA			      0x1327
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHA				      0x1328
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHU				      0x1329
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHI				      0x132A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHAA			      0x132B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHEE			      0x132C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHE				      0x132D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHO				      0x132E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHWA			      0x132F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHA				      0x1330
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHU				      0x1331
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHI				      0x1332
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHAA			      0x1333
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHEE			      0x1334
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHE				      0x1335
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHO				      0x1336
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHWA			      0x1337
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TSA				      0x1338
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TSU				      0x1339
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TSI				      0x133A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TSAA			      0x133B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TSEE			      0x133C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TSE				      0x133D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TSO				      0x133E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TSWA			      0x133F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TZA				      0x1340
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TZU				      0x1341
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TZI				      0x1342
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TZAA			      0x1343
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TZEE			      0x1344
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TZE				      0x1345
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TZO				      0x1346
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TZOA			      0x1347
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FA				      0x1348
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FU				      0x1349
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FI				      0x134A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FAA				      0x134B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FEE				      0x134C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FE				      0x134D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FO				      0x134E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FWA				      0x134F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PA				      0x1350
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PU				      0x1351
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PI				      0x1352
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PAA				      0x1353
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PEE				      0x1354
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PE				      0x1355
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PO				      0x1356
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PWA				      0x1357
#define Z_UNICODE_ETHIOPIC_SYLLABLE_RYA				      0x1358
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MYA				      0x1359
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FYA				      0x135A
#define Z_UNICODE_ETHIOPIC_COMBINING_GEMINATION_AND_VOWEL_LENGTH_MARK 0x135D
#define Z_UNICODE_ETHIOPIC_COMBINING_VOWEL_LENGTH_MARK		      0x135E
#define Z_UNICODE_ETHIOPIC_COMBINING_GEMINATION_MARK		      0x135F
#define Z_UNICODE_ETHIOPIC_SECTION_MARK				      0x1360
#define Z_UNICODE_ETHIOPIC_WORDSPACE				      0x1361
#define Z_UNICODE_ETHIOPIC_FULL_STOP				      0x1362
#define Z_UNICODE_ETHIOPIC_COMMA				      0x1363
#define Z_UNICODE_ETHIOPIC_SEMICOLON				      0x1364
#define Z_UNICODE_ETHIOPIC_COLON				      0x1365
#define Z_UNICODE_ETHIOPIC_PREFACE_COLON			      0x1366
#define Z_UNICODE_ETHIOPIC_QUESTION_MARK			      0x1367
#define Z_UNICODE_ETHIOPIC_PARAGRAPH_SEPARATOR			      0x1368
#define Z_UNICODE_ETHIOPIC_DIGIT_ONE				      0x1369
#define Z_UNICODE_ETHIOPIC_DIGIT_TWO				      0x136A
#define Z_UNICODE_ETHIOPIC_DIGIT_THREE				      0x136B
#define Z_UNICODE_ETHIOPIC_DIGIT_FOUR				      0x136C
#define Z_UNICODE_ETHIOPIC_DIGIT_FIVE				      0x136D
#define Z_UNICODE_ETHIOPIC_DIGIT_SIX				      0x136E
#define Z_UNICODE_ETHIOPIC_DIGIT_SEVEN				      0x136F
#define Z_UNICODE_ETHIOPIC_DIGIT_EIGHT				      0x1370
#define Z_UNICODE_ETHIOPIC_DIGIT_NINE				      0x1371
#define Z_UNICODE_ETHIOPIC_NUMBER_TEN				      0x1372
#define Z_UNICODE_ETHIOPIC_NUMBER_TWENTY			      0x1373
#define Z_UNICODE_ETHIOPIC_NUMBER_THIRTY			      0x1374
#define Z_UNICODE_ETHIOPIC_NUMBER_FORTY				      0x1375
#define Z_UNICODE_ETHIOPIC_NUMBER_FIFTY				      0x1376
#define Z_UNICODE_ETHIOPIC_NUMBER_SIXTY				      0x1377
#define Z_UNICODE_ETHIOPIC_NUMBER_SEVENTY			      0x1378
#define Z_UNICODE_ETHIOPIC_NUMBER_EIGHTY			      0x1379
#define Z_UNICODE_ETHIOPIC_NUMBER_NINETY			      0x137A
#define Z_UNICODE_ETHIOPIC_NUMBER_HUNDRED			      0x137B
#define Z_UNICODE_ETHIOPIC_NUMBER_TEN_THOUSAND			      0x137C

/* MARK: - 1380h-139Fh - Ethiopic Supplement */

#define Z_UNICODE_ETHIOPIC_SYLLABLE_SEBATBEIT_MWA  0x1380
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MWI		   0x1381
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MWEE	   0x1382
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MWE		   0x1383
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SEBATBEIT_BWA  0x1384
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BWI		   0x1385
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BWEE	   0x1386
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BWE		   0x1387
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SEBATBEIT_FWA  0x1388
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FWI		   0x1389
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FWEE	   0x138A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_FWE		   0x138B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SEBATBEIT_PWA  0x138C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PWI		   0x138D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PWEE	   0x138E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PWE		   0x138F
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_YIZET	   0x1390
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_DERET	   0x1391
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_RIKRIK	   0x1392
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_SHORT_RIKRIK 0x1393
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_DIFAT	   0x1394
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_KENAT	   0x1395
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_CHIRET	   0x1396
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_HIDET	   0x1397
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_DERET_HIDET  0x1398
#define Z_UNICODE_ETHIOPIC_TONAL_MARK_KURT	   0x1399

/* MARK: - 13A0h-13FFh - Cherokee */

#define Z_UNICODE_CHEROKEE_LETTER_A	   0x13A0
#define Z_UNICODE_CHEROKEE_LETTER_E	   0x13A1
#define Z_UNICODE_CHEROKEE_LETTER_I	   0x13A2
#define Z_UNICODE_CHEROKEE_LETTER_O	   0x13A3
#define Z_UNICODE_CHEROKEE_LETTER_U	   0x13A4
#define Z_UNICODE_CHEROKEE_LETTER_V	   0x13A5
#define Z_UNICODE_CHEROKEE_LETTER_GA	   0x13A6
#define Z_UNICODE_CHEROKEE_LETTER_KA	   0x13A7
#define Z_UNICODE_CHEROKEE_LETTER_GE	   0x13A8
#define Z_UNICODE_CHEROKEE_LETTER_GI	   0x13A9
#define Z_UNICODE_CHEROKEE_LETTER_GO	   0x13AA
#define Z_UNICODE_CHEROKEE_LETTER_GU	   0x13AB
#define Z_UNICODE_CHEROKEE_LETTER_GV	   0x13AC
#define Z_UNICODE_CHEROKEE_LETTER_HA	   0x13AD
#define Z_UNICODE_CHEROKEE_LETTER_HE	   0x13AE
#define Z_UNICODE_CHEROKEE_LETTER_HI	   0x13AF
#define Z_UNICODE_CHEROKEE_LETTER_HO	   0x13B0
#define Z_UNICODE_CHEROKEE_LETTER_HU	   0x13B1
#define Z_UNICODE_CHEROKEE_LETTER_HV	   0x13B2
#define Z_UNICODE_CHEROKEE_LETTER_LA	   0x13B3
#define Z_UNICODE_CHEROKEE_LETTER_LE	   0x13B4
#define Z_UNICODE_CHEROKEE_LETTER_LI	   0x13B5
#define Z_UNICODE_CHEROKEE_LETTER_LO	   0x13B6
#define Z_UNICODE_CHEROKEE_LETTER_LU	   0x13B7
#define Z_UNICODE_CHEROKEE_LETTER_LV	   0x13B8
#define Z_UNICODE_CHEROKEE_LETTER_MA	   0x13B9
#define Z_UNICODE_CHEROKEE_LETTER_ME	   0x13BA
#define Z_UNICODE_CHEROKEE_LETTER_MI	   0x13BB
#define Z_UNICODE_CHEROKEE_LETTER_MO	   0x13BC
#define Z_UNICODE_CHEROKEE_LETTER_MU	   0x13BD
#define Z_UNICODE_CHEROKEE_LETTER_NA	   0x13BE
#define Z_UNICODE_CHEROKEE_LETTER_HNA	   0x13BF
#define Z_UNICODE_CHEROKEE_LETTER_NAH	   0x13C0
#define Z_UNICODE_CHEROKEE_LETTER_NE	   0x13C1
#define Z_UNICODE_CHEROKEE_LETTER_NI	   0x13C2
#define Z_UNICODE_CHEROKEE_LETTER_NO	   0x13C3
#define Z_UNICODE_CHEROKEE_LETTER_NU	   0x13C4
#define Z_UNICODE_CHEROKEE_LETTER_NV	   0x13C5
#define Z_UNICODE_CHEROKEE_LETTER_QUA	   0x13C6
#define Z_UNICODE_CHEROKEE_LETTER_QUE	   0x13C7
#define Z_UNICODE_CHEROKEE_LETTER_QUI	   0x13C8
#define Z_UNICODE_CHEROKEE_LETTER_QUO	   0x13C9
#define Z_UNICODE_CHEROKEE_LETTER_QUU	   0x13CA
#define Z_UNICODE_CHEROKEE_LETTER_QUV	   0x13CB
#define Z_UNICODE_CHEROKEE_LETTER_SA	   0x13CC
#define Z_UNICODE_CHEROKEE_LETTER_S	   0x13CD
#define Z_UNICODE_CHEROKEE_LETTER_SE	   0x13CE
#define Z_UNICODE_CHEROKEE_LETTER_SI	   0x13CF
#define Z_UNICODE_CHEROKEE_LETTER_SO	   0x13D0
#define Z_UNICODE_CHEROKEE_LETTER_SU	   0x13D1
#define Z_UNICODE_CHEROKEE_LETTER_SV	   0x13D2
#define Z_UNICODE_CHEROKEE_LETTER_DA	   0x13D3
#define Z_UNICODE_CHEROKEE_LETTER_TA	   0x13D4
#define Z_UNICODE_CHEROKEE_LETTER_DE	   0x13D5
#define Z_UNICODE_CHEROKEE_LETTER_TE	   0x13D6
#define Z_UNICODE_CHEROKEE_LETTER_DI	   0x13D7
#define Z_UNICODE_CHEROKEE_LETTER_TI	   0x13D8
#define Z_UNICODE_CHEROKEE_LETTER_DO	   0x13D9
#define Z_UNICODE_CHEROKEE_LETTER_DU	   0x13DA
#define Z_UNICODE_CHEROKEE_LETTER_DV	   0x13DB
#define Z_UNICODE_CHEROKEE_LETTER_DLA	   0x13DC
#define Z_UNICODE_CHEROKEE_LETTER_TLA	   0x13DD
#define Z_UNICODE_CHEROKEE_LETTER_TLE	   0x13DE
#define Z_UNICODE_CHEROKEE_LETTER_TLI	   0x13DF
#define Z_UNICODE_CHEROKEE_LETTER_TLO	   0x13E0
#define Z_UNICODE_CHEROKEE_LETTER_TLU	   0x13E1
#define Z_UNICODE_CHEROKEE_LETTER_TLV	   0x13E2
#define Z_UNICODE_CHEROKEE_LETTER_TSA	   0x13E3
#define Z_UNICODE_CHEROKEE_LETTER_TSE	   0x13E4
#define Z_UNICODE_CHEROKEE_LETTER_TSI	   0x13E5
#define Z_UNICODE_CHEROKEE_LETTER_TSO	   0x13E6
#define Z_UNICODE_CHEROKEE_LETTER_TSU	   0x13E7
#define Z_UNICODE_CHEROKEE_LETTER_TSV	   0x13E8
#define Z_UNICODE_CHEROKEE_LETTER_WA	   0x13E9
#define Z_UNICODE_CHEROKEE_LETTER_WE	   0x13EA
#define Z_UNICODE_CHEROKEE_LETTER_WI	   0x13EB
#define Z_UNICODE_CHEROKEE_LETTER_WO	   0x13EC
#define Z_UNICODE_CHEROKEE_LETTER_WU	   0x13ED
#define Z_UNICODE_CHEROKEE_LETTER_WV	   0x13EE
#define Z_UNICODE_CHEROKEE_LETTER_YA	   0x13EF
#define Z_UNICODE_CHEROKEE_LETTER_YE	   0x13F0
#define Z_UNICODE_CHEROKEE_LETTER_YI	   0x13F1
#define Z_UNICODE_CHEROKEE_LETTER_YO	   0x13F2
#define Z_UNICODE_CHEROKEE_LETTER_YU	   0x13F3
#define Z_UNICODE_CHEROKEE_LETTER_YV	   0x13F4
#define Z_UNICODE_CHEROKEE_LETTER_MV	   0x13F5
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_YE 0x13F8
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_YI 0x13F9
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_YO 0x13FA
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_YU 0x13FB
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_YV 0x13FC
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_MV 0x13FD

/* MARK: - 1400h-167Fh - Unified Canadian Aboriginal Syllabics */

#define Z_UNICODE_CANADIAN_SYLLABICS_HYPHEN				 0x1400
#define Z_UNICODE_CANADIAN_SYLLABICS_E					 0x1401
#define Z_UNICODE_CANADIAN_SYLLABICS_AAI				 0x1402
#define Z_UNICODE_CANADIAN_SYLLABICS_I					 0x1403
#define Z_UNICODE_CANADIAN_SYLLABICS_II					 0x1404
#define Z_UNICODE_CANADIAN_SYLLABICS_O					 0x1405
#define Z_UNICODE_CANADIAN_SYLLABICS_OO					 0x1406
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_OO				 0x1407
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_EE				 0x1408
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_I				 0x1409
#define Z_UNICODE_CANADIAN_SYLLABICS_A					 0x140A
#define Z_UNICODE_CANADIAN_SYLLABICS_AA					 0x140B
#define Z_UNICODE_CANADIAN_SYLLABICS_WE					 0x140C
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_WE			 0x140D
#define Z_UNICODE_CANADIAN_SYLLABICS_WI					 0x140E
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_WI			 0x140F
#define Z_UNICODE_CANADIAN_SYLLABICS_WII				 0x1410
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_WII			 0x1411
#define Z_UNICODE_CANADIAN_SYLLABICS_WO					 0x1412
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_WO			 0x1413
#define Z_UNICODE_CANADIAN_SYLLABICS_WOO				 0x1414
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_WOO			 0x1415
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_WOO			 0x1416
#define Z_UNICODE_CANADIAN_SYLLABICS_WA					 0x1417
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_WA			 0x1418
#define Z_UNICODE_CANADIAN_SYLLABICS_WAA				 0x1419
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_WAA			 0x141A
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_WAA			 0x141B
#define Z_UNICODE_CANADIAN_SYLLABICS_AI					 0x141C
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_W				 0x141D
#define Z_UNICODE_CANADIAN_SYLLABICS_GLOTTAL_STOP			 0x141E
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_ACUTE			 0x141F
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_GRAVE			 0x1420
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_BOTTOM_HALF_RING		 0x1421
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_TOP_HALF_RING		 0x1422
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_RIGHT_HALF_RING		 0x1423
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_RING				 0x1424
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_DOUBLE_ACUTE			 0x1425
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_DOUBLE_SHORT_VERTICAL_STROKES 0x1426
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_MIDDLE_DOT			 0x1427
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_SHORT_HORIZONTAL_STROKE	 0x1428
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_PLUS				 0x1429
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_DOWN_TACK			 0x142A
#define Z_UNICODE_CANADIAN_SYLLABICS_EN					 0x142B
#define Z_UNICODE_CANADIAN_SYLLABICS_IN					 0x142C
#define Z_UNICODE_CANADIAN_SYLLABICS_ON					 0x142D
#define Z_UNICODE_CANADIAN_SYLLABICS_AN					 0x142E
#define Z_UNICODE_CANADIAN_SYLLABICS_PE					 0x142F
#define Z_UNICODE_CANADIAN_SYLLABICS_PAAI				 0x1430
#define Z_UNICODE_CANADIAN_SYLLABICS_PI					 0x1431
#define Z_UNICODE_CANADIAN_SYLLABICS_PII				 0x1432
#define Z_UNICODE_CANADIAN_SYLLABICS_PO					 0x1433
#define Z_UNICODE_CANADIAN_SYLLABICS_POO				 0x1434
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_POO				 0x1435
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_HEE			 0x1436
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_HI				 0x1437
#define Z_UNICODE_CANADIAN_SYLLABICS_PA					 0x1438
#define Z_UNICODE_CANADIAN_SYLLABICS_PAA				 0x1439
#define Z_UNICODE_CANADIAN_SYLLABICS_PWE				 0x143A
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_PWE			 0x143B
#define Z_UNICODE_CANADIAN_SYLLABICS_PWI				 0x143C
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_PWI			 0x143D
#define Z_UNICODE_CANADIAN_SYLLABICS_PWII				 0x143E
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_PWII			 0x143F
#define Z_UNICODE_CANADIAN_SYLLABICS_PWO				 0x1440
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_PWO			 0x1441
#define Z_UNICODE_CANADIAN_SYLLABICS_PWOO				 0x1442
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_PWOO			 0x1443
#define Z_UNICODE_CANADIAN_SYLLABICS_PWA				 0x1444
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_PWA			 0x1445
#define Z_UNICODE_CANADIAN_SYLLABICS_PWAA				 0x1446
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_PWAA			 0x1447
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_PWAA			 0x1448
#define Z_UNICODE_CANADIAN_SYLLABICS_P					 0x1449
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_P			 0x144A
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_H				 0x144B
#define Z_UNICODE_CANADIAN_SYLLABICS_TE					 0x144C
#define Z_UNICODE_CANADIAN_SYLLABICS_TAAI				 0x144D
#define Z_UNICODE_CANADIAN_SYLLABICS_TI					 0x144E
#define Z_UNICODE_CANADIAN_SYLLABICS_TII				 0x144F
#define Z_UNICODE_CANADIAN_SYLLABICS_TO					 0x1450
#define Z_UNICODE_CANADIAN_SYLLABICS_TOO				 0x1451
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_TOO				 0x1452
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DEE			 0x1453
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DI				 0x1454
#define Z_UNICODE_CANADIAN_SYLLABICS_TA					 0x1455
#define Z_UNICODE_CANADIAN_SYLLABICS_TAA				 0x1456
#define Z_UNICODE_CANADIAN_SYLLABICS_TWE				 0x1457
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_TWE			 0x1458
#define Z_UNICODE_CANADIAN_SYLLABICS_TWI				 0x1459
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_TWI			 0x145A
#define Z_UNICODE_CANADIAN_SYLLABICS_TWII				 0x145B
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_TWII			 0x145C
#define Z_UNICODE_CANADIAN_SYLLABICS_TWO				 0x145D
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_TWO			 0x145E
#define Z_UNICODE_CANADIAN_SYLLABICS_TWOO				 0x145F
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_TWOO			 0x1460
#define Z_UNICODE_CANADIAN_SYLLABICS_TWA				 0x1461
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_TWA			 0x1462
#define Z_UNICODE_CANADIAN_SYLLABICS_TWAA				 0x1463
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_TWAA			 0x1464
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_TWAA			 0x1465
#define Z_UNICODE_CANADIAN_SYLLABICS_T					 0x1466
#define Z_UNICODE_CANADIAN_SYLLABICS_TTE				 0x1467
#define Z_UNICODE_CANADIAN_SYLLABICS_TTI				 0x1468
#define Z_UNICODE_CANADIAN_SYLLABICS_TTO				 0x1469
#define Z_UNICODE_CANADIAN_SYLLABICS_TTA				 0x146A
#define Z_UNICODE_CANADIAN_SYLLABICS_KE					 0x146B
#define Z_UNICODE_CANADIAN_SYLLABICS_KAAI				 0x146C
#define Z_UNICODE_CANADIAN_SYLLABICS_KI					 0x146D
#define Z_UNICODE_CANADIAN_SYLLABICS_KII				 0x146E
#define Z_UNICODE_CANADIAN_SYLLABICS_KO					 0x146F
#define Z_UNICODE_CANADIAN_SYLLABICS_KOO				 0x1470
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_KOO				 0x1471
#define Z_UNICODE_CANADIAN_SYLLABICS_KA					 0x1472
#define Z_UNICODE_CANADIAN_SYLLABICS_KAA				 0x1473
#define Z_UNICODE_CANADIAN_SYLLABICS_KWE				 0x1474
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_KWE			 0x1475
#define Z_UNICODE_CANADIAN_SYLLABICS_KWI				 0x1476
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_KWI			 0x1477
#define Z_UNICODE_CANADIAN_SYLLABICS_KWII				 0x1478
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_KWII			 0x1479
#define Z_UNICODE_CANADIAN_SYLLABICS_KWO				 0x147A
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_KWO			 0x147B
#define Z_UNICODE_CANADIAN_SYLLABICS_KWOO				 0x147C
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_KWOO			 0x147D
#define Z_UNICODE_CANADIAN_SYLLABICS_KWA				 0x147E
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_KWA			 0x147F
#define Z_UNICODE_CANADIAN_SYLLABICS_KWAA				 0x1480
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_KWAA			 0x1481
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_KWAA			 0x1482
#define Z_UNICODE_CANADIAN_SYLLABICS_K					 0x1483
#define Z_UNICODE_CANADIAN_SYLLABICS_KW					 0x1484
#define Z_UNICODE_CANADIAN_SYLLABICS_SOUTH_SLAVEY_KEH			 0x1485
#define Z_UNICODE_CANADIAN_SYLLABICS_SOUTH_SLAVEY_KIH			 0x1486
#define Z_UNICODE_CANADIAN_SYLLABICS_SOUTH_SLAVEY_KOH			 0x1487
#define Z_UNICODE_CANADIAN_SYLLABICS_SOUTH_SLAVEY_KAH			 0x1488
#define Z_UNICODE_CANADIAN_SYLLABICS_CE					 0x1489
#define Z_UNICODE_CANADIAN_SYLLABICS_CAAI				 0x148A
#define Z_UNICODE_CANADIAN_SYLLABICS_CI					 0x148B
#define Z_UNICODE_CANADIAN_SYLLABICS_CII				 0x148C
#define Z_UNICODE_CANADIAN_SYLLABICS_CO					 0x148D
#define Z_UNICODE_CANADIAN_SYLLABICS_COO				 0x148E
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_COO				 0x148F
#define Z_UNICODE_CANADIAN_SYLLABICS_CA					 0x1490
#define Z_UNICODE_CANADIAN_SYLLABICS_CAA				 0x1491
#define Z_UNICODE_CANADIAN_SYLLABICS_CWE				 0x1492
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_CWE			 0x1493
#define Z_UNICODE_CANADIAN_SYLLABICS_CWI				 0x1494
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_CWI			 0x1495
#define Z_UNICODE_CANADIAN_SYLLABICS_CWII				 0x1496
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_CWII			 0x1497
#define Z_UNICODE_CANADIAN_SYLLABICS_CWO				 0x1498
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_CWO			 0x1499
#define Z_UNICODE_CANADIAN_SYLLABICS_CWOO				 0x149A
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_CWOO			 0x149B
#define Z_UNICODE_CANADIAN_SYLLABICS_CWA				 0x149C
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_CWA			 0x149D
#define Z_UNICODE_CANADIAN_SYLLABICS_CWAA				 0x149E
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_CWAA			 0x149F
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_CWAA			 0x14A0
#define Z_UNICODE_CANADIAN_SYLLABICS_C					 0x14A1
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_TH				 0x14A2
#define Z_UNICODE_CANADIAN_SYLLABICS_ME					 0x14A3
#define Z_UNICODE_CANADIAN_SYLLABICS_MAAI				 0x14A4
#define Z_UNICODE_CANADIAN_SYLLABICS_MI					 0x14A5
#define Z_UNICODE_CANADIAN_SYLLABICS_MII				 0x14A6
#define Z_UNICODE_CANADIAN_SYLLABICS_MO					 0x14A7
#define Z_UNICODE_CANADIAN_SYLLABICS_MOO				 0x14A8
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_MOO				 0x14A9
#define Z_UNICODE_CANADIAN_SYLLABICS_MA					 0x14AA
#define Z_UNICODE_CANADIAN_SYLLABICS_MAA				 0x14AB
#define Z_UNICODE_CANADIAN_SYLLABICS_MWE				 0x14AC
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_MWE			 0x14AD
#define Z_UNICODE_CANADIAN_SYLLABICS_MWI				 0x14AE
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_MWI			 0x14AF
#define Z_UNICODE_CANADIAN_SYLLABICS_MWII				 0x14B0
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_MWII			 0x14B1
#define Z_UNICODE_CANADIAN_SYLLABICS_MWO				 0x14B2
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_MWO			 0x14B3
#define Z_UNICODE_CANADIAN_SYLLABICS_MWOO				 0x14B4
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_MWOO			 0x14B5
#define Z_UNICODE_CANADIAN_SYLLABICS_MWA				 0x14B6
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_MWA			 0x14B7
#define Z_UNICODE_CANADIAN_SYLLABICS_MWAA				 0x14B8
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_MWAA			 0x14B9
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_MWAA			 0x14BA
#define Z_UNICODE_CANADIAN_SYLLABICS_M					 0x14BB
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_M			 0x14BC
#define Z_UNICODE_CANADIAN_SYLLABICS_MH					 0x14BD
#define Z_UNICODE_CANADIAN_SYLLABICS_ATHAPASCAN_M			 0x14BE
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_M				 0x14BF
#define Z_UNICODE_CANADIAN_SYLLABICS_NE					 0x14C0
#define Z_UNICODE_CANADIAN_SYLLABICS_NAAI				 0x14C1
#define Z_UNICODE_CANADIAN_SYLLABICS_NI					 0x14C2
#define Z_UNICODE_CANADIAN_SYLLABICS_NII				 0x14C3
#define Z_UNICODE_CANADIAN_SYLLABICS_NO					 0x14C4
#define Z_UNICODE_CANADIAN_SYLLABICS_NOO				 0x14C5
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_NOO				 0x14C6
#define Z_UNICODE_CANADIAN_SYLLABICS_NA					 0x14C7
#define Z_UNICODE_CANADIAN_SYLLABICS_NAA				 0x14C8
#define Z_UNICODE_CANADIAN_SYLLABICS_NWE				 0x14C9
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_NWE			 0x14CA
#define Z_UNICODE_CANADIAN_SYLLABICS_NWA				 0x14CB
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_NWA			 0x14CC
#define Z_UNICODE_CANADIAN_SYLLABICS_NWAA				 0x14CD
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_NWAA			 0x14CE
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_NWAA			 0x14CF
#define Z_UNICODE_CANADIAN_SYLLABICS_N					 0x14D0
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_NG				 0x14D1
#define Z_UNICODE_CANADIAN_SYLLABICS_NH					 0x14D2
#define Z_UNICODE_CANADIAN_SYLLABICS_LE					 0x14D3
#define Z_UNICODE_CANADIAN_SYLLABICS_LAAI				 0x14D4
#define Z_UNICODE_CANADIAN_SYLLABICS_LI					 0x14D5
#define Z_UNICODE_CANADIAN_SYLLABICS_LII				 0x14D6
#define Z_UNICODE_CANADIAN_SYLLABICS_LO					 0x14D7
#define Z_UNICODE_CANADIAN_SYLLABICS_LOO				 0x14D8
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_LOO				 0x14D9
#define Z_UNICODE_CANADIAN_SYLLABICS_LA					 0x14DA
#define Z_UNICODE_CANADIAN_SYLLABICS_LAA				 0x14DB
#define Z_UNICODE_CANADIAN_SYLLABICS_LWE				 0x14DC
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LWE			 0x14DD
#define Z_UNICODE_CANADIAN_SYLLABICS_LWI				 0x14DE
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LWI			 0x14DF
#define Z_UNICODE_CANADIAN_SYLLABICS_LWII				 0x14E0
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LWII			 0x14E1
#define Z_UNICODE_CANADIAN_SYLLABICS_LWO				 0x14E2
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LWO			 0x14E3
#define Z_UNICODE_CANADIAN_SYLLABICS_LWOO				 0x14E4
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LWOO			 0x14E5
#define Z_UNICODE_CANADIAN_SYLLABICS_LWA				 0x14E6
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LWA			 0x14E7
#define Z_UNICODE_CANADIAN_SYLLABICS_LWAA				 0x14E8
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LWAA			 0x14E9
#define Z_UNICODE_CANADIAN_SYLLABICS_L					 0x14EA
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_L			 0x14EB
#define Z_UNICODE_CANADIAN_SYLLABICS_MEDIAL_L				 0x14EC
#define Z_UNICODE_CANADIAN_SYLLABICS_SE					 0x14ED
#define Z_UNICODE_CANADIAN_SYLLABICS_SAAI				 0x14EE
#define Z_UNICODE_CANADIAN_SYLLABICS_SI					 0x14EF
#define Z_UNICODE_CANADIAN_SYLLABICS_SII				 0x14F0
#define Z_UNICODE_CANADIAN_SYLLABICS_SO					 0x14F1
#define Z_UNICODE_CANADIAN_SYLLABICS_SOO				 0x14F2
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_SOO				 0x14F3
#define Z_UNICODE_CANADIAN_SYLLABICS_SA					 0x14F4
#define Z_UNICODE_CANADIAN_SYLLABICS_SAA				 0x14F5
#define Z_UNICODE_CANADIAN_SYLLABICS_SWE				 0x14F6
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SWE			 0x14F7
#define Z_UNICODE_CANADIAN_SYLLABICS_SWI				 0x14F8
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SWI			 0x14F9
#define Z_UNICODE_CANADIAN_SYLLABICS_SWII				 0x14FA
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SWII			 0x14FB
#define Z_UNICODE_CANADIAN_SYLLABICS_SWO				 0x14FC
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SWO			 0x14FD
#define Z_UNICODE_CANADIAN_SYLLABICS_SWOO				 0x14FE
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SWOO			 0x14FF
#define Z_UNICODE_CANADIAN_SYLLABICS_SWA				 0x1500
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SWA			 0x1501
#define Z_UNICODE_CANADIAN_SYLLABICS_SWAA				 0x1502
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SWAA			 0x1503
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_SWAA			 0x1504
#define Z_UNICODE_CANADIAN_SYLLABICS_S					 0x1505
#define Z_UNICODE_CANADIAN_SYLLABICS_ATHAPASCAN_S			 0x1506
#define Z_UNICODE_CANADIAN_SYLLABICS_SW					 0x1507
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_S			 0x1508
#define Z_UNICODE_CANADIAN_SYLLABICS_MOOSE_CREE_SK			 0x1509
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_SKW			 0x150A
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_S_W			 0x150B
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_SPWA			 0x150C
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_STWA			 0x150D
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_SKWA			 0x150E
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_SCWA			 0x150F
#define Z_UNICODE_CANADIAN_SYLLABICS_SHE				 0x1510
#define Z_UNICODE_CANADIAN_SYLLABICS_SHI				 0x1511
#define Z_UNICODE_CANADIAN_SYLLABICS_SHII				 0x1512
#define Z_UNICODE_CANADIAN_SYLLABICS_SHO				 0x1513
#define Z_UNICODE_CANADIAN_SYLLABICS_SHOO				 0x1514
#define Z_UNICODE_CANADIAN_SYLLABICS_SHA				 0x1515
#define Z_UNICODE_CANADIAN_SYLLABICS_SHAA				 0x1516
#define Z_UNICODE_CANADIAN_SYLLABICS_SHWE				 0x1517
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SHWE			 0x1518
#define Z_UNICODE_CANADIAN_SYLLABICS_SHWI				 0x1519
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SHWI			 0x151A
#define Z_UNICODE_CANADIAN_SYLLABICS_SHWII				 0x151B
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SHWII			 0x151C
#define Z_UNICODE_CANADIAN_SYLLABICS_SHWO				 0x151D
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SHWO			 0x151E
#define Z_UNICODE_CANADIAN_SYLLABICS_SHWOO				 0x151F
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SHWOO			 0x1520
#define Z_UNICODE_CANADIAN_SYLLABICS_SHWA				 0x1521
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SHWA			 0x1522
#define Z_UNICODE_CANADIAN_SYLLABICS_SHWAA				 0x1523
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_SHWAA			 0x1524
#define Z_UNICODE_CANADIAN_SYLLABICS_SH					 0x1525
#define Z_UNICODE_CANADIAN_SYLLABICS_YE					 0x1526
#define Z_UNICODE_CANADIAN_SYLLABICS_YAAI				 0x1527
#define Z_UNICODE_CANADIAN_SYLLABICS_YI					 0x1528
#define Z_UNICODE_CANADIAN_SYLLABICS_YII				 0x1529
#define Z_UNICODE_CANADIAN_SYLLABICS_YO					 0x152A
#define Z_UNICODE_CANADIAN_SYLLABICS_YOO				 0x152B
#define Z_UNICODE_CANADIAN_SYLLABICS_Y_CREE_YOO				 0x152C
#define Z_UNICODE_CANADIAN_SYLLABICS_YA					 0x152D
#define Z_UNICODE_CANADIAN_SYLLABICS_YAA				 0x152E
#define Z_UNICODE_CANADIAN_SYLLABICS_YWE				 0x152F
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_YWE			 0x1530
#define Z_UNICODE_CANADIAN_SYLLABICS_YWI				 0x1531
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_YWI			 0x1532
#define Z_UNICODE_CANADIAN_SYLLABICS_YWII				 0x1533
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_YWII			 0x1534
#define Z_UNICODE_CANADIAN_SYLLABICS_YWO				 0x1535
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_YWO			 0x1536
#define Z_UNICODE_CANADIAN_SYLLABICS_YWOO				 0x1537
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_YWOO			 0x1538
#define Z_UNICODE_CANADIAN_SYLLABICS_YWA				 0x1539
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_YWA			 0x153A
#define Z_UNICODE_CANADIAN_SYLLABICS_YWAA				 0x153B
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_YWAA			 0x153C
#define Z_UNICODE_CANADIAN_SYLLABICS_NASKAPI_YWAA			 0x153D
#define Z_UNICODE_CANADIAN_SYLLABICS_Y					 0x153E
#define Z_UNICODE_CANADIAN_SYLLABICS_BIBLE_CREE_Y			 0x153F
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_Y			 0x1540
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_YI				 0x1541
#define Z_UNICODE_CANADIAN_SYLLABICS_RE					 0x1542
#define Z_UNICODE_CANADIAN_SYLLABICS_R_CREE_RE				 0x1543
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LE			 0x1544
#define Z_UNICODE_CANADIAN_SYLLABICS_RAAI				 0x1545
#define Z_UNICODE_CANADIAN_SYLLABICS_RI					 0x1546
#define Z_UNICODE_CANADIAN_SYLLABICS_RII				 0x1547
#define Z_UNICODE_CANADIAN_SYLLABICS_RO					 0x1548
#define Z_UNICODE_CANADIAN_SYLLABICS_ROO				 0x1549
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LO			 0x154A
#define Z_UNICODE_CANADIAN_SYLLABICS_RA					 0x154B
#define Z_UNICODE_CANADIAN_SYLLABICS_RAA				 0x154C
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LA			 0x154D
#define Z_UNICODE_CANADIAN_SYLLABICS_RWAA				 0x154E
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_RWAA			 0x154F
#define Z_UNICODE_CANADIAN_SYLLABICS_R					 0x1550
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_R			 0x1551
#define Z_UNICODE_CANADIAN_SYLLABICS_MEDIAL_R				 0x1552
#define Z_UNICODE_CANADIAN_SYLLABICS_FE					 0x1553
#define Z_UNICODE_CANADIAN_SYLLABICS_FAAI				 0x1554
#define Z_UNICODE_CANADIAN_SYLLABICS_FI					 0x1555
#define Z_UNICODE_CANADIAN_SYLLABICS_FII				 0x1556
#define Z_UNICODE_CANADIAN_SYLLABICS_FO					 0x1557
#define Z_UNICODE_CANADIAN_SYLLABICS_FOO				 0x1558
#define Z_UNICODE_CANADIAN_SYLLABICS_FA					 0x1559
#define Z_UNICODE_CANADIAN_SYLLABICS_FAA				 0x155A
#define Z_UNICODE_CANADIAN_SYLLABICS_FWAA				 0x155B
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_FWAA			 0x155C
#define Z_UNICODE_CANADIAN_SYLLABICS_F					 0x155D
#define Z_UNICODE_CANADIAN_SYLLABICS_THE				 0x155E
#define Z_UNICODE_CANADIAN_SYLLABICS_N_CREE_THE				 0x155F
#define Z_UNICODE_CANADIAN_SYLLABICS_THI				 0x1560
#define Z_UNICODE_CANADIAN_SYLLABICS_N_CREE_THI				 0x1561
#define Z_UNICODE_CANADIAN_SYLLABICS_THII				 0x1562
#define Z_UNICODE_CANADIAN_SYLLABICS_N_CREE_THII			 0x1563
#define Z_UNICODE_CANADIAN_SYLLABICS_THO				 0x1564
#define Z_UNICODE_CANADIAN_SYLLABICS_THOO				 0x1565
#define Z_UNICODE_CANADIAN_SYLLABICS_THA				 0x1566
#define Z_UNICODE_CANADIAN_SYLLABICS_THAA				 0x1567
#define Z_UNICODE_CANADIAN_SYLLABICS_THWAA				 0x1568
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_THWAA			 0x1569
#define Z_UNICODE_CANADIAN_SYLLABICS_TH					 0x156A
#define Z_UNICODE_CANADIAN_SYLLABICS_TTHE				 0x156B
#define Z_UNICODE_CANADIAN_SYLLABICS_TTHI				 0x156C
#define Z_UNICODE_CANADIAN_SYLLABICS_TTHO				 0x156D
#define Z_UNICODE_CANADIAN_SYLLABICS_TTHA				 0x156E
#define Z_UNICODE_CANADIAN_SYLLABICS_TTH				 0x156F
#define Z_UNICODE_CANADIAN_SYLLABICS_TYE				 0x1570
#define Z_UNICODE_CANADIAN_SYLLABICS_TYI				 0x1571
#define Z_UNICODE_CANADIAN_SYLLABICS_TYO				 0x1572
#define Z_UNICODE_CANADIAN_SYLLABICS_TYA				 0x1573
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVIK_HE				 0x1574
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVIK_HI				 0x1575
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVIK_HII			 0x1576
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVIK_HO				 0x1577
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVIK_HOO			 0x1578
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVIK_HA				 0x1579
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVIK_HAA			 0x157A
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVIK_H				 0x157B
#define Z_UNICODE_CANADIAN_SYLLABICS_NUNAVUT_H				 0x157C
#define Z_UNICODE_CANADIAN_SYLLABICS_HK					 0x157D
#define Z_UNICODE_CANADIAN_SYLLABICS_QAAI				 0x157E
#define Z_UNICODE_CANADIAN_SYLLABICS_QI					 0x157F
#define Z_UNICODE_CANADIAN_SYLLABICS_QII				 0x1580
#define Z_UNICODE_CANADIAN_SYLLABICS_QO					 0x1581
#define Z_UNICODE_CANADIAN_SYLLABICS_QOO				 0x1582
#define Z_UNICODE_CANADIAN_SYLLABICS_QA					 0x1583
#define Z_UNICODE_CANADIAN_SYLLABICS_QAA				 0x1584
#define Z_UNICODE_CANADIAN_SYLLABICS_Q					 0x1585
#define Z_UNICODE_CANADIAN_SYLLABICS_TLHE				 0x1586
#define Z_UNICODE_CANADIAN_SYLLABICS_TLHI				 0x1587
#define Z_UNICODE_CANADIAN_SYLLABICS_TLHO				 0x1588
#define Z_UNICODE_CANADIAN_SYLLABICS_TLHA				 0x1589
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_RE			 0x158A
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_RI			 0x158B
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_RO			 0x158C
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_RA			 0x158D
#define Z_UNICODE_CANADIAN_SYLLABICS_NGAAI				 0x158E
#define Z_UNICODE_CANADIAN_SYLLABICS_NGI				 0x158F
#define Z_UNICODE_CANADIAN_SYLLABICS_NGII				 0x1590
#define Z_UNICODE_CANADIAN_SYLLABICS_NGO				 0x1591
#define Z_UNICODE_CANADIAN_SYLLABICS_NGOO				 0x1592
#define Z_UNICODE_CANADIAN_SYLLABICS_NGA				 0x1593
#define Z_UNICODE_CANADIAN_SYLLABICS_NGAA				 0x1594
#define Z_UNICODE_CANADIAN_SYLLABICS_NG					 0x1595
#define Z_UNICODE_CANADIAN_SYLLABICS_NNG				 0x1596
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_SHE				 0x1597
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_SHI				 0x1598
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_SHO				 0x1599
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_SHA				 0x159A
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THE			 0x159B
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THI			 0x159C
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THO			 0x159D
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THA			 0x159E
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_TH			 0x159F
#define Z_UNICODE_CANADIAN_SYLLABICS_LHI				 0x15A0
#define Z_UNICODE_CANADIAN_SYLLABICS_LHII				 0x15A1
#define Z_UNICODE_CANADIAN_SYLLABICS_LHO				 0x15A2
#define Z_UNICODE_CANADIAN_SYLLABICS_LHOO				 0x15A3
#define Z_UNICODE_CANADIAN_SYLLABICS_LHA				 0x15A4
#define Z_UNICODE_CANADIAN_SYLLABICS_LHAA				 0x15A5
#define Z_UNICODE_CANADIAN_SYLLABICS_LH					 0x15A6
#define Z_UNICODE_CANADIAN_SYLLABICS_TH_CREE_THE			 0x15A7
#define Z_UNICODE_CANADIAN_SYLLABICS_TH_CREE_THI			 0x15A8
#define Z_UNICODE_CANADIAN_SYLLABICS_TH_CREE_THII			 0x15A9
#define Z_UNICODE_CANADIAN_SYLLABICS_TH_CREE_THO			 0x15AA
#define Z_UNICODE_CANADIAN_SYLLABICS_TH_CREE_THOO			 0x15AB
#define Z_UNICODE_CANADIAN_SYLLABICS_TH_CREE_THA			 0x15AC
#define Z_UNICODE_CANADIAN_SYLLABICS_TH_CREE_THAA			 0x15AD
#define Z_UNICODE_CANADIAN_SYLLABICS_TH_CREE_TH				 0x15AE
#define Z_UNICODE_CANADIAN_SYLLABICS_AIVILIK_B				 0x15AF
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_E			 0x15B0
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_I			 0x15B1
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_O			 0x15B2
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_A			 0x15B3
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_WE			 0x15B4
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_WI			 0x15B5
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_WO			 0x15B6
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_WA			 0x15B7
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_NE			 0x15B8
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_NI			 0x15B9
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_NO			 0x15BA
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_NA			 0x15BB
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_KE			 0x15BC
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_KI			 0x15BD
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_KO			 0x15BE
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_KA			 0x15BF
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_HE				 0x15C0
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_HI				 0x15C1
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_HO				 0x15C2
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_HA				 0x15C3
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GHU			 0x15C4
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GHO			 0x15C5
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GHE			 0x15C6
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GHEE			 0x15C7
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GHI			 0x15C8
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GHA			 0x15C9
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_RU				 0x15CA
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_RO				 0x15CB
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_RE				 0x15CC
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_REE			 0x15CD
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_RI				 0x15CE
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_RA				 0x15CF
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_WU				 0x15D0
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_WO				 0x15D1
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_WE				 0x15D2
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_WEE			 0x15D3
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_WI				 0x15D4
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_WA				 0x15D5
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_HWU			 0x15D6
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_HWO			 0x15D7
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_HWE			 0x15D8
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_HWEE			 0x15D9
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_HWI			 0x15DA
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_HWA			 0x15DB
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_THU			 0x15DC
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_THO			 0x15DD
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_THE			 0x15DE
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_THEE			 0x15DF
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_THI			 0x15E0
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_THA			 0x15E1
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTU			 0x15E2
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTO			 0x15E3
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTE			 0x15E4
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTEE			 0x15E5
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTI			 0x15E6
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTA			 0x15E7
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_PU				 0x15E8
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_PO				 0x15E9
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_PE				 0x15EA
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_PEE			 0x15EB
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_PI				 0x15EC
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_PA				 0x15ED
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_P				 0x15EE
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GU				 0x15EF
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GO				 0x15F0
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GE				 0x15F1
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GEE			 0x15F2
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GI				 0x15F3
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GA				 0x15F4
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KHU			 0x15F5
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KHO			 0x15F6
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KHE			 0x15F7
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KHEE			 0x15F8
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KHI			 0x15F9
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KHA			 0x15FA
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KKU			 0x15FB
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KKO			 0x15FC
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KKE			 0x15FD
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KKEE			 0x15FE
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KKI			 0x15FF
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KKA			 0x1600
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_KK				 0x1601
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_NU				 0x1602
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_NO				 0x1603
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_NE				 0x1604
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_NEE			 0x1605
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_NI				 0x1606
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_NA				 0x1607
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_MU				 0x1608
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_MO				 0x1609
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_ME				 0x160A
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_MEE			 0x160B
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_MI				 0x160C
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_MA				 0x160D
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_YU				 0x160E
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_YO				 0x160F
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_YE				 0x1610
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_YEE			 0x1611
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_YI				 0x1612
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_YA				 0x1613
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JU				 0x1614
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_JU				 0x1615
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JO				 0x1616
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JE				 0x1617
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JEE			 0x1618
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JI				 0x1619
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_JI				 0x161A
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JA				 0x161B
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JJU			 0x161C
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JJO			 0x161D
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JJE			 0x161E
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JJEE			 0x161F
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JJI			 0x1620
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JJA			 0x1621
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LU				 0x1622
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LO				 0x1623
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LE				 0x1624
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LEE			 0x1625
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LI				 0x1626
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LA				 0x1627
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DLU			 0x1628
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DLO			 0x1629
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DLE			 0x162A
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DLEE			 0x162B
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DLI			 0x162C
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DLA			 0x162D
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LHU			 0x162E
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LHO			 0x162F
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LHE			 0x1630
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LHEE			 0x1631
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LHI			 0x1632
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_LHA			 0x1633
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLHU			 0x1634
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLHO			 0x1635
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLHE			 0x1636
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLHEE			 0x1637
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLHI			 0x1638
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLHA			 0x1639
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLU			 0x163A
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLO			 0x163B
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLE			 0x163C
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLEE			 0x163D
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLI			 0x163E
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TLA			 0x163F
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_ZU				 0x1640
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_ZO				 0x1641
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_ZE				 0x1642
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_ZEE			 0x1643
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_ZI				 0x1644
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_ZA				 0x1645
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_Z				 0x1646
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_INITIAL_Z			 0x1647
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DZU			 0x1648
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DZO			 0x1649
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DZE			 0x164A
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DZEE			 0x164B
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DZI			 0x164C
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DZA			 0x164D
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SU				 0x164E
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SO				 0x164F
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SE				 0x1650
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SEE			 0x1651
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SI				 0x1652
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SA				 0x1653
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SHU			 0x1654
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SHO			 0x1655
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SHE			 0x1656
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SHEE			 0x1657
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SHI			 0x1658
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SHA			 0x1659
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_SH				 0x165A
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TSU			 0x165B
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TSO			 0x165C
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TSE			 0x165D
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TSEE			 0x165E
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TSI			 0x165F
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TSA			 0x1660
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_CHU			 0x1661
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_CHO			 0x1662
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_CHE			 0x1663
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_CHEE			 0x1664
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_CHI			 0x1665
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_CHA			 0x1666
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTSU			 0x1667
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTSO			 0x1668
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTSE			 0x1669
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTSEE			 0x166A
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTSI			 0x166B
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_TTSA			 0x166C
#define Z_UNICODE_CANADIAN_SYLLABICS_CHI_SIGN				 0x166D
#define Z_UNICODE_CANADIAN_SYLLABICS_FULL_STOP				 0x166E
#define Z_UNICODE_CANADIAN_SYLLABICS_QAI				 0x166F
#define Z_UNICODE_CANADIAN_SYLLABICS_NGAI				 0x1670
#define Z_UNICODE_CANADIAN_SYLLABICS_NNGI				 0x1671
#define Z_UNICODE_CANADIAN_SYLLABICS_NNGII				 0x1672
#define Z_UNICODE_CANADIAN_SYLLABICS_NNGO				 0x1673
#define Z_UNICODE_CANADIAN_SYLLABICS_NNGOO				 0x1674
#define Z_UNICODE_CANADIAN_SYLLABICS_NNGA				 0x1675
#define Z_UNICODE_CANADIAN_SYLLABICS_NNGAA				 0x1676
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THWEE			 0x1677
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THWI			 0x1678
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THWII			 0x1679
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THWO			 0x167A
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THWOO			 0x167B
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THWA			 0x167C
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_THWAA			 0x167D
#define Z_UNICODE_CANADIAN_SYLLABICS_WOODS_CREE_FINAL_TH		 0x167E
#define Z_UNICODE_CANADIAN_SYLLABICS_BLACKFOOT_W			 0x167F

/* MARK: - 1680h-169Fh - Ogham */

#define Z_UNICODE_OGHAM_SPACE_MARK	      0x1680
#define Z_UNICODE_OGHAM_LETTER_BEITH	      0x1681
#define Z_UNICODE_OGHAM_LETTER_LUIS	      0x1682
#define Z_UNICODE_OGHAM_LETTER_FEARN	      0x1683
#define Z_UNICODE_OGHAM_LETTER_SAIL	      0x1684
#define Z_UNICODE_OGHAM_LETTER_NION	      0x1685
#define Z_UNICODE_OGHAM_LETTER_UATH	      0x1686
#define Z_UNICODE_OGHAM_LETTER_DAIR	      0x1687
#define Z_UNICODE_OGHAM_LETTER_TINNE	      0x1688
#define Z_UNICODE_OGHAM_LETTER_COLL	      0x1689
#define Z_UNICODE_OGHAM_LETTER_CEIRT	      0x168A
#define Z_UNICODE_OGHAM_LETTER_MUIN	      0x168B
#define Z_UNICODE_OGHAM_LETTER_GORT	      0x168C
#define Z_UNICODE_OGHAM_LETTER_NGEADAL	      0x168D
#define Z_UNICODE_OGHAM_LETTER_STRAIF	      0x168E
#define Z_UNICODE_OGHAM_LETTER_RUIS	      0x168F
#define Z_UNICODE_OGHAM_LETTER_AILM	      0x1690
#define Z_UNICODE_OGHAM_LETTER_ONN	      0x1691
#define Z_UNICODE_OGHAM_LETTER_UR	      0x1692
#define Z_UNICODE_OGHAM_LETTER_EADHADH	      0x1693
#define Z_UNICODE_OGHAM_LETTER_IODHADH	      0x1694
#define Z_UNICODE_OGHAM_LETTER_EABHADH	      0x1695
#define Z_UNICODE_OGHAM_LETTER_OR	      0x1696
#define Z_UNICODE_OGHAM_LETTER_UILLEANN	      0x1697
#define Z_UNICODE_OGHAM_LETTER_IFIN	      0x1698
#define Z_UNICODE_OGHAM_LETTER_EAMHANCHOLL    0x1699
#define Z_UNICODE_OGHAM_LETTER_PEITH	      0x169A
#define Z_UNICODE_OGHAM_FEATHER_MARK	      0x169B
#define Z_UNICODE_OGHAM_REVERSED_FEATHER_MARK 0x169C

/* MARK: - 16A0h-16FFh - Runic */

#define Z_UNICODE_RUNIC_LETTER_FEHU_FEOH_FE_F		0x16A0
#define Z_UNICODE_RUNIC_LETTER_V			0x16A1
#define Z_UNICODE_RUNIC_LETTER_URUZ_UR_U		0x16A2
#define Z_UNICODE_RUNIC_LETTER_YR			0x16A3
#define Z_UNICODE_RUNIC_LETTER_Y			0x16A4
#define Z_UNICODE_RUNIC_LETTER_W			0x16A5
#define Z_UNICODE_RUNIC_LETTER_THURISAZ_THURS_THORN	0x16A6
#define Z_UNICODE_RUNIC_LETTER_ETH			0x16A7
#define Z_UNICODE_RUNIC_LETTER_ANSUZ_A			0x16A8
#define Z_UNICODE_RUNIC_LETTER_OS_O			0x16A9
#define Z_UNICODE_RUNIC_LETTER_AC_A			0x16AA
#define Z_UNICODE_RUNIC_LETTER_AESC			0x16AB
#define Z_UNICODE_RUNIC_LETTER_LONG_BRANCH_OSS_O	0x16AC
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_OSS_O		0x16AD
#define Z_UNICODE_RUNIC_LETTER_O			0x16AE
#define Z_UNICODE_RUNIC_LETTER_OE			0x16AF
#define Z_UNICODE_RUNIC_LETTER_ON			0x16B0
#define Z_UNICODE_RUNIC_LETTER_RAIDO_RAD_REID_R		0x16B1
#define Z_UNICODE_RUNIC_LETTER_KAUNA			0x16B2
#define Z_UNICODE_RUNIC_LETTER_CEN			0x16B3
#define Z_UNICODE_RUNIC_LETTER_KAUN_K			0x16B4
#define Z_UNICODE_RUNIC_LETTER_G			0x16B5
#define Z_UNICODE_RUNIC_LETTER_ENG			0x16B6
#define Z_UNICODE_RUNIC_LETTER_GEBO_GYFU_G		0x16B7
#define Z_UNICODE_RUNIC_LETTER_GAR			0x16B8
#define Z_UNICODE_RUNIC_LETTER_WUNJO_WYNN_W		0x16B9
#define Z_UNICODE_RUNIC_LETTER_HAGLAZ_H			0x16BA
#define Z_UNICODE_RUNIC_LETTER_HAEGL_H			0x16BB
#define Z_UNICODE_RUNIC_LETTER_LONG_BRANCH_HAGALL_H	0x16BC
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_HAGALL_H	0x16BD
#define Z_UNICODE_RUNIC_LETTER_NAUDIZ_NYD_NAUD_N	0x16BE
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_NAUD_N	0x16BF
#define Z_UNICODE_RUNIC_LETTER_DOTTED_N			0x16C0
#define Z_UNICODE_RUNIC_LETTER_ISAZ_IS_ISS_I		0x16C1
#define Z_UNICODE_RUNIC_LETTER_E			0x16C2
#define Z_UNICODE_RUNIC_LETTER_JERAN_J			0x16C3
#define Z_UNICODE_RUNIC_LETTER_GER			0x16C4
#define Z_UNICODE_RUNIC_LETTER_LONG_BRANCH_AR_AE	0x16C5
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_AR_A		0x16C6
#define Z_UNICODE_RUNIC_LETTER_IWAZ_EOH			0x16C7
#define Z_UNICODE_RUNIC_LETTER_PERTHO_PEORTH_P		0x16C8
#define Z_UNICODE_RUNIC_LETTER_ALGIZ_EOLHX		0x16C9
#define Z_UNICODE_RUNIC_LETTER_SOWILO_S			0x16CA
#define Z_UNICODE_RUNIC_LETTER_SIGEL_LONG_BRANCH_SOL_S	0x16CB
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_SOL_S		0x16CC
#define Z_UNICODE_RUNIC_LETTER_C			0x16CD
#define Z_UNICODE_RUNIC_LETTER_Z			0x16CE
#define Z_UNICODE_RUNIC_LETTER_TIWAZ_TIR_TYR_T		0x16CF
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_TYR_T		0x16D0
#define Z_UNICODE_RUNIC_LETTER_D			0x16D1
#define Z_UNICODE_RUNIC_LETTER_BERKANAN_BEORC_BJARKAN_B	0x16D2
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_BJARKAN_B	0x16D3
#define Z_UNICODE_RUNIC_LETTER_DOTTED_P			0x16D4
#define Z_UNICODE_RUNIC_LETTER_OPEN_P			0x16D5
#define Z_UNICODE_RUNIC_LETTER_EHWAZ_EH_E		0x16D6
#define Z_UNICODE_RUNIC_LETTER_MANNAZ_MAN_M		0x16D7
#define Z_UNICODE_RUNIC_LETTER_LONG_BRANCH_MADR_M	0x16D8
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_MADR_M	0x16D9
#define Z_UNICODE_RUNIC_LETTER_LAUKAZ_LAGU_LOGR_L	0x16DA
#define Z_UNICODE_RUNIC_LETTER_DOTTED_L			0x16DB
#define Z_UNICODE_RUNIC_LETTER_INGWAZ			0x16DC
#define Z_UNICODE_RUNIC_LETTER_ING			0x16DD
#define Z_UNICODE_RUNIC_LETTER_DAGAZ_DAEG_D		0x16DE
#define Z_UNICODE_RUNIC_LETTER_OTHALAN_ETHEL_O		0x16DF
#define Z_UNICODE_RUNIC_LETTER_EAR			0x16E0
#define Z_UNICODE_RUNIC_LETTER_IOR			0x16E1
#define Z_UNICODE_RUNIC_LETTER_CWEORTH			0x16E2
#define Z_UNICODE_RUNIC_LETTER_CALC			0x16E3
#define Z_UNICODE_RUNIC_LETTER_CEALC			0x16E4
#define Z_UNICODE_RUNIC_LETTER_STAN			0x16E5
#define Z_UNICODE_RUNIC_LETTER_LONG_BRANCH_YR		0x16E6
#define Z_UNICODE_RUNIC_LETTER_SHORT_TWIG_YR		0x16E7
#define Z_UNICODE_RUNIC_LETTER_ICELANDIC_YR		0x16E8
#define Z_UNICODE_RUNIC_LETTER_Q			0x16E9
#define Z_UNICODE_RUNIC_LETTER_X			0x16EA
#define Z_UNICODE_RUNIC_SINGLE_PUNCTUATION		0x16EB
#define Z_UNICODE_RUNIC_MULTIPLE_PUNCTUATION		0x16EC
#define Z_UNICODE_RUNIC_CROSS_PUNCTUATION		0x16ED
#define Z_UNICODE_RUNIC_ARLAUG_SYMBOL			0x16EE
#define Z_UNICODE_RUNIC_TVIMADUR_SYMBOL			0x16EF
#define Z_UNICODE_RUNIC_BELGTHOR_SYMBOL			0x16F0
#define Z_UNICODE_RUNIC_LETTER_K			0x16F1
#define Z_UNICODE_RUNIC_LETTER_SH			0x16F2
#define Z_UNICODE_RUNIC_LETTER_OO			0x16F3
#define Z_UNICODE_RUNIC_LETTER_FRANKS_CASKET_OS		0x16F4
#define Z_UNICODE_RUNIC_LETTER_FRANKS_CASKET_IS		0x16F5
#define Z_UNICODE_RUNIC_LETTER_FRANKS_CASKET_EH		0x16F6
#define Z_UNICODE_RUNIC_LETTER_FRANKS_CASKET_AC		0x16F7
#define Z_UNICODE_RUNIC_LETTER_FRANKS_CASKET_AESC	0x16F8

/* MARK: - 1700h-171Fh - Tagalog */

#define Z_UNICODE_TAGALOG_LETTER_A     0x1700
#define Z_UNICODE_TAGALOG_LETTER_I     0x1701
#define Z_UNICODE_TAGALOG_LETTER_U     0x1702
#define Z_UNICODE_TAGALOG_LETTER_KA    0x1703
#define Z_UNICODE_TAGALOG_LETTER_GA    0x1704
#define Z_UNICODE_TAGALOG_LETTER_NGA   0x1705
#define Z_UNICODE_TAGALOG_LETTER_TA    0x1706
#define Z_UNICODE_TAGALOG_LETTER_DA    0x1707
#define Z_UNICODE_TAGALOG_LETTER_NA    0x1708
#define Z_UNICODE_TAGALOG_LETTER_PA    0x1709
#define Z_UNICODE_TAGALOG_LETTER_BA    0x170A
#define Z_UNICODE_TAGALOG_LETTER_MA    0x170B
#define Z_UNICODE_TAGALOG_LETTER_YA    0x170C
#define Z_UNICODE_TAGALOG_LETTER_LA    0x170E
#define Z_UNICODE_TAGALOG_LETTER_WA    0x170F
#define Z_UNICODE_TAGALOG_LETTER_SA    0x1710
#define Z_UNICODE_TAGALOG_LETTER_HA    0x1711
#define Z_UNICODE_TAGALOG_VOWEL_SIGN_I 0x1712
#define Z_UNICODE_TAGALOG_VOWEL_SIGN_U 0x1713
#define Z_UNICODE_TAGALOG_SIGN_VIRAMA  0x1714

/* MARK: - 1720h-173Fh - Hanunoo */

#define Z_UNICODE_HANUNOO_LETTER_A		0x1720
#define Z_UNICODE_HANUNOO_LETTER_I		0x1721
#define Z_UNICODE_HANUNOO_LETTER_U		0x1722
#define Z_UNICODE_HANUNOO_LETTER_KA		0x1723
#define Z_UNICODE_HANUNOO_LETTER_GA		0x1724
#define Z_UNICODE_HANUNOO_LETTER_NGA		0x1725
#define Z_UNICODE_HANUNOO_LETTER_TA		0x1726
#define Z_UNICODE_HANUNOO_LETTER_DA		0x1727
#define Z_UNICODE_HANUNOO_LETTER_NA		0x1728
#define Z_UNICODE_HANUNOO_LETTER_PA		0x1729
#define Z_UNICODE_HANUNOO_LETTER_BA		0x172A
#define Z_UNICODE_HANUNOO_LETTER_MA		0x172B
#define Z_UNICODE_HANUNOO_LETTER_YA		0x172C
#define Z_UNICODE_HANUNOO_LETTER_RA		0x172D
#define Z_UNICODE_HANUNOO_LETTER_LA		0x172E
#define Z_UNICODE_HANUNOO_LETTER_WA		0x172F
#define Z_UNICODE_HANUNOO_LETTER_SA		0x1730
#define Z_UNICODE_HANUNOO_LETTER_HA		0x1731
#define Z_UNICODE_HANUNOO_VOWEL_SIGN_I		0x1732
#define Z_UNICODE_HANUNOO_VOWEL_SIGN_U		0x1733
#define Z_UNICODE_HANUNOO_SIGN_PAMUDPOD		0x1734
#define Z_UNICODE_PHILIPPINE_SINGLE_PUNCTUATION	0x1735
#define Z_UNICODE_PHILIPPINE_DOUBLE_PUNCTUATION	0x1736

/* MARK: - 1740h-175Fh - Buhid */

#define Z_UNICODE_BUHID_LETTER_A     0x1740
#define Z_UNICODE_BUHID_LETTER_I     0x1741
#define Z_UNICODE_BUHID_LETTER_U     0x1742
#define Z_UNICODE_BUHID_LETTER_KA    0x1743
#define Z_UNICODE_BUHID_LETTER_GA    0x1744
#define Z_UNICODE_BUHID_LETTER_NGA   0x1745
#define Z_UNICODE_BUHID_LETTER_TA    0x1746
#define Z_UNICODE_BUHID_LETTER_DA    0x1747
#define Z_UNICODE_BUHID_LETTER_NA    0x1748
#define Z_UNICODE_BUHID_LETTER_PA    0x1749
#define Z_UNICODE_BUHID_LETTER_BA    0x174A
#define Z_UNICODE_BUHID_LETTER_MA    0x174B
#define Z_UNICODE_BUHID_LETTER_YA    0x174C
#define Z_UNICODE_BUHID_LETTER_RA    0x174D
#define Z_UNICODE_BUHID_LETTER_LA    0x174E
#define Z_UNICODE_BUHID_LETTER_WA    0x174F
#define Z_UNICODE_BUHID_LETTER_SA    0x1750
#define Z_UNICODE_BUHID_LETTER_HA    0x1751
#define Z_UNICODE_BUHID_VOWEL_SIGN_I 0x1752
#define Z_UNICODE_BUHID_VOWEL_SIGN_U 0x1753

/* MARK: - 1760h-177Fh - Tagbanwa */

#define Z_UNICODE_TAGBANWA_LETTER_A	0x1760
#define Z_UNICODE_TAGBANWA_LETTER_I	0x1761
#define Z_UNICODE_TAGBANWA_LETTER_U	0x1762
#define Z_UNICODE_TAGBANWA_LETTER_KA	0x1763
#define Z_UNICODE_TAGBANWA_LETTER_GA	0x1764
#define Z_UNICODE_TAGBANWA_LETTER_NGA	0x1765
#define Z_UNICODE_TAGBANWA_LETTER_TA	0x1766
#define Z_UNICODE_TAGBANWA_LETTER_DA	0x1767
#define Z_UNICODE_TAGBANWA_LETTER_NA	0x1768
#define Z_UNICODE_TAGBANWA_LETTER_PA	0x1769
#define Z_UNICODE_TAGBANWA_LETTER_BA	0x176A
#define Z_UNICODE_TAGBANWA_LETTER_MA	0x176B
#define Z_UNICODE_TAGBANWA_LETTER_YA	0x176C
#define Z_UNICODE_TAGBANWA_LETTER_LA	0x176E
#define Z_UNICODE_TAGBANWA_LETTER_WA	0x176F
#define Z_UNICODE_TAGBANWA_LETTER_SA	0x1770
#define Z_UNICODE_TAGBANWA_VOWEL_SIGN_I	0x1772
#define Z_UNICODE_TAGBANWA_VOWEL_SIGN_U	0x1773

/* MARK: - 1780h-17FFh - Khmer */

#define Z_UNICODE_KHMER_LETTER_KA		       0x1780
#define Z_UNICODE_KHMER_LETTER_KHA		       0x1781
#define Z_UNICODE_KHMER_LETTER_KO		       0x1782
#define Z_UNICODE_KHMER_LETTER_KHO		       0x1783
#define Z_UNICODE_KHMER_LETTER_NGO		       0x1784
#define Z_UNICODE_KHMER_LETTER_CA		       0x1785
#define Z_UNICODE_KHMER_LETTER_CHA		       0x1786
#define Z_UNICODE_KHMER_LETTER_CO		       0x1787
#define Z_UNICODE_KHMER_LETTER_CHO		       0x1788
#define Z_UNICODE_KHMER_LETTER_NYO		       0x1789
#define Z_UNICODE_KHMER_LETTER_DA		       0x178A
#define Z_UNICODE_KHMER_LETTER_TTHA		       0x178B
#define Z_UNICODE_KHMER_LETTER_DO		       0x178C
#define Z_UNICODE_KHMER_LETTER_TTHO		       0x178D
#define Z_UNICODE_KHMER_LETTER_NNO		       0x178E
#define Z_UNICODE_KHMER_LETTER_TA		       0x178F
#define Z_UNICODE_KHMER_LETTER_THA		       0x1790
#define Z_UNICODE_KHMER_LETTER_TO		       0x1791
#define Z_UNICODE_KHMER_LETTER_THO		       0x1792
#define Z_UNICODE_KHMER_LETTER_NO		       0x1793
#define Z_UNICODE_KHMER_LETTER_BA		       0x1794
#define Z_UNICODE_KHMER_LETTER_PHA		       0x1795
#define Z_UNICODE_KHMER_LETTER_PO		       0x1796
#define Z_UNICODE_KHMER_LETTER_PHO		       0x1797
#define Z_UNICODE_KHMER_LETTER_MO		       0x1798
#define Z_UNICODE_KHMER_LETTER_YO		       0x1799
#define Z_UNICODE_KHMER_LETTER_RO		       0x179A
#define Z_UNICODE_KHMER_LETTER_LO		       0x179B
#define Z_UNICODE_KHMER_LETTER_VO		       0x179C
#define Z_UNICODE_KHMER_LETTER_SHA		       0x179D
#define Z_UNICODE_KHMER_LETTER_SSO		       0x179E
#define Z_UNICODE_KHMER_LETTER_SA		       0x179F
#define Z_UNICODE_KHMER_LETTER_HA		       0x17A0
#define Z_UNICODE_KHMER_LETTER_LA		       0x17A1
#define Z_UNICODE_KHMER_LETTER_QA		       0x17A2
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QAQ	       0x17A3
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QAA	       0x17A4
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QI	       0x17A5
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QII	       0x17A6
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QU	       0x17A7
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QUK	       0x17A8
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QUU	       0x17A9
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QUUV	       0x17AA
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_RY	       0x17AB
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_RYY	       0x17AC
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_LY	       0x17AD
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_LYY	       0x17AE
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QE	       0x17AF
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QAI	       0x17B0
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QOO_TYPE_ONE 0x17B1
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QOO_TYPE_TWO 0x17B2
#define Z_UNICODE_KHMER_INDEPENDENT_VOWEL_QAU	       0x17B3
#define Z_UNICODE_KHMER_VOWEL_INHERENT_AQ	       0x17B4
#define Z_UNICODE_KHMER_VOWEL_INHERENT_AA	       0x17B5
#define Z_UNICODE_KHMER_VOWEL_SIGN_AA		       0x17B6
#define Z_UNICODE_KHMER_VOWEL_SIGN_I		       0x17B7
#define Z_UNICODE_KHMER_VOWEL_SIGN_II		       0x17B8
#define Z_UNICODE_KHMER_VOWEL_SIGN_Y		       0x17B9
#define Z_UNICODE_KHMER_VOWEL_SIGN_YY		       0x17BA
#define Z_UNICODE_KHMER_VOWEL_SIGN_U		       0x17BB
#define Z_UNICODE_KHMER_VOWEL_SIGN_UU		       0x17BC
#define Z_UNICODE_KHMER_VOWEL_SIGN_UA		       0x17BD
#define Z_UNICODE_KHMER_VOWEL_SIGN_OE		       0x17BE
#define Z_UNICODE_KHMER_VOWEL_SIGN_YA		       0x17BF
#define Z_UNICODE_KHMER_VOWEL_SIGN_IE		       0x17C0
#define Z_UNICODE_KHMER_VOWEL_SIGN_E		       0x17C1
#define Z_UNICODE_KHMER_VOWEL_SIGN_AE		       0x17C2
#define Z_UNICODE_KHMER_VOWEL_SIGN_AI		       0x17C3
#define Z_UNICODE_KHMER_VOWEL_SIGN_OO		       0x17C4
#define Z_UNICODE_KHMER_VOWEL_SIGN_AU		       0x17C5
#define Z_UNICODE_KHMER_SIGN_NIKAHIT		       0x17C6
#define Z_UNICODE_KHMER_SIGN_REAHMUK		       0x17C7
#define Z_UNICODE_KHMER_SIGN_YUUKALEAPINTU	       0x17C8
#define Z_UNICODE_KHMER_SIGN_MUUSIKATOAN	       0x17C9
#define Z_UNICODE_KHMER_SIGN_TRIISAP		       0x17CA
#define Z_UNICODE_KHMER_SIGN_BANTOC		       0x17CB
#define Z_UNICODE_KHMER_SIGN_ROBAT		       0x17CC
#define Z_UNICODE_KHMER_SIGN_TOANDAKHIAT	       0x17CD
#define Z_UNICODE_KHMER_SIGN_KAKABAT		       0x17CE
#define Z_UNICODE_KHMER_SIGN_AHSDA		       0x17CF
#define Z_UNICODE_KHMER_SIGN_SAMYOK_SANNYA	       0x17D0
#define Z_UNICODE_KHMER_SIGN_VIRIAM		       0x17D1
#define Z_UNICODE_KHMER_SIGN_COENG		       0x17D2
#define Z_UNICODE_KHMER_SIGN_BATHAMASAT		       0x17D3
#define Z_UNICODE_KHMER_SIGN_KHAN		       0x17D4
#define Z_UNICODE_KHMER_SIGN_BARIYOOSAN		       0x17D5
#define Z_UNICODE_KHMER_SIGN_CAMNUC_PII_KUUH	       0x17D6
#define Z_UNICODE_KHMER_SIGN_LEK_TOO		       0x17D7
#define Z_UNICODE_KHMER_SIGN_BEYYAL		       0x17D8
#define Z_UNICODE_KHMER_SIGN_PHNAEK_MUAN	       0x17D9
#define Z_UNICODE_KHMER_SIGN_KOOMUUT		       0x17DA
#define Z_UNICODE_KHMER_CURRENCY_SYMBOL_RIEL	       0x17DB
#define Z_UNICODE_KHMER_SIGN_AVAKRAHASANYA	       0x17DC
#define Z_UNICODE_KHMER_SIGN_ATTHACAN		       0x17DD
#define Z_UNICODE_KHMER_DIGIT_ZERO		       0x17E0
#define Z_UNICODE_KHMER_DIGIT_ONE		       0x17E1
#define Z_UNICODE_KHMER_DIGIT_TWO		       0x17E2
#define Z_UNICODE_KHMER_DIGIT_THREE		       0x17E3
#define Z_UNICODE_KHMER_DIGIT_FOUR		       0x17E4
#define Z_UNICODE_KHMER_DIGIT_FIVE		       0x17E5
#define Z_UNICODE_KHMER_DIGIT_SIX		       0x17E6
#define Z_UNICODE_KHMER_DIGIT_SEVEN		       0x17E7
#define Z_UNICODE_KHMER_DIGIT_EIGHT		       0x17E8
#define Z_UNICODE_KHMER_DIGIT_NINE		       0x17E9
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_SON	       0x17F0
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_MUOY	       0x17F1
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_PII	       0x17F2
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_BEI	       0x17F3
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_BUON	       0x17F4
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_PRAM	       0x17F5
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_PRAM_MUOY     0x17F6
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_PRAM_PII      0x17F7
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_PRAM_BEI      0x17F8
#define Z_UNICODE_KHMER_SYMBOL_LEK_ATTAK_PRAM_BUON     0x17F9

/* MARK: - 1800h-18AFh - Mongolian */

#define Z_UNICODE_MONGOLIAN_BIRGA			     0x1800
#define Z_UNICODE_MONGOLIAN_ELLIPSIS			     0x1801
#define Z_UNICODE_MONGOLIAN_COMMA			     0x1802
#define Z_UNICODE_MONGOLIAN_FULL_STOP			     0x1803
#define Z_UNICODE_MONGOLIAN_COLON			     0x1804
#define Z_UNICODE_MONGOLIAN_FOUR_DOTS			     0x1805
#define Z_UNICODE_MONGOLIAN_TODO_SOFT_HYPHEN		     0x1806
#define Z_UNICODE_MONGOLIAN_SIBE_SYLLABLE_BOUNDARY_MARKER    0x1807
#define Z_UNICODE_MONGOLIAN_MANCHU_COMMA		     0x1808
#define Z_UNICODE_MONGOLIAN_MANCHU_FULL_STOP		     0x1809
#define Z_UNICODE_MONGOLIAN_NIRUGU			     0x180A
#define Z_UNICODE_MONGOLIAN_FREE_VARIATION_SELECTOR_ONE	     0x180B
#define Z_UNICODE_MONGOLIAN_FREE_VARIATION_SELECTOR_TWO	     0x180C
#define Z_UNICODE_MONGOLIAN_FREE_VARIATION_SELECTOR_THREE    0x180D
#define Z_UNICODE_MONGOLIAN_VOWEL_SEPARATOR		     0x180E
#define Z_UNICODE_MONGOLIAN_DIGIT_ZERO			     0x1810
#define Z_UNICODE_MONGOLIAN_DIGIT_ONE			     0x1811
#define Z_UNICODE_MONGOLIAN_DIGIT_TWO			     0x1812
#define Z_UNICODE_MONGOLIAN_DIGIT_THREE			     0x1813
#define Z_UNICODE_MONGOLIAN_DIGIT_FOUR			     0x1814
#define Z_UNICODE_MONGOLIAN_DIGIT_FIVE			     0x1815
#define Z_UNICODE_MONGOLIAN_DIGIT_SIX			     0x1816
#define Z_UNICODE_MONGOLIAN_DIGIT_SEVEN			     0x1817
#define Z_UNICODE_MONGOLIAN_DIGIT_EIGHT			     0x1818
#define Z_UNICODE_MONGOLIAN_DIGIT_NINE			     0x1819
#define Z_UNICODE_MONGOLIAN_LETTER_A			     0x1820
#define Z_UNICODE_MONGOLIAN_LETTER_E			     0x1821
#define Z_UNICODE_MONGOLIAN_LETTER_I			     0x1822
#define Z_UNICODE_MONGOLIAN_LETTER_O			     0x1823
#define Z_UNICODE_MONGOLIAN_LETTER_U			     0x1824
#define Z_UNICODE_MONGOLIAN_LETTER_OE			     0x1825
#define Z_UNICODE_MONGOLIAN_LETTER_UE			     0x1826
#define Z_UNICODE_MONGOLIAN_LETTER_EE			     0x1827
#define Z_UNICODE_MONGOLIAN_LETTER_NA			     0x1828
#define Z_UNICODE_MONGOLIAN_LETTER_ANG			     0x1829
#define Z_UNICODE_MONGOLIAN_LETTER_BA			     0x182A
#define Z_UNICODE_MONGOLIAN_LETTER_PA			     0x182B
#define Z_UNICODE_MONGOLIAN_LETTER_QA			     0x182C
#define Z_UNICODE_MONGOLIAN_LETTER_GA			     0x182D
#define Z_UNICODE_MONGOLIAN_LETTER_MA			     0x182E
#define Z_UNICODE_MONGOLIAN_LETTER_LA			     0x182F
#define Z_UNICODE_MONGOLIAN_LETTER_SA			     0x1830
#define Z_UNICODE_MONGOLIAN_LETTER_SHA			     0x1831
#define Z_UNICODE_MONGOLIAN_LETTER_TA			     0x1832
#define Z_UNICODE_MONGOLIAN_LETTER_DA			     0x1833
#define Z_UNICODE_MONGOLIAN_LETTER_CHA			     0x1834
#define Z_UNICODE_MONGOLIAN_LETTER_JA			     0x1835
#define Z_UNICODE_MONGOLIAN_LETTER_YA			     0x1836
#define Z_UNICODE_MONGOLIAN_LETTER_RA			     0x1837
#define Z_UNICODE_MONGOLIAN_LETTER_WA			     0x1838
#define Z_UNICODE_MONGOLIAN_LETTER_FA			     0x1839
#define Z_UNICODE_MONGOLIAN_LETTER_KA			     0x183A
#define Z_UNICODE_MONGOLIAN_LETTER_KHA			     0x183B
#define Z_UNICODE_MONGOLIAN_LETTER_TSA			     0x183C
#define Z_UNICODE_MONGOLIAN_LETTER_ZA			     0x183D
#define Z_UNICODE_MONGOLIAN_LETTER_HAA			     0x183E
#define Z_UNICODE_MONGOLIAN_LETTER_ZRA			     0x183F
#define Z_UNICODE_MONGOLIAN_LETTER_LHA			     0x1840
#define Z_UNICODE_MONGOLIAN_LETTER_ZHI			     0x1841
#define Z_UNICODE_MONGOLIAN_LETTER_CHI			     0x1842
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_LONG_VOWEL_SIGN	     0x1843
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_E		     0x1844
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_I		     0x1845
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_O		     0x1846
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_U		     0x1847
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_OE		     0x1848
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_UE		     0x1849
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_ANG		     0x184A
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_BA		     0x184B
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_PA		     0x184C
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_QA		     0x184D
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_GA		     0x184E
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_MA		     0x184F
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_TA		     0x1850
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_DA		     0x1851
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_CHA		     0x1852
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_JA		     0x1853
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_TSA		     0x1854
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_YA		     0x1855
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_WA		     0x1856
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_KA		     0x1857
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_GAA		     0x1858
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_HAA		     0x1859
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_JIA		     0x185A
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_NIA		     0x185B
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_DZA		     0x185C
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_E		     0x185D
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_I		     0x185E
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_IY		     0x185F
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_UE		     0x1860
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_U		     0x1861
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_ANG		     0x1862
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_KA		     0x1863
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_GA		     0x1864
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_HA		     0x1865
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_PA		     0x1866
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_SHA		     0x1867
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_TA		     0x1868
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_DA		     0x1869
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_JA		     0x186A
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_FA		     0x186B
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_GAA		     0x186C
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_HAA		     0x186D
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_TSA		     0x186E
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_ZA		     0x186F
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_RAA		     0x1870
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_CHA		     0x1871
#define Z_UNICODE_MONGOLIAN_LETTER_SIBE_ZHA		     0x1872
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_I		     0x1873
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_KA		     0x1874
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_RA		     0x1875
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_FA		     0x1876
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ZHA		     0x1877
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_ANUSVARA_ONE     0x1880
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_VISARGA_ONE	     0x1881
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_DAMARU	     0x1882
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_UBADAMA	     0x1883
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_INVERTED_UBADAMA 0x1884
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_BALUDA	     0x1885
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_THREE_BALUDA     0x1886
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_A		     0x1887
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_I		     0x1888
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_KA		     0x1889
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_NGA		     0x188A
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_CA		     0x188B
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_TTA		     0x188C
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_TTHA	     0x188D
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_DDA		     0x188E
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_NNA		     0x188F
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_TA		     0x1890
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_DA		     0x1891
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_PA		     0x1892
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_PHA		     0x1893
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_SSA		     0x1894
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_ZHA		     0x1895
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_ZA		     0x1896
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_AH		     0x1897
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_ALI_GALI_TA	     0x1898
#define Z_UNICODE_MONGOLIAN_LETTER_TODO_ALI_GALI_ZHA	     0x1899
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_GHA	     0x189A
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_NGA	     0x189B
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_CA	     0x189C
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_JHA	     0x189D
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_TTA	     0x189E
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_DDHA	     0x189F
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_TA	     0x18A0
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_DHA	     0x18A1
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_SSA	     0x18A2
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_CYA	     0x18A3
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_ZHA	     0x18A4
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_ZA	     0x18A5
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_HALF_U	     0x18A6
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_HALF_YA	     0x18A7
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_BHA	     0x18A8
#define Z_UNICODE_MONGOLIAN_LETTER_ALI_GALI_DAGALGA	     0x18A9
#define Z_UNICODE_MONGOLIAN_LETTER_MANCHU_ALI_GALI_LHA	     0x18AA

/* MARK: - 18B0h-18FFh - Unified Canadian Aboriginal Syllabics Extended */

#define Z_UNICODE_CANADIAN_SYLLABICS_OY		      0x18B0
#define Z_UNICODE_CANADIAN_SYLLABICS_AY		      0x18B1
#define Z_UNICODE_CANADIAN_SYLLABICS_AAY	      0x18B2
#define Z_UNICODE_CANADIAN_SYLLABICS_WAY	      0x18B3
#define Z_UNICODE_CANADIAN_SYLLABICS_POY	      0x18B4
#define Z_UNICODE_CANADIAN_SYLLABICS_PAY	      0x18B5
#define Z_UNICODE_CANADIAN_SYLLABICS_PWOY	      0x18B6
#define Z_UNICODE_CANADIAN_SYLLABICS_TAY	      0x18B7
#define Z_UNICODE_CANADIAN_SYLLABICS_KAY	      0x18B8
#define Z_UNICODE_CANADIAN_SYLLABICS_KWAY	      0x18B9
#define Z_UNICODE_CANADIAN_SYLLABICS_MAY	      0x18BA
#define Z_UNICODE_CANADIAN_SYLLABICS_NOY	      0x18BB
#define Z_UNICODE_CANADIAN_SYLLABICS_NAY	      0x18BC
#define Z_UNICODE_CANADIAN_SYLLABICS_LAY	      0x18BD
#define Z_UNICODE_CANADIAN_SYLLABICS_SOY	      0x18BE
#define Z_UNICODE_CANADIAN_SYLLABICS_SAY	      0x18BF
#define Z_UNICODE_CANADIAN_SYLLABICS_SHOY	      0x18C0
#define Z_UNICODE_CANADIAN_SYLLABICS_SHAY	      0x18C1
#define Z_UNICODE_CANADIAN_SYLLABICS_SHWOY	      0x18C2
#define Z_UNICODE_CANADIAN_SYLLABICS_YOY	      0x18C3
#define Z_UNICODE_CANADIAN_SYLLABICS_YAY	      0x18C4
#define Z_UNICODE_CANADIAN_SYLLABICS_RAY	      0x18C5
#define Z_UNICODE_CANADIAN_SYLLABICS_NWI	      0x18C6
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_NWI      0x18C7
#define Z_UNICODE_CANADIAN_SYLLABICS_NWII	      0x18C8
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_NWII     0x18C9
#define Z_UNICODE_CANADIAN_SYLLABICS_NWO	      0x18CA
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_NWO      0x18CB
#define Z_UNICODE_CANADIAN_SYLLABICS_NWOO	      0x18CC
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_NWOO     0x18CD
#define Z_UNICODE_CANADIAN_SYLLABICS_RWEE	      0x18CE
#define Z_UNICODE_CANADIAN_SYLLABICS_RWI	      0x18CF
#define Z_UNICODE_CANADIAN_SYLLABICS_RWII	      0x18D0
#define Z_UNICODE_CANADIAN_SYLLABICS_RWO	      0x18D1
#define Z_UNICODE_CANADIAN_SYLLABICS_RWOO	      0x18D2
#define Z_UNICODE_CANADIAN_SYLLABICS_RWA	      0x18D3
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_P	      0x18D4
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_T	      0x18D5
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_K	      0x18D6
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_C	      0x18D7
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_M	      0x18D8
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_N	      0x18D9
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_S	      0x18DA
#define Z_UNICODE_CANADIAN_SYLLABICS_OJIBWAY_SH	      0x18DB
#define Z_UNICODE_CANADIAN_SYLLABICS_EASTERN_W	      0x18DC
#define Z_UNICODE_CANADIAN_SYLLABICS_WESTERN_W	      0x18DD
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_SMALL_RING 0x18DE
#define Z_UNICODE_CANADIAN_SYLLABICS_FINAL_RAISED_DOT 0x18DF
#define Z_UNICODE_CANADIAN_SYLLABICS_R_CREE_RWE	      0x18E0
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LOO    0x18E1
#define Z_UNICODE_CANADIAN_SYLLABICS_WEST_CREE_LAA    0x18E2
#define Z_UNICODE_CANADIAN_SYLLABICS_THWE	      0x18E3
#define Z_UNICODE_CANADIAN_SYLLABICS_THWA	      0x18E4
#define Z_UNICODE_CANADIAN_SYLLABICS_TTHWE	      0x18E5
#define Z_UNICODE_CANADIAN_SYLLABICS_TTHOO	      0x18E6
#define Z_UNICODE_CANADIAN_SYLLABICS_TTHAA	      0x18E7
#define Z_UNICODE_CANADIAN_SYLLABICS_TLHWE	      0x18E8
#define Z_UNICODE_CANADIAN_SYLLABICS_TLHOO	      0x18E9
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_SHWE      0x18EA
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_SHOO      0x18EB
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_HOO	      0x18EC
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GWU      0x18ED
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DENE_GEE 0x18EE
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GAA      0x18EF
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_GWA      0x18F0
#define Z_UNICODE_CANADIAN_SYLLABICS_SAYISI_JUU	      0x18F1
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_JWA      0x18F2
#define Z_UNICODE_CANADIAN_SYLLABICS_BEAVER_DENE_L    0x18F3
#define Z_UNICODE_CANADIAN_SYLLABICS_BEAVER_DENE_R    0x18F4
#define Z_UNICODE_CANADIAN_SYLLABICS_CARRIER_DENTAL_S 0x18F5

/* MARK: - 1900h-194Fh - Limbu */

#define Z_UNICODE_LIMBU_VOWEL_CARRIER_LETTER  0x1900
#define Z_UNICODE_LIMBU_LETTER_KA	      0x1901
#define Z_UNICODE_LIMBU_LETTER_KHA	      0x1902
#define Z_UNICODE_LIMBU_LETTER_GA	      0x1903
#define Z_UNICODE_LIMBU_LETTER_GHA	      0x1904
#define Z_UNICODE_LIMBU_LETTER_NGA	      0x1905
#define Z_UNICODE_LIMBU_LETTER_CA	      0x1906
#define Z_UNICODE_LIMBU_LETTER_CHA	      0x1907
#define Z_UNICODE_LIMBU_LETTER_JA	      0x1908
#define Z_UNICODE_LIMBU_LETTER_JHA	      0x1909
#define Z_UNICODE_LIMBU_LETTER_YAN	      0x190A
#define Z_UNICODE_LIMBU_LETTER_TA	      0x190B
#define Z_UNICODE_LIMBU_LETTER_THA	      0x190C
#define Z_UNICODE_LIMBU_LETTER_DA	      0x190D
#define Z_UNICODE_LIMBU_LETTER_DHA	      0x190E
#define Z_UNICODE_LIMBU_LETTER_NA	      0x190F
#define Z_UNICODE_LIMBU_LETTER_PA	      0x1910
#define Z_UNICODE_LIMBU_LETTER_PHA	      0x1911
#define Z_UNICODE_LIMBU_LETTER_BA	      0x1912
#define Z_UNICODE_LIMBU_LETTER_BHA	      0x1913
#define Z_UNICODE_LIMBU_LETTER_MA	      0x1914
#define Z_UNICODE_LIMBU_LETTER_YA	      0x1915
#define Z_UNICODE_LIMBU_LETTER_RA	      0x1916
#define Z_UNICODE_LIMBU_LETTER_LA	      0x1917
#define Z_UNICODE_LIMBU_LETTER_WA	      0x1918
#define Z_UNICODE_LIMBU_LETTER_SHA	      0x1919
#define Z_UNICODE_LIMBU_LETTER_SSA	      0x191A
#define Z_UNICODE_LIMBU_LETTER_SA	      0x191B
#define Z_UNICODE_LIMBU_LETTER_HA	      0x191C
#define Z_UNICODE_LIMBU_LETTER_GYAN	      0x191D
#define Z_UNICODE_LIMBU_LETTER_TRA	      0x191E
#define Z_UNICODE_LIMBU_VOWEL_SIGN_A	      0x1920
#define Z_UNICODE_LIMBU_VOWEL_SIGN_I	      0x1921
#define Z_UNICODE_LIMBU_VOWEL_SIGN_U	      0x1922
#define Z_UNICODE_LIMBU_VOWEL_SIGN_EE	      0x1923
#define Z_UNICODE_LIMBU_VOWEL_SIGN_AI	      0x1924
#define Z_UNICODE_LIMBU_VOWEL_SIGN_OO	      0x1925
#define Z_UNICODE_LIMBU_VOWEL_SIGN_AU	      0x1926
#define Z_UNICODE_LIMBU_VOWEL_SIGN_E	      0x1927
#define Z_UNICODE_LIMBU_VOWEL_SIGN_O	      0x1928
#define Z_UNICODE_LIMBU_SUBJOINED_LETTER_YA   0x1929
#define Z_UNICODE_LIMBU_SUBJOINED_LETTER_RA   0x192A
#define Z_UNICODE_LIMBU_SUBJOINED_LETTER_WA   0x192B
#define Z_UNICODE_LIMBU_SMALL_LETTER_KA	      0x1930
#define Z_UNICODE_LIMBU_SMALL_LETTER_NGA      0x1931
#define Z_UNICODE_LIMBU_SMALL_LETTER_ANUSVARA 0x1932
#define Z_UNICODE_LIMBU_SMALL_LETTER_TA	      0x1933
#define Z_UNICODE_LIMBU_SMALL_LETTER_NA	      0x1934
#define Z_UNICODE_LIMBU_SMALL_LETTER_PA	      0x1935
#define Z_UNICODE_LIMBU_SMALL_LETTER_MA	      0x1936
#define Z_UNICODE_LIMBU_SMALL_LETTER_RA	      0x1937
#define Z_UNICODE_LIMBU_SMALL_LETTER_LA	      0x1938
#define Z_UNICODE_LIMBU_SIGN_MUKPHRENG	      0x1939
#define Z_UNICODE_LIMBU_SIGN_KEMPHRENG	      0x193A
#define Z_UNICODE_LIMBU_SIGN_SA_I	      0x193B
#define Z_UNICODE_LIMBU_SIGN_LOO	      0x1940
#define Z_UNICODE_LIMBU_EXCLAMATION_MARK      0x1944
#define Z_UNICODE_LIMBU_QUESTION_MARK	      0x1945
#define Z_UNICODE_LIMBU_DIGIT_ZERO	      0x1946
#define Z_UNICODE_LIMBU_DIGIT_ONE	      0x1947
#define Z_UNICODE_LIMBU_DIGIT_TWO	      0x1948
#define Z_UNICODE_LIMBU_DIGIT_THREE	      0x1949
#define Z_UNICODE_LIMBU_DIGIT_FOUR	      0x194A
#define Z_UNICODE_LIMBU_DIGIT_FIVE	      0x194B
#define Z_UNICODE_LIMBU_DIGIT_SIX	      0x194C
#define Z_UNICODE_LIMBU_DIGIT_SEVEN	      0x194D
#define Z_UNICODE_LIMBU_DIGIT_EIGHT	      0x194E
#define Z_UNICODE_LIMBU_DIGIT_NINE	      0x194F

/* MARK: - 1950h-197Fh - Tai Le */

#define Z_UNICODE_TAI_LE_LETTER_KA     0x1950
#define Z_UNICODE_TAI_LE_LETTER_XA     0x1951
#define Z_UNICODE_TAI_LE_LETTER_NGA    0x1952
#define Z_UNICODE_TAI_LE_LETTER_TSA    0x1953
#define Z_UNICODE_TAI_LE_LETTER_SA     0x1954
#define Z_UNICODE_TAI_LE_LETTER_YA     0x1955
#define Z_UNICODE_TAI_LE_LETTER_TA     0x1956
#define Z_UNICODE_TAI_LE_LETTER_THA    0x1957
#define Z_UNICODE_TAI_LE_LETTER_LA     0x1958
#define Z_UNICODE_TAI_LE_LETTER_PA     0x1959
#define Z_UNICODE_TAI_LE_LETTER_PHA    0x195A
#define Z_UNICODE_TAI_LE_LETTER_MA     0x195B
#define Z_UNICODE_TAI_LE_LETTER_FA     0x195C
#define Z_UNICODE_TAI_LE_LETTER_VA     0x195D
#define Z_UNICODE_TAI_LE_LETTER_HA     0x195E
#define Z_UNICODE_TAI_LE_LETTER_QA     0x195F
#define Z_UNICODE_TAI_LE_LETTER_KHA    0x1960
#define Z_UNICODE_TAI_LE_LETTER_TSHA   0x1961
#define Z_UNICODE_TAI_LE_LETTER_NA     0x1962
#define Z_UNICODE_TAI_LE_LETTER_A      0x1963
#define Z_UNICODE_TAI_LE_LETTER_I      0x1964
#define Z_UNICODE_TAI_LE_LETTER_EE     0x1965
#define Z_UNICODE_TAI_LE_LETTER_EH     0x1966
#define Z_UNICODE_TAI_LE_LETTER_U      0x1967
#define Z_UNICODE_TAI_LE_LETTER_OO     0x1968
#define Z_UNICODE_TAI_LE_LETTER_O      0x1969
#define Z_UNICODE_TAI_LE_LETTER_UE     0x196A
#define Z_UNICODE_TAI_LE_LETTER_E      0x196B
#define Z_UNICODE_TAI_LE_LETTER_AUE    0x196C
#define Z_UNICODE_TAI_LE_LETTER_AI     0x196D
#define Z_UNICODE_TAI_LE_LETTER_TONE_2 0x1970
#define Z_UNICODE_TAI_LE_LETTER_TONE_3 0x1971
#define Z_UNICODE_TAI_LE_LETTER_TONE_4 0x1972
#define Z_UNICODE_TAI_LE_LETTER_TONE_5 0x1973
#define Z_UNICODE_TAI_LE_LETTER_TONE_6 0x1974

/* MARK: - 1980h-19DFh - New Tai Lue */

#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_QA		 0x1980
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_QA		 0x1981
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_KA		 0x1982
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_XA		 0x1983
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_NGA		 0x1984
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_KA		 0x1985
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_XA		 0x1986
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_NGA		 0x1987
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_TSA		 0x1988
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_SA		 0x1989
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_YA		 0x198A
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_TSA		 0x198B
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_SA		 0x198C
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_YA		 0x198D
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_TA		 0x198E
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_THA		 0x198F
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_NA		 0x1990
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_TA		 0x1991
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_THA		 0x1992
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_NA		 0x1993
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_PA		 0x1994
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_PHA		 0x1995
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_MA		 0x1996
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_PA		 0x1997
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_PHA		 0x1998
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_MA		 0x1999
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_FA		 0x199A
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_VA		 0x199B
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_LA		 0x199C
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_FA		 0x199D
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_VA		 0x199E
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_LA		 0x199F
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_HA		 0x19A0
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_DA		 0x19A1
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_BA		 0x19A2
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_HA		 0x19A3
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_DA		 0x19A4
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_BA		 0x19A5
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_KVA		 0x19A6
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_XVA		 0x19A7
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_KVA		 0x19A8
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_XVA		 0x19A9
#define Z_UNICODE_NEW_TAI_LUE_LETTER_HIGH_SUA		 0x19AA
#define Z_UNICODE_NEW_TAI_LUE_LETTER_LOW_SUA		 0x19AB
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_VOWEL_SHORTENER 0x19B0
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_AA		 0x19B1
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_II		 0x19B2
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_U		 0x19B3
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_UU		 0x19B4
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_E		 0x19B5
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_AE		 0x19B6
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_O		 0x19B7
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_OA		 0x19B8
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_UE		 0x19B9
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_AY		 0x19BA
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_AAY		 0x19BB
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_UY		 0x19BC
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_OY		 0x19BD
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_OAY		 0x19BE
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_UEY		 0x19BF
#define Z_UNICODE_NEW_TAI_LUE_VOWEL_SIGN_IY		 0x19C0
#define Z_UNICODE_NEW_TAI_LUE_LETTER_FINAL_V		 0x19C1
#define Z_UNICODE_NEW_TAI_LUE_LETTER_FINAL_NG		 0x19C2
#define Z_UNICODE_NEW_TAI_LUE_LETTER_FINAL_N		 0x19C3
#define Z_UNICODE_NEW_TAI_LUE_LETTER_FINAL_M		 0x19C4
#define Z_UNICODE_NEW_TAI_LUE_LETTER_FINAL_K		 0x19C5
#define Z_UNICODE_NEW_TAI_LUE_LETTER_FINAL_D		 0x19C6
#define Z_UNICODE_NEW_TAI_LUE_LETTER_FINAL_B		 0x19C7
#define Z_UNICODE_NEW_TAI_LUE_TONE_MARK_1		 0x19C8
#define Z_UNICODE_NEW_TAI_LUE_TONE_MARK_2		 0x19C9
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_ZERO		 0x19D0
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_ONE			 0x19D1
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_TWO			 0x19D2
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_THREE		 0x19D3
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_FOUR		 0x19D4
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_FIVE		 0x19D5
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_SIX			 0x19D6
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_SEVEN		 0x19D7
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_EIGHT		 0x19D8
#define Z_UNICODE_NEW_TAI_LUE_DIGIT_NINE		 0x19D9
#define Z_UNICODE_NEW_TAI_LUE_THAM_DIGIT_ONE		 0x19DA
#define Z_UNICODE_NEW_TAI_LUE_SIGN_LAE			 0x19DE
#define Z_UNICODE_NEW_TAI_LUE_SIGN_LAEV			 0x19DF

/* MARK: - 19E0h-19FFh - Khmer Symbols */

#define Z_UNICODE_KHMER_SYMBOL_PATHAMASAT     0x19E0
#define Z_UNICODE_KHMER_SYMBOL_MUOY_KOET      0x19E1
#define Z_UNICODE_KHMER_SYMBOL_PII_KOET	      0x19E2
#define Z_UNICODE_KHMER_SYMBOL_BEI_KOET	      0x19E3
#define Z_UNICODE_KHMER_SYMBOL_BUON_KOET      0x19E4
#define Z_UNICODE_KHMER_SYMBOL_PRAM_KOET      0x19E5
#define Z_UNICODE_KHMER_SYMBOL_PRAM_MUOY_KOET 0x19E6
#define Z_UNICODE_KHMER_SYMBOL_PRAM_PII_KOET  0x19E7
#define Z_UNICODE_KHMER_SYMBOL_PRAM_BEI_KOET  0x19E8
#define Z_UNICODE_KHMER_SYMBOL_PRAM_BUON_KOET 0x19E9
#define Z_UNICODE_KHMER_SYMBOL_DAP_KOET	      0x19EA
#define Z_UNICODE_KHMER_SYMBOL_DAP_MUOY_KOET  0x19EB
#define Z_UNICODE_KHMER_SYMBOL_DAP_PII_KOET   0x19EC
#define Z_UNICODE_KHMER_SYMBOL_DAP_BEI_KOET   0x19ED
#define Z_UNICODE_KHMER_SYMBOL_DAP_BUON_KOET  0x19EE
#define Z_UNICODE_KHMER_SYMBOL_DAP_PRAM_KOET  0x19EF
#define Z_UNICODE_KHMER_SYMBOL_TUTEYASAT      0x19F0
#define Z_UNICODE_KHMER_SYMBOL_MUOY_ROC	      0x19F1
#define Z_UNICODE_KHMER_SYMBOL_PII_ROC	      0x19F2
#define Z_UNICODE_KHMER_SYMBOL_BEI_ROC	      0x19F3
#define Z_UNICODE_KHMER_SYMBOL_BUON_ROC	      0x19F4
#define Z_UNICODE_KHMER_SYMBOL_PRAM_ROC	      0x19F5
#define Z_UNICODE_KHMER_SYMBOL_PRAM_MUOY_ROC  0x19F6
#define Z_UNICODE_KHMER_SYMBOL_PRAM_PII_ROC   0x19F7
#define Z_UNICODE_KHMER_SYMBOL_PRAM_BEI_ROC   0x19F8
#define Z_UNICODE_KHMER_SYMBOL_PRAM_BUON_ROC  0x19F9
#define Z_UNICODE_KHMER_SYMBOL_DAP_ROC	      0x19FA
#define Z_UNICODE_KHMER_SYMBOL_DAP_MUOY_ROC   0x19FB
#define Z_UNICODE_KHMER_SYMBOL_DAP_PII_ROC    0x19FC
#define Z_UNICODE_KHMER_SYMBOL_DAP_BEI_ROC    0x19FD
#define Z_UNICODE_KHMER_SYMBOL_DAP_BUON_ROC   0x19FE
#define Z_UNICODE_KHMER_SYMBOL_DAP_PRAM_ROC   0x19FF

/* MARK: - 1A00h-1A1Fh - Buginese */

#define Z_UNICODE_BUGINESE_LETTER_KA	  0x1A00
#define Z_UNICODE_BUGINESE_LETTER_GA	  0x1A01
#define Z_UNICODE_BUGINESE_LETTER_NGA	  0x1A02
#define Z_UNICODE_BUGINESE_LETTER_NGKA	  0x1A03
#define Z_UNICODE_BUGINESE_LETTER_PA	  0x1A04
#define Z_UNICODE_BUGINESE_LETTER_BA	  0x1A05
#define Z_UNICODE_BUGINESE_LETTER_MA	  0x1A06
#define Z_UNICODE_BUGINESE_LETTER_MPA	  0x1A07
#define Z_UNICODE_BUGINESE_LETTER_TA	  0x1A08
#define Z_UNICODE_BUGINESE_LETTER_DA	  0x1A09
#define Z_UNICODE_BUGINESE_LETTER_NA	  0x1A0A
#define Z_UNICODE_BUGINESE_LETTER_NRA	  0x1A0B
#define Z_UNICODE_BUGINESE_LETTER_CA	  0x1A0C
#define Z_UNICODE_BUGINESE_LETTER_JA	  0x1A0D
#define Z_UNICODE_BUGINESE_LETTER_NYA	  0x1A0E
#define Z_UNICODE_BUGINESE_LETTER_NYCA	  0x1A0F
#define Z_UNICODE_BUGINESE_LETTER_YA	  0x1A10
#define Z_UNICODE_BUGINESE_LETTER_RA	  0x1A11
#define Z_UNICODE_BUGINESE_LETTER_LA	  0x1A12
#define Z_UNICODE_BUGINESE_LETTER_VA	  0x1A13
#define Z_UNICODE_BUGINESE_LETTER_SA	  0x1A14
#define Z_UNICODE_BUGINESE_LETTER_A	  0x1A15
#define Z_UNICODE_BUGINESE_LETTER_HA	  0x1A16
#define Z_UNICODE_BUGINESE_VOWEL_SIGN_I	  0x1A17
#define Z_UNICODE_BUGINESE_VOWEL_SIGN_U	  0x1A18
#define Z_UNICODE_BUGINESE_VOWEL_SIGN_E	  0x1A19
#define Z_UNICODE_BUGINESE_VOWEL_SIGN_O	  0x1A1A
#define Z_UNICODE_BUGINESE_VOWEL_SIGN_AE  0x1A1B
#define Z_UNICODE_BUGINESE_PALLAWA	  0x1A1E
#define Z_UNICODE_BUGINESE_END_OF_SECTION 0x1A1F

/* MARK: - 1A20h-1AAFh - Tai Tham */

#define Z_UNICODE_TAI_THAM_LETTER_HIGH_KA		       0x1A20
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_KHA		       0x1A21
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_KXA		       0x1A22
#define Z_UNICODE_TAI_THAM_LETTER_LOW_KA		       0x1A23
#define Z_UNICODE_TAI_THAM_LETTER_LOW_KXA		       0x1A24
#define Z_UNICODE_TAI_THAM_LETTER_LOW_KHA		       0x1A25
#define Z_UNICODE_TAI_THAM_LETTER_NGA			       0x1A26
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_CA		       0x1A27
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_CHA		       0x1A28
#define Z_UNICODE_TAI_THAM_LETTER_LOW_CA		       0x1A29
#define Z_UNICODE_TAI_THAM_LETTER_LOW_SA		       0x1A2A
#define Z_UNICODE_TAI_THAM_LETTER_LOW_CHA		       0x1A2B
#define Z_UNICODE_TAI_THAM_LETTER_NYA			       0x1A2C
#define Z_UNICODE_TAI_THAM_LETTER_RATA			       0x1A2D
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_RATHA		       0x1A2E
#define Z_UNICODE_TAI_THAM_LETTER_DA			       0x1A2F
#define Z_UNICODE_TAI_THAM_LETTER_LOW_RATHA		       0x1A30
#define Z_UNICODE_TAI_THAM_LETTER_RANA			       0x1A31
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_TA		       0x1A32
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_THA		       0x1A33
#define Z_UNICODE_TAI_THAM_LETTER_LOW_TA		       0x1A34
#define Z_UNICODE_TAI_THAM_LETTER_LOW_THA		       0x1A35
#define Z_UNICODE_TAI_THAM_LETTER_NA			       0x1A36
#define Z_UNICODE_TAI_THAM_LETTER_BA			       0x1A37
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_PA		       0x1A38
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_PHA		       0x1A39
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_FA		       0x1A3A
#define Z_UNICODE_TAI_THAM_LETTER_LOW_PA		       0x1A3B
#define Z_UNICODE_TAI_THAM_LETTER_LOW_FA		       0x1A3C
#define Z_UNICODE_TAI_THAM_LETTER_LOW_PHA		       0x1A3D
#define Z_UNICODE_TAI_THAM_LETTER_MA			       0x1A3E
#define Z_UNICODE_TAI_THAM_LETTER_LOW_YA		       0x1A3F
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_YA		       0x1A40
#define Z_UNICODE_TAI_THAM_LETTER_RA			       0x1A41
#define Z_UNICODE_TAI_THAM_LETTER_RUE			       0x1A42
#define Z_UNICODE_TAI_THAM_LETTER_LA			       0x1A43
#define Z_UNICODE_TAI_THAM_LETTER_LUE			       0x1A44
#define Z_UNICODE_TAI_THAM_LETTER_WA			       0x1A45
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_SHA		       0x1A46
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_SSA		       0x1A47
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_SA		       0x1A48
#define Z_UNICODE_TAI_THAM_LETTER_HIGH_HA		       0x1A49
#define Z_UNICODE_TAI_THAM_LETTER_LLA			       0x1A4A
#define Z_UNICODE_TAI_THAM_LETTER_A			       0x1A4B
#define Z_UNICODE_TAI_THAM_LETTER_LOW_HA		       0x1A4C
#define Z_UNICODE_TAI_THAM_LETTER_I			       0x1A4D
#define Z_UNICODE_TAI_THAM_LETTER_II			       0x1A4E
#define Z_UNICODE_TAI_THAM_LETTER_U			       0x1A4F
#define Z_UNICODE_TAI_THAM_LETTER_UU			       0x1A50
#define Z_UNICODE_TAI_THAM_LETTER_EE			       0x1A51
#define Z_UNICODE_TAI_THAM_LETTER_OO			       0x1A52
#define Z_UNICODE_TAI_THAM_LETTER_LAE			       0x1A53
#define Z_UNICODE_TAI_THAM_LETTER_GREAT_SA		       0x1A54
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_MEDIAL_RA	       0x1A55
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_MEDIAL_LA	       0x1A56
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_LA_TANG_LAI	       0x1A57
#define Z_UNICODE_TAI_THAM_SIGN_MAI_KANG_LAI		       0x1A58
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_FINAL_NGA	       0x1A59
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_LOW_PA	       0x1A5A
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_HIGH_RATHA_OR_LOW_PA 0x1A5B
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_MA		       0x1A5C
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_BA		       0x1A5D
#define Z_UNICODE_TAI_THAM_CONSONANT_SIGN_SA		       0x1A5E
#define Z_UNICODE_TAI_THAM_SIGN_SAKOT			       0x1A60
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_A			       0x1A61
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_MAI_SAT		       0x1A62
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_AA		       0x1A63
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_TALL_AA		       0x1A64
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_I			       0x1A65
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_II		       0x1A66
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_UE		       0x1A67
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_UUE		       0x1A68
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_U			       0x1A69
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_UU		       0x1A6A
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_O			       0x1A6B
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_OA_BELOW		       0x1A6C
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_OY		       0x1A6D
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_E			       0x1A6E
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_AE		       0x1A6F
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_OO		       0x1A70
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_AI		       0x1A71
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_THAM_AI		       0x1A72
#define Z_UNICODE_TAI_THAM_VOWEL_SIGN_OA_ABOVE		       0x1A73
#define Z_UNICODE_TAI_THAM_SIGN_MAI_KANG		       0x1A74
#define Z_UNICODE_TAI_THAM_SIGN_TONE_1			       0x1A75
#define Z_UNICODE_TAI_THAM_SIGN_TONE_2			       0x1A76
#define Z_UNICODE_TAI_THAM_SIGN_KHUEN_TONE_3		       0x1A77
#define Z_UNICODE_TAI_THAM_SIGN_KHUEN_TONE_4		       0x1A78
#define Z_UNICODE_TAI_THAM_SIGN_KHUEN_TONE_5		       0x1A79
#define Z_UNICODE_TAI_THAM_SIGN_RA_HAAM			       0x1A7A
#define Z_UNICODE_TAI_THAM_SIGN_MAI_SAM			       0x1A7B
#define Z_UNICODE_TAI_THAM_SIGN_KHUEN_LUE_KARAN		       0x1A7C
#define Z_UNICODE_TAI_THAM_COMBINING_CRYPTOGRAMMIC_DOT	       0x1A7F
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_ZERO		       0x1A80
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_ONE		       0x1A81
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_TWO		       0x1A82
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_THREE		       0x1A83
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_FOUR		       0x1A84
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_FIVE		       0x1A85
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_SIX		       0x1A86
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_SEVEN		       0x1A87
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_EIGHT		       0x1A88
#define Z_UNICODE_TAI_THAM_HORA_DIGIT_NINE		       0x1A89
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_ZERO		       0x1A90
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_ONE		       0x1A91
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_TWO		       0x1A92
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_THREE		       0x1A93
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_FOUR		       0x1A94
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_FIVE		       0x1A95
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_SIX		       0x1A96
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_SEVEN		       0x1A97
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_EIGHT		       0x1A98
#define Z_UNICODE_TAI_THAM_THAM_DIGIT_NINE		       0x1A99
#define Z_UNICODE_TAI_THAM_SIGN_WIANG			       0x1AA0
#define Z_UNICODE_TAI_THAM_SIGN_WIANGWAAK		       0x1AA1
#define Z_UNICODE_TAI_THAM_SIGN_SAWAN			       0x1AA2
#define Z_UNICODE_TAI_THAM_SIGN_KEOW			       0x1AA3
#define Z_UNICODE_TAI_THAM_SIGN_HOY			       0x1AA4
#define Z_UNICODE_TAI_THAM_SIGN_DOKMAI			       0x1AA5
#define Z_UNICODE_TAI_THAM_SIGN_REVERSED_ROTATED_RANA	       0x1AA6
#define Z_UNICODE_TAI_THAM_SIGN_MAI_YAMOK		       0x1AA7
#define Z_UNICODE_TAI_THAM_SIGN_KAAN			       0x1AA8
#define Z_UNICODE_TAI_THAM_SIGN_KAANKUU			       0x1AA9
#define Z_UNICODE_TAI_THAM_SIGN_SATKAAN			       0x1AAA
#define Z_UNICODE_TAI_THAM_SIGN_SATKAANKUU		       0x1AAB
#define Z_UNICODE_TAI_THAM_SIGN_HANG			       0x1AAC
#define Z_UNICODE_TAI_THAM_SIGN_CAANG			       0x1AAD

/* MARK: - 1AB0h-1AFFh - Combining Diacritical Marks Extended */

#define Z_UNICODE_COMBINING_DOUBLED_CIRCUMFLEX_ACCENT	       0x1AB0
#define Z_UNICODE_COMBINING_DIAERESIS_RING		       0x1AB1
#define Z_UNICODE_COMBINING_INFINITY			       0x1AB2
#define Z_UNICODE_COMBINING_DOWNWARDS_ARROW		       0x1AB3
#define Z_UNICODE_COMBINING_TRIPLE_DOT			       0x1AB4
#define Z_UNICODE_COMBINING_X_X_BELOW			       0x1AB5
#define Z_UNICODE_COMBINING_WIGGLY_LINE_BELOW		       0x1AB6
#define Z_UNICODE_COMBINING_OPEN_MARK_BELOW		       0x1AB7
#define Z_UNICODE_COMBINING_DOUBLE_OPEN_MARK_BELOW	       0x1AB8
#define Z_UNICODE_COMBINING_LIGHT_CENTRALIZATION_STROKE_BELOW  0x1AB9
#define Z_UNICODE_COMBINING_STRONG_CENTRALIZATION_STROKE_BELOW 0x1ABA
#define Z_UNICODE_COMBINING_PARENTHESES_ABOVE		       0x1ABB
#define Z_UNICODE_COMBINING_DOUBLE_PARENTHESES_ABOVE	       0x1ABC
#define Z_UNICODE_COMBINING_PARENTHESES_BELOW		       0x1ABD
#define Z_UNICODE_COMBINING_PARENTHESES_OVERLAY		       0x1ABE

/* MARK: - 1B00h-1B7Fh - Balinese */

#define Z_UNICODE_BALINESE_SIGN_ULU_RICEM				0x1B00
#define Z_UNICODE_BALINESE_SIGN_ULU_CANDRA				0x1B01
#define Z_UNICODE_BALINESE_SIGN_CECEK					0x1B02
#define Z_UNICODE_BALINESE_SIGN_SURANG					0x1B03
#define Z_UNICODE_BALINESE_SIGN_BISAH					0x1B04
#define Z_UNICODE_BALINESE_LETTER_AKARA					0x1B05
#define Z_UNICODE_BALINESE_LETTER_AKARA_TEDUNG				0x1B06
#define Z_UNICODE_BALINESE_LETTER_IKARA					0x1B07
#define Z_UNICODE_BALINESE_LETTER_IKARA_TEDUNG				0x1B08
#define Z_UNICODE_BALINESE_LETTER_UKARA					0x1B09
#define Z_UNICODE_BALINESE_LETTER_UKARA_TEDUNG				0x1B0A
#define Z_UNICODE_BALINESE_LETTER_RA_REPA				0x1B0B
#define Z_UNICODE_BALINESE_LETTER_RA_REPA_TEDUNG			0x1B0C
#define Z_UNICODE_BALINESE_LETTER_LA_LENGA				0x1B0D
#define Z_UNICODE_BALINESE_LETTER_LA_LENGA_TEDUNG			0x1B0E
#define Z_UNICODE_BALINESE_LETTER_EKARA					0x1B0F
#define Z_UNICODE_BALINESE_LETTER_AIKARA				0x1B10
#define Z_UNICODE_BALINESE_LETTER_OKARA					0x1B11
#define Z_UNICODE_BALINESE_LETTER_OKARA_TEDUNG				0x1B12
#define Z_UNICODE_BALINESE_LETTER_KA					0x1B13
#define Z_UNICODE_BALINESE_LETTER_KA_MAHAPRANA				0x1B14
#define Z_UNICODE_BALINESE_LETTER_GA					0x1B15
#define Z_UNICODE_BALINESE_LETTER_GA_GORA				0x1B16
#define Z_UNICODE_BALINESE_LETTER_NGA					0x1B17
#define Z_UNICODE_BALINESE_LETTER_CA					0x1B18
#define Z_UNICODE_BALINESE_LETTER_CA_LACA				0x1B19
#define Z_UNICODE_BALINESE_LETTER_JA					0x1B1A
#define Z_UNICODE_BALINESE_LETTER_JA_JERA				0x1B1B
#define Z_UNICODE_BALINESE_LETTER_NYA					0x1B1C
#define Z_UNICODE_BALINESE_LETTER_TA_LATIK				0x1B1D
#define Z_UNICODE_BALINESE_LETTER_TA_MURDA_MAHAPRANA			0x1B1E
#define Z_UNICODE_BALINESE_LETTER_DA_MURDA_ALPAPRANA			0x1B1F
#define Z_UNICODE_BALINESE_LETTER_DA_MURDA_MAHAPRANA			0x1B20
#define Z_UNICODE_BALINESE_LETTER_NA_RAMBAT				0x1B21
#define Z_UNICODE_BALINESE_LETTER_TA					0x1B22
#define Z_UNICODE_BALINESE_LETTER_TA_TAWA				0x1B23
#define Z_UNICODE_BALINESE_LETTER_DA					0x1B24
#define Z_UNICODE_BALINESE_LETTER_DA_MADU				0x1B25
#define Z_UNICODE_BALINESE_LETTER_NA					0x1B26
#define Z_UNICODE_BALINESE_LETTER_PA					0x1B27
#define Z_UNICODE_BALINESE_LETTER_PA_KAPAL				0x1B28
#define Z_UNICODE_BALINESE_LETTER_BA					0x1B29
#define Z_UNICODE_BALINESE_LETTER_BA_KEMBANG				0x1B2A
#define Z_UNICODE_BALINESE_LETTER_MA					0x1B2B
#define Z_UNICODE_BALINESE_LETTER_YA					0x1B2C
#define Z_UNICODE_BALINESE_LETTER_RA					0x1B2D
#define Z_UNICODE_BALINESE_LETTER_LA					0x1B2E
#define Z_UNICODE_BALINESE_LETTER_WA					0x1B2F
#define Z_UNICODE_BALINESE_LETTER_SA_SAGA				0x1B30
#define Z_UNICODE_BALINESE_LETTER_SA_SAPA				0x1B31
#define Z_UNICODE_BALINESE_LETTER_SA					0x1B32
#define Z_UNICODE_BALINESE_LETTER_HA					0x1B33
#define Z_UNICODE_BALINESE_SIGN_REREKAN					0x1B34
#define Z_UNICODE_BALINESE_VOWEL_SIGN_TEDUNG				0x1B35
#define Z_UNICODE_BALINESE_VOWEL_SIGN_ULU				0x1B36
#define Z_UNICODE_BALINESE_VOWEL_SIGN_ULU_SARI				0x1B37
#define Z_UNICODE_BALINESE_VOWEL_SIGN_SUKU				0x1B38
#define Z_UNICODE_BALINESE_VOWEL_SIGN_SUKU_ILUT				0x1B39
#define Z_UNICODE_BALINESE_VOWEL_SIGN_RA_REPA				0x1B3A
#define Z_UNICODE_BALINESE_VOWEL_SIGN_RA_REPA_TEDUNG			0x1B3B
#define Z_UNICODE_BALINESE_VOWEL_SIGN_LA_LENGA				0x1B3C
#define Z_UNICODE_BALINESE_VOWEL_SIGN_LA_LENGA_TEDUNG			0x1B3D
#define Z_UNICODE_BALINESE_VOWEL_SIGN_TALING				0x1B3E
#define Z_UNICODE_BALINESE_VOWEL_SIGN_TALING_REPA			0x1B3F
#define Z_UNICODE_BALINESE_VOWEL_SIGN_TALING_TEDUNG			0x1B40
#define Z_UNICODE_BALINESE_VOWEL_SIGN_TALING_REPA_TEDUNG		0x1B41
#define Z_UNICODE_BALINESE_VOWEL_SIGN_PEPET				0x1B42
#define Z_UNICODE_BALINESE_VOWEL_SIGN_PEPET_TEDUNG			0x1B43
#define Z_UNICODE_BALINESE_ADEG_ADEG					0x1B44
#define Z_UNICODE_BALINESE_LETTER_KAF_SASAK				0x1B45
#define Z_UNICODE_BALINESE_LETTER_KHOT_SASAK				0x1B46
#define Z_UNICODE_BALINESE_LETTER_TZIR_SASAK				0x1B47
#define Z_UNICODE_BALINESE_LETTER_EF_SASAK				0x1B48
#define Z_UNICODE_BALINESE_LETTER_VE_SASAK				0x1B49
#define Z_UNICODE_BALINESE_LETTER_ZAL_SASAK				0x1B4A
#define Z_UNICODE_BALINESE_LETTER_ASYURA_SASAK				0x1B4B
#define Z_UNICODE_BALINESE_DIGIT_ZERO					0x1B50
#define Z_UNICODE_BALINESE_DIGIT_ONE					0x1B51
#define Z_UNICODE_BALINESE_DIGIT_TWO					0x1B52
#define Z_UNICODE_BALINESE_DIGIT_THREE					0x1B53
#define Z_UNICODE_BALINESE_DIGIT_FOUR					0x1B54
#define Z_UNICODE_BALINESE_DIGIT_FIVE					0x1B55
#define Z_UNICODE_BALINESE_DIGIT_SIX					0x1B56
#define Z_UNICODE_BALINESE_DIGIT_SEVEN					0x1B57
#define Z_UNICODE_BALINESE_DIGIT_EIGHT					0x1B58
#define Z_UNICODE_BALINESE_DIGIT_NINE					0x1B59
#define Z_UNICODE_BALINESE_PANTI					0x1B5A
#define Z_UNICODE_BALINESE_PAMADA					0x1B5B
#define Z_UNICODE_BALINESE_WINDU					0x1B5C
#define Z_UNICODE_BALINESE_CARIK_PAMUNGKAH				0x1B5D
#define Z_UNICODE_BALINESE_CARIK_SIKI					0x1B5E
#define Z_UNICODE_BALINESE_CARIK_PAREREN				0x1B5F
#define Z_UNICODE_BALINESE_PAMENENG					0x1B60
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DONG				0x1B61
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DENG				0x1B62
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DUNG				0x1B63
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DANG				0x1B64
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DANG_SURANG			0x1B65
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DING				0x1B66
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DAENG				0x1B67
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DEUNG				0x1B68
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DAING				0x1B69
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_DANG_GEDE			0x1B6A
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_TEGEH		0x1B6B
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_ENDEP		0x1B6C
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPUL		0x1B6D
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPLI		0x1B6E
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_JEGOGAN		0x1B6F
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPUL_WITH_JEGOGAN	0x1B70
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_KEMPLI_WITH_JEGOGAN	0x1B71
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_BENDE		0x1B72
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_COMBINING_GONG		0x1B73
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_OPEN_DUG		0x1B74
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_OPEN_DAG		0x1B75
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_CLOSED_TUK		0x1B76
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_RIGHT_HAND_CLOSED_TAK		0x1B77
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PANG		0x1B78
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PUNG		0x1B79
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_CLOSED_PLAK		0x1B7A
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_CLOSED_PLUK		0x1B7B
#define Z_UNICODE_BALINESE_MUSICAL_SYMBOL_LEFT_HAND_OPEN_PING		0x1B7C

/* MARK: - 1B80h-1BBFh - Sundanese */

#define Z_UNICODE_SUNDANESE_SIGN_PANYECEK	       0x1B80
#define Z_UNICODE_SUNDANESE_SIGN_PANGLAYAR	       0x1B81
#define Z_UNICODE_SUNDANESE_SIGN_PANGWISAD	       0x1B82
#define Z_UNICODE_SUNDANESE_LETTER_A		       0x1B83
#define Z_UNICODE_SUNDANESE_LETTER_I		       0x1B84
#define Z_UNICODE_SUNDANESE_LETTER_U		       0x1B85
#define Z_UNICODE_SUNDANESE_LETTER_AE		       0x1B86
#define Z_UNICODE_SUNDANESE_LETTER_O		       0x1B87
#define Z_UNICODE_SUNDANESE_LETTER_E		       0x1B88
#define Z_UNICODE_SUNDANESE_LETTER_EU		       0x1B89
#define Z_UNICODE_SUNDANESE_LETTER_KA		       0x1B8A
#define Z_UNICODE_SUNDANESE_LETTER_QA		       0x1B8B
#define Z_UNICODE_SUNDANESE_LETTER_GA		       0x1B8C
#define Z_UNICODE_SUNDANESE_LETTER_NGA		       0x1B8D
#define Z_UNICODE_SUNDANESE_LETTER_CA		       0x1B8E
#define Z_UNICODE_SUNDANESE_LETTER_JA		       0x1B8F
#define Z_UNICODE_SUNDANESE_LETTER_ZA		       0x1B90
#define Z_UNICODE_SUNDANESE_LETTER_NYA		       0x1B91
#define Z_UNICODE_SUNDANESE_LETTER_TA		       0x1B92
#define Z_UNICODE_SUNDANESE_LETTER_DA		       0x1B93
#define Z_UNICODE_SUNDANESE_LETTER_NA		       0x1B94
#define Z_UNICODE_SUNDANESE_LETTER_PA		       0x1B95
#define Z_UNICODE_SUNDANESE_LETTER_FA		       0x1B96
#define Z_UNICODE_SUNDANESE_LETTER_VA		       0x1B97
#define Z_UNICODE_SUNDANESE_LETTER_BA		       0x1B98
#define Z_UNICODE_SUNDANESE_LETTER_MA		       0x1B99
#define Z_UNICODE_SUNDANESE_LETTER_YA		       0x1B9A
#define Z_UNICODE_SUNDANESE_LETTER_RA		       0x1B9B
#define Z_UNICODE_SUNDANESE_LETTER_LA		       0x1B9C
#define Z_UNICODE_SUNDANESE_LETTER_WA		       0x1B9D
#define Z_UNICODE_SUNDANESE_LETTER_SA		       0x1B9E
#define Z_UNICODE_SUNDANESE_LETTER_XA		       0x1B9F
#define Z_UNICODE_SUNDANESE_LETTER_HA		       0x1BA0
#define Z_UNICODE_SUNDANESE_CONSONANT_SIGN_PAMINGKAL   0x1BA1
#define Z_UNICODE_SUNDANESE_CONSONANT_SIGN_PANYAKRA    0x1BA2
#define Z_UNICODE_SUNDANESE_CONSONANT_SIGN_PANYIKU     0x1BA3
#define Z_UNICODE_SUNDANESE_VOWEL_SIGN_PANGHULU	       0x1BA4
#define Z_UNICODE_SUNDANESE_VOWEL_SIGN_PANYUKU	       0x1BA5
#define Z_UNICODE_SUNDANESE_VOWEL_SIGN_PANAELAENG      0x1BA6
#define Z_UNICODE_SUNDANESE_VOWEL_SIGN_PANOLONG	       0x1BA7
#define Z_UNICODE_SUNDANESE_VOWEL_SIGN_PAMEPET	       0x1BA8
#define Z_UNICODE_SUNDANESE_VOWEL_SIGN_PANEULEUNG      0x1BA9
#define Z_UNICODE_SUNDANESE_SIGN_PAMAAEH	       0x1BAA
#define Z_UNICODE_SUNDANESE_SIGN_VIRAMA		       0x1BAB
#define Z_UNICODE_SUNDANESE_CONSONANT_SIGN_PASANGAN_MA 0x1BAC
#define Z_UNICODE_SUNDANESE_CONSONANT_SIGN_PASANGAN_WA 0x1BAD
#define Z_UNICODE_SUNDANESE_LETTER_KHA		       0x1BAE
#define Z_UNICODE_SUNDANESE_LETTER_SYA		       0x1BAF
#define Z_UNICODE_SUNDANESE_DIGIT_ZERO		       0x1BB0
#define Z_UNICODE_SUNDANESE_DIGIT_ONE		       0x1BB1
#define Z_UNICODE_SUNDANESE_DIGIT_TWO		       0x1BB2
#define Z_UNICODE_SUNDANESE_DIGIT_THREE		       0x1BB3
#define Z_UNICODE_SUNDANESE_DIGIT_FOUR		       0x1BB4
#define Z_UNICODE_SUNDANESE_DIGIT_FIVE		       0x1BB5
#define Z_UNICODE_SUNDANESE_DIGIT_SIX		       0x1BB6
#define Z_UNICODE_SUNDANESE_DIGIT_SEVEN		       0x1BB7
#define Z_UNICODE_SUNDANESE_DIGIT_EIGHT		       0x1BB8
#define Z_UNICODE_SUNDANESE_DIGIT_NINE		       0x1BB9
#define Z_UNICODE_SUNDANESE_AVAGRAHA		       0x1BBA
#define Z_UNICODE_SUNDANESE_LETTER_REU		       0x1BBB
#define Z_UNICODE_SUNDANESE_LETTER_LEU		       0x1BBC
#define Z_UNICODE_SUNDANESE_LETTER_BHA		       0x1BBD
#define Z_UNICODE_SUNDANESE_LETTER_FINAL_K	       0x1BBE
#define Z_UNICODE_SUNDANESE_LETTER_FINAL_M	       0x1BBF

/* MARK: - 1BC0h-1BFFh - Batak */

#define Z_UNICODE_BATAK_LETTER_A		       0x1BC0
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_A	       0x1BC1
#define Z_UNICODE_BATAK_LETTER_HA		       0x1BC2
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_HA	       0x1BC3
#define Z_UNICODE_BATAK_LETTER_MANDAILING_HA	       0x1BC4
#define Z_UNICODE_BATAK_LETTER_BA		       0x1BC5
#define Z_UNICODE_BATAK_LETTER_KARO_BA		       0x1BC6
#define Z_UNICODE_BATAK_LETTER_PA		       0x1BC7
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_PA	       0x1BC8
#define Z_UNICODE_BATAK_LETTER_NA		       0x1BC9
#define Z_UNICODE_BATAK_LETTER_MANDAILING_NA	       0x1BCA
#define Z_UNICODE_BATAK_LETTER_WA		       0x1BCB
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_WA	       0x1BCC
#define Z_UNICODE_BATAK_LETTER_PAKPAK_WA	       0x1BCD
#define Z_UNICODE_BATAK_LETTER_GA		       0x1BCE
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_GA	       0x1BCF
#define Z_UNICODE_BATAK_LETTER_JA		       0x1BD0
#define Z_UNICODE_BATAK_LETTER_DA		       0x1BD1
#define Z_UNICODE_BATAK_LETTER_RA		       0x1BD2
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_RA	       0x1BD3
#define Z_UNICODE_BATAK_LETTER_MA		       0x1BD4
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_MA	       0x1BD5
#define Z_UNICODE_BATAK_LETTER_SOUTHERN_TA	       0x1BD6
#define Z_UNICODE_BATAK_LETTER_NORTHERN_TA	       0x1BD7
#define Z_UNICODE_BATAK_LETTER_SA		       0x1BD8
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_SA	       0x1BD9
#define Z_UNICODE_BATAK_LETTER_MANDAILING_SA	       0x1BDA
#define Z_UNICODE_BATAK_LETTER_YA		       0x1BDB
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_YA	       0x1BDC
#define Z_UNICODE_BATAK_LETTER_NGA		       0x1BDD
#define Z_UNICODE_BATAK_LETTER_LA		       0x1BDE
#define Z_UNICODE_BATAK_LETTER_SIMALUNGUN_LA	       0x1BDF
#define Z_UNICODE_BATAK_LETTER_NYA		       0x1BE0
#define Z_UNICODE_BATAK_LETTER_CA		       0x1BE1
#define Z_UNICODE_BATAK_LETTER_NDA		       0x1BE2
#define Z_UNICODE_BATAK_LETTER_MBA		       0x1BE3
#define Z_UNICODE_BATAK_LETTER_I		       0x1BE4
#define Z_UNICODE_BATAK_LETTER_U		       0x1BE5
#define Z_UNICODE_BATAK_SIGN_TOMPI		       0x1BE6
#define Z_UNICODE_BATAK_VOWEL_SIGN_E		       0x1BE7
#define Z_UNICODE_BATAK_VOWEL_SIGN_PAKPAK_E	       0x1BE8
#define Z_UNICODE_BATAK_VOWEL_SIGN_EE		       0x1BE9
#define Z_UNICODE_BATAK_VOWEL_SIGN_I		       0x1BEA
#define Z_UNICODE_BATAK_VOWEL_SIGN_KARO_I	       0x1BEB
#define Z_UNICODE_BATAK_VOWEL_SIGN_O		       0x1BEC
#define Z_UNICODE_BATAK_VOWEL_SIGN_KARO_O	       0x1BED
#define Z_UNICODE_BATAK_VOWEL_SIGN_U		       0x1BEE
#define Z_UNICODE_BATAK_VOWEL_SIGN_U_FOR_SIMALUNGUN_SA 0x1BEF
#define Z_UNICODE_BATAK_CONSONANT_SIGN_NG	       0x1BF0
#define Z_UNICODE_BATAK_CONSONANT_SIGN_H	       0x1BF1
#define Z_UNICODE_BATAK_PANGOLAT		       0x1BF2
#define Z_UNICODE_BATAK_PANONGONAN		       0x1BF3
#define Z_UNICODE_BATAK_SYMBOL_BINDU_NA_METEK	       0x1BFC
#define Z_UNICODE_BATAK_SYMBOL_BINDU_PINARBORAS	       0x1BFD
#define Z_UNICODE_BATAK_SYMBOL_BINDU_JUDUL	       0x1BFE
#define Z_UNICODE_BATAK_SYMBOL_BINDU_PANGOLAT	       0x1BFF

/* MARK: - 1C00h-1C4Fh - Lepcha */

#define Z_UNICODE_LEPCHA_LETTER_KA			0x1C00
#define Z_UNICODE_LEPCHA_LETTER_KLA			0x1C01
#define Z_UNICODE_LEPCHA_LETTER_KHA			0x1C02
#define Z_UNICODE_LEPCHA_LETTER_GA			0x1C03
#define Z_UNICODE_LEPCHA_LETTER_GLA			0x1C04
#define Z_UNICODE_LEPCHA_LETTER_NGA			0x1C05
#define Z_UNICODE_LEPCHA_LETTER_CA			0x1C06
#define Z_UNICODE_LEPCHA_LETTER_CHA			0x1C07
#define Z_UNICODE_LEPCHA_LETTER_JA			0x1C08
#define Z_UNICODE_LEPCHA_LETTER_NYA			0x1C09
#define Z_UNICODE_LEPCHA_LETTER_TA			0x1C0A
#define Z_UNICODE_LEPCHA_LETTER_THA			0x1C0B
#define Z_UNICODE_LEPCHA_LETTER_DA			0x1C0C
#define Z_UNICODE_LEPCHA_LETTER_NA			0x1C0D
#define Z_UNICODE_LEPCHA_LETTER_PA			0x1C0E
#define Z_UNICODE_LEPCHA_LETTER_PLA			0x1C0F
#define Z_UNICODE_LEPCHA_LETTER_PHA			0x1C10
#define Z_UNICODE_LEPCHA_LETTER_FA			0x1C11
#define Z_UNICODE_LEPCHA_LETTER_FLA			0x1C12
#define Z_UNICODE_LEPCHA_LETTER_BA			0x1C13
#define Z_UNICODE_LEPCHA_LETTER_BLA			0x1C14
#define Z_UNICODE_LEPCHA_LETTER_MA			0x1C15
#define Z_UNICODE_LEPCHA_LETTER_MLA			0x1C16
#define Z_UNICODE_LEPCHA_LETTER_TSA			0x1C17
#define Z_UNICODE_LEPCHA_LETTER_TSHA			0x1C18
#define Z_UNICODE_LEPCHA_LETTER_DZA			0x1C19
#define Z_UNICODE_LEPCHA_LETTER_YA			0x1C1A
#define Z_UNICODE_LEPCHA_LETTER_RA			0x1C1B
#define Z_UNICODE_LEPCHA_LETTER_LA			0x1C1C
#define Z_UNICODE_LEPCHA_LETTER_HA			0x1C1D
#define Z_UNICODE_LEPCHA_LETTER_HLA			0x1C1E
#define Z_UNICODE_LEPCHA_LETTER_VA			0x1C1F
#define Z_UNICODE_LEPCHA_LETTER_SA			0x1C20
#define Z_UNICODE_LEPCHA_LETTER_SHA			0x1C21
#define Z_UNICODE_LEPCHA_LETTER_WA			0x1C22
#define Z_UNICODE_LEPCHA_LETTER_A			0x1C23
#define Z_UNICODE_LEPCHA_SUBJOINED_LETTER_YA		0x1C24
#define Z_UNICODE_LEPCHA_SUBJOINED_LETTER_RA		0x1C25
#define Z_UNICODE_LEPCHA_VOWEL_SIGN_AA			0x1C26
#define Z_UNICODE_LEPCHA_VOWEL_SIGN_I			0x1C27
#define Z_UNICODE_LEPCHA_VOWEL_SIGN_O			0x1C28
#define Z_UNICODE_LEPCHA_VOWEL_SIGN_OO			0x1C29
#define Z_UNICODE_LEPCHA_VOWEL_SIGN_U			0x1C2A
#define Z_UNICODE_LEPCHA_VOWEL_SIGN_UU			0x1C2B
#define Z_UNICODE_LEPCHA_VOWEL_SIGN_E			0x1C2C
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_K		0x1C2D
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_M		0x1C2E
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_L		0x1C2F
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_N		0x1C30
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_P		0x1C31
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_R		0x1C32
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_T		0x1C33
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_NYIN_DO		0x1C34
#define Z_UNICODE_LEPCHA_CONSONANT_SIGN_KANG		0x1C35
#define Z_UNICODE_LEPCHA_SIGN_RAN			0x1C36
#define Z_UNICODE_LEPCHA_SIGN_NUKTA			0x1C37
#define Z_UNICODE_LEPCHA_PUNCTUATION_TA_ROL		0x1C3B
#define Z_UNICODE_LEPCHA_PUNCTUATION_NYET_THYOOM_TA_ROL	0x1C3C
#define Z_UNICODE_LEPCHA_PUNCTUATION_CER_WA		0x1C3D
#define Z_UNICODE_LEPCHA_PUNCTUATION_TSHOOK_CER_WA	0x1C3E
#define Z_UNICODE_LEPCHA_PUNCTUATION_TSHOOK		0x1C3F
#define Z_UNICODE_LEPCHA_DIGIT_ZERO			0x1C40
#define Z_UNICODE_LEPCHA_DIGIT_ONE			0x1C41
#define Z_UNICODE_LEPCHA_DIGIT_TWO			0x1C42
#define Z_UNICODE_LEPCHA_DIGIT_THREE			0x1C43
#define Z_UNICODE_LEPCHA_DIGIT_FOUR			0x1C44
#define Z_UNICODE_LEPCHA_DIGIT_FIVE			0x1C45
#define Z_UNICODE_LEPCHA_DIGIT_SIX			0x1C46
#define Z_UNICODE_LEPCHA_DIGIT_SEVEN			0x1C47
#define Z_UNICODE_LEPCHA_DIGIT_EIGHT			0x1C48
#define Z_UNICODE_LEPCHA_DIGIT_NINE			0x1C49
#define Z_UNICODE_LEPCHA_LETTER_TTA			0x1C4D
#define Z_UNICODE_LEPCHA_LETTER_TTHA			0x1C4E
#define Z_UNICODE_LEPCHA_LETTER_DDA			0x1C4F

/* MARK: - 1C50h-1C7Fh - Ol Chiki */

#define Z_UNICODE_OL_CHIKI_DIGIT_ZERO		     0x1C50
#define Z_UNICODE_OL_CHIKI_DIGIT_ONE		     0x1C51
#define Z_UNICODE_OL_CHIKI_DIGIT_TWO		     0x1C52
#define Z_UNICODE_OL_CHIKI_DIGIT_THREE		     0x1C53
#define Z_UNICODE_OL_CHIKI_DIGIT_FOUR		     0x1C54
#define Z_UNICODE_OL_CHIKI_DIGIT_FIVE		     0x1C55
#define Z_UNICODE_OL_CHIKI_DIGIT_SIX		     0x1C56
#define Z_UNICODE_OL_CHIKI_DIGIT_SEVEN		     0x1C57
#define Z_UNICODE_OL_CHIKI_DIGIT_EIGHT		     0x1C58
#define Z_UNICODE_OL_CHIKI_DIGIT_NINE		     0x1C59
#define Z_UNICODE_OL_CHIKI_LETTER_LA		     0x1C5A
#define Z_UNICODE_OL_CHIKI_LETTER_AT		     0x1C5B
#define Z_UNICODE_OL_CHIKI_LETTER_AG		     0x1C5C
#define Z_UNICODE_OL_CHIKI_LETTER_ANG		     0x1C5D
#define Z_UNICODE_OL_CHIKI_LETTER_AL		     0x1C5E
#define Z_UNICODE_OL_CHIKI_LETTER_LAA		     0x1C5F
#define Z_UNICODE_OL_CHIKI_LETTER_AAK		     0x1C60
#define Z_UNICODE_OL_CHIKI_LETTER_AAJ		     0x1C61
#define Z_UNICODE_OL_CHIKI_LETTER_AAM		     0x1C62
#define Z_UNICODE_OL_CHIKI_LETTER_AAW		     0x1C63
#define Z_UNICODE_OL_CHIKI_LETTER_LI		     0x1C64
#define Z_UNICODE_OL_CHIKI_LETTER_IS		     0x1C65
#define Z_UNICODE_OL_CHIKI_LETTER_IH		     0x1C66
#define Z_UNICODE_OL_CHIKI_LETTER_INY		     0x1C67
#define Z_UNICODE_OL_CHIKI_LETTER_IR		     0x1C68
#define Z_UNICODE_OL_CHIKI_LETTER_LU		     0x1C69
#define Z_UNICODE_OL_CHIKI_LETTER_UC		     0x1C6A
#define Z_UNICODE_OL_CHIKI_LETTER_UD		     0x1C6B
#define Z_UNICODE_OL_CHIKI_LETTER_UNN		     0x1C6C
#define Z_UNICODE_OL_CHIKI_LETTER_UY		     0x1C6D
#define Z_UNICODE_OL_CHIKI_LETTER_LE		     0x1C6E
#define Z_UNICODE_OL_CHIKI_LETTER_EP		     0x1C6F
#define Z_UNICODE_OL_CHIKI_LETTER_EDD		     0x1C70
#define Z_UNICODE_OL_CHIKI_LETTER_EN		     0x1C71
#define Z_UNICODE_OL_CHIKI_LETTER_ERR		     0x1C72
#define Z_UNICODE_OL_CHIKI_LETTER_LO		     0x1C73
#define Z_UNICODE_OL_CHIKI_LETTER_OTT		     0x1C74
#define Z_UNICODE_OL_CHIKI_LETTER_OB		     0x1C75
#define Z_UNICODE_OL_CHIKI_LETTER_OV		     0x1C76
#define Z_UNICODE_OL_CHIKI_LETTER_OH		     0x1C77
#define Z_UNICODE_OL_CHIKI_MU_TTUDDAG		     0x1C78
#define Z_UNICODE_OL_CHIKI_GAAHLAA_TTUDDAAG	     0x1C79
#define Z_UNICODE_OL_CHIKI_MU_GAAHLAA_TTUDDAAG	     0x1C7A
#define Z_UNICODE_OL_CHIKI_RELAA		     0x1C7B
#define Z_UNICODE_OL_CHIKI_PHAARKAA		     0x1C7C
#define Z_UNICODE_OL_CHIKI_AHAD			     0x1C7D
#define Z_UNICODE_OL_CHIKI_PUNCTUATION_MUCAAD	     0x1C7E
#define Z_UNICODE_OL_CHIKI_PUNCTUATION_DOUBLE_MUCAAD 0x1C7F

/* MARK: - 1CC0h-1CCFh - Sundanese Supplement */

#define Z_UNICODE_SUNDANESE_PUNCTUATION_BINDU_SURYA	  0x1CC0
#define Z_UNICODE_SUNDANESE_PUNCTUATION_BINDU_PANGLONG	  0x1CC1
#define Z_UNICODE_SUNDANESE_PUNCTUATION_BINDU_PURNAMA	  0x1CC2
#define Z_UNICODE_SUNDANESE_PUNCTUATION_BINDU_CAKRA	  0x1CC3
#define Z_UNICODE_SUNDANESE_PUNCTUATION_BINDU_LEU_SATANGA 0x1CC4
#define Z_UNICODE_SUNDANESE_PUNCTUATION_BINDU_KA_SATANGA  0x1CC5
#define Z_UNICODE_SUNDANESE_PUNCTUATION_BINDU_DA_SATANGA  0x1CC6
#define Z_UNICODE_SUNDANESE_PUNCTUATION_BINDU_BA_SATANGA  0x1CC7

/* MARK: - 1CD0h-1CFFh - Vedic Extensions */

#define Z_UNICODE_VEDIC_TONE_KARSHANA					      0x1CD0
#define Z_UNICODE_VEDIC_TONE_SHARA					      0x1CD1
#define Z_UNICODE_VEDIC_TONE_PRENKHA					      0x1CD2
#define Z_UNICODE_VEDIC_SIGN_NIHSHVASA					      0x1CD3
#define Z_UNICODE_VEDIC_SIGN_YAJURVEDIC_MIDLINE_SVARITA			      0x1CD4
#define Z_UNICODE_VEDIC_TONE_YAJURVEDIC_AGGRAVATED_INDEPENDENT_SVARITA	      0x1CD5
#define Z_UNICODE_VEDIC_TONE_YAJURVEDIC_INDEPENDENT_SVARITA		      0x1CD6
#define Z_UNICODE_VEDIC_TONE_YAJURVEDIC_KATHAKA_INDEPENDENT_SVARITA	      0x1CD7
#define Z_UNICODE_VEDIC_TONE_CANDRA_BELOW				      0x1CD8
#define Z_UNICODE_VEDIC_TONE_YAJURVEDIC_KATHAKA_INDEPENDENT_SVARITA_SCHROEDER 0x1CD9
#define Z_UNICODE_VEDIC_TONE_DOUBLE_SVARITA				      0x1CDA
#define Z_UNICODE_VEDIC_TONE_TRIPLE_SVARITA				      0x1CDB
#define Z_UNICODE_VEDIC_TONE_KATHAKA_ANUDATTA				      0x1CDC
#define Z_UNICODE_VEDIC_TONE_DOT_BELOW					      0x1CDD
#define Z_UNICODE_VEDIC_TONE_TWO_DOTS_BELOW				      0x1CDE
#define Z_UNICODE_VEDIC_TONE_THREE_DOTS_BELOW				      0x1CDF
#define Z_UNICODE_VEDIC_TONE_RIGVEDIC_KASHMIRI_INDEPENDENT_SVARITA	      0x1CE0
#define Z_UNICODE_VEDIC_TONE_ATHARVAVEDIC_INDEPENDENT_SVARITA		      0x1CE1
#define Z_UNICODE_VEDIC_SIGN_VISARGA_SVARITA				      0x1CE2
#define Z_UNICODE_VEDIC_SIGN_VISARGA_UDATTA				      0x1CE3
#define Z_UNICODE_VEDIC_SIGN_REVERSED_VISARGA_UDATTA			      0x1CE4
#define Z_UNICODE_VEDIC_SIGN_VISARGA_ANUDATTA				      0x1CE5
#define Z_UNICODE_VEDIC_SIGN_REVERSED_VISARGA_ANUDATTA			      0x1CE6
#define Z_UNICODE_VEDIC_SIGN_VISARGA_UDATTA_WITH_TAIL			      0x1CE7
#define Z_UNICODE_VEDIC_SIGN_VISARGA_ANUDATTA_WITH_TAIL			      0x1CE8
#define Z_UNICODE_VEDIC_SIGN_ANUSVARA_ANTARGOMUKHA			      0x1CE9
#define Z_UNICODE_VEDIC_SIGN_ANUSVARA_BAHIRGOMUKHA			      0x1CEA
#define Z_UNICODE_VEDIC_SIGN_ANUSVARA_VAMAGOMUKHA			      0x1CEB
#define Z_UNICODE_VEDIC_SIGN_ANUSVARA_VAMAGOMUKHA_WITH_TAIL		      0x1CEC
#define Z_UNICODE_VEDIC_SIGN_TIRYAK					      0x1CED
#define Z_UNICODE_VEDIC_SIGN_HEXIFORM_LONG_ANUSVARA			      0x1CEE
#define Z_UNICODE_VEDIC_SIGN_LONG_ANUSVARA				      0x1CEF
#define Z_UNICODE_VEDIC_SIGN_RTHANG_LONG_ANUSVARA			      0x1CF0
#define Z_UNICODE_VEDIC_SIGN_ANUSVARA_UBHAYATO_MUKHA			      0x1CF1
#define Z_UNICODE_VEDIC_SIGN_ARDHAVISARGA				      0x1CF2
#define Z_UNICODE_VEDIC_SIGN_ROTATED_ARDHAVISARGA			      0x1CF3
#define Z_UNICODE_VEDIC_TONE_CANDRA_ABOVE				      0x1CF4
#define Z_UNICODE_VEDIC_SIGN_JIHVAMULIYA				      0x1CF5
#define Z_UNICODE_VEDIC_SIGN_UPADHMANIYA				      0x1CF6
#define Z_UNICODE_VEDIC_TONE_RING_ABOVE					      0x1CF8
#define Z_UNICODE_VEDIC_TONE_DOUBLE_RING_ABOVE				      0x1CF9

/* MARK: - 1D00h-1D7Fh - Phonetic Extensions */

#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_A			      0x1D00
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_AE			      0x1D01
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_AE			      0x1D02
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_BARRED_B		      0x1D03
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_C			      0x1D04
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_D			      0x1D05
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_ETH		      0x1D06
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_E			      0x1D07
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_OPEN_E		      0x1D08
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_I			      0x1D09
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_J			      0x1D0A
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_K			      0x1D0B
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_L_WITH_STROKE	      0x1D0C
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_M			      0x1D0D
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_REVERSED_N		      0x1D0E
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_O			      0x1D0F
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_OPEN_O		      0x1D10
#define Z_UNICODE_LATIN_SMALL_LETTER_SIDEWAYS_O			      0x1D11
#define Z_UNICODE_LATIN_SMALL_LETTER_SIDEWAYS_OPEN_O		      0x1D12
#define Z_UNICODE_LATIN_SMALL_LETTER_SIDEWAYS_O_WITH_STROKE	      0x1D13
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_OE			      0x1D14
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_OU			      0x1D15
#define Z_UNICODE_LATIN_SMALL_LETTER_TOP_HALF_O			      0x1D16
#define Z_UNICODE_LATIN_SMALL_LETTER_BOTTOM_HALF_O		      0x1D17
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_P			      0x1D18
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_REVERSED_R		      0x1D19
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_TURNED_R		      0x1D1A
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_T			      0x1D1B
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_U			      0x1D1C
#define Z_UNICODE_LATIN_SMALL_LETTER_SIDEWAYS_U			      0x1D1D
#define Z_UNICODE_LATIN_SMALL_LETTER_SIDEWAYS_DIAERESIZED_U	      0x1D1E
#define Z_UNICODE_LATIN_SMALL_LETTER_SIDEWAYS_TURNED_M		      0x1D1F
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_V			      0x1D20
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_W			      0x1D21
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_Z			      0x1D22
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_EZH		      0x1D23
#define Z_UNICODE_LATIN_LETTER_VOICED_LARYNGEAL_SPIRANT		      0x1D24
#define Z_UNICODE_LATIN_LETTER_AIN				      0x1D25
#define Z_UNICODE_GREEK_LETTER_SMALL_CAPITAL_GAMMA		      0x1D26
#define Z_UNICODE_GREEK_LETTER_SMALL_CAPITAL_LAMDA		      0x1D27
#define Z_UNICODE_GREEK_LETTER_SMALL_CAPITAL_PI			      0x1D28
#define Z_UNICODE_GREEK_LETTER_SMALL_CAPITAL_RHO		      0x1D29
#define Z_UNICODE_GREEK_LETTER_SMALL_CAPITAL_PSI		      0x1D2A
#define Z_UNICODE_CYRILLIC_LETTER_SMALL_CAPITAL_EL		      0x1D2B
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_A			      0x1D2C
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_AE			      0x1D2D
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_B			      0x1D2E
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_BARRED_B		      0x1D2F
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_D			      0x1D30
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_E			      0x1D31
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_REVERSED_E		      0x1D32
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_G			      0x1D33
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_H			      0x1D34
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_I			      0x1D35
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_J			      0x1D36
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_K			      0x1D37
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_L			      0x1D38
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_M			      0x1D39
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_N			      0x1D3A
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_REVERSED_N		      0x1D3B
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_O			      0x1D3C
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_OU			      0x1D3D
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_P			      0x1D3E
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_R			      0x1D3F
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_T			      0x1D40
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_U			      0x1D41
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_W			      0x1D42
#define Z_UNICODE_MODIFIER_LETTER_SMALL_A			      0x1D43
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_A		      0x1D44
#define Z_UNICODE_MODIFIER_LETTER_SMALL_ALPHA			      0x1D45
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_AE		      0x1D46
#define Z_UNICODE_MODIFIER_LETTER_SMALL_B			      0x1D47
#define Z_UNICODE_MODIFIER_LETTER_SMALL_D			      0x1D48
#define Z_UNICODE_MODIFIER_LETTER_SMALL_E			      0x1D49
#define Z_UNICODE_MODIFIER_LETTER_SMALL_SCHWA			      0x1D4A
#define Z_UNICODE_MODIFIER_LETTER_SMALL_OPEN_E			      0x1D4B
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_OPEN_E		      0x1D4C
#define Z_UNICODE_MODIFIER_LETTER_SMALL_G			      0x1D4D
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_I		      0x1D4E
#define Z_UNICODE_MODIFIER_LETTER_SMALL_K			      0x1D4F
#define Z_UNICODE_MODIFIER_LETTER_SMALL_M			      0x1D50
#define Z_UNICODE_MODIFIER_LETTER_SMALL_ENG			      0x1D51
#define Z_UNICODE_MODIFIER_LETTER_SMALL_O			      0x1D52
#define Z_UNICODE_MODIFIER_LETTER_SMALL_OPEN_O			      0x1D53
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TOP_HALF_O		      0x1D54
#define Z_UNICODE_MODIFIER_LETTER_SMALL_BOTTOM_HALF_O		      0x1D55
#define Z_UNICODE_MODIFIER_LETTER_SMALL_P			      0x1D56
#define Z_UNICODE_MODIFIER_LETTER_SMALL_T			      0x1D57
#define Z_UNICODE_MODIFIER_LETTER_SMALL_U			      0x1D58
#define Z_UNICODE_MODIFIER_LETTER_SMALL_SIDEWAYS_U		      0x1D59
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_M		      0x1D5A
#define Z_UNICODE_MODIFIER_LETTER_SMALL_V			      0x1D5B
#define Z_UNICODE_MODIFIER_LETTER_SMALL_AIN			      0x1D5C
#define Z_UNICODE_MODIFIER_LETTER_SMALL_BETA			      0x1D5D
#define Z_UNICODE_MODIFIER_LETTER_SMALL_GREEK_GAMMA		      0x1D5E
#define Z_UNICODE_MODIFIER_LETTER_SMALL_DELTA			      0x1D5F
#define Z_UNICODE_MODIFIER_LETTER_SMALL_GREEK_PHI		      0x1D60
#define Z_UNICODE_MODIFIER_LETTER_SMALL_CHI			      0x1D61
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_I		      0x1D62
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_R		      0x1D63
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_U		      0x1D64
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_V		      0x1D65
#define Z_UNICODE_GREEK_SUBSCRIPT_SMALL_LETTER_BETA		      0x1D66
#define Z_UNICODE_GREEK_SUBSCRIPT_SMALL_LETTER_GAMMA		      0x1D67
#define Z_UNICODE_GREEK_SUBSCRIPT_SMALL_LETTER_RHO		      0x1D68
#define Z_UNICODE_GREEK_SUBSCRIPT_SMALL_LETTER_PHI		      0x1D69
#define Z_UNICODE_GREEK_SUBSCRIPT_SMALL_LETTER_CHI		      0x1D6A
#define Z_UNICODE_LATIN_SMALL_LETTER_UE				      0x1D6B
#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_MIDDLE_TILDE	      0x1D6C
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_MIDDLE_TILDE	      0x1D6D
#define Z_UNICODE_LATIN_SMALL_LETTER_F_WITH_MIDDLE_TILDE	      0x1D6E
#define Z_UNICODE_LATIN_SMALL_LETTER_M_WITH_MIDDLE_TILDE	      0x1D6F
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_MIDDLE_TILDE	      0x1D70
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_MIDDLE_TILDE	      0x1D71
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_MIDDLE_TILDE	      0x1D72
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_FISHHOOK_AND_MIDDLE_TILDE 0x1D73
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_MIDDLE_TILDE	      0x1D74
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_MIDDLE_TILDE	      0x1D75
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_MIDDLE_TILDE	      0x1D76
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_G			      0x1D77
#define Z_UNICODE_MODIFIER_LETTER_CYRILLIC_EN			      0x1D78
#define Z_UNICODE_LATIN_SMALL_LETTER_INSULAR_G			      0x1D79
#define Z_UNICODE_LATIN_SMALL_LETTER_TH_WITH_STRIKETHROUGH	      0x1D7A
#define Z_UNICODE_LATIN_SMALL_CAPITAL_LETTER_I_WITH_STROKE	      0x1D7B
#define Z_UNICODE_LATIN_SMALL_LETTER_IOTA_WITH_STROKE		      0x1D7C
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_STROKE		      0x1D7D
#define Z_UNICODE_LATIN_SMALL_CAPITAL_LETTER_U_WITH_STROKE	      0x1D7E
#define Z_UNICODE_LATIN_SMALL_LETTER_UPSILON_WITH_STROKE	      0x1D7F

/* MARK: - 1D80h-1DBFh - Phonetic Extensions Supplement */

#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_PALATAL_HOOK		 0x1D80
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_PALATAL_HOOK		 0x1D81
#define Z_UNICODE_LATIN_SMALL_LETTER_F_WITH_PALATAL_HOOK		 0x1D82
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_PALATAL_HOOK		 0x1D83
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_PALATAL_HOOK		 0x1D84
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_PALATAL_HOOK		 0x1D85
#define Z_UNICODE_LATIN_SMALL_LETTER_M_WITH_PALATAL_HOOK		 0x1D86
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_PALATAL_HOOK		 0x1D87
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_PALATAL_HOOK		 0x1D88
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_PALATAL_HOOK		 0x1D89
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_PALATAL_HOOK		 0x1D8A
#define Z_UNICODE_LATIN_SMALL_LETTER_ESH_WITH_PALATAL_HOOK		 0x1D8B
#define Z_UNICODE_LATIN_SMALL_LETTER_V_WITH_PALATAL_HOOK		 0x1D8C
#define Z_UNICODE_LATIN_SMALL_LETTER_X_WITH_PALATAL_HOOK		 0x1D8D
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_PALATAL_HOOK		 0x1D8E
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_RETROFLEX_HOOK		 0x1D8F
#define Z_UNICODE_LATIN_SMALL_LETTER_ALPHA_WITH_RETROFLEX_HOOK		 0x1D90
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_HOOK_AND_TAIL		 0x1D91
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_RETROFLEX_HOOK		 0x1D92
#define Z_UNICODE_LATIN_SMALL_LETTER_OPEN_E_WITH_RETROFLEX_HOOK		 0x1D93
#define Z_UNICODE_LATIN_SMALL_LETTER_REVERSED_OPEN_E_WITH_RETROFLEX_HOOK 0x1D94
#define Z_UNICODE_LATIN_SMALL_LETTER_SCHWA_WITH_RETROFLEX_HOOK		 0x1D95
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_RETROFLEX_HOOK		 0x1D96
#define Z_UNICODE_LATIN_SMALL_LETTER_OPEN_O_WITH_RETROFLEX_HOOK		 0x1D97
#define Z_UNICODE_LATIN_SMALL_LETTER_ESH_WITH_RETROFLEX_HOOK		 0x1D98
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_RETROFLEX_HOOK		 0x1D99
#define Z_UNICODE_LATIN_SMALL_LETTER_EZH_WITH_RETROFLEX_HOOK		 0x1D9A
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_ALPHA			 0x1D9B
#define Z_UNICODE_MODIFIER_LETTER_SMALL_C				 0x1D9C
#define Z_UNICODE_MODIFIER_LETTER_SMALL_C_WITH_CURL			 0x1D9D
#define Z_UNICODE_MODIFIER_LETTER_SMALL_ETH				 0x1D9E
#define Z_UNICODE_MODIFIER_LETTER_SMALL_REVERSED_OPEN_E			 0x1D9F
#define Z_UNICODE_MODIFIER_LETTER_SMALL_F				 0x1DA0
#define Z_UNICODE_MODIFIER_LETTER_SMALL_DOTLESS_J_WITH_STROKE		 0x1DA1
#define Z_UNICODE_MODIFIER_LETTER_SMALL_SCRIPT_G			 0x1DA2
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_H			 0x1DA3
#define Z_UNICODE_MODIFIER_LETTER_SMALL_I_WITH_STROKE			 0x1DA4
#define Z_UNICODE_MODIFIER_LETTER_SMALL_IOTA				 0x1DA5
#define Z_UNICODE_MODIFIER_LETTER_SMALL_CAPITAL_I			 0x1DA6
#define Z_UNICODE_MODIFIER_LETTER_SMALL_CAPITAL_I_WITH_STROKE		 0x1DA7
#define Z_UNICODE_MODIFIER_LETTER_SMALL_J_WITH_CROSSED_TAIL		 0x1DA8
#define Z_UNICODE_MODIFIER_LETTER_SMALL_L_WITH_RETROFLEX_HOOK		 0x1DA9
#define Z_UNICODE_MODIFIER_LETTER_SMALL_L_WITH_PALATAL_HOOK		 0x1DAA
#define Z_UNICODE_MODIFIER_LETTER_SMALL_CAPITAL_L			 0x1DAB
#define Z_UNICODE_MODIFIER_LETTER_SMALL_M_WITH_HOOK			 0x1DAC
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_M_WITH_LONG_LEG		 0x1DAD
#define Z_UNICODE_MODIFIER_LETTER_SMALL_N_WITH_LEFT_HOOK		 0x1DAE
#define Z_UNICODE_MODIFIER_LETTER_SMALL_N_WITH_RETROFLEX_HOOK		 0x1DAF
#define Z_UNICODE_MODIFIER_LETTER_SMALL_CAPITAL_N			 0x1DB0
#define Z_UNICODE_MODIFIER_LETTER_SMALL_BARRED_O			 0x1DB1
#define Z_UNICODE_MODIFIER_LETTER_SMALL_PHI				 0x1DB2
#define Z_UNICODE_MODIFIER_LETTER_SMALL_S_WITH_HOOK			 0x1DB3
#define Z_UNICODE_MODIFIER_LETTER_SMALL_ESH				 0x1DB4
#define Z_UNICODE_MODIFIER_LETTER_SMALL_T_WITH_PALATAL_HOOK		 0x1DB5
#define Z_UNICODE_MODIFIER_LETTER_SMALL_U_BAR				 0x1DB6
#define Z_UNICODE_MODIFIER_LETTER_SMALL_UPSILON				 0x1DB7
#define Z_UNICODE_MODIFIER_LETTER_SMALL_CAPITAL_U			 0x1DB8
#define Z_UNICODE_MODIFIER_LETTER_SMALL_V_WITH_HOOK			 0x1DB9
#define Z_UNICODE_MODIFIER_LETTER_SMALL_TURNED_V			 0x1DBA
#define Z_UNICODE_MODIFIER_LETTER_SMALL_Z				 0x1DBB
#define Z_UNICODE_MODIFIER_LETTER_SMALL_Z_WITH_RETROFLEX_HOOK		 0x1DBC
#define Z_UNICODE_MODIFIER_LETTER_SMALL_Z_WITH_CURL			 0x1DBD
#define Z_UNICODE_MODIFIER_LETTER_SMALL_EZH				 0x1DBE
#define Z_UNICODE_MODIFIER_LETTER_SMALL_THETA				 0x1DBF

/* MARK: - 1DC0h-1DFFh - Combining Diacritical Marks Supplement */

#define Z_UNICODE_COMBINING_DOTTED_GRAVE_ACCENT					  0x1DC0
#define Z_UNICODE_COMBINING_DOTTED_ACUTE_ACCENT					  0x1DC1
#define Z_UNICODE_COMBINING_SNAKE_BELOW						  0x1DC2
#define Z_UNICODE_COMBINING_SUSPENSION_MARK					  0x1DC3
#define Z_UNICODE_COMBINING_MACRON_ACUTE					  0x1DC4
#define Z_UNICODE_COMBINING_GRAVE_MACRON					  0x1DC5
#define Z_UNICODE_COMBINING_MACRON_GRAVE					  0x1DC6
#define Z_UNICODE_COMBINING_ACUTE_MACRON					  0x1DC7
#define Z_UNICODE_COMBINING_GRAVE_ACUTE_GRAVE					  0x1DC8
#define Z_UNICODE_COMBINING_ACUTE_GRAVE_ACUTE					  0x1DC9
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_R_BELOW				  0x1DCA
#define Z_UNICODE_COMBINING_BREVE_MACRON					  0x1DCB
#define Z_UNICODE_COMBINING_MACRON_BREVE					  0x1DCC
#define Z_UNICODE_COMBINING_DOUBLE_CIRCUMFLEX_ABOVE				  0x1DCD
#define Z_UNICODE_COMBINING_OGONEK_ABOVE					  0x1DCE
#define Z_UNICODE_COMBINING_ZIGZAG_BELOW					  0x1DCF
#define Z_UNICODE_COMBINING_IS_BELOW						  0x1DD0
#define Z_UNICODE_COMBINING_UR_ABOVE						  0x1DD1
#define Z_UNICODE_COMBINING_US_ABOVE						  0x1DD2
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_FLATTENED_OPEN_A_ABOVE		  0x1DD3
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_AE				  0x1DD4
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_AO				  0x1DD5
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_AV				  0x1DD6
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_C_CEDILLA			  0x1DD7
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_INSULAR_D			  0x1DD8
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_ETH				  0x1DD9
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_G				  0x1DDA
#define Z_UNICODE_COMBINING_LATIN_LETTER_SMALL_CAPITAL_G			  0x1DDB
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_K				  0x1DDC
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_L				  0x1DDD
#define Z_UNICODE_COMBINING_LATIN_LETTER_SMALL_CAPITAL_L			  0x1DDE
#define Z_UNICODE_COMBINING_LATIN_LETTER_SMALL_CAPITAL_M			  0x1DDF
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_N				  0x1DE0
#define Z_UNICODE_COMBINING_LATIN_LETTER_SMALL_CAPITAL_N			  0x1DE1
#define Z_UNICODE_COMBINING_LATIN_LETTER_SMALL_CAPITAL_R			  0x1DE2
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_R_ROTUNDA			  0x1DE3
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_S				  0x1DE4
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_LONG_S				  0x1DE5
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_Z				  0x1DE6
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_ALPHA				  0x1DE7
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_B				  0x1DE8
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_BETA				  0x1DE9
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_SCHWA				  0x1DEA
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_F				  0x1DEB
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_L_WITH_DOUBLE_MIDDLE_TILDE	  0x1DEC
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_O_WITH_LIGHT_CENTRALIZATION_STROKE 0x1DED
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_P				  0x1DEE
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_ESH				  0x1DEF
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_U_WITH_LIGHT_CENTRALIZATION_STROKE 0x1DF0
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_W				  0x1DF1
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_A_WITH_DIAERESIS			  0x1DF2
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_O_WITH_DIAERESIS			  0x1DF3
#define Z_UNICODE_COMBINING_LATIN_SMALL_LETTER_U_WITH_DIAERESIS			  0x1DF4
#define Z_UNICODE_COMBINING_UP_TACK_ABOVE					  0x1DF5
#define Z_UNICODE_COMBINING_DOUBLE_INVERTED_BREVE_BELOW				  0x1DFC
#define Z_UNICODE_COMBINING_ALMOST_EQUAL_TO_BELOW				  0x1DFD
#define Z_UNICODE_COMBINING_LEFT_ARROWHEAD_ABOVE				  0x1DFE
#define Z_UNICODE_COMBINING_RIGHT_ARROWHEAD_AND_DOWN_ARROWHEAD_BELOW		  0x1DFF

/* MARK: - 1E00h-1EFFh - Latin Extended Additional */

#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_RING_BELOW		0x1E00
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_RING_BELOW			0x1E01
#define Z_UNICODE_LATIN_CAPITAL_LETTER_B_WITH_DOT_ABOVE			0x1E02
#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_DOT_ABOVE			0x1E03
#define Z_UNICODE_LATIN_CAPITAL_LETTER_B_WITH_DOT_BELOW			0x1E04
#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_DOT_BELOW			0x1E05
#define Z_UNICODE_LATIN_CAPITAL_LETTER_B_WITH_LINE_BELOW		0x1E06
#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_LINE_BELOW			0x1E07
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_CEDILLA_AND_ACUTE		0x1E08
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_CEDILLA_AND_ACUTE		0x1E09
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_DOT_ABOVE			0x1E0A
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_DOT_ABOVE			0x1E0B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_DOT_BELOW			0x1E0C
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_DOT_BELOW			0x1E0D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_LINE_BELOW		0x1E0E
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_LINE_BELOW			0x1E0F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_CEDILLA			0x1E10
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_CEDILLA			0x1E11
#define Z_UNICODE_LATIN_CAPITAL_LETTER_D_WITH_CIRCUMFLEX_BELOW		0x1E12
#define Z_UNICODE_LATIN_SMALL_LETTER_D_WITH_CIRCUMFLEX_BELOW		0x1E13
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_MACRON_AND_GRAVE		0x1E14
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_MACRON_AND_GRAVE		0x1E15
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_MACRON_AND_ACUTE		0x1E16
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_MACRON_AND_ACUTE		0x1E17
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_BELOW		0x1E18
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_BELOW		0x1E19
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_TILDE_BELOW		0x1E1A
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_TILDE_BELOW			0x1E1B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CEDILLA_AND_BREVE		0x1E1C
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CEDILLA_AND_BREVE		0x1E1D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_F_WITH_DOT_ABOVE			0x1E1E
#define Z_UNICODE_LATIN_SMALL_LETTER_F_WITH_DOT_ABOVE			0x1E1F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_MACRON			0x1E20
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_MACRON			0x1E21
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_DOT_ABOVE			0x1E22
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_DOT_ABOVE			0x1E23
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_DOT_BELOW			0x1E24
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_DOT_BELOW			0x1E25
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_DIAERESIS			0x1E26
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_DIAERESIS			0x1E27
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_CEDILLA			0x1E28
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_CEDILLA			0x1E29
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_BREVE_BELOW		0x1E2A
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_BREVE_BELOW			0x1E2B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_TILDE_BELOW		0x1E2C
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_TILDE_BELOW			0x1E2D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_DIAERESIS_AND_ACUTE	0x1E2E
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_DIAERESIS_AND_ACUTE		0x1E2F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_ACUTE			0x1E30
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_ACUTE			0x1E31
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_DOT_BELOW			0x1E32
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_DOT_BELOW			0x1E33
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_LINE_BELOW		0x1E34
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_LINE_BELOW			0x1E35
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_DOT_BELOW			0x1E36
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_DOT_BELOW			0x1E37
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_DOT_BELOW_AND_MACRON	0x1E38
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_DOT_BELOW_AND_MACRON	0x1E39
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_LINE_BELOW		0x1E3A
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_LINE_BELOW			0x1E3B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_CIRCUMFLEX_BELOW		0x1E3C
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_CIRCUMFLEX_BELOW		0x1E3D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_M_WITH_ACUTE			0x1E3E
#define Z_UNICODE_LATIN_SMALL_LETTER_M_WITH_ACUTE			0x1E3F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_M_WITH_DOT_ABOVE			0x1E40
#define Z_UNICODE_LATIN_SMALL_LETTER_M_WITH_DOT_ABOVE			0x1E41
#define Z_UNICODE_LATIN_CAPITAL_LETTER_M_WITH_DOT_BELOW			0x1E42
#define Z_UNICODE_LATIN_SMALL_LETTER_M_WITH_DOT_BELOW			0x1E43
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_DOT_ABOVE			0x1E44
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_DOT_ABOVE			0x1E45
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_DOT_BELOW			0x1E46
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_DOT_BELOW			0x1E47
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_LINE_BELOW		0x1E48
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_LINE_BELOW			0x1E49
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_CIRCUMFLEX_BELOW		0x1E4A
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_CIRCUMFLEX_BELOW		0x1E4B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_ACUTE		0x1E4C
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_TILDE_AND_ACUTE		0x1E4D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_TILDE_AND_DIAERESIS	0x1E4E
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_TILDE_AND_DIAERESIS		0x1E4F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_MACRON_AND_GRAVE		0x1E50
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_MACRON_AND_GRAVE		0x1E51
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_MACRON_AND_ACUTE		0x1E52
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_MACRON_AND_ACUTE		0x1E53
#define Z_UNICODE_LATIN_CAPITAL_LETTER_P_WITH_ACUTE			0x1E54
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_ACUTE			0x1E55
#define Z_UNICODE_LATIN_CAPITAL_LETTER_P_WITH_DOT_ABOVE			0x1E56
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_DOT_ABOVE			0x1E57
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_DOT_ABOVE			0x1E58
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_DOT_ABOVE			0x1E59
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_DOT_BELOW			0x1E5A
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_DOT_BELOW			0x1E5B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_DOT_BELOW_AND_MACRON	0x1E5C
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_DOT_BELOW_AND_MACRON	0x1E5D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_LINE_BELOW		0x1E5E
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_LINE_BELOW			0x1E5F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_DOT_ABOVE			0x1E60
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_DOT_ABOVE			0x1E61
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_DOT_BELOW			0x1E62
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_DOT_BELOW			0x1E63
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_ACUTE_AND_DOT_ABOVE	0x1E64
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_ACUTE_AND_DOT_ABOVE		0x1E65
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_CARON_AND_DOT_ABOVE	0x1E66
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_CARON_AND_DOT_ABOVE		0x1E67
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_DOT_BELOW_AND_DOT_ABOVE	0x1E68
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_DOT_BELOW_AND_DOT_ABOVE	0x1E69
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_DOT_ABOVE			0x1E6A
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_DOT_ABOVE			0x1E6B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_DOT_BELOW			0x1E6C
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_DOT_BELOW			0x1E6D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_LINE_BELOW		0x1E6E
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_LINE_BELOW			0x1E6F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_T_WITH_CIRCUMFLEX_BELOW		0x1E70
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_CIRCUMFLEX_BELOW		0x1E71
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS_BELOW		0x1E72
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DIAERESIS_BELOW		0x1E73
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_TILDE_BELOW		0x1E74
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_TILDE_BELOW			0x1E75
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_CIRCUMFLEX_BELOW		0x1E76
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_CIRCUMFLEX_BELOW		0x1E77
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_TILDE_AND_ACUTE		0x1E78
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_TILDE_AND_ACUTE		0x1E79
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_MACRON_AND_DIAERESIS	0x1E7A
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_MACRON_AND_DIAERESIS	0x1E7B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_V_WITH_TILDE			0x1E7C
#define Z_UNICODE_LATIN_SMALL_LETTER_V_WITH_TILDE			0x1E7D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_V_WITH_DOT_BELOW			0x1E7E
#define Z_UNICODE_LATIN_SMALL_LETTER_V_WITH_DOT_BELOW			0x1E7F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_W_WITH_GRAVE			0x1E80
#define Z_UNICODE_LATIN_SMALL_LETTER_W_WITH_GRAVE			0x1E81
#define Z_UNICODE_LATIN_CAPITAL_LETTER_W_WITH_ACUTE			0x1E82
#define Z_UNICODE_LATIN_SMALL_LETTER_W_WITH_ACUTE			0x1E83
#define Z_UNICODE_LATIN_CAPITAL_LETTER_W_WITH_DIAERESIS			0x1E84
#define Z_UNICODE_LATIN_SMALL_LETTER_W_WITH_DIAERESIS			0x1E85
#define Z_UNICODE_LATIN_CAPITAL_LETTER_W_WITH_DOT_ABOVE			0x1E86
#define Z_UNICODE_LATIN_SMALL_LETTER_W_WITH_DOT_ABOVE			0x1E87
#define Z_UNICODE_LATIN_CAPITAL_LETTER_W_WITH_DOT_BELOW			0x1E88
#define Z_UNICODE_LATIN_SMALL_LETTER_W_WITH_DOT_BELOW			0x1E89
#define Z_UNICODE_LATIN_CAPITAL_LETTER_X_WITH_DOT_ABOVE			0x1E8A
#define Z_UNICODE_LATIN_SMALL_LETTER_X_WITH_DOT_ABOVE			0x1E8B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_X_WITH_DIAERESIS			0x1E8C
#define Z_UNICODE_LATIN_SMALL_LETTER_X_WITH_DIAERESIS			0x1E8D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_DOT_ABOVE			0x1E8E
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_DOT_ABOVE			0x1E8F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_CIRCUMFLEX		0x1E90
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_CIRCUMFLEX			0x1E91
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_DOT_BELOW			0x1E92
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_DOT_BELOW			0x1E93
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_LINE_BELOW		0x1E94
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_LINE_BELOW			0x1E95
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_LINE_BELOW			0x1E96
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_DIAERESIS			0x1E97
#define Z_UNICODE_LATIN_SMALL_LETTER_W_WITH_RING_ABOVE			0x1E98
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_RING_ABOVE			0x1E99
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_RIGHT_HALF_RING		0x1E9A
#define Z_UNICODE_LATIN_SMALL_LETTER_LONG_S_WITH_DOT_ABOVE		0x1E9B
#define Z_UNICODE_LATIN_SMALL_LETTER_LONG_S_WITH_DIAGONAL_STROKE	0x1E9C
#define Z_UNICODE_LATIN_SMALL_LETTER_LONG_S_WITH_HIGH_STROKE		0x1E9D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_SHARP_S				0x1E9E
#define Z_UNICODE_LATIN_SMALL_LETTER_DELTA				0x1E9F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_DOT_BELOW			0x1EA0
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_DOT_BELOW			0x1EA1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_HOOK_ABOVE		0x1EA2
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_HOOK_ABOVE			0x1EA3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_ACUTE	0x1EA4
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_ACUTE	0x1EA5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_GRAVE	0x1EA6
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_GRAVE	0x1EA7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_HOOK_ABOVE	0x1EA8
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_HOOK_ABOVE	0x1EA9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_TILDE	0x1EAA
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_TILDE	0x1EAB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX_AND_DOT_BELOW	0x1EAC
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX_AND_DOT_BELOW	0x1EAD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_ACUTE		0x1EAE
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_ACUTE		0x1EAF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_GRAVE		0x1EB0
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_GRAVE		0x1EB1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_HOOK_ABOVE	0x1EB2
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_HOOK_ABOVE	0x1EB3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_TILDE		0x1EB4
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_TILDE		0x1EB5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_A_WITH_BREVE_AND_DOT_BELOW	0x1EB6
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_BREVE_AND_DOT_BELOW		0x1EB7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_DOT_BELOW			0x1EB8
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_DOT_BELOW			0x1EB9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_HOOK_ABOVE		0x1EBA
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_HOOK_ABOVE			0x1EBB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_TILDE			0x1EBC
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_TILDE			0x1EBD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_ACUTE	0x1EBE
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_ACUTE	0x1EBF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_GRAVE	0x1EC0
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_GRAVE	0x1EC1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_HOOK_ABOVE	0x1EC2
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_HOOK_ABOVE	0x1EC3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_TILDE	0x1EC4
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_TILDE	0x1EC5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX_AND_DOT_BELOW	0x1EC6
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX_AND_DOT_BELOW	0x1EC7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_HOOK_ABOVE		0x1EC8
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_HOOK_ABOVE			0x1EC9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_I_WITH_DOT_BELOW			0x1ECA
#define Z_UNICODE_LATIN_SMALL_LETTER_I_WITH_DOT_BELOW			0x1ECB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_DOT_BELOW			0x1ECC
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_DOT_BELOW			0x1ECD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_HOOK_ABOVE		0x1ECE
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_HOOK_ABOVE			0x1ECF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_ACUTE	0x1ED0
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_ACUTE	0x1ED1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_GRAVE	0x1ED2
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_GRAVE	0x1ED3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_HOOK_ABOVE	0x1ED4
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_HOOK_ABOVE	0x1ED5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_TILDE	0x1ED6
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_TILDE	0x1ED7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX_AND_DOT_BELOW	0x1ED8
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX_AND_DOT_BELOW	0x1ED9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_ACUTE		0x1EDA
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_HORN_AND_ACUTE		0x1EDB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_GRAVE		0x1EDC
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_HORN_AND_GRAVE		0x1EDD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_HOOK_ABOVE	0x1EDE
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_HORN_AND_HOOK_ABOVE		0x1EDF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_TILDE		0x1EE0
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_HORN_AND_TILDE		0x1EE1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_HORN_AND_DOT_BELOW	0x1EE2
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_HORN_AND_DOT_BELOW		0x1EE3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_DOT_BELOW			0x1EE4
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_DOT_BELOW			0x1EE5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_HOOK_ABOVE		0x1EE6
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_HOOK_ABOVE			0x1EE7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_ACUTE		0x1EE8
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_HORN_AND_ACUTE		0x1EE9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_GRAVE		0x1EEA
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_HORN_AND_GRAVE		0x1EEB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_HOOK_ABOVE	0x1EEC
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_HORN_AND_HOOK_ABOVE		0x1EED
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_TILDE		0x1EEE
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_HORN_AND_TILDE		0x1EEF
#define Z_UNICODE_LATIN_CAPITAL_LETTER_U_WITH_HORN_AND_DOT_BELOW	0x1EF0
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_HORN_AND_DOT_BELOW		0x1EF1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_GRAVE			0x1EF2
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_GRAVE			0x1EF3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_DOT_BELOW			0x1EF4
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_DOT_BELOW			0x1EF5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_HOOK_ABOVE		0x1EF6
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_HOOK_ABOVE			0x1EF7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_TILDE			0x1EF8
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_TILDE			0x1EF9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_MIDDLE_WELSH_LL			0x1EFA
#define Z_UNICODE_LATIN_SMALL_LETTER_MIDDLE_WELSH_LL			0x1EFB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_MIDDLE_WELSH_V			0x1EFC
#define Z_UNICODE_LATIN_SMALL_LETTER_MIDDLE_WELSH_V			0x1EFD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Y_WITH_LOOP			0x1EFE
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_LOOP			0x1EFF

/* MARK: - 1F00h-1FFFh - Greek Extended */

#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI					   0x1F00
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA					   0x1F01
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_VARIA				   0x1F02
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_VARIA				   0x1F03
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_OXIA				   0x1F04
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_OXIA				   0x1F05
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI			   0x1F06
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI			   0x1F07
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI					   0x1F08
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA					   0x1F09
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_VARIA			   0x1F0A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_VARIA			   0x1F0B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_OXIA			   0x1F0C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_OXIA			   0x1F0D
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI			   0x1F0E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI			   0x1F0F
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_PSILI					   0x1F10
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_DASIA					   0x1F11
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_PSILI_AND_VARIA			   0x1F12
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_DASIA_AND_VARIA			   0x1F13
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_PSILI_AND_OXIA			   0x1F14
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_DASIA_AND_OXIA			   0x1F15
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI				   0x1F18
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA				   0x1F19
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI_AND_VARIA			   0x1F1A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA_AND_VARIA			   0x1F1B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_PSILI_AND_OXIA			   0x1F1C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_DASIA_AND_OXIA			   0x1F1D
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PSILI					   0x1F20
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_DASIA					   0x1F21
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_VARIA				   0x1F22
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_VARIA				   0x1F23
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_OXIA				   0x1F24
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_OXIA				   0x1F25
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI			   0x1F26
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI			   0x1F27
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI					   0x1F28
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA					   0x1F29
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_VARIA				   0x1F2A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_VARIA				   0x1F2B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_OXIA				   0x1F2C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_OXIA				   0x1F2D
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI			   0x1F2E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI			   0x1F2F
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_PSILI					   0x1F30
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DASIA					   0x1F31
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_VARIA				   0x1F32
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_VARIA				   0x1F33
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_OXIA				   0x1F34
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_OXIA				   0x1F35
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_PSILI_AND_PERISPOMENI			   0x1F36
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DASIA_AND_PERISPOMENI			   0x1F37
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI					   0x1F38
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA					   0x1F39
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_VARIA			   0x1F3A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_VARIA			   0x1F3B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_OXIA				   0x1F3C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_OXIA				   0x1F3D
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_PSILI_AND_PERISPOMENI			   0x1F3E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_DASIA_AND_PERISPOMENI			   0x1F3F
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_PSILI					   0x1F40
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_DASIA					   0x1F41
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_PSILI_AND_VARIA			   0x1F42
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_DASIA_AND_VARIA			   0x1F43
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_PSILI_AND_OXIA			   0x1F44
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_DASIA_AND_OXIA			   0x1F45
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI				   0x1F48
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA				   0x1F49
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI_AND_VARIA			   0x1F4A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA_AND_VARIA			   0x1F4B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_PSILI_AND_OXIA			   0x1F4C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_DASIA_AND_OXIA			   0x1F4D
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_PSILI					   0x1F50
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DASIA					   0x1F51
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_VARIA			   0x1F52
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_VARIA			   0x1F53
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_OXIA			   0x1F54
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_OXIA			   0x1F55
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_PSILI_AND_PERISPOMENI			   0x1F56
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DASIA_AND_PERISPOMENI			   0x1F57
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA				   0x1F59
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_VARIA			   0x1F5B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_OXIA			   0x1F5D
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_DASIA_AND_PERISPOMENI		   0x1F5F
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI					   0x1F60
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA					   0x1F61
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_VARIA				   0x1F62
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_VARIA				   0x1F63
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_OXIA				   0x1F64
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_OXIA				   0x1F65
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI			   0x1F66
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI			   0x1F67
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI					   0x1F68
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA					   0x1F69
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_VARIA			   0x1F6A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_VARIA			   0x1F6B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_OXIA			   0x1F6C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_OXIA			   0x1F6D
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI			   0x1F6E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI			   0x1F6F
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_VARIA					   0x1F70
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_OXIA					   0x1F71
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_VARIA					   0x1F72
#define Z_UNICODE_GREEK_SMALL_LETTER_EPSILON_WITH_OXIA					   0x1F73
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_VARIA					   0x1F74
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_OXIA					   0x1F75
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_VARIA					   0x1F76
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_OXIA					   0x1F77
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_VARIA					   0x1F78
#define Z_UNICODE_GREEK_SMALL_LETTER_OMICRON_WITH_OXIA					   0x1F79
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_VARIA					   0x1F7A
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_OXIA					   0x1F7B
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_VARIA					   0x1F7C
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_OXIA					   0x1F7D
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_YPOGEGRAMMENI			   0x1F80
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_YPOGEGRAMMENI			   0x1F81
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI	   0x1F82
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI	   0x1F83
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI	   0x1F84
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI	   0x1F85
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI	   0x1F86
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI	   0x1F87
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PROSGEGRAMMENI		   0x1F88
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PROSGEGRAMMENI		   0x1F89
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI	   0x1F8A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI	   0x1F8B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI	   0x1F8C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI	   0x1F8D
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1F8E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1F8F
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_YPOGEGRAMMENI			   0x1F90
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_YPOGEGRAMMENI			   0x1F91
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI		   0x1F92
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI		   0x1F93
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI		   0x1F94
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI		   0x1F95
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI	   0x1F96
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI	   0x1F97
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PROSGEGRAMMENI		   0x1F98
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PROSGEGRAMMENI		   0x1F99
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI	   0x1F9A
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI	   0x1F9B
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI	   0x1F9C
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI	   0x1F9D
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI   0x1F9E
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI   0x1F9F
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_YPOGEGRAMMENI			   0x1FA0
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_YPOGEGRAMMENI			   0x1FA1
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_VARIA_AND_YPOGEGRAMMENI	   0x1FA2
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_VARIA_AND_YPOGEGRAMMENI	   0x1FA3
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_OXIA_AND_YPOGEGRAMMENI	   0x1FA4
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_OXIA_AND_YPOGEGRAMMENI	   0x1FA5
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI_AND_YPOGEGRAMMENI	   0x1FA6
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI_AND_YPOGEGRAMMENI	   0x1FA7
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PROSGEGRAMMENI		   0x1FA8
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PROSGEGRAMMENI		   0x1FA9
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_VARIA_AND_PROSGEGRAMMENI	   0x1FAA
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_VARIA_AND_PROSGEGRAMMENI	   0x1FAB
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_OXIA_AND_PROSGEGRAMMENI	   0x1FAC
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_OXIA_AND_PROSGEGRAMMENI	   0x1FAD
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PSILI_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1FAE
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_DASIA_AND_PERISPOMENI_AND_PROSGEGRAMMENI 0x1FAF
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_VRACHY					   0x1FB0
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_MACRON					   0x1FB1
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_VARIA_AND_YPOGEGRAMMENI			   0x1FB2
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_YPOGEGRAMMENI				   0x1FB3
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_OXIA_AND_YPOGEGRAMMENI			   0x1FB4
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PERISPOMENI				   0x1FB6
#define Z_UNICODE_GREEK_SMALL_LETTER_ALPHA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI		   0x1FB7
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_VRACHY				   0x1FB8
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_MACRON				   0x1FB9
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_VARIA					   0x1FBA
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_OXIA					   0x1FBB
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ALPHA_WITH_PROSGEGRAMMENI			   0x1FBC
#define Z_UNICODE_GREEK_KORONIS								   0x1FBD
#define Z_UNICODE_GREEK_PROSGEGRAMMENI							   0x1FBE
#define Z_UNICODE_GREEK_PSILI								   0x1FBF
#define Z_UNICODE_GREEK_PERISPOMENI							   0x1FC0
#define Z_UNICODE_GREEK_DIALYTIKA_AND_PERISPOMENI					   0x1FC1
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_VARIA_AND_YPOGEGRAMMENI			   0x1FC2
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_YPOGEGRAMMENI				   0x1FC3
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_OXIA_AND_YPOGEGRAMMENI			   0x1FC4
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PERISPOMENI				   0x1FC6
#define Z_UNICODE_GREEK_SMALL_LETTER_ETA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI		   0x1FC7
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_VARIA				   0x1FC8
#define Z_UNICODE_GREEK_CAPITAL_LETTER_EPSILON_WITH_OXIA				   0x1FC9
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_VARIA					   0x1FCA
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_OXIA					   0x1FCB
#define Z_UNICODE_GREEK_CAPITAL_LETTER_ETA_WITH_PROSGEGRAMMENI				   0x1FCC
#define Z_UNICODE_GREEK_PSILI_AND_VARIA							   0x1FCD
#define Z_UNICODE_GREEK_PSILI_AND_OXIA							   0x1FCE
#define Z_UNICODE_GREEK_PSILI_AND_PERISPOMENI						   0x1FCF
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_VRACHY					   0x1FD0
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_MACRON					   0x1FD1
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_VARIA			   0x1FD2
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_OXIA			   0x1FD3
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_PERISPOMENI				   0x1FD6
#define Z_UNICODE_GREEK_SMALL_LETTER_IOTA_WITH_DIALYTIKA_AND_PERISPOMENI		   0x1FD7
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_VRACHY					   0x1FD8
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_MACRON					   0x1FD9
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_VARIA					   0x1FDA
#define Z_UNICODE_GREEK_CAPITAL_LETTER_IOTA_WITH_OXIA					   0x1FDB
#define Z_UNICODE_GREEK_DASIA_AND_VARIA							   0x1FDD
#define Z_UNICODE_GREEK_DASIA_AND_OXIA							   0x1FDE
#define Z_UNICODE_GREEK_DASIA_AND_PERISPOMENI						   0x1FDF
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_VRACHY				   0x1FE0
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_MACRON				   0x1FE1
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_VARIA			   0x1FE2
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_OXIA			   0x1FE3
#define Z_UNICODE_GREEK_SMALL_LETTER_RHO_WITH_PSILI					   0x1FE4
#define Z_UNICODE_GREEK_SMALL_LETTER_RHO_WITH_DASIA					   0x1FE5
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_PERISPOMENI				   0x1FE6
#define Z_UNICODE_GREEK_SMALL_LETTER_UPSILON_WITH_DIALYTIKA_AND_PERISPOMENI		   0x1FE7
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_VRACHY				   0x1FE8
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_MACRON				   0x1FE9
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_VARIA				   0x1FEA
#define Z_UNICODE_GREEK_CAPITAL_LETTER_UPSILON_WITH_OXIA				   0x1FEB
#define Z_UNICODE_GREEK_CAPITAL_LETTER_RHO_WITH_DASIA					   0x1FEC
#define Z_UNICODE_GREEK_DIALYTIKA_AND_VARIA						   0x1FED
#define Z_UNICODE_GREEK_DIALYTIKA_AND_OXIA						   0x1FEE
#define Z_UNICODE_GREEK_VARIA								   0x1FEF
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_VARIA_AND_YPOGEGRAMMENI			   0x1FF2
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_YPOGEGRAMMENI				   0x1FF3
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_OXIA_AND_YPOGEGRAMMENI			   0x1FF4
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PERISPOMENI				   0x1FF6
#define Z_UNICODE_GREEK_SMALL_LETTER_OMEGA_WITH_PERISPOMENI_AND_YPOGEGRAMMENI		   0x1FF7
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_VARIA				   0x1FF8
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMICRON_WITH_OXIA				   0x1FF9
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_VARIA					   0x1FFA
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_OXIA					   0x1FFB
#define Z_UNICODE_GREEK_CAPITAL_LETTER_OMEGA_WITH_PROSGEGRAMMENI			   0x1FFC
#define Z_UNICODE_GREEK_OXIA								   0x1FFD
#define Z_UNICODE_GREEK_DASIA								   0x1FFE

/* MARK: - 2000h-206Fh - General Punctuation */

#define Z_UNICODE_EN_QUAD				     0x2000
#define Z_UNICODE_EM_QUAD				     0x2001
#define Z_UNICODE_EN_SPACE				     0x2002
#define Z_UNICODE_EM_SPACE				     0x2003
#define Z_UNICODE_THREE_PER_EM_SPACE			     0x2004
#define Z_UNICODE_FOUR_PER_EM_SPACE			     0x2005
#define Z_UNICODE_SIX_PER_EM_SPACE			     0x2006
#define Z_UNICODE_FIGURE_SPACE				     0x2007
#define Z_UNICODE_PUNCTUATION_SPACE			     0x2008
#define Z_UNICODE_THIN_SPACE				     0x2009
#define Z_UNICODE_HAIR_SPACE				     0x200A
#define Z_UNICODE_ZERO_WIDTH_SPACE			     0x200B
#define Z_UNICODE_ZERO_WIDTH_NON_JOINER			     0x200C
#define Z_UNICODE_ZERO_WIDTH_JOINER			     0x200D
#define Z_UNICODE_LEFT_TO_RIGHT_MARK			     0x200E
#define Z_UNICODE_RIGHT_TO_LEFT_MARK			     0x200F
#define Z_UNICODE_HYPHEN				     0x2010
#define Z_UNICODE_NON_BREAKING_HYPHEN			     0x2011
#define Z_UNICODE_FIGURE_DASH				     0x2012
#define Z_UNICODE_EN_DASH				     0x2013
#define Z_UNICODE_EM_DASH				     0x2014
#define Z_UNICODE_HORIZONTAL_BAR			     0x2015
#define Z_UNICODE_DOUBLE_VERTICAL_LINE			     0x2016
#define Z_UNICODE_DOUBLE_LOW_LINE			     0x2017
#define Z_UNICODE_LEFT_SINGLE_QUOTATION_MARK		     0x2018
#define Z_UNICODE_RIGHT_SINGLE_QUOTATION_MARK		     0x2019
#define Z_UNICODE_SINGLE_LOW_9_QUOTATION_MARK		     0x201A
#define Z_UNICODE_SINGLE_HIGH_REVERSED_9_QUOTATION_MARK	     0x201B
#define Z_UNICODE_LEFT_DOUBLE_QUOTATION_MARK		     0x201C
#define Z_UNICODE_RIGHT_DOUBLE_QUOTATION_MARK		     0x201D
#define Z_UNICODE_DOUBLE_LOW_9_QUOTATION_MARK		     0x201E
#define Z_UNICODE_DOUBLE_HIGH_REVERSED_9_QUOTATION_MARK	     0x201F
#define Z_UNICODE_DAGGER				     0x2020
#define Z_UNICODE_DOUBLE_DAGGER				     0x2021
#define Z_UNICODE_BULLET				     0x2022
#define Z_UNICODE_TRIANGULAR_BULLET			     0x2023
#define Z_UNICODE_ONE_DOT_LEADER			     0x2024
#define Z_UNICODE_TWO_DOT_LEADER			     0x2025
#define Z_UNICODE_HORIZONTAL_ELLIPSIS			     0x2026
#define Z_UNICODE_HYPHENATION_POINT			     0x2027
#define Z_UNICODE_LINE_SEPARATOR			     0x2028
#define Z_UNICODE_PARAGRAPH_SEPARATOR			     0x2029
#define Z_UNICODE_LEFT_TO_RIGHT_EMBEDDING		     0x202A
#define Z_UNICODE_RIGHT_TO_LEFT_EMBEDDING		     0x202B
#define Z_UNICODE_POP_DIRECTIONAL_FORMATTING		     0x202C
#define Z_UNICODE_LEFT_TO_RIGHT_OVERRIDE		     0x202D
#define Z_UNICODE_RIGHT_TO_LEFT_OVERRIDE		     0x202E
#define Z_UNICODE_NARROW_NO_BREAK_SPACE			     0x202F
#define Z_UNICODE_PER_MILLE_SIGN			     0x2030
#define Z_UNICODE_PER_TEN_THOUSAND_SIGN			     0x2031
#define Z_UNICODE_PRIME					     0x2032
#define Z_UNICODE_DOUBLE_PRIME				     0x2033
#define Z_UNICODE_TRIPLE_PRIME				     0x2034
#define Z_UNICODE_REVERSED_PRIME			     0x2035
#define Z_UNICODE_REVERSED_DOUBLE_PRIME			     0x2036
#define Z_UNICODE_REVERSED_TRIPLE_PRIME			     0x2037
#define Z_UNICODE_CARET					     0x2038
#define Z_UNICODE_SINGLE_LEFT_POINTING_ANGLE_QUOTATION_MARK  0x2039
#define Z_UNICODE_SINGLE_RIGHT_POINTING_ANGLE_QUOTATION_MARK 0x203A
#define Z_UNICODE_REFERENCE_MARK			     0x203B
#define Z_UNICODE_DOUBLE_EXCLAMATION_MARK		     0x203C
#define Z_UNICODE_INTERROBANG				     0x203D
#define Z_UNICODE_OVERLINE				     0x203E
#define Z_UNICODE_UNDERTIE				     0x203F
#define Z_UNICODE_CHARACTER_TIE				     0x2040
#define Z_UNICODE_CARET_INSERTION_POINT			     0x2041
#define Z_UNICODE_ASTERISM				     0x2042
#define Z_UNICODE_HYPHEN_BULLET				     0x2043
#define Z_UNICODE_FRACTION_SLASH			     0x2044
#define Z_UNICODE_LEFT_SQUARE_BRACKET_WITH_QUILL	     0x2045
#define Z_UNICODE_RIGHT_SQUARE_BRACKET_WITH_QUILL	     0x2046
#define Z_UNICODE_DOUBLE_QUESTION_MARK			     0x2047
#define Z_UNICODE_QUESTION_EXCLAMATION_MARK		     0x2048
#define Z_UNICODE_EXCLAMATION_QUESTION_MARK		     0x2049
#define Z_UNICODE_TIRONIAN_SIGN_ET			     0x204A
#define Z_UNICODE_REVERSED_PILCROW_SIGN			     0x204B
#define Z_UNICODE_BLACK_LEFTWARDS_BULLET		     0x204C
#define Z_UNICODE_BLACK_RIGHTWARDS_BULLET		     0x204D
#define Z_UNICODE_LOW_ASTERISK				     0x204E
#define Z_UNICODE_REVERSED_SEMICOLON			     0x204F
#define Z_UNICODE_CLOSE_UP				     0x2050
#define Z_UNICODE_TWO_ASTERISKS_ALIGNED_VERTICALLY	     0x2051
#define Z_UNICODE_COMMERCIAL_MINUS_SIGN			     0x2052
#define Z_UNICODE_SWUNG_DASH				     0x2053
#define Z_UNICODE_INVERTED_UNDERTIE			     0x2054
#define Z_UNICODE_FLOWER_PUNCTUATION_MARK		     0x2055
#define Z_UNICODE_THREE_DOT_PUNCTUATION			     0x2056
#define Z_UNICODE_QUADRUPLE_PRIME			     0x2057
#define Z_UNICODE_FOUR_DOT_PUNCTUATION			     0x2058
#define Z_UNICODE_FIVE_DOT_PUNCTUATION			     0x2059
#define Z_UNICODE_TWO_DOT_PUNCTUATION			     0x205A
#define Z_UNICODE_FOUR_DOT_MARK				     0x205B
#define Z_UNICODE_DOTTED_CROSS				     0x205C
#define Z_UNICODE_TRICOLON				     0x205D
#define Z_UNICODE_VERTICAL_FOUR_DOTS			     0x205E
#define Z_UNICODE_MEDIUM_MATHEMATICAL_SPACE		     0x205F
#define Z_UNICODE_WORD_JOINER				     0x2060
#define Z_UNICODE_FUNCTION_APPLICATION			     0x2061
#define Z_UNICODE_INVISIBLE_TIMES			     0x2062
#define Z_UNICODE_INVISIBLE_SEPARATOR			     0x2063
#define Z_UNICODE_INVISIBLE_PLUS			     0x2064
#define Z_UNICODE_LEFT_TO_RIGHT_ISOLATE			     0x2066
#define Z_UNICODE_RIGHT_TO_LEFT_ISOLATE			     0x2067
#define Z_UNICODE_FIRST_STRONG_ISOLATE			     0x2068
#define Z_UNICODE_POP_DIRECTIONAL_ISOLATE		     0x2069
#define Z_UNICODE_INHIBIT_SYMMETRIC_SWAPPING		     0x206A
#define Z_UNICODE_ACTIVATE_SYMMETRIC_SWAPPING		     0x206B
#define Z_UNICODE_INHIBIT_ARABIC_FORM_SHAPING		     0x206C
#define Z_UNICODE_ACTIVATE_ARABIC_FORM_SHAPING		     0x206D
#define Z_UNICODE_NATIONAL_DIGIT_SHAPES			     0x206E
#define Z_UNICODE_NOMINAL_DIGIT_SHAPES			     0x206F

/* MARK: - 2070h-209Fh - Superscripts and Subscripts */

/* 2072h <reserved> */
/* 2073h <reserved> */
#define Z_UNICODE_SUPERSCRIPT_ZERO		     0x2070
#define Z_UNICODE_SUPERSCRIPT_LATIN_SMALL_LETTER_I   0x2071
#define Z_UNICODE_SUPERSCRIPT_FOUR		     0x2074
#define Z_UNICODE_SUPERSCRIPT_FIVE		     0x2075
#define Z_UNICODE_SUPERSCRIPT_SIX		     0x2076
#define Z_UNICODE_SUPERSCRIPT_SEVEN		     0x2077
#define Z_UNICODE_SUPERSCRIPT_EIGHT		     0x2078
#define Z_UNICODE_SUPERSCRIPT_NINE		     0x2079
#define Z_UNICODE_SUPERSCRIPT_PLUS_SIGN		     0x207A
#define Z_UNICODE_SUPERSCRIPT_MINUS		     0x207B
#define Z_UNICODE_SUPERSCRIPT_EQUALS_SIGN	     0x207C
#define Z_UNICODE_SUPERSCRIPT_LEFT_PARENTHESIS	     0x207D
#define Z_UNICODE_SUPERSCRIPT_RIGHT_PARENTHESIS	     0x207E
#define Z_UNICODE_SUPERSCRIPT_LATIN_SMALL_LETTER_N   0x207F
#define Z_UNICODE_SUBSCRIPT_ZERO		     0x2080
#define Z_UNICODE_SUBSCRIPT_ONE			     0x2081
#define Z_UNICODE_SUBSCRIPT_TWO			     0x2082
#define Z_UNICODE_SUBSCRIPT_THREE		     0x2083
#define Z_UNICODE_SUBSCRIPT_FOUR		     0x2084
#define Z_UNICODE_SUBSCRIPT_FIVE		     0x2085
#define Z_UNICODE_SUBSCRIPT_SIX			     0x2086
#define Z_UNICODE_SUBSCRIPT_SEVEN		     0x2087
#define Z_UNICODE_SUBSCRIPT_EIGHT		     0x2088
#define Z_UNICODE_SUBSCRIPT_NINE		     0x2089
#define Z_UNICODE_SUBSCRIPT_PLUS_SIGN		     0x208A
#define Z_UNICODE_SUBSCRIPT_MINUS		     0x208B
#define Z_UNICODE_SUBSCRIPT_EQUALS_SIGN		     0x208C
#define Z_UNICODE_SUBSCRIPT_LEFT_PARENTHESIS	     0x208D
#define Z_UNICODE_SUBSCRIPT_RIGHT_PARENTHESIS	     0x208E
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_A     0x2090
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_E     0x2091
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_O     0x2092
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_X     0x2093
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_SCHWA 0x2094
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_H     0x2095
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_K     0x2096
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_L     0x2097
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_M     0x2098
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_N     0x2099
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_P     0x209A
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_S     0x209B
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_T     0x209C

/* MARK: - 20A0h-20CFh - Currency Symbols */

#define Z_UNICODE_EURO_CURRENCY_SIGN  0x20A0
#define Z_UNICODE_COLON_SIGN	      0x20A1
#define Z_UNICODE_CRUZEIRO_SIGN	      0x20A2
#define Z_UNICODE_FRENCH_FRANC_SIGN   0x20A3
#define Z_UNICODE_LIRA_SIGN	      0x20A4
#define Z_UNICODE_MILL_SIGN	      0x20A5
#define Z_UNICODE_NAIRA_SIGN	      0x20A6
#define Z_UNICODE_PESETA_SIGN	      0x20A7
#define Z_UNICODE_RUPEE_SIGN	      0x20A8
#define Z_UNICODE_WON_SIGN	      0x20A9
#define Z_UNICODE_NEW_SHEQEL_SIGN     0x20AA
#define Z_UNICODE_DONG_SIGN	      0x20AB
#define Z_UNICODE_EURO_SIGN	      0x20AC
#define Z_UNICODE_KIP_SIGN	      0x20AD
#define Z_UNICODE_TUGRIK_SIGN	      0x20AE
#define Z_UNICODE_DRACHMA_SIGN	      0x20AF
#define Z_UNICODE_GERMAN_PENNY_SIGN   0x20B0
#define Z_UNICODE_PESO_SIGN	      0x20B1
#define Z_UNICODE_GUARANI_SIGN	      0x20B2
#define Z_UNICODE_AUSTRAL_SIGN	      0x20B3
#define Z_UNICODE_HRYVNIA_SIGN	      0x20B4
#define Z_UNICODE_CEDI_SIGN	      0x20B5
#define Z_UNICODE_LIVRE_TOURNOIS_SIGN 0x20B6
#define Z_UNICODE_SPESMILO_SIGN	      0x20B7
#define Z_UNICODE_TENGE_SIGN	      0x20B8
#define Z_UNICODE_INDIAN_RUPEE_SIGN   0x20B9
#define Z_UNICODE_TURKISH_LIRA_SIGN   0x20BA
#define Z_UNICODE_NORDIC_MARK_SIGN    0x20BB
#define Z_UNICODE_MANAT_SIGN	      0x20BC
#define Z_UNICODE_RUBLE_SIGN	      0x20BD
#define Z_UNICODE_LARI_SIGN	      0x20BE

/* MARK: - 20D0h-20FFh - Combining Diacritical Marks for Symbols */

#define Z_UNICODE_COMBINING_LEFT_HARPOON_ABOVE			   0x20D0
#define Z_UNICODE_COMBINING_RIGHT_HARPOON_ABOVE			   0x20D1
#define Z_UNICODE_COMBINING_LONG_VERTICAL_LINE_OVERLAY		   0x20D2
#define Z_UNICODE_COMBINING_SHORT_VERTICAL_LINE_OVERLAY		   0x20D3
#define Z_UNICODE_COMBINING_ANTICLOCKWISE_ARROW_ABOVE		   0x20D4
#define Z_UNICODE_COMBINING_CLOCKWISE_ARROW_ABOVE		   0x20D5
#define Z_UNICODE_COMBINING_LEFT_ARROW_ABOVE			   0x20D6
#define Z_UNICODE_COMBINING_RIGHT_ARROW_ABOVE			   0x20D7
#define Z_UNICODE_COMBINING_RING_OVERLAY			   0x20D8
#define Z_UNICODE_COMBINING_CLOCKWISE_RING_OVERLAY		   0x20D9
#define Z_UNICODE_COMBINING_ANTICLOCKWISE_RING_OVERLAY		   0x20DA
#define Z_UNICODE_COMBINING_THREE_DOTS_ABOVE			   0x20DB
#define Z_UNICODE_COMBINING_FOUR_DOTS_ABOVE			   0x20DC
#define Z_UNICODE_COMBINING_ENCLOSING_CIRCLE			   0x20DD
#define Z_UNICODE_COMBINING_ENCLOSING_SQUARE			   0x20DE
#define Z_UNICODE_COMBINING_ENCLOSING_DIAMOND			   0x20DF
#define Z_UNICODE_COMBINING_ENCLOSING_CIRCLE_BACKSLASH		   0x20E0
#define Z_UNICODE_COMBINING_LEFT_RIGHT_ARROW_ABOVE		   0x20E1
#define Z_UNICODE_COMBINING_ENCLOSING_SCREEN			   0x20E2
#define Z_UNICODE_COMBINING_ENCLOSING_KEYCAP			   0x20E3
#define Z_UNICODE_COMBINING_ENCLOSING_UPWARD_POINTING_TRIANGLE	   0x20E4
#define Z_UNICODE_COMBINING_REVERSE_SOLIDUS_OVERLAY		   0x20E5
#define Z_UNICODE_COMBINING_DOUBLE_VERTICAL_STROKE_OVERLAY	   0x20E6
#define Z_UNICODE_COMBINING_ANNUITY_SYMBOL			   0x20E7
#define Z_UNICODE_COMBINING_TRIPLE_UNDERDOT			   0x20E8
#define Z_UNICODE_COMBINING_WIDE_BRIDGE_ABOVE			   0x20E9
#define Z_UNICODE_COMBINING_LEFTWARDS_ARROW_OVERLAY		   0x20EA
#define Z_UNICODE_COMBINING_LONG_DOUBLE_SOLIDUS_OVERLAY		   0x20EB
#define Z_UNICODE_COMBINING_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS 0x20EC
#define Z_UNICODE_COMBINING_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS  0x20ED
#define Z_UNICODE_COMBINING_LEFT_ARROW_BELOW			   0x20EE
#define Z_UNICODE_COMBINING_RIGHT_ARROW_BELOW			   0x20EF
#define Z_UNICODE_COMBINING_ASTERISK_ABOVE			   0x20F0

/* MARK: - 2100h-214Fh - Letterlike Symbols */

#define Z_UNICODE_ACCOUNT_OF			 0x2100
#define Z_UNICODE_ADDRESSED_TO_THE_SUBJECT	 0x2101
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_C	 0x2102
#define Z_UNICODE_DEGREE_CELSIUS		 0x2103
#define Z_UNICODE_CENTRE_LINE_SYMBOL		 0x2104
#define Z_UNICODE_CARE_OF			 0x2105
#define Z_UNICODE_CADA_UNA			 0x2106
#define Z_UNICODE_EULER_CONSTANT		 0x2107
#define Z_UNICODE_SCRUPLE			 0x2108
#define Z_UNICODE_DEGREE_FAHRENHEIT		 0x2109
#define Z_UNICODE_SCRIPT_SMALL_G		 0x210A
#define Z_UNICODE_SCRIPT_CAPITAL_H		 0x210B
#define Z_UNICODE_BLACK_LETTER_CAPITAL_H	 0x210C
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_H	 0x210D
#define Z_UNICODE_PLANCK_CONSTANT		 0x210E
#define Z_UNICODE_PLANCK_CONSTANT_OVER_TWO_PI	 0x210F
#define Z_UNICODE_SCRIPT_CAPITAL_I		 0x2110
#define Z_UNICODE_BLACK_LETTER_CAPITAL_I	 0x2111
#define Z_UNICODE_SCRIPT_CAPITAL_L		 0x2112
#define Z_UNICODE_SCRIPT_SMALL_L		 0x2113
#define Z_UNICODE_L_B_BAR_SYMBOL		 0x2114
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_N	 0x2115
#define Z_UNICODE_NUMERO_SIGN			 0x2116
#define Z_UNICODE_SOUND_RECORDING_COPYRIGHT	 0x2117
#define Z_UNICODE_SCRIPT_CAPITAL_P		 0x2118
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_P	 0x2119
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_Q	 0x211A
#define Z_UNICODE_SCRIPT_CAPITAL_R		 0x211B
#define Z_UNICODE_BLACK_LETTER_CAPITAL_R	 0x211C
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_R	 0x211D
#define Z_UNICODE_PRESCRIPTION_TAKE		 0x211E
#define Z_UNICODE_RESPONSE			 0x211F
#define Z_UNICODE_SERVICE_MARK			 0x2120
#define Z_UNICODE_TELEPHONE_SIGN		 0x2121
#define Z_UNICODE_TRADE_MARK_SIGN		 0x2122
#define Z_UNICODE_VERSICLE			 0x2123
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_Z	 0x2124
#define Z_UNICODE_OUNCE_SIGN			 0x2125
#define Z_UNICODE_OHM_SIGN			 0x2126
#define Z_UNICODE_INVERTED_OHM_SIGN		 0x2127
#define Z_UNICODE_BLACK_LETTER_CAPITAL_Z	 0x2128
#define Z_UNICODE_TURNED_GREEK_SMALL_LETTER_IOTA 0x2129
#define Z_UNICODE_KELVIN_SIGN			 0x212A
#define Z_UNICODE_ANGSTROM_SIGN			 0x212B
#define Z_UNICODE_SCRIPT_CAPITAL_B		 0x212C
#define Z_UNICODE_BLACK_LETTER_CAPITAL_C	 0x212D
#define Z_UNICODE_ESTIMATED_SYMBOL		 0x212E
#define Z_UNICODE_SCRIPT_SMALL_E		 0x212F
#define Z_UNICODE_SCRIPT_CAPITAL_E		 0x2130
#define Z_UNICODE_SCRIPT_CAPITAL_F		 0x2131
#define Z_UNICODE_TURNED_CAPITAL_F		 0x2132
#define Z_UNICODE_SCRIPT_CAPITAL_M		 0x2133
#define Z_UNICODE_SCRIPT_SMALL_O		 0x2134
#define Z_UNICODE_ALEF_SYMBOL			 0x2135
#define Z_UNICODE_BET_SYMBOL			 0x2136
#define Z_UNICODE_GIMEL_SYMBOL			 0x2137
#define Z_UNICODE_DALET_SYMBOL			 0x2138
#define Z_UNICODE_INFORMATION_SOURCE		 0x2139
#define Z_UNICODE_ROTATED_CAPITAL_Q		 0x213A
#define Z_UNICODE_FACSIMILE_SIGN		 0x213B
#define Z_UNICODE_DOUBLE_STRUCK_SMALL_PI	 0x213C
#define Z_UNICODE_DOUBLE_STRUCK_SMALL_GAMMA	 0x213D
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_GAMMA	 0x213E
#define Z_UNICODE_DOUBLE_STRUCK_CAPITAL_PI	 0x213F
#define Z_UNICODE_DOUBLE_STRUCK_N_ARY_SUMMATION	 0x2140
#define Z_UNICODE_TURNED_SANS_SERIF_CAPITAL_G	 0x2141
#define Z_UNICODE_TURNED_SANS_SERIF_CAPITAL_L	 0x2142
#define Z_UNICODE_REVERSED_SANS_SERIF_CAPITAL_L	 0x2143
#define Z_UNICODE_TURNED_SANS_SERIF_CAPITAL_Y	 0x2144
#define Z_UNICODE_DOUBLE_STRUCK_ITALIC_CAPITAL_D 0x2145
#define Z_UNICODE_DOUBLE_STRUCK_ITALIC_SMALL_D	 0x2146
#define Z_UNICODE_DOUBLE_STRUCK_ITALIC_SMALL_E	 0x2147
#define Z_UNICODE_DOUBLE_STRUCK_ITALIC_SMALL_I	 0x2148
#define Z_UNICODE_DOUBLE_STRUCK_ITALIC_SMALL_J	 0x2149
#define Z_UNICODE_PROPERTY_LINE			 0x214A
#define Z_UNICODE_TURNED_AMPERSAND		 0x214B
#define Z_UNICODE_PER_SIGN			 0x214C
#define Z_UNICODE_AKTIESELSKAB			 0x214D
#define Z_UNICODE_TURNED_SMALL_F		 0x214E
#define Z_UNICODE_SYMBOL_FOR_SAMARITAN_SOURCE	 0x214F

/* MARK: - 2150h-218Fh - Number Forms */

#define Z_UNICODE_VULGAR_FRACTION_ONE_SEVENTH	     0x2150
#define Z_UNICODE_VULGAR_FRACTION_ONE_NINTH	     0x2151
#define Z_UNICODE_VULGAR_FRACTION_ONE_TENTH	     0x2152
#define Z_UNICODE_VULGAR_FRACTION_ONE_THIRD	     0x2153
#define Z_UNICODE_VULGAR_FRACTION_TWO_THIRDS	     0x2154
#define Z_UNICODE_VULGAR_FRACTION_ONE_FIFTH	     0x2155
#define Z_UNICODE_VULGAR_FRACTION_TWO_FIFTHS	     0x2156
#define Z_UNICODE_VULGAR_FRACTION_THREE_FIFTHS	     0x2157
#define Z_UNICODE_VULGAR_FRACTION_FOUR_FIFTHS	     0x2158
#define Z_UNICODE_VULGAR_FRACTION_ONE_SIXTH	     0x2159
#define Z_UNICODE_VULGAR_FRACTION_FIVE_SIXTHS	     0x215A
#define Z_UNICODE_VULGAR_FRACTION_ONE_EIGHTH	     0x215B
#define Z_UNICODE_VULGAR_FRACTION_THREE_EIGHTHS	     0x215C
#define Z_UNICODE_VULGAR_FRACTION_FIVE_EIGHTHS	     0x215D
#define Z_UNICODE_VULGAR_FRACTION_SEVEN_EIGHTHS	     0x215E
#define Z_UNICODE_FRACTION_NUMERATOR_ONE	     0x215F
#define Z_UNICODE_ROMAN_NUMERAL_ONE		     0x2160
#define Z_UNICODE_ROMAN_NUMERAL_TWO		     0x2161
#define Z_UNICODE_ROMAN_NUMERAL_THREE		     0x2162
#define Z_UNICODE_ROMAN_NUMERAL_FOUR		     0x2163
#define Z_UNICODE_ROMAN_NUMERAL_FIVE		     0x2164
#define Z_UNICODE_ROMAN_NUMERAL_SIX		     0x2165
#define Z_UNICODE_ROMAN_NUMERAL_SEVEN		     0x2166
#define Z_UNICODE_ROMAN_NUMERAL_EIGHT		     0x2167
#define Z_UNICODE_ROMAN_NUMERAL_NINE		     0x2168
#define Z_UNICODE_ROMAN_NUMERAL_TEN		     0x2169
#define Z_UNICODE_ROMAN_NUMERAL_ELEVEN		     0x216A
#define Z_UNICODE_ROMAN_NUMERAL_TWELVE		     0x216B
#define Z_UNICODE_ROMAN_NUMERAL_FIFTY		     0x216C
#define Z_UNICODE_ROMAN_NUMERAL_ONE_HUNDRED	     0x216D
#define Z_UNICODE_ROMAN_NUMERAL_FIVE_HUNDRED	     0x216E
#define Z_UNICODE_ROMAN_NUMERAL_ONE_THOUSAND	     0x216F
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_ONE	     0x2170
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_TWO	     0x2171
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_THREE	     0x2172
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_FOUR	     0x2173
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_FIVE	     0x2174
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_SIX	     0x2175
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_SEVEN	     0x2176
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_EIGHT	     0x2177
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_NINE	     0x2178
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_TEN	     0x2179
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_ELEVEN	     0x217A
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_TWELVE	     0x217B
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_FIFTY	     0x217C
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_ONE_HUNDRED    0x217D
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_FIVE_HUNDRED   0x217E
#define Z_UNICODE_SMALL_ROMAN_NUMERAL_ONE_THOUSAND   0x217F
#define Z_UNICODE_ROMAN_NUMERAL_ONE_THOUSAND_C_D     0x2180
#define Z_UNICODE_ROMAN_NUMERAL_FIVE_THOUSAND	     0x2181
#define Z_UNICODE_ROMAN_NUMERAL_TEN_THOUSAND	     0x2182
#define Z_UNICODE_ROMAN_NUMERAL_REVERSED_ONE_HUNDRED 0x2183
#define Z_UNICODE_LATIN_SMALL_LETTER_REVERSED_C	     0x2184
#define Z_UNICODE_ROMAN_NUMERAL_SIX_LATE_FORM	     0x2185
#define Z_UNICODE_ROMAN_NUMERAL_FIFTY_EARLY_FORM     0x2186
#define Z_UNICODE_ROMAN_NUMERAL_FIFTY_THOUSAND	     0x2187
#define Z_UNICODE_ROMAN_NUMERAL_ONE_HUNDRED_THOUSAND 0x2188
#define Z_UNICODE_VULGAR_FRACTION_ZERO_THIRDS	     0x2189
#define Z_UNICODE_TURNED_DIGIT_TWO		     0x218A
#define Z_UNICODE_TURNED_DIGIT_THREE		     0x218B

/* MARK: - 2190h-21FFh - Arrows */

#define Z_UNICODE_LEFTWARDS_ARROW				      0x2190
#define Z_UNICODE_UPWARDS_ARROW					      0x2191
#define Z_UNICODE_RIGHTWARDS_ARROW				      0x2192
#define Z_UNICODE_DOWNWARDS_ARROW				      0x2193
#define Z_UNICODE_LEFT_RIGHT_ARROW				      0x2194
#define Z_UNICODE_UP_DOWN_ARROW					      0x2195
#define Z_UNICODE_NORTH_WEST_ARROW				      0x2196
#define Z_UNICODE_NORTH_EAST_ARROW				      0x2197
#define Z_UNICODE_SOUTH_EAST_ARROW				      0x2198
#define Z_UNICODE_SOUTH_WEST_ARROW				      0x2199
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_STROKE			      0x219A
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_STROKE			      0x219B
#define Z_UNICODE_LEFTWARDS_WAVE_ARROW				      0x219C
#define Z_UNICODE_RIGHTWARDS_WAVE_ARROW				      0x219D
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_ARROW			      0x219E
#define Z_UNICODE_UPWARDS_TWO_HEADED_ARROW			      0x219F
#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_ARROW			      0x21A0
#define Z_UNICODE_DOWNWARDS_TWO_HEADED_ARROW			      0x21A1
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_TAIL			      0x21A2
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_TAIL			      0x21A3
#define Z_UNICODE_LEFTWARDS_ARROW_FROM_BAR			      0x21A4
#define Z_UNICODE_UPWARDS_ARROW_FROM_BAR			      0x21A5
#define Z_UNICODE_RIGHTWARDS_ARROW_FROM_BAR			      0x21A6
#define Z_UNICODE_DOWNWARDS_ARROW_FROM_BAR			      0x21A7
#define Z_UNICODE_UP_DOWN_ARROW_WITH_BASE			      0x21A8
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_HOOK			      0x21A9
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_HOOK			      0x21AA
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_LOOP			      0x21AB
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_LOOP			      0x21AC
#define Z_UNICODE_LEFT_RIGHT_WAVE_ARROW				      0x21AD
#define Z_UNICODE_LEFT_RIGHT_ARROW_WITH_STROKE			      0x21AE
#define Z_UNICODE_DOWNWARDS_ZIGZAG_ARROW			      0x21AF
#define Z_UNICODE_UPWARDS_ARROW_WITH_TIP_LEFTWARDS		      0x21B0
#define Z_UNICODE_UPWARDS_ARROW_WITH_TIP_RIGHTWARDS		      0x21B1
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_TIP_LEFTWARDS		      0x21B2
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_TIP_RIGHTWARDS		      0x21B3
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_CORNER_DOWNWARDS	      0x21B4
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_CORNER_LEFTWARDS		      0x21B5
#define Z_UNICODE_ANTICLOCKWISE_TOP_SEMICIRCLE_ARROW		      0x21B6
#define Z_UNICODE_CLOCKWISE_TOP_SEMICIRCLE_ARROW		      0x21B7
#define Z_UNICODE_NORTH_WEST_ARROW_TO_LONG_BAR			      0x21B8
#define Z_UNICODE_LEFTWARDS_ARROW_TO_BAR_OVER_RIGHTWARDS_ARROW_TO_BAR 0x21B9
#define Z_UNICODE_ANTICLOCKWISE_OPEN_CIRCLE_ARROW		      0x21BA
#define Z_UNICODE_CLOCKWISE_OPEN_CIRCLE_ARROW			      0x21BB
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_UPWARDS		      0x21BC
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_DOWNWARDS		      0x21BD
#define Z_UNICODE_UPWARDS_HARPOON_WITH_BARB_RIGHTWARDS		      0x21BE
#define Z_UNICODE_UPWARDS_HARPOON_WITH_BARB_LEFTWARDS		      0x21BF
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_UPWARDS		      0x21C0
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_DOWNWARDS	      0x21C1
#define Z_UNICODE_DOWNWARDS_HARPOON_WITH_BARB_RIGHTWARDS	      0x21C2
#define Z_UNICODE_DOWNWARDS_HARPOON_WITH_BARB_LEFTWARDS		      0x21C3
#define Z_UNICODE_RIGHTWARDS_ARROW_OVER_LEFTWARDS_ARROW		      0x21C4
#define Z_UNICODE_UPWARDS_ARROW_LEFTWARDS_OF_DOWNWARDS_ARROW	      0x21C5
#define Z_UNICODE_LEFTWARDS_ARROW_OVER_RIGHTWARDS_ARROW		      0x21C6
#define Z_UNICODE_LEFTWARDS_PAIRED_ARROWS			      0x21C7
#define Z_UNICODE_UPWARDS_PAIRED_ARROWS				      0x21C8
#define Z_UNICODE_RIGHTWARDS_PAIRED_ARROWS			      0x21C9
#define Z_UNICODE_DOWNWARDS_PAIRED_ARROWS			      0x21CA
#define Z_UNICODE_LEFTWARDS_HARPOON_OVER_RIGHTWARDS_HARPOON	      0x21CB
#define Z_UNICODE_RIGHTWARDS_HARPOON_OVER_LEFTWARDS_HARPOON	      0x21CC
#define Z_UNICODE_LEFTWARDS_DOUBLE_ARROW_WITH_STROKE		      0x21CD
#define Z_UNICODE_LEFT_RIGHT_DOUBLE_ARROW_WITH_STROKE		      0x21CE
#define Z_UNICODE_RIGHTWARDS_DOUBLE_ARROW_WITH_STROKE		      0x21CF
#define Z_UNICODE_LEFTWARDS_DOUBLE_ARROW			      0x21D0
#define Z_UNICODE_UPWARDS_DOUBLE_ARROW				      0x21D1
#define Z_UNICODE_RIGHTWARDS_DOUBLE_ARROW			      0x21D2
#define Z_UNICODE_DOWNWARDS_DOUBLE_ARROW			      0x21D3
#define Z_UNICODE_LEFT_RIGHT_DOUBLE_ARROW			      0x21D4
#define Z_UNICODE_UP_DOWN_DOUBLE_ARROW				      0x21D5
#define Z_UNICODE_NORTH_WEST_DOUBLE_ARROW			      0x21D6
#define Z_UNICODE_NORTH_EAST_DOUBLE_ARROW			      0x21D7
#define Z_UNICODE_SOUTH_EAST_DOUBLE_ARROW			      0x21D8
#define Z_UNICODE_SOUTH_WEST_DOUBLE_ARROW			      0x21D9
#define Z_UNICODE_LEFTWARDS_TRIPLE_ARROW			      0x21DA
#define Z_UNICODE_RIGHTWARDS_TRIPLE_ARROW			      0x21DB
#define Z_UNICODE_LEFTWARDS_SQUIGGLE_ARROW			      0x21DC
#define Z_UNICODE_RIGHTWARDS_SQUIGGLE_ARROW			      0x21DD
#define Z_UNICODE_UPWARDS_ARROW_WITH_DOUBLE_STROKE		      0x21DE
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_DOUBLE_STROKE		      0x21DF
#define Z_UNICODE_LEFTWARDS_DASHED_ARROW			      0x21E0
#define Z_UNICODE_UPWARDS_DASHED_ARROW				      0x21E1
#define Z_UNICODE_RIGHTWARDS_DASHED_ARROW			      0x21E2
#define Z_UNICODE_DOWNWARDS_DASHED_ARROW			      0x21E3
#define Z_UNICODE_LEFTWARDS_ARROW_TO_BAR			      0x21E4
#define Z_UNICODE_RIGHTWARDS_ARROW_TO_BAR			      0x21E5
#define Z_UNICODE_LEFTWARDS_WHITE_ARROW				      0x21E6
#define Z_UNICODE_UPWARDS_WHITE_ARROW				      0x21E7
#define Z_UNICODE_RIGHTWARDS_WHITE_ARROW			      0x21E8
#define Z_UNICODE_DOWNWARDS_WHITE_ARROW				      0x21E9
#define Z_UNICODE_UPWARDS_WHITE_ARROW_FROM_BAR			      0x21EA
#define Z_UNICODE_UPWARDS_WHITE_ARROW_ON_PEDESTAL		      0x21EB
#define Z_UNICODE_UPWARDS_WHITE_ARROW_ON_PEDESTAL_WITH_HORIZONTAL_BAR 0x21EC
#define Z_UNICODE_UPWARDS_WHITE_ARROW_ON_PEDESTAL_WITH_VERTICAL_BAR   0x21ED
#define Z_UNICODE_UPWARDS_WHITE_DOUBLE_ARROW			      0x21EE
#define Z_UNICODE_UPWARDS_WHITE_DOUBLE_ARROW_ON_PEDESTAL	      0x21EF
#define Z_UNICODE_RIGHTWARDS_WHITE_ARROW_FROM_WALL		      0x21F0
#define Z_UNICODE_NORTH_WEST_ARROW_TO_CORNER			      0x21F1
#define Z_UNICODE_SOUTH_EAST_ARROW_TO_CORNER			      0x21F2
#define Z_UNICODE_UP_DOWN_WHITE_ARROW				      0x21F3
#define Z_UNICODE_RIGHT_ARROW_WITH_SMALL_CIRCLE			      0x21F4
#define Z_UNICODE_DOWNWARDS_ARROW_LEFTWARDS_OF_UPWARDS_ARROW	      0x21F5
#define Z_UNICODE_THREE_RIGHTWARDS_ARROWS			      0x21F6
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_VERTICAL_STROKE		      0x21F7
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_VERTICAL_STROKE		      0x21F8
#define Z_UNICODE_LEFT_RIGHT_ARROW_WITH_VERTICAL_STROKE		      0x21F9
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_DOUBLE_VERTICAL_STROKE	      0x21FA
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_DOUBLE_VERTICAL_STROKE	      0x21FB
#define Z_UNICODE_LEFT_RIGHT_ARROW_WITH_DOUBLE_VERTICAL_STROKE	      0x21FC
#define Z_UNICODE_LEFTWARDS_OPEN_HEADED_ARROW			      0x21FD
#define Z_UNICODE_RIGHTWARDS_OPEN_HEADED_ARROW			      0x21FE
#define Z_UNICODE_LEFT_RIGHT_OPEN_HEADED_ARROW			      0x21FF

/* MARK: - 2200h-22FFh - Mathematical Operators */

#define Z_UNICODE_FOR_ALL							 0x2200
#define Z_UNICODE_COMPLEMENT							 0x2201
#define Z_UNICODE_PARTIAL_DIFFERENTIAL						 0x2202
#define Z_UNICODE_THERE_EXISTS							 0x2203
#define Z_UNICODE_THERE_DOES_NOT_EXIST						 0x2204
#define Z_UNICODE_EMPTY_SET							 0x2205
#define Z_UNICODE_INCREMENT							 0x2206
#define Z_UNICODE_NABLA								 0x2207
#define Z_UNICODE_ELEMENT_OF							 0x2208
#define Z_UNICODE_NOT_AN_ELEMENT_OF						 0x2209
#define Z_UNICODE_SMALL_ELEMENT_OF						 0x220A
#define Z_UNICODE_CONTAINS_AS_MEMBER						 0x220B
#define Z_UNICODE_DOES_NOT_CONTAIN_AS_MEMBER					 0x220C
#define Z_UNICODE_SMALL_CONTAINS_AS_MEMBER					 0x220D
#define Z_UNICODE_END_OF_PROOF							 0x220E
#define Z_UNICODE_N_ARY_PRODUCT							 0x220F
#define Z_UNICODE_N_ARY_COPRODUCT						 0x2210
#define Z_UNICODE_N_ARY_SUMMATION						 0x2211
#define Z_UNICODE_MINUS_SIGN							 0x2212
#define Z_UNICODE_MINUS_OR_PLUS_SIGN						 0x2213
#define Z_UNICODE_DOT_PLUS							 0x2214
#define Z_UNICODE_DIVISION_SLASH						 0x2215
#define Z_UNICODE_SET_MINUS							 0x2216
#define Z_UNICODE_ASTERISK_OPERATOR						 0x2217
#define Z_UNICODE_RING_OPERATOR							 0x2218
#define Z_UNICODE_BULLET_OPERATOR						 0x2219
#define Z_UNICODE_SQUARE_ROOT							 0x221A
#define Z_UNICODE_CUBE_ROOT							 0x221B
#define Z_UNICODE_FOURTH_ROOT							 0x221C
#define Z_UNICODE_PROPORTIONAL_TO						 0x221D
#define Z_UNICODE_INFINITY							 0x221E
#define Z_UNICODE_RIGHT_ANGLE							 0x221F
#define Z_UNICODE_ANGLE								 0x2220
#define Z_UNICODE_MEASURED_ANGLE						 0x2221
#define Z_UNICODE_SPHERICAL_ANGLE						 0x2222
#define Z_UNICODE_DIVIDES							 0x2223
#define Z_UNICODE_DOES_NOT_DIVIDE						 0x2224
#define Z_UNICODE_PARALLEL_TO							 0x2225
#define Z_UNICODE_NOT_PARALLEL_TO						 0x2226
#define Z_UNICODE_LOGICAL_AND							 0x2227
#define Z_UNICODE_LOGICAL_OR							 0x2228
#define Z_UNICODE_INTERSECTION							 0x2229
#define Z_UNICODE_UNION								 0x222A
#define Z_UNICODE_INTEGRAL							 0x222B
#define Z_UNICODE_DOUBLE_INTEGRAL						 0x222C
#define Z_UNICODE_TRIPLE_INTEGRAL						 0x222D
#define Z_UNICODE_CONTOUR_INTEGRAL						 0x222E
#define Z_UNICODE_SURFACE_INTEGRAL						 0x222F
#define Z_UNICODE_VOLUME_INTEGRAL						 0x2230
#define Z_UNICODE_CLOCKWISE_INTEGRAL						 0x2231
#define Z_UNICODE_CLOCKWISE_CONTOUR_INTEGRAL					 0x2232
#define Z_UNICODE_ANTICLOCKWISE_CONTOUR_INTEGRAL				 0x2233
#define Z_UNICODE_THEREFORE							 0x2234
#define Z_UNICODE_BECAUSE							 0x2235
#define Z_UNICODE_RATIO								 0x2236
#define Z_UNICODE_PROPORTION							 0x2237
#define Z_UNICODE_DOT_MINUS							 0x2238
#define Z_UNICODE_EXCESS							 0x2239
#define Z_UNICODE_GEOMETRIC_PROPORTION						 0x223A
#define Z_UNICODE_HOMOTHETIC							 0x223B
#define Z_UNICODE_TILDE_OPERATOR						 0x223C
#define Z_UNICODE_REVERSED_TILDE						 0x223D
#define Z_UNICODE_INVERTED_LAZY_S						 0x223E
#define Z_UNICODE_SINE_WAVE							 0x223F
#define Z_UNICODE_WREATH_PRODUCT						 0x2240
#define Z_UNICODE_NOT_TILDE							 0x2241
#define Z_UNICODE_MINUS_TILDE							 0x2242
#define Z_UNICODE_ASYMPTOTICALLY_EQUAL_TO					 0x2243
#define Z_UNICODE_NOT_ASYMPTOTICALLY_EQUAL_TO					 0x2244
#define Z_UNICODE_APPROXIMATELY_EQUAL_TO					 0x2245
#define Z_UNICODE_APPROXIMATELY_BUT_NOT_ACTUALLY_EQUAL_TO			 0x2246
#define Z_UNICODE_NEITHER_APPROXIMATELY_NOR_ACTUALLY_EQUAL_TO			 0x2247
#define Z_UNICODE_ALMOST_EQUAL_TO						 0x2248
#define Z_UNICODE_NOT_ALMOST_EQUAL_TO						 0x2249
#define Z_UNICODE_ALMOST_EQUAL_OR_EQUAL_TO					 0x224A
#define Z_UNICODE_TRIPLE_TILDE							 0x224B
#define Z_UNICODE_ALL_EQUAL_TO							 0x224C
#define Z_UNICODE_EQUIVALENT_TO							 0x224D
#define Z_UNICODE_GEOMETRICALLY_EQUIVALENT_TO					 0x224E
#define Z_UNICODE_DIFFERENCE_BETWEEN						 0x224F
#define Z_UNICODE_APPROACHES_THE_LIMIT						 0x2250
#define Z_UNICODE_GEOMETRICALLY_EQUAL_TO					 0x2251
#define Z_UNICODE_APPROXIMATELY_EQUAL_TO_OR_THE_IMAGE_OF			 0x2252
#define Z_UNICODE_IMAGE_OF_OR_APPROXIMATELY_EQUAL_TO				 0x2253
#define Z_UNICODE_COLON_EQUALS							 0x2254
#define Z_UNICODE_EQUALS_COLON							 0x2255
#define Z_UNICODE_RING_IN_EQUAL_TO						 0x2256
#define Z_UNICODE_RING_EQUAL_TO							 0x2257
#define Z_UNICODE_CORRESPONDS_TO						 0x2258
#define Z_UNICODE_ESTIMATES							 0x2259
#define Z_UNICODE_EQUIANGULAR_TO						 0x225A
#define Z_UNICODE_STAR_EQUALS							 0x225B
#define Z_UNICODE_DELTA_EQUAL_TO						 0x225C
#define Z_UNICODE_EQUAL_TO_BY_DEFINITION					 0x225D
#define Z_UNICODE_MEASURED_BY							 0x225E
#define Z_UNICODE_QUESTIONED_EQUAL_TO						 0x225F
#define Z_UNICODE_NOT_EQUAL_TO							 0x2260
#define Z_UNICODE_IDENTICAL_TO							 0x2261
#define Z_UNICODE_NOT_IDENTICAL_TO						 0x2262
#define Z_UNICODE_STRICTLY_EQUIVALENT_TO					 0x2263
#define Z_UNICODE_LESS_THAN_OR_EQUAL_TO						 0x2264
#define Z_UNICODE_GREATER_THAN_OR_EQUAL_TO					 0x2265
#define Z_UNICODE_LESS_THAN_OVER_EQUAL_TO					 0x2266
#define Z_UNICODE_GREATER_THAN_OVER_EQUAL_TO					 0x2267
#define Z_UNICODE_LESS_THAN_BUT_NOT_EQUAL_TO					 0x2268
#define Z_UNICODE_GREATER_THAN_BUT_NOT_EQUAL_TO					 0x2269
#define Z_UNICODE_MUCH_LESS_THAN						 0x226A
#define Z_UNICODE_MUCH_GREATER_THAN						 0x226B
#define Z_UNICODE_BETWEEN							 0x226C
#define Z_UNICODE_NOT_EQUIVALENT_TO						 0x226D
#define Z_UNICODE_NOT_LESS_THAN							 0x226E
#define Z_UNICODE_NOT_GREATER_THAN						 0x226F
#define Z_UNICODE_NEITHER_LESS_THAN_NOR_EQUAL_TO				 0x2270
#define Z_UNICODE_NEITHER_GREATER_THAN_NOR_EQUAL_TO				 0x2271
#define Z_UNICODE_LESS_THAN_OR_EQUIVALENT_TO					 0x2272
#define Z_UNICODE_GREATER_THAN_OR_EQUIVALENT_TO					 0x2273
#define Z_UNICODE_NEITHER_LESS_THAN_NOR_EQUIVALENT_TO				 0x2274
#define Z_UNICODE_NEITHER_GREATER_THAN_NOR_EQUIVALENT_TO			 0x2275
#define Z_UNICODE_LESS_THAN_OR_GREATER_THAN					 0x2276
#define Z_UNICODE_GREATER_THAN_OR_LESS_THAN					 0x2277
#define Z_UNICODE_NEITHER_LESS_THAN_NOR_GREATER_THAN				 0x2278
#define Z_UNICODE_NEITHER_GREATER_THAN_NOR_LESS_THAN				 0x2279
#define Z_UNICODE_PRECEDES							 0x227A
#define Z_UNICODE_SUCCEEDS							 0x227B
#define Z_UNICODE_PRECEDES_OR_EQUAL_TO						 0x227C
#define Z_UNICODE_SUCCEEDS_OR_EQUAL_TO						 0x227D
#define Z_UNICODE_PRECEDES_OR_EQUIVALENT_TO					 0x227E
#define Z_UNICODE_SUCCEEDS_OR_EQUIVALENT_TO					 0x227F
#define Z_UNICODE_DOES_NOT_PRECEDE						 0x2280
#define Z_UNICODE_DOES_NOT_SUCCEED						 0x2281
#define Z_UNICODE_SUBSET_OF							 0x2282
#define Z_UNICODE_SUPERSET_OF							 0x2283
#define Z_UNICODE_NOT_A_SUBSET_OF						 0x2284
#define Z_UNICODE_NOT_A_SUPERSET_OF						 0x2285
#define Z_UNICODE_SUBSET_OF_OR_EQUAL_TO						 0x2286
#define Z_UNICODE_SUPERSET_OF_OR_EQUAL_TO					 0x2287
#define Z_UNICODE_NEITHER_A_SUBSET_OF_NOR_EQUAL_TO				 0x2288
#define Z_UNICODE_NEITHER_A_SUPERSET_OF_NOR_EQUAL_TO				 0x2289
#define Z_UNICODE_SUBSET_OF_WITH_NOT_EQUAL_TO					 0x228A
#define Z_UNICODE_SUPERSET_OF_WITH_NOT_EQUAL_TO					 0x228B
#define Z_UNICODE_MULTISET							 0x228C
#define Z_UNICODE_MULTISET_MULTIPLICATION					 0x228D
#define Z_UNICODE_MULTISET_UNION						 0x228E
#define Z_UNICODE_SQUARE_IMAGE_OF						 0x228F
#define Z_UNICODE_SQUARE_ORIGINAL_OF						 0x2290
#define Z_UNICODE_SQUARE_IMAGE_OF_OR_EQUAL_TO					 0x2291
#define Z_UNICODE_SQUARE_ORIGINAL_OF_OR_EQUAL_TO				 0x2292
#define Z_UNICODE_SQUARE_CAP							 0x2293
#define Z_UNICODE_SQUARE_CUP							 0x2294
#define Z_UNICODE_CIRCLED_PLUS							 0x2295
#define Z_UNICODE_CIRCLED_MINUS							 0x2296
#define Z_UNICODE_CIRCLED_TIMES							 0x2297
#define Z_UNICODE_CIRCLED_DIVISION_SLASH					 0x2298
#define Z_UNICODE_CIRCLED_DOT_OPERATOR						 0x2299
#define Z_UNICODE_CIRCLED_RING_OPERATOR						 0x229A
#define Z_UNICODE_CIRCLED_ASTERISK_OPERATOR					 0x229B
#define Z_UNICODE_CIRCLED_EQUALS						 0x229C
#define Z_UNICODE_CIRCLED_DASH							 0x229D
#define Z_UNICODE_SQUARED_PLUS							 0x229E
#define Z_UNICODE_SQUARED_MINUS							 0x229F
#define Z_UNICODE_SQUARED_TIMES							 0x22A0
#define Z_UNICODE_SQUARED_DOT_OPERATOR						 0x22A1
#define Z_UNICODE_RIGHT_TACK							 0x22A2
#define Z_UNICODE_LEFT_TACK							 0x22A3
#define Z_UNICODE_DOWN_TACK							 0x22A4
#define Z_UNICODE_UP_TACK							 0x22A5
#define Z_UNICODE_ASSERTION							 0x22A6
#define Z_UNICODE_MODELS							 0x22A7
#define Z_UNICODE_TRUE								 0x22A8
#define Z_UNICODE_FORCES							 0x22A9
#define Z_UNICODE_TRIPLE_VERTICAL_BAR_RIGHT_TURNSTILE				 0x22AA
#define Z_UNICODE_DOUBLE_VERTICAL_BAR_DOUBLE_RIGHT_TURNSTILE			 0x22AB
#define Z_UNICODE_DOES_NOT_PROVE						 0x22AC
#define Z_UNICODE_NOT_TRUE							 0x22AD
#define Z_UNICODE_DOES_NOT_FORCE						 0x22AE
#define Z_UNICODE_NEGATED_DOUBLE_VERTICAL_BAR_DOUBLE_RIGHT_TURNSTILE		 0x22AF
#define Z_UNICODE_PRECEDES_UNDER_RELATION					 0x22B0
#define Z_UNICODE_SUCCEEDS_UNDER_RELATION					 0x22B1
#define Z_UNICODE_NORMAL_SUBGROUP_OF						 0x22B2
#define Z_UNICODE_CONTAINS_AS_NORMAL_SUBGROUP					 0x22B3
#define Z_UNICODE_NORMAL_SUBGROUP_OF_OR_EQUAL_TO				 0x22B4
#define Z_UNICODE_CONTAINS_AS_NORMAL_SUBGROUP_OR_EQUAL_TO			 0x22B5
#define Z_UNICODE_ORIGINAL_OF							 0x22B6
#define Z_UNICODE_IMAGE_OF							 0x22B7
#define Z_UNICODE_MULTIMAP							 0x22B8
#define Z_UNICODE_HERMITIAN_CONJUGATE_MATRIX					 0x22B9
#define Z_UNICODE_INTERCALATE							 0x22BA
#define Z_UNICODE_XOR								 0x22BB
#define Z_UNICODE_NAND								 0x22BC
#define Z_UNICODE_NOR								 0x22BD
#define Z_UNICODE_RIGHT_ANGLE_WITH_ARC						 0x22BE
#define Z_UNICODE_RIGHT_TRIANGLE						 0x22BF
#define Z_UNICODE_N_ARY_LOGICAL_AND						 0x22C0
#define Z_UNICODE_N_ARY_LOGICAL_OR						 0x22C1
#define Z_UNICODE_N_ARY_INTERSECTION						 0x22C2
#define Z_UNICODE_N_ARY_UNION							 0x22C3
#define Z_UNICODE_DIAMOND_OPERATOR						 0x22C4
#define Z_UNICODE_DOT_OPERATOR							 0x22C5
#define Z_UNICODE_STAR_OPERATOR							 0x22C6
#define Z_UNICODE_DIVISION_TIMES						 0x22C7
#define Z_UNICODE_BOWTIE							 0x22C8
#define Z_UNICODE_LEFT_NORMAL_FACTOR_SEMIDIRECT_PRODUCT				 0x22C9
#define Z_UNICODE_RIGHT_NORMAL_FACTOR_SEMIDIRECT_PRODUCT			 0x22CA
#define Z_UNICODE_LEFT_SEMIDIRECT_PRODUCT					 0x22CB
#define Z_UNICODE_RIGHT_SEMIDIRECT_PRODUCT					 0x22CC
#define Z_UNICODE_REVERSED_TILDE_EQUALS						 0x22CD
#define Z_UNICODE_CURLY_LOGICAL_OR						 0x22CE
#define Z_UNICODE_CURLY_LOGICAL_AND						 0x22CF
#define Z_UNICODE_DOUBLE_SUBSET							 0x22D0
#define Z_UNICODE_DOUBLE_SUPERSET						 0x22D1
#define Z_UNICODE_DOUBLE_INTERSECTION						 0x22D2
#define Z_UNICODE_DOUBLE_UNION							 0x22D3
#define Z_UNICODE_PITCHFORK							 0x22D4
#define Z_UNICODE_EQUAL_AND_PARALLEL_TO						 0x22D5
#define Z_UNICODE_LESS_THAN_WITH_DOT						 0x22D6
#define Z_UNICODE_GREATER_THAN_WITH_DOT						 0x22D7
#define Z_UNICODE_VERY_MUCH_LESS_THAN						 0x22D8
#define Z_UNICODE_VERY_MUCH_GREATER_THAN					 0x22D9
#define Z_UNICODE_LESS_THAN_EQUAL_TO_OR_GREATER_THAN				 0x22DA
#define Z_UNICODE_GREATER_THAN_EQUAL_TO_OR_LESS_THAN				 0x22DB
#define Z_UNICODE_EQUAL_TO_OR_LESS_THAN						 0x22DC
#define Z_UNICODE_EQUAL_TO_OR_GREATER_THAN					 0x22DD
#define Z_UNICODE_EQUAL_TO_OR_PRECEDES						 0x22DE
#define Z_UNICODE_EQUAL_TO_OR_SUCCEEDS						 0x22DF
#define Z_UNICODE_DOES_NOT_PRECEDE_OR_EQUAL					 0x22E0
#define Z_UNICODE_DOES_NOT_SUCCEED_OR_EQUAL					 0x22E1
#define Z_UNICODE_NOT_SQUARE_IMAGE_OF_OR_EQUAL_TO				 0x22E2
#define Z_UNICODE_NOT_SQUARE_ORIGINAL_OF_OR_EQUAL_TO				 0x22E3
#define Z_UNICODE_SQUARE_IMAGE_OF_OR_NOT_EQUAL_TO				 0x22E4
#define Z_UNICODE_SQUARE_ORIGINAL_OF_OR_NOT_EQUAL_TO				 0x22E5
#define Z_UNICODE_LESS_THAN_BUT_NOT_EQUIVALENT_TO				 0x22E6
#define Z_UNICODE_GREATER_THAN_BUT_NOT_EQUIVALENT_TO				 0x22E7
#define Z_UNICODE_PRECEDES_BUT_NOT_EQUIVALENT_TO				 0x22E8
#define Z_UNICODE_SUCCEEDS_BUT_NOT_EQUIVALENT_TO				 0x22E9
#define Z_UNICODE_NOT_NORMAL_SUBGROUP_OF					 0x22EA
#define Z_UNICODE_DOES_NOT_CONTAIN_AS_NORMAL_SUBGROUP				 0x22EB
#define Z_UNICODE_NOT_NORMAL_SUBGROUP_OF_OR_EQUAL_TO				 0x22EC
#define Z_UNICODE_DOES_NOT_CONTAIN_AS_NORMAL_SUBGROUP_OR_EQUAL			 0x22ED
#define Z_UNICODE_VERTICAL_ELLIPSIS						 0x22EE
#define Z_UNICODE_MIDLINE_HORIZONTAL_ELLIPSIS					 0x22EF
#define Z_UNICODE_UP_RIGHT_DIAGONAL_ELLIPSIS					 0x22F0
#define Z_UNICODE_DOWN_RIGHT_DIAGONAL_ELLIPSIS					 0x22F1
#define Z_UNICODE_ELEMENT_OF_WITH_LONG_HORIZONTAL_STROKE			 0x22F2
#define Z_UNICODE_ELEMENT_OF_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE	 0x22F3
#define Z_UNICODE_SMALL_ELEMENT_OF_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE 0x22F4
#define Z_UNICODE_ELEMENT_OF_WITH_DOT_ABOVE					 0x22F5
#define Z_UNICODE_ELEMENT_OF_WITH_OVERBAR					 0x22F6
#define Z_UNICODE_SMALL_ELEMENT_OF_WITH_OVERBAR					 0x22F7
#define Z_UNICODE_ELEMENT_OF_WITH_UNDERBAR					 0x22F8
#define Z_UNICODE_ELEMENT_OF_WITH_TWO_HORIZONTAL_STROKES			 0x22F9
#define Z_UNICODE_CONTAINS_WITH_LONG_HORIZONTAL_STROKE				 0x22FA
#define Z_UNICODE_CONTAINS_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE	 0x22FB
#define Z_UNICODE_SMALL_CONTAINS_WITH_VERTICAL_BAR_AT_END_OF_HORIZONTAL_STROKE	 0x22FC
#define Z_UNICODE_CONTAINS_WITH_OVERBAR						 0x22FD
#define Z_UNICODE_SMALL_CONTAINS_WITH_OVERBAR					 0x22FE
#define Z_UNICODE_Z_NOTATION_BAG_MEMBERSHIP					 0x22FF

/* MARK: - 2300h-23FFh - Miscellaneous Technical */

#define Z_UNICODE_DIAMETER_SIGN						   0x2300
#define Z_UNICODE_ELECTRIC_ARROW					   0x2301
#define Z_UNICODE_HOUSE							   0x2302
#define Z_UNICODE_UP_ARROWHEAD						   0x2303
#define Z_UNICODE_DOWN_ARROWHEAD					   0x2304
#define Z_UNICODE_PROJECTIVE						   0x2305
#define Z_UNICODE_PERSPECTIVE						   0x2306
#define Z_UNICODE_WAVY_LINE						   0x2307
#define Z_UNICODE_LEFT_CEILING						   0x2308
#define Z_UNICODE_RIGHT_CEILING						   0x2309
#define Z_UNICODE_LEFT_FLOOR						   0x230A
#define Z_UNICODE_RIGHT_FLOOR						   0x230B
#define Z_UNICODE_BOTTOM_RIGHT_CROP					   0x230C
#define Z_UNICODE_BOTTOM_LEFT_CROP					   0x230D
#define Z_UNICODE_TOP_RIGHT_CROP					   0x230E
#define Z_UNICODE_TOP_LEFT_CROP						   0x230F
#define Z_UNICODE_REVERSED_NOT_SIGN					   0x2310
#define Z_UNICODE_SQUARE_LOZENGE					   0x2311
#define Z_UNICODE_ARC							   0x2312
#define Z_UNICODE_SEGMENT						   0x2313
#define Z_UNICODE_SECTOR						   0x2314
#define Z_UNICODE_TELEPHONE_RECORDER					   0x2315
#define Z_UNICODE_POSITION_INDICATOR					   0x2316
#define Z_UNICODE_VIEWDATA_SQUARE					   0x2317
#define Z_UNICODE_PLACE_OF_INTEREST_SIGN				   0x2318
#define Z_UNICODE_TURNED_NOT_SIGN					   0x2319
#define Z_UNICODE_WATCH							   0x231A
#define Z_UNICODE_HOURGLASS						   0x231B
#define Z_UNICODE_TOP_LEFT_CORNER					   0x231C
#define Z_UNICODE_TOP_RIGHT_CORNER					   0x231D
#define Z_UNICODE_BOTTOM_LEFT_CORNER					   0x231E
#define Z_UNICODE_BOTTOM_RIGHT_CORNER					   0x231F
#define Z_UNICODE_TOP_HALF_INTEGRAL					   0x2320
#define Z_UNICODE_BOTTOM_HALF_INTEGRAL					   0x2321
#define Z_UNICODE_FROWN							   0x2322
#define Z_UNICODE_SMILE							   0x2323
#define Z_UNICODE_UP_ARROWHEAD_BETWEEN_TWO_HORIZONTAL_BARS		   0x2324
#define Z_UNICODE_OPTION_KEY						   0x2325
#define Z_UNICODE_ERASE_TO_THE_RIGHT					   0x2326
#define Z_UNICODE_X_IN_A_RECTANGLE_BOX					   0x2327
#define Z_UNICODE_KEYBOARD						   0x2328
#define Z_UNICODE_LEFT_POINTING_ANGLE_BRACKET				   0x2329
#define Z_UNICODE_RIGHT_POINTING_ANGLE_BRACKET				   0x232A
#define Z_UNICODE_ERASE_TO_THE_LEFT					   0x232B
#define Z_UNICODE_BENZENE_RING						   0x232C
#define Z_UNICODE_CYLINDRICITY						   0x232D
#define Z_UNICODE_ALL_AROUND_PROFILE					   0x232E
#define Z_UNICODE_SYMMETRY						   0x232F
#define Z_UNICODE_TOTAL_RUNOUT						   0x2330
#define Z_UNICODE_DIMENSION_ORIGIN					   0x2331
#define Z_UNICODE_CONICAL_TAPER						   0x2332
#define Z_UNICODE_SLOPE							   0x2333
#define Z_UNICODE_COUNTERBORE						   0x2334
#define Z_UNICODE_COUNTERSINK						   0x2335
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_I_BEAM				   0x2336
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_SQUISH_QUAD			   0x2337
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_EQUAL			   0x2338
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_DIVIDE			   0x2339
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_DIAMOND			   0x233A
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_JOT			   0x233B
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_CIRCLE			   0x233C
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_CIRCLE_STILE			   0x233D
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_CIRCLE_JOT			   0x233E
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_SLASH_BAR			   0x233F
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_BACKSLASH_BAR			   0x2340
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_SLASH			   0x2341
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_BACKSLASH			   0x2342
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_LESS_THAN			   0x2343
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_GREATER_THAN		   0x2344
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_LEFTWARDS_VANE			   0x2345
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_RIGHTWARDS_VANE			   0x2346
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_LEFTWARDS_ARROW		   0x2347
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_RIGHTWARDS_ARROW		   0x2348
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_CIRCLE_BACKSLASH		   0x2349
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DOWN_TACK_UNDERBAR		   0x234A
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DELTA_STILE			   0x234B
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_DOWN_CARET			   0x234C
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_DELTA			   0x234D
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DOWN_TACK_JOT			   0x234E
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_UPWARDS_VANE			   0x234F
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_UPWARDS_ARROW		   0x2350
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_UP_TACK_OVERBAR			   0x2351
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DEL_STILE			   0x2352
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_UP_CARET			   0x2353
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_DEL			   0x2354
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_UP_TACK_JOT			   0x2355
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DOWNWARDS_VANE			   0x2356
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_DOWNWARDS_ARROW		   0x2357
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUOTE_UNDERBAR			   0x2358
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DELTA_UNDERBAR			   0x2359
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DIAMOND_UNDERBAR		   0x235A
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_JOT_UNDERBAR			   0x235B
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_CIRCLE_UNDERBAR			   0x235C
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_UP_SHOE_JOT			   0x235D
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUOTE_QUAD			   0x235E
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_CIRCLE_STAR			   0x235F
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_COLON			   0x2360
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_UP_TACK_DIAERESIS		   0x2361
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DEL_DIAERESIS			   0x2362
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_STAR_DIAERESIS			   0x2363
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_JOT_DIAERESIS			   0x2364
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_CIRCLE_DIAERESIS		   0x2365
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DOWN_SHOE_STILE			   0x2366
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_LEFT_SHOE_STILE			   0x2367
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_TILDE_DIAERESIS			   0x2368
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_GREATER_THAN_DIAERESIS		   0x2369
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_COMMA_BAR			   0x236A
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DEL_TILDE			   0x236B
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_ZILDE				   0x236C
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_STILE_TILDE			   0x236D
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_SEMICOLON_UNDERBAR		   0x236E
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_NOT_EQUAL			   0x236F
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD_QUESTION			   0x2370
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_DOWN_CARET_TILDE		   0x2371
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_UP_CARET_TILDE			   0x2372
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_IOTA				   0x2373
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_RHO				   0x2374
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_OMEGA				   0x2375
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_ALPHA_UNDERBAR			   0x2376
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_EPSILON_UNDERBAR		   0x2377
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_IOTA_UNDERBAR			   0x2378
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_OMEGA_UNDERBAR			   0x2379
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_ALPHA				   0x237A
#define Z_UNICODE_NOT_CHECK_MARK					   0x237B
#define Z_UNICODE_RIGHT_ANGLE_WITH_DOWNWARDS_ZIGZAG_ARROW		   0x237C
#define Z_UNICODE_SHOULDERED_OPEN_BOX					   0x237D
#define Z_UNICODE_BELL_SYMBOL						   0x237E
#define Z_UNICODE_VERTICAL_LINE_WITH_MIDDLE_DOT				   0x237F
#define Z_UNICODE_INSERTION_SYMBOL					   0x2380
#define Z_UNICODE_CONTINUOUS_UNDERLINE_SYMBOL				   0x2381
#define Z_UNICODE_DISCONTINUOUS_UNDERLINE_SYMBOL			   0x2382
#define Z_UNICODE_EMPHASIS_SYMBOL					   0x2383
#define Z_UNICODE_COMPOSITION_SYMBOL					   0x2384
#define Z_UNICODE_WHITE_SQUARE_WITH_CENTRE_VERTICAL_LINE		   0x2385
#define Z_UNICODE_ENTER_SYMBOL						   0x2386
#define Z_UNICODE_ALTERNATIVE_KEY_SYMBOL				   0x2387
#define Z_UNICODE_HELM_SYMBOL						   0x2388
#define Z_UNICODE_CIRCLED_HORIZONTAL_BAR_WITH_NOTCH			   0x2389
#define Z_UNICODE_CIRCLED_TRIANGLE_DOWN					   0x238A
#define Z_UNICODE_BROKEN_CIRCLE_WITH_NORTHWEST_ARROW			   0x238B
#define Z_UNICODE_UNDO_SYMBOL						   0x238C
#define Z_UNICODE_MONOSTABLE_SYMBOL					   0x238D
#define Z_UNICODE_HYSTERESIS_SYMBOL					   0x238E
#define Z_UNICODE_OPEN_CIRCUIT_OUTPUT_H_TYPE_SYMBOL			   0x238F
#define Z_UNICODE_OPEN_CIRCUIT_OUTPUT_L_TYPE_SYMBOL			   0x2390
#define Z_UNICODE_PASSIVE_PULL_DOWN_OUTPUT_SYMBOL			   0x2391
#define Z_UNICODE_PASSIVE_PULL_UP_OUTPUT_SYMBOL				   0x2392
#define Z_UNICODE_DIRECT_CURRENT_SYMBOL_FORM_TWO			   0x2393
#define Z_UNICODE_SOFTWARE_FUNCTION_SYMBOL				   0x2394
#define Z_UNICODE_APL_FUNCTIONAL_SYMBOL_QUAD				   0x2395
#define Z_UNICODE_DECIMAL_SEPARATOR_KEY_SYMBOL				   0x2396
#define Z_UNICODE_PREVIOUS_PAGE						   0x2397
#define Z_UNICODE_NEXT_PAGE						   0x2398
#define Z_UNICODE_PRINT_SCREEN_SYMBOL					   0x2399
#define Z_UNICODE_CLEAR_SCREEN_SYMBOL					   0x239A
#define Z_UNICODE_LEFT_PARENTHESIS_UPPER_HOOK				   0x239B
#define Z_UNICODE_LEFT_PARENTHESIS_EXTENSION				   0x239C
#define Z_UNICODE_LEFT_PARENTHESIS_LOWER_HOOK				   0x239D
#define Z_UNICODE_RIGHT_PARENTHESIS_UPPER_HOOK				   0x239E
#define Z_UNICODE_RIGHT_PARENTHESIS_EXTENSION				   0x239F
#define Z_UNICODE_RIGHT_PARENTHESIS_LOWER_HOOK				   0x23A0
#define Z_UNICODE_LEFT_SQUARE_BRACKET_UPPER_CORNER			   0x23A1
#define Z_UNICODE_LEFT_SQUARE_BRACKET_EXTENSION				   0x23A2
#define Z_UNICODE_LEFT_SQUARE_BRACKET_LOWER_CORNER			   0x23A3
#define Z_UNICODE_RIGHT_SQUARE_BRACKET_UPPER_CORNER			   0x23A4
#define Z_UNICODE_RIGHT_SQUARE_BRACKET_EXTENSION			   0x23A5
#define Z_UNICODE_RIGHT_SQUARE_BRACKET_LOWER_CORNER			   0x23A6
#define Z_UNICODE_LEFT_CURLY_BRACKET_UPPER_HOOK				   0x23A7
#define Z_UNICODE_LEFT_CURLY_BRACKET_MIDDLE_PIECE			   0x23A8
#define Z_UNICODE_LEFT_CURLY_BRACKET_LOWER_HOOK				   0x23A9
#define Z_UNICODE_CURLY_BRACKET_EXTENSION				   0x23AA
#define Z_UNICODE_RIGHT_CURLY_BRACKET_UPPER_HOOK			   0x23AB
#define Z_UNICODE_RIGHT_CURLY_BRACKET_MIDDLE_PIECE			   0x23AC
#define Z_UNICODE_RIGHT_CURLY_BRACKET_LOWER_HOOK			   0x23AD
#define Z_UNICODE_INTEGRAL_EXTENSION					   0x23AE
#define Z_UNICODE_HORIZONTAL_LINE_EXTENSION				   0x23AF
#define Z_UNICODE_UPPER_LEFT_OR_LOWER_RIGHT_CURLY_BRACKET_SECTION	   0x23B0
#define Z_UNICODE_UPPER_RIGHT_OR_LOWER_LEFT_CURLY_BRACKET_SECTION	   0x23B1
#define Z_UNICODE_SUMMATION_TOP						   0x23B2
#define Z_UNICODE_SUMMATION_BOTTOM					   0x23B3
#define Z_UNICODE_TOP_SQUARE_BRACKET					   0x23B4
#define Z_UNICODE_BOTTOM_SQUARE_BRACKET					   0x23B5
#define Z_UNICODE_BOTTOM_SQUARE_BRACKET_OVER_TOP_SQUARE_BRACKET		   0x23B6
#define Z_UNICODE_RADICAL_SYMBOL_BOTTOM					   0x23B7
#define Z_UNICODE_LEFT_VERTICAL_BOX_LINE				   0x23B8
#define Z_UNICODE_RIGHT_VERTICAL_BOX_LINE				   0x23B9
#define Z_UNICODE_HORIZONTAL_SCAN_LINE_1				   0x23BA
#define Z_UNICODE_HORIZONTAL_SCAN_LINE_3				   0x23BB
#define Z_UNICODE_HORIZONTAL_SCAN_LINE_7				   0x23BC
#define Z_UNICODE_HORIZONTAL_SCAN_LINE_9				   0x23BD
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_TOP_RIGHT		   0x23BE
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_BOTTOM_RIGHT	   0x23BF
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_VERTICAL_WITH_CIRCLE		   0x23C0
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_CIRCLE   0x23C1
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_CIRCLE	   0x23C2
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_VERTICAL_WITH_TRIANGLE		   0x23C3
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_TRIANGLE 0x23C4
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_TRIANGLE   0x23C5
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_WAVE		   0x23C6
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL_WITH_WAVE	   0x23C7
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL_WITH_WAVE	   0x23C8
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_DOWN_AND_HORIZONTAL		   0x23C9
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_UP_AND_HORIZONTAL		   0x23CA
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_TOP_LEFT		   0x23CB
#define Z_UNICODE_DENTISTRY_SYMBOL_LIGHT_VERTICAL_AND_BOTTOM_LEFT	   0x23CC
#define Z_UNICODE_SQUARE_FOOT						   0x23CD
#define Z_UNICODE_RETURN_SYMBOL						   0x23CE
#define Z_UNICODE_EJECT_SYMBOL						   0x23CF
#define Z_UNICODE_VERTICAL_LINE_EXTENSION				   0x23D0
#define Z_UNICODE_METRICAL_BREVE					   0x23D1
#define Z_UNICODE_METRICAL_LONG_OVER_SHORT				   0x23D2
#define Z_UNICODE_METRICAL_SHORT_OVER_LONG				   0x23D3
#define Z_UNICODE_METRICAL_LONG_OVER_TWO_SHORTS				   0x23D4
#define Z_UNICODE_METRICAL_TWO_SHORTS_OVER_LONG				   0x23D5
#define Z_UNICODE_METRICAL_TWO_SHORTS_JOINED				   0x23D6
#define Z_UNICODE_METRICAL_TRISEME					   0x23D7
#define Z_UNICODE_METRICAL_TETRASEME					   0x23D8
#define Z_UNICODE_METRICAL_PENTASEME					   0x23D9
#define Z_UNICODE_EARTH_GROUND						   0x23DA
#define Z_UNICODE_FUSE							   0x23DB
#define Z_UNICODE_TOP_PARENTHESIS					   0x23DC
#define Z_UNICODE_BOTTOM_PARENTHESIS					   0x23DD
#define Z_UNICODE_TOP_CURLY_BRACKET					   0x23DE
#define Z_UNICODE_BOTTOM_CURLY_BRACKET					   0x23DF
#define Z_UNICODE_TOP_TORTOISE_SHELL_BRACKET				   0x23E0
#define Z_UNICODE_BOTTOM_TORTOISE_SHELL_BRACKET				   0x23E1
#define Z_UNICODE_WHITE_TRAPEZIUM					   0x23E2
#define Z_UNICODE_BENZENE_RING_WITH_CIRCLE				   0x23E3
#define Z_UNICODE_STRAIGHTNESS						   0x23E4
#define Z_UNICODE_FLATNESS						   0x23E5
#define Z_UNICODE_AC_CURRENT						   0x23E6
#define Z_UNICODE_ELECTRICAL_INTERSECTION				   0x23E7
#define Z_UNICODE_DECIMAL_EXPONENT_SYMBOL				   0x23E8
#define Z_UNICODE_BLACK_RIGHT_POINTING_DOUBLE_TRIANGLE			   0x23E9
#define Z_UNICODE_BLACK_LEFT_POINTING_DOUBLE_TRIANGLE			   0x23EA
#define Z_UNICODE_BLACK_UP_POINTING_DOUBLE_TRIANGLE			   0x23EB
#define Z_UNICODE_BLACK_DOWN_POINTING_DOUBLE_TRIANGLE			   0x23EC
#define Z_UNICODE_BLACK_RIGHT_POINTING_DOUBLE_TRIANGLE_WITH_VERTICAL_BAR   0x23ED
#define Z_UNICODE_BLACK_LEFT_POINTING_DOUBLE_TRIANGLE_WITH_VERTICAL_BAR	   0x23EE
#define Z_UNICODE_BLACK_RIGHT_POINTING_TRIANGLE_WITH_DOUBLE_VERTICAL_BAR   0x23EF
#define Z_UNICODE_ALARM_CLOCK						   0x23F0
#define Z_UNICODE_STOPWATCH						   0x23F1
#define Z_UNICODE_TIMER_CLOCK						   0x23F2
#define Z_UNICODE_HOURGLASS_WITH_FLOWING_SAND				   0x23F3
#define Z_UNICODE_BLACK_MEDIUM_LEFT_POINTING_TRIANGLE			   0x23F4
#define Z_UNICODE_BLACK_MEDIUM_RIGHT_POINTING_TRIANGLE			   0x23F5
#define Z_UNICODE_BLACK_MEDIUM_UP_POINTING_TRIANGLE			   0x23F6
#define Z_UNICODE_BLACK_MEDIUM_DOWN_POINTING_TRIANGLE			   0x23F7
#define Z_UNICODE_DOUBLE_VERTICAL_BAR					   0x23F8
#define Z_UNICODE_BLACK_SQUARE_FOR_STOP					   0x23F9
#define Z_UNICODE_BLACK_CIRCLE_FOR_RECORD				   0x23FA

/* MARK: - 2400h-243Fh - Control Pictures */

#define Z_UNICODE_SYMBOL_FOR_NULL		       0x2400
#define Z_UNICODE_SYMBOL_FOR_START_OF_HEADING	       0x2401
#define Z_UNICODE_SYMBOL_FOR_START_OF_TEXT	       0x2402
#define Z_UNICODE_SYMBOL_FOR_END_OF_TEXT	       0x2403
#define Z_UNICODE_SYMBOL_FOR_END_OF_TRANSMISSION       0x2404
#define Z_UNICODE_SYMBOL_FOR_ENQUIRY		       0x2405
#define Z_UNICODE_SYMBOL_FOR_ACKNOWLEDGE	       0x2406
#define Z_UNICODE_SYMBOL_FOR_BELL		       0x2407
#define Z_UNICODE_SYMBOL_FOR_BACKSPACE		       0x2408
#define Z_UNICODE_SYMBOL_FOR_HORIZONTAL_TABULATION     0x2409
#define Z_UNICODE_SYMBOL_FOR_LINE_FEED		       0x240A
#define Z_UNICODE_SYMBOL_FOR_VERTICAL_TABULATION       0x240B
#define Z_UNICODE_SYMBOL_FOR_FORM_FEED		       0x240C
#define Z_UNICODE_SYMBOL_FOR_CARRIAGE_RETURN	       0x240D
#define Z_UNICODE_SYMBOL_FOR_SHIFT_OUT		       0x240E
#define Z_UNICODE_SYMBOL_FOR_SHIFT_IN		       0x240F
#define Z_UNICODE_SYMBOL_FOR_DATA_LINK_ESCAPE	       0x2410
#define Z_UNICODE_SYMBOL_FOR_DEVICE_CONTROL_ONE	       0x2411
#define Z_UNICODE_SYMBOL_FOR_DEVICE_CONTROL_TWO	       0x2412
#define Z_UNICODE_SYMBOL_FOR_DEVICE_CONTROL_THREE      0x2413
#define Z_UNICODE_SYMBOL_FOR_DEVICE_CONTROL_FOUR       0x2414
#define Z_UNICODE_SYMBOL_FOR_NEGATIVE_ACKNOWLEDGE      0x2415
#define Z_UNICODE_SYMBOL_FOR_SYNCHRONOUS_IDLE	       0x2416
#define Z_UNICODE_SYMBOL_FOR_END_OF_TRANSMISSION_BLOCK 0x2417
#define Z_UNICODE_SYMBOL_FOR_CANCEL		       0x2418
#define Z_UNICODE_SYMBOL_FOR_END_OF_MEDIUM	       0x2419
#define Z_UNICODE_SYMBOL_FOR_SUBSTITUTE		       0x241A
#define Z_UNICODE_SYMBOL_FOR_ESCAPE		       0x241B
#define Z_UNICODE_SYMBOL_FOR_FILE_SEPARATOR	       0x241C
#define Z_UNICODE_SYMBOL_FOR_GROUP_SEPARATOR	       0x241D
#define Z_UNICODE_SYMBOL_FOR_RECORD_SEPARATOR	       0x241E
#define Z_UNICODE_SYMBOL_FOR_UNIT_SEPARATOR	       0x241F
#define Z_UNICODE_SYMBOL_FOR_SPACE		       0x2420
#define Z_UNICODE_SYMBOL_FOR_DELETE		       0x2421
#define Z_UNICODE_BLANK_SYMBOL			       0x2422
#define Z_UNICODE_OPEN_BOX			       0x2423
#define Z_UNICODE_SYMBOL_FOR_NEWLINE		       0x2424
#define Z_UNICODE_SYMBOL_FOR_DELETE_FORM_TWO	       0x2425
#define Z_UNICODE_SYMBOL_FOR_SUBSTITUTE_FORM_TWO       0x2426

/* MARK: - 2440h-245Fh - Optical Character Recognition */

#define Z_UNICODE_OCR_HOOK			 0x2440
#define Z_UNICODE_OCR_CHAIR			 0x2441
#define Z_UNICODE_OCR_FORK			 0x2442
#define Z_UNICODE_OCR_INVERTED_FORK		 0x2443
#define Z_UNICODE_OCR_BELT_BUCKLE		 0x2444
#define Z_UNICODE_OCR_BOW_TIE			 0x2445
#define Z_UNICODE_OCR_BRANCH_BANK_IDENTIFICATION 0x2446
#define Z_UNICODE_OCR_AMOUNT_OF_CHECK		 0x2447
#define Z_UNICODE_OCR_DASH			 0x2448
#define Z_UNICODE_OCR_CUSTOMER_ACCOUNT_NUMBER	 0x2449
#define Z_UNICODE_OCR_DOUBLE_BACKSLASH		 0x244A

/* MARK: - 2460h-24FFh - Enclosed Alphanumerics */

#define Z_UNICODE_CIRCLED_DIGIT_ONE		     0x2460
#define Z_UNICODE_CIRCLED_DIGIT_TWO		     0x2461
#define Z_UNICODE_CIRCLED_DIGIT_THREE		     0x2462
#define Z_UNICODE_CIRCLED_DIGIT_FOUR		     0x2463
#define Z_UNICODE_CIRCLED_DIGIT_FIVE		     0x2464
#define Z_UNICODE_CIRCLED_DIGIT_SIX		     0x2465
#define Z_UNICODE_CIRCLED_DIGIT_SEVEN		     0x2466
#define Z_UNICODE_CIRCLED_DIGIT_EIGHT		     0x2467
#define Z_UNICODE_CIRCLED_DIGIT_NINE		     0x2468
#define Z_UNICODE_CIRCLED_NUMBER_TEN		     0x2469
#define Z_UNICODE_CIRCLED_NUMBER_ELEVEN		     0x246A
#define Z_UNICODE_CIRCLED_NUMBER_TWELVE		     0x246B
#define Z_UNICODE_CIRCLED_NUMBER_THIRTEEN	     0x246C
#define Z_UNICODE_CIRCLED_NUMBER_FOURTEEN	     0x246D
#define Z_UNICODE_CIRCLED_NUMBER_FIFTEEN	     0x246E
#define Z_UNICODE_CIRCLED_NUMBER_SIXTEEN	     0x246F
#define Z_UNICODE_CIRCLED_NUMBER_SEVENTEEN	     0x2470
#define Z_UNICODE_CIRCLED_NUMBER_EIGHTEEN	     0x2471
#define Z_UNICODE_CIRCLED_NUMBER_NINETEEN	     0x2472
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY		     0x2473
#define Z_UNICODE_PARENTHESIZED_DIGIT_ONE	     0x2474
#define Z_UNICODE_PARENTHESIZED_DIGIT_TWO	     0x2475
#define Z_UNICODE_PARENTHESIZED_DIGIT_THREE	     0x2476
#define Z_UNICODE_PARENTHESIZED_DIGIT_FOUR	     0x2477
#define Z_UNICODE_PARENTHESIZED_DIGIT_FIVE	     0x2478
#define Z_UNICODE_PARENTHESIZED_DIGIT_SIX	     0x2479
#define Z_UNICODE_PARENTHESIZED_DIGIT_SEVEN	     0x247A
#define Z_UNICODE_PARENTHESIZED_DIGIT_EIGHT	     0x247B
#define Z_UNICODE_PARENTHESIZED_DIGIT_NINE	     0x247C
#define Z_UNICODE_PARENTHESIZED_NUMBER_TEN	     0x247D
#define Z_UNICODE_PARENTHESIZED_NUMBER_ELEVEN	     0x247E
#define Z_UNICODE_PARENTHESIZED_NUMBER_TWELVE	     0x247F
#define Z_UNICODE_PARENTHESIZED_NUMBER_THIRTEEN	     0x2480
#define Z_UNICODE_PARENTHESIZED_NUMBER_FOURTEEN	     0x2481
#define Z_UNICODE_PARENTHESIZED_NUMBER_FIFTEEN	     0x2482
#define Z_UNICODE_PARENTHESIZED_NUMBER_SIXTEEN	     0x2483
#define Z_UNICODE_PARENTHESIZED_NUMBER_SEVENTEEN     0x2484
#define Z_UNICODE_PARENTHESIZED_NUMBER_EIGHTEEN	     0x2485
#define Z_UNICODE_PARENTHESIZED_NUMBER_NINETEEN	     0x2486
#define Z_UNICODE_PARENTHESIZED_NUMBER_TWENTY	     0x2487
#define Z_UNICODE_DIGIT_ONE_FULL_STOP		     0x2488
#define Z_UNICODE_DIGIT_TWO_FULL_STOP		     0x2489
#define Z_UNICODE_DIGIT_THREE_FULL_STOP		     0x248A
#define Z_UNICODE_DIGIT_FOUR_FULL_STOP		     0x248B
#define Z_UNICODE_DIGIT_FIVE_FULL_STOP		     0x248C
#define Z_UNICODE_DIGIT_SIX_FULL_STOP		     0x248D
#define Z_UNICODE_DIGIT_SEVEN_FULL_STOP		     0x248E
#define Z_UNICODE_DIGIT_EIGHT_FULL_STOP		     0x248F
#define Z_UNICODE_DIGIT_NINE_FULL_STOP		     0x2490
#define Z_UNICODE_NUMBER_TEN_FULL_STOP		     0x2491
#define Z_UNICODE_NUMBER_ELEVEN_FULL_STOP	     0x2492
#define Z_UNICODE_NUMBER_TWELVE_FULL_STOP	     0x2493
#define Z_UNICODE_NUMBER_THIRTEEN_FULL_STOP	     0x2494
#define Z_UNICODE_NUMBER_FOURTEEN_FULL_STOP	     0x2495
#define Z_UNICODE_NUMBER_FIFTEEN_FULL_STOP	     0x2496
#define Z_UNICODE_NUMBER_SIXTEEN_FULL_STOP	     0x2497
#define Z_UNICODE_NUMBER_SEVENTEEN_FULL_STOP	     0x2498
#define Z_UNICODE_NUMBER_EIGHTEEN_FULL_STOP	     0x2499
#define Z_UNICODE_NUMBER_NINETEEN_FULL_STOP	     0x249A
#define Z_UNICODE_NUMBER_TWENTY_FULL_STOP	     0x249B
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_A 0x249C
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_B 0x249D
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_C 0x249E
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_D 0x249F
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_E 0x24A0
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_F 0x24A1
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_G 0x24A2
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_H 0x24A3
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_I 0x24A4
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_J 0x24A5
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_K 0x24A6
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_L 0x24A7
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_M 0x24A8
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_N 0x24A9
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_O 0x24AA
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_P 0x24AB
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_Q 0x24AC
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_R 0x24AD
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_S 0x24AE
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_T 0x24AF
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_U 0x24B0
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_V 0x24B1
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_W 0x24B2
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_X 0x24B3
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_Y 0x24B4
#define Z_UNICODE_PARENTHESIZED_LATIN_SMALL_LETTER_Z 0x24B5
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_A     0x24B6
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_B     0x24B7
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_C     0x24B8
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_D     0x24B9
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_E     0x24BA
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_F     0x24BB
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_G     0x24BC
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_H     0x24BD
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_I     0x24BE
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_J     0x24BF
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_K     0x24C0
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_L     0x24C1
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_M     0x24C2
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_N     0x24C3
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_O     0x24C4
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_P     0x24C5
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_Q     0x24C6
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_R     0x24C7
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_S     0x24C8
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_T     0x24C9
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_U     0x24CA
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_V     0x24CB
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_W     0x24CC
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_X     0x24CD
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_Y     0x24CE
#define Z_UNICODE_CIRCLED_LATIN_CAPITAL_LETTER_Z     0x24CF
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_A	     0x24D0
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_B	     0x24D1
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_C	     0x24D2
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_D	     0x24D3
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_E	     0x24D4
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_F	     0x24D5
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_G	     0x24D6
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_H	     0x24D7
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_I	     0x24D8
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_J	     0x24D9
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_K	     0x24DA
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_L	     0x24DB
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_M	     0x24DC
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_N	     0x24DD
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_O	     0x24DE
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_P	     0x24DF
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_Q	     0x24E0
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_R	     0x24E1
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_S	     0x24E2
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_T	     0x24E3
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_U	     0x24E4
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_V	     0x24E5
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_W	     0x24E6
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_X	     0x24E7
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_Y	     0x24E8
#define Z_UNICODE_CIRCLED_LATIN_SMALL_LETTER_Z	     0x24E9
#define Z_UNICODE_CIRCLED_DIGIT_ZERO		     0x24EA
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_ELEVEN     0x24EB
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_TWELVE     0x24EC
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_THIRTEEN   0x24ED
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_FOURTEEN   0x24EE
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_FIFTEEN    0x24EF
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_SIXTEEN    0x24F0
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_SEVENTEEN  0x24F1
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_EIGHTEEN   0x24F2
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_NINETEEN   0x24F3
#define Z_UNICODE_NEGATIVE_CIRCLED_NUMBER_TWENTY     0x24F4
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_ONE	     0x24F5
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_TWO	     0x24F6
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_THREE	     0x24F7
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_FOUR	     0x24F8
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_FIVE	     0x24F9
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_SIX	     0x24FA
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_SEVEN	     0x24FB
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_EIGHT	     0x24FC
#define Z_UNICODE_DOUBLE_CIRCLED_DIGIT_NINE	     0x24FD
#define Z_UNICODE_DOUBLE_CIRCLED_NUMBER_TEN	     0x24FE
#define Z_UNICODE_NEGATIVE_CIRCLED_DIGIT_ZERO	     0x24FF

/* MARK: - 2500h-257Fh - Box Drawing */

#define Z_UNICODE_BOX_DRAWINGS_LIGHT_HORIZONTAL				0x2500
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_HORIZONTAL				0x2501
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_VERTICAL				0x2502
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_VERTICAL				0x2503
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_TRIPLE_DASH_HORIZONTAL		0x2504
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_TRIPLE_DASH_HORIZONTAL		0x2505
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_TRIPLE_DASH_VERTICAL		0x2506
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_TRIPLE_DASH_VERTICAL		0x2507
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_QUADRUPLE_DASH_HORIZONTAL		0x2508
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_QUADRUPLE_DASH_HORIZONTAL		0x2509
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_QUADRUPLE_DASH_VERTICAL		0x250A
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_QUADRUPLE_DASH_VERTICAL		0x250B
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DOWN_AND_RIGHT			0x250C
#define Z_UNICODE_BOX_DRAWINGS_DOWN_LIGHT_AND_RIGHT_HEAVY		0x250D
#define Z_UNICODE_BOX_DRAWINGS_DOWN_HEAVY_AND_RIGHT_LIGHT		0x250E
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_DOWN_AND_RIGHT			0x250F
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DOWN_AND_LEFT			0x2510
#define Z_UNICODE_BOX_DRAWINGS_DOWN_LIGHT_AND_LEFT_HEAVY		0x2511
#define Z_UNICODE_BOX_DRAWINGS_DOWN_HEAVY_AND_LEFT_LIGHT		0x2512
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_DOWN_AND_LEFT			0x2513
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_UP_AND_RIGHT			0x2514
#define Z_UNICODE_BOX_DRAWINGS_UP_LIGHT_AND_RIGHT_HEAVY			0x2515
#define Z_UNICODE_BOX_DRAWINGS_UP_HEAVY_AND_RIGHT_LIGHT			0x2516
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_UP_AND_RIGHT			0x2517
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_UP_AND_LEFT			0x2518
#define Z_UNICODE_BOX_DRAWINGS_UP_LIGHT_AND_LEFT_HEAVY			0x2519
#define Z_UNICODE_BOX_DRAWINGS_UP_HEAVY_AND_LEFT_LIGHT			0x251A
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_UP_AND_LEFT			0x251B
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_VERTICAL_AND_RIGHT			0x251C
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_LIGHT_AND_RIGHT_HEAVY		0x251D
#define Z_UNICODE_BOX_DRAWINGS_UP_HEAVY_AND_RIGHT_DOWN_LIGHT		0x251E
#define Z_UNICODE_BOX_DRAWINGS_DOWN_HEAVY_AND_RIGHT_UP_LIGHT		0x251F
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_HEAVY_AND_RIGHT_LIGHT		0x2520
#define Z_UNICODE_BOX_DRAWINGS_DOWN_LIGHT_AND_RIGHT_UP_HEAVY		0x2521
#define Z_UNICODE_BOX_DRAWINGS_UP_LIGHT_AND_RIGHT_DOWN_HEAVY		0x2522
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_VERTICAL_AND_RIGHT			0x2523
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_VERTICAL_AND_LEFT			0x2524
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_LIGHT_AND_LEFT_HEAVY		0x2525
#define Z_UNICODE_BOX_DRAWINGS_UP_HEAVY_AND_LEFT_DOWN_LIGHT		0x2526
#define Z_UNICODE_BOX_DRAWINGS_DOWN_HEAVY_AND_LEFT_UP_LIGHT		0x2527
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_HEAVY_AND_LEFT_LIGHT		0x2528
#define Z_UNICODE_BOX_DRAWINGS_DOWN_LIGHT_AND_LEFT_UP_HEAVY		0x2529
#define Z_UNICODE_BOX_DRAWINGS_UP_LIGHT_AND_LEFT_DOWN_HEAVY		0x252A
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_VERTICAL_AND_LEFT			0x252B
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DOWN_AND_HORIZONTAL		0x252C
#define Z_UNICODE_BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_DOWN_LIGHT		0x252D
#define Z_UNICODE_BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_DOWN_LIGHT		0x252E
#define Z_UNICODE_BOX_DRAWINGS_DOWN_LIGHT_AND_HORIZONTAL_HEAVY		0x252F
#define Z_UNICODE_BOX_DRAWINGS_DOWN_HEAVY_AND_HORIZONTAL_LIGHT		0x2530
#define Z_UNICODE_BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_DOWN_HEAVY		0x2531
#define Z_UNICODE_BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_DOWN_HEAVY		0x2532
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_DOWN_AND_HORIZONTAL		0x2533
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_UP_AND_HORIZONTAL			0x2534
#define Z_UNICODE_BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_UP_LIGHT		0x2535
#define Z_UNICODE_BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_UP_LIGHT		0x2536
#define Z_UNICODE_BOX_DRAWINGS_UP_LIGHT_AND_HORIZONTAL_HEAVY		0x2537
#define Z_UNICODE_BOX_DRAWINGS_UP_HEAVY_AND_HORIZONTAL_LIGHT		0x2538
#define Z_UNICODE_BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_UP_HEAVY		0x2539
#define Z_UNICODE_BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_UP_HEAVY		0x253A
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_UP_AND_HORIZONTAL			0x253B
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_VERTICAL_AND_HORIZONTAL		0x253C
#define Z_UNICODE_BOX_DRAWINGS_LEFT_HEAVY_AND_RIGHT_VERTICAL_LIGHT	0x253D
#define Z_UNICODE_BOX_DRAWINGS_RIGHT_HEAVY_AND_LEFT_VERTICAL_LIGHT	0x253E
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_LIGHT_AND_HORIZONTAL_HEAVY	0x253F
#define Z_UNICODE_BOX_DRAWINGS_UP_HEAVY_AND_DOWN_HORIZONTAL_LIGHT	0x2540
#define Z_UNICODE_BOX_DRAWINGS_DOWN_HEAVY_AND_UP_HORIZONTAL_LIGHT	0x2541
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_HEAVY_AND_HORIZONTAL_LIGHT	0x2542
#define Z_UNICODE_BOX_DRAWINGS_LEFT_UP_HEAVY_AND_RIGHT_DOWN_LIGHT	0x2543
#define Z_UNICODE_BOX_DRAWINGS_RIGHT_UP_HEAVY_AND_LEFT_DOWN_LIGHT	0x2544
#define Z_UNICODE_BOX_DRAWINGS_LEFT_DOWN_HEAVY_AND_RIGHT_UP_LIGHT	0x2545
#define Z_UNICODE_BOX_DRAWINGS_RIGHT_DOWN_HEAVY_AND_LEFT_UP_LIGHT	0x2546
#define Z_UNICODE_BOX_DRAWINGS_DOWN_LIGHT_AND_UP_HORIZONTAL_HEAVY	0x2547
#define Z_UNICODE_BOX_DRAWINGS_UP_LIGHT_AND_DOWN_HORIZONTAL_HEAVY	0x2548
#define Z_UNICODE_BOX_DRAWINGS_RIGHT_LIGHT_AND_LEFT_VERTICAL_HEAVY	0x2549
#define Z_UNICODE_BOX_DRAWINGS_LEFT_LIGHT_AND_RIGHT_VERTICAL_HEAVY	0x254A
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_VERTICAL_AND_HORIZONTAL		0x254B
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DOUBLE_DASH_HORIZONTAL		0x254C
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_DOUBLE_DASH_HORIZONTAL		0x254D
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DOUBLE_DASH_VERTICAL		0x254E
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_DOUBLE_DASH_VERTICAL		0x254F
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_HORIZONTAL			0x2550
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_VERTICAL				0x2551
#define Z_UNICODE_BOX_DRAWINGS_DOWN_SINGLE_AND_RIGHT_DOUBLE		0x2552
#define Z_UNICODE_BOX_DRAWINGS_DOWN_DOUBLE_AND_RIGHT_SINGLE		0x2553
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_DOWN_AND_RIGHT			0x2554
#define Z_UNICODE_BOX_DRAWINGS_DOWN_SINGLE_AND_LEFT_DOUBLE		0x2555
#define Z_UNICODE_BOX_DRAWINGS_DOWN_DOUBLE_AND_LEFT_SINGLE		0x2556
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_DOWN_AND_LEFT			0x2557
#define Z_UNICODE_BOX_DRAWINGS_UP_SINGLE_AND_RIGHT_DOUBLE		0x2558
#define Z_UNICODE_BOX_DRAWINGS_UP_DOUBLE_AND_RIGHT_SINGLE		0x2559
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_UP_AND_RIGHT			0x255A
#define Z_UNICODE_BOX_DRAWINGS_UP_SINGLE_AND_LEFT_DOUBLE		0x255B
#define Z_UNICODE_BOX_DRAWINGS_UP_DOUBLE_AND_LEFT_SINGLE		0x255C
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_UP_AND_LEFT			0x255D
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_SINGLE_AND_RIGHT_DOUBLE		0x255E
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_RIGHT_SINGLE		0x255F
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_RIGHT		0x2560
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_SINGLE_AND_LEFT_DOUBLE		0x2561
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_LEFT_SINGLE		0x2562
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_LEFT			0x2563
#define Z_UNICODE_BOX_DRAWINGS_DOWN_SINGLE_AND_HORIZONTAL_DOUBLE	0x2564
#define Z_UNICODE_BOX_DRAWINGS_DOWN_DOUBLE_AND_HORIZONTAL_SINGLE	0x2565
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_DOWN_AND_HORIZONTAL		0x2566
#define Z_UNICODE_BOX_DRAWINGS_UP_SINGLE_AND_HORIZONTAL_DOUBLE		0x2567
#define Z_UNICODE_BOX_DRAWINGS_UP_DOUBLE_AND_HORIZONTAL_SINGLE		0x2568
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_UP_AND_HORIZONTAL			0x2569
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_SINGLE_AND_HORIZONTAL_DOUBLE	0x256A
#define Z_UNICODE_BOX_DRAWINGS_VERTICAL_DOUBLE_AND_HORIZONTAL_SINGLE	0x256B
#define Z_UNICODE_BOX_DRAWINGS_DOUBLE_VERTICAL_AND_HORIZONTAL		0x256C
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_ARC_DOWN_AND_RIGHT			0x256D
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_ARC_DOWN_AND_LEFT			0x256E
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_ARC_UP_AND_LEFT			0x256F
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_ARC_UP_AND_RIGHT			0x2570
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_RIGHT_TO_LOWER_LEFT	0x2571
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DIAGONAL_UPPER_LEFT_TO_LOWER_RIGHT	0x2572
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DIAGONAL_CROSS			0x2573
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_LEFT				0x2574
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_UP					0x2575
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_RIGHT				0x2576
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_DOWN				0x2577
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_LEFT				0x2578
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_UP					0x2579
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_RIGHT				0x257A
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_DOWN				0x257B
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_LEFT_AND_HEAVY_RIGHT		0x257C
#define Z_UNICODE_BOX_DRAWINGS_LIGHT_UP_AND_HEAVY_DOWN			0x257D
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_LEFT_AND_LIGHT_RIGHT		0x257E
#define Z_UNICODE_BOX_DRAWINGS_HEAVY_UP_AND_LIGHT_DOWN			0x257F

/* MARK: - 2580h-259Fh - Block Elements */

#define Z_UNICODE_UPPER_HALF_BLOCK				      0x2580
#define Z_UNICODE_LOWER_ONE_EIGHTH_BLOCK			      0x2581
#define Z_UNICODE_LOWER_ONE_QUARTER_BLOCK			      0x2582
#define Z_UNICODE_LOWER_THREE_EIGHTHS_BLOCK			      0x2583
#define Z_UNICODE_LOWER_HALF_BLOCK				      0x2584
#define Z_UNICODE_LOWER_FIVE_EIGHTHS_BLOCK			      0x2585
#define Z_UNICODE_LOWER_THREE_QUARTERS_BLOCK			      0x2586
#define Z_UNICODE_LOWER_SEVEN_EIGHTHS_BLOCK			      0x2587
#define Z_UNICODE_FULL_BLOCK					      0x2588
#define Z_UNICODE_LEFT_SEVEN_EIGHTHS_BLOCK			      0x2589
#define Z_UNICODE_LEFT_THREE_QUARTERS_BLOCK			      0x258A
#define Z_UNICODE_LEFT_FIVE_EIGHTHS_BLOCK			      0x258B
#define Z_UNICODE_LEFT_HALF_BLOCK				      0x258C
#define Z_UNICODE_LEFT_THREE_EIGHTHS_BLOCK			      0x258D
#define Z_UNICODE_LEFT_ONE_QUARTER_BLOCK			      0x258E
#define Z_UNICODE_LEFT_ONE_EIGHTH_BLOCK				      0x258F
#define Z_UNICODE_RIGHT_HALF_BLOCK				      0x2590
#define Z_UNICODE_LIGHT_SHADE					      0x2591
#define Z_UNICODE_MEDIUM_SHADE					      0x2592
#define Z_UNICODE_DARK_SHADE					      0x2593
#define Z_UNICODE_UPPER_ONE_EIGHTH_BLOCK			      0x2594
#define Z_UNICODE_RIGHT_ONE_EIGHTH_BLOCK			      0x2595
#define Z_UNICODE_QUADRANT_LOWER_LEFT				      0x2596
#define Z_UNICODE_QUADRANT_LOWER_RIGHT				      0x2597
#define Z_UNICODE_QUADRANT_UPPER_LEFT				      0x2598
#define Z_UNICODE_QUADRANT_UPPER_LEFT_AND_LOWER_LEFT_AND_LOWER_RIGHT  0x2599
#define Z_UNICODE_QUADRANT_UPPER_LEFT_AND_LOWER_RIGHT		      0x259A
#define Z_UNICODE_QUADRANT_UPPER_LEFT_AND_UPPER_RIGHT_AND_LOWER_LEFT  0x259B
#define Z_UNICODE_QUADRANT_UPPER_LEFT_AND_UPPER_RIGHT_AND_LOWER_RIGHT 0x259C
#define Z_UNICODE_QUADRANT_UPPER_RIGHT				      0x259D
#define Z_UNICODE_QUADRANT_UPPER_RIGHT_AND_LOWER_LEFT		      0x259E
#define Z_UNICODE_QUADRANT_UPPER_RIGHT_AND_LOWER_LEFT_AND_LOWER_RIGHT 0x259F

/* MARK: - 25A0h-25FFh - Geometric Shapes */

#define Z_UNICODE_BLACK_SQUARE					0x25A0
#define Z_UNICODE_WHITE_SQUARE					0x25A1
#define Z_UNICODE_WHITE_SQUARE_WITH_ROUNDED_CORNERS		0x25A2
#define Z_UNICODE_WHITE_SQUARE_CONTAINING_BLACK_SMALL_SQUARE	0x25A3
#define Z_UNICODE_SQUARE_WITH_HORIZONTAL_FILL			0x25A4
#define Z_UNICODE_SQUARE_WITH_VERTICAL_FILL			0x25A5
#define Z_UNICODE_SQUARE_WITH_ORTHOGONAL_CROSSHATCH_FILL	0x25A6
#define Z_UNICODE_SQUARE_WITH_UPPER_LEFT_TO_LOWER_RIGHT_FILL	0x25A7
#define Z_UNICODE_SQUARE_WITH_UPPER_RIGHT_TO_LOWER_LEFT_FILL	0x25A8
#define Z_UNICODE_SQUARE_WITH_DIAGONAL_CROSSHATCH_FILL		0x25A9
#define Z_UNICODE_BLACK_SMALL_SQUARE				0x25AA
#define Z_UNICODE_WHITE_SMALL_SQUARE				0x25AB
#define Z_UNICODE_BLACK_RECTANGLE				0x25AC
#define Z_UNICODE_WHITE_RECTANGLE				0x25AD
#define Z_UNICODE_BLACK_VERTICAL_RECTANGLE			0x25AE
#define Z_UNICODE_WHITE_VERTICAL_RECTANGLE			0x25AF
#define Z_UNICODE_BLACK_PARALLELOGRAM				0x25B0
#define Z_UNICODE_WHITE_PARALLELOGRAM				0x25B1
#define Z_UNICODE_BLACK_UP_POINTING_TRIANGLE			0x25B2
#define Z_UNICODE_WHITE_UP_POINTING_TRIANGLE			0x25B3
#define Z_UNICODE_BLACK_UP_POINTING_SMALL_TRIANGLE		0x25B4
#define Z_UNICODE_WHITE_UP_POINTING_SMALL_TRIANGLE		0x25B5
#define Z_UNICODE_BLACK_RIGHT_POINTING_TRIANGLE			0x25B6
#define Z_UNICODE_WHITE_RIGHT_POINTING_TRIANGLE			0x25B7
#define Z_UNICODE_BLACK_RIGHT_POINTING_SMALL_TRIANGLE		0x25B8
#define Z_UNICODE_WHITE_RIGHT_POINTING_SMALL_TRIANGLE		0x25B9
#define Z_UNICODE_BLACK_RIGHT_POINTING_POINTER			0x25BA
#define Z_UNICODE_WHITE_RIGHT_POINTING_POINTER			0x25BB
#define Z_UNICODE_BLACK_DOWN_POINTING_TRIANGLE			0x25BC
#define Z_UNICODE_WHITE_DOWN_POINTING_TRIANGLE			0x25BD
#define Z_UNICODE_BLACK_DOWN_POINTING_SMALL_TRIANGLE		0x25BE
#define Z_UNICODE_WHITE_DOWN_POINTING_SMALL_TRIANGLE		0x25BF
#define Z_UNICODE_BLACK_LEFT_POINTING_TRIANGLE			0x25C0
#define Z_UNICODE_WHITE_LEFT_POINTING_TRIANGLE			0x25C1
#define Z_UNICODE_BLACK_LEFT_POINTING_SMALL_TRIANGLE		0x25C2
#define Z_UNICODE_WHITE_LEFT_POINTING_SMALL_TRIANGLE		0x25C3
#define Z_UNICODE_BLACK_LEFT_POINTING_POINTER			0x25C4
#define Z_UNICODE_WHITE_LEFT_POINTING_POINTER			0x25C5
#define Z_UNICODE_BLACK_DIAMOND					0x25C6
#define Z_UNICODE_WHITE_DIAMOND					0x25C7
#define Z_UNICODE_WHITE_DIAMOND_CONTAINING_BLACK_SMALL_DIAMOND	0x25C8
#define Z_UNICODE_FISHEYE					0x25C9
#define Z_UNICODE_LOZENGE					0x25CA
#define Z_UNICODE_WHITE_CIRCLE					0x25CB
#define Z_UNICODE_DOTTED_CIRCLE					0x25CC
#define Z_UNICODE_CIRCLE_WITH_VERTICAL_FILL			0x25CD
#define Z_UNICODE_BULLSEYE					0x25CE
#define Z_UNICODE_BLACK_CIRCLE					0x25CF
#define Z_UNICODE_CIRCLE_WITH_LEFT_HALF_BLACK			0x25D0
#define Z_UNICODE_CIRCLE_WITH_RIGHT_HALF_BLACK			0x25D1
#define Z_UNICODE_CIRCLE_WITH_LOWER_HALF_BLACK			0x25D2
#define Z_UNICODE_CIRCLE_WITH_UPPER_HALF_BLACK			0x25D3
#define Z_UNICODE_CIRCLE_WITH_UPPER_RIGHT_QUADRANT_BLACK	0x25D4
#define Z_UNICODE_CIRCLE_WITH_ALL_BUT_UPPER_LEFT_QUADRANT_BLACK	0x25D5
#define Z_UNICODE_LEFT_HALF_BLACK_CIRCLE			0x25D6
#define Z_UNICODE_RIGHT_HALF_BLACK_CIRCLE			0x25D7
#define Z_UNICODE_INVERSE_BULLET				0x25D8
#define Z_UNICODE_INVERSE_WHITE_CIRCLE				0x25D9
#define Z_UNICODE_UPPER_HALF_INVERSE_WHITE_CIRCLE		0x25DA
#define Z_UNICODE_LOWER_HALF_INVERSE_WHITE_CIRCLE		0x25DB
#define Z_UNICODE_UPPER_LEFT_QUADRANT_CIRCULAR_ARC		0x25DC
#define Z_UNICODE_UPPER_RIGHT_QUADRANT_CIRCULAR_ARC		0x25DD
#define Z_UNICODE_LOWER_RIGHT_QUADRANT_CIRCULAR_ARC		0x25DE
#define Z_UNICODE_LOWER_LEFT_QUADRANT_CIRCULAR_ARC		0x25DF
#define Z_UNICODE_UPPER_HALF_CIRCLE				0x25E0
#define Z_UNICODE_LOWER_HALF_CIRCLE				0x25E1
#define Z_UNICODE_BLACK_LOWER_RIGHT_TRIANGLE			0x25E2
#define Z_UNICODE_BLACK_LOWER_LEFT_TRIANGLE			0x25E3
#define Z_UNICODE_BLACK_UPPER_LEFT_TRIANGLE			0x25E4
#define Z_UNICODE_BLACK_UPPER_RIGHT_TRIANGLE			0x25E5
#define Z_UNICODE_WHITE_BULLET					0x25E6
#define Z_UNICODE_SQUARE_WITH_LEFT_HALF_BLACK			0x25E7
#define Z_UNICODE_SQUARE_WITH_RIGHT_HALF_BLACK			0x25E8
#define Z_UNICODE_SQUARE_WITH_UPPER_LEFT_DIAGONAL_HALF_BLACK	0x25E9
#define Z_UNICODE_SQUARE_WITH_LOWER_RIGHT_DIAGONAL_HALF_BLACK	0x25EA
#define Z_UNICODE_WHITE_SQUARE_WITH_VERTICAL_BISECTING_LINE	0x25EB
#define Z_UNICODE_WHITE_UP_POINTING_TRIANGLE_WITH_DOT		0x25EC
#define Z_UNICODE_UP_POINTING_TRIANGLE_WITH_LEFT_HALF_BLACK	0x25ED
#define Z_UNICODE_UP_POINTING_TRIANGLE_WITH_RIGHT_HALF_BLACK	0x25EE
#define Z_UNICODE_LARGE_CIRCLE					0x25EF
#define Z_UNICODE_WHITE_SQUARE_WITH_UPPER_LEFT_QUADRANT		0x25F0
#define Z_UNICODE_WHITE_SQUARE_WITH_LOWER_LEFT_QUADRANT		0x25F1
#define Z_UNICODE_WHITE_SQUARE_WITH_LOWER_RIGHT_QUADRANT	0x25F2
#define Z_UNICODE_WHITE_SQUARE_WITH_UPPER_RIGHT_QUADRANT	0x25F3
#define Z_UNICODE_WHITE_CIRCLE_WITH_UPPER_LEFT_QUADRANT		0x25F4
#define Z_UNICODE_WHITE_CIRCLE_WITH_LOWER_LEFT_QUADRANT		0x25F5
#define Z_UNICODE_WHITE_CIRCLE_WITH_LOWER_RIGHT_QUADRANT	0x25F6
#define Z_UNICODE_WHITE_CIRCLE_WITH_UPPER_RIGHT_QUADRANT	0x25F7
#define Z_UNICODE_UPPER_LEFT_TRIANGLE				0x25F8
#define Z_UNICODE_UPPER_RIGHT_TRIANGLE				0x25F9
#define Z_UNICODE_LOWER_LEFT_TRIANGLE				0x25FA
#define Z_UNICODE_WHITE_MEDIUM_SQUARE				0x25FB
#define Z_UNICODE_BLACK_MEDIUM_SQUARE				0x25FC
#define Z_UNICODE_WHITE_MEDIUM_SMALL_SQUARE			0x25FD
#define Z_UNICODE_BLACK_MEDIUM_SMALL_SQUARE			0x25FE
#define Z_UNICODE_LOWER_RIGHT_TRIANGLE				0x25FF

/* MARK: - 2600h-26FFh - Miscellaneous Symbols */

#define Z_UNICODE_BLACK_SUN_WITH_RAYS				   0x2600
#define Z_UNICODE_CLOUD						   0x2601
#define Z_UNICODE_UMBRELLA					   0x2602
#define Z_UNICODE_SNOWMAN					   0x2603
#define Z_UNICODE_COMET						   0x2604
#define Z_UNICODE_BLACK_STAR					   0x2605
#define Z_UNICODE_WHITE_STAR					   0x2606
#define Z_UNICODE_LIGHTNING					   0x2607
#define Z_UNICODE_THUNDERSTORM					   0x2608
#define Z_UNICODE_SUN						   0x2609
#define Z_UNICODE_ASCENDING_NODE				   0x260A
#define Z_UNICODE_DESCENDING_NODE				   0x260B
#define Z_UNICODE_CONJUNCTION					   0x260C
#define Z_UNICODE_OPPOSITION					   0x260D
#define Z_UNICODE_BLACK_TELEPHONE				   0x260E
#define Z_UNICODE_WHITE_TELEPHONE				   0x260F
#define Z_UNICODE_BALLOT_BOX					   0x2610
#define Z_UNICODE_BALLOT_BOX_WITH_CHECK				   0x2611
#define Z_UNICODE_BALLOT_BOX_WITH_X				   0x2612
#define Z_UNICODE_SALTIRE					   0x2613
#define Z_UNICODE_UMBRELLA_WITH_RAIN_DROPS			   0x2614
#define Z_UNICODE_HOT_BEVERAGE					   0x2615
#define Z_UNICODE_WHITE_SHOGI_PIECE				   0x2616
#define Z_UNICODE_BLACK_SHOGI_PIECE				   0x2617
#define Z_UNICODE_SHAMROCK					   0x2618
#define Z_UNICODE_REVERSED_ROTATED_FLORAL_HEART_BULLET		   0x2619
#define Z_UNICODE_BLACK_LEFT_POINTING_INDEX			   0x261A
#define Z_UNICODE_BLACK_RIGHT_POINTING_INDEX			   0x261B
#define Z_UNICODE_WHITE_LEFT_POINTING_INDEX			   0x261C
#define Z_UNICODE_WHITE_UP_POINTING_INDEX			   0x261D
#define Z_UNICODE_WHITE_RIGHT_POINTING_INDEX			   0x261E
#define Z_UNICODE_WHITE_DOWN_POINTING_INDEX			   0x261F
#define Z_UNICODE_SKULL_AND_CROSSBONES				   0x2620
#define Z_UNICODE_CAUTION_SIGN					   0x2621
#define Z_UNICODE_RADIOACTIVE_SIGN				   0x2622
#define Z_UNICODE_BIOHAZARD_SIGN				   0x2623
#define Z_UNICODE_CADUCEUS					   0x2624
#define Z_UNICODE_ANKH						   0x2625
#define Z_UNICODE_ORTHODOX_CROSS				   0x2626
#define Z_UNICODE_CHI_RHO					   0x2627
#define Z_UNICODE_CROSS_OF_LORRAINE				   0x2628
#define Z_UNICODE_CROSS_OF_JERUSALEM				   0x2629
#define Z_UNICODE_STAR_AND_CRESCENT				   0x262A
#define Z_UNICODE_FARSI_SYMBOL					   0x262B
#define Z_UNICODE_ADI_SHAKTI					   0x262C
#define Z_UNICODE_HAMMER_AND_SICKLE				   0x262D
#define Z_UNICODE_PEACE_SYMBOL					   0x262E
#define Z_UNICODE_YIN_YANG					   0x262F
#define Z_UNICODE_TRIGRAM_FOR_HEAVEN				   0x2630
#define Z_UNICODE_TRIGRAM_FOR_LAKE				   0x2631
#define Z_UNICODE_TRIGRAM_FOR_FIRE				   0x2632
#define Z_UNICODE_TRIGRAM_FOR_THUNDER				   0x2633
#define Z_UNICODE_TRIGRAM_FOR_WIND				   0x2634
#define Z_UNICODE_TRIGRAM_FOR_WATER				   0x2635
#define Z_UNICODE_TRIGRAM_FOR_MOUNTAIN				   0x2636
#define Z_UNICODE_TRIGRAM_FOR_EARTH				   0x2637
#define Z_UNICODE_WHEEL_OF_DHARMA				   0x2638
#define Z_UNICODE_WHITE_FROWNING_FACE				   0x2639
#define Z_UNICODE_WHITE_SMILING_FACE				   0x263A
#define Z_UNICODE_BLACK_SMILING_FACE				   0x263B
#define Z_UNICODE_WHITE_SUN_WITH_RAYS				   0x263C
#define Z_UNICODE_FIRST_QUARTER_MOON				   0x263D
#define Z_UNICODE_LAST_QUARTER_MOON				   0x263E
#define Z_UNICODE_MERCURY					   0x263F
#define Z_UNICODE_FEMALE_SIGN					   0x2640
#define Z_UNICODE_EARTH						   0x2641
#define Z_UNICODE_MALE_SIGN					   0x2642
#define Z_UNICODE_JUPITER					   0x2643
#define Z_UNICODE_SATURN					   0x2644
#define Z_UNICODE_URANUS					   0x2645
#define Z_UNICODE_NEPTUNE					   0x2646
#define Z_UNICODE_PLUTO						   0x2647
#define Z_UNICODE_ARIES						   0x2648
#define Z_UNICODE_TAURUS					   0x2649
#define Z_UNICODE_GEMINI					   0x264A
#define Z_UNICODE_CANCER					   0x264B
#define Z_UNICODE_LEO						   0x264C
#define Z_UNICODE_VIRGO						   0x264D
#define Z_UNICODE_LIBRA						   0x264E
#define Z_UNICODE_SCORPIUS					   0x264F
#define Z_UNICODE_SAGITTARIUS					   0x2650
#define Z_UNICODE_CAPRICORN					   0x2651
#define Z_UNICODE_AQUARIUS					   0x2652
#define Z_UNICODE_PISCES					   0x2653
#define Z_UNICODE_WHITE_CHESS_KING				   0x2654
#define Z_UNICODE_WHITE_CHESS_QUEEN				   0x2655
#define Z_UNICODE_WHITE_CHESS_ROOK				   0x2656
#define Z_UNICODE_WHITE_CHESS_BISHOP				   0x2657
#define Z_UNICODE_WHITE_CHESS_KNIGHT				   0x2658
#define Z_UNICODE_WHITE_CHESS_PAWN				   0x2659
#define Z_UNICODE_BLACK_CHESS_KING				   0x265A
#define Z_UNICODE_BLACK_CHESS_QUEEN				   0x265B
#define Z_UNICODE_BLACK_CHESS_ROOK				   0x265C
#define Z_UNICODE_BLACK_CHESS_BISHOP				   0x265D
#define Z_UNICODE_BLACK_CHESS_KNIGHT				   0x265E
#define Z_UNICODE_BLACK_CHESS_PAWN				   0x265F
#define Z_UNICODE_BLACK_SPADE_SUIT				   0x2660
#define Z_UNICODE_WHITE_HEART_SUIT				   0x2661
#define Z_UNICODE_WHITE_DIAMOND_SUIT				   0x2662
#define Z_UNICODE_BLACK_CLUB_SUIT				   0x2663
#define Z_UNICODE_WHITE_SPADE_SUIT				   0x2664
#define Z_UNICODE_BLACK_HEART_SUIT				   0x2665
#define Z_UNICODE_BLACK_DIAMOND_SUIT				   0x2666
#define Z_UNICODE_WHITE_CLUB_SUIT				   0x2667
#define Z_UNICODE_HOT_SPRINGS					   0x2668
#define Z_UNICODE_QUARTER_NOTE					   0x2669
#define Z_UNICODE_EIGHTH_NOTE					   0x266A
#define Z_UNICODE_BEAMED_EIGHTH_NOTES				   0x266B
#define Z_UNICODE_BEAMED_SIXTEENTH_NOTES			   0x266C
#define Z_UNICODE_MUSIC_FLAT_SIGN				   0x266D
#define Z_UNICODE_MUSIC_NATURAL_SIGN				   0x266E
#define Z_UNICODE_MUSIC_SHARP_SIGN				   0x266F
#define Z_UNICODE_WEST_SYRIAC_CROSS				   0x2670
#define Z_UNICODE_EAST_SYRIAC_CROSS				   0x2671
#define Z_UNICODE_UNIVERSAL_RECYCLING_SYMBOL			   0x2672
#define Z_UNICODE_RECYCLING_SYMBOL_FOR_TYPE_1_PLASTICS		   0x2673
#define Z_UNICODE_RECYCLING_SYMBOL_FOR_TYPE_2_PLASTICS		   0x2674
#define Z_UNICODE_RECYCLING_SYMBOL_FOR_TYPE_3_PLASTICS		   0x2675
#define Z_UNICODE_RECYCLING_SYMBOL_FOR_TYPE_4_PLASTICS		   0x2676
#define Z_UNICODE_RECYCLING_SYMBOL_FOR_TYPE_5_PLASTICS		   0x2677
#define Z_UNICODE_RECYCLING_SYMBOL_FOR_TYPE_6_PLASTICS		   0x2678
#define Z_UNICODE_RECYCLING_SYMBOL_FOR_TYPE_7_PLASTICS		   0x2679
#define Z_UNICODE_RECYCLING_SYMBOL_FOR_GENERIC_MATERIALS	   0x267A
#define Z_UNICODE_BLACK_UNIVERSAL_RECYCLING_SYMBOL		   0x267B
#define Z_UNICODE_RECYCLED_PAPER_SYMBOL				   0x267C
#define Z_UNICODE_PARTIALLY_RECYCLED_PAPER_SYMBOL		   0x267D
#define Z_UNICODE_PERMANENT_PAPER_SIGN				   0x267E
#define Z_UNICODE_WHEELCHAIR_SYMBOL				   0x267F
#define Z_UNICODE_DIE_FACE_1					   0x2680
#define Z_UNICODE_DIE_FACE_2					   0x2681
#define Z_UNICODE_DIE_FACE_3					   0x2682
#define Z_UNICODE_DIE_FACE_4					   0x2683
#define Z_UNICODE_DIE_FACE_5					   0x2684
#define Z_UNICODE_DIE_FACE_6					   0x2685
#define Z_UNICODE_WHITE_CIRCLE_WITH_DOT_RIGHT			   0x2686
#define Z_UNICODE_WHITE_CIRCLE_WITH_TWO_DOTS			   0x2687
#define Z_UNICODE_BLACK_CIRCLE_WITH_WHITE_DOT_RIGHT		   0x2688
#define Z_UNICODE_BLACK_CIRCLE_WITH_TWO_WHITE_DOTS		   0x2689
#define Z_UNICODE_MONOGRAM_FOR_YANG				   0x268A
#define Z_UNICODE_MONOGRAM_FOR_YIN				   0x268B
#define Z_UNICODE_DIGRAM_FOR_GREATER_YANG			   0x268C
#define Z_UNICODE_DIGRAM_FOR_LESSER_YIN				   0x268D
#define Z_UNICODE_DIGRAM_FOR_LESSER_YANG			   0x268E
#define Z_UNICODE_DIGRAM_FOR_GREATER_YIN			   0x268F
#define Z_UNICODE_WHITE_FLAG					   0x2690
#define Z_UNICODE_BLACK_FLAG					   0x2691
#define Z_UNICODE_HAMMER_AND_PICK				   0x2692
#define Z_UNICODE_ANCHOR					   0x2693
#define Z_UNICODE_CROSSED_SWORDS				   0x2694
#define Z_UNICODE_STAFF_OF_AESCULAPIUS				   0x2695
#define Z_UNICODE_SCALES					   0x2696
#define Z_UNICODE_ALEMBIC					   0x2697
#define Z_UNICODE_FLOWER					   0x2698
#define Z_UNICODE_GEAR						   0x2699
#define Z_UNICODE_STAFF_OF_HERMES				   0x269A
#define Z_UNICODE_ATOM_SYMBOL					   0x269B
#define Z_UNICODE_FLEUR_DE_LIS					   0x269C
#define Z_UNICODE_OUTLINED_WHITE_STAR				   0x269D
#define Z_UNICODE_THREE_LINES_CONVERGING_RIGHT			   0x269E
#define Z_UNICODE_THREE_LINES_CONVERGING_LEFT			   0x269F
#define Z_UNICODE_WARNING_SIGN					   0x26A0
#define Z_UNICODE_HIGH_VOLTAGE_SIGN				   0x26A1
#define Z_UNICODE_DOUBLED_FEMALE_SIGN				   0x26A2
#define Z_UNICODE_DOUBLED_MALE_SIGN				   0x26A3
#define Z_UNICODE_INTERLOCKED_FEMALE_AND_MALE_SIGN		   0x26A4
#define Z_UNICODE_MALE_AND_FEMALE_SIGN				   0x26A5
#define Z_UNICODE_MALE_WITH_STROKE_SIGN				   0x26A6
#define Z_UNICODE_MALE_WITH_STROKE_AND_MALE_AND_FEMALE_SIGN	   0x26A7
#define Z_UNICODE_VERTICAL_MALE_WITH_STROKE_SIGN		   0x26A8
#define Z_UNICODE_HORIZONTAL_MALE_WITH_STROKE_SIGN		   0x26A9
#define Z_UNICODE_MEDIUM_WHITE_CIRCLE				   0x26AA
#define Z_UNICODE_MEDIUM_BLACK_CIRCLE				   0x26AB
#define Z_UNICODE_MEDIUM_SMALL_WHITE_CIRCLE			   0x26AC
#define Z_UNICODE_MARRIAGE_SYMBOL				   0x26AD
#define Z_UNICODE_DIVORCE_SYMBOL				   0x26AE
#define Z_UNICODE_UNMARRIED_PARTNERSHIP_SYMBOL			   0x26AF
#define Z_UNICODE_COFFIN					   0x26B0
#define Z_UNICODE_FUNERAL_URN					   0x26B1
#define Z_UNICODE_NEUTER					   0x26B2
#define Z_UNICODE_CERES						   0x26B3
#define Z_UNICODE_PALLAS					   0x26B4
#define Z_UNICODE_JUNO						   0x26B5
#define Z_UNICODE_VESTA						   0x26B6
#define Z_UNICODE_CHIRON					   0x26B7
#define Z_UNICODE_BLACK_MOON_LILITH				   0x26B8
#define Z_UNICODE_SEXTILE					   0x26B9
#define Z_UNICODE_SEMISEXTILE					   0x26BA
#define Z_UNICODE_QUINCUNX					   0x26BB
#define Z_UNICODE_SESQUIQUADRATE				   0x26BC
#define Z_UNICODE_SOCCER_BALL					   0x26BD
#define Z_UNICODE_BASEBALL					   0x26BE
#define Z_UNICODE_SQUARED_KEY					   0x26BF
#define Z_UNICODE_WHITE_DRAUGHTS_MAN				   0x26C0
#define Z_UNICODE_WHITE_DRAUGHTS_KING				   0x26C1
#define Z_UNICODE_BLACK_DRAUGHTS_MAN				   0x26C2
#define Z_UNICODE_BLACK_DRAUGHTS_KING				   0x26C3
#define Z_UNICODE_SNOWMAN_WITHOUT_SNOW				   0x26C4
#define Z_UNICODE_SUN_BEHIND_CLOUD				   0x26C5
#define Z_UNICODE_RAIN						   0x26C6
#define Z_UNICODE_BLACK_SNOWMAN					   0x26C7
#define Z_UNICODE_THUNDER_CLOUD_AND_RAIN			   0x26C8
#define Z_UNICODE_TURNED_WHITE_SHOGI_PIECE			   0x26C9
#define Z_UNICODE_TURNED_BLACK_SHOGI_PIECE			   0x26CA
#define Z_UNICODE_WHITE_DIAMOND_IN_SQUARE			   0x26CB
#define Z_UNICODE_CROSSING_LANES				   0x26CC
#define Z_UNICODE_DISABLED_CAR					   0x26CD
#define Z_UNICODE_OPHIUCHUS					   0x26CE
#define Z_UNICODE_PICK						   0x26CF
#define Z_UNICODE_CAR_SLIDING					   0x26D0
#define Z_UNICODE_HELMET_WITH_WHITE_CROSS			   0x26D1
#define Z_UNICODE_CIRCLED_CROSSING_LANES			   0x26D2
#define Z_UNICODE_CHAINS					   0x26D3
#define Z_UNICODE_NO_ENTRY					   0x26D4
#define Z_UNICODE_ALTERNATE_ONE_WAY_LEFT_WAY_TRAFFIC		   0x26D5
#define Z_UNICODE_BLACK_TWO_WAY_LEFT_WAY_TRAFFIC		   0x26D6
#define Z_UNICODE_WHITE_TWO_WAY_LEFT_WAY_TRAFFIC		   0x26D7
#define Z_UNICODE_BLACK_LEFT_LANE_MERGE				   0x26D8
#define Z_UNICODE_WHITE_LEFT_LANE_MERGE				   0x26D9
#define Z_UNICODE_DRIVE_SLOW_SIGN				   0x26DA
#define Z_UNICODE_HEAVY_WHITE_DOWN_POINTING_TRIANGLE		   0x26DB
#define Z_UNICODE_LEFT_CLOSED_ENTRY				   0x26DC
#define Z_UNICODE_SQUARED_SALTIRE				   0x26DD
#define Z_UNICODE_FALLING_DIAGONAL_IN_WHITE_CIRCLE_IN_BLACK_SQUARE 0x26DE
#define Z_UNICODE_BLACK_TRUCK					   0x26DF
#define Z_UNICODE_RESTRICTED_LEFT_ENTRY_1			   0x26E0
#define Z_UNICODE_RESTRICTED_LEFT_ENTRY_2			   0x26E1
#define Z_UNICODE_ASTRONOMICAL_SYMBOL_FOR_URANUS		   0x26E2
#define Z_UNICODE_HEAVY_CIRCLE_WITH_STROKE_AND_TWO_DOTS_ABOVE	   0x26E3
#define Z_UNICODE_PENTAGRAM					   0x26E4
#define Z_UNICODE_RIGHT_HANDED_INTERLACED_PENTAGRAM		   0x26E5
#define Z_UNICODE_LEFT_HANDED_INTERLACED_PENTAGRAM		   0x26E6
#define Z_UNICODE_INVERTED_PENTAGRAM				   0x26E7
#define Z_UNICODE_BLACK_CROSS_ON_SHIELD				   0x26E8
#define Z_UNICODE_SHINTO_SHRINE					   0x26E9
#define Z_UNICODE_CHURCH					   0x26EA
#define Z_UNICODE_CASTLE					   0x26EB
#define Z_UNICODE_HISTORIC_SITE					   0x26EC
#define Z_UNICODE_GEAR_WITHOUT_HUB				   0x26ED
#define Z_UNICODE_GEAR_WITH_HANDLES				   0x26EE
#define Z_UNICODE_MAP_SYMBOL_FOR_LIGHTHOUSE			   0x26EF
#define Z_UNICODE_MOUNTAIN					   0x26F0
#define Z_UNICODE_UMBRELLA_ON_GROUND				   0x26F1
#define Z_UNICODE_FOUNTAIN					   0x26F2
#define Z_UNICODE_FLAG_IN_HOLE					   0x26F3
#define Z_UNICODE_FERRY						   0x26F4
#define Z_UNICODE_SAILBOAT					   0x26F5
#define Z_UNICODE_SQUARE_FOUR_CORNERS				   0x26F6
#define Z_UNICODE_SKIER						   0x26F7
#define Z_UNICODE_ICE_SKATE					   0x26F8
#define Z_UNICODE_PERSON_WITH_BALL				   0x26F9
#define Z_UNICODE_TENT						   0x26FA
#define Z_UNICODE_JAPANESE_BANK_SYMBOL				   0x26FB
#define Z_UNICODE_HEADSTONE_GRAVEYARD_SYMBOL			   0x26FC
#define Z_UNICODE_FUEL_PUMP					   0x26FD
#define Z_UNICODE_CUP_ON_BLACK_SQUARE				   0x26FE
#define Z_UNICODE_WHITE_FLAG_WITH_HORIZONTAL_MIDDLE_BLACK_STRIPE   0x26FF

/* MARK: - 2700h-27BFh - Dingbats */

#define Z_UNICODE_BLACK_SAFETY_SCISSORS				      0x2700
#define Z_UNICODE_UPPER_BLADE_SCISSORS				      0x2701
#define Z_UNICODE_BLACK_SCISSORS				      0x2702
#define Z_UNICODE_LOWER_BLADE_SCISSORS				      0x2703
#define Z_UNICODE_WHITE_SCISSORS				      0x2704
#define Z_UNICODE_WHITE_HEAVY_CHECK_MARK			      0x2705
#define Z_UNICODE_TELEPHONE_LOCATION_SIGN			      0x2706
#define Z_UNICODE_TAPE_DRIVE					      0x2707
#define Z_UNICODE_AIRPLANE					      0x2708
#define Z_UNICODE_ENVELOPE					      0x2709
#define Z_UNICODE_RAISED_FIST					      0x270A
#define Z_UNICODE_RAISED_HAND					      0x270B
#define Z_UNICODE_VICTORY_HAND					      0x270C
#define Z_UNICODE_WRITING_HAND					      0x270D
#define Z_UNICODE_LOWER_RIGHT_PENCIL				      0x270E
#define Z_UNICODE_PENCIL					      0x270F
#define Z_UNICODE_UPPER_RIGHT_PENCIL				      0x2710
#define Z_UNICODE_WHITE_NIB					      0x2711
#define Z_UNICODE_BLACK_NIB					      0x2712
#define Z_UNICODE_CHECK_MARK					      0x2713
#define Z_UNICODE_HEAVY_CHECK_MARK				      0x2714
#define Z_UNICODE_MULTIPLICATION_X				      0x2715
#define Z_UNICODE_HEAVY_MULTIPLICATION_X			      0x2716
#define Z_UNICODE_BALLOT_X					      0x2717
#define Z_UNICODE_HEAVY_BALLOT_X				      0x2718
#define Z_UNICODE_OUTLINED_GREEK_CROSS				      0x2719
#define Z_UNICODE_HEAVY_GREEK_CROSS				      0x271A
#define Z_UNICODE_OPEN_CENTRE_CROSS				      0x271B
#define Z_UNICODE_HEAVY_OPEN_CENTRE_CROSS			      0x271C
#define Z_UNICODE_LATIN_CROSS					      0x271D
#define Z_UNICODE_SHADOWED_WHITE_LATIN_CROSS			      0x271E
#define Z_UNICODE_OUTLINED_LATIN_CROSS				      0x271F
#define Z_UNICODE_MALTESE_CROSS					      0x2720
#define Z_UNICODE_STAR_OF_DAVID					      0x2721
#define Z_UNICODE_FOUR_TEARDROP_SPOKED_ASTERISK			      0x2722
#define Z_UNICODE_FOUR_BALLOON_SPOKED_ASTERISK			      0x2723
#define Z_UNICODE_HEAVY_FOUR_BALLOON_SPOKED_ASTERISK		      0x2724
#define Z_UNICODE_FOUR_CLUB_SPOKED_ASTERISK			      0x2725
#define Z_UNICODE_BLACK_FOUR_POINTED_STAR			      0x2726
#define Z_UNICODE_WHITE_FOUR_POINTED_STAR			      0x2727
#define Z_UNICODE_SPARKLES					      0x2728
#define Z_UNICODE_STRESS_OUTLINED_WHITE_STAR			      0x2729
#define Z_UNICODE_CIRCLED_WHITE_STAR				      0x272A
#define Z_UNICODE_OPEN_CENTRE_BLACK_STAR			      0x272B
#define Z_UNICODE_BLACK_CENTRE_WHITE_STAR			      0x272C
#define Z_UNICODE_OUTLINED_BLACK_STAR				      0x272D
#define Z_UNICODE_HEAVY_OUTLINED_BLACK_STAR			      0x272E
#define Z_UNICODE_PINWHEEL_STAR					      0x272F
#define Z_UNICODE_SHADOWED_WHITE_STAR				      0x2730
#define Z_UNICODE_HEAVY_ASTERISK				      0x2731
#define Z_UNICODE_OPEN_CENTRE_ASTERISK				      0x2732
#define Z_UNICODE_EIGHT_SPOKED_ASTERISK				      0x2733
#define Z_UNICODE_EIGHT_POINTED_BLACK_STAR			      0x2734
#define Z_UNICODE_EIGHT_POINTED_PINWHEEL_STAR			      0x2735
#define Z_UNICODE_SIX_POINTED_BLACK_STAR			      0x2736
#define Z_UNICODE_EIGHT_POINTED_RECTILINEAR_BLACK_STAR		      0x2737
#define Z_UNICODE_HEAVY_EIGHT_POINTED_RECTILINEAR_BLACK_STAR	      0x2738
#define Z_UNICODE_TWELVE_POINTED_BLACK_STAR			      0x2739
#define Z_UNICODE_SIXTEEN_POINTED_ASTERISK			      0x273A
#define Z_UNICODE_TEARDROP_SPOKED_ASTERISK			      0x273B
#define Z_UNICODE_OPEN_CENTRE_TEARDROP_SPOKED_ASTERISK		      0x273C
#define Z_UNICODE_HEAVY_TEARDROP_SPOKED_ASTERISK		      0x273D
#define Z_UNICODE_SIX_PETALLED_BLACK_AND_WHITE_FLORETTE		      0x273E
#define Z_UNICODE_BLACK_FLORETTE				      0x273F
#define Z_UNICODE_WHITE_FLORETTE				      0x2740
#define Z_UNICODE_EIGHT_PETALLED_OUTLINED_BLACK_FLORETTE	      0x2741
#define Z_UNICODE_CIRCLED_OPEN_CENTRE_EIGHT_POINTED_STAR	      0x2742
#define Z_UNICODE_HEAVY_TEARDROP_SPOKED_PINWHEEL_ASTERISK	      0x2743
#define Z_UNICODE_SNOWFLAKE					      0x2744
#define Z_UNICODE_TIGHT_TRIFOLIATE_SNOWFLAKE			      0x2745
#define Z_UNICODE_HEAVY_CHEVRON_SNOWFLAKE			      0x2746
#define Z_UNICODE_SPARKLE					      0x2747
#define Z_UNICODE_HEAVY_SPARKLE					      0x2748
#define Z_UNICODE_BALLOON_SPOKED_ASTERISK			      0x2749
#define Z_UNICODE_EIGHT_TEARDROP_SPOKED_PROPELLER_ASTERISK	      0x274A
#define Z_UNICODE_HEAVY_EIGHT_TEARDROP_SPOKED_PROPELLER_ASTERISK      0x274B
#define Z_UNICODE_CROSS_MARK					      0x274C
#define Z_UNICODE_SHADOWED_WHITE_CIRCLE				      0x274D
#define Z_UNICODE_NEGATIVE_SQUARED_CROSS_MARK			      0x274E
#define Z_UNICODE_LOWER_RIGHT_DROP_SHADOWED_WHITE_SQUARE	      0x274F
#define Z_UNICODE_UPPER_RIGHT_DROP_SHADOWED_WHITE_SQUARE	      0x2750
#define Z_UNICODE_LOWER_RIGHT_SHADOWED_WHITE_SQUARE		      0x2751
#define Z_UNICODE_UPPER_RIGHT_SHADOWED_WHITE_SQUARE		      0x2752
#define Z_UNICODE_BLACK_QUESTION_MARK_ORNAMENT			      0x2753
#define Z_UNICODE_WHITE_QUESTION_MARK_ORNAMENT			      0x2754
#define Z_UNICODE_WHITE_EXCLAMATION_MARK_ORNAMENT		      0x2755
#define Z_UNICODE_BLACK_DIAMOND_MINUS_WHITE_X			      0x2756
#define Z_UNICODE_HEAVY_EXCLAMATION_MARK_SYMBOL			      0x2757
#define Z_UNICODE_LIGHT_VERTICAL_BAR				      0x2758
#define Z_UNICODE_MEDIUM_VERTICAL_BAR				      0x2759
#define Z_UNICODE_HEAVY_VERTICAL_BAR				      0x275A
#define Z_UNICODE_HEAVY_SINGLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT   0x275B
#define Z_UNICODE_HEAVY_SINGLE_COMMA_QUOTATION_MARK_ORNAMENT	      0x275C
#define Z_UNICODE_HEAVY_DOUBLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT   0x275D
#define Z_UNICODE_HEAVY_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT	      0x275E
#define Z_UNICODE_HEAVY_LOW_SINGLE_COMMA_QUOTATION_MARK_ORNAMENT      0x275F
#define Z_UNICODE_HEAVY_LOW_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT      0x2760
#define Z_UNICODE_CURVED_STEM_PARAGRAPH_SIGN_ORNAMENT		      0x2761
#define Z_UNICODE_HEAVY_EXCLAMATION_MARK_ORNAMENT		      0x2762
#define Z_UNICODE_HEAVY_HEART_EXCLAMATION_MARK_ORNAMENT		      0x2763
#define Z_UNICODE_HEAVY_BLACK_HEART				      0x2764
#define Z_UNICODE_ROTATED_HEAVY_BLACK_HEART_BULLET		      0x2765
#define Z_UNICODE_FLORAL_HEART					      0x2766
#define Z_UNICODE_ROTATED_FLORAL_HEART_BULLET			      0x2767
#define Z_UNICODE_MEDIUM_LEFT_PARENTHESIS_ORNAMENT		      0x2768
#define Z_UNICODE_MEDIUM_RIGHT_PARENTHESIS_ORNAMENT		      0x2769
#define Z_UNICODE_MEDIUM_FLATTENED_LEFT_PARENTHESIS_ORNAMENT	      0x276A
#define Z_UNICODE_MEDIUM_FLATTENED_RIGHT_PARENTHESIS_ORNAMENT	      0x276B
#define Z_UNICODE_MEDIUM_LEFT_POINTING_ANGLE_BRACKET_ORNAMENT	      0x276C
#define Z_UNICODE_MEDIUM_RIGHT_POINTING_ANGLE_BRACKET_ORNAMENT	      0x276D
#define Z_UNICODE_HEAVY_LEFT_POINTING_ANGLE_QUOTATION_MARK_ORNAMENT   0x276E
#define Z_UNICODE_HEAVY_RIGHT_POINTING_ANGLE_QUOTATION_MARK_ORNAMENT  0x276F
#define Z_UNICODE_HEAVY_LEFT_POINTING_ANGLE_BRACKET_ORNAMENT	      0x2770
#define Z_UNICODE_HEAVY_RIGHT_POINTING_ANGLE_BRACKET_ORNAMENT	      0x2771
#define Z_UNICODE_LIGHT_LEFT_TORTOISE_SHELL_BRACKET_ORNAMENT	      0x2772
#define Z_UNICODE_LIGHT_RIGHT_TORTOISE_SHELL_BRACKET_ORNAMENT	      0x2773
#define Z_UNICODE_MEDIUM_LEFT_CURLY_BRACKET_ORNAMENT		      0x2774
#define Z_UNICODE_MEDIUM_RIGHT_CURLY_BRACKET_ORNAMENT		      0x2775
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_ONE		      0x2776
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_TWO		      0x2777
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_THREE		      0x2778
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_FOUR		      0x2779
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_FIVE		      0x277A
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_SIX		      0x277B
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_SEVEN		      0x277C
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_EIGHT		      0x277D
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_DIGIT_NINE		      0x277E
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_NUMBER_TEN		      0x277F
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_ONE		      0x2780
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_TWO		      0x2781
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_THREE	      0x2782
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_FOUR		      0x2783
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_FIVE		      0x2784
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_SIX		      0x2785
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_SEVEN	      0x2786
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_EIGHT	      0x2787
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_NINE		      0x2788
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_NUMBER_TEN		      0x2789
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_ONE	      0x278A
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_TWO	      0x278B
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_THREE     0x278C
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_FOUR      0x278D
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_FIVE      0x278E
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_SIX	      0x278F
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_SEVEN     0x2790
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_EIGHT     0x2791
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_NINE      0x2792
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_NUMBER_TEN      0x2793
#define Z_UNICODE_HEAVY_WIDE_HEADED_RIGHTWARDS_ARROW		      0x2794
#define Z_UNICODE_HEAVY_PLUS_SIGN				      0x2795
#define Z_UNICODE_HEAVY_MINUS_SIGN				      0x2796
#define Z_UNICODE_HEAVY_DIVISION_SIGN				      0x2797
#define Z_UNICODE_HEAVY_SOUTH_EAST_ARROW			      0x2798
#define Z_UNICODE_HEAVY_RIGHTWARDS_ARROW			      0x2799
#define Z_UNICODE_HEAVY_NORTH_EAST_ARROW			      0x279A
#define Z_UNICODE_DRAFTING_POINT_RIGHTWARDS_ARROW		      0x279B
#define Z_UNICODE_HEAVY_ROUND_TIPPED_RIGHTWARDS_ARROW		      0x279C
#define Z_UNICODE_TRIANGLE_HEADED_RIGHTWARDS_ARROW		      0x279D
#define Z_UNICODE_HEAVY_TRIANGLE_HEADED_RIGHTWARDS_ARROW	      0x279E
#define Z_UNICODE_DASHED_TRIANGLE_HEADED_RIGHTWARDS_ARROW	      0x279F
#define Z_UNICODE_HEAVY_DASHED_TRIANGLE_HEADED_RIGHTWARDS_ARROW	      0x27A0
#define Z_UNICODE_BLACK_RIGHTWARDS_ARROW			      0x27A1
#define Z_UNICODE_THREE_D_TOP_LIGHTED_RIGHTWARDS_ARROWHEAD	      0x27A2
#define Z_UNICODE_THREE_D_BOTTOM_LIGHTED_RIGHTWARDS_ARROWHEAD	      0x27A3
#define Z_UNICODE_BLACK_RIGHTWARDS_ARROWHEAD			      0x27A4
#define Z_UNICODE_HEAVY_BLACK_CURVED_DOWNWARDS_AND_RIGHTWARDS_ARROW   0x27A5
#define Z_UNICODE_HEAVY_BLACK_CURVED_UPWARDS_AND_RIGHTWARDS_ARROW     0x27A6
#define Z_UNICODE_SQUAT_BLACK_RIGHTWARDS_ARROW			      0x27A7
#define Z_UNICODE_HEAVY_CONCAVE_POINTED_BLACK_RIGHTWARDS_ARROW	      0x27A8
#define Z_UNICODE_RIGHT_SHADED_WHITE_RIGHTWARDS_ARROW		      0x27A9
#define Z_UNICODE_LEFT_SHADED_WHITE_RIGHTWARDS_ARROW		      0x27AA
#define Z_UNICODE_BACK_TILTED_SHADOWED_WHITE_RIGHTWARDS_ARROW	      0x27AB
#define Z_UNICODE_FRONT_TILTED_SHADOWED_WHITE_RIGHTWARDS_ARROW	      0x27AC
#define Z_UNICODE_HEAVY_LOWER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW   0x27AD
#define Z_UNICODE_HEAVY_UPPER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW   0x27AE
#define Z_UNICODE_NOTCHED_LOWER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW 0x27AF
#define Z_UNICODE_CURLY_LOOP					      0x27B0
#define Z_UNICODE_NOTCHED_UPPER_RIGHT_SHADOWED_WHITE_RIGHTWARDS_ARROW 0x27B1
#define Z_UNICODE_CIRCLED_HEAVY_WHITE_RIGHTWARDS_ARROW		      0x27B2
#define Z_UNICODE_WHITE_FEATHERED_RIGHTWARDS_ARROW		      0x27B3
#define Z_UNICODE_BLACK_FEATHERED_SOUTH_EAST_ARROW		      0x27B4
#define Z_UNICODE_BLACK_FEATHERED_RIGHTWARDS_ARROW		      0x27B5
#define Z_UNICODE_BLACK_FEATHERED_NORTH_EAST_ARROW		      0x27B6
#define Z_UNICODE_HEAVY_BLACK_FEATHERED_SOUTH_EAST_ARROW	      0x27B7
#define Z_UNICODE_HEAVY_BLACK_FEATHERED_RIGHTWARDS_ARROW	      0x27B8
#define Z_UNICODE_HEAVY_BLACK_FEATHERED_NORTH_EAST_ARROW	      0x27B9
#define Z_UNICODE_TEARDROP_BARBED_RIGHTWARDS_ARROW		      0x27BA
#define Z_UNICODE_HEAVY_TEARDROP_SHANKED_RIGHTWARDS_ARROW	      0x27BB
#define Z_UNICODE_WEDGE_TAILED_RIGHTWARDS_ARROW			      0x27BC
#define Z_UNICODE_HEAVY_WEDGE_TAILED_RIGHTWARDS_ARROW		      0x27BD
#define Z_UNICODE_OPEN_OUTLINED_RIGHTWARDS_ARROW		      0x27BE
#define Z_UNICODE_DOUBLE_CURLY_LOOP				      0x27BF

/* MARK: - 27C0h-27EFh - Miscellaneous Mathematical Symbols-A */

#define Z_UNICODE_THREE_DIMENSIONAL_ANGLE			   0x27C0
#define Z_UNICODE_WHITE_TRIANGLE_CONTAINING_SMALL_WHITE_TRIANGLE   0x27C1
#define Z_UNICODE_PERPENDICULAR					   0x27C2
#define Z_UNICODE_OPEN_SUBSET					   0x27C3
#define Z_UNICODE_OPEN_SUPERSET					   0x27C4
#define Z_UNICODE_LEFT_S_SHAPED_BAG_DELIMITER			   0x27C5
#define Z_UNICODE_RIGHT_S_SHAPED_BAG_DELIMITER			   0x27C6
#define Z_UNICODE_OR_WITH_DOT_INSIDE				   0x27C7
#define Z_UNICODE_REVERSE_SOLIDUS_PRECEDING_SUBSET		   0x27C8
#define Z_UNICODE_SUPERSET_PRECEDING_SOLIDUS			   0x27C9
#define Z_UNICODE_VERTICAL_BAR_WITH_HORIZONTAL_STROKE		   0x27CA
#define Z_UNICODE_MATHEMATICAL_RISING_DIAGONAL			   0x27CB
#define Z_UNICODE_LONG_DIVISION					   0x27CC
#define Z_UNICODE_MATHEMATICAL_FALLING_DIAGONAL			   0x27CD
#define Z_UNICODE_SQUARED_LOGICAL_AND				   0x27CE
#define Z_UNICODE_SQUARED_LOGICAL_OR				   0x27CF
#define Z_UNICODE_WHITE_DIAMOND_WITH_CENTRED_DOT		   0x27D0
#define Z_UNICODE_AND_WITH_DOT					   0x27D1
#define Z_UNICODE_ELEMENT_OF_OPENING_UPWARDS			   0x27D2
#define Z_UNICODE_LOWER_RIGHT_CORNER_WITH_DOT			   0x27D3
#define Z_UNICODE_UPPER_LEFT_CORNER_WITH_DOT			   0x27D4
#define Z_UNICODE_LEFT_OUTER_JOIN				   0x27D5
#define Z_UNICODE_RIGHT_OUTER_JOIN				   0x27D6
#define Z_UNICODE_FULL_OUTER_JOIN				   0x27D7
#define Z_UNICODE_LARGE_UP_TACK					   0x27D8
#define Z_UNICODE_LARGE_DOWN_TACK				   0x27D9
#define Z_UNICODE_LEFT_AND_RIGHT_DOUBLE_TURNSTILE		   0x27DA
#define Z_UNICODE_LEFT_AND_RIGHT_TACK				   0x27DB
#define Z_UNICODE_LEFT_MULTIMAP					   0x27DC
#define Z_UNICODE_LONG_RIGHT_TACK				   0x27DD
#define Z_UNICODE_LONG_LEFT_TACK				   0x27DE
#define Z_UNICODE_UP_TACK_WITH_CIRCLE_ABOVE			   0x27DF
#define Z_UNICODE_LOZENGE_DIVIDED_BY_HORIZONTAL_RULE		   0x27E0
#define Z_UNICODE_WHITE_CONCAVE_SIDED_DIAMOND			   0x27E1
#define Z_UNICODE_WHITE_CONCAVE_SIDED_DIAMOND_WITH_LEFTWARDS_TICK  0x27E2
#define Z_UNICODE_WHITE_CONCAVE_SIDED_DIAMOND_WITH_RIGHTWARDS_TICK 0x27E3
#define Z_UNICODE_WHITE_SQUARE_WITH_LEFTWARDS_TICK		   0x27E4
#define Z_UNICODE_WHITE_SQUARE_WITH_RIGHTWARDS_TICK		   0x27E5
#define Z_UNICODE_MATHEMATICAL_LEFT_WHITE_SQUARE_BRACKET	   0x27E6
#define Z_UNICODE_MATHEMATICAL_RIGHT_WHITE_SQUARE_BRACKET	   0x27E7
#define Z_UNICODE_MATHEMATICAL_LEFT_ANGLE_BRACKET		   0x27E8
#define Z_UNICODE_MATHEMATICAL_RIGHT_ANGLE_BRACKET		   0x27E9
#define Z_UNICODE_MATHEMATICAL_LEFT_DOUBLE_ANGLE_BRACKET	   0x27EA
#define Z_UNICODE_MATHEMATICAL_RIGHT_DOUBLE_ANGLE_BRACKET	   0x27EB
#define Z_UNICODE_MATHEMATICAL_LEFT_WHITE_TORTOISE_SHELL_BRACKET   0x27EC
#define Z_UNICODE_MATHEMATICAL_RIGHT_WHITE_TORTOISE_SHELL_BRACKET  0x27ED
#define Z_UNICODE_MATHEMATICAL_LEFT_FLATTENED_PARENTHESIS	   0x27EE
#define Z_UNICODE_MATHEMATICAL_RIGHT_FLATTENED_PARENTHESIS	   0x27EF

/* MARK: - 27F0h-27FFh - Supplemental Arrows-A */

#define Z_UNICODE_UPWARDS_QUADRUPLE_ARROW		0x27F0
#define Z_UNICODE_DOWNWARDS_QUADRUPLE_ARROW		0x27F1
#define Z_UNICODE_ANTICLOCKWISE_GAPPED_CIRCLE_ARROW	0x27F2
#define Z_UNICODE_CLOCKWISE_GAPPED_CIRCLE_ARROW		0x27F3
#define Z_UNICODE_RIGHT_ARROW_WITH_CIRCLED_PLUS		0x27F4
#define Z_UNICODE_LONG_LEFTWARDS_ARROW			0x27F5
#define Z_UNICODE_LONG_RIGHTWARDS_ARROW			0x27F6
#define Z_UNICODE_LONG_LEFT_RIGHT_ARROW			0x27F7
#define Z_UNICODE_LONG_LEFTWARDS_DOUBLE_ARROW		0x27F8
#define Z_UNICODE_LONG_RIGHTWARDS_DOUBLE_ARROW		0x27F9
#define Z_UNICODE_LONG_LEFT_RIGHT_DOUBLE_ARROW		0x27FA
#define Z_UNICODE_LONG_LEFTWARDS_ARROW_FROM_BAR		0x27FB
#define Z_UNICODE_LONG_RIGHTWARDS_ARROW_FROM_BAR	0x27FC
#define Z_UNICODE_LONG_LEFTWARDS_DOUBLE_ARROW_FROM_BAR	0x27FD
#define Z_UNICODE_LONG_RIGHTWARDS_DOUBLE_ARROW_FROM_BAR	0x27FE
#define Z_UNICODE_LONG_RIGHTWARDS_SQUIGGLE_ARROW	0x27FF

/* MARK: - 2800h-28FFh - Braille Patterns */

#define Z_UNICODE_BRAILLE_PATTERN_BLANK		0x2800
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1	0x2801
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2	0x2802
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12	0x2803
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3	0x2804
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13	0x2805
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23	0x2806
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123	0x2807
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_4	0x2808
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_14	0x2809
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_24	0x280A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_124	0x280B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_34	0x280C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_134	0x280D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_234	0x280E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1234	0x280F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_5	0x2810
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_15	0x2811
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_25	0x2812
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_125	0x2813
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_35	0x2814
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_135	0x2815
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_235	0x2816
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1235	0x2817
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_45	0x2818
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_145	0x2819
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_245	0x281A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1245	0x281B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_345	0x281C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1345	0x281D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2345	0x281E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12345	0x281F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_6	0x2820
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_16	0x2821
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_26	0x2822
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_126	0x2823
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_36	0x2824
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_136	0x2825
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_236	0x2826
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1236	0x2827
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_46	0x2828
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_146	0x2829
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_246	0x282A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1246	0x282B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_346	0x282C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1346	0x282D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2346	0x282E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12346	0x282F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_56	0x2830
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_156	0x2831
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_256	0x2832
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1256	0x2833
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_356	0x2834
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1356	0x2835
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2356	0x2836
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12356	0x2837
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_456	0x2838
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1456	0x2839
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2456	0x283A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12456	0x283B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3456	0x283C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13456	0x283D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23456	0x283E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123456	0x283F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_7	0x2840
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_17	0x2841
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_27	0x2842
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_127	0x2843
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_37	0x2844
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_137	0x2845
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_237	0x2846
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1237	0x2847
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_47	0x2848
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_147	0x2849
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_247	0x284A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1247	0x284B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_347	0x284C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1347	0x284D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2347	0x284E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12347	0x284F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_57	0x2850
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_157	0x2851
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_257	0x2852
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1257	0x2853
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_357	0x2854
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1357	0x2855
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2357	0x2856
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12357	0x2857
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_457	0x2858
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1457	0x2859
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2457	0x285A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12457	0x285B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3457	0x285C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13457	0x285D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23457	0x285E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123457	0x285F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_67	0x2860
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_167	0x2861
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_267	0x2862
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1267	0x2863
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_367	0x2864
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1367	0x2865
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2367	0x2866
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12367	0x2867
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_467	0x2868
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1467	0x2869
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2467	0x286A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12467	0x286B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3467	0x286C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13467	0x286D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23467	0x286E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123467	0x286F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_567	0x2870
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1567	0x2871
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2567	0x2872
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12567	0x2873
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3567	0x2874
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13567	0x2875
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23567	0x2876
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123567	0x2877
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_4567	0x2878
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_14567	0x2879
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_24567	0x287A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_124567	0x287B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_34567	0x287C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_134567	0x287D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_234567	0x287E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1234567	0x287F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_8	0x2880
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_18	0x2881
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_28	0x2882
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_128	0x2883
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_38	0x2884
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_138	0x2885
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_238	0x2886
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1238	0x2887
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_48	0x2888
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_148	0x2889
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_248	0x288A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1248	0x288B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_348	0x288C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1348	0x288D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2348	0x288E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12348	0x288F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_58	0x2890
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_158	0x2891
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_258	0x2892
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1258	0x2893
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_358	0x2894
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1358	0x2895
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2358	0x2896
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12358	0x2897
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_458	0x2898
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1458	0x2899
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2458	0x289A
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12458	0x289B
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3458	0x289C
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13458	0x289D
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23458	0x289E
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123458	0x289F
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_68	0x28A0
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_168	0x28A1
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_268	0x28A2
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1268	0x28A3
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_368	0x28A4
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1368	0x28A5
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2368	0x28A6
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12368	0x28A7
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_468	0x28A8
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1468	0x28A9
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2468	0x28AA
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12468	0x28AB
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3468	0x28AC
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13468	0x28AD
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23468	0x28AE
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123468	0x28AF
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_568	0x28B0
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1568	0x28B1
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2568	0x28B2
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12568	0x28B3
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3568	0x28B4
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13568	0x28B5
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23568	0x28B6
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123568	0x28B7
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_4568	0x28B8
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_14568	0x28B9
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_24568	0x28BA
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_124568	0x28BB
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_34568	0x28BC
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_134568	0x28BD
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_234568	0x28BE
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1234568	0x28BF
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_78	0x28C0
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_178	0x28C1
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_278	0x28C2
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1278	0x28C3
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_378	0x28C4
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1378	0x28C5
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2378	0x28C6
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12378	0x28C7
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_478	0x28C8
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1478	0x28C9
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2478	0x28CA
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12478	0x28CB
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3478	0x28CC
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13478	0x28CD
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23478	0x28CE
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123478	0x28CF
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_578	0x28D0
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1578	0x28D1
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2578	0x28D2
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12578	0x28D3
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3578	0x28D4
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13578	0x28D5
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23578	0x28D6
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123578	0x28D7
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_4578	0x28D8
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_14578	0x28D9
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_24578	0x28DA
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_124578	0x28DB
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_34578	0x28DC
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_134578	0x28DD
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_234578	0x28DE
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1234578	0x28DF
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_678	0x28E0
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1678	0x28E1
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2678	0x28E2
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12678	0x28E3
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_3678	0x28E4
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_13678	0x28E5
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_23678	0x28E6
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_123678	0x28E7
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_4678	0x28E8
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_14678	0x28E9
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_24678	0x28EA
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_124678	0x28EB
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_34678	0x28EC
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_134678	0x28ED
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_234678	0x28EE
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1234678	0x28EF
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_5678	0x28F0
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_15678	0x28F1
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_25678	0x28F2
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_125678	0x28F3
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_35678	0x28F4
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_135678	0x28F5
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_235678	0x28F6
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1235678	0x28F7
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_45678	0x28F8
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_145678	0x28F9
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_245678	0x28FA
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1245678	0x28FB
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_345678	0x28FC
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_1345678	0x28FD
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_2345678	0x28FE
#define Z_UNICODE_BRAILLE_PATTERN_DOTS_12345678	0x28FF

/* MARK: - 2900h-297Fh - Supplemental Arrows-B */

#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_ARROW_WITH_VERTICAL_STROKE			    0x2900
#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_ARROW_WITH_DOUBLE_VERTICAL_STROKE		    0x2901
#define Z_UNICODE_LEFTWARDS_DOUBLE_ARROW_WITH_VERTICAL_STROKE				    0x2902
#define Z_UNICODE_RIGHTWARDS_DOUBLE_ARROW_WITH_VERTICAL_STROKE				    0x2903
#define Z_UNICODE_LEFT_RIGHT_DOUBLE_ARROW_WITH_VERTICAL_STROKE				    0x2904
#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_ARROW_FROM_BAR					    0x2905
#define Z_UNICODE_LEFTWARDS_DOUBLE_ARROW_FROM_BAR					    0x2906
#define Z_UNICODE_RIGHTWARDS_DOUBLE_ARROW_FROM_BAR					    0x2907
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_HORIZONTAL_STROKE				    0x2908
#define Z_UNICODE_UPWARDS_ARROW_WITH_HORIZONTAL_STROKE					    0x2909
#define Z_UNICODE_UPWARDS_TRIPLE_ARROW							    0x290A
#define Z_UNICODE_DOWNWARDS_TRIPLE_ARROW						    0x290B
#define Z_UNICODE_LEFTWARDS_DOUBLE_DASH_ARROW						    0x290C
#define Z_UNICODE_RIGHTWARDS_DOUBLE_DASH_ARROW						    0x290D
#define Z_UNICODE_LEFTWARDS_TRIPLE_DASH_ARROW						    0x290E
#define Z_UNICODE_RIGHTWARDS_TRIPLE_DASH_ARROW						    0x290F
#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_TRIPLE_DASH_ARROW				    0x2910
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_DOTTED_STEM					    0x2911
#define Z_UNICODE_UPWARDS_ARROW_TO_BAR							    0x2912
#define Z_UNICODE_DOWNWARDS_ARROW_TO_BAR						    0x2913
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE			    0x2914
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE		    0x2915
#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL					    0x2916
#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE		    0x2917
#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE	    0x2918
#define Z_UNICODE_LEFTWARDS_ARROW_TAIL							    0x2919
#define Z_UNICODE_RIGHTWARDS_ARROW_TAIL							    0x291A
#define Z_UNICODE_LEFTWARDS_DOUBLE_ARROW_TAIL						    0x291B
#define Z_UNICODE_RIGHTWARDS_DOUBLE_ARROW_TAIL						    0x291C
#define Z_UNICODE_LEFTWARDS_ARROW_TO_BLACK_DIAMOND					    0x291D
#define Z_UNICODE_RIGHTWARDS_ARROW_TO_BLACK_DIAMOND					    0x291E
#define Z_UNICODE_LEFTWARDS_ARROW_FROM_BAR_TO_BLACK_DIAMOND				    0x291F
#define Z_UNICODE_RIGHTWARDS_ARROW_FROM_BAR_TO_BLACK_DIAMOND				    0x2920
#define Z_UNICODE_NORTH_WEST_AND_SOUTH_EAST_ARROW					    0x2921
#define Z_UNICODE_NORTH_EAST_AND_SOUTH_WEST_ARROW					    0x2922
#define Z_UNICODE_NORTH_WEST_ARROW_WITH_HOOK						    0x2923
#define Z_UNICODE_NORTH_EAST_ARROW_WITH_HOOK						    0x2924
#define Z_UNICODE_SOUTH_EAST_ARROW_WITH_HOOK						    0x2925
#define Z_UNICODE_SOUTH_WEST_ARROW_WITH_HOOK						    0x2926
#define Z_UNICODE_NORTH_WEST_ARROW_AND_NORTH_EAST_ARROW					    0x2927
#define Z_UNICODE_NORTH_EAST_ARROW_AND_SOUTH_EAST_ARROW					    0x2928
#define Z_UNICODE_SOUTH_EAST_ARROW_AND_SOUTH_WEST_ARROW					    0x2929
#define Z_UNICODE_SOUTH_WEST_ARROW_AND_NORTH_WEST_ARROW					    0x292A
#define Z_UNICODE_RISING_DIAGONAL_CROSSING_FALLING_DIAGONAL				    0x292B
#define Z_UNICODE_FALLING_DIAGONAL_CROSSING_RISING_DIAGONAL				    0x292C
#define Z_UNICODE_SOUTH_EAST_ARROW_CROSSING_NORTH_EAST_ARROW				    0x292D
#define Z_UNICODE_NORTH_EAST_ARROW_CROSSING_SOUTH_EAST_ARROW				    0x292E
#define Z_UNICODE_FALLING_DIAGONAL_CROSSING_NORTH_EAST_ARROW				    0x292F
#define Z_UNICODE_RISING_DIAGONAL_CROSSING_SOUTH_EAST_ARROW				    0x2930
#define Z_UNICODE_NORTH_EAST_ARROW_CROSSING_NORTH_WEST_ARROW				    0x2931
#define Z_UNICODE_NORTH_WEST_ARROW_CROSSING_NORTH_EAST_ARROW				    0x2932
#define Z_UNICODE_WAVE_ARROW_POINTING_DIRECTLY_RIGHT					    0x2933
#define Z_UNICODE_ARROW_POINTING_RIGHTWARDS_THEN_CURVING_UPWARDS			    0x2934
#define Z_UNICODE_ARROW_POINTING_RIGHTWARDS_THEN_CURVING_DOWNWARDS			    0x2935
#define Z_UNICODE_ARROW_POINTING_DOWNWARDS_THEN_CURVING_LEFTWARDS			    0x2936
#define Z_UNICODE_ARROW_POINTING_DOWNWARDS_THEN_CURVING_RIGHTWARDS			    0x2937
#define Z_UNICODE_RIGHT_SIDE_ARC_CLOCKWISE_ARROW					    0x2938
#define Z_UNICODE_LEFT_SIDE_ARC_ANTICLOCKWISE_ARROW					    0x2939
#define Z_UNICODE_TOP_ARC_ANTICLOCKWISE_ARROW						    0x293A
#define Z_UNICODE_BOTTOM_ARC_ANTICLOCKWISE_ARROW					    0x293B
#define Z_UNICODE_TOP_ARC_CLOCKWISE_ARROW_WITH_MINUS					    0x293C
#define Z_UNICODE_TOP_ARC_ANTICLOCKWISE_ARROW_WITH_PLUS					    0x293D
#define Z_UNICODE_LOWER_RIGHT_SEMICIRCULAR_CLOCKWISE_ARROW				    0x293E
#define Z_UNICODE_LOWER_LEFT_SEMICIRCULAR_ANTICLOCKWISE_ARROW				    0x293F
#define Z_UNICODE_ANTICLOCKWISE_CLOSED_CIRCLE_ARROW					    0x2940
#define Z_UNICODE_CLOCKWISE_CLOSED_CIRCLE_ARROW						    0x2941
#define Z_UNICODE_RIGHTWARDS_ARROW_ABOVE_SHORT_LEFTWARDS_ARROW				    0x2942
#define Z_UNICODE_LEFTWARDS_ARROW_ABOVE_SHORT_RIGHTWARDS_ARROW				    0x2943
#define Z_UNICODE_SHORT_RIGHTWARDS_ARROW_ABOVE_LEFTWARDS_ARROW				    0x2944
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_PLUS_BELOW					    0x2945
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_PLUS_BELOW					    0x2946
#define Z_UNICODE_RIGHTWARDS_ARROW_THROUGH_X						    0x2947
#define Z_UNICODE_LEFT_RIGHT_ARROW_THROUGH_SMALL_CIRCLE					    0x2948
#define Z_UNICODE_UPWARDS_TWO_HEADED_ARROW_FROM_SMALL_CIRCLE				    0x2949
#define Z_UNICODE_LEFT_BARB_UP_RIGHT_BARB_DOWN_HARPOON					    0x294A
#define Z_UNICODE_LEFT_BARB_DOWN_RIGHT_BARB_UP_HARPOON					    0x294B
#define Z_UNICODE_UP_BARB_RIGHT_DOWN_BARB_LEFT_HARPOON					    0x294C
#define Z_UNICODE_UP_BARB_LEFT_DOWN_BARB_RIGHT_HARPOON					    0x294D
#define Z_UNICODE_LEFT_BARB_UP_RIGHT_BARB_UP_HARPOON					    0x294E
#define Z_UNICODE_UP_BARB_RIGHT_DOWN_BARB_RIGHT_HARPOON					    0x294F
#define Z_UNICODE_LEFT_BARB_DOWN_RIGHT_BARB_DOWN_HARPOON				    0x2950
#define Z_UNICODE_UP_BARB_LEFT_DOWN_BARB_LEFT_HARPOON					    0x2951
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_UP_TO_BAR					    0x2952
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_UP_TO_BAR				    0x2953
#define Z_UNICODE_UPWARDS_HARPOON_WITH_BARB_RIGHT_TO_BAR				    0x2954
#define Z_UNICODE_DOWNWARDS_HARPOON_WITH_BARB_RIGHT_TO_BAR				    0x2955
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_DOWN_TO_BAR				    0x2956
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN_TO_BAR				    0x2957
#define Z_UNICODE_UPWARDS_HARPOON_WITH_BARB_LEFT_TO_BAR					    0x2958
#define Z_UNICODE_DOWNWARDS_HARPOON_WITH_BARB_LEFT_TO_BAR				    0x2959
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_UP_FROM_BAR				    0x295A
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_UP_FROM_BAR				    0x295B
#define Z_UNICODE_UPWARDS_HARPOON_WITH_BARB_RIGHT_FROM_BAR				    0x295C
#define Z_UNICODE_DOWNWARDS_HARPOON_WITH_BARB_RIGHT_FROM_BAR				    0x295D
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_DOWN_FROM_BAR				    0x295E
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN_FROM_BAR				    0x295F
#define Z_UNICODE_UPWARDS_HARPOON_WITH_BARB_LEFT_FROM_BAR				    0x2960
#define Z_UNICODE_DOWNWARDS_HARPOON_WITH_BARB_LEFT_FROM_BAR				    0x2961
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_DOWN	    0x2962
#define Z_UNICODE_UPWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_UPWARDS_HARPOON_WITH_BARB_RIGHT	    0x2963
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN   0x2964
#define Z_UNICODE_DOWNWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_DOWNWARDS_HARPOON_WITH_BARB_RIGHT 0x2965
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_UP	    0x2966
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_DOWN_ABOVE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN  0x2967
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_UP	    0x2968
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN_ABOVE_LEFTWARDS_HARPOON_WITH_BARB_DOWN  0x2969
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LONG_DASH			    0x296A
#define Z_UNICODE_LEFTWARDS_HARPOON_WITH_BARB_DOWN_BELOW_LONG_DASH			    0x296B
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_UP_ABOVE_LONG_DASH			    0x296C
#define Z_UNICODE_RIGHTWARDS_HARPOON_WITH_BARB_DOWN_BELOW_LONG_DASH			    0x296D
#define Z_UNICODE_UPWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_DOWNWARDS_HARPOON_WITH_BARB_RIGHT   0x296E
#define Z_UNICODE_DOWNWARDS_HARPOON_WITH_BARB_LEFT_BESIDE_UPWARDS_HARPOON_WITH_BARB_RIGHT   0x296F
#define Z_UNICODE_RIGHT_DOUBLE_ARROW_WITH_ROUNDED_HEAD					    0x2970
#define Z_UNICODE_EQUALS_SIGN_ABOVE_RIGHTWARDS_ARROW					    0x2971
#define Z_UNICODE_TILDE_OPERATOR_ABOVE_RIGHTWARDS_ARROW					    0x2972
#define Z_UNICODE_LEFTWARDS_ARROW_ABOVE_TILDE_OPERATOR					    0x2973
#define Z_UNICODE_RIGHTWARDS_ARROW_ABOVE_TILDE_OPERATOR					    0x2974
#define Z_UNICODE_RIGHTWARDS_ARROW_ABOVE_ALMOST_EQUAL_TO				    0x2975
#define Z_UNICODE_LESS_THAN_ABOVE_LEFTWARDS_ARROW					    0x2976
#define Z_UNICODE_LEFTWARDS_ARROW_THROUGH_LESS_THAN					    0x2977
#define Z_UNICODE_GREATER_THAN_ABOVE_RIGHTWARDS_ARROW					    0x2978
#define Z_UNICODE_SUBSET_ABOVE_RIGHTWARDS_ARROW						    0x2979
#define Z_UNICODE_LEFTWARDS_ARROW_THROUGH_SUBSET					    0x297A
#define Z_UNICODE_SUPERSET_ABOVE_LEFTWARDS_ARROW					    0x297B
#define Z_UNICODE_LEFT_FISH_TAIL							    0x297C
#define Z_UNICODE_RIGHT_FISH_TAIL							    0x297D
#define Z_UNICODE_UP_FISH_TAIL								    0x297E
#define Z_UNICODE_DOWN_FISH_TAIL							    0x297F

/* MARK: - 2980h-29FFh - Miscellaneous Mathematical Symbols-B */

#define Z_UNICODE_TRIPLE_VERTICAL_BAR_DELIMITER						0x2980
#define Z_UNICODE_Z_NOTATION_SPOT							0x2981
#define Z_UNICODE_Z_NOTATION_TYPE_COLON							0x2982
#define Z_UNICODE_LEFT_WHITE_CURLY_BRACKET						0x2983
#define Z_UNICODE_RIGHT_WHITE_CURLY_BRACKET						0x2984
#define Z_UNICODE_LEFT_WHITE_PARENTHESIS						0x2985
#define Z_UNICODE_RIGHT_WHITE_PARENTHESIS						0x2986
#define Z_UNICODE_Z_NOTATION_LEFT_IMAGE_BRACKET						0x2987
#define Z_UNICODE_Z_NOTATION_RIGHT_IMAGE_BRACKET					0x2988
#define Z_UNICODE_Z_NOTATION_LEFT_BINDING_BRACKET					0x2989
#define Z_UNICODE_Z_NOTATION_RIGHT_BINDING_BRACKET					0x298A
#define Z_UNICODE_LEFT_SQUARE_BRACKET_WITH_UNDERBAR					0x298B
#define Z_UNICODE_RIGHT_SQUARE_BRACKET_WITH_UNDERBAR					0x298C
#define Z_UNICODE_LEFT_SQUARE_BRACKET_WITH_TICK_IN_TOP_CORNER				0x298D
#define Z_UNICODE_RIGHT_SQUARE_BRACKET_WITH_TICK_IN_BOTTOM_CORNER			0x298E
#define Z_UNICODE_LEFT_SQUARE_BRACKET_WITH_TICK_IN_BOTTOM_CORNER			0x298F
#define Z_UNICODE_RIGHT_SQUARE_BRACKET_WITH_TICK_IN_TOP_CORNER				0x2990
#define Z_UNICODE_LEFT_ANGLE_BRACKET_WITH_DOT						0x2991
#define Z_UNICODE_RIGHT_ANGLE_BRACKET_WITH_DOT						0x2992
#define Z_UNICODE_LEFT_ARC_LESS_THAN_BRACKET						0x2993
#define Z_UNICODE_RIGHT_ARC_GREATER_THAN_BRACKET					0x2994
#define Z_UNICODE_DOUBLE_LEFT_ARC_GREATER_THAN_BRACKET					0x2995
#define Z_UNICODE_DOUBLE_RIGHT_ARC_LESS_THAN_BRACKET					0x2996
#define Z_UNICODE_LEFT_BLACK_TORTOISE_SHELL_BRACKET					0x2997
#define Z_UNICODE_RIGHT_BLACK_TORTOISE_SHELL_BRACKET					0x2998
#define Z_UNICODE_DOTTED_FENCE								0x2999
#define Z_UNICODE_VERTICAL_ZIGZAG_LINE							0x299A
#define Z_UNICODE_MEASURED_ANGLE_OPENING_LEFT						0x299B
#define Z_UNICODE_RIGHT_ANGLE_VARIANT_WITH_SQUARE					0x299C
#define Z_UNICODE_MEASURED_RIGHT_ANGLE_WITH_DOT						0x299D
#define Z_UNICODE_ANGLE_WITH_S_INSIDE							0x299E
#define Z_UNICODE_ACUTE_ANGLE								0x299F
#define Z_UNICODE_SPHERICAL_ANGLE_OPENING_LEFT						0x29A0
#define Z_UNICODE_SPHERICAL_ANGLE_OPENING_UP						0x29A1
#define Z_UNICODE_TURNED_ANGLE								0x29A2
#define Z_UNICODE_REVERSED_ANGLE							0x29A3
#define Z_UNICODE_ANGLE_WITH_UNDERBAR							0x29A4
#define Z_UNICODE_REVERSED_ANGLE_WITH_UNDERBAR						0x29A5
#define Z_UNICODE_OBLIQUE_ANGLE_OPENING_UP						0x29A6
#define Z_UNICODE_OBLIQUE_ANGLE_OPENING_DOWN						0x29A7
#define Z_UNICODE_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_UP_AND_RIGHT	0x29A8
#define Z_UNICODE_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_UP_AND_LEFT	0x29A9
#define Z_UNICODE_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_DOWN_AND_RIGHT	0x29AA
#define Z_UNICODE_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_DOWN_AND_LEFT	0x29AB
#define Z_UNICODE_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_RIGHT_AND_UP	0x29AC
#define Z_UNICODE_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_LEFT_AND_UP	0x29AD
#define Z_UNICODE_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_RIGHT_AND_DOWN	0x29AE
#define Z_UNICODE_MEASURED_ANGLE_WITH_OPEN_ARM_ENDING_IN_ARROW_POINTING_LEFT_AND_DOWN	0x29AF
#define Z_UNICODE_REVERSED_EMPTY_SET							0x29B0
#define Z_UNICODE_EMPTY_SET_WITH_OVERBAR						0x29B1
#define Z_UNICODE_EMPTY_SET_WITH_SMALL_CIRCLE_ABOVE					0x29B2
#define Z_UNICODE_EMPTY_SET_WITH_RIGHT_ARROW_ABOVE					0x29B3
#define Z_UNICODE_EMPTY_SET_WITH_LEFT_ARROW_ABOVE					0x29B4
#define Z_UNICODE_CIRCLE_WITH_HORIZONTAL_BAR						0x29B5
#define Z_UNICODE_CIRCLED_VERTICAL_BAR							0x29B6
#define Z_UNICODE_CIRCLED_PARALLEL							0x29B7
#define Z_UNICODE_CIRCLED_REVERSE_SOLIDUS						0x29B8
#define Z_UNICODE_CIRCLED_PERPENDICULAR							0x29B9
#define Z_UNICODE_CIRCLE_DIVIDED_BY_HORIZONTAL_BAR_AND_TOP_HALF_DIVIDED_BY_VERTICAL_BAR	0x29BA
#define Z_UNICODE_CIRCLE_WITH_SUPERIMPOSED_X						0x29BB
#define Z_UNICODE_CIRCLED_ANTICLOCKWISE_ROTATED_DIVISION_SIGN				0x29BC
#define Z_UNICODE_UP_ARROW_THROUGH_CIRCLE						0x29BD
#define Z_UNICODE_CIRCLED_WHITE_BULLET							0x29BE
#define Z_UNICODE_CIRCLED_BULLET							0x29BF
#define Z_UNICODE_CIRCLED_LESS_THAN							0x29C0
#define Z_UNICODE_CIRCLED_GREATER_THAN							0x29C1
#define Z_UNICODE_CIRCLE_WITH_SMALL_CIRCLE_TO_THE_RIGHT					0x29C2
#define Z_UNICODE_CIRCLE_WITH_TWO_HORIZONTAL_STROKES_TO_THE_RIGHT			0x29C3
#define Z_UNICODE_SQUARED_RISING_DIAGONAL_SLASH						0x29C4
#define Z_UNICODE_SQUARED_FALLING_DIAGONAL_SLASH					0x29C5
#define Z_UNICODE_SQUARED_ASTERISK							0x29C6
#define Z_UNICODE_SQUARED_SMALL_CIRCLE							0x29C7
#define Z_UNICODE_SQUARED_SQUARE							0x29C8
#define Z_UNICODE_TWO_JOINED_SQUARES							0x29C9
#define Z_UNICODE_TRIANGLE_WITH_DOT_ABOVE						0x29CA
#define Z_UNICODE_TRIANGLE_WITH_UNDERBAR						0x29CB
#define Z_UNICODE_S_IN_TRIANGLE								0x29CC
#define Z_UNICODE_TRIANGLE_WITH_SERIFS_AT_BOTTOM					0x29CD
#define Z_UNICODE_RIGHT_TRIANGLE_ABOVE_LEFT_TRIANGLE					0x29CE
#define Z_UNICODE_LEFT_TRIANGLE_BESIDE_VERTICAL_BAR					0x29CF
#define Z_UNICODE_VERTICAL_BAR_BESIDE_RIGHT_TRIANGLE					0x29D0
#define Z_UNICODE_BOWTIE_WITH_LEFT_HALF_BLACK						0x29D1
#define Z_UNICODE_BOWTIE_WITH_RIGHT_HALF_BLACK						0x29D2
#define Z_UNICODE_BLACK_BOWTIE								0x29D3
#define Z_UNICODE_TIMES_WITH_LEFT_HALF_BLACK						0x29D4
#define Z_UNICODE_TIMES_WITH_RIGHT_HALF_BLACK						0x29D5
#define Z_UNICODE_WHITE_HOURGLASS							0x29D6
#define Z_UNICODE_BLACK_HOURGLASS							0x29D7
#define Z_UNICODE_LEFT_WIGGLY_FENCE							0x29D8
#define Z_UNICODE_RIGHT_WIGGLY_FENCE							0x29D9
#define Z_UNICODE_LEFT_DOUBLE_WIGGLY_FENCE						0x29DA
#define Z_UNICODE_RIGHT_DOUBLE_WIGGLY_FENCE						0x29DB
#define Z_UNICODE_INCOMPLETE_INFINITY							0x29DC
#define Z_UNICODE_TIE_OVER_INFINITY							0x29DD
#define Z_UNICODE_INFINITY_NEGATED_WITH_VERTICAL_BAR					0x29DE
#define Z_UNICODE_DOUBLE_ENDED_MULTIMAP							0x29DF
#define Z_UNICODE_SQUARE_WITH_CONTOURED_OUTLINE						0x29E0
#define Z_UNICODE_INCREASES_AS								0x29E1
#define Z_UNICODE_SHUFFLE_PRODUCT							0x29E2
#define Z_UNICODE_EQUALS_SIGN_AND_SLANTED_PARALLEL					0x29E3
#define Z_UNICODE_EQUALS_SIGN_AND_SLANTED_PARALLEL_WITH_TILDE_ABOVE			0x29E4
#define Z_UNICODE_IDENTICAL_TO_AND_SLANTED_PARALLEL					0x29E5
#define Z_UNICODE_GLEICH_STARK								0x29E6
#define Z_UNICODE_THERMODYNAMIC								0x29E7
#define Z_UNICODE_DOWN_POINTING_TRIANGLE_WITH_LEFT_HALF_BLACK				0x29E8
#define Z_UNICODE_DOWN_POINTING_TRIANGLE_WITH_RIGHT_HALF_BLACK				0x29E9
#define Z_UNICODE_BLACK_DIAMOND_WITH_DOWN_ARROW						0x29EA
#define Z_UNICODE_BLACK_LOZENGE								0x29EB
#define Z_UNICODE_WHITE_CIRCLE_WITH_DOWN_ARROW						0x29EC
#define Z_UNICODE_BLACK_CIRCLE_WITH_DOWN_ARROW						0x29ED
#define Z_UNICODE_ERROR_BARRED_WHITE_SQUARE						0x29EE
#define Z_UNICODE_ERROR_BARRED_BLACK_SQUARE						0x29EF
#define Z_UNICODE_ERROR_BARRED_WHITE_DIAMOND						0x29F0
#define Z_UNICODE_ERROR_BARRED_BLACK_DIAMOND						0x29F1
#define Z_UNICODE_ERROR_BARRED_WHITE_CIRCLE						0x29F2
#define Z_UNICODE_ERROR_BARRED_BLACK_CIRCLE						0x29F3
#define Z_UNICODE_RULE_DELAYED								0x29F4
#define Z_UNICODE_REVERSE_SOLIDUS_OPERATOR						0x29F5
#define Z_UNICODE_SOLIDUS_WITH_OVERBAR							0x29F6
#define Z_UNICODE_REVERSE_SOLIDUS_WITH_HORIZONTAL_STROKE				0x29F7
#define Z_UNICODE_BIG_SOLIDUS								0x29F8
#define Z_UNICODE_BIG_REVERSE_SOLIDUS							0x29F9
#define Z_UNICODE_DOUBLE_PLUS								0x29FA
#define Z_UNICODE_TRIPLE_PLUS								0x29FB
#define Z_UNICODE_LEFT_POINTING_CURVED_ANGLE_BRACKET					0x29FC
#define Z_UNICODE_RIGHT_POINTING_CURVED_ANGLE_BRACKET					0x29FD
#define Z_UNICODE_TINY									0x29FE
#define Z_UNICODE_MINY									0x29FF

/* MARK: - 2A00h-2AFFh - Supplemental Mathematical Operators */

#define Z_UNICODE_N_ARY_CIRCLED_DOT_OPERATOR					       0x2A00
#define Z_UNICODE_N_ARY_CIRCLED_PLUS_OPERATOR					       0x2A01
#define Z_UNICODE_N_ARY_CIRCLED_TIMES_OPERATOR					       0x2A02
#define Z_UNICODE_N_ARY_UNION_OPERATOR_WITH_DOT					       0x2A03
#define Z_UNICODE_N_ARY_UNION_OPERATOR_WITH_PLUS				       0x2A04
#define Z_UNICODE_N_ARY_SQUARE_INTERSECTION_OPERATOR				       0x2A05
#define Z_UNICODE_N_ARY_SQUARE_UNION_OPERATOR					       0x2A06
#define Z_UNICODE_TWO_LOGICAL_AND_OPERATOR					       0x2A07
#define Z_UNICODE_TWO_LOGICAL_OR_OPERATOR					       0x2A08
#define Z_UNICODE_N_ARY_TIMES_OPERATOR						       0x2A09
#define Z_UNICODE_MODULO_TWO_SUM						       0x2A0A
#define Z_UNICODE_SUMMATION_WITH_INTEGRAL					       0x2A0B
#define Z_UNICODE_QUADRUPLE_INTEGRAL_OPERATOR					       0x2A0C
#define Z_UNICODE_FINITE_PART_INTEGRAL						       0x2A0D
#define Z_UNICODE_INTEGRAL_WITH_DOUBLE_STROKE					       0x2A0E
#define Z_UNICODE_INTEGRAL_AVERAGE_WITH_SLASH					       0x2A0F
#define Z_UNICODE_CIRCULATION_FUNCTION						       0x2A10
#define Z_UNICODE_ANTICLOCKWISE_INTEGRATION					       0x2A11
#define Z_UNICODE_LINE_INTEGRATION_WITH_RECTANGULAR_PATH_AROUND_POLE		       0x2A12
#define Z_UNICODE_LINE_INTEGRATION_WITH_SEMICIRCULAR_PATH_AROUND_POLE		       0x2A13
#define Z_UNICODE_LINE_INTEGRATION_NOT_INCLUDING_THE_POLE			       0x2A14
#define Z_UNICODE_INTEGRAL_AROUND_A_POINT_OPERATOR				       0x2A15
#define Z_UNICODE_QUATERNION_INTEGRAL_OPERATOR					       0x2A16
#define Z_UNICODE_INTEGRAL_WITH_LEFTWARDS_ARROW_WITH_HOOK			       0x2A17
#define Z_UNICODE_INTEGRAL_WITH_TIMES_SIGN					       0x2A18
#define Z_UNICODE_INTEGRAL_WITH_INTERSECTION					       0x2A19
#define Z_UNICODE_INTEGRAL_WITH_UNION						       0x2A1A
#define Z_UNICODE_INTEGRAL_WITH_OVERBAR						       0x2A1B
#define Z_UNICODE_INTEGRAL_WITH_UNDERBAR					       0x2A1C
#define Z_UNICODE_JOIN								       0x2A1D
#define Z_UNICODE_LARGE_LEFT_TRIANGLE_OPERATOR					       0x2A1E
#define Z_UNICODE_Z_NOTATION_SCHEMA_COMPOSITION					       0x2A1F
#define Z_UNICODE_Z_NOTATION_SCHEMA_PIPING					       0x2A20
#define Z_UNICODE_Z_NOTATION_SCHEMA_PROJECTION					       0x2A21
#define Z_UNICODE_PLUS_SIGN_WITH_SMALL_CIRCLE_ABOVE				       0x2A22
#define Z_UNICODE_PLUS_SIGN_WITH_CIRCUMFLEX_ACCENT_ABOVE			       0x2A23
#define Z_UNICODE_PLUS_SIGN_WITH_TILDE_ABOVE					       0x2A24
#define Z_UNICODE_PLUS_SIGN_WITH_DOT_BELOW					       0x2A25
#define Z_UNICODE_PLUS_SIGN_WITH_TILDE_BELOW					       0x2A26
#define Z_UNICODE_PLUS_SIGN_WITH_SUBSCRIPT_TWO					       0x2A27
#define Z_UNICODE_PLUS_SIGN_WITH_BLACK_TRIANGLE					       0x2A28
#define Z_UNICODE_MINUS_SIGN_WITH_COMMA_ABOVE					       0x2A29
#define Z_UNICODE_MINUS_SIGN_WITH_DOT_BELOW					       0x2A2A
#define Z_UNICODE_MINUS_SIGN_WITH_FALLING_DOTS					       0x2A2B
#define Z_UNICODE_MINUS_SIGN_WITH_RISING_DOTS					       0x2A2C
#define Z_UNICODE_PLUS_SIGN_IN_LEFT_HALF_CIRCLE					       0x2A2D
#define Z_UNICODE_PLUS_SIGN_IN_RIGHT_HALF_CIRCLE				       0x2A2E
#define Z_UNICODE_VECTOR_OR_CROSS_PRODUCT					       0x2A2F
#define Z_UNICODE_MULTIPLICATION_SIGN_WITH_DOT_ABOVE				       0x2A30
#define Z_UNICODE_MULTIPLICATION_SIGN_WITH_UNDERBAR				       0x2A31
#define Z_UNICODE_SEMIDIRECT_PRODUCT_WITH_BOTTOM_CLOSED				       0x2A32
#define Z_UNICODE_SMASH_PRODUCT							       0x2A33
#define Z_UNICODE_MULTIPLICATION_SIGN_IN_LEFT_HALF_CIRCLE			       0x2A34
#define Z_UNICODE_MULTIPLICATION_SIGN_IN_RIGHT_HALF_CIRCLE			       0x2A35
#define Z_UNICODE_CIRCLED_MULTIPLICATION_SIGN_WITH_CIRCUMFLEX_ACCENT		       0x2A36
#define Z_UNICODE_MULTIPLICATION_SIGN_IN_DOUBLE_CIRCLE				       0x2A37
#define Z_UNICODE_CIRCLED_DIVISION_SIGN						       0x2A38
#define Z_UNICODE_PLUS_SIGN_IN_TRIANGLE						       0x2A39
#define Z_UNICODE_MINUS_SIGN_IN_TRIANGLE					       0x2A3A
#define Z_UNICODE_MULTIPLICATION_SIGN_IN_TRIANGLE				       0x2A3B
#define Z_UNICODE_INTERIOR_PRODUCT						       0x2A3C
#define Z_UNICODE_RIGHTHAND_INTERIOR_PRODUCT					       0x2A3D
#define Z_UNICODE_Z_NOTATION_RELATIONAL_COMPOSITION				       0x2A3E
#define Z_UNICODE_AMALGAMATION_OR_COPRODUCT					       0x2A3F
#define Z_UNICODE_INTERSECTION_WITH_DOT						       0x2A40
#define Z_UNICODE_UNION_WITH_MINUS_SIGN						       0x2A41
#define Z_UNICODE_UNION_WITH_OVERBAR						       0x2A42
#define Z_UNICODE_INTERSECTION_WITH_OVERBAR					       0x2A43
#define Z_UNICODE_INTERSECTION_WITH_LOGICAL_AND					       0x2A44
#define Z_UNICODE_UNION_WITH_LOGICAL_OR						       0x2A45
#define Z_UNICODE_UNION_ABOVE_INTERSECTION					       0x2A46
#define Z_UNICODE_INTERSECTION_ABOVE_UNION					       0x2A47
#define Z_UNICODE_UNION_ABOVE_BAR_ABOVE_INTERSECTION				       0x2A48
#define Z_UNICODE_INTERSECTION_ABOVE_BAR_ABOVE_UNION				       0x2A49
#define Z_UNICODE_UNION_BESIDE_AND_JOINED_WITH_UNION				       0x2A4A
#define Z_UNICODE_INTERSECTION_BESIDE_AND_JOINED_WITH_INTERSECTION		       0x2A4B
#define Z_UNICODE_CLOSED_UNION_WITH_SERIFS					       0x2A4C
#define Z_UNICODE_CLOSED_INTERSECTION_WITH_SERIFS				       0x2A4D
#define Z_UNICODE_DOUBLE_SQUARE_INTERSECTION					       0x2A4E
#define Z_UNICODE_DOUBLE_SQUARE_UNION						       0x2A4F
#define Z_UNICODE_CLOSED_UNION_WITH_SERIFS_AND_SMASH_PRODUCT			       0x2A50
#define Z_UNICODE_LOGICAL_AND_WITH_DOT_ABOVE					       0x2A51
#define Z_UNICODE_LOGICAL_OR_WITH_DOT_ABOVE					       0x2A52
#define Z_UNICODE_DOUBLE_LOGICAL_AND						       0x2A53
#define Z_UNICODE_DOUBLE_LOGICAL_OR						       0x2A54
#define Z_UNICODE_TWO_INTERSECTING_LOGICAL_AND					       0x2A55
#define Z_UNICODE_TWO_INTERSECTING_LOGICAL_OR					       0x2A56
#define Z_UNICODE_SLOPING_LARGE_OR						       0x2A57
#define Z_UNICODE_SLOPING_LARGE_AND						       0x2A58
#define Z_UNICODE_LOGICAL_OR_OVERLAPPING_LOGICAL_AND				       0x2A59
#define Z_UNICODE_LOGICAL_AND_WITH_MIDDLE_STEM					       0x2A5A
#define Z_UNICODE_LOGICAL_OR_WITH_MIDDLE_STEM					       0x2A5B
#define Z_UNICODE_LOGICAL_AND_WITH_HORIZONTAL_DASH				       0x2A5C
#define Z_UNICODE_LOGICAL_OR_WITH_HORIZONTAL_DASH				       0x2A5D
#define Z_UNICODE_LOGICAL_AND_WITH_DOUBLE_OVERBAR				       0x2A5E
#define Z_UNICODE_LOGICAL_AND_WITH_UNDERBAR					       0x2A5F
#define Z_UNICODE_LOGICAL_AND_WITH_DOUBLE_UNDERBAR				       0x2A60
#define Z_UNICODE_SMALL_VEE_WITH_UNDERBAR					       0x2A61
#define Z_UNICODE_LOGICAL_OR_WITH_DOUBLE_OVERBAR				       0x2A62
#define Z_UNICODE_LOGICAL_OR_WITH_DOUBLE_UNDERBAR				       0x2A63
#define Z_UNICODE_Z_NOTATION_DOMAIN_ANTIRESTRICTION				       0x2A64
#define Z_UNICODE_Z_NOTATION_RANGE_ANTIRESTRICTION				       0x2A65
#define Z_UNICODE_EQUALS_SIGN_WITH_DOT_BELOW					       0x2A66
#define Z_UNICODE_IDENTICAL_WITH_DOT_ABOVE					       0x2A67
#define Z_UNICODE_TRIPLE_HORIZONTAL_BAR_WITH_DOUBLE_VERTICAL_STROKE		       0x2A68
#define Z_UNICODE_TRIPLE_HORIZONTAL_BAR_WITH_TRIPLE_VERTICAL_STROKE		       0x2A69
#define Z_UNICODE_TILDE_OPERATOR_WITH_DOT_ABOVE					       0x2A6A
#define Z_UNICODE_TILDE_OPERATOR_WITH_RISING_DOTS				       0x2A6B
#define Z_UNICODE_SIMILAR_MINUS_SIMILAR						       0x2A6C
#define Z_UNICODE_CONGRUENT_WITH_DOT_ABOVE					       0x2A6D
#define Z_UNICODE_EQUALS_WITH_ASTERISK						       0x2A6E
#define Z_UNICODE_ALMOST_EQUAL_TO_WITH_CIRCUMFLEX_ACCENT			       0x2A6F
#define Z_UNICODE_APPROXIMATELY_EQUAL_OR_EQUAL_TO				       0x2A70
#define Z_UNICODE_EQUALS_SIGN_ABOVE_PLUS_SIGN					       0x2A71
#define Z_UNICODE_PLUS_SIGN_ABOVE_EQUALS_SIGN					       0x2A72
#define Z_UNICODE_EQUALS_SIGN_ABOVE_TILDE_OPERATOR				       0x2A73
#define Z_UNICODE_DOUBLE_COLON_EQUAL						       0x2A74
#define Z_UNICODE_TWO_CONSECUTIVE_EQUALS_SIGNS					       0x2A75
#define Z_UNICODE_THREE_CONSECUTIVE_EQUALS_SIGNS				       0x2A76
#define Z_UNICODE_EQUALS_SIGN_WITH_TWO_DOTS_ABOVE_AND_TWO_DOTS_BELOW		       0x2A77
#define Z_UNICODE_EQUIVALENT_WITH_FOUR_DOTS_ABOVE				       0x2A78
#define Z_UNICODE_LESS_THAN_WITH_CIRCLE_INSIDE					       0x2A79
#define Z_UNICODE_GREATER_THAN_WITH_CIRCLE_INSIDE				       0x2A7A
#define Z_UNICODE_LESS_THAN_WITH_QUESTION_MARK_ABOVE				       0x2A7B
#define Z_UNICODE_GREATER_THAN_WITH_QUESTION_MARK_ABOVE				       0x2A7C
#define Z_UNICODE_LESS_THAN_OR_SLANTED_EQUAL_TO					       0x2A7D
#define Z_UNICODE_GREATER_THAN_OR_SLANTED_EQUAL_TO				       0x2A7E
#define Z_UNICODE_LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_INSIDE			       0x2A7F
#define Z_UNICODE_GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_INSIDE		       0x2A80
#define Z_UNICODE_LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE			       0x2A81
#define Z_UNICODE_GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE		       0x2A82
#define Z_UNICODE_LESS_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE_RIGHT		       0x2A83
#define Z_UNICODE_GREATER_THAN_OR_SLANTED_EQUAL_TO_WITH_DOT_ABOVE_LEFT		       0x2A84
#define Z_UNICODE_LESS_THAN_OR_APPROXIMATE					       0x2A85
#define Z_UNICODE_GREATER_THAN_OR_APPROXIMATE					       0x2A86
#define Z_UNICODE_LESS_THAN_AND_SINGLE_LINE_NOT_EQUAL_TO			       0x2A87
#define Z_UNICODE_GREATER_THAN_AND_SINGLE_LINE_NOT_EQUAL_TO			       0x2A88
#define Z_UNICODE_LESS_THAN_AND_NOT_APPROXIMATE					       0x2A89
#define Z_UNICODE_GREATER_THAN_AND_NOT_APPROXIMATE				       0x2A8A
#define Z_UNICODE_LESS_THAN_ABOVE_DOUBLE_LINE_EQUAL_ABOVE_GREATER_THAN		       0x2A8B
#define Z_UNICODE_GREATER_THAN_ABOVE_DOUBLE_LINE_EQUAL_ABOVE_LESS_THAN		       0x2A8C
#define Z_UNICODE_LESS_THAN_ABOVE_SIMILAR_OR_EQUAL				       0x2A8D
#define Z_UNICODE_GREATER_THAN_ABOVE_SIMILAR_OR_EQUAL				       0x2A8E
#define Z_UNICODE_LESS_THAN_ABOVE_SIMILAR_ABOVE_GREATER_THAN			       0x2A8F
#define Z_UNICODE_GREATER_THAN_ABOVE_SIMILAR_ABOVE_LESS_THAN			       0x2A90
#define Z_UNICODE_LESS_THAN_ABOVE_GREATER_THAN_ABOVE_DOUBLE_LINE_EQUAL		       0x2A91
#define Z_UNICODE_GREATER_THAN_ABOVE_LESS_THAN_ABOVE_DOUBLE_LINE_EQUAL		       0x2A92
#define Z_UNICODE_LESS_THAN_ABOVE_SLANTED_EQUAL_ABOVE_GREATER_THAN_ABOVE_SLANTED_EQUAL 0x2A93
#define Z_UNICODE_GREATER_THAN_ABOVE_SLANTED_EQUAL_ABOVE_LESS_THAN_ABOVE_SLANTED_EQUAL 0x2A94
#define Z_UNICODE_SLANTED_EQUAL_TO_OR_LESS_THAN					       0x2A95
#define Z_UNICODE_SLANTED_EQUAL_TO_OR_GREATER_THAN				       0x2A96
#define Z_UNICODE_SLANTED_EQUAL_TO_OR_LESS_THAN_WITH_DOT_INSIDE			       0x2A97
#define Z_UNICODE_SLANTED_EQUAL_TO_OR_GREATER_THAN_WITH_DOT_INSIDE		       0x2A98
#define Z_UNICODE_DOUBLE_LINE_EQUAL_TO_OR_LESS_THAN				       0x2A99
#define Z_UNICODE_DOUBLE_LINE_EQUAL_TO_OR_GREATER_THAN				       0x2A9A
#define Z_UNICODE_DOUBLE_LINE_SLANTED_EQUAL_TO_OR_LESS_THAN			       0x2A9B
#define Z_UNICODE_DOUBLE_LINE_SLANTED_EQUAL_TO_OR_GREATER_THAN			       0x2A9C
#define Z_UNICODE_SIMILAR_OR_LESS_THAN						       0x2A9D
#define Z_UNICODE_SIMILAR_OR_GREATER_THAN					       0x2A9E
#define Z_UNICODE_SIMILAR_ABOVE_LESS_THAN_ABOVE_EQUALS_SIGN			       0x2A9F
#define Z_UNICODE_SIMILAR_ABOVE_GREATER_THAN_ABOVE_EQUALS_SIGN			       0x2AA0
#define Z_UNICODE_DOUBLE_NESTED_LESS_THAN					       0x2AA1
#define Z_UNICODE_DOUBLE_NESTED_GREATER_THAN					       0x2AA2
#define Z_UNICODE_DOUBLE_NESTED_LESS_THAN_WITH_UNDERBAR				       0x2AA3
#define Z_UNICODE_GREATER_THAN_OVERLAPPING_LESS_THAN				       0x2AA4
#define Z_UNICODE_GREATER_THAN_BESIDE_LESS_THAN					       0x2AA5
#define Z_UNICODE_LESS_THAN_CLOSED_BY_CURVE					       0x2AA6
#define Z_UNICODE_GREATER_THAN_CLOSED_BY_CURVE					       0x2AA7
#define Z_UNICODE_LESS_THAN_CLOSED_BY_CURVE_ABOVE_SLANTED_EQUAL			       0x2AA8
#define Z_UNICODE_GREATER_THAN_CLOSED_BY_CURVE_ABOVE_SLANTED_EQUAL		       0x2AA9
#define Z_UNICODE_SMALLER_THAN							       0x2AAA
#define Z_UNICODE_LARGER_THAN							       0x2AAB
#define Z_UNICODE_SMALLER_THAN_OR_EQUAL_TO					       0x2AAC
#define Z_UNICODE_LARGER_THAN_OR_EQUAL_TO					       0x2AAD
#define Z_UNICODE_EQUALS_SIGN_WITH_BUMPY_ABOVE					       0x2AAE
#define Z_UNICODE_PRECEDES_ABOVE_SINGLE_LINE_EQUALS_SIGN			       0x2AAF
#define Z_UNICODE_SUCCEEDS_ABOVE_SINGLE_LINE_EQUALS_SIGN			       0x2AB0
#define Z_UNICODE_PRECEDES_ABOVE_SINGLE_LINE_NOT_EQUAL_TO			       0x2AB1
#define Z_UNICODE_SUCCEEDS_ABOVE_SINGLE_LINE_NOT_EQUAL_TO			       0x2AB2
#define Z_UNICODE_PRECEDES_ABOVE_EQUALS_SIGN					       0x2AB3
#define Z_UNICODE_SUCCEEDS_ABOVE_EQUALS_SIGN					       0x2AB4
#define Z_UNICODE_PRECEDES_ABOVE_NOT_EQUAL_TO					       0x2AB5
#define Z_UNICODE_SUCCEEDS_ABOVE_NOT_EQUAL_TO					       0x2AB6
#define Z_UNICODE_PRECEDES_ABOVE_ALMOST_EQUAL_TO				       0x2AB7
#define Z_UNICODE_SUCCEEDS_ABOVE_ALMOST_EQUAL_TO				       0x2AB8
#define Z_UNICODE_PRECEDES_ABOVE_NOT_ALMOST_EQUAL_TO				       0x2AB9
#define Z_UNICODE_SUCCEEDS_ABOVE_NOT_ALMOST_EQUAL_TO				       0x2ABA
#define Z_UNICODE_DOUBLE_PRECEDES						       0x2ABB
#define Z_UNICODE_DOUBLE_SUCCEEDS						       0x2ABC
#define Z_UNICODE_SUBSET_WITH_DOT						       0x2ABD
#define Z_UNICODE_SUPERSET_WITH_DOT						       0x2ABE
#define Z_UNICODE_SUBSET_WITH_PLUS_SIGN_BELOW					       0x2ABF
#define Z_UNICODE_SUPERSET_WITH_PLUS_SIGN_BELOW					       0x2AC0
#define Z_UNICODE_SUBSET_WITH_MULTIPLICATION_SIGN_BELOW				       0x2AC1
#define Z_UNICODE_SUPERSET_WITH_MULTIPLICATION_SIGN_BELOW			       0x2AC2
#define Z_UNICODE_SUBSET_OF_OR_EQUAL_TO_WITH_DOT_ABOVE				       0x2AC3
#define Z_UNICODE_SUPERSET_OF_OR_EQUAL_TO_WITH_DOT_ABOVE			       0x2AC4
#define Z_UNICODE_SUBSET_OF_ABOVE_EQUALS_SIGN					       0x2AC5
#define Z_UNICODE_SUPERSET_OF_ABOVE_EQUALS_SIGN					       0x2AC6
#define Z_UNICODE_SUBSET_OF_ABOVE_TILDE_OPERATOR				       0x2AC7
#define Z_UNICODE_SUPERSET_OF_ABOVE_TILDE_OPERATOR				       0x2AC8
#define Z_UNICODE_SUBSET_OF_ABOVE_ALMOST_EQUAL_TO				       0x2AC9
#define Z_UNICODE_SUPERSET_OF_ABOVE_ALMOST_EQUAL_TO				       0x2ACA
#define Z_UNICODE_SUBSET_OF_ABOVE_NOT_EQUAL_TO					       0x2ACB
#define Z_UNICODE_SUPERSET_OF_ABOVE_NOT_EQUAL_TO				       0x2ACC
#define Z_UNICODE_SQUARE_LEFT_OPEN_BOX_OPERATOR					       0x2ACD
#define Z_UNICODE_SQUARE_RIGHT_OPEN_BOX_OPERATOR				       0x2ACE
#define Z_UNICODE_CLOSED_SUBSET							       0x2ACF
#define Z_UNICODE_CLOSED_SUPERSET						       0x2AD0
#define Z_UNICODE_CLOSED_SUBSET_OR_EQUAL_TO					       0x2AD1
#define Z_UNICODE_CLOSED_SUPERSET_OR_EQUAL_TO					       0x2AD2
#define Z_UNICODE_SUBSET_ABOVE_SUPERSET						       0x2AD3
#define Z_UNICODE_SUPERSET_ABOVE_SUBSET						       0x2AD4
#define Z_UNICODE_SUBSET_ABOVE_SUBSET						       0x2AD5
#define Z_UNICODE_SUPERSET_ABOVE_SUPERSET					       0x2AD6
#define Z_UNICODE_SUPERSET_BESIDE_SUBSET					       0x2AD7
#define Z_UNICODE_SUPERSET_BESIDE_AND_JOINED_BY_DASH_WITH_SUBSET		       0x2AD8
#define Z_UNICODE_ELEMENT_OF_OPENING_DOWNWARDS					       0x2AD9
#define Z_UNICODE_PITCHFORK_WITH_TEE_TOP					       0x2ADA
#define Z_UNICODE_TRANSVERSAL_INTERSECTION					       0x2ADB
#define Z_UNICODE_FORKING							       0x2ADC
#define Z_UNICODE_NONFORKING							       0x2ADD
#define Z_UNICODE_SHORT_LEFT_TACK						       0x2ADE
#define Z_UNICODE_SHORT_DOWN_TACK						       0x2ADF
#define Z_UNICODE_SHORT_UP_TACK							       0x2AE0
#define Z_UNICODE_PERPENDICULAR_WITH_S						       0x2AE1
#define Z_UNICODE_VERTICAL_BAR_TRIPLE_RIGHT_TURNSTILE				       0x2AE2
#define Z_UNICODE_DOUBLE_VERTICAL_BAR_LEFT_TURNSTILE				       0x2AE3
#define Z_UNICODE_VERTICAL_BAR_DOUBLE_LEFT_TURNSTILE				       0x2AE4
#define Z_UNICODE_DOUBLE_VERTICAL_BAR_DOUBLE_LEFT_TURNSTILE			       0x2AE5
#define Z_UNICODE_LONG_DASH_FROM_LEFT_MEMBER_OF_DOUBLE_VERTICAL			       0x2AE6
#define Z_UNICODE_SHORT_DOWN_TACK_WITH_OVERBAR					       0x2AE7
#define Z_UNICODE_SHORT_UP_TACK_WITH_UNDERBAR					       0x2AE8
#define Z_UNICODE_SHORT_UP_TACK_ABOVE_SHORT_DOWN_TACK				       0x2AE9
#define Z_UNICODE_DOUBLE_DOWN_TACK						       0x2AEA
#define Z_UNICODE_DOUBLE_UP_TACK						       0x2AEB
#define Z_UNICODE_DOUBLE_STROKE_NOT_SIGN					       0x2AEC
#define Z_UNICODE_REVERSED_DOUBLE_STROKE_NOT_SIGN				       0x2AED
#define Z_UNICODE_DOES_NOT_DIVIDE_WITH_REVERSED_NEGATION_SLASH			       0x2AEE
#define Z_UNICODE_VERTICAL_LINE_WITH_CIRCLE_ABOVE				       0x2AEF
#define Z_UNICODE_VERTICAL_LINE_WITH_CIRCLE_BELOW				       0x2AF0
#define Z_UNICODE_DOWN_TACK_WITH_CIRCLE_BELOW					       0x2AF1
#define Z_UNICODE_PARALLEL_WITH_HORIZONTAL_STROKE				       0x2AF2
#define Z_UNICODE_PARALLEL_WITH_TILDE_OPERATOR					       0x2AF3
#define Z_UNICODE_TRIPLE_VERTICAL_BAR_BINARY_RELATION				       0x2AF4
#define Z_UNICODE_TRIPLE_VERTICAL_BAR_WITH_HORIZONTAL_STROKE			       0x2AF5
#define Z_UNICODE_TRIPLE_COLON_OPERATOR						       0x2AF6
#define Z_UNICODE_TRIPLE_NESTED_LESS_THAN					       0x2AF7
#define Z_UNICODE_TRIPLE_NESTED_GREATER_THAN					       0x2AF8
#define Z_UNICODE_DOUBLE_LINE_SLANTED_LESS_THAN_OR_EQUAL_TO			       0x2AF9
#define Z_UNICODE_DOUBLE_LINE_SLANTED_GREATER_THAN_OR_EQUAL_TO			       0x2AFA
#define Z_UNICODE_TRIPLE_SOLIDUS_BINARY_RELATION				       0x2AFB
#define Z_UNICODE_LARGE_TRIPLE_VERTICAL_BAR_OPERATOR				       0x2AFC
#define Z_UNICODE_DOUBLE_SOLIDUS_OPERATOR					       0x2AFD
#define Z_UNICODE_WHITE_VERTICAL_BAR						       0x2AFE
#define Z_UNICODE_N_ARY_WHITE_VERTICAL_BAR					       0x2AFF

/* MARK: - 2B00h-2BFFh - Miscellaneous Symbols and Arrows */

#define Z_UNICODE_NORTH_EAST_WHITE_ARROW						     0x2B00
#define Z_UNICODE_NORTH_WEST_WHITE_ARROW						     0x2B01
#define Z_UNICODE_SOUTH_EAST_WHITE_ARROW						     0x2B02
#define Z_UNICODE_SOUTH_WEST_WHITE_ARROW						     0x2B03
#define Z_UNICODE_LEFT_RIGHT_WHITE_ARROW						     0x2B04
#define Z_UNICODE_LEFTWARDS_BLACK_ARROW							     0x2B05
#define Z_UNICODE_UPWARDS_BLACK_ARROW							     0x2B06
#define Z_UNICODE_DOWNWARDS_BLACK_ARROW							     0x2B07
#define Z_UNICODE_NORTH_EAST_BLACK_ARROW						     0x2B08
#define Z_UNICODE_NORTH_WEST_BLACK_ARROW						     0x2B09
#define Z_UNICODE_SOUTH_EAST_BLACK_ARROW						     0x2B0A
#define Z_UNICODE_SOUTH_WEST_BLACK_ARROW						     0x2B0B
#define Z_UNICODE_LEFT_RIGHT_BLACK_ARROW						     0x2B0C
#define Z_UNICODE_UP_DOWN_BLACK_ARROW							     0x2B0D
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_TIP_DOWNWARDS					     0x2B0E
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_TIP_UPWARDS					     0x2B0F
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_TIP_DOWNWARDS					     0x2B10
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_TIP_UPWARDS					     0x2B11
#define Z_UNICODE_SQUARE_WITH_TOP_HALF_BLACK						     0x2B12
#define Z_UNICODE_SQUARE_WITH_BOTTOM_HALF_BLACK						     0x2B13
#define Z_UNICODE_SQUARE_WITH_UPPER_RIGHT_DIAGONAL_HALF_BLACK				     0x2B14
#define Z_UNICODE_SQUARE_WITH_LOWER_LEFT_DIAGONAL_HALF_BLACK				     0x2B15
#define Z_UNICODE_DIAMOND_WITH_LEFT_HALF_BLACK						     0x2B16
#define Z_UNICODE_DIAMOND_WITH_RIGHT_HALF_BLACK						     0x2B17
#define Z_UNICODE_DIAMOND_WITH_TOP_HALF_BLACK						     0x2B18
#define Z_UNICODE_DIAMOND_WITH_BOTTOM_HALF_BLACK					     0x2B19
#define Z_UNICODE_DOTTED_SQUARE								     0x2B1A
#define Z_UNICODE_BLACK_LARGE_SQUARE							     0x2B1B
#define Z_UNICODE_WHITE_LARGE_SQUARE							     0x2B1C
#define Z_UNICODE_BLACK_VERY_SMALL_SQUARE						     0x2B1D
#define Z_UNICODE_WHITE_VERY_SMALL_SQUARE						     0x2B1E
#define Z_UNICODE_BLACK_PENTAGON							     0x2B1F
#define Z_UNICODE_WHITE_PENTAGON							     0x2B20
#define Z_UNICODE_WHITE_HEXAGON								     0x2B21
#define Z_UNICODE_BLACK_HEXAGON								     0x2B22
#define Z_UNICODE_HORIZONTAL_BLACK_HEXAGON						     0x2B23
#define Z_UNICODE_BLACK_LARGE_CIRCLE							     0x2B24
#define Z_UNICODE_BLACK_MEDIUM_DIAMOND							     0x2B25
#define Z_UNICODE_WHITE_MEDIUM_DIAMOND							     0x2B26
#define Z_UNICODE_BLACK_MEDIUM_LOZENGE							     0x2B27
#define Z_UNICODE_WHITE_MEDIUM_LOZENGE							     0x2B28
#define Z_UNICODE_BLACK_SMALL_DIAMOND							     0x2B29
#define Z_UNICODE_BLACK_SMALL_LOZENGE							     0x2B2A
#define Z_UNICODE_WHITE_SMALL_LOZENGE							     0x2B2B
#define Z_UNICODE_BLACK_HORIZONTAL_ELLIPSE						     0x2B2C
#define Z_UNICODE_WHITE_HORIZONTAL_ELLIPSE						     0x2B2D
#define Z_UNICODE_BLACK_VERTICAL_ELLIPSE						     0x2B2E
#define Z_UNICODE_WHITE_VERTICAL_ELLIPSE						     0x2B2F
#define Z_UNICODE_LEFT_ARROW_WITH_SMALL_CIRCLE						     0x2B30
#define Z_UNICODE_THREE_LEFTWARDS_ARROWS						     0x2B31
#define Z_UNICODE_LEFT_ARROW_WITH_CIRCLED_PLUS						     0x2B32
#define Z_UNICODE_LONG_LEFTWARDS_SQUIGGLE_ARROW						     0x2B33
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_ARROW_WITH_VERTICAL_STROKE			     0x2B34
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_ARROW_WITH_DOUBLE_VERTICAL_STROKE		     0x2B35
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_ARROW_FROM_BAR					     0x2B36
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_TRIPLE_DASH_ARROW				     0x2B37
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_DOTTED_STEM					     0x2B38
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE			     0x2B39
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE			     0x2B3A
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL					     0x2B3B
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_VERTICAL_STROKE		     0x2B3C
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_ARROW_WITH_TAIL_WITH_DOUBLE_VERTICAL_STROKE	     0x2B3D
#define Z_UNICODE_LEFTWARDS_ARROW_THROUGH_X						     0x2B3E
#define Z_UNICODE_WAVE_ARROW_POINTING_DIRECTLY_LEFT					     0x2B3F
#define Z_UNICODE_EQUALS_SIGN_ABOVE_LEFTWARDS_ARROW					     0x2B40
#define Z_UNICODE_REVERSE_TILDE_OPERATOR_ABOVE_LEFTWARDS_ARROW				     0x2B41
#define Z_UNICODE_LEFTWARDS_ARROW_ABOVE_REVERSE_ALMOST_EQUAL_TO				     0x2B42
#define Z_UNICODE_RIGHTWARDS_ARROW_THROUGH_GREATER_THAN					     0x2B43
#define Z_UNICODE_RIGHTWARDS_ARROW_THROUGH_SUPERSET					     0x2B44
#define Z_UNICODE_LEFTWARDS_QUADRUPLE_ARROW						     0x2B45
#define Z_UNICODE_RIGHTWARDS_QUADRUPLE_ARROW						     0x2B46
#define Z_UNICODE_REVERSE_TILDE_OPERATOR_ABOVE_RIGHTWARDS_ARROW				     0x2B47
#define Z_UNICODE_RIGHTWARDS_ARROW_ABOVE_REVERSE_ALMOST_EQUAL_TO			     0x2B48
#define Z_UNICODE_TILDE_OPERATOR_ABOVE_LEFTWARDS_ARROW					     0x2B49
#define Z_UNICODE_LEFTWARDS_ARROW_ABOVE_ALMOST_EQUAL_TO					     0x2B4A
#define Z_UNICODE_LEFTWARDS_ARROW_ABOVE_REVERSE_TILDE_OPERATOR				     0x2B4B
#define Z_UNICODE_RIGHTWARDS_ARROW_ABOVE_REVERSE_TILDE_OPERATOR				     0x2B4C
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ZIGZAG_ARROW				     0x2B4D
#define Z_UNICODE_SHORT_SLANTED_NORTH_ARROW						     0x2B4E
#define Z_UNICODE_SHORT_BACKSLANTED_SOUTH_ARROW						     0x2B4F
#define Z_UNICODE_WHITE_MEDIUM_STAR							     0x2B50
#define Z_UNICODE_BLACK_SMALL_STAR							     0x2B51
#define Z_UNICODE_WHITE_SMALL_STAR							     0x2B52
#define Z_UNICODE_BLACK_RIGHT_POINTING_PENTAGON						     0x2B53
#define Z_UNICODE_WHITE_RIGHT_POINTING_PENTAGON						     0x2B54
#define Z_UNICODE_HEAVY_LARGE_CIRCLE							     0x2B55
#define Z_UNICODE_HEAVY_OVAL_WITH_OVAL_INSIDE						     0x2B56
#define Z_UNICODE_HEAVY_CIRCLE_WITH_CIRCLE_INSIDE					     0x2B57
#define Z_UNICODE_HEAVY_CIRCLE								     0x2B58
#define Z_UNICODE_HEAVY_CIRCLED_SALTIRE							     0x2B59
#define Z_UNICODE_SLANTED_NORTH_ARROW_WITH_HOOKED_HEAD					     0x2B5A
#define Z_UNICODE_BACKSLANTED_SOUTH_ARROW_WITH_HOOKED_TAIL				     0x2B5B
#define Z_UNICODE_SLANTED_NORTH_ARROW_WITH_HORIZONTAL_TAIL				     0x2B5C
#define Z_UNICODE_BACKSLANTED_SOUTH_ARROW_WITH_HORIZONTAL_TAIL				     0x2B5D
#define Z_UNICODE_BENT_ARROW_POINTING_DOWNWARDS_THEN_NORTH_EAST				     0x2B5E
#define Z_UNICODE_SHORT_BENT_ARROW_POINTING_DOWNWARDS_THEN_NORTH_EAST			     0x2B5F
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW					     0x2B60
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW						     0x2B61
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW					     0x2B62
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW					     0x2B63
#define Z_UNICODE_LEFT_RIGHT_TRIANGLE_HEADED_ARROW					     0x2B64
#define Z_UNICODE_UP_DOWN_TRIANGLE_HEADED_ARROW						     0x2B65
#define Z_UNICODE_NORTH_WEST_TRIANGLE_HEADED_ARROW					     0x2B66
#define Z_UNICODE_NORTH_EAST_TRIANGLE_HEADED_ARROW					     0x2B67
#define Z_UNICODE_SOUTH_EAST_TRIANGLE_HEADED_ARROW					     0x2B68
#define Z_UNICODE_SOUTH_WEST_TRIANGLE_HEADED_ARROW					     0x2B69
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_DASHED_ARROW				     0x2B6A
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_DASHED_ARROW					     0x2B6B
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_DASHED_ARROW				     0x2B6C
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_DASHED_ARROW				     0x2B6D
#define Z_UNICODE_CLOCKWISE_TRIANGLE_HEADED_OPEN_CIRCLE_ARROW				     0x2B6E
#define Z_UNICODE_ANTICLOCKWISE_TRIANGLE_HEADED_OPEN_CIRCLE_ARROW			     0x2B6F
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_TO_BAR				     0x2B70
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_TO_BAR					     0x2B71
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_TO_BAR				     0x2B72
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_TO_BAR				     0x2B73
#define Z_UNICODE_NORTH_WEST_TRIANGLE_HEADED_ARROW_TO_BAR				     0x2B76
#define Z_UNICODE_NORTH_EAST_TRIANGLE_HEADED_ARROW_TO_BAR				     0x2B77
#define Z_UNICODE_SOUTH_EAST_TRIANGLE_HEADED_ARROW_TO_BAR				     0x2B78
#define Z_UNICODE_SOUTH_WEST_TRIANGLE_HEADED_ARROW_TO_BAR				     0x2B79
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE		     0x2B7A
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE		     0x2B7B
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE	     0x2B7C
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_DOUBLE_HORIZONTAL_STROKE		     0x2B7D
#define Z_UNICODE_HORIZONTAL_TAB_KEY							     0x2B7E
#define Z_UNICODE_VERTICAL_TAB_KEY							     0x2B7F
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_OVER_RIGHTWARDS_TRIANGLE_HEADED_ARROW	     0x2B80
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_LEFTWARDS_OF_DOWNWARDS_TRIANGLE_HEADED_ARROW 0x2B81
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_OVER_LEFTWARDS_TRIANGLE_HEADED_ARROW	     0x2B82
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_LEFTWARDS_OF_UPWARDS_TRIANGLE_HEADED_ARROW 0x2B83
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_PAIRED_ARROWS				     0x2B84
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_PAIRED_ARROWS					     0x2B85
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_PAIRED_ARROWS				     0x2B86
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_PAIRED_ARROWS				     0x2B87
#define Z_UNICODE_LEFTWARDS_BLACK_CIRCLED_WHITE_ARROW					     0x2B88
#define Z_UNICODE_UPWARDS_BLACK_CIRCLED_WHITE_ARROW					     0x2B89
#define Z_UNICODE_RIGHTWARDS_BLACK_CIRCLED_WHITE_ARROW					     0x2B8A
#define Z_UNICODE_DOWNWARDS_BLACK_CIRCLED_WHITE_ARROW					     0x2B8B
#define Z_UNICODE_ANTICLOCKWISE_TRIANGLE_HEADED_RIGHT_U_SHAPED_ARROW			     0x2B8C
#define Z_UNICODE_ANTICLOCKWISE_TRIANGLE_HEADED_BOTTOM_U_SHAPED_ARROW			     0x2B8D
#define Z_UNICODE_ANTICLOCKWISE_TRIANGLE_HEADED_LEFT_U_SHAPED_ARROW			     0x2B8E
#define Z_UNICODE_ANTICLOCKWISE_TRIANGLE_HEADED_TOP_U_SHAPED_ARROW			     0x2B8F
#define Z_UNICODE_RETURN_LEFT								     0x2B90
#define Z_UNICODE_RETURN_RIGHT								     0x2B91
#define Z_UNICODE_NEWLINE_LEFT								     0x2B92
#define Z_UNICODE_NEWLINE_RIGHT								     0x2B93
#define Z_UNICODE_FOUR_CORNER_ARROWS_CIRCLING_ANTICLOCKWISE				     0x2B94
#define Z_UNICODE_RIGHTWARDS_BLACK_ARROW						     0x2B95
#define Z_UNICODE_THREE_D_TOP_LIGHTED_LEFTWARDS_EQUILATERAL_ARROWHEAD			     0x2B98
#define Z_UNICODE_THREE_D_RIGHT_LIGHTED_UPWARDS_EQUILATERAL_ARROWHEAD			     0x2B99
#define Z_UNICODE_THREE_D_TOP_LIGHTED_RIGHTWARDS_EQUILATERAL_ARROWHEAD			     0x2B9A
#define Z_UNICODE_THREE_D_LEFT_LIGHTED_DOWNWARDS_EQUILATERAL_ARROWHEAD			     0x2B9B
#define Z_UNICODE_BLACK_LEFTWARDS_EQUILATERAL_ARROWHEAD					     0x2B9C
#define Z_UNICODE_BLACK_UPWARDS_EQUILATERAL_ARROWHEAD					     0x2B9D
#define Z_UNICODE_BLACK_RIGHTWARDS_EQUILATERAL_ARROWHEAD				     0x2B9E
#define Z_UNICODE_BLACK_DOWNWARDS_EQUILATERAL_ARROWHEAD					     0x2B9F
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_LEFTWARDS		     0x2BA0
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_RIGHTWARDS		     0x2BA1
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_LEFTWARDS			     0x2BA2
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_RIGHTWARDS		     0x2BA3
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_UPWARDS			     0x2BA4
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_UPWARDS		     0x2BA5
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_DOWNWARDS		     0x2BA6
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_LONG_TIP_DOWNWARDS		     0x2BA7
#define Z_UNICODE_BLACK_CURVED_DOWNWARDS_AND_LEFTWARDS_ARROW				     0x2BA8
#define Z_UNICODE_BLACK_CURVED_DOWNWARDS_AND_RIGHTWARDS_ARROW				     0x2BA9
#define Z_UNICODE_BLACK_CURVED_UPWARDS_AND_LEFTWARDS_ARROW				     0x2BAA
#define Z_UNICODE_BLACK_CURVED_UPWARDS_AND_RIGHTWARDS_ARROW				     0x2BAB
#define Z_UNICODE_BLACK_CURVED_LEFTWARDS_AND_UPWARDS_ARROW				     0x2BAC
#define Z_UNICODE_BLACK_CURVED_RIGHTWARDS_AND_UPWARDS_ARROW				     0x2BAD
#define Z_UNICODE_BLACK_CURVED_LEFTWARDS_AND_DOWNWARDS_ARROW				     0x2BAE
#define Z_UNICODE_BLACK_CURVED_RIGHTWARDS_AND_DOWNWARDS_ARROW				     0x2BAF
#define Z_UNICODE_RIBBON_ARROW_DOWN_LEFT						     0x2BB0
#define Z_UNICODE_RIBBON_ARROW_DOWN_RIGHT						     0x2BB1
#define Z_UNICODE_RIBBON_ARROW_UP_LEFT							     0x2BB2
#define Z_UNICODE_RIBBON_ARROW_UP_RIGHT							     0x2BB3
#define Z_UNICODE_RIBBON_ARROW_LEFT_UP							     0x2BB4
#define Z_UNICODE_RIBBON_ARROW_RIGHT_UP							     0x2BB5
#define Z_UNICODE_RIBBON_ARROW_LEFT_DOWN						     0x2BB6
#define Z_UNICODE_RIBBON_ARROW_RIGHT_DOWN						     0x2BB7
#define Z_UNICODE_UPWARDS_WHITE_ARROW_FROM_BAR_WITH_HORIZONTAL_BAR			     0x2BB8
#define Z_UNICODE_UP_ARROWHEAD_IN_A_RECTANGLE_BOX					     0x2BB9
#define Z_UNICODE_BALLOT_BOX_WITH_LIGHT_X						     0x2BBD
#define Z_UNICODE_CIRCLED_X								     0x2BBE
#define Z_UNICODE_CIRCLED_BOLD_X							     0x2BBF
#define Z_UNICODE_BLACK_SQUARE_CENTRED							     0x2BC0
#define Z_UNICODE_BLACK_DIAMOND_CENTRED							     0x2BC1
#define Z_UNICODE_TURNED_BLACK_PENTAGON							     0x2BC2
#define Z_UNICODE_HORIZONTAL_BLACK_OCTAGON						     0x2BC3
#define Z_UNICODE_BLACK_OCTAGON								     0x2BC4
#define Z_UNICODE_BLACK_MEDIUM_UP_POINTING_TRIANGLE_CENTRED				     0x2BC5
#define Z_UNICODE_BLACK_MEDIUM_DOWN_POINTING_TRIANGLE_CENTRED				     0x2BC6
#define Z_UNICODE_BLACK_MEDIUM_LEFT_POINTING_TRIANGLE_CENTRED				     0x2BC7
#define Z_UNICODE_BLACK_MEDIUM_RIGHT_POINTING_TRIANGLE_CENTRED				     0x2BC8
#define Z_UNICODE_TOP_HALF_BLACK_CIRCLE							     0x2BCA
#define Z_UNICODE_BOTTOM_HALF_BLACK_CIRCLE						     0x2BCB
#define Z_UNICODE_LIGHT_FOUR_POINTED_BLACK_CUSP						     0x2BCC
#define Z_UNICODE_ROTATED_LIGHT_FOUR_POINTED_BLACK_CUSP					     0x2BCD
#define Z_UNICODE_WHITE_FOUR_POINTED_CUSP						     0x2BCE
#define Z_UNICODE_ROTATED_WHITE_FOUR_POINTED_CUSP					     0x2BCF
#define Z_UNICODE_SQUARE_POSITION_INDICATOR						     0x2BD0
#define Z_UNICODE_UNCERTAINTY_SIGN							     0x2BD1
#define Z_UNICODE_LEFTWARDS_TWO_HEADED_ARROW_WITH_TRIANGLE_ARROWHEADS			     0x2BEC
#define Z_UNICODE_UPWARDS_TWO_HEADED_ARROW_WITH_TRIANGLE_ARROWHEADS			     0x2BED
#define Z_UNICODE_RIGHTWARDS_TWO_HEADED_ARROW_WITH_TRIANGLE_ARROWHEADS			     0x2BEE
#define Z_UNICODE_DOWNWARDS_TWO_HEADED_ARROW_WITH_TRIANGLE_ARROWHEADS			     0x2BEF

/* MARK: - 2C00h-2C5Fh - Glagolitic */

#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_AZU			0x2C00
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_BUKY		0x2C01
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_VEDE		0x2C02
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_GLAGOLI		0x2C03
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_DOBRO		0x2C04
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_YESTU		0x2C05
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_ZHIVETE		0x2C06
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_DZELO		0x2C07
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_ZEMLJA		0x2C08
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_IZHE		0x2C09
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_INITIAL_IZHE	0x2C0A
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_I			0x2C0B
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_DJERVI		0x2C0C
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_KAKO		0x2C0D
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_LJUDIJE		0x2C0E
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_MYSLITE		0x2C0F
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_NASHI		0x2C10
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_ONU			0x2C11
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_POKOJI		0x2C12
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_RITSI		0x2C13
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_SLOVO		0x2C14
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_TVRIDO		0x2C15
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_UKU			0x2C16
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_FRITU		0x2C17
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_HERU		0x2C18
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_OTU			0x2C19
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_PE			0x2C1A
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_SHTA		0x2C1B
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_TSI			0x2C1C
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_CHRIVI		0x2C1D
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_SHA			0x2C1E
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_YERU		0x2C1F
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_YERI		0x2C20
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_YATI		0x2C21
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_SPIDERY_HA		0x2C22
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_YU			0x2C23
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_SMALL_YUS		0x2C24
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_SMALL_YUS_WITH_TAIL	0x2C25
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_YO			0x2C26
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_IOTATED_SMALL_YUS	0x2C27
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_BIG_YUS		0x2C28
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_IOTATED_BIG_YUS	0x2C29
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_FITA		0x2C2A
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_IZHITSA		0x2C2B
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_SHTAPIC		0x2C2C
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_TROKUTASTI_A	0x2C2D
#define Z_UNICODE_GLAGOLITIC_CAPITAL_LETTER_LATINATE_MYSLITE	0x2C2E
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_AZU			0x2C30
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_BUKY			0x2C31
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_VEDE			0x2C32
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_GLAGOLI		0x2C33
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_DOBRO			0x2C34
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_YESTU			0x2C35
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_ZHIVETE		0x2C36
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_DZELO			0x2C37
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_ZEMLJA		0x2C38
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_IZHE			0x2C39
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_INITIAL_IZHE		0x2C3A
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_I			0x2C3B
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_DJERVI		0x2C3C
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_KAKO			0x2C3D
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_LJUDIJE		0x2C3E
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_MYSLITE		0x2C3F
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_NASHI			0x2C40
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_ONU			0x2C41
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_POKOJI		0x2C42
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_RITSI			0x2C43
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_SLOVO			0x2C44
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_TVRIDO		0x2C45
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_UKU			0x2C46
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_FRITU			0x2C47
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_HERU			0x2C48
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_OTU			0x2C49
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_PE			0x2C4A
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_SHTA			0x2C4B
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_TSI			0x2C4C
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_CHRIVI		0x2C4D
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_SHA			0x2C4E
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_YERU			0x2C4F
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_YERI			0x2C50
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_YATI			0x2C51
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_SPIDERY_HA		0x2C52
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_YU			0x2C53
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_SMALL_YUS		0x2C54
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_SMALL_YUS_WITH_TAIL	0x2C55
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_YO			0x2C56
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_IOTATED_SMALL_YUS	0x2C57
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_BIG_YUS		0x2C58
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_IOTATED_BIG_YUS	0x2C59
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_FITA			0x2C5A
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_IZHITSA		0x2C5B
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_SHTAPIC		0x2C5C
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_TROKUTASTI_A		0x2C5D
#define Z_UNICODE_GLAGOLITIC_SMALL_LETTER_LATINATE_MYSLITE	0x2C5E

/* MARK: - 2C60h-2C7Fh - Latin Extended-C */

#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_DOUBLE_BAR    0x2C60
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_DOUBLE_BAR	    0x2C61
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_MIDDLE_TILDE  0x2C62
#define Z_UNICODE_LATIN_CAPITAL_LETTER_P_WITH_STROKE	    0x2C63
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_TAIL	    0x2C64
#define Z_UNICODE_LATIN_SMALL_LETTER_A_WITH_STROKE	    0x2C65
#define Z_UNICODE_LATIN_SMALL_LETTER_T_WITH_DIAGONAL_STROKE 0x2C66
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_DESCENDER	    0x2C67
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_DESCENDER	    0x2C68
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_DESCENDER	    0x2C69
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_DESCENDER	    0x2C6A
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_DESCENDER	    0x2C6B
#define Z_UNICODE_LATIN_SMALL_LETTER_Z_WITH_DESCENDER	    0x2C6C
#define Z_UNICODE_LATIN_CAPITAL_LETTER_ALPHA		    0x2C6D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_M_WITH_HOOK	    0x2C6E
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_A		    0x2C6F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_ALPHA	    0x2C70
#define Z_UNICODE_LATIN_SMALL_LETTER_V_WITH_RIGHT_HOOK	    0x2C71
#define Z_UNICODE_LATIN_CAPITAL_LETTER_W_WITH_HOOK	    0x2C72
#define Z_UNICODE_LATIN_SMALL_LETTER_W_WITH_HOOK	    0x2C73
#define Z_UNICODE_LATIN_SMALL_LETTER_V_WITH_CURL	    0x2C74
#define Z_UNICODE_LATIN_CAPITAL_LETTER_HALF_H		    0x2C75
#define Z_UNICODE_LATIN_SMALL_LETTER_HALF_H		    0x2C76
#define Z_UNICODE_LATIN_SMALL_LETTER_TAILLESS_PHI	    0x2C77
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_NOTCH	    0x2C78
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_R_WITH_TAIL	    0x2C79
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_LOW_RING_INSIDE 0x2C7A
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_TURNED_E	    0x2C7B
#define Z_UNICODE_LATIN_SUBSCRIPT_SMALL_LETTER_J	    0x2C7C
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_V		    0x2C7D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_SWASH_TAIL    0x2C7E
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Z_WITH_SWASH_TAIL    0x2C7F

/* MARK: - 2C80h-2CFFh - Coptic */

#define Z_UNICODE_COPTIC_CAPITAL_LETTER_ALFA		     0x2C80
#define Z_UNICODE_COPTIC_SMALL_LETTER_ALFA		     0x2C81
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_VIDA		     0x2C82
#define Z_UNICODE_COPTIC_SMALL_LETTER_VIDA		     0x2C83
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_GAMMA		     0x2C84
#define Z_UNICODE_COPTIC_SMALL_LETTER_GAMMA		     0x2C85
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_DALDA		     0x2C86
#define Z_UNICODE_COPTIC_SMALL_LETTER_DALDA		     0x2C87
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_EIE		     0x2C88
#define Z_UNICODE_COPTIC_SMALL_LETTER_EIE		     0x2C89
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_SOU		     0x2C8A
#define Z_UNICODE_COPTIC_SMALL_LETTER_SOU		     0x2C8B
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_ZATA		     0x2C8C
#define Z_UNICODE_COPTIC_SMALL_LETTER_ZATA		     0x2C8D
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_HATE		     0x2C8E
#define Z_UNICODE_COPTIC_SMALL_LETTER_HATE		     0x2C8F
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_THETHE		     0x2C90
#define Z_UNICODE_COPTIC_SMALL_LETTER_THETHE		     0x2C91
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_IAUDA		     0x2C92
#define Z_UNICODE_COPTIC_SMALL_LETTER_IAUDA		     0x2C93
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_KAPA		     0x2C94
#define Z_UNICODE_COPTIC_SMALL_LETTER_KAPA		     0x2C95
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_LAULA		     0x2C96
#define Z_UNICODE_COPTIC_SMALL_LETTER_LAULA		     0x2C97
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_MI		     0x2C98
#define Z_UNICODE_COPTIC_SMALL_LETTER_MI		     0x2C99
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_NI		     0x2C9A
#define Z_UNICODE_COPTIC_SMALL_LETTER_NI		     0x2C9B
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_KSI		     0x2C9C
#define Z_UNICODE_COPTIC_SMALL_LETTER_KSI		     0x2C9D
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_O		     0x2C9E
#define Z_UNICODE_COPTIC_SMALL_LETTER_O			     0x2C9F
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_PI		     0x2CA0
#define Z_UNICODE_COPTIC_SMALL_LETTER_PI		     0x2CA1
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_RO		     0x2CA2
#define Z_UNICODE_COPTIC_SMALL_LETTER_RO		     0x2CA3
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_SIMA		     0x2CA4
#define Z_UNICODE_COPTIC_SMALL_LETTER_SIMA		     0x2CA5
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_TAU		     0x2CA6
#define Z_UNICODE_COPTIC_SMALL_LETTER_TAU		     0x2CA7
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_UA		     0x2CA8
#define Z_UNICODE_COPTIC_SMALL_LETTER_UA		     0x2CA9
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_FI		     0x2CAA
#define Z_UNICODE_COPTIC_SMALL_LETTER_FI		     0x2CAB
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_KHI		     0x2CAC
#define Z_UNICODE_COPTIC_SMALL_LETTER_KHI		     0x2CAD
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_PSI		     0x2CAE
#define Z_UNICODE_COPTIC_SMALL_LETTER_PSI		     0x2CAF
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OOU		     0x2CB0
#define Z_UNICODE_COPTIC_SMALL_LETTER_OOU		     0x2CB1
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_DIALECT_P_ALEF	     0x2CB2
#define Z_UNICODE_COPTIC_SMALL_LETTER_DIALECT_P_ALEF	     0x2CB3
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_AIN	     0x2CB4
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_AIN	     0x2CB5
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_EIE    0x2CB6
#define Z_UNICODE_COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_EIE	     0x2CB7
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_DIALECT_P_KAPA	     0x2CB8
#define Z_UNICODE_COPTIC_SMALL_LETTER_DIALECT_P_KAPA	     0x2CB9
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_DIALECT_P_NI	     0x2CBA
#define Z_UNICODE_COPTIC_SMALL_LETTER_DIALECT_P_NI	     0x2CBB
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_NI     0x2CBC
#define Z_UNICODE_COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_NI	     0x2CBD
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_OOU	     0x2CBE
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_OOU	     0x2CBF
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_SAMPI		     0x2CC0
#define Z_UNICODE_COPTIC_SMALL_LETTER_SAMPI		     0x2CC1
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_CROSSED_SHEI	     0x2CC2
#define Z_UNICODE_COPTIC_SMALL_LETTER_CROSSED_SHEI	     0x2CC3
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_SHEI	     0x2CC4
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_SHEI	     0x2CC5
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_ESH	     0x2CC6
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_ESH	     0x2CC7
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_AKHMIMIC_KHEI	     0x2CC8
#define Z_UNICODE_COPTIC_SMALL_LETTER_AKHMIMIC_KHEI	     0x2CC9
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_DIALECT_P_HORI	     0x2CCA
#define Z_UNICODE_COPTIC_SMALL_LETTER_DIALECT_P_HORI	     0x2CCB
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_HORI	     0x2CCC
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_HORI	     0x2CCD
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_HA	     0x2CCE
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_HA	     0x2CCF
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_L_SHAPED_HA	     0x2CD0
#define Z_UNICODE_COPTIC_SMALL_LETTER_L_SHAPED_HA	     0x2CD1
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_HEI	     0x2CD2
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_HEI	     0x2CD3
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_HAT	     0x2CD4
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_HAT	     0x2CD5
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_GANGIA    0x2CD6
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_GANGIA	     0x2CD7
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_DJA	     0x2CD8
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_DJA	     0x2CD9
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_COPTIC_SHIMA     0x2CDA
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_COPTIC_SHIMA	     0x2CDB
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_NUBIAN_SHIMA     0x2CDC
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_NUBIAN_SHIMA	     0x2CDD
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_NUBIAN_NGI	     0x2CDE
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_NUBIAN_NGI	     0x2CDF
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_NUBIAN_NYI	     0x2CE0
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_NUBIAN_NYI	     0x2CE1
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_OLD_NUBIAN_WAU	     0x2CE2
#define Z_UNICODE_COPTIC_SMALL_LETTER_OLD_NUBIAN_WAU	     0x2CE3
#define Z_UNICODE_COPTIC_SYMBOL_KAI			     0x2CE4
#define Z_UNICODE_COPTIC_SYMBOL_MI_RO			     0x2CE5
#define Z_UNICODE_COPTIC_SYMBOL_PI_RO			     0x2CE6
#define Z_UNICODE_COPTIC_SYMBOL_STAUROS			     0x2CE7
#define Z_UNICODE_COPTIC_SYMBOL_TAU_RO			     0x2CE8
#define Z_UNICODE_COPTIC_SYMBOL_KHI_RO			     0x2CE9
#define Z_UNICODE_COPTIC_SYMBOL_SHIMA_SIMA		     0x2CEA
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_SHEI   0x2CEB
#define Z_UNICODE_COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_SHEI     0x2CEC
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_CRYPTOGRAMMIC_GANGIA 0x2CED
#define Z_UNICODE_COPTIC_SMALL_LETTER_CRYPTOGRAMMIC_GANGIA   0x2CEE
#define Z_UNICODE_COPTIC_COMBINING_NI_ABOVE		     0x2CEF
#define Z_UNICODE_COPTIC_COMBINING_SPIRITUS_ASPER	     0x2CF0
#define Z_UNICODE_COPTIC_COMBINING_SPIRITUS_LENIS	     0x2CF1
#define Z_UNICODE_COPTIC_CAPITAL_LETTER_BOHAIRIC_KHEI	     0x2CF2
#define Z_UNICODE_COPTIC_SMALL_LETTER_BOHAIRIC_KHEI	     0x2CF3
#define Z_UNICODE_COPTIC_OLD_NUBIAN_FULL_STOP		     0x2CF9
#define Z_UNICODE_COPTIC_OLD_NUBIAN_DIRECT_QUESTION_MARK     0x2CFA
#define Z_UNICODE_COPTIC_OLD_NUBIAN_INDIRECT_QUESTION_MARK   0x2CFB
#define Z_UNICODE_COPTIC_OLD_NUBIAN_VERSE_DIVIDER	     0x2CFC
#define Z_UNICODE_COPTIC_FRACTION_ONE_HALF		     0x2CFD
#define Z_UNICODE_COPTIC_FULL_STOP			     0x2CFE
#define Z_UNICODE_COPTIC_MORPHOLOGICAL_DIVIDER		     0x2CFF

/* MARK: - 2D00h-2D2Fh - Georgian Supplement */

#define Z_UNICODE_GEORGIAN_SMALL_LETTER_AN   0x2D00
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_BAN  0x2D01
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_GAN  0x2D02
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_DON  0x2D03
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_EN   0x2D04
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_VIN  0x2D05
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_ZEN  0x2D06
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_TAN  0x2D07
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_IN   0x2D08
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_KAN  0x2D09
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_LAS  0x2D0A
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_MAN  0x2D0B
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_NAR  0x2D0C
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_ON   0x2D0D
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_PAR  0x2D0E
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_ZHAR 0x2D0F
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_RAE  0x2D10
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_SAN  0x2D11
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_TAR  0x2D12
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_UN   0x2D13
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_PHAR 0x2D14
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_KHAR 0x2D15
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_GHAN 0x2D16
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_QAR  0x2D17
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_SHIN 0x2D18
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_CHIN 0x2D19
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_CAN  0x2D1A
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_JIL  0x2D1B
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_CIL  0x2D1C
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_CHAR 0x2D1D
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_XAN  0x2D1E
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_JHAN 0x2D1F
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_HAE  0x2D20
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_HE   0x2D21
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_HIE  0x2D22
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_WE   0x2D23
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_HAR  0x2D24
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_HOE  0x2D25
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_YN   0x2D27
#define Z_UNICODE_GEORGIAN_SMALL_LETTER_AEN  0x2D2D

/* MARK: - 2D30h-2D7Fh - Tifinagh */

#define Z_UNICODE_TIFINAGH_LETTER_YA			      0x2D30
#define Z_UNICODE_TIFINAGH_LETTER_YAB			      0x2D31
#define Z_UNICODE_TIFINAGH_LETTER_YABH			      0x2D32
#define Z_UNICODE_TIFINAGH_LETTER_YAG			      0x2D33
#define Z_UNICODE_TIFINAGH_LETTER_YAGHH			      0x2D34
#define Z_UNICODE_TIFINAGH_LETTER_BERBER_ACADEMY_YAJ	      0x2D35
#define Z_UNICODE_TIFINAGH_LETTER_YAJ			      0x2D36
#define Z_UNICODE_TIFINAGH_LETTER_YAD			      0x2D37
#define Z_UNICODE_TIFINAGH_LETTER_YADH			      0x2D38
#define Z_UNICODE_TIFINAGH_LETTER_YADD			      0x2D39
#define Z_UNICODE_TIFINAGH_LETTER_YADDH			      0x2D3A
#define Z_UNICODE_TIFINAGH_LETTER_YEY			      0x2D3B
#define Z_UNICODE_TIFINAGH_LETTER_YAF			      0x2D3C
#define Z_UNICODE_TIFINAGH_LETTER_YAK			      0x2D3D
#define Z_UNICODE_TIFINAGH_LETTER_TUAREG_YAK		      0x2D3E
#define Z_UNICODE_TIFINAGH_LETTER_YAKHH			      0x2D3F
#define Z_UNICODE_TIFINAGH_LETTER_YAH			      0x2D40
#define Z_UNICODE_TIFINAGH_LETTER_BERBER_ACADEMY_YAH	      0x2D41
#define Z_UNICODE_TIFINAGH_LETTER_TUAREG_YAH		      0x2D42
#define Z_UNICODE_TIFINAGH_LETTER_YAHH			      0x2D43
#define Z_UNICODE_TIFINAGH_LETTER_YAA			      0x2D44
#define Z_UNICODE_TIFINAGH_LETTER_YAKH			      0x2D45
#define Z_UNICODE_TIFINAGH_LETTER_TUAREG_YAKH		      0x2D46
#define Z_UNICODE_TIFINAGH_LETTER_YAQ			      0x2D47
#define Z_UNICODE_TIFINAGH_LETTER_TUAREG_YAQ		      0x2D48
#define Z_UNICODE_TIFINAGH_LETTER_YI			      0x2D49
#define Z_UNICODE_TIFINAGH_LETTER_YAZH			      0x2D4A
#define Z_UNICODE_TIFINAGH_LETTER_AHAGGAR_YAZH		      0x2D4B
#define Z_UNICODE_TIFINAGH_LETTER_TUAREG_YAZH		      0x2D4C
#define Z_UNICODE_TIFINAGH_LETTER_YAL			      0x2D4D
#define Z_UNICODE_TIFINAGH_LETTER_YAM			      0x2D4E
#define Z_UNICODE_TIFINAGH_LETTER_YAN			      0x2D4F
#define Z_UNICODE_TIFINAGH_LETTER_TUAREG_YAGN		      0x2D50
#define Z_UNICODE_TIFINAGH_LETTER_TUAREG_YANG		      0x2D51
#define Z_UNICODE_TIFINAGH_LETTER_YAP			      0x2D52
#define Z_UNICODE_TIFINAGH_LETTER_YU			      0x2D53
#define Z_UNICODE_TIFINAGH_LETTER_YAR			      0x2D54
#define Z_UNICODE_TIFINAGH_LETTER_YARR			      0x2D55
#define Z_UNICODE_TIFINAGH_LETTER_YAGH			      0x2D56
#define Z_UNICODE_TIFINAGH_LETTER_TUAREG_YAGH		      0x2D57
#define Z_UNICODE_TIFINAGH_LETTER_AYER_YAGH		      0x2D58
#define Z_UNICODE_TIFINAGH_LETTER_YAS			      0x2D59
#define Z_UNICODE_TIFINAGH_LETTER_YASS			      0x2D5A
#define Z_UNICODE_TIFINAGH_LETTER_YASH			      0x2D5B
#define Z_UNICODE_TIFINAGH_LETTER_YAT			      0x2D5C
#define Z_UNICODE_TIFINAGH_LETTER_YATH			      0x2D5D
#define Z_UNICODE_TIFINAGH_LETTER_YACH			      0x2D5E
#define Z_UNICODE_TIFINAGH_LETTER_YATT			      0x2D5F
#define Z_UNICODE_TIFINAGH_LETTER_YAV			      0x2D60
#define Z_UNICODE_TIFINAGH_LETTER_YAW			      0x2D61
#define Z_UNICODE_TIFINAGH_LETTER_YAY			      0x2D62
#define Z_UNICODE_TIFINAGH_LETTER_YAZ			      0x2D63
#define Z_UNICODE_TIFINAGH_LETTER_TAWELLEMET_YAZ	      0x2D64
#define Z_UNICODE_TIFINAGH_LETTER_YAZZ			      0x2D65
#define Z_UNICODE_TIFINAGH_LETTER_YE			      0x2D66
#define Z_UNICODE_TIFINAGH_LETTER_YO			      0x2D67
#define Z_UNICODE_TIFINAGH_MODIFIER_LETTER_LABIALIZATION_MARK 0x2D6F
#define Z_UNICODE_TIFINAGH_SEPARATOR_MARK		      0x2D70
#define Z_UNICODE_TIFINAGH_CONSONANT_JOINER		      0x2D7F

/* MARK: - 2D80h-2DDFh - Ethiopic Extended */

#define Z_UNICODE_ETHIOPIC_SYLLABLE_LOA	       0x2D80
#define Z_UNICODE_ETHIOPIC_SYLLABLE_MOA	       0x2D81
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ROA	       0x2D82
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SOA	       0x2D83
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SHOA       0x2D84
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BOA	       0x2D85
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TOA	       0x2D86
#define Z_UNICODE_ETHIOPIC_SYLLABLE_COA	       0x2D87
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NOA	       0x2D88
#define Z_UNICODE_ETHIOPIC_SYLLABLE_NYOA       0x2D89
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GLOTTAL_OA 0x2D8A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZOA	       0x2D8B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DOA	       0x2D8C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDOA       0x2D8D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_JOA	       0x2D8E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_THOA       0x2D8F
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CHOA       0x2D90
#define Z_UNICODE_ETHIOPIC_SYLLABLE_PHOA       0x2D91
#define Z_UNICODE_ETHIOPIC_SYLLABLE_POA	       0x2D92
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGWA       0x2D93
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGWI       0x2D94
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGWEE      0x2D95
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GGWE       0x2D96
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SSA	       0x2DA0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SSU	       0x2DA1
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SSI	       0x2DA2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SSAA       0x2DA3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SSEE       0x2DA4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SSE	       0x2DA5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_SSO	       0x2DA6
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCA	       0x2DA8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCU	       0x2DA9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCI	       0x2DAA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCAA       0x2DAB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCEE       0x2DAC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCE	       0x2DAD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCO	       0x2DAE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZZA	       0x2DB0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZZU	       0x2DB1
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZZI	       0x2DB2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZZAA       0x2DB3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZZEE       0x2DB4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZZE	       0x2DB5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_ZZO	       0x2DB6
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHA       0x2DB8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHU       0x2DB9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHI       0x2DBA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHAA      0x2DBB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHEE      0x2DBC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHE       0x2DBD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHO       0x2DBE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QYA	       0x2DC0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QYU	       0x2DC1
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QYI	       0x2DC2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QYAA       0x2DC3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QYEE       0x2DC4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QYE	       0x2DC5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_QYO	       0x2DC6
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KYA	       0x2DC8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KYU	       0x2DC9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KYI	       0x2DCA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KYAA       0x2DCB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KYEE       0x2DCC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KYE	       0x2DCD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_KYO	       0x2DCE
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XYA	       0x2DD0
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XYU	       0x2DD1
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XYI	       0x2DD2
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XYAA       0x2DD3
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XYEE       0x2DD4
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XYE	       0x2DD5
#define Z_UNICODE_ETHIOPIC_SYLLABLE_XYO	       0x2DD6
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GYA	       0x2DD8
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GYU	       0x2DD9
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GYI	       0x2DDA
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GYAA       0x2DDB
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GYEE       0x2DDC
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GYE	       0x2DDD
#define Z_UNICODE_ETHIOPIC_SYLLABLE_GYO	       0x2DDE

/* MARK: - 2DE0h-2DFFh - Cyrillic Extended-A */

#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_BE		     0x2DE0
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_VE		     0x2DE1
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_GHE		     0x2DE2
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_DE		     0x2DE3
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_ZHE		     0x2DE4
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_ZE		     0x2DE5
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_KA		     0x2DE6
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_EL		     0x2DE7
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_EM		     0x2DE8
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_EN		     0x2DE9
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_O		     0x2DEA
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_PE		     0x2DEB
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_ER		     0x2DEC
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_ES		     0x2DED
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_TE		     0x2DEE
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_HA		     0x2DEF
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_TSE		     0x2DF0
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_CHE		     0x2DF1
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_SHA		     0x2DF2
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_SHCHA	     0x2DF3
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_FITA	     0x2DF4
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_ES_TE	     0x2DF5
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_A		     0x2DF6
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_IE		     0x2DF7
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_DJERV	     0x2DF8
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_MONOGRAPH_UK     0x2DF9
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_YAT		     0x2DFA
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_YU		     0x2DFB
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_IOTIFIED_A	     0x2DFC
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_LITTLE_YUS	     0x2DFD
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_BIG_YUS	     0x2DFE
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_IOTIFIED_BIG_YUS 0x2DFF

/* MARK: - 2E00h-2E7Fh - Supplemental Punctuation */

#define Z_UNICODE_RIGHT_ANGLE_SUBSTITUTION_MARKER	 0x2E00
#define Z_UNICODE_RIGHT_ANGLE_DOTTED_SUBSTITUTION_MARKER 0x2E01
#define Z_UNICODE_LEFT_SUBSTITUTION_BRACKET		 0x2E02
#define Z_UNICODE_RIGHT_SUBSTITUTION_BRACKET		 0x2E03
#define Z_UNICODE_LEFT_DOTTED_SUBSTITUTION_BRACKET	 0x2E04
#define Z_UNICODE_RIGHT_DOTTED_SUBSTITUTION_BRACKET	 0x2E05
#define Z_UNICODE_RAISED_INTERPOLATION_MARKER		 0x2E06
#define Z_UNICODE_RAISED_DOTTED_INTERPOLATION_MARKER	 0x2E07
#define Z_UNICODE_DOTTED_TRANSPOSITION_MARKER		 0x2E08
#define Z_UNICODE_LEFT_TRANSPOSITION_BRACKET		 0x2E09
#define Z_UNICODE_RIGHT_TRANSPOSITION_BRACKET		 0x2E0A
#define Z_UNICODE_RAISED_SQUARE				 0x2E0B
#define Z_UNICODE_LEFT_RAISED_OMISSION_BRACKET		 0x2E0C
#define Z_UNICODE_RIGHT_RAISED_OMISSION_BRACKET		 0x2E0D
#define Z_UNICODE_EDITORIAL_CORONIS			 0x2E0E
#define Z_UNICODE_PARAGRAPHOS				 0x2E0F
#define Z_UNICODE_FORKED_PARAGRAPHOS			 0x2E10
#define Z_UNICODE_REVERSED_FORKED_PARAGRAPHOS		 0x2E11
#define Z_UNICODE_HYPODIASTOLE				 0x2E12
#define Z_UNICODE_DOTTED_OBELOS				 0x2E13
#define Z_UNICODE_DOWNWARDS_ANCORA			 0x2E14
#define Z_UNICODE_UPWARDS_ANCORA			 0x2E15
#define Z_UNICODE_DOTTED_RIGHT_POINTING_ANGLE		 0x2E16
#define Z_UNICODE_DOUBLE_OBLIQUE_HYPHEN			 0x2E17
#define Z_UNICODE_INVERTED_INTERROBANG			 0x2E18
#define Z_UNICODE_PALM_BRANCH				 0x2E19
#define Z_UNICODE_HYPHEN_WITH_DIAERESIS			 0x2E1A
#define Z_UNICODE_TILDE_WITH_RING_ABOVE			 0x2E1B
#define Z_UNICODE_LEFT_LOW_PARAPHRASE_BRACKET		 0x2E1C
#define Z_UNICODE_RIGHT_LOW_PARAPHRASE_BRACKET		 0x2E1D
#define Z_UNICODE_TILDE_WITH_DOT_ABOVE			 0x2E1E
#define Z_UNICODE_TILDE_WITH_DOT_BELOW			 0x2E1F
#define Z_UNICODE_LEFT_VERTICAL_BAR_WITH_QUILL		 0x2E20
#define Z_UNICODE_RIGHT_VERTICAL_BAR_WITH_QUILL		 0x2E21
#define Z_UNICODE_TOP_LEFT_HALF_BRACKET			 0x2E22
#define Z_UNICODE_TOP_RIGHT_HALF_BRACKET		 0x2E23
#define Z_UNICODE_BOTTOM_LEFT_HALF_BRACKET		 0x2E24
#define Z_UNICODE_BOTTOM_RIGHT_HALF_BRACKET		 0x2E25
#define Z_UNICODE_LEFT_SIDEWAYS_U_BRACKET		 0x2E26
#define Z_UNICODE_RIGHT_SIDEWAYS_U_BRACKET		 0x2E27
#define Z_UNICODE_LEFT_DOUBLE_PARENTHESIS		 0x2E28
#define Z_UNICODE_RIGHT_DOUBLE_PARENTHESIS		 0x2E29
#define Z_UNICODE_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION	 0x2E2A
#define Z_UNICODE_ONE_DOT_OVER_TWO_DOTS_PUNCTUATION	 0x2E2B
#define Z_UNICODE_SQUARED_FOUR_DOT_PUNCTUATION		 0x2E2C
#define Z_UNICODE_FIVE_DOT_MARK				 0x2E2D
#define Z_UNICODE_REVERSED_QUESTION_MARK		 0x2E2E
#define Z_UNICODE_VERTICAL_TILDE			 0x2E2F
#define Z_UNICODE_RING_POINT				 0x2E30
#define Z_UNICODE_WORD_SEPARATOR_MIDDLE_DOT		 0x2E31
#define Z_UNICODE_TURNED_COMMA				 0x2E32
#define Z_UNICODE_RAISED_DOT				 0x2E33
#define Z_UNICODE_RAISED_COMMA				 0x2E34
#define Z_UNICODE_TURNED_SEMICOLON			 0x2E35
#define Z_UNICODE_DAGGER_WITH_LEFT_GUARD		 0x2E36
#define Z_UNICODE_DAGGER_WITH_RIGHT_GUARD		 0x2E37
#define Z_UNICODE_TURNED_DAGGER				 0x2E38
#define Z_UNICODE_TOP_HALF_SECTION_SIGN			 0x2E39
#define Z_UNICODE_TWO_EM_DASH				 0x2E3A
#define Z_UNICODE_THREE_EM_DASH				 0x2E3B
#define Z_UNICODE_STENOGRAPHIC_FULL_STOP		 0x2E3C
#define Z_UNICODE_VERTICAL_SIX_DOTS			 0x2E3D
#define Z_UNICODE_WIGGLY_VERTICAL_LINE			 0x2E3E
#define Z_UNICODE_CAPITULUM				 0x2E3F
#define Z_UNICODE_DOUBLE_HYPHEN				 0x2E40
#define Z_UNICODE_REVERSED_COMMA			 0x2E41
#define Z_UNICODE_DOUBLE_LOW_REVERSED_9_QUOTATION_MARK	 0x2E42

/* MARK: - 2E80h-2EFFh - CJK Radicals Supplement */

#define Z_UNICODE_CJK_RADICAL_REPEAT			  0x2E80
#define Z_UNICODE_CJK_RADICAL_CLIFF			  0x2E81
#define Z_UNICODE_CJK_RADICAL_SECOND_ONE		  0x2E82
#define Z_UNICODE_CJK_RADICAL_SECOND_TWO		  0x2E83
#define Z_UNICODE_CJK_RADICAL_SECOND_THREE		  0x2E84
#define Z_UNICODE_CJK_RADICAL_PERSON			  0x2E85
#define Z_UNICODE_CJK_RADICAL_BOX			  0x2E86
#define Z_UNICODE_CJK_RADICAL_TABLE			  0x2E87
#define Z_UNICODE_CJK_RADICAL_KNIFE_ONE			  0x2E88
#define Z_UNICODE_CJK_RADICAL_KNIFE_TWO			  0x2E89
#define Z_UNICODE_CJK_RADICAL_DIVINATION		  0x2E8A
#define Z_UNICODE_CJK_RADICAL_SEAL			  0x2E8B
#define Z_UNICODE_CJK_RADICAL_SMALL_ONE			  0x2E8C
#define Z_UNICODE_CJK_RADICAL_SMALL_TWO			  0x2E8D
#define Z_UNICODE_CJK_RADICAL_LAME_ONE			  0x2E8E
#define Z_UNICODE_CJK_RADICAL_LAME_TWO			  0x2E8F
#define Z_UNICODE_CJK_RADICAL_LAME_THREE		  0x2E90
#define Z_UNICODE_CJK_RADICAL_LAME_FOUR			  0x2E91
#define Z_UNICODE_CJK_RADICAL_SNAKE			  0x2E92
#define Z_UNICODE_CJK_RADICAL_THREAD			  0x2E93
#define Z_UNICODE_CJK_RADICAL_SNOUT_ONE			  0x2E94
#define Z_UNICODE_CJK_RADICAL_SNOUT_TWO			  0x2E95
#define Z_UNICODE_CJK_RADICAL_HEART_ONE			  0x2E96
#define Z_UNICODE_CJK_RADICAL_HEART_TWO			  0x2E97
#define Z_UNICODE_CJK_RADICAL_HAND			  0x2E98
#define Z_UNICODE_CJK_RADICAL_RAP			  0x2E99
#define Z_UNICODE_CJK_RADICAL_CHOKE			  0x2E9B
#define Z_UNICODE_CJK_RADICAL_SUN			  0x2E9C
#define Z_UNICODE_CJK_RADICAL_MOON			  0x2E9D
#define Z_UNICODE_CJK_RADICAL_DEATH			  0x2E9E
#define Z_UNICODE_CJK_RADICAL_MOTHER			  0x2E9F
#define Z_UNICODE_CJK_RADICAL_CIVILIAN			  0x2EA0
#define Z_UNICODE_CJK_RADICAL_WATER_ONE			  0x2EA1
#define Z_UNICODE_CJK_RADICAL_WATER_TWO			  0x2EA2
#define Z_UNICODE_CJK_RADICAL_FIRE			  0x2EA3
#define Z_UNICODE_CJK_RADICAL_PAW_ONE			  0x2EA4
#define Z_UNICODE_CJK_RADICAL_PAW_TWO			  0x2EA5
#define Z_UNICODE_CJK_RADICAL_SIMPLIFIED_HALF_TREE_TRUNK  0x2EA6
#define Z_UNICODE_CJK_RADICAL_COW			  0x2EA7
#define Z_UNICODE_CJK_RADICAL_DOG			  0x2EA8
#define Z_UNICODE_CJK_RADICAL_JADE			  0x2EA9
#define Z_UNICODE_CJK_RADICAL_BOLT_OF_CLOTH		  0x2EAA
#define Z_UNICODE_CJK_RADICAL_EYE			  0x2EAB
#define Z_UNICODE_CJK_RADICAL_SPIRIT_ONE		  0x2EAC
#define Z_UNICODE_CJK_RADICAL_SPIRIT_TWO		  0x2EAD
#define Z_UNICODE_CJK_RADICAL_BAMBOO			  0x2EAE
#define Z_UNICODE_CJK_RADICAL_SILK			  0x2EAF
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_SILK		  0x2EB0
#define Z_UNICODE_CJK_RADICAL_NET_ONE			  0x2EB1
#define Z_UNICODE_CJK_RADICAL_NET_TWO			  0x2EB2
#define Z_UNICODE_CJK_RADICAL_NET_THREE			  0x2EB3
#define Z_UNICODE_CJK_RADICAL_NET_FOUR			  0x2EB4
#define Z_UNICODE_CJK_RADICAL_MESH			  0x2EB5
#define Z_UNICODE_CJK_RADICAL_SHEEP			  0x2EB6
#define Z_UNICODE_CJK_RADICAL_RAM			  0x2EB7
#define Z_UNICODE_CJK_RADICAL_EWE			  0x2EB8
#define Z_UNICODE_CJK_RADICAL_OLD			  0x2EB9
#define Z_UNICODE_CJK_RADICAL_BRUSH_ONE			  0x2EBA
#define Z_UNICODE_CJK_RADICAL_BRUSH_TWO			  0x2EBB
#define Z_UNICODE_CJK_RADICAL_MEAT			  0x2EBC
#define Z_UNICODE_CJK_RADICAL_MORTAR			  0x2EBD
#define Z_UNICODE_CJK_RADICAL_GRASS_ONE			  0x2EBE
#define Z_UNICODE_CJK_RADICAL_GRASS_TWO			  0x2EBF
#define Z_UNICODE_CJK_RADICAL_GRASS_THREE		  0x2EC0
#define Z_UNICODE_CJK_RADICAL_TIGER			  0x2EC1
#define Z_UNICODE_CJK_RADICAL_CLOTHES			  0x2EC2
#define Z_UNICODE_CJK_RADICAL_WEST_ONE			  0x2EC3
#define Z_UNICODE_CJK_RADICAL_WEST_TWO			  0x2EC4
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_SEE		  0x2EC5
#define Z_UNICODE_CJK_RADICAL_SIMPLIFIED_HORN		  0x2EC6
#define Z_UNICODE_CJK_RADICAL_HORN			  0x2EC7
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_SPEECH	  0x2EC8
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_SHELL	  0x2EC9
#define Z_UNICODE_CJK_RADICAL_FOOT			  0x2ECA
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_CART		  0x2ECB
#define Z_UNICODE_CJK_RADICAL_SIMPLIFIED_WALK		  0x2ECC
#define Z_UNICODE_CJK_RADICAL_WALK_ONE			  0x2ECD
#define Z_UNICODE_CJK_RADICAL_WALK_TWO			  0x2ECE
#define Z_UNICODE_CJK_RADICAL_CITY			  0x2ECF
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_GOLD		  0x2ED0
#define Z_UNICODE_CJK_RADICAL_LONG_ONE			  0x2ED1
#define Z_UNICODE_CJK_RADICAL_LONG_TWO			  0x2ED2
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_LONG		  0x2ED3
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_GATE		  0x2ED4
#define Z_UNICODE_CJK_RADICAL_MOUND_ONE			  0x2ED5
#define Z_UNICODE_CJK_RADICAL_MOUND_TWO			  0x2ED6
#define Z_UNICODE_CJK_RADICAL_RAIN			  0x2ED7
#define Z_UNICODE_CJK_RADICAL_BLUE			  0x2ED8
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_TANNED_LEATHER 0x2ED9
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_LEAF		  0x2EDA
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_WIND		  0x2EDB
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_FLY		  0x2EDC
#define Z_UNICODE_CJK_RADICAL_EAT_ONE			  0x2EDD
#define Z_UNICODE_CJK_RADICAL_EAT_TWO			  0x2EDE
#define Z_UNICODE_CJK_RADICAL_EAT_THREE			  0x2EDF
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_EAT		  0x2EE0
#define Z_UNICODE_CJK_RADICAL_HEAD			  0x2EE1
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_HORSE	  0x2EE2
#define Z_UNICODE_CJK_RADICAL_BONE			  0x2EE3
#define Z_UNICODE_CJK_RADICAL_GHOST			  0x2EE4
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_FISH		  0x2EE5
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_BIRD		  0x2EE6
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_SALT		  0x2EE7
#define Z_UNICODE_CJK_RADICAL_SIMPLIFIED_WHEAT		  0x2EE8
#define Z_UNICODE_CJK_RADICAL_SIMPLIFIED_YELLOW		  0x2EE9
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_FROG		  0x2EEA
#define Z_UNICODE_CJK_RADICAL_J_SIMPLIFIED_EVEN		  0x2EEB
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_EVEN		  0x2EEC
#define Z_UNICODE_CJK_RADICAL_J_SIMPLIFIED_TOOTH	  0x2EED
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_TOOTH	  0x2EEE
#define Z_UNICODE_CJK_RADICAL_J_SIMPLIFIED_DRAGON	  0x2EEF
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_DRAGON	  0x2EF0
#define Z_UNICODE_CJK_RADICAL_TURTLE			  0x2EF1
#define Z_UNICODE_CJK_RADICAL_J_SIMPLIFIED_TURTLE	  0x2EF2
#define Z_UNICODE_CJK_RADICAL_C_SIMPLIFIED_TURTLE	  0x2EF3

/* MARK: - 2F00h-2FDFh - Kangxi Radicals */

#define Z_UNICODE_KANGXI_RADICAL_ONE		   0x2F00
#define Z_UNICODE_KANGXI_RADICAL_LINE		   0x2F01
#define Z_UNICODE_KANGXI_RADICAL_DOT		   0x2F02
#define Z_UNICODE_KANGXI_RADICAL_SLASH		   0x2F03
#define Z_UNICODE_KANGXI_RADICAL_SECOND		   0x2F04
#define Z_UNICODE_KANGXI_RADICAL_HOOK		   0x2F05
#define Z_UNICODE_KANGXI_RADICAL_TWO		   0x2F06
#define Z_UNICODE_KANGXI_RADICAL_LID		   0x2F07
#define Z_UNICODE_KANGXI_RADICAL_MAN		   0x2F08
#define Z_UNICODE_KANGXI_RADICAL_LEGS		   0x2F09
#define Z_UNICODE_KANGXI_RADICAL_ENTER		   0x2F0A
#define Z_UNICODE_KANGXI_RADICAL_EIGHT		   0x2F0B
#define Z_UNICODE_KANGXI_RADICAL_DOWN_BOX	   0x2F0C
#define Z_UNICODE_KANGXI_RADICAL_COVER		   0x2F0D
#define Z_UNICODE_KANGXI_RADICAL_ICE		   0x2F0E
#define Z_UNICODE_KANGXI_RADICAL_TABLE		   0x2F0F
#define Z_UNICODE_KANGXI_RADICAL_OPEN_BOX	   0x2F10
#define Z_UNICODE_KANGXI_RADICAL_KNIFE		   0x2F11
#define Z_UNICODE_KANGXI_RADICAL_POWER		   0x2F12
#define Z_UNICODE_KANGXI_RADICAL_WRAP		   0x2F13
#define Z_UNICODE_KANGXI_RADICAL_SPOON		   0x2F14
#define Z_UNICODE_KANGXI_RADICAL_RIGHT_OPEN_BOX	   0x2F15
#define Z_UNICODE_KANGXI_RADICAL_HIDING_ENCLOSURE  0x2F16
#define Z_UNICODE_KANGXI_RADICAL_TEN		   0x2F17
#define Z_UNICODE_KANGXI_RADICAL_DIVINATION	   0x2F18
#define Z_UNICODE_KANGXI_RADICAL_SEAL		   0x2F19
#define Z_UNICODE_KANGXI_RADICAL_CLIFF		   0x2F1A
#define Z_UNICODE_KANGXI_RADICAL_PRIVATE	   0x2F1B
#define Z_UNICODE_KANGXI_RADICAL_AGAIN		   0x2F1C
#define Z_UNICODE_KANGXI_RADICAL_MOUTH		   0x2F1D
#define Z_UNICODE_KANGXI_RADICAL_ENCLOSURE	   0x2F1E
#define Z_UNICODE_KANGXI_RADICAL_EARTH		   0x2F1F
#define Z_UNICODE_KANGXI_RADICAL_SCHOLAR	   0x2F20
#define Z_UNICODE_KANGXI_RADICAL_GO		   0x2F21
#define Z_UNICODE_KANGXI_RADICAL_GO_SLOWLY	   0x2F22
#define Z_UNICODE_KANGXI_RADICAL_EVENING	   0x2F23
#define Z_UNICODE_KANGXI_RADICAL_BIG		   0x2F24
#define Z_UNICODE_KANGXI_RADICAL_WOMAN		   0x2F25
#define Z_UNICODE_KANGXI_RADICAL_CHILD		   0x2F26
#define Z_UNICODE_KANGXI_RADICAL_ROOF		   0x2F27
#define Z_UNICODE_KANGXI_RADICAL_INCH		   0x2F28
#define Z_UNICODE_KANGXI_RADICAL_SMALL		   0x2F29
#define Z_UNICODE_KANGXI_RADICAL_LAME		   0x2F2A
#define Z_UNICODE_KANGXI_RADICAL_CORPSE		   0x2F2B
#define Z_UNICODE_KANGXI_RADICAL_SPROUT		   0x2F2C
#define Z_UNICODE_KANGXI_RADICAL_MOUNTAIN	   0x2F2D
#define Z_UNICODE_KANGXI_RADICAL_RIVER		   0x2F2E
#define Z_UNICODE_KANGXI_RADICAL_WORK		   0x2F2F
#define Z_UNICODE_KANGXI_RADICAL_ONESELF	   0x2F30
#define Z_UNICODE_KANGXI_RADICAL_TURBAN		   0x2F31
#define Z_UNICODE_KANGXI_RADICAL_DRY		   0x2F32
#define Z_UNICODE_KANGXI_RADICAL_SHORT_THREAD	   0x2F33
#define Z_UNICODE_KANGXI_RADICAL_DOTTED_CLIFF	   0x2F34
#define Z_UNICODE_KANGXI_RADICAL_LONG_STRIDE	   0x2F35
#define Z_UNICODE_KANGXI_RADICAL_TWO_HANDS	   0x2F36
#define Z_UNICODE_KANGXI_RADICAL_SHOOT		   0x2F37
#define Z_UNICODE_KANGXI_RADICAL_BOW		   0x2F38
#define Z_UNICODE_KANGXI_RADICAL_SNOUT		   0x2F39
#define Z_UNICODE_KANGXI_RADICAL_BRISTLE	   0x2F3A
#define Z_UNICODE_KANGXI_RADICAL_STEP		   0x2F3B
#define Z_UNICODE_KANGXI_RADICAL_HEART		   0x2F3C
#define Z_UNICODE_KANGXI_RADICAL_HALBERD	   0x2F3D
#define Z_UNICODE_KANGXI_RADICAL_DOOR		   0x2F3E
#define Z_UNICODE_KANGXI_RADICAL_HAND		   0x2F3F
#define Z_UNICODE_KANGXI_RADICAL_BRANCH		   0x2F40
#define Z_UNICODE_KANGXI_RADICAL_RAP		   0x2F41
#define Z_UNICODE_KANGXI_RADICAL_SCRIPT		   0x2F42
#define Z_UNICODE_KANGXI_RADICAL_DIPPER		   0x2F43
#define Z_UNICODE_KANGXI_RADICAL_AXE		   0x2F44
#define Z_UNICODE_KANGXI_RADICAL_SQUARE		   0x2F45
#define Z_UNICODE_KANGXI_RADICAL_NOT		   0x2F46
#define Z_UNICODE_KANGXI_RADICAL_SUN		   0x2F47
#define Z_UNICODE_KANGXI_RADICAL_SAY		   0x2F48
#define Z_UNICODE_KANGXI_RADICAL_MOON		   0x2F49
#define Z_UNICODE_KANGXI_RADICAL_TREE		   0x2F4A
#define Z_UNICODE_KANGXI_RADICAL_LACK		   0x2F4B
#define Z_UNICODE_KANGXI_RADICAL_STOP		   0x2F4C
#define Z_UNICODE_KANGXI_RADICAL_DEATH		   0x2F4D
#define Z_UNICODE_KANGXI_RADICAL_WEAPON		   0x2F4E
#define Z_UNICODE_KANGXI_RADICAL_DO_NOT		   0x2F4F
#define Z_UNICODE_KANGXI_RADICAL_COMPARE	   0x2F50
#define Z_UNICODE_KANGXI_RADICAL_FUR		   0x2F51
#define Z_UNICODE_KANGXI_RADICAL_CLAN		   0x2F52
#define Z_UNICODE_KANGXI_RADICAL_STEAM		   0x2F53
#define Z_UNICODE_KANGXI_RADICAL_WATER		   0x2F54
#define Z_UNICODE_KANGXI_RADICAL_FIRE		   0x2F55
#define Z_UNICODE_KANGXI_RADICAL_CLAW		   0x2F56
#define Z_UNICODE_KANGXI_RADICAL_FATHER		   0x2F57
#define Z_UNICODE_KANGXI_RADICAL_DOUBLE_X	   0x2F58
#define Z_UNICODE_KANGXI_RADICAL_HALF_TREE_TRUNK   0x2F59
#define Z_UNICODE_KANGXI_RADICAL_SLICE		   0x2F5A
#define Z_UNICODE_KANGXI_RADICAL_FANG		   0x2F5B
#define Z_UNICODE_KANGXI_RADICAL_COW		   0x2F5C
#define Z_UNICODE_KANGXI_RADICAL_DOG		   0x2F5D
#define Z_UNICODE_KANGXI_RADICAL_PROFOUND	   0x2F5E
#define Z_UNICODE_KANGXI_RADICAL_JADE		   0x2F5F
#define Z_UNICODE_KANGXI_RADICAL_MELON		   0x2F60
#define Z_UNICODE_KANGXI_RADICAL_TILE		   0x2F61
#define Z_UNICODE_KANGXI_RADICAL_SWEET		   0x2F62
#define Z_UNICODE_KANGXI_RADICAL_LIFE		   0x2F63
#define Z_UNICODE_KANGXI_RADICAL_USE		   0x2F64
#define Z_UNICODE_KANGXI_RADICAL_FIELD		   0x2F65
#define Z_UNICODE_KANGXI_RADICAL_BOLT_OF_CLOTH	   0x2F66
#define Z_UNICODE_KANGXI_RADICAL_SICKNESS	   0x2F67
#define Z_UNICODE_KANGXI_RADICAL_DOTTED_TENT	   0x2F68
#define Z_UNICODE_KANGXI_RADICAL_WHITE		   0x2F69
#define Z_UNICODE_KANGXI_RADICAL_SKIN		   0x2F6A
#define Z_UNICODE_KANGXI_RADICAL_DISH		   0x2F6B
#define Z_UNICODE_KANGXI_RADICAL_EYE		   0x2F6C
#define Z_UNICODE_KANGXI_RADICAL_SPEAR		   0x2F6D
#define Z_UNICODE_KANGXI_RADICAL_ARROW		   0x2F6E
#define Z_UNICODE_KANGXI_RADICAL_STONE		   0x2F6F
#define Z_UNICODE_KANGXI_RADICAL_SPIRIT		   0x2F70
#define Z_UNICODE_KANGXI_RADICAL_TRACK		   0x2F71
#define Z_UNICODE_KANGXI_RADICAL_GRAIN		   0x2F72
#define Z_UNICODE_KANGXI_RADICAL_CAVE		   0x2F73
#define Z_UNICODE_KANGXI_RADICAL_STAND		   0x2F74
#define Z_UNICODE_KANGXI_RADICAL_BAMBOO		   0x2F75
#define Z_UNICODE_KANGXI_RADICAL_RICE		   0x2F76
#define Z_UNICODE_KANGXI_RADICAL_SILK		   0x2F77
#define Z_UNICODE_KANGXI_RADICAL_JAR		   0x2F78
#define Z_UNICODE_KANGXI_RADICAL_NET		   0x2F79
#define Z_UNICODE_KANGXI_RADICAL_SHEEP		   0x2F7A
#define Z_UNICODE_KANGXI_RADICAL_FEATHER	   0x2F7B
#define Z_UNICODE_KANGXI_RADICAL_OLD		   0x2F7C
#define Z_UNICODE_KANGXI_RADICAL_AND		   0x2F7D
#define Z_UNICODE_KANGXI_RADICAL_PLOW		   0x2F7E
#define Z_UNICODE_KANGXI_RADICAL_EAR		   0x2F7F
#define Z_UNICODE_KANGXI_RADICAL_BRUSH		   0x2F80
#define Z_UNICODE_KANGXI_RADICAL_MEAT		   0x2F81
#define Z_UNICODE_KANGXI_RADICAL_MINISTER	   0x2F82
#define Z_UNICODE_KANGXI_RADICAL_SELF		   0x2F83
#define Z_UNICODE_KANGXI_RADICAL_ARRIVE		   0x2F84
#define Z_UNICODE_KANGXI_RADICAL_MORTAR		   0x2F85
#define Z_UNICODE_KANGXI_RADICAL_TONGUE		   0x2F86
#define Z_UNICODE_KANGXI_RADICAL_OPPOSE		   0x2F87
#define Z_UNICODE_KANGXI_RADICAL_BOAT		   0x2F88
#define Z_UNICODE_KANGXI_RADICAL_STOPPING	   0x2F89
#define Z_UNICODE_KANGXI_RADICAL_COLOR		   0x2F8A
#define Z_UNICODE_KANGXI_RADICAL_GRASS		   0x2F8B
#define Z_UNICODE_KANGXI_RADICAL_TIGER		   0x2F8C
#define Z_UNICODE_KANGXI_RADICAL_INSECT		   0x2F8D
#define Z_UNICODE_KANGXI_RADICAL_BLOOD		   0x2F8E
#define Z_UNICODE_KANGXI_RADICAL_WALK_ENCLOSURE	   0x2F8F
#define Z_UNICODE_KANGXI_RADICAL_CLOTHES	   0x2F90
#define Z_UNICODE_KANGXI_RADICAL_WEST		   0x2F91
#define Z_UNICODE_KANGXI_RADICAL_SEE		   0x2F92
#define Z_UNICODE_KANGXI_RADICAL_HORN		   0x2F93
#define Z_UNICODE_KANGXI_RADICAL_SPEECH		   0x2F94
#define Z_UNICODE_KANGXI_RADICAL_VALLEY		   0x2F95
#define Z_UNICODE_KANGXI_RADICAL_BEAN		   0x2F96
#define Z_UNICODE_KANGXI_RADICAL_PIG		   0x2F97
#define Z_UNICODE_KANGXI_RADICAL_BADGER		   0x2F98
#define Z_UNICODE_KANGXI_RADICAL_SHELL		   0x2F99
#define Z_UNICODE_KANGXI_RADICAL_RED		   0x2F9A
#define Z_UNICODE_KANGXI_RADICAL_RUN		   0x2F9B
#define Z_UNICODE_KANGXI_RADICAL_FOOT		   0x2F9C
#define Z_UNICODE_KANGXI_RADICAL_BODY		   0x2F9D
#define Z_UNICODE_KANGXI_RADICAL_CART		   0x2F9E
#define Z_UNICODE_KANGXI_RADICAL_BITTER		   0x2F9F
#define Z_UNICODE_KANGXI_RADICAL_MORNING	   0x2FA0
#define Z_UNICODE_KANGXI_RADICAL_WALK		   0x2FA1
#define Z_UNICODE_KANGXI_RADICAL_CITY		   0x2FA2
#define Z_UNICODE_KANGXI_RADICAL_WINE		   0x2FA3
#define Z_UNICODE_KANGXI_RADICAL_DISTINGUISH	   0x2FA4
#define Z_UNICODE_KANGXI_RADICAL_VILLAGE	   0x2FA5
#define Z_UNICODE_KANGXI_RADICAL_GOLD		   0x2FA6
#define Z_UNICODE_KANGXI_RADICAL_LONG		   0x2FA7
#define Z_UNICODE_KANGXI_RADICAL_GATE		   0x2FA8
#define Z_UNICODE_KANGXI_RADICAL_MOUND		   0x2FA9
#define Z_UNICODE_KANGXI_RADICAL_SLAVE		   0x2FAA
#define Z_UNICODE_KANGXI_RADICAL_SHORT_TAILED_BIRD 0x2FAB
#define Z_UNICODE_KANGXI_RADICAL_RAIN		   0x2FAC
#define Z_UNICODE_KANGXI_RADICAL_BLUE		   0x2FAD
#define Z_UNICODE_KANGXI_RADICAL_WRONG		   0x2FAE
#define Z_UNICODE_KANGXI_RADICAL_FACE		   0x2FAF
#define Z_UNICODE_KANGXI_RADICAL_LEATHER	   0x2FB0
#define Z_UNICODE_KANGXI_RADICAL_TANNED_LEATHER	   0x2FB1
#define Z_UNICODE_KANGXI_RADICAL_LEEK		   0x2FB2
#define Z_UNICODE_KANGXI_RADICAL_SOUND		   0x2FB3
#define Z_UNICODE_KANGXI_RADICAL_LEAF		   0x2FB4
#define Z_UNICODE_KANGXI_RADICAL_WIND		   0x2FB5
#define Z_UNICODE_KANGXI_RADICAL_FLY		   0x2FB6
#define Z_UNICODE_KANGXI_RADICAL_EAT		   0x2FB7
#define Z_UNICODE_KANGXI_RADICAL_HEAD		   0x2FB8
#define Z_UNICODE_KANGXI_RADICAL_FRAGRANT	   0x2FB9
#define Z_UNICODE_KANGXI_RADICAL_HORSE		   0x2FBA
#define Z_UNICODE_KANGXI_RADICAL_BONE		   0x2FBB
#define Z_UNICODE_KANGXI_RADICAL_TALL		   0x2FBC
#define Z_UNICODE_KANGXI_RADICAL_HAIR		   0x2FBD
#define Z_UNICODE_KANGXI_RADICAL_FIGHT		   0x2FBE
#define Z_UNICODE_KANGXI_RADICAL_SACRIFICIAL_WINE  0x2FBF
#define Z_UNICODE_KANGXI_RADICAL_CAULDRON	   0x2FC0
#define Z_UNICODE_KANGXI_RADICAL_GHOST		   0x2FC1
#define Z_UNICODE_KANGXI_RADICAL_FISH		   0x2FC2
#define Z_UNICODE_KANGXI_RADICAL_BIRD		   0x2FC3
#define Z_UNICODE_KANGXI_RADICAL_SALT		   0x2FC4
#define Z_UNICODE_KANGXI_RADICAL_DEER		   0x2FC5
#define Z_UNICODE_KANGXI_RADICAL_WHEAT		   0x2FC6
#define Z_UNICODE_KANGXI_RADICAL_HEMP		   0x2FC7
#define Z_UNICODE_KANGXI_RADICAL_YELLOW		   0x2FC8
#define Z_UNICODE_KANGXI_RADICAL_MILLET		   0x2FC9
#define Z_UNICODE_KANGXI_RADICAL_BLACK		   0x2FCA
#define Z_UNICODE_KANGXI_RADICAL_EMBROIDERY	   0x2FCB
#define Z_UNICODE_KANGXI_RADICAL_FROG		   0x2FCC
#define Z_UNICODE_KANGXI_RADICAL_TRIPOD		   0x2FCD
#define Z_UNICODE_KANGXI_RADICAL_DRUM		   0x2FCE
#define Z_UNICODE_KANGXI_RADICAL_RAT		   0x2FCF
#define Z_UNICODE_KANGXI_RADICAL_NOSE		   0x2FD0
#define Z_UNICODE_KANGXI_RADICAL_EVEN		   0x2FD1
#define Z_UNICODE_KANGXI_RADICAL_TOOTH		   0x2FD2
#define Z_UNICODE_KANGXI_RADICAL_DRAGON		   0x2FD3
#define Z_UNICODE_KANGXI_RADICAL_TURTLE		   0x2FD4
#define Z_UNICODE_KANGXI_RADICAL_FLUTE		   0x2FD5

/* MARK: - 2FF0h-2FFFh - Ideographic Description Characters */

#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_LEFT_TO_RIGHT	      0x2FF0
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_ABOVE_TO_BELOW	      0x2FF1
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_LEFT_TO_MIDDLE_AND_RIGHT  0x2FF2
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_ABOVE_TO_MIDDLE_AND_BELOW 0x2FF3
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_FULL_SURROUND	      0x2FF4
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_ABOVE	      0x2FF5
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_BELOW	      0x2FF6
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_LEFT	      0x2FF7
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_UPPER_LEFT  0x2FF8
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_UPPER_RIGHT 0x2FF9
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_SURROUND_FROM_LOWER_LEFT  0x2FFA
#define Z_UNICODE_IDEOGRAPHIC_DESCRIPTION_CHARACTER_OVERLAID		      0x2FFB

/* MARK: - 3000h-303Fh - CJK Symbols and Punctuation */

#define Z_UNICODE_IDEOGRAPHIC_SPACE					 0x3000
#define Z_UNICODE_IDEOGRAPHIC_COMMA					 0x3001
#define Z_UNICODE_IDEOGRAPHIC_FULL_STOP					 0x3002
#define Z_UNICODE_DITTO_MARK						 0x3003
#define Z_UNICODE_JAPANESE_INDUSTRIAL_STANDARD_SYMBOL			 0x3004
#define Z_UNICODE_IDEOGRAPHIC_ITERATION_MARK				 0x3005
#define Z_UNICODE_IDEOGRAPHIC_CLOSING_MARK				 0x3006
#define Z_UNICODE_IDEOGRAPHIC_NUMBER_ZERO				 0x3007
#define Z_UNICODE_LEFT_ANGLE_BRACKET					 0x3008
#define Z_UNICODE_RIGHT_ANGLE_BRACKET					 0x3009
#define Z_UNICODE_LEFT_DOUBLE_ANGLE_BRACKET				 0x300A
#define Z_UNICODE_RIGHT_DOUBLE_ANGLE_BRACKET				 0x300B
#define Z_UNICODE_LEFT_CORNER_BRACKET					 0x300C
#define Z_UNICODE_RIGHT_CORNER_BRACKET					 0x300D
#define Z_UNICODE_LEFT_WHITE_CORNER_BRACKET				 0x300E
#define Z_UNICODE_RIGHT_WHITE_CORNER_BRACKET				 0x300F
#define Z_UNICODE_LEFT_BLACK_LENTICULAR_BRACKET				 0x3010
#define Z_UNICODE_RIGHT_BLACK_LENTICULAR_BRACKET			 0x3011
#define Z_UNICODE_POSTAL_MARK						 0x3012
#define Z_UNICODE_GETA_MARK						 0x3013
#define Z_UNICODE_LEFT_TORTOISE_SHELL_BRACKET				 0x3014
#define Z_UNICODE_RIGHT_TORTOISE_SHELL_BRACKET				 0x3015
#define Z_UNICODE_LEFT_WHITE_LENTICULAR_BRACKET				 0x3016
#define Z_UNICODE_RIGHT_WHITE_LENTICULAR_BRACKET			 0x3017
#define Z_UNICODE_LEFT_WHITE_TORTOISE_SHELL_BRACKET			 0x3018
#define Z_UNICODE_RIGHT_WHITE_TORTOISE_SHELL_BRACKET			 0x3019
#define Z_UNICODE_LEFT_WHITE_SQUARE_BRACKET				 0x301A
#define Z_UNICODE_RIGHT_WHITE_SQUARE_BRACKET				 0x301B
#define Z_UNICODE_WAVE_DASH						 0x301C
#define Z_UNICODE_REVERSED_DOUBLE_PRIME_QUOTATION_MARK			 0x301D
#define Z_UNICODE_DOUBLE_PRIME_QUOTATION_MARK				 0x301E
#define Z_UNICODE_LOW_DOUBLE_PRIME_QUOTATION_MARK			 0x301F
#define Z_UNICODE_POSTAL_MARK_FACE					 0x3020
#define Z_UNICODE_HANGZHOU_NUMERAL_ONE					 0x3021
#define Z_UNICODE_HANGZHOU_NUMERAL_TWO					 0x3022
#define Z_UNICODE_HANGZHOU_NUMERAL_THREE				 0x3023
#define Z_UNICODE_HANGZHOU_NUMERAL_FOUR					 0x3024
#define Z_UNICODE_HANGZHOU_NUMERAL_FIVE					 0x3025
#define Z_UNICODE_HANGZHOU_NUMERAL_SIX					 0x3026
#define Z_UNICODE_HANGZHOU_NUMERAL_SEVEN				 0x3027
#define Z_UNICODE_HANGZHOU_NUMERAL_EIGHT				 0x3028
#define Z_UNICODE_HANGZHOU_NUMERAL_NINE					 0x3029
#define Z_UNICODE_IDEOGRAPHIC_LEVEL_TONE_MARK				 0x302A
#define Z_UNICODE_IDEOGRAPHIC_RISING_TONE_MARK				 0x302B
#define Z_UNICODE_IDEOGRAPHIC_DEPARTING_TONE_MARK			 0x302C
#define Z_UNICODE_IDEOGRAPHIC_ENTERING_TONE_MARK			 0x302D
#define Z_UNICODE_HANGUL_SINGLE_DOT_TONE_MARK				 0x302E
#define Z_UNICODE_HANGUL_DOUBLE_DOT_TONE_MARK				 0x302F
#define Z_UNICODE_WAVY_DASH						 0x3030
#define Z_UNICODE_VERTICAL_KANA_REPEAT_MARK				 0x3031
#define Z_UNICODE_VERTICAL_KANA_REPEAT_WITH_VOICED_SOUND_MARK		 0x3032
#define Z_UNICODE_VERTICAL_KANA_REPEAT_MARK_UPPER_HALF			 0x3033
#define Z_UNICODE_VERTICAL_KANA_REPEAT_WITH_VOICED_SOUND_MARK_UPPER_HALF 0x3034
#define Z_UNICODE_VERTICAL_KANA_REPEAT_MARK_LOWER_HALF			 0x3035
#define Z_UNICODE_CIRCLED_POSTAL_MARK					 0x3036
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_LINE_FEED_SEPARATOR_SYMBOL	 0x3037
#define Z_UNICODE_HANGZHOU_NUMERAL_TEN					 0x3038
#define Z_UNICODE_HANGZHOU_NUMERAL_TWENTY				 0x3039
#define Z_UNICODE_HANGZHOU_NUMERAL_THIRTY				 0x303A
#define Z_UNICODE_VERTICAL_IDEOGRAPHIC_ITERATION_MARK			 0x303B
#define Z_UNICODE_MASU_MARK						 0x303C
#define Z_UNICODE_PART_ALTERNATION_MARK					 0x303D
#define Z_UNICODE_IDEOGRAPHIC_VARIATION_INDICATOR			 0x303E
#define Z_UNICODE_IDEOGRAPHIC_HALF_FILL_SPACE				 0x303F

/* MARK: - 3040h-309Fh - Hiragana */

#define Z_UNICODE_HIRAGANA_LETTER_SMALL_A			     0x3041
#define Z_UNICODE_HIRAGANA_LETTER_A				     0x3042
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_I			     0x3043
#define Z_UNICODE_HIRAGANA_LETTER_I				     0x3044
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_U			     0x3045
#define Z_UNICODE_HIRAGANA_LETTER_U				     0x3046
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_E			     0x3047
#define Z_UNICODE_HIRAGANA_LETTER_E				     0x3048
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_O			     0x3049
#define Z_UNICODE_HIRAGANA_LETTER_O				     0x304A
#define Z_UNICODE_HIRAGANA_LETTER_KA				     0x304B
#define Z_UNICODE_HIRAGANA_LETTER_GA				     0x304C
#define Z_UNICODE_HIRAGANA_LETTER_KI				     0x304D
#define Z_UNICODE_HIRAGANA_LETTER_GI				     0x304E
#define Z_UNICODE_HIRAGANA_LETTER_KU				     0x304F
#define Z_UNICODE_HIRAGANA_LETTER_GU				     0x3050
#define Z_UNICODE_HIRAGANA_LETTER_KE				     0x3051
#define Z_UNICODE_HIRAGANA_LETTER_GE				     0x3052
#define Z_UNICODE_HIRAGANA_LETTER_KO				     0x3053
#define Z_UNICODE_HIRAGANA_LETTER_GO				     0x3054
#define Z_UNICODE_HIRAGANA_LETTER_SA				     0x3055
#define Z_UNICODE_HIRAGANA_LETTER_ZA				     0x3056
#define Z_UNICODE_HIRAGANA_LETTER_SI				     0x3057
#define Z_UNICODE_HIRAGANA_LETTER_ZI				     0x3058
#define Z_UNICODE_HIRAGANA_LETTER_SU				     0x3059
#define Z_UNICODE_HIRAGANA_LETTER_ZU				     0x305A
#define Z_UNICODE_HIRAGANA_LETTER_SE				     0x305B
#define Z_UNICODE_HIRAGANA_LETTER_ZE				     0x305C
#define Z_UNICODE_HIRAGANA_LETTER_SO				     0x305D
#define Z_UNICODE_HIRAGANA_LETTER_ZO				     0x305E
#define Z_UNICODE_HIRAGANA_LETTER_TA				     0x305F
#define Z_UNICODE_HIRAGANA_LETTER_DA				     0x3060
#define Z_UNICODE_HIRAGANA_LETTER_TI				     0x3061
#define Z_UNICODE_HIRAGANA_LETTER_DI				     0x3062
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_TU			     0x3063
#define Z_UNICODE_HIRAGANA_LETTER_TU				     0x3064
#define Z_UNICODE_HIRAGANA_LETTER_DU				     0x3065
#define Z_UNICODE_HIRAGANA_LETTER_TE				     0x3066
#define Z_UNICODE_HIRAGANA_LETTER_DE				     0x3067
#define Z_UNICODE_HIRAGANA_LETTER_TO				     0x3068
#define Z_UNICODE_HIRAGANA_LETTER_DO				     0x3069
#define Z_UNICODE_HIRAGANA_LETTER_NA				     0x306A
#define Z_UNICODE_HIRAGANA_LETTER_NI				     0x306B
#define Z_UNICODE_HIRAGANA_LETTER_NU				     0x306C
#define Z_UNICODE_HIRAGANA_LETTER_NE				     0x306D
#define Z_UNICODE_HIRAGANA_LETTER_NO				     0x306E
#define Z_UNICODE_HIRAGANA_LETTER_HA				     0x306F
#define Z_UNICODE_HIRAGANA_LETTER_BA				     0x3070
#define Z_UNICODE_HIRAGANA_LETTER_PA				     0x3071
#define Z_UNICODE_HIRAGANA_LETTER_HI				     0x3072
#define Z_UNICODE_HIRAGANA_LETTER_BI				     0x3073
#define Z_UNICODE_HIRAGANA_LETTER_PI				     0x3074
#define Z_UNICODE_HIRAGANA_LETTER_HU				     0x3075
#define Z_UNICODE_HIRAGANA_LETTER_BU				     0x3076
#define Z_UNICODE_HIRAGANA_LETTER_PU				     0x3077
#define Z_UNICODE_HIRAGANA_LETTER_HE				     0x3078
#define Z_UNICODE_HIRAGANA_LETTER_BE				     0x3079
#define Z_UNICODE_HIRAGANA_LETTER_PE				     0x307A
#define Z_UNICODE_HIRAGANA_LETTER_HO				     0x307B
#define Z_UNICODE_HIRAGANA_LETTER_BO				     0x307C
#define Z_UNICODE_HIRAGANA_LETTER_PO				     0x307D
#define Z_UNICODE_HIRAGANA_LETTER_MA				     0x307E
#define Z_UNICODE_HIRAGANA_LETTER_MI				     0x307F
#define Z_UNICODE_HIRAGANA_LETTER_MU				     0x3080
#define Z_UNICODE_HIRAGANA_LETTER_ME				     0x3081
#define Z_UNICODE_HIRAGANA_LETTER_MO				     0x3082
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_YA			     0x3083
#define Z_UNICODE_HIRAGANA_LETTER_YA				     0x3084
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_YU			     0x3085
#define Z_UNICODE_HIRAGANA_LETTER_YU				     0x3086
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_YO			     0x3087
#define Z_UNICODE_HIRAGANA_LETTER_YO				     0x3088
#define Z_UNICODE_HIRAGANA_LETTER_RA				     0x3089
#define Z_UNICODE_HIRAGANA_LETTER_RI				     0x308A
#define Z_UNICODE_HIRAGANA_LETTER_RU				     0x308B
#define Z_UNICODE_HIRAGANA_LETTER_RE				     0x308C
#define Z_UNICODE_HIRAGANA_LETTER_RO				     0x308D
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_WA			     0x308E
#define Z_UNICODE_HIRAGANA_LETTER_WA				     0x308F
#define Z_UNICODE_HIRAGANA_LETTER_WI				     0x3090
#define Z_UNICODE_HIRAGANA_LETTER_WE				     0x3091
#define Z_UNICODE_HIRAGANA_LETTER_WO				     0x3092
#define Z_UNICODE_HIRAGANA_LETTER_N				     0x3093
#define Z_UNICODE_HIRAGANA_LETTER_VU				     0x3094
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_KA			     0x3095
#define Z_UNICODE_HIRAGANA_LETTER_SMALL_KE			     0x3096
#define Z_UNICODE_COMBINING_KATAKANA_HIRAGANA_VOICED_SOUND_MARK	     0x3099
#define Z_UNICODE_COMBINING_KATAKANA_HIRAGANA_SEMI_VOICED_SOUND_MARK 0x309A
#define Z_UNICODE_KATAKANA_HIRAGANA_VOICED_SOUND_MARK		     0x309B
#define Z_UNICODE_KATAKANA_HIRAGANA_SEMI_VOICED_SOUND_MARK	     0x309C
#define Z_UNICODE_HIRAGANA_ITERATION_MARK			     0x309D
#define Z_UNICODE_HIRAGANA_VOICED_ITERATION_MARK		     0x309E
#define Z_UNICODE_HIRAGANA_DIGRAPH_YORI				     0x309F

/* MARK: - 30A0h-30FFh - Katakana */

#define Z_UNICODE_KATAKANA_HIRAGANA_DOUBLE_HYPHEN	 0x30A0
#define Z_UNICODE_KATAKANA_LETTER_SMALL_A		 0x30A1
#define Z_UNICODE_KATAKANA_LETTER_A			 0x30A2
#define Z_UNICODE_KATAKANA_LETTER_SMALL_I		 0x30A3
#define Z_UNICODE_KATAKANA_LETTER_I			 0x30A4
#define Z_UNICODE_KATAKANA_LETTER_SMALL_U		 0x30A5
#define Z_UNICODE_KATAKANA_LETTER_U			 0x30A6
#define Z_UNICODE_KATAKANA_LETTER_SMALL_E		 0x30A7
#define Z_UNICODE_KATAKANA_LETTER_E			 0x30A8
#define Z_UNICODE_KATAKANA_LETTER_SMALL_O		 0x30A9
#define Z_UNICODE_KATAKANA_LETTER_O			 0x30AA
#define Z_UNICODE_KATAKANA_LETTER_KA			 0x30AB
#define Z_UNICODE_KATAKANA_LETTER_GA			 0x30AC
#define Z_UNICODE_KATAKANA_LETTER_KI			 0x30AD
#define Z_UNICODE_KATAKANA_LETTER_GI			 0x30AE
#define Z_UNICODE_KATAKANA_LETTER_KU			 0x30AF
#define Z_UNICODE_KATAKANA_LETTER_GU			 0x30B0
#define Z_UNICODE_KATAKANA_LETTER_KE			 0x30B1
#define Z_UNICODE_KATAKANA_LETTER_GE			 0x30B2
#define Z_UNICODE_KATAKANA_LETTER_KO			 0x30B3
#define Z_UNICODE_KATAKANA_LETTER_GO			 0x30B4
#define Z_UNICODE_KATAKANA_LETTER_SA			 0x30B5
#define Z_UNICODE_KATAKANA_LETTER_ZA			 0x30B6
#define Z_UNICODE_KATAKANA_LETTER_SI			 0x30B7
#define Z_UNICODE_KATAKANA_LETTER_ZI			 0x30B8
#define Z_UNICODE_KATAKANA_LETTER_SU			 0x30B9
#define Z_UNICODE_KATAKANA_LETTER_ZU			 0x30BA
#define Z_UNICODE_KATAKANA_LETTER_SE			 0x30BB
#define Z_UNICODE_KATAKANA_LETTER_ZE			 0x30BC
#define Z_UNICODE_KATAKANA_LETTER_SO			 0x30BD
#define Z_UNICODE_KATAKANA_LETTER_ZO			 0x30BE
#define Z_UNICODE_KATAKANA_LETTER_TA			 0x30BF
#define Z_UNICODE_KATAKANA_LETTER_DA			 0x30C0
#define Z_UNICODE_KATAKANA_LETTER_TI			 0x30C1
#define Z_UNICODE_KATAKANA_LETTER_DI			 0x30C2
#define Z_UNICODE_KATAKANA_LETTER_SMALL_TU		 0x30C3
#define Z_UNICODE_KATAKANA_LETTER_TU			 0x30C4
#define Z_UNICODE_KATAKANA_LETTER_DU			 0x30C5
#define Z_UNICODE_KATAKANA_LETTER_TE			 0x30C6
#define Z_UNICODE_KATAKANA_LETTER_DE			 0x30C7
#define Z_UNICODE_KATAKANA_LETTER_TO			 0x30C8
#define Z_UNICODE_KATAKANA_LETTER_DO			 0x30C9
#define Z_UNICODE_KATAKANA_LETTER_NA			 0x30CA
#define Z_UNICODE_KATAKANA_LETTER_NI			 0x30CB
#define Z_UNICODE_KATAKANA_LETTER_NU			 0x30CC
#define Z_UNICODE_KATAKANA_LETTER_NE			 0x30CD
#define Z_UNICODE_KATAKANA_LETTER_NO			 0x30CE
#define Z_UNICODE_KATAKANA_LETTER_HA			 0x30CF
#define Z_UNICODE_KATAKANA_LETTER_BA			 0x30D0
#define Z_UNICODE_KATAKANA_LETTER_PA			 0x30D1
#define Z_UNICODE_KATAKANA_LETTER_HI			 0x30D2
#define Z_UNICODE_KATAKANA_LETTER_BI			 0x30D3
#define Z_UNICODE_KATAKANA_LETTER_PI			 0x30D4
#define Z_UNICODE_KATAKANA_LETTER_HU			 0x30D5
#define Z_UNICODE_KATAKANA_LETTER_BU			 0x30D6
#define Z_UNICODE_KATAKANA_LETTER_PU			 0x30D7
#define Z_UNICODE_KATAKANA_LETTER_HE			 0x30D8
#define Z_UNICODE_KATAKANA_LETTER_BE			 0x30D9
#define Z_UNICODE_KATAKANA_LETTER_PE			 0x30DA
#define Z_UNICODE_KATAKANA_LETTER_HO			 0x30DB
#define Z_UNICODE_KATAKANA_LETTER_BO			 0x30DC
#define Z_UNICODE_KATAKANA_LETTER_PO			 0x30DD
#define Z_UNICODE_KATAKANA_LETTER_MA			 0x30DE
#define Z_UNICODE_KATAKANA_LETTER_MI			 0x30DF
#define Z_UNICODE_KATAKANA_LETTER_MU			 0x30E0
#define Z_UNICODE_KATAKANA_LETTER_ME			 0x30E1
#define Z_UNICODE_KATAKANA_LETTER_MO			 0x30E2
#define Z_UNICODE_KATAKANA_LETTER_SMALL_YA		 0x30E3
#define Z_UNICODE_KATAKANA_LETTER_YA			 0x30E4
#define Z_UNICODE_KATAKANA_LETTER_SMALL_YU		 0x30E5
#define Z_UNICODE_KATAKANA_LETTER_YU			 0x30E6
#define Z_UNICODE_KATAKANA_LETTER_SMALL_YO		 0x30E7
#define Z_UNICODE_KATAKANA_LETTER_YO			 0x30E8
#define Z_UNICODE_KATAKANA_LETTER_RA			 0x30E9
#define Z_UNICODE_KATAKANA_LETTER_RI			 0x30EA
#define Z_UNICODE_KATAKANA_LETTER_RU			 0x30EB
#define Z_UNICODE_KATAKANA_LETTER_RE			 0x30EC
#define Z_UNICODE_KATAKANA_LETTER_RO			 0x30ED
#define Z_UNICODE_KATAKANA_LETTER_SMALL_WA		 0x30EE
#define Z_UNICODE_KATAKANA_LETTER_WA			 0x30EF
#define Z_UNICODE_KATAKANA_LETTER_WI			 0x30F0
#define Z_UNICODE_KATAKANA_LETTER_WE			 0x30F1
#define Z_UNICODE_KATAKANA_LETTER_WO			 0x30F2
#define Z_UNICODE_KATAKANA_LETTER_N			 0x30F3
#define Z_UNICODE_KATAKANA_LETTER_VU			 0x30F4
#define Z_UNICODE_KATAKANA_LETTER_SMALL_KA		 0x30F5
#define Z_UNICODE_KATAKANA_LETTER_SMALL_KE		 0x30F6
#define Z_UNICODE_KATAKANA_LETTER_VA			 0x30F7
#define Z_UNICODE_KATAKANA_LETTER_VI			 0x30F8
#define Z_UNICODE_KATAKANA_LETTER_VE			 0x30F9
#define Z_UNICODE_KATAKANA_LETTER_VO			 0x30FA
#define Z_UNICODE_KATAKANA_MIDDLE_DOT			 0x30FB
#define Z_UNICODE_KATAKANA_HIRAGANA_PROLONGED_SOUND_MARK 0x30FC
#define Z_UNICODE_KATAKANA_ITERATION_MARK		 0x30FD
#define Z_UNICODE_KATAKANA_VOICED_ITERATION_MARK	 0x30FE
#define Z_UNICODE_KATAKANA_DIGRAPH_KOTO			 0x30FF

/* MARK: - 3100h-312Fh - Bopomofo */

#define Z_UNICODE_BOPOMOFO_LETTER_B   0x3105
#define Z_UNICODE_BOPOMOFO_LETTER_P   0x3106
#define Z_UNICODE_BOPOMOFO_LETTER_M   0x3107
#define Z_UNICODE_BOPOMOFO_LETTER_F   0x3108
#define Z_UNICODE_BOPOMOFO_LETTER_D   0x3109
#define Z_UNICODE_BOPOMOFO_LETTER_T   0x310A
#define Z_UNICODE_BOPOMOFO_LETTER_N   0x310B
#define Z_UNICODE_BOPOMOFO_LETTER_L   0x310C
#define Z_UNICODE_BOPOMOFO_LETTER_G   0x310D
#define Z_UNICODE_BOPOMOFO_LETTER_K   0x310E
#define Z_UNICODE_BOPOMOFO_LETTER_H   0x310F
#define Z_UNICODE_BOPOMOFO_LETTER_J   0x3110
#define Z_UNICODE_BOPOMOFO_LETTER_Q   0x3111
#define Z_UNICODE_BOPOMOFO_LETTER_X   0x3112
#define Z_UNICODE_BOPOMOFO_LETTER_ZH  0x3113
#define Z_UNICODE_BOPOMOFO_LETTER_CH  0x3114
#define Z_UNICODE_BOPOMOFO_LETTER_SH  0x3115
#define Z_UNICODE_BOPOMOFO_LETTER_R   0x3116
#define Z_UNICODE_BOPOMOFO_LETTER_Z   0x3117
#define Z_UNICODE_BOPOMOFO_LETTER_C   0x3118
#define Z_UNICODE_BOPOMOFO_LETTER_S   0x3119
#define Z_UNICODE_BOPOMOFO_LETTER_A   0x311A
#define Z_UNICODE_BOPOMOFO_LETTER_O   0x311B
#define Z_UNICODE_BOPOMOFO_LETTER_E   0x311C
#define Z_UNICODE_BOPOMOFO_LETTER_EH  0x311D
#define Z_UNICODE_BOPOMOFO_LETTER_AI  0x311E
#define Z_UNICODE_BOPOMOFO_LETTER_EI  0x311F
#define Z_UNICODE_BOPOMOFO_LETTER_AU  0x3120
#define Z_UNICODE_BOPOMOFO_LETTER_OU  0x3121
#define Z_UNICODE_BOPOMOFO_LETTER_AN  0x3122
#define Z_UNICODE_BOPOMOFO_LETTER_EN  0x3123
#define Z_UNICODE_BOPOMOFO_LETTER_ANG 0x3124
#define Z_UNICODE_BOPOMOFO_LETTER_ENG 0x3125
#define Z_UNICODE_BOPOMOFO_LETTER_ER  0x3126
#define Z_UNICODE_BOPOMOFO_LETTER_I   0x3127
#define Z_UNICODE_BOPOMOFO_LETTER_U   0x3128
#define Z_UNICODE_BOPOMOFO_LETTER_IU  0x3129
#define Z_UNICODE_BOPOMOFO_LETTER_V   0x312A
#define Z_UNICODE_BOPOMOFO_LETTER_NG  0x312B
#define Z_UNICODE_BOPOMOFO_LETTER_GN  0x312C
#define Z_UNICODE_BOPOMOFO_LETTER_IH  0x312D

/* MARK: - 3130h-318Fh - Hangul Compatibility Jamo */

#define Z_UNICODE_HANGUL_LETTER_KIYEOK		   0x3131
#define Z_UNICODE_HANGUL_LETTER_SSANGKIYEOK	   0x3132
#define Z_UNICODE_HANGUL_LETTER_KIYEOK_SIOS	   0x3133
#define Z_UNICODE_HANGUL_LETTER_NIEUN		   0x3134
#define Z_UNICODE_HANGUL_LETTER_NIEUN_CIEUC	   0x3135
#define Z_UNICODE_HANGUL_LETTER_NIEUN_HIEUH	   0x3136
#define Z_UNICODE_HANGUL_LETTER_TIKEUT		   0x3137
#define Z_UNICODE_HANGUL_LETTER_SSANGTIKEUT	   0x3138
#define Z_UNICODE_HANGUL_LETTER_RIEUL		   0x3139
#define Z_UNICODE_HANGUL_LETTER_RIEUL_KIYEOK	   0x313A
#define Z_UNICODE_HANGUL_LETTER_RIEUL_MIEUM	   0x313B
#define Z_UNICODE_HANGUL_LETTER_RIEUL_PIEUP	   0x313C
#define Z_UNICODE_HANGUL_LETTER_RIEUL_SIOS	   0x313D
#define Z_UNICODE_HANGUL_LETTER_RIEUL_THIEUTH	   0x313E
#define Z_UNICODE_HANGUL_LETTER_RIEUL_PHIEUPH	   0x313F
#define Z_UNICODE_HANGUL_LETTER_RIEUL_HIEUH	   0x3140
#define Z_UNICODE_HANGUL_LETTER_MIEUM		   0x3141
#define Z_UNICODE_HANGUL_LETTER_PIEUP		   0x3142
#define Z_UNICODE_HANGUL_LETTER_SSANGPIEUP	   0x3143
#define Z_UNICODE_HANGUL_LETTER_PIEUP_SIOS	   0x3144
#define Z_UNICODE_HANGUL_LETTER_SIOS		   0x3145
#define Z_UNICODE_HANGUL_LETTER_SSANGSIOS	   0x3146
#define Z_UNICODE_HANGUL_LETTER_IEUNG		   0x3147
#define Z_UNICODE_HANGUL_LETTER_CIEUC		   0x3148
#define Z_UNICODE_HANGUL_LETTER_SSANGCIEUC	   0x3149
#define Z_UNICODE_HANGUL_LETTER_CHIEUCH		   0x314A
#define Z_UNICODE_HANGUL_LETTER_KHIEUKH		   0x314B
#define Z_UNICODE_HANGUL_LETTER_THIEUTH		   0x314C
#define Z_UNICODE_HANGUL_LETTER_PHIEUPH		   0x314D
#define Z_UNICODE_HANGUL_LETTER_HIEUH		   0x314E
#define Z_UNICODE_HANGUL_LETTER_A		   0x314F
#define Z_UNICODE_HANGUL_LETTER_AE		   0x3150
#define Z_UNICODE_HANGUL_LETTER_YA		   0x3151
#define Z_UNICODE_HANGUL_LETTER_YAE		   0x3152
#define Z_UNICODE_HANGUL_LETTER_EO		   0x3153
#define Z_UNICODE_HANGUL_LETTER_E		   0x3154
#define Z_UNICODE_HANGUL_LETTER_YEO		   0x3155
#define Z_UNICODE_HANGUL_LETTER_YE		   0x3156
#define Z_UNICODE_HANGUL_LETTER_O		   0x3157
#define Z_UNICODE_HANGUL_LETTER_WA		   0x3158
#define Z_UNICODE_HANGUL_LETTER_WAE		   0x3159
#define Z_UNICODE_HANGUL_LETTER_OE		   0x315A
#define Z_UNICODE_HANGUL_LETTER_YO		   0x315B
#define Z_UNICODE_HANGUL_LETTER_U		   0x315C
#define Z_UNICODE_HANGUL_LETTER_WEO		   0x315D
#define Z_UNICODE_HANGUL_LETTER_WE		   0x315E
#define Z_UNICODE_HANGUL_LETTER_WI		   0x315F
#define Z_UNICODE_HANGUL_LETTER_YU		   0x3160
#define Z_UNICODE_HANGUL_LETTER_EU		   0x3161
#define Z_UNICODE_HANGUL_LETTER_YI		   0x3162
#define Z_UNICODE_HANGUL_LETTER_I		   0x3163
#define Z_UNICODE_HANGUL_FILLER			   0x3164
#define Z_UNICODE_HANGUL_LETTER_SSANGNIEUN	   0x3165
#define Z_UNICODE_HANGUL_LETTER_NIEUN_TIKEUT	   0x3166
#define Z_UNICODE_HANGUL_LETTER_NIEUN_SIOS	   0x3167
#define Z_UNICODE_HANGUL_LETTER_NIEUN_PANSIOS	   0x3168
#define Z_UNICODE_HANGUL_LETTER_RIEUL_KIYEOK_SIOS  0x3169
#define Z_UNICODE_HANGUL_LETTER_RIEUL_TIKEUT	   0x316A
#define Z_UNICODE_HANGUL_LETTER_RIEUL_PIEUP_SIOS   0x316B
#define Z_UNICODE_HANGUL_LETTER_RIEUL_PANSIOS	   0x316C
#define Z_UNICODE_HANGUL_LETTER_RIEUL_YEORINHIEUH  0x316D
#define Z_UNICODE_HANGUL_LETTER_MIEUM_PIEUP	   0x316E
#define Z_UNICODE_HANGUL_LETTER_MIEUM_SIOS	   0x316F
#define Z_UNICODE_HANGUL_LETTER_MIEUM_PANSIOS	   0x3170
#define Z_UNICODE_HANGUL_LETTER_KAPYEOUNMIEUM	   0x3171
#define Z_UNICODE_HANGUL_LETTER_PIEUP_KIYEOK	   0x3172
#define Z_UNICODE_HANGUL_LETTER_PIEUP_TIKEUT	   0x3173
#define Z_UNICODE_HANGUL_LETTER_PIEUP_SIOS_KIYEOK  0x3174
#define Z_UNICODE_HANGUL_LETTER_PIEUP_SIOS_TIKEUT  0x3175
#define Z_UNICODE_HANGUL_LETTER_PIEUP_CIEUC	   0x3176
#define Z_UNICODE_HANGUL_LETTER_PIEUP_THIEUTH	   0x3177
#define Z_UNICODE_HANGUL_LETTER_KAPYEOUNPIEUP	   0x3178
#define Z_UNICODE_HANGUL_LETTER_KAPYEOUNSSANGPIEUP 0x3179
#define Z_UNICODE_HANGUL_LETTER_SIOS_KIYEOK	   0x317A
#define Z_UNICODE_HANGUL_LETTER_SIOS_NIEUN	   0x317B
#define Z_UNICODE_HANGUL_LETTER_SIOS_TIKEUT	   0x317C
#define Z_UNICODE_HANGUL_LETTER_SIOS_PIEUP	   0x317D
#define Z_UNICODE_HANGUL_LETTER_SIOS_CIEUC	   0x317E
#define Z_UNICODE_HANGUL_LETTER_PANSIOS		   0x317F
#define Z_UNICODE_HANGUL_LETTER_SSANGIEUNG	   0x3180
#define Z_UNICODE_HANGUL_LETTER_YESIEUNG	   0x3181
#define Z_UNICODE_HANGUL_LETTER_YESIEUNG_SIOS	   0x3182
#define Z_UNICODE_HANGUL_LETTER_YESIEUNG_PANSIOS   0x3183
#define Z_UNICODE_HANGUL_LETTER_KAPYEOUNPHIEUPH	   0x3184
#define Z_UNICODE_HANGUL_LETTER_SSANGHIEUH	   0x3185
#define Z_UNICODE_HANGUL_LETTER_YEORINHIEUH	   0x3186
#define Z_UNICODE_HANGUL_LETTER_YO_YA		   0x3187
#define Z_UNICODE_HANGUL_LETTER_YO_YAE		   0x3188
#define Z_UNICODE_HANGUL_LETTER_YO_I		   0x3189
#define Z_UNICODE_HANGUL_LETTER_YU_YEO		   0x318A
#define Z_UNICODE_HANGUL_LETTER_YU_YE		   0x318B
#define Z_UNICODE_HANGUL_LETTER_YU_I		   0x318C
#define Z_UNICODE_HANGUL_LETTER_ARAEA		   0x318D
#define Z_UNICODE_HANGUL_LETTER_ARAEAE		   0x318E

/* MARK: - 3190h-319Fh - Kanbun */

#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_LINKING_MARK 0x3190
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_REVERSE_MARK 0x3191
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_ONE_MARK     0x3192
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_TWO_MARK     0x3193
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_THREE_MARK   0x3194
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_FOUR_MARK    0x3195
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_TOP_MARK     0x3196
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_MIDDLE_MARK  0x3197
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_BOTTOM_MARK  0x3198
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_FIRST_MARK   0x3199
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_SECOND_MARK  0x319A
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_THIRD_MARK   0x319B
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_FOURTH_MARK  0x319C
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_HEAVEN_MARK  0x319D
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_EARTH_MARK   0x319E
#define Z_UNICODE_IDEOGRAPHIC_ANNOTATION_MAN_MARK     0x319F

/* MARK: - 31A0h-31BFh - Bopomofo Extended */

#define Z_UNICODE_BOPOMOFO_LETTER_BU	  0x31A0
#define Z_UNICODE_BOPOMOFO_LETTER_ZI	  0x31A1
#define Z_UNICODE_BOPOMOFO_LETTER_JI	  0x31A2
#define Z_UNICODE_BOPOMOFO_LETTER_GU	  0x31A3
#define Z_UNICODE_BOPOMOFO_LETTER_EE	  0x31A4
#define Z_UNICODE_BOPOMOFO_LETTER_ENN	  0x31A5
#define Z_UNICODE_BOPOMOFO_LETTER_OO	  0x31A6
#define Z_UNICODE_BOPOMOFO_LETTER_ONN	  0x31A7
#define Z_UNICODE_BOPOMOFO_LETTER_IR	  0x31A8
#define Z_UNICODE_BOPOMOFO_LETTER_ANN	  0x31A9
#define Z_UNICODE_BOPOMOFO_LETTER_INN	  0x31AA
#define Z_UNICODE_BOPOMOFO_LETTER_UNN	  0x31AB
#define Z_UNICODE_BOPOMOFO_LETTER_IM	  0x31AC
#define Z_UNICODE_BOPOMOFO_LETTER_NGG	  0x31AD
#define Z_UNICODE_BOPOMOFO_LETTER_AINN	  0x31AE
#define Z_UNICODE_BOPOMOFO_LETTER_AUNN	  0x31AF
#define Z_UNICODE_BOPOMOFO_LETTER_AM	  0x31B0
#define Z_UNICODE_BOPOMOFO_LETTER_OM	  0x31B1
#define Z_UNICODE_BOPOMOFO_LETTER_ONG	  0x31B2
#define Z_UNICODE_BOPOMOFO_LETTER_INNN	  0x31B3
#define Z_UNICODE_BOPOMOFO_FINAL_LETTER_P 0x31B4
#define Z_UNICODE_BOPOMOFO_FINAL_LETTER_T 0x31B5
#define Z_UNICODE_BOPOMOFO_FINAL_LETTER_K 0x31B6
#define Z_UNICODE_BOPOMOFO_FINAL_LETTER_H 0x31B7
#define Z_UNICODE_BOPOMOFO_LETTER_GH	  0x31B8
#define Z_UNICODE_BOPOMOFO_LETTER_LH	  0x31B9
#define Z_UNICODE_BOPOMOFO_LETTER_ZY	  0x31BA

/* MARK: - 31C0h-31EFh - CJK Strokes */

#define Z_UNICODE_CJK_STROKE_T	   0x31C0
#define Z_UNICODE_CJK_STROKE_WG	   0x31C1
#define Z_UNICODE_CJK_STROKE_XG	   0x31C2
#define Z_UNICODE_CJK_STROKE_BXG   0x31C3
#define Z_UNICODE_CJK_STROKE_SW	   0x31C4
#define Z_UNICODE_CJK_STROKE_HZZ   0x31C5
#define Z_UNICODE_CJK_STROKE_HZG   0x31C6
#define Z_UNICODE_CJK_STROKE_HP	   0x31C7
#define Z_UNICODE_CJK_STROKE_HZWG  0x31C8
#define Z_UNICODE_CJK_STROKE_SZWG  0x31C9
#define Z_UNICODE_CJK_STROKE_HZT   0x31CA
#define Z_UNICODE_CJK_STROKE_HZZP  0x31CB
#define Z_UNICODE_CJK_STROKE_HPWG  0x31CC
#define Z_UNICODE_CJK_STROKE_HZW   0x31CD
#define Z_UNICODE_CJK_STROKE_HZZZ  0x31CE
#define Z_UNICODE_CJK_STROKE_N	   0x31CF
#define Z_UNICODE_CJK_STROKE_H	   0x31D0
#define Z_UNICODE_CJK_STROKE_S	   0x31D1
#define Z_UNICODE_CJK_STROKE_P	   0x31D2
#define Z_UNICODE_CJK_STROKE_SP	   0x31D3
#define Z_UNICODE_CJK_STROKE_D	   0x31D4
#define Z_UNICODE_CJK_STROKE_HZ	   0x31D5
#define Z_UNICODE_CJK_STROKE_HG	   0x31D6
#define Z_UNICODE_CJK_STROKE_SZ	   0x31D7
#define Z_UNICODE_CJK_STROKE_SWZ   0x31D8
#define Z_UNICODE_CJK_STROKE_ST	   0x31D9
#define Z_UNICODE_CJK_STROKE_SG	   0x31DA
#define Z_UNICODE_CJK_STROKE_PD	   0x31DB
#define Z_UNICODE_CJK_STROKE_PZ	   0x31DC
#define Z_UNICODE_CJK_STROKE_TN	   0x31DD
#define Z_UNICODE_CJK_STROKE_SZZ   0x31DE
#define Z_UNICODE_CJK_STROKE_SWG   0x31DF
#define Z_UNICODE_CJK_STROKE_HXWG  0x31E0
#define Z_UNICODE_CJK_STROKE_HZZZG 0x31E1
#define Z_UNICODE_CJK_STROKE_PG	   0x31E2
#define Z_UNICODE_CJK_STROKE_Q	   0x31E3

/* MARK: - 31F0h-31FFh - Katakana Phonetic Extensions */

#define Z_UNICODE_KATAKANA_LETTER_SMALL_KU 0x31F0
#define Z_UNICODE_KATAKANA_LETTER_SMALL_SI 0x31F1
#define Z_UNICODE_KATAKANA_LETTER_SMALL_SU 0x31F2
#define Z_UNICODE_KATAKANA_LETTER_SMALL_TO 0x31F3
#define Z_UNICODE_KATAKANA_LETTER_SMALL_NU 0x31F4
#define Z_UNICODE_KATAKANA_LETTER_SMALL_HA 0x31F5
#define Z_UNICODE_KATAKANA_LETTER_SMALL_HI 0x31F6
#define Z_UNICODE_KATAKANA_LETTER_SMALL_HU 0x31F7
#define Z_UNICODE_KATAKANA_LETTER_SMALL_HE 0x31F8
#define Z_UNICODE_KATAKANA_LETTER_SMALL_HO 0x31F9
#define Z_UNICODE_KATAKANA_LETTER_SMALL_MU 0x31FA
#define Z_UNICODE_KATAKANA_LETTER_SMALL_RA 0x31FB
#define Z_UNICODE_KATAKANA_LETTER_SMALL_RI 0x31FC
#define Z_UNICODE_KATAKANA_LETTER_SMALL_RU 0x31FD
#define Z_UNICODE_KATAKANA_LETTER_SMALL_RE 0x31FE
#define Z_UNICODE_KATAKANA_LETTER_SMALL_RO 0x31FF

/* MARK: - 3200h-32FFh - Enclosed CJK Letters and Months */

#define Z_UNICODE_PARENTHESIZED_HANGUL_KIYEOK		     0x3200
#define Z_UNICODE_PARENTHESIZED_HANGUL_NIEUN		     0x3201
#define Z_UNICODE_PARENTHESIZED_HANGUL_TIKEUT		     0x3202
#define Z_UNICODE_PARENTHESIZED_HANGUL_RIEUL		     0x3203
#define Z_UNICODE_PARENTHESIZED_HANGUL_MIEUM		     0x3204
#define Z_UNICODE_PARENTHESIZED_HANGUL_PIEUP		     0x3205
#define Z_UNICODE_PARENTHESIZED_HANGUL_SIOS		     0x3206
#define Z_UNICODE_PARENTHESIZED_HANGUL_IEUNG		     0x3207
#define Z_UNICODE_PARENTHESIZED_HANGUL_CIEUC		     0x3208
#define Z_UNICODE_PARENTHESIZED_HANGUL_CHIEUCH		     0x3209
#define Z_UNICODE_PARENTHESIZED_HANGUL_KHIEUKH		     0x320A
#define Z_UNICODE_PARENTHESIZED_HANGUL_THIEUTH		     0x320B
#define Z_UNICODE_PARENTHESIZED_HANGUL_PHIEUPH		     0x320C
#define Z_UNICODE_PARENTHESIZED_HANGUL_HIEUH		     0x320D
#define Z_UNICODE_PARENTHESIZED_HANGUL_KIYEOK_A		     0x320E
#define Z_UNICODE_PARENTHESIZED_HANGUL_NIEUN_A		     0x320F
#define Z_UNICODE_PARENTHESIZED_HANGUL_TIKEUT_A		     0x3210
#define Z_UNICODE_PARENTHESIZED_HANGUL_RIEUL_A		     0x3211
#define Z_UNICODE_PARENTHESIZED_HANGUL_MIEUM_A		     0x3212
#define Z_UNICODE_PARENTHESIZED_HANGUL_PIEUP_A		     0x3213
#define Z_UNICODE_PARENTHESIZED_HANGUL_SIOS_A		     0x3214
#define Z_UNICODE_PARENTHESIZED_HANGUL_IEUNG_A		     0x3215
#define Z_UNICODE_PARENTHESIZED_HANGUL_CIEUC_A		     0x3216
#define Z_UNICODE_PARENTHESIZED_HANGUL_CHIEUCH_A	     0x3217
#define Z_UNICODE_PARENTHESIZED_HANGUL_KHIEUKH_A	     0x3218
#define Z_UNICODE_PARENTHESIZED_HANGUL_THIEUTH_A	     0x3219
#define Z_UNICODE_PARENTHESIZED_HANGUL_PHIEUPH_A	     0x321A
#define Z_UNICODE_PARENTHESIZED_HANGUL_HIEUH_A		     0x321B
#define Z_UNICODE_PARENTHESIZED_HANGUL_CIEUC_U		     0x321C
#define Z_UNICODE_PARENTHESIZED_KOREAN_CHARACTER_OJEON	     0x321D
#define Z_UNICODE_PARENTHESIZED_KOREAN_CHARACTER_O_HU	     0x321E
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_ONE		     0x3220
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_TWO		     0x3221
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_THREE		     0x3222
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_FOUR		     0x3223
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_FIVE		     0x3224
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_SIX		     0x3225
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_SEVEN		     0x3226
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_EIGHT		     0x3227
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_NINE		     0x3228
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_TEN		     0x3229
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_MOON		     0x322A
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_FIRE		     0x322B
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_WATER		     0x322C
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_WOOD		     0x322D
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_METAL		     0x322E
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_EARTH		     0x322F
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_SUN		     0x3230
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_STOCK		     0x3231
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_HAVE		     0x3232
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_SOCIETY	     0x3233
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_NAME		     0x3234
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_SPECIAL	     0x3235
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_FINANCIAL	     0x3236
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_CONGRATULATION     0x3237
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_LABOR		     0x3238
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_REPRESENT	     0x3239
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_CALL		     0x323A
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_STUDY		     0x323B
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_SUPERVISE	     0x323C
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_ENTERPRISE	     0x323D
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_RESOURCE	     0x323E
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_ALLIANCE	     0x323F
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_FESTIVAL	     0x3240
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_REST		     0x3241
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_SELF		     0x3242
#define Z_UNICODE_PARENTHESIZED_IDEOGRAPH_REACH		     0x3243
#define Z_UNICODE_CIRCLED_IDEOGRAPH_QUESTION		     0x3244
#define Z_UNICODE_CIRCLED_IDEOGRAPH_KINDERGARTEN	     0x3245
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SCHOOL		     0x3246
#define Z_UNICODE_CIRCLED_IDEOGRAPH_KOTO		     0x3247
#define Z_UNICODE_CIRCLED_NUMBER_TEN_ON_BLACK_SQUARE	     0x3248
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_ON_BLACK_SQUARE	     0x3249
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_ON_BLACK_SQUARE	     0x324A
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_ON_BLACK_SQUARE	     0x324B
#define Z_UNICODE_CIRCLED_NUMBER_FIFTY_ON_BLACK_SQUARE	     0x324C
#define Z_UNICODE_CIRCLED_NUMBER_SIXTY_ON_BLACK_SQUARE	     0x324D
#define Z_UNICODE_CIRCLED_NUMBER_SEVENTY_ON_BLACK_SQUARE     0x324E
#define Z_UNICODE_CIRCLED_NUMBER_EIGHTY_ON_BLACK_SQUARE	     0x324F
#define Z_UNICODE_PARTNERSHIP_SIGN			     0x3250
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_ONE		     0x3251
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_TWO		     0x3252
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_THREE		     0x3253
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_FOUR		     0x3254
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_FIVE		     0x3255
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_SIX		     0x3256
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_SEVEN		     0x3257
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_EIGHT		     0x3258
#define Z_UNICODE_CIRCLED_NUMBER_TWENTY_NINE		     0x3259
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY			     0x325A
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_ONE		     0x325B
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_TWO		     0x325C
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_THREE		     0x325D
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_FOUR		     0x325E
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_FIVE		     0x325F
#define Z_UNICODE_CIRCLED_HANGUL_KIYEOK			     0x3260
#define Z_UNICODE_CIRCLED_HANGUL_NIEUN			     0x3261
#define Z_UNICODE_CIRCLED_HANGUL_TIKEUT			     0x3262
#define Z_UNICODE_CIRCLED_HANGUL_RIEUL			     0x3263
#define Z_UNICODE_CIRCLED_HANGUL_MIEUM			     0x3264
#define Z_UNICODE_CIRCLED_HANGUL_PIEUP			     0x3265
#define Z_UNICODE_CIRCLED_HANGUL_SIOS			     0x3266
#define Z_UNICODE_CIRCLED_HANGUL_IEUNG			     0x3267
#define Z_UNICODE_CIRCLED_HANGUL_CIEUC			     0x3268
#define Z_UNICODE_CIRCLED_HANGUL_CHIEUCH		     0x3269
#define Z_UNICODE_CIRCLED_HANGUL_KHIEUKH		     0x326A
#define Z_UNICODE_CIRCLED_HANGUL_THIEUTH		     0x326B
#define Z_UNICODE_CIRCLED_HANGUL_PHIEUPH		     0x326C
#define Z_UNICODE_CIRCLED_HANGUL_HIEUH			     0x326D
#define Z_UNICODE_CIRCLED_HANGUL_KIYEOK_A		     0x326E
#define Z_UNICODE_CIRCLED_HANGUL_NIEUN_A		     0x326F
#define Z_UNICODE_CIRCLED_HANGUL_TIKEUT_A		     0x3270
#define Z_UNICODE_CIRCLED_HANGUL_RIEUL_A		     0x3271
#define Z_UNICODE_CIRCLED_HANGUL_MIEUM_A		     0x3272
#define Z_UNICODE_CIRCLED_HANGUL_PIEUP_A		     0x3273
#define Z_UNICODE_CIRCLED_HANGUL_SIOS_A			     0x3274
#define Z_UNICODE_CIRCLED_HANGUL_IEUNG_A		     0x3275
#define Z_UNICODE_CIRCLED_HANGUL_CIEUC_A		     0x3276
#define Z_UNICODE_CIRCLED_HANGUL_CHIEUCH_A		     0x3277
#define Z_UNICODE_CIRCLED_HANGUL_KHIEUKH_A		     0x3278
#define Z_UNICODE_CIRCLED_HANGUL_THIEUTH_A		     0x3279
#define Z_UNICODE_CIRCLED_HANGUL_PHIEUPH_A		     0x327A
#define Z_UNICODE_CIRCLED_HANGUL_HIEUH_A		     0x327B
#define Z_UNICODE_CIRCLED_KOREAN_CHARACTER_CHAMKO	     0x327C
#define Z_UNICODE_CIRCLED_KOREAN_CHARACTER_JUEUI	     0x327D
#define Z_UNICODE_CIRCLED_HANGUL_IEUNG_U		     0x327E
#define Z_UNICODE_KOREAN_STANDARD_SYMBOL		     0x327F
#define Z_UNICODE_CIRCLED_IDEOGRAPH_ONE			     0x3280
#define Z_UNICODE_CIRCLED_IDEOGRAPH_TWO			     0x3281
#define Z_UNICODE_CIRCLED_IDEOGRAPH_THREE		     0x3282
#define Z_UNICODE_CIRCLED_IDEOGRAPH_FOUR		     0x3283
#define Z_UNICODE_CIRCLED_IDEOGRAPH_FIVE		     0x3284
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SIX			     0x3285
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SEVEN		     0x3286
#define Z_UNICODE_CIRCLED_IDEOGRAPH_EIGHT		     0x3287
#define Z_UNICODE_CIRCLED_IDEOGRAPH_NINE		     0x3288
#define Z_UNICODE_CIRCLED_IDEOGRAPH_TEN			     0x3289
#define Z_UNICODE_CIRCLED_IDEOGRAPH_MOON		     0x328A
#define Z_UNICODE_CIRCLED_IDEOGRAPH_FIRE		     0x328B
#define Z_UNICODE_CIRCLED_IDEOGRAPH_WATER		     0x328C
#define Z_UNICODE_CIRCLED_IDEOGRAPH_WOOD		     0x328D
#define Z_UNICODE_CIRCLED_IDEOGRAPH_METAL		     0x328E
#define Z_UNICODE_CIRCLED_IDEOGRAPH_EARTH		     0x328F
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SUN			     0x3290
#define Z_UNICODE_CIRCLED_IDEOGRAPH_STOCK		     0x3291
#define Z_UNICODE_CIRCLED_IDEOGRAPH_HAVE		     0x3292
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SOCIETY		     0x3293
#define Z_UNICODE_CIRCLED_IDEOGRAPH_NAME		     0x3294
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SPECIAL		     0x3295
#define Z_UNICODE_CIRCLED_IDEOGRAPH_FINANCIAL		     0x3296
#define Z_UNICODE_CIRCLED_IDEOGRAPH_CONGRATULATION	     0x3297
#define Z_UNICODE_CIRCLED_IDEOGRAPH_LABOR		     0x3298
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SECRET		     0x3299
#define Z_UNICODE_CIRCLED_IDEOGRAPH_MALE		     0x329A
#define Z_UNICODE_CIRCLED_IDEOGRAPH_FEMALE		     0x329B
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SUITABLE		     0x329C
#define Z_UNICODE_CIRCLED_IDEOGRAPH_EXCELLENT		     0x329D
#define Z_UNICODE_CIRCLED_IDEOGRAPH_PRINT		     0x329E
#define Z_UNICODE_CIRCLED_IDEOGRAPH_ATTENTION		     0x329F
#define Z_UNICODE_CIRCLED_IDEOGRAPH_ITEM		     0x32A0
#define Z_UNICODE_CIRCLED_IDEOGRAPH_REST		     0x32A1
#define Z_UNICODE_CIRCLED_IDEOGRAPH_COPY		     0x32A2
#define Z_UNICODE_CIRCLED_IDEOGRAPH_CORRECT		     0x32A3
#define Z_UNICODE_CIRCLED_IDEOGRAPH_HIGH		     0x32A4
#define Z_UNICODE_CIRCLED_IDEOGRAPH_CENTRE		     0x32A5
#define Z_UNICODE_CIRCLED_IDEOGRAPH_LOW			     0x32A6
#define Z_UNICODE_CIRCLED_IDEOGRAPH_LEFT		     0x32A7
#define Z_UNICODE_CIRCLED_IDEOGRAPH_RIGHT		     0x32A8
#define Z_UNICODE_CIRCLED_IDEOGRAPH_MEDICINE		     0x32A9
#define Z_UNICODE_CIRCLED_IDEOGRAPH_RELIGION		     0x32AA
#define Z_UNICODE_CIRCLED_IDEOGRAPH_STUDY		     0x32AB
#define Z_UNICODE_CIRCLED_IDEOGRAPH_SUPERVISE		     0x32AC
#define Z_UNICODE_CIRCLED_IDEOGRAPH_ENTERPRISE		     0x32AD
#define Z_UNICODE_CIRCLED_IDEOGRAPH_RESOURCE		     0x32AE
#define Z_UNICODE_CIRCLED_IDEOGRAPH_ALLIANCE		     0x32AF
#define Z_UNICODE_CIRCLED_IDEOGRAPH_NIGHT		     0x32B0
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_SIX		     0x32B1
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_SEVEN		     0x32B2
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_EIGHT		     0x32B3
#define Z_UNICODE_CIRCLED_NUMBER_THIRTY_NINE		     0x32B4
#define Z_UNICODE_CIRCLED_NUMBER_FORTY			     0x32B5
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_ONE		     0x32B6
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_TWO		     0x32B7
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_THREE		     0x32B8
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_FOUR		     0x32B9
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_FIVE		     0x32BA
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_SIX		     0x32BB
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_SEVEN		     0x32BC
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_EIGHT		     0x32BD
#define Z_UNICODE_CIRCLED_NUMBER_FORTY_NINE		     0x32BE
#define Z_UNICODE_CIRCLED_NUMBER_FIFTY			     0x32BF
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JANUARY   0x32C0
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_FEBRUARY  0x32C1
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_MARCH     0x32C2
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_APRIL     0x32C3
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_MAY	     0x32C4
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JUNE	     0x32C5
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_JULY	     0x32C6
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_AUGUST    0x32C7
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_SEPTEMBER 0x32C8
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_OCTOBER   0x32C9
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_NOVEMBER  0x32CA
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DECEMBER  0x32CB
#define Z_UNICODE_SQUARE_HG				     0x32CC
#define Z_UNICODE_SQUARE_ERG				     0x32CD
#define Z_UNICODE_SQUARE_EV				     0x32CE
#define Z_UNICODE_LIMITED_LIABILITY_SIGN		     0x32CF
#define Z_UNICODE_CIRCLED_KATAKANA_A			     0x32D0
#define Z_UNICODE_CIRCLED_KATAKANA_I			     0x32D1
#define Z_UNICODE_CIRCLED_KATAKANA_U			     0x32D2
#define Z_UNICODE_CIRCLED_KATAKANA_E			     0x32D3
#define Z_UNICODE_CIRCLED_KATAKANA_O			     0x32D4
#define Z_UNICODE_CIRCLED_KATAKANA_KA			     0x32D5
#define Z_UNICODE_CIRCLED_KATAKANA_KI			     0x32D6
#define Z_UNICODE_CIRCLED_KATAKANA_KU			     0x32D7
#define Z_UNICODE_CIRCLED_KATAKANA_KE			     0x32D8
#define Z_UNICODE_CIRCLED_KATAKANA_KO			     0x32D9
#define Z_UNICODE_CIRCLED_KATAKANA_SA			     0x32DA
#define Z_UNICODE_CIRCLED_KATAKANA_SI			     0x32DB
#define Z_UNICODE_CIRCLED_KATAKANA_SU			     0x32DC
#define Z_UNICODE_CIRCLED_KATAKANA_SE			     0x32DD
#define Z_UNICODE_CIRCLED_KATAKANA_SO			     0x32DE
#define Z_UNICODE_CIRCLED_KATAKANA_TA			     0x32DF
#define Z_UNICODE_CIRCLED_KATAKANA_TI			     0x32E0
#define Z_UNICODE_CIRCLED_KATAKANA_TU			     0x32E1
#define Z_UNICODE_CIRCLED_KATAKANA_TE			     0x32E2
#define Z_UNICODE_CIRCLED_KATAKANA_TO			     0x32E3
#define Z_UNICODE_CIRCLED_KATAKANA_NA			     0x32E4
#define Z_UNICODE_CIRCLED_KATAKANA_NI			     0x32E5
#define Z_UNICODE_CIRCLED_KATAKANA_NU			     0x32E6
#define Z_UNICODE_CIRCLED_KATAKANA_NE			     0x32E7
#define Z_UNICODE_CIRCLED_KATAKANA_NO			     0x32E8
#define Z_UNICODE_CIRCLED_KATAKANA_HA			     0x32E9
#define Z_UNICODE_CIRCLED_KATAKANA_HI			     0x32EA
#define Z_UNICODE_CIRCLED_KATAKANA_HU			     0x32EB
#define Z_UNICODE_CIRCLED_KATAKANA_HE			     0x32EC
#define Z_UNICODE_CIRCLED_KATAKANA_HO			     0x32ED
#define Z_UNICODE_CIRCLED_KATAKANA_MA			     0x32EE
#define Z_UNICODE_CIRCLED_KATAKANA_MI			     0x32EF
#define Z_UNICODE_CIRCLED_KATAKANA_MU			     0x32F0
#define Z_UNICODE_CIRCLED_KATAKANA_ME			     0x32F1
#define Z_UNICODE_CIRCLED_KATAKANA_MO			     0x32F2
#define Z_UNICODE_CIRCLED_KATAKANA_YA			     0x32F3
#define Z_UNICODE_CIRCLED_KATAKANA_YU			     0x32F4
#define Z_UNICODE_CIRCLED_KATAKANA_YO			     0x32F5
#define Z_UNICODE_CIRCLED_KATAKANA_RA			     0x32F6
#define Z_UNICODE_CIRCLED_KATAKANA_RI			     0x32F7
#define Z_UNICODE_CIRCLED_KATAKANA_RU			     0x32F8
#define Z_UNICODE_CIRCLED_KATAKANA_RE			     0x32F9
#define Z_UNICODE_CIRCLED_KATAKANA_RO			     0x32FA
#define Z_UNICODE_CIRCLED_KATAKANA_WA			     0x32FB
#define Z_UNICODE_CIRCLED_KATAKANA_WI			     0x32FC
#define Z_UNICODE_CIRCLED_KATAKANA_WE			     0x32FD
#define Z_UNICODE_CIRCLED_KATAKANA_WO			     0x32FE

/* MARK: - 3300h-33FFh - CJK Compatibility */

#define Z_UNICODE_SQUARE_APAATO					     0x3300
#define Z_UNICODE_SQUARE_ARUHUA					     0x3301
#define Z_UNICODE_SQUARE_ANPEA					     0x3302
#define Z_UNICODE_SQUARE_AARU					     0x3303
#define Z_UNICODE_SQUARE_ININGU					     0x3304
#define Z_UNICODE_SQUARE_INTI					     0x3305
#define Z_UNICODE_SQUARE_UON					     0x3306
#define Z_UNICODE_SQUARE_ESUKUUDO				     0x3307
#define Z_UNICODE_SQUARE_EEKAA					     0x3308
#define Z_UNICODE_SQUARE_ONSU					     0x3309
#define Z_UNICODE_SQUARE_OOMU					     0x330A
#define Z_UNICODE_SQUARE_KAIRI					     0x330B
#define Z_UNICODE_SQUARE_KARATTO				     0x330C
#define Z_UNICODE_SQUARE_KARORII				     0x330D
#define Z_UNICODE_SQUARE_GARON					     0x330E
#define Z_UNICODE_SQUARE_GANMA					     0x330F
#define Z_UNICODE_SQUARE_GIGA					     0x3310
#define Z_UNICODE_SQUARE_GINII					     0x3311
#define Z_UNICODE_SQUARE_KYURII					     0x3312
#define Z_UNICODE_SQUARE_GIRUDAA				     0x3313
#define Z_UNICODE_SQUARE_KIRO					     0x3314
#define Z_UNICODE_SQUARE_KIROGURAMU				     0x3315
#define Z_UNICODE_SQUARE_KIROMEETORU				     0x3316
#define Z_UNICODE_SQUARE_KIROWATTO				     0x3317
#define Z_UNICODE_SQUARE_GURAMU					     0x3318
#define Z_UNICODE_SQUARE_GURAMUTON				     0x3319
#define Z_UNICODE_SQUARE_KURUZEIRO				     0x331A
#define Z_UNICODE_SQUARE_KUROONE				     0x331B
#define Z_UNICODE_SQUARE_KEESU					     0x331C
#define Z_UNICODE_SQUARE_KORUNA					     0x331D
#define Z_UNICODE_SQUARE_KOOPO					     0x331E
#define Z_UNICODE_SQUARE_SAIKURU				     0x331F
#define Z_UNICODE_SQUARE_SANTIIMU				     0x3320
#define Z_UNICODE_SQUARE_SIRINGU				     0x3321
#define Z_UNICODE_SQUARE_SENTI					     0x3322
#define Z_UNICODE_SQUARE_SENTO					     0x3323
#define Z_UNICODE_SQUARE_DAASU					     0x3324
#define Z_UNICODE_SQUARE_DESI					     0x3325
#define Z_UNICODE_SQUARE_DORU					     0x3326
#define Z_UNICODE_SQUARE_TON					     0x3327
#define Z_UNICODE_SQUARE_NANO					     0x3328
#define Z_UNICODE_SQUARE_NOTTO					     0x3329
#define Z_UNICODE_SQUARE_HAITU					     0x332A
#define Z_UNICODE_SQUARE_PAASENTO				     0x332B
#define Z_UNICODE_SQUARE_PAATU					     0x332C
#define Z_UNICODE_SQUARE_BAARERU				     0x332D
#define Z_UNICODE_SQUARE_PIASUTORU				     0x332E
#define Z_UNICODE_SQUARE_PIKURU					     0x332F
#define Z_UNICODE_SQUARE_PIKO					     0x3330
#define Z_UNICODE_SQUARE_BIRU					     0x3331
#define Z_UNICODE_SQUARE_HUARADDO				     0x3332
#define Z_UNICODE_SQUARE_HUIITO					     0x3333
#define Z_UNICODE_SQUARE_BUSSYERU				     0x3334
#define Z_UNICODE_SQUARE_HURAN					     0x3335
#define Z_UNICODE_SQUARE_HEKUTAARU				     0x3336
#define Z_UNICODE_SQUARE_PESO					     0x3337
#define Z_UNICODE_SQUARE_PENIHI					     0x3338
#define Z_UNICODE_SQUARE_HERUTU					     0x3339
#define Z_UNICODE_SQUARE_PENSU					     0x333A
#define Z_UNICODE_SQUARE_PEEZI					     0x333B
#define Z_UNICODE_SQUARE_BEETA					     0x333C
#define Z_UNICODE_SQUARE_POINTO					     0x333D
#define Z_UNICODE_SQUARE_BORUTO					     0x333E
#define Z_UNICODE_SQUARE_HON					     0x333F
#define Z_UNICODE_SQUARE_PONDO					     0x3340
#define Z_UNICODE_SQUARE_HOORU					     0x3341
#define Z_UNICODE_SQUARE_HOON					     0x3342
#define Z_UNICODE_SQUARE_MAIKURO				     0x3343
#define Z_UNICODE_SQUARE_MAIRU					     0x3344
#define Z_UNICODE_SQUARE_MAHHA					     0x3345
#define Z_UNICODE_SQUARE_MARUKU					     0x3346
#define Z_UNICODE_SQUARE_MANSYON				     0x3347
#define Z_UNICODE_SQUARE_MIKURON				     0x3348
#define Z_UNICODE_SQUARE_MIRI					     0x3349
#define Z_UNICODE_SQUARE_MIRIBAARU				     0x334A
#define Z_UNICODE_SQUARE_MEGA					     0x334B
#define Z_UNICODE_SQUARE_MEGATON				     0x334C
#define Z_UNICODE_SQUARE_MEETORU				     0x334D
#define Z_UNICODE_SQUARE_YAADO					     0x334E
#define Z_UNICODE_SQUARE_YAARU					     0x334F
#define Z_UNICODE_SQUARE_YUAN					     0x3350
#define Z_UNICODE_SQUARE_RITTORU				     0x3351
#define Z_UNICODE_SQUARE_RIRA					     0x3352
#define Z_UNICODE_SQUARE_RUPII					     0x3353
#define Z_UNICODE_SQUARE_RUUBURU				     0x3354
#define Z_UNICODE_SQUARE_REMU					     0x3355
#define Z_UNICODE_SQUARE_RENTOGEN				     0x3356
#define Z_UNICODE_SQUARE_WATTO					     0x3357
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ZERO	     0x3358
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ONE	     0x3359
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWO	     0x335A
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_THREE	     0x335B
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FOUR	     0x335C
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FIVE	     0x335D
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SIX	     0x335E
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SEVEN	     0x335F
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_EIGHT	     0x3360
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_NINE	     0x3361
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TEN	     0x3362
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_ELEVEN	     0x3363
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWELVE	     0x3364
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_THIRTEEN     0x3365
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FOURTEEN     0x3366
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_FIFTEEN	     0x3367
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SIXTEEN	     0x3368
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_SEVENTEEN    0x3369
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_EIGHTEEN     0x336A
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_NINETEEN     0x336B
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY	     0x336C
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_ONE   0x336D
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_TWO   0x336E
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_THREE 0x336F
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_HOUR_TWENTY_FOUR  0x3370
#define Z_UNICODE_SQUARE_HPA					     0x3371
#define Z_UNICODE_SQUARE_DA					     0x3372
#define Z_UNICODE_SQUARE_AU					     0x3373
#define Z_UNICODE_SQUARE_BAR					     0x3374
#define Z_UNICODE_SQUARE_OV					     0x3375
#define Z_UNICODE_SQUARE_PC					     0x3376
#define Z_UNICODE_SQUARE_DM					     0x3377
#define Z_UNICODE_SQUARE_DM_SQUARED				     0x3378
#define Z_UNICODE_SQUARE_DM_CUBED				     0x3379
#define Z_UNICODE_SQUARE_IU					     0x337A
#define Z_UNICODE_SQUARE_ERA_NAME_HEISEI			     0x337B
#define Z_UNICODE_SQUARE_ERA_NAME_SYOUWA			     0x337C
#define Z_UNICODE_SQUARE_ERA_NAME_TAISYOU			     0x337D
#define Z_UNICODE_SQUARE_ERA_NAME_MEIZI				     0x337E
#define Z_UNICODE_SQUARE_CORPORATION				     0x337F
#define Z_UNICODE_SQUARE_PA_AMPS				     0x3380
#define Z_UNICODE_SQUARE_NA					     0x3381
#define Z_UNICODE_SQUARE_MU_A					     0x3382
#define Z_UNICODE_SQUARE_MA					     0x3383
#define Z_UNICODE_SQUARE_KA					     0x3384
#define Z_UNICODE_SQUARE_KB					     0x3385
#define Z_UNICODE_SQUARE_MB					     0x3386
#define Z_UNICODE_SQUARE_GB					     0x3387
#define Z_UNICODE_SQUARE_CAL					     0x3388
#define Z_UNICODE_SQUARE_KCAL					     0x3389
#define Z_UNICODE_SQUARE_PF					     0x338A
#define Z_UNICODE_SQUARE_NF					     0x338B
#define Z_UNICODE_SQUARE_MU_F					     0x338C
#define Z_UNICODE_SQUARE_MU_G					     0x338D
#define Z_UNICODE_SQUARE_MG					     0x338E
#define Z_UNICODE_SQUARE_KG					     0x338F
#define Z_UNICODE_SQUARE_HZ					     0x3390
#define Z_UNICODE_SQUARE_KHZ					     0x3391
#define Z_UNICODE_SQUARE_MHZ					     0x3392
#define Z_UNICODE_SQUARE_GHZ					     0x3393
#define Z_UNICODE_SQUARE_THZ					     0x3394
#define Z_UNICODE_SQUARE_MU_L					     0x3395
#define Z_UNICODE_SQUARE_ML					     0x3396
#define Z_UNICODE_SQUARE_DL					     0x3397
#define Z_UNICODE_SQUARE_KL					     0x3398
#define Z_UNICODE_SQUARE_FM					     0x3399
#define Z_UNICODE_SQUARE_NM					     0x339A
#define Z_UNICODE_SQUARE_MU_M					     0x339B
#define Z_UNICODE_SQUARE_MM					     0x339C
#define Z_UNICODE_SQUARE_CM					     0x339D
#define Z_UNICODE_SQUARE_KM					     0x339E
#define Z_UNICODE_SQUARE_MM_SQUARED				     0x339F
#define Z_UNICODE_SQUARE_CM_SQUARED				     0x33A0
#define Z_UNICODE_SQUARE_M_SQUARED				     0x33A1
#define Z_UNICODE_SQUARE_KM_SQUARED				     0x33A2
#define Z_UNICODE_SQUARE_MM_CUBED				     0x33A3
#define Z_UNICODE_SQUARE_CM_CUBED				     0x33A4
#define Z_UNICODE_SQUARE_M_CUBED				     0x33A5
#define Z_UNICODE_SQUARE_KM_CUBED				     0x33A6
#define Z_UNICODE_SQUARE_M_OVER_S				     0x33A7
#define Z_UNICODE_SQUARE_M_OVER_S_SQUARED			     0x33A8
#define Z_UNICODE_SQUARE_PA					     0x33A9
#define Z_UNICODE_SQUARE_KPA					     0x33AA
#define Z_UNICODE_SQUARE_MPA					     0x33AB
#define Z_UNICODE_SQUARE_GPA					     0x33AC
#define Z_UNICODE_SQUARE_RAD					     0x33AD
#define Z_UNICODE_SQUARE_RAD_OVER_S				     0x33AE
#define Z_UNICODE_SQUARE_RAD_OVER_S_SQUARED			     0x33AF
#define Z_UNICODE_SQUARE_PS					     0x33B0
#define Z_UNICODE_SQUARE_NS					     0x33B1
#define Z_UNICODE_SQUARE_MU_S					     0x33B2
#define Z_UNICODE_SQUARE_MS					     0x33B3
#define Z_UNICODE_SQUARE_PV					     0x33B4
#define Z_UNICODE_SQUARE_NV					     0x33B5
#define Z_UNICODE_SQUARE_MU_V					     0x33B6
#define Z_UNICODE_SQUARE_MV					     0x33B7
#define Z_UNICODE_SQUARE_KV					     0x33B8
#define Z_UNICODE_SQUARE_MV_MEGA				     0x33B9
#define Z_UNICODE_SQUARE_PW					     0x33BA
#define Z_UNICODE_SQUARE_NW					     0x33BB
#define Z_UNICODE_SQUARE_MU_W					     0x33BC
#define Z_UNICODE_SQUARE_MW					     0x33BD
#define Z_UNICODE_SQUARE_KW					     0x33BE
#define Z_UNICODE_SQUARE_MW_MEGA				     0x33BF
#define Z_UNICODE_SQUARE_K_OHM					     0x33C0
#define Z_UNICODE_SQUARE_M_OHM					     0x33C1
#define Z_UNICODE_SQUARE_AM					     0x33C2
#define Z_UNICODE_SQUARE_BQ					     0x33C3
#define Z_UNICODE_SQUARE_CC					     0x33C4
#define Z_UNICODE_SQUARE_CD					     0x33C5
#define Z_UNICODE_SQUARE_C_OVER_KG				     0x33C6
#define Z_UNICODE_SQUARE_CO					     0x33C7
#define Z_UNICODE_SQUARE_DB					     0x33C8
#define Z_UNICODE_SQUARE_GY					     0x33C9
#define Z_UNICODE_SQUARE_HA					     0x33CA
#define Z_UNICODE_SQUARE_HP					     0x33CB
#define Z_UNICODE_SQUARE_IN					     0x33CC
#define Z_UNICODE_SQUARE_KK					     0x33CD
#define Z_UNICODE_SQUARE_KM_CAPITAL				     0x33CE
#define Z_UNICODE_SQUARE_KT					     0x33CF
#define Z_UNICODE_SQUARE_LM					     0x33D0
#define Z_UNICODE_SQUARE_LN					     0x33D1
#define Z_UNICODE_SQUARE_LOG					     0x33D2
#define Z_UNICODE_SQUARE_LX					     0x33D3
#define Z_UNICODE_SQUARE_MB_SMALL				     0x33D4
#define Z_UNICODE_SQUARE_MIL					     0x33D5
#define Z_UNICODE_SQUARE_MOL					     0x33D6
#define Z_UNICODE_SQUARE_PH					     0x33D7
#define Z_UNICODE_SQUARE_PM					     0x33D8
#define Z_UNICODE_SQUARE_PPM					     0x33D9
#define Z_UNICODE_SQUARE_PR					     0x33DA
#define Z_UNICODE_SQUARE_SR					     0x33DB
#define Z_UNICODE_SQUARE_SV					     0x33DC
#define Z_UNICODE_SQUARE_WB					     0x33DD
#define Z_UNICODE_SQUARE_V_OVER_M				     0x33DE
#define Z_UNICODE_SQUARE_A_OVER_M				     0x33DF
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_ONE	     0x33E0
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWO	     0x33E1
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THREE	     0x33E2
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FOUR	     0x33E3
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FIVE	     0x33E4
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SIX	     0x33E5
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SEVEN	     0x33E6
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_EIGHT	     0x33E7
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_NINE	     0x33E8
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TEN	     0x33E9
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_ELEVEN	     0x33EA
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWELVE	     0x33EB
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTEEN	     0x33EC
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FOURTEEN	     0x33ED
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_FIFTEEN	     0x33EE
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SIXTEEN	     0x33EF
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_SEVENTEEN     0x33F0
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_EIGHTEEN	     0x33F1
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_NINETEEN	     0x33F2
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY	     0x33F3
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_ONE    0x33F4
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_TWO    0x33F5
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_THREE  0x33F6
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_FOUR   0x33F7
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_FIVE   0x33F8
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_SIX    0x33F9
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_SEVEN  0x33FA
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_EIGHT  0x33FB
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_TWENTY_NINE   0x33FC
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTY	     0x33FD
#define Z_UNICODE_IDEOGRAPHIC_TELEGRAPH_SYMBOL_FOR_DAY_THIRTY_ONE    0x33FE
#define Z_UNICODE_SQUARE_GAL					     0x33FF

/* MARK: - 3400h-4DB5h - CJK Unified Ideographs Extension A */

/* MARK: - 4DC0h-4DFFh - Yijing Hexagram Symbols */

#define Z_UNICODE_HEXAGRAM_FOR_THE_CREATIVE_HEAVEN	   0x4DC0
#define Z_UNICODE_HEXAGRAM_FOR_THE_RECEPTIVE_EARTH	   0x4DC1
#define Z_UNICODE_HEXAGRAM_FOR_DIFFICULTY_AT_THE_BEGINNING 0x4DC2
#define Z_UNICODE_HEXAGRAM_FOR_YOUTHFUL_FOLLY		   0x4DC3
#define Z_UNICODE_HEXAGRAM_FOR_WAITING			   0x4DC4
#define Z_UNICODE_HEXAGRAM_FOR_CONFLICT			   0x4DC5
#define Z_UNICODE_HEXAGRAM_FOR_THE_ARMY			   0x4DC6
#define Z_UNICODE_HEXAGRAM_FOR_HOLDING_TOGETHER		   0x4DC7
#define Z_UNICODE_HEXAGRAM_FOR_SMALL_TAMING		   0x4DC8
#define Z_UNICODE_HEXAGRAM_FOR_TREADING			   0x4DC9
#define Z_UNICODE_HEXAGRAM_FOR_PEACE			   0x4DCA
#define Z_UNICODE_HEXAGRAM_FOR_STANDSTILL		   0x4DCB
#define Z_UNICODE_HEXAGRAM_FOR_FELLOWSHIP		   0x4DCC
#define Z_UNICODE_HEXAGRAM_FOR_GREAT_POSSESSION		   0x4DCD
#define Z_UNICODE_HEXAGRAM_FOR_MODESTY			   0x4DCE
#define Z_UNICODE_HEXAGRAM_FOR_ENTHUSIASM		   0x4DCF
#define Z_UNICODE_HEXAGRAM_FOR_FOLLOWING		   0x4DD0
#define Z_UNICODE_HEXAGRAM_FOR_WORK_ON_THE_DECAYED	   0x4DD1
#define Z_UNICODE_HEXAGRAM_FOR_APPROACH			   0x4DD2
#define Z_UNICODE_HEXAGRAM_FOR_CONTEMPLATION		   0x4DD3
#define Z_UNICODE_HEXAGRAM_FOR_BITING_THROUGH		   0x4DD4
#define Z_UNICODE_HEXAGRAM_FOR_GRACE			   0x4DD5
#define Z_UNICODE_HEXAGRAM_FOR_SPLITTING_APART		   0x4DD6
#define Z_UNICODE_HEXAGRAM_FOR_RETURN			   0x4DD7
#define Z_UNICODE_HEXAGRAM_FOR_INNOCENCE		   0x4DD8
#define Z_UNICODE_HEXAGRAM_FOR_GREAT_TAMING		   0x4DD9
#define Z_UNICODE_HEXAGRAM_FOR_MOUTH_CORNERS		   0x4DDA
#define Z_UNICODE_HEXAGRAM_FOR_GREAT_PREPONDERANCE	   0x4DDB
#define Z_UNICODE_HEXAGRAM_FOR_THE_ABYSMAL_WATER	   0x4DDC
#define Z_UNICODE_HEXAGRAM_FOR_THE_CLINGING_FIRE	   0x4DDD
#define Z_UNICODE_HEXAGRAM_FOR_INFLUENCE		   0x4DDE
#define Z_UNICODE_HEXAGRAM_FOR_DURATION			   0x4DDF
#define Z_UNICODE_HEXAGRAM_FOR_RETREAT			   0x4DE0
#define Z_UNICODE_HEXAGRAM_FOR_GREAT_POWER		   0x4DE1
#define Z_UNICODE_HEXAGRAM_FOR_PROGRESS			   0x4DE2
#define Z_UNICODE_HEXAGRAM_FOR_DARKENING_OF_THE_LIGHT	   0x4DE3
#define Z_UNICODE_HEXAGRAM_FOR_THE_FAMILY		   0x4DE4
#define Z_UNICODE_HEXAGRAM_FOR_OPPOSITION		   0x4DE5
#define Z_UNICODE_HEXAGRAM_FOR_OBSTRUCTION		   0x4DE6
#define Z_UNICODE_HEXAGRAM_FOR_DELIVERANCE		   0x4DE7
#define Z_UNICODE_HEXAGRAM_FOR_DECREASE			   0x4DE8
#define Z_UNICODE_HEXAGRAM_FOR_INCREASE			   0x4DE9
#define Z_UNICODE_HEXAGRAM_FOR_BREAKTHROUGH		   0x4DEA
#define Z_UNICODE_HEXAGRAM_FOR_COMING_TO_MEET		   0x4DEB
#define Z_UNICODE_HEXAGRAM_FOR_GATHERING_TOGETHER	   0x4DEC
#define Z_UNICODE_HEXAGRAM_FOR_PUSHING_UPWARD		   0x4DED
#define Z_UNICODE_HEXAGRAM_FOR_OPPRESSION		   0x4DEE
#define Z_UNICODE_HEXAGRAM_FOR_THE_WELL			   0x4DEF
#define Z_UNICODE_HEXAGRAM_FOR_REVOLUTION		   0x4DF0
#define Z_UNICODE_HEXAGRAM_FOR_THE_CAULDRON		   0x4DF1
#define Z_UNICODE_HEXAGRAM_FOR_THE_AROUSING_THUNDER	   0x4DF2
#define Z_UNICODE_HEXAGRAM_FOR_THE_KEEPING_STILL_MOUNTAIN  0x4DF3
#define Z_UNICODE_HEXAGRAM_FOR_DEVELOPMENT		   0x4DF4
#define Z_UNICODE_HEXAGRAM_FOR_THE_MARRYING_MAIDEN	   0x4DF5
#define Z_UNICODE_HEXAGRAM_FOR_ABUNDANCE		   0x4DF6
#define Z_UNICODE_HEXAGRAM_FOR_THE_WANDERER		   0x4DF7
#define Z_UNICODE_HEXAGRAM_FOR_THE_GENTLE_WIND		   0x4DF8
#define Z_UNICODE_HEXAGRAM_FOR_THE_JOYOUS_LAKE		   0x4DF9
#define Z_UNICODE_HEXAGRAM_FOR_DISPERSION		   0x4DFA
#define Z_UNICODE_HEXAGRAM_FOR_LIMITATION		   0x4DFB
#define Z_UNICODE_HEXAGRAM_FOR_INNER_TRUTH		   0x4DFC
#define Z_UNICODE_HEXAGRAM_FOR_SMALL_PREPONDERANCE	   0x4DFD
#define Z_UNICODE_HEXAGRAM_FOR_AFTER_COMPLETION		   0x4DFE
#define Z_UNICODE_HEXAGRAM_FOR_BEFORE_COMPLETION	   0x4DFF

/* MARK: - 4E00h-9FD5h - CJK Unified Ideographs */

/* MARK: - A000h-A48Fh - Yi Syllables */

#define Z_UNICODE_YI_SYLLABLE_IT    0xA000
#define Z_UNICODE_YI_SYLLABLE_IX    0xA001
#define Z_UNICODE_YI_SYLLABLE_I	    0xA002
#define Z_UNICODE_YI_SYLLABLE_IP    0xA003
#define Z_UNICODE_YI_SYLLABLE_IET   0xA004
#define Z_UNICODE_YI_SYLLABLE_IEX   0xA005
#define Z_UNICODE_YI_SYLLABLE_IE    0xA006
#define Z_UNICODE_YI_SYLLABLE_IEP   0xA007
#define Z_UNICODE_YI_SYLLABLE_AT    0xA008
#define Z_UNICODE_YI_SYLLABLE_AX    0xA009
#define Z_UNICODE_YI_SYLLABLE_A	    0xA00A
#define Z_UNICODE_YI_SYLLABLE_AP    0xA00B
#define Z_UNICODE_YI_SYLLABLE_UOX   0xA00C
#define Z_UNICODE_YI_SYLLABLE_UO    0xA00D
#define Z_UNICODE_YI_SYLLABLE_UOP   0xA00E
#define Z_UNICODE_YI_SYLLABLE_OT    0xA00F
#define Z_UNICODE_YI_SYLLABLE_OX    0xA010
#define Z_UNICODE_YI_SYLLABLE_O	    0xA011
#define Z_UNICODE_YI_SYLLABLE_OP    0xA012
#define Z_UNICODE_YI_SYLLABLE_EX    0xA013
#define Z_UNICODE_YI_SYLLABLE_E	    0xA014
#define Z_UNICODE_YI_SYLLABLE_WU    0xA015
#define Z_UNICODE_YI_SYLLABLE_BIT   0xA016
#define Z_UNICODE_YI_SYLLABLE_BIX   0xA017
#define Z_UNICODE_YI_SYLLABLE_BI    0xA018
#define Z_UNICODE_YI_SYLLABLE_BIP   0xA019
#define Z_UNICODE_YI_SYLLABLE_BIET  0xA01A
#define Z_UNICODE_YI_SYLLABLE_BIEX  0xA01B
#define Z_UNICODE_YI_SYLLABLE_BIE   0xA01C
#define Z_UNICODE_YI_SYLLABLE_BIEP  0xA01D
#define Z_UNICODE_YI_SYLLABLE_BAT   0xA01E
#define Z_UNICODE_YI_SYLLABLE_BAX   0xA01F
#define Z_UNICODE_YI_SYLLABLE_BA    0xA020
#define Z_UNICODE_YI_SYLLABLE_BAP   0xA021
#define Z_UNICODE_YI_SYLLABLE_BUOX  0xA022
#define Z_UNICODE_YI_SYLLABLE_BUO   0xA023
#define Z_UNICODE_YI_SYLLABLE_BUOP  0xA024
#define Z_UNICODE_YI_SYLLABLE_BOT   0xA025
#define Z_UNICODE_YI_SYLLABLE_BOX   0xA026
#define Z_UNICODE_YI_SYLLABLE_BO    0xA027
#define Z_UNICODE_YI_SYLLABLE_BOP   0xA028
#define Z_UNICODE_YI_SYLLABLE_BEX   0xA029
#define Z_UNICODE_YI_SYLLABLE_BE    0xA02A
#define Z_UNICODE_YI_SYLLABLE_BEP   0xA02B
#define Z_UNICODE_YI_SYLLABLE_BUT   0xA02C
#define Z_UNICODE_YI_SYLLABLE_BUX   0xA02D
#define Z_UNICODE_YI_SYLLABLE_BU    0xA02E
#define Z_UNICODE_YI_SYLLABLE_BUP   0xA02F
#define Z_UNICODE_YI_SYLLABLE_BURX  0xA030
#define Z_UNICODE_YI_SYLLABLE_BUR   0xA031
#define Z_UNICODE_YI_SYLLABLE_BYT   0xA032
#define Z_UNICODE_YI_SYLLABLE_BYX   0xA033
#define Z_UNICODE_YI_SYLLABLE_BY    0xA034
#define Z_UNICODE_YI_SYLLABLE_BYP   0xA035
#define Z_UNICODE_YI_SYLLABLE_BYRX  0xA036
#define Z_UNICODE_YI_SYLLABLE_BYR   0xA037
#define Z_UNICODE_YI_SYLLABLE_PIT   0xA038
#define Z_UNICODE_YI_SYLLABLE_PIX   0xA039
#define Z_UNICODE_YI_SYLLABLE_PI    0xA03A
#define Z_UNICODE_YI_SYLLABLE_PIP   0xA03B
#define Z_UNICODE_YI_SYLLABLE_PIEX  0xA03C
#define Z_UNICODE_YI_SYLLABLE_PIE   0xA03D
#define Z_UNICODE_YI_SYLLABLE_PIEP  0xA03E
#define Z_UNICODE_YI_SYLLABLE_PAT   0xA03F
#define Z_UNICODE_YI_SYLLABLE_PAX   0xA040
#define Z_UNICODE_YI_SYLLABLE_PA    0xA041
#define Z_UNICODE_YI_SYLLABLE_PAP   0xA042
#define Z_UNICODE_YI_SYLLABLE_PUOX  0xA043
#define Z_UNICODE_YI_SYLLABLE_PUO   0xA044
#define Z_UNICODE_YI_SYLLABLE_PUOP  0xA045
#define Z_UNICODE_YI_SYLLABLE_POT   0xA046
#define Z_UNICODE_YI_SYLLABLE_POX   0xA047
#define Z_UNICODE_YI_SYLLABLE_PO    0xA048
#define Z_UNICODE_YI_SYLLABLE_POP   0xA049
#define Z_UNICODE_YI_SYLLABLE_PUT   0xA04A
#define Z_UNICODE_YI_SYLLABLE_PUX   0xA04B
#define Z_UNICODE_YI_SYLLABLE_PU    0xA04C
#define Z_UNICODE_YI_SYLLABLE_PUP   0xA04D
#define Z_UNICODE_YI_SYLLABLE_PURX  0xA04E
#define Z_UNICODE_YI_SYLLABLE_PUR   0xA04F
#define Z_UNICODE_YI_SYLLABLE_PYT   0xA050
#define Z_UNICODE_YI_SYLLABLE_PYX   0xA051
#define Z_UNICODE_YI_SYLLABLE_PY    0xA052
#define Z_UNICODE_YI_SYLLABLE_PYP   0xA053
#define Z_UNICODE_YI_SYLLABLE_PYRX  0xA054
#define Z_UNICODE_YI_SYLLABLE_PYR   0xA055
#define Z_UNICODE_YI_SYLLABLE_BBIT  0xA056
#define Z_UNICODE_YI_SYLLABLE_BBIX  0xA057
#define Z_UNICODE_YI_SYLLABLE_BBI   0xA058
#define Z_UNICODE_YI_SYLLABLE_BBIP  0xA059
#define Z_UNICODE_YI_SYLLABLE_BBIET 0xA05A
#define Z_UNICODE_YI_SYLLABLE_BBIEX 0xA05B
#define Z_UNICODE_YI_SYLLABLE_BBIE  0xA05C
#define Z_UNICODE_YI_SYLLABLE_BBIEP 0xA05D
#define Z_UNICODE_YI_SYLLABLE_BBAT  0xA05E
#define Z_UNICODE_YI_SYLLABLE_BBAX  0xA05F
#define Z_UNICODE_YI_SYLLABLE_BBA   0xA060
#define Z_UNICODE_YI_SYLLABLE_BBAP  0xA061
#define Z_UNICODE_YI_SYLLABLE_BBUOX 0xA062
#define Z_UNICODE_YI_SYLLABLE_BBUO  0xA063
#define Z_UNICODE_YI_SYLLABLE_BBUOP 0xA064
#define Z_UNICODE_YI_SYLLABLE_BBOT  0xA065
#define Z_UNICODE_YI_SYLLABLE_BBOX  0xA066
#define Z_UNICODE_YI_SYLLABLE_BBO   0xA067
#define Z_UNICODE_YI_SYLLABLE_BBOP  0xA068
#define Z_UNICODE_YI_SYLLABLE_BBEX  0xA069
#define Z_UNICODE_YI_SYLLABLE_BBE   0xA06A
#define Z_UNICODE_YI_SYLLABLE_BBEP  0xA06B
#define Z_UNICODE_YI_SYLLABLE_BBUT  0xA06C
#define Z_UNICODE_YI_SYLLABLE_BBUX  0xA06D
#define Z_UNICODE_YI_SYLLABLE_BBU   0xA06E
#define Z_UNICODE_YI_SYLLABLE_BBUP  0xA06F
#define Z_UNICODE_YI_SYLLABLE_BBURX 0xA070
#define Z_UNICODE_YI_SYLLABLE_BBUR  0xA071
#define Z_UNICODE_YI_SYLLABLE_BBYT  0xA072
#define Z_UNICODE_YI_SYLLABLE_BBYX  0xA073
#define Z_UNICODE_YI_SYLLABLE_BBY   0xA074
#define Z_UNICODE_YI_SYLLABLE_BBYP  0xA075
#define Z_UNICODE_YI_SYLLABLE_NBIT  0xA076
#define Z_UNICODE_YI_SYLLABLE_NBIX  0xA077
#define Z_UNICODE_YI_SYLLABLE_NBI   0xA078
#define Z_UNICODE_YI_SYLLABLE_NBIP  0xA079
#define Z_UNICODE_YI_SYLLABLE_NBIEX 0xA07A
#define Z_UNICODE_YI_SYLLABLE_NBIE  0xA07B
#define Z_UNICODE_YI_SYLLABLE_NBIEP 0xA07C
#define Z_UNICODE_YI_SYLLABLE_NBAT  0xA07D
#define Z_UNICODE_YI_SYLLABLE_NBAX  0xA07E
#define Z_UNICODE_YI_SYLLABLE_NBA   0xA07F
#define Z_UNICODE_YI_SYLLABLE_NBAP  0xA080
#define Z_UNICODE_YI_SYLLABLE_NBOT  0xA081
#define Z_UNICODE_YI_SYLLABLE_NBOX  0xA082
#define Z_UNICODE_YI_SYLLABLE_NBO   0xA083
#define Z_UNICODE_YI_SYLLABLE_NBOP  0xA084
#define Z_UNICODE_YI_SYLLABLE_NBUT  0xA085
#define Z_UNICODE_YI_SYLLABLE_NBUX  0xA086
#define Z_UNICODE_YI_SYLLABLE_NBU   0xA087
#define Z_UNICODE_YI_SYLLABLE_NBUP  0xA088
#define Z_UNICODE_YI_SYLLABLE_NBURX 0xA089
#define Z_UNICODE_YI_SYLLABLE_NBUR  0xA08A
#define Z_UNICODE_YI_SYLLABLE_NBYT  0xA08B
#define Z_UNICODE_YI_SYLLABLE_NBYX  0xA08C
#define Z_UNICODE_YI_SYLLABLE_NBY   0xA08D
#define Z_UNICODE_YI_SYLLABLE_NBYP  0xA08E
#define Z_UNICODE_YI_SYLLABLE_NBYRX 0xA08F
#define Z_UNICODE_YI_SYLLABLE_NBYR  0xA090
#define Z_UNICODE_YI_SYLLABLE_HMIT  0xA091
#define Z_UNICODE_YI_SYLLABLE_HMIX  0xA092
#define Z_UNICODE_YI_SYLLABLE_HMI   0xA093
#define Z_UNICODE_YI_SYLLABLE_HMIP  0xA094
#define Z_UNICODE_YI_SYLLABLE_HMIEX 0xA095
#define Z_UNICODE_YI_SYLLABLE_HMIE  0xA096
#define Z_UNICODE_YI_SYLLABLE_HMIEP 0xA097
#define Z_UNICODE_YI_SYLLABLE_HMAT  0xA098
#define Z_UNICODE_YI_SYLLABLE_HMAX  0xA099
#define Z_UNICODE_YI_SYLLABLE_HMA   0xA09A
#define Z_UNICODE_YI_SYLLABLE_HMAP  0xA09B
#define Z_UNICODE_YI_SYLLABLE_HMUOX 0xA09C
#define Z_UNICODE_YI_SYLLABLE_HMUO  0xA09D
#define Z_UNICODE_YI_SYLLABLE_HMUOP 0xA09E
#define Z_UNICODE_YI_SYLLABLE_HMOT  0xA09F
#define Z_UNICODE_YI_SYLLABLE_HMOX  0xA0A0
#define Z_UNICODE_YI_SYLLABLE_HMO   0xA0A1
#define Z_UNICODE_YI_SYLLABLE_HMOP  0xA0A2
#define Z_UNICODE_YI_SYLLABLE_HMUT  0xA0A3
#define Z_UNICODE_YI_SYLLABLE_HMUX  0xA0A4
#define Z_UNICODE_YI_SYLLABLE_HMU   0xA0A5
#define Z_UNICODE_YI_SYLLABLE_HMUP  0xA0A6
#define Z_UNICODE_YI_SYLLABLE_HMURX 0xA0A7
#define Z_UNICODE_YI_SYLLABLE_HMUR  0xA0A8
#define Z_UNICODE_YI_SYLLABLE_HMYX  0xA0A9
#define Z_UNICODE_YI_SYLLABLE_HMY   0xA0AA
#define Z_UNICODE_YI_SYLLABLE_HMYP  0xA0AB
#define Z_UNICODE_YI_SYLLABLE_HMYRX 0xA0AC
#define Z_UNICODE_YI_SYLLABLE_HMYR  0xA0AD
#define Z_UNICODE_YI_SYLLABLE_MIT   0xA0AE
#define Z_UNICODE_YI_SYLLABLE_MIX   0xA0AF
#define Z_UNICODE_YI_SYLLABLE_MI    0xA0B0
#define Z_UNICODE_YI_SYLLABLE_MIP   0xA0B1
#define Z_UNICODE_YI_SYLLABLE_MIEX  0xA0B2
#define Z_UNICODE_YI_SYLLABLE_MIE   0xA0B3
#define Z_UNICODE_YI_SYLLABLE_MIEP  0xA0B4
#define Z_UNICODE_YI_SYLLABLE_MAT   0xA0B5
#define Z_UNICODE_YI_SYLLABLE_MAX   0xA0B6
#define Z_UNICODE_YI_SYLLABLE_MA    0xA0B7
#define Z_UNICODE_YI_SYLLABLE_MAP   0xA0B8
#define Z_UNICODE_YI_SYLLABLE_MUOT  0xA0B9
#define Z_UNICODE_YI_SYLLABLE_MUOX  0xA0BA
#define Z_UNICODE_YI_SYLLABLE_MUO   0xA0BB
#define Z_UNICODE_YI_SYLLABLE_MUOP  0xA0BC
#define Z_UNICODE_YI_SYLLABLE_MOT   0xA0BD
#define Z_UNICODE_YI_SYLLABLE_MOX   0xA0BE
#define Z_UNICODE_YI_SYLLABLE_MO    0xA0BF
#define Z_UNICODE_YI_SYLLABLE_MOP   0xA0C0
#define Z_UNICODE_YI_SYLLABLE_MEX   0xA0C1
#define Z_UNICODE_YI_SYLLABLE_ME    0xA0C2
#define Z_UNICODE_YI_SYLLABLE_MUT   0xA0C3
#define Z_UNICODE_YI_SYLLABLE_MUX   0xA0C4
#define Z_UNICODE_YI_SYLLABLE_MU    0xA0C5
#define Z_UNICODE_YI_SYLLABLE_MUP   0xA0C6
#define Z_UNICODE_YI_SYLLABLE_MURX  0xA0C7
#define Z_UNICODE_YI_SYLLABLE_MUR   0xA0C8
#define Z_UNICODE_YI_SYLLABLE_MYT   0xA0C9
#define Z_UNICODE_YI_SYLLABLE_MYX   0xA0CA
#define Z_UNICODE_YI_SYLLABLE_MY    0xA0CB
#define Z_UNICODE_YI_SYLLABLE_MYP   0xA0CC
#define Z_UNICODE_YI_SYLLABLE_FIT   0xA0CD
#define Z_UNICODE_YI_SYLLABLE_FIX   0xA0CE
#define Z_UNICODE_YI_SYLLABLE_FI    0xA0CF
#define Z_UNICODE_YI_SYLLABLE_FIP   0xA0D0
#define Z_UNICODE_YI_SYLLABLE_FAT   0xA0D1
#define Z_UNICODE_YI_SYLLABLE_FAX   0xA0D2
#define Z_UNICODE_YI_SYLLABLE_FA    0xA0D3
#define Z_UNICODE_YI_SYLLABLE_FAP   0xA0D4
#define Z_UNICODE_YI_SYLLABLE_FOX   0xA0D5
#define Z_UNICODE_YI_SYLLABLE_FO    0xA0D6
#define Z_UNICODE_YI_SYLLABLE_FOP   0xA0D7
#define Z_UNICODE_YI_SYLLABLE_FUT   0xA0D8
#define Z_UNICODE_YI_SYLLABLE_FUX   0xA0D9
#define Z_UNICODE_YI_SYLLABLE_FU    0xA0DA
#define Z_UNICODE_YI_SYLLABLE_FUP   0xA0DB
#define Z_UNICODE_YI_SYLLABLE_FURX  0xA0DC
#define Z_UNICODE_YI_SYLLABLE_FUR   0xA0DD
#define Z_UNICODE_YI_SYLLABLE_FYT   0xA0DE
#define Z_UNICODE_YI_SYLLABLE_FYX   0xA0DF
#define Z_UNICODE_YI_SYLLABLE_FY    0xA0E0
#define Z_UNICODE_YI_SYLLABLE_FYP   0xA0E1
#define Z_UNICODE_YI_SYLLABLE_VIT   0xA0E2
#define Z_UNICODE_YI_SYLLABLE_VIX   0xA0E3
#define Z_UNICODE_YI_SYLLABLE_VI    0xA0E4
#define Z_UNICODE_YI_SYLLABLE_VIP   0xA0E5
#define Z_UNICODE_YI_SYLLABLE_VIET  0xA0E6
#define Z_UNICODE_YI_SYLLABLE_VIEX  0xA0E7
#define Z_UNICODE_YI_SYLLABLE_VIE   0xA0E8
#define Z_UNICODE_YI_SYLLABLE_VIEP  0xA0E9
#define Z_UNICODE_YI_SYLLABLE_VAT   0xA0EA
#define Z_UNICODE_YI_SYLLABLE_VAX   0xA0EB
#define Z_UNICODE_YI_SYLLABLE_VA    0xA0EC
#define Z_UNICODE_YI_SYLLABLE_VAP   0xA0ED
#define Z_UNICODE_YI_SYLLABLE_VOT   0xA0EE
#define Z_UNICODE_YI_SYLLABLE_VOX   0xA0EF
#define Z_UNICODE_YI_SYLLABLE_VO    0xA0F0
#define Z_UNICODE_YI_SYLLABLE_VOP   0xA0F1
#define Z_UNICODE_YI_SYLLABLE_VEX   0xA0F2
#define Z_UNICODE_YI_SYLLABLE_VEP   0xA0F3
#define Z_UNICODE_YI_SYLLABLE_VUT   0xA0F4
#define Z_UNICODE_YI_SYLLABLE_VUX   0xA0F5
#define Z_UNICODE_YI_SYLLABLE_VU    0xA0F6
#define Z_UNICODE_YI_SYLLABLE_VUP   0xA0F7
#define Z_UNICODE_YI_SYLLABLE_VURX  0xA0F8
#define Z_UNICODE_YI_SYLLABLE_VUR   0xA0F9
#define Z_UNICODE_YI_SYLLABLE_VYT   0xA0FA
#define Z_UNICODE_YI_SYLLABLE_VYX   0xA0FB
#define Z_UNICODE_YI_SYLLABLE_VY    0xA0FC
#define Z_UNICODE_YI_SYLLABLE_VYP   0xA0FD
#define Z_UNICODE_YI_SYLLABLE_VYRX  0xA0FE
#define Z_UNICODE_YI_SYLLABLE_VYR   0xA0FF
#define Z_UNICODE_YI_SYLLABLE_DIT   0xA100
#define Z_UNICODE_YI_SYLLABLE_DIX   0xA101
#define Z_UNICODE_YI_SYLLABLE_DI    0xA102
#define Z_UNICODE_YI_SYLLABLE_DIP   0xA103
#define Z_UNICODE_YI_SYLLABLE_DIEX  0xA104
#define Z_UNICODE_YI_SYLLABLE_DIE   0xA105
#define Z_UNICODE_YI_SYLLABLE_DIEP  0xA106
#define Z_UNICODE_YI_SYLLABLE_DAT   0xA107
#define Z_UNICODE_YI_SYLLABLE_DAX   0xA108
#define Z_UNICODE_YI_SYLLABLE_DA    0xA109
#define Z_UNICODE_YI_SYLLABLE_DAP   0xA10A
#define Z_UNICODE_YI_SYLLABLE_DUOX  0xA10B
#define Z_UNICODE_YI_SYLLABLE_DUO   0xA10C
#define Z_UNICODE_YI_SYLLABLE_DOT   0xA10D
#define Z_UNICODE_YI_SYLLABLE_DOX   0xA10E
#define Z_UNICODE_YI_SYLLABLE_DO    0xA10F
#define Z_UNICODE_YI_SYLLABLE_DOP   0xA110
#define Z_UNICODE_YI_SYLLABLE_DEX   0xA111
#define Z_UNICODE_YI_SYLLABLE_DE    0xA112
#define Z_UNICODE_YI_SYLLABLE_DEP   0xA113
#define Z_UNICODE_YI_SYLLABLE_DUT   0xA114
#define Z_UNICODE_YI_SYLLABLE_DUX   0xA115
#define Z_UNICODE_YI_SYLLABLE_DU    0xA116
#define Z_UNICODE_YI_SYLLABLE_DUP   0xA117
#define Z_UNICODE_YI_SYLLABLE_DURX  0xA118
#define Z_UNICODE_YI_SYLLABLE_DUR   0xA119
#define Z_UNICODE_YI_SYLLABLE_TIT   0xA11A
#define Z_UNICODE_YI_SYLLABLE_TIX   0xA11B
#define Z_UNICODE_YI_SYLLABLE_TI    0xA11C
#define Z_UNICODE_YI_SYLLABLE_TIP   0xA11D
#define Z_UNICODE_YI_SYLLABLE_TIEX  0xA11E
#define Z_UNICODE_YI_SYLLABLE_TIE   0xA11F
#define Z_UNICODE_YI_SYLLABLE_TIEP  0xA120
#define Z_UNICODE_YI_SYLLABLE_TAT   0xA121
#define Z_UNICODE_YI_SYLLABLE_TAX   0xA122
#define Z_UNICODE_YI_SYLLABLE_TA    0xA123
#define Z_UNICODE_YI_SYLLABLE_TAP   0xA124
#define Z_UNICODE_YI_SYLLABLE_TUOT  0xA125
#define Z_UNICODE_YI_SYLLABLE_TUOX  0xA126
#define Z_UNICODE_YI_SYLLABLE_TUO   0xA127
#define Z_UNICODE_YI_SYLLABLE_TUOP  0xA128
#define Z_UNICODE_YI_SYLLABLE_TOT   0xA129
#define Z_UNICODE_YI_SYLLABLE_TOX   0xA12A
#define Z_UNICODE_YI_SYLLABLE_TO    0xA12B
#define Z_UNICODE_YI_SYLLABLE_TOP   0xA12C
#define Z_UNICODE_YI_SYLLABLE_TEX   0xA12D
#define Z_UNICODE_YI_SYLLABLE_TE    0xA12E
#define Z_UNICODE_YI_SYLLABLE_TEP   0xA12F
#define Z_UNICODE_YI_SYLLABLE_TUT   0xA130
#define Z_UNICODE_YI_SYLLABLE_TUX   0xA131
#define Z_UNICODE_YI_SYLLABLE_TU    0xA132
#define Z_UNICODE_YI_SYLLABLE_TUP   0xA133
#define Z_UNICODE_YI_SYLLABLE_TURX  0xA134
#define Z_UNICODE_YI_SYLLABLE_TUR   0xA135
#define Z_UNICODE_YI_SYLLABLE_DDIT  0xA136
#define Z_UNICODE_YI_SYLLABLE_DDIX  0xA137
#define Z_UNICODE_YI_SYLLABLE_DDI   0xA138
#define Z_UNICODE_YI_SYLLABLE_DDIP  0xA139
#define Z_UNICODE_YI_SYLLABLE_DDIEX 0xA13A
#define Z_UNICODE_YI_SYLLABLE_DDIE  0xA13B
#define Z_UNICODE_YI_SYLLABLE_DDIEP 0xA13C
#define Z_UNICODE_YI_SYLLABLE_DDAT  0xA13D
#define Z_UNICODE_YI_SYLLABLE_DDAX  0xA13E
#define Z_UNICODE_YI_SYLLABLE_DDA   0xA13F
#define Z_UNICODE_YI_SYLLABLE_DDAP  0xA140
#define Z_UNICODE_YI_SYLLABLE_DDUOX 0xA141
#define Z_UNICODE_YI_SYLLABLE_DDUO  0xA142
#define Z_UNICODE_YI_SYLLABLE_DDUOP 0xA143
#define Z_UNICODE_YI_SYLLABLE_DDOT  0xA144
#define Z_UNICODE_YI_SYLLABLE_DDOX  0xA145
#define Z_UNICODE_YI_SYLLABLE_DDO   0xA146
#define Z_UNICODE_YI_SYLLABLE_DDOP  0xA147
#define Z_UNICODE_YI_SYLLABLE_DDEX  0xA148
#define Z_UNICODE_YI_SYLLABLE_DDE   0xA149
#define Z_UNICODE_YI_SYLLABLE_DDEP  0xA14A
#define Z_UNICODE_YI_SYLLABLE_DDUT  0xA14B
#define Z_UNICODE_YI_SYLLABLE_DDUX  0xA14C
#define Z_UNICODE_YI_SYLLABLE_DDU   0xA14D
#define Z_UNICODE_YI_SYLLABLE_DDUP  0xA14E
#define Z_UNICODE_YI_SYLLABLE_DDURX 0xA14F
#define Z_UNICODE_YI_SYLLABLE_DDUR  0xA150
#define Z_UNICODE_YI_SYLLABLE_NDIT  0xA151
#define Z_UNICODE_YI_SYLLABLE_NDIX  0xA152
#define Z_UNICODE_YI_SYLLABLE_NDI   0xA153
#define Z_UNICODE_YI_SYLLABLE_NDIP  0xA154
#define Z_UNICODE_YI_SYLLABLE_NDIEX 0xA155
#define Z_UNICODE_YI_SYLLABLE_NDIE  0xA156
#define Z_UNICODE_YI_SYLLABLE_NDAT  0xA157
#define Z_UNICODE_YI_SYLLABLE_NDAX  0xA158
#define Z_UNICODE_YI_SYLLABLE_NDA   0xA159
#define Z_UNICODE_YI_SYLLABLE_NDAP  0xA15A
#define Z_UNICODE_YI_SYLLABLE_NDOT  0xA15B
#define Z_UNICODE_YI_SYLLABLE_NDOX  0xA15C
#define Z_UNICODE_YI_SYLLABLE_NDO   0xA15D
#define Z_UNICODE_YI_SYLLABLE_NDOP  0xA15E
#define Z_UNICODE_YI_SYLLABLE_NDEX  0xA15F
#define Z_UNICODE_YI_SYLLABLE_NDE   0xA160
#define Z_UNICODE_YI_SYLLABLE_NDEP  0xA161
#define Z_UNICODE_YI_SYLLABLE_NDUT  0xA162
#define Z_UNICODE_YI_SYLLABLE_NDUX  0xA163
#define Z_UNICODE_YI_SYLLABLE_NDU   0xA164
#define Z_UNICODE_YI_SYLLABLE_NDUP  0xA165
#define Z_UNICODE_YI_SYLLABLE_NDURX 0xA166
#define Z_UNICODE_YI_SYLLABLE_NDUR  0xA167
#define Z_UNICODE_YI_SYLLABLE_HNIT  0xA168
#define Z_UNICODE_YI_SYLLABLE_HNIX  0xA169
#define Z_UNICODE_YI_SYLLABLE_HNI   0xA16A
#define Z_UNICODE_YI_SYLLABLE_HNIP  0xA16B
#define Z_UNICODE_YI_SYLLABLE_HNIET 0xA16C
#define Z_UNICODE_YI_SYLLABLE_HNIEX 0xA16D
#define Z_UNICODE_YI_SYLLABLE_HNIE  0xA16E
#define Z_UNICODE_YI_SYLLABLE_HNIEP 0xA16F
#define Z_UNICODE_YI_SYLLABLE_HNAT  0xA170
#define Z_UNICODE_YI_SYLLABLE_HNAX  0xA171
#define Z_UNICODE_YI_SYLLABLE_HNA   0xA172
#define Z_UNICODE_YI_SYLLABLE_HNAP  0xA173
#define Z_UNICODE_YI_SYLLABLE_HNUOX 0xA174
#define Z_UNICODE_YI_SYLLABLE_HNUO  0xA175
#define Z_UNICODE_YI_SYLLABLE_HNOT  0xA176
#define Z_UNICODE_YI_SYLLABLE_HNOX  0xA177
#define Z_UNICODE_YI_SYLLABLE_HNOP  0xA178
#define Z_UNICODE_YI_SYLLABLE_HNEX  0xA179
#define Z_UNICODE_YI_SYLLABLE_HNE   0xA17A
#define Z_UNICODE_YI_SYLLABLE_HNEP  0xA17B
#define Z_UNICODE_YI_SYLLABLE_HNUT  0xA17C
#define Z_UNICODE_YI_SYLLABLE_NIT   0xA17D
#define Z_UNICODE_YI_SYLLABLE_NIX   0xA17E
#define Z_UNICODE_YI_SYLLABLE_NI    0xA17F
#define Z_UNICODE_YI_SYLLABLE_NIP   0xA180
#define Z_UNICODE_YI_SYLLABLE_NIEX  0xA181
#define Z_UNICODE_YI_SYLLABLE_NIE   0xA182
#define Z_UNICODE_YI_SYLLABLE_NIEP  0xA183
#define Z_UNICODE_YI_SYLLABLE_NAX   0xA184
#define Z_UNICODE_YI_SYLLABLE_NA    0xA185
#define Z_UNICODE_YI_SYLLABLE_NAP   0xA186
#define Z_UNICODE_YI_SYLLABLE_NUOX  0xA187
#define Z_UNICODE_YI_SYLLABLE_NUO   0xA188
#define Z_UNICODE_YI_SYLLABLE_NUOP  0xA189
#define Z_UNICODE_YI_SYLLABLE_NOT   0xA18A
#define Z_UNICODE_YI_SYLLABLE_NOX   0xA18B
#define Z_UNICODE_YI_SYLLABLE_NO    0xA18C
#define Z_UNICODE_YI_SYLLABLE_NOP   0xA18D
#define Z_UNICODE_YI_SYLLABLE_NEX   0xA18E
#define Z_UNICODE_YI_SYLLABLE_NE    0xA18F
#define Z_UNICODE_YI_SYLLABLE_NEP   0xA190
#define Z_UNICODE_YI_SYLLABLE_NUT   0xA191
#define Z_UNICODE_YI_SYLLABLE_NUX   0xA192
#define Z_UNICODE_YI_SYLLABLE_NU    0xA193
#define Z_UNICODE_YI_SYLLABLE_NUP   0xA194
#define Z_UNICODE_YI_SYLLABLE_NURX  0xA195
#define Z_UNICODE_YI_SYLLABLE_NUR   0xA196
#define Z_UNICODE_YI_SYLLABLE_HLIT  0xA197
#define Z_UNICODE_YI_SYLLABLE_HLIX  0xA198
#define Z_UNICODE_YI_SYLLABLE_HLI   0xA199
#define Z_UNICODE_YI_SYLLABLE_HLIP  0xA19A
#define Z_UNICODE_YI_SYLLABLE_HLIEX 0xA19B
#define Z_UNICODE_YI_SYLLABLE_HLIE  0xA19C
#define Z_UNICODE_YI_SYLLABLE_HLIEP 0xA19D
#define Z_UNICODE_YI_SYLLABLE_HLAT  0xA19E
#define Z_UNICODE_YI_SYLLABLE_HLAX  0xA19F
#define Z_UNICODE_YI_SYLLABLE_HLA   0xA1A0
#define Z_UNICODE_YI_SYLLABLE_HLAP  0xA1A1
#define Z_UNICODE_YI_SYLLABLE_HLUOX 0xA1A2
#define Z_UNICODE_YI_SYLLABLE_HLUO  0xA1A3
#define Z_UNICODE_YI_SYLLABLE_HLUOP 0xA1A4
#define Z_UNICODE_YI_SYLLABLE_HLOX  0xA1A5
#define Z_UNICODE_YI_SYLLABLE_HLO   0xA1A6
#define Z_UNICODE_YI_SYLLABLE_HLOP  0xA1A7
#define Z_UNICODE_YI_SYLLABLE_HLEX  0xA1A8
#define Z_UNICODE_YI_SYLLABLE_HLE   0xA1A9
#define Z_UNICODE_YI_SYLLABLE_HLEP  0xA1AA
#define Z_UNICODE_YI_SYLLABLE_HLUT  0xA1AB
#define Z_UNICODE_YI_SYLLABLE_HLUX  0xA1AC
#define Z_UNICODE_YI_SYLLABLE_HLU   0xA1AD
#define Z_UNICODE_YI_SYLLABLE_HLUP  0xA1AE
#define Z_UNICODE_YI_SYLLABLE_HLURX 0xA1AF
#define Z_UNICODE_YI_SYLLABLE_HLUR  0xA1B0
#define Z_UNICODE_YI_SYLLABLE_HLYT  0xA1B1
#define Z_UNICODE_YI_SYLLABLE_HLYX  0xA1B2
#define Z_UNICODE_YI_SYLLABLE_HLY   0xA1B3
#define Z_UNICODE_YI_SYLLABLE_HLYP  0xA1B4
#define Z_UNICODE_YI_SYLLABLE_HLYRX 0xA1B5
#define Z_UNICODE_YI_SYLLABLE_HLYR  0xA1B6
#define Z_UNICODE_YI_SYLLABLE_LIT   0xA1B7
#define Z_UNICODE_YI_SYLLABLE_LIX   0xA1B8
#define Z_UNICODE_YI_SYLLABLE_LI    0xA1B9
#define Z_UNICODE_YI_SYLLABLE_LIP   0xA1BA
#define Z_UNICODE_YI_SYLLABLE_LIET  0xA1BB
#define Z_UNICODE_YI_SYLLABLE_LIEX  0xA1BC
#define Z_UNICODE_YI_SYLLABLE_LIE   0xA1BD
#define Z_UNICODE_YI_SYLLABLE_LIEP  0xA1BE
#define Z_UNICODE_YI_SYLLABLE_LAT   0xA1BF
#define Z_UNICODE_YI_SYLLABLE_LAX   0xA1C0
#define Z_UNICODE_YI_SYLLABLE_LA    0xA1C1
#define Z_UNICODE_YI_SYLLABLE_LAP   0xA1C2
#define Z_UNICODE_YI_SYLLABLE_LUOT  0xA1C3
#define Z_UNICODE_YI_SYLLABLE_LUOX  0xA1C4
#define Z_UNICODE_YI_SYLLABLE_LUO   0xA1C5
#define Z_UNICODE_YI_SYLLABLE_LUOP  0xA1C6
#define Z_UNICODE_YI_SYLLABLE_LOT   0xA1C7
#define Z_UNICODE_YI_SYLLABLE_LOX   0xA1C8
#define Z_UNICODE_YI_SYLLABLE_LO    0xA1C9
#define Z_UNICODE_YI_SYLLABLE_LOP   0xA1CA
#define Z_UNICODE_YI_SYLLABLE_LEX   0xA1CB
#define Z_UNICODE_YI_SYLLABLE_LE    0xA1CC
#define Z_UNICODE_YI_SYLLABLE_LEP   0xA1CD
#define Z_UNICODE_YI_SYLLABLE_LUT   0xA1CE
#define Z_UNICODE_YI_SYLLABLE_LUX   0xA1CF
#define Z_UNICODE_YI_SYLLABLE_LU    0xA1D0
#define Z_UNICODE_YI_SYLLABLE_LUP   0xA1D1
#define Z_UNICODE_YI_SYLLABLE_LURX  0xA1D2
#define Z_UNICODE_YI_SYLLABLE_LUR   0xA1D3
#define Z_UNICODE_YI_SYLLABLE_LYT   0xA1D4
#define Z_UNICODE_YI_SYLLABLE_LYX   0xA1D5
#define Z_UNICODE_YI_SYLLABLE_LY    0xA1D6
#define Z_UNICODE_YI_SYLLABLE_LYP   0xA1D7
#define Z_UNICODE_YI_SYLLABLE_LYRX  0xA1D8
#define Z_UNICODE_YI_SYLLABLE_LYR   0xA1D9
#define Z_UNICODE_YI_SYLLABLE_GIT   0xA1DA
#define Z_UNICODE_YI_SYLLABLE_GIX   0xA1DB
#define Z_UNICODE_YI_SYLLABLE_GI    0xA1DC
#define Z_UNICODE_YI_SYLLABLE_GIP   0xA1DD
#define Z_UNICODE_YI_SYLLABLE_GIET  0xA1DE
#define Z_UNICODE_YI_SYLLABLE_GIEX  0xA1DF
#define Z_UNICODE_YI_SYLLABLE_GIE   0xA1E0
#define Z_UNICODE_YI_SYLLABLE_GIEP  0xA1E1
#define Z_UNICODE_YI_SYLLABLE_GAT   0xA1E2
#define Z_UNICODE_YI_SYLLABLE_GAX   0xA1E3
#define Z_UNICODE_YI_SYLLABLE_GA    0xA1E4
#define Z_UNICODE_YI_SYLLABLE_GAP   0xA1E5
#define Z_UNICODE_YI_SYLLABLE_GUOT  0xA1E6
#define Z_UNICODE_YI_SYLLABLE_GUOX  0xA1E7
#define Z_UNICODE_YI_SYLLABLE_GUO   0xA1E8
#define Z_UNICODE_YI_SYLLABLE_GUOP  0xA1E9
#define Z_UNICODE_YI_SYLLABLE_GOT   0xA1EA
#define Z_UNICODE_YI_SYLLABLE_GOX   0xA1EB
#define Z_UNICODE_YI_SYLLABLE_GO    0xA1EC
#define Z_UNICODE_YI_SYLLABLE_GOP   0xA1ED
#define Z_UNICODE_YI_SYLLABLE_GET   0xA1EE
#define Z_UNICODE_YI_SYLLABLE_GEX   0xA1EF
#define Z_UNICODE_YI_SYLLABLE_GE    0xA1F0
#define Z_UNICODE_YI_SYLLABLE_GEP   0xA1F1
#define Z_UNICODE_YI_SYLLABLE_GUT   0xA1F2
#define Z_UNICODE_YI_SYLLABLE_GUX   0xA1F3
#define Z_UNICODE_YI_SYLLABLE_GU    0xA1F4
#define Z_UNICODE_YI_SYLLABLE_GUP   0xA1F5
#define Z_UNICODE_YI_SYLLABLE_GURX  0xA1F6
#define Z_UNICODE_YI_SYLLABLE_GUR   0xA1F7
#define Z_UNICODE_YI_SYLLABLE_KIT   0xA1F8
#define Z_UNICODE_YI_SYLLABLE_KIX   0xA1F9
#define Z_UNICODE_YI_SYLLABLE_KI    0xA1FA
#define Z_UNICODE_YI_SYLLABLE_KIP   0xA1FB
#define Z_UNICODE_YI_SYLLABLE_KIEX  0xA1FC
#define Z_UNICODE_YI_SYLLABLE_KIE   0xA1FD
#define Z_UNICODE_YI_SYLLABLE_KIEP  0xA1FE
#define Z_UNICODE_YI_SYLLABLE_KAT   0xA1FF
#define Z_UNICODE_YI_SYLLABLE_KAX   0xA200
#define Z_UNICODE_YI_SYLLABLE_KA    0xA201
#define Z_UNICODE_YI_SYLLABLE_KAP   0xA202
#define Z_UNICODE_YI_SYLLABLE_KUOX  0xA203
#define Z_UNICODE_YI_SYLLABLE_KUO   0xA204
#define Z_UNICODE_YI_SYLLABLE_KUOP  0xA205
#define Z_UNICODE_YI_SYLLABLE_KOT   0xA206
#define Z_UNICODE_YI_SYLLABLE_KOX   0xA207
#define Z_UNICODE_YI_SYLLABLE_KO    0xA208
#define Z_UNICODE_YI_SYLLABLE_KOP   0xA209
#define Z_UNICODE_YI_SYLLABLE_KET   0xA20A
#define Z_UNICODE_YI_SYLLABLE_KEX   0xA20B
#define Z_UNICODE_YI_SYLLABLE_KE    0xA20C
#define Z_UNICODE_YI_SYLLABLE_KEP   0xA20D
#define Z_UNICODE_YI_SYLLABLE_KUT   0xA20E
#define Z_UNICODE_YI_SYLLABLE_KUX   0xA20F
#define Z_UNICODE_YI_SYLLABLE_KU    0xA210
#define Z_UNICODE_YI_SYLLABLE_KUP   0xA211
#define Z_UNICODE_YI_SYLLABLE_KURX  0xA212
#define Z_UNICODE_YI_SYLLABLE_KUR   0xA213
#define Z_UNICODE_YI_SYLLABLE_GGIT  0xA214
#define Z_UNICODE_YI_SYLLABLE_GGIX  0xA215
#define Z_UNICODE_YI_SYLLABLE_GGI   0xA216
#define Z_UNICODE_YI_SYLLABLE_GGIEX 0xA217
#define Z_UNICODE_YI_SYLLABLE_GGIE  0xA218
#define Z_UNICODE_YI_SYLLABLE_GGIEP 0xA219
#define Z_UNICODE_YI_SYLLABLE_GGAT  0xA21A
#define Z_UNICODE_YI_SYLLABLE_GGAX  0xA21B
#define Z_UNICODE_YI_SYLLABLE_GGA   0xA21C
#define Z_UNICODE_YI_SYLLABLE_GGAP  0xA21D
#define Z_UNICODE_YI_SYLLABLE_GGUOT 0xA21E
#define Z_UNICODE_YI_SYLLABLE_GGUOX 0xA21F
#define Z_UNICODE_YI_SYLLABLE_GGUO  0xA220
#define Z_UNICODE_YI_SYLLABLE_GGUOP 0xA221
#define Z_UNICODE_YI_SYLLABLE_GGOT  0xA222
#define Z_UNICODE_YI_SYLLABLE_GGOX  0xA223
#define Z_UNICODE_YI_SYLLABLE_GGO   0xA224
#define Z_UNICODE_YI_SYLLABLE_GGOP  0xA225
#define Z_UNICODE_YI_SYLLABLE_GGET  0xA226
#define Z_UNICODE_YI_SYLLABLE_GGEX  0xA227
#define Z_UNICODE_YI_SYLLABLE_GGE   0xA228
#define Z_UNICODE_YI_SYLLABLE_GGEP  0xA229
#define Z_UNICODE_YI_SYLLABLE_GGUT  0xA22A
#define Z_UNICODE_YI_SYLLABLE_GGUX  0xA22B
#define Z_UNICODE_YI_SYLLABLE_GGU   0xA22C
#define Z_UNICODE_YI_SYLLABLE_GGUP  0xA22D
#define Z_UNICODE_YI_SYLLABLE_GGURX 0xA22E
#define Z_UNICODE_YI_SYLLABLE_GGUR  0xA22F
#define Z_UNICODE_YI_SYLLABLE_MGIEX 0xA230
#define Z_UNICODE_YI_SYLLABLE_MGIE  0xA231
#define Z_UNICODE_YI_SYLLABLE_MGAT  0xA232
#define Z_UNICODE_YI_SYLLABLE_MGAX  0xA233
#define Z_UNICODE_YI_SYLLABLE_MGA   0xA234
#define Z_UNICODE_YI_SYLLABLE_MGAP  0xA235
#define Z_UNICODE_YI_SYLLABLE_MGUOX 0xA236
#define Z_UNICODE_YI_SYLLABLE_MGUO  0xA237
#define Z_UNICODE_YI_SYLLABLE_MGUOP 0xA238
#define Z_UNICODE_YI_SYLLABLE_MGOT  0xA239
#define Z_UNICODE_YI_SYLLABLE_MGOX  0xA23A
#define Z_UNICODE_YI_SYLLABLE_MGO   0xA23B
#define Z_UNICODE_YI_SYLLABLE_MGOP  0xA23C
#define Z_UNICODE_YI_SYLLABLE_MGEX  0xA23D
#define Z_UNICODE_YI_SYLLABLE_MGE   0xA23E
#define Z_UNICODE_YI_SYLLABLE_MGEP  0xA23F
#define Z_UNICODE_YI_SYLLABLE_MGUT  0xA240
#define Z_UNICODE_YI_SYLLABLE_MGUX  0xA241
#define Z_UNICODE_YI_SYLLABLE_MGU   0xA242
#define Z_UNICODE_YI_SYLLABLE_MGUP  0xA243
#define Z_UNICODE_YI_SYLLABLE_MGURX 0xA244
#define Z_UNICODE_YI_SYLLABLE_MGUR  0xA245
#define Z_UNICODE_YI_SYLLABLE_HXIT  0xA246
#define Z_UNICODE_YI_SYLLABLE_HXIX  0xA247
#define Z_UNICODE_YI_SYLLABLE_HXI   0xA248
#define Z_UNICODE_YI_SYLLABLE_HXIP  0xA249
#define Z_UNICODE_YI_SYLLABLE_HXIET 0xA24A
#define Z_UNICODE_YI_SYLLABLE_HXIEX 0xA24B
#define Z_UNICODE_YI_SYLLABLE_HXIE  0xA24C
#define Z_UNICODE_YI_SYLLABLE_HXIEP 0xA24D
#define Z_UNICODE_YI_SYLLABLE_HXAT  0xA24E
#define Z_UNICODE_YI_SYLLABLE_HXAX  0xA24F
#define Z_UNICODE_YI_SYLLABLE_HXA   0xA250
#define Z_UNICODE_YI_SYLLABLE_HXAP  0xA251
#define Z_UNICODE_YI_SYLLABLE_HXUOT 0xA252
#define Z_UNICODE_YI_SYLLABLE_HXUOX 0xA253
#define Z_UNICODE_YI_SYLLABLE_HXUO  0xA254
#define Z_UNICODE_YI_SYLLABLE_HXUOP 0xA255
#define Z_UNICODE_YI_SYLLABLE_HXOT  0xA256
#define Z_UNICODE_YI_SYLLABLE_HXOX  0xA257
#define Z_UNICODE_YI_SYLLABLE_HXO   0xA258
#define Z_UNICODE_YI_SYLLABLE_HXOP  0xA259
#define Z_UNICODE_YI_SYLLABLE_HXEX  0xA25A
#define Z_UNICODE_YI_SYLLABLE_HXE   0xA25B
#define Z_UNICODE_YI_SYLLABLE_HXEP  0xA25C
#define Z_UNICODE_YI_SYLLABLE_NGIEX 0xA25D
#define Z_UNICODE_YI_SYLLABLE_NGIE  0xA25E
#define Z_UNICODE_YI_SYLLABLE_NGIEP 0xA25F
#define Z_UNICODE_YI_SYLLABLE_NGAT  0xA260
#define Z_UNICODE_YI_SYLLABLE_NGAX  0xA261
#define Z_UNICODE_YI_SYLLABLE_NGA   0xA262
#define Z_UNICODE_YI_SYLLABLE_NGAP  0xA263
#define Z_UNICODE_YI_SYLLABLE_NGUOT 0xA264
#define Z_UNICODE_YI_SYLLABLE_NGUOX 0xA265
#define Z_UNICODE_YI_SYLLABLE_NGUO  0xA266
#define Z_UNICODE_YI_SYLLABLE_NGOT  0xA267
#define Z_UNICODE_YI_SYLLABLE_NGOX  0xA268
#define Z_UNICODE_YI_SYLLABLE_NGO   0xA269
#define Z_UNICODE_YI_SYLLABLE_NGOP  0xA26A
#define Z_UNICODE_YI_SYLLABLE_NGEX  0xA26B
#define Z_UNICODE_YI_SYLLABLE_NGE   0xA26C
#define Z_UNICODE_YI_SYLLABLE_NGEP  0xA26D
#define Z_UNICODE_YI_SYLLABLE_HIT   0xA26E
#define Z_UNICODE_YI_SYLLABLE_HIEX  0xA26F
#define Z_UNICODE_YI_SYLLABLE_HIE   0xA270
#define Z_UNICODE_YI_SYLLABLE_HAT   0xA271
#define Z_UNICODE_YI_SYLLABLE_HAX   0xA272
#define Z_UNICODE_YI_SYLLABLE_HA    0xA273
#define Z_UNICODE_YI_SYLLABLE_HAP   0xA274
#define Z_UNICODE_YI_SYLLABLE_HUOT  0xA275
#define Z_UNICODE_YI_SYLLABLE_HUOX  0xA276
#define Z_UNICODE_YI_SYLLABLE_HUO   0xA277
#define Z_UNICODE_YI_SYLLABLE_HUOP  0xA278
#define Z_UNICODE_YI_SYLLABLE_HOT   0xA279
#define Z_UNICODE_YI_SYLLABLE_HOX   0xA27A
#define Z_UNICODE_YI_SYLLABLE_HO    0xA27B
#define Z_UNICODE_YI_SYLLABLE_HOP   0xA27C
#define Z_UNICODE_YI_SYLLABLE_HEX   0xA27D
#define Z_UNICODE_YI_SYLLABLE_HE    0xA27E
#define Z_UNICODE_YI_SYLLABLE_HEP   0xA27F
#define Z_UNICODE_YI_SYLLABLE_WAT   0xA280
#define Z_UNICODE_YI_SYLLABLE_WAX   0xA281
#define Z_UNICODE_YI_SYLLABLE_WA    0xA282
#define Z_UNICODE_YI_SYLLABLE_WAP   0xA283
#define Z_UNICODE_YI_SYLLABLE_WUOX  0xA284
#define Z_UNICODE_YI_SYLLABLE_WUO   0xA285
#define Z_UNICODE_YI_SYLLABLE_WUOP  0xA286
#define Z_UNICODE_YI_SYLLABLE_WOX   0xA287
#define Z_UNICODE_YI_SYLLABLE_WO    0xA288
#define Z_UNICODE_YI_SYLLABLE_WOP   0xA289
#define Z_UNICODE_YI_SYLLABLE_WEX   0xA28A
#define Z_UNICODE_YI_SYLLABLE_WE    0xA28B
#define Z_UNICODE_YI_SYLLABLE_WEP   0xA28C
#define Z_UNICODE_YI_SYLLABLE_ZIT   0xA28D
#define Z_UNICODE_YI_SYLLABLE_ZIX   0xA28E
#define Z_UNICODE_YI_SYLLABLE_ZI    0xA28F
#define Z_UNICODE_YI_SYLLABLE_ZIP   0xA290
#define Z_UNICODE_YI_SYLLABLE_ZIEX  0xA291
#define Z_UNICODE_YI_SYLLABLE_ZIE   0xA292
#define Z_UNICODE_YI_SYLLABLE_ZIEP  0xA293
#define Z_UNICODE_YI_SYLLABLE_ZAT   0xA294
#define Z_UNICODE_YI_SYLLABLE_ZAX   0xA295
#define Z_UNICODE_YI_SYLLABLE_ZA    0xA296
#define Z_UNICODE_YI_SYLLABLE_ZAP   0xA297
#define Z_UNICODE_YI_SYLLABLE_ZUOX  0xA298
#define Z_UNICODE_YI_SYLLABLE_ZUO   0xA299
#define Z_UNICODE_YI_SYLLABLE_ZUOP  0xA29A
#define Z_UNICODE_YI_SYLLABLE_ZOT   0xA29B
#define Z_UNICODE_YI_SYLLABLE_ZOX   0xA29C
#define Z_UNICODE_YI_SYLLABLE_ZO    0xA29D
#define Z_UNICODE_YI_SYLLABLE_ZOP   0xA29E
#define Z_UNICODE_YI_SYLLABLE_ZEX   0xA29F
#define Z_UNICODE_YI_SYLLABLE_ZE    0xA2A0
#define Z_UNICODE_YI_SYLLABLE_ZEP   0xA2A1
#define Z_UNICODE_YI_SYLLABLE_ZUT   0xA2A2
#define Z_UNICODE_YI_SYLLABLE_ZUX   0xA2A3
#define Z_UNICODE_YI_SYLLABLE_ZU    0xA2A4
#define Z_UNICODE_YI_SYLLABLE_ZUP   0xA2A5
#define Z_UNICODE_YI_SYLLABLE_ZURX  0xA2A6
#define Z_UNICODE_YI_SYLLABLE_ZUR   0xA2A7
#define Z_UNICODE_YI_SYLLABLE_ZYT   0xA2A8
#define Z_UNICODE_YI_SYLLABLE_ZYX   0xA2A9
#define Z_UNICODE_YI_SYLLABLE_ZY    0xA2AA
#define Z_UNICODE_YI_SYLLABLE_ZYP   0xA2AB
#define Z_UNICODE_YI_SYLLABLE_ZYRX  0xA2AC
#define Z_UNICODE_YI_SYLLABLE_ZYR   0xA2AD
#define Z_UNICODE_YI_SYLLABLE_CIT   0xA2AE
#define Z_UNICODE_YI_SYLLABLE_CIX   0xA2AF
#define Z_UNICODE_YI_SYLLABLE_CI    0xA2B0
#define Z_UNICODE_YI_SYLLABLE_CIP   0xA2B1
#define Z_UNICODE_YI_SYLLABLE_CIET  0xA2B2
#define Z_UNICODE_YI_SYLLABLE_CIEX  0xA2B3
#define Z_UNICODE_YI_SYLLABLE_CIE   0xA2B4
#define Z_UNICODE_YI_SYLLABLE_CIEP  0xA2B5
#define Z_UNICODE_YI_SYLLABLE_CAT   0xA2B6
#define Z_UNICODE_YI_SYLLABLE_CAX   0xA2B7
#define Z_UNICODE_YI_SYLLABLE_CA    0xA2B8
#define Z_UNICODE_YI_SYLLABLE_CAP   0xA2B9
#define Z_UNICODE_YI_SYLLABLE_CUOX  0xA2BA
#define Z_UNICODE_YI_SYLLABLE_CUO   0xA2BB
#define Z_UNICODE_YI_SYLLABLE_CUOP  0xA2BC
#define Z_UNICODE_YI_SYLLABLE_COT   0xA2BD
#define Z_UNICODE_YI_SYLLABLE_COX   0xA2BE
#define Z_UNICODE_YI_SYLLABLE_CO    0xA2BF
#define Z_UNICODE_YI_SYLLABLE_COP   0xA2C0
#define Z_UNICODE_YI_SYLLABLE_CEX   0xA2C1
#define Z_UNICODE_YI_SYLLABLE_CE    0xA2C2
#define Z_UNICODE_YI_SYLLABLE_CEP   0xA2C3
#define Z_UNICODE_YI_SYLLABLE_CUT   0xA2C4
#define Z_UNICODE_YI_SYLLABLE_CUX   0xA2C5
#define Z_UNICODE_YI_SYLLABLE_CU    0xA2C6
#define Z_UNICODE_YI_SYLLABLE_CUP   0xA2C7
#define Z_UNICODE_YI_SYLLABLE_CURX  0xA2C8
#define Z_UNICODE_YI_SYLLABLE_CUR   0xA2C9
#define Z_UNICODE_YI_SYLLABLE_CYT   0xA2CA
#define Z_UNICODE_YI_SYLLABLE_CYX   0xA2CB
#define Z_UNICODE_YI_SYLLABLE_CY    0xA2CC
#define Z_UNICODE_YI_SYLLABLE_CYP   0xA2CD
#define Z_UNICODE_YI_SYLLABLE_CYRX  0xA2CE
#define Z_UNICODE_YI_SYLLABLE_CYR   0xA2CF
#define Z_UNICODE_YI_SYLLABLE_ZZIT  0xA2D0
#define Z_UNICODE_YI_SYLLABLE_ZZIX  0xA2D1
#define Z_UNICODE_YI_SYLLABLE_ZZI   0xA2D2
#define Z_UNICODE_YI_SYLLABLE_ZZIP  0xA2D3
#define Z_UNICODE_YI_SYLLABLE_ZZIET 0xA2D4
#define Z_UNICODE_YI_SYLLABLE_ZZIEX 0xA2D5
#define Z_UNICODE_YI_SYLLABLE_ZZIE  0xA2D6
#define Z_UNICODE_YI_SYLLABLE_ZZIEP 0xA2D7
#define Z_UNICODE_YI_SYLLABLE_ZZAT  0xA2D8
#define Z_UNICODE_YI_SYLLABLE_ZZAX  0xA2D9
#define Z_UNICODE_YI_SYLLABLE_ZZA   0xA2DA
#define Z_UNICODE_YI_SYLLABLE_ZZAP  0xA2DB
#define Z_UNICODE_YI_SYLLABLE_ZZOX  0xA2DC
#define Z_UNICODE_YI_SYLLABLE_ZZO   0xA2DD
#define Z_UNICODE_YI_SYLLABLE_ZZOP  0xA2DE
#define Z_UNICODE_YI_SYLLABLE_ZZEX  0xA2DF
#define Z_UNICODE_YI_SYLLABLE_ZZE   0xA2E0
#define Z_UNICODE_YI_SYLLABLE_ZZEP  0xA2E1
#define Z_UNICODE_YI_SYLLABLE_ZZUX  0xA2E2
#define Z_UNICODE_YI_SYLLABLE_ZZU   0xA2E3
#define Z_UNICODE_YI_SYLLABLE_ZZUP  0xA2E4
#define Z_UNICODE_YI_SYLLABLE_ZZURX 0xA2E5
#define Z_UNICODE_YI_SYLLABLE_ZZUR  0xA2E6
#define Z_UNICODE_YI_SYLLABLE_ZZYT  0xA2E7
#define Z_UNICODE_YI_SYLLABLE_ZZYX  0xA2E8
#define Z_UNICODE_YI_SYLLABLE_ZZY   0xA2E9
#define Z_UNICODE_YI_SYLLABLE_ZZYP  0xA2EA
#define Z_UNICODE_YI_SYLLABLE_ZZYRX 0xA2EB
#define Z_UNICODE_YI_SYLLABLE_ZZYR  0xA2EC
#define Z_UNICODE_YI_SYLLABLE_NZIT  0xA2ED
#define Z_UNICODE_YI_SYLLABLE_NZIX  0xA2EE
#define Z_UNICODE_YI_SYLLABLE_NZI   0xA2EF
#define Z_UNICODE_YI_SYLLABLE_NZIP  0xA2F0
#define Z_UNICODE_YI_SYLLABLE_NZIEX 0xA2F1
#define Z_UNICODE_YI_SYLLABLE_NZIE  0xA2F2
#define Z_UNICODE_YI_SYLLABLE_NZIEP 0xA2F3
#define Z_UNICODE_YI_SYLLABLE_NZAT  0xA2F4
#define Z_UNICODE_YI_SYLLABLE_NZAX  0xA2F5
#define Z_UNICODE_YI_SYLLABLE_NZA   0xA2F6
#define Z_UNICODE_YI_SYLLABLE_NZAP  0xA2F7
#define Z_UNICODE_YI_SYLLABLE_NZUOX 0xA2F8
#define Z_UNICODE_YI_SYLLABLE_NZUO  0xA2F9
#define Z_UNICODE_YI_SYLLABLE_NZOX  0xA2FA
#define Z_UNICODE_YI_SYLLABLE_NZOP  0xA2FB
#define Z_UNICODE_YI_SYLLABLE_NZEX  0xA2FC
#define Z_UNICODE_YI_SYLLABLE_NZE   0xA2FD
#define Z_UNICODE_YI_SYLLABLE_NZUX  0xA2FE
#define Z_UNICODE_YI_SYLLABLE_NZU   0xA2FF
#define Z_UNICODE_YI_SYLLABLE_NZUP  0xA300
#define Z_UNICODE_YI_SYLLABLE_NZURX 0xA301
#define Z_UNICODE_YI_SYLLABLE_NZUR  0xA302
#define Z_UNICODE_YI_SYLLABLE_NZYT  0xA303
#define Z_UNICODE_YI_SYLLABLE_NZYX  0xA304
#define Z_UNICODE_YI_SYLLABLE_NZY   0xA305
#define Z_UNICODE_YI_SYLLABLE_NZYP  0xA306
#define Z_UNICODE_YI_SYLLABLE_NZYRX 0xA307
#define Z_UNICODE_YI_SYLLABLE_NZYR  0xA308
#define Z_UNICODE_YI_SYLLABLE_SIT   0xA309
#define Z_UNICODE_YI_SYLLABLE_SIX   0xA30A
#define Z_UNICODE_YI_SYLLABLE_SI    0xA30B
#define Z_UNICODE_YI_SYLLABLE_SIP   0xA30C
#define Z_UNICODE_YI_SYLLABLE_SIEX  0xA30D
#define Z_UNICODE_YI_SYLLABLE_SIE   0xA30E
#define Z_UNICODE_YI_SYLLABLE_SIEP  0xA30F
#define Z_UNICODE_YI_SYLLABLE_SAT   0xA310
#define Z_UNICODE_YI_SYLLABLE_SAX   0xA311
#define Z_UNICODE_YI_SYLLABLE_SA    0xA312
#define Z_UNICODE_YI_SYLLABLE_SAP   0xA313
#define Z_UNICODE_YI_SYLLABLE_SUOX  0xA314
#define Z_UNICODE_YI_SYLLABLE_SUO   0xA315
#define Z_UNICODE_YI_SYLLABLE_SUOP  0xA316
#define Z_UNICODE_YI_SYLLABLE_SOT   0xA317
#define Z_UNICODE_YI_SYLLABLE_SOX   0xA318
#define Z_UNICODE_YI_SYLLABLE_SO    0xA319
#define Z_UNICODE_YI_SYLLABLE_SOP   0xA31A
#define Z_UNICODE_YI_SYLLABLE_SEX   0xA31B
#define Z_UNICODE_YI_SYLLABLE_SE    0xA31C
#define Z_UNICODE_YI_SYLLABLE_SEP   0xA31D
#define Z_UNICODE_YI_SYLLABLE_SUT   0xA31E
#define Z_UNICODE_YI_SYLLABLE_SUX   0xA31F
#define Z_UNICODE_YI_SYLLABLE_SU    0xA320
#define Z_UNICODE_YI_SYLLABLE_SUP   0xA321
#define Z_UNICODE_YI_SYLLABLE_SURX  0xA322
#define Z_UNICODE_YI_SYLLABLE_SUR   0xA323
#define Z_UNICODE_YI_SYLLABLE_SYT   0xA324
#define Z_UNICODE_YI_SYLLABLE_SYX   0xA325
#define Z_UNICODE_YI_SYLLABLE_SY    0xA326
#define Z_UNICODE_YI_SYLLABLE_SYP   0xA327
#define Z_UNICODE_YI_SYLLABLE_SYRX  0xA328
#define Z_UNICODE_YI_SYLLABLE_SYR   0xA329
#define Z_UNICODE_YI_SYLLABLE_SSIT  0xA32A
#define Z_UNICODE_YI_SYLLABLE_SSIX  0xA32B
#define Z_UNICODE_YI_SYLLABLE_SSI   0xA32C
#define Z_UNICODE_YI_SYLLABLE_SSIP  0xA32D
#define Z_UNICODE_YI_SYLLABLE_SSIEX 0xA32E
#define Z_UNICODE_YI_SYLLABLE_SSIE  0xA32F
#define Z_UNICODE_YI_SYLLABLE_SSIEP 0xA330
#define Z_UNICODE_YI_SYLLABLE_SSAT  0xA331
#define Z_UNICODE_YI_SYLLABLE_SSAX  0xA332
#define Z_UNICODE_YI_SYLLABLE_SSA   0xA333
#define Z_UNICODE_YI_SYLLABLE_SSAP  0xA334
#define Z_UNICODE_YI_SYLLABLE_SSOT  0xA335
#define Z_UNICODE_YI_SYLLABLE_SSOX  0xA336
#define Z_UNICODE_YI_SYLLABLE_SSO   0xA337
#define Z_UNICODE_YI_SYLLABLE_SSOP  0xA338
#define Z_UNICODE_YI_SYLLABLE_SSEX  0xA339
#define Z_UNICODE_YI_SYLLABLE_SSE   0xA33A
#define Z_UNICODE_YI_SYLLABLE_SSEP  0xA33B
#define Z_UNICODE_YI_SYLLABLE_SSUT  0xA33C
#define Z_UNICODE_YI_SYLLABLE_SSUX  0xA33D
#define Z_UNICODE_YI_SYLLABLE_SSU   0xA33E
#define Z_UNICODE_YI_SYLLABLE_SSUP  0xA33F
#define Z_UNICODE_YI_SYLLABLE_SSYT  0xA340
#define Z_UNICODE_YI_SYLLABLE_SSYX  0xA341
#define Z_UNICODE_YI_SYLLABLE_SSY   0xA342
#define Z_UNICODE_YI_SYLLABLE_SSYP  0xA343
#define Z_UNICODE_YI_SYLLABLE_SSYRX 0xA344
#define Z_UNICODE_YI_SYLLABLE_SSYR  0xA345
#define Z_UNICODE_YI_SYLLABLE_ZHAT  0xA346
#define Z_UNICODE_YI_SYLLABLE_ZHAX  0xA347
#define Z_UNICODE_YI_SYLLABLE_ZHA   0xA348
#define Z_UNICODE_YI_SYLLABLE_ZHAP  0xA349
#define Z_UNICODE_YI_SYLLABLE_ZHUOX 0xA34A
#define Z_UNICODE_YI_SYLLABLE_ZHUO  0xA34B
#define Z_UNICODE_YI_SYLLABLE_ZHUOP 0xA34C
#define Z_UNICODE_YI_SYLLABLE_ZHOT  0xA34D
#define Z_UNICODE_YI_SYLLABLE_ZHOX  0xA34E
#define Z_UNICODE_YI_SYLLABLE_ZHO   0xA34F
#define Z_UNICODE_YI_SYLLABLE_ZHOP  0xA350
#define Z_UNICODE_YI_SYLLABLE_ZHET  0xA351
#define Z_UNICODE_YI_SYLLABLE_ZHEX  0xA352
#define Z_UNICODE_YI_SYLLABLE_ZHE   0xA353
#define Z_UNICODE_YI_SYLLABLE_ZHEP  0xA354
#define Z_UNICODE_YI_SYLLABLE_ZHUT  0xA355
#define Z_UNICODE_YI_SYLLABLE_ZHUX  0xA356
#define Z_UNICODE_YI_SYLLABLE_ZHU   0xA357
#define Z_UNICODE_YI_SYLLABLE_ZHUP  0xA358
#define Z_UNICODE_YI_SYLLABLE_ZHURX 0xA359
#define Z_UNICODE_YI_SYLLABLE_ZHUR  0xA35A
#define Z_UNICODE_YI_SYLLABLE_ZHYT  0xA35B
#define Z_UNICODE_YI_SYLLABLE_ZHYX  0xA35C
#define Z_UNICODE_YI_SYLLABLE_ZHY   0xA35D
#define Z_UNICODE_YI_SYLLABLE_ZHYP  0xA35E
#define Z_UNICODE_YI_SYLLABLE_ZHYRX 0xA35F
#define Z_UNICODE_YI_SYLLABLE_ZHYR  0xA360
#define Z_UNICODE_YI_SYLLABLE_CHAT  0xA361
#define Z_UNICODE_YI_SYLLABLE_CHAX  0xA362
#define Z_UNICODE_YI_SYLLABLE_CHA   0xA363
#define Z_UNICODE_YI_SYLLABLE_CHAP  0xA364
#define Z_UNICODE_YI_SYLLABLE_CHUOT 0xA365
#define Z_UNICODE_YI_SYLLABLE_CHUOX 0xA366
#define Z_UNICODE_YI_SYLLABLE_CHUO  0xA367
#define Z_UNICODE_YI_SYLLABLE_CHUOP 0xA368
#define Z_UNICODE_YI_SYLLABLE_CHOT  0xA369
#define Z_UNICODE_YI_SYLLABLE_CHOX  0xA36A
#define Z_UNICODE_YI_SYLLABLE_CHO   0xA36B
#define Z_UNICODE_YI_SYLLABLE_CHOP  0xA36C
#define Z_UNICODE_YI_SYLLABLE_CHET  0xA36D
#define Z_UNICODE_YI_SYLLABLE_CHEX  0xA36E
#define Z_UNICODE_YI_SYLLABLE_CHE   0xA36F
#define Z_UNICODE_YI_SYLLABLE_CHEP  0xA370
#define Z_UNICODE_YI_SYLLABLE_CHUX  0xA371
#define Z_UNICODE_YI_SYLLABLE_CHU   0xA372
#define Z_UNICODE_YI_SYLLABLE_CHUP  0xA373
#define Z_UNICODE_YI_SYLLABLE_CHURX 0xA374
#define Z_UNICODE_YI_SYLLABLE_CHUR  0xA375
#define Z_UNICODE_YI_SYLLABLE_CHYT  0xA376
#define Z_UNICODE_YI_SYLLABLE_CHYX  0xA377
#define Z_UNICODE_YI_SYLLABLE_CHY   0xA378
#define Z_UNICODE_YI_SYLLABLE_CHYP  0xA379
#define Z_UNICODE_YI_SYLLABLE_CHYRX 0xA37A
#define Z_UNICODE_YI_SYLLABLE_CHYR  0xA37B
#define Z_UNICODE_YI_SYLLABLE_RRAX  0xA37C
#define Z_UNICODE_YI_SYLLABLE_RRA   0xA37D
#define Z_UNICODE_YI_SYLLABLE_RRUOX 0xA37E
#define Z_UNICODE_YI_SYLLABLE_RRUO  0xA37F
#define Z_UNICODE_YI_SYLLABLE_RROT  0xA380
#define Z_UNICODE_YI_SYLLABLE_RROX  0xA381
#define Z_UNICODE_YI_SYLLABLE_RRO   0xA382
#define Z_UNICODE_YI_SYLLABLE_RROP  0xA383
#define Z_UNICODE_YI_SYLLABLE_RRET  0xA384
#define Z_UNICODE_YI_SYLLABLE_RREX  0xA385
#define Z_UNICODE_YI_SYLLABLE_RRE   0xA386
#define Z_UNICODE_YI_SYLLABLE_RREP  0xA387
#define Z_UNICODE_YI_SYLLABLE_RRUT  0xA388
#define Z_UNICODE_YI_SYLLABLE_RRUX  0xA389
#define Z_UNICODE_YI_SYLLABLE_RRU   0xA38A
#define Z_UNICODE_YI_SYLLABLE_RRUP  0xA38B
#define Z_UNICODE_YI_SYLLABLE_RRURX 0xA38C
#define Z_UNICODE_YI_SYLLABLE_RRUR  0xA38D
#define Z_UNICODE_YI_SYLLABLE_RRYT  0xA38E
#define Z_UNICODE_YI_SYLLABLE_RRYX  0xA38F
#define Z_UNICODE_YI_SYLLABLE_RRY   0xA390
#define Z_UNICODE_YI_SYLLABLE_RRYP  0xA391
#define Z_UNICODE_YI_SYLLABLE_RRYRX 0xA392
#define Z_UNICODE_YI_SYLLABLE_RRYR  0xA393
#define Z_UNICODE_YI_SYLLABLE_NRAT  0xA394
#define Z_UNICODE_YI_SYLLABLE_NRAX  0xA395
#define Z_UNICODE_YI_SYLLABLE_NRA   0xA396
#define Z_UNICODE_YI_SYLLABLE_NRAP  0xA397
#define Z_UNICODE_YI_SYLLABLE_NROX  0xA398
#define Z_UNICODE_YI_SYLLABLE_NRO   0xA399
#define Z_UNICODE_YI_SYLLABLE_NROP  0xA39A
#define Z_UNICODE_YI_SYLLABLE_NRET  0xA39B
#define Z_UNICODE_YI_SYLLABLE_NREX  0xA39C
#define Z_UNICODE_YI_SYLLABLE_NRE   0xA39D
#define Z_UNICODE_YI_SYLLABLE_NREP  0xA39E
#define Z_UNICODE_YI_SYLLABLE_NRUT  0xA39F
#define Z_UNICODE_YI_SYLLABLE_NRUX  0xA3A0
#define Z_UNICODE_YI_SYLLABLE_NRU   0xA3A1
#define Z_UNICODE_YI_SYLLABLE_NRUP  0xA3A2
#define Z_UNICODE_YI_SYLLABLE_NRURX 0xA3A3
#define Z_UNICODE_YI_SYLLABLE_NRUR  0xA3A4
#define Z_UNICODE_YI_SYLLABLE_NRYT  0xA3A5
#define Z_UNICODE_YI_SYLLABLE_NRYX  0xA3A6
#define Z_UNICODE_YI_SYLLABLE_NRY   0xA3A7
#define Z_UNICODE_YI_SYLLABLE_NRYP  0xA3A8
#define Z_UNICODE_YI_SYLLABLE_NRYRX 0xA3A9
#define Z_UNICODE_YI_SYLLABLE_NRYR  0xA3AA
#define Z_UNICODE_YI_SYLLABLE_SHAT  0xA3AB
#define Z_UNICODE_YI_SYLLABLE_SHAX  0xA3AC
#define Z_UNICODE_YI_SYLLABLE_SHA   0xA3AD
#define Z_UNICODE_YI_SYLLABLE_SHAP  0xA3AE
#define Z_UNICODE_YI_SYLLABLE_SHUOX 0xA3AF
#define Z_UNICODE_YI_SYLLABLE_SHUO  0xA3B0
#define Z_UNICODE_YI_SYLLABLE_SHUOP 0xA3B1
#define Z_UNICODE_YI_SYLLABLE_SHOT  0xA3B2
#define Z_UNICODE_YI_SYLLABLE_SHOX  0xA3B3
#define Z_UNICODE_YI_SYLLABLE_SHO   0xA3B4
#define Z_UNICODE_YI_SYLLABLE_SHOP  0xA3B5
#define Z_UNICODE_YI_SYLLABLE_SHET  0xA3B6
#define Z_UNICODE_YI_SYLLABLE_SHEX  0xA3B7
#define Z_UNICODE_YI_SYLLABLE_SHE   0xA3B8
#define Z_UNICODE_YI_SYLLABLE_SHEP  0xA3B9
#define Z_UNICODE_YI_SYLLABLE_SHUT  0xA3BA
#define Z_UNICODE_YI_SYLLABLE_SHUX  0xA3BB
#define Z_UNICODE_YI_SYLLABLE_SHU   0xA3BC
#define Z_UNICODE_YI_SYLLABLE_SHUP  0xA3BD
#define Z_UNICODE_YI_SYLLABLE_SHURX 0xA3BE
#define Z_UNICODE_YI_SYLLABLE_SHUR  0xA3BF
#define Z_UNICODE_YI_SYLLABLE_SHYT  0xA3C0
#define Z_UNICODE_YI_SYLLABLE_SHYX  0xA3C1
#define Z_UNICODE_YI_SYLLABLE_SHY   0xA3C2
#define Z_UNICODE_YI_SYLLABLE_SHYP  0xA3C3
#define Z_UNICODE_YI_SYLLABLE_SHYRX 0xA3C4
#define Z_UNICODE_YI_SYLLABLE_SHYR  0xA3C5
#define Z_UNICODE_YI_SYLLABLE_RAT   0xA3C6
#define Z_UNICODE_YI_SYLLABLE_RAX   0xA3C7
#define Z_UNICODE_YI_SYLLABLE_RA    0xA3C8
#define Z_UNICODE_YI_SYLLABLE_RAP   0xA3C9
#define Z_UNICODE_YI_SYLLABLE_RUOX  0xA3CA
#define Z_UNICODE_YI_SYLLABLE_RUO   0xA3CB
#define Z_UNICODE_YI_SYLLABLE_RUOP  0xA3CC
#define Z_UNICODE_YI_SYLLABLE_ROT   0xA3CD
#define Z_UNICODE_YI_SYLLABLE_ROX   0xA3CE
#define Z_UNICODE_YI_SYLLABLE_RO    0xA3CF
#define Z_UNICODE_YI_SYLLABLE_ROP   0xA3D0
#define Z_UNICODE_YI_SYLLABLE_REX   0xA3D1
#define Z_UNICODE_YI_SYLLABLE_RE    0xA3D2
#define Z_UNICODE_YI_SYLLABLE_REP   0xA3D3
#define Z_UNICODE_YI_SYLLABLE_RUT   0xA3D4
#define Z_UNICODE_YI_SYLLABLE_RUX   0xA3D5
#define Z_UNICODE_YI_SYLLABLE_RU    0xA3D6
#define Z_UNICODE_YI_SYLLABLE_RUP   0xA3D7
#define Z_UNICODE_YI_SYLLABLE_RURX  0xA3D8
#define Z_UNICODE_YI_SYLLABLE_RUR   0xA3D9
#define Z_UNICODE_YI_SYLLABLE_RYT   0xA3DA
#define Z_UNICODE_YI_SYLLABLE_RYX   0xA3DB
#define Z_UNICODE_YI_SYLLABLE_RY    0xA3DC
#define Z_UNICODE_YI_SYLLABLE_RYP   0xA3DD
#define Z_UNICODE_YI_SYLLABLE_RYRX  0xA3DE
#define Z_UNICODE_YI_SYLLABLE_RYR   0xA3DF
#define Z_UNICODE_YI_SYLLABLE_JIT   0xA3E0
#define Z_UNICODE_YI_SYLLABLE_JIX   0xA3E1
#define Z_UNICODE_YI_SYLLABLE_JI    0xA3E2
#define Z_UNICODE_YI_SYLLABLE_JIP   0xA3E3
#define Z_UNICODE_YI_SYLLABLE_JIET  0xA3E4
#define Z_UNICODE_YI_SYLLABLE_JIEX  0xA3E5
#define Z_UNICODE_YI_SYLLABLE_JIE   0xA3E6
#define Z_UNICODE_YI_SYLLABLE_JIEP  0xA3E7
#define Z_UNICODE_YI_SYLLABLE_JUOT  0xA3E8
#define Z_UNICODE_YI_SYLLABLE_JUOX  0xA3E9
#define Z_UNICODE_YI_SYLLABLE_JUO   0xA3EA
#define Z_UNICODE_YI_SYLLABLE_JUOP  0xA3EB
#define Z_UNICODE_YI_SYLLABLE_JOT   0xA3EC
#define Z_UNICODE_YI_SYLLABLE_JOX   0xA3ED
#define Z_UNICODE_YI_SYLLABLE_JO    0xA3EE
#define Z_UNICODE_YI_SYLLABLE_JOP   0xA3EF
#define Z_UNICODE_YI_SYLLABLE_JUT   0xA3F0
#define Z_UNICODE_YI_SYLLABLE_JUX   0xA3F1
#define Z_UNICODE_YI_SYLLABLE_JU    0xA3F2
#define Z_UNICODE_YI_SYLLABLE_JUP   0xA3F3
#define Z_UNICODE_YI_SYLLABLE_JURX  0xA3F4
#define Z_UNICODE_YI_SYLLABLE_JUR   0xA3F5
#define Z_UNICODE_YI_SYLLABLE_JYT   0xA3F6
#define Z_UNICODE_YI_SYLLABLE_JYX   0xA3F7
#define Z_UNICODE_YI_SYLLABLE_JY    0xA3F8
#define Z_UNICODE_YI_SYLLABLE_JYP   0xA3F9
#define Z_UNICODE_YI_SYLLABLE_JYRX  0xA3FA
#define Z_UNICODE_YI_SYLLABLE_JYR   0xA3FB
#define Z_UNICODE_YI_SYLLABLE_QIT   0xA3FC
#define Z_UNICODE_YI_SYLLABLE_QIX   0xA3FD
#define Z_UNICODE_YI_SYLLABLE_QI    0xA3FE
#define Z_UNICODE_YI_SYLLABLE_QIP   0xA3FF
#define Z_UNICODE_YI_SYLLABLE_QIET  0xA400
#define Z_UNICODE_YI_SYLLABLE_QIEX  0xA401
#define Z_UNICODE_YI_SYLLABLE_QIE   0xA402
#define Z_UNICODE_YI_SYLLABLE_QIEP  0xA403
#define Z_UNICODE_YI_SYLLABLE_QUOT  0xA404
#define Z_UNICODE_YI_SYLLABLE_QUOX  0xA405
#define Z_UNICODE_YI_SYLLABLE_QUO   0xA406
#define Z_UNICODE_YI_SYLLABLE_QUOP  0xA407
#define Z_UNICODE_YI_SYLLABLE_QOT   0xA408
#define Z_UNICODE_YI_SYLLABLE_QOX   0xA409
#define Z_UNICODE_YI_SYLLABLE_QO    0xA40A
#define Z_UNICODE_YI_SYLLABLE_QOP   0xA40B
#define Z_UNICODE_YI_SYLLABLE_QUT   0xA40C
#define Z_UNICODE_YI_SYLLABLE_QUX   0xA40D
#define Z_UNICODE_YI_SYLLABLE_QU    0xA40E
#define Z_UNICODE_YI_SYLLABLE_QUP   0xA40F
#define Z_UNICODE_YI_SYLLABLE_QURX  0xA410
#define Z_UNICODE_YI_SYLLABLE_QUR   0xA411
#define Z_UNICODE_YI_SYLLABLE_QYT   0xA412
#define Z_UNICODE_YI_SYLLABLE_QYX   0xA413
#define Z_UNICODE_YI_SYLLABLE_QY    0xA414
#define Z_UNICODE_YI_SYLLABLE_QYP   0xA415
#define Z_UNICODE_YI_SYLLABLE_QYRX  0xA416
#define Z_UNICODE_YI_SYLLABLE_QYR   0xA417
#define Z_UNICODE_YI_SYLLABLE_JJIT  0xA418
#define Z_UNICODE_YI_SYLLABLE_JJIX  0xA419
#define Z_UNICODE_YI_SYLLABLE_JJI   0xA41A
#define Z_UNICODE_YI_SYLLABLE_JJIP  0xA41B
#define Z_UNICODE_YI_SYLLABLE_JJIET 0xA41C
#define Z_UNICODE_YI_SYLLABLE_JJIEX 0xA41D
#define Z_UNICODE_YI_SYLLABLE_JJIE  0xA41E
#define Z_UNICODE_YI_SYLLABLE_JJIEP 0xA41F
#define Z_UNICODE_YI_SYLLABLE_JJUOX 0xA420
#define Z_UNICODE_YI_SYLLABLE_JJUO  0xA421
#define Z_UNICODE_YI_SYLLABLE_JJUOP 0xA422
#define Z_UNICODE_YI_SYLLABLE_JJOT  0xA423
#define Z_UNICODE_YI_SYLLABLE_JJOX  0xA424
#define Z_UNICODE_YI_SYLLABLE_JJO   0xA425
#define Z_UNICODE_YI_SYLLABLE_JJOP  0xA426
#define Z_UNICODE_YI_SYLLABLE_JJUT  0xA427
#define Z_UNICODE_YI_SYLLABLE_JJUX  0xA428
#define Z_UNICODE_YI_SYLLABLE_JJU   0xA429
#define Z_UNICODE_YI_SYLLABLE_JJUP  0xA42A
#define Z_UNICODE_YI_SYLLABLE_JJURX 0xA42B
#define Z_UNICODE_YI_SYLLABLE_JJUR  0xA42C
#define Z_UNICODE_YI_SYLLABLE_JJYT  0xA42D
#define Z_UNICODE_YI_SYLLABLE_JJYX  0xA42E
#define Z_UNICODE_YI_SYLLABLE_JJY   0xA42F
#define Z_UNICODE_YI_SYLLABLE_JJYP  0xA430
#define Z_UNICODE_YI_SYLLABLE_NJIT  0xA431
#define Z_UNICODE_YI_SYLLABLE_NJIX  0xA432
#define Z_UNICODE_YI_SYLLABLE_NJI   0xA433
#define Z_UNICODE_YI_SYLLABLE_NJIP  0xA434
#define Z_UNICODE_YI_SYLLABLE_NJIET 0xA435
#define Z_UNICODE_YI_SYLLABLE_NJIEX 0xA436
#define Z_UNICODE_YI_SYLLABLE_NJIE  0xA437
#define Z_UNICODE_YI_SYLLABLE_NJIEP 0xA438
#define Z_UNICODE_YI_SYLLABLE_NJUOX 0xA439
#define Z_UNICODE_YI_SYLLABLE_NJUO  0xA43A
#define Z_UNICODE_YI_SYLLABLE_NJOT  0xA43B
#define Z_UNICODE_YI_SYLLABLE_NJOX  0xA43C
#define Z_UNICODE_YI_SYLLABLE_NJO   0xA43D
#define Z_UNICODE_YI_SYLLABLE_NJOP  0xA43E
#define Z_UNICODE_YI_SYLLABLE_NJUX  0xA43F
#define Z_UNICODE_YI_SYLLABLE_NJU   0xA440
#define Z_UNICODE_YI_SYLLABLE_NJUP  0xA441
#define Z_UNICODE_YI_SYLLABLE_NJURX 0xA442
#define Z_UNICODE_YI_SYLLABLE_NJUR  0xA443
#define Z_UNICODE_YI_SYLLABLE_NJYT  0xA444
#define Z_UNICODE_YI_SYLLABLE_NJYX  0xA445
#define Z_UNICODE_YI_SYLLABLE_NJY   0xA446
#define Z_UNICODE_YI_SYLLABLE_NJYP  0xA447
#define Z_UNICODE_YI_SYLLABLE_NJYRX 0xA448
#define Z_UNICODE_YI_SYLLABLE_NJYR  0xA449
#define Z_UNICODE_YI_SYLLABLE_NYIT  0xA44A
#define Z_UNICODE_YI_SYLLABLE_NYIX  0xA44B
#define Z_UNICODE_YI_SYLLABLE_NYI   0xA44C
#define Z_UNICODE_YI_SYLLABLE_NYIP  0xA44D
#define Z_UNICODE_YI_SYLLABLE_NYIET 0xA44E
#define Z_UNICODE_YI_SYLLABLE_NYIEX 0xA44F
#define Z_UNICODE_YI_SYLLABLE_NYIE  0xA450
#define Z_UNICODE_YI_SYLLABLE_NYIEP 0xA451
#define Z_UNICODE_YI_SYLLABLE_NYUOX 0xA452
#define Z_UNICODE_YI_SYLLABLE_NYUO  0xA453
#define Z_UNICODE_YI_SYLLABLE_NYUOP 0xA454
#define Z_UNICODE_YI_SYLLABLE_NYOT  0xA455
#define Z_UNICODE_YI_SYLLABLE_NYOX  0xA456
#define Z_UNICODE_YI_SYLLABLE_NYO   0xA457
#define Z_UNICODE_YI_SYLLABLE_NYOP  0xA458
#define Z_UNICODE_YI_SYLLABLE_NYUT  0xA459
#define Z_UNICODE_YI_SYLLABLE_NYUX  0xA45A
#define Z_UNICODE_YI_SYLLABLE_NYU   0xA45B
#define Z_UNICODE_YI_SYLLABLE_NYUP  0xA45C
#define Z_UNICODE_YI_SYLLABLE_XIT   0xA45D
#define Z_UNICODE_YI_SYLLABLE_XIX   0xA45E
#define Z_UNICODE_YI_SYLLABLE_XI    0xA45F
#define Z_UNICODE_YI_SYLLABLE_XIP   0xA460
#define Z_UNICODE_YI_SYLLABLE_XIET  0xA461
#define Z_UNICODE_YI_SYLLABLE_XIEX  0xA462
#define Z_UNICODE_YI_SYLLABLE_XIE   0xA463
#define Z_UNICODE_YI_SYLLABLE_XIEP  0xA464
#define Z_UNICODE_YI_SYLLABLE_XUOX  0xA465
#define Z_UNICODE_YI_SYLLABLE_XUO   0xA466
#define Z_UNICODE_YI_SYLLABLE_XOT   0xA467
#define Z_UNICODE_YI_SYLLABLE_XOX   0xA468
#define Z_UNICODE_YI_SYLLABLE_XO    0xA469
#define Z_UNICODE_YI_SYLLABLE_XOP   0xA46A
#define Z_UNICODE_YI_SYLLABLE_XYT   0xA46B
#define Z_UNICODE_YI_SYLLABLE_XYX   0xA46C
#define Z_UNICODE_YI_SYLLABLE_XY    0xA46D
#define Z_UNICODE_YI_SYLLABLE_XYP   0xA46E
#define Z_UNICODE_YI_SYLLABLE_XYRX  0xA46F
#define Z_UNICODE_YI_SYLLABLE_XYR   0xA470
#define Z_UNICODE_YI_SYLLABLE_YIT   0xA471
#define Z_UNICODE_YI_SYLLABLE_YIX   0xA472
#define Z_UNICODE_YI_SYLLABLE_YI    0xA473
#define Z_UNICODE_YI_SYLLABLE_YIP   0xA474
#define Z_UNICODE_YI_SYLLABLE_YIET  0xA475
#define Z_UNICODE_YI_SYLLABLE_YIEX  0xA476
#define Z_UNICODE_YI_SYLLABLE_YIE   0xA477
#define Z_UNICODE_YI_SYLLABLE_YIEP  0xA478
#define Z_UNICODE_YI_SYLLABLE_YUOT  0xA479
#define Z_UNICODE_YI_SYLLABLE_YUOX  0xA47A
#define Z_UNICODE_YI_SYLLABLE_YUO   0xA47B
#define Z_UNICODE_YI_SYLLABLE_YUOP  0xA47C
#define Z_UNICODE_YI_SYLLABLE_YOT   0xA47D
#define Z_UNICODE_YI_SYLLABLE_YOX   0xA47E
#define Z_UNICODE_YI_SYLLABLE_YO    0xA47F
#define Z_UNICODE_YI_SYLLABLE_YOP   0xA480
#define Z_UNICODE_YI_SYLLABLE_YUT   0xA481
#define Z_UNICODE_YI_SYLLABLE_YUX   0xA482
#define Z_UNICODE_YI_SYLLABLE_YU    0xA483
#define Z_UNICODE_YI_SYLLABLE_YUP   0xA484
#define Z_UNICODE_YI_SYLLABLE_YURX  0xA485
#define Z_UNICODE_YI_SYLLABLE_YUR   0xA486
#define Z_UNICODE_YI_SYLLABLE_YYT   0xA487
#define Z_UNICODE_YI_SYLLABLE_YYX   0xA488
#define Z_UNICODE_YI_SYLLABLE_YY    0xA489
#define Z_UNICODE_YI_SYLLABLE_YYP   0xA48A
#define Z_UNICODE_YI_SYLLABLE_YYRX  0xA48B
#define Z_UNICODE_YI_SYLLABLE_YYR   0xA48C

/* MARK: - A490h-A4CFh - Yi Radicals */

#define Z_UNICODE_YI_RADICAL_QOT   0xA490
#define Z_UNICODE_YI_RADICAL_LI	   0xA491
#define Z_UNICODE_YI_RADICAL_KIT   0xA492
#define Z_UNICODE_YI_RADICAL_NYIP  0xA493
#define Z_UNICODE_YI_RADICAL_CYP   0xA494
#define Z_UNICODE_YI_RADICAL_SSI   0xA495
#define Z_UNICODE_YI_RADICAL_GGOP  0xA496
#define Z_UNICODE_YI_RADICAL_GEP   0xA497
#define Z_UNICODE_YI_RADICAL_MI	   0xA498
#define Z_UNICODE_YI_RADICAL_HXIT  0xA499
#define Z_UNICODE_YI_RADICAL_LYR   0xA49A
#define Z_UNICODE_YI_RADICAL_BBUT  0xA49B
#define Z_UNICODE_YI_RADICAL_MOP   0xA49C
#define Z_UNICODE_YI_RADICAL_YO	   0xA49D
#define Z_UNICODE_YI_RADICAL_PUT   0xA49E
#define Z_UNICODE_YI_RADICAL_HXUO  0xA49F
#define Z_UNICODE_YI_RADICAL_TAT   0xA4A0
#define Z_UNICODE_YI_RADICAL_GA	   0xA4A1
#define Z_UNICODE_YI_RADICAL_ZUP   0xA4A2
#define Z_UNICODE_YI_RADICAL_CYT   0xA4A3
#define Z_UNICODE_YI_RADICAL_DDUR  0xA4A4
#define Z_UNICODE_YI_RADICAL_BUR   0xA4A5
#define Z_UNICODE_YI_RADICAL_GGUO  0xA4A6
#define Z_UNICODE_YI_RADICAL_NYOP  0xA4A7
#define Z_UNICODE_YI_RADICAL_TU	   0xA4A8
#define Z_UNICODE_YI_RADICAL_OP	   0xA4A9
#define Z_UNICODE_YI_RADICAL_JJUT  0xA4AA
#define Z_UNICODE_YI_RADICAL_ZOT   0xA4AB
#define Z_UNICODE_YI_RADICAL_PYT   0xA4AC
#define Z_UNICODE_YI_RADICAL_HMO   0xA4AD
#define Z_UNICODE_YI_RADICAL_YIT   0xA4AE
#define Z_UNICODE_YI_RADICAL_VUR   0xA4AF
#define Z_UNICODE_YI_RADICAL_SHY   0xA4B0
#define Z_UNICODE_YI_RADICAL_VEP   0xA4B1
#define Z_UNICODE_YI_RADICAL_ZA	   0xA4B2
#define Z_UNICODE_YI_RADICAL_JO	   0xA4B3
#define Z_UNICODE_YI_RADICAL_NZUP  0xA4B4
#define Z_UNICODE_YI_RADICAL_JJY   0xA4B5
#define Z_UNICODE_YI_RADICAL_GOT   0xA4B6
#define Z_UNICODE_YI_RADICAL_JJIE  0xA4B7
#define Z_UNICODE_YI_RADICAL_WO	   0xA4B8
#define Z_UNICODE_YI_RADICAL_DU	   0xA4B9
#define Z_UNICODE_YI_RADICAL_SHUR  0xA4BA
#define Z_UNICODE_YI_RADICAL_LIE   0xA4BB
#define Z_UNICODE_YI_RADICAL_CY	   0xA4BC
#define Z_UNICODE_YI_RADICAL_CUOP  0xA4BD
#define Z_UNICODE_YI_RADICAL_CIP   0xA4BE
#define Z_UNICODE_YI_RADICAL_HXOP  0xA4BF
#define Z_UNICODE_YI_RADICAL_SHAT  0xA4C0
#define Z_UNICODE_YI_RADICAL_ZUR   0xA4C1
#define Z_UNICODE_YI_RADICAL_SHOP  0xA4C2
#define Z_UNICODE_YI_RADICAL_CHE   0xA4C3
#define Z_UNICODE_YI_RADICAL_ZZIET 0xA4C4
#define Z_UNICODE_YI_RADICAL_NBIE  0xA4C5
#define Z_UNICODE_YI_RADICAL_KE	   0xA4C6

/* MARK: - A4D0h-A4FFh - Lisu */

#define Z_UNICODE_LISU_LETTER_BA	     0xA4D0
#define Z_UNICODE_LISU_LETTER_PA	     0xA4D1
#define Z_UNICODE_LISU_LETTER_PHA	     0xA4D2
#define Z_UNICODE_LISU_LETTER_DA	     0xA4D3
#define Z_UNICODE_LISU_LETTER_TA	     0xA4D4
#define Z_UNICODE_LISU_LETTER_THA	     0xA4D5
#define Z_UNICODE_LISU_LETTER_GA	     0xA4D6
#define Z_UNICODE_LISU_LETTER_KA	     0xA4D7
#define Z_UNICODE_LISU_LETTER_KHA	     0xA4D8
#define Z_UNICODE_LISU_LETTER_JA	     0xA4D9
#define Z_UNICODE_LISU_LETTER_CA	     0xA4DA
#define Z_UNICODE_LISU_LETTER_CHA	     0xA4DB
#define Z_UNICODE_LISU_LETTER_DZA	     0xA4DC
#define Z_UNICODE_LISU_LETTER_TSA	     0xA4DD
#define Z_UNICODE_LISU_LETTER_TSHA	     0xA4DE
#define Z_UNICODE_LISU_LETTER_MA	     0xA4DF
#define Z_UNICODE_LISU_LETTER_NA	     0xA4E0
#define Z_UNICODE_LISU_LETTER_LA	     0xA4E1
#define Z_UNICODE_LISU_LETTER_SA	     0xA4E2
#define Z_UNICODE_LISU_LETTER_ZHA	     0xA4E3
#define Z_UNICODE_LISU_LETTER_ZA	     0xA4E4
#define Z_UNICODE_LISU_LETTER_NGA	     0xA4E5
#define Z_UNICODE_LISU_LETTER_HA	     0xA4E6
#define Z_UNICODE_LISU_LETTER_XA	     0xA4E7
#define Z_UNICODE_LISU_LETTER_HHA	     0xA4E8
#define Z_UNICODE_LISU_LETTER_FA	     0xA4E9
#define Z_UNICODE_LISU_LETTER_WA	     0xA4EA
#define Z_UNICODE_LISU_LETTER_SHA	     0xA4EB
#define Z_UNICODE_LISU_LETTER_YA	     0xA4EC
#define Z_UNICODE_LISU_LETTER_GHA	     0xA4ED
#define Z_UNICODE_LISU_LETTER_A		     0xA4EE
#define Z_UNICODE_LISU_LETTER_AE	     0xA4EF
#define Z_UNICODE_LISU_LETTER_E		     0xA4F0
#define Z_UNICODE_LISU_LETTER_EU	     0xA4F1
#define Z_UNICODE_LISU_LETTER_I		     0xA4F2
#define Z_UNICODE_LISU_LETTER_O		     0xA4F3
#define Z_UNICODE_LISU_LETTER_U		     0xA4F4
#define Z_UNICODE_LISU_LETTER_UE	     0xA4F5
#define Z_UNICODE_LISU_LETTER_UH	     0xA4F6
#define Z_UNICODE_LISU_LETTER_OE	     0xA4F7
#define Z_UNICODE_LISU_LETTER_TONE_MYA_TI    0xA4F8
#define Z_UNICODE_LISU_LETTER_TONE_NA_PO     0xA4F9
#define Z_UNICODE_LISU_LETTER_TONE_MYA_CYA   0xA4FA
#define Z_UNICODE_LISU_LETTER_TONE_MYA_BO    0xA4FB
#define Z_UNICODE_LISU_LETTER_TONE_MYA_NA    0xA4FC
#define Z_UNICODE_LISU_LETTER_TONE_MYA_JEU   0xA4FD
#define Z_UNICODE_LISU_PUNCTUATION_COMMA     0xA4FE
#define Z_UNICODE_LISU_PUNCTUATION_FULL_STOP 0xA4FF

/* MARK: - A500h-A63Fh - Vai */

#define Z_UNICODE_VAI_SYLLABLE_EE	  0xA500
#define Z_UNICODE_VAI_SYLLABLE_EEN	  0xA501
#define Z_UNICODE_VAI_SYLLABLE_HEE	  0xA502
#define Z_UNICODE_VAI_SYLLABLE_WEE	  0xA503
#define Z_UNICODE_VAI_SYLLABLE_WEEN	  0xA504
#define Z_UNICODE_VAI_SYLLABLE_PEE	  0xA505
#define Z_UNICODE_VAI_SYLLABLE_BHEE	  0xA506
#define Z_UNICODE_VAI_SYLLABLE_BEE	  0xA507
#define Z_UNICODE_VAI_SYLLABLE_MBEE	  0xA508
#define Z_UNICODE_VAI_SYLLABLE_KPEE	  0xA509
#define Z_UNICODE_VAI_SYLLABLE_MGBEE	  0xA50A
#define Z_UNICODE_VAI_SYLLABLE_GBEE	  0xA50B
#define Z_UNICODE_VAI_SYLLABLE_FEE	  0xA50C
#define Z_UNICODE_VAI_SYLLABLE_VEE	  0xA50D
#define Z_UNICODE_VAI_SYLLABLE_TEE	  0xA50E
#define Z_UNICODE_VAI_SYLLABLE_THEE	  0xA50F
#define Z_UNICODE_VAI_SYLLABLE_DHEE	  0xA510
#define Z_UNICODE_VAI_SYLLABLE_DHHEE	  0xA511
#define Z_UNICODE_VAI_SYLLABLE_LEE	  0xA512
#define Z_UNICODE_VAI_SYLLABLE_REE	  0xA513
#define Z_UNICODE_VAI_SYLLABLE_DEE	  0xA514
#define Z_UNICODE_VAI_SYLLABLE_NDEE	  0xA515
#define Z_UNICODE_VAI_SYLLABLE_SEE	  0xA516
#define Z_UNICODE_VAI_SYLLABLE_SHEE	  0xA517
#define Z_UNICODE_VAI_SYLLABLE_ZEE	  0xA518
#define Z_UNICODE_VAI_SYLLABLE_ZHEE	  0xA519
#define Z_UNICODE_VAI_SYLLABLE_CEE	  0xA51A
#define Z_UNICODE_VAI_SYLLABLE_JEE	  0xA51B
#define Z_UNICODE_VAI_SYLLABLE_NJEE	  0xA51C
#define Z_UNICODE_VAI_SYLLABLE_YEE	  0xA51D
#define Z_UNICODE_VAI_SYLLABLE_KEE	  0xA51E
#define Z_UNICODE_VAI_SYLLABLE_NGGEE	  0xA51F
#define Z_UNICODE_VAI_SYLLABLE_GEE	  0xA520
#define Z_UNICODE_VAI_SYLLABLE_MEE	  0xA521
#define Z_UNICODE_VAI_SYLLABLE_NEE	  0xA522
#define Z_UNICODE_VAI_SYLLABLE_NYEE	  0xA523
#define Z_UNICODE_VAI_SYLLABLE_I	  0xA524
#define Z_UNICODE_VAI_SYLLABLE_IN	  0xA525
#define Z_UNICODE_VAI_SYLLABLE_HI	  0xA526
#define Z_UNICODE_VAI_SYLLABLE_HIN	  0xA527
#define Z_UNICODE_VAI_SYLLABLE_WI	  0xA528
#define Z_UNICODE_VAI_SYLLABLE_WIN	  0xA529
#define Z_UNICODE_VAI_SYLLABLE_PI	  0xA52A
#define Z_UNICODE_VAI_SYLLABLE_BHI	  0xA52B
#define Z_UNICODE_VAI_SYLLABLE_BI	  0xA52C
#define Z_UNICODE_VAI_SYLLABLE_MBI	  0xA52D
#define Z_UNICODE_VAI_SYLLABLE_KPI	  0xA52E
#define Z_UNICODE_VAI_SYLLABLE_MGBI	  0xA52F
#define Z_UNICODE_VAI_SYLLABLE_GBI	  0xA530
#define Z_UNICODE_VAI_SYLLABLE_FI	  0xA531
#define Z_UNICODE_VAI_SYLLABLE_VI	  0xA532
#define Z_UNICODE_VAI_SYLLABLE_TI	  0xA533
#define Z_UNICODE_VAI_SYLLABLE_THI	  0xA534
#define Z_UNICODE_VAI_SYLLABLE_DHI	  0xA535
#define Z_UNICODE_VAI_SYLLABLE_DHHI	  0xA536
#define Z_UNICODE_VAI_SYLLABLE_LI	  0xA537
#define Z_UNICODE_VAI_SYLLABLE_RI	  0xA538
#define Z_UNICODE_VAI_SYLLABLE_DI	  0xA539
#define Z_UNICODE_VAI_SYLLABLE_NDI	  0xA53A
#define Z_UNICODE_VAI_SYLLABLE_SI	  0xA53B
#define Z_UNICODE_VAI_SYLLABLE_SHI	  0xA53C
#define Z_UNICODE_VAI_SYLLABLE_ZI	  0xA53D
#define Z_UNICODE_VAI_SYLLABLE_ZHI	  0xA53E
#define Z_UNICODE_VAI_SYLLABLE_CI	  0xA53F
#define Z_UNICODE_VAI_SYLLABLE_JI	  0xA540
#define Z_UNICODE_VAI_SYLLABLE_NJI	  0xA541
#define Z_UNICODE_VAI_SYLLABLE_YI	  0xA542
#define Z_UNICODE_VAI_SYLLABLE_KI	  0xA543
#define Z_UNICODE_VAI_SYLLABLE_NGGI	  0xA544
#define Z_UNICODE_VAI_SYLLABLE_GI	  0xA545
#define Z_UNICODE_VAI_SYLLABLE_MI	  0xA546
#define Z_UNICODE_VAI_SYLLABLE_NI	  0xA547
#define Z_UNICODE_VAI_SYLLABLE_NYI	  0xA548
#define Z_UNICODE_VAI_SYLLABLE_A	  0xA549
#define Z_UNICODE_VAI_SYLLABLE_AN	  0xA54A
#define Z_UNICODE_VAI_SYLLABLE_NGAN	  0xA54B
#define Z_UNICODE_VAI_SYLLABLE_HA	  0xA54C
#define Z_UNICODE_VAI_SYLLABLE_HAN	  0xA54D
#define Z_UNICODE_VAI_SYLLABLE_WA	  0xA54E
#define Z_UNICODE_VAI_SYLLABLE_WAN	  0xA54F
#define Z_UNICODE_VAI_SYLLABLE_PA	  0xA550
#define Z_UNICODE_VAI_SYLLABLE_BHA	  0xA551
#define Z_UNICODE_VAI_SYLLABLE_BA	  0xA552
#define Z_UNICODE_VAI_SYLLABLE_MBA	  0xA553
#define Z_UNICODE_VAI_SYLLABLE_KPA	  0xA554
#define Z_UNICODE_VAI_SYLLABLE_KPAN	  0xA555
#define Z_UNICODE_VAI_SYLLABLE_MGBA	  0xA556
#define Z_UNICODE_VAI_SYLLABLE_GBA	  0xA557
#define Z_UNICODE_VAI_SYLLABLE_FA	  0xA558
#define Z_UNICODE_VAI_SYLLABLE_VA	  0xA559
#define Z_UNICODE_VAI_SYLLABLE_TA	  0xA55A
#define Z_UNICODE_VAI_SYLLABLE_THA	  0xA55B
#define Z_UNICODE_VAI_SYLLABLE_DHA	  0xA55C
#define Z_UNICODE_VAI_SYLLABLE_DHHA	  0xA55D
#define Z_UNICODE_VAI_SYLLABLE_LA	  0xA55E
#define Z_UNICODE_VAI_SYLLABLE_RA	  0xA55F
#define Z_UNICODE_VAI_SYLLABLE_DA	  0xA560
#define Z_UNICODE_VAI_SYLLABLE_NDA	  0xA561
#define Z_UNICODE_VAI_SYLLABLE_SA	  0xA562
#define Z_UNICODE_VAI_SYLLABLE_SHA	  0xA563
#define Z_UNICODE_VAI_SYLLABLE_ZA	  0xA564
#define Z_UNICODE_VAI_SYLLABLE_ZHA	  0xA565
#define Z_UNICODE_VAI_SYLLABLE_CA	  0xA566
#define Z_UNICODE_VAI_SYLLABLE_JA	  0xA567
#define Z_UNICODE_VAI_SYLLABLE_NJA	  0xA568
#define Z_UNICODE_VAI_SYLLABLE_YA	  0xA569
#define Z_UNICODE_VAI_SYLLABLE_KA	  0xA56A
#define Z_UNICODE_VAI_SYLLABLE_KAN	  0xA56B
#define Z_UNICODE_VAI_SYLLABLE_NGGA	  0xA56C
#define Z_UNICODE_VAI_SYLLABLE_GA	  0xA56D
#define Z_UNICODE_VAI_SYLLABLE_MA	  0xA56E
#define Z_UNICODE_VAI_SYLLABLE_NA	  0xA56F
#define Z_UNICODE_VAI_SYLLABLE_NYA	  0xA570
#define Z_UNICODE_VAI_SYLLABLE_OO	  0xA571
#define Z_UNICODE_VAI_SYLLABLE_OON	  0xA572
#define Z_UNICODE_VAI_SYLLABLE_HOO	  0xA573
#define Z_UNICODE_VAI_SYLLABLE_WOO	  0xA574
#define Z_UNICODE_VAI_SYLLABLE_WOON	  0xA575
#define Z_UNICODE_VAI_SYLLABLE_POO	  0xA576
#define Z_UNICODE_VAI_SYLLABLE_BHOO	  0xA577
#define Z_UNICODE_VAI_SYLLABLE_BOO	  0xA578
#define Z_UNICODE_VAI_SYLLABLE_MBOO	  0xA579
#define Z_UNICODE_VAI_SYLLABLE_KPOO	  0xA57A
#define Z_UNICODE_VAI_SYLLABLE_MGBOO	  0xA57B
#define Z_UNICODE_VAI_SYLLABLE_GBOO	  0xA57C
#define Z_UNICODE_VAI_SYLLABLE_FOO	  0xA57D
#define Z_UNICODE_VAI_SYLLABLE_VOO	  0xA57E
#define Z_UNICODE_VAI_SYLLABLE_TOO	  0xA57F
#define Z_UNICODE_VAI_SYLLABLE_THOO	  0xA580
#define Z_UNICODE_VAI_SYLLABLE_DHOO	  0xA581
#define Z_UNICODE_VAI_SYLLABLE_DHHOO	  0xA582
#define Z_UNICODE_VAI_SYLLABLE_LOO	  0xA583
#define Z_UNICODE_VAI_SYLLABLE_ROO	  0xA584
#define Z_UNICODE_VAI_SYLLABLE_DOO	  0xA585
#define Z_UNICODE_VAI_SYLLABLE_NDOO	  0xA586
#define Z_UNICODE_VAI_SYLLABLE_SOO	  0xA587
#define Z_UNICODE_VAI_SYLLABLE_SHOO	  0xA588
#define Z_UNICODE_VAI_SYLLABLE_ZOO	  0xA589
#define Z_UNICODE_VAI_SYLLABLE_ZHOO	  0xA58A
#define Z_UNICODE_VAI_SYLLABLE_COO	  0xA58B
#define Z_UNICODE_VAI_SYLLABLE_JOO	  0xA58C
#define Z_UNICODE_VAI_SYLLABLE_NJOO	  0xA58D
#define Z_UNICODE_VAI_SYLLABLE_YOO	  0xA58E
#define Z_UNICODE_VAI_SYLLABLE_KOO	  0xA58F
#define Z_UNICODE_VAI_SYLLABLE_NGGOO	  0xA590
#define Z_UNICODE_VAI_SYLLABLE_GOO	  0xA591
#define Z_UNICODE_VAI_SYLLABLE_MOO	  0xA592
#define Z_UNICODE_VAI_SYLLABLE_NOO	  0xA593
#define Z_UNICODE_VAI_SYLLABLE_NYOO	  0xA594
#define Z_UNICODE_VAI_SYLLABLE_U	  0xA595
#define Z_UNICODE_VAI_SYLLABLE_UN	  0xA596
#define Z_UNICODE_VAI_SYLLABLE_HU	  0xA597
#define Z_UNICODE_VAI_SYLLABLE_HUN	  0xA598
#define Z_UNICODE_VAI_SYLLABLE_WU	  0xA599
#define Z_UNICODE_VAI_SYLLABLE_WUN	  0xA59A
#define Z_UNICODE_VAI_SYLLABLE_PU	  0xA59B
#define Z_UNICODE_VAI_SYLLABLE_BHU	  0xA59C
#define Z_UNICODE_VAI_SYLLABLE_BU	  0xA59D
#define Z_UNICODE_VAI_SYLLABLE_MBU	  0xA59E
#define Z_UNICODE_VAI_SYLLABLE_KPU	  0xA59F
#define Z_UNICODE_VAI_SYLLABLE_MGBU	  0xA5A0
#define Z_UNICODE_VAI_SYLLABLE_GBU	  0xA5A1
#define Z_UNICODE_VAI_SYLLABLE_FU	  0xA5A2
#define Z_UNICODE_VAI_SYLLABLE_VU	  0xA5A3
#define Z_UNICODE_VAI_SYLLABLE_TU	  0xA5A4
#define Z_UNICODE_VAI_SYLLABLE_THU	  0xA5A5
#define Z_UNICODE_VAI_SYLLABLE_DHU	  0xA5A6
#define Z_UNICODE_VAI_SYLLABLE_DHHU	  0xA5A7
#define Z_UNICODE_VAI_SYLLABLE_LU	  0xA5A8
#define Z_UNICODE_VAI_SYLLABLE_RU	  0xA5A9
#define Z_UNICODE_VAI_SYLLABLE_DU	  0xA5AA
#define Z_UNICODE_VAI_SYLLABLE_NDU	  0xA5AB
#define Z_UNICODE_VAI_SYLLABLE_SU	  0xA5AC
#define Z_UNICODE_VAI_SYLLABLE_SHU	  0xA5AD
#define Z_UNICODE_VAI_SYLLABLE_ZU	  0xA5AE
#define Z_UNICODE_VAI_SYLLABLE_ZHU	  0xA5AF
#define Z_UNICODE_VAI_SYLLABLE_CU	  0xA5B0
#define Z_UNICODE_VAI_SYLLABLE_JU	  0xA5B1
#define Z_UNICODE_VAI_SYLLABLE_NJU	  0xA5B2
#define Z_UNICODE_VAI_SYLLABLE_YU	  0xA5B3
#define Z_UNICODE_VAI_SYLLABLE_KU	  0xA5B4
#define Z_UNICODE_VAI_SYLLABLE_NGGU	  0xA5B5
#define Z_UNICODE_VAI_SYLLABLE_GU	  0xA5B6
#define Z_UNICODE_VAI_SYLLABLE_MU	  0xA5B7
#define Z_UNICODE_VAI_SYLLABLE_NU	  0xA5B8
#define Z_UNICODE_VAI_SYLLABLE_NYU	  0xA5B9
#define Z_UNICODE_VAI_SYLLABLE_O	  0xA5BA
#define Z_UNICODE_VAI_SYLLABLE_ON	  0xA5BB
#define Z_UNICODE_VAI_SYLLABLE_NGON	  0xA5BC
#define Z_UNICODE_VAI_SYLLABLE_HO	  0xA5BD
#define Z_UNICODE_VAI_SYLLABLE_HON	  0xA5BE
#define Z_UNICODE_VAI_SYLLABLE_WO	  0xA5BF
#define Z_UNICODE_VAI_SYLLABLE_WON	  0xA5C0
#define Z_UNICODE_VAI_SYLLABLE_PO	  0xA5C1
#define Z_UNICODE_VAI_SYLLABLE_BHO	  0xA5C2
#define Z_UNICODE_VAI_SYLLABLE_BO	  0xA5C3
#define Z_UNICODE_VAI_SYLLABLE_MBO	  0xA5C4
#define Z_UNICODE_VAI_SYLLABLE_KPO	  0xA5C5
#define Z_UNICODE_VAI_SYLLABLE_MGBO	  0xA5C6
#define Z_UNICODE_VAI_SYLLABLE_GBO	  0xA5C7
#define Z_UNICODE_VAI_SYLLABLE_GBON	  0xA5C8
#define Z_UNICODE_VAI_SYLLABLE_FO	  0xA5C9
#define Z_UNICODE_VAI_SYLLABLE_VO	  0xA5CA
#define Z_UNICODE_VAI_SYLLABLE_TO	  0xA5CB
#define Z_UNICODE_VAI_SYLLABLE_THO	  0xA5CC
#define Z_UNICODE_VAI_SYLLABLE_DHO	  0xA5CD
#define Z_UNICODE_VAI_SYLLABLE_DHHO	  0xA5CE
#define Z_UNICODE_VAI_SYLLABLE_LO	  0xA5CF
#define Z_UNICODE_VAI_SYLLABLE_RO	  0xA5D0
#define Z_UNICODE_VAI_SYLLABLE_DO	  0xA5D1
#define Z_UNICODE_VAI_SYLLABLE_NDO	  0xA5D2
#define Z_UNICODE_VAI_SYLLABLE_SO	  0xA5D3
#define Z_UNICODE_VAI_SYLLABLE_SHO	  0xA5D4
#define Z_UNICODE_VAI_SYLLABLE_ZO	  0xA5D5
#define Z_UNICODE_VAI_SYLLABLE_ZHO	  0xA5D6
#define Z_UNICODE_VAI_SYLLABLE_CO	  0xA5D7
#define Z_UNICODE_VAI_SYLLABLE_JO	  0xA5D8
#define Z_UNICODE_VAI_SYLLABLE_NJO	  0xA5D9
#define Z_UNICODE_VAI_SYLLABLE_YO	  0xA5DA
#define Z_UNICODE_VAI_SYLLABLE_KO	  0xA5DB
#define Z_UNICODE_VAI_SYLLABLE_NGGO	  0xA5DC
#define Z_UNICODE_VAI_SYLLABLE_GO	  0xA5DD
#define Z_UNICODE_VAI_SYLLABLE_MO	  0xA5DE
#define Z_UNICODE_VAI_SYLLABLE_NO	  0xA5DF
#define Z_UNICODE_VAI_SYLLABLE_NYO	  0xA5E0
#define Z_UNICODE_VAI_SYLLABLE_E	  0xA5E1
#define Z_UNICODE_VAI_SYLLABLE_EN	  0xA5E2
#define Z_UNICODE_VAI_SYLLABLE_NGEN	  0xA5E3
#define Z_UNICODE_VAI_SYLLABLE_HE	  0xA5E4
#define Z_UNICODE_VAI_SYLLABLE_HEN	  0xA5E5
#define Z_UNICODE_VAI_SYLLABLE_WE	  0xA5E6
#define Z_UNICODE_VAI_SYLLABLE_WEN	  0xA5E7
#define Z_UNICODE_VAI_SYLLABLE_PE	  0xA5E8
#define Z_UNICODE_VAI_SYLLABLE_BHE	  0xA5E9
#define Z_UNICODE_VAI_SYLLABLE_BE	  0xA5EA
#define Z_UNICODE_VAI_SYLLABLE_MBE	  0xA5EB
#define Z_UNICODE_VAI_SYLLABLE_KPE	  0xA5EC
#define Z_UNICODE_VAI_SYLLABLE_KPEN	  0xA5ED
#define Z_UNICODE_VAI_SYLLABLE_MGBE	  0xA5EE
#define Z_UNICODE_VAI_SYLLABLE_GBE	  0xA5EF
#define Z_UNICODE_VAI_SYLLABLE_GBEN	  0xA5F0
#define Z_UNICODE_VAI_SYLLABLE_FE	  0xA5F1
#define Z_UNICODE_VAI_SYLLABLE_VE	  0xA5F2
#define Z_UNICODE_VAI_SYLLABLE_TE	  0xA5F3
#define Z_UNICODE_VAI_SYLLABLE_THE	  0xA5F4
#define Z_UNICODE_VAI_SYLLABLE_DHE	  0xA5F5
#define Z_UNICODE_VAI_SYLLABLE_DHHE	  0xA5F6
#define Z_UNICODE_VAI_SYLLABLE_LE	  0xA5F7
#define Z_UNICODE_VAI_SYLLABLE_RE	  0xA5F8
#define Z_UNICODE_VAI_SYLLABLE_DE	  0xA5F9
#define Z_UNICODE_VAI_SYLLABLE_NDE	  0xA5FA
#define Z_UNICODE_VAI_SYLLABLE_SE	  0xA5FB
#define Z_UNICODE_VAI_SYLLABLE_SHE	  0xA5FC
#define Z_UNICODE_VAI_SYLLABLE_ZE	  0xA5FD
#define Z_UNICODE_VAI_SYLLABLE_ZHE	  0xA5FE
#define Z_UNICODE_VAI_SYLLABLE_CE	  0xA5FF
#define Z_UNICODE_VAI_SYLLABLE_JE	  0xA600
#define Z_UNICODE_VAI_SYLLABLE_NJE	  0xA601
#define Z_UNICODE_VAI_SYLLABLE_YE	  0xA602
#define Z_UNICODE_VAI_SYLLABLE_KE	  0xA603
#define Z_UNICODE_VAI_SYLLABLE_NGGE	  0xA604
#define Z_UNICODE_VAI_SYLLABLE_NGGEN	  0xA605
#define Z_UNICODE_VAI_SYLLABLE_GE	  0xA606
#define Z_UNICODE_VAI_SYLLABLE_GEN	  0xA607
#define Z_UNICODE_VAI_SYLLABLE_ME	  0xA608
#define Z_UNICODE_VAI_SYLLABLE_NE	  0xA609
#define Z_UNICODE_VAI_SYLLABLE_NYE	  0xA60A
#define Z_UNICODE_VAI_SYLLABLE_NG	  0xA60B
#define Z_UNICODE_VAI_SYLLABLE_LENGTHENER 0xA60C
#define Z_UNICODE_VAI_COMMA		  0xA60D
#define Z_UNICODE_VAI_FULL_STOP		  0xA60E
#define Z_UNICODE_VAI_QUESTION_MARK	  0xA60F
#define Z_UNICODE_VAI_SYLLABLE_NDOLE_FA	  0xA610
#define Z_UNICODE_VAI_SYLLABLE_NDOLE_KA	  0xA611
#define Z_UNICODE_VAI_SYLLABLE_NDOLE_SOO  0xA612
#define Z_UNICODE_VAI_SYMBOL_FEENG	  0xA613
#define Z_UNICODE_VAI_SYMBOL_KEENG	  0xA614
#define Z_UNICODE_VAI_SYMBOL_TING	  0xA615
#define Z_UNICODE_VAI_SYMBOL_NII	  0xA616
#define Z_UNICODE_VAI_SYMBOL_BANG	  0xA617
#define Z_UNICODE_VAI_SYMBOL_FAA	  0xA618
#define Z_UNICODE_VAI_SYMBOL_TAA	  0xA619
#define Z_UNICODE_VAI_SYMBOL_DANG	  0xA61A
#define Z_UNICODE_VAI_SYMBOL_DOONG	  0xA61B
#define Z_UNICODE_VAI_SYMBOL_KUNG	  0xA61C
#define Z_UNICODE_VAI_SYMBOL_TONG	  0xA61D
#define Z_UNICODE_VAI_SYMBOL_DO_O	  0xA61E
#define Z_UNICODE_VAI_SYMBOL_JONG	  0xA61F
#define Z_UNICODE_VAI_DIGIT_ZERO	  0xA620
#define Z_UNICODE_VAI_DIGIT_ONE		  0xA621
#define Z_UNICODE_VAI_DIGIT_TWO		  0xA622
#define Z_UNICODE_VAI_DIGIT_THREE	  0xA623
#define Z_UNICODE_VAI_DIGIT_FOUR	  0xA624
#define Z_UNICODE_VAI_DIGIT_FIVE	  0xA625
#define Z_UNICODE_VAI_DIGIT_SIX		  0xA626
#define Z_UNICODE_VAI_DIGIT_SEVEN	  0xA627
#define Z_UNICODE_VAI_DIGIT_EIGHT	  0xA628
#define Z_UNICODE_VAI_DIGIT_NINE	  0xA629
#define Z_UNICODE_VAI_SYLLABLE_NDOLE_MA	  0xA62A
#define Z_UNICODE_VAI_SYLLABLE_NDOLE_DO	  0xA62B

/* MARK: - A640h-A69Fh - Cyrillic Extended-B */

#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZEMLYA		     0xA640
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZEMLYA			     0xA641
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DZELO			     0xA642
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DZELO			     0xA643
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_REVERSED_DZE		     0xA644
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_REVERSED_DZE		     0xA645
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IOTA			     0xA646
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IOTA			     0xA647
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DJERV			     0xA648
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DJERV			     0xA649
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_MONOGRAPH_UK		     0xA64A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_MONOGRAPH_UK		     0xA64B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BROAD_OMEGA		     0xA64C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BROAD_OMEGA		     0xA64D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_NEUTRAL_YER		     0xA64E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_NEUTRAL_YER		     0xA64F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YERU_WITH_BACK_YER	     0xA650
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YERU_WITH_BACK_YER	     0xA651
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IOTIFIED_YAT		     0xA652
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IOTIFIED_YAT		     0xA653
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_REVERSED_YU		     0xA654
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_REVERSED_YU		     0xA655
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IOTIFIED_A		     0xA656
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IOTIFIED_A		     0xA657
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_CLOSED_LITTLE_YUS	     0xA658
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_CLOSED_LITTLE_YUS	     0xA659
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BLENDED_YUS		     0xA65A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BLENDED_YUS		     0xA65B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_IOTIFIED_CLOSED_LITTLE_YUS 0xA65C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_IOTIFIED_CLOSED_LITTLE_YUS   0xA65D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_YN			     0xA65E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_YN			     0xA65F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_REVERSED_TSE		     0xA660
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_REVERSED_TSE		     0xA661
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SOFT_DE		     0xA662
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SOFT_DE			     0xA663
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SOFT_EL		     0xA664
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SOFT_EL			     0xA665
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SOFT_EM		     0xA666
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SOFT_EM			     0xA667
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_MONOCULAR_O		     0xA668
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_MONOCULAR_O		     0xA669
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_BINOCULAR_O		     0xA66A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_BINOCULAR_O		     0xA66B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DOUBLE_MONOCULAR_O	     0xA66C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DOUBLE_MONOCULAR_O	     0xA66D
#define Z_UNICODE_CYRILLIC_LETTER_MULTIOCULAR_O			     0xA66E
#define Z_UNICODE_COMBINING_CYRILLIC_VZMET			     0xA66F
#define Z_UNICODE_COMBINING_CYRILLIC_TEN_MILLIONS_SIGN		     0xA670
#define Z_UNICODE_COMBINING_CYRILLIC_HUNDRED_MILLIONS_SIGN	     0xA671
#define Z_UNICODE_COMBINING_CYRILLIC_THOUSAND_MILLIONS_SIGN	     0xA672
#define Z_UNICODE_SLAVONIC_ASTERISK				     0xA673
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_UKRAINIAN_IE	     0xA674
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_I			     0xA675
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_YI			     0xA676
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_U			     0xA677
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_HARD_SIGN		     0xA678
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_YERU		     0xA679
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_SOFT_SIGN		     0xA67A
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_OMEGA		     0xA67B
#define Z_UNICODE_COMBINING_CYRILLIC_KAVYKA			     0xA67C
#define Z_UNICODE_COMBINING_CYRILLIC_PAYEROK			     0xA67D
#define Z_UNICODE_CYRILLIC_KAVYKA				     0xA67E
#define Z_UNICODE_CYRILLIC_PAYEROK				     0xA67F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DWE			     0xA680
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DWE			     0xA681
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DZWE			     0xA682
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DZWE			     0xA683
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_ZHWE			     0xA684
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_ZHWE			     0xA685
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_CCHE			     0xA686
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_CCHE			     0xA687
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DZZE			     0xA688
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DZZE			     0xA689
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TE_WITH_MIDDLE_HOOK	     0xA68A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TE_WITH_MIDDLE_HOOK	     0xA68B
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TWE			     0xA68C
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TWE			     0xA68D
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TSWE			     0xA68E
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TSWE			     0xA68F
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TSSE			     0xA690
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TSSE			     0xA691
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_TCHE			     0xA692
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_TCHE			     0xA693
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_HWE			     0xA694
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_HWE			     0xA695
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_SHWE			     0xA696
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_SHWE			     0xA697
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_DOUBLE_O		     0xA698
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_DOUBLE_O		     0xA699
#define Z_UNICODE_CYRILLIC_CAPITAL_LETTER_CROSSED_O		     0xA69A
#define Z_UNICODE_CYRILLIC_SMALL_LETTER_CROSSED_O		     0xA69B
#define Z_UNICODE_MODIFIER_LETTER_CYRILLIC_HARD_SIGN		     0xA69C
#define Z_UNICODE_MODIFIER_LETTER_CYRILLIC_SOFT_SIGN		     0xA69D
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_EF			     0xA69E
#define Z_UNICODE_COMBINING_CYRILLIC_LETTER_IOTIFIED_E		     0xA69F

/* MARK: - A6A0h-A6FFh - Bamum */

#define Z_UNICODE_BAMUM_LETTER_A		 0xA6A0
#define Z_UNICODE_BAMUM_LETTER_KA		 0xA6A1
#define Z_UNICODE_BAMUM_LETTER_U		 0xA6A2
#define Z_UNICODE_BAMUM_LETTER_KU		 0xA6A3
#define Z_UNICODE_BAMUM_LETTER_EE		 0xA6A4
#define Z_UNICODE_BAMUM_LETTER_REE		 0xA6A5
#define Z_UNICODE_BAMUM_LETTER_TAE		 0xA6A6
#define Z_UNICODE_BAMUM_LETTER_O		 0xA6A7
#define Z_UNICODE_BAMUM_LETTER_NYI		 0xA6A8
#define Z_UNICODE_BAMUM_LETTER_I		 0xA6A9
#define Z_UNICODE_BAMUM_LETTER_LA		 0xA6AA
#define Z_UNICODE_BAMUM_LETTER_PA		 0xA6AB
#define Z_UNICODE_BAMUM_LETTER_RII		 0xA6AC
#define Z_UNICODE_BAMUM_LETTER_RIEE		 0xA6AD
#define Z_UNICODE_BAMUM_LETTER_LEEEE		 0xA6AE
#define Z_UNICODE_BAMUM_LETTER_MEEEE		 0xA6AF
#define Z_UNICODE_BAMUM_LETTER_TAA		 0xA6B0
#define Z_UNICODE_BAMUM_LETTER_NDAA		 0xA6B1
#define Z_UNICODE_BAMUM_LETTER_NJAEM		 0xA6B2
#define Z_UNICODE_BAMUM_LETTER_M		 0xA6B3
#define Z_UNICODE_BAMUM_LETTER_SUU		 0xA6B4
#define Z_UNICODE_BAMUM_LETTER_MU		 0xA6B5
#define Z_UNICODE_BAMUM_LETTER_SHII		 0xA6B6
#define Z_UNICODE_BAMUM_LETTER_SI		 0xA6B7
#define Z_UNICODE_BAMUM_LETTER_SHEUX		 0xA6B8
#define Z_UNICODE_BAMUM_LETTER_SEUX		 0xA6B9
#define Z_UNICODE_BAMUM_LETTER_KYEE		 0xA6BA
#define Z_UNICODE_BAMUM_LETTER_KET		 0xA6BB
#define Z_UNICODE_BAMUM_LETTER_NUAE		 0xA6BC
#define Z_UNICODE_BAMUM_LETTER_NU		 0xA6BD
#define Z_UNICODE_BAMUM_LETTER_NJUAE		 0xA6BE
#define Z_UNICODE_BAMUM_LETTER_YOQ		 0xA6BF
#define Z_UNICODE_BAMUM_LETTER_SHU		 0xA6C0
#define Z_UNICODE_BAMUM_LETTER_YUQ		 0xA6C1
#define Z_UNICODE_BAMUM_LETTER_YA		 0xA6C2
#define Z_UNICODE_BAMUM_LETTER_NSHA		 0xA6C3
#define Z_UNICODE_BAMUM_LETTER_KEUX		 0xA6C4
#define Z_UNICODE_BAMUM_LETTER_PEUX		 0xA6C5
#define Z_UNICODE_BAMUM_LETTER_NJEE		 0xA6C6
#define Z_UNICODE_BAMUM_LETTER_NTEE		 0xA6C7
#define Z_UNICODE_BAMUM_LETTER_PUE		 0xA6C8
#define Z_UNICODE_BAMUM_LETTER_WUE		 0xA6C9
#define Z_UNICODE_BAMUM_LETTER_PEE		 0xA6CA
#define Z_UNICODE_BAMUM_LETTER_FEE		 0xA6CB
#define Z_UNICODE_BAMUM_LETTER_RU		 0xA6CC
#define Z_UNICODE_BAMUM_LETTER_LU		 0xA6CD
#define Z_UNICODE_BAMUM_LETTER_MI		 0xA6CE
#define Z_UNICODE_BAMUM_LETTER_NI		 0xA6CF
#define Z_UNICODE_BAMUM_LETTER_REUX		 0xA6D0
#define Z_UNICODE_BAMUM_LETTER_RAE		 0xA6D1
#define Z_UNICODE_BAMUM_LETTER_KEN		 0xA6D2
#define Z_UNICODE_BAMUM_LETTER_NGKWAEN		 0xA6D3
#define Z_UNICODE_BAMUM_LETTER_NGGA		 0xA6D4
#define Z_UNICODE_BAMUM_LETTER_NGA		 0xA6D5
#define Z_UNICODE_BAMUM_LETTER_SHO		 0xA6D6
#define Z_UNICODE_BAMUM_LETTER_PUAE		 0xA6D7
#define Z_UNICODE_BAMUM_LETTER_FU		 0xA6D8
#define Z_UNICODE_BAMUM_LETTER_FOM		 0xA6D9
#define Z_UNICODE_BAMUM_LETTER_WA		 0xA6DA
#define Z_UNICODE_BAMUM_LETTER_NA		 0xA6DB
#define Z_UNICODE_BAMUM_LETTER_LI		 0xA6DC
#define Z_UNICODE_BAMUM_LETTER_PI		 0xA6DD
#define Z_UNICODE_BAMUM_LETTER_LOQ		 0xA6DE
#define Z_UNICODE_BAMUM_LETTER_KO		 0xA6DF
#define Z_UNICODE_BAMUM_LETTER_MBEN		 0xA6E0
#define Z_UNICODE_BAMUM_LETTER_REN		 0xA6E1
#define Z_UNICODE_BAMUM_LETTER_MEN		 0xA6E2
#define Z_UNICODE_BAMUM_LETTER_MA		 0xA6E3
#define Z_UNICODE_BAMUM_LETTER_TI		 0xA6E4
#define Z_UNICODE_BAMUM_LETTER_KI		 0xA6E5
#define Z_UNICODE_BAMUM_LETTER_MO		 0xA6E6
#define Z_UNICODE_BAMUM_LETTER_MBAA		 0xA6E7
#define Z_UNICODE_BAMUM_LETTER_TET		 0xA6E8
#define Z_UNICODE_BAMUM_LETTER_KPA		 0xA6E9
#define Z_UNICODE_BAMUM_LETTER_TEN		 0xA6EA
#define Z_UNICODE_BAMUM_LETTER_NTUU		 0xA6EB
#define Z_UNICODE_BAMUM_LETTER_SAMBA		 0xA6EC
#define Z_UNICODE_BAMUM_LETTER_FAAMAE		 0xA6ED
#define Z_UNICODE_BAMUM_LETTER_KOVUU		 0xA6EE
#define Z_UNICODE_BAMUM_LETTER_KOGHOM		 0xA6EF
#define Z_UNICODE_BAMUM_COMBINING_MARK_KOQNDON	 0xA6F0
#define Z_UNICODE_BAMUM_COMBINING_MARK_TUKWENTIS 0xA6F1
#define Z_UNICODE_BAMUM_NJAEMLI			 0xA6F2
#define Z_UNICODE_BAMUM_FULL_STOP		 0xA6F3
#define Z_UNICODE_BAMUM_COLON			 0xA6F4
#define Z_UNICODE_BAMUM_COMMA			 0xA6F5
#define Z_UNICODE_BAMUM_SEMICOLON		 0xA6F6
#define Z_UNICODE_BAMUM_QUESTION_MARK		 0xA6F7

/* MARK: - A700h-A71Fh - Modifier Tone Letters */

#define Z_UNICODE_MODIFIER_LETTER_CHINESE_TONE_YIN_PING		       0xA700
#define Z_UNICODE_MODIFIER_LETTER_CHINESE_TONE_YANG_PING	       0xA701
#define Z_UNICODE_MODIFIER_LETTER_CHINESE_TONE_YIN_SHANG	       0xA702
#define Z_UNICODE_MODIFIER_LETTER_CHINESE_TONE_YANG_SHANG	       0xA703
#define Z_UNICODE_MODIFIER_LETTER_CHINESE_TONE_YIN_QU		       0xA704
#define Z_UNICODE_MODIFIER_LETTER_CHINESE_TONE_YANG_QU		       0xA705
#define Z_UNICODE_MODIFIER_LETTER_CHINESE_TONE_YIN_RU		       0xA706
#define Z_UNICODE_MODIFIER_LETTER_CHINESE_TONE_YANG_RU		       0xA707
#define Z_UNICODE_MODIFIER_LETTER_EXTRA_HIGH_DOTTED_TONE_BAR	       0xA708
#define Z_UNICODE_MODIFIER_LETTER_HIGH_DOTTED_TONE_BAR		       0xA709
#define Z_UNICODE_MODIFIER_LETTER_MID_DOTTED_TONE_BAR		       0xA70A
#define Z_UNICODE_MODIFIER_LETTER_LOW_DOTTED_TONE_BAR		       0xA70B
#define Z_UNICODE_MODIFIER_LETTER_EXTRA_LOW_DOTTED_TONE_BAR	       0xA70C
#define Z_UNICODE_MODIFIER_LETTER_EXTRA_HIGH_DOTTED_LEFT_STEM_TONE_BAR 0xA70D
#define Z_UNICODE_MODIFIER_LETTER_HIGH_DOTTED_LEFT_STEM_TONE_BAR       0xA70E
#define Z_UNICODE_MODIFIER_LETTER_MID_DOTTED_LEFT_STEM_TONE_BAR	       0xA70F
#define Z_UNICODE_MODIFIER_LETTER_LOW_DOTTED_LEFT_STEM_TONE_BAR	       0xA710
#define Z_UNICODE_MODIFIER_LETTER_EXTRA_LOW_DOTTED_LEFT_STEM_TONE_BAR  0xA711
#define Z_UNICODE_MODIFIER_LETTER_EXTRA_HIGH_LEFT_STEM_TONE_BAR	       0xA712
#define Z_UNICODE_MODIFIER_LETTER_HIGH_LEFT_STEM_TONE_BAR	       0xA713
#define Z_UNICODE_MODIFIER_LETTER_MID_LEFT_STEM_TONE_BAR	       0xA714
#define Z_UNICODE_MODIFIER_LETTER_LOW_LEFT_STEM_TONE_BAR	       0xA715
#define Z_UNICODE_MODIFIER_LETTER_EXTRA_LOW_LEFT_STEM_TONE_BAR	       0xA716
#define Z_UNICODE_MODIFIER_LETTER_DOT_VERTICAL_BAR		       0xA717
#define Z_UNICODE_MODIFIER_LETTER_DOT_SLASH			       0xA718
#define Z_UNICODE_MODIFIER_LETTER_DOT_HORIZONTAL_BAR		       0xA719
#define Z_UNICODE_MODIFIER_LETTER_LOWER_RIGHT_CORNER_ANGLE	       0xA71A
#define Z_UNICODE_MODIFIER_LETTER_RAISED_UP_ARROW		       0xA71B
#define Z_UNICODE_MODIFIER_LETTER_RAISED_DOWN_ARROW		       0xA71C
#define Z_UNICODE_MODIFIER_LETTER_RAISED_EXCLAMATION_MARK	       0xA71D
#define Z_UNICODE_MODIFIER_LETTER_RAISED_INVERTED_EXCLAMATION_MARK     0xA71E
#define Z_UNICODE_MODIFIER_LETTER_LOW_INVERTED_EXCLAMATION_MARK	       0xA71F

/* MARK: - A720h-A7FFh - Latin Extended-D */

#define Z_UNICODE_MODIFIER_LETTER_STRESS_AND_HIGH_TONE			   0xA720
#define Z_UNICODE_MODIFIER_LETTER_STRESS_AND_LOW_TONE			   0xA721
#define Z_UNICODE_LATIN_CAPITAL_LETTER_EGYPTOLOGICAL_ALEF		   0xA722
#define Z_UNICODE_LATIN_SMALL_LETTER_EGYPTOLOGICAL_ALEF			   0xA723
#define Z_UNICODE_LATIN_CAPITAL_LETTER_EGYPTOLOGICAL_AIN		   0xA724
#define Z_UNICODE_LATIN_SMALL_LETTER_EGYPTOLOGICAL_AIN			   0xA725
#define Z_UNICODE_LATIN_CAPITAL_LETTER_HENG				   0xA726
#define Z_UNICODE_LATIN_SMALL_LETTER_HENG				   0xA727
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TZ				   0xA728
#define Z_UNICODE_LATIN_SMALL_LETTER_TZ					   0xA729
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TRESILLO				   0xA72A
#define Z_UNICODE_LATIN_SMALL_LETTER_TRESILLO				   0xA72B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_CUATRILLO			   0xA72C
#define Z_UNICODE_LATIN_SMALL_LETTER_CUATRILLO				   0xA72D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_CUATRILLO_WITH_COMMA		   0xA72E
#define Z_UNICODE_LATIN_SMALL_LETTER_CUATRILLO_WITH_COMMA		   0xA72F
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_F				   0xA730
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_S				   0xA731
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AA				   0xA732
#define Z_UNICODE_LATIN_SMALL_LETTER_AA					   0xA733
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AO				   0xA734
#define Z_UNICODE_LATIN_SMALL_LETTER_AO					   0xA735
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AU				   0xA736
#define Z_UNICODE_LATIN_SMALL_LETTER_AU					   0xA737
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AV				   0xA738
#define Z_UNICODE_LATIN_SMALL_LETTER_AV					   0xA739
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AV_WITH_HORIZONTAL_BAR		   0xA73A
#define Z_UNICODE_LATIN_SMALL_LETTER_AV_WITH_HORIZONTAL_BAR		   0xA73B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_AY				   0xA73C
#define Z_UNICODE_LATIN_SMALL_LETTER_AY					   0xA73D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_REVERSED_C_WITH_DOT		   0xA73E
#define Z_UNICODE_LATIN_SMALL_LETTER_REVERSED_C_WITH_DOT		   0xA73F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_STROKE			   0xA740
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_STROKE			   0xA741
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_DIAGONAL_STROKE		   0xA742
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_DIAGONAL_STROKE		   0xA743
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_STROKE_AND_DIAGONAL_STROKE   0xA744
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_STROKE_AND_DIAGONAL_STROKE	   0xA745
#define Z_UNICODE_LATIN_CAPITAL_LETTER_BROKEN_L				   0xA746
#define Z_UNICODE_LATIN_SMALL_LETTER_BROKEN_L				   0xA747
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_HIGH_STROKE		   0xA748
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_HIGH_STROKE			   0xA749
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_LONG_STROKE_OVERLAY	   0xA74A
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_LONG_STROKE_OVERLAY		   0xA74B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_O_WITH_LOOP			   0xA74C
#define Z_UNICODE_LATIN_SMALL_LETTER_O_WITH_LOOP			   0xA74D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_OO				   0xA74E
#define Z_UNICODE_LATIN_SMALL_LETTER_OO					   0xA74F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_P_WITH_STROKE_THROUGH_DESCENDER	   0xA750
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_STROKE_THROUGH_DESCENDER	   0xA751
#define Z_UNICODE_LATIN_CAPITAL_LETTER_P_WITH_FLOURISH			   0xA752
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_FLOURISH			   0xA753
#define Z_UNICODE_LATIN_CAPITAL_LETTER_P_WITH_SQUIRREL_TAIL		   0xA754
#define Z_UNICODE_LATIN_SMALL_LETTER_P_WITH_SQUIRREL_TAIL		   0xA755
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Q_WITH_STROKE_THROUGH_DESCENDER	   0xA756
#define Z_UNICODE_LATIN_SMALL_LETTER_Q_WITH_STROKE_THROUGH_DESCENDER	   0xA757
#define Z_UNICODE_LATIN_CAPITAL_LETTER_Q_WITH_DIAGONAL_STROKE		   0xA758
#define Z_UNICODE_LATIN_SMALL_LETTER_Q_WITH_DIAGONAL_STROKE		   0xA759
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_ROTUNDA			   0xA75A
#define Z_UNICODE_LATIN_SMALL_LETTER_R_ROTUNDA				   0xA75B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_RUM_ROTUNDA			   0xA75C
#define Z_UNICODE_LATIN_SMALL_LETTER_RUM_ROTUNDA			   0xA75D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_V_WITH_DIAGONAL_STROKE		   0xA75E
#define Z_UNICODE_LATIN_SMALL_LETTER_V_WITH_DIAGONAL_STROKE		   0xA75F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_VY				   0xA760
#define Z_UNICODE_LATIN_SMALL_LETTER_VY					   0xA761
#define Z_UNICODE_LATIN_CAPITAL_LETTER_VISIGOTHIC_Z			   0xA762
#define Z_UNICODE_LATIN_SMALL_LETTER_VISIGOTHIC_Z			   0xA763
#define Z_UNICODE_LATIN_CAPITAL_LETTER_THORN_WITH_STROKE		   0xA764
#define Z_UNICODE_LATIN_SMALL_LETTER_THORN_WITH_STROKE			   0xA765
#define Z_UNICODE_LATIN_CAPITAL_LETTER_THORN_WITH_STROKE_THROUGH_DESCENDER 0xA766
#define Z_UNICODE_LATIN_SMALL_LETTER_THORN_WITH_STROKE_THROUGH_DESCENDER   0xA767
#define Z_UNICODE_LATIN_CAPITAL_LETTER_VEND				   0xA768
#define Z_UNICODE_LATIN_SMALL_LETTER_VEND				   0xA769
#define Z_UNICODE_LATIN_CAPITAL_LETTER_ET				   0xA76A
#define Z_UNICODE_LATIN_SMALL_LETTER_ET					   0xA76B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_IS				   0xA76C
#define Z_UNICODE_LATIN_SMALL_LETTER_IS					   0xA76D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_CON				   0xA76E
#define Z_UNICODE_LATIN_SMALL_LETTER_CON				   0xA76F
#define Z_UNICODE_MODIFIER_LETTER_US					   0xA770
#define Z_UNICODE_LATIN_SMALL_LETTER_DUM				   0xA771
#define Z_UNICODE_LATIN_SMALL_LETTER_LUM				   0xA772
#define Z_UNICODE_LATIN_SMALL_LETTER_MUM				   0xA773
#define Z_UNICODE_LATIN_SMALL_LETTER_NUM				   0xA774
#define Z_UNICODE_LATIN_SMALL_LETTER_RUM				   0xA775
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_RUM			   0xA776
#define Z_UNICODE_LATIN_SMALL_LETTER_TUM				   0xA777
#define Z_UNICODE_LATIN_SMALL_LETTER_UM					   0xA778
#define Z_UNICODE_LATIN_CAPITAL_LETTER_INSULAR_D			   0xA779
#define Z_UNICODE_LATIN_SMALL_LETTER_INSULAR_D				   0xA77A
#define Z_UNICODE_LATIN_CAPITAL_LETTER_INSULAR_F			   0xA77B
#define Z_UNICODE_LATIN_SMALL_LETTER_INSULAR_F				   0xA77C
#define Z_UNICODE_LATIN_CAPITAL_LETTER_INSULAR_G			   0xA77D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_INSULAR_G			   0xA77E
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_INSULAR_G			   0xA77F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_L				   0xA780
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_L				   0xA781
#define Z_UNICODE_LATIN_CAPITAL_LETTER_INSULAR_R			   0xA782
#define Z_UNICODE_LATIN_SMALL_LETTER_INSULAR_R				   0xA783
#define Z_UNICODE_LATIN_CAPITAL_LETTER_INSULAR_S			   0xA784
#define Z_UNICODE_LATIN_SMALL_LETTER_INSULAR_S				   0xA785
#define Z_UNICODE_LATIN_CAPITAL_LETTER_INSULAR_T			   0xA786
#define Z_UNICODE_LATIN_SMALL_LETTER_INSULAR_T				   0xA787
#define Z_UNICODE_MODIFIER_LETTER_LOW_CIRCUMFLEX_ACCENT			   0xA788
#define Z_UNICODE_MODIFIER_LETTER_COLON					   0xA789
#define Z_UNICODE_MODIFIER_LETTER_SHORT_EQUALS_SIGN			   0xA78A
#define Z_UNICODE_LATIN_CAPITAL_LETTER_SALTILLO				   0xA78B
#define Z_UNICODE_LATIN_SMALL_LETTER_SALTILLO				   0xA78C
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_H				   0xA78D
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_RETROFLEX_HOOK_AND_BELT	   0xA78E
#define Z_UNICODE_LATIN_LETTER_SINOLOGICAL_DOT				   0xA78F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_DESCENDER			   0xA790
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_DESCENDER			   0xA791
#define Z_UNICODE_LATIN_CAPITAL_LETTER_C_WITH_BAR			   0xA792
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_BAR				   0xA793
#define Z_UNICODE_LATIN_SMALL_LETTER_C_WITH_PALATAL_HOOK		   0xA794
#define Z_UNICODE_LATIN_SMALL_LETTER_H_WITH_PALATAL_HOOK		   0xA795
#define Z_UNICODE_LATIN_CAPITAL_LETTER_B_WITH_FLOURISH			   0xA796
#define Z_UNICODE_LATIN_SMALL_LETTER_B_WITH_FLOURISH			   0xA797
#define Z_UNICODE_LATIN_CAPITAL_LETTER_F_WITH_STROKE			   0xA798
#define Z_UNICODE_LATIN_SMALL_LETTER_F_WITH_STROKE			   0xA799
#define Z_UNICODE_LATIN_CAPITAL_LETTER_VOLAPUK_AE			   0xA79A
#define Z_UNICODE_LATIN_SMALL_LETTER_VOLAPUK_AE				   0xA79B
#define Z_UNICODE_LATIN_CAPITAL_LETTER_VOLAPUK_OE			   0xA79C
#define Z_UNICODE_LATIN_SMALL_LETTER_VOLAPUK_OE				   0xA79D
#define Z_UNICODE_LATIN_CAPITAL_LETTER_VOLAPUK_UE			   0xA79E
#define Z_UNICODE_LATIN_SMALL_LETTER_VOLAPUK_UE				   0xA79F
#define Z_UNICODE_LATIN_CAPITAL_LETTER_G_WITH_OBLIQUE_STROKE		   0xA7A0
#define Z_UNICODE_LATIN_SMALL_LETTER_G_WITH_OBLIQUE_STROKE		   0xA7A1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_K_WITH_OBLIQUE_STROKE		   0xA7A2
#define Z_UNICODE_LATIN_SMALL_LETTER_K_WITH_OBLIQUE_STROKE		   0xA7A3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_N_WITH_OBLIQUE_STROKE		   0xA7A4
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_OBLIQUE_STROKE		   0xA7A5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_R_WITH_OBLIQUE_STROKE		   0xA7A6
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_OBLIQUE_STROKE		   0xA7A7
#define Z_UNICODE_LATIN_CAPITAL_LETTER_S_WITH_OBLIQUE_STROKE		   0xA7A8
#define Z_UNICODE_LATIN_SMALL_LETTER_S_WITH_OBLIQUE_STROKE		   0xA7A9
#define Z_UNICODE_LATIN_CAPITAL_LETTER_H_WITH_HOOK			   0xA7AA
#define Z_UNICODE_LATIN_CAPITAL_LETTER_REVERSED_OPEN_E			   0xA7AB
#define Z_UNICODE_LATIN_CAPITAL_LETTER_SCRIPT_G				   0xA7AC
#define Z_UNICODE_LATIN_CAPITAL_LETTER_L_WITH_BELT			   0xA7AD
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_K				   0xA7B0
#define Z_UNICODE_LATIN_CAPITAL_LETTER_TURNED_T				   0xA7B1
#define Z_UNICODE_LATIN_CAPITAL_LETTER_J_WITH_CROSSED_TAIL		   0xA7B2
#define Z_UNICODE_LATIN_CAPITAL_LETTER_CHI				   0xA7B3
#define Z_UNICODE_LATIN_CAPITAL_LETTER_BETA				   0xA7B4
#define Z_UNICODE_LATIN_SMALL_LETTER_BETA				   0xA7B5
#define Z_UNICODE_LATIN_CAPITAL_LETTER_OMEGA				   0xA7B6
#define Z_UNICODE_LATIN_SMALL_LETTER_OMEGA				   0xA7B7
#define Z_UNICODE_LATIN_EPIGRAPHIC_LETTER_SIDEWAYS_I			   0xA7F7
#define Z_UNICODE_MODIFIER_LETTER_CAPITAL_H_WITH_STROKE			   0xA7F8
#define Z_UNICODE_MODIFIER_LETTER_SMALL_LIGATURE_OE			   0xA7F9
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_TURNED_M			   0xA7FA
#define Z_UNICODE_LATIN_EPIGRAPHIC_LETTER_REVERSED_F			   0xA7FB
#define Z_UNICODE_LATIN_EPIGRAPHIC_LETTER_REVERSED_P			   0xA7FC
#define Z_UNICODE_LATIN_EPIGRAPHIC_LETTER_INVERTED_M			   0xA7FD
#define Z_UNICODE_LATIN_EPIGRAPHIC_LETTER_I_LONGA			   0xA7FE
#define Z_UNICODE_LATIN_EPIGRAPHIC_LETTER_ARCHAIC_M			   0xA7FF

/* MARK: - A800h-A82Fh - Syloti Nagri */

#define Z_UNICODE_SYLOTI_NAGRI_LETTER_A	     0xA800
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_I	     0xA801
#define Z_UNICODE_SYLOTI_NAGRI_SIGN_DVISVARA 0xA802
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_U	     0xA803
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_E	     0xA804
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_O	     0xA805
#define Z_UNICODE_SYLOTI_NAGRI_SIGN_HASANTA  0xA806
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_KO     0xA807
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_KHO    0xA808
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_GO     0xA809
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_GHO    0xA80A
#define Z_UNICODE_SYLOTI_NAGRI_SIGN_ANUSVARA 0xA80B
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_CO     0xA80C
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_CHO    0xA80D
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_JO     0xA80E
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_JHO    0xA80F
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_TTO    0xA810
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_TTHO   0xA811
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_DDO    0xA812
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_DDHO   0xA813
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_TO     0xA814
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_THO    0xA815
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_DO     0xA816
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_DHO    0xA817
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_NO     0xA818
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_PO     0xA819
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_PHO    0xA81A
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_BO     0xA81B
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_BHO    0xA81C
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_MO     0xA81D
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_RO     0xA81E
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_LO     0xA81F
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_RRO    0xA820
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_SO     0xA821
#define Z_UNICODE_SYLOTI_NAGRI_LETTER_HO     0xA822
#define Z_UNICODE_SYLOTI_NAGRI_VOWEL_SIGN_A  0xA823
#define Z_UNICODE_SYLOTI_NAGRI_VOWEL_SIGN_I  0xA824
#define Z_UNICODE_SYLOTI_NAGRI_VOWEL_SIGN_U  0xA825
#define Z_UNICODE_SYLOTI_NAGRI_VOWEL_SIGN_E  0xA826
#define Z_UNICODE_SYLOTI_NAGRI_VOWEL_SIGN_OO 0xA827
#define Z_UNICODE_SYLOTI_NAGRI_POETRY_MARK_1 0xA828
#define Z_UNICODE_SYLOTI_NAGRI_POETRY_MARK_2 0xA829
#define Z_UNICODE_SYLOTI_NAGRI_POETRY_MARK_3 0xA82A
#define Z_UNICODE_SYLOTI_NAGRI_POETRY_MARK_4 0xA82B

/* MARK: - A830h-A83Fh - Common Indic Number Forms */

#define Z_UNICODE_NORTH_INDIC_FRACTION_ONE_QUARTER	0xA830
#define Z_UNICODE_NORTH_INDIC_FRACTION_ONE_HALF		0xA831
#define Z_UNICODE_NORTH_INDIC_FRACTION_THREE_QUARTERS	0xA832
#define Z_UNICODE_NORTH_INDIC_FRACTION_ONE_SIXTEENTH	0xA833
#define Z_UNICODE_NORTH_INDIC_FRACTION_ONE_EIGHTH	0xA834
#define Z_UNICODE_NORTH_INDIC_FRACTION_THREE_SIXTEENTHS	0xA835
#define Z_UNICODE_NORTH_INDIC_QUARTER_MARK		0xA836
#define Z_UNICODE_NORTH_INDIC_PLACEHOLDER_MARK		0xA837
#define Z_UNICODE_NORTH_INDIC_RUPEE_MARK		0xA838
#define Z_UNICODE_NORTH_INDIC_QUANTITY_MARK		0xA839

/* MARK: - A840h-A87Fh - Phags-pa */

#define Z_UNICODE_PHAGS_PA_LETTER_KA		0xA840
#define Z_UNICODE_PHAGS_PA_LETTER_KHA		0xA841
#define Z_UNICODE_PHAGS_PA_LETTER_GA		0xA842
#define Z_UNICODE_PHAGS_PA_LETTER_NGA		0xA843
#define Z_UNICODE_PHAGS_PA_LETTER_CA		0xA844
#define Z_UNICODE_PHAGS_PA_LETTER_CHA		0xA845
#define Z_UNICODE_PHAGS_PA_LETTER_JA		0xA846
#define Z_UNICODE_PHAGS_PA_LETTER_NYA		0xA847
#define Z_UNICODE_PHAGS_PA_LETTER_TA		0xA848
#define Z_UNICODE_PHAGS_PA_LETTER_THA		0xA849
#define Z_UNICODE_PHAGS_PA_LETTER_DA		0xA84A
#define Z_UNICODE_PHAGS_PA_LETTER_NA		0xA84B
#define Z_UNICODE_PHAGS_PA_LETTER_PA		0xA84C
#define Z_UNICODE_PHAGS_PA_LETTER_PHA		0xA84D
#define Z_UNICODE_PHAGS_PA_LETTER_BA		0xA84E
#define Z_UNICODE_PHAGS_PA_LETTER_MA		0xA84F
#define Z_UNICODE_PHAGS_PA_LETTER_TSA		0xA850
#define Z_UNICODE_PHAGS_PA_LETTER_TSHA		0xA851
#define Z_UNICODE_PHAGS_PA_LETTER_DZA		0xA852
#define Z_UNICODE_PHAGS_PA_LETTER_WA		0xA853
#define Z_UNICODE_PHAGS_PA_LETTER_ZHA		0xA854
#define Z_UNICODE_PHAGS_PA_LETTER_ZA		0xA855
#define Z_UNICODE_PHAGS_PA_LETTER_SMALL_A	0xA856
#define Z_UNICODE_PHAGS_PA_LETTER_YA		0xA857
#define Z_UNICODE_PHAGS_PA_LETTER_RA		0xA858
#define Z_UNICODE_PHAGS_PA_LETTER_LA		0xA859
#define Z_UNICODE_PHAGS_PA_LETTER_SHA		0xA85A
#define Z_UNICODE_PHAGS_PA_LETTER_SA		0xA85B
#define Z_UNICODE_PHAGS_PA_LETTER_HA		0xA85C
#define Z_UNICODE_PHAGS_PA_LETTER_A		0xA85D
#define Z_UNICODE_PHAGS_PA_LETTER_I		0xA85E
#define Z_UNICODE_PHAGS_PA_LETTER_U		0xA85F
#define Z_UNICODE_PHAGS_PA_LETTER_E		0xA860
#define Z_UNICODE_PHAGS_PA_LETTER_O		0xA861
#define Z_UNICODE_PHAGS_PA_LETTER_QA		0xA862
#define Z_UNICODE_PHAGS_PA_LETTER_XA		0xA863
#define Z_UNICODE_PHAGS_PA_LETTER_FA		0xA864
#define Z_UNICODE_PHAGS_PA_LETTER_GGA		0xA865
#define Z_UNICODE_PHAGS_PA_LETTER_EE		0xA866
#define Z_UNICODE_PHAGS_PA_SUBJOINED_LETTER_WA	0xA867
#define Z_UNICODE_PHAGS_PA_SUBJOINED_LETTER_YA	0xA868
#define Z_UNICODE_PHAGS_PA_LETTER_TTA		0xA869
#define Z_UNICODE_PHAGS_PA_LETTER_TTHA		0xA86A
#define Z_UNICODE_PHAGS_PA_LETTER_DDA		0xA86B
#define Z_UNICODE_PHAGS_PA_LETTER_NNA		0xA86C
#define Z_UNICODE_PHAGS_PA_LETTER_ALTERNATE_YA	0xA86D
#define Z_UNICODE_PHAGS_PA_LETTER_VOICELESS_SHA	0xA86E
#define Z_UNICODE_PHAGS_PA_LETTER_VOICED_HA	0xA86F
#define Z_UNICODE_PHAGS_PA_LETTER_ASPIRATED_FA	0xA870
#define Z_UNICODE_PHAGS_PA_SUBJOINED_LETTER_RA	0xA871
#define Z_UNICODE_PHAGS_PA_SUPERFIXED_LETTER_RA	0xA872
#define Z_UNICODE_PHAGS_PA_LETTER_CANDRABINDU	0xA873
#define Z_UNICODE_PHAGS_PA_SINGLE_HEAD_MARK	0xA874
#define Z_UNICODE_PHAGS_PA_DOUBLE_HEAD_MARK	0xA875
#define Z_UNICODE_PHAGS_PA_MARK_SHAD		0xA876
#define Z_UNICODE_PHAGS_PA_MARK_DOUBLE_SHAD	0xA877

/* MARK: - A880h-A8DFh - Saurashtra */

#define Z_UNICODE_SAURASHTRA_SIGN_ANUSVARA	   0xA880
#define Z_UNICODE_SAURASHTRA_SIGN_VISARGA	   0xA881
#define Z_UNICODE_SAURASHTRA_LETTER_A		   0xA882
#define Z_UNICODE_SAURASHTRA_LETTER_AA		   0xA883
#define Z_UNICODE_SAURASHTRA_LETTER_I		   0xA884
#define Z_UNICODE_SAURASHTRA_LETTER_II		   0xA885
#define Z_UNICODE_SAURASHTRA_LETTER_U		   0xA886
#define Z_UNICODE_SAURASHTRA_LETTER_UU		   0xA887
#define Z_UNICODE_SAURASHTRA_LETTER_VOCALIC_R	   0xA888
#define Z_UNICODE_SAURASHTRA_LETTER_VOCALIC_RR	   0xA889
#define Z_UNICODE_SAURASHTRA_LETTER_VOCALIC_L	   0xA88A
#define Z_UNICODE_SAURASHTRA_LETTER_VOCALIC_LL	   0xA88B
#define Z_UNICODE_SAURASHTRA_LETTER_E		   0xA88C
#define Z_UNICODE_SAURASHTRA_LETTER_EE		   0xA88D
#define Z_UNICODE_SAURASHTRA_LETTER_AI		   0xA88E
#define Z_UNICODE_SAURASHTRA_LETTER_O		   0xA88F
#define Z_UNICODE_SAURASHTRA_LETTER_OO		   0xA890
#define Z_UNICODE_SAURASHTRA_LETTER_AU		   0xA891
#define Z_UNICODE_SAURASHTRA_LETTER_KA		   0xA892
#define Z_UNICODE_SAURASHTRA_LETTER_KHA		   0xA893
#define Z_UNICODE_SAURASHTRA_LETTER_GA		   0xA894
#define Z_UNICODE_SAURASHTRA_LETTER_GHA		   0xA895
#define Z_UNICODE_SAURASHTRA_LETTER_NGA		   0xA896
#define Z_UNICODE_SAURASHTRA_LETTER_CA		   0xA897
#define Z_UNICODE_SAURASHTRA_LETTER_CHA		   0xA898
#define Z_UNICODE_SAURASHTRA_LETTER_JA		   0xA899
#define Z_UNICODE_SAURASHTRA_LETTER_JHA		   0xA89A
#define Z_UNICODE_SAURASHTRA_LETTER_NYA		   0xA89B
#define Z_UNICODE_SAURASHTRA_LETTER_TTA		   0xA89C
#define Z_UNICODE_SAURASHTRA_LETTER_TTHA	   0xA89D
#define Z_UNICODE_SAURASHTRA_LETTER_DDA		   0xA89E
#define Z_UNICODE_SAURASHTRA_LETTER_DDHA	   0xA89F
#define Z_UNICODE_SAURASHTRA_LETTER_NNA		   0xA8A0
#define Z_UNICODE_SAURASHTRA_LETTER_TA		   0xA8A1
#define Z_UNICODE_SAURASHTRA_LETTER_THA		   0xA8A2
#define Z_UNICODE_SAURASHTRA_LETTER_DA		   0xA8A3
#define Z_UNICODE_SAURASHTRA_LETTER_DHA		   0xA8A4
#define Z_UNICODE_SAURASHTRA_LETTER_NA		   0xA8A5
#define Z_UNICODE_SAURASHTRA_LETTER_PA		   0xA8A6
#define Z_UNICODE_SAURASHTRA_LETTER_PHA		   0xA8A7
#define Z_UNICODE_SAURASHTRA_LETTER_BA		   0xA8A8
#define Z_UNICODE_SAURASHTRA_LETTER_BHA		   0xA8A9
#define Z_UNICODE_SAURASHTRA_LETTER_MA		   0xA8AA
#define Z_UNICODE_SAURASHTRA_LETTER_YA		   0xA8AB
#define Z_UNICODE_SAURASHTRA_LETTER_RA		   0xA8AC
#define Z_UNICODE_SAURASHTRA_LETTER_LA		   0xA8AD
#define Z_UNICODE_SAURASHTRA_LETTER_VA		   0xA8AE
#define Z_UNICODE_SAURASHTRA_LETTER_SHA		   0xA8AF
#define Z_UNICODE_SAURASHTRA_LETTER_SSA		   0xA8B0
#define Z_UNICODE_SAURASHTRA_LETTER_SA		   0xA8B1
#define Z_UNICODE_SAURASHTRA_LETTER_HA		   0xA8B2
#define Z_UNICODE_SAURASHTRA_LETTER_LLA		   0xA8B3
#define Z_UNICODE_SAURASHTRA_CONSONANT_SIGN_HAARU  0xA8B4
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_AA	   0xA8B5
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_I	   0xA8B6
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_II	   0xA8B7
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_U	   0xA8B8
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_UU	   0xA8B9
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_VOCALIC_R  0xA8BA
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_VOCALIC_RR 0xA8BB
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_VOCALIC_L  0xA8BC
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_VOCALIC_LL 0xA8BD
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_E	   0xA8BE
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_EE	   0xA8BF
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_AI	   0xA8C0
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_O	   0xA8C1
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_OO	   0xA8C2
#define Z_UNICODE_SAURASHTRA_VOWEL_SIGN_AU	   0xA8C3
#define Z_UNICODE_SAURASHTRA_SIGN_VIRAMA	   0xA8C4
#define Z_UNICODE_SAURASHTRA_DANDA		   0xA8CE
#define Z_UNICODE_SAURASHTRA_DOUBLE_DANDA	   0xA8CF
#define Z_UNICODE_SAURASHTRA_DIGIT_ZERO		   0xA8D0
#define Z_UNICODE_SAURASHTRA_DIGIT_ONE		   0xA8D1
#define Z_UNICODE_SAURASHTRA_DIGIT_TWO		   0xA8D2
#define Z_UNICODE_SAURASHTRA_DIGIT_THREE	   0xA8D3
#define Z_UNICODE_SAURASHTRA_DIGIT_FOUR		   0xA8D4
#define Z_UNICODE_SAURASHTRA_DIGIT_FIVE		   0xA8D5
#define Z_UNICODE_SAURASHTRA_DIGIT_SIX		   0xA8D6
#define Z_UNICODE_SAURASHTRA_DIGIT_SEVEN	   0xA8D7
#define Z_UNICODE_SAURASHTRA_DIGIT_EIGHT	   0xA8D8
#define Z_UNICODE_SAURASHTRA_DIGIT_NINE		   0xA8D9

/* MARK: - A8E0h-A8FFh - Devanagari Extended */

#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_ZERO	    0xA8E0
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_ONE	    0xA8E1
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_TWO	    0xA8E2
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_THREE	    0xA8E3
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_FOUR	    0xA8E4
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_FIVE	    0xA8E5
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_SIX	    0xA8E6
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_SEVEN	    0xA8E7
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_EIGHT	    0xA8E8
#define Z_UNICODE_COMBINING_DEVANAGARI_DIGIT_NINE	    0xA8E9
#define Z_UNICODE_COMBINING_DEVANAGARI_LETTER_A		    0xA8EA
#define Z_UNICODE_COMBINING_DEVANAGARI_LETTER_U		    0xA8EB
#define Z_UNICODE_COMBINING_DEVANAGARI_LETTER_KA	    0xA8EC
#define Z_UNICODE_COMBINING_DEVANAGARI_LETTER_NA	    0xA8ED
#define Z_UNICODE_COMBINING_DEVANAGARI_LETTER_PA	    0xA8EE
#define Z_UNICODE_COMBINING_DEVANAGARI_LETTER_RA	    0xA8EF
#define Z_UNICODE_COMBINING_DEVANAGARI_LETTER_VI	    0xA8F0
#define Z_UNICODE_COMBINING_DEVANAGARI_SIGN_AVAGRAHA	    0xA8F1
#define Z_UNICODE_DEVANAGARI_SIGN_SPACING_CANDRABINDU	    0xA8F2
#define Z_UNICODE_DEVANAGARI_SIGN_CANDRABINDU_VIRAMA	    0xA8F3
#define Z_UNICODE_DEVANAGARI_SIGN_DOUBLE_CANDRABINDU_VIRAMA 0xA8F4
#define Z_UNICODE_DEVANAGARI_SIGN_CANDRABINDU_TWO	    0xA8F5
#define Z_UNICODE_DEVANAGARI_SIGN_CANDRABINDU_THREE	    0xA8F6
#define Z_UNICODE_DEVANAGARI_SIGN_CANDRABINDU_AVAGRAHA	    0xA8F7
#define Z_UNICODE_DEVANAGARI_SIGN_PUSHPIKA		    0xA8F8
#define Z_UNICODE_DEVANAGARI_GAP_FILLER			    0xA8F9
#define Z_UNICODE_DEVANAGARI_CARET			    0xA8FA
#define Z_UNICODE_DEVANAGARI_HEADSTROKE			    0xA8FB
#define Z_UNICODE_DEVANAGARI_SIGN_SIDDHAM		    0xA8FC
#define Z_UNICODE_DEVANAGARI_JAIN_OM			    0xA8FD

/* MARK: - A900h-A92Fh - Kayah Li */

#define Z_UNICODE_KAYAH_LI_DIGIT_ZERO	     0xA900
#define Z_UNICODE_KAYAH_LI_DIGIT_ONE	     0xA901
#define Z_UNICODE_KAYAH_LI_DIGIT_TWO	     0xA902
#define Z_UNICODE_KAYAH_LI_DIGIT_THREE	     0xA903
#define Z_UNICODE_KAYAH_LI_DIGIT_FOUR	     0xA904
#define Z_UNICODE_KAYAH_LI_DIGIT_FIVE	     0xA905
#define Z_UNICODE_KAYAH_LI_DIGIT_SIX	     0xA906
#define Z_UNICODE_KAYAH_LI_DIGIT_SEVEN	     0xA907
#define Z_UNICODE_KAYAH_LI_DIGIT_EIGHT	     0xA908
#define Z_UNICODE_KAYAH_LI_DIGIT_NINE	     0xA909
#define Z_UNICODE_KAYAH_LI_LETTER_KA	     0xA90A
#define Z_UNICODE_KAYAH_LI_LETTER_KHA	     0xA90B
#define Z_UNICODE_KAYAH_LI_LETTER_GA	     0xA90C
#define Z_UNICODE_KAYAH_LI_LETTER_NGA	     0xA90D
#define Z_UNICODE_KAYAH_LI_LETTER_SA	     0xA90E
#define Z_UNICODE_KAYAH_LI_LETTER_SHA	     0xA90F
#define Z_UNICODE_KAYAH_LI_LETTER_ZA	     0xA910
#define Z_UNICODE_KAYAH_LI_LETTER_NYA	     0xA911
#define Z_UNICODE_KAYAH_LI_LETTER_TA	     0xA912
#define Z_UNICODE_KAYAH_LI_LETTER_HTA	     0xA913
#define Z_UNICODE_KAYAH_LI_LETTER_NA	     0xA914
#define Z_UNICODE_KAYAH_LI_LETTER_PA	     0xA915
#define Z_UNICODE_KAYAH_LI_LETTER_PHA	     0xA916
#define Z_UNICODE_KAYAH_LI_LETTER_MA	     0xA917
#define Z_UNICODE_KAYAH_LI_LETTER_DA	     0xA918
#define Z_UNICODE_KAYAH_LI_LETTER_BA	     0xA919
#define Z_UNICODE_KAYAH_LI_LETTER_RA	     0xA91A
#define Z_UNICODE_KAYAH_LI_LETTER_YA	     0xA91B
#define Z_UNICODE_KAYAH_LI_LETTER_LA	     0xA91C
#define Z_UNICODE_KAYAH_LI_LETTER_WA	     0xA91D
#define Z_UNICODE_KAYAH_LI_LETTER_THA	     0xA91E
#define Z_UNICODE_KAYAH_LI_LETTER_HA	     0xA91F
#define Z_UNICODE_KAYAH_LI_LETTER_VA	     0xA920
#define Z_UNICODE_KAYAH_LI_LETTER_CA	     0xA921
#define Z_UNICODE_KAYAH_LI_LETTER_A	     0xA922
#define Z_UNICODE_KAYAH_LI_LETTER_OE	     0xA923
#define Z_UNICODE_KAYAH_LI_LETTER_I	     0xA924
#define Z_UNICODE_KAYAH_LI_LETTER_OO	     0xA925
#define Z_UNICODE_KAYAH_LI_VOWEL_UE	     0xA926
#define Z_UNICODE_KAYAH_LI_VOWEL_E	     0xA927
#define Z_UNICODE_KAYAH_LI_VOWEL_U	     0xA928
#define Z_UNICODE_KAYAH_LI_VOWEL_EE	     0xA929
#define Z_UNICODE_KAYAH_LI_VOWEL_O	     0xA92A
#define Z_UNICODE_KAYAH_LI_TONE_PLOPHU	     0xA92B
#define Z_UNICODE_KAYAH_LI_TONE_CALYA	     0xA92C
#define Z_UNICODE_KAYAH_LI_TONE_CALYA_PLOPHU 0xA92D
#define Z_UNICODE_KAYAH_LI_SIGN_CWI	     0xA92E
#define Z_UNICODE_KAYAH_LI_SIGN_SHYA	     0xA92F

/* MARK: - A930h-A95Fh - Rejang */

#define Z_UNICODE_REJANG_LETTER_KA	   0xA930
#define Z_UNICODE_REJANG_LETTER_GA	   0xA931
#define Z_UNICODE_REJANG_LETTER_NGA	   0xA932
#define Z_UNICODE_REJANG_LETTER_TA	   0xA933
#define Z_UNICODE_REJANG_LETTER_DA	   0xA934
#define Z_UNICODE_REJANG_LETTER_NA	   0xA935
#define Z_UNICODE_REJANG_LETTER_PA	   0xA936
#define Z_UNICODE_REJANG_LETTER_BA	   0xA937
#define Z_UNICODE_REJANG_LETTER_MA	   0xA938
#define Z_UNICODE_REJANG_LETTER_CA	   0xA939
#define Z_UNICODE_REJANG_LETTER_JA	   0xA93A
#define Z_UNICODE_REJANG_LETTER_NYA	   0xA93B
#define Z_UNICODE_REJANG_LETTER_SA	   0xA93C
#define Z_UNICODE_REJANG_LETTER_RA	   0xA93D
#define Z_UNICODE_REJANG_LETTER_LA	   0xA93E
#define Z_UNICODE_REJANG_LETTER_YA	   0xA93F
#define Z_UNICODE_REJANG_LETTER_WA	   0xA940
#define Z_UNICODE_REJANG_LETTER_HA	   0xA941
#define Z_UNICODE_REJANG_LETTER_MBA	   0xA942
#define Z_UNICODE_REJANG_LETTER_NGGA	   0xA943
#define Z_UNICODE_REJANG_LETTER_NDA	   0xA944
#define Z_UNICODE_REJANG_LETTER_NYJA	   0xA945
#define Z_UNICODE_REJANG_LETTER_A	   0xA946
#define Z_UNICODE_REJANG_VOWEL_SIGN_I	   0xA947
#define Z_UNICODE_REJANG_VOWEL_SIGN_U	   0xA948
#define Z_UNICODE_REJANG_VOWEL_SIGN_E	   0xA949
#define Z_UNICODE_REJANG_VOWEL_SIGN_AI	   0xA94A
#define Z_UNICODE_REJANG_VOWEL_SIGN_O	   0xA94B
#define Z_UNICODE_REJANG_VOWEL_SIGN_AU	   0xA94C
#define Z_UNICODE_REJANG_VOWEL_SIGN_EU	   0xA94D
#define Z_UNICODE_REJANG_VOWEL_SIGN_EA	   0xA94E
#define Z_UNICODE_REJANG_CONSONANT_SIGN_NG 0xA94F
#define Z_UNICODE_REJANG_CONSONANT_SIGN_N  0xA950
#define Z_UNICODE_REJANG_CONSONANT_SIGN_R  0xA951
#define Z_UNICODE_REJANG_CONSONANT_SIGN_H  0xA952
#define Z_UNICODE_REJANG_VIRAMA		   0xA953
#define Z_UNICODE_REJANG_SECTION_MARK	   0xA95F

/* MARK: - A960h-A97Fh - Hangul Jamo Extended-A */

#define Z_UNICODE_HANGUL_CHOSEONG_TIKEUT_MIEUM	      0xA960
#define Z_UNICODE_HANGUL_CHOSEONG_TIKEUT_PIEUP	      0xA961
#define Z_UNICODE_HANGUL_CHOSEONG_TIKEUT_SIOS	      0xA962
#define Z_UNICODE_HANGUL_CHOSEONG_TIKEUT_CIEUC	      0xA963
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_KIYEOK	      0xA964
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_SSANGKIYEOK   0xA965
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_TIKEUT	      0xA966
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_SSANGTIKEUT   0xA967
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_MIEUM	      0xA968
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_PIEUP	      0xA969
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_SSANGPIEUP    0xA96A
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_KAPYEOUNPIEUP 0xA96B
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_SIOS	      0xA96C
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_CIEUC	      0xA96D
#define Z_UNICODE_HANGUL_CHOSEONG_RIEUL_KHIEUKH	      0xA96E
#define Z_UNICODE_HANGUL_CHOSEONG_MIEUM_KIYEOK	      0xA96F
#define Z_UNICODE_HANGUL_CHOSEONG_MIEUM_TIKEUT	      0xA970
#define Z_UNICODE_HANGUL_CHOSEONG_MIEUM_SIOS	      0xA971
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_SIOS_THIEUTH  0xA972
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_KHIEUKH	      0xA973
#define Z_UNICODE_HANGUL_CHOSEONG_PIEUP_HIEUH	      0xA974
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGSIOS_PIEUP     0xA975
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_RIEUL	      0xA976
#define Z_UNICODE_HANGUL_CHOSEONG_IEUNG_HIEUH	      0xA977
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGCIEUC_HIEUH    0xA978
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGTHIEUTH	      0xA979
#define Z_UNICODE_HANGUL_CHOSEONG_PHIEUPH_HIEUH	      0xA97A
#define Z_UNICODE_HANGUL_CHOSEONG_HIEUH_SIOS	      0xA97B
#define Z_UNICODE_HANGUL_CHOSEONG_SSANGYEORINHIEUH    0xA97C

/* MARK: - A980h-A9DFh - Javanese */

#define Z_UNICODE_JAVANESE_SIGN_PANYANGGA	    0xA980
#define Z_UNICODE_JAVANESE_SIGN_CECAK		    0xA981
#define Z_UNICODE_JAVANESE_SIGN_LAYAR		    0xA982
#define Z_UNICODE_JAVANESE_SIGN_WIGNYAN		    0xA983
#define Z_UNICODE_JAVANESE_LETTER_A		    0xA984
#define Z_UNICODE_JAVANESE_LETTER_I_KAWI	    0xA985
#define Z_UNICODE_JAVANESE_LETTER_I		    0xA986
#define Z_UNICODE_JAVANESE_LETTER_II		    0xA987
#define Z_UNICODE_JAVANESE_LETTER_U		    0xA988
#define Z_UNICODE_JAVANESE_LETTER_PA_CEREK	    0xA989
#define Z_UNICODE_JAVANESE_LETTER_NGA_LELET	    0xA98A
#define Z_UNICODE_JAVANESE_LETTER_NGA_LELET_RASWADI 0xA98B
#define Z_UNICODE_JAVANESE_LETTER_E		    0xA98C
#define Z_UNICODE_JAVANESE_LETTER_AI		    0xA98D
#define Z_UNICODE_JAVANESE_LETTER_O		    0xA98E
#define Z_UNICODE_JAVANESE_LETTER_KA		    0xA98F
#define Z_UNICODE_JAVANESE_LETTER_KA_SASAK	    0xA990
#define Z_UNICODE_JAVANESE_LETTER_KA_MURDA	    0xA991
#define Z_UNICODE_JAVANESE_LETTER_GA		    0xA992
#define Z_UNICODE_JAVANESE_LETTER_GA_MURDA	    0xA993
#define Z_UNICODE_JAVANESE_LETTER_NGA		    0xA994
#define Z_UNICODE_JAVANESE_LETTER_CA		    0xA995
#define Z_UNICODE_JAVANESE_LETTER_CA_MURDA	    0xA996
#define Z_UNICODE_JAVANESE_LETTER_JA		    0xA997
#define Z_UNICODE_JAVANESE_LETTER_NYA_MURDA	    0xA998
#define Z_UNICODE_JAVANESE_LETTER_JA_MAHAPRANA	    0xA999
#define Z_UNICODE_JAVANESE_LETTER_NYA		    0xA99A
#define Z_UNICODE_JAVANESE_LETTER_TTA		    0xA99B
#define Z_UNICODE_JAVANESE_LETTER_TTA_MAHAPRANA	    0xA99C
#define Z_UNICODE_JAVANESE_LETTER_DDA		    0xA99D
#define Z_UNICODE_JAVANESE_LETTER_DDA_MAHAPRANA	    0xA99E
#define Z_UNICODE_JAVANESE_LETTER_NA_MURDA	    0xA99F
#define Z_UNICODE_JAVANESE_LETTER_TA		    0xA9A0
#define Z_UNICODE_JAVANESE_LETTER_TA_MURDA	    0xA9A1
#define Z_UNICODE_JAVANESE_LETTER_DA		    0xA9A2
#define Z_UNICODE_JAVANESE_LETTER_DA_MAHAPRANA	    0xA9A3
#define Z_UNICODE_JAVANESE_LETTER_NA		    0xA9A4
#define Z_UNICODE_JAVANESE_LETTER_PA		    0xA9A5
#define Z_UNICODE_JAVANESE_LETTER_PA_MURDA	    0xA9A6
#define Z_UNICODE_JAVANESE_LETTER_BA		    0xA9A7
#define Z_UNICODE_JAVANESE_LETTER_BA_MURDA	    0xA9A8
#define Z_UNICODE_JAVANESE_LETTER_MA		    0xA9A9
#define Z_UNICODE_JAVANESE_LETTER_YA		    0xA9AA
#define Z_UNICODE_JAVANESE_LETTER_RA		    0xA9AB
#define Z_UNICODE_JAVANESE_LETTER_RA_AGUNG	    0xA9AC
#define Z_UNICODE_JAVANESE_LETTER_LA		    0xA9AD
#define Z_UNICODE_JAVANESE_LETTER_WA		    0xA9AE
#define Z_UNICODE_JAVANESE_LETTER_SA_MURDA	    0xA9AF
#define Z_UNICODE_JAVANESE_LETTER_SA_MAHAPRANA	    0xA9B0
#define Z_UNICODE_JAVANESE_LETTER_SA		    0xA9B1
#define Z_UNICODE_JAVANESE_LETTER_HA		    0xA9B2
#define Z_UNICODE_JAVANESE_SIGN_CECAK_TELU	    0xA9B3
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_TARUNG	    0xA9B4
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_TOLONG	    0xA9B5
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_WULU	    0xA9B6
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_WULU_MELIK    0xA9B7
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_SUKU	    0xA9B8
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_SUKU_MENDUT   0xA9B9
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_TALING	    0xA9BA
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_DIRGA_MURE    0xA9BB
#define Z_UNICODE_JAVANESE_VOWEL_SIGN_PEPET	    0xA9BC
#define Z_UNICODE_JAVANESE_CONSONANT_SIGN_KERET	    0xA9BD
#define Z_UNICODE_JAVANESE_CONSONANT_SIGN_PENGKAL   0xA9BE
#define Z_UNICODE_JAVANESE_CONSONANT_SIGN_CAKRA	    0xA9BF
#define Z_UNICODE_JAVANESE_PANGKON		    0xA9C0
#define Z_UNICODE_JAVANESE_LEFT_RERENGGAN	    0xA9C1
#define Z_UNICODE_JAVANESE_RIGHT_RERENGGAN	    0xA9C2
#define Z_UNICODE_JAVANESE_PADA_ANDAP		    0xA9C3
#define Z_UNICODE_JAVANESE_PADA_MADYA		    0xA9C4
#define Z_UNICODE_JAVANESE_PADA_LUHUR		    0xA9C5
#define Z_UNICODE_JAVANESE_PADA_WINDU		    0xA9C6
#define Z_UNICODE_JAVANESE_PADA_PANGKAT		    0xA9C7
#define Z_UNICODE_JAVANESE_PADA_LINGSA		    0xA9C8
#define Z_UNICODE_JAVANESE_PADA_LUNGSI		    0xA9C9
#define Z_UNICODE_JAVANESE_PADA_ADEG		    0xA9CA
#define Z_UNICODE_JAVANESE_PADA_ADEG_ADEG	    0xA9CB
#define Z_UNICODE_JAVANESE_PADA_PISELEH		    0xA9CC
#define Z_UNICODE_JAVANESE_TURNED_PADA_PISELEH	    0xA9CD
#define Z_UNICODE_JAVANESE_PANGRANGKEP		    0xA9CF
#define Z_UNICODE_JAVANESE_DIGIT_ZERO		    0xA9D0
#define Z_UNICODE_JAVANESE_DIGIT_ONE		    0xA9D1
#define Z_UNICODE_JAVANESE_DIGIT_TWO		    0xA9D2
#define Z_UNICODE_JAVANESE_DIGIT_THREE		    0xA9D3
#define Z_UNICODE_JAVANESE_DIGIT_FOUR		    0xA9D4
#define Z_UNICODE_JAVANESE_DIGIT_FIVE		    0xA9D5
#define Z_UNICODE_JAVANESE_DIGIT_SIX		    0xA9D6
#define Z_UNICODE_JAVANESE_DIGIT_SEVEN		    0xA9D7
#define Z_UNICODE_JAVANESE_DIGIT_EIGHT		    0xA9D8
#define Z_UNICODE_JAVANESE_DIGIT_NINE		    0xA9D9
#define Z_UNICODE_JAVANESE_PADA_TIRTA_TUMETES	    0xA9DE
#define Z_UNICODE_JAVANESE_PADA_ISEN_ISEN	    0xA9DF

/* MARK: - A9E0h-A9FFh - Myanmar Extended-B */

#define Z_UNICODE_MYANMAR_LETTER_SHAN_GHA		     0xA9E0
#define Z_UNICODE_MYANMAR_LETTER_SHAN_CHA		     0xA9E1
#define Z_UNICODE_MYANMAR_LETTER_SHAN_JHA		     0xA9E2
#define Z_UNICODE_MYANMAR_LETTER_SHAN_NNA		     0xA9E3
#define Z_UNICODE_MYANMAR_LETTER_SHAN_BHA		     0xA9E4
#define Z_UNICODE_MYANMAR_SIGN_SHAN_SAW			     0xA9E5
#define Z_UNICODE_MYANMAR_MODIFIER_LETTER_SHAN_REDUPLICATION 0xA9E6
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_NYA		     0xA9E7
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_FA		     0xA9E8
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_GA		     0xA9E9
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_GHA		     0xA9EA
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_JA		     0xA9EB
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_JHA		     0xA9EC
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_DDA		     0xA9ED
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_DDHA		     0xA9EE
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_NNA		     0xA9EF
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_ZERO		     0xA9F0
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_ONE		     0xA9F1
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_TWO		     0xA9F2
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_THREE		     0xA9F3
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_FOUR		     0xA9F4
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_FIVE		     0xA9F5
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_SIX		     0xA9F6
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_SEVEN		     0xA9F7
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_EIGHT		     0xA9F8
#define Z_UNICODE_MYANMAR_TAI_LAING_DIGIT_NINE		     0xA9F9
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_LLA		     0xA9FA
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_DA		     0xA9FB
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_DHA		     0xA9FC
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_BA		     0xA9FD
#define Z_UNICODE_MYANMAR_LETTER_TAI_LAING_BHA		     0xA9FE

/* MARK: - AA00h-AA5Fh - Cham */

#define Z_UNICODE_CHAM_LETTER_A			0xAA00
#define Z_UNICODE_CHAM_LETTER_I			0xAA01
#define Z_UNICODE_CHAM_LETTER_U			0xAA02
#define Z_UNICODE_CHAM_LETTER_E			0xAA03
#define Z_UNICODE_CHAM_LETTER_AI		0xAA04
#define Z_UNICODE_CHAM_LETTER_O			0xAA05
#define Z_UNICODE_CHAM_LETTER_KA		0xAA06
#define Z_UNICODE_CHAM_LETTER_KHA		0xAA07
#define Z_UNICODE_CHAM_LETTER_GA		0xAA08
#define Z_UNICODE_CHAM_LETTER_GHA		0xAA09
#define Z_UNICODE_CHAM_LETTER_NGUE		0xAA0A
#define Z_UNICODE_CHAM_LETTER_NGA		0xAA0B
#define Z_UNICODE_CHAM_LETTER_CHA		0xAA0C
#define Z_UNICODE_CHAM_LETTER_CHHA		0xAA0D
#define Z_UNICODE_CHAM_LETTER_JA		0xAA0E
#define Z_UNICODE_CHAM_LETTER_JHA		0xAA0F
#define Z_UNICODE_CHAM_LETTER_NHUE		0xAA10
#define Z_UNICODE_CHAM_LETTER_NHA		0xAA11
#define Z_UNICODE_CHAM_LETTER_NHJA		0xAA12
#define Z_UNICODE_CHAM_LETTER_TA		0xAA13
#define Z_UNICODE_CHAM_LETTER_THA		0xAA14
#define Z_UNICODE_CHAM_LETTER_DA		0xAA15
#define Z_UNICODE_CHAM_LETTER_DHA		0xAA16
#define Z_UNICODE_CHAM_LETTER_NUE		0xAA17
#define Z_UNICODE_CHAM_LETTER_NA		0xAA18
#define Z_UNICODE_CHAM_LETTER_DDA		0xAA19
#define Z_UNICODE_CHAM_LETTER_PA		0xAA1A
#define Z_UNICODE_CHAM_LETTER_PPA		0xAA1B
#define Z_UNICODE_CHAM_LETTER_PHA		0xAA1C
#define Z_UNICODE_CHAM_LETTER_BA		0xAA1D
#define Z_UNICODE_CHAM_LETTER_BHA		0xAA1E
#define Z_UNICODE_CHAM_LETTER_MUE		0xAA1F
#define Z_UNICODE_CHAM_LETTER_MA		0xAA20
#define Z_UNICODE_CHAM_LETTER_BBA		0xAA21
#define Z_UNICODE_CHAM_LETTER_YA		0xAA22
#define Z_UNICODE_CHAM_LETTER_RA		0xAA23
#define Z_UNICODE_CHAM_LETTER_LA		0xAA24
#define Z_UNICODE_CHAM_LETTER_VA		0xAA25
#define Z_UNICODE_CHAM_LETTER_SSA		0xAA26
#define Z_UNICODE_CHAM_LETTER_SA		0xAA27
#define Z_UNICODE_CHAM_LETTER_HA		0xAA28
#define Z_UNICODE_CHAM_VOWEL_SIGN_AA		0xAA29
#define Z_UNICODE_CHAM_VOWEL_SIGN_I		0xAA2A
#define Z_UNICODE_CHAM_VOWEL_SIGN_II		0xAA2B
#define Z_UNICODE_CHAM_VOWEL_SIGN_EI		0xAA2C
#define Z_UNICODE_CHAM_VOWEL_SIGN_U		0xAA2D
#define Z_UNICODE_CHAM_VOWEL_SIGN_OE		0xAA2E
#define Z_UNICODE_CHAM_VOWEL_SIGN_O		0xAA2F
#define Z_UNICODE_CHAM_VOWEL_SIGN_AI		0xAA30
#define Z_UNICODE_CHAM_VOWEL_SIGN_AU		0xAA31
#define Z_UNICODE_CHAM_VOWEL_SIGN_UE		0xAA32
#define Z_UNICODE_CHAM_CONSONANT_SIGN_YA	0xAA33
#define Z_UNICODE_CHAM_CONSONANT_SIGN_RA	0xAA34
#define Z_UNICODE_CHAM_CONSONANT_SIGN_LA	0xAA35
#define Z_UNICODE_CHAM_CONSONANT_SIGN_WA	0xAA36
#define Z_UNICODE_CHAM_LETTER_FINAL_K		0xAA40
#define Z_UNICODE_CHAM_LETTER_FINAL_G		0xAA41
#define Z_UNICODE_CHAM_LETTER_FINAL_NG		0xAA42
#define Z_UNICODE_CHAM_CONSONANT_SIGN_FINAL_NG	0xAA43
#define Z_UNICODE_CHAM_LETTER_FINAL_CH		0xAA44
#define Z_UNICODE_CHAM_LETTER_FINAL_T		0xAA45
#define Z_UNICODE_CHAM_LETTER_FINAL_N		0xAA46
#define Z_UNICODE_CHAM_LETTER_FINAL_P		0xAA47
#define Z_UNICODE_CHAM_LETTER_FINAL_Y		0xAA48
#define Z_UNICODE_CHAM_LETTER_FINAL_R		0xAA49
#define Z_UNICODE_CHAM_LETTER_FINAL_L		0xAA4A
#define Z_UNICODE_CHAM_LETTER_FINAL_SS		0xAA4B
#define Z_UNICODE_CHAM_CONSONANT_SIGN_FINAL_M	0xAA4C
#define Z_UNICODE_CHAM_CONSONANT_SIGN_FINAL_H	0xAA4D
#define Z_UNICODE_CHAM_DIGIT_ZERO		0xAA50
#define Z_UNICODE_CHAM_DIGIT_ONE		0xAA51
#define Z_UNICODE_CHAM_DIGIT_TWO		0xAA52
#define Z_UNICODE_CHAM_DIGIT_THREE		0xAA53
#define Z_UNICODE_CHAM_DIGIT_FOUR		0xAA54
#define Z_UNICODE_CHAM_DIGIT_FIVE		0xAA55
#define Z_UNICODE_CHAM_DIGIT_SIX		0xAA56
#define Z_UNICODE_CHAM_DIGIT_SEVEN		0xAA57
#define Z_UNICODE_CHAM_DIGIT_EIGHT		0xAA58
#define Z_UNICODE_CHAM_DIGIT_NINE		0xAA59
#define Z_UNICODE_CHAM_PUNCTUATION_SPIRAL	0xAA5C
#define Z_UNICODE_CHAM_PUNCTUATION_DANDA	0xAA5D
#define Z_UNICODE_CHAM_PUNCTUATION_DOUBLE_DANDA	0xAA5E
#define Z_UNICODE_CHAM_PUNCTUATION_TRIPLE_DANDA	0xAA5F

/* MARK: - AA60h-AA7Fh - Myanmar Extended-A */

#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_GA		       0xAA60
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_CA		       0xAA61
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_CHA		       0xAA62
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_JA		       0xAA63
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_JHA		       0xAA64
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_NYA		       0xAA65
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_TTA		       0xAA66
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_TTHA		       0xAA67
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_DDA		       0xAA68
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_DDHA		       0xAA69
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_DHA		       0xAA6A
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_NA		       0xAA6B
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_SA		       0xAA6C
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_HA		       0xAA6D
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_HHA		       0xAA6E
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_FA		       0xAA6F
#define Z_UNICODE_MYANMAR_MODIFIER_LETTER_KHAMTI_REDUPLICATION 0xAA70
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_XA		       0xAA71
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_ZA		       0xAA72
#define Z_UNICODE_MYANMAR_LETTER_KHAMTI_RA		       0xAA73
#define Z_UNICODE_MYANMAR_LOGOGRAM_KHAMTI_OAY		       0xAA74
#define Z_UNICODE_MYANMAR_LOGOGRAM_KHAMTI_QN		       0xAA75
#define Z_UNICODE_MYANMAR_LOGOGRAM_KHAMTI_HM		       0xAA76
#define Z_UNICODE_MYANMAR_SYMBOL_AITON_EXCLAMATION	       0xAA77
#define Z_UNICODE_MYANMAR_SYMBOL_AITON_ONE		       0xAA78
#define Z_UNICODE_MYANMAR_SYMBOL_AITON_TWO		       0xAA79
#define Z_UNICODE_MYANMAR_LETTER_AITON_RA		       0xAA7A
#define Z_UNICODE_MYANMAR_SIGN_PAO_KAREN_TONE		       0xAA7B
#define Z_UNICODE_MYANMAR_SIGN_TAI_LAING_TONE_2		       0xAA7C
#define Z_UNICODE_MYANMAR_SIGN_TAI_LAING_TONE_5		       0xAA7D
#define Z_UNICODE_MYANMAR_LETTER_SHWE_PALAUNG_CHA	       0xAA7E
#define Z_UNICODE_MYANMAR_LETTER_SHWE_PALAUNG_SHA	       0xAA7F

/* MARK: - AA80h-AADFh - Tai Viet */

#define Z_UNICODE_TAI_VIET_LETTER_LOW_KO    0xAA80
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_KO   0xAA81
#define Z_UNICODE_TAI_VIET_LETTER_LOW_KHO   0xAA82
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_KHO  0xAA83
#define Z_UNICODE_TAI_VIET_LETTER_LOW_KHHO  0xAA84
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_KHHO 0xAA85
#define Z_UNICODE_TAI_VIET_LETTER_LOW_GO    0xAA86
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_GO   0xAA87
#define Z_UNICODE_TAI_VIET_LETTER_LOW_NGO   0xAA88
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_NGO  0xAA89
#define Z_UNICODE_TAI_VIET_LETTER_LOW_CO    0xAA8A
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_CO   0xAA8B
#define Z_UNICODE_TAI_VIET_LETTER_LOW_CHO   0xAA8C
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_CHO  0xAA8D
#define Z_UNICODE_TAI_VIET_LETTER_LOW_SO    0xAA8E
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_SO   0xAA8F
#define Z_UNICODE_TAI_VIET_LETTER_LOW_NYO   0xAA90
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_NYO  0xAA91
#define Z_UNICODE_TAI_VIET_LETTER_LOW_DO    0xAA92
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_DO   0xAA93
#define Z_UNICODE_TAI_VIET_LETTER_LOW_TO    0xAA94
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_TO   0xAA95
#define Z_UNICODE_TAI_VIET_LETTER_LOW_THO   0xAA96
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_THO  0xAA97
#define Z_UNICODE_TAI_VIET_LETTER_LOW_NO    0xAA98
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_NO   0xAA99
#define Z_UNICODE_TAI_VIET_LETTER_LOW_BO    0xAA9A
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_BO   0xAA9B
#define Z_UNICODE_TAI_VIET_LETTER_LOW_PO    0xAA9C
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_PO   0xAA9D
#define Z_UNICODE_TAI_VIET_LETTER_LOW_PHO   0xAA9E
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_PHO  0xAA9F
#define Z_UNICODE_TAI_VIET_LETTER_LOW_FO    0xAAA0
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_FO   0xAAA1
#define Z_UNICODE_TAI_VIET_LETTER_LOW_MO    0xAAA2
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_MO   0xAAA3
#define Z_UNICODE_TAI_VIET_LETTER_LOW_YO    0xAAA4
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_YO   0xAAA5
#define Z_UNICODE_TAI_VIET_LETTER_LOW_RO    0xAAA6
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_RO   0xAAA7
#define Z_UNICODE_TAI_VIET_LETTER_LOW_LO    0xAAA8
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_LO   0xAAA9
#define Z_UNICODE_TAI_VIET_LETTER_LOW_VO    0xAAAA
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_VO   0xAAAB
#define Z_UNICODE_TAI_VIET_LETTER_LOW_HO    0xAAAC
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_HO   0xAAAD
#define Z_UNICODE_TAI_VIET_LETTER_LOW_O	    0xAAAE
#define Z_UNICODE_TAI_VIET_LETTER_HIGH_O    0xAAAF
#define Z_UNICODE_TAI_VIET_MAI_KANG	    0xAAB0
#define Z_UNICODE_TAI_VIET_VOWEL_AA	    0xAAB1
#define Z_UNICODE_TAI_VIET_VOWEL_I	    0xAAB2
#define Z_UNICODE_TAI_VIET_VOWEL_UE	    0xAAB3
#define Z_UNICODE_TAI_VIET_VOWEL_U	    0xAAB4
#define Z_UNICODE_TAI_VIET_VOWEL_E	    0xAAB5
#define Z_UNICODE_TAI_VIET_VOWEL_O	    0xAAB6
#define Z_UNICODE_TAI_VIET_MAI_KHIT	    0xAAB7
#define Z_UNICODE_TAI_VIET_VOWEL_IA	    0xAAB8
#define Z_UNICODE_TAI_VIET_VOWEL_UEA	    0xAAB9
#define Z_UNICODE_TAI_VIET_VOWEL_UA	    0xAABA
#define Z_UNICODE_TAI_VIET_VOWEL_AUE	    0xAABB
#define Z_UNICODE_TAI_VIET_VOWEL_AY	    0xAABC
#define Z_UNICODE_TAI_VIET_VOWEL_AN	    0xAABD
#define Z_UNICODE_TAI_VIET_VOWEL_AM	    0xAABE
#define Z_UNICODE_TAI_VIET_TONE_MAI_EK	    0xAABF
#define Z_UNICODE_TAI_VIET_TONE_MAI_NUENG   0xAAC0
#define Z_UNICODE_TAI_VIET_TONE_MAI_THO	    0xAAC1
#define Z_UNICODE_TAI_VIET_TONE_MAI_SONG    0xAAC2
#define Z_UNICODE_TAI_VIET_SYMBOL_KON	    0xAADB
#define Z_UNICODE_TAI_VIET_SYMBOL_NUENG	    0xAADC
#define Z_UNICODE_TAI_VIET_SYMBOL_SAM	    0xAADD
#define Z_UNICODE_TAI_VIET_SYMBOL_HO_HOI    0xAADE
#define Z_UNICODE_TAI_VIET_SYMBOL_KOI_KOI   0xAADF

/* MARK: - AAE0h-AAFFh - Meetei Mayek Extensions */

#define Z_UNICODE_MEETEI_MAYEK_LETTER_E			0xAAE0
#define Z_UNICODE_MEETEI_MAYEK_LETTER_O			0xAAE1
#define Z_UNICODE_MEETEI_MAYEK_LETTER_CHA		0xAAE2
#define Z_UNICODE_MEETEI_MAYEK_LETTER_NYA		0xAAE3
#define Z_UNICODE_MEETEI_MAYEK_LETTER_TTA		0xAAE4
#define Z_UNICODE_MEETEI_MAYEK_LETTER_TTHA		0xAAE5
#define Z_UNICODE_MEETEI_MAYEK_LETTER_DDA		0xAAE6
#define Z_UNICODE_MEETEI_MAYEK_LETTER_DDHA		0xAAE7
#define Z_UNICODE_MEETEI_MAYEK_LETTER_NNA		0xAAE8
#define Z_UNICODE_MEETEI_MAYEK_LETTER_SHA		0xAAE9
#define Z_UNICODE_MEETEI_MAYEK_LETTER_SSA		0xAAEA
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_II		0xAAEB
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_UU		0xAAEC
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_AAI		0xAAED
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_AU		0xAAEE
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_AAU		0xAAEF
#define Z_UNICODE_MEETEI_MAYEK_CHEIKHAN			0xAAF0
#define Z_UNICODE_MEETEI_MAYEK_AHANG_KHUDAM		0xAAF1
#define Z_UNICODE_MEETEI_MAYEK_ANJI			0xAAF2
#define Z_UNICODE_MEETEI_MAYEK_SYLLABLE_REPETITION_MARK	0xAAF3
#define Z_UNICODE_MEETEI_MAYEK_WORD_REPETITION_MARK	0xAAF4
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_VISARGA	0xAAF5
#define Z_UNICODE_MEETEI_MAYEK_VIRAMA			0xAAF6

/* MARK: - AB00h-AB2Fh - Ethiopic Extended-A */

#define Z_UNICODE_ETHIOPIC_SYLLABLE_TTHU   0xAB01
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TTHI   0xAB02
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TTHAA  0xAB03
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TTHEE  0xAB04
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TTHE   0xAB05
#define Z_UNICODE_ETHIOPIC_SYLLABLE_TTHO   0xAB06
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDHU   0xAB09
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDHI   0xAB0A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDHAA  0xAB0B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDHEE  0xAB0C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDHE   0xAB0D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DDHO   0xAB0E
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DZU	   0xAB11
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DZI	   0xAB12
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DZAA   0xAB13
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DZEE   0xAB14
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DZE	   0xAB15
#define Z_UNICODE_ETHIOPIC_SYLLABLE_DZO	   0xAB16
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHHA  0xAB20
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHHU  0xAB21
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHHI  0xAB22
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHHAA 0xAB23
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHHEE 0xAB24
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHHE  0xAB25
#define Z_UNICODE_ETHIOPIC_SYLLABLE_CCHHO  0xAB26
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BBA	   0xAB28
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BBU	   0xAB29
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BBI	   0xAB2A
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BBAA   0xAB2B
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BBEE   0xAB2C
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BBE	   0xAB2D
#define Z_UNICODE_ETHIOPIC_SYLLABLE_BBO	   0xAB2E

/* MARK: - AB30h-AB6Fh - Latin Extended-E */

#define Z_UNICODE_LATIN_SMALL_LETTER_BARRED_ALPHA			     0xAB30
#define Z_UNICODE_LATIN_SMALL_LETTER_A_REVERSED_SCHWA			     0xAB31
#define Z_UNICODE_LATIN_SMALL_LETTER_BLACKLETTER_E			     0xAB32
#define Z_UNICODE_LATIN_SMALL_LETTER_BARRED_E				     0xAB33
#define Z_UNICODE_LATIN_SMALL_LETTER_E_WITH_FLOURISH			     0xAB34
#define Z_UNICODE_LATIN_SMALL_LETTER_LENIS_F				     0xAB35
#define Z_UNICODE_LATIN_SMALL_LETTER_SCRIPT_G_WITH_CROSSED_TAIL		     0xAB36
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_INVERTED_LAZY_S		     0xAB37
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_DOUBLE_MIDDLE_TILDE		     0xAB38
#define Z_UNICODE_LATIN_SMALL_LETTER_L_WITH_MIDDLE_RING			     0xAB39
#define Z_UNICODE_LATIN_SMALL_LETTER_M_WITH_CROSSED_TAIL		     0xAB3A
#define Z_UNICODE_LATIN_SMALL_LETTER_N_WITH_CROSSED_TAIL		     0xAB3B
#define Z_UNICODE_LATIN_SMALL_LETTER_ENG_WITH_CROSSED_TAIL		     0xAB3C
#define Z_UNICODE_LATIN_SMALL_LETTER_BLACKLETTER_O			     0xAB3D
#define Z_UNICODE_LATIN_SMALL_LETTER_BLACKLETTER_O_WITH_STROKE		     0xAB3E
#define Z_UNICODE_LATIN_SMALL_LETTER_OPEN_O_WITH_STROKE			     0xAB3F
#define Z_UNICODE_LATIN_SMALL_LETTER_INVERTED_OE			     0xAB40
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_OE_WITH_STROKE		     0xAB41
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_OE_WITH_HORIZONTAL_STROKE	     0xAB42
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_O_OPEN_O			     0xAB43
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_O_OPEN_O_WITH_STROKE	     0xAB44
#define Z_UNICODE_LATIN_SMALL_LETTER_STIRRUP_R				     0xAB45
#define Z_UNICODE_LATIN_LETTER_SMALL_CAPITAL_R_WITH_RIGHT_LEG		     0xAB46
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITHOUT_HANDLE			     0xAB47
#define Z_UNICODE_LATIN_SMALL_LETTER_DOUBLE_R				     0xAB48
#define Z_UNICODE_LATIN_SMALL_LETTER_R_WITH_CROSSED_TAIL		     0xAB49
#define Z_UNICODE_LATIN_SMALL_LETTER_DOUBLE_R_WITH_CROSSED_TAIL		     0xAB4A
#define Z_UNICODE_LATIN_SMALL_LETTER_SCRIPT_R				     0xAB4B
#define Z_UNICODE_LATIN_SMALL_LETTER_SCRIPT_R_WITH_RING			     0xAB4C
#define Z_UNICODE_LATIN_SMALL_LETTER_BASELINE_ESH			     0xAB4D
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_SHORT_RIGHT_LEG		     0xAB4E
#define Z_UNICODE_LATIN_SMALL_LETTER_U_BAR_WITH_SHORT_RIGHT_LEG		     0xAB4F
#define Z_UNICODE_LATIN_SMALL_LETTER_UI					     0xAB50
#define Z_UNICODE_LATIN_SMALL_LETTER_TURNED_UI				     0xAB51
#define Z_UNICODE_LATIN_SMALL_LETTER_U_WITH_LEFT_HOOK			     0xAB52
#define Z_UNICODE_LATIN_SMALL_LETTER_CHI				     0xAB53
#define Z_UNICODE_LATIN_SMALL_LETTER_CHI_WITH_LOW_RIGHT_RING		     0xAB54
#define Z_UNICODE_LATIN_SMALL_LETTER_CHI_WITH_LOW_LEFT_SERIF		     0xAB55
#define Z_UNICODE_LATIN_SMALL_LETTER_X_WITH_LOW_RIGHT_RING		     0xAB56
#define Z_UNICODE_LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG		     0xAB57
#define Z_UNICODE_LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG_AND_LOW_RIGHT_RING 0xAB58
#define Z_UNICODE_LATIN_SMALL_LETTER_X_WITH_LONG_LEFT_LEG_WITH_SERIF	     0xAB59
#define Z_UNICODE_LATIN_SMALL_LETTER_Y_WITH_SHORT_RIGHT_LEG		     0xAB5A
#define Z_UNICODE_MODIFIER_BREVE_WITH_INVERTED_BREVE			     0xAB5B
#define Z_UNICODE_MODIFIER_LETTER_SMALL_HENG				     0xAB5C
#define Z_UNICODE_MODIFIER_LETTER_SMALL_L_WITH_INVERTED_LAZY_S		     0xAB5D
#define Z_UNICODE_MODIFIER_LETTER_SMALL_L_WITH_MIDDLE_TILDE		     0xAB5E
#define Z_UNICODE_MODIFIER_LETTER_SMALL_U_WITH_LEFT_HOOK		     0xAB5F
#define Z_UNICODE_LATIN_SMALL_LETTER_SAKHA_YAT				     0xAB60
#define Z_UNICODE_LATIN_SMALL_LETTER_IOTIFIED_E				     0xAB61
#define Z_UNICODE_LATIN_SMALL_LETTER_OPEN_OE				     0xAB62
#define Z_UNICODE_LATIN_SMALL_LETTER_UO					     0xAB63
#define Z_UNICODE_LATIN_SMALL_LETTER_INVERTED_ALPHA			     0xAB64
#define Z_UNICODE_GREEK_LETTER_SMALL_CAPITAL_OMEGA			     0xAB65

/* MARK: - AB70h-ABBFh - Cherokee Supplement */

#define Z_UNICODE_CHEROKEE_SMALL_LETTER_A   0xAB70
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_E   0xAB71
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_I   0xAB72
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_O   0xAB73
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_U   0xAB74
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_V   0xAB75
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_GA  0xAB76
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_KA  0xAB77
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_GE  0xAB78
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_GI  0xAB79
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_GO  0xAB7A
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_GU  0xAB7B
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_GV  0xAB7C
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_HA  0xAB7D
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_HE  0xAB7E
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_HI  0xAB7F
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_HO  0xAB80
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_HU  0xAB81
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_HV  0xAB82
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_LA  0xAB83
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_LE  0xAB84
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_LI  0xAB85
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_LO  0xAB86
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_LU  0xAB87
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_LV  0xAB88
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_MA  0xAB89
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_ME  0xAB8A
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_MI  0xAB8B
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_MO  0xAB8C
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_MU  0xAB8D
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_NA  0xAB8E
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_HNA 0xAB8F
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_NAH 0xAB90
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_NE  0xAB91
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_NI  0xAB92
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_NO  0xAB93
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_NU  0xAB94
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_NV  0xAB95
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_QUA 0xAB96
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_QUE 0xAB97
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_QUI 0xAB98
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_QUO 0xAB99
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_QUU 0xAB9A
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_QUV 0xAB9B
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_SA  0xAB9C
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_S   0xAB9D
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_SE  0xAB9E
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_SI  0xAB9F
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_SO  0xABA0
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_SU  0xABA1
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_SV  0xABA2
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_DA  0xABA3
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TA  0xABA4
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_DE  0xABA5
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TE  0xABA6
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_DI  0xABA7
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TI  0xABA8
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_DO  0xABA9
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_DU  0xABAA
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_DV  0xABAB
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_DLA 0xABAC
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TLA 0xABAD
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TLE 0xABAE
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TLI 0xABAF
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TLO 0xABB0
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TLU 0xABB1
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TLV 0xABB2
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TSA 0xABB3
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TSE 0xABB4
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TSI 0xABB5
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TSO 0xABB6
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TSU 0xABB7
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_TSV 0xABB8
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_WA  0xABB9
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_WE  0xABBA
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_WI  0xABBB
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_WO  0xABBC
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_WU  0xABBD
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_WV  0xABBE
#define Z_UNICODE_CHEROKEE_SMALL_LETTER_YA  0xABBF

/* MARK: - ABC0h-ABFFh - Meetei Mayek */

#define Z_UNICODE_MEETEI_MAYEK_LETTER_KOK	  0xABC0
#define Z_UNICODE_MEETEI_MAYEK_LETTER_SAM	  0xABC1
#define Z_UNICODE_MEETEI_MAYEK_LETTER_LAI	  0xABC2
#define Z_UNICODE_MEETEI_MAYEK_LETTER_MIT	  0xABC3
#define Z_UNICODE_MEETEI_MAYEK_LETTER_PA	  0xABC4
#define Z_UNICODE_MEETEI_MAYEK_LETTER_NA	  0xABC5
#define Z_UNICODE_MEETEI_MAYEK_LETTER_CHIL	  0xABC6
#define Z_UNICODE_MEETEI_MAYEK_LETTER_TIL	  0xABC7
#define Z_UNICODE_MEETEI_MAYEK_LETTER_KHOU	  0xABC8
#define Z_UNICODE_MEETEI_MAYEK_LETTER_NGOU	  0xABC9
#define Z_UNICODE_MEETEI_MAYEK_LETTER_THOU	  0xABCA
#define Z_UNICODE_MEETEI_MAYEK_LETTER_WAI	  0xABCB
#define Z_UNICODE_MEETEI_MAYEK_LETTER_YANG	  0xABCC
#define Z_UNICODE_MEETEI_MAYEK_LETTER_HUK	  0xABCD
#define Z_UNICODE_MEETEI_MAYEK_LETTER_UN	  0xABCE
#define Z_UNICODE_MEETEI_MAYEK_LETTER_I		  0xABCF
#define Z_UNICODE_MEETEI_MAYEK_LETTER_PHAM	  0xABD0
#define Z_UNICODE_MEETEI_MAYEK_LETTER_ATIYA	  0xABD1
#define Z_UNICODE_MEETEI_MAYEK_LETTER_GOK	  0xABD2
#define Z_UNICODE_MEETEI_MAYEK_LETTER_JHAM	  0xABD3
#define Z_UNICODE_MEETEI_MAYEK_LETTER_RAI	  0xABD4
#define Z_UNICODE_MEETEI_MAYEK_LETTER_BA	  0xABD5
#define Z_UNICODE_MEETEI_MAYEK_LETTER_JIL	  0xABD6
#define Z_UNICODE_MEETEI_MAYEK_LETTER_DIL	  0xABD7
#define Z_UNICODE_MEETEI_MAYEK_LETTER_GHOU	  0xABD8
#define Z_UNICODE_MEETEI_MAYEK_LETTER_DHOU	  0xABD9
#define Z_UNICODE_MEETEI_MAYEK_LETTER_BHAM	  0xABDA
#define Z_UNICODE_MEETEI_MAYEK_LETTER_KOK_LONSUM  0xABDB
#define Z_UNICODE_MEETEI_MAYEK_LETTER_LAI_LONSUM  0xABDC
#define Z_UNICODE_MEETEI_MAYEK_LETTER_MIT_LONSUM  0xABDD
#define Z_UNICODE_MEETEI_MAYEK_LETTER_PA_LONSUM	  0xABDE
#define Z_UNICODE_MEETEI_MAYEK_LETTER_NA_LONSUM	  0xABDF
#define Z_UNICODE_MEETEI_MAYEK_LETTER_TIL_LONSUM  0xABE0
#define Z_UNICODE_MEETEI_MAYEK_LETTER_NGOU_LONSUM 0xABE1
#define Z_UNICODE_MEETEI_MAYEK_LETTER_I_LONSUM	  0xABE2
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_ONAP	  0xABE3
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_INAP	  0xABE4
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_ANAP	  0xABE5
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_YENAP	  0xABE6
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_SOUNAP  0xABE7
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_UNAP	  0xABE8
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_CHEINAP 0xABE9
#define Z_UNICODE_MEETEI_MAYEK_VOWEL_SIGN_NUNG	  0xABEA
#define Z_UNICODE_MEETEI_MAYEK_CHEIKHEI		  0xABEB
#define Z_UNICODE_MEETEI_MAYEK_LUM_IYEK		  0xABEC
#define Z_UNICODE_MEETEI_MAYEK_APUN_IYEK	  0xABED
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_ZERO	  0xABF0
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_ONE	  0xABF1
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_TWO	  0xABF2
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_THREE	  0xABF3
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_FOUR	  0xABF4
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_FIVE	  0xABF5
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_SIX	  0xABF6
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_SEVEN	  0xABF7
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_EIGHT	  0xABF8
#define Z_UNICODE_MEETEI_MAYEK_DIGIT_NINE	  0xABF9

/* MARK: - AC00h-D7A3h - Hangul Syllables */

/* MARK: - D7B0h-D7FFh - Hangul Jamo Extended-B */

#define Z_UNICODE_HANGUL_JUNGSEONG_O_YEO		   0xD7B0
#define Z_UNICODE_HANGUL_JUNGSEONG_O_O_I		   0xD7B1
#define Z_UNICODE_HANGUL_JUNGSEONG_YO_A			   0xD7B2
#define Z_UNICODE_HANGUL_JUNGSEONG_YO_AE		   0xD7B3
#define Z_UNICODE_HANGUL_JUNGSEONG_YO_EO		   0xD7B4
#define Z_UNICODE_HANGUL_JUNGSEONG_U_YEO		   0xD7B5
#define Z_UNICODE_HANGUL_JUNGSEONG_U_I_I		   0xD7B6
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_AE		   0xD7B7
#define Z_UNICODE_HANGUL_JUNGSEONG_YU_O			   0xD7B8
#define Z_UNICODE_HANGUL_JUNGSEONG_EU_A			   0xD7B9
#define Z_UNICODE_HANGUL_JUNGSEONG_EU_EO		   0xD7BA
#define Z_UNICODE_HANGUL_JUNGSEONG_EU_E			   0xD7BB
#define Z_UNICODE_HANGUL_JUNGSEONG_EU_O			   0xD7BC
#define Z_UNICODE_HANGUL_JUNGSEONG_I_YA_O		   0xD7BD
#define Z_UNICODE_HANGUL_JUNGSEONG_I_YAE		   0xD7BE
#define Z_UNICODE_HANGUL_JUNGSEONG_I_YEO		   0xD7BF
#define Z_UNICODE_HANGUL_JUNGSEONG_I_YE			   0xD7C0
#define Z_UNICODE_HANGUL_JUNGSEONG_I_O_I		   0xD7C1
#define Z_UNICODE_HANGUL_JUNGSEONG_I_YO			   0xD7C2
#define Z_UNICODE_HANGUL_JUNGSEONG_I_YU			   0xD7C3
#define Z_UNICODE_HANGUL_JUNGSEONG_I_I			   0xD7C4
#define Z_UNICODE_HANGUL_JUNGSEONG_ARAEA_A		   0xD7C5
#define Z_UNICODE_HANGUL_JUNGSEONG_ARAEA_E		   0xD7C6
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_RIEUL		   0xD7CB
#define Z_UNICODE_HANGUL_JONGSEONG_NIEUN_CHIEUCH	   0xD7CC
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGTIKEUT		   0xD7CD
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGTIKEUT_PIEUP	   0xD7CE
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT_PIEUP		   0xD7CF
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT_SIOS		   0xD7D0
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT_SIOS_KIYEOK	   0xD7D1
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT_CIEUC		   0xD7D2
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT_CHIEUCH	   0xD7D3
#define Z_UNICODE_HANGUL_JONGSEONG_TIKEUT_THIEUTH	   0xD7D4
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_SSANGKIYEOK	   0xD7D5
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_KIYEOK_HIEUH	   0xD7D6
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGRIEUL_KHIEUKH	   0xD7D7
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_MIEUM_HIEUH	   0xD7D8
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_PIEUP_TIKEUT	   0xD7D9
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_PIEUP_PHIEUPH	   0xD7DA
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_YESIEUNG	   0xD7DB
#define Z_UNICODE_HANGUL_JONGSEONG_RIEUL_YEORINHIEUH_HIEUH 0xD7DC
#define Z_UNICODE_HANGUL_JONGSEONG_KAPYEOUNRIEUL	   0xD7DD
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_NIEUN		   0xD7DE
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_SSANGNIEUN	   0xD7DF
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGMIEUM		   0xD7E0
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_PIEUP_SIOS	   0xD7E1
#define Z_UNICODE_HANGUL_JONGSEONG_MIEUM_CIEUC		   0xD7E2
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_TIKEUT		   0xD7E3
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_RIEUL_PHIEUPH	   0xD7E4
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_MIEUM		   0xD7E5
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGPIEUP		   0xD7E6
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_SIOS_TIKEUT	   0xD7E7
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_CIEUC		   0xD7E8
#define Z_UNICODE_HANGUL_JONGSEONG_PIEUP_CHIEUCH	   0xD7E9
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_MIEUM		   0xD7EA
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_KAPYEOUNPIEUP	   0xD7EB
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGSIOS_KIYEOK	   0xD7EC
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGSIOS_TIKEUT	   0xD7ED
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_PANSIOS		   0xD7EE
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_CIEUC		   0xD7EF
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_CHIEUCH		   0xD7F0
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_THIEUTH		   0xD7F1
#define Z_UNICODE_HANGUL_JONGSEONG_SIOS_HIEUH		   0xD7F2
#define Z_UNICODE_HANGUL_JONGSEONG_PANSIOS_PIEUP	   0xD7F3
#define Z_UNICODE_HANGUL_JONGSEONG_PANSIOS_KAPYEOUNPIEUP   0xD7F4
#define Z_UNICODE_HANGUL_JONGSEONG_YESIEUNG_MIEUM	   0xD7F5
#define Z_UNICODE_HANGUL_JONGSEONG_YESIEUNG_HIEUH	   0xD7F6
#define Z_UNICODE_HANGUL_JONGSEONG_CIEUC_PIEUP		   0xD7F7
#define Z_UNICODE_HANGUL_JONGSEONG_CIEUC_SSANGPIEUP	   0xD7F8
#define Z_UNICODE_HANGUL_JONGSEONG_SSANGCIEUC		   0xD7F9
#define Z_UNICODE_HANGUL_JONGSEONG_PHIEUPH_SIOS		   0xD7FA
#define Z_UNICODE_HANGUL_JONGSEONG_PHIEUPH_THIEUTH	   0xD7FB

/* MARK: - D800h-DB7Fh - High Surrogates */
/* MARK: - DB80h-DBFFh - High Private Use Surrogates */
/* MARK: - DC00h-DFFFh - Low Surrogates */
/* MARK: - E000h-F8FFh - Private Use Area */

/* MARK: - F900h-FAFFh - CJK Compatibility Ideographs */

#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F900 0xF900
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F901 0xF901
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F902 0xF902
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F903 0xF903
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F904 0xF904
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F905 0xF905
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F906 0xF906
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F907 0xF907
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F908 0xF908
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F909 0xF909
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F90A 0xF90A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F90B 0xF90B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F90C 0xF90C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F90D 0xF90D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F90E 0xF90E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F90F 0xF90F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F910 0xF910
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F911 0xF911
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F912 0xF912
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F913 0xF913
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F914 0xF914
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F915 0xF915
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F916 0xF916
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F917 0xF917
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F918 0xF918
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F919 0xF919
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F91A 0xF91A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F91B 0xF91B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F91C 0xF91C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F91D 0xF91D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F91E 0xF91E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F91F 0xF91F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F920 0xF920
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F921 0xF921
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F922 0xF922
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F923 0xF923
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F924 0xF924
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F925 0xF925
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F926 0xF926
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F927 0xF927
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F928 0xF928
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F929 0xF929
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F92A 0xF92A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F92B 0xF92B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F92C 0xF92C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F92D 0xF92D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F92E 0xF92E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F92F 0xF92F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F930 0xF930
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F931 0xF931
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F932 0xF932
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F933 0xF933
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F934 0xF934
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F935 0xF935
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F936 0xF936
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F937 0xF937
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F938 0xF938
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F939 0xF939
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F93A 0xF93A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F93B 0xF93B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F93C 0xF93C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F93D 0xF93D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F93E 0xF93E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F93F 0xF93F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F940 0xF940
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F941 0xF941
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F942 0xF942
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F943 0xF943
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F944 0xF944
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F945 0xF945
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F946 0xF946
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F947 0xF947
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F948 0xF948
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F949 0xF949
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F94A 0xF94A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F94B 0xF94B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F94C 0xF94C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F94D 0xF94D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F94E 0xF94E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F94F 0xF94F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F950 0xF950
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F951 0xF951
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F952 0xF952
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F953 0xF953
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F954 0xF954
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F955 0xF955
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F956 0xF956
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F957 0xF957
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F958 0xF958
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F959 0xF959
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F95A 0xF95A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F95B 0xF95B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F95C 0xF95C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F95D 0xF95D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F95E 0xF95E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F95F 0xF95F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F960 0xF960
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F961 0xF961
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F962 0xF962
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F963 0xF963
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F964 0xF964
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F965 0xF965
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F966 0xF966
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F967 0xF967
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F968 0xF968
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F969 0xF969
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F96A 0xF96A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F96B 0xF96B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F96C 0xF96C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F96D 0xF96D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F96E 0xF96E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F96F 0xF96F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F970 0xF970
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F971 0xF971
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F972 0xF972
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F973 0xF973
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F974 0xF974
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F975 0xF975
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F976 0xF976
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F977 0xF977
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F978 0xF978
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F979 0xF979
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F97A 0xF97A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F97B 0xF97B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F97C 0xF97C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F97D 0xF97D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F97E 0xF97E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F97F 0xF97F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F980 0xF980
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F981 0xF981
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F982 0xF982
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F983 0xF983
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F984 0xF984
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F985 0xF985
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F986 0xF986
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F987 0xF987
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F988 0xF988
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F989 0xF989
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F98A 0xF98A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F98B 0xF98B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F98C 0xF98C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F98D 0xF98D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F98E 0xF98E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F98F 0xF98F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F990 0xF990
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F991 0xF991
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F992 0xF992
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F993 0xF993
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F994 0xF994
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F995 0xF995
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F996 0xF996
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F997 0xF997
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F998 0xF998
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F999 0xF999
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F99A 0xF99A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F99B 0xF99B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F99C 0xF99C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F99D 0xF99D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F99E 0xF99E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F99F 0xF99F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A0 0xF9A0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A1 0xF9A1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A2 0xF9A2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A3 0xF9A3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A4 0xF9A4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A5 0xF9A5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A6 0xF9A6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A7 0xF9A7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A8 0xF9A8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9A9 0xF9A9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9AA 0xF9AA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9AB 0xF9AB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9AC 0xF9AC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9AD 0xF9AD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9AE 0xF9AE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9AF 0xF9AF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B0 0xF9B0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B1 0xF9B1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B2 0xF9B2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B3 0xF9B3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B4 0xF9B4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B5 0xF9B5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B6 0xF9B6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B7 0xF9B7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B8 0xF9B8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9B9 0xF9B9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9BA 0xF9BA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9BB 0xF9BB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9BC 0xF9BC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9BD 0xF9BD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9BE 0xF9BE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9BF 0xF9BF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C0 0xF9C0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C1 0xF9C1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C2 0xF9C2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C3 0xF9C3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C4 0xF9C4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C5 0xF9C5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C6 0xF9C6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C7 0xF9C7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C8 0xF9C8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9C9 0xF9C9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9CA 0xF9CA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9CB 0xF9CB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9CC 0xF9CC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9CD 0xF9CD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9CE 0xF9CE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9CF 0xF9CF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D0 0xF9D0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D1 0xF9D1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D2 0xF9D2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D3 0xF9D3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D4 0xF9D4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D5 0xF9D5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D6 0xF9D6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D7 0xF9D7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D8 0xF9D8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9D9 0xF9D9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9DA 0xF9DA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9DB 0xF9DB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9DC 0xF9DC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9DD 0xF9DD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9DE 0xF9DE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9DF 0xF9DF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E0 0xF9E0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E1 0xF9E1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E2 0xF9E2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E3 0xF9E3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E4 0xF9E4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E5 0xF9E5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E6 0xF9E6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E7 0xF9E7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E8 0xF9E8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9E9 0xF9E9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9EA 0xF9EA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9EB 0xF9EB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9EC 0xF9EC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9ED 0xF9ED
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9EE 0xF9EE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9EF 0xF9EF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F0 0xF9F0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F1 0xF9F1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F2 0xF9F2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F3 0xF9F3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F4 0xF9F4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F5 0xF9F5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F6 0xF9F6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F7 0xF9F7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F8 0xF9F8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9F9 0xF9F9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9FA 0xF9FA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9FB 0xF9FB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9FC 0xF9FC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9FD 0xF9FD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9FE 0xF9FE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_F9FF 0xF9FF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA00 0xFA00
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA01 0xFA01
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA02 0xFA02
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA03 0xFA03
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA04 0xFA04
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA05 0xFA05
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA06 0xFA06
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA07 0xFA07
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA08 0xFA08
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA09 0xFA09
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA0A 0xFA0A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA0B 0xFA0B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA0C 0xFA0C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA0D 0xFA0D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA0E 0xFA0E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA0F 0xFA0F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA10 0xFA10
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA11 0xFA11
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA12 0xFA12
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA13 0xFA13
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA14 0xFA14
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA15 0xFA15
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA16 0xFA16
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA17 0xFA17
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA18 0xFA18
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA19 0xFA19
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA1A 0xFA1A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA1B 0xFA1B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA1C 0xFA1C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA1D 0xFA1D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA1E 0xFA1E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA1F 0xFA1F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA20 0xFA20
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA21 0xFA21
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA22 0xFA22
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA23 0xFA23
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA24 0xFA24
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA25 0xFA25
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA26 0xFA26
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA27 0xFA27
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA28 0xFA28
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA29 0xFA29
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA2A 0xFA2A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA2B 0xFA2B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA2C 0xFA2C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA2D 0xFA2D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA2E 0xFA2E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA2F 0xFA2F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA30 0xFA30
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA31 0xFA31
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA32 0xFA32
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA33 0xFA33
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA34 0xFA34
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA35 0xFA35
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA36 0xFA36
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA37 0xFA37
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA38 0xFA38
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA39 0xFA39
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA3A 0xFA3A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA3B 0xFA3B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA3C 0xFA3C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA3D 0xFA3D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA3E 0xFA3E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA3F 0xFA3F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA40 0xFA40
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA41 0xFA41
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA42 0xFA42
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA43 0xFA43
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA44 0xFA44
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA45 0xFA45
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA46 0xFA46
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA47 0xFA47
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA48 0xFA48
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA49 0xFA49
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA4A 0xFA4A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA4B 0xFA4B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA4C 0xFA4C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA4D 0xFA4D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA4E 0xFA4E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA4F 0xFA4F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA50 0xFA50
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA51 0xFA51
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA52 0xFA52
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA53 0xFA53
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA54 0xFA54
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA55 0xFA55
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA56 0xFA56
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA57 0xFA57
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA58 0xFA58
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA59 0xFA59
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA5A 0xFA5A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA5B 0xFA5B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA5C 0xFA5C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA5D 0xFA5D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA5E 0xFA5E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA5F 0xFA5F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA60 0xFA60
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA61 0xFA61
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA62 0xFA62
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA63 0xFA63
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA64 0xFA64
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA65 0xFA65
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA66 0xFA66
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA67 0xFA67
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA68 0xFA68
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA69 0xFA69
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA6A 0xFA6A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA6B 0xFA6B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA6C 0xFA6C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA6D 0xFA6D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA70 0xFA70
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA71 0xFA71
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA72 0xFA72
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA73 0xFA73
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA74 0xFA74
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA75 0xFA75
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA76 0xFA76
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA77 0xFA77
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA78 0xFA78
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA79 0xFA79
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA7A 0xFA7A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA7B 0xFA7B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA7C 0xFA7C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA7D 0xFA7D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA7E 0xFA7E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA7F 0xFA7F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA80 0xFA80
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA81 0xFA81
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA82 0xFA82
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA83 0xFA83
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA84 0xFA84
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA85 0xFA85
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA86 0xFA86
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA87 0xFA87
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA88 0xFA88
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA89 0xFA89
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA8A 0xFA8A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA8B 0xFA8B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA8C 0xFA8C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA8D 0xFA8D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA8E 0xFA8E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA8F 0xFA8F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA90 0xFA90
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA91 0xFA91
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA92 0xFA92
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA93 0xFA93
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA94 0xFA94
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA95 0xFA95
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA96 0xFA96
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA97 0xFA97
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA98 0xFA98
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA99 0xFA99
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA9A 0xFA9A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA9B 0xFA9B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA9C 0xFA9C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA9D 0xFA9D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA9E 0xFA9E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FA9F 0xFA9F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA0 0xFAA0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA1 0xFAA1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA2 0xFAA2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA3 0xFAA3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA4 0xFAA4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA5 0xFAA5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA6 0xFAA6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA7 0xFAA7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA8 0xFAA8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAA9 0xFAA9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAAA 0xFAAA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAAB 0xFAAB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAAC 0xFAAC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAAD 0xFAAD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAAE 0xFAAE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAAF 0xFAAF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB0 0xFAB0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB1 0xFAB1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB2 0xFAB2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB3 0xFAB3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB4 0xFAB4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB5 0xFAB5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB6 0xFAB6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB7 0xFAB7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB8 0xFAB8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAB9 0xFAB9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FABA 0xFABA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FABB 0xFABB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FABC 0xFABC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FABD 0xFABD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FABE 0xFABE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FABF 0xFABF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC0 0xFAC0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC1 0xFAC1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC2 0xFAC2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC3 0xFAC3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC4 0xFAC4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC5 0xFAC5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC6 0xFAC6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC7 0xFAC7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC8 0xFAC8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAC9 0xFAC9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FACA 0xFACA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FACB 0xFACB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FACC 0xFACC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FACD 0xFACD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FACE 0xFACE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FACF 0xFACF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD0 0xFAD0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD1 0xFAD1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD2 0xFAD2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD3 0xFAD3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD4 0xFAD4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD5 0xFAD5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD6 0xFAD6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD7 0xFAD7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD8 0xFAD8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_FAD9 0xFAD9

/* MARK: - FB00h-FB4Fh - Alphabetic Presentation Forms */

#define Z_UNICODE_LATIN_SMALL_LIGATURE_FF		      0xFB00
#define Z_UNICODE_LATIN_SMALL_LIGATURE_FI		      0xFB01
#define Z_UNICODE_LATIN_SMALL_LIGATURE_FL		      0xFB02
#define Z_UNICODE_LATIN_SMALL_LIGATURE_FFI		      0xFB03
#define Z_UNICODE_LATIN_SMALL_LIGATURE_FFL		      0xFB04
#define Z_UNICODE_LATIN_SMALL_LIGATURE_LONG_S_T		      0xFB05
#define Z_UNICODE_LATIN_SMALL_LIGATURE_ST		      0xFB06
#define Z_UNICODE_ARMENIAN_SMALL_LIGATURE_MEN_NOW	      0xFB13
#define Z_UNICODE_ARMENIAN_SMALL_LIGATURE_MEN_ECH	      0xFB14
#define Z_UNICODE_ARMENIAN_SMALL_LIGATURE_MEN_INI	      0xFB15
#define Z_UNICODE_ARMENIAN_SMALL_LIGATURE_VEW_NOW	      0xFB16
#define Z_UNICODE_ARMENIAN_SMALL_LIGATURE_MEN_XEH	      0xFB17
#define Z_UNICODE_HEBREW_LETTER_YOD_WITH_HIRIQ		      0xFB1D
#define Z_UNICODE_HEBREW_POINT_JUDEO_SPANISH_VARIKA	      0xFB1E
#define Z_UNICODE_HEBREW_LIGATURE_YIDDISH_YOD_YOD_PATAH	      0xFB1F
#define Z_UNICODE_HEBREW_LETTER_ALTERNATIVE_AYIN	      0xFB20
#define Z_UNICODE_HEBREW_LETTER_WIDE_ALEF		      0xFB21
#define Z_UNICODE_HEBREW_LETTER_WIDE_DALET		      0xFB22
#define Z_UNICODE_HEBREW_LETTER_WIDE_HE			      0xFB23
#define Z_UNICODE_HEBREW_LETTER_WIDE_KAF		      0xFB24
#define Z_UNICODE_HEBREW_LETTER_WIDE_LAMED		      0xFB25
#define Z_UNICODE_HEBREW_LETTER_WIDE_FINAL_MEM		      0xFB26
#define Z_UNICODE_HEBREW_LETTER_WIDE_RESH		      0xFB27
#define Z_UNICODE_HEBREW_LETTER_WIDE_TAV		      0xFB28
#define Z_UNICODE_HEBREW_LETTER_ALTERNATIVE_PLUS_SIGN	      0xFB29
#define Z_UNICODE_HEBREW_LETTER_SHIN_WITH_SHIN_DOT	      0xFB2A
#define Z_UNICODE_HEBREW_LETTER_SHIN_WITH_SIN_DOT	      0xFB2B
#define Z_UNICODE_HEBREW_LETTER_SHIN_WITH_DAGESH_AND_SHIN_DOT 0xFB2C
#define Z_UNICODE_HEBREW_LETTER_SHIN_WITH_DAGESH_AND_SIN_DOT  0xFB2D
#define Z_UNICODE_HEBREW_LETTER_ALEF_WITH_PATAH		      0xFB2E
#define Z_UNICODE_HEBREW_LETTER_ALEF_WITH_QAMATS	      0xFB2F
#define Z_UNICODE_HEBREW_LETTER_ALEF_WITH_MAPIQ		      0xFB30
#define Z_UNICODE_HEBREW_LETTER_BET_WITH_DAGESH		      0xFB31
#define Z_UNICODE_HEBREW_LETTER_GIMEL_WITH_DAGESH	      0xFB32
#define Z_UNICODE_HEBREW_LETTER_DALET_WITH_DAGESH	      0xFB33
#define Z_UNICODE_HEBREW_LETTER_HE_WITH_MAPIQ		      0xFB34
#define Z_UNICODE_HEBREW_LETTER_VAV_WITH_DAGESH		      0xFB35
#define Z_UNICODE_HEBREW_LETTER_ZAYIN_WITH_DAGESH	      0xFB36
#define Z_UNICODE_HEBREW_LETTER_TET_WITH_DAGESH		      0xFB38
#define Z_UNICODE_HEBREW_LETTER_YOD_WITH_DAGESH		      0xFB39
#define Z_UNICODE_HEBREW_LETTER_FINAL_KAF_WITH_DAGESH	      0xFB3A
#define Z_UNICODE_HEBREW_LETTER_KAF_WITH_DAGESH		      0xFB3B
#define Z_UNICODE_HEBREW_LETTER_LAMED_WITH_DAGESH	      0xFB3C
#define Z_UNICODE_HEBREW_LETTER_MEM_WITH_DAGESH		      0xFB3E
#define Z_UNICODE_HEBREW_LETTER_NUN_WITH_DAGESH		      0xFB40
#define Z_UNICODE_HEBREW_LETTER_SAMEKH_WITH_DAGESH	      0xFB41
#define Z_UNICODE_HEBREW_LETTER_FINAL_PE_WITH_DAGESH	      0xFB43
#define Z_UNICODE_HEBREW_LETTER_PE_WITH_DAGESH		      0xFB44
#define Z_UNICODE_HEBREW_LETTER_TSADI_WITH_DAGESH	      0xFB46
#define Z_UNICODE_HEBREW_LETTER_QOF_WITH_DAGESH		      0xFB47
#define Z_UNICODE_HEBREW_LETTER_RESH_WITH_DAGESH	      0xFB48
#define Z_UNICODE_HEBREW_LETTER_SHIN_WITH_DAGESH	      0xFB49
#define Z_UNICODE_HEBREW_LETTER_TAV_WITH_DAGESH		      0xFB4A
#define Z_UNICODE_HEBREW_LETTER_VAV_WITH_HOLAM		      0xFB4B
#define Z_UNICODE_HEBREW_LETTER_BET_WITH_RAFE		      0xFB4C
#define Z_UNICODE_HEBREW_LETTER_KAF_WITH_RAFE		      0xFB4D
#define Z_UNICODE_HEBREW_LETTER_PE_WITH_RAFE		      0xFB4E
#define Z_UNICODE_HEBREW_LIGATURE_ALEF_LAMED		      0xFB4F

/* MARK: - FB50h-FDFFh - Arabic Presentation Forms-A */

/* FDD0h <not a character> */
/* FDD1h <not a character> */
/* FDD2h <not a character> */
/* FDD3h <not a character> */
/* FDD4h <not a character> */
/* FDD5h <not a character> */
/* FDD6h <not a character> */
/* FDD7h <not a character> */
/* FDD8h <not a character> */
/* FDD9h <not a character> */
/* FDDAh <not a character> */
/* FDDBh <not a character> */
/* FDDCh <not a character> */
/* FDDDh <not a character> */
/* FDDEh <not a character> */
/* FDDFh <not a character> */
/* FDE0h <not a character> */
/* FDE1h <not a character> */
/* FDE2h <not a character> */
/* FDE3h <not a character> */
/* FDE4h <not a character> */
/* FDE5h <not a character> */
/* FDE6h <not a character> */
/* FDE7h <not a character> */
/* FDE8h <not a character> */
/* FDE9h <not a character> */
/* FDEAh <not a character> */
/* FDEBh <not a character> */
/* FDECh <not a character> */
/* FDEDh <not a character> */
/* FDEEh <not a character> */
/* FDEFh <not a character> */
#define Z_UNICODE_ARABIC_LETTER_ALEF_WASLA_ISOLATED_FORM					      0xFB50
#define Z_UNICODE_ARABIC_LETTER_ALEF_WASLA_FINAL_FORM						      0xFB51
#define Z_UNICODE_ARABIC_LETTER_BEEH_ISOLATED_FORM						      0xFB52
#define Z_UNICODE_ARABIC_LETTER_BEEH_FINAL_FORM							      0xFB53
#define Z_UNICODE_ARABIC_LETTER_BEEH_INITIAL_FORM						      0xFB54
#define Z_UNICODE_ARABIC_LETTER_BEEH_MEDIAL_FORM						      0xFB55
#define Z_UNICODE_ARABIC_LETTER_PEH_ISOLATED_FORM						      0xFB56
#define Z_UNICODE_ARABIC_LETTER_PEH_FINAL_FORM							      0xFB57
#define Z_UNICODE_ARABIC_LETTER_PEH_INITIAL_FORM						      0xFB58
#define Z_UNICODE_ARABIC_LETTER_PEH_MEDIAL_FORM							      0xFB59
#define Z_UNICODE_ARABIC_LETTER_BEHEH_ISOLATED_FORM						      0xFB5A
#define Z_UNICODE_ARABIC_LETTER_BEHEH_FINAL_FORM						      0xFB5B
#define Z_UNICODE_ARABIC_LETTER_BEHEH_INITIAL_FORM						      0xFB5C
#define Z_UNICODE_ARABIC_LETTER_BEHEH_MEDIAL_FORM						      0xFB5D
#define Z_UNICODE_ARABIC_LETTER_TTEHEH_ISOLATED_FORM						      0xFB5E
#define Z_UNICODE_ARABIC_LETTER_TTEHEH_FINAL_FORM						      0xFB5F
#define Z_UNICODE_ARABIC_LETTER_TTEHEH_INITIAL_FORM						      0xFB60
#define Z_UNICODE_ARABIC_LETTER_TTEHEH_MEDIAL_FORM						      0xFB61
#define Z_UNICODE_ARABIC_LETTER_TEHEH_ISOLATED_FORM						      0xFB62
#define Z_UNICODE_ARABIC_LETTER_TEHEH_FINAL_FORM						      0xFB63
#define Z_UNICODE_ARABIC_LETTER_TEHEH_INITIAL_FORM						      0xFB64
#define Z_UNICODE_ARABIC_LETTER_TEHEH_MEDIAL_FORM						      0xFB65
#define Z_UNICODE_ARABIC_LETTER_TTEH_ISOLATED_FORM						      0xFB66
#define Z_UNICODE_ARABIC_LETTER_TTEH_FINAL_FORM							      0xFB67
#define Z_UNICODE_ARABIC_LETTER_TTEH_INITIAL_FORM						      0xFB68
#define Z_UNICODE_ARABIC_LETTER_TTEH_MEDIAL_FORM						      0xFB69
#define Z_UNICODE_ARABIC_LETTER_VEH_ISOLATED_FORM						      0xFB6A
#define Z_UNICODE_ARABIC_LETTER_VEH_FINAL_FORM							      0xFB6B
#define Z_UNICODE_ARABIC_LETTER_VEH_INITIAL_FORM						      0xFB6C
#define Z_UNICODE_ARABIC_LETTER_VEH_MEDIAL_FORM							      0xFB6D
#define Z_UNICODE_ARABIC_LETTER_PEHEH_ISOLATED_FORM						      0xFB6E
#define Z_UNICODE_ARABIC_LETTER_PEHEH_FINAL_FORM						      0xFB6F
#define Z_UNICODE_ARABIC_LETTER_PEHEH_INITIAL_FORM						      0xFB70
#define Z_UNICODE_ARABIC_LETTER_PEHEH_MEDIAL_FORM						      0xFB71
#define Z_UNICODE_ARABIC_LETTER_DYEH_ISOLATED_FORM						      0xFB72
#define Z_UNICODE_ARABIC_LETTER_DYEH_FINAL_FORM							      0xFB73
#define Z_UNICODE_ARABIC_LETTER_DYEH_INITIAL_FORM						      0xFB74
#define Z_UNICODE_ARABIC_LETTER_DYEH_MEDIAL_FORM						      0xFB75
#define Z_UNICODE_ARABIC_LETTER_NYEH_ISOLATED_FORM						      0xFB76
#define Z_UNICODE_ARABIC_LETTER_NYEH_FINAL_FORM							      0xFB77
#define Z_UNICODE_ARABIC_LETTER_NYEH_INITIAL_FORM						      0xFB78
#define Z_UNICODE_ARABIC_LETTER_NYEH_MEDIAL_FORM						      0xFB79
#define Z_UNICODE_ARABIC_LETTER_TCHEH_ISOLATED_FORM						      0xFB7A
#define Z_UNICODE_ARABIC_LETTER_TCHEH_FINAL_FORM						      0xFB7B
#define Z_UNICODE_ARABIC_LETTER_TCHEH_INITIAL_FORM						      0xFB7C
#define Z_UNICODE_ARABIC_LETTER_TCHEH_MEDIAL_FORM						      0xFB7D
#define Z_UNICODE_ARABIC_LETTER_TCHEHEH_ISOLATED_FORM						      0xFB7E
#define Z_UNICODE_ARABIC_LETTER_TCHEHEH_FINAL_FORM						      0xFB7F
#define Z_UNICODE_ARABIC_LETTER_TCHEHEH_INITIAL_FORM						      0xFB80
#define Z_UNICODE_ARABIC_LETTER_TCHEHEH_MEDIAL_FORM						      0xFB81
#define Z_UNICODE_ARABIC_LETTER_DDAHAL_ISOLATED_FORM						      0xFB82
#define Z_UNICODE_ARABIC_LETTER_DDAHAL_FINAL_FORM						      0xFB83
#define Z_UNICODE_ARABIC_LETTER_DAHAL_ISOLATED_FORM						      0xFB84
#define Z_UNICODE_ARABIC_LETTER_DAHAL_FINAL_FORM						      0xFB85
#define Z_UNICODE_ARABIC_LETTER_DUL_ISOLATED_FORM						      0xFB86
#define Z_UNICODE_ARABIC_LETTER_DUL_FINAL_FORM							      0xFB87
#define Z_UNICODE_ARABIC_LETTER_DDAL_ISOLATED_FORM						      0xFB88
#define Z_UNICODE_ARABIC_LETTER_DDAL_FINAL_FORM							      0xFB89
#define Z_UNICODE_ARABIC_LETTER_JEH_ISOLATED_FORM						      0xFB8A
#define Z_UNICODE_ARABIC_LETTER_JEH_FINAL_FORM							      0xFB8B
#define Z_UNICODE_ARABIC_LETTER_RREH_ISOLATED_FORM						      0xFB8C
#define Z_UNICODE_ARABIC_LETTER_RREH_FINAL_FORM							      0xFB8D
#define Z_UNICODE_ARABIC_LETTER_KEHEH_ISOLATED_FORM						      0xFB8E
#define Z_UNICODE_ARABIC_LETTER_KEHEH_FINAL_FORM						      0xFB8F
#define Z_UNICODE_ARABIC_LETTER_KEHEH_INITIAL_FORM						      0xFB90
#define Z_UNICODE_ARABIC_LETTER_KEHEH_MEDIAL_FORM						      0xFB91
#define Z_UNICODE_ARABIC_LETTER_GAF_ISOLATED_FORM						      0xFB92
#define Z_UNICODE_ARABIC_LETTER_GAF_FINAL_FORM							      0xFB93
#define Z_UNICODE_ARABIC_LETTER_GAF_INITIAL_FORM						      0xFB94
#define Z_UNICODE_ARABIC_LETTER_GAF_MEDIAL_FORM							      0xFB95
#define Z_UNICODE_ARABIC_LETTER_GUEH_ISOLATED_FORM						      0xFB96
#define Z_UNICODE_ARABIC_LETTER_GUEH_FINAL_FORM							      0xFB97
#define Z_UNICODE_ARABIC_LETTER_GUEH_INITIAL_FORM						      0xFB98
#define Z_UNICODE_ARABIC_LETTER_GUEH_MEDIAL_FORM						      0xFB99
#define Z_UNICODE_ARABIC_LETTER_NGOEH_ISOLATED_FORM						      0xFB9A
#define Z_UNICODE_ARABIC_LETTER_NGOEH_FINAL_FORM						      0xFB9B
#define Z_UNICODE_ARABIC_LETTER_NGOEH_INITIAL_FORM						      0xFB9C
#define Z_UNICODE_ARABIC_LETTER_NGOEH_MEDIAL_FORM						      0xFB9D
#define Z_UNICODE_ARABIC_LETTER_NOON_GHUNNA_ISOLATED_FORM					      0xFB9E
#define Z_UNICODE_ARABIC_LETTER_NOON_GHUNNA_FINAL_FORM						      0xFB9F
#define Z_UNICODE_ARABIC_LETTER_RNOON_ISOLATED_FORM						      0xFBA0
#define Z_UNICODE_ARABIC_LETTER_RNOON_FINAL_FORM						      0xFBA1
#define Z_UNICODE_ARABIC_LETTER_RNOON_INITIAL_FORM						      0xFBA2
#define Z_UNICODE_ARABIC_LETTER_RNOON_MEDIAL_FORM						      0xFBA3
#define Z_UNICODE_ARABIC_LETTER_HEH_WITH_YEH_ABOVE_ISOLATED_FORM				      0xFBA4
#define Z_UNICODE_ARABIC_LETTER_HEH_WITH_YEH_ABOVE_FINAL_FORM					      0xFBA5
#define Z_UNICODE_ARABIC_LETTER_HEH_GOAL_ISOLATED_FORM						      0xFBA6
#define Z_UNICODE_ARABIC_LETTER_HEH_GOAL_FINAL_FORM						      0xFBA7
#define Z_UNICODE_ARABIC_LETTER_HEH_GOAL_INITIAL_FORM						      0xFBA8
#define Z_UNICODE_ARABIC_LETTER_HEH_GOAL_MEDIAL_FORM						      0xFBA9
#define Z_UNICODE_ARABIC_LETTER_HEH_DOACHASHMEE_ISOLATED_FORM					      0xFBAA
#define Z_UNICODE_ARABIC_LETTER_HEH_DOACHASHMEE_FINAL_FORM					      0xFBAB
#define Z_UNICODE_ARABIC_LETTER_HEH_DOACHASHMEE_INITIAL_FORM					      0xFBAC
#define Z_UNICODE_ARABIC_LETTER_HEH_DOACHASHMEE_MEDIAL_FORM					      0xFBAD
#define Z_UNICODE_ARABIC_LETTER_YEH_BARREE_ISOLATED_FORM					      0xFBAE
#define Z_UNICODE_ARABIC_LETTER_YEH_BARREE_FINAL_FORM						      0xFBAF
#define Z_UNICODE_ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE_ISOLATED_FORM			      0xFBB0
#define Z_UNICODE_ARABIC_LETTER_YEH_BARREE_WITH_HAMZA_ABOVE_FINAL_FORM				      0xFBB1
#define Z_UNICODE_ARABIC_SYMBOL_DOT_ABOVE							      0xFBB2
#define Z_UNICODE_ARABIC_SYMBOL_DOT_BELOW							      0xFBB3
#define Z_UNICODE_ARABIC_SYMBOL_TWO_DOTS_ABOVE							      0xFBB4
#define Z_UNICODE_ARABIC_SYMBOL_TWO_DOTS_BELOW							      0xFBB5
#define Z_UNICODE_ARABIC_SYMBOL_THREE_DOTS_ABOVE						      0xFBB6
#define Z_UNICODE_ARABIC_SYMBOL_THREE_DOTS_BELOW						      0xFBB7
#define Z_UNICODE_ARABIC_SYMBOL_THREE_DOTS_POINTING_DOWNWARDS_ABOVE				      0xFBB8
#define Z_UNICODE_ARABIC_SYMBOL_THREE_DOTS_POINTING_DOWNWARDS_BELOW				      0xFBB9
#define Z_UNICODE_ARABIC_SYMBOL_FOUR_DOTS_ABOVE							      0xFBBA
#define Z_UNICODE_ARABIC_SYMBOL_FOUR_DOTS_BELOW							      0xFBBB
#define Z_UNICODE_ARABIC_SYMBOL_DOUBLE_VERTICAL_BAR_BELOW					      0xFBBC
#define Z_UNICODE_ARABIC_SYMBOL_TWO_DOTS_VERTICALLY_ABOVE					      0xFBBD
#define Z_UNICODE_ARABIC_SYMBOL_TWO_DOTS_VERTICALLY_BELOW					      0xFBBE
#define Z_UNICODE_ARABIC_SYMBOL_RING								      0xFBBF
#define Z_UNICODE_ARABIC_SYMBOL_SMALL_TAH_ABOVE							      0xFBC0
#define Z_UNICODE_ARABIC_SYMBOL_SMALL_TAH_BELOW							      0xFBC1
#define Z_UNICODE_ARABIC_LETTER_NG_ISOLATED_FORM						      0xFBD3
#define Z_UNICODE_ARABIC_LETTER_NG_FINAL_FORM							      0xFBD4
#define Z_UNICODE_ARABIC_LETTER_NG_INITIAL_FORM							      0xFBD5
#define Z_UNICODE_ARABIC_LETTER_NG_MEDIAL_FORM							      0xFBD6
#define Z_UNICODE_ARABIC_LETTER_U_ISOLATED_FORM							      0xFBD7
#define Z_UNICODE_ARABIC_LETTER_U_FINAL_FORM							      0xFBD8
#define Z_UNICODE_ARABIC_LETTER_OE_ISOLATED_FORM						      0xFBD9
#define Z_UNICODE_ARABIC_LETTER_OE_FINAL_FORM							      0xFBDA
#define Z_UNICODE_ARABIC_LETTER_YU_ISOLATED_FORM						      0xFBDB
#define Z_UNICODE_ARABIC_LETTER_YU_FINAL_FORM							      0xFBDC
#define Z_UNICODE_ARABIC_LETTER_U_WITH_HAMZA_ABOVE_ISOLATED_FORM				      0xFBDD
#define Z_UNICODE_ARABIC_LETTER_VE_ISOLATED_FORM						      0xFBDE
#define Z_UNICODE_ARABIC_LETTER_VE_FINAL_FORM							      0xFBDF
#define Z_UNICODE_ARABIC_LETTER_KIRGHIZ_OE_ISOLATED_FORM					      0xFBE0
#define Z_UNICODE_ARABIC_LETTER_KIRGHIZ_OE_FINAL_FORM						      0xFBE1
#define Z_UNICODE_ARABIC_LETTER_KIRGHIZ_YU_ISOLATED_FORM					      0xFBE2
#define Z_UNICODE_ARABIC_LETTER_KIRGHIZ_YU_FINAL_FORM						      0xFBE3
#define Z_UNICODE_ARABIC_LETTER_E_ISOLATED_FORM							      0xFBE4
#define Z_UNICODE_ARABIC_LETTER_E_FINAL_FORM							      0xFBE5
#define Z_UNICODE_ARABIC_LETTER_E_INITIAL_FORM							      0xFBE6
#define Z_UNICODE_ARABIC_LETTER_E_MEDIAL_FORM							      0xFBE7
#define Z_UNICODE_ARABIC_LETTER_UIGHUR_KAZAKH_KIRGHIZ_ALEF_MAKSURA_INITIAL_FORM			      0xFBE8
#define Z_UNICODE_ARABIC_LETTER_UIGHUR_KAZAKH_KIRGHIZ_ALEF_MAKSURA_MEDIAL_FORM			      0xFBE9
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_ISOLATED_FORM			      0xFBEA
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_FINAL_FORM			      0xFBEB
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_AE_ISOLATED_FORM			      0xFBEC
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_AE_FINAL_FORM			      0xFBED
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_WAW_ISOLATED_FORM			      0xFBEE
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_WAW_FINAL_FORM			      0xFBEF
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_U_ISOLATED_FORM			      0xFBF0
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_U_FINAL_FORM			      0xFBF1
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_OE_ISOLATED_FORM			      0xFBF2
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_OE_FINAL_FORM			      0xFBF3
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YU_ISOLATED_FORM			      0xFBF4
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YU_FINAL_FORM			      0xFBF5
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_ISOLATED_FORM			      0xFBF6
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_FINAL_FORM			      0xFBF7
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_E_INITIAL_FORM			      0xFBF8
#define Z_UNICODE_ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_ISOLATED_FORM 0xFBF9
#define Z_UNICODE_ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_FINAL_FORM    0xFBFA
#define Z_UNICODE_ARABIC_LIGATURE_UIGHUR_KIRGHIZ_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_INITIAL_FORM  0xFBFB
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_ISOLATED_FORM						      0xFBFC
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_FINAL_FORM						      0xFBFD
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_INITIAL_FORM						      0xFBFE
#define Z_UNICODE_ARABIC_LETTER_FARSI_YEH_MEDIAL_FORM						      0xFBFF
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_JEEM_ISOLATED_FORM			      0xFC00
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HAH_ISOLATED_FORM			      0xFC01
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_ISOLATED_FORM			      0xFC02
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_ISOLATED_FORM		      0xFC03
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YEH_ISOLATED_FORM			      0xFC04
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_JEEM_ISOLATED_FORM					      0xFC05
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_HAH_ISOLATED_FORM					      0xFC06
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_KHAH_ISOLATED_FORM					      0xFC07
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_MEEM_ISOLATED_FORM					      0xFC08
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC09
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_YEH_ISOLATED_FORM					      0xFC0A
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_JEEM_ISOLATED_FORM					      0xFC0B
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_HAH_ISOLATED_FORM					      0xFC0C
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_KHAH_ISOLATED_FORM					      0xFC0D
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_ISOLATED_FORM					      0xFC0E
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC0F
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_YEH_ISOLATED_FORM					      0xFC10
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_JEEM_ISOLATED_FORM					      0xFC11
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_MEEM_ISOLATED_FORM					      0xFC12
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC13
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_YEH_ISOLATED_FORM					      0xFC14
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_HAH_ISOLATED_FORM					      0xFC15
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_MEEM_ISOLATED_FORM					      0xFC16
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_JEEM_ISOLATED_FORM					      0xFC17
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_MEEM_ISOLATED_FORM					      0xFC18
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_JEEM_ISOLATED_FORM					      0xFC19
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_HAH_ISOLATED_FORM					      0xFC1A
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_MEEM_ISOLATED_FORM					      0xFC1B
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_JEEM_ISOLATED_FORM					      0xFC1C
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_HAH_ISOLATED_FORM					      0xFC1D
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_KHAH_ISOLATED_FORM					      0xFC1E
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_MEEM_ISOLATED_FORM					      0xFC1F
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_HAH_ISOLATED_FORM					      0xFC20
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_MEEM_ISOLATED_FORM					      0xFC21
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_JEEM_ISOLATED_FORM					      0xFC22
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_HAH_ISOLATED_FORM					      0xFC23
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_KHAH_ISOLATED_FORM					      0xFC24
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_MEEM_ISOLATED_FORM					      0xFC25
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_HAH_ISOLATED_FORM					      0xFC26
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_MEEM_ISOLATED_FORM					      0xFC27
#define Z_UNICODE_ARABIC_LIGATURE_ZAH_WITH_MEEM_ISOLATED_FORM					      0xFC28
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_JEEM_ISOLATED_FORM					      0xFC29
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_MEEM_ISOLATED_FORM					      0xFC2A
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_JEEM_ISOLATED_FORM					      0xFC2B
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_MEEM_ISOLATED_FORM					      0xFC2C
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_JEEM_ISOLATED_FORM					      0xFC2D
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_HAH_ISOLATED_FORM					      0xFC2E
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_KHAH_ISOLATED_FORM					      0xFC2F
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_MEEM_ISOLATED_FORM					      0xFC30
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC31
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_YEH_ISOLATED_FORM					      0xFC32
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_HAH_ISOLATED_FORM					      0xFC33
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_MEEM_ISOLATED_FORM					      0xFC34
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC35
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_YEH_ISOLATED_FORM					      0xFC36
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_ALEF_ISOLATED_FORM					      0xFC37
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_JEEM_ISOLATED_FORM					      0xFC38
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_HAH_ISOLATED_FORM					      0xFC39
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_KHAH_ISOLATED_FORM					      0xFC3A
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_LAM_ISOLATED_FORM					      0xFC3B
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_MEEM_ISOLATED_FORM					      0xFC3C
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC3D
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_YEH_ISOLATED_FORM					      0xFC3E
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_JEEM_ISOLATED_FORM					      0xFC3F
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_HAH_ISOLATED_FORM					      0xFC40
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_KHAH_ISOLATED_FORM					      0xFC41
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_MEEM_ISOLATED_FORM					      0xFC42
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC43
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_YEH_ISOLATED_FORM					      0xFC44
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_JEEM_ISOLATED_FORM					      0xFC45
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_HAH_ISOLATED_FORM					      0xFC46
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_KHAH_ISOLATED_FORM					      0xFC47
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_MEEM_ISOLATED_FORM					      0xFC48
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC49
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_YEH_ISOLATED_FORM					      0xFC4A
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_JEEM_ISOLATED_FORM					      0xFC4B
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_HAH_ISOLATED_FORM					      0xFC4C
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_KHAH_ISOLATED_FORM					      0xFC4D
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_MEEM_ISOLATED_FORM					      0xFC4E
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC4F
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_YEH_ISOLATED_FORM					      0xFC50
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_JEEM_ISOLATED_FORM					      0xFC51
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_MEEM_ISOLATED_FORM					      0xFC52
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC53
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_YEH_ISOLATED_FORM					      0xFC54
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_JEEM_ISOLATED_FORM					      0xFC55
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAH_ISOLATED_FORM					      0xFC56
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_KHAH_ISOLATED_FORM					      0xFC57
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_MEEM_ISOLATED_FORM					      0xFC58
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFC59
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_YEH_ISOLATED_FORM					      0xFC5A
#define Z_UNICODE_ARABIC_LIGATURE_THAL_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM			      0xFC5B
#define Z_UNICODE_ARABIC_LIGATURE_REH_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM			      0xFC5C
#define Z_UNICODE_ARABIC_LIGATURE_ALEF_MAKSURA_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM		      0xFC5D
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_DAMMATAN_ISOLATED_FORM				      0xFC5E
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_KASRATAN_ISOLATED_FORM				      0xFC5F
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_FATHA_ISOLATED_FORM				      0xFC60
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_DAMMA_ISOLATED_FORM				      0xFC61
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_KASRA_ISOLATED_FORM				      0xFC62
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_SUPERSCRIPT_ALEF_ISOLATED_FORM			      0xFC63
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_REH_FINAL_FORM			      0xFC64
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ZAIN_FINAL_FORM			      0xFC65
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_FINAL_FORM			      0xFC66
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_NOON_FINAL_FORM			      0xFC67
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_ALEF_MAKSURA_FINAL_FORM		      0xFC68
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_YEH_FINAL_FORM			      0xFC69
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_REH_FINAL_FORM					      0xFC6A
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_ZAIN_FINAL_FORM					      0xFC6B
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_MEEM_FINAL_FORM					      0xFC6C
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_NOON_FINAL_FORM					      0xFC6D
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC6E
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_YEH_FINAL_FORM					      0xFC6F
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_REH_FINAL_FORM					      0xFC70
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_ZAIN_FINAL_FORM					      0xFC71
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_FINAL_FORM					      0xFC72
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_NOON_FINAL_FORM					      0xFC73
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC74
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_YEH_FINAL_FORM					      0xFC75
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_REH_FINAL_FORM					      0xFC76
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_ZAIN_FINAL_FORM					      0xFC77
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_MEEM_FINAL_FORM					      0xFC78
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_NOON_FINAL_FORM					      0xFC79
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC7A
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_YEH_FINAL_FORM					      0xFC7B
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC7C
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_YEH_FINAL_FORM					      0xFC7D
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC7E
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_YEH_FINAL_FORM					      0xFC7F
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_ALEF_FINAL_FORM					      0xFC80
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_LAM_FINAL_FORM					      0xFC81
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_MEEM_FINAL_FORM					      0xFC82
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC83
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_YEH_FINAL_FORM					      0xFC84
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_MEEM_FINAL_FORM					      0xFC85
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC86
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_YEH_FINAL_FORM					      0xFC87
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_ALEF_FINAL_FORM					      0xFC88
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_MEEM_FINAL_FORM					      0xFC89
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_REH_FINAL_FORM					      0xFC8A
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_ZAIN_FINAL_FORM					      0xFC8B
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_MEEM_FINAL_FORM					      0xFC8C
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_NOON_FINAL_FORM					      0xFC8D
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC8E
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_YEH_FINAL_FORM					      0xFC8F
#define Z_UNICODE_ARABIC_LIGATURE_ALEF_MAKSURA_WITH_SUPERSCRIPT_ALEF_FINAL_FORM			      0xFC90
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_REH_FINAL_FORM					      0xFC91
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_ZAIN_FINAL_FORM					      0xFC92
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_MEEM_FINAL_FORM					      0xFC93
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_NOON_FINAL_FORM					      0xFC94
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFC95
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_YEH_FINAL_FORM					      0xFC96
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_JEEM_INITIAL_FORM			      0xFC97
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HAH_INITIAL_FORM			      0xFC98
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_KHAH_INITIAL_FORM			      0xFC99
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_INITIAL_FORM			      0xFC9A
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HEH_INITIAL_FORM			      0xFC9B
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_JEEM_INITIAL_FORM					      0xFC9C
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_HAH_INITIAL_FORM					      0xFC9D
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_KHAH_INITIAL_FORM					      0xFC9E
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_MEEM_INITIAL_FORM					      0xFC9F
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_HEH_INITIAL_FORM					      0xFCA0
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_JEEM_INITIAL_FORM					      0xFCA1
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_HAH_INITIAL_FORM					      0xFCA2
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_KHAH_INITIAL_FORM					      0xFCA3
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_INITIAL_FORM					      0xFCA4
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_HEH_INITIAL_FORM					      0xFCA5
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_MEEM_INITIAL_FORM					      0xFCA6
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_HAH_INITIAL_FORM					      0xFCA7
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_MEEM_INITIAL_FORM					      0xFCA8
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_JEEM_INITIAL_FORM					      0xFCA9
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_MEEM_INITIAL_FORM					      0xFCAA
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_JEEM_INITIAL_FORM					      0xFCAB
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_MEEM_INITIAL_FORM					      0xFCAC
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_JEEM_INITIAL_FORM					      0xFCAD
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_HAH_INITIAL_FORM					      0xFCAE
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_KHAH_INITIAL_FORM					      0xFCAF
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_MEEM_INITIAL_FORM					      0xFCB0
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_HAH_INITIAL_FORM					      0xFCB1
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_KHAH_INITIAL_FORM					      0xFCB2
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_MEEM_INITIAL_FORM					      0xFCB3
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_JEEM_INITIAL_FORM					      0xFCB4
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_HAH_INITIAL_FORM					      0xFCB5
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_KHAH_INITIAL_FORM					      0xFCB6
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_MEEM_INITIAL_FORM					      0xFCB7
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_HAH_INITIAL_FORM					      0xFCB8
#define Z_UNICODE_ARABIC_LIGATURE_ZAH_WITH_MEEM_INITIAL_FORM					      0xFCB9
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_JEEM_INITIAL_FORM					      0xFCBA
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_MEEM_INITIAL_FORM					      0xFCBB
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_JEEM_INITIAL_FORM					      0xFCBC
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_MEEM_INITIAL_FORM					      0xFCBD
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_JEEM_INITIAL_FORM					      0xFCBE
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_HAH_INITIAL_FORM					      0xFCBF
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_KHAH_INITIAL_FORM					      0xFCC0
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_MEEM_INITIAL_FORM					      0xFCC1
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_HAH_INITIAL_FORM					      0xFCC2
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_MEEM_INITIAL_FORM					      0xFCC3
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_JEEM_INITIAL_FORM					      0xFCC4
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_HAH_INITIAL_FORM					      0xFCC5
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_KHAH_INITIAL_FORM					      0xFCC6
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_LAM_INITIAL_FORM					      0xFCC7
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_MEEM_INITIAL_FORM					      0xFCC8
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_JEEM_INITIAL_FORM					      0xFCC9
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_HAH_INITIAL_FORM					      0xFCCA
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_KHAH_INITIAL_FORM					      0xFCCB
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_MEEM_INITIAL_FORM					      0xFCCC
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_HEH_INITIAL_FORM					      0xFCCD
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_JEEM_INITIAL_FORM					      0xFCCE
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_HAH_INITIAL_FORM					      0xFCCF
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_KHAH_INITIAL_FORM					      0xFCD0
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_MEEM_INITIAL_FORM					      0xFCD1
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_JEEM_INITIAL_FORM					      0xFCD2
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_HAH_INITIAL_FORM					      0xFCD3
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_KHAH_INITIAL_FORM					      0xFCD4
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_MEEM_INITIAL_FORM					      0xFCD5
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_HEH_INITIAL_FORM					      0xFCD6
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_JEEM_INITIAL_FORM					      0xFCD7
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_MEEM_INITIAL_FORM					      0xFCD8
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_SUPERSCRIPT_ALEF_INITIAL_FORM			      0xFCD9
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_JEEM_INITIAL_FORM					      0xFCDA
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAH_INITIAL_FORM					      0xFCDB
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_KHAH_INITIAL_FORM					      0xFCDC
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_MEEM_INITIAL_FORM					      0xFCDD
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HEH_INITIAL_FORM					      0xFCDE
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_MEEM_MEDIAL_FORM			      0xFCDF
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAMZA_ABOVE_WITH_HEH_MEDIAL_FORM			      0xFCE0
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_MEEM_MEDIAL_FORM					      0xFCE1
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_HEH_MEDIAL_FORM					      0xFCE2
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_MEDIAL_FORM					      0xFCE3
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_HEH_MEDIAL_FORM					      0xFCE4
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_MEEM_MEDIAL_FORM					      0xFCE5
#define Z_UNICODE_ARABIC_LIGATURE_THEH_WITH_HEH_MEDIAL_FORM					      0xFCE6
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_MEEM_MEDIAL_FORM					      0xFCE7
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_HEH_MEDIAL_FORM					      0xFCE8
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_MEEM_MEDIAL_FORM					      0xFCE9
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HEH_MEDIAL_FORM					      0xFCEA
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_LAM_MEDIAL_FORM					      0xFCEB
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_MEEM_MEDIAL_FORM					      0xFCEC
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_MEEM_MEDIAL_FORM					      0xFCED
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_MEEM_MEDIAL_FORM					      0xFCEE
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_HEH_MEDIAL_FORM					      0xFCEF
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_MEEM_MEDIAL_FORM					      0xFCF0
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HEH_MEDIAL_FORM					      0xFCF1
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_FATHA_MEDIAL_FORM					      0xFCF2
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_DAMMA_MEDIAL_FORM					      0xFCF3
#define Z_UNICODE_ARABIC_LIGATURE_SHADDA_WITH_KASRA_MEDIAL_FORM					      0xFCF4
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFCF5
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_YEH_ISOLATED_FORM					      0xFCF6
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFCF7
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_YEH_ISOLATED_FORM					      0xFCF8
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFCF9
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_YEH_ISOLATED_FORM					      0xFCFA
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFCFB
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_YEH_ISOLATED_FORM					      0xFCFC
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFCFD
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_YEH_ISOLATED_FORM					      0xFCFE
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFCFF
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_YEH_ISOLATED_FORM					      0xFD00
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFD01
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_YEH_ISOLATED_FORM					      0xFD02
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFD03
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_YEH_ISOLATED_FORM					      0xFD04
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFD05
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_YEH_ISOLATED_FORM					      0xFD06
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_ALEF_MAKSURA_ISOLATED_FORM				      0xFD07
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_YEH_ISOLATED_FORM					      0xFD08
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_JEEM_ISOLATED_FORM					      0xFD09
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HAH_ISOLATED_FORM					      0xFD0A
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_KHAH_ISOLATED_FORM					      0xFD0B
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_MEEM_ISOLATED_FORM					      0xFD0C
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_REH_ISOLATED_FORM					      0xFD0D
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_REH_ISOLATED_FORM					      0xFD0E
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_REH_ISOLATED_FORM					      0xFD0F
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_REH_ISOLATED_FORM					      0xFD10
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD11
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_YEH_FINAL_FORM					      0xFD12
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD13
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_YEH_FINAL_FORM					      0xFD14
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD15
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_YEH_FINAL_FORM					      0xFD16
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD17
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_YEH_FINAL_FORM					      0xFD18
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD19
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_YEH_FINAL_FORM					      0xFD1A
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD1B
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_YEH_FINAL_FORM					      0xFD1C
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD1D
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_YEH_FINAL_FORM					      0xFD1E
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD1F
#define Z_UNICODE_ARABIC_LIGATURE_KHAH_WITH_YEH_FINAL_FORM					      0xFD20
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD21
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_YEH_FINAL_FORM					      0xFD22
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_ALEF_MAKSURA_FINAL_FORM				      0xFD23
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_YEH_FINAL_FORM					      0xFD24
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_JEEM_FINAL_FORM					      0xFD25
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HAH_FINAL_FORM					      0xFD26
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_KHAH_FINAL_FORM					      0xFD27
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_MEEM_FINAL_FORM					      0xFD28
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_REH_FINAL_FORM					      0xFD29
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_REH_FINAL_FORM					      0xFD2A
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_REH_FINAL_FORM					      0xFD2B
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_REH_FINAL_FORM					      0xFD2C
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_JEEM_INITIAL_FORM					      0xFD2D
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HAH_INITIAL_FORM					      0xFD2E
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_KHAH_INITIAL_FORM					      0xFD2F
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_MEEM_INITIAL_FORM					      0xFD30
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_HEH_INITIAL_FORM					      0xFD31
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HEH_INITIAL_FORM					      0xFD32
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_MEEM_INITIAL_FORM					      0xFD33
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_JEEM_MEDIAL_FORM					      0xFD34
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_HAH_MEDIAL_FORM					      0xFD35
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_KHAH_MEDIAL_FORM					      0xFD36
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_JEEM_MEDIAL_FORM					      0xFD37
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HAH_MEDIAL_FORM					      0xFD38
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_KHAH_MEDIAL_FORM					      0xFD39
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_MEEM_MEDIAL_FORM					      0xFD3A
#define Z_UNICODE_ARABIC_LIGATURE_ZAH_WITH_MEEM_MEDIAL_FORM					      0xFD3B
#define Z_UNICODE_ARABIC_LIGATURE_ALEF_WITH_FATHATAN_FINAL_FORM					      0xFD3C
#define Z_UNICODE_ARABIC_LIGATURE_ALEF_WITH_FATHATAN_ISOLATED_FORM				      0xFD3D
#define Z_UNICODE_ORNATE_LEFT_PARENTHESIS							      0xFD3E
#define Z_UNICODE_ORNATE_RIGHT_PARENTHESIS							      0xFD3F
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_MEEM_INITIAL_FORM				      0xFD50
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_HAH_WITH_JEEM_FINAL_FORM				      0xFD51
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_HAH_WITH_JEEM_INITIAL_FORM				      0xFD52
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_HAH_WITH_MEEM_INITIAL_FORM				      0xFD53
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_MEEM_INITIAL_FORM				      0xFD54
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_JEEM_INITIAL_FORM				      0xFD55
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_HAH_INITIAL_FORM				      0xFD56
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_KHAH_INITIAL_FORM				      0xFD57
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_HAH_FINAL_FORM				      0xFD58
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_HAH_INITIAL_FORM				      0xFD59
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFD5A
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD5B
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_HAH_WITH_JEEM_INITIAL_FORM				      0xFD5C
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_JEEM_WITH_HAH_INITIAL_FORM				      0xFD5D
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD5E
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_HAH_FINAL_FORM				      0xFD5F
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_HAH_INITIAL_FORM				      0xFD60
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_JEEM_INITIAL_FORM				      0xFD61
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_MEEM_FINAL_FORM				      0xFD62
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_MEEM_WITH_MEEM_INITIAL_FORM				      0xFD63
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_HAH_WITH_HAH_FINAL_FORM				      0xFD64
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_HAH_WITH_HAH_INITIAL_FORM				      0xFD65
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_MEEM_WITH_MEEM_FINAL_FORM				      0xFD66
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_MEEM_FINAL_FORM				      0xFD67
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_MEEM_INITIAL_FORM				      0xFD68
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_JEEM_WITH_YEH_FINAL_FORM				      0xFD69
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_KHAH_FINAL_FORM				      0xFD6A
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_KHAH_INITIAL_FORM			      0xFD6B
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_MEEM_FINAL_FORM				      0xFD6C
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_MEEM_WITH_MEEM_INITIAL_FORM			      0xFD6D
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD6E
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_KHAH_WITH_MEEM_FINAL_FORM				      0xFD6F
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_KHAH_WITH_MEEM_INITIAL_FORM				      0xFD70
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_HAH_FINAL_FORM				      0xFD71
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_HAH_INITIAL_FORM				      0xFD72
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_MEEM_INITIAL_FORM				      0xFD73
#define Z_UNICODE_ARABIC_LIGATURE_TAH_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFD74
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_JEEM_WITH_MEEM_FINAL_FORM				      0xFD75
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_MEEM_FINAL_FORM				      0xFD76
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_MEEM_INITIAL_FORM				      0xFD77
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD78
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_MEEM_FINAL_FORM				      0xFD79
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFD7A
#define Z_UNICODE_ARABIC_LIGATURE_GHAIN_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD7B
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_KHAH_WITH_MEEM_FINAL_FORM				      0xFD7C
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_KHAH_WITH_MEEM_INITIAL_FORM				      0xFD7D
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_HAH_FINAL_FORM				      0xFD7E
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_MEEM_FINAL_FORM				      0xFD7F
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_HAH_WITH_MEEM_FINAL_FORM				      0xFD80
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFD81
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD82
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_JEEM_INITIAL_FORM				      0xFD83
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_JEEM_FINAL_FORM				      0xFD84
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_KHAH_WITH_MEEM_FINAL_FORM				      0xFD85
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_KHAH_WITH_MEEM_INITIAL_FORM				      0xFD86
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_HAH_FINAL_FORM				      0xFD87
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_HAH_INITIAL_FORM				      0xFD88
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_JEEM_INITIAL_FORM				      0xFD89
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_MEEM_INITIAL_FORM				      0xFD8A
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFD8B
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_HAH_INITIAL_FORM				      0xFD8C
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_MEEM_INITIAL_FORM				      0xFD8D
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_JEEM_INITIAL_FORM				      0xFD8E
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_MEEM_INITIAL_FORM				      0xFD8F
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_KHAH_INITIAL_FORM				      0xFD92
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_MEEM_WITH_JEEM_INITIAL_FORM				      0xFD93
#define Z_UNICODE_ARABIC_LIGATURE_HEH_WITH_MEEM_WITH_MEEM_INITIAL_FORM				      0xFD94
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_HAH_WITH_MEEM_INITIAL_FORM				      0xFD95
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD96
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_MEEM_FINAL_FORM				      0xFD97
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_MEEM_INITIAL_FORM				      0xFD98
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD99
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFD9A
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFD9B
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_MEEM_FINAL_FORM				      0xFD9C
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_MEEM_INITIAL_FORM				      0xFD9D
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_KHAH_WITH_YEH_FINAL_FORM				      0xFD9E
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_YEH_FINAL_FORM				      0xFD9F
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_JEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFDA0
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_YEH_FINAL_FORM				      0xFDA1
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFDA2
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDA3
#define Z_UNICODE_ARABIC_LIGATURE_TEH_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFDA4
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDA5
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_HAH_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFDA6
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_MEEM_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFDA7
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_KHAH_WITH_ALEF_MAKSURA_FINAL_FORM			      0xFDA8
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFDA9
#define Z_UNICODE_ARABIC_LIGATURE_SHEEN_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFDAA
#define Z_UNICODE_ARABIC_LIGATURE_DAD_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFDAB
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_YEH_FINAL_FORM				      0xFDAC
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDAD
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFDAE
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_JEEM_WITH_YEH_FINAL_FORM				      0xFDAF
#define Z_UNICODE_ARABIC_LIGATURE_YEH_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDB0
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDB1
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDB2
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFDB3
#define Z_UNICODE_ARABIC_LIGATURE_QAF_WITH_MEEM_WITH_HAH_INITIAL_FORM				      0xFDB4
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_HAH_WITH_MEEM_INITIAL_FORM				      0xFDB5
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDB6
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDB7
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_HAH_INITIAL_FORM				      0xFDB8
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_KHAH_WITH_YEH_FINAL_FORM				      0xFDB9
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_MEEM_INITIAL_FORM				      0xFDBA
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_MEEM_FINAL_FORM				      0xFDBB
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_JEEM_WITH_MEEM_FINAL_FORM				      0xFDBC
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_HAH_FINAL_FORM				      0xFDBD
#define Z_UNICODE_ARABIC_LIGATURE_JEEM_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFDBE
#define Z_UNICODE_ARABIC_LIGATURE_HAH_WITH_JEEM_WITH_YEH_FINAL_FORM				      0xFDBF
#define Z_UNICODE_ARABIC_LIGATURE_MEEM_WITH_JEEM_WITH_YEH_FINAL_FORM				      0xFDC0
#define Z_UNICODE_ARABIC_LIGATURE_FEH_WITH_MEEM_WITH_YEH_FINAL_FORM				      0xFDC1
#define Z_UNICODE_ARABIC_LIGATURE_BEH_WITH_HAH_WITH_YEH_FINAL_FORM				      0xFDC2
#define Z_UNICODE_ARABIC_LIGATURE_KAF_WITH_MEEM_WITH_MEEM_INITIAL_FORM				      0xFDC3
#define Z_UNICODE_ARABIC_LIGATURE_AIN_WITH_JEEM_WITH_MEEM_INITIAL_FORM				      0xFDC4
#define Z_UNICODE_ARABIC_LIGATURE_SAD_WITH_MEEM_WITH_MEEM_INITIAL_FORM				      0xFDC5
#define Z_UNICODE_ARABIC_LIGATURE_SEEN_WITH_KHAH_WITH_YEH_FINAL_FORM				      0xFDC6
#define Z_UNICODE_ARABIC_LIGATURE_NOON_WITH_JEEM_WITH_YEH_FINAL_FORM				      0xFDC7
#define Z_UNICODE_ARABIC_LIGATURE_SALLA_USED_AS_KORANIC_STOP_SIGN_ISOLATED_FORM			      0xFDF0
#define Z_UNICODE_ARABIC_LIGATURE_QALA_USED_AS_KORANIC_STOP_SIGN_ISOLATED_FORM			      0xFDF1
#define Z_UNICODE_ARABIC_LIGATURE_ALLAH_ISOLATED_FORM						      0xFDF2
#define Z_UNICODE_ARABIC_LIGATURE_AKBAR_ISOLATED_FORM						      0xFDF3
#define Z_UNICODE_ARABIC_LIGATURE_MOHAMMAD_ISOLATED_FORM					      0xFDF4
#define Z_UNICODE_ARABIC_LIGATURE_SALAM_ISOLATED_FORM						      0xFDF5
#define Z_UNICODE_ARABIC_LIGATURE_RASOUL_ISOLATED_FORM						      0xFDF6
#define Z_UNICODE_ARABIC_LIGATURE_ALAYHE_ISOLATED_FORM						      0xFDF7
#define Z_UNICODE_ARABIC_LIGATURE_WASALLAM_ISOLATED_FORM					      0xFDF8
#define Z_UNICODE_ARABIC_LIGATURE_SALLA_ISOLATED_FORM						      0xFDF9
#define Z_UNICODE_ARABIC_LIGATURE_SALLALLAHOU_ALAYHE_WASALLAM					      0xFDFA
#define Z_UNICODE_ARABIC_LIGATURE_JALLAJALALOUHOU						      0xFDFB
#define Z_UNICODE_RIAL_SIGN									      0xFDFC
#define Z_UNICODE_ARABIC_LIGATURE_BISMILLAH_AR_RAHMAN_AR_RAHEEM					      0xFDFD

/* MARK: - FE00h-FE0Fh - Variation Selectors */

#define Z_UNICODE_VARIATION_SELECTOR_1	0xFE00
#define Z_UNICODE_VARIATION_SELECTOR_2	0xFE01
#define Z_UNICODE_VARIATION_SELECTOR_3	0xFE02
#define Z_UNICODE_VARIATION_SELECTOR_4	0xFE03
#define Z_UNICODE_VARIATION_SELECTOR_5	0xFE04
#define Z_UNICODE_VARIATION_SELECTOR_6	0xFE05
#define Z_UNICODE_VARIATION_SELECTOR_7	0xFE06
#define Z_UNICODE_VARIATION_SELECTOR_8	0xFE07
#define Z_UNICODE_VARIATION_SELECTOR_9	0xFE08
#define Z_UNICODE_VARIATION_SELECTOR_10	0xFE09
#define Z_UNICODE_VARIATION_SELECTOR_11	0xFE0A
#define Z_UNICODE_VARIATION_SELECTOR_12	0xFE0B
#define Z_UNICODE_VARIATION_SELECTOR_13	0xFE0C
#define Z_UNICODE_VARIATION_SELECTOR_14	0xFE0D
#define Z_UNICODE_VARIATION_SELECTOR_15	0xFE0E
#define Z_UNICODE_VARIATION_SELECTOR_16	0xFE0F

/* MARK: - FE10h-FE1Fh - Vertical Forms */

#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_COMMA				0xFE10
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_IDEOGRAPHIC_COMMA		0xFE11
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_IDEOGRAPHIC_FULL_STOP		0xFE12
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_COLON				0xFE13
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_SEMICOLON			0xFE14
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_EXCLAMATION_MARK		0xFE15
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_QUESTION_MARK			0xFE16
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_WHITE_LENTICULAR_BRACKET	0xFE17
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_WHITE_LENTICULAR_BRAKCET	0xFE18
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_HORIZONTAL_ELLIPSIS		0xFE19

/* MARK: - FE20h-FE2Fh - Combining Half Marks */

#define Z_UNICODE_COMBINING_LIGATURE_LEFT_HALF	      0xFE20
#define Z_UNICODE_COMBINING_LIGATURE_RIGHT_HALF	      0xFE21
#define Z_UNICODE_COMBINING_DOUBLE_TILDE_LEFT_HALF    0xFE22
#define Z_UNICODE_COMBINING_DOUBLE_TILDE_RIGHT_HALF   0xFE23
#define Z_UNICODE_COMBINING_MACRON_LEFT_HALF	      0xFE24
#define Z_UNICODE_COMBINING_MACRON_RIGHT_HALF	      0xFE25
#define Z_UNICODE_COMBINING_CONJOINING_MACRON	      0xFE26
#define Z_UNICODE_COMBINING_LIGATURE_LEFT_HALF_BELOW  0xFE27
#define Z_UNICODE_COMBINING_LIGATURE_RIGHT_HALF_BELOW 0xFE28
#define Z_UNICODE_COMBINING_TILDE_LEFT_HALF_BELOW     0xFE29
#define Z_UNICODE_COMBINING_TILDE_RIGHT_HALF_BELOW    0xFE2A
#define Z_UNICODE_COMBINING_MACRON_LEFT_HALF_BELOW    0xFE2B
#define Z_UNICODE_COMBINING_MACRON_RIGHT_HALF_BELOW   0xFE2C
#define Z_UNICODE_COMBINING_CONJOINING_MACRON_BELOW   0xFE2D
#define Z_UNICODE_COMBINING_CYRILLIC_TITLO_LEFT_HALF  0xFE2E
#define Z_UNICODE_COMBINING_CYRILLIC_TITLO_RIGHT_HALF 0xFE2F

/* MARK: - FE30h-FE4Fh - CJK Compatibility Forms */

#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_TWO_DOT_LEADER			0xFE30
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_EM_DASH			0xFE31
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_EN_DASH			0xFE32
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LOW_LINE			0xFE33
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_WAVY_LOW_LINE			0xFE34
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_PARENTHESIS		0xFE35
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_PARENTHESIS		0xFE36
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_CURLY_BRACKET		0xFE37
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_CURLY_BRACKET		0xFE38
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_TORTOISE_SHELL_BRACKET	0xFE39
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_TORTOISE_SHELL_BRACKET	0xFE3A
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_BLACK_LENTICULAR_BRACKET	0xFE3B
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_BLACK_LENTICULAR_BRACKET	0xFE3C
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_DOUBLE_ANGLE_BRACKET	0xFE3D
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_DOUBLE_ANGLE_BRACKET	0xFE3E
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_ANGLE_BRACKET		0xFE3F
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_ANGLE_BRACKET		0xFE40
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_CORNER_BRACKET		0xFE41
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_CORNER_BRACKET		0xFE42
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_WHITE_CORNER_BRACKET	0xFE43
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_WHITE_CORNER_BRACKET	0xFE44
#define Z_UNICODE_SESAME_DOT							0xFE45
#define Z_UNICODE_WHITE_SESAME_DOT						0xFE46
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_LEFT_SQUARE_BRACKET		0xFE47
#define Z_UNICODE_PRESENTATION_FORM_FOR_VERTICAL_RIGHT_SQUARE_BRACKET		0xFE48
#define Z_UNICODE_DASHED_OVERLINE						0xFE49
#define Z_UNICODE_CENTRELINE_OVERLINE						0xFE4A
#define Z_UNICODE_WAVY_OVERLINE							0xFE4B
#define Z_UNICODE_DOUBLE_WAVY_OVERLINE						0xFE4C
#define Z_UNICODE_DASHED_LOW_LINE						0xFE4D
#define Z_UNICODE_CENTRELINE_LOW_LINE						0xFE4E
#define Z_UNICODE_WAVY_LOW_LINE							0xFE4F

/* MARK: - FE50h-FE6Fh - Small Form Variants */

#define Z_UNICODE_SMALL_COMMA			     0xFE50
#define Z_UNICODE_SMALL_IDEOGRAPHIC_COMMA	     0xFE51
#define Z_UNICODE_SMALL_FULL_STOP		     0xFE52
#define Z_UNICODE_SMALL_SEMICOLON		     0xFE54
#define Z_UNICODE_SMALL_COLON			     0xFE55
#define Z_UNICODE_SMALL_QUESTION_MARK		     0xFE56
#define Z_UNICODE_SMALL_EXCLAMATION_MARK	     0xFE57
#define Z_UNICODE_SMALL_EM_DASH			     0xFE58
#define Z_UNICODE_SMALL_LEFT_PARENTHESIS	     0xFE59
#define Z_UNICODE_SMALL_RIGHT_PARENTHESIS	     0xFE5A
#define Z_UNICODE_SMALL_LEFT_CURLY_BRACKET	     0xFE5B
#define Z_UNICODE_SMALL_RIGHT_CURLY_BRACKET	     0xFE5C
#define Z_UNICODE_SMALL_LEFT_TORTOISE_SHELL_BRACKET  0xFE5D
#define Z_UNICODE_SMALL_RIGHT_TORTOISE_SHELL_BRACKET 0xFE5E
#define Z_UNICODE_SMALL_NUMBER_SIGN		     0xFE5F
#define Z_UNICODE_SMALL_AMPERSAND		     0xFE60
#define Z_UNICODE_SMALL_ASTERISK		     0xFE61
#define Z_UNICODE_SMALL_PLUS_SIGN		     0xFE62
#define Z_UNICODE_SMALL_HYPHEN_MINUS		     0xFE63
#define Z_UNICODE_SMALL_LESS_THAN_SIGN		     0xFE64
#define Z_UNICODE_SMALL_GREATER_THAN_SIGN	     0xFE65
#define Z_UNICODE_SMALL_EQUALS_SIGN		     0xFE66
#define Z_UNICODE_SMALL_REVERSE_SOLIDUS		     0xFE68
#define Z_UNICODE_SMALL_DOLLAR_SIGN		     0xFE69
#define Z_UNICODE_SMALL_PERCENT_SIGN		     0xFE6A
#define Z_UNICODE_SMALL_COMMERCIAL_AT		     0xFE6B

/* MARK: - FE70h-FEFFh - Arabic Presentation Forms-B */

#define Z_UNICODE_ARABIC_FATHATAN_ISOLATED_FORM				       0xFE70
#define Z_UNICODE_ARABIC_TATWEEL_WITH_FATHATAN_ABOVE			       0xFE71
#define Z_UNICODE_ARABIC_DAMMATAN_ISOLATED_FORM				       0xFE72
#define Z_UNICODE_ARABIC_TAIL_FRAGMENT					       0xFE73
#define Z_UNICODE_ARABIC_KASRATAN_ISOLATED_FORM				       0xFE74
#define Z_UNICODE_ARABIC_FATHA_ISOLATED_FORM				       0xFE76
#define Z_UNICODE_ARABIC_FATHA_MEDIAL_FORM				       0xFE77
#define Z_UNICODE_ARABIC_DAMMA_ISOLATED_FORM				       0xFE78
#define Z_UNICODE_ARABIC_DAMMA_MEDIAL_FORM				       0xFE79
#define Z_UNICODE_ARABIC_KASRA_ISOLATED_FORM				       0xFE7A
#define Z_UNICODE_ARABIC_KASRA_MEDIAL_FORM				       0xFE7B
#define Z_UNICODE_ARABIC_SHADDA_ISOLATED_FORM				       0xFE7C
#define Z_UNICODE_ARABIC_SHADDA_MEDIAL_FORM				       0xFE7D
#define Z_UNICODE_ARABIC_SUKUN_ISOLATED_FORM				       0xFE7E
#define Z_UNICODE_ARABIC_SUKUN_MEDIAL_FORM				       0xFE7F
#define Z_UNICODE_ARABIC_LETTER_HAMZA_ISOLATED_FORM			       0xFE80
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE_ISOLATED_FORM	       0xFE81
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_MADDA_ABOVE_FINAL_FORM	       0xFE82
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE_ISOLATED_FORM	       0xFE83
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_HAMZA_ABOVE_FINAL_FORM	       0xFE84
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE_ISOLATED_FORM	       0xFE85
#define Z_UNICODE_ARABIC_LETTER_WAW_WITH_HAMZA_ABOVE_FINAL_FORM		       0xFE86
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW_ISOLATED_FORM	       0xFE87
#define Z_UNICODE_ARABIC_LETTER_ALEF_WITH_HAMZA_BELOW_FINAL_FORM	       0xFE88
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_ISOLATED_FORM	       0xFE89
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_FINAL_FORM		       0xFE8A
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_INITIAL_FORM	       0xFE8B
#define Z_UNICODE_ARABIC_LETTER_YEH_WITH_HAMZA_ABOVE_MEDIAL_FORM	       0xFE8C
#define Z_UNICODE_ARABIC_LETTER_ALEF_ISOLATED_FORM			       0xFE8D
#define Z_UNICODE_ARABIC_LETTER_ALEF_FINAL_FORM				       0xFE8E
#define Z_UNICODE_ARABIC_LETTER_BEH_ISOLATED_FORM			       0xFE8F
#define Z_UNICODE_ARABIC_LETTER_BEH_FINAL_FORM				       0xFE90
#define Z_UNICODE_ARABIC_LETTER_BEH_INITIAL_FORM			       0xFE91
#define Z_UNICODE_ARABIC_LETTER_BEH_MEDIAL_FORM				       0xFE92
#define Z_UNICODE_ARABIC_LETTER_TEH_MARBUTA_ISOLATED_FORM		       0xFE93
#define Z_UNICODE_ARABIC_LETTER_TEH_MARBUTA_FINAL_FORM			       0xFE94
#define Z_UNICODE_ARABIC_LETTER_TEH_ISOLATED_FORM			       0xFE95
#define Z_UNICODE_ARABIC_LETTER_TEH_FINAL_FORM				       0xFE96
#define Z_UNICODE_ARABIC_LETTER_TEH_INITIAL_FORM			       0xFE97
#define Z_UNICODE_ARABIC_LETTER_TEH_MEDIAL_FORM				       0xFE98
#define Z_UNICODE_ARABIC_LETTER_THEH_ISOLATED_FORM			       0xFE99
#define Z_UNICODE_ARABIC_LETTER_THEH_FINAL_FORM				       0xFE9A
#define Z_UNICODE_ARABIC_LETTER_THEH_INITIAL_FORM			       0xFE9B
#define Z_UNICODE_ARABIC_LETTER_THEH_MEDIAL_FORM			       0xFE9C
#define Z_UNICODE_ARABIC_LETTER_JEEM_ISOLATED_FORM			       0xFE9D
#define Z_UNICODE_ARABIC_LETTER_JEEM_FINAL_FORM				       0xFE9E
#define Z_UNICODE_ARABIC_LETTER_JEEM_INITIAL_FORM			       0xFE9F
#define Z_UNICODE_ARABIC_LETTER_JEEM_MEDIAL_FORM			       0xFEA0
#define Z_UNICODE_ARABIC_LETTER_HAH_ISOLATED_FORM			       0xFEA1
#define Z_UNICODE_ARABIC_LETTER_HAH_FINAL_FORM				       0xFEA2
#define Z_UNICODE_ARABIC_LETTER_HAH_INITIAL_FORM			       0xFEA3
#define Z_UNICODE_ARABIC_LETTER_HAH_MEDIAL_FORM				       0xFEA4
#define Z_UNICODE_ARABIC_LETTER_KHAH_ISOLATED_FORM			       0xFEA5
#define Z_UNICODE_ARABIC_LETTER_KHAH_FINAL_FORM				       0xFEA6
#define Z_UNICODE_ARABIC_LETTER_KHAH_INITIAL_FORM			       0xFEA7
#define Z_UNICODE_ARABIC_LETTER_KHAH_MEDIAL_FORM			       0xFEA8
#define Z_UNICODE_ARABIC_LETTER_DAL_ISOLATED_FORM			       0xFEA9
#define Z_UNICODE_ARABIC_LETTER_DAL_FINAL_FORM				       0xFEAA
#define Z_UNICODE_ARABIC_LETTER_THAL_ISOLATED_FORM			       0xFEAB
#define Z_UNICODE_ARABIC_LETTER_THAL_FINAL_FORM				       0xFEAC
#define Z_UNICODE_ARABIC_LETTER_REH_ISOLATED_FORM			       0xFEAD
#define Z_UNICODE_ARABIC_LETTER_REH_FINAL_FORM				       0xFEAE
#define Z_UNICODE_ARABIC_LETTER_ZAIN_ISOLATED_FORM			       0xFEAF
#define Z_UNICODE_ARABIC_LETTER_ZAIN_FINAL_FORM				       0xFEB0
#define Z_UNICODE_ARABIC_LETTER_SEEN_ISOLATED_FORM			       0xFEB1
#define Z_UNICODE_ARABIC_LETTER_SEEN_FINAL_FORM				       0xFEB2
#define Z_UNICODE_ARABIC_LETTER_SEEN_INITIAL_FORM			       0xFEB3
#define Z_UNICODE_ARABIC_LETTER_SEEN_MEDIAL_FORM			       0xFEB4
#define Z_UNICODE_ARABIC_LETTER_SHEEN_ISOLATED_FORM			       0xFEB5
#define Z_UNICODE_ARABIC_LETTER_SHEEN_FINAL_FORM			       0xFEB6
#define Z_UNICODE_ARABIC_LETTER_SHEEN_INITIAL_FORM			       0xFEB7
#define Z_UNICODE_ARABIC_LETTER_SHEEN_MEDIAL_FORM			       0xFEB8
#define Z_UNICODE_ARABIC_LETTER_SAD_ISOLATED_FORM			       0xFEB9
#define Z_UNICODE_ARABIC_LETTER_SAD_FINAL_FORM				       0xFEBA
#define Z_UNICODE_ARABIC_LETTER_SAD_INITIAL_FORM			       0xFEBB
#define Z_UNICODE_ARABIC_LETTER_SAD_MEDIAL_FORM				       0xFEBC
#define Z_UNICODE_ARABIC_LETTER_DAD_ISOLATED_FORM			       0xFEBD
#define Z_UNICODE_ARABIC_LETTER_DAD_FINAL_FORM				       0xFEBE
#define Z_UNICODE_ARABIC_LETTER_DAD_INITIAL_FORM			       0xFEBF
#define Z_UNICODE_ARABIC_LETTER_DAD_MEDIAL_FORM				       0xFEC0
#define Z_UNICODE_ARABIC_LETTER_TAH_ISOLATED_FORM			       0xFEC1
#define Z_UNICODE_ARABIC_LETTER_TAH_FINAL_FORM				       0xFEC2
#define Z_UNICODE_ARABIC_LETTER_TAH_INITIAL_FORM			       0xFEC3
#define Z_UNICODE_ARABIC_LETTER_TAH_MEDIAL_FORM				       0xFEC4
#define Z_UNICODE_ARABIC_LETTER_ZAH_ISOLATED_FORM			       0xFEC5
#define Z_UNICODE_ARABIC_LETTER_ZAH_FINAL_FORM				       0xFEC6
#define Z_UNICODE_ARABIC_LETTER_ZAH_INITIAL_FORM			       0xFEC7
#define Z_UNICODE_ARABIC_LETTER_ZAH_MEDIAL_FORM				       0xFEC8
#define Z_UNICODE_ARABIC_LETTER_AIN_ISOLATED_FORM			       0xFEC9
#define Z_UNICODE_ARABIC_LETTER_AIN_FINAL_FORM				       0xFECA
#define Z_UNICODE_ARABIC_LETTER_AIN_INITIAL_FORM			       0xFECB
#define Z_UNICODE_ARABIC_LETTER_AIN_MEDIAL_FORM				       0xFECC
#define Z_UNICODE_ARABIC_LETTER_GHAIN_ISOLATED_FORM			       0xFECD
#define Z_UNICODE_ARABIC_LETTER_GHAIN_FINAL_FORM			       0xFECE
#define Z_UNICODE_ARABIC_LETTER_GHAIN_INITIAL_FORM			       0xFECF
#define Z_UNICODE_ARABIC_LETTER_GHAIN_MEDIAL_FORM			       0xFED0
#define Z_UNICODE_ARABIC_LETTER_FEH_ISOLATED_FORM			       0xFED1
#define Z_UNICODE_ARABIC_LETTER_FEH_FINAL_FORM				       0xFED2
#define Z_UNICODE_ARABIC_LETTER_FEH_INITIAL_FORM			       0xFED3
#define Z_UNICODE_ARABIC_LETTER_FEH_MEDIAL_FORM				       0xFED4
#define Z_UNICODE_ARABIC_LETTER_QAF_ISOLATED_FORM			       0xFED5
#define Z_UNICODE_ARABIC_LETTER_QAF_FINAL_FORM				       0xFED6
#define Z_UNICODE_ARABIC_LETTER_QAF_INITIAL_FORM			       0xFED7
#define Z_UNICODE_ARABIC_LETTER_QAF_MEDIAL_FORM				       0xFED8
#define Z_UNICODE_ARABIC_LETTER_KAF_ISOLATED_FORM			       0xFED9
#define Z_UNICODE_ARABIC_LETTER_KAF_FINAL_FORM				       0xFEDA
#define Z_UNICODE_ARABIC_LETTER_KAF_INITIAL_FORM			       0xFEDB
#define Z_UNICODE_ARABIC_LETTER_KAF_MEDIAL_FORM				       0xFEDC
#define Z_UNICODE_ARABIC_LETTER_LAM_ISOLATED_FORM			       0xFEDD
#define Z_UNICODE_ARABIC_LETTER_LAM_FINAL_FORM				       0xFEDE
#define Z_UNICODE_ARABIC_LETTER_LAM_INITIAL_FORM			       0xFEDF
#define Z_UNICODE_ARABIC_LETTER_LAM_MEDIAL_FORM				       0xFEE0
#define Z_UNICODE_ARABIC_LETTER_MEEM_ISOLATED_FORM			       0xFEE1
#define Z_UNICODE_ARABIC_LETTER_MEEM_FINAL_FORM				       0xFEE2
#define Z_UNICODE_ARABIC_LETTER_MEEM_INITIAL_FORM			       0xFEE3
#define Z_UNICODE_ARABIC_LETTER_MEEM_MEDIAL_FORM			       0xFEE4
#define Z_UNICODE_ARABIC_LETTER_NOON_ISOLATED_FORM			       0xFEE5
#define Z_UNICODE_ARABIC_LETTER_NOON_FINAL_FORM				       0xFEE6
#define Z_UNICODE_ARABIC_LETTER_NOON_INITIAL_FORM			       0xFEE7
#define Z_UNICODE_ARABIC_LETTER_NOON_MEDIAL_FORM			       0xFEE8
#define Z_UNICODE_ARABIC_LETTER_HEH_ISOLATED_FORM			       0xFEE9
#define Z_UNICODE_ARABIC_LETTER_HEH_FINAL_FORM				       0xFEEA
#define Z_UNICODE_ARABIC_LETTER_HEH_INITIAL_FORM			       0xFEEB
#define Z_UNICODE_ARABIC_LETTER_HEH_MEDIAL_FORM				       0xFEEC
#define Z_UNICODE_ARABIC_LETTER_WAW_ISOLATED_FORM			       0xFEED
#define Z_UNICODE_ARABIC_LETTER_WAW_FINAL_FORM				       0xFEEE
#define Z_UNICODE_ARABIC_LETTER_ALEF_MAKSURA_ISOLATED_FORM		       0xFEEF
#define Z_UNICODE_ARABIC_LETTER_ALEF_MAKSURA_FINAL_FORM			       0xFEF0
#define Z_UNICODE_ARABIC_LETTER_YEH_ISOLATED_FORM			       0xFEF1
#define Z_UNICODE_ARABIC_LETTER_YEH_FINAL_FORM				       0xFEF2
#define Z_UNICODE_ARABIC_LETTER_YEH_INITIAL_FORM			       0xFEF3
#define Z_UNICODE_ARABIC_LETTER_YEH_MEDIAL_FORM				       0xFEF4
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_MADDA_ABOVE_ISOLATED_FORM 0xFEF5
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_MADDA_ABOVE_FINAL_FORM    0xFEF6
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_ABOVE_ISOLATED_FORM 0xFEF7
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_ABOVE_FINAL_FORM    0xFEF8
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_BELOW_ISOLATED_FORM 0xFEF9
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_WITH_HAMZA_BELOW_FINAL_FORM    0xFEFA
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_ISOLATED_FORM		       0xFEFB
#define Z_UNICODE_ARABIC_LIGATURE_LAM_WITH_ALEF_FINAL_FORM		       0xFEFC
#define Z_UNICODE_ZERO_WIDTH_NO_BREAK_SPACE				       0xFEFF

/* MARK: - FF00h-FFEFh - Halfwidth and Fullwidth Forms */

#define Z_UNICODE_FULLWIDTH_EXCLAMATION_MARK			   0xFF01
#define Z_UNICODE_FULLWIDTH_QUOTATION_MARK			   0xFF02
#define Z_UNICODE_FULLWIDTH_NUMBER_SIGN				   0xFF03
#define Z_UNICODE_FULLWIDTH_DOLLAR_SIGN				   0xFF04
#define Z_UNICODE_FULLWIDTH_PERCENT_SIGN			   0xFF05
#define Z_UNICODE_FULLWIDTH_AMPERSAND				   0xFF06
#define Z_UNICODE_FULLWIDTH_APOSTROPHE				   0xFF07
#define Z_UNICODE_FULLWIDTH_LEFT_PARENTHESIS			   0xFF08
#define Z_UNICODE_FULLWIDTH_RIGHT_PARENTHESIS			   0xFF09
#define Z_UNICODE_FULLWIDTH_ASTERISK				   0xFF0A
#define Z_UNICODE_FULLWIDTH_PLUS_SIGN				   0xFF0B
#define Z_UNICODE_FULLWIDTH_COMMA				   0xFF0C
#define Z_UNICODE_FULLWIDTH_HYPHEN_MINUS			   0xFF0D
#define Z_UNICODE_FULLWIDTH_FULL_STOP				   0xFF0E
#define Z_UNICODE_FULLWIDTH_SOLIDUS				   0xFF0F
#define Z_UNICODE_FULLWIDTH_DIGIT_ZERO				   0xFF10
#define Z_UNICODE_FULLWIDTH_DIGIT_ONE				   0xFF11
#define Z_UNICODE_FULLWIDTH_DIGIT_TWO				   0xFF12
#define Z_UNICODE_FULLWIDTH_DIGIT_THREE				   0xFF13
#define Z_UNICODE_FULLWIDTH_DIGIT_FOUR				   0xFF14
#define Z_UNICODE_FULLWIDTH_DIGIT_FIVE				   0xFF15
#define Z_UNICODE_FULLWIDTH_DIGIT_SIX				   0xFF16
#define Z_UNICODE_FULLWIDTH_DIGIT_SEVEN				   0xFF17
#define Z_UNICODE_FULLWIDTH_DIGIT_EIGHT				   0xFF18
#define Z_UNICODE_FULLWIDTH_DIGIT_NINE				   0xFF19
#define Z_UNICODE_FULLWIDTH_COLON				   0xFF1A
#define Z_UNICODE_FULLWIDTH_SEMICOLON				   0xFF1B
#define Z_UNICODE_FULLWIDTH_LESS_THAN_SIGN			   0xFF1C
#define Z_UNICODE_FULLWIDTH_EQUALS_SIGN				   0xFF1D
#define Z_UNICODE_FULLWIDTH_GREATER_THAN_SIGN			   0xFF1E
#define Z_UNICODE_FULLWIDTH_QUESTION_MARK			   0xFF1F
#define Z_UNICODE_FULLWIDTH_COMMERCIAL_AT			   0xFF20
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_A		   0xFF21
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_B		   0xFF22
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_C		   0xFF23
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_D		   0xFF24
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_E		   0xFF25
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_F		   0xFF26
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_G		   0xFF27
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_H		   0xFF28
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_I		   0xFF29
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_J		   0xFF2A
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_K		   0xFF2B
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_L		   0xFF2C
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_M		   0xFF2D
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_N		   0xFF2E
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_O		   0xFF2F
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_P		   0xFF30
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_Q		   0xFF31
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_R		   0xFF32
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_S		   0xFF33
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_T		   0xFF34
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_U		   0xFF35
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_V		   0xFF36
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_W		   0xFF37
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_X		   0xFF38
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_Y		   0xFF39
#define Z_UNICODE_FULLWIDTH_LATIN_CAPITAL_LETTER_Z		   0xFF3A
#define Z_UNICODE_FULLWIDTH_LEFT_SQUARE_BRACKET			   0xFF3B
#define Z_UNICODE_FULLWIDTH_REVERSE_SOLIDUS			   0xFF3C
#define Z_UNICODE_FULLWIDTH_RIGHT_SQUARE_BRACKET		   0xFF3D
#define Z_UNICODE_FULLWIDTH_CIRCUMFLEX_ACCENT			   0xFF3E
#define Z_UNICODE_FULLWIDTH_LOW_LINE				   0xFF3F
#define Z_UNICODE_FULLWIDTH_GRAVE_ACCENT			   0xFF40
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_A		   0xFF41
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_B		   0xFF42
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_C		   0xFF43
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_D		   0xFF44
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_E		   0xFF45
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_F		   0xFF46
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_G		   0xFF47
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_H		   0xFF48
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_I		   0xFF49
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_J		   0xFF4A
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_K		   0xFF4B
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_L		   0xFF4C
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_M		   0xFF4D
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_N		   0xFF4E
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_O		   0xFF4F
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_P		   0xFF50
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_Q		   0xFF51
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_R		   0xFF52
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_S		   0xFF53
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_T		   0xFF54
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_U		   0xFF55
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_V		   0xFF56
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_W		   0xFF57
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_X		   0xFF58
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_Y		   0xFF59
#define Z_UNICODE_FULLWIDTH_LATIN_SMALL_LETTER_Z		   0xFF5A
#define Z_UNICODE_FULLWIDTH_LEFT_CURLY_BRACKET			   0xFF5B
#define Z_UNICODE_FULLWIDTH_VERTICAL_LINE			   0xFF5C
#define Z_UNICODE_FULLWIDTH_RIGHT_CURLY_BRACKET			   0xFF5D
#define Z_UNICODE_FULLWIDTH_TILDE				   0xFF5E
#define Z_UNICODE_FULLWIDTH_LEFT_WHITE_PARENTHESIS		   0xFF5F
#define Z_UNICODE_FULLWIDTH_RIGHT_WHITE_PARENTHESIS		   0xFF60
#define Z_UNICODE_HALFWIDTH_IDEOGRAPHIC_FULL_STOP		   0xFF61
#define Z_UNICODE_HALFWIDTH_LEFT_CORNER_BRACKET			   0xFF62
#define Z_UNICODE_HALFWIDTH_RIGHT_CORNER_BRACKET		   0xFF63
#define Z_UNICODE_HALFWIDTH_IDEOGRAPHIC_COMMA			   0xFF64
#define Z_UNICODE_HALFWIDTH_KATAKANA_MIDDLE_DOT			   0xFF65
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_WO			   0xFF66
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_A		   0xFF67
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_I		   0xFF68
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_U		   0xFF69
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_E		   0xFF6A
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_O		   0xFF6B
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_YA		   0xFF6C
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_YU		   0xFF6D
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_YO		   0xFF6E
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SMALL_TU		   0xFF6F
#define Z_UNICODE_HALFWIDTH_KATAKANA_HIRAGANA_PROLONGED_SOUND_MARK 0xFF70
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_A			   0xFF71
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_I			   0xFF72
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_U			   0xFF73
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_E			   0xFF74
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_O			   0xFF75
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_KA			   0xFF76
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_KI			   0xFF77
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_KU			   0xFF78
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_KE			   0xFF79
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_KO			   0xFF7A
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SA			   0xFF7B
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SI			   0xFF7C
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SU			   0xFF7D
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SE			   0xFF7E
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_SO			   0xFF7F
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_TA			   0xFF80
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_TI			   0xFF81
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_TU			   0xFF82
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_TE			   0xFF83
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_TO			   0xFF84
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_NA			   0xFF85
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_NI			   0xFF86
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_NU			   0xFF87
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_NE			   0xFF88
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_NO			   0xFF89
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_HA			   0xFF8A
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_HI			   0xFF8B
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_HU			   0xFF8C
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_HE			   0xFF8D
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_HO			   0xFF8E
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_MA			   0xFF8F
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_MI			   0xFF90
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_MU			   0xFF91
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_ME			   0xFF92
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_MO			   0xFF93
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_YA			   0xFF94
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_YU			   0xFF95
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_YO			   0xFF96
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_RA			   0xFF97
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_RI			   0xFF98
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_RU			   0xFF99
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_RE			   0xFF9A
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_RO			   0xFF9B
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_WA			   0xFF9C
#define Z_UNICODE_HALFWIDTH_KATAKANA_LETTER_N			   0xFF9D
#define Z_UNICODE_HALFWIDTH_KATAKANA_VOICED_SOUND_MARK		   0xFF9E
#define Z_UNICODE_HALFWIDTH_KATAKANA_SEMI_VOICED_SOUND_MARK	   0xFF9F
#define Z_UNICODE_HALFWIDTH_HANGUL_FILLER			   0xFFA0
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_KIYEOK		   0xFFA1
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_SSANGKIYEOK		   0xFFA2
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_KIYEOK_SIOS		   0xFFA3
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_NIEUN			   0xFFA4
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_NIEUN_CIEUC		   0xFFA5
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_NIEUN_HIEUH		   0xFFA6
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_TIKEUT		   0xFFA7
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_SSANGTIKEUT		   0xFFA8
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_RIEUL			   0xFFA9
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_RIEUL_KIYEOK		   0xFFAA
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_RIEUL_MIEUM		   0xFFAB
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_RIEUL_PIEUP		   0xFFAC
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_RIEUL_SIOS		   0xFFAD
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_RIEUL_THIEUTH		   0xFFAE
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_RIEUL_PHIEUPH		   0xFFAF
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_RIEUL_HIEUH		   0xFFB0
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_MIEUM			   0xFFB1
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_PIEUP			   0xFFB2
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_SSANGPIEUP		   0xFFB3
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_PIEUP_SIOS		   0xFFB4
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_SIOS			   0xFFB5
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_SSANGSIOS		   0xFFB6
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_IEUNG			   0xFFB7
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_CIEUC			   0xFFB8
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_SSANGCIEUC		   0xFFB9
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_CHIEUCH		   0xFFBA
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_KHIEUKH		   0xFFBB
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_THIEUTH		   0xFFBC
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_PHIEUPH		   0xFFBD
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_HIEUH			   0xFFBE
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_A			   0xFFC2
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_AE			   0xFFC3
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_YA			   0xFFC4
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_YAE			   0xFFC5
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_EO			   0xFFC6
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_E			   0xFFC7
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_YEO			   0xFFCA
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_YE			   0xFFCB
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_O			   0xFFCC
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_WA			   0xFFCD
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_WAE			   0xFFCE
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_OE			   0xFFCF
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_YO			   0xFFD2
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_U			   0xFFD3
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_WEO			   0xFFD4
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_WE			   0xFFD5
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_WI			   0xFFD6
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_YU			   0xFFD7
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_EU			   0xFFDA
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_YI			   0xFFDB
#define Z_UNICODE_HALFWIDTH_HANGUL_LETTER_I			   0xFFDC
#define Z_UNICODE_FULLWIDTH_CENT_SIGN				   0xFFE0
#define Z_UNICODE_FULLWIDTH_POUND_SIGN				   0xFFE1
#define Z_UNICODE_FULLWIDTH_NOT_SIGN				   0xFFE2
#define Z_UNICODE_FULLWIDTH_MACRON				   0xFFE3
#define Z_UNICODE_FULLWIDTH_BROKEN_BAR				   0xFFE4
#define Z_UNICODE_FULLWIDTH_YEN_SIGN				   0xFFE5
#define Z_UNICODE_FULLWIDTH_WON_SIGN				   0xFFE6
#define Z_UNICODE_HALFWIDTH_FORMS_LIGHT_VERTICAL		   0xFFE8
#define Z_UNICODE_HALFWIDTH_LEFTWARDS_ARROW			   0xFFE9
#define Z_UNICODE_HALFWIDTH_UPWARDS_ARROW			   0xFFEA
#define Z_UNICODE_HALFWIDTH_RIGHTWARDS_ARROW			   0xFFEB
#define Z_UNICODE_HALFWIDTH_DOWNWARDS_ARROW			   0xFFEC
#define Z_UNICODE_HALFWIDTH_BLACK_SQUARE			   0xFFED
#define Z_UNICODE_HALFWIDTH_WHITE_CIRCLE			   0xFFEE

/* MARK: - FFF0h-FFFFh - Specials */

/* FFFEh <not a character> */
/* FFFFh <not a character> */
#define Z_UNICODE_INTERLINEAR_ANNOTATION_ANCHOR	    0xFFF9
#define Z_UNICODE_INTERLINEAR_ANNOTATION_SEPARATOR  0xFFFA
#define Z_UNICODE_INTERLINEAR_ANNOTATION_TERMINATOR 0xFFFB
#define Z_UNICODE_OBJECT_REPLACEMENT_CHARACTER	    0xFFFC
#define Z_UNICODE_REPLACEMENT_CHARACTER		    0xFFFD

/* MARK: - 10000h-1007Fh - Linear B Syllabary */

#define Z_UNICODE_LINEAR_B_SYLLABLE_B008_A   0x10000
#define Z_UNICODE_LINEAR_B_SYLLABLE_B038_E   0x10001
#define Z_UNICODE_LINEAR_B_SYLLABLE_B028_I   0x10002
#define Z_UNICODE_LINEAR_B_SYLLABLE_B061_O   0x10003
#define Z_UNICODE_LINEAR_B_SYLLABLE_B010_U   0x10004
#define Z_UNICODE_LINEAR_B_SYLLABLE_B001_DA  0x10005
#define Z_UNICODE_LINEAR_B_SYLLABLE_B045_DE  0x10006
#define Z_UNICODE_LINEAR_B_SYLLABLE_B007_DI  0x10007
#define Z_UNICODE_LINEAR_B_SYLLABLE_B014_DO  0x10008
#define Z_UNICODE_LINEAR_B_SYLLABLE_B051_DU  0x10009
#define Z_UNICODE_LINEAR_B_SYLLABLE_B057_JA  0x1000A
#define Z_UNICODE_LINEAR_B_SYLLABLE_B046_JE  0x1000B
#define Z_UNICODE_LINEAR_B_SYLLABLE_B036_JO  0x1000D
#define Z_UNICODE_LINEAR_B_SYLLABLE_B065_JU  0x1000E
#define Z_UNICODE_LINEAR_B_SYLLABLE_B077_KA  0x1000F
#define Z_UNICODE_LINEAR_B_SYLLABLE_B044_KE  0x10010
#define Z_UNICODE_LINEAR_B_SYLLABLE_B067_KI  0x10011
#define Z_UNICODE_LINEAR_B_SYLLABLE_B070_KO  0x10012
#define Z_UNICODE_LINEAR_B_SYLLABLE_B081_KU  0x10013
#define Z_UNICODE_LINEAR_B_SYLLABLE_B080_MA  0x10014
#define Z_UNICODE_LINEAR_B_SYLLABLE_B013_ME  0x10015
#define Z_UNICODE_LINEAR_B_SYLLABLE_B073_MI  0x10016
#define Z_UNICODE_LINEAR_B_SYLLABLE_B015_MO  0x10017
#define Z_UNICODE_LINEAR_B_SYLLABLE_B023_MU  0x10018
#define Z_UNICODE_LINEAR_B_SYLLABLE_B006_NA  0x10019
#define Z_UNICODE_LINEAR_B_SYLLABLE_B024_NE  0x1001A
#define Z_UNICODE_LINEAR_B_SYLLABLE_B030_NI  0x1001B
#define Z_UNICODE_LINEAR_B_SYLLABLE_B052_NO  0x1001C
#define Z_UNICODE_LINEAR_B_SYLLABLE_B055_NU  0x1001D
#define Z_UNICODE_LINEAR_B_SYLLABLE_B003_PA  0x1001E
#define Z_UNICODE_LINEAR_B_SYLLABLE_B072_PE  0x1001F
#define Z_UNICODE_LINEAR_B_SYLLABLE_B039_PI  0x10020
#define Z_UNICODE_LINEAR_B_SYLLABLE_B011_PO  0x10021
#define Z_UNICODE_LINEAR_B_SYLLABLE_B050_PU  0x10022
#define Z_UNICODE_LINEAR_B_SYLLABLE_B016_QA  0x10023
#define Z_UNICODE_LINEAR_B_SYLLABLE_B078_QE  0x10024
#define Z_UNICODE_LINEAR_B_SYLLABLE_B021_QI  0x10025
#define Z_UNICODE_LINEAR_B_SYLLABLE_B032_QO  0x10026
#define Z_UNICODE_LINEAR_B_SYLLABLE_B060_RA  0x10028
#define Z_UNICODE_LINEAR_B_SYLLABLE_B027_RE  0x10029
#define Z_UNICODE_LINEAR_B_SYLLABLE_B053_RI  0x1002A
#define Z_UNICODE_LINEAR_B_SYLLABLE_B002_RO  0x1002B
#define Z_UNICODE_LINEAR_B_SYLLABLE_B026_RU  0x1002C
#define Z_UNICODE_LINEAR_B_SYLLABLE_B031_SA  0x1002D
#define Z_UNICODE_LINEAR_B_SYLLABLE_B009_SE  0x1002E
#define Z_UNICODE_LINEAR_B_SYLLABLE_B041_SI  0x1002F
#define Z_UNICODE_LINEAR_B_SYLLABLE_B012_SO  0x10030
#define Z_UNICODE_LINEAR_B_SYLLABLE_B058_SU  0x10031
#define Z_UNICODE_LINEAR_B_SYLLABLE_B059_TA  0x10032
#define Z_UNICODE_LINEAR_B_SYLLABLE_B004_TE  0x10033
#define Z_UNICODE_LINEAR_B_SYLLABLE_B037_TI  0x10034
#define Z_UNICODE_LINEAR_B_SYLLABLE_B005_TO  0x10035
#define Z_UNICODE_LINEAR_B_SYLLABLE_B069_TU  0x10036
#define Z_UNICODE_LINEAR_B_SYLLABLE_B054_WA  0x10037
#define Z_UNICODE_LINEAR_B_SYLLABLE_B075_WE  0x10038
#define Z_UNICODE_LINEAR_B_SYLLABLE_B040_WI  0x10039
#define Z_UNICODE_LINEAR_B_SYLLABLE_B042_WO  0x1003A
#define Z_UNICODE_LINEAR_B_SYLLABLE_B017_ZA  0x1003C
#define Z_UNICODE_LINEAR_B_SYLLABLE_B074_ZE  0x1003D
#define Z_UNICODE_LINEAR_B_SYLLABLE_B020_ZO  0x1003F
#define Z_UNICODE_LINEAR_B_SYLLABLE_B025_A2  0x10040
#define Z_UNICODE_LINEAR_B_SYLLABLE_B043_A3  0x10041
#define Z_UNICODE_LINEAR_B_SYLLABLE_B085_AU  0x10042
#define Z_UNICODE_LINEAR_B_SYLLABLE_B071_DWE 0x10043
#define Z_UNICODE_LINEAR_B_SYLLABLE_B090_DWO 0x10044
#define Z_UNICODE_LINEAR_B_SYLLABLE_B048_NWA 0x10045
#define Z_UNICODE_LINEAR_B_SYLLABLE_B029_PU2 0x10046
#define Z_UNICODE_LINEAR_B_SYLLABLE_B062_PTE 0x10047
#define Z_UNICODE_LINEAR_B_SYLLABLE_B076_RA2 0x10048
#define Z_UNICODE_LINEAR_B_SYLLABLE_B033_RA3 0x10049
#define Z_UNICODE_LINEAR_B_SYLLABLE_B068_RO2 0x1004A
#define Z_UNICODE_LINEAR_B_SYLLABLE_B066_TA2 0x1004B
#define Z_UNICODE_LINEAR_B_SYLLABLE_B087_TWE 0x1004C
#define Z_UNICODE_LINEAR_B_SYLLABLE_B091_TWO 0x1004D
#define Z_UNICODE_LINEAR_B_SYMBOL_B018	     0x10050
#define Z_UNICODE_LINEAR_B_SYMBOL_B019	     0x10051
#define Z_UNICODE_LINEAR_B_SYMBOL_B022	     0x10052
#define Z_UNICODE_LINEAR_B_SYMBOL_B034	     0x10053
#define Z_UNICODE_LINEAR_B_SYMBOL_B047	     0x10054
#define Z_UNICODE_LINEAR_B_SYMBOL_B049	     0x10055
#define Z_UNICODE_LINEAR_B_SYMBOL_B056	     0x10056
#define Z_UNICODE_LINEAR_B_SYMBOL_B063	     0x10057
#define Z_UNICODE_LINEAR_B_SYMBOL_B064	     0x10058
#define Z_UNICODE_LINEAR_B_SYMBOL_B079	     0x10059
#define Z_UNICODE_LINEAR_B_SYMBOL_B082	     0x1005A
#define Z_UNICODE_LINEAR_B_SYMBOL_B083	     0x1005B
#define Z_UNICODE_LINEAR_B_SYMBOL_B086	     0x1005C
#define Z_UNICODE_LINEAR_B_SYMBOL_B089	     0x1005D

/* MARK: - 10080h-100FFh - Linear B Ideograms */

#define Z_UNICODE_LINEAR_B_IDEOGRAM_B100_MAN		 0x10080
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B102_WOMAN		 0x10081
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B104_DEER		 0x10082
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B105_EQUID		 0x10083
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B105F_MARE		 0x10084
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B105M_STALLION	 0x10085
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B106F_EWE		 0x10086
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B106M_RAM		 0x10087
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B107F_SHE_GOAT	 0x10088
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B107M_HE_GOAT	 0x10089
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B108F_SOW		 0x1008A
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B108M_BOAR		 0x1008B
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B109F_COW		 0x1008C
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B109M_BULL		 0x1008D
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B120_WHEAT		 0x1008E
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B121_BARLEY		 0x1008F
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B122_OLIVE		 0x10090
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B123_SPICE		 0x10091
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B125_CYPERUS	 0x10092
#define Z_UNICODE_LINEAR_B_MONOGRAM_B127_KAPO		 0x10093
#define Z_UNICODE_LINEAR_B_MONOGRAM_B128_KANAKO		 0x10094
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B130_OIL		 0x10095
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B131_WINE		 0x10096
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B132		 0x10097
#define Z_UNICODE_LINEAR_B_MONOGRAM_B133_AREPA		 0x10098
#define Z_UNICODE_LINEAR_B_MONOGRAM_B135_MERI		 0x10099
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B140_BRONZE		 0x1009A
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B141_GOLD		 0x1009B
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B142		 0x1009C
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B145_WOOL		 0x1009D
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B146		 0x1009E
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B150		 0x1009F
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B151_HORN		 0x100A0
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B152		 0x100A1
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B153		 0x100A2
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B154		 0x100A3
#define Z_UNICODE_LINEAR_B_MONOGRAM_B156_TURO2		 0x100A4
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B157		 0x100A5
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B158		 0x100A6
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B159_CLOTH		 0x100A7
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B160		 0x100A8
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B161		 0x100A9
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B162_GARMENT	 0x100AA
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B163_ARMOUR		 0x100AB
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B164		 0x100AC
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B165		 0x100AD
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B166		 0x100AE
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B167		 0x100AF
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B168		 0x100B0
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B169		 0x100B1
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B170		 0x100B2
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B171		 0x100B3
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B172		 0x100B4
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B173_MONTH		 0x100B5
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B174		 0x100B6
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B176_TREE		 0x100B7
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B177		 0x100B8
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B178		 0x100B9
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B179		 0x100BA
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B180		 0x100BB
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B181		 0x100BC
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B182		 0x100BD
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B183		 0x100BE
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B184		 0x100BF
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B185		 0x100C0
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B189		 0x100C1
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B190		 0x100C2
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B191_HELMET		 0x100C3
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B220_FOOTSTOOL	 0x100C4
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B225_BATHTUB	 0x100C5
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B230_SPEAR		 0x100C6
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B231_ARROW		 0x100C7
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B232		 0x100C8
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B233_SWORD		 0x100C9
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B234		 0x100CA
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B236		 0x100CB
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B240_WHEELED_CHARIOT 0x100CC
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B241_CHARIOT	 0x100CD
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B242_CHARIOT_FRAME	 0x100CE
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B243_WHEEL		 0x100CF
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B245		 0x100D0
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B246		 0x100D1
#define Z_UNICODE_LINEAR_B_MONOGRAM_B247_DIPTE		 0x100D2
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B248		 0x100D3
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B249		 0x100D4
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B251		 0x100D5
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B252		 0x100D6
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B253		 0x100D7
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B254_DART		 0x100D8
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B255		 0x100D9
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B256		 0x100DA
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B257		 0x100DB
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B258		 0x100DC
#define Z_UNICODE_LINEAR_B_IDEOGRAM_B259		 0x100DD
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B155		 0x100DE
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B200		 0x100DF
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B201		 0x100E0
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B202		 0x100E1
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B203		 0x100E2
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B204		 0x100E3
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B205		 0x100E4
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B206		 0x100E5
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B207		 0x100E6
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B208		 0x100E7
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B209		 0x100E8
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B210		 0x100E9
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B211		 0x100EA
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B212		 0x100EB
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B213		 0x100EC
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B214		 0x100ED
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B215		 0x100EE
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B216		 0x100EF
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B217		 0x100F0
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B218		 0x100F1
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B219		 0x100F2
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B221		 0x100F3
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B222		 0x100F4
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B226		 0x100F5
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B227		 0x100F6
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B228		 0x100F7
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B229		 0x100F8
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B250		 0x100F9
#define Z_UNICODE_LINEAR_B_IDEOGRAM_VESSEL_B305		 0x100FA

/* MARK: - 10100h-1013Fh - Aegean Numbers */

#define Z_UNICODE_AEGEAN_WORD_SEPARATOR_LINE	      0x10100
#define Z_UNICODE_AEGEAN_WORD_SEPARATOR_DOT	      0x10101
#define Z_UNICODE_AEGEAN_CHECK_MARK		      0x10102
#define Z_UNICODE_AEGEAN_NUMBER_ONE		      0x10107
#define Z_UNICODE_AEGEAN_NUMBER_TWO		      0x10108
#define Z_UNICODE_AEGEAN_NUMBER_THREE		      0x10109
#define Z_UNICODE_AEGEAN_NUMBER_FOUR		      0x1010A
#define Z_UNICODE_AEGEAN_NUMBER_FIVE		      0x1010B
#define Z_UNICODE_AEGEAN_NUMBER_SIX		      0x1010C
#define Z_UNICODE_AEGEAN_NUMBER_SEVEN		      0x1010D
#define Z_UNICODE_AEGEAN_NUMBER_EIGHT		      0x1010E
#define Z_UNICODE_AEGEAN_NUMBER_NINE		      0x1010F
#define Z_UNICODE_AEGEAN_NUMBER_TEN		      0x10110
#define Z_UNICODE_AEGEAN_NUMBER_TWENTY		      0x10111
#define Z_UNICODE_AEGEAN_NUMBER_THIRTY		      0x10112
#define Z_UNICODE_AEGEAN_NUMBER_FORTY		      0x10113
#define Z_UNICODE_AEGEAN_NUMBER_FIFTY		      0x10114
#define Z_UNICODE_AEGEAN_NUMBER_SIXTY		      0x10115
#define Z_UNICODE_AEGEAN_NUMBER_SEVENTY		      0x10116
#define Z_UNICODE_AEGEAN_NUMBER_EIGHTY		      0x10117
#define Z_UNICODE_AEGEAN_NUMBER_NINETY		      0x10118
#define Z_UNICODE_AEGEAN_NUMBER_ONE_HUNDRED	      0x10119
#define Z_UNICODE_AEGEAN_NUMBER_TWO_HUNDRED	      0x1011A
#define Z_UNICODE_AEGEAN_NUMBER_THREE_HUNDRED	      0x1011B
#define Z_UNICODE_AEGEAN_NUMBER_FOUR_HUNDRED	      0x1011C
#define Z_UNICODE_AEGEAN_NUMBER_FIVE_HUNDRED	      0x1011D
#define Z_UNICODE_AEGEAN_NUMBER_SIX_HUNDRED	      0x1011E
#define Z_UNICODE_AEGEAN_NUMBER_SEVEN_HUNDRED	      0x1011F
#define Z_UNICODE_AEGEAN_NUMBER_EIGHT_HUNDRED	      0x10120
#define Z_UNICODE_AEGEAN_NUMBER_NINE_HUNDRED	      0x10121
#define Z_UNICODE_AEGEAN_NUMBER_ONE_THOUSAND	      0x10122
#define Z_UNICODE_AEGEAN_NUMBER_TWO_THOUSAND	      0x10123
#define Z_UNICODE_AEGEAN_NUMBER_THREE_THOUSAND	      0x10124
#define Z_UNICODE_AEGEAN_NUMBER_FOUR_THOUSAND	      0x10125
#define Z_UNICODE_AEGEAN_NUMBER_FIVE_THOUSAND	      0x10126
#define Z_UNICODE_AEGEAN_NUMBER_SIX_THOUSAND	      0x10127
#define Z_UNICODE_AEGEAN_NUMBER_SEVEN_THOUSAND	      0x10128
#define Z_UNICODE_AEGEAN_NUMBER_EIGHT_THOUSAND	      0x10129
#define Z_UNICODE_AEGEAN_NUMBER_NINE_THOUSAND	      0x1012A
#define Z_UNICODE_AEGEAN_NUMBER_TEN_THOUSAND	      0x1012B
#define Z_UNICODE_AEGEAN_NUMBER_TWENTY_THOUSAND	      0x1012C
#define Z_UNICODE_AEGEAN_NUMBER_THIRTY_THOUSAND	      0x1012D
#define Z_UNICODE_AEGEAN_NUMBER_FORTY_THOUSAND	      0x1012E
#define Z_UNICODE_AEGEAN_NUMBER_FIFTY_THOUSAND	      0x1012F
#define Z_UNICODE_AEGEAN_NUMBER_SIXTY_THOUSAND	      0x10130
#define Z_UNICODE_AEGEAN_NUMBER_SEVENTY_THOUSAND      0x10131
#define Z_UNICODE_AEGEAN_NUMBER_EIGHTY_THOUSAND	      0x10132
#define Z_UNICODE_AEGEAN_NUMBER_NINETY_THOUSAND	      0x10133
#define Z_UNICODE_AEGEAN_WEIGHT_BASE_UNIT	      0x10137
#define Z_UNICODE_AEGEAN_WEIGHT_FIRST_SUBUNIT	      0x10138
#define Z_UNICODE_AEGEAN_WEIGHT_SECOND_SUBUNIT	      0x10139
#define Z_UNICODE_AEGEAN_WEIGHT_THIRD_SUBUNIT	      0x1013A
#define Z_UNICODE_AEGEAN_WEIGHT_FOURTH_SUBUNIT	      0x1013B
#define Z_UNICODE_AEGEAN_DRY_MEASURE_FIRST_SUBUNIT    0x1013C
#define Z_UNICODE_AEGEAN_LIQUID_MEASURE_FIRST_SUBUNIT 0x1013D
#define Z_UNICODE_AEGEAN_MEASURE_SECOND_SUBUNIT	      0x1013E
#define Z_UNICODE_AEGEAN_MEASURE_THIRD_SUBUNIT	      0x1013F

/* MARK: - 10140h-1018Fh - Ancient Greek Numbers */

#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_ONE_QUARTER		   0x10140
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_ONE_HALF		   0x10141
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_ONE_DRACHMA		   0x10142
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIVE			   0x10143
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIFTY			   0x10144
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED		   0x10145
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIVE_THOUSAND		   0x10146
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIFTY_THOUSAND		   0x10147
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIVE_TALENTS		   0x10148
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_TEN_TALENTS		   0x10149
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIFTY_TALENTS		   0x1014A
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_ONE_HUNDRED_TALENTS	   0x1014B
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED_TALENTS	   0x1014C
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_ONE_THOUSAND_TALENTS	   0x1014D
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIVE_THOUSAND_TALENTS	   0x1014E
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIVE_STATERS		   0x1014F
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_TEN_STATERS		   0x10150
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIFTY_STATERS		   0x10151
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_ONE_HUNDRED_STATERS	   0x10152
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIVE_HUNDRED_STATERS	   0x10153
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_ONE_THOUSAND_STATERS	   0x10154
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_TEN_THOUSAND_STATERS	   0x10155
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_FIFTY_THOUSAND_STATERS	   0x10156
#define Z_UNICODE_GREEK_ACROPHONIC_ATTIC_TEN_MNAS		   0x10157
#define Z_UNICODE_GREEK_ACROPHONIC_HERAEUM_ONE_PLETHRON		   0x10158
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_ONE			   0x10159
#define Z_UNICODE_GREEK_ACROPHONIC_HERMIONIAN_ONE		   0x1015A
#define Z_UNICODE_GREEK_ACROPHONIC_EPIDAUREAN_TWO		   0x1015B
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_TWO			   0x1015C
#define Z_UNICODE_GREEK_ACROPHONIC_CYRENAIC_TWO_DRACHMAS	   0x1015D
#define Z_UNICODE_GREEK_ACROPHONIC_EPIDAUREAN_TWO_DRACHMAS	   0x1015E
#define Z_UNICODE_GREEK_ACROPHONIC_TROEZENIAN_FIVE		   0x1015F
#define Z_UNICODE_GREEK_ACROPHONIC_TROEZENIAN_TEN		   0x10160
#define Z_UNICODE_GREEK_ACROPHONIC_TROEZENIAN_TEN_ALTERNATE_FORM   0x10161
#define Z_UNICODE_GREEK_ACROPHONIC_HERMIONIAN_TEN		   0x10162
#define Z_UNICODE_GREEK_ACROPHONIC_MESSENIAN_TEN		   0x10163
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_TEN			   0x10164
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_THIRTY		   0x10165
#define Z_UNICODE_GREEK_ACROPHONIC_TROEZENIAN_FIFTY		   0x10166
#define Z_UNICODE_GREEK_ACROPHONIC_TROEZENIAN_FIFTY_ALTERNATE_FORM 0x10167
#define Z_UNICODE_GREEK_ACROPHONIC_HERMIONIAN_FIFTY		   0x10168
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_FIFTY		   0x10169
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_ONE_HUNDRED		   0x1016A
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_THREE_HUNDRED	   0x1016B
#define Z_UNICODE_GREEK_ACROPHONIC_EPIDAUREAN_FIVE_HUNDRED	   0x1016C
#define Z_UNICODE_GREEK_ACROPHONIC_TROEZENIAN_FIVE_HUNDRED	   0x1016D
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_FIVE_HUNDRED	   0x1016E
#define Z_UNICODE_GREEK_ACROPHONIC_CARYSTIAN_FIVE_HUNDRED	   0x1016F
#define Z_UNICODE_GREEK_ACROPHONIC_NAXIAN_FIVE_HUNDRED		   0x10170
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_ONE_THOUSAND	   0x10171
#define Z_UNICODE_GREEK_ACROPHONIC_THESPIAN_FIVE_THOUSAND	   0x10172
#define Z_UNICODE_GREEK_ACROPHONIC_DELPHIC_FIVE_MNAS		   0x10173
#define Z_UNICODE_GREEK_ACROPHONIC_STRATIAN_FIFTY_MNAS		   0x10174
#define Z_UNICODE_GREEK_ONE_HALF_SIGN				   0x10175
#define Z_UNICODE_GREEK_ONE_HALF_SIGN_ALTERNATE_FORM		   0x10176
#define Z_UNICODE_GREEK_TWO_THIRDS_SIGN				   0x10177
#define Z_UNICODE_GREEK_THREE_QUARTERS_SIGN			   0x10178
#define Z_UNICODE_GREEK_YEAR_SIGN				   0x10179
#define Z_UNICODE_GREEK_TALENT_SIGN				   0x1017A
#define Z_UNICODE_GREEK_DRACHMA_SIGN				   0x1017B
#define Z_UNICODE_GREEK_OBOL_SIGN				   0x1017C
#define Z_UNICODE_GREEK_TWO_OBOLS_SIGN				   0x1017D
#define Z_UNICODE_GREEK_THREE_OBOLS_SIGN			   0x1017E
#define Z_UNICODE_GREEK_FOUR_OBOLS_SIGN				   0x1017F
#define Z_UNICODE_GREEK_FIVE_OBOLS_SIGN				   0x10180
#define Z_UNICODE_GREEK_METRETES_SIGN				   0x10181
#define Z_UNICODE_GREEK_KYATHOS_BASE_SIGN			   0x10182
#define Z_UNICODE_GREEK_LITRA_SIGN				   0x10183
#define Z_UNICODE_GREEK_OUNKIA_SIGN				   0x10184
#define Z_UNICODE_GREEK_XESTES_SIGN				   0x10185
#define Z_UNICODE_GREEK_ARTABE_SIGN				   0x10186
#define Z_UNICODE_GREEK_AROURA_SIGN				   0x10187
#define Z_UNICODE_GREEK_GRAMMA_SIGN				   0x10188
#define Z_UNICODE_GREEK_TRYBLION_BASE_SIGN			   0x10189
#define Z_UNICODE_GREEK_ZERO_SIGN				   0x1018A
#define Z_UNICODE_GREEK_ONE_QUARTER_SIGN			   0x1018B
#define Z_UNICODE_GREEK_SINUSOID_SIGN				   0x1018C

/* MARK: - 10190h-101CFh - Ancient Symbols */

#define Z_UNICODE_ROMAN_SEXTANS_SIGN	     0x10190
#define Z_UNICODE_ROMAN_UNCIA_SIGN	     0x10191
#define Z_UNICODE_ROMAN_SEMUNCIA_SIGN	     0x10192
#define Z_UNICODE_ROMAN_SEXTULA_SIGN	     0x10193
#define Z_UNICODE_ROMAN_DIMIDIA_SEXTULA_SIGN 0x10194
#define Z_UNICODE_ROMAN_SILIQUA_SIGN	     0x10195
#define Z_UNICODE_ROMAN_DENARIUS_SIGN	     0x10196
#define Z_UNICODE_ROMAN_QUINARIUS_SIGN	     0x10197
#define Z_UNICODE_ROMAN_SESTERTIUS_SIGN	     0x10198
#define Z_UNICODE_ROMAN_DUPONDIUS_SIGN	     0x10199
#define Z_UNICODE_ROMAN_AS_SIGN		     0x1019A
#define Z_UNICODE_ROMAN_CENTURIAL_SIGN	     0x1019B
#define Z_UNICODE_GREEK_SYMBOL_TAU_RHO	     0x101A0

/* MARK: - 101D0h-101FFh - Phaistos Disc */

#define Z_UNICODE_PHAISTOS_DISC_SIGN_PEDESTRIAN		      0x101D0
#define Z_UNICODE_PHAISTOS_DISC_SIGN_PLUMED_HEAD	      0x101D1
#define Z_UNICODE_PHAISTOS_DISC_SIGN_TATTOOED_HEAD	      0x101D2
#define Z_UNICODE_PHAISTOS_DISC_SIGN_CAPTIVE		      0x101D3
#define Z_UNICODE_PHAISTOS_DISC_SIGN_CHILD		      0x101D4
#define Z_UNICODE_PHAISTOS_DISC_SIGN_WOMAN		      0x101D5
#define Z_UNICODE_PHAISTOS_DISC_SIGN_HELMET		      0x101D6
#define Z_UNICODE_PHAISTOS_DISC_SIGN_GAUNTLET		      0x101D7
#define Z_UNICODE_PHAISTOS_DISC_SIGN_TIARA		      0x101D8
#define Z_UNICODE_PHAISTOS_DISC_SIGN_ARROW		      0x101D9
#define Z_UNICODE_PHAISTOS_DISC_SIGN_BOW		      0x101DA
#define Z_UNICODE_PHAISTOS_DISC_SIGN_SHIELD		      0x101DB
#define Z_UNICODE_PHAISTOS_DISC_SIGN_CLUB		      0x101DC
#define Z_UNICODE_PHAISTOS_DISC_SIGN_MANACLES		      0x101DD
#define Z_UNICODE_PHAISTOS_DISC_SIGN_MATTOCK		      0x101DE
#define Z_UNICODE_PHAISTOS_DISC_SIGN_SAW		      0x101DF
#define Z_UNICODE_PHAISTOS_DISC_SIGN_LID		      0x101E0
#define Z_UNICODE_PHAISTOS_DISC_SIGN_BOOMERANG		      0x101E1
#define Z_UNICODE_PHAISTOS_DISC_SIGN_CARPENTRY_PLANE	      0x101E2
#define Z_UNICODE_PHAISTOS_DISC_SIGN_DOLIUM		      0x101E3
#define Z_UNICODE_PHAISTOS_DISC_SIGN_COMB		      0x101E4
#define Z_UNICODE_PHAISTOS_DISC_SIGN_SLING		      0x101E5
#define Z_UNICODE_PHAISTOS_DISC_SIGN_COLUMN		      0x101E6
#define Z_UNICODE_PHAISTOS_DISC_SIGN_BEEHIVE		      0x101E7
#define Z_UNICODE_PHAISTOS_DISC_SIGN_SHIP		      0x101E8
#define Z_UNICODE_PHAISTOS_DISC_SIGN_HORN		      0x101E9
#define Z_UNICODE_PHAISTOS_DISC_SIGN_HIDE		      0x101EA
#define Z_UNICODE_PHAISTOS_DISC_SIGN_BULLS_LEG		      0x101EB
#define Z_UNICODE_PHAISTOS_DISC_SIGN_CAT		      0x101EC
#define Z_UNICODE_PHAISTOS_DISC_SIGN_RAM		      0x101ED
#define Z_UNICODE_PHAISTOS_DISC_SIGN_EAGLE		      0x101EE
#define Z_UNICODE_PHAISTOS_DISC_SIGN_DOVE		      0x101EF
#define Z_UNICODE_PHAISTOS_DISC_SIGN_TUNNY		      0x101F0
#define Z_UNICODE_PHAISTOS_DISC_SIGN_BEE		      0x101F1
#define Z_UNICODE_PHAISTOS_DISC_SIGN_PLANE_TREE		      0x101F2
#define Z_UNICODE_PHAISTOS_DISC_SIGN_VINE		      0x101F3
#define Z_UNICODE_PHAISTOS_DISC_SIGN_PAPYRUS		      0x101F4
#define Z_UNICODE_PHAISTOS_DISC_SIGN_ROSETTE		      0x101F5
#define Z_UNICODE_PHAISTOS_DISC_SIGN_LILY		      0x101F6
#define Z_UNICODE_PHAISTOS_DISC_SIGN_OX_BACK		      0x101F7
#define Z_UNICODE_PHAISTOS_DISC_SIGN_FLUTE		      0x101F8
#define Z_UNICODE_PHAISTOS_DISC_SIGN_GRATER		      0x101F9
#define Z_UNICODE_PHAISTOS_DISC_SIGN_STRAINER		      0x101FA
#define Z_UNICODE_PHAISTOS_DISC_SIGN_SMALL_AXE		      0x101FB
#define Z_UNICODE_PHAISTOS_DISC_SIGN_WAVY_BAND		      0x101FC
#define Z_UNICODE_PHAISTOS_DISC_SIGN_COMBINING_OBLIQUE_STROKE 0x101FD

/* MARK: - 10280h-1029Fh - Lycian */

#define Z_UNICODE_LYCIAN_LETTER_A  0x10280
#define Z_UNICODE_LYCIAN_LETTER_E  0x10281
#define Z_UNICODE_LYCIAN_LETTER_B  0x10282
#define Z_UNICODE_LYCIAN_LETTER_BH 0x10283
#define Z_UNICODE_LYCIAN_LETTER_G  0x10284
#define Z_UNICODE_LYCIAN_LETTER_D  0x10285
#define Z_UNICODE_LYCIAN_LETTER_I  0x10286
#define Z_UNICODE_LYCIAN_LETTER_W  0x10287
#define Z_UNICODE_LYCIAN_LETTER_Z  0x10288
#define Z_UNICODE_LYCIAN_LETTER_TH 0x10289
#define Z_UNICODE_LYCIAN_LETTER_J  0x1028A
#define Z_UNICODE_LYCIAN_LETTER_K  0x1028B
#define Z_UNICODE_LYCIAN_LETTER_Q  0x1028C
#define Z_UNICODE_LYCIAN_LETTER_L  0x1028D
#define Z_UNICODE_LYCIAN_LETTER_M  0x1028E
#define Z_UNICODE_LYCIAN_LETTER_N  0x1028F
#define Z_UNICODE_LYCIAN_LETTER_MM 0x10290
#define Z_UNICODE_LYCIAN_LETTER_NN 0x10291
#define Z_UNICODE_LYCIAN_LETTER_U  0x10292
#define Z_UNICODE_LYCIAN_LETTER_P  0x10293
#define Z_UNICODE_LYCIAN_LETTER_KK 0x10294
#define Z_UNICODE_LYCIAN_LETTER_R  0x10295
#define Z_UNICODE_LYCIAN_LETTER_S  0x10296
#define Z_UNICODE_LYCIAN_LETTER_T  0x10297
#define Z_UNICODE_LYCIAN_LETTER_TT 0x10298
#define Z_UNICODE_LYCIAN_LETTER_AN 0x10299
#define Z_UNICODE_LYCIAN_LETTER_EN 0x1029A
#define Z_UNICODE_LYCIAN_LETTER_H  0x1029B
#define Z_UNICODE_LYCIAN_LETTER_X  0x1029C

/* MARK: - 102A0h-102DFh - Carian */

#define Z_UNICODE_CARIAN_LETTER_A    0x102A0
#define Z_UNICODE_CARIAN_LETTER_P2   0x102A1
#define Z_UNICODE_CARIAN_LETTER_D    0x102A2
#define Z_UNICODE_CARIAN_LETTER_L    0x102A3
#define Z_UNICODE_CARIAN_LETTER_UUU  0x102A4
#define Z_UNICODE_CARIAN_LETTER_R    0x102A5
#define Z_UNICODE_CARIAN_LETTER_LD   0x102A6
#define Z_UNICODE_CARIAN_LETTER_A2   0x102A7
#define Z_UNICODE_CARIAN_LETTER_Q    0x102A8
#define Z_UNICODE_CARIAN_LETTER_B    0x102A9
#define Z_UNICODE_CARIAN_LETTER_M    0x102AA
#define Z_UNICODE_CARIAN_LETTER_O    0x102AB
#define Z_UNICODE_CARIAN_LETTER_D2   0x102AC
#define Z_UNICODE_CARIAN_LETTER_T    0x102AD
#define Z_UNICODE_CARIAN_LETTER_SH   0x102AE
#define Z_UNICODE_CARIAN_LETTER_SH2  0x102AF
#define Z_UNICODE_CARIAN_LETTER_S    0x102B0
#define Z_UNICODE_CARIAN_LETTER_C_18 0x102B1
#define Z_UNICODE_CARIAN_LETTER_U    0x102B2
#define Z_UNICODE_CARIAN_LETTER_NN   0x102B3
#define Z_UNICODE_CARIAN_LETTER_X    0x102B4
#define Z_UNICODE_CARIAN_LETTER_N    0x102B5
#define Z_UNICODE_CARIAN_LETTER_TT2  0x102B6
#define Z_UNICODE_CARIAN_LETTER_P    0x102B7
#define Z_UNICODE_CARIAN_LETTER_SS   0x102B8
#define Z_UNICODE_CARIAN_LETTER_I    0x102B9
#define Z_UNICODE_CARIAN_LETTER_E    0x102BA
#define Z_UNICODE_CARIAN_LETTER_UUUU 0x102BB
#define Z_UNICODE_CARIAN_LETTER_K    0x102BC
#define Z_UNICODE_CARIAN_LETTER_K2   0x102BD
#define Z_UNICODE_CARIAN_LETTER_ND   0x102BE
#define Z_UNICODE_CARIAN_LETTER_UU   0x102BF
#define Z_UNICODE_CARIAN_LETTER_G    0x102C0
#define Z_UNICODE_CARIAN_LETTER_G2   0x102C1
#define Z_UNICODE_CARIAN_LETTER_ST   0x102C2
#define Z_UNICODE_CARIAN_LETTER_ST2  0x102C3
#define Z_UNICODE_CARIAN_LETTER_NG   0x102C4
#define Z_UNICODE_CARIAN_LETTER_II   0x102C5
#define Z_UNICODE_CARIAN_LETTER_C_39 0x102C6
#define Z_UNICODE_CARIAN_LETTER_TT   0x102C7
#define Z_UNICODE_CARIAN_LETTER_UUU2 0x102C8
#define Z_UNICODE_CARIAN_LETTER_RR   0x102C9
#define Z_UNICODE_CARIAN_LETTER_MB   0x102CA
#define Z_UNICODE_CARIAN_LETTER_MB2  0x102CB
#define Z_UNICODE_CARIAN_LETTER_MB3  0x102CC
#define Z_UNICODE_CARIAN_LETTER_MB4  0x102CD
#define Z_UNICODE_CARIAN_LETTER_LD2  0x102CE
#define Z_UNICODE_CARIAN_LETTER_E2   0x102CF
#define Z_UNICODE_CARIAN_LETTER_UUU3 0x102D0

/* MARK: - 102E0h-102FFh - Coptic Epact Numbers */

#define Z_UNICODE_COPTIC_EPACT_THOUSANDS_MARK	    0x102E0
#define Z_UNICODE_COPTIC_EPACT_DIGIT_ONE	    0x102E1
#define Z_UNICODE_COPTIC_EPACT_DIGIT_TWO	    0x102E2
#define Z_UNICODE_COPTIC_EPACT_DIGIT_THREE	    0x102E3
#define Z_UNICODE_COPTIC_EPACT_DIGIT_FOUR	    0x102E4
#define Z_UNICODE_COPTIC_EPACT_DIGIT_FIVE	    0x102E5
#define Z_UNICODE_COPTIC_EPACT_DIGIT_SIX	    0x102E6
#define Z_UNICODE_COPTIC_EPACT_DIGIT_SEVEN	    0x102E7
#define Z_UNICODE_COPTIC_EPACT_DIGIT_EIGHT	    0x102E8
#define Z_UNICODE_COPTIC_EPACT_DIGIT_NINE	    0x102E9
#define Z_UNICODE_COPTIC_EPACT_NUMBER_TEN	    0x102EA
#define Z_UNICODE_COPTIC_EPACT_NUMBER_TWENTY	    0x102EB
#define Z_UNICODE_COPTIC_EPACT_NUMBER_THIRTY	    0x102EC
#define Z_UNICODE_COPTIC_EPACT_NUMBER_FORTY	    0x102ED
#define Z_UNICODE_COPTIC_EPACT_NUMBER_FIFTY	    0x102EE
#define Z_UNICODE_COPTIC_EPACT_NUMBER_SIXTY	    0x102EF
#define Z_UNICODE_COPTIC_EPACT_NUMBER_SEVENTY	    0x102F0
#define Z_UNICODE_COPTIC_EPACT_NUMBER_EIGHTY	    0x102F1
#define Z_UNICODE_COPTIC_EPACT_NUMBER_NINETY	    0x102F2
#define Z_UNICODE_COPTIC_EPACT_NUMBER_ONE_HUNDRED   0x102F3
#define Z_UNICODE_COPTIC_EPACT_NUMBER_TWO_HUNDRED   0x102F4
#define Z_UNICODE_COPTIC_EPACT_NUMBER_THREE_HUNDRED 0x102F5
#define Z_UNICODE_COPTIC_EPACT_NUMBER_FOUR_HUNDRED  0x102F6
#define Z_UNICODE_COPTIC_EPACT_NUMBER_FIVE_HUNDRED  0x102F7
#define Z_UNICODE_COPTIC_EPACT_NUMBER_SIX_HUNDRED   0x102F8
#define Z_UNICODE_COPTIC_EPACT_NUMBER_SEVEN_HUNDRED 0x102F9
#define Z_UNICODE_COPTIC_EPACT_NUMBER_EIGHT_HUNDRED 0x102FA
#define Z_UNICODE_COPTIC_EPACT_NUMBER_NINE_HUNDRED  0x102FB

/* MARK: - 10300h-1032Fh - Old Italic */

#define Z_UNICODE_OLD_ITALIC_LETTER_A	   0x10300
#define Z_UNICODE_OLD_ITALIC_LETTER_BE	   0x10301
#define Z_UNICODE_OLD_ITALIC_LETTER_KE	   0x10302
#define Z_UNICODE_OLD_ITALIC_LETTER_DE	   0x10303
#define Z_UNICODE_OLD_ITALIC_LETTER_E	   0x10304
#define Z_UNICODE_OLD_ITALIC_LETTER_VE	   0x10305
#define Z_UNICODE_OLD_ITALIC_LETTER_ZE	   0x10306
#define Z_UNICODE_OLD_ITALIC_LETTER_HE	   0x10307
#define Z_UNICODE_OLD_ITALIC_LETTER_THE	   0x10308
#define Z_UNICODE_OLD_ITALIC_LETTER_I	   0x10309
#define Z_UNICODE_OLD_ITALIC_LETTER_KA	   0x1030A
#define Z_UNICODE_OLD_ITALIC_LETTER_EL	   0x1030B
#define Z_UNICODE_OLD_ITALIC_LETTER_EM	   0x1030C
#define Z_UNICODE_OLD_ITALIC_LETTER_EN	   0x1030D
#define Z_UNICODE_OLD_ITALIC_LETTER_ESH	   0x1030E
#define Z_UNICODE_OLD_ITALIC_LETTER_O	   0x1030F
#define Z_UNICODE_OLD_ITALIC_LETTER_PE	   0x10310
#define Z_UNICODE_OLD_ITALIC_LETTER_SHE	   0x10311
#define Z_UNICODE_OLD_ITALIC_LETTER_KU	   0x10312
#define Z_UNICODE_OLD_ITALIC_LETTER_ER	   0x10313
#define Z_UNICODE_OLD_ITALIC_LETTER_ES	   0x10314
#define Z_UNICODE_OLD_ITALIC_LETTER_TE	   0x10315
#define Z_UNICODE_OLD_ITALIC_LETTER_U	   0x10316
#define Z_UNICODE_OLD_ITALIC_LETTER_EKS	   0x10317
#define Z_UNICODE_OLD_ITALIC_LETTER_PHE	   0x10318
#define Z_UNICODE_OLD_ITALIC_LETTER_KHE	   0x10319
#define Z_UNICODE_OLD_ITALIC_LETTER_EF	   0x1031A
#define Z_UNICODE_OLD_ITALIC_LETTER_ERS	   0x1031B
#define Z_UNICODE_OLD_ITALIC_LETTER_CHE	   0x1031C
#define Z_UNICODE_OLD_ITALIC_LETTER_II	   0x1031D
#define Z_UNICODE_OLD_ITALIC_LETTER_UU	   0x1031E
#define Z_UNICODE_OLD_ITALIC_LETTER_ESS	   0x1031F
#define Z_UNICODE_OLD_ITALIC_NUMERAL_ONE   0x10320
#define Z_UNICODE_OLD_ITALIC_NUMERAL_FIVE  0x10321
#define Z_UNICODE_OLD_ITALIC_NUMERAL_TEN   0x10322
#define Z_UNICODE_OLD_ITALIC_NUMERAL_FIFTY 0x10323

/* MARK: - 10330h-1034Fh - Gothic */

#define Z_UNICODE_GOTHIC_LETTER_AHSA	     0x10330
#define Z_UNICODE_GOTHIC_LETTER_BAIRKAN	     0x10331
#define Z_UNICODE_GOTHIC_LETTER_GIBA	     0x10332
#define Z_UNICODE_GOTHIC_LETTER_DAGS	     0x10333
#define Z_UNICODE_GOTHIC_LETTER_AIHVUS	     0x10334
#define Z_UNICODE_GOTHIC_LETTER_QAIRTHRA     0x10335
#define Z_UNICODE_GOTHIC_LETTER_IUJA	     0x10336
#define Z_UNICODE_GOTHIC_LETTER_HAGL	     0x10337
#define Z_UNICODE_GOTHIC_LETTER_THIUTH	     0x10338
#define Z_UNICODE_GOTHIC_LETTER_EIS	     0x10339
#define Z_UNICODE_GOTHIC_LETTER_KUSMA	     0x1033A
#define Z_UNICODE_GOTHIC_LETTER_LAGUS	     0x1033B
#define Z_UNICODE_GOTHIC_LETTER_MANNA	     0x1033C
#define Z_UNICODE_GOTHIC_LETTER_NAUTHS	     0x1033D
#define Z_UNICODE_GOTHIC_LETTER_JER	     0x1033E
#define Z_UNICODE_GOTHIC_LETTER_URUS	     0x1033F
#define Z_UNICODE_GOTHIC_LETTER_PAIRTHRA     0x10340
#define Z_UNICODE_GOTHIC_LETTER_NINETY	     0x10341
#define Z_UNICODE_GOTHIC_LETTER_RAIDA	     0x10342
#define Z_UNICODE_GOTHIC_LETTER_SAUIL	     0x10343
#define Z_UNICODE_GOTHIC_LETTER_TEIWS	     0x10344
#define Z_UNICODE_GOTHIC_LETTER_WINJA	     0x10345
#define Z_UNICODE_GOTHIC_LETTER_FAIHU	     0x10346
#define Z_UNICODE_GOTHIC_LETTER_IGGWS	     0x10347
#define Z_UNICODE_GOTHIC_LETTER_HWAIR	     0x10348
#define Z_UNICODE_GOTHIC_LETTER_OTHAL	     0x10349
#define Z_UNICODE_GOTHIC_LETTER_NINE_HUNDRED 0x1034A

/* MARK: - 10350h-1037Fh - Old Permic */

#define Z_UNICODE_OLD_PERMIC_LETTER_AN		    0x10350
#define Z_UNICODE_OLD_PERMIC_LETTER_BUR		    0x10351
#define Z_UNICODE_OLD_PERMIC_LETTER_GAI		    0x10352
#define Z_UNICODE_OLD_PERMIC_LETTER_DOI		    0x10353
#define Z_UNICODE_OLD_PERMIC_LETTER_E		    0x10354
#define Z_UNICODE_OLD_PERMIC_LETTER_ZHOI	    0x10355
#define Z_UNICODE_OLD_PERMIC_LETTER_DZHOI	    0x10356
#define Z_UNICODE_OLD_PERMIC_LETTER_ZATA	    0x10357
#define Z_UNICODE_OLD_PERMIC_LETTER_DZITA	    0x10358
#define Z_UNICODE_OLD_PERMIC_LETTER_I		    0x10359
#define Z_UNICODE_OLD_PERMIC_LETTER_KOKE	    0x1035A
#define Z_UNICODE_OLD_PERMIC_LETTER_LEI		    0x1035B
#define Z_UNICODE_OLD_PERMIC_LETTER_MENOE	    0x1035C
#define Z_UNICODE_OLD_PERMIC_LETTER_NENOE	    0x1035D
#define Z_UNICODE_OLD_PERMIC_LETTER_VOOI	    0x1035E
#define Z_UNICODE_OLD_PERMIC_LETTER_PEEI	    0x1035F
#define Z_UNICODE_OLD_PERMIC_LETTER_REI		    0x10360
#define Z_UNICODE_OLD_PERMIC_LETTER_SII		    0x10361
#define Z_UNICODE_OLD_PERMIC_LETTER_TAI		    0x10362
#define Z_UNICODE_OLD_PERMIC_LETTER_U		    0x10363
#define Z_UNICODE_OLD_PERMIC_LETTER_CHERY	    0x10364
#define Z_UNICODE_OLD_PERMIC_LETTER_SHOOI	    0x10365
#define Z_UNICODE_OLD_PERMIC_LETTER_SHCHOOI	    0x10366
#define Z_UNICODE_OLD_PERMIC_LETTER_YRY		    0x10367
#define Z_UNICODE_OLD_PERMIC_LETTER_YERU	    0x10368
#define Z_UNICODE_OLD_PERMIC_LETTER_O		    0x10369
#define Z_UNICODE_OLD_PERMIC_LETTER_OO		    0x1036A
#define Z_UNICODE_OLD_PERMIC_LETTER_EF		    0x1036B
#define Z_UNICODE_OLD_PERMIC_LETTER_HA		    0x1036C
#define Z_UNICODE_OLD_PERMIC_LETTER_TSIU	    0x1036D
#define Z_UNICODE_OLD_PERMIC_LETTER_VER		    0x1036E
#define Z_UNICODE_OLD_PERMIC_LETTER_YER		    0x1036F
#define Z_UNICODE_OLD_PERMIC_LETTER_YERI	    0x10370
#define Z_UNICODE_OLD_PERMIC_LETTER_YAT		    0x10371
#define Z_UNICODE_OLD_PERMIC_LETTER_IE		    0x10372
#define Z_UNICODE_OLD_PERMIC_LETTER_YU		    0x10373
#define Z_UNICODE_OLD_PERMIC_LETTER_YA		    0x10374
#define Z_UNICODE_OLD_PERMIC_LETTER_IA		    0x10375
#define Z_UNICODE_COMBINING_OLD_PERMIC_LETTER_AN    0x10376
#define Z_UNICODE_COMBINING_OLD_PERMIC_LETTER_DOI   0x10377
#define Z_UNICODE_COMBINING_OLD_PERMIC_LETTER_ZATA  0x10378
#define Z_UNICODE_COMBINING_OLD_PERMIC_LETTER_NENOE 0x10379
#define Z_UNICODE_COMBINING_OLD_PERMIC_LETTER_SII   0x1037A

/* MARK: - 10380h-1039Fh - Ugaritic */

#define Z_UNICODE_UGARITIC_LETTER_ALPA	 0x10380
#define Z_UNICODE_UGARITIC_LETTER_BETA	 0x10381
#define Z_UNICODE_UGARITIC_LETTER_GAMLA	 0x10382
#define Z_UNICODE_UGARITIC_LETTER_KHA	 0x10383
#define Z_UNICODE_UGARITIC_LETTER_DELTA	 0x10384
#define Z_UNICODE_UGARITIC_LETTER_HO	 0x10385
#define Z_UNICODE_UGARITIC_LETTER_WO	 0x10386
#define Z_UNICODE_UGARITIC_LETTER_ZETA	 0x10387
#define Z_UNICODE_UGARITIC_LETTER_HOTA	 0x10388
#define Z_UNICODE_UGARITIC_LETTER_TET	 0x10389
#define Z_UNICODE_UGARITIC_LETTER_YOD	 0x1038A
#define Z_UNICODE_UGARITIC_LETTER_KAF	 0x1038B
#define Z_UNICODE_UGARITIC_LETTER_SHIN	 0x1038C
#define Z_UNICODE_UGARITIC_LETTER_LAMDA	 0x1038D
#define Z_UNICODE_UGARITIC_LETTER_MEM	 0x1038E
#define Z_UNICODE_UGARITIC_LETTER_DHAL	 0x1038F
#define Z_UNICODE_UGARITIC_LETTER_NUN	 0x10390
#define Z_UNICODE_UGARITIC_LETTER_ZU	 0x10391
#define Z_UNICODE_UGARITIC_LETTER_SAMKA	 0x10392
#define Z_UNICODE_UGARITIC_LETTER_AIN	 0x10393
#define Z_UNICODE_UGARITIC_LETTER_PU	 0x10394
#define Z_UNICODE_UGARITIC_LETTER_SADE	 0x10395
#define Z_UNICODE_UGARITIC_LETTER_QOPA	 0x10396
#define Z_UNICODE_UGARITIC_LETTER_RASHA	 0x10397
#define Z_UNICODE_UGARITIC_LETTER_THANNA 0x10398
#define Z_UNICODE_UGARITIC_LETTER_GHAIN	 0x10399
#define Z_UNICODE_UGARITIC_LETTER_TO	 0x1039A
#define Z_UNICODE_UGARITIC_LETTER_I	 0x1039B
#define Z_UNICODE_UGARITIC_LETTER_U	 0x1039C
#define Z_UNICODE_UGARITIC_LETTER_SSU	 0x1039D
#define Z_UNICODE_UGARITIC_WORD_DIVIDER	 0x1039F

/* MARK: - 103A0h-103DFh - Old Persian */

#define Z_UNICODE_OLD_PERSIAN_SIGN_A		0x103A0
#define Z_UNICODE_OLD_PERSIAN_SIGN_I		0x103A1
#define Z_UNICODE_OLD_PERSIAN_SIGN_U		0x103A2
#define Z_UNICODE_OLD_PERSIAN_SIGN_KA		0x103A3
#define Z_UNICODE_OLD_PERSIAN_SIGN_KU		0x103A4
#define Z_UNICODE_OLD_PERSIAN_SIGN_GA		0x103A5
#define Z_UNICODE_OLD_PERSIAN_SIGN_GU		0x103A6
#define Z_UNICODE_OLD_PERSIAN_SIGN_XA		0x103A7
#define Z_UNICODE_OLD_PERSIAN_SIGN_CA		0x103A8
#define Z_UNICODE_OLD_PERSIAN_SIGN_JA		0x103A9
#define Z_UNICODE_OLD_PERSIAN_SIGN_JI		0x103AA
#define Z_UNICODE_OLD_PERSIAN_SIGN_TA		0x103AB
#define Z_UNICODE_OLD_PERSIAN_SIGN_TU		0x103AC
#define Z_UNICODE_OLD_PERSIAN_SIGN_DA		0x103AD
#define Z_UNICODE_OLD_PERSIAN_SIGN_DI		0x103AE
#define Z_UNICODE_OLD_PERSIAN_SIGN_DU		0x103AF
#define Z_UNICODE_OLD_PERSIAN_SIGN_THA		0x103B0
#define Z_UNICODE_OLD_PERSIAN_SIGN_PA		0x103B1
#define Z_UNICODE_OLD_PERSIAN_SIGN_BA		0x103B2
#define Z_UNICODE_OLD_PERSIAN_SIGN_FA		0x103B3
#define Z_UNICODE_OLD_PERSIAN_SIGN_NA		0x103B4
#define Z_UNICODE_OLD_PERSIAN_SIGN_NU		0x103B5
#define Z_UNICODE_OLD_PERSIAN_SIGN_MA		0x103B6
#define Z_UNICODE_OLD_PERSIAN_SIGN_MI		0x103B7
#define Z_UNICODE_OLD_PERSIAN_SIGN_MU		0x103B8
#define Z_UNICODE_OLD_PERSIAN_SIGN_YA		0x103B9
#define Z_UNICODE_OLD_PERSIAN_SIGN_VA		0x103BA
#define Z_UNICODE_OLD_PERSIAN_SIGN_VI		0x103BB
#define Z_UNICODE_OLD_PERSIAN_SIGN_RA		0x103BC
#define Z_UNICODE_OLD_PERSIAN_SIGN_RU		0x103BD
#define Z_UNICODE_OLD_PERSIAN_SIGN_LA		0x103BE
#define Z_UNICODE_OLD_PERSIAN_SIGN_SA		0x103BF
#define Z_UNICODE_OLD_PERSIAN_SIGN_ZA		0x103C0
#define Z_UNICODE_OLD_PERSIAN_SIGN_SHA		0x103C1
#define Z_UNICODE_OLD_PERSIAN_SIGN_SSA		0x103C2
#define Z_UNICODE_OLD_PERSIAN_SIGN_HA		0x103C3
#define Z_UNICODE_OLD_PERSIAN_SIGN_AURAMAZDAA	0x103C8
#define Z_UNICODE_OLD_PERSIAN_SIGN_AURAMAZDAA_2	0x103C9
#define Z_UNICODE_OLD_PERSIAN_SIGN_AURAMAZDAAHA	0x103CA
#define Z_UNICODE_OLD_PERSIAN_SIGN_XSHAAYATHIYA	0x103CB
#define Z_UNICODE_OLD_PERSIAN_SIGN_DAHYAAUSH	0x103CC
#define Z_UNICODE_OLD_PERSIAN_SIGN_DAHYAAUSH_2	0x103CD
#define Z_UNICODE_OLD_PERSIAN_SIGN_BAGA		0x103CE
#define Z_UNICODE_OLD_PERSIAN_SIGN_BUUMISH	0x103CF
#define Z_UNICODE_OLD_PERSIAN_WORD_DIVIDER	0x103D0
#define Z_UNICODE_OLD_PERSIAN_NUMBER_ONE	0x103D1
#define Z_UNICODE_OLD_PERSIAN_NUMBER_TWO	0x103D2
#define Z_UNICODE_OLD_PERSIAN_NUMBER_TEN	0x103D3
#define Z_UNICODE_OLD_PERSIAN_NUMBER_TWENTY	0x103D4
#define Z_UNICODE_OLD_PERSIAN_NUMBER_HUNDRED	0x103D5

/* MARK: - 10400h-1044Fh - Deseret */

#define Z_UNICODE_DESERET_CAPITAL_LETTER_LONG_I	  0x10400
#define Z_UNICODE_DESERET_CAPITAL_LETTER_LONG_E	  0x10401
#define Z_UNICODE_DESERET_CAPITAL_LETTER_LONG_A	  0x10402
#define Z_UNICODE_DESERET_CAPITAL_LETTER_LONG_AH  0x10403
#define Z_UNICODE_DESERET_CAPITAL_LETTER_LONG_O	  0x10404
#define Z_UNICODE_DESERET_CAPITAL_LETTER_LONG_OO  0x10405
#define Z_UNICODE_DESERET_CAPITAL_LETTER_SHORT_I  0x10406
#define Z_UNICODE_DESERET_CAPITAL_LETTER_SHORT_E  0x10407
#define Z_UNICODE_DESERET_CAPITAL_LETTER_SHORT_A  0x10408
#define Z_UNICODE_DESERET_CAPITAL_LETTER_SHORT_AH 0x10409
#define Z_UNICODE_DESERET_CAPITAL_LETTER_SHORT_O  0x1040A
#define Z_UNICODE_DESERET_CAPITAL_LETTER_SHORT_OO 0x1040B
#define Z_UNICODE_DESERET_CAPITAL_LETTER_AY	  0x1040C
#define Z_UNICODE_DESERET_CAPITAL_LETTER_OW	  0x1040D
#define Z_UNICODE_DESERET_CAPITAL_LETTER_WU	  0x1040E
#define Z_UNICODE_DESERET_CAPITAL_LETTER_YEE	  0x1040F
#define Z_UNICODE_DESERET_CAPITAL_LETTER_H	  0x10410
#define Z_UNICODE_DESERET_CAPITAL_LETTER_PEE	  0x10411
#define Z_UNICODE_DESERET_CAPITAL_LETTER_BEE	  0x10412
#define Z_UNICODE_DESERET_CAPITAL_LETTER_TEE	  0x10413
#define Z_UNICODE_DESERET_CAPITAL_LETTER_DEE	  0x10414
#define Z_UNICODE_DESERET_CAPITAL_LETTER_CHEE	  0x10415
#define Z_UNICODE_DESERET_CAPITAL_LETTER_JEE	  0x10416
#define Z_UNICODE_DESERET_CAPITAL_LETTER_KAY	  0x10417
#define Z_UNICODE_DESERET_CAPITAL_LETTER_GAY	  0x10418
#define Z_UNICODE_DESERET_CAPITAL_LETTER_EF	  0x10419
#define Z_UNICODE_DESERET_CAPITAL_LETTER_VEE	  0x1041A
#define Z_UNICODE_DESERET_CAPITAL_LETTER_ETH	  0x1041B
#define Z_UNICODE_DESERET_CAPITAL_LETTER_THEE	  0x1041C
#define Z_UNICODE_DESERET_CAPITAL_LETTER_ES	  0x1041D
#define Z_UNICODE_DESERET_CAPITAL_LETTER_ZEE	  0x1041E
#define Z_UNICODE_DESERET_CAPITAL_LETTER_ESH	  0x1041F
#define Z_UNICODE_DESERET_CAPITAL_LETTER_ZHEE	  0x10420
#define Z_UNICODE_DESERET_CAPITAL_LETTER_ER	  0x10421
#define Z_UNICODE_DESERET_CAPITAL_LETTER_EL	  0x10422
#define Z_UNICODE_DESERET_CAPITAL_LETTER_EM	  0x10423
#define Z_UNICODE_DESERET_CAPITAL_LETTER_EN	  0x10424
#define Z_UNICODE_DESERET_CAPITAL_LETTER_ENG	  0x10425
#define Z_UNICODE_DESERET_CAPITAL_LETTER_OI	  0x10426
#define Z_UNICODE_DESERET_CAPITAL_LETTER_EW	  0x10427
#define Z_UNICODE_DESERET_SMALL_LETTER_LONG_I	  0x10428
#define Z_UNICODE_DESERET_SMALL_LETTER_LONG_E	  0x10429
#define Z_UNICODE_DESERET_SMALL_LETTER_LONG_A	  0x1042A
#define Z_UNICODE_DESERET_SMALL_LETTER_LONG_AH	  0x1042B
#define Z_UNICODE_DESERET_SMALL_LETTER_LONG_O	  0x1042C
#define Z_UNICODE_DESERET_SMALL_LETTER_LONG_OO	  0x1042D
#define Z_UNICODE_DESERET_SMALL_LETTER_SHORT_I	  0x1042E
#define Z_UNICODE_DESERET_SMALL_LETTER_SHORT_E	  0x1042F
#define Z_UNICODE_DESERET_SMALL_LETTER_SHORT_A	  0x10430
#define Z_UNICODE_DESERET_SMALL_LETTER_SHORT_AH	  0x10431
#define Z_UNICODE_DESERET_SMALL_LETTER_SHORT_O	  0x10432
#define Z_UNICODE_DESERET_SMALL_LETTER_SHORT_OO	  0x10433
#define Z_UNICODE_DESERET_SMALL_LETTER_AY	  0x10434
#define Z_UNICODE_DESERET_SMALL_LETTER_OW	  0x10435
#define Z_UNICODE_DESERET_SMALL_LETTER_WU	  0x10436
#define Z_UNICODE_DESERET_SMALL_LETTER_YEE	  0x10437
#define Z_UNICODE_DESERET_SMALL_LETTER_H	  0x10438
#define Z_UNICODE_DESERET_SMALL_LETTER_PEE	  0x10439
#define Z_UNICODE_DESERET_SMALL_LETTER_BEE	  0x1043A
#define Z_UNICODE_DESERET_SMALL_LETTER_TEE	  0x1043B
#define Z_UNICODE_DESERET_SMALL_LETTER_DEE	  0x1043C
#define Z_UNICODE_DESERET_SMALL_LETTER_CHEE	  0x1043D
#define Z_UNICODE_DESERET_SMALL_LETTER_JEE	  0x1043E
#define Z_UNICODE_DESERET_SMALL_LETTER_KAY	  0x1043F
#define Z_UNICODE_DESERET_SMALL_LETTER_GAY	  0x10440
#define Z_UNICODE_DESERET_SMALL_LETTER_EF	  0x10441
#define Z_UNICODE_DESERET_SMALL_LETTER_VEE	  0x10442
#define Z_UNICODE_DESERET_SMALL_LETTER_ETH	  0x10443
#define Z_UNICODE_DESERET_SMALL_LETTER_THEE	  0x10444
#define Z_UNICODE_DESERET_SMALL_LETTER_ES	  0x10445
#define Z_UNICODE_DESERET_SMALL_LETTER_ZEE	  0x10446
#define Z_UNICODE_DESERET_SMALL_LETTER_ESH	  0x10447
#define Z_UNICODE_DESERET_SMALL_LETTER_ZHEE	  0x10448
#define Z_UNICODE_DESERET_SMALL_LETTER_ER	  0x10449
#define Z_UNICODE_DESERET_SMALL_LETTER_EL	  0x1044A
#define Z_UNICODE_DESERET_SMALL_LETTER_EM	  0x1044B
#define Z_UNICODE_DESERET_SMALL_LETTER_EN	  0x1044C
#define Z_UNICODE_DESERET_SMALL_LETTER_ENG	  0x1044D
#define Z_UNICODE_DESERET_SMALL_LETTER_OI	  0x1044E
#define Z_UNICODE_DESERET_SMALL_LETTER_EW	  0x1044F

/* MARK: - 10450h-1047Fh - Shavian */

#define Z_UNICODE_SHAVIAN_LETTER_PEEP	 0x10450
#define Z_UNICODE_SHAVIAN_LETTER_TOT	 0x10451
#define Z_UNICODE_SHAVIAN_LETTER_KICK	 0x10452
#define Z_UNICODE_SHAVIAN_LETTER_FEE	 0x10453
#define Z_UNICODE_SHAVIAN_LETTER_THIGH	 0x10454
#define Z_UNICODE_SHAVIAN_LETTER_SO	 0x10455
#define Z_UNICODE_SHAVIAN_LETTER_SURE	 0x10456
#define Z_UNICODE_SHAVIAN_LETTER_CHURCH	 0x10457
#define Z_UNICODE_SHAVIAN_LETTER_YEA	 0x10458
#define Z_UNICODE_SHAVIAN_LETTER_HUNG	 0x10459
#define Z_UNICODE_SHAVIAN_LETTER_BIB	 0x1045A
#define Z_UNICODE_SHAVIAN_LETTER_DEAD	 0x1045B
#define Z_UNICODE_SHAVIAN_LETTER_GAG	 0x1045C
#define Z_UNICODE_SHAVIAN_LETTER_VOW	 0x1045D
#define Z_UNICODE_SHAVIAN_LETTER_THEY	 0x1045E
#define Z_UNICODE_SHAVIAN_LETTER_ZOO	 0x1045F
#define Z_UNICODE_SHAVIAN_LETTER_MEASURE 0x10460
#define Z_UNICODE_SHAVIAN_LETTER_JUDGE	 0x10461
#define Z_UNICODE_SHAVIAN_LETTER_WOE	 0x10462
#define Z_UNICODE_SHAVIAN_LETTER_HA_HA	 0x10463
#define Z_UNICODE_SHAVIAN_LETTER_LOLL	 0x10464
#define Z_UNICODE_SHAVIAN_LETTER_MIME	 0x10465
#define Z_UNICODE_SHAVIAN_LETTER_IF	 0x10466
#define Z_UNICODE_SHAVIAN_LETTER_EGG	 0x10467
#define Z_UNICODE_SHAVIAN_LETTER_ASH	 0x10468
#define Z_UNICODE_SHAVIAN_LETTER_ADO	 0x10469
#define Z_UNICODE_SHAVIAN_LETTER_ON	 0x1046A
#define Z_UNICODE_SHAVIAN_LETTER_WOOL	 0x1046B
#define Z_UNICODE_SHAVIAN_LETTER_OUT	 0x1046C
#define Z_UNICODE_SHAVIAN_LETTER_AH	 0x1046D
#define Z_UNICODE_SHAVIAN_LETTER_ROAR	 0x1046E
#define Z_UNICODE_SHAVIAN_LETTER_NUN	 0x1046F
#define Z_UNICODE_SHAVIAN_LETTER_EAT	 0x10470
#define Z_UNICODE_SHAVIAN_LETTER_AGE	 0x10471
#define Z_UNICODE_SHAVIAN_LETTER_ICE	 0x10472
#define Z_UNICODE_SHAVIAN_LETTER_UP	 0x10473
#define Z_UNICODE_SHAVIAN_LETTER_OAK	 0x10474
#define Z_UNICODE_SHAVIAN_LETTER_OOZE	 0x10475
#define Z_UNICODE_SHAVIAN_LETTER_OIL	 0x10476
#define Z_UNICODE_SHAVIAN_LETTER_AWE	 0x10477
#define Z_UNICODE_SHAVIAN_LETTER_ARE	 0x10478
#define Z_UNICODE_SHAVIAN_LETTER_OR	 0x10479
#define Z_UNICODE_SHAVIAN_LETTER_AIR	 0x1047A
#define Z_UNICODE_SHAVIAN_LETTER_ERR	 0x1047B
#define Z_UNICODE_SHAVIAN_LETTER_ARRAY	 0x1047C
#define Z_UNICODE_SHAVIAN_LETTER_EAR	 0x1047D
#define Z_UNICODE_SHAVIAN_LETTER_IAN	 0x1047E
#define Z_UNICODE_SHAVIAN_LETTER_YEW	 0x1047F

/* MARK: - 10480h-104AFh - Osmanya */

#define Z_UNICODE_OSMANYA_LETTER_ALEF  0x10480
#define Z_UNICODE_OSMANYA_LETTER_BA    0x10481
#define Z_UNICODE_OSMANYA_LETTER_TA    0x10482
#define Z_UNICODE_OSMANYA_LETTER_JA    0x10483
#define Z_UNICODE_OSMANYA_LETTER_XA    0x10484
#define Z_UNICODE_OSMANYA_LETTER_KHA   0x10485
#define Z_UNICODE_OSMANYA_LETTER_DEEL  0x10486
#define Z_UNICODE_OSMANYA_LETTER_RA    0x10487
#define Z_UNICODE_OSMANYA_LETTER_SA    0x10488
#define Z_UNICODE_OSMANYA_LETTER_SHIIN 0x10489
#define Z_UNICODE_OSMANYA_LETTER_DHA   0x1048A
#define Z_UNICODE_OSMANYA_LETTER_CAYN  0x1048B
#define Z_UNICODE_OSMANYA_LETTER_GA    0x1048C
#define Z_UNICODE_OSMANYA_LETTER_FA    0x1048D
#define Z_UNICODE_OSMANYA_LETTER_QAAF  0x1048E
#define Z_UNICODE_OSMANYA_LETTER_KAAF  0x1048F
#define Z_UNICODE_OSMANYA_LETTER_LAAN  0x10490
#define Z_UNICODE_OSMANYA_LETTER_MIIN  0x10491
#define Z_UNICODE_OSMANYA_LETTER_NUUN  0x10492
#define Z_UNICODE_OSMANYA_LETTER_WAW   0x10493
#define Z_UNICODE_OSMANYA_LETTER_HA    0x10494
#define Z_UNICODE_OSMANYA_LETTER_YA    0x10495
#define Z_UNICODE_OSMANYA_LETTER_A     0x10496
#define Z_UNICODE_OSMANYA_LETTER_E     0x10497
#define Z_UNICODE_OSMANYA_LETTER_I     0x10498
#define Z_UNICODE_OSMANYA_LETTER_O     0x10499
#define Z_UNICODE_OSMANYA_LETTER_U     0x1049A
#define Z_UNICODE_OSMANYA_LETTER_AA    0x1049B
#define Z_UNICODE_OSMANYA_LETTER_EE    0x1049C
#define Z_UNICODE_OSMANYA_LETTER_OO    0x1049D
#define Z_UNICODE_OSMANYA_DIGIT_ZERO   0x104A0
#define Z_UNICODE_OSMANYA_DIGIT_ONE    0x104A1
#define Z_UNICODE_OSMANYA_DIGIT_TWO    0x104A2
#define Z_UNICODE_OSMANYA_DIGIT_THREE  0x104A3
#define Z_UNICODE_OSMANYA_DIGIT_FOUR   0x104A4
#define Z_UNICODE_OSMANYA_DIGIT_FIVE   0x104A5
#define Z_UNICODE_OSMANYA_DIGIT_SIX    0x104A6
#define Z_UNICODE_OSMANYA_DIGIT_SEVEN  0x104A7
#define Z_UNICODE_OSMANYA_DIGIT_EIGHT  0x104A8
#define Z_UNICODE_OSMANYA_DIGIT_NINE   0x104A9

/* MARK: - 10500h-1052Fh - Elbasan */

#define Z_UNICODE_ELBASAN_LETTER_A	0x10500
#define Z_UNICODE_ELBASAN_LETTER_BE	0x10501
#define Z_UNICODE_ELBASAN_LETTER_CE	0x10502
#define Z_UNICODE_ELBASAN_LETTER_CHE	0x10503
#define Z_UNICODE_ELBASAN_LETTER_DE	0x10504
#define Z_UNICODE_ELBASAN_LETTER_NDE	0x10505
#define Z_UNICODE_ELBASAN_LETTER_DHE	0x10506
#define Z_UNICODE_ELBASAN_LETTER_EI	0x10507
#define Z_UNICODE_ELBASAN_LETTER_E	0x10508
#define Z_UNICODE_ELBASAN_LETTER_FE	0x10509
#define Z_UNICODE_ELBASAN_LETTER_GE	0x1050A
#define Z_UNICODE_ELBASAN_LETTER_GJE	0x1050B
#define Z_UNICODE_ELBASAN_LETTER_HE	0x1050C
#define Z_UNICODE_ELBASAN_LETTER_I	0x1050D
#define Z_UNICODE_ELBASAN_LETTER_JE	0x1050E
#define Z_UNICODE_ELBASAN_LETTER_KE	0x1050F
#define Z_UNICODE_ELBASAN_LETTER_LE	0x10510
#define Z_UNICODE_ELBASAN_LETTER_LLE	0x10511
#define Z_UNICODE_ELBASAN_LETTER_ME	0x10512
#define Z_UNICODE_ELBASAN_LETTER_NE	0x10513
#define Z_UNICODE_ELBASAN_LETTER_NA	0x10514
#define Z_UNICODE_ELBASAN_LETTER_NJE	0x10515
#define Z_UNICODE_ELBASAN_LETTER_O	0x10516
#define Z_UNICODE_ELBASAN_LETTER_PE	0x10517
#define Z_UNICODE_ELBASAN_LETTER_QE	0x10518
#define Z_UNICODE_ELBASAN_LETTER_RE	0x10519
#define Z_UNICODE_ELBASAN_LETTER_RRE	0x1051A
#define Z_UNICODE_ELBASAN_LETTER_SE	0x1051B
#define Z_UNICODE_ELBASAN_LETTER_SHE	0x1051C
#define Z_UNICODE_ELBASAN_LETTER_TE	0x1051D
#define Z_UNICODE_ELBASAN_LETTER_THE	0x1051E
#define Z_UNICODE_ELBASAN_LETTER_U	0x1051F
#define Z_UNICODE_ELBASAN_LETTER_VE	0x10520
#define Z_UNICODE_ELBASAN_LETTER_XE	0x10521
#define Z_UNICODE_ELBASAN_LETTER_Y	0x10522
#define Z_UNICODE_ELBASAN_LETTER_ZE	0x10523
#define Z_UNICODE_ELBASAN_LETTER_ZHE	0x10524
#define Z_UNICODE_ELBASAN_LETTER_GHE	0x10525
#define Z_UNICODE_ELBASAN_LETTER_GHAMMA	0x10526
#define Z_UNICODE_ELBASAN_LETTER_KHE	0x10527

/* MARK: - 10530h-1056Fh - Caucasian Albanian */

#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_ALT	   0x10530
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_BET	   0x10531
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_GIM	   0x10532
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_DAT	   0x10533
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_EB	   0x10534
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_ZARL   0x10535
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_EYN	   0x10536
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_ZHIL   0x10537
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_TAS	   0x10538
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_CHA	   0x10539
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_YOWD   0x1053A
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_ZHA	   0x1053B
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_IRB	   0x1053C
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_SHA	   0x1053D
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_LAN	   0x1053E
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_INYA   0x1053F
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_XEYN   0x10540
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_DYAN   0x10541
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_CAR	   0x10542
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_JHOX   0x10543
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_KAR	   0x10544
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_LYIT   0x10545
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_HEYT   0x10546
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_QAY	   0x10547
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_AOR	   0x10548
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_CHOY   0x10549
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_CHI	   0x1054A
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_CYAY   0x1054B
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_MAQ	   0x1054C
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_QAR	   0x1054D
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_NOWC   0x1054E
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_DZYAY  0x1054F
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_SHAK   0x10550
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_JAYN   0x10551
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_ON	   0x10552
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_TYAY   0x10553
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_FAM	   0x10554
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_DZAY   0x10555
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_CHAT   0x10556
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_PEN	   0x10557
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_GHEYS  0x10558
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_RAT	   0x10559
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_SEYK   0x1055A
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_VEYZ   0x1055B
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_TIWR   0x1055C
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_SHOY   0x1055D
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_IWN	   0x1055E
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_CYAW   0x1055F
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_CAYN   0x10560
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_YAYD   0x10561
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_PIWR   0x10562
#define Z_UNICODE_CAUCASIAN_ALBANIAN_LETTER_KIW	   0x10563
#define Z_UNICODE_CAUCASIAN_ALBANIAN_CITATION_MARK 0x1056F

/* MARK: - 10600h-1077Fh - Linear A */

#define Z_UNICODE_LINEAR_A_SIGN_AB001	   0x10600
#define Z_UNICODE_LINEAR_A_SIGN_AB002	   0x10601
#define Z_UNICODE_LINEAR_A_SIGN_AB003	   0x10602
#define Z_UNICODE_LINEAR_A_SIGN_AB004	   0x10603
#define Z_UNICODE_LINEAR_A_SIGN_AB005	   0x10604
#define Z_UNICODE_LINEAR_A_SIGN_AB006	   0x10605
#define Z_UNICODE_LINEAR_A_SIGN_AB007	   0x10606
#define Z_UNICODE_LINEAR_A_SIGN_AB008	   0x10607
#define Z_UNICODE_LINEAR_A_SIGN_AB009	   0x10608
#define Z_UNICODE_LINEAR_A_SIGN_AB010	   0x10609
#define Z_UNICODE_LINEAR_A_SIGN_AB011	   0x1060A
#define Z_UNICODE_LINEAR_A_SIGN_AB013	   0x1060B
#define Z_UNICODE_LINEAR_A_SIGN_AB016	   0x1060C
#define Z_UNICODE_LINEAR_A_SIGN_AB017	   0x1060D
#define Z_UNICODE_LINEAR_A_SIGN_AB020	   0x1060E
#define Z_UNICODE_LINEAR_A_SIGN_AB021	   0x1060F
#define Z_UNICODE_LINEAR_A_SIGN_AB021F	   0x10610
#define Z_UNICODE_LINEAR_A_SIGN_AB021M	   0x10611
#define Z_UNICODE_LINEAR_A_SIGN_AB022	   0x10612
#define Z_UNICODE_LINEAR_A_SIGN_AB022F	   0x10613
#define Z_UNICODE_LINEAR_A_SIGN_AB022M	   0x10614
#define Z_UNICODE_LINEAR_A_SIGN_AB023	   0x10615
#define Z_UNICODE_LINEAR_A_SIGN_AB023M	   0x10616
#define Z_UNICODE_LINEAR_A_SIGN_AB024	   0x10617
#define Z_UNICODE_LINEAR_A_SIGN_AB026	   0x10618
#define Z_UNICODE_LINEAR_A_SIGN_AB027	   0x10619
#define Z_UNICODE_LINEAR_A_SIGN_AB028	   0x1061A
#define Z_UNICODE_LINEAR_A_SIGN_A028B	   0x1061B
#define Z_UNICODE_LINEAR_A_SIGN_AB029	   0x1061C
#define Z_UNICODE_LINEAR_A_SIGN_AB030	   0x1061D
#define Z_UNICODE_LINEAR_A_SIGN_AB031	   0x1061E
#define Z_UNICODE_LINEAR_A_SIGN_AB034	   0x1061F
#define Z_UNICODE_LINEAR_A_SIGN_AB037	   0x10620
#define Z_UNICODE_LINEAR_A_SIGN_AB038	   0x10621
#define Z_UNICODE_LINEAR_A_SIGN_AB039	   0x10622
#define Z_UNICODE_LINEAR_A_SIGN_AB040	   0x10623
#define Z_UNICODE_LINEAR_A_SIGN_AB041	   0x10624
#define Z_UNICODE_LINEAR_A_SIGN_AB044	   0x10625
#define Z_UNICODE_LINEAR_A_SIGN_AB045	   0x10626
#define Z_UNICODE_LINEAR_A_SIGN_AB046	   0x10627
#define Z_UNICODE_LINEAR_A_SIGN_AB047	   0x10628
#define Z_UNICODE_LINEAR_A_SIGN_AB048	   0x10629
#define Z_UNICODE_LINEAR_A_SIGN_AB049	   0x1062A
#define Z_UNICODE_LINEAR_A_SIGN_AB050	   0x1062B
#define Z_UNICODE_LINEAR_A_SIGN_AB051	   0x1062C
#define Z_UNICODE_LINEAR_A_SIGN_AB053	   0x1062D
#define Z_UNICODE_LINEAR_A_SIGN_AB054	   0x1062E
#define Z_UNICODE_LINEAR_A_SIGN_AB055	   0x1062F
#define Z_UNICODE_LINEAR_A_SIGN_AB056	   0x10630
#define Z_UNICODE_LINEAR_A_SIGN_AB057	   0x10631
#define Z_UNICODE_LINEAR_A_SIGN_AB058	   0x10632
#define Z_UNICODE_LINEAR_A_SIGN_AB059	   0x10633
#define Z_UNICODE_LINEAR_A_SIGN_AB060	   0x10634
#define Z_UNICODE_LINEAR_A_SIGN_AB061	   0x10635
#define Z_UNICODE_LINEAR_A_SIGN_AB065	   0x10636
#define Z_UNICODE_LINEAR_A_SIGN_AB066	   0x10637
#define Z_UNICODE_LINEAR_A_SIGN_AB067	   0x10638
#define Z_UNICODE_LINEAR_A_SIGN_AB069	   0x10639
#define Z_UNICODE_LINEAR_A_SIGN_AB070	   0x1063A
#define Z_UNICODE_LINEAR_A_SIGN_AB073	   0x1063B
#define Z_UNICODE_LINEAR_A_SIGN_AB074	   0x1063C
#define Z_UNICODE_LINEAR_A_SIGN_AB076	   0x1063D
#define Z_UNICODE_LINEAR_A_SIGN_AB077	   0x1063E
#define Z_UNICODE_LINEAR_A_SIGN_AB078	   0x1063F
#define Z_UNICODE_LINEAR_A_SIGN_AB079	   0x10640
#define Z_UNICODE_LINEAR_A_SIGN_AB080	   0x10641
#define Z_UNICODE_LINEAR_A_SIGN_AB081	   0x10642
#define Z_UNICODE_LINEAR_A_SIGN_AB082	   0x10643
#define Z_UNICODE_LINEAR_A_SIGN_AB085	   0x10644
#define Z_UNICODE_LINEAR_A_SIGN_AB086	   0x10645
#define Z_UNICODE_LINEAR_A_SIGN_AB087	   0x10646
#define Z_UNICODE_LINEAR_A_SIGN_A100_102   0x10647
#define Z_UNICODE_LINEAR_A_SIGN_AB118	   0x10648
#define Z_UNICODE_LINEAR_A_SIGN_AB120	   0x10649
#define Z_UNICODE_LINEAR_A_SIGN_A120B	   0x1064A
#define Z_UNICODE_LINEAR_A_SIGN_AB122	   0x1064B
#define Z_UNICODE_LINEAR_A_SIGN_AB123	   0x1064C
#define Z_UNICODE_LINEAR_A_SIGN_AB131A	   0x1064D
#define Z_UNICODE_LINEAR_A_SIGN_AB131B	   0x1064E
#define Z_UNICODE_LINEAR_A_SIGN_A131C	   0x1064F
#define Z_UNICODE_LINEAR_A_SIGN_AB164	   0x10650
#define Z_UNICODE_LINEAR_A_SIGN_AB171	   0x10651
#define Z_UNICODE_LINEAR_A_SIGN_AB180	   0x10652
#define Z_UNICODE_LINEAR_A_SIGN_AB188	   0x10653
#define Z_UNICODE_LINEAR_A_SIGN_AB191	   0x10654
#define Z_UNICODE_LINEAR_A_SIGN_A301	   0x10655
#define Z_UNICODE_LINEAR_A_SIGN_A302	   0x10656
#define Z_UNICODE_LINEAR_A_SIGN_A303	   0x10657
#define Z_UNICODE_LINEAR_A_SIGN_A304	   0x10658
#define Z_UNICODE_LINEAR_A_SIGN_A305	   0x10659
#define Z_UNICODE_LINEAR_A_SIGN_A306	   0x1065A
#define Z_UNICODE_LINEAR_A_SIGN_A307	   0x1065B
#define Z_UNICODE_LINEAR_A_SIGN_A308	   0x1065C
#define Z_UNICODE_LINEAR_A_SIGN_A309A	   0x1065D
#define Z_UNICODE_LINEAR_A_SIGN_A309B	   0x1065E
#define Z_UNICODE_LINEAR_A_SIGN_A309C	   0x1065F
#define Z_UNICODE_LINEAR_A_SIGN_A310	   0x10660
#define Z_UNICODE_LINEAR_A_SIGN_A311	   0x10661
#define Z_UNICODE_LINEAR_A_SIGN_A312	   0x10662
#define Z_UNICODE_LINEAR_A_SIGN_A313A	   0x10663
#define Z_UNICODE_LINEAR_A_SIGN_A313B	   0x10664
#define Z_UNICODE_LINEAR_A_SIGN_A313C	   0x10665
#define Z_UNICODE_LINEAR_A_SIGN_A314	   0x10666
#define Z_UNICODE_LINEAR_A_SIGN_A315	   0x10667
#define Z_UNICODE_LINEAR_A_SIGN_A316	   0x10668
#define Z_UNICODE_LINEAR_A_SIGN_A317	   0x10669
#define Z_UNICODE_LINEAR_A_SIGN_A318	   0x1066A
#define Z_UNICODE_LINEAR_A_SIGN_A319	   0x1066B
#define Z_UNICODE_LINEAR_A_SIGN_A320	   0x1066C
#define Z_UNICODE_LINEAR_A_SIGN_A321	   0x1066D
#define Z_UNICODE_LINEAR_A_SIGN_A322	   0x1066E
#define Z_UNICODE_LINEAR_A_SIGN_A323	   0x1066F
#define Z_UNICODE_LINEAR_A_SIGN_A324	   0x10670
#define Z_UNICODE_LINEAR_A_SIGN_A325	   0x10671
#define Z_UNICODE_LINEAR_A_SIGN_A326	   0x10672
#define Z_UNICODE_LINEAR_A_SIGN_A327	   0x10673
#define Z_UNICODE_LINEAR_A_SIGN_A328	   0x10674
#define Z_UNICODE_LINEAR_A_SIGN_A329	   0x10675
#define Z_UNICODE_LINEAR_A_SIGN_A330	   0x10676
#define Z_UNICODE_LINEAR_A_SIGN_A331	   0x10677
#define Z_UNICODE_LINEAR_A_SIGN_A332	   0x10678
#define Z_UNICODE_LINEAR_A_SIGN_A333	   0x10679
#define Z_UNICODE_LINEAR_A_SIGN_A334	   0x1067A
#define Z_UNICODE_LINEAR_A_SIGN_A335	   0x1067B
#define Z_UNICODE_LINEAR_A_SIGN_A336	   0x1067C
#define Z_UNICODE_LINEAR_A_SIGN_A337	   0x1067D
#define Z_UNICODE_LINEAR_A_SIGN_A338	   0x1067E
#define Z_UNICODE_LINEAR_A_SIGN_A339	   0x1067F
#define Z_UNICODE_LINEAR_A_SIGN_A340	   0x10680
#define Z_UNICODE_LINEAR_A_SIGN_A341	   0x10681
#define Z_UNICODE_LINEAR_A_SIGN_A342	   0x10682
#define Z_UNICODE_LINEAR_A_SIGN_A343	   0x10683
#define Z_UNICODE_LINEAR_A_SIGN_A344	   0x10684
#define Z_UNICODE_LINEAR_A_SIGN_A345	   0x10685
#define Z_UNICODE_LINEAR_A_SIGN_A346	   0x10686
#define Z_UNICODE_LINEAR_A_SIGN_A347	   0x10687
#define Z_UNICODE_LINEAR_A_SIGN_A348	   0x10688
#define Z_UNICODE_LINEAR_A_SIGN_A349	   0x10689
#define Z_UNICODE_LINEAR_A_SIGN_A350	   0x1068A
#define Z_UNICODE_LINEAR_A_SIGN_A351	   0x1068B
#define Z_UNICODE_LINEAR_A_SIGN_A352	   0x1068C
#define Z_UNICODE_LINEAR_A_SIGN_A353	   0x1068D
#define Z_UNICODE_LINEAR_A_SIGN_A354	   0x1068E
#define Z_UNICODE_LINEAR_A_SIGN_A355	   0x1068F
#define Z_UNICODE_LINEAR_A_SIGN_A356	   0x10690
#define Z_UNICODE_LINEAR_A_SIGN_A357	   0x10691
#define Z_UNICODE_LINEAR_A_SIGN_A358	   0x10692
#define Z_UNICODE_LINEAR_A_SIGN_A359	   0x10693
#define Z_UNICODE_LINEAR_A_SIGN_A360	   0x10694
#define Z_UNICODE_LINEAR_A_SIGN_A361	   0x10695
#define Z_UNICODE_LINEAR_A_SIGN_A362	   0x10696
#define Z_UNICODE_LINEAR_A_SIGN_A363	   0x10697
#define Z_UNICODE_LINEAR_A_SIGN_A364	   0x10698
#define Z_UNICODE_LINEAR_A_SIGN_A365	   0x10699
#define Z_UNICODE_LINEAR_A_SIGN_A366	   0x1069A
#define Z_UNICODE_LINEAR_A_SIGN_A367	   0x1069B
#define Z_UNICODE_LINEAR_A_SIGN_A368	   0x1069C
#define Z_UNICODE_LINEAR_A_SIGN_A369	   0x1069D
#define Z_UNICODE_LINEAR_A_SIGN_A370	   0x1069E
#define Z_UNICODE_LINEAR_A_SIGN_A371	   0x1069F
#define Z_UNICODE_LINEAR_A_SIGN_A400_VAS   0x106A0
#define Z_UNICODE_LINEAR_A_SIGN_A401_VAS   0x106A1
#define Z_UNICODE_LINEAR_A_SIGN_A402_VAS   0x106A2
#define Z_UNICODE_LINEAR_A_SIGN_A403_VAS   0x106A3
#define Z_UNICODE_LINEAR_A_SIGN_A404_VAS   0x106A4
#define Z_UNICODE_LINEAR_A_SIGN_A405_VAS   0x106A5
#define Z_UNICODE_LINEAR_A_SIGN_A406_VAS   0x106A6
#define Z_UNICODE_LINEAR_A_SIGN_A407_VAS   0x106A7
#define Z_UNICODE_LINEAR_A_SIGN_A408_VAS   0x106A8
#define Z_UNICODE_LINEAR_A_SIGN_A409_VAS   0x106A9
#define Z_UNICODE_LINEAR_A_SIGN_A410_VAS   0x106AA
#define Z_UNICODE_LINEAR_A_SIGN_A411_VAS   0x106AB
#define Z_UNICODE_LINEAR_A_SIGN_A412_VAS   0x106AC
#define Z_UNICODE_LINEAR_A_SIGN_A413_VAS   0x106AD
#define Z_UNICODE_LINEAR_A_SIGN_A414_VAS   0x106AE
#define Z_UNICODE_LINEAR_A_SIGN_A415_VAS   0x106AF
#define Z_UNICODE_LINEAR_A_SIGN_A416_VAS   0x106B0
#define Z_UNICODE_LINEAR_A_SIGN_A417_VAS   0x106B1
#define Z_UNICODE_LINEAR_A_SIGN_A418_VAS   0x106B2
#define Z_UNICODE_LINEAR_A_SIGN_A501	   0x106B3
#define Z_UNICODE_LINEAR_A_SIGN_A502	   0x106B4
#define Z_UNICODE_LINEAR_A_SIGN_A503	   0x106B5
#define Z_UNICODE_LINEAR_A_SIGN_A504	   0x106B6
#define Z_UNICODE_LINEAR_A_SIGN_A505	   0x106B7
#define Z_UNICODE_LINEAR_A_SIGN_A506	   0x106B8
#define Z_UNICODE_LINEAR_A_SIGN_A508	   0x106B9
#define Z_UNICODE_LINEAR_A_SIGN_A509	   0x106BA
#define Z_UNICODE_LINEAR_A_SIGN_A510	   0x106BB
#define Z_UNICODE_LINEAR_A_SIGN_A511	   0x106BC
#define Z_UNICODE_LINEAR_A_SIGN_A512	   0x106BD
#define Z_UNICODE_LINEAR_A_SIGN_A513	   0x106BE
#define Z_UNICODE_LINEAR_A_SIGN_A515	   0x106BF
#define Z_UNICODE_LINEAR_A_SIGN_A516	   0x106C0
#define Z_UNICODE_LINEAR_A_SIGN_A520	   0x106C1
#define Z_UNICODE_LINEAR_A_SIGN_A521	   0x106C2
#define Z_UNICODE_LINEAR_A_SIGN_A523	   0x106C3
#define Z_UNICODE_LINEAR_A_SIGN_A524	   0x106C4
#define Z_UNICODE_LINEAR_A_SIGN_A525	   0x106C5
#define Z_UNICODE_LINEAR_A_SIGN_A526	   0x106C6
#define Z_UNICODE_LINEAR_A_SIGN_A527	   0x106C7
#define Z_UNICODE_LINEAR_A_SIGN_A528	   0x106C8
#define Z_UNICODE_LINEAR_A_SIGN_A529	   0x106C9
#define Z_UNICODE_LINEAR_A_SIGN_A530	   0x106CA
#define Z_UNICODE_LINEAR_A_SIGN_A531	   0x106CB
#define Z_UNICODE_LINEAR_A_SIGN_A532	   0x106CC
#define Z_UNICODE_LINEAR_A_SIGN_A534	   0x106CD
#define Z_UNICODE_LINEAR_A_SIGN_A535	   0x106CE
#define Z_UNICODE_LINEAR_A_SIGN_A536	   0x106CF
#define Z_UNICODE_LINEAR_A_SIGN_A537	   0x106D0
#define Z_UNICODE_LINEAR_A_SIGN_A538	   0x106D1
#define Z_UNICODE_LINEAR_A_SIGN_A539	   0x106D2
#define Z_UNICODE_LINEAR_A_SIGN_A540	   0x106D3
#define Z_UNICODE_LINEAR_A_SIGN_A541	   0x106D4
#define Z_UNICODE_LINEAR_A_SIGN_A542	   0x106D5
#define Z_UNICODE_LINEAR_A_SIGN_A545	   0x106D6
#define Z_UNICODE_LINEAR_A_SIGN_A547	   0x106D7
#define Z_UNICODE_LINEAR_A_SIGN_A548	   0x106D8
#define Z_UNICODE_LINEAR_A_SIGN_A549	   0x106D9
#define Z_UNICODE_LINEAR_A_SIGN_A550	   0x106DA
#define Z_UNICODE_LINEAR_A_SIGN_A551	   0x106DB
#define Z_UNICODE_LINEAR_A_SIGN_A552	   0x106DC
#define Z_UNICODE_LINEAR_A_SIGN_A553	   0x106DD
#define Z_UNICODE_LINEAR_A_SIGN_A554	   0x106DE
#define Z_UNICODE_LINEAR_A_SIGN_A555	   0x106DF
#define Z_UNICODE_LINEAR_A_SIGN_A556	   0x106E0
#define Z_UNICODE_LINEAR_A_SIGN_A557	   0x106E1
#define Z_UNICODE_LINEAR_A_SIGN_A559	   0x106E2
#define Z_UNICODE_LINEAR_A_SIGN_A563	   0x106E3
#define Z_UNICODE_LINEAR_A_SIGN_A564	   0x106E4
#define Z_UNICODE_LINEAR_A_SIGN_A565	   0x106E5
#define Z_UNICODE_LINEAR_A_SIGN_A566	   0x106E6
#define Z_UNICODE_LINEAR_A_SIGN_A568	   0x106E7
#define Z_UNICODE_LINEAR_A_SIGN_A569	   0x106E8
#define Z_UNICODE_LINEAR_A_SIGN_A570	   0x106E9
#define Z_UNICODE_LINEAR_A_SIGN_A571	   0x106EA
#define Z_UNICODE_LINEAR_A_SIGN_A572	   0x106EB
#define Z_UNICODE_LINEAR_A_SIGN_A573	   0x106EC
#define Z_UNICODE_LINEAR_A_SIGN_A574	   0x106ED
#define Z_UNICODE_LINEAR_A_SIGN_A575	   0x106EE
#define Z_UNICODE_LINEAR_A_SIGN_A576	   0x106EF
#define Z_UNICODE_LINEAR_A_SIGN_A577	   0x106F0
#define Z_UNICODE_LINEAR_A_SIGN_A578	   0x106F1
#define Z_UNICODE_LINEAR_A_SIGN_A579	   0x106F2
#define Z_UNICODE_LINEAR_A_SIGN_A580	   0x106F3
#define Z_UNICODE_LINEAR_A_SIGN_A581	   0x106F4
#define Z_UNICODE_LINEAR_A_SIGN_A582	   0x106F5
#define Z_UNICODE_LINEAR_A_SIGN_A583	   0x106F6
#define Z_UNICODE_LINEAR_A_SIGN_A584	   0x106F7
#define Z_UNICODE_LINEAR_A_SIGN_A585	   0x106F8
#define Z_UNICODE_LINEAR_A_SIGN_A586	   0x106F9
#define Z_UNICODE_LINEAR_A_SIGN_A587	   0x106FA
#define Z_UNICODE_LINEAR_A_SIGN_A588	   0x106FB
#define Z_UNICODE_LINEAR_A_SIGN_A589	   0x106FC
#define Z_UNICODE_LINEAR_A_SIGN_A591	   0x106FD
#define Z_UNICODE_LINEAR_A_SIGN_A592	   0x106FE
#define Z_UNICODE_LINEAR_A_SIGN_A594	   0x106FF
#define Z_UNICODE_LINEAR_A_SIGN_A595	   0x10700
#define Z_UNICODE_LINEAR_A_SIGN_A596	   0x10701
#define Z_UNICODE_LINEAR_A_SIGN_A598	   0x10702
#define Z_UNICODE_LINEAR_A_SIGN_A600	   0x10703
#define Z_UNICODE_LINEAR_A_SIGN_A601	   0x10704
#define Z_UNICODE_LINEAR_A_SIGN_A602	   0x10705
#define Z_UNICODE_LINEAR_A_SIGN_A603	   0x10706
#define Z_UNICODE_LINEAR_A_SIGN_A604	   0x10707
#define Z_UNICODE_LINEAR_A_SIGN_A606	   0x10708
#define Z_UNICODE_LINEAR_A_SIGN_A608	   0x10709
#define Z_UNICODE_LINEAR_A_SIGN_A609	   0x1070A
#define Z_UNICODE_LINEAR_A_SIGN_A610	   0x1070B
#define Z_UNICODE_LINEAR_A_SIGN_A611	   0x1070C
#define Z_UNICODE_LINEAR_A_SIGN_A612	   0x1070D
#define Z_UNICODE_LINEAR_A_SIGN_A613	   0x1070E
#define Z_UNICODE_LINEAR_A_SIGN_A614	   0x1070F
#define Z_UNICODE_LINEAR_A_SIGN_A615	   0x10710
#define Z_UNICODE_LINEAR_A_SIGN_A616	   0x10711
#define Z_UNICODE_LINEAR_A_SIGN_A617	   0x10712
#define Z_UNICODE_LINEAR_A_SIGN_A618	   0x10713
#define Z_UNICODE_LINEAR_A_SIGN_A619	   0x10714
#define Z_UNICODE_LINEAR_A_SIGN_A620	   0x10715
#define Z_UNICODE_LINEAR_A_SIGN_A621	   0x10716
#define Z_UNICODE_LINEAR_A_SIGN_A622	   0x10717
#define Z_UNICODE_LINEAR_A_SIGN_A623	   0x10718
#define Z_UNICODE_LINEAR_A_SIGN_A624	   0x10719
#define Z_UNICODE_LINEAR_A_SIGN_A626	   0x1071A
#define Z_UNICODE_LINEAR_A_SIGN_A627	   0x1071B
#define Z_UNICODE_LINEAR_A_SIGN_A628	   0x1071C
#define Z_UNICODE_LINEAR_A_SIGN_A629	   0x1071D
#define Z_UNICODE_LINEAR_A_SIGN_A634	   0x1071E
#define Z_UNICODE_LINEAR_A_SIGN_A637	   0x1071F
#define Z_UNICODE_LINEAR_A_SIGN_A638	   0x10720
#define Z_UNICODE_LINEAR_A_SIGN_A640	   0x10721
#define Z_UNICODE_LINEAR_A_SIGN_A642	   0x10722
#define Z_UNICODE_LINEAR_A_SIGN_A643	   0x10723
#define Z_UNICODE_LINEAR_A_SIGN_A644	   0x10724
#define Z_UNICODE_LINEAR_A_SIGN_A645	   0x10725
#define Z_UNICODE_LINEAR_A_SIGN_A646	   0x10726
#define Z_UNICODE_LINEAR_A_SIGN_A648	   0x10727
#define Z_UNICODE_LINEAR_A_SIGN_A649	   0x10728
#define Z_UNICODE_LINEAR_A_SIGN_A651	   0x10729
#define Z_UNICODE_LINEAR_A_SIGN_A652	   0x1072A
#define Z_UNICODE_LINEAR_A_SIGN_A653	   0x1072B
#define Z_UNICODE_LINEAR_A_SIGN_A654	   0x1072C
#define Z_UNICODE_LINEAR_A_SIGN_A655	   0x1072D
#define Z_UNICODE_LINEAR_A_SIGN_A656	   0x1072E
#define Z_UNICODE_LINEAR_A_SIGN_A657	   0x1072F
#define Z_UNICODE_LINEAR_A_SIGN_A658	   0x10730
#define Z_UNICODE_LINEAR_A_SIGN_A659	   0x10731
#define Z_UNICODE_LINEAR_A_SIGN_A660	   0x10732
#define Z_UNICODE_LINEAR_A_SIGN_A661	   0x10733
#define Z_UNICODE_LINEAR_A_SIGN_A662	   0x10734
#define Z_UNICODE_LINEAR_A_SIGN_A663	   0x10735
#define Z_UNICODE_LINEAR_A_SIGN_A664	   0x10736
#define Z_UNICODE_LINEAR_A_SIGN_A701_A	   0x10740
#define Z_UNICODE_LINEAR_A_SIGN_A702_B	   0x10741
#define Z_UNICODE_LINEAR_A_SIGN_A703_D	   0x10742
#define Z_UNICODE_LINEAR_A_SIGN_A704_E	   0x10743
#define Z_UNICODE_LINEAR_A_SIGN_A705_F	   0x10744
#define Z_UNICODE_LINEAR_A_SIGN_A706_H	   0x10745
#define Z_UNICODE_LINEAR_A_SIGN_A707_J	   0x10746
#define Z_UNICODE_LINEAR_A_SIGN_A708_K	   0x10747
#define Z_UNICODE_LINEAR_A_SIGN_A709_L	   0x10748
#define Z_UNICODE_LINEAR_A_SIGN_A709_2_L2  0x10749
#define Z_UNICODE_LINEAR_A_SIGN_A709_3_L3  0x1074A
#define Z_UNICODE_LINEAR_A_SIGN_A709_4_L4  0x1074B
#define Z_UNICODE_LINEAR_A_SIGN_A709_6_L6  0x1074C
#define Z_UNICODE_LINEAR_A_SIGN_A710_W	   0x1074D
#define Z_UNICODE_LINEAR_A_SIGN_A711_X	   0x1074E
#define Z_UNICODE_LINEAR_A_SIGN_A712_Y	   0x1074F
#define Z_UNICODE_LINEAR_A_SIGN_A713_OMEGA 0x10750
#define Z_UNICODE_LINEAR_A_SIGN_A714_ABB   0x10751
#define Z_UNICODE_LINEAR_A_SIGN_A715_BB	   0x10752
#define Z_UNICODE_LINEAR_A_SIGN_A717_DD	   0x10753
#define Z_UNICODE_LINEAR_A_SIGN_A726_EYYY  0x10754
#define Z_UNICODE_LINEAR_A_SIGN_A732_JE	   0x10755
#define Z_UNICODE_LINEAR_A_SIGN_A800	   0x10760
#define Z_UNICODE_LINEAR_A_SIGN_A801	   0x10761
#define Z_UNICODE_LINEAR_A_SIGN_A802	   0x10762
#define Z_UNICODE_LINEAR_A_SIGN_A803	   0x10763
#define Z_UNICODE_LINEAR_A_SIGN_A804	   0x10764
#define Z_UNICODE_LINEAR_A_SIGN_A805	   0x10765
#define Z_UNICODE_LINEAR_A_SIGN_A806	   0x10766
#define Z_UNICODE_LINEAR_A_SIGN_A807	   0x10767

/* MARK: - 10800h-1083Fh - Cypriot Syllabary */

#define Z_UNICODE_CYPRIOT_SYLLABLE_A  0x10800
#define Z_UNICODE_CYPRIOT_SYLLABLE_E  0x10801
#define Z_UNICODE_CYPRIOT_SYLLABLE_I  0x10802
#define Z_UNICODE_CYPRIOT_SYLLABLE_O  0x10803
#define Z_UNICODE_CYPRIOT_SYLLABLE_U  0x10804
#define Z_UNICODE_CYPRIOT_SYLLABLE_JA 0x10805
#define Z_UNICODE_CYPRIOT_SYLLABLE_JO 0x10808
#define Z_UNICODE_CYPRIOT_SYLLABLE_KA 0x1080A
#define Z_UNICODE_CYPRIOT_SYLLABLE_KE 0x1080B
#define Z_UNICODE_CYPRIOT_SYLLABLE_KI 0x1080C
#define Z_UNICODE_CYPRIOT_SYLLABLE_KO 0x1080D
#define Z_UNICODE_CYPRIOT_SYLLABLE_KU 0x1080E
#define Z_UNICODE_CYPRIOT_SYLLABLE_LA 0x1080F
#define Z_UNICODE_CYPRIOT_SYLLABLE_LE 0x10810
#define Z_UNICODE_CYPRIOT_SYLLABLE_LI 0x10811
#define Z_UNICODE_CYPRIOT_SYLLABLE_LO 0x10812
#define Z_UNICODE_CYPRIOT_SYLLABLE_LU 0x10813
#define Z_UNICODE_CYPRIOT_SYLLABLE_MA 0x10814
#define Z_UNICODE_CYPRIOT_SYLLABLE_ME 0x10815
#define Z_UNICODE_CYPRIOT_SYLLABLE_MI 0x10816
#define Z_UNICODE_CYPRIOT_SYLLABLE_MO 0x10817
#define Z_UNICODE_CYPRIOT_SYLLABLE_MU 0x10818
#define Z_UNICODE_CYPRIOT_SYLLABLE_NA 0x10819
#define Z_UNICODE_CYPRIOT_SYLLABLE_NE 0x1081A
#define Z_UNICODE_CYPRIOT_SYLLABLE_NI 0x1081B
#define Z_UNICODE_CYPRIOT_SYLLABLE_NO 0x1081C
#define Z_UNICODE_CYPRIOT_SYLLABLE_NU 0x1081D
#define Z_UNICODE_CYPRIOT_SYLLABLE_PA 0x1081E
#define Z_UNICODE_CYPRIOT_SYLLABLE_PE 0x1081F
#define Z_UNICODE_CYPRIOT_SYLLABLE_PI 0x10820
#define Z_UNICODE_CYPRIOT_SYLLABLE_PO 0x10821
#define Z_UNICODE_CYPRIOT_SYLLABLE_PU 0x10822
#define Z_UNICODE_CYPRIOT_SYLLABLE_RA 0x10823
#define Z_UNICODE_CYPRIOT_SYLLABLE_RE 0x10824
#define Z_UNICODE_CYPRIOT_SYLLABLE_RI 0x10825
#define Z_UNICODE_CYPRIOT_SYLLABLE_RO 0x10826
#define Z_UNICODE_CYPRIOT_SYLLABLE_RU 0x10827
#define Z_UNICODE_CYPRIOT_SYLLABLE_SA 0x10828
#define Z_UNICODE_CYPRIOT_SYLLABLE_SE 0x10829
#define Z_UNICODE_CYPRIOT_SYLLABLE_SI 0x1082A
#define Z_UNICODE_CYPRIOT_SYLLABLE_SO 0x1082B
#define Z_UNICODE_CYPRIOT_SYLLABLE_SU 0x1082C
#define Z_UNICODE_CYPRIOT_SYLLABLE_TA 0x1082D
#define Z_UNICODE_CYPRIOT_SYLLABLE_TE 0x1082E
#define Z_UNICODE_CYPRIOT_SYLLABLE_TI 0x1082F
#define Z_UNICODE_CYPRIOT_SYLLABLE_TO 0x10830
#define Z_UNICODE_CYPRIOT_SYLLABLE_TU 0x10831
#define Z_UNICODE_CYPRIOT_SYLLABLE_WA 0x10832
#define Z_UNICODE_CYPRIOT_SYLLABLE_WE 0x10833
#define Z_UNICODE_CYPRIOT_SYLLABLE_WI 0x10834
#define Z_UNICODE_CYPRIOT_SYLLABLE_WO 0x10835
#define Z_UNICODE_CYPRIOT_SYLLABLE_XA 0x10837
#define Z_UNICODE_CYPRIOT_SYLLABLE_XE 0x10838
#define Z_UNICODE_CYPRIOT_SYLLABLE_ZA 0x1083C
#define Z_UNICODE_CYPRIOT_SYLLABLE_ZO 0x1083F

/* MARK: - 10840h-1085Fh - Imperial Aramaic */

#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_ALEPH	       0x10840
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_BETH	       0x10841
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_GIMEL	       0x10842
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_DALETH       0x10843
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_HE	       0x10844
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_WAW	       0x10845
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_ZAYIN	       0x10846
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_HETH	       0x10847
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_TETH	       0x10848
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_YODH	       0x10849
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_KAPH	       0x1084A
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_LAMEDH       0x1084B
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_MEM	       0x1084C
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_NUN	       0x1084D
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_SAMEKH       0x1084E
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_AYIN	       0x1084F
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_PE	       0x10850
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_SADHE	       0x10851
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_QOPH	       0x10852
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_RESH	       0x10853
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_SHIN	       0x10854
#define Z_UNICODE_IMPERIAL_ARAMAIC_LETTER_TAW	       0x10855
#define Z_UNICODE_IMPERIAL_ARAMAIC_SECTION_SIGN	       0x10857
#define Z_UNICODE_IMPERIAL_ARAMAIC_NUMBER_ONE	       0x10858
#define Z_UNICODE_IMPERIAL_ARAMAIC_NUMBER_TWO	       0x10859
#define Z_UNICODE_IMPERIAL_ARAMAIC_NUMBER_THREE	       0x1085A
#define Z_UNICODE_IMPERIAL_ARAMAIC_NUMBER_TEN	       0x1085B
#define Z_UNICODE_IMPERIAL_ARAMAIC_NUMBER_TWENTY       0x1085C
#define Z_UNICODE_IMPERIAL_ARAMAIC_NUMBER_ONE_HUNDRED  0x1085D
#define Z_UNICODE_IMPERIAL_ARAMAIC_NUMBER_ONE_THOUSAND 0x1085E
#define Z_UNICODE_IMPERIAL_ARAMAIC_NUMBER_TEN_THOUSAND 0x1085F

/* MARK: - 10860h-1087Fh - Palmyrene */

#define Z_UNICODE_PALMYRENE_LETTER_ALEPH	   0x10860
#define Z_UNICODE_PALMYRENE_LETTER_BETH		   0x10861
#define Z_UNICODE_PALMYRENE_LETTER_GIMEL	   0x10862
#define Z_UNICODE_PALMYRENE_LETTER_DALETH	   0x10863
#define Z_UNICODE_PALMYRENE_LETTER_HE		   0x10864
#define Z_UNICODE_PALMYRENE_LETTER_WAW		   0x10865
#define Z_UNICODE_PALMYRENE_LETTER_ZAYIN	   0x10866
#define Z_UNICODE_PALMYRENE_LETTER_HETH		   0x10867
#define Z_UNICODE_PALMYRENE_LETTER_TETH		   0x10868
#define Z_UNICODE_PALMYRENE_LETTER_YODH		   0x10869
#define Z_UNICODE_PALMYRENE_LETTER_KAPH		   0x1086A
#define Z_UNICODE_PALMYRENE_LETTER_LAMEDH	   0x1086B
#define Z_UNICODE_PALMYRENE_LETTER_MEM		   0x1086C
#define Z_UNICODE_PALMYRENE_LETTER_FINAL_NUN	   0x1086D
#define Z_UNICODE_PALMYRENE_LETTER_NUN		   0x1086E
#define Z_UNICODE_PALMYRENE_LETTER_SAMEKH	   0x1086F
#define Z_UNICODE_PALMYRENE_LETTER_AYIN		   0x10870
#define Z_UNICODE_PALMYRENE_LETTER_PE		   0x10871
#define Z_UNICODE_PALMYRENE_LETTER_SADHE	   0x10872
#define Z_UNICODE_PALMYRENE_LETTER_QOPH		   0x10873
#define Z_UNICODE_PALMYRENE_LETTER_RESH		   0x10874
#define Z_UNICODE_PALMYRENE_LETTER_SHIN		   0x10875
#define Z_UNICODE_PALMYRENE_LETTER_TAW		   0x10876
#define Z_UNICODE_PALMYRENE_LEFT_POINTING_FLEURON  0x10877
#define Z_UNICODE_PALMYRENE_RIGHT_POINTING_FLEURON 0x10878
#define Z_UNICODE_PALMYRENE_NUMBER_ONE		   0x10879
#define Z_UNICODE_PALMYRENE_NUMBER_TWO		   0x1087A
#define Z_UNICODE_PALMYRENE_NUMBER_THREE	   0x1087B
#define Z_UNICODE_PALMYRENE_NUMBER_FOUR		   0x1087C
#define Z_UNICODE_PALMYRENE_NUMBER_FIVE		   0x1087D
#define Z_UNICODE_PALMYRENE_NUMBER_TEN		   0x1087E
#define Z_UNICODE_PALMYRENE_NUMBER_TWENTY	   0x1087F

/* MARK: - 10880h-108AFh - Nabataean */

#define Z_UNICODE_NABATAEAN_LETTER_FINAL_ALEPH	  0x10880
#define Z_UNICODE_NABATAEAN_LETTER_ALEPH	  0x10881
#define Z_UNICODE_NABATAEAN_LETTER_FINAL_BETH	  0x10882
#define Z_UNICODE_NABATAEAN_LETTER_BETH		  0x10883
#define Z_UNICODE_NABATAEAN_LETTER_GIMEL	  0x10884
#define Z_UNICODE_NABATAEAN_LETTER_DALETH	  0x10885
#define Z_UNICODE_NABATAEAN_LETTER_FINAL_HE	  0x10886
#define Z_UNICODE_NABATAEAN_LETTER_HE		  0x10887
#define Z_UNICODE_NABATAEAN_LETTER_WAW		  0x10888
#define Z_UNICODE_NABATAEAN_LETTER_ZAYIN	  0x10889
#define Z_UNICODE_NABATAEAN_LETTER_HETH		  0x1088A
#define Z_UNICODE_NABATAEAN_LETTER_TETH		  0x1088B
#define Z_UNICODE_NABATAEAN_LETTER_FINAL_YODH	  0x1088C
#define Z_UNICODE_NABATAEAN_LETTER_YODH		  0x1088D
#define Z_UNICODE_NABATAEAN_LETTER_FINAL_KAPH	  0x1088E
#define Z_UNICODE_NABATAEAN_LETTER_KAPH		  0x1088F
#define Z_UNICODE_NABATAEAN_LETTER_FINAL_LAMEDH	  0x10890
#define Z_UNICODE_NABATAEAN_LETTER_LAMEDH	  0x10891
#define Z_UNICODE_NABATAEAN_LETTER_FINAL_MEM	  0x10892
#define Z_UNICODE_NABATAEAN_LETTER_MEM		  0x10893
#define Z_UNICODE_NABATAEAN_LETTER_FINAL_NUN	  0x10894
#define Z_UNICODE_NABATAEAN_LETTER_NUN		  0x10895
#define Z_UNICODE_NABATAEAN_LETTER_SAMEKH	  0x10896
#define Z_UNICODE_NABATAEAN_LETTER_AYIN		  0x10897
#define Z_UNICODE_NABATAEAN_LETTER_PE		  0x10898
#define Z_UNICODE_NABATAEAN_LETTER_SADHE	  0x10899
#define Z_UNICODE_NABATAEAN_LETTER_QOPH		  0x1089A
#define Z_UNICODE_NABATAEAN_LETTER_RESH		  0x1089B
#define Z_UNICODE_NABATAEAN_LETTER_FINAL_SHIN	  0x1089C
#define Z_UNICODE_NABATAEAN_LETTER_SHIN		  0x1089D
#define Z_UNICODE_NABATAEAN_LETTER_TAW		  0x1089E
#define Z_UNICODE_NABATAEAN_NUMBER_ONE		  0x108A7
#define Z_UNICODE_NABATAEAN_NUMBER_TWO		  0x108A8
#define Z_UNICODE_NABATAEAN_NUMBER_THREE	  0x108A9
#define Z_UNICODE_NABATAEAN_NUMBER_FOUR		  0x108AA
#define Z_UNICODE_NABATAEAN_CRUCIFORM_NUMBER_FOUR 0x108AB
#define Z_UNICODE_NABATAEAN_NUMBER_FIVE		  0x108AC
#define Z_UNICODE_NABATAEAN_NUMBER_TEN		  0x108AD
#define Z_UNICODE_NABATAEAN_NUMBER_TWENTY	  0x108AE
#define Z_UNICODE_NABATAEAN_NUMBER_ONE_HUNDRED	  0x108AF

/* MARK: - 108E0h-108FFh - Hatran */

#define Z_UNICODE_HATRAN_LETTER_ALEPH	    0x108E0
#define Z_UNICODE_HATRAN_LETTER_BETH	    0x108E1
#define Z_UNICODE_HATRAN_LETTER_GIMEL	    0x108E2
#define Z_UNICODE_HATRAN_LETTER_DALETH_RESH 0x108E3
#define Z_UNICODE_HATRAN_LETTER_HE	    0x108E4
#define Z_UNICODE_HATRAN_LETTER_WAW	    0x108E5
#define Z_UNICODE_HATRAN_LETTER_ZAYN	    0x108E6
#define Z_UNICODE_HATRAN_LETTER_HETH	    0x108E7
#define Z_UNICODE_HATRAN_LETTER_TETH	    0x108E8
#define Z_UNICODE_HATRAN_LETTER_YODH	    0x108E9
#define Z_UNICODE_HATRAN_LETTER_KAPH	    0x108EA
#define Z_UNICODE_HATRAN_LETTER_LAMEDH	    0x108EB
#define Z_UNICODE_HATRAN_LETTER_MEM	    0x108EC
#define Z_UNICODE_HATRAN_LETTER_NUN	    0x108ED
#define Z_UNICODE_HATRAN_LETTER_SAMEKH	    0x108EE
#define Z_UNICODE_HATRAN_LETTER_AYN	    0x108EF
#define Z_UNICODE_HATRAN_LETTER_PE	    0x108F0
#define Z_UNICODE_HATRAN_LETTER_SADHE	    0x108F1
#define Z_UNICODE_HATRAN_LETTER_QOPH	    0x108F2
#define Z_UNICODE_HATRAN_LETTER_SHIN	    0x108F4
#define Z_UNICODE_HATRAN_LETTER_TAW	    0x108F5
#define Z_UNICODE_HATRAN_NUMBER_ONE	    0x108FB
#define Z_UNICODE_HATRAN_NUMBER_FIVE	    0x108FC
#define Z_UNICODE_HATRAN_NUMBER_TEN	    0x108FD
#define Z_UNICODE_HATRAN_NUMBER_TWENTY	    0x108FE
#define Z_UNICODE_HATRAN_NUMBER_ONE_HUNDRED 0x108FF

/* MARK: - 10900h-1091Fh - Phoenician */

#define Z_UNICODE_PHOENICIAN_LETTER_ALF		0x10900
#define Z_UNICODE_PHOENICIAN_LETTER_BET		0x10901
#define Z_UNICODE_PHOENICIAN_LETTER_GAML	0x10902
#define Z_UNICODE_PHOENICIAN_LETTER_DELT	0x10903
#define Z_UNICODE_PHOENICIAN_LETTER_HE		0x10904
#define Z_UNICODE_PHOENICIAN_LETTER_WAU		0x10905
#define Z_UNICODE_PHOENICIAN_LETTER_ZAI		0x10906
#define Z_UNICODE_PHOENICIAN_LETTER_HET		0x10907
#define Z_UNICODE_PHOENICIAN_LETTER_TET		0x10908
#define Z_UNICODE_PHOENICIAN_LETTER_YOD		0x10909
#define Z_UNICODE_PHOENICIAN_LETTER_KAF		0x1090A
#define Z_UNICODE_PHOENICIAN_LETTER_LAMD	0x1090B
#define Z_UNICODE_PHOENICIAN_LETTER_MEM		0x1090C
#define Z_UNICODE_PHOENICIAN_LETTER_NUN		0x1090D
#define Z_UNICODE_PHOENICIAN_LETTER_SEMK	0x1090E
#define Z_UNICODE_PHOENICIAN_LETTER_AIN		0x1090F
#define Z_UNICODE_PHOENICIAN_LETTER_PE		0x10910
#define Z_UNICODE_PHOENICIAN_LETTER_SADE	0x10911
#define Z_UNICODE_PHOENICIAN_LETTER_QOF		0x10912
#define Z_UNICODE_PHOENICIAN_LETTER_ROSH	0x10913
#define Z_UNICODE_PHOENICIAN_LETTER_SHIN	0x10914
#define Z_UNICODE_PHOENICIAN_LETTER_TAU		0x10915
#define Z_UNICODE_PHOENICIAN_NUMBER_ONE		0x10916
#define Z_UNICODE_PHOENICIAN_NUMBER_TEN		0x10917
#define Z_UNICODE_PHOENICIAN_NUMBER_TWENTY	0x10918
#define Z_UNICODE_PHOENICIAN_NUMBER_ONE_HUNDRED	0x10919
#define Z_UNICODE_PHOENICIAN_NUMBER_TWO		0x1091A
#define Z_UNICODE_PHOENICIAN_NUMBER_THREE	0x1091B
#define Z_UNICODE_PHOENICIAN_WORD_SEPARATOR	0x1091F

/* MARK: - 10920h-1093Fh - Lydian */

#define Z_UNICODE_LYDIAN_LETTER_A	 0x10920
#define Z_UNICODE_LYDIAN_LETTER_B	 0x10921
#define Z_UNICODE_LYDIAN_LETTER_G	 0x10922
#define Z_UNICODE_LYDIAN_LETTER_D	 0x10923
#define Z_UNICODE_LYDIAN_LETTER_E	 0x10924
#define Z_UNICODE_LYDIAN_LETTER_V	 0x10925
#define Z_UNICODE_LYDIAN_LETTER_I	 0x10926
#define Z_UNICODE_LYDIAN_LETTER_Y	 0x10927
#define Z_UNICODE_LYDIAN_LETTER_K	 0x10928
#define Z_UNICODE_LYDIAN_LETTER_L	 0x10929
#define Z_UNICODE_LYDIAN_LETTER_M	 0x1092A
#define Z_UNICODE_LYDIAN_LETTER_N	 0x1092B
#define Z_UNICODE_LYDIAN_LETTER_O	 0x1092C
#define Z_UNICODE_LYDIAN_LETTER_R	 0x1092D
#define Z_UNICODE_LYDIAN_LETTER_SS	 0x1092E
#define Z_UNICODE_LYDIAN_LETTER_T	 0x1092F
#define Z_UNICODE_LYDIAN_LETTER_U	 0x10930
#define Z_UNICODE_LYDIAN_LETTER_F	 0x10931
#define Z_UNICODE_LYDIAN_LETTER_Q	 0x10932
#define Z_UNICODE_LYDIAN_LETTER_S	 0x10933
#define Z_UNICODE_LYDIAN_LETTER_TT	 0x10934
#define Z_UNICODE_LYDIAN_LETTER_AN	 0x10935
#define Z_UNICODE_LYDIAN_LETTER_EN	 0x10936
#define Z_UNICODE_LYDIAN_LETTER_LY	 0x10937
#define Z_UNICODE_LYDIAN_LETTER_NN	 0x10938
#define Z_UNICODE_LYDIAN_LETTER_C	 0x10939
#define Z_UNICODE_LYDIAN_TRIANGULAR_MARK 0x1093F

/* MARK: - 10980h-1099Fh - Meroitic Hieroglyphs */

#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_A      0x10980
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_E      0x10981
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_I      0x10982
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_O      0x10983
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_YA     0x10984
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_WA     0x10985
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_BA     0x10986
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_BA_2   0x10987
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_PA     0x10988
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_MA     0x10989
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_NA     0x1098A
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_NA_2   0x1098B
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_NE     0x1098C
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_NE_2   0x1098D
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_RA     0x1098E
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_RA_2   0x1098F
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_LA     0x10990
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_KHA    0x10991
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_HHA    0x10992
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_SA     0x10993
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_SA_2   0x10994
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_SE     0x10995
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_KA     0x10996
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_QA     0x10997
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_TA     0x10998
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_TA_2   0x10999
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_TE     0x1099A
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_TE_2   0x1099B
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_TO     0x1099C
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_LETTER_DA     0x1099D
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_SYMBOL_VIDJ   0x1099E
#define Z_UNICODE_MEROITIC_HIEROGLYPHIC_SYMBOL_VIDJ_2 0x1099F

/* MARK: - 109A0h-109FFh - Meroitic Cursive */

#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_A			 0x109A0
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_E			 0x109A1
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_I			 0x109A2
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_O			 0x109A3
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_YA			 0x109A4
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_WA			 0x109A5
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_BA			 0x109A6
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_PA			 0x109A7
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_MA			 0x109A8
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_NA			 0x109A9
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_NE			 0x109AA
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_RA			 0x109AB
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_LA			 0x109AC
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_KHA			 0x109AD
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_HHA			 0x109AE
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_SA			 0x109AF
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_ARCHAIC_SA		 0x109B0
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_SE			 0x109B1
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_KA			 0x109B2
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_QA			 0x109B3
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_TA			 0x109B4
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_TE			 0x109B5
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_TO			 0x109B6
#define Z_UNICODE_MEROITIC_CURSIVE_LETTER_DA			 0x109B7
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_ELEVEN_TWELFTHS	 0x109BC
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_ONE_HALF		 0x109BD
#define Z_UNICODE_MEROITIC_CURSIVE_LOGOGRAM_RMT			 0x109BE
#define Z_UNICODE_MEROITIC_CURSIVE_LOGOGRAM_IMN			 0x109BF
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_ONE			 0x109C0
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_TWO			 0x109C1
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_THREE			 0x109C2
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FOUR			 0x109C3
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FIVE			 0x109C4
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SIX			 0x109C5
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SEVEN			 0x109C6
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_EIGHT			 0x109C7
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_NINE			 0x109C8
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_TEN			 0x109C9
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_TWENTY		 0x109CA
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_THIRTY		 0x109CB
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FORTY			 0x109CC
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FIFTY			 0x109CD
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SIXTY			 0x109CE
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SEVENTY		 0x109CF
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_ONE_HUNDRED		 0x109D2
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_TWO_HUNDRED		 0x109D3
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_THREE_HUNDRED		 0x109D4
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FOUR_HUNDRED		 0x109D5
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FIVE_HUNDRED		 0x109D6
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SIX_HUNDRED		 0x109D7
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SEVEN_HUNDRED		 0x109D8
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_EIGHT_HUNDRED		 0x109D9
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_NINE_HUNDRED		 0x109DA
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_ONE_THOUSAND		 0x109DB
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_TWO_THOUSAND		 0x109DC
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_THREE_THOUSAND	 0x109DD
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FOUR_THOUSAND		 0x109DE
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FIVE_THOUSAND		 0x109DF
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SIX_THOUSAND		 0x109E0
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SEVEN_THOUSAND	 0x109E1
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_EIGHT_THOUSAND	 0x109E2
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_NINE_THOUSAND		 0x109E3
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_TEN_THOUSAND		 0x109E4
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_TWENTY_THOUSAND	 0x109E5
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_THIRTY_THOUSAND	 0x109E6
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FORTY_THOUSAND	 0x109E7
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FIFTY_THOUSAND	 0x109E8
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SIXTY_THOUSAND	 0x109E9
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SEVENTY_THOUSAND	 0x109EA
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_EIGHTY_THOUSAND	 0x109EB
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_NINETY_THOUSAND	 0x109EC
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_ONE_HUNDRED_THOUSAND	 0x109ED
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_TWO_HUNDRED_THOUSAND	 0x109EE
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_THREE_HUNDRED_THOUSAND 0x109EF
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FOUR_HUNDRED_THOUSAND	 0x109F0
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_FIVE_HUNDRED_THOUSAND	 0x109F1
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SIX_HUNDRED_THOUSAND	 0x109F2
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_SEVEN_HUNDRED_THOUSAND 0x109F3
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_EIGHT_HUNDRED_THOUSAND 0x109F4
#define Z_UNICODE_MEROITIC_CURSIVE_NUMBER_NINE_HUNDRED_THOUSAND	 0x109F5
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_ONE_TWELFTH		 0x109F6
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_TWO_TWELFTHS	 0x109F7
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_THREE_TWELFTHS	 0x109F8
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_FOUR_TWELFTHS	 0x109F9
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_FIVE_TWELFTHS	 0x109FA
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_SIX_TWELFTHS	 0x109FB
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_SEVEN_TWELFTHS	 0x109FC
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_EIGHT_TWELFTHS	 0x109FD
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_NINE_TWELFTHS	 0x109FE
#define Z_UNICODE_MEROITIC_CURSIVE_FRACTION_TEN_TWELFTHS	 0x109FF

/* MARK: - 10A00h-10A5Fh - Kharoshthi */

#define Z_UNICODE_KHAROSHTHI_LETTER_A		      0x10A00
#define Z_UNICODE_KHAROSHTHI_VOWEL_SIGN_I	      0x10A01
#define Z_UNICODE_KHAROSHTHI_VOWEL_SIGN_U	      0x10A02
#define Z_UNICODE_KHAROSHTHI_VOWEL_SIGN_VOCALIC_R     0x10A03
#define Z_UNICODE_KHAROSHTHI_VOWEL_SIGN_E	      0x10A05
#define Z_UNICODE_KHAROSHTHI_VOWEL_SIGN_O	      0x10A06
#define Z_UNICODE_KHAROSHTHI_VOWEL_LENGTH_MARK	      0x10A0C
#define Z_UNICODE_KHAROSHTHI_SIGN_DOUBLE_RING_BELOW   0x10A0D
#define Z_UNICODE_KHAROSHTHI_SIGN_ANUSVARA	      0x10A0E
#define Z_UNICODE_KHAROSHTHI_SIGN_VISARGA	      0x10A0F
#define Z_UNICODE_KHAROSHTHI_LETTER_KA		      0x10A10
#define Z_UNICODE_KHAROSHTHI_LETTER_KHA		      0x10A11
#define Z_UNICODE_KHAROSHTHI_LETTER_GA		      0x10A12
#define Z_UNICODE_KHAROSHTHI_LETTER_GHA		      0x10A13
#define Z_UNICODE_KHAROSHTHI_LETTER_CA		      0x10A15
#define Z_UNICODE_KHAROSHTHI_LETTER_CHA		      0x10A16
#define Z_UNICODE_KHAROSHTHI_LETTER_JA		      0x10A17
#define Z_UNICODE_KHAROSHTHI_LETTER_NYA		      0x10A19
#define Z_UNICODE_KHAROSHTHI_LETTER_TTA		      0x10A1A
#define Z_UNICODE_KHAROSHTHI_LETTER_TTHA	      0x10A1B
#define Z_UNICODE_KHAROSHTHI_LETTER_DDA		      0x10A1C
#define Z_UNICODE_KHAROSHTHI_LETTER_DDHA	      0x10A1D
#define Z_UNICODE_KHAROSHTHI_LETTER_NNA		      0x10A1E
#define Z_UNICODE_KHAROSHTHI_LETTER_TA		      0x10A1F
#define Z_UNICODE_KHAROSHTHI_LETTER_THA		      0x10A20
#define Z_UNICODE_KHAROSHTHI_LETTER_DA		      0x10A21
#define Z_UNICODE_KHAROSHTHI_LETTER_DHA		      0x10A22
#define Z_UNICODE_KHAROSHTHI_LETTER_NA		      0x10A23
#define Z_UNICODE_KHAROSHTHI_LETTER_PA		      0x10A24
#define Z_UNICODE_KHAROSHTHI_LETTER_PHA		      0x10A25
#define Z_UNICODE_KHAROSHTHI_LETTER_BA		      0x10A26
#define Z_UNICODE_KHAROSHTHI_LETTER_BHA		      0x10A27
#define Z_UNICODE_KHAROSHTHI_LETTER_MA		      0x10A28
#define Z_UNICODE_KHAROSHTHI_LETTER_YA		      0x10A29
#define Z_UNICODE_KHAROSHTHI_LETTER_RA		      0x10A2A
#define Z_UNICODE_KHAROSHTHI_LETTER_LA		      0x10A2B
#define Z_UNICODE_KHAROSHTHI_LETTER_VA		      0x10A2C
#define Z_UNICODE_KHAROSHTHI_LETTER_SHA		      0x10A2D
#define Z_UNICODE_KHAROSHTHI_LETTER_SSA		      0x10A2E
#define Z_UNICODE_KHAROSHTHI_LETTER_SA		      0x10A2F
#define Z_UNICODE_KHAROSHTHI_LETTER_ZA		      0x10A30
#define Z_UNICODE_KHAROSHTHI_LETTER_HA		      0x10A31
#define Z_UNICODE_KHAROSHTHI_LETTER_KKA		      0x10A32
#define Z_UNICODE_KHAROSHTHI_LETTER_TTTHA	      0x10A33
#define Z_UNICODE_KHAROSHTHI_SIGN_BAR_ABOVE	      0x10A38
#define Z_UNICODE_KHAROSHTHI_SIGN_CAUDA		      0x10A39
#define Z_UNICODE_KHAROSHTHI_SIGN_DOT_BELOW	      0x10A3A
#define Z_UNICODE_KHAROSHTHI_VIRAMA		      0x10A3F
#define Z_UNICODE_KHAROSHTHI_DIGIT_ONE		      0x10A40
#define Z_UNICODE_KHAROSHTHI_DIGIT_TWO		      0x10A41
#define Z_UNICODE_KHAROSHTHI_DIGIT_THREE	      0x10A42
#define Z_UNICODE_KHAROSHTHI_DIGIT_FOUR		      0x10A43
#define Z_UNICODE_KHAROSHTHI_NUMBER_TEN		      0x10A44
#define Z_UNICODE_KHAROSHTHI_NUMBER_TWENTY	      0x10A45
#define Z_UNICODE_KHAROSHTHI_NUMBER_ONE_HUNDRED	      0x10A46
#define Z_UNICODE_KHAROSHTHI_NUMBER_ONE_THOUSAND      0x10A47
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_DOT	      0x10A50
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_SMALL_CIRCLE 0x10A51
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_CIRCLE	      0x10A52
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_CRESCENT_BAR 0x10A53
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_MANGALAM     0x10A54
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_LOTUS	      0x10A55
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_DANDA	      0x10A56
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_DOUBLE_DANDA 0x10A57
#define Z_UNICODE_KHAROSHTHI_PUNCTUATION_LINES	      0x10A58

/* MARK: - 10A60h-10A7Fh - Old South Arabian */

#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_HE	      0x10A60
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_LAMEDH     0x10A61
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_HETH	      0x10A62
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_MEM	      0x10A63
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_QOPH	      0x10A64
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_WAW	      0x10A65
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_SHIN	      0x10A66
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_RESH	      0x10A67
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_BETH	      0x10A68
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_TAW	      0x10A69
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_SAT	      0x10A6A
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_KAPH	      0x10A6B
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_NUN	      0x10A6C
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_KHETH      0x10A6D
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_SADHE      0x10A6E
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_SAMEKH     0x10A6F
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_FE	      0x10A70
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_ALEF	      0x10A71
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_AYN	      0x10A72
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_DHADHE     0x10A73
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_GIMEL      0x10A74
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_DALETH     0x10A75
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_GHAYN      0x10A76
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_TETH	      0x10A77
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_ZAYN	      0x10A78
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_DHALETH    0x10A79
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_YODH	      0x10A7A
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_THAW	      0x10A7B
#define Z_UNICODE_OLD_SOUTH_ARABIAN_LETTER_THETH      0x10A7C
#define Z_UNICODE_OLD_SOUTH_ARABIAN_NUMBER_ONE	      0x10A7D
#define Z_UNICODE_OLD_SOUTH_ARABIAN_NUMBER_FIFTY      0x10A7E
#define Z_UNICODE_OLD_SOUTH_ARABIAN_NUMERIC_INDICATOR 0x10A7F

/* MARK: - 10A80h-10A9Fh - Old North Arabian */

#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_HEH	  0x10A80
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_LAM	  0x10A81
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_HAH	  0x10A82
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_MEEM	  0x10A83
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_QAF	  0x10A84
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_WAW	  0x10A85
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_ES_2	  0x10A86
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_REH	  0x10A87
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_BEH	  0x10A88
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_TEH	  0x10A89
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_ES_1	  0x10A8A
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_KAF	  0x10A8B
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_NOON	  0x10A8C
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_KHAH	  0x10A8D
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_SAD	  0x10A8E
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_ES_3	  0x10A8F
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_FEH	  0x10A90
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_ALEF	  0x10A91
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_AIN	  0x10A92
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_DAD	  0x10A93
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_GEEM	  0x10A94
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_DAL	  0x10A95
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_GHAIN  0x10A96
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_TAH	  0x10A97
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_ZAIN	  0x10A98
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_THAL	  0x10A99
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_YEH	  0x10A9A
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_THEH	  0x10A9B
#define Z_UNICODE_OLD_NORTH_ARABIAN_LETTER_ZAH	  0x10A9C
#define Z_UNICODE_OLD_NORTH_ARABIAN_NUMBER_ONE	  0x10A9D
#define Z_UNICODE_OLD_NORTH_ARABIAN_NUMBER_TEN	  0x10A9E
#define Z_UNICODE_OLD_NORTH_ARABIAN_NUMBER_TWENTY 0x10A9F

/* MARK: - 10AC0h-10AFFh - Manichaean */

#define Z_UNICODE_MANICHAEAN_LETTER_ALEPH		       0x10AC0
#define Z_UNICODE_MANICHAEAN_LETTER_BETH		       0x10AC1
#define Z_UNICODE_MANICHAEAN_LETTER_BHETH		       0x10AC2
#define Z_UNICODE_MANICHAEAN_LETTER_GIMEL		       0x10AC3
#define Z_UNICODE_MANICHAEAN_LETTER_GHIMEL		       0x10AC4
#define Z_UNICODE_MANICHAEAN_LETTER_DALETH		       0x10AC5
#define Z_UNICODE_MANICHAEAN_LETTER_HE			       0x10AC6
#define Z_UNICODE_MANICHAEAN_LETTER_WAW			       0x10AC7
#define Z_UNICODE_MANICHAEAN_SIGN_UD			       0x10AC8
#define Z_UNICODE_MANICHAEAN_LETTER_ZAYIN		       0x10AC9
#define Z_UNICODE_MANICHAEAN_LETTER_ZHAYIN		       0x10ACA
#define Z_UNICODE_MANICHAEAN_LETTER_JAYIN		       0x10ACB
#define Z_UNICODE_MANICHAEAN_LETTER_JHAYIN		       0x10ACC
#define Z_UNICODE_MANICHAEAN_LETTER_HETH		       0x10ACD
#define Z_UNICODE_MANICHAEAN_LETTER_TETH		       0x10ACE
#define Z_UNICODE_MANICHAEAN_LETTER_YODH		       0x10ACF
#define Z_UNICODE_MANICHAEAN_LETTER_KAPH		       0x10AD0
#define Z_UNICODE_MANICHAEAN_LETTER_XAPH		       0x10AD1
#define Z_UNICODE_MANICHAEAN_LETTER_KHAPH		       0x10AD2
#define Z_UNICODE_MANICHAEAN_LETTER_LAMEDH		       0x10AD3
#define Z_UNICODE_MANICHAEAN_LETTER_DHAMEDH		       0x10AD4
#define Z_UNICODE_MANICHAEAN_LETTER_THAMEDH		       0x10AD5
#define Z_UNICODE_MANICHAEAN_LETTER_MEM			       0x10AD6
#define Z_UNICODE_MANICHAEAN_LETTER_NUN			       0x10AD7
#define Z_UNICODE_MANICHAEAN_LETTER_SAMEKH		       0x10AD8
#define Z_UNICODE_MANICHAEAN_LETTER_AYIN		       0x10AD9
#define Z_UNICODE_MANICHAEAN_LETTER_AAYIN		       0x10ADA
#define Z_UNICODE_MANICHAEAN_LETTER_PE			       0x10ADB
#define Z_UNICODE_MANICHAEAN_LETTER_FE			       0x10ADC
#define Z_UNICODE_MANICHAEAN_LETTER_SADHE		       0x10ADD
#define Z_UNICODE_MANICHAEAN_LETTER_QOPH		       0x10ADE
#define Z_UNICODE_MANICHAEAN_LETTER_XOPH		       0x10ADF
#define Z_UNICODE_MANICHAEAN_LETTER_QHOPH		       0x10AE0
#define Z_UNICODE_MANICHAEAN_LETTER_RESH		       0x10AE1
#define Z_UNICODE_MANICHAEAN_LETTER_SHIN		       0x10AE2
#define Z_UNICODE_MANICHAEAN_LETTER_SSHIN		       0x10AE3
#define Z_UNICODE_MANICHAEAN_LETTER_TAW			       0x10AE4
#define Z_UNICODE_MANICHAEAN_ABBREVIATION_MARK_ABOVE	       0x10AE5
#define Z_UNICODE_MANICHAEAN_ABBREVIATION_MARK_BELOW	       0x10AE6
#define Z_UNICODE_MANICHAEAN_NUMBER_ONE			       0x10AEB
#define Z_UNICODE_MANICHAEAN_NUMBER_FIVE		       0x10AEC
#define Z_UNICODE_MANICHAEAN_NUMBER_TEN			       0x10AED
#define Z_UNICODE_MANICHAEAN_NUMBER_TWENTY		       0x10AEE
#define Z_UNICODE_MANICHAEAN_NUMBER_ONE_HUNDRED		       0x10AEF
#define Z_UNICODE_MANICHAEAN_PUNCTUATION_STAR		       0x10AF0
#define Z_UNICODE_MANICHAEAN_PUNCTUATION_FLEURON	       0x10AF1
#define Z_UNICODE_MANICHAEAN_PUNCTUATION_DOUBLE_DOT_WITHIN_DOT 0x10AF2
#define Z_UNICODE_MANICHAEAN_PUNCTUATION_DOT_WITHIN_DOT	       0x10AF3
#define Z_UNICODE_MANICHAEAN_PUNCTUATION_DOT		       0x10AF4
#define Z_UNICODE_MANICHAEAN_PUNCTUATION_TWO_DOTS	       0x10AF5
#define Z_UNICODE_MANICHAEAN_PUNCTUATION_LINE_FILLER	       0x10AF6

/* MARK: - 10B00h-10B3Fh - Avestan */

#define Z_UNICODE_AVESTAN_LETTER_A			    0x10B00
#define Z_UNICODE_AVESTAN_LETTER_AA			    0x10B01
#define Z_UNICODE_AVESTAN_LETTER_AO			    0x10B02
#define Z_UNICODE_AVESTAN_LETTER_AAO			    0x10B03
#define Z_UNICODE_AVESTAN_LETTER_AN			    0x10B04
#define Z_UNICODE_AVESTAN_LETTER_AAN			    0x10B05
#define Z_UNICODE_AVESTAN_LETTER_AE			    0x10B06
#define Z_UNICODE_AVESTAN_LETTER_AEE			    0x10B07
#define Z_UNICODE_AVESTAN_LETTER_E			    0x10B08
#define Z_UNICODE_AVESTAN_LETTER_EE			    0x10B09
#define Z_UNICODE_AVESTAN_LETTER_O			    0x10B0A
#define Z_UNICODE_AVESTAN_LETTER_OO			    0x10B0B
#define Z_UNICODE_AVESTAN_LETTER_I			    0x10B0C
#define Z_UNICODE_AVESTAN_LETTER_II			    0x10B0D
#define Z_UNICODE_AVESTAN_LETTER_U			    0x10B0E
#define Z_UNICODE_AVESTAN_LETTER_UU			    0x10B0F
#define Z_UNICODE_AVESTAN_LETTER_KE			    0x10B10
#define Z_UNICODE_AVESTAN_LETTER_XE			    0x10B11
#define Z_UNICODE_AVESTAN_LETTER_XYE			    0x10B12
#define Z_UNICODE_AVESTAN_LETTER_XVE			    0x10B13
#define Z_UNICODE_AVESTAN_LETTER_GE			    0x10B14
#define Z_UNICODE_AVESTAN_LETTER_GGE			    0x10B15
#define Z_UNICODE_AVESTAN_LETTER_GHE			    0x10B16
#define Z_UNICODE_AVESTAN_LETTER_CE			    0x10B17
#define Z_UNICODE_AVESTAN_LETTER_JE			    0x10B18
#define Z_UNICODE_AVESTAN_LETTER_TE			    0x10B19
#define Z_UNICODE_AVESTAN_LETTER_THE			    0x10B1A
#define Z_UNICODE_AVESTAN_LETTER_DE			    0x10B1B
#define Z_UNICODE_AVESTAN_LETTER_DHE			    0x10B1C
#define Z_UNICODE_AVESTAN_LETTER_TTE			    0x10B1D
#define Z_UNICODE_AVESTAN_LETTER_PE			    0x10B1E
#define Z_UNICODE_AVESTAN_LETTER_FE			    0x10B1F
#define Z_UNICODE_AVESTAN_LETTER_BE			    0x10B20
#define Z_UNICODE_AVESTAN_LETTER_BHE			    0x10B21
#define Z_UNICODE_AVESTAN_LETTER_NGE			    0x10B22
#define Z_UNICODE_AVESTAN_LETTER_NGYE			    0x10B23
#define Z_UNICODE_AVESTAN_LETTER_NGVE			    0x10B24
#define Z_UNICODE_AVESTAN_LETTER_NE			    0x10B25
#define Z_UNICODE_AVESTAN_LETTER_NYE			    0x10B26
#define Z_UNICODE_AVESTAN_LETTER_NNE			    0x10B27
#define Z_UNICODE_AVESTAN_LETTER_ME			    0x10B28
#define Z_UNICODE_AVESTAN_LETTER_HME			    0x10B29
#define Z_UNICODE_AVESTAN_LETTER_YYE			    0x10B2A
#define Z_UNICODE_AVESTAN_LETTER_YE			    0x10B2B
#define Z_UNICODE_AVESTAN_LETTER_VE			    0x10B2C
#define Z_UNICODE_AVESTAN_LETTER_RE			    0x10B2D
#define Z_UNICODE_AVESTAN_LETTER_LE			    0x10B2E
#define Z_UNICODE_AVESTAN_LETTER_SE			    0x10B2F
#define Z_UNICODE_AVESTAN_LETTER_ZE			    0x10B30
#define Z_UNICODE_AVESTAN_LETTER_SHE			    0x10B31
#define Z_UNICODE_AVESTAN_LETTER_ZHE			    0x10B32
#define Z_UNICODE_AVESTAN_LETTER_SHYE			    0x10B33
#define Z_UNICODE_AVESTAN_LETTER_SSHE			    0x10B34
#define Z_UNICODE_AVESTAN_LETTER_HE			    0x10B35
#define Z_UNICODE_AVESTAN_ABBREVIATION_MARK		    0x10B39
#define Z_UNICODE_TINY_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION    0x10B3A
#define Z_UNICODE_SMALL_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION   0x10B3B
#define Z_UNICODE_LARGE_TWO_DOTS_OVER_ONE_DOT_PUNCTUATION   0x10B3C
#define Z_UNICODE_LARGE_ONE_DOT_OVER_TWO_DOTS_PUNCTUATION   0x10B3D
#define Z_UNICODE_LARGE_TWO_RINGS_OVER_ONE_RING_PUNCTUATION 0x10B3E
#define Z_UNICODE_LARGE_ONE_RING_OVER_TWO_RINGS_PUNCTUATION 0x10B3F

/* MARK: - 10B40h-10B5Fh - Inscriptional Parthian */

#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_ALEPH	     0x10B40
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_BETH	     0x10B41
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_GIMEL	     0x10B42
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_DALETH	     0x10B43
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_HE	     0x10B44
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_WAW	     0x10B45
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_ZAYIN	     0x10B46
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_HETH	     0x10B47
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_TETH	     0x10B48
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_YODH	     0x10B49
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_KAPH	     0x10B4A
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_LAMEDH	     0x10B4B
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_MEM	     0x10B4C
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_NUN	     0x10B4D
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_SAMEKH	     0x10B4E
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_AYIN	     0x10B4F
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_PE	     0x10B50
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_SADHE	     0x10B51
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_QOPH	     0x10B52
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_RESH	     0x10B53
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_SHIN	     0x10B54
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_LETTER_TAW	     0x10B55
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_NUMBER_ONE	     0x10B58
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_NUMBER_TWO	     0x10B59
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_NUMBER_THREE	     0x10B5A
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_NUMBER_FOUR	     0x10B5B
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_NUMBER_TEN	     0x10B5C
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_NUMBER_TWENTY	     0x10B5D
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_NUMBER_ONE_HUNDRED  0x10B5E
#define Z_UNICODE_INSCRIPTIONAL_PARTHIAN_NUMBER_ONE_THOUSAND 0x10B5F

/* MARK: - 10B60h-10B7Fh - Inscriptional Pahlavi */

#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_ALEPH	     0x10B60
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_BETH	     0x10B61
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_GIMEL	     0x10B62
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_DALETH	     0x10B63
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_HE	     0x10B64
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_WAW_AYIN_RESH 0x10B65
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_ZAYIN	     0x10B66
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_HETH	     0x10B67
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_TETH	     0x10B68
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_YODH	     0x10B69
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_KAPH	     0x10B6A
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_LAMEDH	     0x10B6B
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_MEM_QOPH	     0x10B6C
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_NUN	     0x10B6D
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_SAMEKH	     0x10B6E
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_PE	     0x10B6F
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_SADHE	     0x10B70
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_SHIN	     0x10B71
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_LETTER_TAW	     0x10B72
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_NUMBER_ONE	     0x10B78
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_NUMBER_TWO	     0x10B79
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_NUMBER_THREE	     0x10B7A
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_NUMBER_FOUR	     0x10B7B
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_NUMBER_TEN	     0x10B7C
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_NUMBER_TWENTY	     0x10B7D
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_NUMBER_ONE_HUNDRED   0x10B7E
#define Z_UNICODE_INSCRIPTIONAL_PAHLAVI_NUMBER_ONE_THOUSAND  0x10B7F

/* MARK: - 10B80h-10BAFh - Psalter Pahlavi */

#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_ALEPH	       0x10B80
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_BETH	       0x10B81
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_GIMEL	       0x10B82
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_DALETH	       0x10B83
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_HE	       0x10B84
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_WAW_AYIN_RESH 0x10B85
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_ZAYIN	       0x10B86
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_HETH	       0x10B87
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_YODH	       0x10B88
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_KAPH	       0x10B89
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_LAMEDH	       0x10B8A
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_MEM_QOPH      0x10B8B
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_NUN	       0x10B8C
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_SAMEKH	       0x10B8D
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_PE	       0x10B8E
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_SADHE	       0x10B8F
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_SHIN	       0x10B90
#define Z_UNICODE_PSALTER_PAHLAVI_LETTER_TAW	       0x10B91
#define Z_UNICODE_PSALTER_PAHLAVI_SECTION_MARK	       0x10B99
#define Z_UNICODE_PSALTER_PAHLAVI_TURNED_SECTION_MARK  0x10B9A
#define Z_UNICODE_PSALTER_PAHLAVI_FOUR_DOTS_WITH_CROSS 0x10B9B
#define Z_UNICODE_PSALTER_PAHLAVI_FOUR_DOTS_WITH_DOT   0x10B9C
#define Z_UNICODE_PSALTER_PAHLAVI_NUMBER_ONE	       0x10BA9
#define Z_UNICODE_PSALTER_PAHLAVI_NUMBER_TWO	       0x10BAA
#define Z_UNICODE_PSALTER_PAHLAVI_NUMBER_THREE	       0x10BAB
#define Z_UNICODE_PSALTER_PAHLAVI_NUMBER_FOUR	       0x10BAC
#define Z_UNICODE_PSALTER_PAHLAVI_NUMBER_TEN	       0x10BAD
#define Z_UNICODE_PSALTER_PAHLAVI_NUMBER_TWENTY	       0x10BAE
#define Z_UNICODE_PSALTER_PAHLAVI_NUMBER_ONE_HUNDRED   0x10BAF

/* MARK: - 10C00h-10C4Fh - Old Turkic */

#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_A	 0x10C00
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_A	 0x10C01
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AE	 0x10C02
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_I	 0x10C03
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_I	 0x10C04
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_E	 0x10C05
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_O	 0x10C06
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_OE	 0x10C07
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_OE	 0x10C08
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AB	 0x10C09
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AB	 0x10C0A
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AEB	 0x10C0B
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AEB	 0x10C0C
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AG	 0x10C0D
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AG	 0x10C0E
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AEG	 0x10C0F
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AEG	 0x10C10
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AD	 0x10C11
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AD	 0x10C12
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AED	 0x10C13
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_EZ	 0x10C14
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_EZ	 0x10C15
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AY	 0x10C16
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AY	 0x10C17
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AEY	 0x10C18
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AEY	 0x10C19
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AEK	 0x10C1A
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AEK	 0x10C1B
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_OEK	 0x10C1C
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_OEK	 0x10C1D
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AL	 0x10C1E
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AL	 0x10C1F
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AEL	 0x10C20
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_ELT	 0x10C21
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_EM	 0x10C22
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AN	 0x10C23
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AEN	 0x10C24
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AEN	 0x10C25
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_ENT	 0x10C26
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_ENT	 0x10C27
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_ENC	 0x10C28
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_ENC	 0x10C29
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_ENY	 0x10C2A
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_ENY	 0x10C2B
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_ANG	 0x10C2C
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_ENG	 0x10C2D
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AENG 0x10C2E
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_EP	 0x10C2F
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_OP	 0x10C30
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_IC	 0x10C31
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_EC	 0x10C32
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_EC	 0x10C33
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AQ	 0x10C34
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AQ	 0x10C35
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_IQ	 0x10C36
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_IQ	 0x10C37
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_OQ	 0x10C38
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_OQ	 0x10C39
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AR	 0x10C3A
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AR	 0x10C3B
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AER	 0x10C3C
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AS	 0x10C3D
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AES	 0x10C3E
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_ASH	 0x10C3F
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_ASH	 0x10C40
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_ESH	 0x10C41
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_ESH	 0x10C42
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AT	 0x10C43
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AT	 0x10C44
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_AET	 0x10C45
#define Z_UNICODE_OLD_TURKIC_LETTER_YENISEI_AET	 0x10C46
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_OT	 0x10C47
#define Z_UNICODE_OLD_TURKIC_LETTER_ORKHON_BASH	 0x10C48

/* MARK: - 10C80h-10CFFh - Old Hungarian */

#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_A	       0x10C80
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_AA	       0x10C81
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EB	       0x10C82
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_AMB	       0x10C83
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EC	       0x10C84
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ENC	       0x10C85
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ECS	       0x10C86
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ED	       0x10C87
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_AND	       0x10C88
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_E	       0x10C89
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_CLOSE_E	       0x10C8A
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EE	       0x10C8B
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EF	       0x10C8C
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EG	       0x10C8D
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EGY	       0x10C8E
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EH	       0x10C8F
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_I	       0x10C90
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_II	       0x10C91
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EJ	       0x10C92
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EK	       0x10C93
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_AK	       0x10C94
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_UNK	       0x10C95
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EL	       0x10C96
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ELY	       0x10C97
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EM	       0x10C98
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EN	       0x10C99
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ENY	       0x10C9A
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_O	       0x10C9B
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_OO	       0x10C9C
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_NIKOLSBURG_OE   0x10C9D
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_RUDIMENTA_OE    0x10C9E
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_OEE	       0x10C9F
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EP	       0x10CA0
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EMP	       0x10CA1
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ER	       0x10CA2
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_SHORT_ER	       0x10CA3
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ES	       0x10CA4
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ESZ	       0x10CA5
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ET	       0x10CA6
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ENT	       0x10CA7
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ETY	       0x10CA8
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ECH	       0x10CA9
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_U	       0x10CAA
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_UU	       0x10CAB
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_NIKOLSBURG_UE   0x10CAC
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_RUDIMENTA_UE    0x10CAD
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EV	       0x10CAE
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EZ	       0x10CAF
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_EZS	       0x10CB0
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_ENT_SHAPED_SIGN 0x10CB1
#define Z_UNICODE_OLD_HUNGARIAN_CAPITAL_LETTER_US	       0x10CB2
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_A		       0x10CC0
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_AA		       0x10CC1
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EB		       0x10CC2
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_AMB	       0x10CC3
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EC		       0x10CC4
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ENC	       0x10CC5
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ECS	       0x10CC6
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ED		       0x10CC7
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_AND	       0x10CC8
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_E		       0x10CC9
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_CLOSE_E	       0x10CCA
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EE		       0x10CCB
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EF		       0x10CCC
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EG		       0x10CCD
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EGY	       0x10CCE
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EH		       0x10CCF
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_I		       0x10CD0
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_II		       0x10CD1
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EJ		       0x10CD2
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EK		       0x10CD3
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_AK		       0x10CD4
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_UNK	       0x10CD5
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EL		       0x10CD6
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ELY	       0x10CD7
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EM		       0x10CD8
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EN		       0x10CD9
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ENY	       0x10CDA
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_O		       0x10CDB
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_OO		       0x10CDC
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_NIKOLSBURG_OE     0x10CDD
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_RUDIMENTA_OE      0x10CDE
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_OEE	       0x10CDF
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EP		       0x10CE0
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EMP	       0x10CE1
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ER		       0x10CE2
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_SHORT_ER	       0x10CE3
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ES		       0x10CE4
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ESZ	       0x10CE5
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ET		       0x10CE6
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ENT	       0x10CE7
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ETY	       0x10CE8
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ECH	       0x10CE9
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_U		       0x10CEA
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_UU		       0x10CEB
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_NIKOLSBURG_UE     0x10CEC
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_RUDIMENTA_UE      0x10CED
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EV		       0x10CEE
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EZ		       0x10CEF
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_EZS	       0x10CF0
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_ENT_SHAPED_SIGN   0x10CF1
#define Z_UNICODE_OLD_HUNGARIAN_SMALL_LETTER_US		       0x10CF2
#define Z_UNICODE_OLD_HUNGARIAN_NUMBER_ONE		       0x10CFA
#define Z_UNICODE_OLD_HUNGARIAN_NUMBER_FIVE		       0x10CFB
#define Z_UNICODE_OLD_HUNGARIAN_NUMBER_TEN		       0x10CFC
#define Z_UNICODE_OLD_HUNGARIAN_NUMBER_FIFTY		       0x10CFD
#define Z_UNICODE_OLD_HUNGARIAN_NUMBER_ONE_HUNDRED	       0x10CFE
#define Z_UNICODE_OLD_HUNGARIAN_NUMBER_ONE_THOUSAND	       0x10CFF

/* MARK: - 10E60h-10E7Fh - Rumi Numeral Symbols */

#define Z_UNICODE_RUMI_DIGIT_ONE	    0x10E60
#define Z_UNICODE_RUMI_DIGIT_TWO	    0x10E61
#define Z_UNICODE_RUMI_DIGIT_THREE	    0x10E62
#define Z_UNICODE_RUMI_DIGIT_FOUR	    0x10E63
#define Z_UNICODE_RUMI_DIGIT_FIVE	    0x10E64
#define Z_UNICODE_RUMI_DIGIT_SIX	    0x10E65
#define Z_UNICODE_RUMI_DIGIT_SEVEN	    0x10E66
#define Z_UNICODE_RUMI_DIGIT_EIGHT	    0x10E67
#define Z_UNICODE_RUMI_DIGIT_NINE	    0x10E68
#define Z_UNICODE_RUMI_NUMBER_TEN	    0x10E69
#define Z_UNICODE_RUMI_NUMBER_TWENTY	    0x10E6A
#define Z_UNICODE_RUMI_NUMBER_THIRTY	    0x10E6B
#define Z_UNICODE_RUMI_NUMBER_FORTY	    0x10E6C
#define Z_UNICODE_RUMI_NUMBER_FIFTY	    0x10E6D
#define Z_UNICODE_RUMI_NUMBER_SIXTY	    0x10E6E
#define Z_UNICODE_RUMI_NUMBER_SEVENTY	    0x10E6F
#define Z_UNICODE_RUMI_NUMBER_EIGHTY	    0x10E70
#define Z_UNICODE_RUMI_NUMBER_NINETY	    0x10E71
#define Z_UNICODE_RUMI_NUMBER_ONE_HUNDRED   0x10E72
#define Z_UNICODE_RUMI_NUMBER_TWO_HUNDRED   0x10E73
#define Z_UNICODE_RUMI_NUMBER_THREE_HUNDRED 0x10E74
#define Z_UNICODE_RUMI_NUMBER_FOUR_HUNDRED  0x10E75
#define Z_UNICODE_RUMI_NUMBER_FIVE_HUNDRED  0x10E76
#define Z_UNICODE_RUMI_NUMBER_SIX_HUNDRED   0x10E77
#define Z_UNICODE_RUMI_NUMBER_SEVEN_HUNDRED 0x10E78
#define Z_UNICODE_RUMI_NUMBER_EIGHT_HUNDRED 0x10E79
#define Z_UNICODE_RUMI_NUMBER_NINE_HUNDRED  0x10E7A
#define Z_UNICODE_RUMI_FRACTION_ONE_HALF    0x10E7B
#define Z_UNICODE_RUMI_FRACTION_ONE_QUARTER 0x10E7C
#define Z_UNICODE_RUMI_FRACTION_ONE_THIRD   0x10E7D
#define Z_UNICODE_RUMI_FRACTION_TWO_THIRDS  0x10E7E

/* MARK: - 11000h-1107Fh - Brahmi */

#define Z_UNICODE_BRAHMI_SIGN_CANDRABINDU	   0x11000
#define Z_UNICODE_BRAHMI_SIGN_ANUSVARA		   0x11001
#define Z_UNICODE_BRAHMI_SIGN_VISARGA		   0x11002
#define Z_UNICODE_BRAHMI_SIGN_JIHVAMULIYA	   0x11003
#define Z_UNICODE_BRAHMI_SIGN_UPADHMANIYA	   0x11004
#define Z_UNICODE_BRAHMI_LETTER_A		   0x11005
#define Z_UNICODE_BRAHMI_LETTER_AA		   0x11006
#define Z_UNICODE_BRAHMI_LETTER_I		   0x11007
#define Z_UNICODE_BRAHMI_LETTER_II		   0x11008
#define Z_UNICODE_BRAHMI_LETTER_U		   0x11009
#define Z_UNICODE_BRAHMI_LETTER_UU		   0x1100A
#define Z_UNICODE_BRAHMI_LETTER_VOCALIC_R	   0x1100B
#define Z_UNICODE_BRAHMI_LETTER_VOCALIC_RR	   0x1100C
#define Z_UNICODE_BRAHMI_LETTER_VOCALIC_L	   0x1100D
#define Z_UNICODE_BRAHMI_LETTER_VOCALIC_LL	   0x1100E
#define Z_UNICODE_BRAHMI_LETTER_E		   0x1100F
#define Z_UNICODE_BRAHMI_LETTER_AI		   0x11010
#define Z_UNICODE_BRAHMI_LETTER_O		   0x11011
#define Z_UNICODE_BRAHMI_LETTER_AU		   0x11012
#define Z_UNICODE_BRAHMI_LETTER_KA		   0x11013
#define Z_UNICODE_BRAHMI_LETTER_KHA		   0x11014
#define Z_UNICODE_BRAHMI_LETTER_GA		   0x11015
#define Z_UNICODE_BRAHMI_LETTER_GHA		   0x11016
#define Z_UNICODE_BRAHMI_LETTER_NGA		   0x11017
#define Z_UNICODE_BRAHMI_LETTER_CA		   0x11018
#define Z_UNICODE_BRAHMI_LETTER_CHA		   0x11019
#define Z_UNICODE_BRAHMI_LETTER_JA		   0x1101A
#define Z_UNICODE_BRAHMI_LETTER_JHA		   0x1101B
#define Z_UNICODE_BRAHMI_LETTER_NYA		   0x1101C
#define Z_UNICODE_BRAHMI_LETTER_TTA		   0x1101D
#define Z_UNICODE_BRAHMI_LETTER_TTHA		   0x1101E
#define Z_UNICODE_BRAHMI_LETTER_DDA		   0x1101F
#define Z_UNICODE_BRAHMI_LETTER_DDHA		   0x11020
#define Z_UNICODE_BRAHMI_LETTER_NNA		   0x11021
#define Z_UNICODE_BRAHMI_LETTER_TA		   0x11022
#define Z_UNICODE_BRAHMI_LETTER_THA		   0x11023
#define Z_UNICODE_BRAHMI_LETTER_DA		   0x11024
#define Z_UNICODE_BRAHMI_LETTER_DHA		   0x11025
#define Z_UNICODE_BRAHMI_LETTER_NA		   0x11026
#define Z_UNICODE_BRAHMI_LETTER_PA		   0x11027
#define Z_UNICODE_BRAHMI_LETTER_PHA		   0x11028
#define Z_UNICODE_BRAHMI_LETTER_BA		   0x11029
#define Z_UNICODE_BRAHMI_LETTER_BHA		   0x1102A
#define Z_UNICODE_BRAHMI_LETTER_MA		   0x1102B
#define Z_UNICODE_BRAHMI_LETTER_YA		   0x1102C
#define Z_UNICODE_BRAHMI_LETTER_RA		   0x1102D
#define Z_UNICODE_BRAHMI_LETTER_LA		   0x1102E
#define Z_UNICODE_BRAHMI_LETTER_VA		   0x1102F
#define Z_UNICODE_BRAHMI_LETTER_SHA		   0x11030
#define Z_UNICODE_BRAHMI_LETTER_SSA		   0x11031
#define Z_UNICODE_BRAHMI_LETTER_SA		   0x11032
#define Z_UNICODE_BRAHMI_LETTER_HA		   0x11033
#define Z_UNICODE_BRAHMI_LETTER_LLA		   0x11034
#define Z_UNICODE_BRAHMI_LETTER_OLD_TAMIL_LLLA	   0x11035
#define Z_UNICODE_BRAHMI_LETTER_OLD_TAMIL_RRA	   0x11036
#define Z_UNICODE_BRAHMI_LETTER_OLD_TAMIL_NNNA	   0x11037
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_AA		   0x11038
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_BHATTIPROLU_AA 0x11039
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_I		   0x1103A
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_II		   0x1103B
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_U		   0x1103C
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_UU		   0x1103D
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_VOCALIC_R	   0x1103E
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_VOCALIC_RR	   0x1103F
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_VOCALIC_L	   0x11040
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_VOCALIC_LL	   0x11041
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_E		   0x11042
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_AI		   0x11043
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_O		   0x11044
#define Z_UNICODE_BRAHMI_VOWEL_SIGN_AU		   0x11045
#define Z_UNICODE_BRAHMI_VIRAMA			   0x11046
#define Z_UNICODE_BRAHMI_DANDA			   0x11047
#define Z_UNICODE_BRAHMI_DOUBLE_DANDA		   0x11048
#define Z_UNICODE_BRAHMI_PUNCTUATION_DOT	   0x11049
#define Z_UNICODE_BRAHMI_PUNCTUATION_DOUBLE_DOT	   0x1104A
#define Z_UNICODE_BRAHMI_PUNCTUATION_LINE	   0x1104B
#define Z_UNICODE_BRAHMI_PUNCTUATION_CRESCENT_BAR  0x1104C
#define Z_UNICODE_BRAHMI_PUNCTUATION_LOTUS	   0x1104D
#define Z_UNICODE_BRAHMI_NUMBER_ONE		   0x11052
#define Z_UNICODE_BRAHMI_NUMBER_TWO		   0x11053
#define Z_UNICODE_BRAHMI_NUMBER_THREE		   0x11054
#define Z_UNICODE_BRAHMI_NUMBER_FOUR		   0x11055
#define Z_UNICODE_BRAHMI_NUMBER_FIVE		   0x11056
#define Z_UNICODE_BRAHMI_NUMBER_SIX		   0x11057
#define Z_UNICODE_BRAHMI_NUMBER_SEVEN		   0x11058
#define Z_UNICODE_BRAHMI_NUMBER_EIGHT		   0x11059
#define Z_UNICODE_BRAHMI_NUMBER_NINE		   0x1105A
#define Z_UNICODE_BRAHMI_NUMBER_TEN		   0x1105B
#define Z_UNICODE_BRAHMI_NUMBER_TWENTY		   0x1105C
#define Z_UNICODE_BRAHMI_NUMBER_THIRTY		   0x1105D
#define Z_UNICODE_BRAHMI_NUMBER_FORTY		   0x1105E
#define Z_UNICODE_BRAHMI_NUMBER_FIFTY		   0x1105F
#define Z_UNICODE_BRAHMI_NUMBER_SIXTY		   0x11060
#define Z_UNICODE_BRAHMI_NUMBER_SEVENTY		   0x11061
#define Z_UNICODE_BRAHMI_NUMBER_EIGHTY		   0x11062
#define Z_UNICODE_BRAHMI_NUMBER_NINETY		   0x11063
#define Z_UNICODE_BRAHMI_NUMBER_ONE_HUNDRED	   0x11064
#define Z_UNICODE_BRAHMI_NUMBER_ONE_THOUSAND	   0x11065
#define Z_UNICODE_BRAHMI_DIGIT_ZERO		   0x11066
#define Z_UNICODE_BRAHMI_DIGIT_ONE		   0x11067
#define Z_UNICODE_BRAHMI_DIGIT_TWO		   0x11068
#define Z_UNICODE_BRAHMI_DIGIT_THREE		   0x11069
#define Z_UNICODE_BRAHMI_DIGIT_FOUR		   0x1106A
#define Z_UNICODE_BRAHMI_DIGIT_FIVE		   0x1106B
#define Z_UNICODE_BRAHMI_DIGIT_SIX		   0x1106C
#define Z_UNICODE_BRAHMI_DIGIT_SEVEN		   0x1106D
#define Z_UNICODE_BRAHMI_DIGIT_EIGHT		   0x1106E
#define Z_UNICODE_BRAHMI_DIGIT_NINE		   0x1106F
#define Z_UNICODE_BRAHMI_NUMBER_JOINER		   0x1107F

/* MARK: - 11080h-110CFh - Kaithi */

#define Z_UNICODE_KAITHI_SIGN_CANDRABINDU    0x11080
#define Z_UNICODE_KAITHI_SIGN_ANUSVARA	     0x11081
#define Z_UNICODE_KAITHI_SIGN_VISARGA	     0x11082
#define Z_UNICODE_KAITHI_LETTER_A	     0x11083
#define Z_UNICODE_KAITHI_LETTER_AA	     0x11084
#define Z_UNICODE_KAITHI_LETTER_I	     0x11085
#define Z_UNICODE_KAITHI_LETTER_II	     0x11086
#define Z_UNICODE_KAITHI_LETTER_U	     0x11087
#define Z_UNICODE_KAITHI_LETTER_UU	     0x11088
#define Z_UNICODE_KAITHI_LETTER_E	     0x11089
#define Z_UNICODE_KAITHI_LETTER_AI	     0x1108A
#define Z_UNICODE_KAITHI_LETTER_O	     0x1108B
#define Z_UNICODE_KAITHI_LETTER_AU	     0x1108C
#define Z_UNICODE_KAITHI_LETTER_KA	     0x1108D
#define Z_UNICODE_KAITHI_LETTER_KHA	     0x1108E
#define Z_UNICODE_KAITHI_LETTER_GA	     0x1108F
#define Z_UNICODE_KAITHI_LETTER_GHA	     0x11090
#define Z_UNICODE_KAITHI_LETTER_NGA	     0x11091
#define Z_UNICODE_KAITHI_LETTER_CA	     0x11092
#define Z_UNICODE_KAITHI_LETTER_CHA	     0x11093
#define Z_UNICODE_KAITHI_LETTER_JA	     0x11094
#define Z_UNICODE_KAITHI_LETTER_JHA	     0x11095
#define Z_UNICODE_KAITHI_LETTER_NYA	     0x11096
#define Z_UNICODE_KAITHI_LETTER_TTA	     0x11097
#define Z_UNICODE_KAITHI_LETTER_TTHA	     0x11098
#define Z_UNICODE_KAITHI_LETTER_DDA	     0x11099
#define Z_UNICODE_KAITHI_LETTER_DDDHA	     0x1109A
#define Z_UNICODE_KAITHI_LETTER_DDHA	     0x1109B
#define Z_UNICODE_KAITHI_LETTER_RHA	     0x1109C
#define Z_UNICODE_KAITHI_LETTER_NNA	     0x1109D
#define Z_UNICODE_KAITHI_LETTER_TA	     0x1109E
#define Z_UNICODE_KAITHI_LETTER_THA	     0x1109F
#define Z_UNICODE_KAITHI_LETTER_DA	     0x110A0
#define Z_UNICODE_KAITHI_LETTER_DHA	     0x110A1
#define Z_UNICODE_KAITHI_LETTER_NA	     0x110A2
#define Z_UNICODE_KAITHI_LETTER_PA	     0x110A3
#define Z_UNICODE_KAITHI_LETTER_PHA	     0x110A4
#define Z_UNICODE_KAITHI_LETTER_BA	     0x110A5
#define Z_UNICODE_KAITHI_LETTER_BHA	     0x110A6
#define Z_UNICODE_KAITHI_LETTER_MA	     0x110A7
#define Z_UNICODE_KAITHI_LETTER_YA	     0x110A8
#define Z_UNICODE_KAITHI_LETTER_RA	     0x110A9
#define Z_UNICODE_KAITHI_LETTER_LA	     0x110AA
#define Z_UNICODE_KAITHI_LETTER_VA	     0x110AB
#define Z_UNICODE_KAITHI_LETTER_SHA	     0x110AC
#define Z_UNICODE_KAITHI_LETTER_SSA	     0x110AD
#define Z_UNICODE_KAITHI_LETTER_SA	     0x110AE
#define Z_UNICODE_KAITHI_LETTER_HA	     0x110AF
#define Z_UNICODE_KAITHI_VOWEL_SIGN_AA	     0x110B0
#define Z_UNICODE_KAITHI_VOWEL_SIGN_I	     0x110B1
#define Z_UNICODE_KAITHI_VOWEL_SIGN_II	     0x110B2
#define Z_UNICODE_KAITHI_VOWEL_SIGN_U	     0x110B3
#define Z_UNICODE_KAITHI_VOWEL_SIGN_UU	     0x110B4
#define Z_UNICODE_KAITHI_VOWEL_SIGN_E	     0x110B5
#define Z_UNICODE_KAITHI_VOWEL_SIGN_AI	     0x110B6
#define Z_UNICODE_KAITHI_VOWEL_SIGN_O	     0x110B7
#define Z_UNICODE_KAITHI_VOWEL_SIGN_AU	     0x110B8
#define Z_UNICODE_KAITHI_SIGN_VIRAMA	     0x110B9
#define Z_UNICODE_KAITHI_SIGN_NUKTA	     0x110BA
#define Z_UNICODE_KAITHI_ABBREVIATION_SIGN   0x110BB
#define Z_UNICODE_KAITHI_ENUMERATION_SIGN    0x110BC
#define Z_UNICODE_KAITHI_NUMBER_SIGN	     0x110BD
#define Z_UNICODE_KAITHI_SECTION_MARK	     0x110BE
#define Z_UNICODE_KAITHI_DOUBLE_SECTION_MARK 0x110BF
#define Z_UNICODE_KAITHI_DANDA		     0x110C0
#define Z_UNICODE_KAITHI_DOUBLE_DANDA	     0x110C1

/* MARK: - 110D0h-110FFh - Sora Sompeng */

#define Z_UNICODE_SORA_SOMPENG_LETTER_SAH  0x110D0
#define Z_UNICODE_SORA_SOMPENG_LETTER_TAH  0x110D1
#define Z_UNICODE_SORA_SOMPENG_LETTER_BAH  0x110D2
#define Z_UNICODE_SORA_SOMPENG_LETTER_CAH  0x110D3
#define Z_UNICODE_SORA_SOMPENG_LETTER_DAH  0x110D4
#define Z_UNICODE_SORA_SOMPENG_LETTER_GAH  0x110D5
#define Z_UNICODE_SORA_SOMPENG_LETTER_MAH  0x110D6
#define Z_UNICODE_SORA_SOMPENG_LETTER_NGAH 0x110D7
#define Z_UNICODE_SORA_SOMPENG_LETTER_LAH  0x110D8
#define Z_UNICODE_SORA_SOMPENG_LETTER_NAH  0x110D9
#define Z_UNICODE_SORA_SOMPENG_LETTER_VAH  0x110DA
#define Z_UNICODE_SORA_SOMPENG_LETTER_PAH  0x110DB
#define Z_UNICODE_SORA_SOMPENG_LETTER_YAH  0x110DC
#define Z_UNICODE_SORA_SOMPENG_LETTER_RAH  0x110DD
#define Z_UNICODE_SORA_SOMPENG_LETTER_HAH  0x110DE
#define Z_UNICODE_SORA_SOMPENG_LETTER_KAH  0x110DF
#define Z_UNICODE_SORA_SOMPENG_LETTER_JAH  0x110E0
#define Z_UNICODE_SORA_SOMPENG_LETTER_NYAH 0x110E1
#define Z_UNICODE_SORA_SOMPENG_LETTER_AH   0x110E2
#define Z_UNICODE_SORA_SOMPENG_LETTER_EEH  0x110E3
#define Z_UNICODE_SORA_SOMPENG_LETTER_IH   0x110E4
#define Z_UNICODE_SORA_SOMPENG_LETTER_UH   0x110E5
#define Z_UNICODE_SORA_SOMPENG_LETTER_OH   0x110E6
#define Z_UNICODE_SORA_SOMPENG_LETTER_EH   0x110E7
#define Z_UNICODE_SORA_SOMPENG_LETTER_MAE  0x110E8
#define Z_UNICODE_SORA_SOMPENG_DIGIT_ZERO  0x110F0
#define Z_UNICODE_SORA_SOMPENG_DIGIT_ONE   0x110F1
#define Z_UNICODE_SORA_SOMPENG_DIGIT_TWO   0x110F2
#define Z_UNICODE_SORA_SOMPENG_DIGIT_THREE 0x110F3
#define Z_UNICODE_SORA_SOMPENG_DIGIT_FOUR  0x110F4
#define Z_UNICODE_SORA_SOMPENG_DIGIT_FIVE  0x110F5
#define Z_UNICODE_SORA_SOMPENG_DIGIT_SIX   0x110F6
#define Z_UNICODE_SORA_SOMPENG_DIGIT_SEVEN 0x110F7
#define Z_UNICODE_SORA_SOMPENG_DIGIT_EIGHT 0x110F8
#define Z_UNICODE_SORA_SOMPENG_DIGIT_NINE  0x110F9

/* MARK: - 11100h-1114Fh - Chakma */

#define Z_UNICODE_CHAKMA_SIGN_CANDRABINDU 0x11100
#define Z_UNICODE_CHAKMA_SIGN_ANUSVARA	  0x11101
#define Z_UNICODE_CHAKMA_SIGN_VISARGA	  0x11102
#define Z_UNICODE_CHAKMA_LETTER_AA	  0x11103
#define Z_UNICODE_CHAKMA_LETTER_I	  0x11104
#define Z_UNICODE_CHAKMA_LETTER_U	  0x11105
#define Z_UNICODE_CHAKMA_LETTER_E	  0x11106
#define Z_UNICODE_CHAKMA_LETTER_KAA	  0x11107
#define Z_UNICODE_CHAKMA_LETTER_KHAA	  0x11108
#define Z_UNICODE_CHAKMA_LETTER_GAA	  0x11109
#define Z_UNICODE_CHAKMA_LETTER_GHAA	  0x1110A
#define Z_UNICODE_CHAKMA_LETTER_NGAA	  0x1110B
#define Z_UNICODE_CHAKMA_LETTER_CAA	  0x1110C
#define Z_UNICODE_CHAKMA_LETTER_CHAA	  0x1110D
#define Z_UNICODE_CHAKMA_LETTER_JAA	  0x1110E
#define Z_UNICODE_CHAKMA_LETTER_JHAA	  0x1110F
#define Z_UNICODE_CHAKMA_LETTER_NYAA	  0x11110
#define Z_UNICODE_CHAKMA_LETTER_TTAA	  0x11111
#define Z_UNICODE_CHAKMA_LETTER_TTHAA	  0x11112
#define Z_UNICODE_CHAKMA_LETTER_DDAA	  0x11113
#define Z_UNICODE_CHAKMA_LETTER_DDHAA	  0x11114
#define Z_UNICODE_CHAKMA_LETTER_NNAA	  0x11115
#define Z_UNICODE_CHAKMA_LETTER_TAA	  0x11116
#define Z_UNICODE_CHAKMA_LETTER_THAA	  0x11117
#define Z_UNICODE_CHAKMA_LETTER_DAA	  0x11118
#define Z_UNICODE_CHAKMA_LETTER_DHAA	  0x11119
#define Z_UNICODE_CHAKMA_LETTER_NAA	  0x1111A
#define Z_UNICODE_CHAKMA_LETTER_PAA	  0x1111B
#define Z_UNICODE_CHAKMA_LETTER_PHAA	  0x1111C
#define Z_UNICODE_CHAKMA_LETTER_BAA	  0x1111D
#define Z_UNICODE_CHAKMA_LETTER_BHAA	  0x1111E
#define Z_UNICODE_CHAKMA_LETTER_MAA	  0x1111F
#define Z_UNICODE_CHAKMA_LETTER_YYAA	  0x11120
#define Z_UNICODE_CHAKMA_LETTER_YAA	  0x11121
#define Z_UNICODE_CHAKMA_LETTER_RAA	  0x11122
#define Z_UNICODE_CHAKMA_LETTER_LAA	  0x11123
#define Z_UNICODE_CHAKMA_LETTER_WAA	  0x11124
#define Z_UNICODE_CHAKMA_LETTER_SAA	  0x11125
#define Z_UNICODE_CHAKMA_LETTER_HAA	  0x11126
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_A	  0x11127
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_I	  0x11128
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_II	  0x11129
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_U	  0x1112A
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_UU	  0x1112B
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_E	  0x1112C
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_AI	  0x1112D
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_O	  0x1112E
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_AU	  0x1112F
#define Z_UNICODE_CHAKMA_VOWEL_SIGN_OI	  0x11130
#define Z_UNICODE_CHAKMA_O_MARK		  0x11131
#define Z_UNICODE_CHAKMA_AU_MARK	  0x11132
#define Z_UNICODE_CHAKMA_VIRAMA		  0x11133
#define Z_UNICODE_CHAKMA_MAAYYAA	  0x11134
#define Z_UNICODE_CHAKMA_DIGIT_ZERO	  0x11136
#define Z_UNICODE_CHAKMA_DIGIT_ONE	  0x11137
#define Z_UNICODE_CHAKMA_DIGIT_TWO	  0x11138
#define Z_UNICODE_CHAKMA_DIGIT_THREE	  0x11139
#define Z_UNICODE_CHAKMA_DIGIT_FOUR	  0x1113A
#define Z_UNICODE_CHAKMA_DIGIT_FIVE	  0x1113B
#define Z_UNICODE_CHAKMA_DIGIT_SIX	  0x1113C
#define Z_UNICODE_CHAKMA_DIGIT_SEVEN	  0x1113D
#define Z_UNICODE_CHAKMA_DIGIT_EIGHT	  0x1113E
#define Z_UNICODE_CHAKMA_DIGIT_NINE	  0x1113F
#define Z_UNICODE_CHAKMA_SECTION_MARK	  0x11140
#define Z_UNICODE_CHAKMA_DANDA		  0x11141
#define Z_UNICODE_CHAKMA_DOUBLE_DANDA	  0x11142
#define Z_UNICODE_CHAKMA_QUESTION_MARK	  0x11143

/* MARK: - 11150h-1117Fh - Mahajani */

#define Z_UNICODE_MAHAJANI_LETTER_A	     0x11150
#define Z_UNICODE_MAHAJANI_LETTER_I	     0x11151
#define Z_UNICODE_MAHAJANI_LETTER_U	     0x11152
#define Z_UNICODE_MAHAJANI_LETTER_E	     0x11153
#define Z_UNICODE_MAHAJANI_LETTER_O	     0x11154
#define Z_UNICODE_MAHAJANI_LETTER_KA	     0x11155
#define Z_UNICODE_MAHAJANI_LETTER_KHA	     0x11156
#define Z_UNICODE_MAHAJANI_LETTER_GA	     0x11157
#define Z_UNICODE_MAHAJANI_LETTER_GHA	     0x11158
#define Z_UNICODE_MAHAJANI_LETTER_CA	     0x11159
#define Z_UNICODE_MAHAJANI_LETTER_CHA	     0x1115A
#define Z_UNICODE_MAHAJANI_LETTER_JA	     0x1115B
#define Z_UNICODE_MAHAJANI_LETTER_JHA	     0x1115C
#define Z_UNICODE_MAHAJANI_LETTER_NYA	     0x1115D
#define Z_UNICODE_MAHAJANI_LETTER_TTA	     0x1115E
#define Z_UNICODE_MAHAJANI_LETTER_TTHA	     0x1115F
#define Z_UNICODE_MAHAJANI_LETTER_DDA	     0x11160
#define Z_UNICODE_MAHAJANI_LETTER_DDHA	     0x11161
#define Z_UNICODE_MAHAJANI_LETTER_NNA	     0x11162
#define Z_UNICODE_MAHAJANI_LETTER_TA	     0x11163
#define Z_UNICODE_MAHAJANI_LETTER_THA	     0x11164
#define Z_UNICODE_MAHAJANI_LETTER_DA	     0x11165
#define Z_UNICODE_MAHAJANI_LETTER_DHA	     0x11166
#define Z_UNICODE_MAHAJANI_LETTER_NA	     0x11167
#define Z_UNICODE_MAHAJANI_LETTER_PA	     0x11168
#define Z_UNICODE_MAHAJANI_LETTER_PHA	     0x11169
#define Z_UNICODE_MAHAJANI_LETTER_BA	     0x1116A
#define Z_UNICODE_MAHAJANI_LETTER_BHA	     0x1116B
#define Z_UNICODE_MAHAJANI_LETTER_MA	     0x1116C
#define Z_UNICODE_MAHAJANI_LETTER_RA	     0x1116D
#define Z_UNICODE_MAHAJANI_LETTER_LA	     0x1116E
#define Z_UNICODE_MAHAJANI_LETTER_VA	     0x1116F
#define Z_UNICODE_MAHAJANI_LETTER_SA	     0x11170
#define Z_UNICODE_MAHAJANI_LETTER_HA	     0x11171
#define Z_UNICODE_MAHAJANI_LETTER_RRA	     0x11172
#define Z_UNICODE_MAHAJANI_SIGN_NUKTA	     0x11173
#define Z_UNICODE_MAHAJANI_ABBREVIATION_SIGN 0x11174
#define Z_UNICODE_MAHAJANI_SECTION_MARK	     0x11175
#define Z_UNICODE_MAHAJANI_LIGATURE_SHRI     0x11176

/* MARK: - 11180h-111DFh - Sharada */

#define Z_UNICODE_SHARADA_SIGN_CANDRABINDU	 0x11180
#define Z_UNICODE_SHARADA_SIGN_ANUSVARA		 0x11181
#define Z_UNICODE_SHARADA_SIGN_VISARGA		 0x11182
#define Z_UNICODE_SHARADA_LETTER_A		 0x11183
#define Z_UNICODE_SHARADA_LETTER_AA		 0x11184
#define Z_UNICODE_SHARADA_LETTER_I		 0x11185
#define Z_UNICODE_SHARADA_LETTER_II		 0x11186
#define Z_UNICODE_SHARADA_LETTER_U		 0x11187
#define Z_UNICODE_SHARADA_LETTER_UU		 0x11188
#define Z_UNICODE_SHARADA_LETTER_VOCALIC_R	 0x11189
#define Z_UNICODE_SHARADA_LETTER_VOCALIC_RR	 0x1118A
#define Z_UNICODE_SHARADA_LETTER_VOCALIC_L	 0x1118B
#define Z_UNICODE_SHARADA_LETTER_VOCALIC_LL	 0x1118C
#define Z_UNICODE_SHARADA_LETTER_E		 0x1118D
#define Z_UNICODE_SHARADA_LETTER_AI		 0x1118E
#define Z_UNICODE_SHARADA_LETTER_O		 0x1118F
#define Z_UNICODE_SHARADA_LETTER_AU		 0x11190
#define Z_UNICODE_SHARADA_LETTER_KA		 0x11191
#define Z_UNICODE_SHARADA_LETTER_KHA		 0x11192
#define Z_UNICODE_SHARADA_LETTER_GA		 0x11193
#define Z_UNICODE_SHARADA_LETTER_GHA		 0x11194
#define Z_UNICODE_SHARADA_LETTER_NGA		 0x11195
#define Z_UNICODE_SHARADA_LETTER_CA		 0x11196
#define Z_UNICODE_SHARADA_LETTER_CHA		 0x11197
#define Z_UNICODE_SHARADA_LETTER_JA		 0x11198
#define Z_UNICODE_SHARADA_LETTER_JHA		 0x11199
#define Z_UNICODE_SHARADA_LETTER_NYA		 0x1119A
#define Z_UNICODE_SHARADA_LETTER_TTA		 0x1119B
#define Z_UNICODE_SHARADA_LETTER_TTHA		 0x1119C
#define Z_UNICODE_SHARADA_LETTER_DDA		 0x1119D
#define Z_UNICODE_SHARADA_LETTER_DDHA		 0x1119E
#define Z_UNICODE_SHARADA_LETTER_NNA		 0x1119F
#define Z_UNICODE_SHARADA_LETTER_TA		 0x111A0
#define Z_UNICODE_SHARADA_LETTER_THA		 0x111A1
#define Z_UNICODE_SHARADA_LETTER_DA		 0x111A2
#define Z_UNICODE_SHARADA_LETTER_DHA		 0x111A3
#define Z_UNICODE_SHARADA_LETTER_NA		 0x111A4
#define Z_UNICODE_SHARADA_LETTER_PA		 0x111A5
#define Z_UNICODE_SHARADA_LETTER_PHA		 0x111A6
#define Z_UNICODE_SHARADA_LETTER_BA		 0x111A7
#define Z_UNICODE_SHARADA_LETTER_BHA		 0x111A8
#define Z_UNICODE_SHARADA_LETTER_MA		 0x111A9
#define Z_UNICODE_SHARADA_LETTER_YA		 0x111AA
#define Z_UNICODE_SHARADA_LETTER_RA		 0x111AB
#define Z_UNICODE_SHARADA_LETTER_LA		 0x111AC
#define Z_UNICODE_SHARADA_LETTER_LLA		 0x111AD
#define Z_UNICODE_SHARADA_LETTER_VA		 0x111AE
#define Z_UNICODE_SHARADA_LETTER_SHA		 0x111AF
#define Z_UNICODE_SHARADA_LETTER_SSA		 0x111B0
#define Z_UNICODE_SHARADA_LETTER_SA		 0x111B1
#define Z_UNICODE_SHARADA_LETTER_HA		 0x111B2
#define Z_UNICODE_SHARADA_VOWEL_SIGN_AA		 0x111B3
#define Z_UNICODE_SHARADA_VOWEL_SIGN_I		 0x111B4
#define Z_UNICODE_SHARADA_VOWEL_SIGN_II		 0x111B5
#define Z_UNICODE_SHARADA_VOWEL_SIGN_U		 0x111B6
#define Z_UNICODE_SHARADA_VOWEL_SIGN_UU		 0x111B7
#define Z_UNICODE_SHARADA_VOWEL_SIGN_VOCALIC_R	 0x111B8
#define Z_UNICODE_SHARADA_VOWEL_SIGN_VOCALIC_RR	 0x111B9
#define Z_UNICODE_SHARADA_VOWEL_SIGN_VOCALIC_L	 0x111BA
#define Z_UNICODE_SHARADA_VOWEL_SIGN_VOCALIC_LL	 0x111BB
#define Z_UNICODE_SHARADA_VOWEL_SIGN_E		 0x111BC
#define Z_UNICODE_SHARADA_VOWEL_SIGN_AI		 0x111BD
#define Z_UNICODE_SHARADA_VOWEL_SIGN_O		 0x111BE
#define Z_UNICODE_SHARADA_VOWEL_SIGN_AU		 0x111BF
#define Z_UNICODE_SHARADA_SIGN_VIRAMA		 0x111C0
#define Z_UNICODE_SHARADA_SIGN_AVAGRAHA		 0x111C1
#define Z_UNICODE_SHARADA_SIGN_JIHVAMULIYA	 0x111C2
#define Z_UNICODE_SHARADA_SIGN_UPADHMANIYA	 0x111C3
#define Z_UNICODE_SHARADA_OM			 0x111C4
#define Z_UNICODE_SHARADA_DANDA			 0x111C5
#define Z_UNICODE_SHARADA_DOUBLE_DANDA		 0x111C6
#define Z_UNICODE_SHARADA_ABBREVIATION_SIGN	 0x111C7
#define Z_UNICODE_SHARADA_SEPARATOR		 0x111C8
#define Z_UNICODE_SHARADA_SANDHI_MARK		 0x111C9
#define Z_UNICODE_SHARADA_SIGN_NUKTA		 0x111CA
#define Z_UNICODE_SHARADA_VOWEL_MODIFIER_MARK	 0x111CB
#define Z_UNICODE_SHARADA_EXTRA_SHORT_VOWEL_MARK 0x111CC
#define Z_UNICODE_SHARADA_SUTRA_MARK		 0x111CD
#define Z_UNICODE_SHARADA_DIGIT_ZERO		 0x111D0
#define Z_UNICODE_SHARADA_DIGIT_ONE		 0x111D1
#define Z_UNICODE_SHARADA_DIGIT_TWO		 0x111D2
#define Z_UNICODE_SHARADA_DIGIT_THREE		 0x111D3
#define Z_UNICODE_SHARADA_DIGIT_FOUR		 0x111D4
#define Z_UNICODE_SHARADA_DIGIT_FIVE		 0x111D5
#define Z_UNICODE_SHARADA_DIGIT_SIX		 0x111D6
#define Z_UNICODE_SHARADA_DIGIT_SEVEN		 0x111D7
#define Z_UNICODE_SHARADA_DIGIT_EIGHT		 0x111D8
#define Z_UNICODE_SHARADA_DIGIT_NINE		 0x111D9
#define Z_UNICODE_SHARADA_EKAM			 0x111DA
#define Z_UNICODE_SHARADA_SIGN_SIDDHAM		 0x111DB
#define Z_UNICODE_SHARADA_HEADSTROKE		 0x111DC
#define Z_UNICODE_SHARADA_CONTINUATION_SIGN	 0x111DD
#define Z_UNICODE_SHARADA_SECTION_MARK_1	 0x111DE
#define Z_UNICODE_SHARADA_SECTION_MARK_2	 0x111DF

/* MARK: - 111E0h-111FFh - Sinhala Archaic Numbers */

#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_ONE	      0x111E1
#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_TWO	      0x111E2
#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_THREE	      0x111E3
#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_FOUR	      0x111E4
#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_FIVE	      0x111E5
#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_SIX	      0x111E6
#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_SEVEN	      0x111E7
#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_EIGHT	      0x111E8
#define Z_UNICODE_SINHALA_ARCHAIC_DIGIT_NINE	      0x111E9
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_TEN	      0x111EA
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_TWENTY	      0x111EB
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_THIRTY	      0x111EC
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_FORTY	      0x111ED
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_FIFTY	      0x111EE
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_SIXTY	      0x111EF
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_SEVENTY      0x111F0
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_EIGHTY	      0x111F1
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_NINETY	      0x111F2
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_ONE_HUNDRED  0x111F3
#define Z_UNICODE_SINHALA_ARCHAIC_NUMBER_ONE_THOUSAND 0x111F4

/* MARK: - 11200h-1124Fh - Khojki */

#define Z_UNICODE_KHOJKI_LETTER_A	     0x11200
#define Z_UNICODE_KHOJKI_LETTER_AA	     0x11201
#define Z_UNICODE_KHOJKI_LETTER_I	     0x11202
#define Z_UNICODE_KHOJKI_LETTER_U	     0x11203
#define Z_UNICODE_KHOJKI_LETTER_E	     0x11204
#define Z_UNICODE_KHOJKI_LETTER_AI	     0x11205
#define Z_UNICODE_KHOJKI_LETTER_O	     0x11206
#define Z_UNICODE_KHOJKI_LETTER_AU	     0x11207
#define Z_UNICODE_KHOJKI_LETTER_KA	     0x11208
#define Z_UNICODE_KHOJKI_LETTER_KHA	     0x11209
#define Z_UNICODE_KHOJKI_LETTER_GA	     0x1120A
#define Z_UNICODE_KHOJKI_LETTER_GGA	     0x1120B
#define Z_UNICODE_KHOJKI_LETTER_GHA	     0x1120C
#define Z_UNICODE_KHOJKI_LETTER_NGA	     0x1120D
#define Z_UNICODE_KHOJKI_LETTER_CA	     0x1120E
#define Z_UNICODE_KHOJKI_LETTER_CHA	     0x1120F
#define Z_UNICODE_KHOJKI_LETTER_JA	     0x11210
#define Z_UNICODE_KHOJKI_LETTER_JJA	     0x11211
#define Z_UNICODE_KHOJKI_LETTER_NYA	     0x11213
#define Z_UNICODE_KHOJKI_LETTER_TTA	     0x11214
#define Z_UNICODE_KHOJKI_LETTER_TTHA	     0x11215
#define Z_UNICODE_KHOJKI_LETTER_DDA	     0x11216
#define Z_UNICODE_KHOJKI_LETTER_DDHA	     0x11217
#define Z_UNICODE_KHOJKI_LETTER_NNA	     0x11218
#define Z_UNICODE_KHOJKI_LETTER_TA	     0x11219
#define Z_UNICODE_KHOJKI_LETTER_THA	     0x1121A
#define Z_UNICODE_KHOJKI_LETTER_DA	     0x1121B
#define Z_UNICODE_KHOJKI_LETTER_DDDA	     0x1121C
#define Z_UNICODE_KHOJKI_LETTER_DHA	     0x1121D
#define Z_UNICODE_KHOJKI_LETTER_NA	     0x1121E
#define Z_UNICODE_KHOJKI_LETTER_PA	     0x1121F
#define Z_UNICODE_KHOJKI_LETTER_PHA	     0x11220
#define Z_UNICODE_KHOJKI_LETTER_BA	     0x11221
#define Z_UNICODE_KHOJKI_LETTER_BBA	     0x11222
#define Z_UNICODE_KHOJKI_LETTER_BHA	     0x11223
#define Z_UNICODE_KHOJKI_LETTER_MA	     0x11224
#define Z_UNICODE_KHOJKI_LETTER_YA	     0x11225
#define Z_UNICODE_KHOJKI_LETTER_RA	     0x11226
#define Z_UNICODE_KHOJKI_LETTER_LA	     0x11227
#define Z_UNICODE_KHOJKI_LETTER_VA	     0x11228
#define Z_UNICODE_KHOJKI_LETTER_SA	     0x11229
#define Z_UNICODE_KHOJKI_LETTER_HA	     0x1122A
#define Z_UNICODE_KHOJKI_LETTER_LLA	     0x1122B
#define Z_UNICODE_KHOJKI_VOWEL_SIGN_AA	     0x1122C
#define Z_UNICODE_KHOJKI_VOWEL_SIGN_I	     0x1122D
#define Z_UNICODE_KHOJKI_VOWEL_SIGN_II	     0x1122E
#define Z_UNICODE_KHOJKI_VOWEL_SIGN_U	     0x1122F
#define Z_UNICODE_KHOJKI_VOWEL_SIGN_E	     0x11230
#define Z_UNICODE_KHOJKI_VOWEL_SIGN_AI	     0x11231
#define Z_UNICODE_KHOJKI_VOWEL_SIGN_O	     0x11232
#define Z_UNICODE_KHOJKI_VOWEL_SIGN_AU	     0x11233
#define Z_UNICODE_KHOJKI_SIGN_ANUSVARA	     0x11234
#define Z_UNICODE_KHOJKI_SIGN_VIRAMA	     0x11235
#define Z_UNICODE_KHOJKI_SIGN_NUKTA	     0x11236
#define Z_UNICODE_KHOJKI_SIGN_SHADDA	     0x11237
#define Z_UNICODE_KHOJKI_DANDA		     0x11238
#define Z_UNICODE_KHOJKI_DOUBLE_DANDA	     0x11239
#define Z_UNICODE_KHOJKI_WORD_SEPARATOR	     0x1123A
#define Z_UNICODE_KHOJKI_SECTION_MARK	     0x1123B
#define Z_UNICODE_KHOJKI_DOUBLE_SECTION_MARK 0x1123C
#define Z_UNICODE_KHOJKI_ABBREVIATION_SIGN   0x1123D

/* MARK: - 11280h-112AFh - Multani */

#define Z_UNICODE_MULTANI_LETTER_A     0x11280
#define Z_UNICODE_MULTANI_LETTER_I     0x11281
#define Z_UNICODE_MULTANI_LETTER_U     0x11282
#define Z_UNICODE_MULTANI_LETTER_E     0x11283
#define Z_UNICODE_MULTANI_LETTER_KA    0x11284
#define Z_UNICODE_MULTANI_LETTER_KHA   0x11285
#define Z_UNICODE_MULTANI_LETTER_GA    0x11286
#define Z_UNICODE_MULTANI_LETTER_GHA   0x11288
#define Z_UNICODE_MULTANI_LETTER_CA    0x1128A
#define Z_UNICODE_MULTANI_LETTER_CHA   0x1128B
#define Z_UNICODE_MULTANI_LETTER_JA    0x1128C
#define Z_UNICODE_MULTANI_LETTER_JJA   0x1128D
#define Z_UNICODE_MULTANI_LETTER_NYA   0x1128F
#define Z_UNICODE_MULTANI_LETTER_TTA   0x11290
#define Z_UNICODE_MULTANI_LETTER_TTHA  0x11291
#define Z_UNICODE_MULTANI_LETTER_DDA   0x11292
#define Z_UNICODE_MULTANI_LETTER_DDDA  0x11293
#define Z_UNICODE_MULTANI_LETTER_DDHA  0x11294
#define Z_UNICODE_MULTANI_LETTER_NNA   0x11295
#define Z_UNICODE_MULTANI_LETTER_TA    0x11296
#define Z_UNICODE_MULTANI_LETTER_THA   0x11297
#define Z_UNICODE_MULTANI_LETTER_DA    0x11298
#define Z_UNICODE_MULTANI_LETTER_DHA   0x11299
#define Z_UNICODE_MULTANI_LETTER_NA    0x1129A
#define Z_UNICODE_MULTANI_LETTER_PA    0x1129B
#define Z_UNICODE_MULTANI_LETTER_PHA   0x1129C
#define Z_UNICODE_MULTANI_LETTER_BA    0x1129D
#define Z_UNICODE_MULTANI_LETTER_BHA   0x1129F
#define Z_UNICODE_MULTANI_LETTER_MA    0x112A0
#define Z_UNICODE_MULTANI_LETTER_YA    0x112A1
#define Z_UNICODE_MULTANI_LETTER_RA    0x112A2
#define Z_UNICODE_MULTANI_LETTER_LA    0x112A3
#define Z_UNICODE_MULTANI_LETTER_VA    0x112A4
#define Z_UNICODE_MULTANI_LETTER_SA    0x112A5
#define Z_UNICODE_MULTANI_LETTER_HA    0x112A6
#define Z_UNICODE_MULTANI_LETTER_RRA   0x112A7
#define Z_UNICODE_MULTANI_LETTER_RHA   0x112A8
#define Z_UNICODE_MULTANI_SECTION_MARK 0x112A9

/* MARK: - 112B0h-112FFh - Khudawadi */

#define Z_UNICODE_KHUDAWADI_LETTER_A	  0x112B0
#define Z_UNICODE_KHUDAWADI_LETTER_AA	  0x112B1
#define Z_UNICODE_KHUDAWADI_LETTER_I	  0x112B2
#define Z_UNICODE_KHUDAWADI_LETTER_II	  0x112B3
#define Z_UNICODE_KHUDAWADI_LETTER_U	  0x112B4
#define Z_UNICODE_KHUDAWADI_LETTER_UU	  0x112B5
#define Z_UNICODE_KHUDAWADI_LETTER_E	  0x112B6
#define Z_UNICODE_KHUDAWADI_LETTER_AI	  0x112B7
#define Z_UNICODE_KHUDAWADI_LETTER_O	  0x112B8
#define Z_UNICODE_KHUDAWADI_LETTER_AU	  0x112B9
#define Z_UNICODE_KHUDAWADI_LETTER_KA	  0x112BA
#define Z_UNICODE_KHUDAWADI_LETTER_KHA	  0x112BB
#define Z_UNICODE_KHUDAWADI_LETTER_GA	  0x112BC
#define Z_UNICODE_KHUDAWADI_LETTER_GGA	  0x112BD
#define Z_UNICODE_KHUDAWADI_LETTER_GHA	  0x112BE
#define Z_UNICODE_KHUDAWADI_LETTER_NGA	  0x112BF
#define Z_UNICODE_KHUDAWADI_LETTER_CA	  0x112C0
#define Z_UNICODE_KHUDAWADI_LETTER_CHA	  0x112C1
#define Z_UNICODE_KHUDAWADI_LETTER_JA	  0x112C2
#define Z_UNICODE_KHUDAWADI_LETTER_JJA	  0x112C3
#define Z_UNICODE_KHUDAWADI_LETTER_JHA	  0x112C4
#define Z_UNICODE_KHUDAWADI_LETTER_NYA	  0x112C5
#define Z_UNICODE_KHUDAWADI_LETTER_TTA	  0x112C6
#define Z_UNICODE_KHUDAWADI_LETTER_TTHA	  0x112C7
#define Z_UNICODE_KHUDAWADI_LETTER_DDA	  0x112C8
#define Z_UNICODE_KHUDAWADI_LETTER_DDDA	  0x112C9
#define Z_UNICODE_KHUDAWADI_LETTER_RRA	  0x112CA
#define Z_UNICODE_KHUDAWADI_LETTER_DDHA	  0x112CB
#define Z_UNICODE_KHUDAWADI_LETTER_NNA	  0x112CC
#define Z_UNICODE_KHUDAWADI_LETTER_TA	  0x112CD
#define Z_UNICODE_KHUDAWADI_LETTER_THA	  0x112CE
#define Z_UNICODE_KHUDAWADI_LETTER_DA	  0x112CF
#define Z_UNICODE_KHUDAWADI_LETTER_DHA	  0x112D0
#define Z_UNICODE_KHUDAWADI_LETTER_NA	  0x112D1
#define Z_UNICODE_KHUDAWADI_LETTER_PA	  0x112D2
#define Z_UNICODE_KHUDAWADI_LETTER_PHA	  0x112D3
#define Z_UNICODE_KHUDAWADI_LETTER_BA	  0x112D4
#define Z_UNICODE_KHUDAWADI_LETTER_BBA	  0x112D5
#define Z_UNICODE_KHUDAWADI_LETTER_BHA	  0x112D6
#define Z_UNICODE_KHUDAWADI_LETTER_MA	  0x112D7
#define Z_UNICODE_KHUDAWADI_LETTER_YA	  0x112D8
#define Z_UNICODE_KHUDAWADI_LETTER_RA	  0x112D9
#define Z_UNICODE_KHUDAWADI_LETTER_LA	  0x112DA
#define Z_UNICODE_KHUDAWADI_LETTER_VA	  0x112DB
#define Z_UNICODE_KHUDAWADI_LETTER_SHA	  0x112DC
#define Z_UNICODE_KHUDAWADI_LETTER_SA	  0x112DD
#define Z_UNICODE_KHUDAWADI_LETTER_HA	  0x112DE
#define Z_UNICODE_KHUDAWADI_SIGN_ANUSVARA 0x112DF
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_AA 0x112E0
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_I  0x112E1
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_II 0x112E2
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_U  0x112E3
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_UU 0x112E4
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_E  0x112E5
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_AI 0x112E6
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_O  0x112E7
#define Z_UNICODE_KHUDAWADI_VOWEL_SIGN_AU 0x112E8
#define Z_UNICODE_KHUDAWADI_SIGN_NUKTA	  0x112E9
#define Z_UNICODE_KHUDAWADI_SIGN_VIRAMA	  0x112EA
#define Z_UNICODE_KHUDAWADI_DIGIT_ZERO	  0x112F0
#define Z_UNICODE_KHUDAWADI_DIGIT_ONE	  0x112F1
#define Z_UNICODE_KHUDAWADI_DIGIT_TWO	  0x112F2
#define Z_UNICODE_KHUDAWADI_DIGIT_THREE	  0x112F3
#define Z_UNICODE_KHUDAWADI_DIGIT_FOUR	  0x112F4
#define Z_UNICODE_KHUDAWADI_DIGIT_FIVE	  0x112F5
#define Z_UNICODE_KHUDAWADI_DIGIT_SIX	  0x112F6
#define Z_UNICODE_KHUDAWADI_DIGIT_SEVEN	  0x112F7
#define Z_UNICODE_KHUDAWADI_DIGIT_EIGHT	  0x112F8
#define Z_UNICODE_KHUDAWADI_DIGIT_NINE	  0x112F9

/* MARK: - 11300h-1137Fh - Grantha */

#define Z_UNICODE_GRANTHA_SIGN_COMBINING_ANUSVARA_ABOVE	0x11300
#define Z_UNICODE_GRANTHA_SIGN_CANDRABINDU		0x11301
#define Z_UNICODE_GRANTHA_SIGN_ANUSVARA			0x11302
#define Z_UNICODE_GRANTHA_SIGN_VISARGA			0x11303
#define Z_UNICODE_GRANTHA_LETTER_A			0x11305
#define Z_UNICODE_GRANTHA_LETTER_AA			0x11306
#define Z_UNICODE_GRANTHA_LETTER_I			0x11307
#define Z_UNICODE_GRANTHA_LETTER_II			0x11308
#define Z_UNICODE_GRANTHA_LETTER_U			0x11309
#define Z_UNICODE_GRANTHA_LETTER_UU			0x1130A
#define Z_UNICODE_GRANTHA_LETTER_VOCALIC_R		0x1130B
#define Z_UNICODE_GRANTHA_LETTER_VOCALIC_L		0x1130C
#define Z_UNICODE_GRANTHA_LETTER_EE			0x1130F
#define Z_UNICODE_GRANTHA_LETTER_AI			0x11310
#define Z_UNICODE_GRANTHA_LETTER_OO			0x11313
#define Z_UNICODE_GRANTHA_LETTER_AU			0x11314
#define Z_UNICODE_GRANTHA_LETTER_KA			0x11315
#define Z_UNICODE_GRANTHA_LETTER_KHA			0x11316
#define Z_UNICODE_GRANTHA_LETTER_GA			0x11317
#define Z_UNICODE_GRANTHA_LETTER_GHA			0x11318
#define Z_UNICODE_GRANTHA_LETTER_NGA			0x11319
#define Z_UNICODE_GRANTHA_LETTER_CA			0x1131A
#define Z_UNICODE_GRANTHA_LETTER_CHA			0x1131B
#define Z_UNICODE_GRANTHA_LETTER_JA			0x1131C
#define Z_UNICODE_GRANTHA_LETTER_JHA			0x1131D
#define Z_UNICODE_GRANTHA_LETTER_NYA			0x1131E
#define Z_UNICODE_GRANTHA_LETTER_TTA			0x1131F
#define Z_UNICODE_GRANTHA_LETTER_TTHA			0x11320
#define Z_UNICODE_GRANTHA_LETTER_DDA			0x11321
#define Z_UNICODE_GRANTHA_LETTER_DDHA			0x11322
#define Z_UNICODE_GRANTHA_LETTER_NNA			0x11323
#define Z_UNICODE_GRANTHA_LETTER_TA			0x11324
#define Z_UNICODE_GRANTHA_LETTER_THA			0x11325
#define Z_UNICODE_GRANTHA_LETTER_DA			0x11326
#define Z_UNICODE_GRANTHA_LETTER_DHA			0x11327
#define Z_UNICODE_GRANTHA_LETTER_NA			0x11328
#define Z_UNICODE_GRANTHA_LETTER_PA			0x1132A
#define Z_UNICODE_GRANTHA_LETTER_PHA			0x1132B
#define Z_UNICODE_GRANTHA_LETTER_BA			0x1132C
#define Z_UNICODE_GRANTHA_LETTER_BHA			0x1132D
#define Z_UNICODE_GRANTHA_LETTER_MA			0x1132E
#define Z_UNICODE_GRANTHA_LETTER_YA			0x1132F
#define Z_UNICODE_GRANTHA_LETTER_RA			0x11330
#define Z_UNICODE_GRANTHA_LETTER_LA			0x11332
#define Z_UNICODE_GRANTHA_LETTER_LLA			0x11333
#define Z_UNICODE_GRANTHA_LETTER_VA			0x11335
#define Z_UNICODE_GRANTHA_LETTER_SHA			0x11336
#define Z_UNICODE_GRANTHA_LETTER_SSA			0x11337
#define Z_UNICODE_GRANTHA_LETTER_SA			0x11338
#define Z_UNICODE_GRANTHA_LETTER_HA			0x11339
#define Z_UNICODE_GRANTHA_SIGN_NUKTA			0x1133C
#define Z_UNICODE_GRANTHA_SIGN_AVAGRAHA			0x1133D
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_AA			0x1133E
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_I			0x1133F
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_II			0x11340
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_U			0x11341
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_UU			0x11342
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_VOCALIC_R		0x11343
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_VOCALIC_RR		0x11344
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_EE			0x11347
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_AI			0x11348
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_OO			0x1134B
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_AU			0x1134C
#define Z_UNICODE_GRANTHA_SIGN_VIRAMA			0x1134D
#define Z_UNICODE_GRANTHA_OM				0x11350
#define Z_UNICODE_GRANTHA_AU_LENGTH_MARK		0x11357
#define Z_UNICODE_GRANTHA_SIGN_PLUTA			0x1135D
#define Z_UNICODE_GRANTHA_LETTER_VEDIC_ANUSVARA		0x1135E
#define Z_UNICODE_GRANTHA_LETTER_VEDIC_DOUBLE_ANUSVARA	0x1135F
#define Z_UNICODE_GRANTHA_LETTER_VOCALIC_RR		0x11360
#define Z_UNICODE_GRANTHA_LETTER_VOCALIC_LL		0x11361
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_VOCALIC_L		0x11362
#define Z_UNICODE_GRANTHA_VOWEL_SIGN_VOCALIC_LL		0x11363
#define Z_UNICODE_COMBINING_GRANTHA_DIGIT_ZERO		0x11366
#define Z_UNICODE_COMBINING_GRANTHA_DIGIT_ONE		0x11367
#define Z_UNICODE_COMBINING_GRANTHA_DIGIT_TWO		0x11368
#define Z_UNICODE_COMBINING_GRANTHA_DIGIT_THREE		0x11369
#define Z_UNICODE_COMBINING_GRANTHA_DIGIT_FOUR		0x1136A
#define Z_UNICODE_COMBINING_GRANTHA_DIGIT_FIVE		0x1136B
#define Z_UNICODE_COMBINING_GRANTHA_DIGIT_SIX		0x1136C
#define Z_UNICODE_COMBINING_GRANTHA_LETTER_A		0x11370
#define Z_UNICODE_COMBINING_GRANTHA_LETTER_KA		0x11371
#define Z_UNICODE_COMBINING_GRANTHA_LETTER_NA		0x11372
#define Z_UNICODE_COMBINING_GRANTHA_LETTER_VI		0x11373
#define Z_UNICODE_COMBINING_GRANTHA_LETTER_PA		0x11374

/* MARK: - 11480h-114DFh - Tirhuta */

#define Z_UNICODE_TIRHUTA_ANJI			0x11480
#define Z_UNICODE_TIRHUTA_LETTER_A		0x11481
#define Z_UNICODE_TIRHUTA_LETTER_AA		0x11482
#define Z_UNICODE_TIRHUTA_LETTER_I		0x11483
#define Z_UNICODE_TIRHUTA_LETTER_II		0x11484
#define Z_UNICODE_TIRHUTA_LETTER_U		0x11485
#define Z_UNICODE_TIRHUTA_LETTER_UU		0x11486
#define Z_UNICODE_TIRHUTA_LETTER_VOCALIC_R	0x11487
#define Z_UNICODE_TIRHUTA_LETTER_VOCALIC_RR	0x11488
#define Z_UNICODE_TIRHUTA_LETTER_VOCALIC_L	0x11489
#define Z_UNICODE_TIRHUTA_LETTER_VOCALIC_LL	0x1148A
#define Z_UNICODE_TIRHUTA_LETTER_E		0x1148B
#define Z_UNICODE_TIRHUTA_LETTER_AI		0x1148C
#define Z_UNICODE_TIRHUTA_LETTER_O		0x1148D
#define Z_UNICODE_TIRHUTA_LETTER_AU		0x1148E
#define Z_UNICODE_TIRHUTA_LETTER_KA		0x1148F
#define Z_UNICODE_TIRHUTA_LETTER_KHA		0x11490
#define Z_UNICODE_TIRHUTA_LETTER_GA		0x11491
#define Z_UNICODE_TIRHUTA_LETTER_GHA		0x11492
#define Z_UNICODE_TIRHUTA_LETTER_NGA		0x11493
#define Z_UNICODE_TIRHUTA_LETTER_CA		0x11494
#define Z_UNICODE_TIRHUTA_LETTER_CHA		0x11495
#define Z_UNICODE_TIRHUTA_LETTER_JA		0x11496
#define Z_UNICODE_TIRHUTA_LETTER_JHA		0x11497
#define Z_UNICODE_TIRHUTA_LETTER_NYA		0x11498
#define Z_UNICODE_TIRHUTA_LETTER_TTA		0x11499
#define Z_UNICODE_TIRHUTA_LETTER_TTHA		0x1149A
#define Z_UNICODE_TIRHUTA_LETTER_DDA		0x1149B
#define Z_UNICODE_TIRHUTA_LETTER_DDHA		0x1149C
#define Z_UNICODE_TIRHUTA_LETTER_NNA		0x1149D
#define Z_UNICODE_TIRHUTA_LETTER_TA		0x1149E
#define Z_UNICODE_TIRHUTA_LETTER_THA		0x1149F
#define Z_UNICODE_TIRHUTA_LETTER_DA		0x114A0
#define Z_UNICODE_TIRHUTA_LETTER_DHA		0x114A1
#define Z_UNICODE_TIRHUTA_LETTER_NA		0x114A2
#define Z_UNICODE_TIRHUTA_LETTER_PA		0x114A3
#define Z_UNICODE_TIRHUTA_LETTER_PHA		0x114A4
#define Z_UNICODE_TIRHUTA_LETTER_BA		0x114A5
#define Z_UNICODE_TIRHUTA_LETTER_BHA		0x114A6
#define Z_UNICODE_TIRHUTA_LETTER_MA		0x114A7
#define Z_UNICODE_TIRHUTA_LETTER_YA		0x114A8
#define Z_UNICODE_TIRHUTA_LETTER_RA		0x114A9
#define Z_UNICODE_TIRHUTA_LETTER_LA		0x114AA
#define Z_UNICODE_TIRHUTA_LETTER_VA		0x114AB
#define Z_UNICODE_TIRHUTA_LETTER_SHA		0x114AC
#define Z_UNICODE_TIRHUTA_LETTER_SSA		0x114AD
#define Z_UNICODE_TIRHUTA_LETTER_SA		0x114AE
#define Z_UNICODE_TIRHUTA_LETTER_HA		0x114AF
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_AA		0x114B0
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_I		0x114B1
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_II		0x114B2
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_U		0x114B3
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_UU		0x114B4
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_VOCALIC_R	0x114B5
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_VOCALIC_RR	0x114B6
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_VOCALIC_L	0x114B7
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_VOCALIC_LL	0x114B8
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_E		0x114B9
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_SHORT_E	0x114BA
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_AI		0x114BB
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_O		0x114BC
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_SHORT_O	0x114BD
#define Z_UNICODE_TIRHUTA_VOWEL_SIGN_AU		0x114BE
#define Z_UNICODE_TIRHUTA_SIGN_CANDRABINDU	0x114BF
#define Z_UNICODE_TIRHUTA_SIGN_ANUSVARA		0x114C0
#define Z_UNICODE_TIRHUTA_SIGN_VISARGA		0x114C1
#define Z_UNICODE_TIRHUTA_SIGN_VIRAMA		0x114C2
#define Z_UNICODE_TIRHUTA_SIGN_NUKTA		0x114C3
#define Z_UNICODE_TIRHUTA_SIGN_AVAGRAHA		0x114C4
#define Z_UNICODE_TIRHUTA_GVANG			0x114C5
#define Z_UNICODE_TIRHUTA_ABBREVIATION_SIGN	0x114C6
#define Z_UNICODE_TIRHUTA_OM			0x114C7
#define Z_UNICODE_TIRHUTA_DIGIT_ZERO		0x114D0
#define Z_UNICODE_TIRHUTA_DIGIT_ONE		0x114D1
#define Z_UNICODE_TIRHUTA_DIGIT_TWO		0x114D2
#define Z_UNICODE_TIRHUTA_DIGIT_THREE		0x114D3
#define Z_UNICODE_TIRHUTA_DIGIT_FOUR		0x114D4
#define Z_UNICODE_TIRHUTA_DIGIT_FIVE		0x114D5
#define Z_UNICODE_TIRHUTA_DIGIT_SIX		0x114D6
#define Z_UNICODE_TIRHUTA_DIGIT_SEVEN		0x114D7
#define Z_UNICODE_TIRHUTA_DIGIT_EIGHT		0x114D8
#define Z_UNICODE_TIRHUTA_DIGIT_NINE		0x114D9

/* MARK: - 11580h-115FFh - Siddham */

#define Z_UNICODE_SIDDHAM_LETTER_A					     0x11580
#define Z_UNICODE_SIDDHAM_LETTER_AA					     0x11581
#define Z_UNICODE_SIDDHAM_LETTER_I					     0x11582
#define Z_UNICODE_SIDDHAM_LETTER_II					     0x11583
#define Z_UNICODE_SIDDHAM_LETTER_U					     0x11584
#define Z_UNICODE_SIDDHAM_LETTER_UU					     0x11585
#define Z_UNICODE_SIDDHAM_LETTER_VOCALIC_R				     0x11586
#define Z_UNICODE_SIDDHAM_LETTER_VOCALIC_RR				     0x11587
#define Z_UNICODE_SIDDHAM_LETTER_VOCALIC_L				     0x11588
#define Z_UNICODE_SIDDHAM_LETTER_VOCALIC_LL				     0x11589
#define Z_UNICODE_SIDDHAM_LETTER_E					     0x1158A
#define Z_UNICODE_SIDDHAM_LETTER_AI					     0x1158B
#define Z_UNICODE_SIDDHAM_LETTER_O					     0x1158C
#define Z_UNICODE_SIDDHAM_LETTER_AU					     0x1158D
#define Z_UNICODE_SIDDHAM_LETTER_KA					     0x1158E
#define Z_UNICODE_SIDDHAM_LETTER_KHA					     0x1158F
#define Z_UNICODE_SIDDHAM_LETTER_GA					     0x11590
#define Z_UNICODE_SIDDHAM_LETTER_GHA					     0x11591
#define Z_UNICODE_SIDDHAM_LETTER_NGA					     0x11592
#define Z_UNICODE_SIDDHAM_LETTER_CA					     0x11593
#define Z_UNICODE_SIDDHAM_LETTER_CHA					     0x11594
#define Z_UNICODE_SIDDHAM_LETTER_JA					     0x11595
#define Z_UNICODE_SIDDHAM_LETTER_JHA					     0x11596
#define Z_UNICODE_SIDDHAM_LETTER_NYA					     0x11597
#define Z_UNICODE_SIDDHAM_LETTER_TTA					     0x11598
#define Z_UNICODE_SIDDHAM_LETTER_TTHA					     0x11599
#define Z_UNICODE_SIDDHAM_LETTER_DDA					     0x1159A
#define Z_UNICODE_SIDDHAM_LETTER_DDHA					     0x1159B
#define Z_UNICODE_SIDDHAM_LETTER_NNA					     0x1159C
#define Z_UNICODE_SIDDHAM_LETTER_TA					     0x1159D
#define Z_UNICODE_SIDDHAM_LETTER_THA					     0x1159E
#define Z_UNICODE_SIDDHAM_LETTER_DA					     0x1159F
#define Z_UNICODE_SIDDHAM_LETTER_DHA					     0x115A0
#define Z_UNICODE_SIDDHAM_LETTER_NA					     0x115A1
#define Z_UNICODE_SIDDHAM_LETTER_PA					     0x115A2
#define Z_UNICODE_SIDDHAM_LETTER_PHA					     0x115A3
#define Z_UNICODE_SIDDHAM_LETTER_BA					     0x115A4
#define Z_UNICODE_SIDDHAM_LETTER_BHA					     0x115A5
#define Z_UNICODE_SIDDHAM_LETTER_MA					     0x115A6
#define Z_UNICODE_SIDDHAM_LETTER_YA					     0x115A7
#define Z_UNICODE_SIDDHAM_LETTER_RA					     0x115A8
#define Z_UNICODE_SIDDHAM_LETTER_LA					     0x115A9
#define Z_UNICODE_SIDDHAM_LETTER_VA					     0x115AA
#define Z_UNICODE_SIDDHAM_LETTER_SHA					     0x115AB
#define Z_UNICODE_SIDDHAM_LETTER_SSA					     0x115AC
#define Z_UNICODE_SIDDHAM_LETTER_SA					     0x115AD
#define Z_UNICODE_SIDDHAM_LETTER_HA					     0x115AE
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_AA					     0x115AF
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_I					     0x115B0
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_II					     0x115B1
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_U					     0x115B2
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_UU					     0x115B3
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_VOCALIC_R				     0x115B4
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_VOCALIC_RR				     0x115B5
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_E					     0x115B8
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_AI					     0x115B9
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_O					     0x115BA
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_AU					     0x115BB
#define Z_UNICODE_SIDDHAM_SIGN_CANDRABINDU				     0x115BC
#define Z_UNICODE_SIDDHAM_SIGN_ANUSVARA					     0x115BD
#define Z_UNICODE_SIDDHAM_SIGN_VISARGA					     0x115BE
#define Z_UNICODE_SIDDHAM_SIGN_VIRAMA					     0x115BF
#define Z_UNICODE_SIDDHAM_SIGN_NUKTA					     0x115C0
#define Z_UNICODE_SIDDHAM_SIGN_SIDDHAM					     0x115C1
#define Z_UNICODE_SIDDHAM_DANDA						     0x115C2
#define Z_UNICODE_SIDDHAM_DOUBLE_DANDA					     0x115C3
#define Z_UNICODE_SIDDHAM_SEPARATOR_DOT					     0x115C4
#define Z_UNICODE_SIDDHAM_SEPARATOR_BAR					     0x115C5
#define Z_UNICODE_SIDDHAM_REPETITION_MARK_1				     0x115C6
#define Z_UNICODE_SIDDHAM_REPETITION_MARK_2				     0x115C7
#define Z_UNICODE_SIDDHAM_REPETITION_MARK_3				     0x115C8
#define Z_UNICODE_SIDDHAM_END_OF_TEXT_MARK				     0x115C9
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_TRIDENT_AND_U_SHAPED_ORNAMENTS   0x115CA
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_TRIDENT_AND_DOTTED_CRESCENTS     0x115CB
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_RAYS_AND_DOTTED_CRESCENTS	     0x115CC
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_RAYS_AND_DOTTED_DOUBLE_CRESCENTS 0x115CD
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_RAYS_AND_DOTTED_TRIPLE_CRESCENTS 0x115CE
#define Z_UNICODE_SIDDHAM_SECTION_MARK_DOUBLE_RING			     0x115CF
#define Z_UNICODE_SIDDHAM_SECTION_MARK_DOUBLE_RING_WITH_RAYS		     0x115D0
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_DOUBLE_CRESCENTS		     0x115D1
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_TRIPLE_CRESCENTS		     0x115D2
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_QUADRUPLE_CRESCENTS		     0x115D3
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_SEPTUPLE_CRESCENTS		     0x115D4
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_CIRCLES_AND_RAYS		     0x115D5
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_CIRCLES_AND_TWO_ENCLOSURES	     0x115D6
#define Z_UNICODE_SIDDHAM_SECTION_MARK_WITH_CIRCLES_AND_FOUR_ENCLOSURES	     0x115D7
#define Z_UNICODE_SIDDHAM_LETTER_THREE_CIRCLE_ALTERNATE_I		     0x115D8
#define Z_UNICODE_SIDDHAM_LETTER_TWO_CIRCLE_ALTERNATE_I			     0x115D9
#define Z_UNICODE_SIDDHAM_LETTER_TWO_CIRCLE_ALTERNATE_II		     0x115DA
#define Z_UNICODE_SIDDHAM_LETTER_ALTERNATE_U				     0x115DB
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_ALTERNATE_U			     0x115DC
#define Z_UNICODE_SIDDHAM_VOWEL_SIGN_ALTERNATE_UU			     0x115DD

/* MARK: - 11600h-1165Fh - Modi */

#define Z_UNICODE_MODI_LETTER_A		     0x11600
#define Z_UNICODE_MODI_LETTER_AA	     0x11601
#define Z_UNICODE_MODI_LETTER_I		     0x11602
#define Z_UNICODE_MODI_LETTER_II	     0x11603
#define Z_UNICODE_MODI_LETTER_U		     0x11604
#define Z_UNICODE_MODI_LETTER_UU	     0x11605
#define Z_UNICODE_MODI_LETTER_VOCALIC_R	     0x11606
#define Z_UNICODE_MODI_LETTER_VOCALIC_RR     0x11607
#define Z_UNICODE_MODI_LETTER_VOCALIC_L	     0x11608
#define Z_UNICODE_MODI_LETTER_VOCALIC_LL     0x11609
#define Z_UNICODE_MODI_LETTER_E		     0x1160A
#define Z_UNICODE_MODI_LETTER_AI	     0x1160B
#define Z_UNICODE_MODI_LETTER_O		     0x1160C
#define Z_UNICODE_MODI_LETTER_AU	     0x1160D
#define Z_UNICODE_MODI_LETTER_KA	     0x1160E
#define Z_UNICODE_MODI_LETTER_KHA	     0x1160F
#define Z_UNICODE_MODI_LETTER_GA	     0x11610
#define Z_UNICODE_MODI_LETTER_GHA	     0x11611
#define Z_UNICODE_MODI_LETTER_NGA	     0x11612
#define Z_UNICODE_MODI_LETTER_CA	     0x11613
#define Z_UNICODE_MODI_LETTER_CHA	     0x11614
#define Z_UNICODE_MODI_LETTER_JA	     0x11615
#define Z_UNICODE_MODI_LETTER_JHA	     0x11616
#define Z_UNICODE_MODI_LETTER_NYA	     0x11617
#define Z_UNICODE_MODI_LETTER_TTA	     0x11618
#define Z_UNICODE_MODI_LETTER_TTHA	     0x11619
#define Z_UNICODE_MODI_LETTER_DDA	     0x1161A
#define Z_UNICODE_MODI_LETTER_DDHA	     0x1161B
#define Z_UNICODE_MODI_LETTER_NNA	     0x1161C
#define Z_UNICODE_MODI_LETTER_TA	     0x1161D
#define Z_UNICODE_MODI_LETTER_THA	     0x1161E
#define Z_UNICODE_MODI_LETTER_DA	     0x1161F
#define Z_UNICODE_MODI_LETTER_DHA	     0x11620
#define Z_UNICODE_MODI_LETTER_NA	     0x11621
#define Z_UNICODE_MODI_LETTER_PA	     0x11622
#define Z_UNICODE_MODI_LETTER_PHA	     0x11623
#define Z_UNICODE_MODI_LETTER_BA	     0x11624
#define Z_UNICODE_MODI_LETTER_BHA	     0x11625
#define Z_UNICODE_MODI_LETTER_MA	     0x11626
#define Z_UNICODE_MODI_LETTER_YA	     0x11627
#define Z_UNICODE_MODI_LETTER_RA	     0x11628
#define Z_UNICODE_MODI_LETTER_LA	     0x11629
#define Z_UNICODE_MODI_LETTER_VA	     0x1162A
#define Z_UNICODE_MODI_LETTER_SHA	     0x1162B
#define Z_UNICODE_MODI_LETTER_SSA	     0x1162C
#define Z_UNICODE_MODI_LETTER_SA	     0x1162D
#define Z_UNICODE_MODI_LETTER_HA	     0x1162E
#define Z_UNICODE_MODI_LETTER_LLA	     0x1162F
#define Z_UNICODE_MODI_VOWEL_SIGN_AA	     0x11630
#define Z_UNICODE_MODI_VOWEL_SIGN_I	     0x11631
#define Z_UNICODE_MODI_VOWEL_SIGN_II	     0x11632
#define Z_UNICODE_MODI_VOWEL_SIGN_U	     0x11633
#define Z_UNICODE_MODI_VOWEL_SIGN_UU	     0x11634
#define Z_UNICODE_MODI_VOWEL_SIGN_VOCALIC_R  0x11635
#define Z_UNICODE_MODI_VOWEL_SIGN_VOCALIC_RR 0x11636
#define Z_UNICODE_MODI_VOWEL_SIGN_VOCALIC_L  0x11637
#define Z_UNICODE_MODI_VOWEL_SIGN_VOCALIC_LL 0x11638
#define Z_UNICODE_MODI_VOWEL_SIGN_E	     0x11639
#define Z_UNICODE_MODI_VOWEL_SIGN_AI	     0x1163A
#define Z_UNICODE_MODI_VOWEL_SIGN_O	     0x1163B
#define Z_UNICODE_MODI_VOWEL_SIGN_AU	     0x1163C
#define Z_UNICODE_MODI_SIGN_ANUSVARA	     0x1163D
#define Z_UNICODE_MODI_SIGN_VISARGA	     0x1163E
#define Z_UNICODE_MODI_SIGN_VIRAMA	     0x1163F
#define Z_UNICODE_MODI_SIGN_ARDHACANDRA	     0x11640
#define Z_UNICODE_MODI_DANDA		     0x11641
#define Z_UNICODE_MODI_DOUBLE_DANDA	     0x11642
#define Z_UNICODE_MODI_ABBREVIATION_SIGN     0x11643
#define Z_UNICODE_MODI_SIGN_HUVA	     0x11644
#define Z_UNICODE_MODI_DIGIT_ZERO	     0x11650
#define Z_UNICODE_MODI_DIGIT_ONE	     0x11651
#define Z_UNICODE_MODI_DIGIT_TWO	     0x11652
#define Z_UNICODE_MODI_DIGIT_THREE	     0x11653
#define Z_UNICODE_MODI_DIGIT_FOUR	     0x11654
#define Z_UNICODE_MODI_DIGIT_FIVE	     0x11655
#define Z_UNICODE_MODI_DIGIT_SIX	     0x11656
#define Z_UNICODE_MODI_DIGIT_SEVEN	     0x11657
#define Z_UNICODE_MODI_DIGIT_EIGHT	     0x11658
#define Z_UNICODE_MODI_DIGIT_NINE	     0x11659

/* MARK: - 11680h-116CFh - Takri */

#define Z_UNICODE_TAKRI_LETTER_A      0x11680
#define Z_UNICODE_TAKRI_LETTER_AA     0x11681
#define Z_UNICODE_TAKRI_LETTER_I      0x11682
#define Z_UNICODE_TAKRI_LETTER_II     0x11683
#define Z_UNICODE_TAKRI_LETTER_U      0x11684
#define Z_UNICODE_TAKRI_LETTER_UU     0x11685
#define Z_UNICODE_TAKRI_LETTER_E      0x11686
#define Z_UNICODE_TAKRI_LETTER_AI     0x11687
#define Z_UNICODE_TAKRI_LETTER_O      0x11688
#define Z_UNICODE_TAKRI_LETTER_AU     0x11689
#define Z_UNICODE_TAKRI_LETTER_KA     0x1168A
#define Z_UNICODE_TAKRI_LETTER_KHA    0x1168B
#define Z_UNICODE_TAKRI_LETTER_GA     0x1168C
#define Z_UNICODE_TAKRI_LETTER_GHA    0x1168D
#define Z_UNICODE_TAKRI_LETTER_NGA    0x1168E
#define Z_UNICODE_TAKRI_LETTER_CA     0x1168F
#define Z_UNICODE_TAKRI_LETTER_CHA    0x11690
#define Z_UNICODE_TAKRI_LETTER_JA     0x11691
#define Z_UNICODE_TAKRI_LETTER_JHA    0x11692
#define Z_UNICODE_TAKRI_LETTER_NYA    0x11693
#define Z_UNICODE_TAKRI_LETTER_TTA    0x11694
#define Z_UNICODE_TAKRI_LETTER_TTHA   0x11695
#define Z_UNICODE_TAKRI_LETTER_DDA    0x11696
#define Z_UNICODE_TAKRI_LETTER_DDHA   0x11697
#define Z_UNICODE_TAKRI_LETTER_NNA    0x11698
#define Z_UNICODE_TAKRI_LETTER_TA     0x11699
#define Z_UNICODE_TAKRI_LETTER_THA    0x1169A
#define Z_UNICODE_TAKRI_LETTER_DA     0x1169B
#define Z_UNICODE_TAKRI_LETTER_DHA    0x1169C
#define Z_UNICODE_TAKRI_LETTER_NA     0x1169D
#define Z_UNICODE_TAKRI_LETTER_PA     0x1169E
#define Z_UNICODE_TAKRI_LETTER_PHA    0x1169F
#define Z_UNICODE_TAKRI_LETTER_BA     0x116A0
#define Z_UNICODE_TAKRI_LETTER_BHA    0x116A1
#define Z_UNICODE_TAKRI_LETTER_MA     0x116A2
#define Z_UNICODE_TAKRI_LETTER_YA     0x116A3
#define Z_UNICODE_TAKRI_LETTER_RA     0x116A4
#define Z_UNICODE_TAKRI_LETTER_LA     0x116A5
#define Z_UNICODE_TAKRI_LETTER_VA     0x116A6
#define Z_UNICODE_TAKRI_LETTER_SHA    0x116A7
#define Z_UNICODE_TAKRI_LETTER_SA     0x116A8
#define Z_UNICODE_TAKRI_LETTER_HA     0x116A9
#define Z_UNICODE_TAKRI_LETTER_RRA    0x116AA
#define Z_UNICODE_TAKRI_SIGN_ANUSVARA 0x116AB
#define Z_UNICODE_TAKRI_SIGN_VISARGA  0x116AC
#define Z_UNICODE_TAKRI_VOWEL_SIGN_AA 0x116AD
#define Z_UNICODE_TAKRI_VOWEL_SIGN_I  0x116AE
#define Z_UNICODE_TAKRI_VOWEL_SIGN_II 0x116AF
#define Z_UNICODE_TAKRI_VOWEL_SIGN_U  0x116B0
#define Z_UNICODE_TAKRI_VOWEL_SIGN_UU 0x116B1
#define Z_UNICODE_TAKRI_VOWEL_SIGN_E  0x116B2
#define Z_UNICODE_TAKRI_VOWEL_SIGN_AI 0x116B3
#define Z_UNICODE_TAKRI_VOWEL_SIGN_O  0x116B4
#define Z_UNICODE_TAKRI_VOWEL_SIGN_AU 0x116B5
#define Z_UNICODE_TAKRI_SIGN_VIRAMA   0x116B6
#define Z_UNICODE_TAKRI_SIGN_NUKTA    0x116B7
#define Z_UNICODE_TAKRI_DIGIT_ZERO    0x116C0
#define Z_UNICODE_TAKRI_DIGIT_ONE     0x116C1
#define Z_UNICODE_TAKRI_DIGIT_TWO     0x116C2
#define Z_UNICODE_TAKRI_DIGIT_THREE   0x116C3
#define Z_UNICODE_TAKRI_DIGIT_FOUR    0x116C4
#define Z_UNICODE_TAKRI_DIGIT_FIVE    0x116C5
#define Z_UNICODE_TAKRI_DIGIT_SIX     0x116C6
#define Z_UNICODE_TAKRI_DIGIT_SEVEN   0x116C7
#define Z_UNICODE_TAKRI_DIGIT_EIGHT   0x116C8
#define Z_UNICODE_TAKRI_DIGIT_NINE    0x116C9

/* MARK: - 11700h-1173Fh - Ahom */

#define Z_UNICODE_AHOM_LETTER_KA			 0x11700
#define Z_UNICODE_AHOM_LETTER_KHA			 0x11701
#define Z_UNICODE_AHOM_LETTER_NGA			 0x11702
#define Z_UNICODE_AHOM_LETTER_NA			 0x11703
#define Z_UNICODE_AHOM_LETTER_TA			 0x11704
#define Z_UNICODE_AHOM_LETTER_ALTERNATE_TA		 0x11705
#define Z_UNICODE_AHOM_LETTER_PA			 0x11706
#define Z_UNICODE_AHOM_LETTER_PHA			 0x11707
#define Z_UNICODE_AHOM_LETTER_BA			 0x11708
#define Z_UNICODE_AHOM_LETTER_MA			 0x11709
#define Z_UNICODE_AHOM_LETTER_JA			 0x1170A
#define Z_UNICODE_AHOM_LETTER_CHA			 0x1170B
#define Z_UNICODE_AHOM_LETTER_THA			 0x1170C
#define Z_UNICODE_AHOM_LETTER_RA			 0x1170D
#define Z_UNICODE_AHOM_LETTER_LA			 0x1170E
#define Z_UNICODE_AHOM_LETTER_SA			 0x1170F
#define Z_UNICODE_AHOM_LETTER_NYA			 0x11710
#define Z_UNICODE_AHOM_LETTER_HA			 0x11711
#define Z_UNICODE_AHOM_LETTER_A				 0x11712
#define Z_UNICODE_AHOM_LETTER_DA			 0x11713
#define Z_UNICODE_AHOM_LETTER_DHA			 0x11714
#define Z_UNICODE_AHOM_LETTER_GA			 0x11715
#define Z_UNICODE_AHOM_LETTER_ALTERNATE_GA		 0x11716
#define Z_UNICODE_AHOM_LETTER_GHA			 0x11717
#define Z_UNICODE_AHOM_LETTER_BHA			 0x11718
#define Z_UNICODE_AHOM_LETTER_JHA			 0x11719
#define Z_UNICODE_AHOM_CONSONANT_SIGN_MEDIAL_LA		 0x1171D
#define Z_UNICODE_AHOM_CONSONANT_SIGN_MEDIAL_RA		 0x1171E
#define Z_UNICODE_AHOM_CONSONANT_SIGN_MEDIAL_LIGATING_RA 0x1171F
#define Z_UNICODE_AHOM_VOWEL_SIGN_A			 0x11720
#define Z_UNICODE_AHOM_VOWEL_SIGN_AA			 0x11721
#define Z_UNICODE_AHOM_VOWEL_SIGN_I			 0x11722
#define Z_UNICODE_AHOM_VOWEL_SIGN_II			 0x11723
#define Z_UNICODE_AHOM_VOWEL_SIGN_U			 0x11724
#define Z_UNICODE_AHOM_VOWEL_SIGN_UU			 0x11725
#define Z_UNICODE_AHOM_VOWEL_SIGN_E			 0x11726
#define Z_UNICODE_AHOM_VOWEL_SIGN_AW			 0x11727
#define Z_UNICODE_AHOM_VOWEL_SIGN_O			 0x11728
#define Z_UNICODE_AHOM_VOWEL_SIGN_AI			 0x11729
#define Z_UNICODE_AHOM_VOWEL_SIGN_AM			 0x1172A
#define Z_UNICODE_AHOM_SIGN_KILLER			 0x1172B
#define Z_UNICODE_AHOM_DIGIT_ZERO			 0x11730
#define Z_UNICODE_AHOM_DIGIT_ONE			 0x11731
#define Z_UNICODE_AHOM_DIGIT_TWO			 0x11732
#define Z_UNICODE_AHOM_DIGIT_THREE			 0x11733
#define Z_UNICODE_AHOM_DIGIT_FOUR			 0x11734
#define Z_UNICODE_AHOM_DIGIT_FIVE			 0x11735
#define Z_UNICODE_AHOM_DIGIT_SIX			 0x11736
#define Z_UNICODE_AHOM_DIGIT_SEVEN			 0x11737
#define Z_UNICODE_AHOM_DIGIT_EIGHT			 0x11738
#define Z_UNICODE_AHOM_DIGIT_NINE			 0x11739
#define Z_UNICODE_AHOM_NUMBER_TEN			 0x1173A
#define Z_UNICODE_AHOM_NUMBER_TWENTY			 0x1173B
#define Z_UNICODE_AHOM_SIGN_SMALL_SECTION		 0x1173C
#define Z_UNICODE_AHOM_SIGN_SECTION			 0x1173D
#define Z_UNICODE_AHOM_SIGN_RULAI			 0x1173E
#define Z_UNICODE_AHOM_SYMBOL_VI			 0x1173F

/* MARK: - 118A0h-118FFh - Warang Citi */

#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_NGAA 0x118A0
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_A	  0x118A1
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_WI	  0x118A2
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_YU	  0x118A3
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_YA	  0x118A4
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_YO	  0x118A5
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_II	  0x118A6
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_UU	  0x118A7
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_E	  0x118A8
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_O	  0x118A9
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_ANG  0x118AA
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_GA	  0x118AB
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_KO	  0x118AC
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_ENY  0x118AD
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_YUJ  0x118AE
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_UC	  0x118AF
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_ENN  0x118B0
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_ODD  0x118B1
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_TTE  0x118B2
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_NUNG 0x118B3
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_DA	  0x118B4
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_AT	  0x118B5
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_AM	  0x118B6
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_BU	  0x118B7
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_PU	  0x118B8
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_HIYO 0x118B9
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_HOLO 0x118BA
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_HORR 0x118BB
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_HAR  0x118BC
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_SSUU 0x118BD
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_SII  0x118BE
#define Z_UNICODE_WARANG_CITI_CAPITAL_LETTER_VIYO 0x118BF
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_NGAA	  0x118C0
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_A	  0x118C1
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_WI	  0x118C2
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_YU	  0x118C3
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_YA	  0x118C4
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_YO	  0x118C5
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_II	  0x118C6
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_UU	  0x118C7
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_E	  0x118C8
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_O	  0x118C9
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_ANG	  0x118CA
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_GA	  0x118CB
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_KO	  0x118CC
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_ENY	  0x118CD
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_YUJ	  0x118CE
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_UC	  0x118CF
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_ENN	  0x118D0
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_ODD	  0x118D1
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_TTE	  0x118D2
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_NUNG	  0x118D3
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_DA	  0x118D4
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_AT	  0x118D5
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_AM	  0x118D6
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_BU	  0x118D7
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_PU	  0x118D8
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_HIYO	  0x118D9
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_HOLO	  0x118DA
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_HORR	  0x118DB
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_HAR	  0x118DC
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_SSUU	  0x118DD
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_SII	  0x118DE
#define Z_UNICODE_WARANG_CITI_SMALL_LETTER_VIYO	  0x118DF
#define Z_UNICODE_WARANG_CITI_DIGIT_ZERO	  0x118E0
#define Z_UNICODE_WARANG_CITI_DIGIT_ONE		  0x118E1
#define Z_UNICODE_WARANG_CITI_DIGIT_TWO		  0x118E2
#define Z_UNICODE_WARANG_CITI_DIGIT_THREE	  0x118E3
#define Z_UNICODE_WARANG_CITI_DIGIT_FOUR	  0x118E4
#define Z_UNICODE_WARANG_CITI_DIGIT_FIVE	  0x118E5
#define Z_UNICODE_WARANG_CITI_DIGIT_SIX		  0x118E6
#define Z_UNICODE_WARANG_CITI_DIGIT_SEVEN	  0x118E7
#define Z_UNICODE_WARANG_CITI_DIGIT_EIGHT	  0x118E8
#define Z_UNICODE_WARANG_CITI_DIGIT_NINE	  0x118E9
#define Z_UNICODE_WARANG_CITI_NUMBER_TEN	  0x118EA
#define Z_UNICODE_WARANG_CITI_NUMBER_TWENTY	  0x118EB
#define Z_UNICODE_WARANG_CITI_NUMBER_THIRTY	  0x118EC
#define Z_UNICODE_WARANG_CITI_NUMBER_FORTY	  0x118ED
#define Z_UNICODE_WARANG_CITI_NUMBER_FIFTY	  0x118EE
#define Z_UNICODE_WARANG_CITI_NUMBER_SIXTY	  0x118EF
#define Z_UNICODE_WARANG_CITI_NUMBER_SEVENTY	  0x118F0
#define Z_UNICODE_WARANG_CITI_NUMBER_EIGHTY	  0x118F1
#define Z_UNICODE_WARANG_CITI_NUMBER_NINETY	  0x118F2
#define Z_UNICODE_WARANG_CITI_OM		  0x118FF

/* MARK: - 11AC0h-11AFFh - Pau Cin Hau */

#define Z_UNICODE_PAU_CIN_HAU_LETTER_PA			  0x11AC0
#define Z_UNICODE_PAU_CIN_HAU_LETTER_KA			  0x11AC1
#define Z_UNICODE_PAU_CIN_HAU_LETTER_LA			  0x11AC2
#define Z_UNICODE_PAU_CIN_HAU_LETTER_MA			  0x11AC3
#define Z_UNICODE_PAU_CIN_HAU_LETTER_DA			  0x11AC4
#define Z_UNICODE_PAU_CIN_HAU_LETTER_ZA			  0x11AC5
#define Z_UNICODE_PAU_CIN_HAU_LETTER_VA			  0x11AC6
#define Z_UNICODE_PAU_CIN_HAU_LETTER_NGA		  0x11AC7
#define Z_UNICODE_PAU_CIN_HAU_LETTER_HA			  0x11AC8
#define Z_UNICODE_PAU_CIN_HAU_LETTER_GA			  0x11AC9
#define Z_UNICODE_PAU_CIN_HAU_LETTER_KHA		  0x11ACA
#define Z_UNICODE_PAU_CIN_HAU_LETTER_SA			  0x11ACB
#define Z_UNICODE_PAU_CIN_HAU_LETTER_BA			  0x11ACC
#define Z_UNICODE_PAU_CIN_HAU_LETTER_CA			  0x11ACD
#define Z_UNICODE_PAU_CIN_HAU_LETTER_TA			  0x11ACE
#define Z_UNICODE_PAU_CIN_HAU_LETTER_THA		  0x11ACF
#define Z_UNICODE_PAU_CIN_HAU_LETTER_NA			  0x11AD0
#define Z_UNICODE_PAU_CIN_HAU_LETTER_PHA		  0x11AD1
#define Z_UNICODE_PAU_CIN_HAU_LETTER_RA			  0x11AD2
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FA			  0x11AD3
#define Z_UNICODE_PAU_CIN_HAU_LETTER_CHA		  0x11AD4
#define Z_UNICODE_PAU_CIN_HAU_LETTER_A			  0x11AD5
#define Z_UNICODE_PAU_CIN_HAU_LETTER_E			  0x11AD6
#define Z_UNICODE_PAU_CIN_HAU_LETTER_I			  0x11AD7
#define Z_UNICODE_PAU_CIN_HAU_LETTER_O			  0x11AD8
#define Z_UNICODE_PAU_CIN_HAU_LETTER_U			  0x11AD9
#define Z_UNICODE_PAU_CIN_HAU_LETTER_UA			  0x11ADA
#define Z_UNICODE_PAU_CIN_HAU_LETTER_IA			  0x11ADB
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_P		  0x11ADC
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_K		  0x11ADD
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_T		  0x11ADE
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_M		  0x11ADF
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_N		  0x11AE0
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_L		  0x11AE1
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_W		  0x11AE2
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_NG		  0x11AE3
#define Z_UNICODE_PAU_CIN_HAU_LETTER_FINAL_Y		  0x11AE4
#define Z_UNICODE_PAU_CIN_HAU_RISING_TONE_LONG		  0x11AE5
#define Z_UNICODE_PAU_CIN_HAU_RISING_TONE		  0x11AE6
#define Z_UNICODE_PAU_CIN_HAU_SANDHI_GLOTTAL_STOP	  0x11AE7
#define Z_UNICODE_PAU_CIN_HAU_RISING_TONE_LONG_FINAL	  0x11AE8
#define Z_UNICODE_PAU_CIN_HAU_RISING_TONE_FINAL		  0x11AE9
#define Z_UNICODE_PAU_CIN_HAU_SANDHI_GLOTTAL_STOP_FINAL	  0x11AEA
#define Z_UNICODE_PAU_CIN_HAU_SANDHI_TONE_LONG		  0x11AEB
#define Z_UNICODE_PAU_CIN_HAU_SANDHI_TONE		  0x11AEC
#define Z_UNICODE_PAU_CIN_HAU_SANDHI_TONE_LONG_FINAL	  0x11AED
#define Z_UNICODE_PAU_CIN_HAU_SANDHI_TONE_FINAL		  0x11AEE
#define Z_UNICODE_PAU_CIN_HAU_MID_LEVEL_TONE		  0x11AEF
#define Z_UNICODE_PAU_CIN_HAU_GLOTTAL_STOP_VARIANT	  0x11AF0
#define Z_UNICODE_PAU_CIN_HAU_MID_LEVEL_TONE_LONG_FINAL	  0x11AF1
#define Z_UNICODE_PAU_CIN_HAU_MID_LEVEL_TONE_FINAL	  0x11AF2
#define Z_UNICODE_PAU_CIN_HAU_LOW_FALLING_TONE_LONG	  0x11AF3
#define Z_UNICODE_PAU_CIN_HAU_LOW_FALLING_TONE		  0x11AF4
#define Z_UNICODE_PAU_CIN_HAU_GLOTTAL_STOP		  0x11AF5
#define Z_UNICODE_PAU_CIN_HAU_LOW_FALLING_TONE_LONG_FINAL 0x11AF6
#define Z_UNICODE_PAU_CIN_HAU_LOW_FALLING_TONE_FINAL	  0x11AF7
#define Z_UNICODE_PAU_CIN_HAU_GLOTTAL_STOP_FINAL	  0x11AF8

/* MARK: - 12000h-123FFh - Cuneiform */

#define Z_UNICODE_CUNEIFORM_SIGN_A						      0x12000
#define Z_UNICODE_CUNEIFORM_SIGN_A_TIMES_A					      0x12001
#define Z_UNICODE_CUNEIFORM_SIGN_A_TIMES_BAD					      0x12002
#define Z_UNICODE_CUNEIFORM_SIGN_A_TIMES_GAN2_TENU				      0x12003
#define Z_UNICODE_CUNEIFORM_SIGN_A_TIMES_HA					      0x12004
#define Z_UNICODE_CUNEIFORM_SIGN_A_TIMES_IGI					      0x12005
#define Z_UNICODE_CUNEIFORM_SIGN_A_TIMES_LAGAR_GUNU				      0x12006
#define Z_UNICODE_CUNEIFORM_SIGN_A_TIMES_MUSH					      0x12007
#define Z_UNICODE_CUNEIFORM_SIGN_A_TIMES_SAG					      0x12008
#define Z_UNICODE_CUNEIFORM_SIGN_A2						      0x12009
#define Z_UNICODE_CUNEIFORM_SIGN_AB						      0x1200A
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_ASH2					      0x1200B
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_DUN3_GUNU				      0x1200C
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_GAL					      0x1200D
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_GAN2_TENU				      0x1200E
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_HA					      0x1200F
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_IGI_GUNU				      0x12010
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_IMIN					      0x12011
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_LAGAB					      0x12012
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_SHESH					      0x12013
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_U_PLUS_U_PLUS_U			      0x12014
#define Z_UNICODE_CUNEIFORM_SIGN_AB_GUNU					      0x12015
#define Z_UNICODE_CUNEIFORM_SIGN_AB2						      0x12016
#define Z_UNICODE_CUNEIFORM_SIGN_AB2_TIMES_BALAG				      0x12017
#define Z_UNICODE_CUNEIFORM_SIGN_AB2_TIMES_GAN2_TENU				      0x12018
#define Z_UNICODE_CUNEIFORM_SIGN_AB2_TIMES_ME_PLUS_EN				      0x12019
#define Z_UNICODE_CUNEIFORM_SIGN_AB2_TIMES_SHA3					      0x1201A
#define Z_UNICODE_CUNEIFORM_SIGN_AB2_TIMES_TAK4					      0x1201B
#define Z_UNICODE_CUNEIFORM_SIGN_AD						      0x1201C
#define Z_UNICODE_CUNEIFORM_SIGN_AK						      0x1201D
#define Z_UNICODE_CUNEIFORM_SIGN_AK_TIMES_ERIN2					      0x1201E
#define Z_UNICODE_CUNEIFORM_SIGN_AK_TIMES_SHITA_PLUS_GISH			      0x1201F
#define Z_UNICODE_CUNEIFORM_SIGN_AL						      0x12020
#define Z_UNICODE_CUNEIFORM_SIGN_AL_TIMES_AL					      0x12021
#define Z_UNICODE_CUNEIFORM_SIGN_AL_TIMES_DIM2					      0x12022
#define Z_UNICODE_CUNEIFORM_SIGN_AL_TIMES_GISH					      0x12023
#define Z_UNICODE_CUNEIFORM_SIGN_AL_TIMES_HA					      0x12024
#define Z_UNICODE_CUNEIFORM_SIGN_AL_TIMES_KAD3					      0x12025
#define Z_UNICODE_CUNEIFORM_SIGN_AL_TIMES_KI					      0x12026
#define Z_UNICODE_CUNEIFORM_SIGN_AL_TIMES_SHE					      0x12027
#define Z_UNICODE_CUNEIFORM_SIGN_AL_TIMES_USH					      0x12028
#define Z_UNICODE_CUNEIFORM_SIGN_ALAN						      0x12029
#define Z_UNICODE_CUNEIFORM_SIGN_ALEPH						      0x1202A
#define Z_UNICODE_CUNEIFORM_SIGN_AMAR						      0x1202B
#define Z_UNICODE_CUNEIFORM_SIGN_AMAR_TIMES_SHE					      0x1202C
#define Z_UNICODE_CUNEIFORM_SIGN_AN						      0x1202D
#define Z_UNICODE_CUNEIFORM_SIGN_AN_OVER_AN					      0x1202E
#define Z_UNICODE_CUNEIFORM_SIGN_AN_THREE_TIMES					      0x1202F
#define Z_UNICODE_CUNEIFORM_SIGN_AN_PLUS_NAGA_OPPOSING_AN_PLUS_NAGA		      0x12030
#define Z_UNICODE_CUNEIFORM_SIGN_AN_PLUS_NAGA_SQUARED				      0x12031
#define Z_UNICODE_CUNEIFORM_SIGN_ANSHE						      0x12032
#define Z_UNICODE_CUNEIFORM_SIGN_APIN						      0x12033
#define Z_UNICODE_CUNEIFORM_SIGN_ARAD						      0x12034
#define Z_UNICODE_CUNEIFORM_SIGN_ARAD_TIMES_KUR					      0x12035
#define Z_UNICODE_CUNEIFORM_SIGN_ARKAB						      0x12036
#define Z_UNICODE_CUNEIFORM_SIGN_ASAL2						      0x12037
#define Z_UNICODE_CUNEIFORM_SIGN_ASH						      0x12038
#define Z_UNICODE_CUNEIFORM_SIGN_ASH_ZIDA_TENU					      0x12039
#define Z_UNICODE_CUNEIFORM_SIGN_ASH_KABA_TENU					      0x1203A
#define Z_UNICODE_CUNEIFORM_SIGN_ASH_OVER_ASH_TUG2_OVER_TUG2_TUG2_OVER_TUG2_PAP	      0x1203B
#define Z_UNICODE_CUNEIFORM_SIGN_ASH_OVER_ASH_OVER_ASH				      0x1203C
#define Z_UNICODE_CUNEIFORM_SIGN_ASH_OVER_ASH_OVER_ASH_CROSSING_ASH_OVER_ASH_OVER_ASH 0x1203D
#define Z_UNICODE_CUNEIFORM_SIGN_ASH2						      0x1203E
#define Z_UNICODE_CUNEIFORM_SIGN_ASHGAB						      0x1203F
#define Z_UNICODE_CUNEIFORM_SIGN_BA						      0x12040
#define Z_UNICODE_CUNEIFORM_SIGN_BAD						      0x12041
#define Z_UNICODE_CUNEIFORM_SIGN_BAG3						      0x12042
#define Z_UNICODE_CUNEIFORM_SIGN_BAHAR2						      0x12043
#define Z_UNICODE_CUNEIFORM_SIGN_BAL						      0x12044
#define Z_UNICODE_CUNEIFORM_SIGN_BAL_OVER_BAL					      0x12045
#define Z_UNICODE_CUNEIFORM_SIGN_BALAG						      0x12046
#define Z_UNICODE_CUNEIFORM_SIGN_BAR						      0x12047
#define Z_UNICODE_CUNEIFORM_SIGN_BARA2						      0x12048
#define Z_UNICODE_CUNEIFORM_SIGN_BI						      0x12049
#define Z_UNICODE_CUNEIFORM_SIGN_BI_TIMES_A					      0x1204A
#define Z_UNICODE_CUNEIFORM_SIGN_BI_TIMES_GAR					      0x1204B
#define Z_UNICODE_CUNEIFORM_SIGN_BI_TIMES_IGI_GUNU				      0x1204C
#define Z_UNICODE_CUNEIFORM_SIGN_BU						      0x1204D
#define Z_UNICODE_CUNEIFORM_SIGN_BU_OVER_BU_AB					      0x1204E
#define Z_UNICODE_CUNEIFORM_SIGN_BU_OVER_BU_UN					      0x1204F
#define Z_UNICODE_CUNEIFORM_SIGN_BU_CROSSING_BU					      0x12050
#define Z_UNICODE_CUNEIFORM_SIGN_BULUG						      0x12051
#define Z_UNICODE_CUNEIFORM_SIGN_BULUG_OVER_BULUG				      0x12052
#define Z_UNICODE_CUNEIFORM_SIGN_BUR						      0x12053
#define Z_UNICODE_CUNEIFORM_SIGN_BUR2						      0x12054
#define Z_UNICODE_CUNEIFORM_SIGN_DA						      0x12055
#define Z_UNICODE_CUNEIFORM_SIGN_DAG						      0x12056
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_A_PLUS_MASH			      0x12057
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_AMAR				      0x12058
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_BALAG				      0x12059
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_BI				      0x1205A
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GA				      0x1205B
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GA_PLUS_MASH			      0x1205C
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GI				      0x1205D
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GIR2				      0x1205E
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_GUD				      0x1205F
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_HA				      0x12060
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_IR				      0x12061
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_IR_PLUS_LU			      0x12062
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_KAK				      0x12063
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LA				      0x12064
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LU				      0x12065
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LU_PLUS_MASH2			      0x12066
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_LUM				      0x12067
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_NE				      0x12068
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_PAP_PLUS_PAP			      0x12069
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_SI				      0x1206A
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_TAK4				      0x1206B
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_U2_PLUS_GIR2			      0x1206C
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_USH				      0x1206D
#define Z_UNICODE_CUNEIFORM_SIGN_DAM						      0x1206E
#define Z_UNICODE_CUNEIFORM_SIGN_DAR						      0x1206F
#define Z_UNICODE_CUNEIFORM_SIGN_DARA3						      0x12070
#define Z_UNICODE_CUNEIFORM_SIGN_DARA4						      0x12071
#define Z_UNICODE_CUNEIFORM_SIGN_DI						      0x12072
#define Z_UNICODE_CUNEIFORM_SIGN_DIB						      0x12073
#define Z_UNICODE_CUNEIFORM_SIGN_DIM						      0x12074
#define Z_UNICODE_CUNEIFORM_SIGN_DIM_TIMES_SHE					      0x12075
#define Z_UNICODE_CUNEIFORM_SIGN_DIM2						      0x12076
#define Z_UNICODE_CUNEIFORM_SIGN_DIN						      0x12077
#define Z_UNICODE_CUNEIFORM_SIGN_DIN_KASKAL_U_GUNU_DISH				      0x12078
#define Z_UNICODE_CUNEIFORM_SIGN_DISH						      0x12079
#define Z_UNICODE_CUNEIFORM_SIGN_DU						      0x1207A
#define Z_UNICODE_CUNEIFORM_SIGN_DU_OVER_DU					      0x1207B
#define Z_UNICODE_CUNEIFORM_SIGN_DU_GUNU					      0x1207C
#define Z_UNICODE_CUNEIFORM_SIGN_DU_SHESHIG					      0x1207D
#define Z_UNICODE_CUNEIFORM_SIGN_DUB						      0x1207E
#define Z_UNICODE_CUNEIFORM_SIGN_DUB_TIMES_ESH2					      0x1207F
#define Z_UNICODE_CUNEIFORM_SIGN_DUB2						      0x12080
#define Z_UNICODE_CUNEIFORM_SIGN_DUG						      0x12081
#define Z_UNICODE_CUNEIFORM_SIGN_DUGUD						      0x12082
#define Z_UNICODE_CUNEIFORM_SIGN_DUH						      0x12083
#define Z_UNICODE_CUNEIFORM_SIGN_DUN						      0x12084
#define Z_UNICODE_CUNEIFORM_SIGN_DUN3						      0x12085
#define Z_UNICODE_CUNEIFORM_SIGN_DUN3_GUNU					      0x12086
#define Z_UNICODE_CUNEIFORM_SIGN_DUN3_GUNU_GUNU					      0x12087
#define Z_UNICODE_CUNEIFORM_SIGN_DUN4						      0x12088
#define Z_UNICODE_CUNEIFORM_SIGN_DUR2						      0x12089
#define Z_UNICODE_CUNEIFORM_SIGN_E						      0x1208A
#define Z_UNICODE_CUNEIFORM_SIGN_E_TIMES_PAP					      0x1208B
#define Z_UNICODE_CUNEIFORM_SIGN_E_OVER_E_NUN_OVER_NUN				      0x1208C
#define Z_UNICODE_CUNEIFORM_SIGN_E2						      0x1208D
#define Z_UNICODE_CUNEIFORM_SIGN_E2_TIMES_A_PLUS_HA_PLUS_DA			      0x1208E
#define Z_UNICODE_CUNEIFORM_SIGN_E2_TIMES_GAR					      0x1208F
#define Z_UNICODE_CUNEIFORM_SIGN_E2_TIMES_MI					      0x12090
#define Z_UNICODE_CUNEIFORM_SIGN_E2_TIMES_SAL					      0x12091
#define Z_UNICODE_CUNEIFORM_SIGN_E2_TIMES_SHE					      0x12092
#define Z_UNICODE_CUNEIFORM_SIGN_E2_TIMES_U					      0x12093
#define Z_UNICODE_CUNEIFORM_SIGN_EDIN						      0x12094
#define Z_UNICODE_CUNEIFORM_SIGN_EGIR						      0x12095
#define Z_UNICODE_CUNEIFORM_SIGN_EL						      0x12096
#define Z_UNICODE_CUNEIFORM_SIGN_EN						      0x12097
#define Z_UNICODE_CUNEIFORM_SIGN_EN_TIMES_GAN2					      0x12098
#define Z_UNICODE_CUNEIFORM_SIGN_EN_TIMES_GAN2_TENU				      0x12099
#define Z_UNICODE_CUNEIFORM_SIGN_EN_TIMES_ME					      0x1209A
#define Z_UNICODE_CUNEIFORM_SIGN_EN_CROSSING_EN					      0x1209B
#define Z_UNICODE_CUNEIFORM_SIGN_EN_OPPOSING_EN					      0x1209C
#define Z_UNICODE_CUNEIFORM_SIGN_EN_SQUARED					      0x1209D
#define Z_UNICODE_CUNEIFORM_SIGN_EREN						      0x1209E
#define Z_UNICODE_CUNEIFORM_SIGN_ERIN2						      0x1209F
#define Z_UNICODE_CUNEIFORM_SIGN_ESH2						      0x120A0
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN						      0x120A1
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_A					      0x120A2
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_A_PLUS_LAL				      0x120A3
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_A_PLUS_LAL_TIMES_LAL		      0x120A4
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_AN					      0x120A5
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_BAD					      0x120A6
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_DUN3_GUNU				      0x120A7
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_DUN3_GUNU_GUNU			      0x120A8
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_HA					      0x120A9
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_HA_GUNU				      0x120AA
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_IGI_GUNU				      0x120AB
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_KASKAL				      0x120AC
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_KASKAL_SQUARED			      0x120AD
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_KU3					      0x120AE
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_LA					      0x120AF
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_LAL_TIMES_LAL			      0x120B0
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_LI					      0x120B1
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_LU					      0x120B2
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_U2					      0x120B3
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_UD					      0x120B4
#define Z_UNICODE_CUNEIFORM_SIGN_GA						      0x120B5
#define Z_UNICODE_CUNEIFORM_SIGN_GA_GUNU					      0x120B6
#define Z_UNICODE_CUNEIFORM_SIGN_GA2						      0x120B7
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_DA_PLUS_HA			      0x120B8
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_HA				      0x120B9
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_A_PLUS_IGI				      0x120BA
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_AB2_TENU_PLUS_TAB			      0x120BB
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_AN					      0x120BC
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_ASH					      0x120BD
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_ASH2_PLUS_GAL			      0x120BE
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_BAD					      0x120BF
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_BAR_PLUS_RA				      0x120C0
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_BUR					      0x120C1
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_BUR_PLUS_RA				      0x120C2
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_DA					      0x120C3
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_DI					      0x120C4
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_DIM_TIMES_SHE			      0x120C5
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_DUB					      0x120C6
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_EL					      0x120C7
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_EL_PLUS_LA				      0x120C8
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_EN					      0x120C9
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_EN_TIMES_GAN2_TENU			      0x120CA
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GAN2_TENU				      0x120CB
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GAR					      0x120CC
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GI					      0x120CD
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GI4					      0x120CE
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GI4_PLUS_A				      0x120CF
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GIR2_PLUS_SU				      0x120D0
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_HA_PLUS_LU_PLUS_ESH2			      0x120D1
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_HAL					      0x120D2
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_HAL_PLUS_LA				      0x120D3
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_HI_PLUS_LI				      0x120D4
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_HUB2					      0x120D5
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_IGI_GUNU				      0x120D6
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_ISH_PLUS_HU_PLUS_ASH			      0x120D7
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_KAK					      0x120D8
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_KASKAL				      0x120D9
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_KID					      0x120DA
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_KID_PLUS_LAL				      0x120DB
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_KU3_PLUS_AN				      0x120DC
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_LA					      0x120DD
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_ME_PLUS_EN				      0x120DE
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_MI					      0x120DF
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_NUN					      0x120E0
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_NUN_OVER_NUN				      0x120E1
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_PA					      0x120E2
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_SAL					      0x120E3
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_SAR					      0x120E4
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_SHE					      0x120E5
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_SHE_PLUS_TUR				      0x120E6
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_SHID					      0x120E7
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_SUM					      0x120E8
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_TAK4					      0x120E9
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_U					      0x120EA
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_UD					      0x120EB
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_UD_PLUS_DU				      0x120EC
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_OVER_GA2					      0x120ED
#define Z_UNICODE_CUNEIFORM_SIGN_GABA						      0x120EE
#define Z_UNICODE_CUNEIFORM_SIGN_GABA_CROSSING_GABA				      0x120EF
#define Z_UNICODE_CUNEIFORM_SIGN_GAD						      0x120F0
#define Z_UNICODE_CUNEIFORM_SIGN_GAD_OVER_GAD_GAR_OVER_GAR			      0x120F1
#define Z_UNICODE_CUNEIFORM_SIGN_GAL						      0x120F2
#define Z_UNICODE_CUNEIFORM_SIGN_GAL_GAD_OVER_GAD_GAR_OVER_GAR			      0x120F3
#define Z_UNICODE_CUNEIFORM_SIGN_GALAM						      0x120F4
#define Z_UNICODE_CUNEIFORM_SIGN_GAM						      0x120F5
#define Z_UNICODE_CUNEIFORM_SIGN_GAN						      0x120F6
#define Z_UNICODE_CUNEIFORM_SIGN_GAN2						      0x120F7
#define Z_UNICODE_CUNEIFORM_SIGN_GAN2_TENU					      0x120F8
#define Z_UNICODE_CUNEIFORM_SIGN_GAN2_OVER_GAN2					      0x120F9
#define Z_UNICODE_CUNEIFORM_SIGN_GAN2_CROSSING_GAN2				      0x120FA
#define Z_UNICODE_CUNEIFORM_SIGN_GAR						      0x120FB
#define Z_UNICODE_CUNEIFORM_SIGN_GAR3						      0x120FC
#define Z_UNICODE_CUNEIFORM_SIGN_GASHAN						      0x120FD
#define Z_UNICODE_CUNEIFORM_SIGN_GESHTIN					      0x120FE
#define Z_UNICODE_CUNEIFORM_SIGN_GESHTIN_TIMES_KUR				      0x120FF
#define Z_UNICODE_CUNEIFORM_SIGN_GI						      0x12100
#define Z_UNICODE_CUNEIFORM_SIGN_GI_TIMES_E					      0x12101
#define Z_UNICODE_CUNEIFORM_SIGN_GI_TIMES_U					      0x12102
#define Z_UNICODE_CUNEIFORM_SIGN_GI_CROSSING_GI					      0x12103
#define Z_UNICODE_CUNEIFORM_SIGN_GI4						      0x12104
#define Z_UNICODE_CUNEIFORM_SIGN_GI4_OVER_GI4					      0x12105
#define Z_UNICODE_CUNEIFORM_SIGN_GI4_CROSSING_GI4				      0x12106
#define Z_UNICODE_CUNEIFORM_SIGN_GIDIM						      0x12107
#define Z_UNICODE_CUNEIFORM_SIGN_GIR2						      0x12108
#define Z_UNICODE_CUNEIFORM_SIGN_GIR2_GUNU					      0x12109
#define Z_UNICODE_CUNEIFORM_SIGN_GIR3						      0x1210A
#define Z_UNICODE_CUNEIFORM_SIGN_GIR3_TIMES_A_PLUS_IGI				      0x1210B
#define Z_UNICODE_CUNEIFORM_SIGN_GIR3_TIMES_GAN2_TENU				      0x1210C
#define Z_UNICODE_CUNEIFORM_SIGN_GIR3_TIMES_IGI					      0x1210D
#define Z_UNICODE_CUNEIFORM_SIGN_GIR3_TIMES_LU_PLUS_IGI				      0x1210E
#define Z_UNICODE_CUNEIFORM_SIGN_GIR3_TIMES_PA					      0x1210F
#define Z_UNICODE_CUNEIFORM_SIGN_GISAL						      0x12110
#define Z_UNICODE_CUNEIFORM_SIGN_GISH						      0x12111
#define Z_UNICODE_CUNEIFORM_SIGN_GISH_CROSSING_GISH				      0x12112
#define Z_UNICODE_CUNEIFORM_SIGN_GISH_TIMES_BAD					      0x12113
#define Z_UNICODE_CUNEIFORM_SIGN_GISH_TIMES_TAK4				      0x12114
#define Z_UNICODE_CUNEIFORM_SIGN_GISH_TENU					      0x12115
#define Z_UNICODE_CUNEIFORM_SIGN_GU						      0x12116
#define Z_UNICODE_CUNEIFORM_SIGN_GU_CROSSING_GU					      0x12117
#define Z_UNICODE_CUNEIFORM_SIGN_GU2						      0x12118
#define Z_UNICODE_CUNEIFORM_SIGN_GU2_TIMES_KAK					      0x12119
#define Z_UNICODE_CUNEIFORM_SIGN_GU2_TIMES_KAK_TIMES_IGI_GUNU			      0x1211A
#define Z_UNICODE_CUNEIFORM_SIGN_GU2_TIMES_NUN					      0x1211B
#define Z_UNICODE_CUNEIFORM_SIGN_GU2_TIMES_SAL_PLUS_TUG2			      0x1211C
#define Z_UNICODE_CUNEIFORM_SIGN_GU2_GUNU					      0x1211D
#define Z_UNICODE_CUNEIFORM_SIGN_GUD						      0x1211E
#define Z_UNICODE_CUNEIFORM_SIGN_GUD_TIMES_A_PLUS_KUR				      0x1211F
#define Z_UNICODE_CUNEIFORM_SIGN_GUD_TIMES_KUR					      0x12120
#define Z_UNICODE_CUNEIFORM_SIGN_GUD_OVER_GUD_LUGAL				      0x12121
#define Z_UNICODE_CUNEIFORM_SIGN_GUL						      0x12122
#define Z_UNICODE_CUNEIFORM_SIGN_GUM						      0x12123
#define Z_UNICODE_CUNEIFORM_SIGN_GUM_TIMES_SHE					      0x12124
#define Z_UNICODE_CUNEIFORM_SIGN_GUR						      0x12125
#define Z_UNICODE_CUNEIFORM_SIGN_GUR7						      0x12126
#define Z_UNICODE_CUNEIFORM_SIGN_GURUN						      0x12127
#define Z_UNICODE_CUNEIFORM_SIGN_GURUSH						      0x12128
#define Z_UNICODE_CUNEIFORM_SIGN_HA						      0x12129
#define Z_UNICODE_CUNEIFORM_SIGN_HA_TENU					      0x1212A
#define Z_UNICODE_CUNEIFORM_SIGN_HA_GUNU					      0x1212B
#define Z_UNICODE_CUNEIFORM_SIGN_HAL						      0x1212C
#define Z_UNICODE_CUNEIFORM_SIGN_HI						      0x1212D
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_ASH					      0x1212E
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_ASH2					      0x1212F
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_BAD					      0x12130
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_DISH					      0x12131
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_GAD					      0x12132
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_KIN					      0x12133
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_NUN					      0x12134
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_SHE					      0x12135
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_U					      0x12136
#define Z_UNICODE_CUNEIFORM_SIGN_HU						      0x12137
#define Z_UNICODE_CUNEIFORM_SIGN_HUB2						      0x12138
#define Z_UNICODE_CUNEIFORM_SIGN_HUB2_TIMES_AN					      0x12139
#define Z_UNICODE_CUNEIFORM_SIGN_HUB2_TIMES_HAL					      0x1213A
#define Z_UNICODE_CUNEIFORM_SIGN_HUB2_TIMES_KASKAL				      0x1213B
#define Z_UNICODE_CUNEIFORM_SIGN_HUB2_TIMES_LISH				      0x1213C
#define Z_UNICODE_CUNEIFORM_SIGN_HUB2_TIMES_UD					      0x1213D
#define Z_UNICODE_CUNEIFORM_SIGN_HUL2						      0x1213E
#define Z_UNICODE_CUNEIFORM_SIGN_I						      0x1213F
#define Z_UNICODE_CUNEIFORM_SIGN_I_A						      0x12140
#define Z_UNICODE_CUNEIFORM_SIGN_IB						      0x12141
#define Z_UNICODE_CUNEIFORM_SIGN_IDIM						      0x12142
#define Z_UNICODE_CUNEIFORM_SIGN_IDIM_OVER_IDIM_BUR				      0x12143
#define Z_UNICODE_CUNEIFORM_SIGN_IDIM_OVER_IDIM_SQUARED				      0x12144
#define Z_UNICODE_CUNEIFORM_SIGN_IG						      0x12145
#define Z_UNICODE_CUNEIFORM_SIGN_IGI						      0x12146
#define Z_UNICODE_CUNEIFORM_SIGN_IGI_DIB					      0x12147
#define Z_UNICODE_CUNEIFORM_SIGN_IGI_RI						      0x12148
#define Z_UNICODE_CUNEIFORM_SIGN_IGI_OVER_IGI_SHIR_OVER_SHIR_UD_OVER_UD		      0x12149
#define Z_UNICODE_CUNEIFORM_SIGN_IGI_GUNU					      0x1214A
#define Z_UNICODE_CUNEIFORM_SIGN_IL						      0x1214B
#define Z_UNICODE_CUNEIFORM_SIGN_IL_TIMES_GAN2_TENU				      0x1214C
#define Z_UNICODE_CUNEIFORM_SIGN_IL2						      0x1214D
#define Z_UNICODE_CUNEIFORM_SIGN_IM						      0x1214E
#define Z_UNICODE_CUNEIFORM_SIGN_IM_TIMES_TAK4					      0x1214F
#define Z_UNICODE_CUNEIFORM_SIGN_IM_CROSSING_IM					      0x12150
#define Z_UNICODE_CUNEIFORM_SIGN_IM_OPPOSING_IM					      0x12151
#define Z_UNICODE_CUNEIFORM_SIGN_IM_SQUARED					      0x12152
#define Z_UNICODE_CUNEIFORM_SIGN_IMIN						      0x12153
#define Z_UNICODE_CUNEIFORM_SIGN_IN						      0x12154
#define Z_UNICODE_CUNEIFORM_SIGN_IR						      0x12155
#define Z_UNICODE_CUNEIFORM_SIGN_ISH						      0x12156
#define Z_UNICODE_CUNEIFORM_SIGN_KA						      0x12157
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_A					      0x12158
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_AD					      0x12159
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_AD_PLUS_KU3				      0x1215A
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ASH2					      0x1215B
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_BAD					      0x1215C
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_BALAG					      0x1215D
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_BAR					      0x1215E
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_BI					      0x1215F
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ERIN2					      0x12160
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ESH2					      0x12161
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GA					      0x12162
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GAL					      0x12163
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GAN2_TENU				      0x12164
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GAR					      0x12165
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GAR_PLUS_SHA3_PLUS_A			      0x12166
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GI					      0x12167
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GIR2					      0x12168
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GISH_PLUS_SAR				      0x12169
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GISH_CROSSING_GISH			      0x1216A
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GU					      0x1216B
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GUR7					      0x1216C
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_IGI					      0x1216D
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_IM					      0x1216E
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_KAK					      0x1216F
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_KI					      0x12170
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_KID					      0x12171
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_LI					      0x12172
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_LU					      0x12173
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ME					      0x12174
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_DU				      0x12175
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_GI				      0x12176
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ME_PLUS_TE				      0x12177
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_MI					      0x12178
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_MI_PLUS_NUNUZ				      0x12179
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_NE					      0x1217A
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_NUN					      0x1217B
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_PI					      0x1217C
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_RU					      0x1217D
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SA					      0x1217E
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SAR					      0x1217F
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SHA					      0x12180
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SHE					      0x12181
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SHID					      0x12182
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SHU					      0x12183
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SIG					      0x12184
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SUHUR					      0x12185
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_TAR					      0x12186
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_U					      0x12187
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_U2					      0x12188
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_UD					      0x12189
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_UMUM_TIMES_PA				      0x1218A
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_USH					      0x1218B
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ZI					      0x1218C
#define Z_UNICODE_CUNEIFORM_SIGN_KA2						      0x1218D
#define Z_UNICODE_CUNEIFORM_SIGN_KA2_CROSSING_KA2				      0x1218E
#define Z_UNICODE_CUNEIFORM_SIGN_KAB						      0x1218F
#define Z_UNICODE_CUNEIFORM_SIGN_KAD2						      0x12190
#define Z_UNICODE_CUNEIFORM_SIGN_KAD3						      0x12191
#define Z_UNICODE_CUNEIFORM_SIGN_KAD4						      0x12192
#define Z_UNICODE_CUNEIFORM_SIGN_KAD5						      0x12193
#define Z_UNICODE_CUNEIFORM_SIGN_KAD5_OVER_KAD5					      0x12194
#define Z_UNICODE_CUNEIFORM_SIGN_KAK						      0x12195
#define Z_UNICODE_CUNEIFORM_SIGN_KAK_TIMES_IGI_GUNU				      0x12196
#define Z_UNICODE_CUNEIFORM_SIGN_KAL						      0x12197
#define Z_UNICODE_CUNEIFORM_SIGN_KAL_TIMES_BAD					      0x12198
#define Z_UNICODE_CUNEIFORM_SIGN_KAL_CROSSING_KAL				      0x12199
#define Z_UNICODE_CUNEIFORM_SIGN_KAM2						      0x1219A
#define Z_UNICODE_CUNEIFORM_SIGN_KAM4						      0x1219B
#define Z_UNICODE_CUNEIFORM_SIGN_KASKAL						      0x1219C
#define Z_UNICODE_CUNEIFORM_SIGN_KASKAL_LAGAB_TIMES_U_OVER_LAGAB_TIMES_U	      0x1219D
#define Z_UNICODE_CUNEIFORM_SIGN_KASKAL_OVER_KASKAL_LAGAB_TIMES_U_OVER_LAGAB_TIMES_U  0x1219E
#define Z_UNICODE_CUNEIFORM_SIGN_KESH2						      0x1219F
#define Z_UNICODE_CUNEIFORM_SIGN_KI						      0x121A0
#define Z_UNICODE_CUNEIFORM_SIGN_KI_TIMES_BAD					      0x121A1
#define Z_UNICODE_CUNEIFORM_SIGN_KI_TIMES_U					      0x121A2
#define Z_UNICODE_CUNEIFORM_SIGN_KI_TIMES_UD					      0x121A3
#define Z_UNICODE_CUNEIFORM_SIGN_KID						      0x121A4
#define Z_UNICODE_CUNEIFORM_SIGN_KIN						      0x121A5
#define Z_UNICODE_CUNEIFORM_SIGN_KISAL						      0x121A6
#define Z_UNICODE_CUNEIFORM_SIGN_KISH						      0x121A7
#define Z_UNICODE_CUNEIFORM_SIGN_KISIM5						      0x121A8
#define Z_UNICODE_CUNEIFORM_SIGN_KISIM5_OVER_KISIM5				      0x121A9
#define Z_UNICODE_CUNEIFORM_SIGN_KU						      0x121AA
#define Z_UNICODE_CUNEIFORM_SIGN_KU_OVER_HI_TIMES_ASH2_KU_OVER_HI_TIMES_ASH2	      0x121AB
#define Z_UNICODE_CUNEIFORM_SIGN_KU3						      0x121AC
#define Z_UNICODE_CUNEIFORM_SIGN_KU4						      0x121AD
#define Z_UNICODE_CUNEIFORM_SIGN_KU4_VARIANT_FORM				      0x121AE
#define Z_UNICODE_CUNEIFORM_SIGN_KU7						      0x121AF
#define Z_UNICODE_CUNEIFORM_SIGN_KUL						      0x121B0
#define Z_UNICODE_CUNEIFORM_SIGN_KUL_GUNU					      0x121B1
#define Z_UNICODE_CUNEIFORM_SIGN_KUN						      0x121B2
#define Z_UNICODE_CUNEIFORM_SIGN_KUR						      0x121B3
#define Z_UNICODE_CUNEIFORM_SIGN_KUR_OPPOSING_KUR				      0x121B4
#define Z_UNICODE_CUNEIFORM_SIGN_KUSHU2						      0x121B5
#define Z_UNICODE_CUNEIFORM_SIGN_KWU318						      0x121B6
#define Z_UNICODE_CUNEIFORM_SIGN_LA						      0x121B7
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB						      0x121B8
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_A					      0x121B9
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_DA_PLUS_HA			      0x121BA
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_GAR				      0x121BB
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_A_PLUS_LAL				      0x121BC
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_AL					      0x121BD
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_AN					      0x121BE
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_ASH_ZIDA_TENU			      0x121BF
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_BAD				      0x121C0
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_BI					      0x121C1
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_DAR				      0x121C2
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_EN					      0x121C3
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_GA					      0x121C4
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_GAR				      0x121C5
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_GUD				      0x121C6
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_GUD_PLUS_GUD			      0x121C7
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_HA					      0x121C8
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_HAL				      0x121C9
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_HI_TIMES_NUN			      0x121CA
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_IGI_GUNU				      0x121CB
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_IM					      0x121CC
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_IM_PLUS_HA				      0x121CD
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_IM_PLUS_LU				      0x121CE
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_KI					      0x121CF
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_KIN				      0x121D0
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_KU3				      0x121D1
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_KUL				      0x121D2
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_KUL_PLUS_HI_PLUS_A			      0x121D3
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_LAGAB				      0x121D4
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_LISH				      0x121D5
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_LU					      0x121D6
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_LUL				      0x121D7
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_ME					      0x121D8
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_ME_PLUS_EN				      0x121D9
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_MUSH				      0x121DA
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_NE					      0x121DB
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_SHE_PLUS_SUM			      0x121DC
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_SHITA_PLUS_GISH_PLUS_ERIN2		      0x121DD
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_SHITA_PLUS_GISH_TENU		      0x121DE
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_SHU2				      0x121DF
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_SHU2_PLUS_SHU2			      0x121E0
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_SUM				      0x121E1
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_TAG				      0x121E2
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_TAK4				      0x121E3
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_TE_PLUS_A_PLUS_SU_PLUS_NA		      0x121E4
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_U					      0x121E5
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_U_PLUS_A				      0x121E6
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_U_PLUS_U_PLUS_U			      0x121E7
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_U2_PLUS_ASH			      0x121E8
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_UD					      0x121E9
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_USH				      0x121EA
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_SQUARED					      0x121EB
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAR						      0x121EC
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAR_TIMES_SHE				      0x121ED
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAR_TIMES_SHE_PLUS_SUM			      0x121EE
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAR_GUNU					      0x121EF
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAR_GUNU_OVER_LAGAR_GUNU_SHE			      0x121F0
#define Z_UNICODE_CUNEIFORM_SIGN_LAHSHU						      0x121F1
#define Z_UNICODE_CUNEIFORM_SIGN_LAL						      0x121F2
#define Z_UNICODE_CUNEIFORM_SIGN_LAL_TIMES_LAL					      0x121F3
#define Z_UNICODE_CUNEIFORM_SIGN_LAM						      0x121F4
#define Z_UNICODE_CUNEIFORM_SIGN_LAM_TIMES_KUR					      0x121F5
#define Z_UNICODE_CUNEIFORM_SIGN_LAM_TIMES_KUR_PLUS_RU				      0x121F6
#define Z_UNICODE_CUNEIFORM_SIGN_LI						      0x121F7
#define Z_UNICODE_CUNEIFORM_SIGN_LIL						      0x121F8
#define Z_UNICODE_CUNEIFORM_SIGN_LIMMU2						      0x121F9
#define Z_UNICODE_CUNEIFORM_SIGN_LISH						      0x121FA
#define Z_UNICODE_CUNEIFORM_SIGN_LU						      0x121FB
#define Z_UNICODE_CUNEIFORM_SIGN_LU_TIMES_BAD					      0x121FC
#define Z_UNICODE_CUNEIFORM_SIGN_LU2						      0x121FD
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_AL					      0x121FE
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_BAD					      0x121FF
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_ESH2					      0x12200
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_ESH2_TENU				      0x12201
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_GAN2_TENU				      0x12202
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_HI_TIMES_BAD				      0x12203
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_IM					      0x12204
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_KAD2					      0x12205
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_KAD3					      0x12206
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_KAD3_PLUS_ASH			      0x12207
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_KI					      0x12208
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_LA_PLUS_ASH				      0x12209
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_LAGAB				      0x1220A
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_ME_PLUS_EN				      0x1220B
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_NE					      0x1220C
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_NU					      0x1220D
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_SI_PLUS_ASH				      0x1220E
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_SIK2_PLUS_BU				      0x1220F
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_TUG2					      0x12210
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TENU					      0x12211
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_CROSSING_LU2				      0x12212
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_OPPOSING_LU2				      0x12213
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_SQUARED					      0x12214
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_SHESHIG					      0x12215
#define Z_UNICODE_CUNEIFORM_SIGN_LU3						      0x12216
#define Z_UNICODE_CUNEIFORM_SIGN_LUGAL						      0x12217
#define Z_UNICODE_CUNEIFORM_SIGN_LUGAL_OVER_LUGAL				      0x12218
#define Z_UNICODE_CUNEIFORM_SIGN_LUGAL_OPPOSING_LUGAL				      0x12219
#define Z_UNICODE_CUNEIFORM_SIGN_LUGAL_SHESHIG					      0x1221A
#define Z_UNICODE_CUNEIFORM_SIGN_LUH						      0x1221B
#define Z_UNICODE_CUNEIFORM_SIGN_LUL						      0x1221C
#define Z_UNICODE_CUNEIFORM_SIGN_LUM						      0x1221D
#define Z_UNICODE_CUNEIFORM_SIGN_LUM_OVER_LUM					      0x1221E
#define Z_UNICODE_CUNEIFORM_SIGN_LUM_OVER_LUM_GAR_OVER_GAR			      0x1221F
#define Z_UNICODE_CUNEIFORM_SIGN_MA						      0x12220
#define Z_UNICODE_CUNEIFORM_SIGN_MA_TIMES_TAK4					      0x12221
#define Z_UNICODE_CUNEIFORM_SIGN_MA_GUNU					      0x12222
#define Z_UNICODE_CUNEIFORM_SIGN_MA2						      0x12223
#define Z_UNICODE_CUNEIFORM_SIGN_MAH						      0x12224
#define Z_UNICODE_CUNEIFORM_SIGN_MAR						      0x12225
#define Z_UNICODE_CUNEIFORM_SIGN_MASH						      0x12226
#define Z_UNICODE_CUNEIFORM_SIGN_MASH2						      0x12227
#define Z_UNICODE_CUNEIFORM_SIGN_ME						      0x12228
#define Z_UNICODE_CUNEIFORM_SIGN_MES						      0x12229
#define Z_UNICODE_CUNEIFORM_SIGN_MI						      0x1222A
#define Z_UNICODE_CUNEIFORM_SIGN_MIN						      0x1222B
#define Z_UNICODE_CUNEIFORM_SIGN_MU						      0x1222C
#define Z_UNICODE_CUNEIFORM_SIGN_MU_OVER_MU					      0x1222D
#define Z_UNICODE_CUNEIFORM_SIGN_MUG						      0x1222E
#define Z_UNICODE_CUNEIFORM_SIGN_MUG_GUNU					      0x1222F
#define Z_UNICODE_CUNEIFORM_SIGN_MUNSUB						      0x12230
#define Z_UNICODE_CUNEIFORM_SIGN_MURGU2						      0x12231
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH						      0x12232
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH_TIMES_A					      0x12233
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH_TIMES_KUR					      0x12234
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH_TIMES_ZA					      0x12235
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH_OVER_MUSH					      0x12236
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH_OVER_MUSH_TIMES_A_PLUS_NA			      0x12237
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH_CROSSING_MUSH				      0x12238
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH3						      0x12239
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH3_TIMES_A					      0x1223A
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH3_TIMES_A_PLUS_DI				      0x1223B
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH3_TIMES_DI					      0x1223C
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH3_GUNU					      0x1223D
#define Z_UNICODE_CUNEIFORM_SIGN_NA						      0x1223E
#define Z_UNICODE_CUNEIFORM_SIGN_NA2						      0x1223F
#define Z_UNICODE_CUNEIFORM_SIGN_NAGA						      0x12240
#define Z_UNICODE_CUNEIFORM_SIGN_NAGA_INVERTED					      0x12241
#define Z_UNICODE_CUNEIFORM_SIGN_NAGA_TIMES_SHU_TENU				      0x12242
#define Z_UNICODE_CUNEIFORM_SIGN_NAGA_OPPOSING_NAGA				      0x12243
#define Z_UNICODE_CUNEIFORM_SIGN_NAGAR						      0x12244
#define Z_UNICODE_CUNEIFORM_SIGN_NAM_NUTILLU					      0x12245
#define Z_UNICODE_CUNEIFORM_SIGN_NAM						      0x12246
#define Z_UNICODE_CUNEIFORM_SIGN_NAM2						      0x12247
#define Z_UNICODE_CUNEIFORM_SIGN_NE						      0x12248
#define Z_UNICODE_CUNEIFORM_SIGN_NE_TIMES_A					      0x12249
#define Z_UNICODE_CUNEIFORM_SIGN_NE_TIMES_UD					      0x1224A
#define Z_UNICODE_CUNEIFORM_SIGN_NE_SHESHIG					      0x1224B
#define Z_UNICODE_CUNEIFORM_SIGN_NI						      0x1224C
#define Z_UNICODE_CUNEIFORM_SIGN_NI_TIMES_E					      0x1224D
#define Z_UNICODE_CUNEIFORM_SIGN_NI2						      0x1224E
#define Z_UNICODE_CUNEIFORM_SIGN_NIM						      0x1224F
#define Z_UNICODE_CUNEIFORM_SIGN_NIM_TIMES_GAN2_TENU				      0x12250
#define Z_UNICODE_CUNEIFORM_SIGN_NIM_TIMES_GAR_PLUS_GAN2_TENU			      0x12251
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2						      0x12252
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_AN				      0x12253
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_ASH				      0x12254
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_ASH_PLUS_ASH			      0x12255
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_GUD				      0x12256
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_ME_PLUS_GAN2_TENU			      0x12257
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_NE				      0x12258
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_NUN				      0x12259
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_SHE				      0x1225A
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_A_AN			      0x1225B
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_ASH			      0x1225C
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_SHE_PLUS_ASH_PLUS_ASH		      0x1225D
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_U2_PLUS_ASH			      0x1225E
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_USH				      0x1225F
#define Z_UNICODE_CUNEIFORM_SIGN_NISAG						      0x12260
#define Z_UNICODE_CUNEIFORM_SIGN_NU						      0x12261
#define Z_UNICODE_CUNEIFORM_SIGN_NU11						      0x12262
#define Z_UNICODE_CUNEIFORM_SIGN_NUN						      0x12263
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_GAR				      0x12264
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_MASH				      0x12265
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_SAL				      0x12266
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_SAL_OVER_NUN_LAGAR_TIMES_SAL	      0x12267
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_LAGAR_TIMES_USH				      0x12268
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_TENU					      0x12269
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_OVER_NUN					      0x1226A
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_CROSSING_NUN				      0x1226B
#define Z_UNICODE_CUNEIFORM_SIGN_NUN_CROSSING_NUN_LAGAR_OVER_LAGAR		      0x1226C
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ						      0x1226D
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_ASHGAB				      0x1226E
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_BI				      0x1226F
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_DUG				      0x12270
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_GUD				      0x12271
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_IGI_GUNU			      0x12272
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_KAD3				      0x12273
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_LA				      0x12274
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_NE				      0x12275
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_SILA3				      0x12276
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_AB2_TIMES_U2				      0x12277
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_KISIM5_TIMES_BI				      0x12278
#define Z_UNICODE_CUNEIFORM_SIGN_NUNUZ_KISIM5_TIMES_BI_U			      0x12279
#define Z_UNICODE_CUNEIFORM_SIGN_PA						      0x1227A
#define Z_UNICODE_CUNEIFORM_SIGN_PAD						      0x1227B
#define Z_UNICODE_CUNEIFORM_SIGN_PAN						      0x1227C
#define Z_UNICODE_CUNEIFORM_SIGN_PAP						      0x1227D
#define Z_UNICODE_CUNEIFORM_SIGN_PESH2						      0x1227E
#define Z_UNICODE_CUNEIFORM_SIGN_PI						      0x1227F
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_A					      0x12280
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_AB					      0x12281
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_BI					      0x12282
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_BU					      0x12283
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_E					      0x12284
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_I					      0x12285
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_IB					      0x12286
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_U					      0x12287
#define Z_UNICODE_CUNEIFORM_SIGN_PI_TIMES_U2					      0x12288
#define Z_UNICODE_CUNEIFORM_SIGN_PI_CROSSING_PI					      0x12289
#define Z_UNICODE_CUNEIFORM_SIGN_PIRIG						      0x1228A
#define Z_UNICODE_CUNEIFORM_SIGN_PIRIG_TIMES_KAL				      0x1228B
#define Z_UNICODE_CUNEIFORM_SIGN_PIRIG_TIMES_UD					      0x1228C
#define Z_UNICODE_CUNEIFORM_SIGN_PIRIG_TIMES_ZA					      0x1228D
#define Z_UNICODE_CUNEIFORM_SIGN_PIRIG_OPPOSING_PIRIG				      0x1228E
#define Z_UNICODE_CUNEIFORM_SIGN_RA						      0x1228F
#define Z_UNICODE_CUNEIFORM_SIGN_RAB						      0x12290
#define Z_UNICODE_CUNEIFORM_SIGN_RI						      0x12291
#define Z_UNICODE_CUNEIFORM_SIGN_RU						      0x12292
#define Z_UNICODE_CUNEIFORM_SIGN_SA						      0x12293
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_NUTILLU					      0x12294
#define Z_UNICODE_CUNEIFORM_SIGN_SAG						      0x12295
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_A					      0x12296
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_DU					      0x12297
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_DUB					      0x12298
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_HA					      0x12299
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_KAK					      0x1229A
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_KUR					      0x1229B
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_LUM					      0x1229C
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_MI					      0x1229D
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_NUN					      0x1229E
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_SAL					      0x1229F
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_SHID					      0x122A0
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_TAB					      0x122A1
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_U2					      0x122A2
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_UB					      0x122A3
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_UM					      0x122A4
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_UR					      0x122A5
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_USH					      0x122A6
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_OVER_SAG					      0x122A7
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_GUNU					      0x122A8
#define Z_UNICODE_CUNEIFORM_SIGN_SAL						      0x122A9
#define Z_UNICODE_CUNEIFORM_SIGN_SAL_LAGAB_TIMES_ASH2				      0x122AA
#define Z_UNICODE_CUNEIFORM_SIGN_SANGA2						      0x122AB
#define Z_UNICODE_CUNEIFORM_SIGN_SAR						      0x122AC
#define Z_UNICODE_CUNEIFORM_SIGN_SHA						      0x122AD
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3						      0x122AE
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3_TIMES_A					      0x122AF
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3_TIMES_BAD					      0x122B0
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3_TIMES_GISH				      0x122B1
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3_TIMES_NE					      0x122B2
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3_TIMES_SHU2				      0x122B3
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3_TIMES_TUR					      0x122B4
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3_TIMES_U					      0x122B5
#define Z_UNICODE_CUNEIFORM_SIGN_SHA3_TIMES_U_PLUS_A				      0x122B6
#define Z_UNICODE_CUNEIFORM_SIGN_SHA6						      0x122B7
#define Z_UNICODE_CUNEIFORM_SIGN_SHAB6						      0x122B8
#define Z_UNICODE_CUNEIFORM_SIGN_SHAR2						      0x122B9
#define Z_UNICODE_CUNEIFORM_SIGN_SHE						      0x122BA
#define Z_UNICODE_CUNEIFORM_SIGN_SHE_HU						      0x122BB
#define Z_UNICODE_CUNEIFORM_SIGN_SHE_OVER_SHE_GAD_OVER_GAD_GAR_OVER_GAR		      0x122BC
#define Z_UNICODE_CUNEIFORM_SIGN_SHE_OVER_SHE_TAB_OVER_TAB_GAR_OVER_GAR		      0x122BD
#define Z_UNICODE_CUNEIFORM_SIGN_SHEG9						      0x122BE
#define Z_UNICODE_CUNEIFORM_SIGN_SHEN						      0x122BF
#define Z_UNICODE_CUNEIFORM_SIGN_SHESH						      0x122C0
#define Z_UNICODE_CUNEIFORM_SIGN_SHESH2						      0x122C1
#define Z_UNICODE_CUNEIFORM_SIGN_SHESHLAM					      0x122C2
#define Z_UNICODE_CUNEIFORM_SIGN_SHID						      0x122C3
#define Z_UNICODE_CUNEIFORM_SIGN_SHID_TIMES_A					      0x122C4
#define Z_UNICODE_CUNEIFORM_SIGN_SHID_TIMES_IM					      0x122C5
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM						      0x122C6
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_A					      0x122C7
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_BAL					      0x122C8
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_BULUG				      0x122C9
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_DIN					      0x122CA
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_GAR					      0x122CB
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_IGI					      0x122CC
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_IGI_GUNU				      0x122CD
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_KUSHU2				      0x122CE
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_LUL					      0x122CF
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_MUG					      0x122D0
#define Z_UNICODE_CUNEIFORM_SIGN_SHIM_TIMES_SAL					      0x122D1
#define Z_UNICODE_CUNEIFORM_SIGN_SHINIG						      0x122D2
#define Z_UNICODE_CUNEIFORM_SIGN_SHIR						      0x122D3
#define Z_UNICODE_CUNEIFORM_SIGN_SHIR_TENU					      0x122D4
#define Z_UNICODE_CUNEIFORM_SIGN_SHIR_OVER_SHIR_BUR_OVER_BUR			      0x122D5
#define Z_UNICODE_CUNEIFORM_SIGN_SHITA						      0x122D6
#define Z_UNICODE_CUNEIFORM_SIGN_SHU						      0x122D7
#define Z_UNICODE_CUNEIFORM_SIGN_SHU_OVER_INVERTED_SHU				      0x122D8
#define Z_UNICODE_CUNEIFORM_SIGN_SHU2						      0x122D9
#define Z_UNICODE_CUNEIFORM_SIGN_SHUBUR						      0x122DA
#define Z_UNICODE_CUNEIFORM_SIGN_SI						      0x122DB
#define Z_UNICODE_CUNEIFORM_SIGN_SI_GUNU					      0x122DC
#define Z_UNICODE_CUNEIFORM_SIGN_SIG						      0x122DD
#define Z_UNICODE_CUNEIFORM_SIGN_SIG4						      0x122DE
#define Z_UNICODE_CUNEIFORM_SIGN_SIG4_OVER_SIG4_SHU2				      0x122DF
#define Z_UNICODE_CUNEIFORM_SIGN_SIK2						      0x122E0
#define Z_UNICODE_CUNEIFORM_SIGN_SILA3						      0x122E1
#define Z_UNICODE_CUNEIFORM_SIGN_SU						      0x122E2
#define Z_UNICODE_CUNEIFORM_SIGN_SU_OVER_SU					      0x122E3
#define Z_UNICODE_CUNEIFORM_SIGN_SUD						      0x122E4
#define Z_UNICODE_CUNEIFORM_SIGN_SUD2						      0x122E5
#define Z_UNICODE_CUNEIFORM_SIGN_SUHUR						      0x122E6
#define Z_UNICODE_CUNEIFORM_SIGN_SUM						      0x122E7
#define Z_UNICODE_CUNEIFORM_SIGN_SUMASH						      0x122E8
#define Z_UNICODE_CUNEIFORM_SIGN_SUR						      0x122E9
#define Z_UNICODE_CUNEIFORM_SIGN_SUR9						      0x122EA
#define Z_UNICODE_CUNEIFORM_SIGN_TA						      0x122EB
#define Z_UNICODE_CUNEIFORM_SIGN_TA_ASTERISK					      0x122EC
#define Z_UNICODE_CUNEIFORM_SIGN_TA_TIMES_HI					      0x122ED
#define Z_UNICODE_CUNEIFORM_SIGN_TA_TIMES_MI					      0x122EE
#define Z_UNICODE_CUNEIFORM_SIGN_TA_GUNU					      0x122EF
#define Z_UNICODE_CUNEIFORM_SIGN_TAB						      0x122F0
#define Z_UNICODE_CUNEIFORM_SIGN_TAB_OVER_TAB_NI_OVER_NI_DISH_OVER_DISH		      0x122F1
#define Z_UNICODE_CUNEIFORM_SIGN_TAB_SQUARED					      0x122F2
#define Z_UNICODE_CUNEIFORM_SIGN_TAG						      0x122F3
#define Z_UNICODE_CUNEIFORM_SIGN_TAG_TIMES_BI					      0x122F4
#define Z_UNICODE_CUNEIFORM_SIGN_TAG_TIMES_GUD					      0x122F5
#define Z_UNICODE_CUNEIFORM_SIGN_TAG_TIMES_SHE					      0x122F6
#define Z_UNICODE_CUNEIFORM_SIGN_TAG_TIMES_SHU					      0x122F7
#define Z_UNICODE_CUNEIFORM_SIGN_TAG_TIMES_TUG2					      0x122F8
#define Z_UNICODE_CUNEIFORM_SIGN_TAG_TIMES_UD					      0x122F9
#define Z_UNICODE_CUNEIFORM_SIGN_TAK4						      0x122FA
#define Z_UNICODE_CUNEIFORM_SIGN_TAR						      0x122FB
#define Z_UNICODE_CUNEIFORM_SIGN_TE						      0x122FC
#define Z_UNICODE_CUNEIFORM_SIGN_TE_GUNU					      0x122FD
#define Z_UNICODE_CUNEIFORM_SIGN_TI						      0x122FE
#define Z_UNICODE_CUNEIFORM_SIGN_TI_TENU					      0x122FF
#define Z_UNICODE_CUNEIFORM_SIGN_TIL						      0x12300
#define Z_UNICODE_CUNEIFORM_SIGN_TIR						      0x12301
#define Z_UNICODE_CUNEIFORM_SIGN_TIR_TIMES_TAK4					      0x12302
#define Z_UNICODE_CUNEIFORM_SIGN_TIR_OVER_TIR					      0x12303
#define Z_UNICODE_CUNEIFORM_SIGN_TIR_OVER_TIR_GAD_OVER_GAD_GAR_OVER_GAR		      0x12304
#define Z_UNICODE_CUNEIFORM_SIGN_TU						      0x12305
#define Z_UNICODE_CUNEIFORM_SIGN_TUG2						      0x12306
#define Z_UNICODE_CUNEIFORM_SIGN_TUK						      0x12307
#define Z_UNICODE_CUNEIFORM_SIGN_TUM						      0x12308
#define Z_UNICODE_CUNEIFORM_SIGN_TUR						      0x12309
#define Z_UNICODE_CUNEIFORM_SIGN_TUR_OVER_TUR_ZA_OVER_ZA			      0x1230A
#define Z_UNICODE_CUNEIFORM_SIGN_U						      0x1230B
#define Z_UNICODE_CUNEIFORM_SIGN_U_GUD						      0x1230C
#define Z_UNICODE_CUNEIFORM_SIGN_U_U_U						      0x1230D
#define Z_UNICODE_CUNEIFORM_SIGN_U_OVER_U_PA_OVER_PA_GAR_OVER_GAR		      0x1230E
#define Z_UNICODE_CUNEIFORM_SIGN_U_OVER_U_SUR_OVER_SUR				      0x1230F
#define Z_UNICODE_CUNEIFORM_SIGN_U_OVER_U_U_REVERSED_OVER_U_REVERSED		      0x12310
#define Z_UNICODE_CUNEIFORM_SIGN_U2						      0x12311
#define Z_UNICODE_CUNEIFORM_SIGN_UB						      0x12312
#define Z_UNICODE_CUNEIFORM_SIGN_UD						      0x12313
#define Z_UNICODE_CUNEIFORM_SIGN_UD_KUSHU2					      0x12314
#define Z_UNICODE_CUNEIFORM_SIGN_UD_TIMES_BAD					      0x12315
#define Z_UNICODE_CUNEIFORM_SIGN_UD_TIMES_MI					      0x12316
#define Z_UNICODE_CUNEIFORM_SIGN_UD_TIMES_U_PLUS_U_PLUS_U			      0x12317
#define Z_UNICODE_CUNEIFORM_SIGN_UD_TIMES_U_PLUS_U_PLUS_U_GUNU			      0x12318
#define Z_UNICODE_CUNEIFORM_SIGN_UD_GUNU					      0x12319
#define Z_UNICODE_CUNEIFORM_SIGN_UD_SHESHIG					      0x1231A
#define Z_UNICODE_CUNEIFORM_SIGN_UD_SHESHIG_TIMES_BAD				      0x1231B
#define Z_UNICODE_CUNEIFORM_SIGN_UDUG						      0x1231C
#define Z_UNICODE_CUNEIFORM_SIGN_UM						      0x1231D
#define Z_UNICODE_CUNEIFORM_SIGN_UM_TIMES_LAGAB					      0x1231E
#define Z_UNICODE_CUNEIFORM_SIGN_UM_TIMES_ME_PLUS_DA				      0x1231F
#define Z_UNICODE_CUNEIFORM_SIGN_UM_TIMES_SHA3					      0x12320
#define Z_UNICODE_CUNEIFORM_SIGN_UM_TIMES_U					      0x12321
#define Z_UNICODE_CUNEIFORM_SIGN_UMBIN						      0x12322
#define Z_UNICODE_CUNEIFORM_SIGN_UMUM						      0x12323
#define Z_UNICODE_CUNEIFORM_SIGN_UMUM_TIMES_KASKAL				      0x12324
#define Z_UNICODE_CUNEIFORM_SIGN_UMUM_TIMES_PA					      0x12325
#define Z_UNICODE_CUNEIFORM_SIGN_UN						      0x12326
#define Z_UNICODE_CUNEIFORM_SIGN_UN_GUNU					      0x12327
#define Z_UNICODE_CUNEIFORM_SIGN_UR						      0x12328
#define Z_UNICODE_CUNEIFORM_SIGN_UR_CROSSING_UR					      0x12329
#define Z_UNICODE_CUNEIFORM_SIGN_UR_SHESHIG					      0x1232A
#define Z_UNICODE_CUNEIFORM_SIGN_UR2						      0x1232B
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_A_PLUS_HA				      0x1232C
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_A_PLUS_NA				      0x1232D
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_AL					      0x1232E
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_HA					      0x1232F
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_NUN					      0x12330
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_U2					      0x12331
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_U2_PLUS_ASH				      0x12332
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_U2_PLUS_BI				      0x12333
#define Z_UNICODE_CUNEIFORM_SIGN_UR4						      0x12334
#define Z_UNICODE_CUNEIFORM_SIGN_URI						      0x12335
#define Z_UNICODE_CUNEIFORM_SIGN_URI3						      0x12336
#define Z_UNICODE_CUNEIFORM_SIGN_URU						      0x12337
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_A					      0x12338
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_ASHGAB				      0x12339
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_BAR					      0x1233A
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_DUN					      0x1233B
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_GA					      0x1233C
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_GAL					      0x1233D
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_GAN2_TENU				      0x1233E
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_GAR					      0x1233F
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_GU					      0x12340
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_HA					      0x12341
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_IGI					      0x12342
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_IM					      0x12343
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_ISH					      0x12344
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_KI					      0x12345
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_LUM					      0x12346
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_MIN					      0x12347
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_PA					      0x12348
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_SHE					      0x12349
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_SIG4					      0x1234A
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_TU					      0x1234B
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_U_PLUS_GUD				      0x1234C
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_UD					      0x1234D
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_URUDA				      0x1234E
#define Z_UNICODE_CUNEIFORM_SIGN_URUDA						      0x1234F
#define Z_UNICODE_CUNEIFORM_SIGN_URUDA_TIMES_U					      0x12350
#define Z_UNICODE_CUNEIFORM_SIGN_USH						      0x12351
#define Z_UNICODE_CUNEIFORM_SIGN_USH_TIMES_A					      0x12352
#define Z_UNICODE_CUNEIFORM_SIGN_USH_TIMES_KU					      0x12353
#define Z_UNICODE_CUNEIFORM_SIGN_USH_TIMES_KUR					      0x12354
#define Z_UNICODE_CUNEIFORM_SIGN_USH_TIMES_TAK4					      0x12355
#define Z_UNICODE_CUNEIFORM_SIGN_USHX						      0x12356
#define Z_UNICODE_CUNEIFORM_SIGN_USH2						      0x12357
#define Z_UNICODE_CUNEIFORM_SIGN_USHUMX						      0x12358
#define Z_UNICODE_CUNEIFORM_SIGN_UTUKI						      0x12359
#define Z_UNICODE_CUNEIFORM_SIGN_UZ3						      0x1235A
#define Z_UNICODE_CUNEIFORM_SIGN_UZ3_TIMES_KASKAL				      0x1235B
#define Z_UNICODE_CUNEIFORM_SIGN_UZU						      0x1235C
#define Z_UNICODE_CUNEIFORM_SIGN_ZA						      0x1235D
#define Z_UNICODE_CUNEIFORM_SIGN_ZA_TENU					      0x1235E
#define Z_UNICODE_CUNEIFORM_SIGN_ZA_SQUARED_TIMES_KUR				      0x1235F
#define Z_UNICODE_CUNEIFORM_SIGN_ZAG						      0x12360
#define Z_UNICODE_CUNEIFORM_SIGN_ZAMX						      0x12361
#define Z_UNICODE_CUNEIFORM_SIGN_ZE2						      0x12362
#define Z_UNICODE_CUNEIFORM_SIGN_ZI						      0x12363
#define Z_UNICODE_CUNEIFORM_SIGN_ZI_OVER_ZI					      0x12364
#define Z_UNICODE_CUNEIFORM_SIGN_ZI3						      0x12365
#define Z_UNICODE_CUNEIFORM_SIGN_ZIB						      0x12366
#define Z_UNICODE_CUNEIFORM_SIGN_ZIB_KABA_TENU					      0x12367
#define Z_UNICODE_CUNEIFORM_SIGN_ZIG						      0x12368
#define Z_UNICODE_CUNEIFORM_SIGN_ZIZ2						      0x12369
#define Z_UNICODE_CUNEIFORM_SIGN_ZU						      0x1236A
#define Z_UNICODE_CUNEIFORM_SIGN_ZU5						      0x1236B
#define Z_UNICODE_CUNEIFORM_SIGN_ZU5_TIMES_A					      0x1236C
#define Z_UNICODE_CUNEIFORM_SIGN_ZUBUR						      0x1236D
#define Z_UNICODE_CUNEIFORM_SIGN_ZUM						      0x1236E
#define Z_UNICODE_CUNEIFORM_SIGN_KAP_ELAMITE					      0x1236F
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_NUN					      0x12370
#define Z_UNICODE_CUNEIFORM_SIGN_AB2_TIMES_A					      0x12371
#define Z_UNICODE_CUNEIFORM_SIGN_AMAR_TIMES_KUG					      0x12372
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_KISIM5_TIMES_U2_PLUS_MASH			      0x12373
#define Z_UNICODE_CUNEIFORM_SIGN_DAG3						      0x12374
#define Z_UNICODE_CUNEIFORM_SIGN_DISH_PLUS_SHU					      0x12375
#define Z_UNICODE_CUNEIFORM_SIGN_DUB_TIMES_SHE					      0x12376
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_GUD					      0x12377
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_SHE					      0x12378
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_AN_PLUS_KAK_PLUS_A			      0x12379
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_ASH2					      0x1237A
#define Z_UNICODE_CUNEIFORM_SIGN_GE22						      0x1237B
#define Z_UNICODE_CUNEIFORM_SIGN_GIG						      0x1237C
#define Z_UNICODE_CUNEIFORM_SIGN_HUSH						      0x1237D
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ANSHE					      0x1237E
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_ASH3					      0x1237F
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GISH					      0x12380
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_GUD					      0x12381
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_HI_TIMES_ASH2				      0x12382
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_LUM					      0x12383
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_PA					      0x12384
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_SHUL					      0x12385
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_TU					      0x12386
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_UR2					      0x12387
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_GI					      0x12388
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_SHESHIG_TIMES_BAD				      0x12389
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_ESH2_PLUS_LAL			      0x1238A
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_SHU					      0x1238B
#define Z_UNICODE_CUNEIFORM_SIGN_MESH						      0x1238C
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH3_TIMES_ZA					      0x1238D
#define Z_UNICODE_CUNEIFORM_SIGN_NA4						      0x1238E
#define Z_UNICODE_CUNEIFORM_SIGN_NIN						      0x1238F
#define Z_UNICODE_CUNEIFORM_SIGN_NIN9						      0x12390
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_BAL				      0x12391
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_GI				      0x12392
#define Z_UNICODE_CUNEIFORM_SIGN_NU11_ROTATED_NINETY_DEGREES			      0x12393
#define Z_UNICODE_CUNEIFORM_SIGN_PESH2_ASTERISK					      0x12394
#define Z_UNICODE_CUNEIFORM_SIGN_PIR2						      0x12395
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_IGI_GUNU				      0x12396
#define Z_UNICODE_CUNEIFORM_SIGN_TI2						      0x12397
#define Z_UNICODE_CUNEIFORM_SIGN_UM_TIMES_ME					      0x12398
#define Z_UNICODE_CUNEIFORM_SIGN_U_U						      0x12399

/* MARK: - 12400h-1247Fh - Cuneiform Numbers and Punctuation */

#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_ASH		       0x12400
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_ASH		       0x12401
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_ASH		       0x12402
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_ASH		       0x12403
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SIX_ASH		       0x12404
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_ASH		       0x12405
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_EIGHT_ASH		       0x12406
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_ASH		       0x12407
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_DISH		       0x12408
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_DISH		       0x12409
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_DISH		       0x1240A
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SIX_DISH		       0x1240B
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_DISH		       0x1240C
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_EIGHT_DISH		       0x1240D
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_DISH		       0x1240E
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_U			       0x1240F
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_U			       0x12410
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SIX_U			       0x12411
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_U		       0x12412
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_EIGHT_U		       0x12413
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_U			       0x12414
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_GESH2		       0x12415
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_GESH2		       0x12416
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_GESH2		       0x12417
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_GESH2		       0x12418
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_GESH2		       0x12419
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SIX_GESH2		       0x1241A
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_GESH2		       0x1241B
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_EIGHT_GESH2		       0x1241C
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_GESH2		       0x1241D
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_GESHU		       0x1241E
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_GESHU		       0x1241F
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_GESHU		       0x12420
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_GESHU		       0x12421
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_GESHU		       0x12422
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_SHAR2		       0x12423
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_SHAR2		       0x12424
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_SHAR2_VARIANT_FORM      0x12425
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_SHAR2		       0x12426
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_SHAR2		       0x12427
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SIX_SHAR2		       0x12428
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_SHAR2		       0x12429
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_EIGHT_SHAR2		       0x1242A
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_SHAR2		       0x1242B
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_SHARU		       0x1242C
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_SHARU		       0x1242D
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_SHARU		       0x1242E
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_SHARU_VARIANT_FORM      0x1242F
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_SHARU		       0x12430
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_SHARU		       0x12431
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SHAR2_TIMES_GAL_PLUS_DISH     0x12432
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SHAR2_TIMES_GAL_PLUS_MIN      0x12433
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_BURU		       0x12434
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_BURU		       0x12435
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_BURU		       0x12436
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_BURU_VARIANT_FORM       0x12437
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_BURU		       0x12438
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_BURU		       0x12439
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_VARIANT_FORM_ESH16      0x1243A
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_VARIANT_FORM_ESH21      0x1243B
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU       0x1243C
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU4      0x1243D
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU_A     0x1243E
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_VARIANT_FORM_LIMMU_B     0x1243F
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SIX_VARIANT_FORM_ASH9	       0x12440
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN3      0x12441
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN_A     0x12442
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_VARIANT_FORM_IMIN_B     0x12443
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_EIGHT_VARIANT_FORM_USSU       0x12444
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_EIGHT_VARIANT_FORM_USSU3      0x12445
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU      0x12446
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU3     0x12447
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU4     0x12448
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_VARIANT_FORM_ILIMMU_A    0x12449
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_ASH_TENU		       0x1244A
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_ASH_TENU		       0x1244B
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_ASH_TENU		       0x1244C
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_ASH_TENU		       0x1244D
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SIX_ASH_TENU		       0x1244E
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_BAN2		       0x1244F
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_BAN2		       0x12450
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_THREE_BAN2		       0x12451
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_BAN2		       0x12452
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_BAN2_VARIANT_FORM	       0x12453
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_BAN2		       0x12454
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_BAN2_VARIANT_FORM	       0x12455
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NIGIDAMIN		       0x12456
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NIGIDAESH		       0x12457
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_ESHE3		       0x12458
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_ESHE3		       0x12459
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_THIRD_DISH		       0x1245A
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_THIRDS_DISH	       0x1245B
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_SIXTHS_DISH	       0x1245C
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_THIRD_VARIANT_FORM_A      0x1245D
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_TWO_THIRDS_VARIANT_FORM_A     0x1245E
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_EIGHTH_ASH		       0x1245F
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_QUARTER_ASH	       0x12460
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_OLD_ASSYRIAN_ONE_SIXTH	       0x12461
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_OLD_ASSYRIAN_ONE_QUARTER      0x12462
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_QUARTER_GUR	       0x12463
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ONE_HALF_GUR		       0x12464
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ELAMITE_ONE_THIRD	       0x12465
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ELAMITE_TWO_THIRDS	       0x12466
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ELAMITE_FORTY		       0x12467
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_ELAMITE_FIFTY		       0x12468
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FOUR_U_VARIANT_FORM	       0x12469
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_FIVE_U_VARIANT_FORM	       0x1246A
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SIX_U_VARIANT_FORM	       0x1246B
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_SEVEN_U_VARIANT_FORM	       0x1246C
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_EIGHT_U_VARIANT_FORM	       0x1246D
#define Z_UNICODE_CUNEIFORM_NUMERIC_SIGN_NINE_U_VARIANT_FORM	       0x1246E
#define Z_UNICODE_CUNEIFORM_PUNCTUATION_SIGN_OLD_ASSYRIAN_WORD_DIVIDER 0x12470
#define Z_UNICODE_CUNEIFORM_PUNCTUATION_SIGN_VERTICAL_COLON	       0x12471
#define Z_UNICODE_CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_COLON	       0x12472
#define Z_UNICODE_CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_TRICOLON	       0x12473
#define Z_UNICODE_CUNEIFORM_PUNCTUATION_SIGN_DIAGONAL_QUADCOLON	       0x12474

/* MARK: - 12480h-1254Fh - Early Dynastic Cuneiform */

#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_NUN_TENU		     0x12480
#define Z_UNICODE_CUNEIFORM_SIGN_AB_TIMES_SHU2			     0x12481
#define Z_UNICODE_CUNEIFORM_SIGN_AD_TIMES_ESH2			     0x12482
#define Z_UNICODE_CUNEIFORM_SIGN_BAD_TIMES_DISH_TENU		     0x12483
#define Z_UNICODE_CUNEIFORM_SIGN_BAHAR2_TIMES_AB2		     0x12484
#define Z_UNICODE_CUNEIFORM_SIGN_BAHAR2_TIMES_NI		     0x12485
#define Z_UNICODE_CUNEIFORM_SIGN_BAHAR2_TIMES_ZA		     0x12486
#define Z_UNICODE_CUNEIFORM_SIGN_BU_OVER_BU_TIMES_NA2		     0x12487
#define Z_UNICODE_CUNEIFORM_SIGN_DA_TIMES_TAK4			     0x12488
#define Z_UNICODE_CUNEIFORM_SIGN_DAG_TIMES_KUR			     0x12489
#define Z_UNICODE_CUNEIFORM_SIGN_DIM_TIMES_IGI			     0x1248A
#define Z_UNICODE_CUNEIFORM_SIGN_DIM_TIMES_U_U_U		     0x1248B
#define Z_UNICODE_CUNEIFORM_SIGN_DIM2_TIMES_UD			     0x1248C
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_ANSHE		     0x1248D
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_ASH			     0x1248E
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_ASH_AT_LEFT		     0x1248F
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_DIN			     0x12490
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_DUN			     0x12491
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_ERIN2		     0x12492
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_GA			     0x12493
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_GI			     0x12494
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_GIR2_GUNU		     0x12495
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_GISH			     0x12496
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_HA			     0x12497
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_HI			     0x12498
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_IGI_GUNU		     0x12499
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_KASKAL		     0x1249A
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_KUR			     0x1249B
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_KUSHU2		     0x1249C
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_KUSHU2_PLUS_KASKAL	     0x1249D
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_LAK_020		     0x1249E
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_LAM			     0x1249F
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_LAM_TIMES_KUR	     0x124A0
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_LUH_PLUS_GISH	     0x124A1
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_MASH			     0x124A2
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_MES			     0x124A3
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_MI			     0x124A4
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_NI			     0x124A5
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_PI			     0x124A6
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_SHE			     0x124A7
#define Z_UNICODE_CUNEIFORM_SIGN_DUG_TIMES_SI_GUNU		     0x124A8
#define Z_UNICODE_CUNEIFORM_SIGN_E2_TIMES_KUR			     0x124A9
#define Z_UNICODE_CUNEIFORM_SIGN_E2_TIMES_PAP			     0x124AA
#define Z_UNICODE_CUNEIFORM_SIGN_ERIN2_X			     0x124AB
#define Z_UNICODE_CUNEIFORM_SIGN_ESH2_CROSSING_ESH2		     0x124AC
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_ASH		     0x124AD
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_HI		     0x124AE
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_IGI_GUNU	     0x124AF
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_LA		     0x124B0
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_LAL		     0x124B1
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_ME		     0x124B2
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_MES		     0x124B3
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_SHESHIG_TIMES_SU		     0x124B4
#define Z_UNICODE_CUNEIFORM_SIGN_EZEN_TIMES_SU			     0x124B5
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_BAHAR2		     0x124B6
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_DIM_GUNU		     0x124B7
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_DUG_TIMES_IGI_GUNU	     0x124B8
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_DUG_TIMES_KASKAL	     0x124B9
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_EREN			     0x124BA
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GA			     0x124BB
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GAR_PLUS_DI		     0x124BC
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_GAR_PLUS_NE		     0x124BD
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_HA_PLUS_A		     0x124BE
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_KUSHU2_PLUS_KASKAL	     0x124BF
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_LAM			     0x124C0
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_LAM_TIMES_KUR	     0x124C1
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_LUH			     0x124C2
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_MUSH			     0x124C3
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_NE			     0x124C4
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_NE_PLUS_E2		     0x124C5
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_NE_PLUS_GI		     0x124C6
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_SHIM			     0x124C7
#define Z_UNICODE_CUNEIFORM_SIGN_GA2_TIMES_ZIZ2			     0x124C8
#define Z_UNICODE_CUNEIFORM_SIGN_GABA_ROTATED_NINETY_DEGREES	     0x124C9
#define Z_UNICODE_CUNEIFORM_SIGN_GESHTIN_TIMES_U		     0x124CA
#define Z_UNICODE_CUNEIFORM_SIGN_GISH_TIMES_GISH_CROSSING_GISH	     0x124CB
#define Z_UNICODE_CUNEIFORM_SIGN_GU2_TIMES_IGI_GUNU		     0x124CC
#define Z_UNICODE_CUNEIFORM_SIGN_GUD_PLUS_GISH_TIMES_TAK4	     0x124CD
#define Z_UNICODE_CUNEIFORM_SIGN_HA_TENU_GUNU			     0x124CE
#define Z_UNICODE_CUNEIFORM_SIGN_HI_TIMES_ASH_OVER_HI_TIMES_ASH	     0x124CF
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_BU			     0x124D0
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_KA			     0x124D1
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_U_U_U			     0x124D2
#define Z_UNICODE_CUNEIFORM_SIGN_KA_TIMES_UR			     0x124D3
#define Z_UNICODE_CUNEIFORM_SIGN_LAGAB_TIMES_ZU_OVER_ZU		     0x124D4
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_003			     0x124D5
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_021			     0x124D6
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_025			     0x124D7
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_030			     0x124D8
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_050			     0x124D9
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_051			     0x124DA
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_062			     0x124DB
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_079_OVER_LAK_079_GUNU	     0x124DC
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_080			     0x124DD
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_081_OVER_LAK_081		     0x124DE
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_092			     0x124DF
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_130			     0x124E0
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_142			     0x124E1
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_210			     0x124E2
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_219			     0x124E3
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_220			     0x124E4
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_225			     0x124E5
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_228			     0x124E6
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_238			     0x124E7
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_265			     0x124E8
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_266			     0x124E9
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_343			     0x124EA
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_347			     0x124EB
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_348			     0x124EC
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_383			     0x124ED
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_384			     0x124EE
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_390			     0x124EF
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_441			     0x124F0
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_449			     0x124F1
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_449_TIMES_GU		     0x124F2
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_449_TIMES_IGI		     0x124F3
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_449_TIMES_PAP_PLUS_LU3	     0x124F4
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_449_TIMES_PAP_PLUS_PAP_PLUS_LU3 0x124F5
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_449_TIMES_U2_PLUS_BA	     0x124F6
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_450			     0x124F7
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_457			     0x124F8
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_470			     0x124F9
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_483			     0x124FA
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_490			     0x124FB
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_492			     0x124FC
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_493			     0x124FD
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_495			     0x124FE
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_550			     0x124FF
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_608			     0x12500
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617			     0x12501
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_ASH		     0x12502
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_BAD		     0x12503
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_DUN3_GUNU_GUNU	     0x12504
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_KU3		     0x12505
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_LA		     0x12506
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_TAR		     0x12507
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_TE		     0x12508
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_U2		     0x12509
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_UD		     0x1250A
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_617_TIMES_URUDA		     0x1250B
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_636			     0x1250C
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648			     0x1250D
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_DUB		     0x1250E
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_GA		     0x1250F
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_IGI		     0x12510
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_IGI_GUNU		     0x12511
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_NI		     0x12512
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_PAP_PLUS_PAP_PLUS_LU3 0x12513
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_SHESH_PLUS_KI	     0x12514
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_UD		     0x12515
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_648_TIMES_URUDA		     0x12516
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_724			     0x12517
#define Z_UNICODE_CUNEIFORM_SIGN_LAK_749			     0x12518
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_GUNU_TIMES_ASH		     0x12519
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_DISH			     0x1251A
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_HAL			     0x1251B
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_PAP			     0x1251C
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_PAP_PLUS_PAP_PLUS_LU3     0x1251D
#define Z_UNICODE_CUNEIFORM_SIGN_LU2_TIMES_TAK4			     0x1251E
#define Z_UNICODE_CUNEIFORM_SIGN_MI_PLUS_ZA7			     0x1251F
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH_OVER_MUSH_TIMES_GA	     0x12520
#define Z_UNICODE_CUNEIFORM_SIGN_MUSH_OVER_MUSH_TIMES_KAK	     0x12521
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_DIM_GUNU		     0x12522
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_GISH		     0x12523
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_GUL		     0x12524
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_HI		     0x12525
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_KESH2		     0x12526
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_LAK_050		     0x12527
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_MASH		     0x12528
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_PAP_PLUS_PAP	     0x12529
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_U			     0x1252A
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_U_PLUS_U		     0x1252B
#define Z_UNICODE_CUNEIFORM_SIGN_NINDA2_TIMES_URUDA		     0x1252C
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_GUNU_TIMES_HA		     0x1252D
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_EN			     0x1252E
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_SHE_AT_LEFT		     0x1252F
#define Z_UNICODE_CUNEIFORM_SIGN_SAG_TIMES_TAK4			     0x12530
#define Z_UNICODE_CUNEIFORM_SIGN_SHA6_TENU			     0x12531
#define Z_UNICODE_CUNEIFORM_SIGN_SHE_OVER_SHE			     0x12532
#define Z_UNICODE_CUNEIFORM_SIGN_SHE_PLUS_HUB2			     0x12533
#define Z_UNICODE_CUNEIFORM_SIGN_SHE_PLUS_NAM2			     0x12534
#define Z_UNICODE_CUNEIFORM_SIGN_SHE_PLUS_SAR			     0x12535
#define Z_UNICODE_CUNEIFORM_SIGN_SHU2_PLUS_DUG_TIMES_NI		     0x12536
#define Z_UNICODE_CUNEIFORM_SIGN_SHU2_PLUS_E2_TIMES_AN		     0x12537
#define Z_UNICODE_CUNEIFORM_SIGN_SI_TIMES_TAK4			     0x12538
#define Z_UNICODE_CUNEIFORM_SIGN_TAK4_PLUS_SAG			     0x12539
#define Z_UNICODE_CUNEIFORM_SIGN_TUM_TIMES_GAN2_TENU		     0x1253A
#define Z_UNICODE_CUNEIFORM_SIGN_TUM_TIMES_THREE_DISH		     0x1253B
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_INVERTED			     0x1253C
#define Z_UNICODE_CUNEIFORM_SIGN_UR2_TIMES_UD			     0x1253D
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_DARA3		     0x1253E
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_LAK_668		     0x1253F
#define Z_UNICODE_CUNEIFORM_SIGN_URU_TIMES_LU3			     0x12540
#define Z_UNICODE_CUNEIFORM_SIGN_ZA7				     0x12541
#define Z_UNICODE_CUNEIFORM_SIGN_ZU_OVER_ZU_PLUS_SAR		     0x12542
#define Z_UNICODE_CUNEIFORM_SIGN_ZU5_TIMES_THREE_DISH_TENU	     0x12543

/* MARK: - 13000h-1342Fh - Egyptian Hieroglyphs */

#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A001   0x13000
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A002   0x13001
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A003   0x13002
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A004   0x13003
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A005   0x13004
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A005A  0x13005
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A006   0x13006
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A006A  0x13007
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A006B  0x13008
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A007   0x13009
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A008   0x1300A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A009   0x1300B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A010   0x1300C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A011   0x1300D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A012   0x1300E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A013   0x1300F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A014   0x13010
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A014A  0x13011
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A015   0x13012
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A016   0x13013
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A017   0x13014
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A017A  0x13015
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A018   0x13016
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A019   0x13017
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A020   0x13018
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A021   0x13019
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A022   0x1301A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A023   0x1301B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A024   0x1301C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A025   0x1301D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A026   0x1301E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A027   0x1301F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A028   0x13020
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A029   0x13021
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A030   0x13022
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A031   0x13023
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A032   0x13024
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A032A  0x13025
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A033   0x13026
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A034   0x13027
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A035   0x13028
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A036   0x13029
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A037   0x1302A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A038   0x1302B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A039   0x1302C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A040   0x1302D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A040A  0x1302E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A041   0x1302F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A042   0x13030
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A042A  0x13031
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A043   0x13032
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A043A  0x13033
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A044   0x13034
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A045   0x13035
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A045A  0x13036
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A046   0x13037
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A047   0x13038
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A048   0x13039
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A049   0x1303A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A050   0x1303B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A051   0x1303C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A052   0x1303D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A053   0x1303E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A054   0x1303F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A055   0x13040
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A056   0x13041
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A057   0x13042
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A058   0x13043
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A059   0x13044
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A060   0x13045
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A061   0x13046
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A062   0x13047
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A063   0x13048
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A064   0x13049
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A065   0x1304A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A066   0x1304B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A067   0x1304C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A068   0x1304D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A069   0x1304E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_A070   0x1304F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B001   0x13050
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B002   0x13051
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B003   0x13052
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B004   0x13053
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B005   0x13054
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B005A  0x13055
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B006   0x13056
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B007   0x13057
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B008   0x13058
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_B009   0x13059
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C001   0x1305A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C002   0x1305B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C002A  0x1305C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C002B  0x1305D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C002C  0x1305E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C003   0x1305F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C004   0x13060
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C005   0x13061
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C006   0x13062
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C007   0x13063
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C008   0x13064
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C009   0x13065
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C010   0x13066
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C010A  0x13067
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C011   0x13068
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C012   0x13069
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C013   0x1306A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C014   0x1306B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C015   0x1306C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C016   0x1306D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C017   0x1306E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C018   0x1306F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C019   0x13070
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C020   0x13071
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C021   0x13072
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C022   0x13073
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C023   0x13074
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_C024   0x13075
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D001   0x13076
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D002   0x13077
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D003   0x13078
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D004   0x13079
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D005   0x1307A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D006   0x1307B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D007   0x1307C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D008   0x1307D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D008A  0x1307E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D009   0x1307F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D010   0x13080
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D011   0x13081
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D012   0x13082
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D013   0x13083
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D014   0x13084
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D015   0x13085
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D016   0x13086
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D017   0x13087
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D018   0x13088
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D019   0x13089
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D020   0x1308A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D021   0x1308B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D022   0x1308C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D023   0x1308D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D024   0x1308E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D025   0x1308F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D026   0x13090
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D027   0x13091
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D027A  0x13092
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D028   0x13093
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D029   0x13094
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D030   0x13095
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D031   0x13096
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D031A  0x13097
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D032   0x13098
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D033   0x13099
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D034   0x1309A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D034A  0x1309B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D035   0x1309C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D036   0x1309D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D037   0x1309E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D038   0x1309F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D039   0x130A0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D040   0x130A1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D041   0x130A2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D042   0x130A3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D043   0x130A4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D044   0x130A5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D045   0x130A6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D046   0x130A7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D046A  0x130A8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D047   0x130A9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D048   0x130AA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D048A  0x130AB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D049   0x130AC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050   0x130AD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050A  0x130AE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050B  0x130AF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050C  0x130B0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050D  0x130B1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050E  0x130B2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050F  0x130B3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050G  0x130B4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050H  0x130B5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D050I  0x130B6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D051   0x130B7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D052   0x130B8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D052A  0x130B9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D053   0x130BA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D054   0x130BB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D054A  0x130BC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D055   0x130BD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D056   0x130BE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D057   0x130BF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D058   0x130C0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D059   0x130C1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D060   0x130C2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D061   0x130C3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D062   0x130C4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D063   0x130C5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D064   0x130C6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D065   0x130C7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D066   0x130C8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067   0x130C9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067A  0x130CA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067B  0x130CB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067C  0x130CC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067D  0x130CD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067E  0x130CE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067F  0x130CF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067G  0x130D0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_D067H  0x130D1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E001   0x130D2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E002   0x130D3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E003   0x130D4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E004   0x130D5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E005   0x130D6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E006   0x130D7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E007   0x130D8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E008   0x130D9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E008A  0x130DA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E009   0x130DB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E009A  0x130DC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E010   0x130DD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E011   0x130DE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E012   0x130DF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E013   0x130E0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E014   0x130E1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E015   0x130E2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E016   0x130E3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E016A  0x130E4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E017   0x130E5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E017A  0x130E6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E018   0x130E7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E019   0x130E8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E020   0x130E9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E020A  0x130EA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E021   0x130EB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E022   0x130EC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E023   0x130ED
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E024   0x130EE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E025   0x130EF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E026   0x130F0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E027   0x130F1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E028   0x130F2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E028A  0x130F3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E029   0x130F4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E030   0x130F5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E031   0x130F6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E032   0x130F7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E033   0x130F8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E034   0x130F9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E034A  0x130FA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E036   0x130FB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E037   0x130FC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_E038   0x130FD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F001   0x130FE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F001A  0x130FF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F002   0x13100
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F003   0x13101
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F004   0x13102
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F005   0x13103
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F006   0x13104
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F007   0x13105
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F008   0x13106
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F009   0x13107
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F010   0x13108
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F011   0x13109
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F012   0x1310A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F013   0x1310B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F013A  0x1310C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F014   0x1310D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F015   0x1310E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F016   0x1310F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F017   0x13110
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F018   0x13111
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F019   0x13112
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F020   0x13113
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F021   0x13114
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F021A  0x13115
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F022   0x13116
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F023   0x13117
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F024   0x13118
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F025   0x13119
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F026   0x1311A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F027   0x1311B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F028   0x1311C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F029   0x1311D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F030   0x1311E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F031   0x1311F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F031A  0x13120
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F032   0x13121
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F033   0x13122
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F034   0x13123
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F035   0x13124
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F036   0x13125
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F037   0x13126
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F037A  0x13127
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F038   0x13128
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F038A  0x13129
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F039   0x1312A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F040   0x1312B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F041   0x1312C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F042   0x1312D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F043   0x1312E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F044   0x1312F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F045   0x13130
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F045A  0x13131
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F046   0x13132
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F046A  0x13133
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F047   0x13134
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F047A  0x13135
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F048   0x13136
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F049   0x13137
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F050   0x13138
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F051   0x13139
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F051A  0x1313A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F051B  0x1313B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F051C  0x1313C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F052   0x1313D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_F053   0x1313E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G001   0x1313F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G002   0x13140
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G003   0x13141
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G004   0x13142
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G005   0x13143
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G006   0x13144
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G006A  0x13145
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G007   0x13146
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G007A  0x13147
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G007B  0x13148
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G008   0x13149
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G009   0x1314A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G010   0x1314B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G011   0x1314C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G011A  0x1314D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G012   0x1314E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G013   0x1314F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G014   0x13150
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G015   0x13151
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G016   0x13152
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G017   0x13153
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G018   0x13154
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G019   0x13155
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G020   0x13156
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G020A  0x13157
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G021   0x13158
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G022   0x13159
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G023   0x1315A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G024   0x1315B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G025   0x1315C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G026   0x1315D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G026A  0x1315E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G027   0x1315F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G028   0x13160
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G029   0x13161
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G030   0x13162
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G031   0x13163
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G032   0x13164
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G033   0x13165
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G034   0x13166
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G035   0x13167
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G036   0x13168
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G036A  0x13169
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G037   0x1316A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G037A  0x1316B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G038   0x1316C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G039   0x1316D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G040   0x1316E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G041   0x1316F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G042   0x13170
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G043   0x13171
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G043A  0x13172
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G044   0x13173
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G045   0x13174
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G045A  0x13175
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G046   0x13176
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G047   0x13177
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G048   0x13178
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G049   0x13179
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G050   0x1317A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G051   0x1317B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G052   0x1317C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G053   0x1317D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_G054   0x1317E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H001   0x1317F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H002   0x13180
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H003   0x13181
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H004   0x13182
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H005   0x13183
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H006   0x13184
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H006A  0x13185
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H007   0x13186
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_H008   0x13187
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I001   0x13188
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I002   0x13189
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I003   0x1318A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I004   0x1318B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I005   0x1318C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I005A  0x1318D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I006   0x1318E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I007   0x1318F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I008   0x13190
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I009   0x13191
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I009A  0x13192
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I010   0x13193
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I010A  0x13194
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I011   0x13195
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I011A  0x13196
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I012   0x13197
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I013   0x13198
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I014   0x13199
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_I015   0x1319A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_K001   0x1319B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_K002   0x1319C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_K003   0x1319D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_K004   0x1319E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_K005   0x1319F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_K006   0x131A0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_K007   0x131A1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_K008   0x131A2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L001   0x131A3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L002   0x131A4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L002A  0x131A5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L003   0x131A6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L004   0x131A7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L005   0x131A8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L006   0x131A9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L006A  0x131AA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L007   0x131AB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_L008   0x131AC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M001   0x131AD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M001A  0x131AE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M001B  0x131AF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M002   0x131B0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M003   0x131B1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M003A  0x131B2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M004   0x131B3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M005   0x131B4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M006   0x131B5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M007   0x131B6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M008   0x131B7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M009   0x131B8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M010   0x131B9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M010A  0x131BA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M011   0x131BB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012   0x131BC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012A  0x131BD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012B  0x131BE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012C  0x131BF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012D  0x131C0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012E  0x131C1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012F  0x131C2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012G  0x131C3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M012H  0x131C4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M013   0x131C5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M014   0x131C6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M015   0x131C7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M015A  0x131C8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M016   0x131C9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M016A  0x131CA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M017   0x131CB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M017A  0x131CC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M018   0x131CD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M019   0x131CE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M020   0x131CF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M021   0x131D0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M022   0x131D1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M022A  0x131D2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M023   0x131D3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M024   0x131D4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M024A  0x131D5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M025   0x131D6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M026   0x131D7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M027   0x131D8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M028   0x131D9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M028A  0x131DA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M029   0x131DB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M030   0x131DC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M031   0x131DD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M031A  0x131DE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M032   0x131DF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M033   0x131E0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M033A  0x131E1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M033B  0x131E2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M034   0x131E3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M035   0x131E4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M036   0x131E5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M037   0x131E6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M038   0x131E7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M039   0x131E8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M040   0x131E9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M040A  0x131EA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M041   0x131EB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M042   0x131EC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M043   0x131ED
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_M044   0x131EE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N001   0x131EF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N002   0x131F0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N003   0x131F1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N004   0x131F2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N005   0x131F3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N006   0x131F4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N007   0x131F5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N008   0x131F6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N009   0x131F7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N010   0x131F8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N011   0x131F9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N012   0x131FA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N013   0x131FB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N014   0x131FC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N015   0x131FD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N016   0x131FE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N017   0x131FF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N018   0x13200
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N018A  0x13201
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N018B  0x13202
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N019   0x13203
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N020   0x13204
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N021   0x13205
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N022   0x13206
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N023   0x13207
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N024   0x13208
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N025   0x13209
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N025A  0x1320A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N026   0x1320B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N027   0x1320C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N028   0x1320D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N029   0x1320E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N030   0x1320F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N031   0x13210
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N032   0x13211
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N033   0x13212
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N033A  0x13213
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N034   0x13214
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N034A  0x13215
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N035   0x13216
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N035A  0x13217
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N036   0x13218
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N037   0x13219
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N037A  0x1321A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N038   0x1321B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N039   0x1321C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N040   0x1321D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N041   0x1321E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_N042   0x1321F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL001  0x13220
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL002  0x13221
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL003  0x13222
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL004  0x13223
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL005  0x13224
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL005A 0x13225
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL006  0x13226
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL007  0x13227
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL008  0x13228
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL009  0x13229
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL010  0x1322A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL011  0x1322B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL012  0x1322C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL013  0x1322D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL014  0x1322E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL015  0x1322F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL016  0x13230
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL017  0x13231
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL017A 0x13232
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL018  0x13233
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL019  0x13234
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NL020  0x13235
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU001  0x13236
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU002  0x13237
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU003  0x13238
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU004  0x13239
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU005  0x1323A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU006  0x1323B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU007  0x1323C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU008  0x1323D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU009  0x1323E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU010  0x1323F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU010A 0x13240
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU011  0x13241
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU011A 0x13242
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU012  0x13243
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU013  0x13244
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU014  0x13245
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU015  0x13246
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU016  0x13247
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU017  0x13248
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU018  0x13249
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU018A 0x1324A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU019  0x1324B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU020  0x1324C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU021  0x1324D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU022  0x1324E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_NU022A 0x1324F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O001   0x13250
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O001A  0x13251
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O002   0x13252
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O003   0x13253
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O004   0x13254
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O005   0x13255
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O005A  0x13256
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O006   0x13257
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O006A  0x13258
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O006B  0x13259
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O006C  0x1325A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O006D  0x1325B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O006E  0x1325C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O006F  0x1325D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O007   0x1325E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O008   0x1325F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O009   0x13260
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O010   0x13261
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O010A  0x13262
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O010B  0x13263
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O010C  0x13264
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O011   0x13265
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O012   0x13266
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O013   0x13267
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O014   0x13268
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O015   0x13269
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O016   0x1326A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O017   0x1326B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O018   0x1326C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O019   0x1326D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O019A  0x1326E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O020   0x1326F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O020A  0x13270
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O021   0x13271
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O022   0x13272
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O023   0x13273
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O024   0x13274
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O024A  0x13275
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O025   0x13276
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O025A  0x13277
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O026   0x13278
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O027   0x13279
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O028   0x1327A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O029   0x1327B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O029A  0x1327C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O030   0x1327D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O030A  0x1327E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O031   0x1327F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O032   0x13280
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O033   0x13281
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O033A  0x13282
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O034   0x13283
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O035   0x13284
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O036   0x13285
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O036A  0x13286
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O036B  0x13287
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O036C  0x13288
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O036D  0x13289
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O037   0x1328A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O038   0x1328B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O039   0x1328C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O040   0x1328D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O041   0x1328E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O042   0x1328F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O043   0x13290
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O044   0x13291
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O045   0x13292
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O046   0x13293
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O047   0x13294
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O048   0x13295
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O049   0x13296
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O050   0x13297
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O050A  0x13298
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O050B  0x13299
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_O051   0x1329A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P001   0x1329B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P001A  0x1329C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P002   0x1329D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P003   0x1329E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P003A  0x1329F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P004   0x132A0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P005   0x132A1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P006   0x132A2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P007   0x132A3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P008   0x132A4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P009   0x132A5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P010   0x132A6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_P011   0x132A7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Q001   0x132A8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Q002   0x132A9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Q003   0x132AA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Q004   0x132AB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Q005   0x132AC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Q006   0x132AD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Q007   0x132AE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R001   0x132AF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R002   0x132B0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R002A  0x132B1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R003   0x132B2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R003A  0x132B3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R003B  0x132B4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R004   0x132B5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R005   0x132B6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R006   0x132B7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R007   0x132B8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R008   0x132B9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R009   0x132BA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R010   0x132BB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R010A  0x132BC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R011   0x132BD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R012   0x132BE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R013   0x132BF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R014   0x132C0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R015   0x132C1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R016   0x132C2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R016A  0x132C3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R017   0x132C4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R018   0x132C5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R019   0x132C6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R020   0x132C7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R021   0x132C8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R022   0x132C9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R023   0x132CA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R024   0x132CB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R025   0x132CC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R026   0x132CD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R027   0x132CE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R028   0x132CF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_R029   0x132D0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S001   0x132D1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S002   0x132D2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S002A  0x132D3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S003   0x132D4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S004   0x132D5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S005   0x132D6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S006   0x132D7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S006A  0x132D8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S007   0x132D9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S008   0x132DA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S009   0x132DB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S010   0x132DC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S011   0x132DD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S012   0x132DE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S013   0x132DF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S014   0x132E0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S014A  0x132E1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S014B  0x132E2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S015   0x132E3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S016   0x132E4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S017   0x132E5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S017A  0x132E6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S018   0x132E7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S019   0x132E8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S020   0x132E9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S021   0x132EA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S022   0x132EB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S023   0x132EC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S024   0x132ED
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S025   0x132EE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S026   0x132EF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S026A  0x132F0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S026B  0x132F1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S027   0x132F2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S028   0x132F3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S029   0x132F4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S030   0x132F5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S031   0x132F6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S032   0x132F7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S033   0x132F8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S034   0x132F9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S035   0x132FA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S035A  0x132FB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S036   0x132FC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S037   0x132FD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S038   0x132FE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S039   0x132FF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S040   0x13300
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S041   0x13301
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S042   0x13302
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S043   0x13303
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S044   0x13304
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S045   0x13305
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_S046   0x13306
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T001   0x13307
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T002   0x13308
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T003   0x13309
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T003A  0x1330A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T004   0x1330B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T005   0x1330C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T006   0x1330D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T007   0x1330E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T007A  0x1330F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T008   0x13310
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T008A  0x13311
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T009   0x13312
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T009A  0x13313
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T010   0x13314
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T011   0x13315
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T011A  0x13316
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T012   0x13317
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T013   0x13318
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T014   0x13319
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T015   0x1331A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T016   0x1331B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T016A  0x1331C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T017   0x1331D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T018   0x1331E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T019   0x1331F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T020   0x13320
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T021   0x13321
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T022   0x13322
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T023   0x13323
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T024   0x13324
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T025   0x13325
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T026   0x13326
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T027   0x13327
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T028   0x13328
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T029   0x13329
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T030   0x1332A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T031   0x1332B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T032   0x1332C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T032A  0x1332D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T033   0x1332E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T033A  0x1332F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T034   0x13330
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T035   0x13331
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_T036   0x13332
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U001   0x13333
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U002   0x13334
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U003   0x13335
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U004   0x13336
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U005   0x13337
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U006   0x13338
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U006A  0x13339
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U006B  0x1333A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U007   0x1333B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U008   0x1333C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U009   0x1333D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U010   0x1333E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U011   0x1333F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U012   0x13340
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U013   0x13341
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U014   0x13342
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U015   0x13343
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U016   0x13344
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U017   0x13345
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U018   0x13346
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U019   0x13347
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U020   0x13348
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U021   0x13349
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U022   0x1334A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U023   0x1334B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U023A  0x1334C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U024   0x1334D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U025   0x1334E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U026   0x1334F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U027   0x13350
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U028   0x13351
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U029   0x13352
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U029A  0x13353
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U030   0x13354
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U031   0x13355
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U032   0x13356
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U032A  0x13357
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U033   0x13358
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U034   0x13359
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U035   0x1335A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U036   0x1335B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U037   0x1335C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U038   0x1335D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U039   0x1335E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U040   0x1335F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U041   0x13360
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_U042   0x13361
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001   0x13362
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001A  0x13363
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001B  0x13364
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001C  0x13365
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001D  0x13366
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001E  0x13367
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001F  0x13368
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001G  0x13369
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001H  0x1336A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V001I  0x1336B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V002   0x1336C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V002A  0x1336D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V003   0x1336E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V004   0x1336F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V005   0x13370
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V006   0x13371
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V007   0x13372
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V007A  0x13373
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V007B  0x13374
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V008   0x13375
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V009   0x13376
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V010   0x13377
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V011   0x13378
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V011A  0x13379
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V011B  0x1337A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V011C  0x1337B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V012   0x1337C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V012A  0x1337D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V012B  0x1337E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V013   0x1337F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V014   0x13380
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V015   0x13381
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V016   0x13382
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V017   0x13383
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V018   0x13384
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V019   0x13385
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020   0x13386
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020A  0x13387
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020B  0x13388
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020C  0x13389
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020D  0x1338A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020E  0x1338B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020F  0x1338C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020G  0x1338D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020H  0x1338E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020I  0x1338F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020J  0x13390
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020K  0x13391
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V020L  0x13392
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V021   0x13393
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V022   0x13394
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V023   0x13395
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V023A  0x13396
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V024   0x13397
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V025   0x13398
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V026   0x13399
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V027   0x1339A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V028   0x1339B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V028A  0x1339C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V029   0x1339D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V029A  0x1339E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V030   0x1339F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V030A  0x133A0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V031   0x133A1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V031A  0x133A2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V032   0x133A3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V033   0x133A4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V033A  0x133A5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V034   0x133A6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V035   0x133A7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V036   0x133A8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V037   0x133A9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V037A  0x133AA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V038   0x133AB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V039   0x133AC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V040   0x133AD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_V040A  0x133AE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W001   0x133AF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W002   0x133B0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W003   0x133B1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W003A  0x133B2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W004   0x133B3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W005   0x133B4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W006   0x133B5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W007   0x133B6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W008   0x133B7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W009   0x133B8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W009A  0x133B9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W010   0x133BA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W010A  0x133BB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W011   0x133BC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W012   0x133BD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W013   0x133BE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W014   0x133BF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W014A  0x133C0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W015   0x133C1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W016   0x133C2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W017   0x133C3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W017A  0x133C4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W018   0x133C5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W018A  0x133C6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W019   0x133C7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W020   0x133C8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W021   0x133C9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W022   0x133CA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W023   0x133CB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W024   0x133CC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W024A  0x133CD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_W025   0x133CE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X001   0x133CF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X002   0x133D0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X003   0x133D1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X004   0x133D2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X004A  0x133D3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X004B  0x133D4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X005   0x133D5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X006   0x133D6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X006A  0x133D7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X007   0x133D8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X008   0x133D9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_X008A  0x133DA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y001   0x133DB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y001A  0x133DC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y002   0x133DD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y003   0x133DE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y004   0x133DF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y005   0x133E0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y006   0x133E1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y007   0x133E2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Y008   0x133E3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z001   0x133E4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z002   0x133E5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z002A  0x133E6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z002B  0x133E7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z002C  0x133E8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z002D  0x133E9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z003   0x133EA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z003A  0x133EB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z003B  0x133EC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z004   0x133ED
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z004A  0x133EE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z005   0x133EF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z005A  0x133F0
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z006   0x133F1
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z007   0x133F2
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z008   0x133F3
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z009   0x133F4
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z010   0x133F5
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z011   0x133F6
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z012   0x133F7
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z013   0x133F8
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z014   0x133F9
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015   0x133FA
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015A  0x133FB
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015B  0x133FC
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015C  0x133FD
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015D  0x133FE
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015E  0x133FF
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015F  0x13400
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015G  0x13401
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015H  0x13402
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z015I  0x13403
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016   0x13404
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016A  0x13405
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016B  0x13406
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016C  0x13407
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016D  0x13408
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016E  0x13409
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016F  0x1340A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016G  0x1340B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_Z016H  0x1340C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA001  0x1340D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA002  0x1340E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA003  0x1340F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA004  0x13410
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA005  0x13411
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA006  0x13412
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA007  0x13413
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA007A 0x13414
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA007B 0x13415
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA008  0x13416
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA009  0x13417
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA010  0x13418
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA011  0x13419
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA012  0x1341A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA013  0x1341B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA014  0x1341C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA015  0x1341D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA016  0x1341E
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA017  0x1341F
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA018  0x13420
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA019  0x13421
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA020  0x13422
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA021  0x13423
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA022  0x13424
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA023  0x13425
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA024  0x13426
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA025  0x13427
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA026  0x13428
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA027  0x13429
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA028  0x1342A
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA029  0x1342B
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA030  0x1342C
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA031  0x1342D
#define Z_UNICODE_EGYPTIAN_HIEROGLYPH_AA032  0x1342E

/* MARK: - 14400h-1467Fh - Anatolian Hieroglyphs */

#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A001			0x14400
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A002			0x14401
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A003			0x14402
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A004			0x14403
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A005			0x14404
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A006			0x14405
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A007			0x14406
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A008			0x14407
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A009			0x14408
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A010			0x14409
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A010A			0x1440A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A011			0x1440B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A012			0x1440C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A013			0x1440D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A014			0x1440E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A015			0x1440F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A016			0x14410
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A017			0x14411
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A018			0x14412
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A019			0x14413
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A020			0x14414
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A021			0x14415
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A022			0x14416
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A023			0x14417
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A024			0x14418
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A025			0x14419
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A026			0x1441A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A026A			0x1441B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A027			0x1441C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A028			0x1441D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A029			0x1441E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A030			0x1441F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A031			0x14420
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A032			0x14421
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A033			0x14422
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A034			0x14423
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A035			0x14424
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A036			0x14425
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A037			0x14426
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A038			0x14427
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A039			0x14428
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A039A			0x14429
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A040			0x1442A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A041			0x1442B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A041A			0x1442C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A042			0x1442D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A043			0x1442E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A044			0x1442F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A045			0x14430
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A045A			0x14431
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A046			0x14432
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A046A			0x14433
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A046B			0x14434
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A047			0x14435
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A048			0x14436
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A049			0x14437
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A050			0x14438
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A051			0x14439
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A052			0x1443A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A053			0x1443B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A054			0x1443C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A055			0x1443D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A056			0x1443E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A057			0x1443F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A058			0x14440
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A059			0x14441
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A060			0x14442
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A061			0x14443
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A062			0x14444
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A063			0x14445
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A064			0x14446
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A065			0x14447
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A066			0x14448
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A066A			0x14449
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A066B			0x1444A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A066C			0x1444B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A067			0x1444C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A068			0x1444D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A069			0x1444E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A070			0x1444F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A071			0x14450
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A072			0x14451
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A073			0x14452
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A074			0x14453
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A075			0x14454
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A076			0x14455
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A077			0x14456
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A078			0x14457
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A079			0x14458
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A080			0x14459
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A081			0x1445A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A082			0x1445B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A083			0x1445C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A084			0x1445D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A085			0x1445E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A086			0x1445F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A087			0x14460
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A088			0x14461
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A089			0x14462
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A090			0x14463
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A091			0x14464
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A092			0x14465
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A093			0x14466
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A094			0x14467
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A095			0x14468
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A096			0x14469
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A097			0x1446A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A097A			0x1446B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A098			0x1446C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A098A			0x1446D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A099			0x1446E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A100			0x1446F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A100A			0x14470
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A101			0x14471
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A101A			0x14472
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A102			0x14473
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A102A			0x14474
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A103			0x14475
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A104			0x14476
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A104A			0x14477
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A104B			0x14478
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A104C			0x14479
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A105			0x1447A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A105A			0x1447B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A105B			0x1447C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A106			0x1447D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A107			0x1447E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A107A			0x1447F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A107B			0x14480
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A107C			0x14481
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A108			0x14482
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A109			0x14483
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A110			0x14484
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A110A			0x14485
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A110B			0x14486
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A111			0x14487
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A112			0x14488
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A113			0x14489
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A114			0x1448A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A115			0x1448B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A115A			0x1448C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A116			0x1448D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A117			0x1448E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A118			0x1448F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A119			0x14490
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A120			0x14491
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A121			0x14492
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A122			0x14493
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A123			0x14494
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A124			0x14495
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A125			0x14496
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A125A			0x14497
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A126			0x14498
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A127			0x14499
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A128			0x1449A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A129			0x1449B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A130			0x1449C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A131			0x1449D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A132			0x1449E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A133			0x1449F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A134			0x144A0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A135			0x144A1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A135A			0x144A2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A136			0x144A3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A137			0x144A4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A138			0x144A5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A139			0x144A6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A140			0x144A7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A141			0x144A8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A142			0x144A9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A143			0x144AA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A144			0x144AB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A145			0x144AC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A146			0x144AD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A147			0x144AE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A148			0x144AF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A149			0x144B0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A150			0x144B1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A151			0x144B2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A152			0x144B3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A153			0x144B4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A154			0x144B5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A155			0x144B6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A156			0x144B7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A157			0x144B8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A158			0x144B9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A159			0x144BA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A160			0x144BB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A161			0x144BC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A162			0x144BD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A163			0x144BE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A164			0x144BF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A165			0x144C0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A166			0x144C1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A167			0x144C2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A168			0x144C3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A169			0x144C4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A170			0x144C5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A171			0x144C6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A172			0x144C7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A173			0x144C8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A174			0x144C9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A175			0x144CA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A176			0x144CB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A177			0x144CC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A178			0x144CD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A179			0x144CE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A180			0x144CF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A181			0x144D0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A182			0x144D1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A183			0x144D2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A184			0x144D3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A185			0x144D4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A186			0x144D5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A187			0x144D6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A188			0x144D7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A189			0x144D8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A190			0x144D9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A191			0x144DA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A192			0x144DB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A193			0x144DC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A194			0x144DD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A195			0x144DE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A196			0x144DF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A197			0x144E0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A198			0x144E1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A199			0x144E2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A200			0x144E3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A201			0x144E4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A202			0x144E5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A202A			0x144E6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A202B			0x144E7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A203			0x144E8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A204			0x144E9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A205			0x144EA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A206			0x144EB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A207			0x144EC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A207A			0x144ED
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A208			0x144EE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A209			0x144EF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A209A			0x144F0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A210			0x144F1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A211			0x144F2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A212			0x144F3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A213			0x144F4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A214			0x144F5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A215			0x144F6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A215A			0x144F7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A216			0x144F8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A216A			0x144F9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A217			0x144FA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A218			0x144FB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A219			0x144FC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A220			0x144FD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A221			0x144FE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A222			0x144FF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A223			0x14500
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A224			0x14501
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A225			0x14502
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A226			0x14503
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A227			0x14504
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A227A			0x14505
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A228			0x14506
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A229			0x14507
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A230			0x14508
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A231			0x14509
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A232			0x1450A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A233			0x1450B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A234			0x1450C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A235			0x1450D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A236			0x1450E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A237			0x1450F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A238			0x14510
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A239			0x14511
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A240			0x14512
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A241			0x14513
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A242			0x14514
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A243			0x14515
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A244			0x14516
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A245			0x14517
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A246			0x14518
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A247			0x14519
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A248			0x1451A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A249			0x1451B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A250			0x1451C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A251			0x1451D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A252			0x1451E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A253			0x1451F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A254			0x14520
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A255			0x14521
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A256			0x14522
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A257			0x14523
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A258			0x14524
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A259			0x14525
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A260			0x14526
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A261			0x14527
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A262			0x14528
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A263			0x14529
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A264			0x1452A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A265			0x1452B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A266			0x1452C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A267			0x1452D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A267A			0x1452E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A268			0x1452F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A269			0x14530
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A270			0x14531
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A271			0x14532
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A272			0x14533
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A273			0x14534
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A274			0x14535
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A275			0x14536
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A276			0x14537
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A277			0x14538
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A278			0x14539
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A279			0x1453A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A280			0x1453B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A281			0x1453C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A282			0x1453D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A283			0x1453E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A284			0x1453F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A285			0x14540
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A286			0x14541
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A287			0x14542
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A288			0x14543
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A289			0x14544
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A289A			0x14545
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A290			0x14546
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A291			0x14547
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A292			0x14548
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A293			0x14549
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A294			0x1454A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A294A			0x1454B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A295			0x1454C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A296			0x1454D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A297			0x1454E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A298			0x1454F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A299			0x14550
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A299A			0x14551
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A300			0x14552
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A301			0x14553
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A302			0x14554
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A303			0x14555
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A304			0x14556
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A305			0x14557
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A306			0x14558
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A307			0x14559
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A308			0x1455A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A309			0x1455B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A309A			0x1455C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A310			0x1455D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A311			0x1455E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A312			0x1455F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A313			0x14560
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A314			0x14561
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A315			0x14562
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A316			0x14563
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A317			0x14564
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A318			0x14565
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A319			0x14566
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A320			0x14567
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A321			0x14568
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A322			0x14569
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A323			0x1456A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A324			0x1456B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A325			0x1456C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A326			0x1456D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A327			0x1456E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A328			0x1456F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A329			0x14570
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A329A			0x14571
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A330			0x14572
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A331			0x14573
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A332A			0x14574
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A332B			0x14575
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A332C			0x14576
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A333			0x14577
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A334			0x14578
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A335			0x14579
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A336			0x1457A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A336A			0x1457B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A336B			0x1457C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A336C			0x1457D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A337			0x1457E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A338			0x1457F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A339			0x14580
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A340			0x14581
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A341			0x14582
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A342			0x14583
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A343			0x14584
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A344			0x14585
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A345			0x14586
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A346			0x14587
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A347			0x14588
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A348			0x14589
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A349			0x1458A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A350			0x1458B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A351			0x1458C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A352			0x1458D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A353			0x1458E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A354			0x1458F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A355			0x14590
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A356			0x14591
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A357			0x14592
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A358			0x14593
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A359			0x14594
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A359A			0x14595
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A360			0x14596
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A361			0x14597
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A362			0x14598
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A363			0x14599
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A364			0x1459A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A364A			0x1459B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A365			0x1459C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A366			0x1459D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A367			0x1459E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A368			0x1459F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A368A			0x145A0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A369			0x145A1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A370			0x145A2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A371			0x145A3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A371A			0x145A4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A372			0x145A5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A373			0x145A6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A374			0x145A7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A375			0x145A8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A376			0x145A9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A377			0x145AA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A378			0x145AB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A379			0x145AC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A380			0x145AD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A381			0x145AE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A381A			0x145AF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A382			0x145B0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A383_RA_OR_RI		0x145B1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A383A			0x145B2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A384			0x145B3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A385			0x145B4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A386			0x145B5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A386A			0x145B6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A387			0x145B7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A388			0x145B8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A389			0x145B9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A390			0x145BA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A391			0x145BB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A392			0x145BC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A393_EIGHT		0x145BD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A394			0x145BE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A395			0x145BF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A396			0x145C0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A397			0x145C1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A398			0x145C2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A399			0x145C3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A400			0x145C4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A401			0x145C5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A402			0x145C6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A403			0x145C7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A404			0x145C8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A405			0x145C9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A406			0x145CA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A407			0x145CB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A408			0x145CC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A409			0x145CD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A410_BEGIN_LOGOGRAM_MARK	0x145CE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A410A_END_LOGOGRAM_MARK	0x145CF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A411			0x145D0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A412			0x145D1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A413			0x145D2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A414			0x145D3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A415			0x145D4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A416			0x145D5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A417			0x145D6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A418			0x145D7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A419			0x145D8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A420			0x145D9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A421			0x145DA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A422			0x145DB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A423			0x145DC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A424			0x145DD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A425			0x145DE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A426			0x145DF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A427			0x145E0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A428			0x145E1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A429			0x145E2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A430			0x145E3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A431			0x145E4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A432			0x145E5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A433			0x145E6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A434			0x145E7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A435			0x145E8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A436			0x145E9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A437			0x145EA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A438			0x145EB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A439			0x145EC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A440			0x145ED
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A441			0x145EE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A442			0x145EF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A443			0x145F0
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A444			0x145F1
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A445			0x145F2
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A446			0x145F3
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A447			0x145F4
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A448			0x145F5
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A449			0x145F6
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A450			0x145F7
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A450A			0x145F8
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A451			0x145F9
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A452			0x145FA
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A453			0x145FB
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A454			0x145FC
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A455			0x145FD
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A456			0x145FE
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A457			0x145FF
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A457A			0x14600
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A458			0x14601
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A459			0x14602
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A460			0x14603
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A461			0x14604
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A462			0x14605
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A463			0x14606
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A464			0x14607
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A465			0x14608
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A466			0x14609
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A467			0x1460A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A468			0x1460B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A469			0x1460C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A470			0x1460D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A471			0x1460E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A472			0x1460F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A473			0x14610
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A474			0x14611
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A475			0x14612
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A476			0x14613
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A477			0x14614
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A478			0x14615
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A479			0x14616
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A480			0x14617
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A481			0x14618
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A482			0x14619
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A483			0x1461A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A484			0x1461B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A485			0x1461C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A486			0x1461D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A487			0x1461E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A488			0x1461F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A489			0x14620
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A490			0x14621
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A491			0x14622
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A492			0x14623
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A493			0x14624
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A494			0x14625
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A495			0x14626
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A496			0x14627
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A497			0x14628
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A501			0x14629
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A502			0x1462A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A503			0x1462B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A504			0x1462C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A505			0x1462D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A506			0x1462E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A507			0x1462F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A508			0x14630
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A509			0x14631
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A510			0x14632
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A511			0x14633
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A512			0x14634
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A513			0x14635
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A514			0x14636
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A515			0x14637
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A516			0x14638
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A517			0x14639
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A518			0x1463A
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A519			0x1463B
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A520			0x1463C
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A521			0x1463D
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A522			0x1463E
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A523			0x1463F
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A524			0x14640
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A525			0x14641
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A526			0x14642
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A527			0x14643
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A528			0x14644
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A529			0x14645
#define Z_UNICODE_ANATOLIAN_HIEROGLYPH_A530			0x14646

/* MARK: - 16800h-16A3Fh - Bamum Supplement */

#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NGKUE_MFON	      0x16800
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_GBIEE_FON	      0x16801
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PON_MFON_PIPAEMGBIEE   0x16802
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PON_MFON_PIPAEMBA      0x16803
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NAA_MFON		      0x16804
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SHUENSHUET	      0x16805
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_TITA_MFON	      0x16806
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NZA_MFON		      0x16807
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SHINDA_PA_NJI	      0x16808
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PON_PA_NJI_PIPAEMGBIEE 0x16809
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PON_PA_NJI_PIPAEMBA    0x1680A
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MAEMBGBIEE	      0x1680B
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_TU_MAEMBA	      0x1680C
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NGANGU		      0x1680D
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MAEMVEUX		      0x1680E
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MANSUAE		      0x1680F
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MVEUAENGAM	      0x16810
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SEUNYAM		      0x16811
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NTOQPEN		      0x16812
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_KEUKEUTNDA	      0x16813
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NKINDI		      0x16814
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SUU		      0x16815
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NGKUENZEUM	      0x16816
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_LAPAQ		      0x16817
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_LET_KUT		      0x16818
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NTAP_MFAA	      0x16819
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MAEKEUP		      0x1681A
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PASHAE		      0x1681B
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_GHEUAERAE	      0x1681C
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PAMSHAE		      0x1681D
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MON_NGGEUAET	      0x1681E
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NZUN_MEUT	      0x1681F
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_U_YUQ_NAE	      0x16820
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_GHEUAEGHEUAE	      0x16821
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NTAP_NTAA	      0x16822
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SISA		      0x16823
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MGBASA		      0x16824
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MEUNJOMNDEUQ	      0x16825
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MOOMPUQ		      0x16826
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_KAFA		      0x16827
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PA_LEERAEWA	      0x16828
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NDA_LEERAEWA	      0x16829
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PET		      0x1682A
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MAEMKPEN		      0x1682B
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NIKA		      0x1682C
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PUP		      0x1682D
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_TUAEP		      0x1682E
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_LUAEP		      0x1682F
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SONJAM		      0x16830
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_TEUTEUWEN	      0x16831
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MAENYI		      0x16832
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_KET		      0x16833
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NDAANGGEUAET	      0x16834
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_KUOQ		      0x16835
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MOOMEUT		      0x16836
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SHUM		      0x16837
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_LOMMAE		      0x16838
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_FIRI		      0x16839
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_ROM		      0x1683A
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_KPOQ		      0x1683B
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SOQ		      0x1683C
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MAP_PIEET	      0x1683D
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SHIRAE		      0x1683E
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NTAP		      0x1683F
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SHOQ_NSHUT_YUM	      0x16840
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NYIT_MONGKEUAEQ	      0x16841
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PAARAE		      0x16842
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NKAARAE		      0x16843
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_UNKNOWN		      0x16844
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NGGEN		      0x16845
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MAESI		      0x16846
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NJAM		      0x16847
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MBANYI		      0x16848
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NYET		      0x16849
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_TEUAEN		      0x1684A
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_SOT		      0x1684B
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_PAAM		      0x1684C
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NSHIEE		      0x1684D
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MAEM		      0x1684E
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NYI		      0x1684F
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_KAQ		      0x16850
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NSHA		      0x16851
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_VEE		      0x16852
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_LU		      0x16853
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NEN		      0x16854
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_NAQ		      0x16855
#define Z_UNICODE_BAMUM_LETTER_PHASE_A_MBAQ		      0x16856
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NSHUET		      0x16857
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_TU_MAEMGBIEE	      0x16858
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_SIEE		      0x16859
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_SET_TU		      0x1685A
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_LOM_NTEUM	      0x1685B
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MBA_MAELEE	      0x1685C
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_KIEEM		      0x1685D
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_YEURAE		      0x1685E
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MBAARAE		      0x1685F
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_KAM		      0x16860
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_PEESHI		      0x16861
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_YAFU_LEERAEWA	      0x16862
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_LAM_NSHUT_NYAM	      0x16863
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NTIEE_SHEUOQ	      0x16864
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NDU_NJAA		      0x16865
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_GHEUGHEUAEM	      0x16866
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_PIT		      0x16867
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_TU_NSIEE		      0x16868
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_SHET_NJAQ	      0x16869
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_SHEUAEQTU	      0x1686A
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MFON_TEUAEQ	      0x1686B
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MBIT_MBAAKET	      0x1686C
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NYI_NTEUM	      0x1686D
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_KEUPUQ		      0x1686E
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_GHEUGHEN		      0x1686F
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_KEUYEUX		      0x16870
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_LAANAE		      0x16871
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_PARUM		      0x16872
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_VEUM		      0x16873
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NGKINDI_MVOP	      0x16874
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NGGEU_MBU	      0x16875
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_WUAET		      0x16876
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_SAKEUAE		      0x16877
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_TAAM		      0x16878
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MEUQ		      0x16879
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NGGUOQ		      0x1687A
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NGGUOQ_LARGE	      0x1687B
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MFIYAQ		      0x1687C
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_SUE		      0x1687D
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MBEURI		      0x1687E
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MONTIEEN		      0x1687F
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NYAEMAE		      0x16880
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_PUNGAAM		      0x16881
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MEUT_NGGEET	      0x16882
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_FEUX		      0x16883
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MBUOQ		      0x16884
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_FEE		      0x16885
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_KEUAEM		      0x16886
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MA_NJEUAENA	      0x16887
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MA_NJUQA		      0x16888
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_LET		      0x16889
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NGGAAM		      0x1688A
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NSEN		      0x1688B
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_MA		      0x1688C
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_KIQ		      0x1688D
#define Z_UNICODE_BAMUM_LETTER_PHASE_B_NGOM		      0x1688E
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGKUE_MAEMBA	      0x1688F
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NZA		      0x16890
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_YUM		      0x16891
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_WANGKUOQ		      0x16892
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGGEN		      0x16893
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NDEUAEREE	      0x16894
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGKAQ		      0x16895
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_GHARAE		      0x16896
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBEEKEET		      0x16897
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_GBAYI		      0x16898
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NYIR_MKPARAQ_MEUN      0x16899
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NTU_MBIT		      0x1689A
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBEUM		      0x1689B
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_PIRIEEN		      0x1689C
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NDOMBU		      0x1689D
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBAA_CABBAGE_TREE      0x1689E
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KEUSHEUAEP	      0x1689F
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_GHAP		      0x168A0
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KEUKAQ		      0x168A1
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_YU_MUOMAE	      0x168A2
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NZEUM		      0x168A3
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBUE		      0x168A4
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NSEUAEN		      0x168A5
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBIT		      0x168A6
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_YEUQ		      0x168A7
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KPARAQ		      0x168A8
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KAA		      0x168A9
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_SEUX		      0x168AA
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NDIDA		      0x168AB
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_TAASHAE		      0x168AC
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NJUEQ		      0x168AD
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_TITA_YUE		      0x168AE
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_SUAET		      0x168AF
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGGUAEN_NYAM	      0x168B0
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_VEUX		      0x168B1
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NANSANAQ		      0x168B2
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MA_KEUAERI	      0x168B3
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NTAA		      0x168B4
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGGUON		      0x168B5
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_LAP		      0x168B6
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBIRIEEN		      0x168B7
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MGBASAQ		      0x168B8
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NTEUNGBA		      0x168B9
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_TEUTEUX		      0x168BA
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGGUM		      0x168BB
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_FUE		      0x168BC
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NDEUT		      0x168BD
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NSA		      0x168BE
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NSHAQ		      0x168BF
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_BUNG		      0x168C0
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_VEUAEPEN		      0x168C1
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBERAE		      0x168C2
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_RU		      0x168C3
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NJAEM		      0x168C4
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_LAM		      0x168C5
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_TITUAEP		      0x168C6
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NSUOT_NGOM	      0x168C7
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NJEEEE		      0x168C8
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KET		      0x168C9
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGGU		      0x168CA
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MAESI		      0x168CB
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBUAEM		      0x168CC
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_LU		      0x168CD
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KUT		      0x168CE
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NJAM		      0x168CF
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGOM		      0x168D0
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_WUP		      0x168D1
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGGUEET		      0x168D2
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NSOM		      0x168D3
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NTEN		      0x168D4
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KUOP_NKAARAE	      0x168D5
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NSUN		      0x168D6
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NDAM		      0x168D7
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MA_NSIEE		      0x168D8
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_YAA		      0x168D9
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NDAP		      0x168DA
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_SHUEQ		      0x168DB
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_SETFON		      0x168DC
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBI		      0x168DD
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MAEMBA		      0x168DE
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBANYI		      0x168DF
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KEUSEUX		      0x168E0
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBEUX		      0x168E1
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KEUM		      0x168E2
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MBAA_PICKET	      0x168E3
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_YUWOQ		      0x168E4
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NJEUX		      0x168E5
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MIEE		      0x168E6
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_MUAE		      0x168E7
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_SHIQ		      0x168E8
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KEN_LAW		      0x168E9
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_KEN_FATIGUE	      0x168EA
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NGAQ		      0x168EB
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_NAQ		      0x168EC
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_LIQ		      0x168ED
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_PIN		      0x168EE
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_PEN		      0x168EF
#define Z_UNICODE_BAMUM_LETTER_PHASE_C_TET		      0x168F0
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MBUO		      0x168F1
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_WAP		      0x168F2
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NJI		      0x168F3
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MFON		      0x168F4
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NJIEE		      0x168F5
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_LIEE		      0x168F6
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NJEUT		      0x168F7
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NSHEE		      0x168F8
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGGAAMAE		      0x168F9
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NYAM		      0x168FA
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_WUAEN		      0x168FB
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGKUN		      0x168FC
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SHEE		      0x168FD
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGKAP		      0x168FE
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KEUAETMEUN	      0x168FF
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TEUT		      0x16900
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SHEUAE		      0x16901
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NJAP		      0x16902
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SUE		      0x16903
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KET		      0x16904
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_YAEMMAE		      0x16905
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KUOM		      0x16906
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SAP		      0x16907
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MFEUT		      0x16908
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NDEUX		      0x16909
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MALEERI		      0x1690A
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MEUT		      0x1690B
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SEUAEQ		      0x1690C
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_YEN		      0x1690D
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NJEUAEM		      0x1690E
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KEUOT_MBUAE	      0x1690F
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGKEURI		      0x16910
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TU		      0x16911
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_GHAA		      0x16912
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGKYEE		      0x16913
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_FEUFEUAET	      0x16914
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NDEE		      0x16915
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MGBOFUM		      0x16916
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_LEUAEP		      0x16917
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NDON		      0x16918
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MONI		      0x16919
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MGBEUN		      0x1691A
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_PUUT		      0x1691B
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MGBIEE		      0x1691C
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MFO		      0x1691D
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_LUM		      0x1691E
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NSIEEP		      0x1691F
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MBAA		      0x16920
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KWAET		      0x16921
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NYET		      0x16922
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TEUAEN		      0x16923
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SOT		      0x16924
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_YUWOQ		      0x16925
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KEUM		      0x16926
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_RAEM		      0x16927
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TEEEE		      0x16928
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGKEUAEQ		      0x16929
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MFEUAE		      0x1692A
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NSIEET		      0x1692B
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KEUP		      0x1692C
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_PIP		      0x1692D
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_PEUTAE		      0x1692E
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NYUE		      0x1692F
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_LET		      0x16930
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGGAAM		      0x16931
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MFIEE		      0x16932
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGGWAEN		      0x16933
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_YUOM		      0x16934
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_PAP		      0x16935
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_YUOP		      0x16936
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NDAM		      0x16937
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NTEUM		      0x16938
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SUAE		      0x16939
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KUN		      0x1693A
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGGEUX		      0x1693B
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGKIEE		      0x1693C
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TUOT		      0x1693D
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MEUN		      0x1693E
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KUQ		      0x1693F
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NSUM		      0x16940
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TEUN		      0x16941
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MAENJET		      0x16942
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGGAP		      0x16943
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_LEUM		      0x16944
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NGGUOM		      0x16945
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NSHUT		      0x16946
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NJUEQ		      0x16947
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_GHEUAE		      0x16948
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KU		      0x16949
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_REN_OLD		      0x1694A
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TAE		      0x1694B
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TOQ		      0x1694C
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NYI		      0x1694D
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_RII		      0x1694E
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_LEEEE		      0x1694F
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MEEEE		      0x16950
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_M		      0x16951
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SUU		      0x16952
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MU		      0x16953
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SHII		      0x16954
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SHEUX		      0x16955
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_KYEE		      0x16956
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NU		      0x16957
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SHU		      0x16958
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NTEE		      0x16959
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_PEE		      0x1695A
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NI		      0x1695B
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SHOQ		      0x1695C
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_PUQ		      0x1695D
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MVOP		      0x1695E
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_LOQ		      0x1695F
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_REN_MUCH		      0x16960
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_TI		      0x16961
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_NTUU		      0x16962
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_MBAA_SEVEN	      0x16963
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_SAQ		      0x16964
#define Z_UNICODE_BAMUM_LETTER_PHASE_D_FAA		      0x16965
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NDAP		      0x16966
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TOON		      0x16967
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MBEUM		      0x16968
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LAP		      0x16969
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_VOM		      0x1696A
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LOON		      0x1696B
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PAA		      0x1696C
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SOM		      0x1696D
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_RAQ		      0x1696E
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NSHUOP		      0x1696F
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NDUN		      0x16970
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PUAE		      0x16971
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TAM		      0x16972
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGKA		      0x16973
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KPEUX		      0x16974
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_WUO		      0x16975
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SEE		      0x16976
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGGEUAET		      0x16977
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PAAM		      0x16978
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TOO		      0x16979
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KUOP		      0x1697A
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LOM		      0x1697B
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NSHIEE		      0x1697C
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGOP		      0x1697D
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MAEM		      0x1697E
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGKEUX		      0x1697F
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGOQ		      0x16980
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NSHUE		      0x16981
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_RIMGBA		      0x16982
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NJEUX		      0x16983
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PEEM		      0x16984
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SAA		      0x16985
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGGURAE		      0x16986
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MGBA		      0x16987
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_GHEUX		      0x16988
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGKEUAEM		      0x16989
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NJAEMLI		      0x1698A
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MAP		      0x1698B
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LOOT		      0x1698C
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGGEEEE		      0x1698D
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NDIQ		      0x1698E
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TAEN_NTEUM	      0x1698F
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SET		      0x16990
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PUM		      0x16991
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NDAA_SOFTNESS	      0x16992
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGGUAESHAE_NYAM	      0x16993
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YIEE		      0x16994
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_GHEUN		      0x16995
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TUAE		      0x16996
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YEUAE		      0x16997
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PO		      0x16998
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TUMAE		      0x16999
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KEUAE		      0x1699A
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SUAEN		      0x1699B
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TEUAEQ		      0x1699C
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_VEUAE		      0x1699D
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_WEUX		      0x1699E
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LAAM		      0x1699F
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PU		      0x169A0
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TAAQ		      0x169A1
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_GHAAMAE		      0x169A2
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGEUREUT		      0x169A3
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SHEUAEQ		      0x169A4
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MGBEN		      0x169A5
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MBEE		      0x169A6
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NZAQ		      0x169A7
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NKOM		      0x169A8
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_GBET		      0x169A9
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TUM		      0x169AA
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KUET		      0x169AB
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YAP		      0x169AC
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NYI_CLEAVER	      0x169AD
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YIT		      0x169AE
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MFEUQ		      0x169AF
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NDIAQ		      0x169B0
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PIEEQ		      0x169B1
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YUEQ		      0x169B2
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LEUAEM		      0x169B3
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FUE		      0x169B4
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_GBEUX		      0x169B5
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGKUP		      0x169B6
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KET		      0x169B7
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MAE		      0x169B8
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGKAAMI		      0x169B9
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_GHET		      0x169BA
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FA		      0x169BB
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NTUM		      0x169BC
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PEUT		      0x169BD
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YEUM		      0x169BE
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGGEUAE		      0x169BF
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NYI_BETWEEN	      0x169C0
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NZUQ		      0x169C1
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_POON		      0x169C2
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MIEE		      0x169C3
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FUET		      0x169C4
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NAE		      0x169C5
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MUAE		      0x169C6
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_GHEUAE		      0x169C7
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FU_I		      0x169C8
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MVI		      0x169C9
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PUAQ		      0x169CA
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGKUM		      0x169CB
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KUT		      0x169CC
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PIET		      0x169CD
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NTAP		      0x169CE
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YEUAET		      0x169CF
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGGUP		      0x169D0
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PA_PEOPLE	      0x169D1
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FU_CALL		      0x169D2
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FOM		      0x169D3
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NJEE		      0x169D4
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_A		      0x169D5
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TOQ		      0x169D6
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_O		      0x169D7
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_I		      0x169D8
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LAQ		      0x169D9
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PA_PLURAL	      0x169DA
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TAA		      0x169DB
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TAQ		      0x169DC
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NDAA_MY_HOUSE	      0x169DD
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SHIQ		      0x169DE
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YEUX		      0x169DF
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGUAE		      0x169E0
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YUAEN		      0x169E1
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YOQ_SWIMMING	      0x169E2
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YOQ_COVER	      0x169E3
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YUQ		      0x169E4
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_YUN		      0x169E5
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KEUX		      0x169E6
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PEUX		      0x169E7
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NJEE_EPOCH	      0x169E8
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PUE		      0x169E9
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_WUE		      0x169EA
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FEE		      0x169EB
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_VEE		      0x169EC
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LU		      0x169ED
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MI		      0x169EE
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_REUX		      0x169EF
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_RAE		      0x169F0
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGUAET		      0x169F1
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NGA		      0x169F2
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SHO		      0x169F3
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_SHOQ		      0x169F4
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FU_REMEDY	      0x169F5
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_NA		      0x169F6
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_PI		      0x169F7
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_LOQ		      0x169F8
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KO		      0x169F9
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MEN		      0x169FA
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MA		      0x169FB
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MAQ		      0x169FC
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TEU		      0x169FD
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_KI		      0x169FE
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_MON		      0x169FF
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_TEN		      0x16A00
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_FAQ		      0x16A01
#define Z_UNICODE_BAMUM_LETTER_PHASE_E_GHOM		      0x16A02
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_KA		      0x16A03
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_U		      0x16A04
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_KU		      0x16A05
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_EE		      0x16A06
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_REE		      0x16A07
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_TAE		      0x16A08
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NYI		      0x16A09
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_LA		      0x16A0A
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_RII		      0x16A0B
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_RIEE		      0x16A0C
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_MEEEE		      0x16A0D
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_TAA		      0x16A0E
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NDAA		      0x16A0F
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NJAEM		      0x16A10
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_M		      0x16A11
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_SUU		      0x16A12
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_SHII		      0x16A13
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_SI		      0x16A14
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_SEUX		      0x16A15
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_KYEE		      0x16A16
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_KET		      0x16A17
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NUAE		      0x16A18
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NU		      0x16A19
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NJUAE		      0x16A1A
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_YOQ		      0x16A1B
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_SHU		      0x16A1C
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_YA		      0x16A1D
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NSHA		      0x16A1E
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_PEUX		      0x16A1F
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NTEE		      0x16A20
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_WUE		      0x16A21
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_PEE		      0x16A22
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_RU		      0x16A23
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NI		      0x16A24
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_REUX		      0x16A25
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_KEN		      0x16A26
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NGKWAEN		      0x16A27
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_NGGA		      0x16A28
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_SHO		      0x16A29
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_PUAE		      0x16A2A
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_FOM		      0x16A2B
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_WA		      0x16A2C
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_LI		      0x16A2D
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_LOQ		      0x16A2E
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_KO		      0x16A2F
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_MBEN		      0x16A30
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_REN		      0x16A31
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_MA		      0x16A32
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_MO		      0x16A33
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_MBAA		      0x16A34
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_TET		      0x16A35
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_KPA		      0x16A36
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_SAMBA		      0x16A37
#define Z_UNICODE_BAMUM_LETTER_PHASE_F_VUEQ		      0x16A38

/* MARK: - 16A40h-16A6Fh - Mro */

#define Z_UNICODE_MRO_LETTER_TA	   0x16A40
#define Z_UNICODE_MRO_LETTER_NGI   0x16A41
#define Z_UNICODE_MRO_LETTER_YO	   0x16A42
#define Z_UNICODE_MRO_LETTER_MIM   0x16A43
#define Z_UNICODE_MRO_LETTER_BA	   0x16A44
#define Z_UNICODE_MRO_LETTER_DA	   0x16A45
#define Z_UNICODE_MRO_LETTER_A	   0x16A46
#define Z_UNICODE_MRO_LETTER_PHI   0x16A47
#define Z_UNICODE_MRO_LETTER_KHAI  0x16A48
#define Z_UNICODE_MRO_LETTER_HAO   0x16A49
#define Z_UNICODE_MRO_LETTER_DAI   0x16A4A
#define Z_UNICODE_MRO_LETTER_CHU   0x16A4B
#define Z_UNICODE_MRO_LETTER_KEAAE 0x16A4C
#define Z_UNICODE_MRO_LETTER_OL	   0x16A4D
#define Z_UNICODE_MRO_LETTER_MAEM  0x16A4E
#define Z_UNICODE_MRO_LETTER_NIN   0x16A4F
#define Z_UNICODE_MRO_LETTER_PA	   0x16A50
#define Z_UNICODE_MRO_LETTER_OO	   0x16A51
#define Z_UNICODE_MRO_LETTER_O	   0x16A52
#define Z_UNICODE_MRO_LETTER_RO	   0x16A53
#define Z_UNICODE_MRO_LETTER_SHI   0x16A54
#define Z_UNICODE_MRO_LETTER_THEA  0x16A55
#define Z_UNICODE_MRO_LETTER_EA	   0x16A56
#define Z_UNICODE_MRO_LETTER_WA	   0x16A57
#define Z_UNICODE_MRO_LETTER_E	   0x16A58
#define Z_UNICODE_MRO_LETTER_KO	   0x16A59
#define Z_UNICODE_MRO_LETTER_LAN   0x16A5A
#define Z_UNICODE_MRO_LETTER_LA	   0x16A5B
#define Z_UNICODE_MRO_LETTER_HAI   0x16A5C
#define Z_UNICODE_MRO_LETTER_RI	   0x16A5D
#define Z_UNICODE_MRO_LETTER_TEK   0x16A5E
#define Z_UNICODE_MRO_DIGIT_ZERO   0x16A60
#define Z_UNICODE_MRO_DIGIT_ONE	   0x16A61
#define Z_UNICODE_MRO_DIGIT_TWO	   0x16A62
#define Z_UNICODE_MRO_DIGIT_THREE  0x16A63
#define Z_UNICODE_MRO_DIGIT_FOUR   0x16A64
#define Z_UNICODE_MRO_DIGIT_FIVE   0x16A65
#define Z_UNICODE_MRO_DIGIT_SIX	   0x16A66
#define Z_UNICODE_MRO_DIGIT_SEVEN  0x16A67
#define Z_UNICODE_MRO_DIGIT_EIGHT  0x16A68
#define Z_UNICODE_MRO_DIGIT_NINE   0x16A69
#define Z_UNICODE_MRO_DANDA	   0x16A6E
#define Z_UNICODE_MRO_DOUBLE_DANDA 0x16A6F

/* MARK: - 16AD0h-16AFFh - Bassa Vah */

#define Z_UNICODE_BASSA_VAH_LETTER_ENNI		    0x16AD0
#define Z_UNICODE_BASSA_VAH_LETTER_KA		    0x16AD1
#define Z_UNICODE_BASSA_VAH_LETTER_SE		    0x16AD2
#define Z_UNICODE_BASSA_VAH_LETTER_FA		    0x16AD3
#define Z_UNICODE_BASSA_VAH_LETTER_MBE		    0x16AD4
#define Z_UNICODE_BASSA_VAH_LETTER_YIE		    0x16AD5
#define Z_UNICODE_BASSA_VAH_LETTER_GAH		    0x16AD6
#define Z_UNICODE_BASSA_VAH_LETTER_DHII		    0x16AD7
#define Z_UNICODE_BASSA_VAH_LETTER_KPAH		    0x16AD8
#define Z_UNICODE_BASSA_VAH_LETTER_JO		    0x16AD9
#define Z_UNICODE_BASSA_VAH_LETTER_HWAH		    0x16ADA
#define Z_UNICODE_BASSA_VAH_LETTER_WA		    0x16ADB
#define Z_UNICODE_BASSA_VAH_LETTER_ZO		    0x16ADC
#define Z_UNICODE_BASSA_VAH_LETTER_GBU		    0x16ADD
#define Z_UNICODE_BASSA_VAH_LETTER_DO		    0x16ADE
#define Z_UNICODE_BASSA_VAH_LETTER_CE		    0x16ADF
#define Z_UNICODE_BASSA_VAH_LETTER_UWU		    0x16AE0
#define Z_UNICODE_BASSA_VAH_LETTER_TO		    0x16AE1
#define Z_UNICODE_BASSA_VAH_LETTER_BA		    0x16AE2
#define Z_UNICODE_BASSA_VAH_LETTER_VU		    0x16AE3
#define Z_UNICODE_BASSA_VAH_LETTER_YEIN		    0x16AE4
#define Z_UNICODE_BASSA_VAH_LETTER_PA		    0x16AE5
#define Z_UNICODE_BASSA_VAH_LETTER_WADDA	    0x16AE6
#define Z_UNICODE_BASSA_VAH_LETTER_A		    0x16AE7
#define Z_UNICODE_BASSA_VAH_LETTER_O		    0x16AE8
#define Z_UNICODE_BASSA_VAH_LETTER_OO		    0x16AE9
#define Z_UNICODE_BASSA_VAH_LETTER_U		    0x16AEA
#define Z_UNICODE_BASSA_VAH_LETTER_EE		    0x16AEB
#define Z_UNICODE_BASSA_VAH_LETTER_E		    0x16AEC
#define Z_UNICODE_BASSA_VAH_LETTER_I		    0x16AED
#define Z_UNICODE_BASSA_VAH_COMBINING_HIGH_TONE	    0x16AF0
#define Z_UNICODE_BASSA_VAH_COMBINING_LOW_TONE	    0x16AF1
#define Z_UNICODE_BASSA_VAH_COMBINING_MID_TONE	    0x16AF2
#define Z_UNICODE_BASSA_VAH_COMBINING_LOW_MID_TONE  0x16AF3
#define Z_UNICODE_BASSA_VAH_COMBINING_HIGH_LOW_TONE 0x16AF4
#define Z_UNICODE_BASSA_VAH_FULL_STOP		    0x16AF5

/* MARK: - 16B00h-16B8Fh - Pahawh Hmong */

#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KEEB		   0x16B00
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KEEV		   0x16B01
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KIB		   0x16B02
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KIV		   0x16B03
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAUB		   0x16B04
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAUV		   0x16B05
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KUB		   0x16B06
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KUV		   0x16B07
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KEB		   0x16B08
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KEV		   0x16B09
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAIB		   0x16B0A
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAIV		   0x16B0B
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KOOB		   0x16B0C
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KOOV		   0x16B0D
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAWB		   0x16B0E
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAWV		   0x16B0F
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KUAB		   0x16B10
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KUAV		   0x16B11
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KOB		   0x16B12
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KOV		   0x16B13
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KIAB		   0x16B14
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KIAV		   0x16B15
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAB		   0x16B16
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAV		   0x16B17
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KWB		   0x16B18
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KWV		   0x16B19
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAAB		   0x16B1A
#define Z_UNICODE_PAHAWH_HMONG_VOWEL_KAAV		   0x16B1B
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_VAU		   0x16B1C
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_NTSAU		   0x16B1D
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_LAU		   0x16B1E
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_HAU		   0x16B1F
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_NLAU		   0x16B20
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_RAU		   0x16B21
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_NKAU		   0x16B22
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_QHAU		   0x16B23
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_YAU		   0x16B24
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_HLAU		   0x16B25
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_MAU		   0x16B26
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_CHAU		   0x16B27
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_NCHAU		   0x16B28
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_HNAU		   0x16B29
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_PLHAU		   0x16B2A
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_NTHAU		   0x16B2B
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_NAU		   0x16B2C
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_AU		   0x16B2D
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_XAU		   0x16B2E
#define Z_UNICODE_PAHAWH_HMONG_CONSONANT_CAU		   0x16B2F
#define Z_UNICODE_PAHAWH_HMONG_MARK_CIM_TUB		   0x16B30
#define Z_UNICODE_PAHAWH_HMONG_MARK_CIM_SO		   0x16B31
#define Z_UNICODE_PAHAWH_HMONG_MARK_CIM_KES		   0x16B32
#define Z_UNICODE_PAHAWH_HMONG_MARK_CIM_KHAV		   0x16B33
#define Z_UNICODE_PAHAWH_HMONG_MARK_CIM_SUAM		   0x16B34
#define Z_UNICODE_PAHAWH_HMONG_MARK_CIM_HOM		   0x16B35
#define Z_UNICODE_PAHAWH_HMONG_MARK_CIM_TAUM		   0x16B36
#define Z_UNICODE_PAHAWH_HMONG_SIGN_VOS_THOM		   0x16B37
#define Z_UNICODE_PAHAWH_HMONG_SIGN_VOS_TSHAB_CEEB	   0x16B38
#define Z_UNICODE_PAHAWH_HMONG_SIGN_CIM_CHEEM		   0x16B39
#define Z_UNICODE_PAHAWH_HMONG_SIGN_VOS_THIAB		   0x16B3A
#define Z_UNICODE_PAHAWH_HMONG_SIGN_VOS_FEEM		   0x16B3B
#define Z_UNICODE_PAHAWH_HMONG_SIGN_XYEEM_NTXIV		   0x16B3C
#define Z_UNICODE_PAHAWH_HMONG_SIGN_XYEEM_RHO		   0x16B3D
#define Z_UNICODE_PAHAWH_HMONG_SIGN_XYEEM_TOV		   0x16B3E
#define Z_UNICODE_PAHAWH_HMONG_SIGN_XYEEM_FAIB		   0x16B3F
#define Z_UNICODE_PAHAWH_HMONG_SIGN_VOS_SEEV		   0x16B40
#define Z_UNICODE_PAHAWH_HMONG_SIGN_MEEJ_SUAB		   0x16B41
#define Z_UNICODE_PAHAWH_HMONG_SIGN_VOS_NRUA		   0x16B42
#define Z_UNICODE_PAHAWH_HMONG_SIGN_IB_YAM		   0x16B43
#define Z_UNICODE_PAHAWH_HMONG_SIGN_XAUS		   0x16B44
#define Z_UNICODE_PAHAWH_HMONG_SIGN_CIM_TSOV_ROG	   0x16B45
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_ZERO		   0x16B50
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_ONE		   0x16B51
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_TWO		   0x16B52
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_THREE		   0x16B53
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_FOUR		   0x16B54
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_FIVE		   0x16B55
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_SIX		   0x16B56
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_SEVEN		   0x16B57
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_EIGHT		   0x16B58
#define Z_UNICODE_PAHAWH_HMONG_DIGIT_NINE		   0x16B59
#define Z_UNICODE_PAHAWH_HMONG_NUMBER_TENS		   0x16B5B
#define Z_UNICODE_PAHAWH_HMONG_NUMBER_HUNDREDS		   0x16B5C
#define Z_UNICODE_PAHAWH_HMONG_NUMBER_TEN_THOUSANDS	   0x16B5D
#define Z_UNICODE_PAHAWH_HMONG_NUMBER_MILLIONS		   0x16B5E
#define Z_UNICODE_PAHAWH_HMONG_NUMBER_HUNDRED_MILLIONS	   0x16B5F
#define Z_UNICODE_PAHAWH_HMONG_NUMBER_TEN_BILLIONS	   0x16B60
#define Z_UNICODE_PAHAWH_HMONG_NUMBER_TRILLIONS		   0x16B61
#define Z_UNICODE_PAHAWH_HMONG_SIGN_VOS_LUB		   0x16B63
#define Z_UNICODE_PAHAWH_HMONG_SIGN_XYOO		   0x16B64
#define Z_UNICODE_PAHAWH_HMONG_SIGN_HLI			   0x16B65
#define Z_UNICODE_PAHAWH_HMONG_SIGN_THIRD_STAGE_HLI	   0x16B66
#define Z_UNICODE_PAHAWH_HMONG_SIGN_ZWJ_THAJ		   0x16B67
#define Z_UNICODE_PAHAWH_HMONG_SIGN_HNUB		   0x16B68
#define Z_UNICODE_PAHAWH_HMONG_SIGN_NQIG		   0x16B69
#define Z_UNICODE_PAHAWH_HMONG_SIGN_XIAB		   0x16B6A
#define Z_UNICODE_PAHAWH_HMONG_SIGN_NTUJ		   0x16B6B
#define Z_UNICODE_PAHAWH_HMONG_SIGN_AV			   0x16B6C
#define Z_UNICODE_PAHAWH_HMONG_SIGN_TXHEEJ_CEEV		   0x16B6D
#define Z_UNICODE_PAHAWH_HMONG_SIGN_MEEJ_TSEEB		   0x16B6E
#define Z_UNICODE_PAHAWH_HMONG_SIGN_TAU			   0x16B6F
#define Z_UNICODE_PAHAWH_HMONG_SIGN_LOS			   0x16B70
#define Z_UNICODE_PAHAWH_HMONG_SIGN_MUS			   0x16B71
#define Z_UNICODE_PAHAWH_HMONG_SIGN_CIM_HAIS_LUS_NTOG_NTOG 0x16B72
#define Z_UNICODE_PAHAWH_HMONG_SIGN_CIM_CUAM_TSHOOJ	   0x16B73
#define Z_UNICODE_PAHAWH_HMONG_SIGN_CIM_TXWV		   0x16B74
#define Z_UNICODE_PAHAWH_HMONG_SIGN_CIM_TXWV_CHWV	   0x16B75
#define Z_UNICODE_PAHAWH_HMONG_SIGN_CIM_PUB_DAWB	   0x16B76
#define Z_UNICODE_PAHAWH_HMONG_SIGN_CIM_NRES_TOS	   0x16B77
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_TSHEEJ		   0x16B7D
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_YEEG		   0x16B7E
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_LIS		   0x16B7F
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_LAUJ		   0x16B80
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_XYOOJ		   0x16B81
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_KOO		   0x16B82
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_HAWJ		   0x16B83
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_MUAS		   0x16B84
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_THOJ		   0x16B85
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_TSAB		   0x16B86
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_PHAB		   0x16B87
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_KHAB		   0x16B88
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_HAM		   0x16B89
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_VAJ		   0x16B8A
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_FAJ		   0x16B8B
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_YAJ		   0x16B8C
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_TSWB		   0x16B8D
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_KWM		   0x16B8E
#define Z_UNICODE_PAHAWH_HMONG_CLAN_SIGN_VWJ		   0x16B8F

/* MARK: - 16F00h-16F9Fh - Miao */

#define Z_UNICODE_MIAO_LETTER_PA		0x16F00
#define Z_UNICODE_MIAO_LETTER_BA		0x16F01
#define Z_UNICODE_MIAO_LETTER_YI_PA		0x16F02
#define Z_UNICODE_MIAO_LETTER_PLA		0x16F03
#define Z_UNICODE_MIAO_LETTER_MA		0x16F04
#define Z_UNICODE_MIAO_LETTER_MHA		0x16F05
#define Z_UNICODE_MIAO_LETTER_ARCHAIC_MA	0x16F06
#define Z_UNICODE_MIAO_LETTER_FA		0x16F07
#define Z_UNICODE_MIAO_LETTER_VA		0x16F08
#define Z_UNICODE_MIAO_LETTER_VFA		0x16F09
#define Z_UNICODE_MIAO_LETTER_TA		0x16F0A
#define Z_UNICODE_MIAO_LETTER_DA		0x16F0B
#define Z_UNICODE_MIAO_LETTER_YI_TTA		0x16F0C
#define Z_UNICODE_MIAO_LETTER_YI_TA		0x16F0D
#define Z_UNICODE_MIAO_LETTER_TTA		0x16F0E
#define Z_UNICODE_MIAO_LETTER_DDA		0x16F0F
#define Z_UNICODE_MIAO_LETTER_NA		0x16F10
#define Z_UNICODE_MIAO_LETTER_NHA		0x16F11
#define Z_UNICODE_MIAO_LETTER_YI_NNA		0x16F12
#define Z_UNICODE_MIAO_LETTER_ARCHAIC_NA	0x16F13
#define Z_UNICODE_MIAO_LETTER_NNA		0x16F14
#define Z_UNICODE_MIAO_LETTER_NNHA		0x16F15
#define Z_UNICODE_MIAO_LETTER_LA		0x16F16
#define Z_UNICODE_MIAO_LETTER_LYA		0x16F17
#define Z_UNICODE_MIAO_LETTER_LHA		0x16F18
#define Z_UNICODE_MIAO_LETTER_LHYA		0x16F19
#define Z_UNICODE_MIAO_LETTER_TLHA		0x16F1A
#define Z_UNICODE_MIAO_LETTER_DLHA		0x16F1B
#define Z_UNICODE_MIAO_LETTER_TLHYA		0x16F1C
#define Z_UNICODE_MIAO_LETTER_DLHYA		0x16F1D
#define Z_UNICODE_MIAO_LETTER_KA		0x16F1E
#define Z_UNICODE_MIAO_LETTER_GA		0x16F1F
#define Z_UNICODE_MIAO_LETTER_YI_KA		0x16F20
#define Z_UNICODE_MIAO_LETTER_QA		0x16F21
#define Z_UNICODE_MIAO_LETTER_QGA		0x16F22
#define Z_UNICODE_MIAO_LETTER_NGA		0x16F23
#define Z_UNICODE_MIAO_LETTER_NGHA		0x16F24
#define Z_UNICODE_MIAO_LETTER_ARCHAIC_NGA	0x16F25
#define Z_UNICODE_MIAO_LETTER_HA		0x16F26
#define Z_UNICODE_MIAO_LETTER_XA		0x16F27
#define Z_UNICODE_MIAO_LETTER_GHA		0x16F28
#define Z_UNICODE_MIAO_LETTER_GHHA		0x16F29
#define Z_UNICODE_MIAO_LETTER_TSSA		0x16F2A
#define Z_UNICODE_MIAO_LETTER_DZZA		0x16F2B
#define Z_UNICODE_MIAO_LETTER_NYA		0x16F2C
#define Z_UNICODE_MIAO_LETTER_NYHA		0x16F2D
#define Z_UNICODE_MIAO_LETTER_TSHA		0x16F2E
#define Z_UNICODE_MIAO_LETTER_DZHA		0x16F2F
#define Z_UNICODE_MIAO_LETTER_YI_TSHA		0x16F30
#define Z_UNICODE_MIAO_LETTER_YI_DZHA		0x16F31
#define Z_UNICODE_MIAO_LETTER_REFORMED_TSHA	0x16F32
#define Z_UNICODE_MIAO_LETTER_SHA		0x16F33
#define Z_UNICODE_MIAO_LETTER_SSA		0x16F34
#define Z_UNICODE_MIAO_LETTER_ZHA		0x16F35
#define Z_UNICODE_MIAO_LETTER_ZSHA		0x16F36
#define Z_UNICODE_MIAO_LETTER_TSA		0x16F37
#define Z_UNICODE_MIAO_LETTER_DZA		0x16F38
#define Z_UNICODE_MIAO_LETTER_YI_TSA		0x16F39
#define Z_UNICODE_MIAO_LETTER_SA		0x16F3A
#define Z_UNICODE_MIAO_LETTER_ZA		0x16F3B
#define Z_UNICODE_MIAO_LETTER_ZSA		0x16F3C
#define Z_UNICODE_MIAO_LETTER_ZZA		0x16F3D
#define Z_UNICODE_MIAO_LETTER_ZZSA		0x16F3E
#define Z_UNICODE_MIAO_LETTER_ARCHAIC_ZZA	0x16F3F
#define Z_UNICODE_MIAO_LETTER_ZZYA		0x16F40
#define Z_UNICODE_MIAO_LETTER_ZZSYA		0x16F41
#define Z_UNICODE_MIAO_LETTER_WA		0x16F42
#define Z_UNICODE_MIAO_LETTER_AH		0x16F43
#define Z_UNICODE_MIAO_LETTER_HHA		0x16F44
#define Z_UNICODE_MIAO_LETTER_NASALIZATION	0x16F50
#define Z_UNICODE_MIAO_SIGN_ASPIRATION		0x16F51
#define Z_UNICODE_MIAO_SIGN_REFORMED_VOICING	0x16F52
#define Z_UNICODE_MIAO_SIGN_REFORMED_ASPIRATION	0x16F53
#define Z_UNICODE_MIAO_VOWEL_SIGN_A		0x16F54
#define Z_UNICODE_MIAO_VOWEL_SIGN_AA		0x16F55
#define Z_UNICODE_MIAO_VOWEL_SIGN_AHH		0x16F56
#define Z_UNICODE_MIAO_VOWEL_SIGN_AN		0x16F57
#define Z_UNICODE_MIAO_VOWEL_SIGN_ANG		0x16F58
#define Z_UNICODE_MIAO_VOWEL_SIGN_O		0x16F59
#define Z_UNICODE_MIAO_VOWEL_SIGN_OO		0x16F5A
#define Z_UNICODE_MIAO_VOWEL_SIGN_WO		0x16F5B
#define Z_UNICODE_MIAO_VOWEL_SIGN_W		0x16F5C
#define Z_UNICODE_MIAO_VOWEL_SIGN_E		0x16F5D
#define Z_UNICODE_MIAO_VOWEL_SIGN_EN		0x16F5E
#define Z_UNICODE_MIAO_VOWEL_SIGN_ENG		0x16F5F
#define Z_UNICODE_MIAO_VOWEL_SIGN_OEY		0x16F60
#define Z_UNICODE_MIAO_VOWEL_SIGN_I		0x16F61
#define Z_UNICODE_MIAO_VOWEL_SIGN_IA		0x16F62
#define Z_UNICODE_MIAO_VOWEL_SIGN_IAN		0x16F63
#define Z_UNICODE_MIAO_VOWEL_SIGN_IANG		0x16F64
#define Z_UNICODE_MIAO_VOWEL_SIGN_IO		0x16F65
#define Z_UNICODE_MIAO_VOWEL_SIGN_IE		0x16F66
#define Z_UNICODE_MIAO_VOWEL_SIGN_II		0x16F67
#define Z_UNICODE_MIAO_VOWEL_SIGN_IU		0x16F68
#define Z_UNICODE_MIAO_VOWEL_SIGN_ING		0x16F69
#define Z_UNICODE_MIAO_VOWEL_SIGN_U		0x16F6A
#define Z_UNICODE_MIAO_VOWEL_SIGN_UA		0x16F6B
#define Z_UNICODE_MIAO_VOWEL_SIGN_UAN		0x16F6C
#define Z_UNICODE_MIAO_VOWEL_SIGN_UANG		0x16F6D
#define Z_UNICODE_MIAO_VOWEL_SIGN_UU		0x16F6E
#define Z_UNICODE_MIAO_VOWEL_SIGN_UEI		0x16F6F
#define Z_UNICODE_MIAO_VOWEL_SIGN_UNG		0x16F70
#define Z_UNICODE_MIAO_VOWEL_SIGN_Y		0x16F71
#define Z_UNICODE_MIAO_VOWEL_SIGN_YI		0x16F72
#define Z_UNICODE_MIAO_VOWEL_SIGN_AE		0x16F73
#define Z_UNICODE_MIAO_VOWEL_SIGN_AEE		0x16F74
#define Z_UNICODE_MIAO_VOWEL_SIGN_ERR		0x16F75
#define Z_UNICODE_MIAO_VOWEL_SIGN_ROUNDED_ERR	0x16F76
#define Z_UNICODE_MIAO_VOWEL_SIGN_ER		0x16F77
#define Z_UNICODE_MIAO_VOWEL_SIGN_ROUNDED_ER	0x16F78
#define Z_UNICODE_MIAO_VOWEL_SIGN_AI		0x16F79
#define Z_UNICODE_MIAO_VOWEL_SIGN_EI		0x16F7A
#define Z_UNICODE_MIAO_VOWEL_SIGN_AU		0x16F7B
#define Z_UNICODE_MIAO_VOWEL_SIGN_OU		0x16F7C
#define Z_UNICODE_MIAO_VOWEL_SIGN_N		0x16F7D
#define Z_UNICODE_MIAO_VOWEL_SIGN_NG		0x16F7E
#define Z_UNICODE_MIAO_TONE_RIGHT		0x16F8F
#define Z_UNICODE_MIAO_TONE_TOP_RIGHT		0x16F90
#define Z_UNICODE_MIAO_TONE_ABOVE		0x16F91
#define Z_UNICODE_MIAO_TONE_BELOW		0x16F92
#define Z_UNICODE_MIAO_LETTER_TONE_2		0x16F93
#define Z_UNICODE_MIAO_LETTER_TONE_3		0x16F94
#define Z_UNICODE_MIAO_LETTER_TONE_4		0x16F95
#define Z_UNICODE_MIAO_LETTER_TONE_5		0x16F96
#define Z_UNICODE_MIAO_LETTER_TONE_6		0x16F97
#define Z_UNICODE_MIAO_LETTER_TONE_7		0x16F98
#define Z_UNICODE_MIAO_LETTER_TONE_8		0x16F99
#define Z_UNICODE_MIAO_LETTER_REFORMED_TONE_1	0x16F9A
#define Z_UNICODE_MIAO_LETTER_REFORMED_TONE_2	0x16F9B
#define Z_UNICODE_MIAO_LETTER_REFORMED_TONE_4	0x16F9C
#define Z_UNICODE_MIAO_LETTER_REFORMED_TONE_5	0x16F9D
#define Z_UNICODE_MIAO_LETTER_REFORMED_TONE_6	0x16F9E
#define Z_UNICODE_MIAO_LETTER_REFORMED_TONE_8	0x16F9F

/* MARK: - 1B000h-1B0FFh - Kana Supplement */

#define Z_UNICODE_KATAKANA_LETTER_ARCHAIC_E  0x1B000
#define Z_UNICODE_HIRAGANA_LETTER_ARCHAIC_YE 0x1B001

/* MARK: - 1BC00h-1BC9Fh - Duployan */

#define Z_UNICODE_DUPLOYAN_LETTER_H			       0x1BC00
#define Z_UNICODE_DUPLOYAN_LETTER_X			       0x1BC01
#define Z_UNICODE_DUPLOYAN_LETTER_P			       0x1BC02
#define Z_UNICODE_DUPLOYAN_LETTER_T			       0x1BC03
#define Z_UNICODE_DUPLOYAN_LETTER_F			       0x1BC04
#define Z_UNICODE_DUPLOYAN_LETTER_K			       0x1BC05
#define Z_UNICODE_DUPLOYAN_LETTER_L			       0x1BC06
#define Z_UNICODE_DUPLOYAN_LETTER_B			       0x1BC07
#define Z_UNICODE_DUPLOYAN_LETTER_D			       0x1BC08
#define Z_UNICODE_DUPLOYAN_LETTER_V			       0x1BC09
#define Z_UNICODE_DUPLOYAN_LETTER_G			       0x1BC0A
#define Z_UNICODE_DUPLOYAN_LETTER_R			       0x1BC0B
#define Z_UNICODE_DUPLOYAN_LETTER_P_N			       0x1BC0C
#define Z_UNICODE_DUPLOYAN_LETTER_D_S			       0x1BC0D
#define Z_UNICODE_DUPLOYAN_LETTER_F_N			       0x1BC0E
#define Z_UNICODE_DUPLOYAN_LETTER_K_M			       0x1BC0F
#define Z_UNICODE_DUPLOYAN_LETTER_R_S			       0x1BC10
#define Z_UNICODE_DUPLOYAN_LETTER_TH			       0x1BC11
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_DH		       0x1BC12
#define Z_UNICODE_DUPLOYAN_LETTER_DH			       0x1BC13
#define Z_UNICODE_DUPLOYAN_LETTER_KK			       0x1BC14
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_J		       0x1BC15
#define Z_UNICODE_DUPLOYAN_LETTER_HL			       0x1BC16
#define Z_UNICODE_DUPLOYAN_LETTER_LH			       0x1BC17
#define Z_UNICODE_DUPLOYAN_LETTER_RH			       0x1BC18
#define Z_UNICODE_DUPLOYAN_LETTER_M			       0x1BC19
#define Z_UNICODE_DUPLOYAN_LETTER_N			       0x1BC1A
#define Z_UNICODE_DUPLOYAN_LETTER_J			       0x1BC1B
#define Z_UNICODE_DUPLOYAN_LETTER_S			       0x1BC1C
#define Z_UNICODE_DUPLOYAN_LETTER_M_N			       0x1BC1D
#define Z_UNICODE_DUPLOYAN_LETTER_N_M			       0x1BC1E
#define Z_UNICODE_DUPLOYAN_LETTER_J_M			       0x1BC1F
#define Z_UNICODE_DUPLOYAN_LETTER_S_J			       0x1BC20
#define Z_UNICODE_DUPLOYAN_LETTER_M_WITH_DOT		       0x1BC21
#define Z_UNICODE_DUPLOYAN_LETTER_N_WITH_DOT		       0x1BC22
#define Z_UNICODE_DUPLOYAN_LETTER_J_WITH_DOT		       0x1BC23
#define Z_UNICODE_DUPLOYAN_LETTER_J_WITH_DOTS_INSIDE_AND_ABOVE 0x1BC24
#define Z_UNICODE_DUPLOYAN_LETTER_S_WITH_DOT		       0x1BC25
#define Z_UNICODE_DUPLOYAN_LETTER_S_WITH_DOT_BELOW	       0x1BC26
#define Z_UNICODE_DUPLOYAN_LETTER_M_S			       0x1BC27
#define Z_UNICODE_DUPLOYAN_LETTER_N_S			       0x1BC28
#define Z_UNICODE_DUPLOYAN_LETTER_J_S			       0x1BC29
#define Z_UNICODE_DUPLOYAN_LETTER_S_S			       0x1BC2A
#define Z_UNICODE_DUPLOYAN_LETTER_M_N_S			       0x1BC2B
#define Z_UNICODE_DUPLOYAN_LETTER_N_M_S			       0x1BC2C
#define Z_UNICODE_DUPLOYAN_LETTER_J_M_S			       0x1BC2D
#define Z_UNICODE_DUPLOYAN_LETTER_S_J_S			       0x1BC2E
#define Z_UNICODE_DUPLOYAN_LETTER_J_S_WITH_DOT		       0x1BC2F
#define Z_UNICODE_DUPLOYAN_LETTER_J_N			       0x1BC30
#define Z_UNICODE_DUPLOYAN_LETTER_J_N_S			       0x1BC31
#define Z_UNICODE_DUPLOYAN_LETTER_S_T			       0x1BC32
#define Z_UNICODE_DUPLOYAN_LETTER_S_T_R			       0x1BC33
#define Z_UNICODE_DUPLOYAN_LETTER_S_P			       0x1BC34
#define Z_UNICODE_DUPLOYAN_LETTER_S_P_R			       0x1BC35
#define Z_UNICODE_DUPLOYAN_LETTER_T_S			       0x1BC36
#define Z_UNICODE_DUPLOYAN_LETTER_T_R_S			       0x1BC37
#define Z_UNICODE_DUPLOYAN_LETTER_W			       0x1BC38
#define Z_UNICODE_DUPLOYAN_LETTER_WH			       0x1BC39
#define Z_UNICODE_DUPLOYAN_LETTER_W_R			       0x1BC3A
#define Z_UNICODE_DUPLOYAN_LETTER_S_N			       0x1BC3B
#define Z_UNICODE_DUPLOYAN_LETTER_S_M			       0x1BC3C
#define Z_UNICODE_DUPLOYAN_LETTER_K_R_S			       0x1BC3D
#define Z_UNICODE_DUPLOYAN_LETTER_G_R_S			       0x1BC3E
#define Z_UNICODE_DUPLOYAN_LETTER_S_K			       0x1BC3F
#define Z_UNICODE_DUPLOYAN_LETTER_S_K_R			       0x1BC40
#define Z_UNICODE_DUPLOYAN_LETTER_A			       0x1BC41
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_OW		       0x1BC42
#define Z_UNICODE_DUPLOYAN_LETTER_OA			       0x1BC43
#define Z_UNICODE_DUPLOYAN_LETTER_O			       0x1BC44
#define Z_UNICODE_DUPLOYAN_LETTER_AOU			       0x1BC45
#define Z_UNICODE_DUPLOYAN_LETTER_I			       0x1BC46
#define Z_UNICODE_DUPLOYAN_LETTER_E			       0x1BC47
#define Z_UNICODE_DUPLOYAN_LETTER_IE			       0x1BC48
#define Z_UNICODE_DUPLOYAN_LETTER_SHORT_I		       0x1BC49
#define Z_UNICODE_DUPLOYAN_LETTER_UI			       0x1BC4A
#define Z_UNICODE_DUPLOYAN_LETTER_EE			       0x1BC4B
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_EH		       0x1BC4C
#define Z_UNICODE_DUPLOYAN_LETTER_ROMANIAN_I		       0x1BC4D
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_EE		       0x1BC4E
#define Z_UNICODE_DUPLOYAN_LETTER_LONG_I		       0x1BC4F
#define Z_UNICODE_DUPLOYAN_LETTER_YE			       0x1BC50
#define Z_UNICODE_DUPLOYAN_LETTER_U			       0x1BC51
#define Z_UNICODE_DUPLOYAN_LETTER_EU			       0x1BC52
#define Z_UNICODE_DUPLOYAN_LETTER_XW			       0x1BC53
#define Z_UNICODE_DUPLOYAN_LETTER_U_N			       0x1BC54
#define Z_UNICODE_DUPLOYAN_LETTER_LONG_U		       0x1BC55
#define Z_UNICODE_DUPLOYAN_LETTER_ROMANIAN_U		       0x1BC56
#define Z_UNICODE_DUPLOYAN_LETTER_UH			       0x1BC57
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_U		       0x1BC58
#define Z_UNICODE_DUPLOYAN_LETTER_OOH			       0x1BC59
#define Z_UNICODE_DUPLOYAN_LETTER_OW			       0x1BC5A
#define Z_UNICODE_DUPLOYAN_LETTER_OU			       0x1BC5B
#define Z_UNICODE_DUPLOYAN_LETTER_WA			       0x1BC5C
#define Z_UNICODE_DUPLOYAN_LETTER_WO			       0x1BC5D
#define Z_UNICODE_DUPLOYAN_LETTER_WI			       0x1BC5E
#define Z_UNICODE_DUPLOYAN_LETTER_WEI			       0x1BC5F
#define Z_UNICODE_DUPLOYAN_LETTER_WOW			       0x1BC60
#define Z_UNICODE_DUPLOYAN_LETTER_NASAL_U		       0x1BC61
#define Z_UNICODE_DUPLOYAN_LETTER_NASAL_O		       0x1BC62
#define Z_UNICODE_DUPLOYAN_LETTER_NASAL_I		       0x1BC63
#define Z_UNICODE_DUPLOYAN_LETTER_NASAL_A		       0x1BC64
#define Z_UNICODE_DUPLOYAN_LETTER_PERNIN_AN		       0x1BC65
#define Z_UNICODE_DUPLOYAN_LETTER_PERNIN_AM		       0x1BC66
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_EN		       0x1BC67
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_AN		       0x1BC68
#define Z_UNICODE_DUPLOYAN_LETTER_SLOAN_ON		       0x1BC69
#define Z_UNICODE_DUPLOYAN_LETTER_VOCALIC_M		       0x1BC6A
#define Z_UNICODE_DUPLOYAN_AFFIX_LEFT_HORIZONTAL_SECANT	       0x1BC70
#define Z_UNICODE_DUPLOYAN_AFFIX_MID_HORIZONTAL_SECANT	       0x1BC71
#define Z_UNICODE_DUPLOYAN_AFFIX_RIGHT_HORIZONTAL_SECANT       0x1BC72
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_VERTICAL_SECANT	       0x1BC73
#define Z_UNICODE_DUPLOYAN_AFFIX_MID_VERTICAL_SECANT	       0x1BC74
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_VERTICAL_SECANT	       0x1BC75
#define Z_UNICODE_DUPLOYAN_AFFIX_ATTACHED_SECANT	       0x1BC76
#define Z_UNICODE_DUPLOYAN_AFFIX_ATTACHED_LEFT_TO_RIGHT_SECANT 0x1BC77
#define Z_UNICODE_DUPLOYAN_AFFIX_ATTACHED_TANGENT	       0x1BC78
#define Z_UNICODE_DUPLOYAN_AFFIX_ATTACHED_TAIL		       0x1BC79
#define Z_UNICODE_DUPLOYAN_AFFIX_ATTACHED_E_HOOK	       0x1BC7A
#define Z_UNICODE_DUPLOYAN_AFFIX_ATTACHED_I_HOOK	       0x1BC7B
#define Z_UNICODE_DUPLOYAN_AFFIX_ATTACHED_TANGENT_HOOK	       0x1BC7C
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_ACUTE		       0x1BC80
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_TIGHT_ACUTE	       0x1BC81
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_GRAVE		       0x1BC82
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_LONG_GRAVE	       0x1BC83
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_DOT		       0x1BC84
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_CIRCLE		       0x1BC85
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_LINE		       0x1BC86
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_WAVE		       0x1BC87
#define Z_UNICODE_DUPLOYAN_AFFIX_HIGH_VERTICAL		       0x1BC88
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_ACUTE		       0x1BC90
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_TIGHT_ACUTE	       0x1BC91
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_GRAVE		       0x1BC92
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_LONG_GRAVE		       0x1BC93
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_DOT		       0x1BC94
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_CIRCLE		       0x1BC95
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_LINE		       0x1BC96
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_WAVE		       0x1BC97
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_VERTICAL		       0x1BC98
#define Z_UNICODE_DUPLOYAN_AFFIX_LOW_ARROW		       0x1BC99
#define Z_UNICODE_DUPLOYAN_SIGN_O_WITH_CROSS		       0x1BC9C
#define Z_UNICODE_DUPLOYAN_THICK_LETTER_SELECTOR	       0x1BC9D
#define Z_UNICODE_DUPLOYAN_DOUBLE_MARK			       0x1BC9E
#define Z_UNICODE_DUPLOYAN_PUNCTUATION_CHINOOK_FULL_STOP       0x1BC9F

/* MARK: - 1BCA0h-1BCAFh - Shorthand Format Controls */

#define Z_UNICODE_SHORTHAND_FORMAT_LETTER_OVERLAP     0x1BCA0
#define Z_UNICODE_SHORTHAND_FORMAT_CONTINUING_OVERLAP 0x1BCA1
#define Z_UNICODE_SHORTHAND_FORMAT_DOWN_STEP	      0x1BCA2
#define Z_UNICODE_SHORTHAND_FORMAT_UP_STEP	      0x1BCA3

/* MARK: - 1D000h-1D0FFh - Byzantine Musical Symbols */

#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PSILI				0x1D000
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DASEIA				0x1D001
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PERISPOMENI				0x1D002
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OXEIA_EKFONITIKON			0x1D003
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OXEIA_DIPLI				0x1D004
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_VAREIA_EKFONITIKON			0x1D005
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_VAREIA_DIPLI				0x1D006
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KATHISTI				0x1D007
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SYRMATIKI				0x1D008
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI				0x1D009
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YPOKRISIS				0x1D00A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YPOKRISIS_DIPLI			0x1D00B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KREMASTI				0x1D00C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APESO_EKFONITIKON			0x1D00D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_EXO_EKFONITIKON			0x1D00E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TELEIA				0x1D00F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA				0x1D010
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS				0x1D011
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS_DIPLI			0x1D012
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SYNEVMA				0x1D013
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_THITA				0x1D014
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OLIGON_ARCHAION			0x1D015
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GORGON_ARCHAION			0x1D016
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PSILON				0x1D017
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_CHAMILON				0x1D018
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_VATHY				0x1D019
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ISON_ARCHAION			0x1D01A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMA_ARCHAION			0x1D01B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_ARCHAION			0x1D01C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SAXIMATA				0x1D01D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PARICHON				0x1D01E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_STAVROS_APODEXIA			0x1D01F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OXEIAI_ARCHAION			0x1D020
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_VAREIAI_ARCHAION			0x1D021
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APODERMA_ARCHAION			0x1D022
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APOTHEMA				0x1D023
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KLASMA				0x1D024
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_REVMA				0x1D025
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PIASMA_ARCHAION			0x1D026
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TINAGMA				0x1D027
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ANATRICHISMA				0x1D028
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SEISMA				0x1D029
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_ARCHAION			0x1D02A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_META_STAVROU			0x1D02B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OYRANISMA_ARCHAION			0x1D02C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_THEMA				0x1D02D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_LEMOI				0x1D02E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DYO					0x1D02F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TRIA					0x1D030
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TESSERA				0x1D031
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KRATIMATA				0x1D032
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APESO_EXO_NEO			0x1D033
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_ARCHAION			0x1D034
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_IMIFTHORA				0x1D035
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TROMIKON_ARCHAION			0x1D036
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KATAVA_TROMIKON			0x1D037
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PELASTON				0x1D038
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PSIFISTON				0x1D039
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KONTEVMA				0x1D03A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_CHOREVMA_ARCHAION			0x1D03B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_RAPISMA				0x1D03C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PARAKALESMA_ARCHAION			0x1D03D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI_ARCHAION			0x1D03E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ICHADIN				0x1D03F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_NANA					0x1D040
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PETASMA				0x1D041
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KONTEVMA_ALLO			0x1D042
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TROMIKON_ALLO			0x1D043
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_STRAGGISMATA				0x1D044
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GRONTHISMATA				0x1D045
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ISON_NEO				0x1D046
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OLIGON_NEO				0x1D047
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OXEIA_NEO				0x1D048
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PETASTI				0x1D049
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KOUFISMA				0x1D04A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PETASTOKOUFISMA			0x1D04B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KRATIMOKOUFISMA			0x1D04C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PELASTON_NEO				0x1D04D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_ANO			0x1D04E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_ANO			0x1D04F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YPSILI				0x1D050
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOS_NEO			0x1D051
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOI_SYNDESMOS_NEO		0x1D052
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YPORROI				0x1D053
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KRATIMOYPORROON			0x1D054
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ELAFRON				0x1D055
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_CHAMILI				0x1D056
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MIKRON_ISON				0x1D057
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_VAREIA_NEO				0x1D058
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PIASMA_NEO				0x1D059
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PSIFISTON_NEO			0x1D05A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OMALON				0x1D05B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ANTIKENOMA				0x1D05C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_LYGISMA				0x1D05D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PARAKLITIKI_NEO			0x1D05E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PARAKALESMA_NEO			0x1D05F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ETERON_PARAKALESMA			0x1D060
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KYLISMA				0x1D061
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ANTIKENOKYLISMA			0x1D062
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TROMIKON_NEO				0x1D063
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_EKSTREPTON				0x1D064
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SYNAGMA_NEO				0x1D065
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SYRMA				0x1D066
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_CHOREVMA_NEO				0x1D067
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_EPEGERMA				0x1D068
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SEISMA_NEO				0x1D069
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_XIRON_KLASMA				0x1D06A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TROMIKOPSIFISTON			0x1D06B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PSIFISTOLYGISMA			0x1D06C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TROMIKOLYGISMA			0x1D06D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TROMIKOPARAKALESMA			0x1D06E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PSIFISTOPARAKALESMA			0x1D06F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TROMIKOSYNAGMA			0x1D070
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_PSIFISTOSYNAGMA			0x1D071
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GORGOSYNTHETON			0x1D072
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARGOSYNTHETON			0x1D073
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ETERON_ARGOSYNTHETON			0x1D074
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_OYRANISMA_NEO			0x1D075
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_THEMATISMOS_ESO			0x1D076
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_THEMATISMOS_EXO			0x1D077
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_THEMA_APLOUN				0x1D078
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_THES_KAI_APOTHES			0x1D079
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KATAVASMA				0x1D07A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ENDOFONON				0x1D07B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YFEN_KATO				0x1D07C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YFEN_ANO				0x1D07D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_STAVROS				0x1D07E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KLASMA_ANO				0x1D07F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIPLI_ARCHAION			0x1D080
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KRATIMA_ARCHAION			0x1D081
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KRATIMA_ALLO				0x1D082
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KRATIMA_NEO				0x1D083
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APODERMA_NEO				0x1D084
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APLI					0x1D085
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIPLI				0x1D086
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TRIPLI				0x1D087
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TETRAPLI				0x1D088
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KORONIS				0x1D089
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_ENOS_CHRONOU			0x1D08A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_DYO_CHRONON			0x1D08B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_TRION_CHRONON			0x1D08C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_TESSARON_CHRONON		0x1D08D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_LEIMMA_IMISEOS_CHRONOU		0x1D08E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GORGON_NEO_ANO			0x1D08F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GORGON_PARESTIGMENON_ARISTERA	0x1D090
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GORGON_PARESTIGMENON_DEXIA		0x1D091
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIGORGON				0x1D092
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_ARISTERA_KATO	0x1D093
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_ARISTERA_ANO	0x1D094
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIGORGON_PARESTIGMENON_DEXIA		0x1D095
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_TRIGORGON				0x1D096
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARGON				0x1D097
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_IMIDIARGON				0x1D098
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIARGON				0x1D099
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_AGOGI_POLI_ARGI			0x1D09A
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_AGOGI_ARGOTERI			0x1D09B
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_AGOGI_ARGI				0x1D09C
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_AGOGI_METRIA				0x1D09D
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_AGOGI_MESI				0x1D09E
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_AGOGI_GORGI				0x1D09F
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_AGOGI_GORGOTERI			0x1D0A0
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_AGOGI_POLI_GORGI			0x1D0A1
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PROTOS_ICHOS		0x1D0A2
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_ALLI_PROTOS_ICHOS		0x1D0A3
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_DEYTEROS_ICHOS		0x1D0A4
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_ALLI_DEYTEROS_ICHOS		0x1D0A5
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TRITOS_ICHOS		0x1D0A6
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TRIFONIAS			0x1D0A7
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TETARTOS_ICHOS		0x1D0A8
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_TETARTOS_LEGETOS_ICHOS	0x1D0A9
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_LEGETOS_ICHOS		0x1D0AA
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PLAGIOS_ICHOS		0x1D0AB
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ISAKIA_TELOUS_ICHIMATOS		0x1D0AC
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_APOSTROFOI_TELOUS_ICHIMATOS		0x1D0AD
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_TETRAFONIAS		0x1D0AE
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_MONOFONIAS			0x1D0AF
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FANEROSIS_DIFONIAS			0x1D0B0
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_VARYS_ICHOS			0x1D0B1
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PROTOVARYS_ICHOS		0x1D0B2
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_MARTYRIA_PLAGIOS_TETARTOS_ICHOS	0x1D0B3
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GORTHMIKON_N_APLOUN			0x1D0B4
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GORTHMIKON_N_DIPLOUN			0x1D0B5
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ENARXIS_KAI_FTHORA_VOU		0x1D0B6
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_IMIFONON				0x1D0B7
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_IMIFTHORON				0x1D0B8
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_ARCHAION_DEYTEROU_ICHOU	0x1D0B9
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_PA			0x1D0BA
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NANA		0x1D0BB
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_NAOS_ICHOS			0x1D0BC
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_DI			0x1D0BD
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_SKLIRON_DIATONON_DI		0x1D0BE
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_KE			0x1D0BF
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_ZO			0x1D0C0
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NI_KATO		0x1D0C1
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_DIATONIKI_NI_ANO		0x1D0C2
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_MALAKON_CHROMA_DIFONIAS	0x1D0C3
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_MALAKON_CHROMA_MONOFONIAS	0x1D0C4
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FHTORA_SKLIRON_CHROMA_VASIS		0x1D0C5
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_SKLIRON_CHROMA_SYNAFI		0x1D0C6
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_NENANO			0x1D0C7
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_CHROA_ZYGOS				0x1D0C8
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_CHROA_KLITON				0x1D0C9
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_CHROA_SPATHI				0x1D0CA
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_I_YFESIS_TETARTIMORION	0x1D0CB
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_FTHORA_ENARMONIOS_ANTIFONIA		0x1D0CC
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YFESIS_TRITIMORION			0x1D0CD
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIESIS_TRITIMORION			0x1D0CE
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIESIS_TETARTIMORION			0x1D0CF
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIESIS_APLI_DYO_DODEKATA		0x1D0D0
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIESIS_MONOGRAMMOS_TESSERA_DODEKATA	0x1D0D1
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIESIS_DIGRAMMOS_EX_DODEKATA		0x1D0D2
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIESIS_TRIGRAMMOS_OKTO_DODEKATA	0x1D0D3
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YFESIS_APLI_DYO_DODEKATA		0x1D0D4
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YFESIS_MONOGRAMMOS_TESSERA_DODEKATA	0x1D0D5
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YFESIS_DIGRAMMOS_EX_DODEKATA		0x1D0D6
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_YFESIS_TRIGRAMMOS_OKTO_DODEKATA	0x1D0D7
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GENIKI_DIESIS			0x1D0D8
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GENIKI_YFESIS			0x1D0D9
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_APLI_MIKRI			0x1D0DA
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_APLI_MEGALI			0x1D0DB
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_DIPLI			0x1D0DC
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIASTOLI_THESEOS			0x1D0DD
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS			0x1D0DE
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_DISIMOU		0x1D0DF
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_TRISIMOU		0x1D0E0
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_THESEOS_TETRASIMOU		0x1D0E1
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS			0x1D0E2
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_DISIMOU		0x1D0E3
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_TRISIMOU		0x1D0E4
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_SIMANSIS_ARSEOS_TETRASIMOU		0x1D0E5
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIGRAMMA_GG				0x1D0E6
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_DIFTOGGOS_OU				0x1D0E7
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_STIGMA				0x1D0E8
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_PA				0x1D0E9
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_VOU				0x1D0EA
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_GA				0x1D0EB
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_DI				0x1D0EC
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_KE				0x1D0ED
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_ZO				0x1D0EE
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_ARKTIKO_NI				0x1D0EF
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_MESO			0x1D0F0
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_MESO			0x1D0F1
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMATA_NEO_KATO			0x1D0F2
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KENTIMA_NEO_KATO			0x1D0F3
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_KLASMA_KATO				0x1D0F4
#define Z_UNICODE_BYZANTINE_MUSICAL_SYMBOL_GORGON_NEO_KATO			0x1D0F5

/* MARK: - 1D100h-1D1FFh - Musical Symbols */

#define Z_UNICODE_MUSICAL_SYMBOL_SINGLE_BARLINE						   0x1D100
#define Z_UNICODE_MUSICAL_SYMBOL_DOUBLE_BARLINE						   0x1D101
#define Z_UNICODE_MUSICAL_SYMBOL_FINAL_BARLINE						   0x1D102
#define Z_UNICODE_MUSICAL_SYMBOL_REVERSE_FINAL_BARLINE					   0x1D103
#define Z_UNICODE_MUSICAL_SYMBOL_DASHED_BARLINE						   0x1D104
#define Z_UNICODE_MUSICAL_SYMBOL_SHORT_BARLINE						   0x1D105
#define Z_UNICODE_MUSICAL_SYMBOL_LEFT_REPEAT_SIGN					   0x1D106
#define Z_UNICODE_MUSICAL_SYMBOL_RIGHT_REPEAT_SIGN					   0x1D107
#define Z_UNICODE_MUSICAL_SYMBOL_REPEAT_DOTS						   0x1D108
#define Z_UNICODE_MUSICAL_SYMBOL_DAL_SEGNO						   0x1D109
#define Z_UNICODE_MUSICAL_SYMBOL_DA_CAPO						   0x1D10A
#define Z_UNICODE_MUSICAL_SYMBOL_SEGNO							   0x1D10B
#define Z_UNICODE_MUSICAL_SYMBOL_CODA							   0x1D10C
#define Z_UNICODE_MUSICAL_SYMBOL_REPEATED_FIGURE_1					   0x1D10D
#define Z_UNICODE_MUSICAL_SYMBOL_REPEATED_FIGURE_2					   0x1D10E
#define Z_UNICODE_MUSICAL_SYMBOL_REPEATED_FIGURE_3					   0x1D10F
#define Z_UNICODE_MUSICAL_SYMBOL_FERMATA						   0x1D110
#define Z_UNICODE_MUSICAL_SYMBOL_FERMATA_BELOW						   0x1D111
#define Z_UNICODE_MUSICAL_SYMBOL_BREATH_MARK						   0x1D112
#define Z_UNICODE_MUSICAL_SYMBOL_CAESURA						   0x1D113
#define Z_UNICODE_MUSICAL_SYMBOL_BRACE							   0x1D114
#define Z_UNICODE_MUSICAL_SYMBOL_BRACKET						   0x1D115
#define Z_UNICODE_MUSICAL_SYMBOL_ONE_LINE_STAFF						   0x1D116
#define Z_UNICODE_MUSICAL_SYMBOL_TWO_LINE_STAFF						   0x1D117
#define Z_UNICODE_MUSICAL_SYMBOL_THREE_LINE_STAFF					   0x1D118
#define Z_UNICODE_MUSICAL_SYMBOL_FOUR_LINE_STAFF					   0x1D119
#define Z_UNICODE_MUSICAL_SYMBOL_FIVE_LINE_STAFF					   0x1D11A
#define Z_UNICODE_MUSICAL_SYMBOL_SIX_LINE_STAFF						   0x1D11B
#define Z_UNICODE_MUSICAL_SYMBOL_SIX_STRING_FRETBOARD					   0x1D11C
#define Z_UNICODE_MUSICAL_SYMBOL_FOUR_STRING_FRETBOARD					   0x1D11D
#define Z_UNICODE_MUSICAL_SYMBOL_G_CLEF							   0x1D11E
#define Z_UNICODE_MUSICAL_SYMBOL_G_CLEF_OTTAVA_ALTA					   0x1D11F
#define Z_UNICODE_MUSICAL_SYMBOL_G_CLEF_OTTAVA_BASSA					   0x1D120
#define Z_UNICODE_MUSICAL_SYMBOL_C_CLEF							   0x1D121
#define Z_UNICODE_MUSICAL_SYMBOL_F_CLEF							   0x1D122
#define Z_UNICODE_MUSICAL_SYMBOL_F_CLEF_OTTAVA_ALTA					   0x1D123
#define Z_UNICODE_MUSICAL_SYMBOL_F_CLEF_OTTAVA_BASSA					   0x1D124
#define Z_UNICODE_MUSICAL_SYMBOL_DRUM_CLEF_1						   0x1D125
#define Z_UNICODE_MUSICAL_SYMBOL_DRUM_CLEF_2						   0x1D126
#define Z_UNICODE_MUSICAL_SYMBOL_MULTIPLE_MEASURE_REST					   0x1D129
#define Z_UNICODE_MUSICAL_SYMBOL_DOUBLE_SHARP						   0x1D12A
#define Z_UNICODE_MUSICAL_SYMBOL_DOUBLE_FLAT						   0x1D12B
#define Z_UNICODE_MUSICAL_SYMBOL_FLAT_UP						   0x1D12C
#define Z_UNICODE_MUSICAL_SYMBOL_FLAT_DOWN						   0x1D12D
#define Z_UNICODE_MUSICAL_SYMBOL_NATURAL_UP						   0x1D12E
#define Z_UNICODE_MUSICAL_SYMBOL_NATURAL_DOWN						   0x1D12F
#define Z_UNICODE_MUSICAL_SYMBOL_SHARP_UP						   0x1D130
#define Z_UNICODE_MUSICAL_SYMBOL_SHARP_DOWN						   0x1D131
#define Z_UNICODE_MUSICAL_SYMBOL_QUARTER_TONE_SHARP					   0x1D132
#define Z_UNICODE_MUSICAL_SYMBOL_QUARTER_TONE_FLAT					   0x1D133
#define Z_UNICODE_MUSICAL_SYMBOL_COMMON_TIME						   0x1D134
#define Z_UNICODE_MUSICAL_SYMBOL_CUT_TIME						   0x1D135
#define Z_UNICODE_MUSICAL_SYMBOL_OTTAVA_ALTA						   0x1D136
#define Z_UNICODE_MUSICAL_SYMBOL_OTTAVA_BASSA						   0x1D137
#define Z_UNICODE_MUSICAL_SYMBOL_QUINDICESIMA_ALTA					   0x1D138
#define Z_UNICODE_MUSICAL_SYMBOL_QUINDICESIMA_BASSA					   0x1D139
#define Z_UNICODE_MUSICAL_SYMBOL_MULTI_REST						   0x1D13A
#define Z_UNICODE_MUSICAL_SYMBOL_WHOLE_REST						   0x1D13B
#define Z_UNICODE_MUSICAL_SYMBOL_HALF_REST						   0x1D13C
#define Z_UNICODE_MUSICAL_SYMBOL_QUARTER_REST						   0x1D13D
#define Z_UNICODE_MUSICAL_SYMBOL_EIGHTH_REST						   0x1D13E
#define Z_UNICODE_MUSICAL_SYMBOL_SIXTEENTH_REST						   0x1D13F
#define Z_UNICODE_MUSICAL_SYMBOL_THIRTY_SECOND_REST					   0x1D140
#define Z_UNICODE_MUSICAL_SYMBOL_SIXTY_FOURTH_REST					   0x1D141
#define Z_UNICODE_MUSICAL_SYMBOL_ONE_HUNDRED_TWENTY_EIGHTH_REST				   0x1D142
#define Z_UNICODE_MUSICAL_SYMBOL_X_NOTEHEAD						   0x1D143
#define Z_UNICODE_MUSICAL_SYMBOL_PLUS_NOTEHEAD						   0x1D144
#define Z_UNICODE_MUSICAL_SYMBOL_CIRCLE_X_NOTEHEAD					   0x1D145
#define Z_UNICODE_MUSICAL_SYMBOL_SQUARE_NOTEHEAD_WHITE					   0x1D146
#define Z_UNICODE_MUSICAL_SYMBOL_SQUARE_NOTEHEAD_BLACK					   0x1D147
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_WHITE				   0x1D148
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_BLACK				   0x1D149
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_LEFT_WHITE				   0x1D14A
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_LEFT_BLACK				   0x1D14B
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_RIGHT_WHITE				   0x1D14C
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_RIGHT_BLACK				   0x1D14D
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_DOWN_WHITE				   0x1D14E
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_DOWN_BLACK				   0x1D14F
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_RIGHT_WHITE			   0x1D150
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_NOTEHEAD_UP_RIGHT_BLACK			   0x1D151
#define Z_UNICODE_MUSICAL_SYMBOL_MOON_NOTEHEAD_WHITE					   0x1D152
#define Z_UNICODE_MUSICAL_SYMBOL_MOON_NOTEHEAD_BLACK					   0x1D153
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_ROUND_NOTEHEAD_DOWN_WHITE			   0x1D154
#define Z_UNICODE_MUSICAL_SYMBOL_TRIANGLE_ROUND_NOTEHEAD_DOWN_BLACK			   0x1D155
#define Z_UNICODE_MUSICAL_SYMBOL_PARENTHESIS_NOTEHEAD					   0x1D156
#define Z_UNICODE_MUSICAL_SYMBOL_VOID_NOTEHEAD						   0x1D157
#define Z_UNICODE_MUSICAL_SYMBOL_NOTEHEAD_BLACK						   0x1D158
#define Z_UNICODE_MUSICAL_SYMBOL_NULL_NOTEHEAD						   0x1D159
#define Z_UNICODE_MUSICAL_SYMBOL_CLUSTER_NOTEHEAD_WHITE					   0x1D15A
#define Z_UNICODE_MUSICAL_SYMBOL_CLUSTER_NOTEHEAD_BLACK					   0x1D15B
#define Z_UNICODE_MUSICAL_SYMBOL_BREVE							   0x1D15C
#define Z_UNICODE_MUSICAL_SYMBOL_WHOLE_NOTE						   0x1D15D
#define Z_UNICODE_MUSICAL_SYMBOL_HALF_NOTE						   0x1D15E
#define Z_UNICODE_MUSICAL_SYMBOL_QUARTER_NOTE						   0x1D15F
#define Z_UNICODE_MUSICAL_SYMBOL_EIGHTH_NOTE						   0x1D160
#define Z_UNICODE_MUSICAL_SYMBOL_SIXTEENTH_NOTE						   0x1D161
#define Z_UNICODE_MUSICAL_SYMBOL_THIRTY_SECOND_NOTE					   0x1D162
#define Z_UNICODE_MUSICAL_SYMBOL_SIXTY_FOURTH_NOTE					   0x1D163
#define Z_UNICODE_MUSICAL_SYMBOL_ONE_HUNDRED_TWENTY_EIGHTH_NOTE				   0x1D164
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_STEM						   0x1D165
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_SPRECHGESANG_STEM				   0x1D166
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_TREMOLO_1					   0x1D167
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_TREMOLO_2					   0x1D168
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_TREMOLO_3					   0x1D169
#define Z_UNICODE_MUSICAL_SYMBOL_FINGERED_TREMOLO_1					   0x1D16A
#define Z_UNICODE_MUSICAL_SYMBOL_FINGERED_TREMOLO_2					   0x1D16B
#define Z_UNICODE_MUSICAL_SYMBOL_FINGERED_TREMOLO_3					   0x1D16C
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_AUGMENTATION_DOT				   0x1D16D
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_FLAG_1					   0x1D16E
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_FLAG_2					   0x1D16F
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_FLAG_3					   0x1D170
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_FLAG_4					   0x1D171
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_FLAG_5					   0x1D172
#define Z_UNICODE_MUSICAL_SYMBOL_BEGIN_BEAM						   0x1D173
#define Z_UNICODE_MUSICAL_SYMBOL_END_BEAM						   0x1D174
#define Z_UNICODE_MUSICAL_SYMBOL_BEGIN_TIE						   0x1D175
#define Z_UNICODE_MUSICAL_SYMBOL_END_TIE						   0x1D176
#define Z_UNICODE_MUSICAL_SYMBOL_BEGIN_SLUR						   0x1D177
#define Z_UNICODE_MUSICAL_SYMBOL_END_SLUR						   0x1D178
#define Z_UNICODE_MUSICAL_SYMBOL_BEGIN_PHRASE						   0x1D179
#define Z_UNICODE_MUSICAL_SYMBOL_END_PHRASE						   0x1D17A
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_ACCENT					   0x1D17B
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_STACCATO					   0x1D17C
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_TENUTO					   0x1D17D
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_STACCATISSIMO				   0x1D17E
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_MARCATO					   0x1D17F
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_MARCATO_STACCATO				   0x1D180
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_ACCENT_STACCATO				   0x1D181
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_LOURE					   0x1D182
#define Z_UNICODE_MUSICAL_SYMBOL_ARPEGGIATO_UP						   0x1D183
#define Z_UNICODE_MUSICAL_SYMBOL_ARPEGGIATO_DOWN					   0x1D184
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_DOIT						   0x1D185
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_RIP						   0x1D186
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_FLIP						   0x1D187
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_SMEAR					   0x1D188
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_BEND						   0x1D189
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_DOUBLE_TONGUE				   0x1D18A
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_TRIPLE_TONGUE				   0x1D18B
#define Z_UNICODE_MUSICAL_SYMBOL_RINFORZANDO						   0x1D18C
#define Z_UNICODE_MUSICAL_SYMBOL_SUBITO							   0x1D18D
#define Z_UNICODE_MUSICAL_SYMBOL_Z							   0x1D18E
#define Z_UNICODE_MUSICAL_SYMBOL_PIANO							   0x1D18F
#define Z_UNICODE_MUSICAL_SYMBOL_MEZZO							   0x1D190
#define Z_UNICODE_MUSICAL_SYMBOL_FORTE							   0x1D191
#define Z_UNICODE_MUSICAL_SYMBOL_CRESCENDO						   0x1D192
#define Z_UNICODE_MUSICAL_SYMBOL_DECRESCENDO						   0x1D193
#define Z_UNICODE_MUSICAL_SYMBOL_GRACE_NOTE_SLASH					   0x1D194
#define Z_UNICODE_MUSICAL_SYMBOL_GRACE_NOTE_NO_SLASH					   0x1D195
#define Z_UNICODE_MUSICAL_SYMBOL_TR							   0x1D196
#define Z_UNICODE_MUSICAL_SYMBOL_TURN							   0x1D197
#define Z_UNICODE_MUSICAL_SYMBOL_INVERTED_TURN						   0x1D198
#define Z_UNICODE_MUSICAL_SYMBOL_TURN_SLASH						   0x1D199
#define Z_UNICODE_MUSICAL_SYMBOL_TURN_UP						   0x1D19A
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_1					   0x1D19B
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_2					   0x1D19C
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_3					   0x1D19D
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_4					   0x1D19E
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_5					   0x1D19F
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_6					   0x1D1A0
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_7					   0x1D1A1
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_8					   0x1D1A2
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_9					   0x1D1A3
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_10					   0x1D1A4
#define Z_UNICODE_MUSICAL_SYMBOL_ORNAMENT_STROKE_11					   0x1D1A5
#define Z_UNICODE_MUSICAL_SYMBOL_HAUPTSTIMME						   0x1D1A6
#define Z_UNICODE_MUSICAL_SYMBOL_NEBENSTIMME						   0x1D1A7
#define Z_UNICODE_MUSICAL_SYMBOL_END_OF_STIMME						   0x1D1A8
#define Z_UNICODE_MUSICAL_SYMBOL_DEGREE_SLASH						   0x1D1A9
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_DOWN_BOW					   0x1D1AA
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_UP_BOW					   0x1D1AB
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_HARMONIC					   0x1D1AC
#define Z_UNICODE_MUSICAL_SYMBOL_COMBINING_SNAP_PIZZICATO				   0x1D1AD
#define Z_UNICODE_MUSICAL_SYMBOL_PEDAL_MARK						   0x1D1AE
#define Z_UNICODE_MUSICAL_SYMBOL_PEDAL_UP_MARK						   0x1D1AF
#define Z_UNICODE_MUSICAL_SYMBOL_HALF_PEDAL_MARK					   0x1D1B0
#define Z_UNICODE_MUSICAL_SYMBOL_GLISSANDO_UP						   0x1D1B1
#define Z_UNICODE_MUSICAL_SYMBOL_GLISSANDO_DOWN						   0x1D1B2
#define Z_UNICODE_MUSICAL_SYMBOL_WITH_FINGERNAILS					   0x1D1B3
#define Z_UNICODE_MUSICAL_SYMBOL_DAMP							   0x1D1B4
#define Z_UNICODE_MUSICAL_SYMBOL_DAMP_ALL						   0x1D1B5
#define Z_UNICODE_MUSICAL_SYMBOL_MAXIMA							   0x1D1B6
#define Z_UNICODE_MUSICAL_SYMBOL_LONGA							   0x1D1B7
#define Z_UNICODE_MUSICAL_SYMBOL_BREVIS							   0x1D1B8
#define Z_UNICODE_MUSICAL_SYMBOL_SEMIBREVIS_WHITE					   0x1D1B9
#define Z_UNICODE_MUSICAL_SYMBOL_SEMIBREVIS_BLACK					   0x1D1BA
#define Z_UNICODE_MUSICAL_SYMBOL_MINIMA							   0x1D1BB
#define Z_UNICODE_MUSICAL_SYMBOL_MINIMA_BLACK						   0x1D1BC
#define Z_UNICODE_MUSICAL_SYMBOL_SEMIMINIMA_WHITE					   0x1D1BD
#define Z_UNICODE_MUSICAL_SYMBOL_SEMIMINIMA_BLACK					   0x1D1BE
#define Z_UNICODE_MUSICAL_SYMBOL_FUSA_WHITE						   0x1D1BF
#define Z_UNICODE_MUSICAL_SYMBOL_FUSA_BLACK						   0x1D1C0
#define Z_UNICODE_MUSICAL_SYMBOL_LONGA_PERFECTA_REST					   0x1D1C1
#define Z_UNICODE_MUSICAL_SYMBOL_LONGA_IMPERFECTA_REST					   0x1D1C2
#define Z_UNICODE_MUSICAL_SYMBOL_BREVIS_REST						   0x1D1C3
#define Z_UNICODE_MUSICAL_SYMBOL_SEMIBREVIS_REST					   0x1D1C4
#define Z_UNICODE_MUSICAL_SYMBOL_MINIMA_REST						   0x1D1C5
#define Z_UNICODE_MUSICAL_SYMBOL_SEMIMINIMA_REST					   0x1D1C6
#define Z_UNICODE_MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_PERFECTA		   0x1D1C7
#define Z_UNICODE_MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_IMPERFECTA		   0x1D1C8
#define Z_UNICODE_MUSICAL_SYMBOL_TEMPUS_PERFECTUM_CUM_PROLATIONE_PERFECTA_DIMINUTION_1	   0x1D1C9
#define Z_UNICODE_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_PERFECTA		   0x1D1CA
#define Z_UNICODE_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA		   0x1D1CB
#define Z_UNICODE_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_1 0x1D1CC
#define Z_UNICODE_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_2 0x1D1CD
#define Z_UNICODE_MUSICAL_SYMBOL_TEMPUS_IMPERFECTUM_CUM_PROLATIONE_IMPERFECTA_DIMINUTION_3 0x1D1CE
#define Z_UNICODE_MUSICAL_SYMBOL_CROIX							   0x1D1CF
#define Z_UNICODE_MUSICAL_SYMBOL_GREGORIAN_C_CLEF					   0x1D1D0
#define Z_UNICODE_MUSICAL_SYMBOL_GREGORIAN_F_CLEF					   0x1D1D1
#define Z_UNICODE_MUSICAL_SYMBOL_SQUARE_B						   0x1D1D2
#define Z_UNICODE_MUSICAL_SYMBOL_VIRGA							   0x1D1D3
#define Z_UNICODE_MUSICAL_SYMBOL_PODATUS						   0x1D1D4
#define Z_UNICODE_MUSICAL_SYMBOL_CLIVIS							   0x1D1D5
#define Z_UNICODE_MUSICAL_SYMBOL_SCANDICUS						   0x1D1D6
#define Z_UNICODE_MUSICAL_SYMBOL_CLIMACUS						   0x1D1D7
#define Z_UNICODE_MUSICAL_SYMBOL_TORCULUS						   0x1D1D8
#define Z_UNICODE_MUSICAL_SYMBOL_PORRECTUS						   0x1D1D9
#define Z_UNICODE_MUSICAL_SYMBOL_PORRECTUS_FLEXUS					   0x1D1DA
#define Z_UNICODE_MUSICAL_SYMBOL_SCANDICUS_FLEXUS					   0x1D1DB
#define Z_UNICODE_MUSICAL_SYMBOL_TORCULUS_RESUPINUS					   0x1D1DC
#define Z_UNICODE_MUSICAL_SYMBOL_PES_SUBPUNCTIS						   0x1D1DD
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_C_CLEF						   0x1D1DE
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_END_OF_PIECE					   0x1D1DF
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_FINAL_NOTE					   0x1D1E0
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_RECITATIVE_MARK					   0x1D1E1
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_WHOLE_NOTE					   0x1D1E2
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_HALF_NOTE					   0x1D1E3
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_QUARTER_NOTE_STEM_DOWN				   0x1D1E4
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_QUARTER_NOTE_STEM_UP				   0x1D1E5
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_EIGHTH_NOTE_STEM_DOWN				   0x1D1E6
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_EIGHTH_NOTE_STEM_UP				   0x1D1E7
#define Z_UNICODE_MUSICAL_SYMBOL_KIEVAN_FLAT_SIGN					   0x1D1E8

/* MARK: - 1D200h-1D24Fh - Ancient Greek Musical Notation */

#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_1		0x1D200
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_2		0x1D201
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_3		0x1D202
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_4		0x1D203
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_5		0x1D204
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_6		0x1D205
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_7		0x1D206
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_8		0x1D207
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_9		0x1D208
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_10	0x1D209
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_11	0x1D20A
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_12	0x1D20B
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_13	0x1D20C
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_14	0x1D20D
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_15	0x1D20E
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_16	0x1D20F
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_17	0x1D210
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_18	0x1D211
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_19	0x1D212
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_20	0x1D213
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_21	0x1D214
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_22	0x1D215
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_23	0x1D216
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_24	0x1D217
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_50	0x1D218
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_51	0x1D219
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_52	0x1D21A
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_53	0x1D21B
#define Z_UNICODE_GREEK_VOCAL_NOTATION_SYMBOL_54	0x1D21C
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_1	0x1D21D
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_2	0x1D21E
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_4	0x1D21F
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_5	0x1D220
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_7	0x1D221
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_8	0x1D222
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_11	0x1D223
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_12	0x1D224
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_13	0x1D225
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_14	0x1D226
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_17	0x1D227
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_18	0x1D228
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_19	0x1D229
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_23	0x1D22A
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_24	0x1D22B
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_25	0x1D22C
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_26	0x1D22D
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_27	0x1D22E
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_29	0x1D22F
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_30	0x1D230
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_32	0x1D231
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_36	0x1D232
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_37	0x1D233
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_38	0x1D234
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_39	0x1D235
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_40	0x1D236
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_42	0x1D237
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_43	0x1D238
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_45	0x1D239
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_47	0x1D23A
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_48	0x1D23B
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_49	0x1D23C
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_50	0x1D23D
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_51	0x1D23E
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_52	0x1D23F
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_53	0x1D240
#define Z_UNICODE_GREEK_INSTRUMENTAL_NOTATION_SYMBOL_54	0x1D241
#define Z_UNICODE_COMBINING_GREEK_MUSICAL_TRISEME	0x1D242
#define Z_UNICODE_COMBINING_GREEK_MUSICAL_TETRASEME	0x1D243
#define Z_UNICODE_COMBINING_GREEK_MUSICAL_PENTASEME	0x1D244
#define Z_UNICODE_GREEK_MUSICAL_LEIMMA			0x1D245

/* MARK: - 1D300h-1D35Fh - Tai Xuan Jing Symbols */

#define Z_UNICODE_MONOGRAM_FOR_EARTH			    0x1D300
#define Z_UNICODE_DIGRAM_FOR_HEAVENLY_EARTH		    0x1D301
#define Z_UNICODE_DIGRAM_FOR_HUMAN_EARTH		    0x1D302
#define Z_UNICODE_DIGRAM_FOR_EARTHLY_HEAVEN		    0x1D303
#define Z_UNICODE_DIGRAM_FOR_EARTHLY_HUMAN		    0x1D304
#define Z_UNICODE_DIGRAM_FOR_EARTH			    0x1D305
#define Z_UNICODE_TETRAGRAM_FOR_CENTRE			    0x1D306
#define Z_UNICODE_TETRAGRAM_FOR_FULL_CIRCLE		    0x1D307
#define Z_UNICODE_TETRAGRAM_FOR_MIRED			    0x1D308
#define Z_UNICODE_TETRAGRAM_FOR_BARRIER			    0x1D309
#define Z_UNICODE_TETRAGRAM_FOR_KEEPING_SMALL		    0x1D30A
#define Z_UNICODE_TETRAGRAM_FOR_CONTRARIETY		    0x1D30B
#define Z_UNICODE_TETRAGRAM_FOR_ASCENT			    0x1D30C
#define Z_UNICODE_TETRAGRAM_FOR_OPPOSITION		    0x1D30D
#define Z_UNICODE_TETRAGRAM_FOR_BRANCHING_OUT		    0x1D30E
#define Z_UNICODE_TETRAGRAM_FOR_DEFECTIVENESS_OR_DISTORTION 0x1D30F
#define Z_UNICODE_TETRAGRAM_FOR_DIVERGENCE		    0x1D310
#define Z_UNICODE_TETRAGRAM_FOR_YOUTHFULNESS		    0x1D311
#define Z_UNICODE_TETRAGRAM_FOR_INCREASE		    0x1D312
#define Z_UNICODE_TETRAGRAM_FOR_PENETRATION		    0x1D313
#define Z_UNICODE_TETRAGRAM_FOR_REACH			    0x1D314
#define Z_UNICODE_TETRAGRAM_FOR_CONTACT			    0x1D315
#define Z_UNICODE_TETRAGRAM_FOR_HOLDING_BACK		    0x1D316
#define Z_UNICODE_TETRAGRAM_FOR_WAITING			    0x1D317
#define Z_UNICODE_TETRAGRAM_FOR_FOLLOWING		    0x1D318
#define Z_UNICODE_TETRAGRAM_FOR_ADVANCE			    0x1D319
#define Z_UNICODE_TETRAGRAM_FOR_RELEASE			    0x1D31A
#define Z_UNICODE_TETRAGRAM_FOR_RESISTANCE		    0x1D31B
#define Z_UNICODE_TETRAGRAM_FOR_EASE			    0x1D31C
#define Z_UNICODE_TETRAGRAM_FOR_JOY			    0x1D31D
#define Z_UNICODE_TETRAGRAM_FOR_CONTENTION		    0x1D31E
#define Z_UNICODE_TETRAGRAM_FOR_ENDEAVOUR		    0x1D31F
#define Z_UNICODE_TETRAGRAM_FOR_DUTIES			    0x1D320
#define Z_UNICODE_TETRAGRAM_FOR_CHANGE			    0x1D321
#define Z_UNICODE_TETRAGRAM_FOR_DECISIVENESS		    0x1D322
#define Z_UNICODE_TETRAGRAM_FOR_BOLD_RESOLUTION		    0x1D323
#define Z_UNICODE_TETRAGRAM_FOR_PACKING			    0x1D324
#define Z_UNICODE_TETRAGRAM_FOR_LEGION			    0x1D325
#define Z_UNICODE_TETRAGRAM_FOR_CLOSENESS		    0x1D326
#define Z_UNICODE_TETRAGRAM_FOR_KINSHIP			    0x1D327
#define Z_UNICODE_TETRAGRAM_FOR_GATHERING		    0x1D328
#define Z_UNICODE_TETRAGRAM_FOR_STRENGTH		    0x1D329
#define Z_UNICODE_TETRAGRAM_FOR_PURITY			    0x1D32A
#define Z_UNICODE_TETRAGRAM_FOR_FULLNESS		    0x1D32B
#define Z_UNICODE_TETRAGRAM_FOR_RESIDENCE		    0x1D32C
#define Z_UNICODE_TETRAGRAM_FOR_LAW_OR_MODEL		    0x1D32D
#define Z_UNICODE_TETRAGRAM_FOR_RESPONSE		    0x1D32E
#define Z_UNICODE_TETRAGRAM_FOR_GOING_TO_MEET		    0x1D32F
#define Z_UNICODE_TETRAGRAM_FOR_ENCOUNTERS		    0x1D330
#define Z_UNICODE_TETRAGRAM_FOR_STOVE			    0x1D331
#define Z_UNICODE_TETRAGRAM_FOR_GREATNESS		    0x1D332
#define Z_UNICODE_TETRAGRAM_FOR_ENLARGEMENT		    0x1D333
#define Z_UNICODE_TETRAGRAM_FOR_PATTERN			    0x1D334
#define Z_UNICODE_TETRAGRAM_FOR_RITUAL			    0x1D335
#define Z_UNICODE_TETRAGRAM_FOR_FLIGHT			    0x1D336
#define Z_UNICODE_TETRAGRAM_FOR_VASTNESS_OR_WASTING	    0x1D337
#define Z_UNICODE_TETRAGRAM_FOR_CONSTANCY		    0x1D338
#define Z_UNICODE_TETRAGRAM_FOR_MEASURE			    0x1D339
#define Z_UNICODE_TETRAGRAM_FOR_ETERNITY		    0x1D33A
#define Z_UNICODE_TETRAGRAM_FOR_UNITY			    0x1D33B
#define Z_UNICODE_TETRAGRAM_FOR_DIMINISHMENT		    0x1D33C
#define Z_UNICODE_TETRAGRAM_FOR_CLOSED_MOUTH		    0x1D33D
#define Z_UNICODE_TETRAGRAM_FOR_GUARDEDNESS		    0x1D33E
#define Z_UNICODE_TETRAGRAM_FOR_GATHERING_IN		    0x1D33F
#define Z_UNICODE_TETRAGRAM_FOR_MASSING			    0x1D340
#define Z_UNICODE_TETRAGRAM_FOR_ACCUMULATION		    0x1D341
#define Z_UNICODE_TETRAGRAM_FOR_EMBELLISHMENT		    0x1D342
#define Z_UNICODE_TETRAGRAM_FOR_DOUBT			    0x1D343
#define Z_UNICODE_TETRAGRAM_FOR_WATCH			    0x1D344
#define Z_UNICODE_TETRAGRAM_FOR_SINKING			    0x1D345
#define Z_UNICODE_TETRAGRAM_FOR_INNER			    0x1D346
#define Z_UNICODE_TETRAGRAM_FOR_DEPARTURE		    0x1D347
#define Z_UNICODE_TETRAGRAM_FOR_DARKENING		    0x1D348
#define Z_UNICODE_TETRAGRAM_FOR_DIMMING			    0x1D349
#define Z_UNICODE_TETRAGRAM_FOR_EXHAUSTION		    0x1D34A
#define Z_UNICODE_TETRAGRAM_FOR_SEVERANCE		    0x1D34B
#define Z_UNICODE_TETRAGRAM_FOR_STOPPAGE		    0x1D34C
#define Z_UNICODE_TETRAGRAM_FOR_HARDNESS		    0x1D34D
#define Z_UNICODE_TETRAGRAM_FOR_COMPLETION		    0x1D34E
#define Z_UNICODE_TETRAGRAM_FOR_CLOSURE			    0x1D34F
#define Z_UNICODE_TETRAGRAM_FOR_FAILURE			    0x1D350
#define Z_UNICODE_TETRAGRAM_FOR_AGGRAVATION		    0x1D351
#define Z_UNICODE_TETRAGRAM_FOR_COMPLIANCE		    0x1D352
#define Z_UNICODE_TETRAGRAM_FOR_ON_THE_VERGE		    0x1D353
#define Z_UNICODE_TETRAGRAM_FOR_DIFFICULTIES		    0x1D354
#define Z_UNICODE_TETRAGRAM_FOR_LABOURING		    0x1D355
#define Z_UNICODE_TETRAGRAM_FOR_FOSTERING		    0x1D356

/* MARK: - 1D360h-1D37Fh - Counting Rod Numerals */

#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_ONE	0x1D360
#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_TWO	0x1D361
#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_THREE	0x1D362
#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_FOUR	0x1D363
#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_FIVE	0x1D364
#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_SIX	0x1D365
#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_SEVEN	0x1D366
#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_EIGHT	0x1D367
#define Z_UNICODE_COUNTING_ROD_UNIT_DIGIT_NINE	0x1D368
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_ONE	0x1D369
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_TWO	0x1D36A
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_THREE	0x1D36B
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_FOUR	0x1D36C
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_FIVE	0x1D36D
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_SIX	0x1D36E
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_SEVEN	0x1D36F
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_EIGHT	0x1D370
#define Z_UNICODE_COUNTING_ROD_TENS_DIGIT_NINE	0x1D371

/* MARK: - 1D400h-1D7FFh - Mathematical Alphanumeric Symbols */

/* 1D455h <reserved> */
/* 1D49Dh <reserved> */
/* 1D4A0h <reserved> */
/* 1D4A1h <reserved> */
/* 1D4A3h <reserved> */
/* 1D4A4h <reserved> */
/* 1D4A7h <reserved> */
/* 1D4A8h <reserved> */
/* 1D4ADh <reserved> */
/* 1D4BAh <reserved> */
/* 1D4BCh <reserved> */
/* 1D4C4h <reserved> */
/* 1D506h <reserved> */
/* 1D50Bh <reserved> */
/* 1D50Ch <reserved> */
/* 1D515h <reserved> */
/* 1D51Dh <reserved> */
/* 1D53Ah <reserved> */
/* 1D53Fh <reserved> */
/* 1D545h <reserved> */
/* 1D547h <reserved> */
/* 1D548h <reserved> */
/* 1D549h <reserved> */
/* 1D551h <reserved> */
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_A				   0x1D400
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_B				   0x1D401
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_C				   0x1D402
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_D				   0x1D403
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_E				   0x1D404
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_F				   0x1D405
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_G				   0x1D406
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_H				   0x1D407
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_I				   0x1D408
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_J				   0x1D409
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_K				   0x1D40A
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_L				   0x1D40B
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_M				   0x1D40C
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_N				   0x1D40D
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_O				   0x1D40E
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_P				   0x1D40F
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_Q				   0x1D410
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_R				   0x1D411
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_S				   0x1D412
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_T				   0x1D413
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_U				   0x1D414
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_V				   0x1D415
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_W				   0x1D416
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_X				   0x1D417
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_Y				   0x1D418
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_Z				   0x1D419
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_A				   0x1D41A
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_B				   0x1D41B
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_C				   0x1D41C
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_D				   0x1D41D
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_E				   0x1D41E
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_F				   0x1D41F
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_G				   0x1D420
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_H				   0x1D421
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_I				   0x1D422
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_J				   0x1D423
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_K				   0x1D424
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_L				   0x1D425
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_M				   0x1D426
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_N				   0x1D427
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_O				   0x1D428
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_P				   0x1D429
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_Q				   0x1D42A
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_R				   0x1D42B
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_S				   0x1D42C
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_T				   0x1D42D
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_U				   0x1D42E
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_V				   0x1D42F
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_W				   0x1D430
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_X				   0x1D431
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_Y				   0x1D432
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_Z				   0x1D433
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_A				   0x1D434
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_B				   0x1D435
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_C				   0x1D436
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_D				   0x1D437
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_E				   0x1D438
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_F				   0x1D439
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_G				   0x1D43A
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_H				   0x1D43B
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_I				   0x1D43C
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_J				   0x1D43D
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_K				   0x1D43E
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_L				   0x1D43F
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_M				   0x1D440
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_N				   0x1D441
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_O				   0x1D442
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_P				   0x1D443
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_Q				   0x1D444
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_R				   0x1D445
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_S				   0x1D446
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_T				   0x1D447
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_U				   0x1D448
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_V				   0x1D449
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_W				   0x1D44A
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_X				   0x1D44B
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_Y				   0x1D44C
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_Z				   0x1D44D
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_A				   0x1D44E
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_B				   0x1D44F
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_C				   0x1D450
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_D				   0x1D451
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_E				   0x1D452
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_F				   0x1D453
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_G				   0x1D454
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_I				   0x1D456
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_J				   0x1D457
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_K				   0x1D458
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_L				   0x1D459
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_M				   0x1D45A
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_N				   0x1D45B
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_O				   0x1D45C
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_P				   0x1D45D
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_Q				   0x1D45E
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_R				   0x1D45F
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_S				   0x1D460
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_T				   0x1D461
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_U				   0x1D462
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_V				   0x1D463
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_W				   0x1D464
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_X				   0x1D465
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_Y				   0x1D466
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_Z				   0x1D467
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_A			   0x1D468
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_B			   0x1D469
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_C			   0x1D46A
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_D			   0x1D46B
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_E			   0x1D46C
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_F			   0x1D46D
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_G			   0x1D46E
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_H			   0x1D46F
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_I			   0x1D470
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_J			   0x1D471
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_K			   0x1D472
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_L			   0x1D473
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_M			   0x1D474
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_N			   0x1D475
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_O			   0x1D476
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_P			   0x1D477
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_Q			   0x1D478
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_R			   0x1D479
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_S			   0x1D47A
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_T			   0x1D47B
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_U			   0x1D47C
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_V			   0x1D47D
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_W			   0x1D47E
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_X			   0x1D47F
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_Y			   0x1D480
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_Z			   0x1D481
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_A			   0x1D482
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_B			   0x1D483
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_C			   0x1D484
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_D			   0x1D485
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_E			   0x1D486
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_F			   0x1D487
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_G			   0x1D488
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_H			   0x1D489
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_I			   0x1D48A
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_J			   0x1D48B
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_K			   0x1D48C
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_L			   0x1D48D
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_M			   0x1D48E
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_N			   0x1D48F
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_O			   0x1D490
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_P			   0x1D491
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_Q			   0x1D492
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_R			   0x1D493
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_S			   0x1D494
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_T			   0x1D495
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_U			   0x1D496
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_V			   0x1D497
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_W			   0x1D498
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_X			   0x1D499
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_Y			   0x1D49A
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_Z			   0x1D49B
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_A				   0x1D49C
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_C				   0x1D49E
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_D				   0x1D49F
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_G				   0x1D4A2
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_J				   0x1D4A5
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_K				   0x1D4A6
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_N				   0x1D4A9
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_O				   0x1D4AA
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_P				   0x1D4AB
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_Q				   0x1D4AC
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_S				   0x1D4AE
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_T				   0x1D4AF
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_U				   0x1D4B0
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_V				   0x1D4B1
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_W				   0x1D4B2
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_X				   0x1D4B3
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_Y				   0x1D4B4
#define Z_UNICODE_MATHEMATICAL_SCRIPT_CAPITAL_Z				   0x1D4B5
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_A				   0x1D4B6
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_B				   0x1D4B7
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_C				   0x1D4B8
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_D				   0x1D4B9
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_F				   0x1D4BB
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_H				   0x1D4BD
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_I				   0x1D4BE
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_J				   0x1D4BF
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_K				   0x1D4C0
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_L				   0x1D4C1
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_M				   0x1D4C2
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_N				   0x1D4C3
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_P				   0x1D4C5
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_Q				   0x1D4C6
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_R				   0x1D4C7
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_S				   0x1D4C8
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_T				   0x1D4C9
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_U				   0x1D4CA
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_V				   0x1D4CB
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_W				   0x1D4CC
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_X				   0x1D4CD
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_Y				   0x1D4CE
#define Z_UNICODE_MATHEMATICAL_SCRIPT_SMALL_Z				   0x1D4CF
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_A			   0x1D4D0
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_B			   0x1D4D1
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_C			   0x1D4D2
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_D			   0x1D4D3
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_E			   0x1D4D4
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_F			   0x1D4D5
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_G			   0x1D4D6
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_H			   0x1D4D7
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_I			   0x1D4D8
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_J			   0x1D4D9
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_K			   0x1D4DA
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_L			   0x1D4DB
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_M			   0x1D4DC
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_N			   0x1D4DD
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_O			   0x1D4DE
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_P			   0x1D4DF
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Q			   0x1D4E0
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_R			   0x1D4E1
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_S			   0x1D4E2
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_T			   0x1D4E3
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_U			   0x1D4E4
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_V			   0x1D4E5
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_W			   0x1D4E6
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_X			   0x1D4E7
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Y			   0x1D4E8
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_CAPITAL_Z			   0x1D4E9
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_A			   0x1D4EA
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_B			   0x1D4EB
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_C			   0x1D4EC
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_D			   0x1D4ED
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_E			   0x1D4EE
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_F			   0x1D4EF
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_G			   0x1D4F0
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_H			   0x1D4F1
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_I			   0x1D4F2
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_J			   0x1D4F3
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_K			   0x1D4F4
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_L			   0x1D4F5
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_M			   0x1D4F6
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_N			   0x1D4F7
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_O			   0x1D4F8
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_P			   0x1D4F9
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_Q			   0x1D4FA
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_R			   0x1D4FB
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_S			   0x1D4FC
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_T			   0x1D4FD
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_U			   0x1D4FE
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_V			   0x1D4FF
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_W			   0x1D500
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_X			   0x1D501
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_Y			   0x1D502
#define Z_UNICODE_MATHEMATICAL_BOLD_SCRIPT_SMALL_Z			   0x1D503
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_A			   0x1D504
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_B			   0x1D505
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_D			   0x1D507
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_E			   0x1D508
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_F			   0x1D509
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_G			   0x1D50A
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_J			   0x1D50D
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_K			   0x1D50E
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_L			   0x1D50F
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_M			   0x1D510
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_N			   0x1D511
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_O			   0x1D512
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_P			   0x1D513
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_Q			   0x1D514
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_S			   0x1D516
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_T			   0x1D517
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_U			   0x1D518
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_V			   0x1D519
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_W			   0x1D51A
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_X			   0x1D51B
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_CAPITAL_Y			   0x1D51C
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_A				   0x1D51E
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_B				   0x1D51F
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_C				   0x1D520
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_D				   0x1D521
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_E				   0x1D522
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_F				   0x1D523
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_G				   0x1D524
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_H				   0x1D525
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_I				   0x1D526
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_J				   0x1D527
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_K				   0x1D528
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_L				   0x1D529
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_M				   0x1D52A
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_N				   0x1D52B
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_O				   0x1D52C
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_P				   0x1D52D
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_Q				   0x1D52E
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_R				   0x1D52F
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_S				   0x1D530
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_T				   0x1D531
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_U				   0x1D532
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_V				   0x1D533
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_W				   0x1D534
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_X				   0x1D535
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_Y				   0x1D536
#define Z_UNICODE_MATHEMATICAL_FRAKTUR_SMALL_Z				   0x1D537
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_A			   0x1D538
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_B			   0x1D539
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_D			   0x1D53B
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_E			   0x1D53C
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_F			   0x1D53D
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_G			   0x1D53E
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_I			   0x1D540
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_J			   0x1D541
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_K			   0x1D542
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_L			   0x1D543
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_M			   0x1D544
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_O			   0x1D546
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_S			   0x1D54A
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_T			   0x1D54B
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_U			   0x1D54C
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_V			   0x1D54D
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_W			   0x1D54E
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_X			   0x1D54F
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_CAPITAL_Y			   0x1D550
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_A			   0x1D552
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_B			   0x1D553
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_C			   0x1D554
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_D			   0x1D555
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_E			   0x1D556
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_F			   0x1D557
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_G			   0x1D558
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_H			   0x1D559
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_I			   0x1D55A
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_J			   0x1D55B
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_K			   0x1D55C
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_L			   0x1D55D
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_M			   0x1D55E
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_N			   0x1D55F
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_O			   0x1D560
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_P			   0x1D561
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_Q			   0x1D562
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_R			   0x1D563
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_S			   0x1D564
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_T			   0x1D565
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_U			   0x1D566
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_V			   0x1D567
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_W			   0x1D568
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_X			   0x1D569
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_Y			   0x1D56A
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_SMALL_Z			   0x1D56B
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_A			   0x1D56C
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_B			   0x1D56D
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_C			   0x1D56E
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_D			   0x1D56F
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_E			   0x1D570
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_F			   0x1D571
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_G			   0x1D572
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_H			   0x1D573
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_I			   0x1D574
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_J			   0x1D575
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_K			   0x1D576
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_L			   0x1D577
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_M			   0x1D578
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_N			   0x1D579
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_O			   0x1D57A
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_P			   0x1D57B
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Q			   0x1D57C
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_R			   0x1D57D
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_S			   0x1D57E
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_T			   0x1D57F
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_U			   0x1D580
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_V			   0x1D581
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_W			   0x1D582
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_X			   0x1D583
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Y			   0x1D584
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_CAPITAL_Z			   0x1D585
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_A			   0x1D586
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_B			   0x1D587
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_C			   0x1D588
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_D			   0x1D589
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_E			   0x1D58A
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_F			   0x1D58B
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_G			   0x1D58C
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_H			   0x1D58D
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_I			   0x1D58E
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_J			   0x1D58F
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_K			   0x1D590
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_L			   0x1D591
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_M			   0x1D592
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_N			   0x1D593
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_O			   0x1D594
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_P			   0x1D595
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_Q			   0x1D596
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_R			   0x1D597
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_S			   0x1D598
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_T			   0x1D599
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_U			   0x1D59A
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_V			   0x1D59B
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_W			   0x1D59C
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_X			   0x1D59D
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_Y			   0x1D59E
#define Z_UNICODE_MATHEMATICAL_BOLD_FRAKTUR_SMALL_Z			   0x1D59F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_A			   0x1D5A0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_B			   0x1D5A1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_C			   0x1D5A2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_D			   0x1D5A3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_E			   0x1D5A4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_F			   0x1D5A5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_G			   0x1D5A6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_H			   0x1D5A7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_I			   0x1D5A8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_J			   0x1D5A9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_K			   0x1D5AA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_L			   0x1D5AB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_M			   0x1D5AC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_N			   0x1D5AD
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_O			   0x1D5AE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_P			   0x1D5AF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_Q			   0x1D5B0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_R			   0x1D5B1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_S			   0x1D5B2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_T			   0x1D5B3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_U			   0x1D5B4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_V			   0x1D5B5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_W			   0x1D5B6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_X			   0x1D5B7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_Y			   0x1D5B8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_CAPITAL_Z			   0x1D5B9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_A			   0x1D5BA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_B			   0x1D5BB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_C			   0x1D5BC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_D			   0x1D5BD
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_E			   0x1D5BE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_F			   0x1D5BF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_G			   0x1D5C0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_H			   0x1D5C1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_I			   0x1D5C2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_J			   0x1D5C3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_K			   0x1D5C4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_L			   0x1D5C5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_M			   0x1D5C6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_N			   0x1D5C7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_O			   0x1D5C8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_P			   0x1D5C9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_Q			   0x1D5CA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_R			   0x1D5CB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_S			   0x1D5CC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_T			   0x1D5CD
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_U			   0x1D5CE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_V			   0x1D5CF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_W			   0x1D5D0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_X			   0x1D5D1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_Y			   0x1D5D2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_SMALL_Z			   0x1D5D3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_A		   0x1D5D4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_B		   0x1D5D5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_C		   0x1D5D6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_D		   0x1D5D7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_E		   0x1D5D8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_F		   0x1D5D9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_G		   0x1D5DA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_H		   0x1D5DB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_I		   0x1D5DC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_J		   0x1D5DD
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_K		   0x1D5DE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_L		   0x1D5DF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_M		   0x1D5E0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_N		   0x1D5E1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_O		   0x1D5E2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_P		   0x1D5E3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Q		   0x1D5E4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_R		   0x1D5E5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_S		   0x1D5E6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_T		   0x1D5E7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_U		   0x1D5E8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_V		   0x1D5E9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_W		   0x1D5EA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_X		   0x1D5EB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Y		   0x1D5EC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_Z		   0x1D5ED
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_A			   0x1D5EE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_B			   0x1D5EF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_C			   0x1D5F0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_D			   0x1D5F1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_E			   0x1D5F2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_F			   0x1D5F3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_G			   0x1D5F4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_H			   0x1D5F5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_I			   0x1D5F6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_J			   0x1D5F7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_K			   0x1D5F8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_L			   0x1D5F9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_M			   0x1D5FA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_N			   0x1D5FB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_O			   0x1D5FC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_P			   0x1D5FD
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Q			   0x1D5FE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_R			   0x1D5FF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_S			   0x1D600
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_T			   0x1D601
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_U			   0x1D602
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_V			   0x1D603
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_W			   0x1D604
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_X			   0x1D605
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Y			   0x1D606
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_Z			   0x1D607
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_A		   0x1D608
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_B		   0x1D609
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_C		   0x1D60A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_D		   0x1D60B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_E		   0x1D60C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_F		   0x1D60D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_G		   0x1D60E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_H		   0x1D60F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_I		   0x1D610
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_J		   0x1D611
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_K		   0x1D612
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_L		   0x1D613
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_M		   0x1D614
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_N		   0x1D615
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_O		   0x1D616
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_P		   0x1D617
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Q		   0x1D618
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_R		   0x1D619
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_S		   0x1D61A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_T		   0x1D61B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_U		   0x1D61C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_V		   0x1D61D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_W		   0x1D61E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_X		   0x1D61F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Y		   0x1D620
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_CAPITAL_Z		   0x1D621
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_A		   0x1D622
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_B		   0x1D623
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_C		   0x1D624
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_D		   0x1D625
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_E		   0x1D626
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_F		   0x1D627
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_G		   0x1D628
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_H		   0x1D629
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_I		   0x1D62A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_J		   0x1D62B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_K		   0x1D62C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_L		   0x1D62D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_M		   0x1D62E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_N		   0x1D62F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_O		   0x1D630
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_P		   0x1D631
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Q		   0x1D632
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_R		   0x1D633
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_S		   0x1D634
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_T		   0x1D635
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_U		   0x1D636
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_V		   0x1D637
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_W		   0x1D638
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_X		   0x1D639
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Y		   0x1D63A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_ITALIC_SMALL_Z		   0x1D63B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_A		   0x1D63C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_B		   0x1D63D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_C		   0x1D63E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_D		   0x1D63F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_E		   0x1D640
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_F		   0x1D641
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_G		   0x1D642
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_H		   0x1D643
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_I		   0x1D644
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_J		   0x1D645
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_K		   0x1D646
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_L		   0x1D647
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_M		   0x1D648
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_N		   0x1D649
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_O		   0x1D64A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_P		   0x1D64B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Q		   0x1D64C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_R		   0x1D64D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_S		   0x1D64E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_T		   0x1D64F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_U		   0x1D650
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_V		   0x1D651
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_W		   0x1D652
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_X		   0x1D653
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Y		   0x1D654
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_Z		   0x1D655
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_A		   0x1D656
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_B		   0x1D657
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_C		   0x1D658
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_D		   0x1D659
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_E		   0x1D65A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_F		   0x1D65B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_G		   0x1D65C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_H		   0x1D65D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_I		   0x1D65E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_J		   0x1D65F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_K		   0x1D660
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_L		   0x1D661
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_M		   0x1D662
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_N		   0x1D663
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_O		   0x1D664
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_P		   0x1D665
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Q		   0x1D666
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_R		   0x1D667
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_S		   0x1D668
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_T		   0x1D669
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_U		   0x1D66A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_V		   0x1D66B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_W		   0x1D66C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_X		   0x1D66D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Y		   0x1D66E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_Z		   0x1D66F
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_A			   0x1D670
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_B			   0x1D671
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_C			   0x1D672
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_D			   0x1D673
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_E			   0x1D674
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_F			   0x1D675
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_G			   0x1D676
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_H			   0x1D677
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_I			   0x1D678
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_J			   0x1D679
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_K			   0x1D67A
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_L			   0x1D67B
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_M			   0x1D67C
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_N			   0x1D67D
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_O			   0x1D67E
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_P			   0x1D67F
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_Q			   0x1D680
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_R			   0x1D681
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_S			   0x1D682
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_T			   0x1D683
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_U			   0x1D684
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_V			   0x1D685
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_W			   0x1D686
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_X			   0x1D687
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_Y			   0x1D688
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_CAPITAL_Z			   0x1D689
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_A			   0x1D68A
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_B			   0x1D68B
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_C			   0x1D68C
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_D			   0x1D68D
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_E			   0x1D68E
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_F			   0x1D68F
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_G			   0x1D690
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_H			   0x1D691
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_I			   0x1D692
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_J			   0x1D693
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_K			   0x1D694
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_L			   0x1D695
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_M			   0x1D696
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_N			   0x1D697
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_O			   0x1D698
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_P			   0x1D699
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_Q			   0x1D69A
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_R			   0x1D69B
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_S			   0x1D69C
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_T			   0x1D69D
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_U			   0x1D69E
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_V			   0x1D69F
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_W			   0x1D6A0
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_X			   0x1D6A1
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_Y			   0x1D6A2
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_SMALL_Z			   0x1D6A3
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_DOTLESS_I			   0x1D6A4
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_DOTLESS_J			   0x1D6A5
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_ALPHA			   0x1D6A8
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_BETA			   0x1D6A9
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_GAMMA			   0x1D6AA
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_DELTA			   0x1D6AB
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_EPSILON			   0x1D6AC
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_ZETA			   0x1D6AD
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_ETA				   0x1D6AE
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_THETA			   0x1D6AF
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_IOTA			   0x1D6B0
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_KAPPA			   0x1D6B1
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_LAMDA			   0x1D6B2
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_MU				   0x1D6B3
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_NU				   0x1D6B4
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_XI				   0x1D6B5
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_OMICRON			   0x1D6B6
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_PI				   0x1D6B7
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_RHO				   0x1D6B8
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_THETA_SYMBOL		   0x1D6B9
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_SIGMA			   0x1D6BA
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_TAU				   0x1D6BB
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_UPSILON			   0x1D6BC
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_PHI				   0x1D6BD
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_CHI				   0x1D6BE
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_PSI				   0x1D6BF
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_OMEGA			   0x1D6C0
#define Z_UNICODE_MATHEMATICAL_BOLD_NABLA				   0x1D6C1
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_ALPHA				   0x1D6C2
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_BETA				   0x1D6C3
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_GAMMA				   0x1D6C4
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_DELTA				   0x1D6C5
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_EPSILON			   0x1D6C6
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_ZETA				   0x1D6C7
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_ETA				   0x1D6C8
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_THETA				   0x1D6C9
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_IOTA				   0x1D6CA
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_KAPPA				   0x1D6CB
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_LAMDA				   0x1D6CC
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_MU				   0x1D6CD
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_NU				   0x1D6CE
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_XI				   0x1D6CF
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_OMICRON			   0x1D6D0
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_PI				   0x1D6D1
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_RHO				   0x1D6D2
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_FINAL_SIGMA			   0x1D6D3
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_SIGMA				   0x1D6D4
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_TAU				   0x1D6D5
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_UPSILON			   0x1D6D6
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_PHI				   0x1D6D7
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_CHI				   0x1D6D8
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_PSI				   0x1D6D9
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_OMEGA				   0x1D6DA
#define Z_UNICODE_MATHEMATICAL_BOLD_PARTIAL_DIFFERENTIAL		   0x1D6DB
#define Z_UNICODE_MATHEMATICAL_BOLD_EPSILON_SYMBOL			   0x1D6DC
#define Z_UNICODE_MATHEMATICAL_BOLD_THETA_SYMBOL			   0x1D6DD
#define Z_UNICODE_MATHEMATICAL_BOLD_KAPPA_SYMBOL			   0x1D6DE
#define Z_UNICODE_MATHEMATICAL_BOLD_PHI_SYMBOL				   0x1D6DF
#define Z_UNICODE_MATHEMATICAL_BOLD_RHO_SYMBOL				   0x1D6E0
#define Z_UNICODE_MATHEMATICAL_BOLD_PI_SYMBOL				   0x1D6E1
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_ALPHA			   0x1D6E2
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_BETA			   0x1D6E3
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_GAMMA			   0x1D6E4
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_DELTA			   0x1D6E5
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_EPSILON			   0x1D6E6
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_ZETA			   0x1D6E7
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_ETA			   0x1D6E8
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_THETA			   0x1D6E9
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_IOTA			   0x1D6EA
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_KAPPA			   0x1D6EB
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_LAMDA			   0x1D6EC
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_MU			   0x1D6ED
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_NU			   0x1D6EE
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_XI			   0x1D6EF
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_OMICRON			   0x1D6F0
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_PI			   0x1D6F1
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_RHO			   0x1D6F2
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_THETA_SYMBOL		   0x1D6F3
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_SIGMA			   0x1D6F4
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_TAU			   0x1D6F5
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_UPSILON			   0x1D6F6
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_PHI			   0x1D6F7
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_CHI			   0x1D6F8
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_PSI			   0x1D6F9
#define Z_UNICODE_MATHEMATICAL_ITALIC_CAPITAL_OMEGA			   0x1D6FA
#define Z_UNICODE_MATHEMATICAL_ITALIC_NABLA				   0x1D6FB
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_ALPHA			   0x1D6FC
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_BETA			   0x1D6FD
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_GAMMA			   0x1D6FE
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_DELTA			   0x1D6FF
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_EPSILON			   0x1D700
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_ZETA			   0x1D701
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_ETA				   0x1D702
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_THETA			   0x1D703
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_IOTA			   0x1D704
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_KAPPA			   0x1D705
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_LAMDA			   0x1D706
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_MU				   0x1D707
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_NU				   0x1D708
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_XI				   0x1D709
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_OMICRON			   0x1D70A
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_PI				   0x1D70B
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_RHO				   0x1D70C
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_FINAL_SIGMA			   0x1D70D
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_SIGMA			   0x1D70E
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_TAU				   0x1D70F
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_UPSILON			   0x1D710
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_PHI				   0x1D711
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_CHI				   0x1D712
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_PSI				   0x1D713
#define Z_UNICODE_MATHEMATICAL_ITALIC_SMALL_OMEGA			   0x1D714
#define Z_UNICODE_MATHEMATICAL_ITALIC_PARTIAL_DIFFERENTIAL		   0x1D715
#define Z_UNICODE_MATHEMATICAL_ITALIC_EPSILON_SYMBOL			   0x1D716
#define Z_UNICODE_MATHEMATICAL_ITALIC_THETA_SYMBOL			   0x1D717
#define Z_UNICODE_MATHEMATICAL_ITALIC_KAPPA_SYMBOL			   0x1D718
#define Z_UNICODE_MATHEMATICAL_ITALIC_PHI_SYMBOL			   0x1D719
#define Z_UNICODE_MATHEMATICAL_ITALIC_RHO_SYMBOL			   0x1D71A
#define Z_UNICODE_MATHEMATICAL_ITALIC_PI_SYMBOL				   0x1D71B
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_ALPHA		   0x1D71C
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_BETA			   0x1D71D
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_GAMMA		   0x1D71E
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_DELTA		   0x1D71F
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_EPSILON		   0x1D720
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_ZETA			   0x1D721
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_ETA			   0x1D722
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_THETA		   0x1D723
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_IOTA			   0x1D724
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_KAPPA		   0x1D725
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_LAMDA		   0x1D726
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_MU			   0x1D727
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_NU			   0x1D728
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_XI			   0x1D729
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_OMICRON		   0x1D72A
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_PI			   0x1D72B
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_RHO			   0x1D72C
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_THETA_SYMBOL		   0x1D72D
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_SIGMA		   0x1D72E
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_TAU			   0x1D72F
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_UPSILON		   0x1D730
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_PHI			   0x1D731
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_CHI			   0x1D732
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_PSI			   0x1D733
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_CAPITAL_OMEGA		   0x1D734
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_NABLA			   0x1D735
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_ALPHA			   0x1D736
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_BETA			   0x1D737
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_GAMMA			   0x1D738
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_DELTA			   0x1D739
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_EPSILON		   0x1D73A
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_ZETA			   0x1D73B
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_ETA			   0x1D73C
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_THETA			   0x1D73D
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_IOTA			   0x1D73E
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_KAPPA			   0x1D73F
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_LAMDA			   0x1D740
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_MU			   0x1D741
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_NU			   0x1D742
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_XI			   0x1D743
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_OMICRON		   0x1D744
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_PI			   0x1D745
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_RHO			   0x1D746
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_FINAL_SIGMA		   0x1D747
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_SIGMA			   0x1D748
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_TAU			   0x1D749
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_UPSILON		   0x1D74A
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_PHI			   0x1D74B
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_CHI			   0x1D74C
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_PSI			   0x1D74D
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_SMALL_OMEGA			   0x1D74E
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_PARTIAL_DIFFERENTIAL		   0x1D74F
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_EPSILON_SYMBOL		   0x1D750
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_THETA_SYMBOL			   0x1D751
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_KAPPA_SYMBOL			   0x1D752
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_PHI_SYMBOL			   0x1D753
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_RHO_SYMBOL			   0x1D754
#define Z_UNICODE_MATHEMATICAL_BOLD_ITALIC_PI_SYMBOL			   0x1D755
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ALPHA		   0x1D756
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_BETA		   0x1D757
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_GAMMA		   0x1D758
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_DELTA		   0x1D759
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_EPSILON		   0x1D75A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ZETA		   0x1D75B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_ETA		   0x1D75C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_THETA		   0x1D75D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_IOTA		   0x1D75E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_KAPPA		   0x1D75F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_LAMDA		   0x1D760
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_MU		   0x1D761
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_NU		   0x1D762
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_XI		   0x1D763
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_OMICRON		   0x1D764
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PI		   0x1D765
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_RHO		   0x1D766
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_THETA_SYMBOL	   0x1D767
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_SIGMA		   0x1D768
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_TAU		   0x1D769
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_UPSILON		   0x1D76A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PHI		   0x1D76B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_CHI		   0x1D76C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_PSI		   0x1D76D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_CAPITAL_OMEGA		   0x1D76E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_NABLA			   0x1D76F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ALPHA		   0x1D770
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_BETA		   0x1D771
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_GAMMA		   0x1D772
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_DELTA		   0x1D773
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_EPSILON		   0x1D774
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ZETA		   0x1D775
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_ETA		   0x1D776
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_THETA		   0x1D777
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_IOTA		   0x1D778
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_KAPPA		   0x1D779
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_LAMDA		   0x1D77A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_MU			   0x1D77B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_NU			   0x1D77C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_XI			   0x1D77D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_OMICRON		   0x1D77E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PI			   0x1D77F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_RHO		   0x1D780
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_FINAL_SIGMA	   0x1D781
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_SIGMA		   0x1D782
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_TAU		   0x1D783
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_UPSILON		   0x1D784
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PHI		   0x1D785
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_CHI		   0x1D786
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_PSI		   0x1D787
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_SMALL_OMEGA		   0x1D788
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_PARTIAL_DIFFERENTIAL	   0x1D789
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_EPSILON_SYMBOL		   0x1D78A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_THETA_SYMBOL		   0x1D78B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_KAPPA_SYMBOL		   0x1D78C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_PHI_SYMBOL		   0x1D78D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_RHO_SYMBOL		   0x1D78E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_PI_SYMBOL		   0x1D78F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ALPHA	   0x1D790
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_BETA	   0x1D791
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_GAMMA	   0x1D792
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_DELTA	   0x1D793
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_EPSILON	   0x1D794
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ZETA	   0x1D795
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_ETA	   0x1D796
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_THETA	   0x1D797
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_IOTA	   0x1D798
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_KAPPA	   0x1D799
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_LAMDA	   0x1D79A
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_MU	   0x1D79B
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_NU	   0x1D79C
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_XI	   0x1D79D
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_OMICRON	   0x1D79E
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PI	   0x1D79F
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_RHO	   0x1D7A0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_THETA_SYMBOL 0x1D7A1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_SIGMA	   0x1D7A2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_TAU	   0x1D7A3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_UPSILON	   0x1D7A4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PHI	   0x1D7A5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_CHI	   0x1D7A6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_PSI	   0x1D7A7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_CAPITAL_OMEGA	   0x1D7A8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_NABLA		   0x1D7A9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ALPHA	   0x1D7AA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_BETA	   0x1D7AB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_GAMMA	   0x1D7AC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_DELTA	   0x1D7AD
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_EPSILON	   0x1D7AE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ZETA	   0x1D7AF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_ETA		   0x1D7B0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_THETA	   0x1D7B1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_IOTA	   0x1D7B2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_KAPPA	   0x1D7B3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_LAMDA	   0x1D7B4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_MU		   0x1D7B5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_NU		   0x1D7B6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_XI		   0x1D7B7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_OMICRON	   0x1D7B8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PI		   0x1D7B9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_RHO		   0x1D7BA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_FINAL_SIGMA	   0x1D7BB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_SIGMA	   0x1D7BC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_TAU		   0x1D7BD
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_UPSILON	   0x1D7BE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PHI		   0x1D7BF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_CHI		   0x1D7C0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_PSI		   0x1D7C1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_SMALL_OMEGA	   0x1D7C2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PARTIAL_DIFFERENTIAL 0x1D7C3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_EPSILON_SYMBOL	   0x1D7C4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_THETA_SYMBOL	   0x1D7C5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_KAPPA_SYMBOL	   0x1D7C6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PHI_SYMBOL	   0x1D7C7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_RHO_SYMBOL	   0x1D7C8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_ITALIC_PI_SYMBOL		   0x1D7C9
#define Z_UNICODE_MATHEMATICAL_BOLD_CAPITAL_DIGAMMA			   0x1D7CA
#define Z_UNICODE_MATHEMATICAL_BOLD_SMALL_DIGAMMA			   0x1D7CB
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_ZERO				   0x1D7CE
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_ONE				   0x1D7CF
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_TWO				   0x1D7D0
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_THREE				   0x1D7D1
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_FOUR				   0x1D7D2
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_FIVE				   0x1D7D3
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_SIX				   0x1D7D4
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_SEVEN				   0x1D7D5
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_EIGHT				   0x1D7D6
#define Z_UNICODE_MATHEMATICAL_BOLD_DIGIT_NINE				   0x1D7D7
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_ZERO			   0x1D7D8
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_ONE			   0x1D7D9
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_TWO			   0x1D7DA
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_THREE		   0x1D7DB
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_FOUR			   0x1D7DC
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_FIVE			   0x1D7DD
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_SIX			   0x1D7DE
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_SEVEN		   0x1D7DF
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_EIGHT		   0x1D7E0
#define Z_UNICODE_MATHEMATICAL_DOUBLE_STRUCK_DIGIT_NINE			   0x1D7E1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_ZERO			   0x1D7E2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_ONE			   0x1D7E3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_TWO			   0x1D7E4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_THREE			   0x1D7E5
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_FOUR			   0x1D7E6
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_FIVE			   0x1D7E7
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_SIX			   0x1D7E8
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_SEVEN			   0x1D7E9
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_EIGHT			   0x1D7EA
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_DIGIT_NINE			   0x1D7EB
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_ZERO		   0x1D7EC
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_ONE		   0x1D7ED
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_TWO		   0x1D7EE
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_THREE		   0x1D7EF
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_FOUR		   0x1D7F0
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_FIVE		   0x1D7F1
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_SIX		   0x1D7F2
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_SEVEN		   0x1D7F3
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_EIGHT		   0x1D7F4
#define Z_UNICODE_MATHEMATICAL_SANS_SERIF_BOLD_DIGIT_NINE		   0x1D7F5
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_ZERO			   0x1D7F6
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_ONE			   0x1D7F7
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_TWO			   0x1D7F8
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_THREE			   0x1D7F9
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_FOUR			   0x1D7FA
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_FIVE			   0x1D7FB
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_SIX			   0x1D7FC
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_SEVEN			   0x1D7FD
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_EIGHT			   0x1D7FE
#define Z_UNICODE_MATHEMATICAL_MONOSPACE_DIGIT_NINE			   0x1D7FF

/* MARK: - 1D800h-1DAAFh - Sutton SignWriting */

#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX						 0x1D800
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX						 0x1D801
#define Z_UNICODE_SIGNWRITING_HAND_CUP_INDEX						 0x1D802
#define Z_UNICODE_SIGNWRITING_HAND_OVAL_INDEX						 0x1D803
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX						 0x1D804
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_INDEX						 0x1D805
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_BENT					 0x1D806
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_BENT					 0x1D807
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_UNDER_INDEX_BENT				 0x1D808
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_RAISED_KNUCKLE				 0x1D809
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_CUPPED					 0x1D80A
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_HINGED					 0x1D80B
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_HINGED_LOW				 0x1D80C
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_HINGE					 0x1D80D
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE					 0x1D80E
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE					 0x1D80F
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_BENT				 0x1D810
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_RAISED_KNUCKLES			 0x1D811
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_HINGED				 0x1D812
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_UP_MIDDLE_HINGED				 0x1D813
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_HINGED_MIDDLE_UP				 0x1D814
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED				 0x1D815
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_INDEX_BENT		 0x1D816
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_MIDDLE_BENT		 0x1D817
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_CUPPED			 0x1D818
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_HINGED			 0x1D819
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CROSSED				 0x1D81A
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_CROSSED				 0x1D81B
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_BENT_OVER_INDEX				 0x1D81C
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_BENT_OVER_MIDDLE				 0x1D81D
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB				 0x1D81E
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_THUMB				 0x1D81F
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_STRAIGHT_THUMB_BENT		 0x1D820
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_BENT_THUMB_STRAIGHT		 0x1D821
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_BENT				 0x1D822
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_HINGED_SPREAD_THUMB_SIDE		 0x1D823
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_UP_MIDDLE_HINGED_THUMB_SIDE		 0x1D824
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_UP_MIDDLE_HINGED_THUMB_CONJOINED		 0x1D825
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_HINGED_MIDDLE_UP_THUMB_SIDE		 0x1D826
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_UP_SPREAD_THUMB_FORWARD		 0x1D827
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_CUPPED			 0x1D828
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_CIRCLED			 0x1D829
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_HOOKED			 0x1D82A
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_HINGED			 0x1D82B
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_BETWEEN_INDEX_MIDDLE_STRAIGHT		 0x1D82C
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_THUMB_SIDE		 0x1D82D
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_THUMB_SIDE_CONJOINED	 0x1D82E
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_THUMB_SIDE_BENT		 0x1D82F
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_THUMB_HOOKED_INDEX_UP			 0x1D830
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_HOOKED_MIDDLE_UP			 0x1D831
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_HINGED_THUMB_SIDE	 0x1D832
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CROSSED_THUMB_SIDE			 0x1D833
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_THUMB_FORWARD		 0x1D834
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CONJOINED_CUPPED_THUMB_FORWARD	 0x1D835
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_THUMB_CUPPED_INDEX_UP			 0x1D836
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_CUPPED_MIDDLE_UP			 0x1D837
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_THUMB_CIRCLED_INDEX_UP			 0x1D838
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_THUMB_CIRCLED_INDEX_HINGED		 0x1D839
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_ANGLED_OUT_MIDDLE_UP		 0x1D83A
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_ANGLED_IN_MIDDLE_UP			 0x1D83B
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_CIRCLED_MIDDLE_UP			 0x1D83C
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_CONJOINED_HINGED		 0x1D83D
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_ANGLED_OUT			 0x1D83E
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_THUMB_ANGLED			 0x1D83F
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_THUMB_ANGLED_OUT_INDEX_UP		 0x1D840
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_THUMB_ANGLED_OUT_INDEX_CROSSED		 0x1D841
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_THUMB_ANGLED_INDEX_UP			 0x1D842
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_HOOKED_MIDDLE_HINGED		 0x1D843
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FOUR_FINGERS					 0x1D844
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FOUR_FINGERS_BENT				 0x1D845
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FOUR_FINGERS_HINGED				 0x1D846
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FOUR_FINGERS_CONJOINED				 0x1D847
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FOUR_FINGERS_CONJOINED_SPLIT			 0x1D848
#define Z_UNICODE_SIGNWRITING_HAND_CLAW_FOUR_FINGERS_CONJOINED				 0x1D849
#define Z_UNICODE_SIGNWRITING_HAND_FIST_FOUR_FINGERS_CONJOINED_BENT			 0x1D84A
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_FOUR_FINGERS_CONJOINED				 0x1D84B
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD				 0x1D84C
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_HEEL_FIVE_FINGERS_SPREAD			 0x1D84D
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_FOUR_BENT			 0x1D84E
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_HEEL_FIVE_FINGERS_SPREAD_FOUR_BENT		 0x1D84F
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_BENT			 0x1D850
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_HEEL_FIVE_FINGERS_SPREAD_BENT			 0x1D851
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_THUMB_FORWARD		 0x1D852
#define Z_UNICODE_SIGNWRITING_HAND_CUP_FIVE_FINGERS_SPREAD				 0x1D853
#define Z_UNICODE_SIGNWRITING_HAND_CUP_FIVE_FINGERS_SPREAD_OPEN				 0x1D854
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_FIVE_FINGERS_SPREAD_OPEN			 0x1D855
#define Z_UNICODE_SIGNWRITING_HAND_OVAL_FIVE_FINGERS_SPREAD				 0x1D856
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_HINGED			 0x1D857
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_HINGED_THUMB_SIDE		 0x1D858
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_FIVE_FINGERS_SPREAD_HINGED_NO_THUMB		 0x1D859
#define Z_UNICODE_SIGNWRITING_HAND_FLAT							 0x1D85A
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_BETWEEN_PALM_FACINGS				 0x1D85B
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_HEEL						 0x1D85C
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_THUMB_SIDE					 0x1D85D
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_HEEL_THUMB_SIDE					 0x1D85E
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_THUMB_BENT					 0x1D85F
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_THUMB_FORWARD					 0x1D860
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_SPLIT_INDEX_THUMB_SIDE				 0x1D861
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_SPLIT_CENTRE					 0x1D862
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_SPLIT_CENTRE_THUMB_SIDE				 0x1D863
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_SPLIT_CENTRE_THUMB_SIDE_BENT			 0x1D864
#define Z_UNICODE_SIGNWRITING_HAND_FLAT_SPLIT_LITTLE					 0x1D865
#define Z_UNICODE_SIGNWRITING_HAND_CLAW							 0x1D866
#define Z_UNICODE_SIGNWRITING_HAND_CLAW_THUMB_SIDE					 0x1D867
#define Z_UNICODE_SIGNWRITING_HAND_CLAW_NO_THUMB					 0x1D868
#define Z_UNICODE_SIGNWRITING_HAND_CLAW_THUMB_FORWARD					 0x1D869
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_CURLICUE					 0x1D86A
#define Z_UNICODE_SIGNWRITING_HAND_HOOK							 0x1D86B
#define Z_UNICODE_SIGNWRITING_HAND_CUP_OPEN						 0x1D86C
#define Z_UNICODE_SIGNWRITING_HAND_CUP							 0x1D86D
#define Z_UNICODE_SIGNWRITING_HAND_CUP_OPEN_THUMB_SIDE					 0x1D86E
#define Z_UNICODE_SIGNWRITING_HAND_CUP_THUMB_SIDE					 0x1D86F
#define Z_UNICODE_SIGNWRITING_HAND_CUP_OPEN_NO_THUMB					 0x1D870
#define Z_UNICODE_SIGNWRITING_HAND_CUP_NO_THUMB						 0x1D871
#define Z_UNICODE_SIGNWRITING_HAND_CUP_OPEN_THUMB_FORWARD				 0x1D872
#define Z_UNICODE_SIGNWRITING_HAND_CUP_THUMB_FORWARD					 0x1D873
#define Z_UNICODE_SIGNWRITING_HAND_CURLICUE_OPEN					 0x1D874
#define Z_UNICODE_SIGNWRITING_HAND_CURLICUE						 0x1D875
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE						 0x1D876
#define Z_UNICODE_SIGNWRITING_HAND_OVAL							 0x1D877
#define Z_UNICODE_SIGNWRITING_HAND_OVAL_THUMB_SIDE					 0x1D878
#define Z_UNICODE_SIGNWRITING_HAND_OVAL_NO_THUMB					 0x1D879
#define Z_UNICODE_SIGNWRITING_HAND_OVAL_THUMB_FORWARD					 0x1D87A
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_OPEN						 0x1D87B
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_OPEN_THUMB_FORWARD				 0x1D87C
#define Z_UNICODE_SIGNWRITING_HAND_HINGE						 0x1D87D
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_SMALL						 0x1D87E
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_OPEN_THUMB_SIDE				 0x1D87F
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_THUMB_SIDE					 0x1D880
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_OPEN_NO_THUMB					 0x1D881
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_NO_THUMB					 0x1D882
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_THUMB_SIDE_TOUCHING_INDEX			 0x1D883
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_THUMB_BETWEEN_MIDDLE_RING			 0x1D884
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE						 0x1D885
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_RING				 0x1D886
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_RING				 0x1D887
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_MIDDLE_RING				 0x1D888
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_INDEX_MIDDLE_RING				 0x1D889
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_LITTLE						 0x1D88A
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_RING_BENT				 0x1D88B
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_RING_CONJOINED			 0x1D88C
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_MIDDLE_RING_CONJOINED			 0x1D88D
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_DOWN					 0x1D88E
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_DOWN_RIPPLE_STRAIGHT			 0x1D88F
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_DOWN_RIPPLE_CURVED			 0x1D890
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_DOWN_OTHERS_CIRCLED			 0x1D891
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_UP					 0x1D892
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_UNDER_LITTLE_UP				 0x1D893
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_LITTLE_UP					 0x1D894
#define Z_UNICODE_SIGNWRITING_HAND_OVAL_LITTLE_UP					 0x1D895
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_LITTLE_UP					 0x1D896
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_RAISED_KNUCKLE				 0x1D897
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_BENT					 0x1D898
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_TOUCHES_THUMB				 0x1D899
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_THUMB					 0x1D89A
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_LITTLE_THUMB					 0x1D89B
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_INDEX_THUMB				 0x1D89C
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_LITTLE_INDEX_THUMB				 0x1D89D
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_LITTLE_INDEX_THUMB_INDEX_THUMB_OUT		 0x1D89E
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_LITTLE_INDEX_THUMB_INDEX_THUMB			 0x1D89F
#define Z_UNICODE_SIGNWRITING_HAND_FIST_LITTLE_INDEX					 0x1D8A0
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_LITTLE_INDEX					 0x1D8A1
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_LITTLE_INDEX					 0x1D8A2
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_LITTLE_INDEX					 0x1D8A3
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_LITTLE				 0x1D8A4
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_LITTLE				 0x1D8A5
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_MIDDLE_LITTLE				 0x1D8A6
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_RING						 0x1D8A7
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_INDEX_MIDDLE_LITTLE				 0x1D8A8
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_MIDDLE_CROSS_LITTLE			 0x1D8A9
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_MIDDLE_CROSS_LITTLE			 0x1D8AA
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_DOWN					 0x1D8AB
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_RING_DOWN_INDEX_THUMB_HOOK_MIDDLE		 0x1D8AC
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_RING_DOWN_MIDDLE_THUMB_INDEX_CROSS		 0x1D8AD
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_UP						 0x1D8AE
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_RAISED_KNUCKLE				 0x1D8AF
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_LITTLE					 0x1D8B0
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_RING_LITTLE					 0x1D8B1
#define Z_UNICODE_SIGNWRITING_HAND_OVAL_RING_LITTLE					 0x1D8B2
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_RING_LITTLE					 0x1D8B3
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_MIDDLE					 0x1D8B4
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_MIDDLE_CONJOINED				 0x1D8B5
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_MIDDLE_RAISED_KNUCKLES			 0x1D8B6
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_INDEX					 0x1D8B7
#define Z_UNICODE_SIGNWRITING_HAND_FIST_RING_THUMB					 0x1D8B8
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_RING_THUMB					 0x1D8B9
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_RING_LITTLE				 0x1D8BA
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_INDEX_RING_LITTLE				 0x1D8BB
#define Z_UNICODE_SIGNWRITING_HAND_CURLICUE_INDEX_RING_LITTLE_ON			 0x1D8BC
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_INDEX_RING_LITTLE_OUT				 0x1D8BD
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_INDEX_RING_LITTLE_IN				 0x1D8BE
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_INDEX_RING_LITTLE_UNDER				 0x1D8BF
#define Z_UNICODE_SIGNWRITING_HAND_CUP_INDEX_RING_LITTLE				 0x1D8C0
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_RING_LITTLE				 0x1D8C1
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_INDEX_RING_LITTLE_OUT				 0x1D8C2
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_INDEX_RING_LITTLE				 0x1D8C3
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_DOWN					 0x1D8C4
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_MIDDLE						 0x1D8C5
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_UP					 0x1D8C6
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_MIDDLE_UP					 0x1D8C7
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_RAISED_KNUCKLE				 0x1D8C8
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_UP_THUMB_SIDE				 0x1D8C9
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_MIDDLE_THUMB					 0x1D8CA
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_THUMB_LITTLE				 0x1D8CB
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_LITTLE					 0x1D8CC
#define Z_UNICODE_SIGNWRITING_HAND_FIST_MIDDLE_RING_LITTLE				 0x1D8CD
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_MIDDLE_RING_LITTLE				 0x1D8CE
#define Z_UNICODE_SIGNWRITING_HAND_CURLICUE_MIDDLE_RING_LITTLE_ON			 0x1D8CF
#define Z_UNICODE_SIGNWRITING_HAND_CUP_MIDDLE_RING_LITTLE				 0x1D8D0
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_MIDDLE_RING_LITTLE				 0x1D8D1
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_MIDDLE_RING_LITTLE_OUT				 0x1D8D2
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_MIDDLE_RING_LITTLE_IN				 0x1D8D3
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_MIDDLE_RING_LITTLE				 0x1D8D4
#define Z_UNICODE_SIGNWRITING_HAND_CIRCLE_MIDDLE_RING_LITTLE_BENT			 0x1D8D5
#define Z_UNICODE_SIGNWRITING_HAND_CLAW_MIDDLE_RING_LITTLE_CONJOINED			 0x1D8D6
#define Z_UNICODE_SIGNWRITING_HAND_CLAW_MIDDLE_RING_LITTLE_CONJOINED_SIDE		 0x1D8D7
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_MIDDLE_RING_LITTLE_CONJOINED_OUT		 0x1D8D8
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_MIDDLE_RING_LITTLE_CONJOINED_IN			 0x1D8D9
#define Z_UNICODE_SIGNWRITING_HAND_HOOK_MIDDLE_RING_LITTLE_CONJOINED			 0x1D8DA
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_HINGED					 0x1D8DB
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE				 0x1D8DC
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_THUMB_SIDE				 0x1D8DD
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_THUMB_DIAGONAL			 0x1D8DE
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_THUMB_CONJOINED		 0x1D8DF
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_THUMB_BENT			 0x1D8E0
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_INDEX_BENT			 0x1D8E1
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_BOTH_BENT			 0x1D8E2
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_SIDE_INDEX_HINGE			 0x1D8E3
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_FORWARD_INDEX_STRAIGHT		 0x1D8E4
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_FORWARD_INDEX_BENT			 0x1D8E5
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_HOOK				 0x1D8E6
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_CURLICUE				 0x1D8E7
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_CURVE_THUMB_INSIDE			 0x1D8E8
#define Z_UNICODE_SIGNWRITING_HAND_CLAW_INDEX_THUMB_CURVE_THUMB_INSIDE			 0x1D8E9
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_CURVE_THUMB_UNDER			 0x1D8EA
#define Z_UNICODE_SIGNWRITING_HAND_FIST_INDEX_THUMB_CIRCLE				 0x1D8EB
#define Z_UNICODE_SIGNWRITING_HAND_CUP_INDEX_THUMB					 0x1D8EC
#define Z_UNICODE_SIGNWRITING_HAND_CUP_INDEX_THUMB_OPEN					 0x1D8ED
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_THUMB_OPEN				 0x1D8EE
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_THUMB_LARGE				 0x1D8EF
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_THUMB					 0x1D8F0
#define Z_UNICODE_SIGNWRITING_HAND_HINGE_INDEX_THUMB_SMALL				 0x1D8F1
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_INDEX_THUMB_OUT				 0x1D8F2
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_INDEX_THUMB_IN					 0x1D8F3
#define Z_UNICODE_SIGNWRITING_HAND_ANGLE_INDEX_THUMB					 0x1D8F4
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB						 0x1D8F5
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_HEEL					 0x1D8F6
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_SIDE_DIAGONAL				 0x1D8F7
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_SIDE_CONJOINED				 0x1D8F8
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_SIDE_BENT					 0x1D8F9
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_FORWARD					 0x1D8FA
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_BETWEEN_INDEX_MIDDLE			 0x1D8FB
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_BETWEEN_MIDDLE_RING			 0x1D8FC
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_BETWEEN_RING_LITTLE			 0x1D8FD
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_UNDER_TWO_FINGERS				 0x1D8FE
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_OVER_TWO_FINGERS				 0x1D8FF
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_UNDER_THREE_FINGERS			 0x1D900
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_UNDER_FOUR_FINGERS			 0x1D901
#define Z_UNICODE_SIGNWRITING_HAND_FIST_THUMB_OVER_FOUR_RAISED_KNUCKLES			 0x1D902
#define Z_UNICODE_SIGNWRITING_HAND_FIST							 0x1D903
#define Z_UNICODE_SIGNWRITING_HAND_FIST_HEEL						 0x1D904
#define Z_UNICODE_SIGNWRITING_TOUCH_SINGLE						 0x1D905
#define Z_UNICODE_SIGNWRITING_TOUCH_MULTIPLE						 0x1D906
#define Z_UNICODE_SIGNWRITING_TOUCH_BETWEEN						 0x1D907
#define Z_UNICODE_SIGNWRITING_GRASP_SINGLE						 0x1D908
#define Z_UNICODE_SIGNWRITING_GRASP_MULTIPLE						 0x1D909
#define Z_UNICODE_SIGNWRITING_GRASP_BETWEEN						 0x1D90A
#define Z_UNICODE_SIGNWRITING_STRIKE_SINGLE						 0x1D90B
#define Z_UNICODE_SIGNWRITING_STRIKE_MULTIPLE						 0x1D90C
#define Z_UNICODE_SIGNWRITING_STRIKE_BETWEEN						 0x1D90D
#define Z_UNICODE_SIGNWRITING_BRUSH_SINGLE						 0x1D90E
#define Z_UNICODE_SIGNWRITING_BRUSH_MULTIPLE						 0x1D90F
#define Z_UNICODE_SIGNWRITING_BRUSH_BETWEEN						 0x1D910
#define Z_UNICODE_SIGNWRITING_RUB_SINGLE						 0x1D911
#define Z_UNICODE_SIGNWRITING_RUB_MULTIPLE						 0x1D912
#define Z_UNICODE_SIGNWRITING_RUB_BETWEEN						 0x1D913
#define Z_UNICODE_SIGNWRITING_SURFACE_SYMBOLS						 0x1D914
#define Z_UNICODE_SIGNWRITING_SURFACE_BETWEEN						 0x1D915
#define Z_UNICODE_SIGNWRITING_SQUEEZE_LARGE_SINGLE					 0x1D916
#define Z_UNICODE_SIGNWRITING_SQUEEZE_SMALL_SINGLE					 0x1D917
#define Z_UNICODE_SIGNWRITING_SQUEEZE_LARGE_MULTIPLE					 0x1D918
#define Z_UNICODE_SIGNWRITING_SQUEEZE_SMALL_MULTIPLE					 0x1D919
#define Z_UNICODE_SIGNWRITING_SQUEEZE_SEQUENTIAL					 0x1D91A
#define Z_UNICODE_SIGNWRITING_FLICK_LARGE_SINGLE					 0x1D91B
#define Z_UNICODE_SIGNWRITING_FLICK_SMALL_SINGLE					 0x1D91C
#define Z_UNICODE_SIGNWRITING_FLICK_LARGE_MULTIPLE					 0x1D91D
#define Z_UNICODE_SIGNWRITING_FLICK_SMALL_MULTIPLE					 0x1D91E
#define Z_UNICODE_SIGNWRITING_FLICK_SEQUENTIAL						 0x1D91F
#define Z_UNICODE_SIGNWRITING_SQUEEZE_FLICK_ALTERNATING					 0x1D920
#define Z_UNICODE_SIGNWRITING_MOVEMENT_HINGE_UP_DOWN_LARGE				 0x1D921
#define Z_UNICODE_SIGNWRITING_MOVEMENT_HINGE_UP_DOWN_SMALL				 0x1D922
#define Z_UNICODE_SIGNWRITING_MOVEMENT_HINGE_UP_SEQUENTIAL				 0x1D923
#define Z_UNICODE_SIGNWRITING_MOVEMENT_HINGE_DOWN_SEQUENTIAL				 0x1D924
#define Z_UNICODE_SIGNWRITING_MOVEMENT_HINGE_UP_DOWN_ALTERNATING_LARGE			 0x1D925
#define Z_UNICODE_SIGNWRITING_MOVEMENT_HINGE_UP_DOWN_ALTERNATING_SMALL			 0x1D926
#define Z_UNICODE_SIGNWRITING_MOVEMENT_HINGE_SIDE_TO_SIDE_SCISSORS			 0x1D927
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_FINGER_CONTACT				 0x1D928
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_FINGER_CONTACT			 0x1D929
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_STRAIGHT_SMALL			 0x1D92A
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_STRAIGHT_MEDIUM			 0x1D92B
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_STRAIGHT_LARGE			 0x1D92C
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_STRAIGHT_LARGEST		 0x1D92D
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_SINGLE_WRIST_FLEX			 0x1D92E
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_DOUBLE_STRAIGHT			 0x1D92F
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_DOUBLE_WRIST_FLEX			 0x1D930
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_DOUBLE_ALTERNATING			 0x1D931
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_DOUBLE_ALTERNATING_WRIST_FLEX		 0x1D932
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CROSS					 0x1D933
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_TRIPLE_STRAIGHT_MOVEMENT		 0x1D934
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_TRIPLE_WRIST_FLEX			 0x1D935
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_TRIPLE_ALTERNATING			 0x1D936
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_TRIPLE_ALTERNATING_WRIST_FLEX		 0x1D937
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_BEND_SMALL				 0x1D938
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_BEND_MEDIUM				 0x1D939
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_BEND_LARGE				 0x1D93A
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CORNER_SMALL				 0x1D93B
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CORNER_MEDIUM				 0x1D93C
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CORNER_LARGE				 0x1D93D
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CORNER_ROTATION			 0x1D93E
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CHECK_SMALL				 0x1D93F
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CHECK_MEDIUM				 0x1D940
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CHECK_LARGE				 0x1D941
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_BOX_SMALL				 0x1D942
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_BOX_MEDIUM				 0x1D943
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_BOX_LARGE				 0x1D944
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_ZIGZAG_SMALL				 0x1D945
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_ZIGZAG_MEDIUM				 0x1D946
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_ZIGZAG_LARGE				 0x1D947
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_PEAKS_SMALL				 0x1D948
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_PEAKS_MEDIUM				 0x1D949
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_PEAKS_LARGE				 0x1D94A
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_WALLPLANE_SINGLE		 0x1D94B
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_WALLPLANE_DOUBLE		 0x1D94C
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_WALLPLANE_ALTERNATING		 0x1D94D
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_FLOORPLANE_SINGLE		 0x1D94E
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_FLOORPLANE_DOUBLE		 0x1D94F
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ROTATION_FLOORPLANE_ALTERNATING		 0x1D950
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_SHAKING					 0x1D951
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ARM_SPIRAL_SINGLE			 0x1D952
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ARM_SPIRAL_DOUBLE			 0x1D953
#define Z_UNICODE_SIGNWRITING_TRAVEL_WALLPLANE_ARM_SPIRAL_TRIPLE			 0x1D954
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_AWAY_SMALL				 0x1D955
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_AWAY_MEDIUM				 0x1D956
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_AWAY_LARGE				 0x1D957
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_AWAY_LARGEST				 0x1D958
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_TOWARDS_SMALL				 0x1D959
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_TOWARDS_MEDIUM				 0x1D95A
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_TOWARDS_LARGE				 0x1D95B
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_TOWARDS_LARGEST				 0x1D95C
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_AWAY_SMALL			 0x1D95D
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_AWAY_MEDIUM			 0x1D95E
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_AWAY_LARGE			 0x1D95F
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_AWAY_LARGEST			 0x1D960
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_TOWARDS_SMALL			 0x1D961
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_TOWARDS_MEDIUM			 0x1D962
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_TOWARDS_LARGE			 0x1D963
#define Z_UNICODE_SIGNWRITING_MOVEMENT_DIAGONAL_BETWEEN_TOWARDS_LARGEST			 0x1D964
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_STRAIGHT_SMALL			 0x1D965
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_STRAIGHT_MEDIUM		 0x1D966
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_STRAIGHT_LARGE			 0x1D967
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_STRAIGHT_LARGEST		 0x1D968
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_SINGLE_WRIST_FLEX			 0x1D969
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_DOUBLE_STRAIGHT			 0x1D96A
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_DOUBLE_WRIST_FLEX			 0x1D96B
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_DOUBLE_ALTERNATING			 0x1D96C
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_DOUBLE_ALTERNATING_WRIST_FLEX		 0x1D96D
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CROSS					 0x1D96E
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_TRIPLE_STRAIGHT_MOVEMENT		 0x1D96F
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_TRIPLE_WRIST_FLEX			 0x1D970
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_TRIPLE_ALTERNATING_MOVEMENT		 0x1D971
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_TRIPLE_ALTERNATING_WRIST_FLEX		 0x1D972
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_BEND					 0x1D973
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CORNER_SMALL				 0x1D974
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CORNER_MEDIUM				 0x1D975
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CORNER_LARGE				 0x1D976
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CHECK					 0x1D977
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_BOX_SMALL				 0x1D978
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_BOX_MEDIUM				 0x1D979
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_BOX_LARGE				 0x1D97A
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ZIGZAG_SMALL				 0x1D97B
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ZIGZAG_MEDIUM				 0x1D97C
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ZIGZAG_LARGE				 0x1D97D
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_PEAKS_SMALL				 0x1D97E
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_PEAKS_MEDIUM				 0x1D97F
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_PEAKS_LARGE				 0x1D980
#define Z_UNICODE_SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_FLOORPLANE_SINGLE		 0x1D981
#define Z_UNICODE_SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_FLOORPLANE_DOUBLE		 0x1D982
#define Z_UNICODE_SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_FLOORPLANE_ALTERNATING		 0x1D983
#define Z_UNICODE_SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_WALLPLANE_SINGLE		 0x1D984
#define Z_UNICODE_SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_WALLPLANE_DOUBLE		 0x1D985
#define Z_UNICODE_SIGNWRITING_TRAVEL_FLOORPLANE_ROTATION_WALLPLANE_ALTERNATING		 0x1D986
#define Z_UNICODE_SIGNWRITING_TRAVEL_FLOORPLANE_SHAKING					 0x1D987
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_QUARTER_SMALL			 0x1D988
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_QUARTER_MEDIUM			 0x1D989
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_QUARTER_LARGE			 0x1D98A
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_QUARTER_LARGEST			 0x1D98B
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HALF_CIRCLE_SMALL		 0x1D98C
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HALF_CIRCLE_MEDIUM		 0x1D98D
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HALF_CIRCLE_LARGE		 0x1D98E
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HALF_CIRCLE_LARGEST		 0x1D98F
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_THREE_QUARTER_CIRCLE_SMALL	 0x1D990
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_THREE_QUARTER_CIRCLE_MEDIUM	 0x1D991
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_SMALL				 0x1D992
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_MEDIUM				 0x1D993
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_LARGE				 0x1D994
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_SMALL				 0x1D995
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_MEDIUM				 0x1D996
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_LARGE				 0x1D997
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_SMALL_DOUBLE			 0x1D998
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_DOUBLE_SMALL		 0x1D999
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_DOUBLE_MEDIUM		 0x1D99A
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_DOUBLE_LARGE		 0x1D99B
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_TRIPLE_SMALL		 0x1D99C
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_TRIPLE_MEDIUM		 0x1D99D
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_CURVE_TRIPLE_LARGE		 0x1D99E
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_THEN_STRAIGHT			 0x1D99F
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVED_CROSS_SMALL			 0x1D9A0
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVED_CROSS_MEDIUM			 0x1D9A1
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_SINGLE					 0x1D9A2
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_DOUBLE					 0x1D9A3
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_ALTERNATE				 0x1D9A4
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_SHAKING				 0x1D9A5
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HITTING_FRONT_WALL		 0x1D9A6
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_HITTING_FRONT_WALL		 0x1D9A7
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_HITTING_FRONT_WALL		 0x1D9A8
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_HITTING_FRONT_WALL		 0x1D9A9
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_SINGLE_HITTING_FRONT_WALL		 0x1D9AA
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_DOUBLE_HITTING_FRONT_WALL		 0x1D9AB
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_ALTERNATING_HITTING_FRONT_WALL		 0x1D9AC
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_CURVE_HITTING_CHEST			 0x1D9AD
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_HUMP_HITTING_CHEST			 0x1D9AE
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_LOOP_HITTING_CHEST			 0x1D9AF
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_HITTING_CHEST			 0x1D9B0
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_SINGLE_HITTING_CHEST			 0x1D9B1
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_DOUBLE_HITTING_CHEST			 0x1D9B2
#define Z_UNICODE_SIGNWRITING_ROTATION_WALLPLANE_ALTERNATING_HITTING_CHEST		 0x1D9B3
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_DIAGONAL_PATH_SMALL		 0x1D9B4
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_DIAGONAL_PATH_MEDIUM		 0x1D9B5
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WAVE_DIAGONAL_PATH_LARGE		 0x1D9B6
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_HITTING_CEILING_SMALL		 0x1D9B7
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_HITTING_CEILING_LARGE		 0x1D9B8
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_CEILING_SMALL_DOUBLE	 0x1D9B9
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_CEILING_LARGE_DOUBLE	 0x1D9BA
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_CEILING_SMALL_TRIPLE	 0x1D9BB
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_CEILING_LARGE_TRIPLE	 0x1D9BC
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_CEILING_SMALL_SINGLE	 0x1D9BD
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_CEILING_LARGE_SINGLE	 0x1D9BE
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_CEILING_SMALL_DOUBLE	 0x1D9BF
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_CEILING_LARGE_DOUBLE	 0x1D9C0
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_HITTING_CEILING_SMALL		 0x1D9C1
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_HITTING_CEILING_LARGE		 0x1D9C2
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_SINGLE_HITTING_CEILING		 0x1D9C3
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_DOUBLE_HITTING_CEILING		 0x1D9C4
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_ALTERNATING_HITTING_CEILING		 0x1D9C5
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_HITTING_FLOOR_SMALL		 0x1D9C6
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_HITTING_FLOOR_LARGE		 0x1D9C7
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_FLOOR_SMALL_DOUBLE	 0x1D9C8
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_FLOOR_LARGE_DOUBLE	 0x1D9C9
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_FLOOR_TRIPLE_SMALL_TRIPLE 0x1D9CA
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_HITTING_FLOOR_TRIPLE_LARGE_TRIPLE 0x1D9CB
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_FLOOR_SMALL_SINGLE	 0x1D9CC
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_FLOOR_LARGE_SINGLE	 0x1D9CD
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_FLOOR_SMALL_DOUBLE	 0x1D9CE
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_HITTING_FLOOR_LARGE_DOUBLE	 0x1D9CF
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_HITTING_FLOOR_SMALL		 0x1D9D0
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_HITTING_FLOOR_LARGE		 0x1D9D1
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_SINGLE_HITTING_FLOOR			 0x1D9D2
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_DOUBLE_HITTING_FLOOR			 0x1D9D3
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_ALTERNATING_HITTING_FLOOR		 0x1D9D4
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_SMALL				 0x1D9D5
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_MEDIUM				 0x1D9D6
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_LARGE				 0x1D9D7
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_LARGEST				 0x1D9D8
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_CURVE_COMBINED			 0x1D9D9
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_HUMP_SMALL				 0x1D9DA
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_LOOP_SMALL				 0x1D9DB
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_SNAKE				 0x1D9DC
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_SMALL				 0x1D9DD
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WAVE_LARGE				 0x1D9DE
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_SINGLE				 0x1D9DF
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_DOUBLE				 0x1D9E0
#define Z_UNICODE_SIGNWRITING_ROTATION_FLOORPLANE_ALTERNATING				 0x1D9E1
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_SHAKING_PARALLEL			 0x1D9E2
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_ARM_CIRCLE_SMALL_SINGLE		 0x1D9E3
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_ARM_CIRCLE_MEDIUM_SINGLE		 0x1D9E4
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_ARM_CIRCLE_SMALL_DOUBLE		 0x1D9E5
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_ARM_CIRCLE_MEDIUM_DOUBLE		 0x1D9E6
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_SMALL_SINGLE	 0x1D9E7
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_MEDIUM_SINGLE	 0x1D9E8
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_LARGE_SINGLE	 0x1D9E9
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_SMALL_DOUBLE	 0x1D9EA
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_MEDIUM_DOUBLE	 0x1D9EB
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_ARM_CIRCLE_HITTING_WALL_LARGE_DOUBLE	 0x1D9EC
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WRIST_CIRCLE_FRONT_SINGLE		 0x1D9ED
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_WRIST_CIRCLE_FRONT_DOUBLE		 0x1D9EE
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WRIST_CIRCLE_HITTING_WALL_SINGLE	 0x1D9EF
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_WRIST_CIRCLE_HITTING_WALL_DOUBLE	 0x1D9F0
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_FINGER_CIRCLES_SINGLE			 0x1D9F1
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_FINGER_CIRCLES_DOUBLE			 0x1D9F2
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_FINGER_CIRCLES_HITTING_WALL_SINGLE	 0x1D9F3
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_FINGER_CIRCLES_HITTING_WALL_DOUBLE	 0x1D9F4
#define Z_UNICODE_SIGNWRITING_DYNAMIC_ARROWHEAD_SMALL					 0x1D9F5
#define Z_UNICODE_SIGNWRITING_DYNAMIC_ARROWHEAD_LARGE					 0x1D9F6
#define Z_UNICODE_SIGNWRITING_DYNAMIC_FAST						 0x1D9F7
#define Z_UNICODE_SIGNWRITING_DYNAMIC_SLOW						 0x1D9F8
#define Z_UNICODE_SIGNWRITING_DYNAMIC_TENSE						 0x1D9F9
#define Z_UNICODE_SIGNWRITING_DYNAMIC_RELAXED						 0x1D9FA
#define Z_UNICODE_SIGNWRITING_DYNAMIC_SIMULTANEOUS					 0x1D9FB
#define Z_UNICODE_SIGNWRITING_DYNAMIC_SIMULTANEOUS_ALTERNATING				 0x1D9FC
#define Z_UNICODE_SIGNWRITING_DYNAMIC_EVERY_OTHER_TIME					 0x1D9FD
#define Z_UNICODE_SIGNWRITING_DYNAMIC_GRADUAL						 0x1D9FE
#define Z_UNICODE_SIGNWRITING_HEAD							 0x1D9FF
#define Z_UNICODE_SIGNWRITING_HEAD_RIM							 0x1DA00
#define Z_UNICODE_SIGNWRITING_HEAD_MOVEMENT_WALLPLANE_STRAIGHT				 0x1DA01
#define Z_UNICODE_SIGNWRITING_HEAD_MOVEMENT_WALLPLANE_TILT				 0x1DA02
#define Z_UNICODE_SIGNWRITING_HEAD_MOVEMENT_FLOORPLANE_STRAIGHT				 0x1DA03
#define Z_UNICODE_SIGNWRITING_HEAD_MOVEMENT_WALLPLANE_CURVE				 0x1DA04
#define Z_UNICODE_SIGNWRITING_HEAD_MOVEMENT_FLOORPLANE_CURVE				 0x1DA05
#define Z_UNICODE_SIGNWRITING_HEAD_MOVEMENT_CIRCLE					 0x1DA06
#define Z_UNICODE_SIGNWRITING_FACE_DIRECTION_POSITION_NOSE_FORWARD_TILTING		 0x1DA07
#define Z_UNICODE_SIGNWRITING_FACE_DIRECTION_POSITION_NOSE_UP_OR_DOWN			 0x1DA08
#define Z_UNICODE_SIGNWRITING_FACE_DIRECTION_POSITION_NOSE_UP_OR_DOWN_TILTING		 0x1DA09
#define Z_UNICODE_SIGNWRITING_EYEBROWS_STRAIGHT_UP					 0x1DA0A
#define Z_UNICODE_SIGNWRITING_EYEBROWS_STRAIGHT_NEUTRAL					 0x1DA0B
#define Z_UNICODE_SIGNWRITING_EYEBROWS_STRAIGHT_DOWN					 0x1DA0C
#define Z_UNICODE_SIGNWRITING_DREAMY_EYEBROWS_NEUTRAL_DOWN				 0x1DA0D
#define Z_UNICODE_SIGNWRITING_DREAMY_EYEBROWS_DOWN_NEUTRAL				 0x1DA0E
#define Z_UNICODE_SIGNWRITING_DREAMY_EYEBROWS_UP_NEUTRAL				 0x1DA0F
#define Z_UNICODE_SIGNWRITING_DREAMY_EYEBROWS_NEUTRAL_UP				 0x1DA10
#define Z_UNICODE_SIGNWRITING_FOREHEAD_NEUTRAL						 0x1DA11
#define Z_UNICODE_SIGNWRITING_FOREHEAD_CONTACT						 0x1DA12
#define Z_UNICODE_SIGNWRITING_FOREHEAD_WRINKLED						 0x1DA13
#define Z_UNICODE_SIGNWRITING_EYES_OPEN							 0x1DA14
#define Z_UNICODE_SIGNWRITING_EYES_SQUEEZED						 0x1DA15
#define Z_UNICODE_SIGNWRITING_EYES_CLOSED						 0x1DA16
#define Z_UNICODE_SIGNWRITING_EYE_BLINK_SINGLE						 0x1DA17
#define Z_UNICODE_SIGNWRITING_EYE_BLINK_MULTIPLE					 0x1DA18
#define Z_UNICODE_SIGNWRITING_EYES_HALF_OPEN						 0x1DA19
#define Z_UNICODE_SIGNWRITING_EYES_WIDE_OPEN						 0x1DA1A
#define Z_UNICODE_SIGNWRITING_EYES_HALF_CLOSED						 0x1DA1B
#define Z_UNICODE_SIGNWRITING_EYES_WIDENING_MOVEMENT					 0x1DA1C
#define Z_UNICODE_SIGNWRITING_EYE_WINK							 0x1DA1D
#define Z_UNICODE_SIGNWRITING_EYELASHES_UP						 0x1DA1E
#define Z_UNICODE_SIGNWRITING_EYELASHES_DOWN						 0x1DA1F
#define Z_UNICODE_SIGNWRITING_EYELASHES_FLUTTERING					 0x1DA20
#define Z_UNICODE_SIGNWRITING_EYEGAZE_WALLPLANE_STRAIGHT				 0x1DA21
#define Z_UNICODE_SIGNWRITING_EYEGAZE_WALLPLANE_STRAIGHT_DOUBLE				 0x1DA22
#define Z_UNICODE_SIGNWRITING_EYEGAZE_WALLPLANE_STRAIGHT_ALTERNATING			 0x1DA23
#define Z_UNICODE_SIGNWRITING_EYEGAZE_FLOORPLANE_STRAIGHT				 0x1DA24
#define Z_UNICODE_SIGNWRITING_EYEGAZE_FLOORPLANE_STRAIGHT_DOUBLE			 0x1DA25
#define Z_UNICODE_SIGNWRITING_EYEGAZE_FLOORPLANE_STRAIGHT_ALTERNATING			 0x1DA26
#define Z_UNICODE_SIGNWRITING_EYEGAZE_WALLPLANE_CURVED					 0x1DA27
#define Z_UNICODE_SIGNWRITING_EYEGAZE_FLOORPLANE_CURVED					 0x1DA28
#define Z_UNICODE_SIGNWRITING_EYEGAZE_WALLPLANE_CIRCLING				 0x1DA29
#define Z_UNICODE_SIGNWRITING_CHEEKS_PUFFED						 0x1DA2A
#define Z_UNICODE_SIGNWRITING_CHEEKS_NEUTRAL						 0x1DA2B
#define Z_UNICODE_SIGNWRITING_CHEEKS_SUCKED						 0x1DA2C
#define Z_UNICODE_SIGNWRITING_TENSE_CHEEKS_HIGH						 0x1DA2D
#define Z_UNICODE_SIGNWRITING_TENSE_CHEEKS_MIDDLE					 0x1DA2E
#define Z_UNICODE_SIGNWRITING_TENSE_CHEEKS_LOW						 0x1DA2F
#define Z_UNICODE_SIGNWRITING_EARS							 0x1DA30
#define Z_UNICODE_SIGNWRITING_NOSE_NEUTRAL						 0x1DA31
#define Z_UNICODE_SIGNWRITING_NOSE_CONTACT						 0x1DA32
#define Z_UNICODE_SIGNWRITING_NOSE_WRINKLES						 0x1DA33
#define Z_UNICODE_SIGNWRITING_NOSE_WIGGLES						 0x1DA34
#define Z_UNICODE_SIGNWRITING_AIR_BLOWING_OUT						 0x1DA35
#define Z_UNICODE_SIGNWRITING_AIR_SUCKING_IN						 0x1DA36
#define Z_UNICODE_SIGNWRITING_AIR_BLOW_SMALL_ROTATIONS					 0x1DA37
#define Z_UNICODE_SIGNWRITING_AIR_SUCK_SMALL_ROTATIONS					 0x1DA38
#define Z_UNICODE_SIGNWRITING_BREATH_INHALE						 0x1DA39
#define Z_UNICODE_SIGNWRITING_BREATH_EXHALE						 0x1DA3A
#define Z_UNICODE_SIGNWRITING_MOUTH_CLOSED_NEUTRAL					 0x1DA3B
#define Z_UNICODE_SIGNWRITING_MOUTH_CLOSED_FORWARD					 0x1DA3C
#define Z_UNICODE_SIGNWRITING_MOUTH_CLOSED_CONTACT					 0x1DA3D
#define Z_UNICODE_SIGNWRITING_MOUTH_SMILE						 0x1DA3E
#define Z_UNICODE_SIGNWRITING_MOUTH_SMILE_WRINKLED					 0x1DA3F
#define Z_UNICODE_SIGNWRITING_MOUTH_SMILE_OPEN						 0x1DA40
#define Z_UNICODE_SIGNWRITING_MOUTH_FROWN						 0x1DA41
#define Z_UNICODE_SIGNWRITING_MOUTH_FROWN_WRINKLED					 0x1DA42
#define Z_UNICODE_SIGNWRITING_MOUTH_FROWN_OPEN						 0x1DA43
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_CIRCLE						 0x1DA44
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_FORWARD					 0x1DA45
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_WRINKLED					 0x1DA46
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_OVAL						 0x1DA47
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_OVAL_WRINKLED					 0x1DA48
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_OVAL_YAWN					 0x1DA49
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_RECTANGLE					 0x1DA4A
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_RECTANGLE_WRINKLED				 0x1DA4B
#define Z_UNICODE_SIGNWRITING_MOUTH_OPEN_RECTANGLE_YAWN					 0x1DA4C
#define Z_UNICODE_SIGNWRITING_MOUTH_KISS						 0x1DA4D
#define Z_UNICODE_SIGNWRITING_MOUTH_KISS_FORWARD					 0x1DA4E
#define Z_UNICODE_SIGNWRITING_MOUTH_KISS_WRINKLED					 0x1DA4F
#define Z_UNICODE_SIGNWRITING_MOUTH_TENSE						 0x1DA50
#define Z_UNICODE_SIGNWRITING_MOUTH_TENSE_FORWARD					 0x1DA51
#define Z_UNICODE_SIGNWRITING_MOUTH_TENSE_SUCKED					 0x1DA52
#define Z_UNICODE_SIGNWRITING_LIPS_PRESSED_TOGETHER					 0x1DA53
#define Z_UNICODE_SIGNWRITING_LIP_LOWER_OVER_UPPER					 0x1DA54
#define Z_UNICODE_SIGNWRITING_LIP_UPPER_OVER_LOWER					 0x1DA55
#define Z_UNICODE_SIGNWRITING_MOUTH_CORNERS						 0x1DA56
#define Z_UNICODE_SIGNWRITING_MOUTH_WRINKLES_SINGLE					 0x1DA57
#define Z_UNICODE_SIGNWRITING_MOUTH_WRINKLES_DOUBLE					 0x1DA58
#define Z_UNICODE_SIGNWRITING_TONGUE_STICKING_OUT_FAR					 0x1DA59
#define Z_UNICODE_SIGNWRITING_TONGUE_LICKING_LIPS					 0x1DA5A
#define Z_UNICODE_SIGNWRITING_TONGUE_TIP_BETWEEN_LIPS					 0x1DA5B
#define Z_UNICODE_SIGNWRITING_TONGUE_TIP_TOUCHING_INSIDE_MOUTH				 0x1DA5C
#define Z_UNICODE_SIGNWRITING_TONGUE_INSIDE_MOUTH_RELAXED				 0x1DA5D
#define Z_UNICODE_SIGNWRITING_TONGUE_MOVES_AGAINST_CHEEK				 0x1DA5E
#define Z_UNICODE_SIGNWRITING_TONGUE_CENTRE_STICKING_OUT				 0x1DA5F
#define Z_UNICODE_SIGNWRITING_TONGUE_CENTRE_INSIDE_MOUTH				 0x1DA60
#define Z_UNICODE_SIGNWRITING_TEETH							 0x1DA61
#define Z_UNICODE_SIGNWRITING_TEETH_MOVEMENT						 0x1DA62
#define Z_UNICODE_SIGNWRITING_TEETH_ON_TONGUE						 0x1DA63
#define Z_UNICODE_SIGNWRITING_TEETH_ON_TONGUE_MOVEMENT					 0x1DA64
#define Z_UNICODE_SIGNWRITING_TEETH_ON_LIPS						 0x1DA65
#define Z_UNICODE_SIGNWRITING_TEETH_ON_LIPS_MOVEMENT					 0x1DA66
#define Z_UNICODE_SIGNWRITING_TEETH_BITE_LIPS						 0x1DA67
#define Z_UNICODE_SIGNWRITING_MOVEMENT_WALLPLANE_JAW					 0x1DA68
#define Z_UNICODE_SIGNWRITING_MOVEMENT_FLOORPLANE_JAW					 0x1DA69
#define Z_UNICODE_SIGNWRITING_NECK							 0x1DA6A
#define Z_UNICODE_SIGNWRITING_HAIR							 0x1DA6B
#define Z_UNICODE_SIGNWRITING_EXCITEMENT						 0x1DA6C
#define Z_UNICODE_SIGNWRITING_SHOULDER_HIP_SPINE					 0x1DA6D
#define Z_UNICODE_SIGNWRITING_SHOULDER_HIP_POSITIONS					 0x1DA6E
#define Z_UNICODE_SIGNWRITING_WALLPLANE_SHOULDER_HIP_MOVE				 0x1DA6F
#define Z_UNICODE_SIGNWRITING_FLOORPLANE_SHOULDER_HIP_MOVE				 0x1DA70
#define Z_UNICODE_SIGNWRITING_SHOULDER_TILTING_FROM_WAIST				 0x1DA71
#define Z_UNICODE_SIGNWRITING_TORSO_WALLPLANE_STRAIGHT_STRETCH				 0x1DA72
#define Z_UNICODE_SIGNWRITING_TORSO_WALLPLANE_CURVED_BEND				 0x1DA73
#define Z_UNICODE_SIGNWRITING_TORSO_FLOORPLANE_TWISTING					 0x1DA74
#define Z_UNICODE_SIGNWRITING_UPPER_BODY_TILTING_FROM_HIP_JOINTS			 0x1DA75
#define Z_UNICODE_SIGNWRITING_LIMB_COMBINATION						 0x1DA76
#define Z_UNICODE_SIGNWRITING_LIMB_LENGTH_1						 0x1DA77
#define Z_UNICODE_SIGNWRITING_LIMB_LENGTH_2						 0x1DA78
#define Z_UNICODE_SIGNWRITING_LIMB_LENGTH_3						 0x1DA79
#define Z_UNICODE_SIGNWRITING_LIMB_LENGTH_4						 0x1DA7A
#define Z_UNICODE_SIGNWRITING_LIMB_LENGTH_5						 0x1DA7B
#define Z_UNICODE_SIGNWRITING_LIMB_LENGTH_6						 0x1DA7C
#define Z_UNICODE_SIGNWRITING_LIMB_LENGTH_7						 0x1DA7D
#define Z_UNICODE_SIGNWRITING_FINGER							 0x1DA7E
#define Z_UNICODE_SIGNWRITING_LOCATION_WALLPLANE_SPACE					 0x1DA7F
#define Z_UNICODE_SIGNWRITING_LOCATION_FLOORPLANE_SPACE					 0x1DA80
#define Z_UNICODE_SIGNWRITING_LOCATION_HEIGHT						 0x1DA81
#define Z_UNICODE_SIGNWRITING_LOCATION_WIDTH						 0x1DA82
#define Z_UNICODE_SIGNWRITING_LOCATION_DEPTH						 0x1DA83
#define Z_UNICODE_SIGNWRITING_LOCATION_HEAD_NECK					 0x1DA84
#define Z_UNICODE_SIGNWRITING_LOCATION_TORSO						 0x1DA85
#define Z_UNICODE_SIGNWRITING_LOCATION_LIMBS_DIGITS					 0x1DA86
#define Z_UNICODE_SIGNWRITING_COMMA							 0x1DA87
#define Z_UNICODE_SIGNWRITING_FULL_STOP							 0x1DA88
#define Z_UNICODE_SIGNWRITING_SEMICOLON							 0x1DA89
#define Z_UNICODE_SIGNWRITING_COLON							 0x1DA8A
#define Z_UNICODE_SIGNWRITING_PARENTHESIS						 0x1DA8B
#define Z_UNICODE_SIGNWRITING_FILL_MODIFIER_2						 0x1DA9B
#define Z_UNICODE_SIGNWRITING_FILL_MODIFIER_3						 0x1DA9C
#define Z_UNICODE_SIGNWRITING_FILL_MODIFIER_4						 0x1DA9D
#define Z_UNICODE_SIGNWRITING_FILL_MODIFIER_5						 0x1DA9E
#define Z_UNICODE_SIGNWRITING_FILL_MODIFIER_6						 0x1DA9F
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_2					 0x1DAA1
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_3					 0x1DAA2
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_4					 0x1DAA3
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_5					 0x1DAA4
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_6					 0x1DAA5
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_7					 0x1DAA6
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_8					 0x1DAA7
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_9					 0x1DAA8
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_10					 0x1DAA9
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_11					 0x1DAAA
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_12					 0x1DAAB
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_13					 0x1DAAC
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_14					 0x1DAAD
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_15					 0x1DAAE
#define Z_UNICODE_SIGNWRITING_ROTATION_MODIFIER_16					 0x1DAAF

/* MARK: - 1E800h-1E8DFh - Mende Kikakui */

#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M001_KI		   0x1E800
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M002_KA		   0x1E801
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M003_KU		   0x1E802
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M065_KEE		   0x1E803
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M095_KE		   0x1E804
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M076_KOO		   0x1E805
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M048_KO		   0x1E806
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M179_KUA		   0x1E807
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M004_WI		   0x1E808
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M005_WA		   0x1E809
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M006_WU		   0x1E80A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M126_WEE		   0x1E80B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M118_WE		   0x1E80C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M114_WOO		   0x1E80D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M045_WO		   0x1E80E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M194_WUI		   0x1E80F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M143_WEI		   0x1E810
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M061_WVI		   0x1E811
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M049_WVA		   0x1E812
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M139_WVE		   0x1E813
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M007_MIN		   0x1E814
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M008_MAN		   0x1E815
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M009_MUN		   0x1E816
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M059_MEN		   0x1E817
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M094_MON		   0x1E818
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M154_MUAN		   0x1E819
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M189_MUEN		   0x1E81A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M010_BI		   0x1E81B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M011_BA		   0x1E81C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M012_BU		   0x1E81D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M150_BEE		   0x1E81E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M097_BE		   0x1E81F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M103_BOO		   0x1E820
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M138_BO		   0x1E821
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M013_I			   0x1E822
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M014_A			   0x1E823
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M015_U			   0x1E824
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M163_EE		   0x1E825
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M100_E			   0x1E826
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M165_OO		   0x1E827
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M147_O			   0x1E828
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M137_EI		   0x1E829
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M131_IN		   0x1E82A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M135_IN		   0x1E82B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M195_AN		   0x1E82C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M178_EN		   0x1E82D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M019_SI		   0x1E82E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M020_SA		   0x1E82F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M021_SU		   0x1E830
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M162_SEE		   0x1E831
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M116_SE		   0x1E832
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M136_SOO		   0x1E833
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M079_SO		   0x1E834
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M196_SIA		   0x1E835
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M025_LI		   0x1E836
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M026_LA		   0x1E837
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M027_LU		   0x1E838
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M084_LEE		   0x1E839
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M073_LE		   0x1E83A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M054_LOO		   0x1E83B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M153_LO		   0x1E83C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M110_LONG_LE		   0x1E83D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M016_DI		   0x1E83E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M017_DA		   0x1E83F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M018_DU		   0x1E840
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M089_DEE		   0x1E841
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M180_DOO		   0x1E842
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M181_DO		   0x1E843
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M022_TI		   0x1E844
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M023_TA		   0x1E845
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M024_TU		   0x1E846
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M091_TEE		   0x1E847
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M055_TE		   0x1E848
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M104_TOO		   0x1E849
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M069_TO		   0x1E84A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M028_JI		   0x1E84B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M029_JA		   0x1E84C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M030_JU		   0x1E84D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M157_JEE		   0x1E84E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M113_JE		   0x1E84F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M160_JOO		   0x1E850
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M063_JO		   0x1E851
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M175_LONG_JO		   0x1E852
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M031_YI		   0x1E853
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M032_YA		   0x1E854
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M033_YU		   0x1E855
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M109_YEE		   0x1E856
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M080_YE		   0x1E857
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M141_YOO		   0x1E858
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M121_YO		   0x1E859
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M034_FI		   0x1E85A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M035_FA		   0x1E85B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M036_FU		   0x1E85C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M078_FEE		   0x1E85D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M075_FE		   0x1E85E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M133_FOO		   0x1E85F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M088_FO		   0x1E860
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M197_FUA		   0x1E861
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M101_FAN		   0x1E862
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M037_NIN		   0x1E863
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M038_NAN		   0x1E864
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M039_NUN		   0x1E865
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M117_NEN		   0x1E866
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M169_NON		   0x1E867
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M176_HI		   0x1E868
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M041_HA		   0x1E869
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M186_HU		   0x1E86A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M040_HEE		   0x1E86B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M096_HE		   0x1E86C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M042_HOO		   0x1E86D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M140_HO		   0x1E86E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M083_HEEI		   0x1E86F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M128_HOOU		   0x1E870
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M053_HIN		   0x1E871
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M130_HAN		   0x1E872
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M087_HUN		   0x1E873
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M052_HEN		   0x1E874
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M193_HON		   0x1E875
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M046_HUAN		   0x1E876
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M090_NGGI		   0x1E877
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M043_NGGA		   0x1E878
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M082_NGGU		   0x1E879
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M115_NGGEE		   0x1E87A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M146_NGGE		   0x1E87B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M156_NGGOO		   0x1E87C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M120_NGGO		   0x1E87D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M159_NGGAA		   0x1E87E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M127_NGGUA		   0x1E87F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M086_LONG_NGGE		   0x1E880
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M106_LONG_NGGOO	   0x1E881
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M183_LONG_NGGO		   0x1E882
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M155_GI		   0x1E883
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M111_GA		   0x1E884
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M168_GU		   0x1E885
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M190_GEE		   0x1E886
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M166_GUEI		   0x1E887
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M167_GUAN		   0x1E888
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M184_NGEN		   0x1E889
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M057_NGON		   0x1E88A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M177_NGUAN		   0x1E88B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M068_PI		   0x1E88C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M099_PA		   0x1E88D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M050_PU		   0x1E88E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M081_PEE		   0x1E88F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M051_PE		   0x1E890
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M102_POO		   0x1E891
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M066_PO		   0x1E892
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M145_MBI		   0x1E893
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M062_MBA		   0x1E894
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M122_MBU		   0x1E895
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M047_MBEE		   0x1E896
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M188_MBEE		   0x1E897
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M072_MBE		   0x1E898
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M172_MBOO		   0x1E899
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M174_MBO		   0x1E89A
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M187_MBUU		   0x1E89B
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M161_LONG_MBE		   0x1E89C
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M105_LONG_MBOO		   0x1E89D
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M142_LONG_MBO		   0x1E89E
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M132_KPI		   0x1E89F
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M092_KPA		   0x1E8A0
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M074_KPU		   0x1E8A1
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M044_KPEE		   0x1E8A2
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M108_KPE		   0x1E8A3
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M112_KPOO		   0x1E8A4
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M158_KPO		   0x1E8A5
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M124_GBI		   0x1E8A6
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M056_GBA		   0x1E8A7
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M148_GBU		   0x1E8A8
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M093_GBEE		   0x1E8A9
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M107_GBE		   0x1E8AA
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M071_GBOO		   0x1E8AB
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M070_GBO		   0x1E8AC
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M171_RA		   0x1E8AD
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M123_NDI		   0x1E8AE
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M129_NDA		   0x1E8AF
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M125_NDU		   0x1E8B0
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M191_NDEE		   0x1E8B1
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M119_NDE		   0x1E8B2
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M067_NDOO		   0x1E8B3
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M064_NDO		   0x1E8B4
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M152_NJA		   0x1E8B5
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M192_NJU		   0x1E8B6
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M149_NJEE		   0x1E8B7
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M134_NJOO		   0x1E8B8
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M182_VI		   0x1E8B9
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M185_VA		   0x1E8BA
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M151_VU		   0x1E8BB
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M173_VEE		   0x1E8BC
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M085_VE		   0x1E8BD
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M144_VOO		   0x1E8BE
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M077_VO		   0x1E8BF
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M164_NYIN		   0x1E8C0
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M058_NYAN		   0x1E8C1
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M170_NYUN		   0x1E8C2
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M098_NYEN		   0x1E8C3
#define Z_UNICODE_MENDE_KIKAKUI_SYLLABLE_M060_NYON		   0x1E8C4
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_ONE			   0x1E8C7
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_TWO			   0x1E8C8
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_THREE			   0x1E8C9
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_FOUR			   0x1E8CA
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_FIVE			   0x1E8CB
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_SIX			   0x1E8CC
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_SEVEN			   0x1E8CD
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_EIGHT			   0x1E8CE
#define Z_UNICODE_MENDE_KIKAKUI_DIGIT_NINE			   0x1E8CF
#define Z_UNICODE_MENDE_KIKAKUI_COMBINING_NUMBER_TEENS		   0x1E8D0
#define Z_UNICODE_MENDE_KIKAKUI_COMBINING_NUMBER_TENS		   0x1E8D1
#define Z_UNICODE_MENDE_KIKAKUI_COMBINING_NUMBER_HUNDREDS	   0x1E8D2
#define Z_UNICODE_MENDE_KIKAKUI_COMBINING_NUMBER_THOUSANDS	   0x1E8D3
#define Z_UNICODE_MENDE_KIKAKUI_COMBINING_NUMBER_TEN_THOUSANDS	   0x1E8D4
#define Z_UNICODE_MENDE_KIKAKUI_COMBINING_NUMBER_HUNDRED_THOUSANDS 0x1E8D5
#define Z_UNICODE_MENDE_KIKAKUI_COMBINING_NUMBER_MILLIONS	   0x1E8D6

/* MARK: - 1EE00h-1EEFFh - Arabic Mathematical Alphabetic Symbols */

#define Z_UNICODE_ARABIC_MATHEMATICAL_ALEF				  0x1EE00
#define Z_UNICODE_ARABIC_MATHEMATICAL_BEH				  0x1EE01
#define Z_UNICODE_ARABIC_MATHEMATICAL_JEEM				  0x1EE02
#define Z_UNICODE_ARABIC_MATHEMATICAL_DAL				  0x1EE03
#define Z_UNICODE_ARABIC_MATHEMATICAL_WAW				  0x1EE05
#define Z_UNICODE_ARABIC_MATHEMATICAL_ZAIN				  0x1EE06
#define Z_UNICODE_ARABIC_MATHEMATICAL_HAH				  0x1EE07
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAH				  0x1EE08
#define Z_UNICODE_ARABIC_MATHEMATICAL_YEH				  0x1EE09
#define Z_UNICODE_ARABIC_MATHEMATICAL_KAF				  0x1EE0A
#define Z_UNICODE_ARABIC_MATHEMATICAL_LAM				  0x1EE0B
#define Z_UNICODE_ARABIC_MATHEMATICAL_MEEM				  0x1EE0C
#define Z_UNICODE_ARABIC_MATHEMATICAL_NOON				  0x1EE0D
#define Z_UNICODE_ARABIC_MATHEMATICAL_SEEN				  0x1EE0E
#define Z_UNICODE_ARABIC_MATHEMATICAL_AIN				  0x1EE0F
#define Z_UNICODE_ARABIC_MATHEMATICAL_FEH				  0x1EE10
#define Z_UNICODE_ARABIC_MATHEMATICAL_SAD				  0x1EE11
#define Z_UNICODE_ARABIC_MATHEMATICAL_QAF				  0x1EE12
#define Z_UNICODE_ARABIC_MATHEMATICAL_REH				  0x1EE13
#define Z_UNICODE_ARABIC_MATHEMATICAL_SHEEN				  0x1EE14
#define Z_UNICODE_ARABIC_MATHEMATICAL_TEH				  0x1EE15
#define Z_UNICODE_ARABIC_MATHEMATICAL_THEH				  0x1EE16
#define Z_UNICODE_ARABIC_MATHEMATICAL_KHAH				  0x1EE17
#define Z_UNICODE_ARABIC_MATHEMATICAL_THAL				  0x1EE18
#define Z_UNICODE_ARABIC_MATHEMATICAL_DAD				  0x1EE19
#define Z_UNICODE_ARABIC_MATHEMATICAL_ZAH				  0x1EE1A
#define Z_UNICODE_ARABIC_MATHEMATICAL_GHAIN				  0x1EE1B
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOTLESS_BEH			  0x1EE1C
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOTLESS_NOON			  0x1EE1D
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOTLESS_FEH			  0x1EE1E
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOTLESS_QAF			  0x1EE1F
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_BEH			  0x1EE21
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_JEEM			  0x1EE22
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_HEH			  0x1EE24
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_HAH			  0x1EE27
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_YEH			  0x1EE29
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_KAF			  0x1EE2A
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_LAM			  0x1EE2B
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_MEEM			  0x1EE2C
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_NOON			  0x1EE2D
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_SEEN			  0x1EE2E
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_AIN			  0x1EE2F
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_FEH			  0x1EE30
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_SAD			  0x1EE31
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_QAF			  0x1EE32
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_SHEEN			  0x1EE34
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_TEH			  0x1EE35
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_THEH			  0x1EE36
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_KHAH			  0x1EE37
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_DAD			  0x1EE39
#define Z_UNICODE_ARABIC_MATHEMATICAL_INITIAL_GHAIN			  0x1EE3B
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_JEEM			  0x1EE42
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_HAH			  0x1EE47
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_YEH			  0x1EE49
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_LAM			  0x1EE4B
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_NOON			  0x1EE4D
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_SEEN			  0x1EE4E
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_AIN			  0x1EE4F
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_SAD			  0x1EE51
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_QAF			  0x1EE52
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_SHEEN			  0x1EE54
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_KHAH			  0x1EE57
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_DAD			  0x1EE59
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_GHAIN			  0x1EE5B
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_DOTLESS_NOON		  0x1EE5D
#define Z_UNICODE_ARABIC_MATHEMATICAL_TAILED_DOTLESS_QAF		  0x1EE5F
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_BEH			  0x1EE61
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_JEEM			  0x1EE62
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_HEH			  0x1EE64
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_HAH			  0x1EE67
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_TAH			  0x1EE68
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_YEH			  0x1EE69
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_KAF			  0x1EE6A
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_MEEM			  0x1EE6C
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_NOON			  0x1EE6D
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_SEEN			  0x1EE6E
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_AIN			  0x1EE6F
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_FEH			  0x1EE70
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_SAD			  0x1EE71
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_QAF			  0x1EE72
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_SHEEN			  0x1EE74
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_TEH			  0x1EE75
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_THEH			  0x1EE76
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_KHAH			  0x1EE77
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_DAD			  0x1EE79
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_ZAH			  0x1EE7A
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_GHAIN			  0x1EE7B
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_DOTLESS_BEH		  0x1EE7C
#define Z_UNICODE_ARABIC_MATHEMATICAL_STRETCHED_DOTLESS_FEH		  0x1EE7E
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_ALEF			  0x1EE80
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_BEH			  0x1EE81
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_JEEM			  0x1EE82
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_DAL			  0x1EE83
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_HEH			  0x1EE84
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_WAW			  0x1EE85
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_ZAIN			  0x1EE86
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_HAH			  0x1EE87
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_TAH			  0x1EE88
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_YEH			  0x1EE89
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_LAM			  0x1EE8B
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_MEEM			  0x1EE8C
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_NOON			  0x1EE8D
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_SEEN			  0x1EE8E
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_AIN			  0x1EE8F
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_FEH			  0x1EE90
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_SAD			  0x1EE91
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_QAF			  0x1EE92
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_REH			  0x1EE93
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_SHEEN			  0x1EE94
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_TEH			  0x1EE95
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_THEH			  0x1EE96
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_KHAH			  0x1EE97
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_THAL			  0x1EE98
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_DAD			  0x1EE99
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_ZAH			  0x1EE9A
#define Z_UNICODE_ARABIC_MATHEMATICAL_LOOPED_GHAIN			  0x1EE9B
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_BEH			  0x1EEA1
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_JEEM		  0x1EEA2
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_DAL			  0x1EEA3
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_WAW			  0x1EEA5
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_ZAIN		  0x1EEA6
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_HAH			  0x1EEA7
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_TAH			  0x1EEA8
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_YEH			  0x1EEA9
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_LAM			  0x1EEAB
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_MEEM		  0x1EEAC
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_NOON		  0x1EEAD
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SEEN		  0x1EEAE
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_AIN			  0x1EEAF
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_FEH			  0x1EEB0
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SAD			  0x1EEB1
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_QAF			  0x1EEB2
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_REH			  0x1EEB3
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_SHEEN		  0x1EEB4
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_TEH			  0x1EEB5
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_THEH		  0x1EEB6
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_KHAH		  0x1EEB7
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_THAL		  0x1EEB8
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_DAD			  0x1EEB9
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_ZAH			  0x1EEBA
#define Z_UNICODE_ARABIC_MATHEMATICAL_DOUBLE_STRUCK_GHAIN		  0x1EEBB
#define Z_UNICODE_ARABIC_MATHEMATICAL_OPERATOR_MEEM_WITH_HAH_WITH_TATWEEL 0x1EEF0
#define Z_UNICODE_ARABIC_MATHEMATICAL_OPERATOR_HAH_WITH_DAL		  0x1EEF1

/* MARK: - 1F000h-1F02Fh - Mahjong Tiles */

#define Z_UNICODE_MAHJONG_TILE_EAST_WIND	   0x1F000
#define Z_UNICODE_MAHJONG_TILE_SOUTH_WIND	   0x1F001
#define Z_UNICODE_MAHJONG_TILE_WEST_WIND	   0x1F002
#define Z_UNICODE_MAHJONG_TILE_NORTH_WIND	   0x1F003
#define Z_UNICODE_MAHJONG_TILE_RED_DRAGON	   0x1F004
#define Z_UNICODE_MAHJONG_TILE_GREEN_DRAGON	   0x1F005
#define Z_UNICODE_MAHJONG_TILE_WHITE_DRAGON	   0x1F006
#define Z_UNICODE_MAHJONG_TILE_ONE_OF_CHARACTERS   0x1F007
#define Z_UNICODE_MAHJONG_TILE_TWO_OF_CHARACTERS   0x1F008
#define Z_UNICODE_MAHJONG_TILE_THREE_OF_CHARACTERS 0x1F009
#define Z_UNICODE_MAHJONG_TILE_FOUR_OF_CHARACTERS  0x1F00A
#define Z_UNICODE_MAHJONG_TILE_FIVE_OF_CHARACTERS  0x1F00B
#define Z_UNICODE_MAHJONG_TILE_SIX_OF_CHARACTERS   0x1F00C
#define Z_UNICODE_MAHJONG_TILE_SEVEN_OF_CHARACTERS 0x1F00D
#define Z_UNICODE_MAHJONG_TILE_EIGHT_OF_CHARACTERS 0x1F00E
#define Z_UNICODE_MAHJONG_TILE_NINE_OF_CHARACTERS  0x1F00F
#define Z_UNICODE_MAHJONG_TILE_ONE_OF_BAMBOOS	   0x1F010
#define Z_UNICODE_MAHJONG_TILE_TWO_OF_BAMBOOS	   0x1F011
#define Z_UNICODE_MAHJONG_TILE_THREE_OF_BAMBOOS	   0x1F012
#define Z_UNICODE_MAHJONG_TILE_FOUR_OF_BAMBOOS	   0x1F013
#define Z_UNICODE_MAHJONG_TILE_FIVE_OF_BAMBOOS	   0x1F014
#define Z_UNICODE_MAHJONG_TILE_SIX_OF_BAMBOOS	   0x1F015
#define Z_UNICODE_MAHJONG_TILE_SEVEN_OF_BAMBOOS	   0x1F016
#define Z_UNICODE_MAHJONG_TILE_EIGHT_OF_BAMBOOS	   0x1F017
#define Z_UNICODE_MAHJONG_TILE_NINE_OF_BAMBOOS	   0x1F018
#define Z_UNICODE_MAHJONG_TILE_ONE_OF_CIRCLES	   0x1F019
#define Z_UNICODE_MAHJONG_TILE_TWO_OF_CIRCLES	   0x1F01A
#define Z_UNICODE_MAHJONG_TILE_THREE_OF_CIRCLES	   0x1F01B
#define Z_UNICODE_MAHJONG_TILE_FOUR_OF_CIRCLES	   0x1F01C
#define Z_UNICODE_MAHJONG_TILE_FIVE_OF_CIRCLES	   0x1F01D
#define Z_UNICODE_MAHJONG_TILE_SIX_OF_CIRCLES	   0x1F01E
#define Z_UNICODE_MAHJONG_TILE_SEVEN_OF_CIRCLES	   0x1F01F
#define Z_UNICODE_MAHJONG_TILE_EIGHT_OF_CIRCLES	   0x1F020
#define Z_UNICODE_MAHJONG_TILE_NINE_OF_CIRCLES	   0x1F021
#define Z_UNICODE_MAHJONG_TILE_PLUM		   0x1F022
#define Z_UNICODE_MAHJONG_TILE_ORCHID		   0x1F023
#define Z_UNICODE_MAHJONG_TILE_BAMBOO		   0x1F024
#define Z_UNICODE_MAHJONG_TILE_CHRYSANTHEMUM	   0x1F025
#define Z_UNICODE_MAHJONG_TILE_SPRING		   0x1F026
#define Z_UNICODE_MAHJONG_TILE_SUMMER		   0x1F027
#define Z_UNICODE_MAHJONG_TILE_AUTUMN		   0x1F028
#define Z_UNICODE_MAHJONG_TILE_WINTER		   0x1F029
#define Z_UNICODE_MAHJONG_TILE_JOKER		   0x1F02A
#define Z_UNICODE_MAHJONG_TILE_BACK		   0x1F02B

/* MARK: - 1F030h-1F09Fh - Domino Tiles */

#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_BACK  0x1F030
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_00_00 0x1F031
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_00_01 0x1F032
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_00_02 0x1F033
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_00_03 0x1F034
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_00_04 0x1F035
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_00_05 0x1F036
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_00_06 0x1F037
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_01_00 0x1F038
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_01_01 0x1F039
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_01_02 0x1F03A
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_01_03 0x1F03B
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_01_04 0x1F03C
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_01_05 0x1F03D
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_01_06 0x1F03E
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_02_00 0x1F03F
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_02_01 0x1F040
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_02_02 0x1F041
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_02_03 0x1F042
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_02_04 0x1F043
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_02_05 0x1F044
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_02_06 0x1F045
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_03_00 0x1F046
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_03_01 0x1F047
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_03_02 0x1F048
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_03_03 0x1F049
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_03_04 0x1F04A
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_03_05 0x1F04B
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_03_06 0x1F04C
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_04_00 0x1F04D
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_04_01 0x1F04E
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_04_02 0x1F04F
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_04_03 0x1F050
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_04_04 0x1F051
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_04_05 0x1F052
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_04_06 0x1F053
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_05_00 0x1F054
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_05_01 0x1F055
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_05_02 0x1F056
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_05_03 0x1F057
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_05_04 0x1F058
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_05_05 0x1F059
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_05_06 0x1F05A
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_06_00 0x1F05B
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_06_01 0x1F05C
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_06_02 0x1F05D
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_06_03 0x1F05E
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_06_04 0x1F05F
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_06_05 0x1F060
#define Z_UNICODE_DOMINO_TILE_HORIZONTAL_06_06 0x1F061
#define Z_UNICODE_DOMINO_TILE_VERTICAL_BACK    0x1F062
#define Z_UNICODE_DOMINO_TILE_VERTICAL_00_00   0x1F063
#define Z_UNICODE_DOMINO_TILE_VERTICAL_00_01   0x1F064
#define Z_UNICODE_DOMINO_TILE_VERTICAL_00_02   0x1F065
#define Z_UNICODE_DOMINO_TILE_VERTICAL_00_03   0x1F066
#define Z_UNICODE_DOMINO_TILE_VERTICAL_00_04   0x1F067
#define Z_UNICODE_DOMINO_TILE_VERTICAL_00_05   0x1F068
#define Z_UNICODE_DOMINO_TILE_VERTICAL_00_06   0x1F069
#define Z_UNICODE_DOMINO_TILE_VERTICAL_01_00   0x1F06A
#define Z_UNICODE_DOMINO_TILE_VERTICAL_01_01   0x1F06B
#define Z_UNICODE_DOMINO_TILE_VERTICAL_01_02   0x1F06C
#define Z_UNICODE_DOMINO_TILE_VERTICAL_01_03   0x1F06D
#define Z_UNICODE_DOMINO_TILE_VERTICAL_01_04   0x1F06E
#define Z_UNICODE_DOMINO_TILE_VERTICAL_01_05   0x1F06F
#define Z_UNICODE_DOMINO_TILE_VERTICAL_01_06   0x1F070
#define Z_UNICODE_DOMINO_TILE_VERTICAL_02_00   0x1F071
#define Z_UNICODE_DOMINO_TILE_VERTICAL_02_01   0x1F072
#define Z_UNICODE_DOMINO_TILE_VERTICAL_02_02   0x1F073
#define Z_UNICODE_DOMINO_TILE_VERTICAL_02_03   0x1F074
#define Z_UNICODE_DOMINO_TILE_VERTICAL_02_04   0x1F075
#define Z_UNICODE_DOMINO_TILE_VERTICAL_02_05   0x1F076
#define Z_UNICODE_DOMINO_TILE_VERTICAL_02_06   0x1F077
#define Z_UNICODE_DOMINO_TILE_VERTICAL_03_00   0x1F078
#define Z_UNICODE_DOMINO_TILE_VERTICAL_03_01   0x1F079
#define Z_UNICODE_DOMINO_TILE_VERTICAL_03_02   0x1F07A
#define Z_UNICODE_DOMINO_TILE_VERTICAL_03_03   0x1F07B
#define Z_UNICODE_DOMINO_TILE_VERTICAL_03_04   0x1F07C
#define Z_UNICODE_DOMINO_TILE_VERTICAL_03_05   0x1F07D
#define Z_UNICODE_DOMINO_TILE_VERTICAL_03_06   0x1F07E
#define Z_UNICODE_DOMINO_TILE_VERTICAL_04_00   0x1F07F
#define Z_UNICODE_DOMINO_TILE_VERTICAL_04_01   0x1F080
#define Z_UNICODE_DOMINO_TILE_VERTICAL_04_02   0x1F081
#define Z_UNICODE_DOMINO_TILE_VERTICAL_04_03   0x1F082
#define Z_UNICODE_DOMINO_TILE_VERTICAL_04_04   0x1F083
#define Z_UNICODE_DOMINO_TILE_VERTICAL_04_05   0x1F084
#define Z_UNICODE_DOMINO_TILE_VERTICAL_04_06   0x1F085
#define Z_UNICODE_DOMINO_TILE_VERTICAL_05_00   0x1F086
#define Z_UNICODE_DOMINO_TILE_VERTICAL_05_01   0x1F087
#define Z_UNICODE_DOMINO_TILE_VERTICAL_05_02   0x1F088
#define Z_UNICODE_DOMINO_TILE_VERTICAL_05_03   0x1F089
#define Z_UNICODE_DOMINO_TILE_VERTICAL_05_04   0x1F08A
#define Z_UNICODE_DOMINO_TILE_VERTICAL_05_05   0x1F08B
#define Z_UNICODE_DOMINO_TILE_VERTICAL_05_06   0x1F08C
#define Z_UNICODE_DOMINO_TILE_VERTICAL_06_00   0x1F08D
#define Z_UNICODE_DOMINO_TILE_VERTICAL_06_01   0x1F08E
#define Z_UNICODE_DOMINO_TILE_VERTICAL_06_02   0x1F08F
#define Z_UNICODE_DOMINO_TILE_VERTICAL_06_03   0x1F090
#define Z_UNICODE_DOMINO_TILE_VERTICAL_06_04   0x1F091
#define Z_UNICODE_DOMINO_TILE_VERTICAL_06_05   0x1F092
#define Z_UNICODE_DOMINO_TILE_VERTICAL_06_06   0x1F093

/* MARK: - 1F0A0h-1F0FFh - Playing Cards */

#define Z_UNICODE_PLAYING_CARD_BACK		  0x1F0A0
#define Z_UNICODE_PLAYING_CARD_ACE_OF_SPADES	  0x1F0A1
#define Z_UNICODE_PLAYING_CARD_TWO_OF_SPADES	  0x1F0A2
#define Z_UNICODE_PLAYING_CARD_THREE_OF_SPADES	  0x1F0A3
#define Z_UNICODE_PLAYING_CARD_FOUR_OF_SPADES	  0x1F0A4
#define Z_UNICODE_PLAYING_CARD_FIVE_OF_SPADES	  0x1F0A5
#define Z_UNICODE_PLAYING_CARD_SIX_OF_SPADES	  0x1F0A6
#define Z_UNICODE_PLAYING_CARD_SEVEN_OF_SPADES	  0x1F0A7
#define Z_UNICODE_PLAYING_CARD_EIGHT_OF_SPADES	  0x1F0A8
#define Z_UNICODE_PLAYING_CARD_NINE_OF_SPADES	  0x1F0A9
#define Z_UNICODE_PLAYING_CARD_TEN_OF_SPADES	  0x1F0AA
#define Z_UNICODE_PLAYING_CARD_JACK_OF_SPADES	  0x1F0AB
#define Z_UNICODE_PLAYING_CARD_KNIGHT_OF_SPADES	  0x1F0AC
#define Z_UNICODE_PLAYING_CARD_QUEEN_OF_SPADES	  0x1F0AD
#define Z_UNICODE_PLAYING_CARD_KING_OF_SPADES	  0x1F0AE
#define Z_UNICODE_PLAYING_CARD_ACE_OF_HEARTS	  0x1F0B1
#define Z_UNICODE_PLAYING_CARD_TWO_OF_HEARTS	  0x1F0B2
#define Z_UNICODE_PLAYING_CARD_THREE_OF_HEARTS	  0x1F0B3
#define Z_UNICODE_PLAYING_CARD_FOUR_OF_HEARTS	  0x1F0B4
#define Z_UNICODE_PLAYING_CARD_FIVE_OF_HEARTS	  0x1F0B5
#define Z_UNICODE_PLAYING_CARD_SIX_OF_HEARTS	  0x1F0B6
#define Z_UNICODE_PLAYING_CARD_SEVEN_OF_HEARTS	  0x1F0B7
#define Z_UNICODE_PLAYING_CARD_EIGHT_OF_HEARTS	  0x1F0B8
#define Z_UNICODE_PLAYING_CARD_NINE_OF_HEARTS	  0x1F0B9
#define Z_UNICODE_PLAYING_CARD_TEN_OF_HEARTS	  0x1F0BA
#define Z_UNICODE_PLAYING_CARD_JACK_OF_HEARTS	  0x1F0BB
#define Z_UNICODE_PLAYING_CARD_KNIGHT_OF_HEARTS	  0x1F0BC
#define Z_UNICODE_PLAYING_CARD_QUEEN_OF_HEARTS	  0x1F0BD
#define Z_UNICODE_PLAYING_CARD_KING_OF_HEARTS	  0x1F0BE
#define Z_UNICODE_PLAYING_CARD_RED_JOKER	  0x1F0BF
#define Z_UNICODE_PLAYING_CARD_ACE_OF_DIAMONDS	  0x1F0C1
#define Z_UNICODE_PLAYING_CARD_TWO_OF_DIAMONDS	  0x1F0C2
#define Z_UNICODE_PLAYING_CARD_THREE_OF_DIAMONDS  0x1F0C3
#define Z_UNICODE_PLAYING_CARD_FOUR_OF_DIAMONDS	  0x1F0C4
#define Z_UNICODE_PLAYING_CARD_FIVE_OF_DIAMONDS	  0x1F0C5
#define Z_UNICODE_PLAYING_CARD_SIX_OF_DIAMONDS	  0x1F0C6
#define Z_UNICODE_PLAYING_CARD_SEVEN_OF_DIAMONDS  0x1F0C7
#define Z_UNICODE_PLAYING_CARD_EIGHT_OF_DIAMONDS  0x1F0C8
#define Z_UNICODE_PLAYING_CARD_NINE_OF_DIAMONDS	  0x1F0C9
#define Z_UNICODE_PLAYING_CARD_TEN_OF_DIAMONDS	  0x1F0CA
#define Z_UNICODE_PLAYING_CARD_JACK_OF_DIAMONDS	  0x1F0CB
#define Z_UNICODE_PLAYING_CARD_KNIGHT_OF_DIAMONDS 0x1F0CC
#define Z_UNICODE_PLAYING_CARD_QUEEN_OF_DIAMONDS  0x1F0CD
#define Z_UNICODE_PLAYING_CARD_KING_OF_DIAMONDS	  0x1F0CE
#define Z_UNICODE_PLAYING_CARD_BLACK_JOKER	  0x1F0CF
#define Z_UNICODE_PLAYING_CARD_ACE_OF_CLUBS	  0x1F0D1
#define Z_UNICODE_PLAYING_CARD_TWO_OF_CLUBS	  0x1F0D2
#define Z_UNICODE_PLAYING_CARD_THREE_OF_CLUBS	  0x1F0D3
#define Z_UNICODE_PLAYING_CARD_FOUR_OF_CLUBS	  0x1F0D4
#define Z_UNICODE_PLAYING_CARD_FIVE_OF_CLUBS	  0x1F0D5
#define Z_UNICODE_PLAYING_CARD_SIX_OF_CLUBS	  0x1F0D6
#define Z_UNICODE_PLAYING_CARD_SEVEN_OF_CLUBS	  0x1F0D7
#define Z_UNICODE_PLAYING_CARD_EIGHT_OF_CLUBS	  0x1F0D8
#define Z_UNICODE_PLAYING_CARD_NINE_OF_CLUBS	  0x1F0D9
#define Z_UNICODE_PLAYING_CARD_TEN_OF_CLUBS	  0x1F0DA
#define Z_UNICODE_PLAYING_CARD_JACK_OF_CLUBS	  0x1F0DB
#define Z_UNICODE_PLAYING_CARD_KNIGHT_OF_CLUBS	  0x1F0DC
#define Z_UNICODE_PLAYING_CARD_QUEEN_OF_CLUBS	  0x1F0DD
#define Z_UNICODE_PLAYING_CARD_KING_OF_CLUBS	  0x1F0DE
#define Z_UNICODE_PLAYING_CARD_WHITE_JOKER	  0x1F0DF
#define Z_UNICODE_PLAYING_CARD_FOOL		  0x1F0E0
#define Z_UNICODE_PLAYING_CARD_TRUMP_1		  0x1F0E1
#define Z_UNICODE_PLAYING_CARD_TRUMP_2		  0x1F0E2
#define Z_UNICODE_PLAYING_CARD_TRUMP_3		  0x1F0E3
#define Z_UNICODE_PLAYING_CARD_TRUMP_4		  0x1F0E4
#define Z_UNICODE_PLAYING_CARD_TRUMP_5		  0x1F0E5
#define Z_UNICODE_PLAYING_CARD_TRUMP_6		  0x1F0E6
#define Z_UNICODE_PLAYING_CARD_TRUMP_7		  0x1F0E7
#define Z_UNICODE_PLAYING_CARD_TRUMP_8		  0x1F0E8
#define Z_UNICODE_PLAYING_CARD_TRUMP_9		  0x1F0E9
#define Z_UNICODE_PLAYING_CARD_TRUMP_10		  0x1F0EA
#define Z_UNICODE_PLAYING_CARD_TRUMP_11		  0x1F0EB
#define Z_UNICODE_PLAYING_CARD_TRUMP_12		  0x1F0EC
#define Z_UNICODE_PLAYING_CARD_TRUMP_13		  0x1F0ED
#define Z_UNICODE_PLAYING_CARD_TRUMP_14		  0x1F0EE
#define Z_UNICODE_PLAYING_CARD_TRUMP_15		  0x1F0EF
#define Z_UNICODE_PLAYING_CARD_TRUMP_16		  0x1F0F0
#define Z_UNICODE_PLAYING_CARD_TRUMP_17		  0x1F0F1
#define Z_UNICODE_PLAYING_CARD_TRUMP_18		  0x1F0F2
#define Z_UNICODE_PLAYING_CARD_TRUMP_19		  0x1F0F3
#define Z_UNICODE_PLAYING_CARD_TRUMP_20		  0x1F0F4
#define Z_UNICODE_PLAYING_CARD_TRUMP_21		  0x1F0F5

/* MARK: - 1F100h-1F1FFh - Enclosed Alphanumeric Supplement */

#define Z_UNICODE_DIGIT_ZERO_FULL_STOP				  0x1F100
#define Z_UNICODE_DIGIT_ZERO_COMMA				  0x1F101
#define Z_UNICODE_DIGIT_ONE_COMMA				  0x1F102
#define Z_UNICODE_DIGIT_TWO_COMMA				  0x1F103
#define Z_UNICODE_DIGIT_THREE_COMMA				  0x1F104
#define Z_UNICODE_DIGIT_FOUR_COMMA				  0x1F105
#define Z_UNICODE_DIGIT_FIVE_COMMA				  0x1F106
#define Z_UNICODE_DIGIT_SIX_COMMA				  0x1F107
#define Z_UNICODE_DIGIT_SEVEN_COMMA				  0x1F108
#define Z_UNICODE_DIGIT_EIGHT_COMMA				  0x1F109
#define Z_UNICODE_DIGIT_NINE_COMMA				  0x1F10A
#define Z_UNICODE_DINGBAT_CIRCLED_SANS_SERIF_DIGIT_ZERO		  0x1F10B
#define Z_UNICODE_DINGBAT_NEGATIVE_CIRCLED_SANS_SERIF_DIGIT_ZERO  0x1F10C
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_A		  0x1F110
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_B		  0x1F111
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_C		  0x1F112
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_D		  0x1F113
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_E		  0x1F114
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_F		  0x1F115
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_G		  0x1F116
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_H		  0x1F117
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_I		  0x1F118
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_J		  0x1F119
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_K		  0x1F11A
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_L		  0x1F11B
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_M		  0x1F11C
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_N		  0x1F11D
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_O		  0x1F11E
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_P		  0x1F11F
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_Q		  0x1F120
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_R		  0x1F121
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_S		  0x1F122
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_T		  0x1F123
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_U		  0x1F124
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_V		  0x1F125
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_W		  0x1F126
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_X		  0x1F127
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_Y		  0x1F128
#define Z_UNICODE_PARENTHESIZED_LATIN_CAPITAL_LETTER_Z		  0x1F129
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_LATIN_CAPITAL_LETTER_S 0x1F12A
#define Z_UNICODE_CIRCLED_ITALIC_LATIN_CAPITAL_LETTER_C		  0x1F12B
#define Z_UNICODE_CIRCLED_ITALIC_LATIN_CAPITAL_LETTER_R		  0x1F12C
#define Z_UNICODE_CIRCLED_CD					  0x1F12D
#define Z_UNICODE_CIRCLED_WZ					  0x1F12E
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_A		  0x1F130
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_B		  0x1F131
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_C		  0x1F132
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_D		  0x1F133
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_E		  0x1F134
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_F		  0x1F135
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_G		  0x1F136
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_H		  0x1F137
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_I		  0x1F138
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_J		  0x1F139
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_K		  0x1F13A
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_L		  0x1F13B
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_M		  0x1F13C
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_N		  0x1F13D
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_O		  0x1F13E
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_P		  0x1F13F
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_Q		  0x1F140
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_R		  0x1F141
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_S		  0x1F142
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_T		  0x1F143
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_U		  0x1F144
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_V		  0x1F145
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_W		  0x1F146
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_X		  0x1F147
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_Y		  0x1F148
#define Z_UNICODE_SQUARED_LATIN_CAPITAL_LETTER_Z		  0x1F149
#define Z_UNICODE_SQUARED_HV					  0x1F14A
#define Z_UNICODE_SQUARED_MV					  0x1F14B
#define Z_UNICODE_SQUARED_SD					  0x1F14C
#define Z_UNICODE_SQUARED_SS					  0x1F14D
#define Z_UNICODE_SQUARED_PPV					  0x1F14E
#define Z_UNICODE_SQUARED_WC					  0x1F14F
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_A	  0x1F150
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_B	  0x1F151
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_C	  0x1F152
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_D	  0x1F153
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_E	  0x1F154
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_F	  0x1F155
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_G	  0x1F156
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_H	  0x1F157
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_I	  0x1F158
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_J	  0x1F159
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_K	  0x1F15A
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_L	  0x1F15B
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_M	  0x1F15C
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_N	  0x1F15D
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_O	  0x1F15E
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_P	  0x1F15F
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Q	  0x1F160
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_R	  0x1F161
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_S	  0x1F162
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_T	  0x1F163
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_U	  0x1F164
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_V	  0x1F165
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_W	  0x1F166
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_X	  0x1F167
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Y	  0x1F168
#define Z_UNICODE_NEGATIVE_CIRCLED_LATIN_CAPITAL_LETTER_Z	  0x1F169
#define Z_UNICODE_RAISED_MC_SIGN				  0x1F16A
#define Z_UNICODE_RAISED_MD_SIGN				  0x1F16B
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_A	  0x1F170
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_B	  0x1F171
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_C	  0x1F172
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_D	  0x1F173
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_E	  0x1F174
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_F	  0x1F175
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_G	  0x1F176
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_H	  0x1F177
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_I	  0x1F178
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_J	  0x1F179
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_K	  0x1F17A
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_L	  0x1F17B
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_M	  0x1F17C
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_N	  0x1F17D
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_O	  0x1F17E
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_P	  0x1F17F
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Q	  0x1F180
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_R	  0x1F181
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_S	  0x1F182
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_T	  0x1F183
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_U	  0x1F184
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_V	  0x1F185
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_W	  0x1F186
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_X	  0x1F187
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Y	  0x1F188
#define Z_UNICODE_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_Z	  0x1F189
#define Z_UNICODE_CROSSED_NEGATIVE_SQUARED_LATIN_CAPITAL_LETTER_P 0x1F18A
#define Z_UNICODE_NEGATIVE_SQUARED_IC				  0x1F18B
#define Z_UNICODE_NEGATIVE_SQUARED_PA				  0x1F18C
#define Z_UNICODE_NEGATIVE_SQUARED_SA				  0x1F18D
#define Z_UNICODE_NEGATIVE_SQUARED_AB				  0x1F18E
#define Z_UNICODE_NEGATIVE_SQUARED_WC				  0x1F18F
#define Z_UNICODE_SQUARE_DJ					  0x1F190
#define Z_UNICODE_SQUARED_CL					  0x1F191
#define Z_UNICODE_SQUARED_COOL					  0x1F192
#define Z_UNICODE_SQUARED_FREE					  0x1F193
#define Z_UNICODE_SQUARED_ID					  0x1F194
#define Z_UNICODE_SQUARED_NEW					  0x1F195
#define Z_UNICODE_SQUARED_NG					  0x1F196
#define Z_UNICODE_SQUARED_OK					  0x1F197
#define Z_UNICODE_SQUARED_SOS					  0x1F198
#define Z_UNICODE_SQUARED_UP_WITH_EXCLAMATION_MARK		  0x1F199
#define Z_UNICODE_SQUARED_VS					  0x1F19A
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_A		  0x1F1E6
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_B		  0x1F1E7
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_C		  0x1F1E8
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_D		  0x1F1E9
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_E		  0x1F1EA
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_F		  0x1F1EB
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_G		  0x1F1EC
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_H		  0x1F1ED
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_I		  0x1F1EE
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_J		  0x1F1EF
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_K		  0x1F1F0
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_L		  0x1F1F1
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_M		  0x1F1F2
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_N		  0x1F1F3
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_O		  0x1F1F4
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_P		  0x1F1F5
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_Q		  0x1F1F6
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_R		  0x1F1F7
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_S		  0x1F1F8
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_T		  0x1F1F9
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_U		  0x1F1FA
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_V		  0x1F1FB
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_W		  0x1F1FC
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_X		  0x1F1FD
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_Y		  0x1F1FE
#define Z_UNICODE_REGIONAL_INDICATOR_SYMBOL_LETTER_Z		  0x1F1FF

/* MARK: - 1F200h-1F2FFh - Enclosed Ideographic Supplement */

#define Z_UNICODE_SQUARE_HIRAGANA_HOKA				      0x1F200
#define Z_UNICODE_SQUARED_KATAKANA_KOKO				      0x1F201
#define Z_UNICODE_SQUARED_KATAKANA_SA				      0x1F202
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_624B		      0x1F210
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_5B57		      0x1F211
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_53CC		      0x1F212
#define Z_UNICODE_SQUARED_KATAKANA_DE				      0x1F213
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_4E8C		      0x1F214
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_591A		      0x1F215
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_89E3		      0x1F216
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_5929		      0x1F217
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_4EA4		      0x1F218
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6620		      0x1F219
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_7121		      0x1F21A
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6599		      0x1F21B
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_524D		      0x1F21C
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_5F8C		      0x1F21D
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_518D		      0x1F21E
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_65B0		      0x1F21F
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_521D		      0x1F220
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_7D42		      0x1F221
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_751F		      0x1F222
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_8CA9		      0x1F223
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_58F0		      0x1F224
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_5439		      0x1F225
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6F14		      0x1F226
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6295		      0x1F227
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6355		      0x1F228
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_4E00		      0x1F229
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_4E09		      0x1F22A
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_904A		      0x1F22B
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_5DE6		      0x1F22C
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_4E2D		      0x1F22D
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_53F3		      0x1F22E
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6307		      0x1F22F
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_8D70		      0x1F230
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6253		      0x1F231
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_7981		      0x1F232
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_7A7A		      0x1F233
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_5408		      0x1F234
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6E80		      0x1F235
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6709		      0x1F236
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_6708		      0x1F237
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_7533		      0x1F238
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_5272		      0x1F239
#define Z_UNICODE_SQUARED_CJK_UNIFIED_IDEOGRAPH_55B6		      0x1F23A
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_672C 0x1F240
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_4E09 0x1F241
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_4E8C 0x1F242
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_5B89 0x1F243
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_70B9 0x1F244
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_6253 0x1F245
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_76D7 0x1F246
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_52DD 0x1F247
#define Z_UNICODE_TORTOISE_SHELL_BRACKETED_CJK_UNIFIED_IDEOGRAPH_6557 0x1F248
#define Z_UNICODE_CIRCLED_IDEOGRAPH_ADVANTAGE			      0x1F250
#define Z_UNICODE_CIRCLED_IDEOGRAPH_ACCEPT			      0x1F251

/* MARK: - 1F300h-1F5FFh - Miscellaneous Symbols and Pictographs */

#define Z_UNICODE_CYCLONE									 0x1F300
#define Z_UNICODE_FOGGY										 0x1F301
#define Z_UNICODE_CLOSED_UMBRELLA								 0x1F302
#define Z_UNICODE_NIGHT_WITH_STARS								 0x1F303
#define Z_UNICODE_SUNRISE_OVER_MOUNTAINS							 0x1F304
#define Z_UNICODE_SUNRISE									 0x1F305
#define Z_UNICODE_CITYSCAPE_AT_DUSK								 0x1F306
#define Z_UNICODE_SUNSET_OVER_BUILDINGS								 0x1F307
#define Z_UNICODE_RAINBOW									 0x1F308
#define Z_UNICODE_BRIDGE_AT_NIGHT								 0x1F309
#define Z_UNICODE_WATER_WAVE									 0x1F30A
#define Z_UNICODE_VOLCANO									 0x1F30B
#define Z_UNICODE_MILKY_WAY									 0x1F30C
#define Z_UNICODE_EARTH_GLOBE_EUROPE_AFRICA							 0x1F30D
#define Z_UNICODE_EARTH_GLOBE_AMERICAS								 0x1F30E
#define Z_UNICODE_EARTH_GLOBE_ASIA_AUSTRALIA							 0x1F30F
#define Z_UNICODE_GLOBE_WITH_MERIDIANS								 0x1F310
#define Z_UNICODE_NEW_MOON_SYMBOL								 0x1F311
#define Z_UNICODE_WAXING_CRESCENT_MOON_SYMBOL							 0x1F312
#define Z_UNICODE_FIRST_QUARTER_MOON_SYMBOL							 0x1F313
#define Z_UNICODE_WAXING_GIBBOUS_MOON_SYMBOL							 0x1F314
#define Z_UNICODE_FULL_MOON_SYMBOL								 0x1F315
#define Z_UNICODE_WANING_GIBBOUS_MOON_SYMBOL							 0x1F316
#define Z_UNICODE_LAST_QUARTER_MOON_SYMBOL							 0x1F317
#define Z_UNICODE_WANING_CRESCENT_MOON_SYMBOL							 0x1F318
#define Z_UNICODE_CRESCENT_MOON									 0x1F319
#define Z_UNICODE_NEW_MOON_WITH_FACE								 0x1F31A
#define Z_UNICODE_FIRST_QUARTER_MOON_WITH_FACE							 0x1F31B
#define Z_UNICODE_LAST_QUARTER_MOON_WITH_FACE							 0x1F31C
#define Z_UNICODE_FULL_MOON_WITH_FACE								 0x1F31D
#define Z_UNICODE_SUN_WITH_FACE									 0x1F31E
#define Z_UNICODE_GLOWING_STAR									 0x1F31F
#define Z_UNICODE_SHOOTING_STAR									 0x1F320
#define Z_UNICODE_THERMOMETER									 0x1F321
#define Z_UNICODE_BLACK_DROPLET									 0x1F322
#define Z_UNICODE_WHITE_SUN									 0x1F323
#define Z_UNICODE_WHITE_SUN_WITH_SMALL_CLOUD							 0x1F324
#define Z_UNICODE_WHITE_SUN_BEHIND_CLOUD							 0x1F325
#define Z_UNICODE_WHITE_SUN_BEHIND_CLOUD_WITH_RAIN						 0x1F326
#define Z_UNICODE_CLOUD_WITH_RAIN								 0x1F327
#define Z_UNICODE_CLOUD_WITH_SNOW								 0x1F328
#define Z_UNICODE_CLOUD_WITH_LIGHTNING								 0x1F329
#define Z_UNICODE_CLOUD_WITH_TORNADO								 0x1F32A
#define Z_UNICODE_FOG										 0x1F32B
#define Z_UNICODE_WIND_BLOWING_FACE								 0x1F32C
#define Z_UNICODE_HOT_DOG									 0x1F32D
#define Z_UNICODE_TACO										 0x1F32E
#define Z_UNICODE_BURRITO									 0x1F32F
#define Z_UNICODE_CHESTNUT									 0x1F330
#define Z_UNICODE_SEEDLING									 0x1F331
#define Z_UNICODE_EVERGREEN_TREE								 0x1F332
#define Z_UNICODE_DECIDUOUS_TREE								 0x1F333
#define Z_UNICODE_PALM_TREE									 0x1F334
#define Z_UNICODE_CACTUS									 0x1F335
#define Z_UNICODE_HOT_PEPPER									 0x1F336
#define Z_UNICODE_TULIP										 0x1F337
#define Z_UNICODE_CHERRY_BLOSSOM								 0x1F338
#define Z_UNICODE_ROSE										 0x1F339
#define Z_UNICODE_HIBISCUS									 0x1F33A
#define Z_UNICODE_SUNFLOWER									 0x1F33B
#define Z_UNICODE_BLOSSOM									 0x1F33C
#define Z_UNICODE_EAR_OF_MAIZE									 0x1F33D
#define Z_UNICODE_EAR_OF_RICE									 0x1F33E
#define Z_UNICODE_HERB										 0x1F33F
#define Z_UNICODE_FOUR_LEAF_CLOVER								 0x1F340
#define Z_UNICODE_MAPLE_LEAF									 0x1F341
#define Z_UNICODE_FALLEN_LEAF									 0x1F342
#define Z_UNICODE_LEAF_FLUTTERING_IN_WIND							 0x1F343
#define Z_UNICODE_MUSHROOM									 0x1F344
#define Z_UNICODE_TOMATO									 0x1F345
#define Z_UNICODE_AUBERGINE									 0x1F346
#define Z_UNICODE_GRAPES									 0x1F347
#define Z_UNICODE_MELON										 0x1F348
#define Z_UNICODE_WATERMELON									 0x1F349
#define Z_UNICODE_TANGERINE									 0x1F34A
#define Z_UNICODE_LEMON										 0x1F34B
#define Z_UNICODE_BANANA									 0x1F34C
#define Z_UNICODE_PINEAPPLE									 0x1F34D
#define Z_UNICODE_RED_APPLE									 0x1F34E
#define Z_UNICODE_GREEN_APPLE									 0x1F34F
#define Z_UNICODE_PEAR										 0x1F350
#define Z_UNICODE_PEACH										 0x1F351
#define Z_UNICODE_CHERRIES									 0x1F352
#define Z_UNICODE_STRAWBERRY									 0x1F353
#define Z_UNICODE_HAMBURGER									 0x1F354
#define Z_UNICODE_SLICE_OF_PIZZA								 0x1F355
#define Z_UNICODE_MEAT_ON_BONE									 0x1F356
#define Z_UNICODE_POULTRY_LEG									 0x1F357
#define Z_UNICODE_RICE_CRACKER									 0x1F358
#define Z_UNICODE_RICE_BALL									 0x1F359
#define Z_UNICODE_COOKED_RICE									 0x1F35A
#define Z_UNICODE_CURRY_AND_RICE								 0x1F35B
#define Z_UNICODE_STEAMING_BOWL									 0x1F35C
#define Z_UNICODE_SPAGHETTI									 0x1F35D
#define Z_UNICODE_BREAD										 0x1F35E
#define Z_UNICODE_FRENCH_FRIES									 0x1F35F
#define Z_UNICODE_ROASTED_SWEET_POTATO								 0x1F360
#define Z_UNICODE_DANGO										 0x1F361
#define Z_UNICODE_ODEN										 0x1F362
#define Z_UNICODE_SUSHI										 0x1F363
#define Z_UNICODE_FRIED_SHRIMP									 0x1F364
#define Z_UNICODE_FISH_CAKE_WITH_SWIRL_DESIGN							 0x1F365
#define Z_UNICODE_SOFT_ICE_CREAM								 0x1F366
#define Z_UNICODE_SHAVED_ICE									 0x1F367
#define Z_UNICODE_ICE_CREAM									 0x1F368
#define Z_UNICODE_DOUGHNUT									 0x1F369
#define Z_UNICODE_COOKIE									 0x1F36A
#define Z_UNICODE_CHOCOLATE_BAR									 0x1F36B
#define Z_UNICODE_CANDY										 0x1F36C
#define Z_UNICODE_LOLLIPOP									 0x1F36D
#define Z_UNICODE_CUSTARD									 0x1F36E
#define Z_UNICODE_HONEY_POT									 0x1F36F
#define Z_UNICODE_SHORTCAKE									 0x1F370
#define Z_UNICODE_BENTO_BOX									 0x1F371
#define Z_UNICODE_POT_OF_FOOD									 0x1F372
#define Z_UNICODE_COOKING									 0x1F373
#define Z_UNICODE_FORK_AND_KNIFE								 0x1F374
#define Z_UNICODE_TEACUP_WITHOUT_HANDLE								 0x1F375
#define Z_UNICODE_SAKE_BOTTLE_AND_CUP								 0x1F376
#define Z_UNICODE_WINE_GLASS									 0x1F377
#define Z_UNICODE_COCKTAIL_GLASS								 0x1F378
#define Z_UNICODE_TROPICAL_DRINK								 0x1F379
#define Z_UNICODE_BEER_MUG									 0x1F37A
#define Z_UNICODE_CLINKING_BEER_MUGS								 0x1F37B
#define Z_UNICODE_BABY_BOTTLE									 0x1F37C
#define Z_UNICODE_FORK_AND_KNIFE_WITH_PLATE							 0x1F37D
#define Z_UNICODE_BOTTLE_WITH_POPPING_CORK							 0x1F37E
#define Z_UNICODE_POPCORN									 0x1F37F
#define Z_UNICODE_RIBBON									 0x1F380
#define Z_UNICODE_WRAPPED_PRESENT								 0x1F381
#define Z_UNICODE_BIRTHDAY_CAKE									 0x1F382
#define Z_UNICODE_JACK_O_LANTERN								 0x1F383
#define Z_UNICODE_CHRISTMAS_TREE								 0x1F384
#define Z_UNICODE_FATHER_CHRISTMAS								 0x1F385
#define Z_UNICODE_FIREWORKS									 0x1F386
#define Z_UNICODE_FIREWORK_SPARKLER								 0x1F387
#define Z_UNICODE_BALLOON									 0x1F388
#define Z_UNICODE_PARTY_POPPER									 0x1F389
#define Z_UNICODE_CONFETTI_BALL									 0x1F38A
#define Z_UNICODE_TANABATA_TREE									 0x1F38B
#define Z_UNICODE_CROSSED_FLAGS									 0x1F38C
#define Z_UNICODE_PINE_DECORATION								 0x1F38D
#define Z_UNICODE_JAPANESE_DOLLS								 0x1F38E
#define Z_UNICODE_CARP_STREAMER									 0x1F38F
#define Z_UNICODE_WIND_CHIME									 0x1F390
#define Z_UNICODE_MOON_VIEWING_CEREMONY								 0x1F391
#define Z_UNICODE_SCHOOL_SATCHEL								 0x1F392
#define Z_UNICODE_GRADUATION_CAP								 0x1F393
#define Z_UNICODE_HEART_WITH_TIP_ON_THE_LEFT							 0x1F394
#define Z_UNICODE_BOUQUET_OF_FLOWERS								 0x1F395
#define Z_UNICODE_MILITARY_MEDAL								 0x1F396
#define Z_UNICODE_REMINDER_RIBBON								 0x1F397
#define Z_UNICODE_MUSICAL_KEYBOARD_WITH_JACKS							 0x1F398
#define Z_UNICODE_STUDIO_MICROPHONE								 0x1F399
#define Z_UNICODE_LEVEL_SLIDER									 0x1F39A
#define Z_UNICODE_CONTROL_KNOBS									 0x1F39B
#define Z_UNICODE_BEAMED_ASCENDING_MUSICAL_NOTES						 0x1F39C
#define Z_UNICODE_BEAMED_DESCENDING_MUSICAL_NOTES						 0x1F39D
#define Z_UNICODE_FILM_FRAMES									 0x1F39E
#define Z_UNICODE_ADMISSION_TICKETS								 0x1F39F
#define Z_UNICODE_CAROUSEL_HORSE								 0x1F3A0
#define Z_UNICODE_FERRIS_WHEEL									 0x1F3A1
#define Z_UNICODE_ROLLER_COASTER								 0x1F3A2
#define Z_UNICODE_FISHING_POLE_AND_FISH								 0x1F3A3
#define Z_UNICODE_MICROPHONE									 0x1F3A4
#define Z_UNICODE_MOVIE_CAMERA									 0x1F3A5
#define Z_UNICODE_CINEMA									 0x1F3A6
#define Z_UNICODE_HEADPHONE									 0x1F3A7
#define Z_UNICODE_ARTIST_PALETTE								 0x1F3A8
#define Z_UNICODE_TOP_HAT									 0x1F3A9
#define Z_UNICODE_CIRCUS_TENT									 0x1F3AA
#define Z_UNICODE_TICKET									 0x1F3AB
#define Z_UNICODE_CLAPPER_BOARD									 0x1F3AC
#define Z_UNICODE_PERFORMING_ARTS								 0x1F3AD
#define Z_UNICODE_VIDEO_GAME									 0x1F3AE
#define Z_UNICODE_DIRECT_HIT									 0x1F3AF
#define Z_UNICODE_SLOT_MACHINE									 0x1F3B0
#define Z_UNICODE_BILLIARDS									 0x1F3B1
#define Z_UNICODE_GAME_DIE									 0x1F3B2
#define Z_UNICODE_BOWLING									 0x1F3B3
#define Z_UNICODE_FLOWER_PLAYING_CARDS								 0x1F3B4
#define Z_UNICODE_MUSICAL_NOTE									 0x1F3B5
#define Z_UNICODE_MULTIPLE_MUSICAL_NOTES							 0x1F3B6
#define Z_UNICODE_SAXOPHONE									 0x1F3B7
#define Z_UNICODE_GUITAR									 0x1F3B8
#define Z_UNICODE_MUSICAL_KEYBOARD								 0x1F3B9
#define Z_UNICODE_TRUMPET									 0x1F3BA
#define Z_UNICODE_VIOLIN									 0x1F3BB
#define Z_UNICODE_MUSICAL_SCORE									 0x1F3BC
#define Z_UNICODE_RUNNING_SHIRT_WITH_SASH							 0x1F3BD
#define Z_UNICODE_TENNIS_RACQUET_AND_BALL							 0x1F3BE
#define Z_UNICODE_SKI_AND_SKI_BOOT								 0x1F3BF
#define Z_UNICODE_BASKETBALL_AND_HOOP								 0x1F3C0
#define Z_UNICODE_CHEQUERED_FLAG								 0x1F3C1
#define Z_UNICODE_SNOWBOARDER									 0x1F3C2
#define Z_UNICODE_RUNNER									 0x1F3C3
#define Z_UNICODE_SURFER									 0x1F3C4
#define Z_UNICODE_SPORTS_MEDAL									 0x1F3C5
#define Z_UNICODE_TROPHY									 0x1F3C6
#define Z_UNICODE_HORSE_RACING									 0x1F3C7
#define Z_UNICODE_AMERICAN_FOOTBALL								 0x1F3C8
#define Z_UNICODE_RUGBY_FOOTBALL								 0x1F3C9
#define Z_UNICODE_SWIMMER									 0x1F3CA
#define Z_UNICODE_WEIGHT_LIFTER									 0x1F3CB
#define Z_UNICODE_GOLFER									 0x1F3CC
#define Z_UNICODE_RACING_MOTORCYCLE								 0x1F3CD
#define Z_UNICODE_RACING_CAR									 0x1F3CE
#define Z_UNICODE_CRICKET_BAT_AND_BALL								 0x1F3CF
#define Z_UNICODE_VOLLEYBALL									 0x1F3D0
#define Z_UNICODE_FIELD_HOCKEY_STICK_AND_BALL							 0x1F3D1
#define Z_UNICODE_ICE_HOCKEY_STICK_AND_PUCK							 0x1F3D2
#define Z_UNICODE_TABLE_TENNIS_PADDLE_AND_BALL							 0x1F3D3
#define Z_UNICODE_SNOW_CAPPED_MOUNTAIN								 0x1F3D4
#define Z_UNICODE_CAMPING									 0x1F3D5
#define Z_UNICODE_BEACH_WITH_UMBRELLA								 0x1F3D6
#define Z_UNICODE_BUILDING_CONSTRUCTION								 0x1F3D7
#define Z_UNICODE_HOUSE_BUILDINGS								 0x1F3D8
#define Z_UNICODE_CITYSCAPE									 0x1F3D9
#define Z_UNICODE_DERELICT_HOUSE_BUILDING							 0x1F3DA
#define Z_UNICODE_CLASSICAL_BUILDING								 0x1F3DB
#define Z_UNICODE_DESERT									 0x1F3DC
#define Z_UNICODE_DESERT_ISLAND									 0x1F3DD
#define Z_UNICODE_NATIONAL_PARK									 0x1F3DE
#define Z_UNICODE_STADIUM									 0x1F3DF
#define Z_UNICODE_HOUSE_BUILDING								 0x1F3E0
#define Z_UNICODE_HOUSE_WITH_GARDEN								 0x1F3E1
#define Z_UNICODE_OFFICE_BUILDING								 0x1F3E2
#define Z_UNICODE_JAPANESE_POST_OFFICE								 0x1F3E3
#define Z_UNICODE_EUROPEAN_POST_OFFICE								 0x1F3E4
#define Z_UNICODE_HOSPITAL									 0x1F3E5
#define Z_UNICODE_BANK										 0x1F3E6
#define Z_UNICODE_AUTOMATED_TELLER_MACHINE							 0x1F3E7
#define Z_UNICODE_HOTEL										 0x1F3E8
#define Z_UNICODE_LOVE_HOTEL									 0x1F3E9
#define Z_UNICODE_CONVENIENCE_STORE								 0x1F3EA
#define Z_UNICODE_SCHOOL									 0x1F3EB
#define Z_UNICODE_DEPARTMENT_STORE								 0x1F3EC
#define Z_UNICODE_FACTORY									 0x1F3ED
#define Z_UNICODE_IZAKAYA_LANTERN								 0x1F3EE
#define Z_UNICODE_JAPANESE_CASTLE								 0x1F3EF
#define Z_UNICODE_EUROPEAN_CASTLE								 0x1F3F0
#define Z_UNICODE_WHITE_PENNANT									 0x1F3F1
#define Z_UNICODE_BLACK_PENNANT									 0x1F3F2
#define Z_UNICODE_WAVING_WHITE_FLAG								 0x1F3F3
#define Z_UNICODE_WAVING_BLACK_FLAG								 0x1F3F4
#define Z_UNICODE_ROSETTE									 0x1F3F5
#define Z_UNICODE_BLACK_ROSETTE									 0x1F3F6
#define Z_UNICODE_LABEL										 0x1F3F7
#define Z_UNICODE_BADMINTON_RACQUET_AND_SHUTTLECOCK						 0x1F3F8
#define Z_UNICODE_BOW_AND_ARROW									 0x1F3F9
#define Z_UNICODE_AMPHORA									 0x1F3FA
#define Z_UNICODE_EMOJI_MODIFIER_FITZPATRICK_TYPE_1_2						 0x1F3FB
#define Z_UNICODE_EMOJI_MODIFIER_FITZPATRICK_TYPE_3						 0x1F3FC
#define Z_UNICODE_EMOJI_MODIFIER_FITZPATRICK_TYPE_4						 0x1F3FD
#define Z_UNICODE_EMOJI_MODIFIER_FITZPATRICK_TYPE_5						 0x1F3FE
#define Z_UNICODE_EMOJI_MODIFIER_FITZPATRICK_TYPE_6						 0x1F3FF
#define Z_UNICODE_RAT										 0x1F400
#define Z_UNICODE_MOUSE										 0x1F401
#define Z_UNICODE_OX										 0x1F402
#define Z_UNICODE_WATER_BUFFALO									 0x1F403
#define Z_UNICODE_COW										 0x1F404
#define Z_UNICODE_TIGER										 0x1F405
#define Z_UNICODE_LEOPARD									 0x1F406
#define Z_UNICODE_RABBIT									 0x1F407
#define Z_UNICODE_CAT										 0x1F408
#define Z_UNICODE_DRAGON									 0x1F409
#define Z_UNICODE_CROCODILE									 0x1F40A
#define Z_UNICODE_WHALE										 0x1F40B
#define Z_UNICODE_SNAIL										 0x1F40C
#define Z_UNICODE_SNAKE										 0x1F40D
#define Z_UNICODE_HORSE										 0x1F40E
#define Z_UNICODE_RAM										 0x1F40F
#define Z_UNICODE_GOAT										 0x1F410
#define Z_UNICODE_SHEEP										 0x1F411
#define Z_UNICODE_MONKEY									 0x1F412
#define Z_UNICODE_ROOSTER									 0x1F413
#define Z_UNICODE_CHICKEN									 0x1F414
#define Z_UNICODE_DOG										 0x1F415
#define Z_UNICODE_PIG										 0x1F416
#define Z_UNICODE_BOAR										 0x1F417
#define Z_UNICODE_ELEPHANT									 0x1F418
#define Z_UNICODE_OCTOPUS									 0x1F419
#define Z_UNICODE_SPIRAL_SHELL									 0x1F41A
#define Z_UNICODE_BUG										 0x1F41B
#define Z_UNICODE_ANT										 0x1F41C
#define Z_UNICODE_HONEYBEE									 0x1F41D
#define Z_UNICODE_LADY_BEETLE									 0x1F41E
#define Z_UNICODE_FISH										 0x1F41F
#define Z_UNICODE_TROPICAL_FISH									 0x1F420
#define Z_UNICODE_BLOWFISH									 0x1F421
#define Z_UNICODE_TURTLE									 0x1F422
#define Z_UNICODE_HATCHING_CHICK								 0x1F423
#define Z_UNICODE_BABY_CHICK									 0x1F424
#define Z_UNICODE_FRONT_FACING_BABY_CHICK							 0x1F425
#define Z_UNICODE_BIRD										 0x1F426
#define Z_UNICODE_PENGUIN									 0x1F427
#define Z_UNICODE_KOALA										 0x1F428
#define Z_UNICODE_POODLE									 0x1F429
#define Z_UNICODE_DROMEDARY_CAMEL								 0x1F42A
#define Z_UNICODE_BACTRIAN_CAMEL								 0x1F42B
#define Z_UNICODE_DOLPHIN									 0x1F42C
#define Z_UNICODE_MOUSE_FACE									 0x1F42D
#define Z_UNICODE_COW_FACE									 0x1F42E
#define Z_UNICODE_TIGER_FACE									 0x1F42F
#define Z_UNICODE_RABBIT_FACE									 0x1F430
#define Z_UNICODE_CAT_FACE									 0x1F431
#define Z_UNICODE_DRAGON_FACE									 0x1F432
#define Z_UNICODE_SPOUTING_WHALE								 0x1F433
#define Z_UNICODE_HORSE_FACE									 0x1F434
#define Z_UNICODE_MONKEY_FACE									 0x1F435
#define Z_UNICODE_DOG_FACE									 0x1F436
#define Z_UNICODE_PIG_FACE									 0x1F437
#define Z_UNICODE_FROG_FACE									 0x1F438
#define Z_UNICODE_HAMSTER_FACE									 0x1F439
#define Z_UNICODE_WOLF_FACE									 0x1F43A
#define Z_UNICODE_BEAR_FACE									 0x1F43B
#define Z_UNICODE_PANDA_FACE									 0x1F43C
#define Z_UNICODE_PIG_NOSE									 0x1F43D
#define Z_UNICODE_PAW_PRINTS									 0x1F43E
#define Z_UNICODE_CHIPMUNK									 0x1F43F
#define Z_UNICODE_EYES										 0x1F440
#define Z_UNICODE_EYE										 0x1F441
#define Z_UNICODE_EAR										 0x1F442
#define Z_UNICODE_NOSE										 0x1F443
#define Z_UNICODE_MOUTH										 0x1F444
#define Z_UNICODE_TONGUE									 0x1F445
#define Z_UNICODE_WHITE_UP_POINTING_BACKHAND_INDEX						 0x1F446
#define Z_UNICODE_WHITE_DOWN_POINTING_BACKHAND_INDEX						 0x1F447
#define Z_UNICODE_WHITE_LEFT_POINTING_BACKHAND_INDEX						 0x1F448
#define Z_UNICODE_WHITE_RIGHT_POINTING_BACKHAND_INDEX						 0x1F449
#define Z_UNICODE_FISTED_HAND_SIGN								 0x1F44A
#define Z_UNICODE_WAVING_HAND_SIGN								 0x1F44B
#define Z_UNICODE_OK_HAND_SIGN									 0x1F44C
#define Z_UNICODE_THUMBS_UP_SIGN								 0x1F44D
#define Z_UNICODE_THUMBS_DOWN_SIGN								 0x1F44E
#define Z_UNICODE_CLAPPING_HANDS_SIGN								 0x1F44F
#define Z_UNICODE_OPEN_HANDS_SIGN								 0x1F450
#define Z_UNICODE_CROWN										 0x1F451
#define Z_UNICODE_WOMANS_HAT									 0x1F452
#define Z_UNICODE_EYEGLASSES									 0x1F453
#define Z_UNICODE_NECKTIE									 0x1F454
#define Z_UNICODE_T_SHIRT									 0x1F455
#define Z_UNICODE_JEANS										 0x1F456
#define Z_UNICODE_DRESS										 0x1F457
#define Z_UNICODE_KIMONO									 0x1F458
#define Z_UNICODE_BIKINI									 0x1F459
#define Z_UNICODE_WOMANS_CLOTHES								 0x1F45A
#define Z_UNICODE_PURSE										 0x1F45B
#define Z_UNICODE_HANDBAG									 0x1F45C
#define Z_UNICODE_POUCH										 0x1F45D
#define Z_UNICODE_MANS_SHOE									 0x1F45E
#define Z_UNICODE_ATHLETIC_SHOE									 0x1F45F
#define Z_UNICODE_HIGH_HEELED_SHOE								 0x1F460
#define Z_UNICODE_WOMANS_SANDAL									 0x1F461
#define Z_UNICODE_WOMANS_BOOTS									 0x1F462
#define Z_UNICODE_FOOTPRINTS									 0x1F463
#define Z_UNICODE_BUST_IN_SILHOUETTE								 0x1F464
#define Z_UNICODE_BUSTS_IN_SILHOUETTE								 0x1F465
#define Z_UNICODE_BOY										 0x1F466
#define Z_UNICODE_GIRL										 0x1F467
#define Z_UNICODE_MAN										 0x1F468
#define Z_UNICODE_WOMAN										 0x1F469
#define Z_UNICODE_FAMILY									 0x1F46A
#define Z_UNICODE_MAN_AND_WOMAN_HOLDING_HANDS							 0x1F46B
#define Z_UNICODE_TWO_MEN_HOLDING_HANDS								 0x1F46C
#define Z_UNICODE_TWO_WOMEN_HOLDING_HANDS							 0x1F46D
#define Z_UNICODE_POLICE_OFFICER								 0x1F46E
#define Z_UNICODE_WOMAN_WITH_BUNNY_EARS								 0x1F46F
#define Z_UNICODE_BRIDE_WITH_VEIL								 0x1F470
#define Z_UNICODE_PERSON_WITH_BLOND_HAIR							 0x1F471
#define Z_UNICODE_MAN_WITH_GUA_PI_MAO								 0x1F472
#define Z_UNICODE_MAN_WITH_TURBAN								 0x1F473
#define Z_UNICODE_OLDER_MAN									 0x1F474
#define Z_UNICODE_OLDER_WOMAN									 0x1F475
#define Z_UNICODE_BABY										 0x1F476
#define Z_UNICODE_CONSTRUCTION_WORKER								 0x1F477
#define Z_UNICODE_PRINCESS									 0x1F478
#define Z_UNICODE_JAPANESE_OGRE									 0x1F479
#define Z_UNICODE_JAPANESE_GOBLIN								 0x1F47A
#define Z_UNICODE_GHOST										 0x1F47B
#define Z_UNICODE_BABY_ANGEL									 0x1F47C
#define Z_UNICODE_EXTRATERRESTRIAL_ALIEN							 0x1F47D
#define Z_UNICODE_ALIEN_MONSTER									 0x1F47E
#define Z_UNICODE_IMP										 0x1F47F
#define Z_UNICODE_SKULL										 0x1F480
#define Z_UNICODE_INFORMATION_DESK_PERSON							 0x1F481
#define Z_UNICODE_GUARDSMAN									 0x1F482
#define Z_UNICODE_DANCER									 0x1F483
#define Z_UNICODE_LIPSTICK									 0x1F484
#define Z_UNICODE_NAIL_POLISH									 0x1F485
#define Z_UNICODE_FACE_MASSAGE									 0x1F486
#define Z_UNICODE_HAIRCUT									 0x1F487
#define Z_UNICODE_BARBER_POLE									 0x1F488
#define Z_UNICODE_SYRINGE									 0x1F489
#define Z_UNICODE_PILL										 0x1F48A
#define Z_UNICODE_KISS_MARK									 0x1F48B
#define Z_UNICODE_LOVE_LETTER									 0x1F48C
#define Z_UNICODE_RING										 0x1F48D
#define Z_UNICODE_GEM_STONE									 0x1F48E
#define Z_UNICODE_KISS										 0x1F48F
#define Z_UNICODE_BOUQUET									 0x1F490
#define Z_UNICODE_COUPLE_WITH_HEART								 0x1F491
#define Z_UNICODE_WEDDING									 0x1F492
#define Z_UNICODE_BEATING_HEART									 0x1F493
#define Z_UNICODE_BROKEN_HEART									 0x1F494
#define Z_UNICODE_TWO_HEARTS									 0x1F495
#define Z_UNICODE_SPARKLING_HEART								 0x1F496
#define Z_UNICODE_GROWING_HEART									 0x1F497
#define Z_UNICODE_HEART_WITH_ARROW								 0x1F498
#define Z_UNICODE_BLUE_HEART									 0x1F499
#define Z_UNICODE_GREEN_HEART									 0x1F49A
#define Z_UNICODE_YELLOW_HEART									 0x1F49B
#define Z_UNICODE_PURPLE_HEART									 0x1F49C
#define Z_UNICODE_HEART_WITH_RIBBON								 0x1F49D
#define Z_UNICODE_REVOLVING_HEARTS								 0x1F49E
#define Z_UNICODE_HEART_DECORATION								 0x1F49F
#define Z_UNICODE_DIAMOND_SHAPE_WITH_A_DOT_INSIDE						 0x1F4A0
#define Z_UNICODE_ELECTRIC_LIGHT_BULB								 0x1F4A1
#define Z_UNICODE_ANGER_SYMBOL									 0x1F4A2
#define Z_UNICODE_BOMB										 0x1F4A3
#define Z_UNICODE_SLEEPING_SYMBOL								 0x1F4A4
#define Z_UNICODE_COLLISION_SYMBOL								 0x1F4A5
#define Z_UNICODE_SPLASHING_SWEAT_SYMBOL							 0x1F4A6
#define Z_UNICODE_DROPLET									 0x1F4A7
#define Z_UNICODE_DASH_SYMBOL									 0x1F4A8
#define Z_UNICODE_PILE_OF_POO									 0x1F4A9
#define Z_UNICODE_FLEXED_BICEPS									 0x1F4AA
#define Z_UNICODE_DIZZY_SYMBOL									 0x1F4AB
#define Z_UNICODE_SPEECH_BALLOON								 0x1F4AC
#define Z_UNICODE_THOUGHT_BALLOON								 0x1F4AD
#define Z_UNICODE_WHITE_FLOWER									 0x1F4AE
#define Z_UNICODE_HUNDRED_POINTS_SYMBOL								 0x1F4AF
#define Z_UNICODE_MONEY_BAG									 0x1F4B0
#define Z_UNICODE_CURRENCY_EXCHANGE								 0x1F4B1
#define Z_UNICODE_HEAVY_DOLLAR_SIGN								 0x1F4B2
#define Z_UNICODE_CREDIT_CARD									 0x1F4B3
#define Z_UNICODE_BANKNOTE_WITH_YEN_SIGN							 0x1F4B4
#define Z_UNICODE_BANKNOTE_WITH_DOLLAR_SIGN							 0x1F4B5
#define Z_UNICODE_BANKNOTE_WITH_EURO_SIGN							 0x1F4B6
#define Z_UNICODE_BANKNOTE_WITH_POUND_SIGN							 0x1F4B7
#define Z_UNICODE_MONEY_WITH_WINGS								 0x1F4B8
#define Z_UNICODE_CHART_WITH_UPWARDS_TREND_AND_YEN_SIGN						 0x1F4B9
#define Z_UNICODE_SEAT										 0x1F4BA
#define Z_UNICODE_PERSONAL_COMPUTER								 0x1F4BB
#define Z_UNICODE_BRIEFCASE									 0x1F4BC
#define Z_UNICODE_MINIDISC									 0x1F4BD
#define Z_UNICODE_FLOPPY_DISK									 0x1F4BE
#define Z_UNICODE_OPTICAL_DISC									 0x1F4BF
#define Z_UNICODE_DVD										 0x1F4C0
#define Z_UNICODE_FILE_FOLDER									 0x1F4C1
#define Z_UNICODE_OPEN_FILE_FOLDER								 0x1F4C2
#define Z_UNICODE_PAGE_WITH_CURL								 0x1F4C3
#define Z_UNICODE_PAGE_FACING_UP								 0x1F4C4
#define Z_UNICODE_CALENDAR									 0x1F4C5
#define Z_UNICODE_TEAR_OFF_CALENDAR								 0x1F4C6
#define Z_UNICODE_CARD_INDEX									 0x1F4C7
#define Z_UNICODE_CHART_WITH_UPWARDS_TREND							 0x1F4C8
#define Z_UNICODE_CHART_WITH_DOWNWARDS_TREND							 0x1F4C9
#define Z_UNICODE_BAR_CHART									 0x1F4CA
#define Z_UNICODE_CLIPBOARD									 0x1F4CB
#define Z_UNICODE_PUSHPIN									 0x1F4CC
#define Z_UNICODE_ROUND_PUSHPIN									 0x1F4CD
#define Z_UNICODE_PAPERCLIP									 0x1F4CE
#define Z_UNICODE_STRAIGHT_RULER								 0x1F4CF
#define Z_UNICODE_TRIANGULAR_RULER								 0x1F4D0
#define Z_UNICODE_BOOKMARK_TABS									 0x1F4D1
#define Z_UNICODE_LEDGER									 0x1F4D2
#define Z_UNICODE_NOTEBOOK									 0x1F4D3
#define Z_UNICODE_NOTEBOOK_WITH_DECORATIVE_COVER						 0x1F4D4
#define Z_UNICODE_CLOSED_BOOK									 0x1F4D5
#define Z_UNICODE_OPEN_BOOK									 0x1F4D6
#define Z_UNICODE_GREEN_BOOK									 0x1F4D7
#define Z_UNICODE_BLUE_BOOK									 0x1F4D8
#define Z_UNICODE_ORANGE_BOOK									 0x1F4D9
#define Z_UNICODE_BOOKS										 0x1F4DA
#define Z_UNICODE_NAME_BADGE									 0x1F4DB
#define Z_UNICODE_SCROLL									 0x1F4DC
#define Z_UNICODE_MEMO										 0x1F4DD
#define Z_UNICODE_TELEPHONE_RECEIVER								 0x1F4DE
#define Z_UNICODE_PAGER										 0x1F4DF
#define Z_UNICODE_FAX_MACHINE									 0x1F4E0
#define Z_UNICODE_SATELLITE_ANTENNA								 0x1F4E1
#define Z_UNICODE_PUBLIC_ADDRESS_LOUDSPEAKER							 0x1F4E2
#define Z_UNICODE_CHEERING_MEGAPHONE								 0x1F4E3
#define Z_UNICODE_OUTBOX_TRAY									 0x1F4E4
#define Z_UNICODE_INBOX_TRAY									 0x1F4E5
#define Z_UNICODE_PACKAGE									 0x1F4E6
#define Z_UNICODE_E_MAIL_SYMBOL									 0x1F4E7
#define Z_UNICODE_INCOMING_ENVELOPE								 0x1F4E8
#define Z_UNICODE_ENVELOPE_WITH_DOWNWARDS_ARROW_ABOVE						 0x1F4E9
#define Z_UNICODE_CLOSED_MAILBOX_WITH_LOWERED_FLAG						 0x1F4EA
#define Z_UNICODE_CLOSED_MAILBOX_WITH_RAISED_FLAG						 0x1F4EB
#define Z_UNICODE_OPEN_MAILBOX_WITH_RAISED_FLAG							 0x1F4EC
#define Z_UNICODE_OPEN_MAILBOX_WITH_LOWERED_FLAG						 0x1F4ED
#define Z_UNICODE_POSTBOX									 0x1F4EE
#define Z_UNICODE_POSTAL_HORN									 0x1F4EF
#define Z_UNICODE_NEWSPAPER									 0x1F4F0
#define Z_UNICODE_MOBILE_PHONE									 0x1F4F1
#define Z_UNICODE_MOBILE_PHONE_WITH_RIGHTWARDS_ARROW_AT_LEFT					 0x1F4F2
#define Z_UNICODE_VIBRATION_MODE								 0x1F4F3
#define Z_UNICODE_MOBILE_PHONE_OFF								 0x1F4F4
#define Z_UNICODE_NO_MOBILE_PHONES								 0x1F4F5
#define Z_UNICODE_ANTENNA_WITH_BARS								 0x1F4F6
#define Z_UNICODE_CAMERA									 0x1F4F7
#define Z_UNICODE_CAMERA_WITH_FLASH								 0x1F4F8
#define Z_UNICODE_VIDEO_CAMERA									 0x1F4F9
#define Z_UNICODE_TELEVISION									 0x1F4FA
#define Z_UNICODE_RADIO										 0x1F4FB
#define Z_UNICODE_VIDEOCASSETTE									 0x1F4FC
#define Z_UNICODE_FILM_PROJECTOR								 0x1F4FD
#define Z_UNICODE_PORTABLE_STEREO								 0x1F4FE
#define Z_UNICODE_PRAYER_BEADS									 0x1F4FF
#define Z_UNICODE_TWISTED_RIGHTWARDS_ARROWS							 0x1F500
#define Z_UNICODE_CLOCKWISE_RIGHTWARDS_AND_LEFTWARDS_OPEN_CIRCLE_ARROWS				 0x1F501
#define Z_UNICODE_CLOCKWISE_RIGHTWARDS_AND_LEFTWARDS_OPEN_CIRCLE_ARROWS_WITH_CIRCLED_ONE_OVERLAY 0x1F502
#define Z_UNICODE_CLOCKWISE_DOWNWARDS_AND_UPWARDS_OPEN_CIRCLE_ARROWS				 0x1F503
#define Z_UNICODE_ANTICLOCKWISE_DOWNWARDS_AND_UPWARDS_OPEN_CIRCLE_ARROWS			 0x1F504
#define Z_UNICODE_LOW_BRIGHTNESS_SYMBOL								 0x1F505
#define Z_UNICODE_HIGH_BRIGHTNESS_SYMBOL							 0x1F506
#define Z_UNICODE_SPEAKER_WITH_CANCELLATION_STROKE						 0x1F507
#define Z_UNICODE_SPEAKER									 0x1F508
#define Z_UNICODE_SPEAKER_WITH_ONE_SOUND_WAVE							 0x1F509
#define Z_UNICODE_SPEAKER_WITH_THREE_SOUND_WAVES						 0x1F50A
#define Z_UNICODE_BATTERY									 0x1F50B
#define Z_UNICODE_ELECTRIC_PLUG									 0x1F50C
#define Z_UNICODE_LEFT_POINTING_MAGNIFYING_GLASS						 0x1F50D
#define Z_UNICODE_RIGHT_POINTING_MAGNIFYING_GLASS						 0x1F50E
#define Z_UNICODE_LOCK_WITH_INK_PEN								 0x1F50F
#define Z_UNICODE_CLOSED_LOCK_WITH_KEY								 0x1F510
#define Z_UNICODE_KEY										 0x1F511
#define Z_UNICODE_LOCK										 0x1F512
#define Z_UNICODE_OPEN_LOCK									 0x1F513
#define Z_UNICODE_BELL										 0x1F514
#define Z_UNICODE_BELL_WITH_CANCELLATION_STROKE							 0x1F515
#define Z_UNICODE_BOOKMARK									 0x1F516
#define Z_UNICODE_LINK_SYMBOL									 0x1F517
#define Z_UNICODE_RADIO_BUTTON									 0x1F518
#define Z_UNICODE_BACK_WITH_LEFTWARDS_ARROW_ABOVE						 0x1F519
#define Z_UNICODE_END_WITH_LEFTWARDS_ARROW_ABOVE						 0x1F51A
#define Z_UNICODE_ON_WITH_EXCLAMATION_MARK_WITH_LEFT_RIGHT_ARROW_ABOVE				 0x1F51B
#define Z_UNICODE_SOON_WITH_RIGHTWARDS_ARROW_ABOVE						 0x1F51C
#define Z_UNICODE_TOP_WITH_UPWARDS_ARROW_ABOVE							 0x1F51D
#define Z_UNICODE_NO_ONE_UNDER_EIGHTEEN_SYMBOL							 0x1F51E
#define Z_UNICODE_KEYCAP_TEN									 0x1F51F
#define Z_UNICODE_INPUT_SYMBOL_FOR_LATIN_CAPITAL_LETTERS					 0x1F520
#define Z_UNICODE_INPUT_SYMBOL_FOR_LATIN_SMALL_LETTERS						 0x1F521
#define Z_UNICODE_INPUT_SYMBOL_FOR_NUMBERS							 0x1F522
#define Z_UNICODE_INPUT_SYMBOL_FOR_SYMBOLS							 0x1F523
#define Z_UNICODE_INPUT_SYMBOL_FOR_LATIN_LETTERS						 0x1F524
#define Z_UNICODE_FIRE										 0x1F525
#define Z_UNICODE_ELECTRIC_TORCH								 0x1F526
#define Z_UNICODE_WRENCH									 0x1F527
#define Z_UNICODE_HAMMER									 0x1F528
#define Z_UNICODE_NUT_AND_BOLT									 0x1F529
#define Z_UNICODE_HOCHO										 0x1F52A
#define Z_UNICODE_PISTOL									 0x1F52B
#define Z_UNICODE_MICROSCOPE									 0x1F52C
#define Z_UNICODE_TELESCOPE									 0x1F52D
#define Z_UNICODE_CRYSTAL_BALL									 0x1F52E
#define Z_UNICODE_SIX_POINTED_STAR_WITH_MIDDLE_DOT						 0x1F52F
#define Z_UNICODE_JAPANESE_SYMBOL_FOR_BEGINNER							 0x1F530
#define Z_UNICODE_TRIDENT_EMBLEM								 0x1F531
#define Z_UNICODE_BLACK_SQUARE_BUTTON								 0x1F532
#define Z_UNICODE_WHITE_SQUARE_BUTTON								 0x1F533
#define Z_UNICODE_LARGE_RED_CIRCLE								 0x1F534
#define Z_UNICODE_LARGE_BLUE_CIRCLE								 0x1F535
#define Z_UNICODE_LARGE_ORANGE_DIAMOND								 0x1F536
#define Z_UNICODE_LARGE_BLUE_DIAMOND								 0x1F537
#define Z_UNICODE_SMALL_ORANGE_DIAMOND								 0x1F538
#define Z_UNICODE_SMALL_BLUE_DIAMOND								 0x1F539
#define Z_UNICODE_UP_POINTING_RED_TRIANGLE							 0x1F53A
#define Z_UNICODE_DOWN_POINTING_RED_TRIANGLE							 0x1F53B
#define Z_UNICODE_UP_POINTING_SMALL_RED_TRIANGLE						 0x1F53C
#define Z_UNICODE_DOWN_POINTING_SMALL_RED_TRIANGLE						 0x1F53D
#define Z_UNICODE_LOWER_RIGHT_SHADOWED_WHITE_CIRCLE						 0x1F53E
#define Z_UNICODE_UPPER_RIGHT_SHADOWED_WHITE_CIRCLE						 0x1F53F
#define Z_UNICODE_CIRCLED_CROSS_POMMEE								 0x1F540
#define Z_UNICODE_CROSS_POMMEE_WITH_HALF_CIRCLE_BELOW						 0x1F541
#define Z_UNICODE_CROSS_POMMEE									 0x1F542
#define Z_UNICODE_NOTCHED_LEFT_SEMICIRCLE_WITH_THREE_DOTS					 0x1F543
#define Z_UNICODE_NOTCHED_RIGHT_SEMICIRCLE_WITH_THREE_DOTS					 0x1F544
#define Z_UNICODE_SYMBOL_FOR_MARKS_CHAPTER							 0x1F545
#define Z_UNICODE_WHITE_LATIN_CROSS								 0x1F546
#define Z_UNICODE_HEAVY_LATIN_CROSS								 0x1F547
#define Z_UNICODE_CELTIC_CROSS									 0x1F548
#define Z_UNICODE_OM_SYMBOL									 0x1F549
#define Z_UNICODE_DOVE_OF_PEACE									 0x1F54A
#define Z_UNICODE_KAABA										 0x1F54B
#define Z_UNICODE_MOSQUE									 0x1F54C
#define Z_UNICODE_SYNAGOGUE									 0x1F54D
#define Z_UNICODE_MENORAH_WITH_NINE_BRANCHES							 0x1F54E
#define Z_UNICODE_BOWL_OF_HYGIEIA								 0x1F54F
#define Z_UNICODE_CLOCK_FACE_ONE_OCLOCK								 0x1F550
#define Z_UNICODE_CLOCK_FACE_TWO_OCLOCK								 0x1F551
#define Z_UNICODE_CLOCK_FACE_THREE_OCLOCK							 0x1F552
#define Z_UNICODE_CLOCK_FACE_FOUR_OCLOCK							 0x1F553
#define Z_UNICODE_CLOCK_FACE_FIVE_OCLOCK							 0x1F554
#define Z_UNICODE_CLOCK_FACE_SIX_OCLOCK								 0x1F555
#define Z_UNICODE_CLOCK_FACE_SEVEN_OCLOCK							 0x1F556
#define Z_UNICODE_CLOCK_FACE_EIGHT_OCLOCK							 0x1F557
#define Z_UNICODE_CLOCK_FACE_NINE_OCLOCK							 0x1F558
#define Z_UNICODE_CLOCK_FACE_TEN_OCLOCK								 0x1F559
#define Z_UNICODE_CLOCK_FACE_ELEVEN_OCLOCK							 0x1F55A
#define Z_UNICODE_CLOCK_FACE_TWELVE_OCLOCK							 0x1F55B
#define Z_UNICODE_CLOCK_FACE_ONE_THIRTY								 0x1F55C
#define Z_UNICODE_CLOCK_FACE_TWO_THIRTY								 0x1F55D
#define Z_UNICODE_CLOCK_FACE_THREE_THIRTY							 0x1F55E
#define Z_UNICODE_CLOCK_FACE_FOUR_THIRTY							 0x1F55F
#define Z_UNICODE_CLOCK_FACE_FIVE_THIRTY							 0x1F560
#define Z_UNICODE_CLOCK_FACE_SIX_THIRTY								 0x1F561
#define Z_UNICODE_CLOCK_FACE_SEVEN_THIRTY							 0x1F562
#define Z_UNICODE_CLOCK_FACE_EIGHT_THIRTY							 0x1F563
#define Z_UNICODE_CLOCK_FACE_NINE_THIRTY							 0x1F564
#define Z_UNICODE_CLOCK_FACE_TEN_THIRTY								 0x1F565
#define Z_UNICODE_CLOCK_FACE_ELEVEN_THIRTY							 0x1F566
#define Z_UNICODE_CLOCK_FACE_TWELVE_THIRTY							 0x1F567
#define Z_UNICODE_RIGHT_SPEAKER									 0x1F568
#define Z_UNICODE_RIGHT_SPEAKER_WITH_ONE_SOUND_WAVE						 0x1F569
#define Z_UNICODE_RIGHT_SPEAKER_WITH_THREE_SOUND_WAVES						 0x1F56A
#define Z_UNICODE_BULLHORN									 0x1F56B
#define Z_UNICODE_BULLHORN_WITH_SOUND_WAVES							 0x1F56C
#define Z_UNICODE_RINGING_BELL									 0x1F56D
#define Z_UNICODE_BOOK										 0x1F56E
#define Z_UNICODE_CANDLE									 0x1F56F
#define Z_UNICODE_MANTELPIECE_CLOCK								 0x1F570
#define Z_UNICODE_BLACK_SKULL_AND_CROSSBONES							 0x1F571
#define Z_UNICODE_NO_PIRACY									 0x1F572
#define Z_UNICODE_HOLE										 0x1F573
#define Z_UNICODE_MAN_IN_BUSINESS_SUIT_LEVITATING						 0x1F574
#define Z_UNICODE_SLEUTH_OR_SPY									 0x1F575
#define Z_UNICODE_DARK_SUNGLASSES								 0x1F576
#define Z_UNICODE_SPIDER									 0x1F577
#define Z_UNICODE_SPIDER_WEB									 0x1F578
#define Z_UNICODE_JOYSTICK									 0x1F579
#define Z_UNICODE_LEFT_HAND_TELEPHONE_RECEIVER							 0x1F57B
#define Z_UNICODE_TELEPHONE_RECEIVER_WITH_PAGE							 0x1F57C
#define Z_UNICODE_RIGHT_HAND_TELEPHONE_RECEIVER							 0x1F57D
#define Z_UNICODE_WHITE_TOUCHTONE_TELEPHONE							 0x1F57E
#define Z_UNICODE_BLACK_TOUCHTONE_TELEPHONE							 0x1F57F
#define Z_UNICODE_TELEPHONE_ON_TOP_OF_MODEM							 0x1F580
#define Z_UNICODE_CLAMSHELL_MOBILE_PHONE							 0x1F581
#define Z_UNICODE_BACK_OF_ENVELOPE								 0x1F582
#define Z_UNICODE_STAMPED_ENVELOPE								 0x1F583
#define Z_UNICODE_ENVELOPE_WITH_LIGHTNING							 0x1F584
#define Z_UNICODE_FLYING_ENVELOPE								 0x1F585
#define Z_UNICODE_PEN_OVER_STAMPED_ENVELOPE							 0x1F586
#define Z_UNICODE_LINKED_PAPERCLIPS								 0x1F587
#define Z_UNICODE_BLACK_PUSHPIN									 0x1F588
#define Z_UNICODE_LOWER_LEFT_PENCIL								 0x1F589
#define Z_UNICODE_LOWER_LEFT_BALLPOINT_PEN							 0x1F58A
#define Z_UNICODE_LOWER_LEFT_FOUNTAIN_PEN							 0x1F58B
#define Z_UNICODE_LOWER_LEFT_PAINTBRUSH								 0x1F58C
#define Z_UNICODE_LOWER_LEFT_CRAYON								 0x1F58D
#define Z_UNICODE_LEFT_WRITING_HAND								 0x1F58E
#define Z_UNICODE_TURNED_OK_HAND_SIGN								 0x1F58F
#define Z_UNICODE_RAISED_HAND_WITH_FINGERS_SPLAYED						 0x1F590
#define Z_UNICODE_REVERSED_RAISED_HAND_WITH_FINGERS_SPLAYED					 0x1F591
#define Z_UNICODE_REVERSED_THUMBS_UP_SIGN							 0x1F592
#define Z_UNICODE_REVERSED_THUMBS_DOWN_SIGN							 0x1F593
#define Z_UNICODE_REVERSED_VICTORY_HAND								 0x1F594
#define Z_UNICODE_REVERSED_HAND_WITH_MIDDLE_FINGER_EXTENDED					 0x1F595
#define Z_UNICODE_RAISED_HAND_WITH_PART_BETWEEN_MIDDLE_AND_RING_FINGERS				 0x1F596
#define Z_UNICODE_WHITE_DOWN_POINTING_LEFT_HAND_INDEX						 0x1F597
#define Z_UNICODE_SIDEWAYS_WHITE_LEFT_POINTING_INDEX						 0x1F598
#define Z_UNICODE_SIDEWAYS_WHITE_RIGHT_POINTING_INDEX						 0x1F599
#define Z_UNICODE_SIDEWAYS_BLACK_LEFT_POINTING_INDEX						 0x1F59A
#define Z_UNICODE_SIDEWAYS_BLACK_RIGHT_POINTING_INDEX						 0x1F59B
#define Z_UNICODE_BLACK_LEFT_POINTING_BACKHAND_INDEX						 0x1F59C
#define Z_UNICODE_BLACK_RIGHT_POINTING_BACKHAND_INDEX						 0x1F59D
#define Z_UNICODE_SIDEWAYS_WHITE_UP_POINTING_INDEX						 0x1F59E
#define Z_UNICODE_SIDEWAYS_WHITE_DOWN_POINTING_INDEX						 0x1F59F
#define Z_UNICODE_SIDEWAYS_BLACK_UP_POINTING_INDEX						 0x1F5A0
#define Z_UNICODE_SIDEWAYS_BLACK_DOWN_POINTING_INDEX						 0x1F5A1
#define Z_UNICODE_BLACK_UP_POINTING_BACKHAND_INDEX						 0x1F5A2
#define Z_UNICODE_BLACK_DOWN_POINTING_BACKHAND_INDEX						 0x1F5A3
#define Z_UNICODE_DESKTOP_COMPUTER								 0x1F5A5
#define Z_UNICODE_KEYBOARD_AND_MOUSE								 0x1F5A6
#define Z_UNICODE_THREE_NETWORKED_COMPUTERS							 0x1F5A7
#define Z_UNICODE_PRINTER									 0x1F5A8
#define Z_UNICODE_POCKET_CALCULATOR								 0x1F5A9
#define Z_UNICODE_BLACK_HARD_SHELL_FLOPPY_DISK							 0x1F5AA
#define Z_UNICODE_WHITE_HARD_SHELL_FLOPPY_DISK							 0x1F5AB
#define Z_UNICODE_SOFT_SHELL_FLOPPY_DISK							 0x1F5AC
#define Z_UNICODE_TAPE_CARTRIDGE								 0x1F5AD
#define Z_UNICODE_WIRED_KEYBOARD								 0x1F5AE
#define Z_UNICODE_ONE_BUTTON_MOUSE								 0x1F5AF
#define Z_UNICODE_TWO_BUTTON_MOUSE								 0x1F5B0
#define Z_UNICODE_THREE_BUTTON_MOUSE								 0x1F5B1
#define Z_UNICODE_TRACKBALL									 0x1F5B2
#define Z_UNICODE_OLD_PERSONAL_COMPUTER								 0x1F5B3
#define Z_UNICODE_HARD_DISK									 0x1F5B4
#define Z_UNICODE_SCREEN									 0x1F5B5
#define Z_UNICODE_PRINTER_ICON									 0x1F5B6
#define Z_UNICODE_FAX_ICON									 0x1F5B7
#define Z_UNICODE_OPTICAL_DISC_ICON								 0x1F5B8
#define Z_UNICODE_DOCUMENT_WITH_TEXT								 0x1F5B9
#define Z_UNICODE_DOCUMENT_WITH_TEXT_AND_PICTURE						 0x1F5BA
#define Z_UNICODE_DOCUMENT_WITH_PICTURE								 0x1F5BB
#define Z_UNICODE_FRAME_WITH_PICTURE								 0x1F5BC
#define Z_UNICODE_FRAME_WITH_TILES								 0x1F5BD
#define Z_UNICODE_FRAME_WITH_AN_X								 0x1F5BE
#define Z_UNICODE_BLACK_FOLDER									 0x1F5BF
#define Z_UNICODE_FOLDER									 0x1F5C0
#define Z_UNICODE_OPEN_FOLDER									 0x1F5C1
#define Z_UNICODE_CARD_INDEX_DIVIDERS								 0x1F5C2
#define Z_UNICODE_CARD_FILE_BOX									 0x1F5C3
#define Z_UNICODE_FILE_CABINET									 0x1F5C4
#define Z_UNICODE_EMPTY_NOTE									 0x1F5C5
#define Z_UNICODE_EMPTY_NOTE_PAGE								 0x1F5C6
#define Z_UNICODE_EMPTY_NOTE_PAD								 0x1F5C7
#define Z_UNICODE_NOTE										 0x1F5C8
#define Z_UNICODE_NOTE_PAGE									 0x1F5C9
#define Z_UNICODE_NOTE_PAD									 0x1F5CA
#define Z_UNICODE_EMPTY_DOCUMENT								 0x1F5CB
#define Z_UNICODE_EMPTY_PAGE									 0x1F5CC
#define Z_UNICODE_EMPTY_PAGES									 0x1F5CD
#define Z_UNICODE_DOCUMENT									 0x1F5CE
#define Z_UNICODE_PAGE										 0x1F5CF
#define Z_UNICODE_PAGES										 0x1F5D0
#define Z_UNICODE_WASTEBASKET									 0x1F5D1
#define Z_UNICODE_SPIRAL_NOTE_PAD								 0x1F5D2
#define Z_UNICODE_SPIRAL_CALENDAR_PAD								 0x1F5D3
#define Z_UNICODE_DESKTOP_WINDOW								 0x1F5D4
#define Z_UNICODE_MINIMIZE									 0x1F5D5
#define Z_UNICODE_MAXIMIZE									 0x1F5D6
#define Z_UNICODE_OVERLAP									 0x1F5D7
#define Z_UNICODE_CLOCKWISE_RIGHT_AND_LEFT_SEMICIRCLE_ARROWS					 0x1F5D8
#define Z_UNICODE_CANCELLATION_X								 0x1F5D9
#define Z_UNICODE_INCREASE_FONT_SIZE_SYMBOL							 0x1F5DA
#define Z_UNICODE_DECREASE_FONT_SIZE_SYMBOL							 0x1F5DB
#define Z_UNICODE_COMPRESSION									 0x1F5DC
#define Z_UNICODE_OLD_KEY									 0x1F5DD
#define Z_UNICODE_ROLLED_UP_NEWSPAPER								 0x1F5DE
#define Z_UNICODE_PAGE_WITH_CIRCLED_TEXT							 0x1F5DF
#define Z_UNICODE_STOCK_CHART									 0x1F5E0
#define Z_UNICODE_DAGGER_KNIFE									 0x1F5E1
#define Z_UNICODE_LIPS										 0x1F5E2
#define Z_UNICODE_SPEAKING_HEAD_IN_SILHOUETTE							 0x1F5E3
#define Z_UNICODE_THREE_RAYS_ABOVE								 0x1F5E4
#define Z_UNICODE_THREE_RAYS_BELOW								 0x1F5E5
#define Z_UNICODE_THREE_RAYS_LEFT								 0x1F5E6
#define Z_UNICODE_THREE_RAYS_RIGHT								 0x1F5E7
#define Z_UNICODE_LEFT_SPEECH_BUBBLE								 0x1F5E8
#define Z_UNICODE_RIGHT_SPEECH_BUBBLE								 0x1F5E9
#define Z_UNICODE_TWO_SPEECH_BUBBLES								 0x1F5EA
#define Z_UNICODE_THREE_SPEECH_BUBBLES								 0x1F5EB
#define Z_UNICODE_LEFT_THOUGHT_BUBBLE								 0x1F5EC
#define Z_UNICODE_RIGHT_THOUGHT_BUBBLE								 0x1F5ED
#define Z_UNICODE_LEFT_ANGER_BUBBLE								 0x1F5EE
#define Z_UNICODE_RIGHT_ANGER_BUBBLE								 0x1F5EF
#define Z_UNICODE_MOOD_BUBBLE									 0x1F5F0
#define Z_UNICODE_LIGHTNING_MOOD_BUBBLE								 0x1F5F1
#define Z_UNICODE_LIGHTNING_MOOD								 0x1F5F2
#define Z_UNICODE_BALLOT_BOX_WITH_BALLOT							 0x1F5F3
#define Z_UNICODE_BALLOT_SCRIPT_X								 0x1F5F4
#define Z_UNICODE_BALLOT_BOX_WITH_SCRIPT_X							 0x1F5F5
#define Z_UNICODE_BALLOT_BOLD_SCRIPT_X								 0x1F5F6
#define Z_UNICODE_BALLOT_BOX_WITH_BOLD_SCRIPT_X							 0x1F5F7
#define Z_UNICODE_LIGHT_CHECK_MARK								 0x1F5F8
#define Z_UNICODE_BALLOT_BOX_WITH_BOLD_CHECK							 0x1F5F9
#define Z_UNICODE_WORLD_MAP									 0x1F5FA
#define Z_UNICODE_MOUNT_FUJI									 0x1F5FB
#define Z_UNICODE_TOKYO_TOWER									 0x1F5FC
#define Z_UNICODE_STATUE_OF_LIBERTY								 0x1F5FD
#define Z_UNICODE_SILHOUETTE_OF_JAPAN								 0x1F5FE
#define Z_UNICODE_MOYAI										 0x1F5FF

/* MARK: - 1F600h-1F64Fh - Emoticons */

#define Z_UNICODE_GRINNING_FACE					       0x1F600
#define Z_UNICODE_GRINNING_FACE_WITH_SMILING_EYES		       0x1F601
#define Z_UNICODE_FACE_WITH_TEARS_OF_JOY			       0x1F602
#define Z_UNICODE_SMILING_FACE_WITH_OPEN_MOUTH			       0x1F603
#define Z_UNICODE_SMILING_FACE_WITH_OPEN_MOUTH_AND_SMILING_EYES	       0x1F604
#define Z_UNICODE_SMILING_FACE_WITH_OPEN_MOUTH_AND_COLD_SWEAT	       0x1F605
#define Z_UNICODE_SMILING_FACE_WITH_OPEN_MOUTH_AND_TIGHTLY_CLOSED_EYES 0x1F606
#define Z_UNICODE_SMILING_FACE_WITH_HALO			       0x1F607
#define Z_UNICODE_SMILING_FACE_WITH_HORNS			       0x1F608
#define Z_UNICODE_WINKING_FACE					       0x1F609
#define Z_UNICODE_SMILING_FACE_WITH_SMILING_EYES		       0x1F60A
#define Z_UNICODE_FACE_SAVOURING_DELICIOUS_FOOD			       0x1F60B
#define Z_UNICODE_RELIEVED_FACE					       0x1F60C
#define Z_UNICODE_SMILING_FACE_WITH_HEART_SHAPED_EYES		       0x1F60D
#define Z_UNICODE_SMILING_FACE_WITH_SUNGLASSES			       0x1F60E
#define Z_UNICODE_SMIRKING_FACE					       0x1F60F
#define Z_UNICODE_NEUTRAL_FACE					       0x1F610
#define Z_UNICODE_EXPRESSIONLESS_FACE				       0x1F611
#define Z_UNICODE_UNAMUSED_FACE					       0x1F612
#define Z_UNICODE_FACE_WITH_COLD_SWEAT				       0x1F613
#define Z_UNICODE_PENSIVE_FACE					       0x1F614
#define Z_UNICODE_CONFUSED_FACE					       0x1F615
#define Z_UNICODE_CONFOUNDED_FACE				       0x1F616
#define Z_UNICODE_KISSING_FACE					       0x1F617
#define Z_UNICODE_FACE_THROWING_A_KISS				       0x1F618
#define Z_UNICODE_KISSING_FACE_WITH_SMILING_EYES		       0x1F619
#define Z_UNICODE_KISSING_FACE_WITH_CLOSED_EYES			       0x1F61A
#define Z_UNICODE_FACE_WITH_STUCK_OUT_TONGUE			       0x1F61B
#define Z_UNICODE_FACE_WITH_STUCK_OUT_TONGUE_AND_WINKING_EYE	       0x1F61C
#define Z_UNICODE_FACE_WITH_STUCK_OUT_TONGUE_AND_TIGHTLY_CLOSED_EYES   0x1F61D
#define Z_UNICODE_DISAPPOINTED_FACE				       0x1F61E
#define Z_UNICODE_WORRIED_FACE					       0x1F61F
#define Z_UNICODE_ANGRY_FACE					       0x1F620
#define Z_UNICODE_POUTING_FACE					       0x1F621
#define Z_UNICODE_CRYING_FACE					       0x1F622
#define Z_UNICODE_PERSEVERING_FACE				       0x1F623
#define Z_UNICODE_FACE_WITH_LOOK_OF_TRIUMPH			       0x1F624
#define Z_UNICODE_DISAPPOINTED_BUT_RELIEVED_FACE		       0x1F625
#define Z_UNICODE_FROWNING_FACE_WITH_OPEN_MOUTH			       0x1F626
#define Z_UNICODE_ANGUISHED_FACE				       0x1F627
#define Z_UNICODE_FEARFUL_FACE					       0x1F628
#define Z_UNICODE_WEARY_FACE					       0x1F629
#define Z_UNICODE_SLEEPY_FACE					       0x1F62A
#define Z_UNICODE_TIRED_FACE					       0x1F62B
#define Z_UNICODE_GRIMACING_FACE				       0x1F62C
#define Z_UNICODE_LOUDLY_CRYING_FACE				       0x1F62D
#define Z_UNICODE_FACE_WITH_OPEN_MOUTH				       0x1F62E
#define Z_UNICODE_HUSHED_FACE					       0x1F62F
#define Z_UNICODE_FACE_WITH_OPEN_MOUTH_AND_COLD_SWEAT		       0x1F630
#define Z_UNICODE_FACE_SCREAMING_IN_FEAR			       0x1F631
#define Z_UNICODE_ASTONISHED_FACE				       0x1F632
#define Z_UNICODE_FLUSHED_FACE					       0x1F633
#define Z_UNICODE_SLEEPING_FACE					       0x1F634
#define Z_UNICODE_DIZZY_FACE					       0x1F635
#define Z_UNICODE_FACE_WITHOUT_MOUTH				       0x1F636
#define Z_UNICODE_FACE_WITH_MEDICAL_MASK			       0x1F637
#define Z_UNICODE_GRINNING_CAT_FACE_WITH_SMILING_EYES		       0x1F638
#define Z_UNICODE_CAT_FACE_WITH_TEARS_OF_JOY			       0x1F639
#define Z_UNICODE_SMILING_CAT_FACE_WITH_OPEN_MOUTH		       0x1F63A
#define Z_UNICODE_SMILING_CAT_FACE_WITH_HEART_SHAPED_EYES	       0x1F63B
#define Z_UNICODE_CAT_FACE_WITH_WRY_SMILE			       0x1F63C
#define Z_UNICODE_KISSING_CAT_FACE_WITH_CLOSED_EYES		       0x1F63D
#define Z_UNICODE_POUTING_CAT_FACE				       0x1F63E
#define Z_UNICODE_CRYING_CAT_FACE				       0x1F63F
#define Z_UNICODE_WEARY_CAT_FACE				       0x1F640
#define Z_UNICODE_SLIGHTLY_FROWNING_FACE			       0x1F641
#define Z_UNICODE_SLIGHTLY_SMILING_FACE				       0x1F642
#define Z_UNICODE_UPSIDE_DOWN_FACE				       0x1F643
#define Z_UNICODE_FACE_WITH_ROLLING_EYES			       0x1F644
#define Z_UNICODE_FACE_WITH_NO_GOOD_GESTURE			       0x1F645
#define Z_UNICODE_FACE_WITH_OK_GESTURE				       0x1F646
#define Z_UNICODE_PERSON_BOWING_DEEPLY				       0x1F647
#define Z_UNICODE_SEE_NO_EVIL_MONKEY				       0x1F648
#define Z_UNICODE_HEAR_NO_EVIL_MONKEY				       0x1F649
#define Z_UNICODE_SPEAK_NO_EVIL_MONKEY				       0x1F64A
#define Z_UNICODE_HAPPY_PERSON_RAISING_ONE_HAND			       0x1F64B
#define Z_UNICODE_PERSON_RAISING_BOTH_HANDS_IN_CELEBRATION	       0x1F64C
#define Z_UNICODE_PERSON_FROWNING				       0x1F64D
#define Z_UNICODE_PERSON_WITH_POUTING_FACE			       0x1F64E
#define Z_UNICODE_PERSON_WITH_FOLDED_HANDS			       0x1F64F

/* MARK: - 1F650h-1F67Fh - Ornamental Dingbats */

#define Z_UNICODE_NORTH_WEST_POINTING_LEAF				       0x1F650
#define Z_UNICODE_SOUTH_WEST_POINTING_LEAF				       0x1F651
#define Z_UNICODE_NORTH_EAST_POINTING_LEAF				       0x1F652
#define Z_UNICODE_SOUTH_EAST_POINTING_LEAF				       0x1F653
#define Z_UNICODE_TURNED_NORTH_WEST_POINTING_LEAF			       0x1F654
#define Z_UNICODE_TURNED_SOUTH_WEST_POINTING_LEAF			       0x1F655
#define Z_UNICODE_TURNED_NORTH_EAST_POINTING_LEAF			       0x1F656
#define Z_UNICODE_TURNED_SOUTH_EAST_POINTING_LEAF			       0x1F657
#define Z_UNICODE_NORTH_WEST_POINTING_VINE_LEAF				       0x1F658
#define Z_UNICODE_SOUTH_WEST_POINTING_VINE_LEAF				       0x1F659
#define Z_UNICODE_NORTH_EAST_POINTING_VINE_LEAF				       0x1F65A
#define Z_UNICODE_SOUTH_EAST_POINTING_VINE_LEAF				       0x1F65B
#define Z_UNICODE_HEAVY_NORTH_WEST_POINTING_VINE_LEAF			       0x1F65C
#define Z_UNICODE_HEAVY_SOUTH_WEST_POINTING_VINE_LEAF			       0x1F65D
#define Z_UNICODE_HEAVY_NORTH_EAST_POINTING_VINE_LEAF			       0x1F65E
#define Z_UNICODE_HEAVY_SOUTH_EAST_POINTING_VINE_LEAF			       0x1F65F
#define Z_UNICODE_NORTH_WEST_POINTING_BUD				       0x1F660
#define Z_UNICODE_SOUTH_WEST_POINTING_BUD				       0x1F661
#define Z_UNICODE_NORTH_EAST_POINTING_BUD				       0x1F662
#define Z_UNICODE_SOUTH_EAST_POINTING_BUD				       0x1F663
#define Z_UNICODE_HEAVY_NORTH_WEST_POINTING_BUD				       0x1F664
#define Z_UNICODE_HEAVY_SOUTH_WEST_POINTING_BUD				       0x1F665
#define Z_UNICODE_HEAVY_NORTH_EAST_POINTING_BUD				       0x1F666
#define Z_UNICODE_HEAVY_SOUTH_EAST_POINTING_BUD				       0x1F667
#define Z_UNICODE_HOLLOW_QUILT_SQUARE_ORNAMENT				       0x1F668
#define Z_UNICODE_HOLLOW_QUILT_SQUARE_ORNAMENT_IN_BLACK_SQUARE		       0x1F669
#define Z_UNICODE_SOLID_QUILT_SQUARE_ORNAMENT				       0x1F66A
#define Z_UNICODE_SOLID_QUILT_SQUARE_ORNAMENT_IN_BLACK_SQUARE		       0x1F66B
#define Z_UNICODE_LEFTWARDS_ROCKET					       0x1F66C
#define Z_UNICODE_UPWARDS_ROCKET					       0x1F66D
#define Z_UNICODE_RIGHTWARDS_ROCKET					       0x1F66E
#define Z_UNICODE_DOWNWARDS_ROCKET					       0x1F66F
#define Z_UNICODE_SCRIPT_LIGATURE_ET_ORNAMENT				       0x1F670
#define Z_UNICODE_HEAVY_SCRIPT_LIGATURE_ET_ORNAMENT			       0x1F671
#define Z_UNICODE_LIGATURE_OPEN_ET_ORNAMENT				       0x1F672
#define Z_UNICODE_HEAVY_LIGATURE_OPEN_ET_ORNAMENT			       0x1F673
#define Z_UNICODE_HEAVY_AMPERSAND_ORNAMENT				       0x1F674
#define Z_UNICODE_SWASH_AMPERSAND_ORNAMENT				       0x1F675
#define Z_UNICODE_SANS_SERIF_HEAVY_DOUBLE_TURNED_COMMA_QUOTATION_MARK_ORNAMENT 0x1F676
#define Z_UNICODE_SANS_SERIF_HEAVY_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT	       0x1F677
#define Z_UNICODE_SANS_SERIF_HEAVY_LOW_DOUBLE_COMMA_QUOTATION_MARK_ORNAMENT    0x1F678
#define Z_UNICODE_HEAVY_INTERROBANG_ORNAMENT				       0x1F679
#define Z_UNICODE_SANS_SERIF_INTERROBANG_ORNAMENT			       0x1F67A
#define Z_UNICODE_HEAVY_SANS_SERIF_INTERROBANG_ORNAMENT			       0x1F67B
#define Z_UNICODE_VERY_HEAVY_SOLIDUS					       0x1F67C
#define Z_UNICODE_VERY_HEAVY_REVERSE_SOLIDUS				       0x1F67D
#define Z_UNICODE_CHECKER_BOARD						       0x1F67E
#define Z_UNICODE_REVERSE_CHECKER_BOARD					       0x1F67F

/* MARK: - 1F680h-1F6FFh - Transport and Map Symbols */

#define Z_UNICODE_ROCKET			    0x1F680
#define Z_UNICODE_HELICOPTER			    0x1F681
#define Z_UNICODE_STEAM_LOCOMOTIVE		    0x1F682
#define Z_UNICODE_RAILWAY_CAR			    0x1F683
#define Z_UNICODE_HIGH_SPEED_TRAIN		    0x1F684
#define Z_UNICODE_HIGH_SPEED_TRAIN_WITH_BULLET_NOSE 0x1F685
#define Z_UNICODE_TRAIN				    0x1F686
#define Z_UNICODE_METRO				    0x1F687
#define Z_UNICODE_LIGHT_RAIL			    0x1F688
#define Z_UNICODE_STATION			    0x1F689
#define Z_UNICODE_TRAM				    0x1F68A
#define Z_UNICODE_TRAM_CAR			    0x1F68B
#define Z_UNICODE_BUS				    0x1F68C
#define Z_UNICODE_ONCOMING_BUS			    0x1F68D
#define Z_UNICODE_TROLLEYBUS			    0x1F68E
#define Z_UNICODE_BUS_STOP			    0x1F68F
#define Z_UNICODE_MINIBUS			    0x1F690
#define Z_UNICODE_AMBULANCE			    0x1F691
#define Z_UNICODE_FIRE_ENGINE			    0x1F692
#define Z_UNICODE_POLICE_CAR			    0x1F693
#define Z_UNICODE_ONCOMING_POLICE_CAR		    0x1F694
#define Z_UNICODE_TAXI				    0x1F695
#define Z_UNICODE_ONCOMING_TAXI			    0x1F696
#define Z_UNICODE_AUTOMOBILE			    0x1F697
#define Z_UNICODE_ONCOMING_AUTOMOBILE		    0x1F698
#define Z_UNICODE_RECREATIONAL_VEHICLE		    0x1F699
#define Z_UNICODE_DELIVERY_TRUCK		    0x1F69A
#define Z_UNICODE_ARTICULATED_LORRY		    0x1F69B
#define Z_UNICODE_TRACTOR			    0x1F69C
#define Z_UNICODE_MONORAIL			    0x1F69D
#define Z_UNICODE_MOUNTAIN_RAILWAY		    0x1F69E
#define Z_UNICODE_SUSPENSION_RAILWAY		    0x1F69F
#define Z_UNICODE_MOUNTAIN_CABLEWAY		    0x1F6A0
#define Z_UNICODE_AERIAL_TRAMWAY		    0x1F6A1
#define Z_UNICODE_SHIP				    0x1F6A2
#define Z_UNICODE_ROWBOAT			    0x1F6A3
#define Z_UNICODE_SPEEDBOAT			    0x1F6A4
#define Z_UNICODE_HORIZONTAL_TRAFFIC_LIGHT	    0x1F6A5
#define Z_UNICODE_VERTICAL_TRAFFIC_LIGHT	    0x1F6A6
#define Z_UNICODE_CONSTRUCTION_SIGN		    0x1F6A7
#define Z_UNICODE_POLICE_CARS_REVOLVING_LIGHT	    0x1F6A8
#define Z_UNICODE_TRIANGULAR_FLAG_ON_POST	    0x1F6A9
#define Z_UNICODE_DOOR				    0x1F6AA
#define Z_UNICODE_NO_ENTRY_SIGN			    0x1F6AB
#define Z_UNICODE_SMOKING_SYMBOL		    0x1F6AC
#define Z_UNICODE_NO_SMOKING_SYMBOL		    0x1F6AD
#define Z_UNICODE_PUT_LITTER_IN_ITS_PLACE_SYMBOL    0x1F6AE
#define Z_UNICODE_DO_NOT_LITTER_SYMBOL		    0x1F6AF
#define Z_UNICODE_POTABLE_WATER_SYMBOL		    0x1F6B0
#define Z_UNICODE_NON_POTABLE_WATER_SYMBOL	    0x1F6B1
#define Z_UNICODE_BICYCLE			    0x1F6B2
#define Z_UNICODE_NO_BICYCLES			    0x1F6B3
#define Z_UNICODE_BICYCLIST			    0x1F6B4
#define Z_UNICODE_MOUNTAIN_BICYCLIST		    0x1F6B5
#define Z_UNICODE_PEDESTRIAN			    0x1F6B6
#define Z_UNICODE_NO_PEDESTRIANS		    0x1F6B7
#define Z_UNICODE_CHILDREN_CROSSING		    0x1F6B8
#define Z_UNICODE_MENS_SYMBOL			    0x1F6B9
#define Z_UNICODE_WOMENS_SYMBOL			    0x1F6BA
#define Z_UNICODE_RESTROOM			    0x1F6BB
#define Z_UNICODE_BABY_SYMBOL			    0x1F6BC
#define Z_UNICODE_TOILET			    0x1F6BD
#define Z_UNICODE_WATER_CLOSET			    0x1F6BE
#define Z_UNICODE_SHOWER			    0x1F6BF
#define Z_UNICODE_BATH				    0x1F6C0
#define Z_UNICODE_BATHTUB			    0x1F6C1
#define Z_UNICODE_PASSPORT_CONTROL		    0x1F6C2
#define Z_UNICODE_CUSTOMS			    0x1F6C3
#define Z_UNICODE_BAGGAGE_CLAIM			    0x1F6C4
#define Z_UNICODE_LEFT_LUGGAGE			    0x1F6C5
#define Z_UNICODE_TRIANGLE_WITH_ROUNDED_CORNERS	    0x1F6C6
#define Z_UNICODE_PROHIBITED_SIGN		    0x1F6C7
#define Z_UNICODE_CIRCLED_INFORMATION_SOURCE	    0x1F6C8
#define Z_UNICODE_BOYS_SYMBOL			    0x1F6C9
#define Z_UNICODE_GIRLS_SYMBOL			    0x1F6CA
#define Z_UNICODE_COUCH_AND_LAMP		    0x1F6CB
#define Z_UNICODE_SLEEPING_ACCOMMODATION	    0x1F6CC
#define Z_UNICODE_SHOPPING_BAGS			    0x1F6CD
#define Z_UNICODE_BELLHOP_BELL			    0x1F6CE
#define Z_UNICODE_BED				    0x1F6CF
#define Z_UNICODE_PLACE_OF_WORSHIP		    0x1F6D0
#define Z_UNICODE_HAMMER_AND_WRENCH		    0x1F6E0
#define Z_UNICODE_SHIELD			    0x1F6E1
#define Z_UNICODE_OIL_DRUM			    0x1F6E2
#define Z_UNICODE_MOTORWAY			    0x1F6E3
#define Z_UNICODE_RAILWAY_TRACK			    0x1F6E4
#define Z_UNICODE_MOTOR_BOAT			    0x1F6E5
#define Z_UNICODE_UP_POINTING_MILITARY_AIRPLANE	    0x1F6E6
#define Z_UNICODE_UP_POINTING_AIRPLANE		    0x1F6E7
#define Z_UNICODE_UP_POINTING_SMALL_AIRPLANE	    0x1F6E8
#define Z_UNICODE_SMALL_AIRPLANE		    0x1F6E9
#define Z_UNICODE_NORTHEAST_POINTING_AIRPLANE	    0x1F6EA
#define Z_UNICODE_AIRPLANE_DEPARTURE		    0x1F6EB
#define Z_UNICODE_AIRPLANE_ARRIVING		    0x1F6EC
#define Z_UNICODE_SATELLITE			    0x1F6F0
#define Z_UNICODE_ONCOMING_FIRE_ENGINE		    0x1F6F1
#define Z_UNICODE_DIESEL_LOCOMOTIVE		    0x1F6F2
#define Z_UNICODE_PASSENGER_SHIP		    0x1F6F3

/* MARK: - 1F700h-1F77Fh - Alchemical Symbols */

#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_QUINTESSENCE		      0x1F700
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_AIR			      0x1F701
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_FIRE			      0x1F702
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_EARTH			      0x1F703
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_WATER			      0x1F704
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_AQUAFORTIS		      0x1F705
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_AQUA_REGIA		      0x1F706
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_AQUA_REGIA_2		      0x1F707
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_AQUA_VITAE		      0x1F708
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_AQUA_VITAE_2		      0x1F709
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_VINEGAR			      0x1F70A
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_VINEGAR_2		      0x1F70B
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_VINEGAR_3		      0x1F70C
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SULFUR			      0x1F70D
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_PHILOSOPHERS_SULFUR	      0x1F70E
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_BLACK_SULFUR		      0x1F70F
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE	      0x1F710
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE_2	      0x1F711
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_MERCURY_SUBLIMATE_3	      0x1F712
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CINNABAR		      0x1F713
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SALT			      0x1F714
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_NITRE			      0x1F715
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_VITRIOL			      0x1F716
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_VITRIOL_2		      0x1F717
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ROCK_SALT		      0x1F718
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ROCK_SALT_2		      0x1F719
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_GOLD			      0x1F71A
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SILVER			      0x1F71B
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_IRON_ORE		      0x1F71C
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_IRON_ORE_2		      0x1F71D
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_IRON		      0x1F71E
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_IRON		      0x1F71F
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_COPPER_ORE		      0x1F720
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_IRON_COPPER_ORE		      0x1F721
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_COPPER	      0x1F722
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_COPPER	      0x1F723
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CROCUS_OF_COPPER_2	      0x1F724
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_COPPER_ANTIMONIATE	      0x1F725
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SALT_OF_COPPER_ANTIMONIATE    0x1F726
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_SALT_OF_COPPER   0x1F727
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_VERDIGRIS		      0x1F728
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_TIN_ORE			      0x1F729
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_LEAD_ORE		      0x1F72A
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ANTIMONY_ORE		      0x1F72B
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_ANTIMONY	      0x1F72C
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SALT_OF_ANTIMONY	      0x1F72D
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SUBLIMATE_OF_SALT_OF_ANTIMONY 0x1F72E
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_VINEGAR_OF_ANTIMONY	      0x1F72F
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_ANTIMONY	      0x1F730
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REGULUS_OF_ANTIMONY_2	      0x1F731
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REGULUS			      0x1F732
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REGULUS_2		      0x1F733
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REGULUS_3		      0x1F734
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REGULUS_4		      0x1F735
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ALKALI			      0x1F736
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ALKALI_2		      0x1F737
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_MARCASITE		      0x1F738
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SAL_AMMONIAC		      0x1F739
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ARSENIC			      0x1F73A
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REALGAR			      0x1F73B
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_REALGAR_2		      0x1F73C
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_AURIPIGMENT		      0x1F73D
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_BISMUTH_ORE		      0x1F73E
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_TARTAR			      0x1F73F
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_TARTAR_2		      0x1F740
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_QUICK_LIME		      0x1F741
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_BORAX			      0x1F742
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_BORAX_2			      0x1F743
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_BORAX_3			      0x1F744
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ALUM			      0x1F745
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_OIL			      0x1F746
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SPIRIT			      0x1F747
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_TINCTURE		      0x1F748
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_GUM			      0x1F749
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_WAX			      0x1F74A
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_POWDER			      0x1F74B
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CALX			      0x1F74C
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_TUTTY			      0x1F74D
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CAPUT_MORTUUM		      0x1F74E
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SCEPTER_OF_JOVE		      0x1F74F
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CADUCEUS		      0x1F750
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_TRIDENT			      0x1F751
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_STARRED_TRIDENT		      0x1F752
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_LODESTONE		      0x1F753
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SOAP			      0x1F754
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_URINE			      0x1F755
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_HORSE_DUNG		      0x1F756
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ASHES			      0x1F757
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_POT_ASHES		      0x1F758
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_BRICK			      0x1F759
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_POWDERED_BRICK		      0x1F75A
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_AMALGAM			      0x1F75B
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_STRATUM_SUPER_STRATUM	      0x1F75C
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_STRATUM_SUPER_STRATUM_2	      0x1F75D
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_SUBLIMATION		      0x1F75E
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_PRECIPITATE		      0x1F75F
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_DISTILL			      0x1F760
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_DISSOLVE		      0x1F761
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_DISSOLVE_2		      0x1F762
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_PURIFY			      0x1F763
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_PUTREFACTION		      0x1F764
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE		      0x1F765
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_2		      0x1F766
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_3		      0x1F767
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_4		      0x1F768
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_CRUCIBLE_5		      0x1F769
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_ALEMBIC			      0x1F76A
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_BATH_OF_MARY		      0x1F76B
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_BATH_OF_VAPOURS		      0x1F76C
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_RETORT			      0x1F76D
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_HOUR			      0x1F76E
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_NIGHT			      0x1F76F
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_DAY_NIGHT		      0x1F770
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_MONTH			      0x1F771
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_HALF_DRAM		      0x1F772
#define Z_UNICODE_ALCHEMICAL_SYMBOL_FOR_HALF_OUNCE		      0x1F773

/* MARK: - 1F780h-1F7FFh - Geometric Shapes Extended */

#define Z_UNICODE_BLACK_LEFT_POINTING_ISOSCELES_RIGHT_TRIANGLE	    0x1F780
#define Z_UNICODE_BLACK_UP_POINTING_ISOSCELES_RIGHT_TRIANGLE	    0x1F781
#define Z_UNICODE_BLACK_RIGHT_POINTING_ISOSCELES_RIGHT_TRIANGLE	    0x1F782
#define Z_UNICODE_BLACK_DOWN_POINTING_ISOSCELES_RIGHT_TRIANGLE	    0x1F783
#define Z_UNICODE_BLACK_SLIGHTLY_SMALL_CIRCLE			    0x1F784
#define Z_UNICODE_MEDIUM_BOLD_WHITE_CIRCLE			    0x1F785
#define Z_UNICODE_BOLD_WHITE_CIRCLE				    0x1F786
#define Z_UNICODE_HEAVY_WHITE_CIRCLE				    0x1F787
#define Z_UNICODE_VERY_HEAVY_WHITE_CIRCLE			    0x1F788
#define Z_UNICODE_EXTREMELY_HEAVY_WHITE_CIRCLE			    0x1F789
#define Z_UNICODE_WHITE_CIRCLE_CONTAINING_BLACK_SMALL_CIRCLE	    0x1F78A
#define Z_UNICODE_ROUND_TARGET					    0x1F78B
#define Z_UNICODE_BLACK_TINY_SQUARE				    0x1F78C
#define Z_UNICODE_BLACK_SLIGHTLY_SMALL_SQUARE			    0x1F78D
#define Z_UNICODE_LIGHT_WHITE_SQUARE				    0x1F78E
#define Z_UNICODE_MEDIUM_WHITE_SQUARE				    0x1F78F
#define Z_UNICODE_BOLD_WHITE_SQUARE				    0x1F790
#define Z_UNICODE_HEAVY_WHITE_SQUARE				    0x1F791
#define Z_UNICODE_VERY_HEAVY_WHITE_SQUARE			    0x1F792
#define Z_UNICODE_EXTREMELY_HEAVY_WHITE_SQUARE			    0x1F793
#define Z_UNICODE_WHITE_SQUARE_CONTAINING_BLACK_VERY_SMALL_SQUARE   0x1F794
#define Z_UNICODE_WHITE_SQUARE_CONTAINING_BLACK_MEDIUM_SQUARE	    0x1F795
#define Z_UNICODE_SQUARE_TARGET					    0x1F796
#define Z_UNICODE_BLACK_TINY_DIAMOND				    0x1F797
#define Z_UNICODE_BLACK_VERY_SMALL_DIAMOND			    0x1F798
#define Z_UNICODE_BLACK_MEDIUM_SMALL_DIAMOND			    0x1F799
#define Z_UNICODE_WHITE_DIAMOND_CONTAINING_BLACK_VERY_SMALL_DIAMOND 0x1F79A
#define Z_UNICODE_WHITE_DIAMOND_CONTAINING_BLACK_MEDIUM_DIAMOND	    0x1F79B
#define Z_UNICODE_DIAMOND_TARGET				    0x1F79C
#define Z_UNICODE_BLACK_TINY_LOZENGE				    0x1F79D
#define Z_UNICODE_BLACK_VERY_SMALL_LOZENGE			    0x1F79E
#define Z_UNICODE_BLACK_MEDIUM_SMALL_LOZENGE			    0x1F79F
#define Z_UNICODE_WHITE_LOZENGE_CONTAINING_BLACK_SMALL_LOZENGE	    0x1F7A0
#define Z_UNICODE_THIN_GREEK_CROSS				    0x1F7A1
#define Z_UNICODE_LIGHT_GREEK_CROSS				    0x1F7A2
#define Z_UNICODE_MEDIUM_GREEK_CROSS				    0x1F7A3
#define Z_UNICODE_BOLD_GREEK_CROSS				    0x1F7A4
#define Z_UNICODE_VERY_BOLD_GREEK_CROSS				    0x1F7A5
#define Z_UNICODE_VERY_HEAVY_GREEK_CROSS			    0x1F7A6
#define Z_UNICODE_EXTREMELY_HEAVY_GREEK_CROSS			    0x1F7A7
#define Z_UNICODE_THIN_SALTIRE					    0x1F7A8
#define Z_UNICODE_LIGHT_SALTIRE					    0x1F7A9
#define Z_UNICODE_MEDIUM_SALTIRE				    0x1F7AA
#define Z_UNICODE_BOLD_SALTIRE					    0x1F7AB
#define Z_UNICODE_HEAVY_SALTIRE					    0x1F7AC
#define Z_UNICODE_VERY_HEAVY_SALTIRE				    0x1F7AD
#define Z_UNICODE_EXTREMELY_HEAVY_SALTIRE			    0x1F7AE
#define Z_UNICODE_LIGHT_FIVE_SPOKED_ASTERISK			    0x1F7AF
#define Z_UNICODE_MEDIUM_FIVE_SPOKED_ASTERISK			    0x1F7B0
#define Z_UNICODE_BOLD_FIVE_SPOKED_ASTERISK			    0x1F7B1
#define Z_UNICODE_HEAVY_FIVE_SPOKED_ASTERISK			    0x1F7B2
#define Z_UNICODE_VERY_HEAVY_FIVE_SPOKED_ASTERISK		    0x1F7B3
#define Z_UNICODE_EXTREMELY_HEAVY_FIVE_SPOKED_ASTERISK		    0x1F7B4
#define Z_UNICODE_LIGHT_SIX_SPOKED_ASTERISK			    0x1F7B5
#define Z_UNICODE_MEDIUM_SIX_SPOKED_ASTERISK			    0x1F7B6
#define Z_UNICODE_BOLD_SIX_SPOKED_ASTERISK			    0x1F7B7
#define Z_UNICODE_HEAVY_SIX_SPOKED_ASTERISK			    0x1F7B8
#define Z_UNICODE_VERY_HEAVY_SIX_SPOKED_ASTERISK		    0x1F7B9
#define Z_UNICODE_EXTREMELY_HEAVY_SIX_SPOKED_ASTERISK		    0x1F7BA
#define Z_UNICODE_LIGHT_EIGHT_SPOKED_ASTERISK			    0x1F7BB
#define Z_UNICODE_MEDIUM_EIGHT_SPOKED_ASTERISK			    0x1F7BC
#define Z_UNICODE_BOLD_EIGHT_SPOKED_ASTERISK			    0x1F7BD
#define Z_UNICODE_HEAVY_EIGHT_SPOKED_ASTERISK			    0x1F7BE
#define Z_UNICODE_VERY_HEAVY_EIGHT_SPOKED_ASTERISK		    0x1F7BF
#define Z_UNICODE_LIGHT_THREE_POINTED_BLACK_STAR		    0x1F7C0
#define Z_UNICODE_MEDIUM_THREE_POINTED_BLACK_STAR		    0x1F7C1
#define Z_UNICODE_THREE_POINTED_BLACK_STAR			    0x1F7C2
#define Z_UNICODE_MEDIUM_THREE_POINTED_PINWHEEL_STAR		    0x1F7C3
#define Z_UNICODE_LIGHT_FOUR_POINTED_BLACK_STAR			    0x1F7C4
#define Z_UNICODE_MEDIUM_FOUR_POINTED_BLACK_STAR		    0x1F7C5
#define Z_UNICODE_FOUR_POINTED_BLACK_STAR			    0x1F7C6
#define Z_UNICODE_MEDIUM_FOUR_POINTED_PINWHEEL_STAR		    0x1F7C7
#define Z_UNICODE_REVERSE_LIGHT_FOUR_POINTED_PINWHEEL_STAR	    0x1F7C8
#define Z_UNICODE_LIGHT_FIVE_POINTED_BLACK_STAR			    0x1F7C9
#define Z_UNICODE_HEAVY_FIVE_POINTED_BLACK_STAR			    0x1F7CA
#define Z_UNICODE_MEDIUM_SIX_POINTED_BLACK_STAR			    0x1F7CB
#define Z_UNICODE_HEAVY_SIX_POINTED_BLACK_STAR			    0x1F7CC
#define Z_UNICODE_SIX_POINTED_PINWHEEL_STAR			    0x1F7CD
#define Z_UNICODE_MEDIUM_EIGHT_POINTED_BLACK_STAR		    0x1F7CE
#define Z_UNICODE_HEAVY_EIGHT_POINTED_BLACK_STAR		    0x1F7CF
#define Z_UNICODE_VERY_HEAVY_EIGHT_POINTED_BLACK_STAR		    0x1F7D0
#define Z_UNICODE_HEAVY_EIGHT_POINTED_PINWHEEL_STAR		    0x1F7D1
#define Z_UNICODE_LIGHT_TWELVE_POINTED_BLACK_STAR		    0x1F7D2
#define Z_UNICODE_HEAVY_TWELVE_POINTED_BLACK_STAR		    0x1F7D3
#define Z_UNICODE_HEAVY_TWELVE_POINTED_PINWHEEL_STAR		    0x1F7D4

/* MARK: - 1F800h-1F8FFh - Supplemental Arrows-C */

#define Z_UNICODE_LEFTWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD		  0x1F800
#define Z_UNICODE_UPWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD		  0x1F801
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD	  0x1F802
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_SMALL_TRIANGLE_ARROWHEAD		  0x1F803
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD	  0x1F804
#define Z_UNICODE_UPWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD		  0x1F805
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD	  0x1F806
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_MEDIUM_TRIANGLE_ARROWHEAD	  0x1F807
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD		  0x1F808
#define Z_UNICODE_UPWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD		  0x1F809
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD	  0x1F80A
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_LARGE_TRIANGLE_ARROWHEAD		  0x1F80B
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD	  0x1F810
#define Z_UNICODE_UPWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD	  0x1F811
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD	  0x1F812
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_SMALL_EQUILATERAL_ARROWHEAD	  0x1F813
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD		  0x1F814
#define Z_UNICODE_UPWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD		  0x1F815
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD		  0x1F816
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD		  0x1F817
#define Z_UNICODE_HEAVY_LEFTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD	  0x1F818
#define Z_UNICODE_HEAVY_UPWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD	  0x1F819
#define Z_UNICODE_HEAVY_RIGHTWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD	  0x1F81A
#define Z_UNICODE_HEAVY_DOWNWARDS_ARROW_WITH_EQUILATERAL_ARROWHEAD	  0x1F81B
#define Z_UNICODE_HEAVY_LEFTWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD  0x1F81C
#define Z_UNICODE_HEAVY_UPWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD	  0x1F81D
#define Z_UNICODE_HEAVY_RIGHTWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD 0x1F81E
#define Z_UNICODE_HEAVY_DOWNWARDS_ARROW_WITH_LARGE_EQUILATERAL_ARROWHEAD  0x1F81F
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT	  0x1F820
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT	  0x1F821
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT	  0x1F822
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_NARROW_SHAFT	  0x1F823
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT	  0x1F824
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT	  0x1F825
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT	  0x1F826
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_MEDIUM_SHAFT	  0x1F827
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT	  0x1F828
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT		  0x1F829
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT	  0x1F82A
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_BOLD_SHAFT	  0x1F82B
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT	  0x1F82C
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT	  0x1F82D
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT	  0x1F82E
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_HEAVY_SHAFT	  0x1F82F
#define Z_UNICODE_LEFTWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT	  0x1F830
#define Z_UNICODE_UPWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT	  0x1F831
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT  0x1F832
#define Z_UNICODE_DOWNWARDS_TRIANGLE_HEADED_ARROW_WITH_VERY_HEAVY_SHAFT	  0x1F833
#define Z_UNICODE_LEFTWARDS_FINGER_POST_ARROW				  0x1F834
#define Z_UNICODE_UPWARDS_FINGER_POST_ARROW				  0x1F835
#define Z_UNICODE_RIGHTWARDS_FINGER_POST_ARROW				  0x1F836
#define Z_UNICODE_DOWNWARDS_FINGER_POST_ARROW				  0x1F837
#define Z_UNICODE_LEFTWARDS_SQUARED_ARROW				  0x1F838
#define Z_UNICODE_UPWARDS_SQUARED_ARROW					  0x1F839
#define Z_UNICODE_RIGHTWARDS_SQUARED_ARROW				  0x1F83A
#define Z_UNICODE_DOWNWARDS_SQUARED_ARROW				  0x1F83B
#define Z_UNICODE_LEFTWARDS_COMPRESSED_ARROW				  0x1F83C
#define Z_UNICODE_UPWARDS_COMPRESSED_ARROW				  0x1F83D
#define Z_UNICODE_RIGHTWARDS_COMPRESSED_ARROW				  0x1F83E
#define Z_UNICODE_DOWNWARDS_COMPRESSED_ARROW				  0x1F83F
#define Z_UNICODE_LEFTWARDS_HEAVY_COMPRESSED_ARROW			  0x1F840
#define Z_UNICODE_UPWARDS_HEAVY_COMPRESSED_ARROW			  0x1F841
#define Z_UNICODE_RIGHTWARDS_HEAVY_COMPRESSED_ARROW			  0x1F842
#define Z_UNICODE_DOWNWARDS_HEAVY_COMPRESSED_ARROW			  0x1F843
#define Z_UNICODE_LEFTWARDS_HEAVY_ARROW					  0x1F844
#define Z_UNICODE_UPWARDS_HEAVY_ARROW					  0x1F845
#define Z_UNICODE_RIGHTWARDS_HEAVY_ARROW				  0x1F846
#define Z_UNICODE_DOWNWARDS_HEAVY_ARROW					  0x1F847
#define Z_UNICODE_LEFTWARDS_SANS_SERIF_ARROW				  0x1F850
#define Z_UNICODE_UPWARDS_SANS_SERIF_ARROW				  0x1F851
#define Z_UNICODE_RIGHTWARDS_SANS_SERIF_ARROW				  0x1F852
#define Z_UNICODE_DOWNWARDS_SANS_SERIF_ARROW				  0x1F853
#define Z_UNICODE_NORTH_WEST_SANS_SERIF_ARROW				  0x1F854
#define Z_UNICODE_NORTH_EAST_SANS_SERIF_ARROW				  0x1F855
#define Z_UNICODE_SOUTH_EAST_SANS_SERIF_ARROW				  0x1F856
#define Z_UNICODE_SOUTH_WEST_SANS_SERIF_ARROW				  0x1F857
#define Z_UNICODE_LEFT_RIGHT_SANS_SERIF_ARROW				  0x1F858
#define Z_UNICODE_UP_DOWN_SANS_SERIF_ARROW				  0x1F859
#define Z_UNICODE_WIDE_HEADED_LEFTWARDS_LIGHT_BARB_ARROW		  0x1F860
#define Z_UNICODE_WIDE_HEADED_UPWARDS_LIGHT_BARB_ARROW			  0x1F861
#define Z_UNICODE_WIDE_HEADED_RIGHTWARDS_LIGHT_BARB_ARROW		  0x1F862
#define Z_UNICODE_WIDE_HEADED_DOWNWARDS_LIGHT_BARB_ARROW		  0x1F863
#define Z_UNICODE_WIDE_HEADED_NORTH_WEST_LIGHT_BARB_ARROW		  0x1F864
#define Z_UNICODE_WIDE_HEADED_NORTH_EAST_LIGHT_BARB_ARROW		  0x1F865
#define Z_UNICODE_WIDE_HEADED_SOUTH_EAST_LIGHT_BARB_ARROW		  0x1F866
#define Z_UNICODE_WIDE_HEADED_SOUTH_WEST_LIGHT_BARB_ARROW		  0x1F867
#define Z_UNICODE_WIDE_HEADED_LEFTWARDS_BARB_ARROW			  0x1F868
#define Z_UNICODE_WIDE_HEADED_UPWARDS_BARB_ARROW			  0x1F869
#define Z_UNICODE_WIDE_HEADED_RIGHTWARDS_BARB_ARROW			  0x1F86A
#define Z_UNICODE_WIDE_HEADED_DOWNWARDS_BARB_ARROW			  0x1F86B
#define Z_UNICODE_WIDE_HEADED_NORTH_WEST_BARB_ARROW			  0x1F86C
#define Z_UNICODE_WIDE_HEADED_NORTH_EAST_BARB_ARROW			  0x1F86D
#define Z_UNICODE_WIDE_HEADED_SOUTH_EAST_BARB_ARROW			  0x1F86E
#define Z_UNICODE_WIDE_HEADED_SOUTH_WEST_BARB_ARROW			  0x1F86F
#define Z_UNICODE_WIDE_HEADED_LEFTWARDS_MEDIUM_BARB_ARROW		  0x1F870
#define Z_UNICODE_WIDE_HEADED_UPWARDS_MEDIUM_BARB_ARROW			  0x1F871
#define Z_UNICODE_WIDE_HEADED_RIGHTWARDS_MEDIUM_BARB_ARROW		  0x1F872
#define Z_UNICODE_WIDE_HEADED_DOWNWARDS_MEDIUM_BARB_ARROW		  0x1F873
#define Z_UNICODE_WIDE_HEADED_NORTH_WEST_MEDIUM_BARB_ARROW		  0x1F874
#define Z_UNICODE_WIDE_HEADED_NORTH_EAST_MEDIUM_BARB_ARROW		  0x1F875
#define Z_UNICODE_WIDE_HEADED_SOUTH_EAST_MEDIUM_BARB_ARROW		  0x1F876
#define Z_UNICODE_WIDE_HEADED_SOUTH_WEST_MEDIUM_BARB_ARROW		  0x1F877
#define Z_UNICODE_WIDE_HEADED_LEFTWARDS_HEAVY_BARB_ARROW		  0x1F878
#define Z_UNICODE_WIDE_HEADED_UPWARDS_HEAVY_BARB_ARROW			  0x1F879
#define Z_UNICODE_WIDE_HEADED_RIGHTWARDS_HEAVY_BARB_ARROW		  0x1F87A
#define Z_UNICODE_WIDE_HEADED_DOWNWARDS_HEAVY_BARB_ARROW		  0x1F87B
#define Z_UNICODE_WIDE_HEADED_NORTH_WEST_HEAVY_BARB_ARROW		  0x1F87C
#define Z_UNICODE_WIDE_HEADED_NORTH_EAST_HEAVY_BARB_ARROW		  0x1F87D
#define Z_UNICODE_WIDE_HEADED_SOUTH_EAST_HEAVY_BARB_ARROW		  0x1F87E
#define Z_UNICODE_WIDE_HEADED_SOUTH_WEST_HEAVY_BARB_ARROW		  0x1F87F
#define Z_UNICODE_WIDE_HEADED_LEFTWARDS_VERY_HEAVY_BARB_ARROW		  0x1F880
#define Z_UNICODE_WIDE_HEADED_UPWARDS_VERY_HEAVY_BARB_ARROW		  0x1F881
#define Z_UNICODE_WIDE_HEADED_RIGHTWARDS_VERY_HEAVY_BARB_ARROW		  0x1F882
#define Z_UNICODE_WIDE_HEADED_DOWNWARDS_VERY_HEAVY_BARB_ARROW		  0x1F883
#define Z_UNICODE_WIDE_HEADED_NORTH_WEST_VERY_HEAVY_BARB_ARROW		  0x1F884
#define Z_UNICODE_WIDE_HEADED_NORTH_EAST_VERY_HEAVY_BARB_ARROW		  0x1F885
#define Z_UNICODE_WIDE_HEADED_SOUTH_EAST_VERY_HEAVY_BARB_ARROW		  0x1F886
#define Z_UNICODE_WIDE_HEADED_SOUTH_WEST_VERY_HEAVY_BARB_ARROW		  0x1F887
#define Z_UNICODE_LEFTWARDS_TRIANGLE_ARROWHEAD				  0x1F890
#define Z_UNICODE_UPWARDS_TRIANGLE_ARROWHEAD				  0x1F891
#define Z_UNICODE_RIGHTWARDS_TRIANGLE_ARROWHEAD				  0x1F892
#define Z_UNICODE_DOWNWARDS_TRIANGLE_ARROWHEAD				  0x1F893
#define Z_UNICODE_LEFTWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD	  0x1F894
#define Z_UNICODE_UPWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD		  0x1F895
#define Z_UNICODE_RIGHTWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD	  0x1F896
#define Z_UNICODE_DOWNWARDS_WHITE_ARROW_WITHIN_TRIANGLE_ARROWHEAD	  0x1F897
#define Z_UNICODE_LEFTWARDS_ARROW_WITH_NOTCHED_TAIL			  0x1F898
#define Z_UNICODE_UPWARDS_ARROW_WITH_NOTCHED_TAIL			  0x1F899
#define Z_UNICODE_RIGHTWARDS_ARROW_WITH_NOTCHED_TAIL			  0x1F89A
#define Z_UNICODE_DOWNWARDS_ARROW_WITH_NOTCHED_TAIL			  0x1F89B
#define Z_UNICODE_HEAVY_ARROW_SHAFT_WIDTH_ONE				  0x1F89C
#define Z_UNICODE_HEAVY_ARROW_SHAFT_WIDTH_TWO_THIRDS			  0x1F89D
#define Z_UNICODE_HEAVY_ARROW_SHAFT_WIDTH_ONE_HALF			  0x1F89E
#define Z_UNICODE_HEAVY_ARROW_SHAFT_WIDTH_ONE_THIRD			  0x1F89F
#define Z_UNICODE_LEFTWARDS_BOTTOM_SHADED_WHITE_ARROW			  0x1F8A0
#define Z_UNICODE_RIGHTWARDS_BOTTOM_SHADED_WHITE_ARROW			  0x1F8A1
#define Z_UNICODE_LEFTWARDS_TOP_SHADED_WHITE_ARROW			  0x1F8A2
#define Z_UNICODE_RIGHTWARDS_TOP_SHADED_WHITE_ARROW			  0x1F8A3
#define Z_UNICODE_LEFTWARDS_LEFT_SHADED_WHITE_ARROW			  0x1F8A4
#define Z_UNICODE_RIGHTWARDS_RIGHT_SHADED_WHITE_ARROW			  0x1F8A5
#define Z_UNICODE_LEFTWARDS_RIGHT_SHADED_WHITE_ARROW			  0x1F8A6
#define Z_UNICODE_RIGHTWARDS_LEFT_SHADED_WHITE_ARROW			  0x1F8A7
#define Z_UNICODE_LEFTWARDS_BACK_TILTED_SHADOWED_WHITE_ARROW		  0x1F8A8
#define Z_UNICODE_RIGHTWARDS_BACK_TILTED_SHADOWED_WHITE_ARROW		  0x1F8A9
#define Z_UNICODE_LEFTWARDS_FRONT_TILTED_SHADOWED_WHITE_ARROW		  0x1F8AA
#define Z_UNICODE_RIGHTWARDS_FRONT_TILTED_SHADOWED_WHITE_ARROW		  0x1F8AB
#define Z_UNICODE_WHITE_ARROW_SHAFT_WIDTH_ONE				  0x1F8AC
#define Z_UNICODE_WHITE_ARROW_SHAFT_WIDTH_TWO_THIRDS			  0x1F8AD

/* MARK: - 1F900h-1F9FFh - Supplemental Symbols and Pictographs */

#define Z_UNICODE_ZIPPER_MOUTH_FACE	 0x1F910
#define Z_UNICODE_MONEY_MOUTH_FACE	 0x1F911
#define Z_UNICODE_FACE_WITH_THERMOMETER	 0x1F912
#define Z_UNICODE_NERD_FACE		 0x1F913
#define Z_UNICODE_THINKING_FACE		 0x1F914
#define Z_UNICODE_FACE_WITH_HEAD_BANDAGE 0x1F915
#define Z_UNICODE_ROBOT_FACE		 0x1F916
#define Z_UNICODE_HUGGING_FACE		 0x1F917
#define Z_UNICODE_SIGN_OF_THE_HORNS	 0x1F918
#define Z_UNICODE_CRAB			 0x1F980
#define Z_UNICODE_LION_FACE		 0x1F981
#define Z_UNICODE_SCORPION		 0x1F982
#define Z_UNICODE_TURKEY		 0x1F983
#define Z_UNICODE_UNICORN_FACE		 0x1F984
#define Z_UNICODE_CHEESE_WEDGE		 0x1F9C0

/* MARK: - 1FF80h-1FFFFh - Unassigned

/* 1FFFEh <not a character> */
/* 1FFFFh <not a character> */

/* MARK: - 20000h-2A6D6h - CJK Unified Ideographs Extension B */
/* MARK: - 2A700h-2B734h - CJK Unified Ideographs Extension C */
/* MARK: - 2B740h-2B81Dh - CJK Unified Ideographs Extension D */
/* MARK: - 2B820h-2CEA1h - CJK Unified Ideographs Extension E */

/* MARK: - 2F800h-2FA1Fh - CJK Compatibility Ideographs Supplement */

#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F800 0x2F800
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F801 0x2F801
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F802 0x2F802
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F803 0x2F803
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F804 0x2F804
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F805 0x2F805
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F806 0x2F806
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F807 0x2F807
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F808 0x2F808
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F809 0x2F809
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F80A 0x2F80A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F80B 0x2F80B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F80C 0x2F80C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F80D 0x2F80D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F80E 0x2F80E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F80F 0x2F80F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F810 0x2F810
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F811 0x2F811
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F812 0x2F812
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F813 0x2F813
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F814 0x2F814
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F815 0x2F815
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F816 0x2F816
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F817 0x2F817
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F818 0x2F818
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F819 0x2F819
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F81A 0x2F81A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F81B 0x2F81B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F81C 0x2F81C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F81D 0x2F81D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F81E 0x2F81E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F81F 0x2F81F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F820 0x2F820
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F821 0x2F821
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F822 0x2F822
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F823 0x2F823
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F824 0x2F824
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F825 0x2F825
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F826 0x2F826
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F827 0x2F827
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F828 0x2F828
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F829 0x2F829
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F82A 0x2F82A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F82B 0x2F82B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F82C 0x2F82C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F82D 0x2F82D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F82E 0x2F82E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F82F 0x2F82F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F830 0x2F830
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F831 0x2F831
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F832 0x2F832
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F833 0x2F833
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F834 0x2F834
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F835 0x2F835
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F836 0x2F836
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F837 0x2F837
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F838 0x2F838
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F839 0x2F839
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F83A 0x2F83A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F83B 0x2F83B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F83C 0x2F83C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F83D 0x2F83D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F83E 0x2F83E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F83F 0x2F83F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F840 0x2F840
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F841 0x2F841
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F842 0x2F842
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F843 0x2F843
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F844 0x2F844
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F845 0x2F845
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F846 0x2F846
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F847 0x2F847
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F848 0x2F848
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F849 0x2F849
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F84A 0x2F84A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F84B 0x2F84B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F84C 0x2F84C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F84D 0x2F84D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F84E 0x2F84E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F84F 0x2F84F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F850 0x2F850
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F851 0x2F851
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F852 0x2F852
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F853 0x2F853
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F854 0x2F854
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F855 0x2F855
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F856 0x2F856
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F857 0x2F857
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F858 0x2F858
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F859 0x2F859
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F85A 0x2F85A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F85B 0x2F85B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F85C 0x2F85C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F85D 0x2F85D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F85E 0x2F85E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F85F 0x2F85F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F860 0x2F860
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F861 0x2F861
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F862 0x2F862
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F863 0x2F863
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F864 0x2F864
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F865 0x2F865
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F866 0x2F866
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F867 0x2F867
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F868 0x2F868
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F869 0x2F869
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F86A 0x2F86A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F86B 0x2F86B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F86C 0x2F86C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F86D 0x2F86D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F86E 0x2F86E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F86F 0x2F86F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F870 0x2F870
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F871 0x2F871
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F872 0x2F872
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F873 0x2F873
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F874 0x2F874
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F875 0x2F875
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F876 0x2F876
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F877 0x2F877
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F878 0x2F878
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F879 0x2F879
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F87A 0x2F87A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F87B 0x2F87B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F87C 0x2F87C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F87D 0x2F87D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F87E 0x2F87E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F87F 0x2F87F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F880 0x2F880
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F881 0x2F881
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F882 0x2F882
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F883 0x2F883
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F884 0x2F884
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F885 0x2F885
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F886 0x2F886
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F887 0x2F887
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F888 0x2F888
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F889 0x2F889
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F88A 0x2F88A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F88B 0x2F88B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F88C 0x2F88C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F88D 0x2F88D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F88E 0x2F88E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F88F 0x2F88F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F890 0x2F890
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F891 0x2F891
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F892 0x2F892
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F893 0x2F893
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F894 0x2F894
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F895 0x2F895
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F896 0x2F896
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F897 0x2F897
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F898 0x2F898
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F899 0x2F899
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F89A 0x2F89A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F89B 0x2F89B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F89C 0x2F89C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F89D 0x2F89D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F89E 0x2F89E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F89F 0x2F89F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A0 0x2F8A0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A1 0x2F8A1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A2 0x2F8A2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A3 0x2F8A3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A4 0x2F8A4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A5 0x2F8A5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A6 0x2F8A6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A7 0x2F8A7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A8 0x2F8A8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8A9 0x2F8A9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8AA 0x2F8AA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8AB 0x2F8AB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8AC 0x2F8AC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8AD 0x2F8AD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8AE 0x2F8AE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8AF 0x2F8AF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B0 0x2F8B0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B1 0x2F8B1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B2 0x2F8B2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B3 0x2F8B3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B4 0x2F8B4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B5 0x2F8B5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B6 0x2F8B6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B7 0x2F8B7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B8 0x2F8B8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8B9 0x2F8B9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8BA 0x2F8BA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8BB 0x2F8BB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8BC 0x2F8BC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8BD 0x2F8BD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8BE 0x2F8BE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8BF 0x2F8BF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C0 0x2F8C0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C1 0x2F8C1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C2 0x2F8C2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C3 0x2F8C3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C4 0x2F8C4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C5 0x2F8C5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C6 0x2F8C6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C7 0x2F8C7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C8 0x2F8C8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8C9 0x2F8C9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8CA 0x2F8CA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8CB 0x2F8CB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8CC 0x2F8CC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8CD 0x2F8CD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8CE 0x2F8CE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8CF 0x2F8CF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D0 0x2F8D0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D1 0x2F8D1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D2 0x2F8D2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D3 0x2F8D3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D4 0x2F8D4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D5 0x2F8D5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D6 0x2F8D6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D7 0x2F8D7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D8 0x2F8D8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8D9 0x2F8D9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8DA 0x2F8DA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8DB 0x2F8DB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8DC 0x2F8DC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8DD 0x2F8DD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8DE 0x2F8DE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8DF 0x2F8DF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E0 0x2F8E0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E1 0x2F8E1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E2 0x2F8E2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E3 0x2F8E3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E4 0x2F8E4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E5 0x2F8E5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E6 0x2F8E6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E7 0x2F8E7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E8 0x2F8E8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8E9 0x2F8E9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8EA 0x2F8EA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8EB 0x2F8EB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8EC 0x2F8EC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8ED 0x2F8ED
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8EE 0x2F8EE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8EF 0x2F8EF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F0 0x2F8F0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F1 0x2F8F1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F2 0x2F8F2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F3 0x2F8F3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F4 0x2F8F4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F5 0x2F8F5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F6 0x2F8F6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F7 0x2F8F7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F8 0x2F8F8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8F9 0x2F8F9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8FA 0x2F8FA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8FB 0x2F8FB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8FC 0x2F8FC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8FD 0x2F8FD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8FE 0x2F8FE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F8FF 0x2F8FF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F900 0x2F900
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F901 0x2F901
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F902 0x2F902
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F903 0x2F903
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F904 0x2F904
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F905 0x2F905
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F906 0x2F906
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F907 0x2F907
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F908 0x2F908
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F909 0x2F909
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F90A 0x2F90A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F90B 0x2F90B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F90C 0x2F90C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F90D 0x2F90D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F90E 0x2F90E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F90F 0x2F90F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F910 0x2F910
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F911 0x2F911
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F912 0x2F912
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F913 0x2F913
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F914 0x2F914
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F915 0x2F915
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F916 0x2F916
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F917 0x2F917
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F918 0x2F918
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F919 0x2F919
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F91A 0x2F91A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F91B 0x2F91B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F91C 0x2F91C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F91D 0x2F91D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F91E 0x2F91E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F91F 0x2F91F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F920 0x2F920
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F921 0x2F921
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F922 0x2F922
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F923 0x2F923
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F924 0x2F924
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F925 0x2F925
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F926 0x2F926
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F927 0x2F927
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F928 0x2F928
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F929 0x2F929
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F92A 0x2F92A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F92B 0x2F92B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F92C 0x2F92C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F92D 0x2F92D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F92E 0x2F92E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F92F 0x2F92F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F930 0x2F930
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F931 0x2F931
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F932 0x2F932
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F933 0x2F933
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F934 0x2F934
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F935 0x2F935
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F936 0x2F936
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F937 0x2F937
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F938 0x2F938
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F939 0x2F939
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F93A 0x2F93A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F93B 0x2F93B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F93C 0x2F93C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F93D 0x2F93D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F93E 0x2F93E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F93F 0x2F93F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F940 0x2F940
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F941 0x2F941
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F942 0x2F942
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F943 0x2F943
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F944 0x2F944
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F945 0x2F945
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F946 0x2F946
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F947 0x2F947
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F948 0x2F948
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F949 0x2F949
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F94A 0x2F94A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F94B 0x2F94B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F94C 0x2F94C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F94D 0x2F94D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F94E 0x2F94E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F94F 0x2F94F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F950 0x2F950
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F951 0x2F951
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F952 0x2F952
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F953 0x2F953
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F954 0x2F954
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F955 0x2F955
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F956 0x2F956
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F957 0x2F957
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F958 0x2F958
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F959 0x2F959
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F95A 0x2F95A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F95B 0x2F95B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F95C 0x2F95C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F95D 0x2F95D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F95E 0x2F95E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F95F 0x2F95F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F960 0x2F960
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F961 0x2F961
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F962 0x2F962
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F963 0x2F963
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F964 0x2F964
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F965 0x2F965
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F966 0x2F966
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F967 0x2F967
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F968 0x2F968
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F969 0x2F969
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F96A 0x2F96A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F96B 0x2F96B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F96C 0x2F96C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F96D 0x2F96D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F96E 0x2F96E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F96F 0x2F96F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F970 0x2F970
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F971 0x2F971
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F972 0x2F972
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F973 0x2F973
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F974 0x2F974
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F975 0x2F975
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F976 0x2F976
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F977 0x2F977
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F978 0x2F978
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F979 0x2F979
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F97A 0x2F97A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F97B 0x2F97B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F97C 0x2F97C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F97D 0x2F97D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F97E 0x2F97E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F97F 0x2F97F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F980 0x2F980
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F981 0x2F981
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F982 0x2F982
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F983 0x2F983
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F984 0x2F984
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F985 0x2F985
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F986 0x2F986
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F987 0x2F987
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F988 0x2F988
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F989 0x2F989
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F98A 0x2F98A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F98B 0x2F98B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F98C 0x2F98C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F98D 0x2F98D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F98E 0x2F98E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F98F 0x2F98F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F990 0x2F990
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F991 0x2F991
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F992 0x2F992
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F993 0x2F993
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F994 0x2F994
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F995 0x2F995
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F996 0x2F996
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F997 0x2F997
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F998 0x2F998
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F999 0x2F999
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F99A 0x2F99A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F99B 0x2F99B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F99C 0x2F99C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F99D 0x2F99D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F99E 0x2F99E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F99F 0x2F99F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A0 0x2F9A0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A1 0x2F9A1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A2 0x2F9A2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A3 0x2F9A3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A4 0x2F9A4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A5 0x2F9A5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A6 0x2F9A6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A7 0x2F9A7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A8 0x2F9A8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9A9 0x2F9A9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9AA 0x2F9AA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9AB 0x2F9AB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9AC 0x2F9AC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9AD 0x2F9AD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9AE 0x2F9AE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9AF 0x2F9AF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B0 0x2F9B0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B1 0x2F9B1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B2 0x2F9B2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B3 0x2F9B3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B4 0x2F9B4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B5 0x2F9B5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B6 0x2F9B6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B7 0x2F9B7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B8 0x2F9B8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9B9 0x2F9B9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9BA 0x2F9BA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9BB 0x2F9BB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9BC 0x2F9BC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9BD 0x2F9BD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9BE 0x2F9BE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9BF 0x2F9BF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C0 0x2F9C0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C1 0x2F9C1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C2 0x2F9C2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C3 0x2F9C3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C4 0x2F9C4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C5 0x2F9C5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C6 0x2F9C6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C7 0x2F9C7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C8 0x2F9C8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9C9 0x2F9C9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9CA 0x2F9CA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9CB 0x2F9CB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9CC 0x2F9CC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9CD 0x2F9CD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9CE 0x2F9CE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9CF 0x2F9CF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D0 0x2F9D0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D1 0x2F9D1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D2 0x2F9D2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D3 0x2F9D3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D4 0x2F9D4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D5 0x2F9D5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D6 0x2F9D6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D7 0x2F9D7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D8 0x2F9D8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9D9 0x2F9D9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9DA 0x2F9DA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9DB 0x2F9DB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9DC 0x2F9DC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9DD 0x2F9DD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9DE 0x2F9DE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9DF 0x2F9DF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E0 0x2F9E0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E1 0x2F9E1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E2 0x2F9E2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E3 0x2F9E3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E4 0x2F9E4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E5 0x2F9E5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E6 0x2F9E6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E7 0x2F9E7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E8 0x2F9E8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9E9 0x2F9E9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9EA 0x2F9EA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9EB 0x2F9EB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9EC 0x2F9EC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9ED 0x2F9ED
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9EE 0x2F9EE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9EF 0x2F9EF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F0 0x2F9F0
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F1 0x2F9F1
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F2 0x2F9F2
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F3 0x2F9F3
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F4 0x2F9F4
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F5 0x2F9F5
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F6 0x2F9F6
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F7 0x2F9F7
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F8 0x2F9F8
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9F9 0x2F9F9
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9FA 0x2F9FA
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9FB 0x2F9FB
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9FC 0x2F9FC
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9FD 0x2F9FD
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9FE 0x2F9FE
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2F9FF 0x2F9FF
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA00 0x2FA00
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA01 0x2FA01
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA02 0x2FA02
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA03 0x2FA03
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA04 0x2FA04
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA05 0x2FA05
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA06 0x2FA06
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA07 0x2FA07
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA08 0x2FA08
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA09 0x2FA09
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA0A 0x2FA0A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA0B 0x2FA0B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA0C 0x2FA0C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA0D 0x2FA0D
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA0E 0x2FA0E
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA0F 0x2FA0F
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA10 0x2FA10
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA11 0x2FA11
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA12 0x2FA12
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA13 0x2FA13
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA14 0x2FA14
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA15 0x2FA15
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA16 0x2FA16
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA17 0x2FA17
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA18 0x2FA18
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA19 0x2FA19
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA1A 0x2FA1A
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA1B 0x2FA1B
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA1C 0x2FA1C
#define Z_UNICODE_CJK_COMPATIBILITY_IDEOGRAPH_2FA1D 0x2FA1D

/* MARK: - 2FF80h-2FFFFh - Unassigned */

/* 2FFFEh <not a character> */
/* 2FFFFh <not a character> */

/* MARK: - 3FF80h-3FFFFh Unassigned */

/* 3FFFEh <not a character> */
/* 3FFFFh <not a character> */

/* MARK: - 4FF80h-4FFFFh - Unassigned */

/* 4FFFEh <not a character> */
/* 4FFFFh <not a character> */

/* MARK: - 5FF80h-5FFFFh - Unassigned */

/* 5FFFEh <not a character> */
/* 5FFFFh <not a character> */

/* MARK: - 6FF80h-6FFFFh - Unassigned */

/* 6FFFEh <not a character> */
/* 6FFFFh <not a character> */

/* MARK: - 7FF80h-7FFFFh - Unassigned */

/* 7FFFEh <not a character> */
/* 7FFFFh <not a character> */

/* MARK: - 8FF80h-8FFFFh - Unassigned */

/* 8FFFEh <not a character> */
/* 8FFFFh <not a character> */

/* MARK: - 9FF80h-9FFFFh - Unassigned */

/* 9FFFEh <not a character> */
/* 9FFFFh <not a character> */

/* MARK: - AFF80h-AFFFFh - Unassigned */

/* AFFFEh <not a character> */
/* AFFFFh <not a character> */

/* MARK: - BFF80h-BFFFFh - Unassigned */

/* BFFFEh <not a character> */
/* BFFFFh <not a character> */

/* MARK: - CFF80h-CFFFFh - Unassigned */

/* CFFFEh <not a character> */
/* CFFFFh <not a character> */

/* MARK: - DFF80h-DFFFFh - Unassigned */

/* DFFFEh <not a character> */
/* DFFFFh <not a character> */

/* MARK: - E0000h-E007Fh - Tags */

#define Z_UNICODE_LANGUAGE_TAG		     0xE0001
#define Z_UNICODE_TAG_SPACE		     0xE0020
#define Z_UNICODE_TAG_EXCLAMATION_MARK	     0xE0021
#define Z_UNICODE_TAG_QUOTATION_MARK	     0xE0022
#define Z_UNICODE_TAG_NUMBER_SIGN	     0xE0023
#define Z_UNICODE_TAG_DOLLAR_SIGN	     0xE0024
#define Z_UNICODE_TAG_PERCENT_SIGN	     0xE0025
#define Z_UNICODE_TAG_AMPERSAND		     0xE0026
#define Z_UNICODE_TAG_APOSTROPHE	     0xE0027
#define Z_UNICODE_TAG_LEFT_PARENTHESIS	     0xE0028
#define Z_UNICODE_TAG_RIGHT_PARENTHESIS	     0xE0029
#define Z_UNICODE_TAG_ASTERISK		     0xE002A
#define Z_UNICODE_TAG_PLUS_SIGN		     0xE002B
#define Z_UNICODE_TAG_COMMA		     0xE002C
#define Z_UNICODE_TAG_HYPHEN_MINUS	     0xE002D
#define Z_UNICODE_TAG_FULL_STOP		     0xE002E
#define Z_UNICODE_TAG_SOLIDUS		     0xE002F
#define Z_UNICODE_TAG_DIGIT_ZERO	     0xE0030
#define Z_UNICODE_TAG_DIGIT_ONE		     0xE0031
#define Z_UNICODE_TAG_DIGIT_TWO		     0xE0032
#define Z_UNICODE_TAG_DIGIT_THREE	     0xE0033
#define Z_UNICODE_TAG_DIGIT_FOUR	     0xE0034
#define Z_UNICODE_TAG_DIGIT_FIVE	     0xE0035
#define Z_UNICODE_TAG_DIGIT_SIX		     0xE0036
#define Z_UNICODE_TAG_DIGIT_SEVEN	     0xE0037
#define Z_UNICODE_TAG_DIGIT_EIGHT	     0xE0038
#define Z_UNICODE_TAG_DIGIT_NINE	     0xE0039
#define Z_UNICODE_TAG_COLON		     0xE003A
#define Z_UNICODE_TAG_SEMICOLON		     0xE003B
#define Z_UNICODE_TAG_LESS_THAN_SIGN	     0xE003C
#define Z_UNICODE_TAG_EQUALS_SIGN	     0xE003D
#define Z_UNICODE_TAG_GREATER_THAN_SIGN	     0xE003E
#define Z_UNICODE_TAG_QUESTION_MARK	     0xE003F
#define Z_UNICODE_TAG_COMMERCIAL_AT	     0xE0040
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_A 0xE0041
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_B 0xE0042
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_C 0xE0043
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_D 0xE0044
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_E 0xE0045
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_F 0xE0046
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_G 0xE0047
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_H 0xE0048
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_I 0xE0049
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_J 0xE004A
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_K 0xE004B
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_L 0xE004C
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_M 0xE004D
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_N 0xE004E
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_O 0xE004F
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_P 0xE0050
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_Q 0xE0051
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_R 0xE0052
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_S 0xE0053
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_T 0xE0054
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_U 0xE0055
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_V 0xE0056
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_W 0xE0057
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_X 0xE0058
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_Y 0xE0059
#define Z_UNICODE_TAG_LATIN_CAPITAL_LETTER_Z 0xE005A
#define Z_UNICODE_TAG_LEFT_SQUARE_BRACKET    0xE005B
#define Z_UNICODE_TAG_REVERSE_SOLIDUS	     0xE005C
#define Z_UNICODE_TAG_RIGHT_SQUARE_BRACKET   0xE005D
#define Z_UNICODE_TAG_CIRCUMFLEX_ACCENT	     0xE005E
#define Z_UNICODE_TAG_LOW_LINE		     0xE005F
#define Z_UNICODE_TAG_GRAVE_ACCENT	     0xE0060
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_A   0xE0061
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_B   0xE0062
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_C   0xE0063
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_D   0xE0064
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_E   0xE0065
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_F   0xE0066
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_G   0xE0067
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_H   0xE0068
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_I   0xE0069
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_J   0xE006A
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_K   0xE006B
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_L   0xE006C
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_M   0xE006D
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_N   0xE006E
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_O   0xE006F
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_P   0xE0070
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_Q   0xE0071
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_R   0xE0072
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_S   0xE0073
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_T   0xE0074
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_U   0xE0075
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_V   0xE0076
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_W   0xE0077
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_X   0xE0078
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_Y   0xE0079
#define Z_UNICODE_TAG_LATIN_SMALL_LETTER_Z   0xE007A
#define Z_UNICODE_TAG_LEFT_CURLY_BRACKET     0xE007B
#define Z_UNICODE_TAG_VERTICAL_LINE	     0xE007C
#define Z_UNICODE_TAG_RIGHT_CURLY_BRACKET    0xE007D
#define Z_UNICODE_TAG_TILDE		     0xE007E
#define Z_UNICODE_CANCEL_TAG		     0xE007F

/* MARK: - E0100h-E01EFh - Variation Selectors Supplement */

#define Z_UNICODE_VARIATION_SELECTOR_17	 0xE0100
#define Z_UNICODE_VARIATION_SELECTOR_18	 0xE0101
#define Z_UNICODE_VARIATION_SELECTOR_19	 0xE0102
#define Z_UNICODE_VARIATION_SELECTOR_20	 0xE0103
#define Z_UNICODE_VARIATION_SELECTOR_21	 0xE0104
#define Z_UNICODE_VARIATION_SELECTOR_22	 0xE0105
#define Z_UNICODE_VARIATION_SELECTOR_23	 0xE0106
#define Z_UNICODE_VARIATION_SELECTOR_24	 0xE0107
#define Z_UNICODE_VARIATION_SELECTOR_25	 0xE0108
#define Z_UNICODE_VARIATION_SELECTOR_26	 0xE0109
#define Z_UNICODE_VARIATION_SELECTOR_27	 0xE010A
#define Z_UNICODE_VARIATION_SELECTOR_28	 0xE010B
#define Z_UNICODE_VARIATION_SELECTOR_29	 0xE010C
#define Z_UNICODE_VARIATION_SELECTOR_30	 0xE010D
#define Z_UNICODE_VARIATION_SELECTOR_31	 0xE010E
#define Z_UNICODE_VARIATION_SELECTOR_32	 0xE010F
#define Z_UNICODE_VARIATION_SELECTOR_33	 0xE0110
#define Z_UNICODE_VARIATION_SELECTOR_34	 0xE0111
#define Z_UNICODE_VARIATION_SELECTOR_35	 0xE0112
#define Z_UNICODE_VARIATION_SELECTOR_36	 0xE0113
#define Z_UNICODE_VARIATION_SELECTOR_37	 0xE0114
#define Z_UNICODE_VARIATION_SELECTOR_38	 0xE0115
#define Z_UNICODE_VARIATION_SELECTOR_39	 0xE0116
#define Z_UNICODE_VARIATION_SELECTOR_40	 0xE0117
#define Z_UNICODE_VARIATION_SELECTOR_41	 0xE0118
#define Z_UNICODE_VARIATION_SELECTOR_42	 0xE0119
#define Z_UNICODE_VARIATION_SELECTOR_43	 0xE011A
#define Z_UNICODE_VARIATION_SELECTOR_44	 0xE011B
#define Z_UNICODE_VARIATION_SELECTOR_45	 0xE011C
#define Z_UNICODE_VARIATION_SELECTOR_46	 0xE011D
#define Z_UNICODE_VARIATION_SELECTOR_47	 0xE011E
#define Z_UNICODE_VARIATION_SELECTOR_48	 0xE011F
#define Z_UNICODE_VARIATION_SELECTOR_49	 0xE0120
#define Z_UNICODE_VARIATION_SELECTOR_50	 0xE0121
#define Z_UNICODE_VARIATION_SELECTOR_51	 0xE0122
#define Z_UNICODE_VARIATION_SELECTOR_52	 0xE0123
#define Z_UNICODE_VARIATION_SELECTOR_53	 0xE0124
#define Z_UNICODE_VARIATION_SELECTOR_54	 0xE0125
#define Z_UNICODE_VARIATION_SELECTOR_55	 0xE0126
#define Z_UNICODE_VARIATION_SELECTOR_56	 0xE0127
#define Z_UNICODE_VARIATION_SELECTOR_57	 0xE0128
#define Z_UNICODE_VARIATION_SELECTOR_58	 0xE0129
#define Z_UNICODE_VARIATION_SELECTOR_59	 0xE012A
#define Z_UNICODE_VARIATION_SELECTOR_60	 0xE012B
#define Z_UNICODE_VARIATION_SELECTOR_61	 0xE012C
#define Z_UNICODE_VARIATION_SELECTOR_62	 0xE012D
#define Z_UNICODE_VARIATION_SELECTOR_63	 0xE012E
#define Z_UNICODE_VARIATION_SELECTOR_64	 0xE012F
#define Z_UNICODE_VARIATION_SELECTOR_65	 0xE0130
#define Z_UNICODE_VARIATION_SELECTOR_66	 0xE0131
#define Z_UNICODE_VARIATION_SELECTOR_67	 0xE0132
#define Z_UNICODE_VARIATION_SELECTOR_68	 0xE0133
#define Z_UNICODE_VARIATION_SELECTOR_69	 0xE0134
#define Z_UNICODE_VARIATION_SELECTOR_70	 0xE0135
#define Z_UNICODE_VARIATION_SELECTOR_71	 0xE0136
#define Z_UNICODE_VARIATION_SELECTOR_72	 0xE0137
#define Z_UNICODE_VARIATION_SELECTOR_73	 0xE0138
#define Z_UNICODE_VARIATION_SELECTOR_74	 0xE0139
#define Z_UNICODE_VARIATION_SELECTOR_75	 0xE013A
#define Z_UNICODE_VARIATION_SELECTOR_76	 0xE013B
#define Z_UNICODE_VARIATION_SELECTOR_77	 0xE013C
#define Z_UNICODE_VARIATION_SELECTOR_78	 0xE013D
#define Z_UNICODE_VARIATION_SELECTOR_79	 0xE013E
#define Z_UNICODE_VARIATION_SELECTOR_80	 0xE013F
#define Z_UNICODE_VARIATION_SELECTOR_81	 0xE0140
#define Z_UNICODE_VARIATION_SELECTOR_82	 0xE0141
#define Z_UNICODE_VARIATION_SELECTOR_83	 0xE0142
#define Z_UNICODE_VARIATION_SELECTOR_84	 0xE0143
#define Z_UNICODE_VARIATION_SELECTOR_85	 0xE0144
#define Z_UNICODE_VARIATION_SELECTOR_86	 0xE0145
#define Z_UNICODE_VARIATION_SELECTOR_87	 0xE0146
#define Z_UNICODE_VARIATION_SELECTOR_88	 0xE0147
#define Z_UNICODE_VARIATION_SELECTOR_89	 0xE0148
#define Z_UNICODE_VARIATION_SELECTOR_90	 0xE0149
#define Z_UNICODE_VARIATION_SELECTOR_91	 0xE014A
#define Z_UNICODE_VARIATION_SELECTOR_92	 0xE014B
#define Z_UNICODE_VARIATION_SELECTOR_93	 0xE014C
#define Z_UNICODE_VARIATION_SELECTOR_94	 0xE014D
#define Z_UNICODE_VARIATION_SELECTOR_95	 0xE014E
#define Z_UNICODE_VARIATION_SELECTOR_96	 0xE014F
#define Z_UNICODE_VARIATION_SELECTOR_97	 0xE0150
#define Z_UNICODE_VARIATION_SELECTOR_98	 0xE0151
#define Z_UNICODE_VARIATION_SELECTOR_99	 0xE0152
#define Z_UNICODE_VARIATION_SELECTOR_100 0xE0153
#define Z_UNICODE_VARIATION_SELECTOR_101 0xE0154
#define Z_UNICODE_VARIATION_SELECTOR_102 0xE0155
#define Z_UNICODE_VARIATION_SELECTOR_103 0xE0156
#define Z_UNICODE_VARIATION_SELECTOR_104 0xE0157
#define Z_UNICODE_VARIATION_SELECTOR_105 0xE0158
#define Z_UNICODE_VARIATION_SELECTOR_106 0xE0159
#define Z_UNICODE_VARIATION_SELECTOR_107 0xE015A
#define Z_UNICODE_VARIATION_SELECTOR_108 0xE015B
#define Z_UNICODE_VARIATION_SELECTOR_109 0xE015C
#define Z_UNICODE_VARIATION_SELECTOR_110 0xE015D
#define Z_UNICODE_VARIATION_SELECTOR_111 0xE015E
#define Z_UNICODE_VARIATION_SELECTOR_112 0xE015F
#define Z_UNICODE_VARIATION_SELECTOR_113 0xE0160
#define Z_UNICODE_VARIATION_SELECTOR_114 0xE0161
#define Z_UNICODE_VARIATION_SELECTOR_115 0xE0162
#define Z_UNICODE_VARIATION_SELECTOR_116 0xE0163
#define Z_UNICODE_VARIATION_SELECTOR_117 0xE0164
#define Z_UNICODE_VARIATION_SELECTOR_118 0xE0165
#define Z_UNICODE_VARIATION_SELECTOR_119 0xE0166
#define Z_UNICODE_VARIATION_SELECTOR_120 0xE0167
#define Z_UNICODE_VARIATION_SELECTOR_121 0xE0168
#define Z_UNICODE_VARIATION_SELECTOR_122 0xE0169
#define Z_UNICODE_VARIATION_SELECTOR_123 0xE016A
#define Z_UNICODE_VARIATION_SELECTOR_124 0xE016B
#define Z_UNICODE_VARIATION_SELECTOR_125 0xE016C
#define Z_UNICODE_VARIATION_SELECTOR_126 0xE016D
#define Z_UNICODE_VARIATION_SELECTOR_127 0xE016E
#define Z_UNICODE_VARIATION_SELECTOR_128 0xE016F
#define Z_UNICODE_VARIATION_SELECTOR_129 0xE0170
#define Z_UNICODE_VARIATION_SELECTOR_130 0xE0171
#define Z_UNICODE_VARIATION_SELECTOR_131 0xE0172
#define Z_UNICODE_VARIATION_SELECTOR_132 0xE0173
#define Z_UNICODE_VARIATION_SELECTOR_133 0xE0174
#define Z_UNICODE_VARIATION_SELECTOR_134 0xE0175
#define Z_UNICODE_VARIATION_SELECTOR_135 0xE0176
#define Z_UNICODE_VARIATION_SELECTOR_136 0xE0177
#define Z_UNICODE_VARIATION_SELECTOR_137 0xE0178
#define Z_UNICODE_VARIATION_SELECTOR_138 0xE0179
#define Z_UNICODE_VARIATION_SELECTOR_139 0xE017A
#define Z_UNICODE_VARIATION_SELECTOR_140 0xE017B
#define Z_UNICODE_VARIATION_SELECTOR_141 0xE017C
#define Z_UNICODE_VARIATION_SELECTOR_142 0xE017D
#define Z_UNICODE_VARIATION_SELECTOR_143 0xE017E
#define Z_UNICODE_VARIATION_SELECTOR_144 0xE017F
#define Z_UNICODE_VARIATION_SELECTOR_145 0xE0180
#define Z_UNICODE_VARIATION_SELECTOR_146 0xE0181
#define Z_UNICODE_VARIATION_SELECTOR_147 0xE0182
#define Z_UNICODE_VARIATION_SELECTOR_148 0xE0183
#define Z_UNICODE_VARIATION_SELECTOR_149 0xE0184
#define Z_UNICODE_VARIATION_SELECTOR_150 0xE0185
#define Z_UNICODE_VARIATION_SELECTOR_151 0xE0186
#define Z_UNICODE_VARIATION_SELECTOR_152 0xE0187
#define Z_UNICODE_VARIATION_SELECTOR_153 0xE0188
#define Z_UNICODE_VARIATION_SELECTOR_154 0xE0189
#define Z_UNICODE_VARIATION_SELECTOR_155 0xE018A
#define Z_UNICODE_VARIATION_SELECTOR_156 0xE018B
#define Z_UNICODE_VARIATION_SELECTOR_157 0xE018C
#define Z_UNICODE_VARIATION_SELECTOR_158 0xE018D
#define Z_UNICODE_VARIATION_SELECTOR_159 0xE018E
#define Z_UNICODE_VARIATION_SELECTOR_160 0xE018F
#define Z_UNICODE_VARIATION_SELECTOR_161 0xE0190
#define Z_UNICODE_VARIATION_SELECTOR_162 0xE0191
#define Z_UNICODE_VARIATION_SELECTOR_163 0xE0192
#define Z_UNICODE_VARIATION_SELECTOR_164 0xE0193
#define Z_UNICODE_VARIATION_SELECTOR_165 0xE0194
#define Z_UNICODE_VARIATION_SELECTOR_166 0xE0195
#define Z_UNICODE_VARIATION_SELECTOR_167 0xE0196
#define Z_UNICODE_VARIATION_SELECTOR_168 0xE0197
#define Z_UNICODE_VARIATION_SELECTOR_169 0xE0198
#define Z_UNICODE_VARIATION_SELECTOR_170 0xE0199
#define Z_UNICODE_VARIATION_SELECTOR_171 0xE019A
#define Z_UNICODE_VARIATION_SELECTOR_172 0xE019B
#define Z_UNICODE_VARIATION_SELECTOR_173 0xE019C
#define Z_UNICODE_VARIATION_SELECTOR_174 0xE019D
#define Z_UNICODE_VARIATION_SELECTOR_175 0xE019E
#define Z_UNICODE_VARIATION_SELECTOR_176 0xE019F
#define Z_UNICODE_VARIATION_SELECTOR_177 0xE01A0
#define Z_UNICODE_VARIATION_SELECTOR_178 0xE01A1
#define Z_UNICODE_VARIATION_SELECTOR_179 0xE01A2
#define Z_UNICODE_VARIATION_SELECTOR_180 0xE01A3
#define Z_UNICODE_VARIATION_SELECTOR_181 0xE01A4
#define Z_UNICODE_VARIATION_SELECTOR_182 0xE01A5
#define Z_UNICODE_VARIATION_SELECTOR_183 0xE01A6
#define Z_UNICODE_VARIATION_SELECTOR_184 0xE01A7
#define Z_UNICODE_VARIATION_SELECTOR_185 0xE01A8
#define Z_UNICODE_VARIATION_SELECTOR_186 0xE01A9
#define Z_UNICODE_VARIATION_SELECTOR_187 0xE01AA
#define Z_UNICODE_VARIATION_SELECTOR_188 0xE01AB
#define Z_UNICODE_VARIATION_SELECTOR_189 0xE01AC
#define Z_UNICODE_VARIATION_SELECTOR_190 0xE01AD
#define Z_UNICODE_VARIATION_SELECTOR_191 0xE01AE
#define Z_UNICODE_VARIATION_SELECTOR_192 0xE01AF
#define Z_UNICODE_VARIATION_SELECTOR_193 0xE01B0
#define Z_UNICODE_VARIATION_SELECTOR_194 0xE01B1
#define Z_UNICODE_VARIATION_SELECTOR_195 0xE01B2
#define Z_UNICODE_VARIATION_SELECTOR_196 0xE01B3
#define Z_UNICODE_VARIATION_SELECTOR_197 0xE01B4
#define Z_UNICODE_VARIATION_SELECTOR_198 0xE01B5
#define Z_UNICODE_VARIATION_SELECTOR_199 0xE01B6
#define Z_UNICODE_VARIATION_SELECTOR_200 0xE01B7
#define Z_UNICODE_VARIATION_SELECTOR_201 0xE01B8
#define Z_UNICODE_VARIATION_SELECTOR_202 0xE01B9
#define Z_UNICODE_VARIATION_SELECTOR_203 0xE01BA
#define Z_UNICODE_VARIATION_SELECTOR_204 0xE01BB
#define Z_UNICODE_VARIATION_SELECTOR_205 0xE01BC
#define Z_UNICODE_VARIATION_SELECTOR_206 0xE01BD
#define Z_UNICODE_VARIATION_SELECTOR_207 0xE01BE
#define Z_UNICODE_VARIATION_SELECTOR_208 0xE01BF
#define Z_UNICODE_VARIATION_SELECTOR_209 0xE01C0
#define Z_UNICODE_VARIATION_SELECTOR_210 0xE01C1
#define Z_UNICODE_VARIATION_SELECTOR_211 0xE01C2
#define Z_UNICODE_VARIATION_SELECTOR_212 0xE01C3
#define Z_UNICODE_VARIATION_SELECTOR_213 0xE01C4
#define Z_UNICODE_VARIATION_SELECTOR_214 0xE01C5
#define Z_UNICODE_VARIATION_SELECTOR_215 0xE01C6
#define Z_UNICODE_VARIATION_SELECTOR_216 0xE01C7
#define Z_UNICODE_VARIATION_SELECTOR_217 0xE01C8
#define Z_UNICODE_VARIATION_SELECTOR_218 0xE01C9
#define Z_UNICODE_VARIATION_SELECTOR_219 0xE01CA
#define Z_UNICODE_VARIATION_SELECTOR_220 0xE01CB
#define Z_UNICODE_VARIATION_SELECTOR_221 0xE01CC
#define Z_UNICODE_VARIATION_SELECTOR_222 0xE01CD
#define Z_UNICODE_VARIATION_SELECTOR_223 0xE01CE
#define Z_UNICODE_VARIATION_SELECTOR_224 0xE01CF
#define Z_UNICODE_VARIATION_SELECTOR_225 0xE01D0
#define Z_UNICODE_VARIATION_SELECTOR_226 0xE01D1
#define Z_UNICODE_VARIATION_SELECTOR_227 0xE01D2
#define Z_UNICODE_VARIATION_SELECTOR_228 0xE01D3
#define Z_UNICODE_VARIATION_SELECTOR_229 0xE01D4
#define Z_UNICODE_VARIATION_SELECTOR_230 0xE01D5
#define Z_UNICODE_VARIATION_SELECTOR_231 0xE01D6
#define Z_UNICODE_VARIATION_SELECTOR_232 0xE01D7
#define Z_UNICODE_VARIATION_SELECTOR_233 0xE01D8
#define Z_UNICODE_VARIATION_SELECTOR_234 0xE01D9
#define Z_UNICODE_VARIATION_SELECTOR_235 0xE01DA
#define Z_UNICODE_VARIATION_SELECTOR_236 0xE01DB
#define Z_UNICODE_VARIATION_SELECTOR_237 0xE01DC
#define Z_UNICODE_VARIATION_SELECTOR_238 0xE01DD
#define Z_UNICODE_VARIATION_SELECTOR_239 0xE01DE
#define Z_UNICODE_VARIATION_SELECTOR_240 0xE01DF
#define Z_UNICODE_VARIATION_SELECTOR_241 0xE01E0
#define Z_UNICODE_VARIATION_SELECTOR_242 0xE01E1
#define Z_UNICODE_VARIATION_SELECTOR_243 0xE01E2
#define Z_UNICODE_VARIATION_SELECTOR_244 0xE01E3
#define Z_UNICODE_VARIATION_SELECTOR_245 0xE01E4
#define Z_UNICODE_VARIATION_SELECTOR_246 0xE01E5
#define Z_UNICODE_VARIATION_SELECTOR_247 0xE01E6
#define Z_UNICODE_VARIATION_SELECTOR_248 0xE01E7
#define Z_UNICODE_VARIATION_SELECTOR_249 0xE01E8
#define Z_UNICODE_VARIATION_SELECTOR_250 0xE01E9
#define Z_UNICODE_VARIATION_SELECTOR_251 0xE01EA
#define Z_UNICODE_VARIATION_SELECTOR_252 0xE01EB
#define Z_UNICODE_VARIATION_SELECTOR_253 0xE01EC
#define Z_UNICODE_VARIATION_SELECTOR_254 0xE01ED
#define Z_UNICODE_VARIATION_SELECTOR_255 0xE01EE
#define Z_UNICODE_VARIATION_SELECTOR_256 0xE01EF

/* MARK: - EFF80h-EFFFFh - Unassigned */

/* EFFFEh <not a character> */
/* EFFFFh <not a character> */

/* MARK: - FFF80h-FFFFFh - Supplementary Private Use Area-A */

/* FFFFEh <not a character> */
/* FFFFFh <not a character> */

/* MARK: - 10FF80h-10FFFFh - Supplementary Private Use Area-B */

/* 10FFFEh <not a character> */
/* 10FFFFh <not a character> */

#endif /* _Z_formats_character_set_Unicode_H_ */
